#include <Adafruit_GFX.h> 
#include <Adafruit_ST7735.h> 
#include <SPI.h>

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_MOSI, TFT_SCLK, TFT_RST);

const unsigned short  smf [] PROGMEM = {
  0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0010 (16) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0020 (32) pixels
0xFFFD, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFD,   // 0x0030 (48) pixels
0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0040 (64) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FF, 0xF7FF, 0xF7FF, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE,   // 0x0050 (80) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0060 (96) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0070 (112) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0080 (128) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0090 (144) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x00A0 (160) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFBF, 0xFFDF, 0xFFDF,   // 0x00B0 (176) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFBF, 0xFFBF, 0xFFBF, 0xFFBF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFDE, 0xFFDE, 0xFFDF,   // 0x00C0 (192) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FF, 0xF7FF, 0xFFFE, 0xFFFE, 0xFFFF,   // 0x00D0 (208) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFDE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x00E0 (224) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x00F0 (240) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0100 (256) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0110 (272) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFE,   // 0x0120 (288) pixels
0xFFFE, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDE, 0xFFBC, 0xFF9B,   // 0x0130 (304) pixels
0xFF9A, 0xFF9A, 0xFF33, 0xFF33, 0xFF33, 0xFF33, 0xFF33, 0xFF32, 0xFF32, 0xFF32, 0xFF33, 0xFF34, 0xFF35, 0xFF36, 0xFF38, 0xFF3A,   // 0x0140 (320) pixels
0xFF5B, 0xFF5C, 0xFF9F, 0xFFBF, 0xFFDF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FF, 0xF7FF, 0xFFFE, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0150 (336) pixels
0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0160 (352) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0170 (368) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0180 (384) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0190 (400) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FF, 0xF7FF, 0xF7DE,   // 0x01A0 (416) pixels
0xFFDF, 0xFFFF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFDD, 0xFFBB, 0xFF7A, 0xFF57, 0xF754, 0xF72F, 0xEF0B, 0xEEE6, 0xEEE3, 0xEEE1, 0xF6C2,   // 0x01B0 (432) pixels
0xF6C2, 0xF6C2, 0xF6C1, 0xF6C1, 0xF6C1, 0xF6C1, 0xF6C1, 0xF6C0, 0xF6C1, 0xF6C2, 0xF6C3, 0xF6C5, 0xF6E6, 0xF6E7, 0xF6E8, 0xF6F2,   // 0x01C0 (448) pixels
0xF714, 0xF756, 0xF779, 0xFFBC, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF,   // 0x01D0 (464) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x01E0 (480) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x01F0 (496) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0200 (512) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0210 (528) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFBD,   // 0x0220 (544) pixels
0xFF79, 0xFF34, 0xFF0F, 0xFEED, 0xF702, 0xF702, 0xF6E1, 0xF6C1, 0xF6A0, 0xFE80, 0xFE80, 0xFE80, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0,   // 0x0230 (560) pixels
0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC0, 0xF6C0, 0xFEC0, 0xF6C0, 0xF6A0, 0xF6A1, 0xEEC5, 0xF6CA,   // 0x0240 (576) pixels
0xF6EF, 0xF714, 0xFF37, 0xFF39, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0250 (592) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0260 (608) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0270 (624) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0280 (640) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0290 (656) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFDA, 0xFF74, 0xF72D, 0xF6E7, 0xF6A3, 0xF6A1,   // 0x02A0 (672) pixels
0xF680, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEA1, 0xFEA1, 0xFEA1, 0xFEA1, 0xFEA1, 0xFEA0, 0xFEA0,   // 0x02B0 (688) pixels
0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0, 0xF6A2, 0xF6A3, 0xF6C5,   // 0x02C0 (704) pixels
0xF6C6, 0xEF30, 0xF754, 0xFF5B, 0xFF9F, 0xFFDF, 0xFFFF, 0xF7FF, 0xF7FD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x02D0 (720) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x02E0 (736) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x02F0 (752) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0300 (768) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FE, 0xFFFF,   // 0x0310 (784) pixels
0xFFFF, 0xFFFF, 0xFFFE, 0xFFDB, 0xFFB7, 0xFF94, 0xFEED, 0xFEEA, 0xF6C6, 0xF6C1, 0xF6C0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEA0, 0xFEA0,   // 0x0320 (800) pixels
0xFEA0, 0xFEC0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC1, 0xFEC1, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEA3, 0xFEA3,   // 0x0330 (816) pixels
0xFEA3, 0xFEA2, 0xFEA2, 0xFEA2, 0xFEA1, 0xFEA1, 0xFEC1, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xF683, 0xF6A6,   // 0x0340 (832) pixels
0xF6CB, 0xFEF1, 0xFF36, 0xFF9A, 0xFFDC, 0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0350 (848) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0360 (864) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0370 (880) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0380 (896) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFBB,   // 0x0390 (912) pixels
0xFF54, 0xEEED, 0xE6C8, 0xFE80, 0xFE80, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA1, 0xFEC0, 0xFEC1, 0xFEE1, 0xFEE1, 0xFF01,   // 0x03A0 (928) pixels
0xFEE1, 0xF6E0, 0xF6E0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x03B0 (944) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA1, 0xFE81, 0xFE81, 0xFEA0, 0xFEA0, 0xFE80, 0xF680, 0xEEA7,   // 0x03C0 (960) pixels
0xEEF1, 0xF71B, 0xFF3F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x03D0 (976) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x03E0 (992) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x03F0 (1008) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0400 (1024) pixels
0xFFFE, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDE, 0xFFDF, 0xFFBF, 0xFF57, 0xFEEF, 0xFE87, 0xFE82, 0xFE80, 0xFE80,   // 0x0410 (1040) pixels
0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00,   // 0x0420 (1056) pixels
0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x0430 (1072) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA1, 0xFEA1, 0xFEA1, 0xFEA2,   // 0x0440 (1088) pixels
0xF716, 0xF759, 0xF7BD, 0xF7FF, 0xF7FF, 0xF7FF, 0xFFFF, 0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF,   // 0x0450 (1104) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0460 (1120) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0470 (1136) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF,   // 0x0480 (1152) pixels
0xFFFF, 0xFFFD, 0xFFFD, 0xFFFF, 0xFFDF, 0xF775, 0xF732, 0xFEED, 0xFEA7, 0xFE83, 0xFE80, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0,   // 0x0490 (1168) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x04A0 (1184) pixels
0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x04B0 (1200) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA1, 0xFEA1, 0xFEA1, 0xF6C7, 0xF6EC, 0xF735,   // 0x04C0 (1216) pixels
0xFF5C, 0xF79F, 0xF7DF, 0xF7FF, 0xF7FE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x04D0 (1232) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x04E0 (1248) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x04F0 (1264) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFBF, 0xFFFF, 0xFFFD, 0xFFFD, 0xFFFF, 0xFFFF,   // 0x0500 (1280) pixels
0xFFDB, 0xF777, 0xEEE6, 0xEEC4, 0xF6C1, 0xF6A0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x0510 (1296) pixels
0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x0520 (1312) pixels
0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0,   // 0x0530 (1328) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC1, 0xFEA1, 0xFEA0, 0xFEA0, 0xFEA7, 0xFEAF, 0xF6F6, 0xF75C,   // 0x0540 (1344) pixels
0xF7BF, 0xF7FF, 0xFFFE, 0xFFFE, 0xF7FE, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFBF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0550 (1360) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0560 (1376) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0570 (1392) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFBF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFF79, 0xF70D, 0xEEC4, 0xFEC0,   // 0x0580 (1408) pixels
0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x0590 (1424) pixels
0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x05A0 (1440) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0,   // 0x05B0 (1456) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFE80, 0xFE80, 0xF686, 0xEECF, 0xF739, 0xF77F, 0xFFFF,   // 0x05C0 (1472) pixels
0xFFFF, 0xF7FF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x05D0 (1488) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x05E0 (1504) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x05F0 (1520) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFD, 0xFFFF, 0xFFDF, 0xFF9F, 0xF733, 0xF6E7, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0,   // 0x0600 (1536) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE1, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x0610 (1552) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x0620 (1568) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x0630 (1584) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE2, 0xFEE0, 0xFEC0, 0xFE80, 0xFE80, 0xF685, 0xF6AC, 0xF6D2, 0xF73D, 0xF79F, 0xFFFF, 0xFFFF,   // 0x0640 (1600) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0650 (1616) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0660 (1632) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0670 (1648) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFF98, 0xF72E, 0xF6C3, 0xF680, 0xFEA0, 0xFEC0, 0xFE81, 0xFE81, 0xFEA1, 0xFEC1, 0xFEE1, 0xFEE1, 0xFEE1,   // 0x0680 (1664) pixels
0xFEE1, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40,   // 0x0690 (1680) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40,   // 0x06A0 (1696) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x06B0 (1712) pixels
0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEA0, 0xFEA1, 0xFEA1, 0xFEA2, 0xEE94, 0xF717, 0xFFBC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x06C0 (1728) pixels
0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x06D0 (1744) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x06E0 (1760) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFC, 0xF773,   // 0x06F0 (1776) pixels
0xF6E7, 0xF6A0, 0xFEA0, 0xFE80, 0xFEC0, 0xFEE0, 0xFEA0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00,   // 0x0700 (1792) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60,   // 0x0710 (1808) pixels
0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40,   // 0x0720 (1824) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEC0, 0xFEE0,   // 0x0730 (1840) pixels
0xFF01, 0xFF01, 0xFEE1, 0xFEC0, 0xFEA0, 0xFEA0, 0xF667, 0xF6CC, 0xF733, 0xF79A, 0xF7DF, 0xF7FF, 0xFFFF, 0xFFDE, 0xFFFF, 0xFFFF,   // 0x0740 (1856) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0750 (1872) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0760 (1888) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xEF4B, 0xEEC6, 0xF661, 0xFE80, 0xFEA0,   // 0x0770 (1904) pixels
0xFEA0, 0xFEC0, 0xF6C1, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40,   // 0x0780 (1920) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60,   // 0x0790 (1936) pixels
0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40,   // 0x07A0 (1952) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFEC1, 0xFEE0, 0xFF20, 0xF720, 0xF700,   // 0x07B0 (1968) pixels
0xF6E0, 0xFEA1, 0xFEA2, 0xFEE0, 0xF6A2, 0xE6AB, 0xDEF5, 0xEF7C, 0xF7DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x07C0 (1984) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x07D0 (2000) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x07E0 (2016) pixels
0xFF7F, 0xFFFF, 0xFFFE, 0xF7FF, 0xFFDF, 0xFFDF, 0xFF96, 0xFF0B, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0,   // 0x07F0 (2032) pixels
0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60,   // 0x0800 (2048) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0810 (2064) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60,   // 0x0820 (2080) pixels
0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0,   // 0x0830 (2096) pixels
0xFE80, 0xFEC0, 0xFEC0, 0xFEA2, 0xF68E, 0xEEDA, 0xEF9F, 0xEFFF, 0xFFFE, 0xFFDF, 0xFFDF, 0xFFFE, 0xFFFC, 0xFFFC, 0xFFFF, 0xF7FF,   // 0x0840 (2112) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0850 (2128) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFE, 0xFFFE,   // 0x0860 (2144) pixels
0xFFFF, 0xFFDF, 0xFF58, 0xFEEC, 0xF6C2, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00,   // 0x0870 (2160) pixels
0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80,   // 0x0880 (2176) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0890 (2192) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40,   // 0x08A0 (2208) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEA0, 0xFEC0, 0xFEC0,   // 0x08B0 (2224) pixels
0xFEA1, 0xF6A7, 0xEED0, 0xEF39, 0xEF9F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x08C0 (2240) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x08D0 (2256) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFD, 0xFF75, 0xF6EA,   // 0x08E0 (2272) pixels
0xF681, 0xFE80, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40,   // 0x08F0 (2288) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0900 (2304) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0910 (2320) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF20,   // 0x0920 (2336) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC1, 0xFEA1, 0xFEA0, 0xFEC0, 0xF6C4,   // 0x0930 (2352) pixels
0xEECF, 0xEED8, 0xF79F, 0xFFDF, 0xFFFD, 0xFFFF, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0940 (2368) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0950 (2384) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FE, 0xFFFF, 0xFFFF, 0xF754, 0xEEE7, 0xF6C0, 0xFEA0, 0xFE60, 0xFEC0,   // 0x0960 (2400) pixels
0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60,   // 0x0970 (2416) pixels
0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0980 (2432) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0990 (2448) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40,   // 0x09A0 (2464) pixels
0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFF00, 0xFEE1, 0xFEA2, 0xFEA0, 0xFEC0, 0xF6A0, 0xF6A5, 0xF66C, 0xE71B,   // 0x09B0 (2480) pixels
0xEF9C, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x09C0 (2496) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x09D0 (2512) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDE, 0xFF75, 0xEEE8, 0xEEA0, 0xFEC0, 0xFEA0, 0xFE81, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0,   // 0x09E0 (2528) pixels
0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x09F0 (2544) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0A00 (2560) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0A10 (2576) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF20,   // 0x0A20 (2592) pixels
0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEA1, 0xDEAF, 0xEF15, 0xF79C, 0xFFFF,   // 0x0A30 (2608) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0A40 (2624) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0A50 (2640) pixels
0xFFFF, 0xFFBF, 0xFF56, 0xEEE6, 0xF6C0, 0xFEC0, 0xFE80, 0xFE81, 0xFEE1, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20,   // 0x0A60 (2656) pixels
0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0A70 (2672) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0A80 (2688) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0A90 (2704) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20,   // 0x0AA0 (2720) pixels
0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEC1, 0xFEA1, 0xFEC0, 0xFEC0, 0xE685, 0xEEAD, 0xEF17, 0xF79D, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0AB0 (2736) pixels
0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0AC0 (2752) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFF76, 0xFEEA,   // 0x0AD0 (2768) pixels
0xF6A0, 0xFEC0, 0xFEC0, 0xFEA2, 0xFEA1, 0xFF00, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40,   // 0x0AE0 (2784) pixels
0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0AF0 (2800) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0B00 (2816) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0B10 (2832) pixels
0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF01, 0xFF00,   // 0x0B20 (2848) pixels
0xFF20, 0xFF00, 0xFEE0, 0xFEC1, 0xFEC0, 0xFEC0, 0xFEA0, 0xF685, 0xEEAD, 0xE717, 0xEF7D, 0xF7DF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0B30 (2864) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0B40 (2880) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF6C6, 0xFEC3, 0xFEA0, 0xFEA0, 0xFEA0,   // 0x0B50 (2896) pixels
0xFEE1, 0xFF01, 0xEF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60,   // 0x0B60 (2912) pixels
0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0B70 (2928) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0B80 (2944) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0B90 (2960) pixels
0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF01, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x0BA0 (2976) pixels
0xFEE0, 0xFEC1, 0xFEA2, 0xFEC0, 0xFEA0, 0xE666, 0xDEB1, 0xE71C, 0xF79F, 0xFFFF, 0xFFFC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0BB0 (2992) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0BC0 (3008) pixels
0xFFBF, 0xFFFE, 0xFFFF, 0xF7FF, 0xFFFF, 0xFFDF, 0xFF7A, 0xFF29, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00,   // 0x0BD0 (3024) pixels
0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0BE0 (3040) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0BF0 (3056) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0C00 (3072) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0C10 (3088) pixels
0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x0C20 (3104) pixels
0xF6A1, 0xFF00, 0xFEE0, 0xEE64, 0xEE51, 0xF6FC, 0xEFDF, 0xE7FE, 0xF7FF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDE, 0xFFFE, 0xFFFF,   // 0x0C30 (3120) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFD,   // 0x0C40 (3136) pixels
0xFFFE, 0xFFFF, 0xFFBD, 0xFF30, 0xF6C4, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20,   // 0x0C50 (3152) pixels
0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0C60 (3168) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0C70 (3184) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0C80 (3200) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60,   // 0x0C90 (3216) pixels
0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xF6A2, 0xFEE0, 0xFEE0,   // 0x0CA0 (3232) pixels
0xF6A1, 0xEE8A, 0xEED4, 0xEF5C, 0xEFDF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0CB0 (3248) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FD, 0xFFFE, 0xFFBF, 0xFF53,   // 0x0CC0 (3264) pixels
0xF6E4, 0xF6A0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40,   // 0x0CD0 (3280) pixels
0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0CE0 (3296) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0CF0 (3312) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0D00 (3328) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60,   // 0x0D10 (3344) pixels
0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC2, 0xFEA0, 0xFEE0, 0xFEE0, 0xF6C1, 0xE68A,   // 0x0D20 (3360) pixels
0xE6D6, 0xF75F, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0D30 (3376) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FF, 0xFFFF, 0xFFDF, 0xFF58, 0xF707, 0xF6E0, 0xFEC0, 0xFEC0,   // 0x0D40 (3392) pixels
0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80,   // 0x0D50 (3408) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0D60 (3424) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0D70 (3440) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0D80 (3456) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40,   // 0x0D90 (3472) pixels
0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEA0, 0xFEA0, 0xFF00, 0xF6E0, 0xEEA2, 0xEE8E, 0xF6B9, 0xF79E,   // 0x0DA0 (3488) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0DB0 (3504) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFFF, 0xFFDF, 0xFF5E, 0xFEEE, 0xF6C0, 0xFEA0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00,   // 0x0DC0 (3520) pixels
0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0DD0 (3536) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0DE0 (3552) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0DF0 (3568) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0E00 (3584) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20,   // 0x0E10 (3600) pixels
0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEC0, 0xFEA0, 0xFEE0, 0xFF00, 0xF6C0, 0xEE87, 0xEE2E, 0xEF3B, 0xFF9F, 0xFFDF, 0xFFFF,   // 0x0E20 (3616) pixels
0xFFFE, 0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0E30 (3632) pixels
0xFFFF, 0xF7FF, 0xFFFF, 0xFFBF, 0xFEF7, 0xF6A4, 0xF680, 0xFE80, 0xFEC1, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20,   // 0x0E40 (3648) pixels
0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0E50 (3664) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0E60 (3680) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0E70 (3696) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0E80 (3712) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20,   // 0x0E90 (3728) pixels
0xFF00, 0xFF20, 0xFEE0, 0xFEC1, 0xFEC0, 0xFEE0, 0xFEE0, 0xFE82, 0xF624, 0xE6D5, 0xF73B, 0xFF9F, 0xFFDF, 0xFFFF, 0xFFFD, 0xFFFE,   // 0x0EA0 (3744) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE,   // 0x0EB0 (3760) pixels
0xFF55, 0xFEC9, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40,   // 0x0EC0 (3776) pixels
0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0ED0 (3792) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0EE0 (3808) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0EF0 (3824) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0F00 (3840) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x0F10 (3856) pixels
0xFF00, 0xFEE0, 0xFEC1, 0xFEC1, 0xFEA0, 0xFE80, 0xDE8E, 0xE6D5, 0xF75D, 0xFFDF, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0F20 (3872) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFF7C, 0xF70C, 0xFEE0, 0xFEA0,   // 0x0F30 (3888) pixels
0xFEC0, 0xFEE0, 0xF6E0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80,   // 0x0F40 (3904) pixels
0xFF80, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0F50 (3920) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0F60 (3936) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0F70 (3952) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0F80 (3968) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFEE2, 0xFF21, 0xFF40, 0xFF00, 0xFEC1,   // 0x0F90 (3984) pixels
0xFEA1, 0xFEC0, 0xFEE0, 0xDE68, 0xDEB0, 0xEF3B, 0xFFDF, 0xFFFF, 0xF7FE, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x0FA0 (4000) pixels
0xFFFC, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFD, 0xFFFF, 0xF7FF, 0xF7FF, 0xFFFF, 0xF753, 0xEEC4, 0xF6C0, 0xFEC0, 0xFEA0, 0xFEA1, 0xFEE0,   // 0x0FB0 (4016) pixels
0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0FC0 (4032) pixels
0xF760, 0xFFC0, 0xFFA0, 0xFF60, 0xFF60, 0xFF41, 0xFF42, 0xFF41, 0xFF80, 0xFF60, 0xFF82, 0xFF60, 0xFF60, 0xFFA0, 0xFF60, 0xFF20,   // 0x0FD0 (4048) pixels
0xF760, 0xFFA0, 0xFFC1, 0xFF60, 0xFF40, 0xFF80, 0xFFA0, 0xF760, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x0FE0 (4064) pixels
0xFF80, 0xF740, 0xFFA0, 0xFF80, 0xFF60, 0xFFA0, 0xFF80, 0xFF80, 0xFF62, 0xFF81, 0xFF80, 0xFFA0, 0xFFA0, 0xFF80, 0xFF60, 0xFF60,   // 0x0FF0 (4080) pixels
0xFF60, 0xFF80, 0xFF62, 0xFF60, 0xFF60, 0xFF81, 0xFFA1, 0xFFC0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1000 (4096) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA0,   // 0x1010 (4112) pixels
0xFEA0, 0xF647, 0xE675, 0xEF3F, 0xF7FF, 0xF7FE, 0xFFFE, 0xFFBF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFD, 0xFFFF, 0xFFDF,   // 0x1020 (4128) pixels
0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xF7FF, 0xFF99, 0xF70E, 0xEEC2, 0xFEC0, 0xFEE0, 0xFEC1, 0xFEC1, 0xFF00, 0xFEE0, 0xFF00, 0xFF00,   // 0x1030 (4144) pixels
0xFF00, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xF780, 0xFFA0, 0xFF80,   // 0x1040 (4160) pixels
0xFF80, 0xFFA0, 0xFF80, 0xFF60, 0xFF80, 0xFF40, 0xFFA0, 0xFFE0, 0xFFC1, 0xFFE4, 0xFFE4, 0xFF80, 0xFFE0, 0xFFE0, 0xFFA0, 0xFF60,   // 0x1050 (4176) pixels
0xFF80, 0xFFA1, 0xFF81, 0xFF81, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFFC1,   // 0x1060 (4192) pixels
0xFF80, 0xFF40, 0xFF80, 0xFF80, 0xFF80, 0xFF61, 0xFF80, 0xFFE0, 0xFFE0, 0xFFC2, 0xFFE4, 0xFFE3, 0xFFE0, 0xFFA2, 0xFFE1, 0xF740,   // 0x1070 (4208) pixels
0xF760, 0xFFE2, 0xFFC1, 0xF740, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1080 (4224) pixels
0xFF80, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEA0, 0xFEA0, 0xFE80, 0xF664, 0xE670,   // 0x1090 (4240) pixels
0xE6FB, 0xEFDF, 0xF7FF, 0xFFFE, 0xFFBF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFF,   // 0x10A0 (4256) pixels
0xFFFF, 0xFFFF, 0xFF0F, 0xF6C7, 0xF6A0, 0xFEC0, 0xFEE0, 0xFEC1, 0xFEE1, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40,   // 0x10B0 (4272) pixels
0xFF40, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFF60, 0xFF80, 0xFFA0, 0xFF60,   // 0x10C0 (4288) pixels
0xFF80, 0xFFC0, 0xFFA0, 0xFFE0, 0xEF41, 0xAD60, 0x8C40, 0x7BA0, 0x9461, 0xD646, 0xEF62, 0xFFE2, 0xFFE0, 0xFF80, 0xFF82, 0xFF63,   // 0x10D0 (4304) pixels
0xFF61, 0xFFE0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA1, 0xFF80, 0xFF80, 0xFFA0,   // 0x10E0 (4320) pixels
0xFF80, 0xFF80, 0xFF60, 0xFF80, 0xFFE1, 0xEF66, 0xB566, 0x83C3, 0x83C0, 0x94A0, 0xCDE5, 0xFFE5, 0xFFE1, 0xFFC0, 0xF780, 0xF780,   // 0x10F0 (4336) pixels
0xFFC0, 0xFF82, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF40,   // 0x1100 (4352) pixels
0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFE80, 0xF681, 0xE688, 0xDEB5, 0xE73E, 0xF7FF,   // 0x1110 (4368) pixels
0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFBB, 0xFEC5,   // 0x1120 (4384) pixels
0xFEA1, 0xFEA0, 0xFEC0, 0xFEE0, 0xFEE1, 0xFF00, 0xFF40, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80,   // 0x1130 (4400) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFF40, 0xFF60, 0xFF80, 0xF740, 0xFFA0, 0xFFE0, 0xFFE6,   // 0x1140 (4416) pixels
0xB562, 0x5240, 0x1040, 0x0000, 0x0000, 0x0000, 0x1880, 0x7BC0, 0xDEA4, 0xFFE2, 0xFFA0, 0xFF40, 0xFF61, 0xFF80, 0xFFC0, 0xFF80,   // 0x1150 (4432) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFF80, 0xFF60, 0xFFC0,   // 0x1160 (4448) pixels
0xFFA1, 0xBDC2, 0x5280, 0x1040, 0x0001, 0x0000, 0x0000, 0x28E0, 0x7BA0, 0xD6A2, 0xFFE3, 0xF7A0, 0xEF40, 0xFFE0, 0xFF41, 0xFF80,   // 0x1170 (4464) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20,   // 0x1180 (4480) pixels
0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFE82, 0xFEC0, 0xEEA2, 0xDE6E, 0xE6DA, 0xF79F, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x1190 (4496) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFDF, 0xFF9B, 0xFF74, 0xFEA0, 0xFE80, 0xFEA0, 0xFEE0,   // 0x11A0 (4512) pixels
0xFEE0, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x11B0 (4528) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF41, 0xFF60, 0xFF60, 0xFFA0, 0xFFE0, 0xF7A1, 0x9C68, 0x3961, 0x0800, 0x0003,   // 0x11C0 (4544) pixels
0x0004, 0x1084, 0x0041, 0x0000, 0x0800, 0x5AC0, 0xCE42, 0xFFE1, 0xFFA0, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x11D0 (4560) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF81, 0xFF80, 0xFF80, 0xFFA0, 0xFF80, 0xFF60, 0xFF80, 0xFF80, 0xFFE4, 0xAD20, 0x3180, 0x0000,   // 0x11E0 (4576) pixels
0x0002, 0x0004, 0x0024, 0x0004, 0x0800, 0x0800, 0x5241, 0xCE64, 0xFFE2, 0xFFC0, 0xFF80, 0xFF61, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x11F0 (4592) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00,   // 0x1200 (4608) pixels
0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEA2, 0xFEE0, 0xF6E0, 0xE667, 0xE694, 0xF73D, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x1210 (4624) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFBF, 0xFF76, 0xF70B, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00,   // 0x1220 (4640) pixels
0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1230 (4656) pixels
0xFF80, 0xFF80, 0xFFA1, 0xFF61, 0xFF80, 0xFFA0, 0xFFE0, 0xFFA4, 0xBDC2, 0x1880, 0x0000, 0x0000, 0x0041, 0x0002, 0x0002, 0x0000,   // 0x1240 (4672) pixels
0x0040, 0x0003, 0x0000, 0x6300, 0xEF25, 0xFFE1, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1250 (4688) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xF740, 0xFF60, 0xFFC2, 0xFFC2, 0xBDC5, 0x2940, 0x0000, 0x0823, 0x0861, 0x0020, 0x0020,   // 0x1260 (4704) pixels
0x0000, 0x1062, 0x0805, 0x0802, 0x5280, 0xE703, 0xFFE2, 0xF740, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1270 (4720) pixels
0xFF80, 0xFFA0, 0xFF80, 0xFFA0, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0,   // 0x1280 (4736) pixels
0xFEE0, 0xFEC1, 0xFEE0, 0xFEE0, 0xEEA3, 0xE68E, 0xEEDA, 0xF79F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x1290 (4752) pixels
0xFFFF, 0xF7FF, 0xFFDF, 0xFFBE, 0xFF31, 0xEEC3, 0xFEC0, 0xFEC0, 0xFEC1, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF00, 0xFF20, 0xFF40,   // 0x12A0 (4768) pixels
0xFF40, 0xFF40, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF81,   // 0x12B0 (4784) pixels
0xFF61, 0xFFA0, 0xFFC0, 0xFFE2, 0xD665, 0x5A80, 0x0820, 0x0020, 0x0040, 0x0020, 0x0020, 0x0022, 0x0001, 0x0000, 0x0864, 0x0001,   // 0x12C0 (4800) pixels
0x1860, 0x9423, 0xF744, 0xFFC0, 0xFF60, 0xFFA1, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60,   // 0x12D0 (4816) pixels
0xFF80, 0xFFA0, 0xFF60, 0xFFA1, 0xFFC4, 0xEEC1, 0x39A0, 0x0000, 0x0000, 0x0842, 0x0000, 0x0020, 0x0840, 0x0820, 0x0020, 0x0002,   // 0x12E0 (4832) pixels
0x0003, 0x0800, 0x83E0, 0xFF85, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0,   // 0x12F0 (4848) pixels
0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x1300 (4864) pixels
0xFEE0, 0xFEE0, 0xEE88, 0xE676, 0xEF3E, 0xF7FE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFDF,   // 0x1310 (4880) pixels
0xFF9D, 0xFF2E, 0xEEA0, 0xFEC1, 0xFEC1, 0xFEE2, 0xFEE1, 0xFF20, 0xFF40, 0xFF20, 0xFF00, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60,   // 0x1320 (4896) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF81, 0xFF41, 0xFF80, 0xFFA0,   // 0x1330 (4912) pixels
0xFFA3, 0xAD03, 0x1000, 0x0003, 0x0003, 0x0042, 0x0020, 0x0020, 0x0860, 0x0000, 0x0003, 0x0040, 0x0863, 0x0801, 0x30E0, 0xD604,   // 0x1340 (4928) pixels
0xFFE3, 0xFF40, 0xFF82, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF80, 0xFF80, 0xFFA0, 0xFF60,   // 0x1350 (4944) pixels
0xFFA2, 0xF722, 0xB500, 0x0801, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0001, 0x0800, 0x0080, 0x0020, 0x0862, 0x0800, 0x3120,   // 0x1360 (4960) pixels
0xCE03, 0xFFE2, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80,   // 0x1370 (4976) pixels
0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEC1, 0xFEC0, 0xFEE0, 0xEE84,   // 0x1380 (4992) pixels
0xDE53, 0xE6FD, 0xF7FD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFB, 0xFFFF, 0xEFFF, 0xFFFF, 0xFFBF, 0xFF13, 0xFEA2, 0xFEA0,   // 0x1390 (5008) pixels
0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x13A0 (5024) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF64, 0xFF80, 0xF760, 0xFFE0, 0xE747, 0x18C0, 0x0020,   // 0x13B0 (5040) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0020, 0x0841, 0x6325, 0xFFE4, 0xFFA0, 0xFF80,   // 0x13C0 (5056) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFE0, 0xF760, 0xFF80, 0xFFA0, 0xFF80, 0xFFE0, 0xE744, 0x28E1,   // 0x13D0 (5072) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0040, 0x0000, 0x0000, 0x0020, 0x0843, 0x5AE4, 0xFFE1, 0xFF60,   // 0x13E0 (5088) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x13F0 (5104) pixels
0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEA2, 0xFEE1, 0xFEE0, 0xFEC0, 0xFEA0, 0xEE28, 0xDE94, 0xDF7F,   // 0x1400 (5120) pixels
0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFC, 0xFFFF, 0xEFFF, 0xFFFF, 0xFFBF, 0xFEF0, 0xFEA1, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0,   // 0x1410 (5136) pixels
0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1420 (5152) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF43, 0xFF80, 0xFF80, 0xFFC0, 0xB5C4, 0x1060, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1430 (5168) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0020, 0x0000, 0x39C1, 0xDF01, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1440 (5184) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFC0, 0xFF60, 0xFF80, 0xFF80, 0xFF60, 0xFFC0, 0xB580, 0x1020, 0x0000, 0x0000, 0x0000,   // 0x1450 (5200) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x0020, 0x0002, 0x31A0, 0xEF41, 0xFFA0, 0xFF80, 0xFF80, 0xFF80,   // 0x1460 (5216) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40,   // 0x1470 (5232) pixels
0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEC1, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEA0, 0xEE66, 0xDE92, 0xDF3E, 0xFFDF, 0xFFFF, 0xFFFF,   // 0x1480 (5248) pixels
0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xF7FF, 0xFFFF, 0xFF9A, 0xFECB, 0xF680, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF20,   // 0x1490 (5264) pixels
0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x14A0 (5280) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF42, 0xFF80, 0xFFA0, 0xF7A3, 0x7380, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x14B0 (5296) pixels
0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0001, 0x1060, 0xAD60, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x14C0 (5312) pixels
0xFF80, 0xFF80, 0xFFC0, 0xFF60, 0xFF80, 0xFFA0, 0xFF60, 0xF782, 0x6B60, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x14D0 (5328) pixels
0x0000, 0x0000, 0x0020, 0x0020, 0x0000, 0x0020, 0x0002, 0x0860, 0xBDA0, 0xFFA1, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x14E0 (5344) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20,   // 0x14F0 (5360) pixels
0xFF00, 0xFF00, 0xFEC1, 0xFEE0, 0xFEC0, 0xFEA0, 0xFEA0, 0xEE82, 0xDE8E, 0xDEDC, 0xF7BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x1500 (5376) pixels
0xFFFF, 0xFFFF, 0xFFFE, 0xFF54, 0xF6A6, 0xF680, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40,   // 0x1510 (5392) pixels
0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0,   // 0x1520 (5408) pixels
0xFF41, 0xFF80, 0xFFC0, 0xEF24, 0x3160, 0x0001, 0x0002, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1530 (5424) pixels
0x0001, 0x0040, 0x0001, 0x0000, 0x8400, 0xFFC2, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0,   // 0x1540 (5440) pixels
0xFF60, 0xFF60, 0xFFA0, 0xFF80, 0xF785, 0x39A0, 0x0002, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020,   // 0x1550 (5456) pixels
0x0000, 0x0000, 0x0020, 0x0001, 0x0000, 0x83E0, 0xFF83, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1560 (5472) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFEE1,   // 0x1570 (5488) pixels
0xFEE0, 0xFEC0, 0xFEA2, 0xFEA0, 0xF6A0, 0xE689, 0xD677, 0xEF7D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDC,   // 0x1580 (5504) pixels
0xFF2D, 0xF681, 0xF6A0, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80,   // 0x1590 (5520) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFFA0, 0xFFC0,   // 0x15A0 (5536) pixels
0xDE85, 0x1020, 0x0002, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0021, 0x0022,   // 0x15B0 (5552) pixels
0x0000, 0x62C0, 0xFFC3, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFFA0,   // 0x15C0 (5568) pixels
0xFFC0, 0xE706, 0x1080, 0x0004, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x0000,   // 0x15D0 (5584) pixels
0x0000, 0x0000, 0x5260, 0xFF83, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x15E0 (5600) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFEE1, 0xFEE0, 0xF6E0, 0xFEA3,   // 0x15F0 (5616) pixels
0xFEA0, 0xFEC0, 0xEE86, 0xDE32, 0xE73C, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFF99, 0xF6E7, 0xF6A0, 0xFEC0,   // 0x1600 (5632) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1610 (5648) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFFA0, 0xFFA0, 0xFFC0, 0xC5E4, 0x0800, 0x0002,   // 0x1620 (5664) pixels
0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0001, 0x4180, 0xF784,   // 0x1630 (5680) pixels
0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF41, 0xFF60, 0xFFA0, 0xC624, 0x0000,   // 0x1640 (5696) pixels
0x0003, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0801, 0x0001, 0x0020, 0x0021, 0x3140,   // 0x1650 (5712) pixels
0xFF83, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1660 (5728) pixels
0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xF6E0, 0xFEC2, 0xFEA0, 0xFEC0, 0xF6A3,   // 0x1670 (5744) pixels
0xDE2B, 0xD6BA, 0xF7BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFDF, 0xFF37, 0xF6E3, 0xFEC0, 0xFEE0, 0xFEC1, 0xFEE0, 0xFEE0,   // 0x1680 (5760) pixels
0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1690 (5776) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFFA0, 0xFFA0, 0xFFC0, 0xAD23, 0x0800, 0x0001, 0x0020, 0x0000, 0x0000,   // 0x16A0 (5792) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0020, 0x0000, 0x0020, 0x0001, 0x20A0, 0xEF23, 0xFFA0, 0xFF80, 0xFF80,   // 0x16B0 (5808) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF61, 0xFF60, 0xFFC0, 0xAD62, 0x0000, 0x0001, 0x0000, 0x0000,   // 0x16C0 (5824) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0001, 0x0000, 0x0040, 0x0020, 0x20C0, 0xF761, 0xFF80, 0xFF80,   // 0x16D0 (5840) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60,   // 0x16E0 (5856) pixels
0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xFF00, 0xFEE1, 0xFEA0, 0xFEA0, 0xFEA2, 0xE646, 0xCE79, 0xEF7D,   // 0x16F0 (5872) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFD, 0xFFDF, 0xF715, 0xF6C1, 0xFEE0, 0xFF01, 0xF6A2, 0xFEE0, 0xFEE0, 0xFF00, 0xFF20, 0xFF20,   // 0x1700 (5888) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1710 (5904) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFFA0, 0xFF80, 0xFFC0, 0xA4C1, 0x0801, 0x0000, 0x0040, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1720 (5920) pixels
0x0000, 0x0000, 0x0000, 0x0001, 0x0860, 0x0000, 0x0040, 0x0000, 0x1840, 0xEF03, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1730 (5936) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF81, 0xFF80, 0xFF62, 0xFF80, 0xFFE0, 0xA501, 0x0000, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1740 (5952) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0802, 0x0001, 0x0000, 0x0040, 0x0020, 0x20A0, 0xE740, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1750 (5968) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40,   // 0x1760 (5984) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xFF01, 0xFF00, 0xFEA0, 0xFEA0, 0xFEA2, 0xEE63, 0xC638, 0xEF5D, 0xFFDF, 0xFFFF, 0xFFFF,   // 0x1770 (6000) pixels
0xEFFF, 0xFFFF, 0xFF9C, 0xFF07, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEE3, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60,   // 0x1780 (6016) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1790 (6032) pixels
0xFF80, 0xFF61, 0xFFA0, 0xFFE1, 0x9C82, 0x0800, 0x0000, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x17A0 (6048) pixels
0x0000, 0x0020, 0x0060, 0x0020, 0x0020, 0x1860, 0xDEC0, 0xFFC0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x17B0 (6064) pixels
0xFF80, 0xFFA0, 0xFF61, 0xFF80, 0xFFE0, 0x9481, 0x0841, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x17C0 (6080) pixels
0x0000, 0x0001, 0x0000, 0x0040, 0x0020, 0x0000, 0x1880, 0xE740, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x17D0 (6096) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20,   // 0x17E0 (6112) pixels
0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xDE4E, 0xDEBD, 0xF7DF, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFFF, 0xFF9B,   // 0x17F0 (6128) pixels
0xFEE6, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEE2, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80,   // 0x1800 (6144) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF62, 0xFFA0,   // 0x1810 (6160) pixels
0xFFE0, 0xA4E3, 0x0800, 0x0001, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020,   // 0x1820 (6176) pixels
0x0000, 0x0000, 0x20A0, 0xE701, 0xFFC0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF80, 0xFF61,   // 0x1830 (6192) pixels
0xFF80, 0xFFC0, 0x9CE2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1840 (6208) pixels
0x0000, 0x0040, 0x0001, 0x20C0, 0xEF40, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1850 (6224) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x1860 (6240) pixels
0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xDE4C, 0xD69B, 0xEFBF, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFFF, 0xFF57, 0xFEC4, 0xFEA0, 0xFEA0,   // 0x1870 (6256) pixels
0xFEC0, 0xFEE2, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1880 (6272) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF62, 0xFF80, 0xFFE0, 0xBD84, 0x0800,   // 0x1890 (6288) pixels
0x0822, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0020, 0x0000, 0x0000, 0x3940,   // 0x18A0 (6304) pixels
0xF763, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF60, 0xFF61, 0xFF80, 0xF7A0, 0xB584,   // 0x18B0 (6320) pixels
0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0041, 0x0001,   // 0x18C0 (6336) pixels
0x3120, 0xF762, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x18D0 (6352) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0,   // 0x18E0 (6368) pixels
0xFEC0, 0xFEC0, 0xDE49, 0xD659, 0xE77F, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFDF, 0xFF33, 0xF6A2, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEE1, 0xFF00,   // 0x18F0 (6384) pixels
0xFF00, 0xFF00, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1900 (6400) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF62, 0xFF60, 0xFFC0, 0xCE24, 0x0800, 0x0001, 0x0000, 0x0000,   // 0x1910 (6416) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0002, 0x0000, 0x0041, 0x0000, 0x5240, 0xFFA3, 0xFF81, 0xFF80,   // 0x1920 (6432) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF80, 0xFF61, 0xFFA1, 0xFFA0, 0xD685, 0x0820, 0x0003, 0x0000,   // 0x1930 (6448) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0002, 0x0001, 0x41C0, 0xFF83, 0xFF80,   // 0x1940 (6464) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1950 (6480) pixels
0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xE646,   // 0x1960 (6496) pixels
0xD636, 0xE75D, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFBE, 0xF70F, 0xF6A0, 0xFEA0, 0xFEC0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20,   // 0x1970 (6512) pixels
0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1980 (6528) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF61, 0xFF81, 0xFFE0, 0xDEC2, 0x20C0, 0x0001, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1990 (6544) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0002, 0x0020, 0x0041, 0x0000, 0x7360, 0xFFA2, 0xFF81, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x19A0 (6560) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xF780, 0xFFA0, 0xFF61, 0xFF81, 0xFFA0, 0xEF25, 0x28E0, 0x0003, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x19B0 (6576) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0002, 0x0000, 0x6AE0, 0xFFA3, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x19C0 (6592) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x19D0 (6608) pixels
0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xEE83, 0xD613, 0xDF1C, 0xFFFF,   // 0x19E0 (6624) pixels
0xFFFF, 0xFFFF, 0xFF9D, 0xF6EB, 0xF6A0, 0xFEC0, 0xFEC0, 0xFEE1, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60,   // 0x19F0 (6640) pixels
0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1A00 (6656) pixels
0xFF80, 0xFF60, 0xFF40, 0xFF81, 0xFFE0, 0xEF61, 0x5260, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1A10 (6672) pixels
0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x94C0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1A20 (6688) pixels
0xFF80, 0xF780, 0xFFA0, 0xFF61, 0xFF61, 0xFFA0, 0xF782, 0x5260, 0x0802, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1A30 (6704) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0040, 0x0002, 0x0000, 0x9CA0, 0xFFC1, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1A40 (6720) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40,   // 0x1A50 (6736) pixels
0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA1, 0xD611, 0xDEFA, 0xFFDF, 0xFFDF, 0xFFFE, 0xFF7C,   // 0x1A60 (6752) pixels
0xF6E8, 0xF6C0, 0xFEC0, 0xFEA0, 0xFEC2, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80,   // 0x1A70 (6768) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60,   // 0x1A80 (6784) pixels
0xFF60, 0xFFC0, 0xFFE0, 0x9463, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,   // 0x1A90 (6800) pixels
0x0000, 0x0000, 0x18A1, 0xCE80, 0xFFC0, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xF7A0, 0xFF80,   // 0x1AA0 (6816) pixels
0xFF61, 0xFF60, 0xFFA0, 0xFFE0, 0x9460, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0021, 0x0000,   // 0x1AB0 (6832) pixels
0x0000, 0x0040, 0x0002, 0x20E0, 0xD681, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1AC0 (6848) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00,   // 0x1AD0 (6864) pixels
0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xD5EF, 0xD6B9, 0xFFDF, 0xFFDF, 0xFFFE, 0xFF7C, 0xF6E7, 0xF6C0, 0xFEC0,   // 0x1AE0 (6880) pixels
0xFEA0, 0xFEC2, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1AF0 (6896) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFFA0, 0xFFE1,   // 0x1B00 (6912) pixels
0xBDC7, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0840, 0x3984,   // 0x1B10 (6928) pixels
0xF7E3, 0xFFE0, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA1, 0xFF80, 0xFF80, 0xFF80, 0xFFC0,   // 0x1B20 (6944) pixels
0xFFE0, 0xC604, 0x1841, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0042, 0x0000, 0x0000, 0x0040, 0x0002,   // 0x1B30 (6960) pixels
0x39A2, 0xFFC3, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1B40 (6976) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0,   // 0x1B50 (6992) pixels
0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xD5CD, 0xD698, 0xFFBF, 0xFFBF, 0xFFDF, 0xFF34, 0xFEC3, 0xFEA0, 0xFEC1, 0xFEE0, 0xFEC0, 0xFF00,   // 0x1B60 (7008) pixels
0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1B70 (7024) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xF780, 0xFF81, 0xFF61, 0xFF20, 0xFFE0, 0xEF23, 0x6B01, 0x0000,   // 0x1B80 (7040) pixels
0x0800, 0x0820, 0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0800, 0x0020, 0x0062, 0x0002, 0x1020, 0xACE3, 0xFFE0, 0xF760, 0xFF63,   // 0x1B90 (7056) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF81, 0xFF81, 0xFF60, 0xFFE0, 0xF760, 0xFFA1, 0xF745, 0x72E0,   // 0x1BA0 (7072) pixels
0x0020, 0x0020, 0x0002, 0x0001, 0x0020, 0x0000, 0x0800, 0x1002, 0x0840, 0x0000, 0x0843, 0x0004, 0x0800, 0xAD02, 0xFFE2, 0xFFA0,   // 0x1BB0 (7088) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1BC0 (7104) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0,   // 0x1BD0 (7120) pixels
0xFEC0, 0xE625, 0xCE3A, 0xE75E, 0xFFFF, 0xFFDF, 0xFF34, 0xFEC3, 0xFEA0, 0xFEC1, 0xFEE0, 0xFEC0, 0xFF00, 0xFF00, 0xFF20, 0xFF20,   // 0x1BE0 (7136) pixels
0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1BF0 (7152) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xF740, 0xFF61, 0xFF60, 0xFF80, 0xFFC4, 0xB545, 0x18C0, 0x0802, 0x0002, 0x0002,   // 0x1C00 (7168) pixels
0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0021, 0x0003, 0x0000, 0x5220, 0xEF05, 0xFFE1, 0xFF80, 0xFFA0, 0xFF80, 0xFF80, 0xFF80,   // 0x1C10 (7184) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF81, 0xF740, 0xFFA0, 0xFF80, 0xFFA1, 0xFFC5, 0xC580, 0x0001, 0x0000, 0x0020,   // 0x1C20 (7200) pixels
0x0020, 0x0000, 0x0021, 0x0821, 0x0000, 0x0020, 0x0042, 0x0005, 0x0000, 0x4A60, 0xDEE3, 0xFFC1, 0xFF60, 0xFF80, 0xFF80, 0xFF80,   // 0x1C30 (7216) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1C40 (7232) pixels
0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xEE25, 0xCE3A,   // 0x1C50 (7248) pixels
0xE75E, 0xFFFF, 0xFFDF, 0xF734, 0xF6C2, 0xFEA0, 0xFEC1, 0xFEE0, 0xFEC0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60,   // 0x1C60 (7264) pixels
0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1C70 (7280) pixels
0xFF80, 0xFF80, 0xFFA0, 0xFF40, 0xFF41, 0xFF80, 0xFF40, 0xFFE2, 0xEF67, 0x7BC0, 0x0801, 0x0001, 0x0000, 0x0040, 0x0020, 0x0020,   // 0x1C80 (7296) pixels
0x0020, 0x0040, 0x0843, 0x0001, 0x2100, 0xB5A1, 0xFFE2, 0xF740, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1C90 (7312) pixels
0xFF80, 0xFF80, 0xFF80, 0xFFA1, 0xF740, 0xFF80, 0xFFA0, 0xFF80, 0xFFC3, 0xFF83, 0x62E6, 0x1080, 0x0020, 0x0861, 0x0002, 0x0002,   // 0x1CA0 (7328) pixels
0x0020, 0x0860, 0x0060, 0x0004, 0x0003, 0x18E0, 0xB5A0, 0xFFE2, 0xF720, 0xFF22, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1CB0 (7344) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60,   // 0x1CC0 (7360) pixels
0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xEE25, 0xC639, 0xE75D, 0xFFFF, 0xFFDF,   // 0x1CD0 (7376) pixels
0xF733, 0xF6C2, 0xFEA0, 0xFEC0, 0xFEE0, 0xFEC0, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80,   // 0x1CE0 (7392) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0,   // 0x1CF0 (7408) pixels
0xFFA1, 0xFF40, 0xFF40, 0xFF80, 0xFFA0, 0xF7A2, 0xDF02, 0x4220, 0x0880, 0x0020, 0x0041, 0x0062, 0x0000, 0x0000, 0x0040, 0x0000,   // 0x1D00 (7424) pixels
0x0820, 0x94A0, 0xFFE2, 0xFFE0, 0xFF60, 0xFF60, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0,   // 0x1D10 (7440) pixels
0xFFA0, 0xFF60, 0xFF80, 0xFFC0, 0xFF80, 0xF780, 0xFFE0, 0xEF67, 0x5AC0, 0x0800, 0x0002, 0x0005, 0x0003, 0x0000, 0x0000, 0x0861,   // 0x1D20 (7456) pixels
0x0001, 0x1080, 0x8C60, 0xF7C1, 0xFFE0, 0xF6E0, 0xFF62, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1D30 (7472) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20,   // 0x1D40 (7488) pixels
0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xEE25, 0xC618, 0xE73D, 0xFFFF, 0xFFDF, 0xF732, 0xF6C2, 0xFEA0,   // 0x1D50 (7504) pixels
0xFEC0, 0xFEE0, 0xFEC0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1D60 (7520) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFF81, 0xFF60,   // 0x1D70 (7536) pixels
0xFFA0, 0xFFA0, 0xEF60, 0xFFE1, 0xDEE8, 0x6320, 0x0020, 0x0001, 0x0004, 0x0004, 0x0001, 0x0000, 0x28E0, 0x9460, 0xF781, 0xFFC0,   // 0x1D80 (7552) pixels
0xFF80, 0xFFC0, 0xF740, 0xFF81, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF80, 0xFF80,   // 0x1D90 (7568) pixels
0xFFA0, 0xFFA0, 0xFFA0, 0xFFA0, 0xFFE0, 0xD682, 0x7321, 0x1880, 0x0001, 0x0002, 0x0001, 0x0000, 0x0000, 0x20E0, 0x94A2, 0xEF83,   // 0x1DA0 (7584) pixels
0xFFE0, 0xFF60, 0xFF40, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1DB0 (7600) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x1DC0 (7616) pixels
0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xEE25, 0xC618, 0xE73C, 0xFFDF, 0xFFDF, 0xF732, 0xF6C1, 0xFEA0, 0xFEC0, 0xFEE0, 0xFEC1,   // 0x1DD0 (7632) pixels
0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1DE0 (7648) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF40, 0xFFA0, 0xFF80, 0xFF80, 0xFFE0, 0xFF80,   // 0x1DF0 (7664) pixels
0xFF80, 0xFFE2, 0xDEC2, 0x9CA2, 0x5241, 0x1840, 0x0800, 0x3120, 0x5A60, 0xBD85, 0xFFA3, 0xFFE0, 0xFFA0, 0xFF40, 0xFF60, 0xFFA0,   // 0x1E00 (7680) pixels
0xFF42, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF80, 0xFFC0, 0xFF80, 0xF760, 0xFFA1, 0xFFC0,   // 0x1E10 (7696) pixels
0xF780, 0xFF60, 0xFFE4, 0xEF44, 0x9460, 0x4A00, 0x1060, 0x0800, 0x2920, 0x6B01, 0xAD23, 0xFFA5, 0xFFE0, 0xFF60, 0xFF41, 0xFFA1,   // 0x1E20 (7712) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1E30 (7728) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0,   // 0x1E40 (7744) pixels
0xFEC0, 0xFEC0, 0xEE44, 0xC5F7, 0xE73C, 0xFFDF, 0xFFDF, 0xF731, 0xF6C1, 0xFEA0, 0xFEC0, 0xFEE0, 0xFEC1, 0xFEE0, 0xFF00, 0xFF20,   // 0x1E50 (7760) pixels
0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1E60 (7776) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF61, 0xFF40, 0xFFA0, 0xFFC0, 0xFF80, 0xFFA1, 0xFFA0, 0xF720, 0xFF80, 0xFFE0,   // 0x1E70 (7792) pixels
0xFFE3, 0xEF45, 0xDEC5, 0xE6A4, 0xEF25, 0xFF85, 0xFFE4, 0xFFC0, 0xFF60, 0xFFE1, 0xFF60, 0xFF40, 0xFFC1, 0xF780, 0xFF80, 0xFF80,   // 0x1E80 (7808) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF81, 0xFFC0, 0xFFC0, 0xFF80, 0xF760, 0xFF81, 0xFFA1, 0xF780, 0xFF20, 0xFF60,   // 0x1E90 (7824) pixels
0xF780, 0xFFC2, 0xF785, 0xD685, 0xD644, 0xEF07, 0xF786, 0xFFE3, 0xFFE1, 0xFF60, 0xFF80, 0xFF80, 0xFFA0, 0xF7A0, 0xFF80, 0xFF80,   // 0x1EA0 (7840) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1EB0 (7856) pixels
0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xF644,   // 0x1EC0 (7872) pixels
0xC5F7, 0xE73C, 0xFFFE, 0xFFDE, 0xF731, 0xF6C1, 0xFE80, 0xFEC0, 0xFEE0, 0xFEC1, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40,   // 0x1ED0 (7888) pixels
0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1EE0 (7904) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF42, 0xFFA0, 0xFF60, 0xFFA0, 0xFFA1, 0xF720, 0xFF61, 0xFFA0, 0xFF20, 0xFF60, 0xFF60, 0xFFA0, 0xFFE0,   // 0x1EF0 (7920) pixels
0xFFC0, 0xFFA0, 0xFFA0, 0xFF80, 0xFF60, 0xFF81, 0xFF40, 0xFF20, 0xFF83, 0xF720, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1F00 (7936) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF40, 0xFFA0, 0xFF60, 0xF760, 0xFFA0, 0xFF82, 0xFF61, 0xFFA1, 0xFFA0, 0xFF60, 0xFF80, 0xFFC0, 0xF7C0,   // 0x1F10 (7952) pixels
0xFFE0, 0xFFE0, 0xFF80, 0xFFC0, 0xF740, 0xFF60, 0xFF62, 0xFFA1, 0xFF80, 0xF7C0, 0xF7C1, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1F20 (7968) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60,   // 0x1F30 (7984) pixels
0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xF644, 0xC5F7, 0xE73C, 0xFFFE,   // 0x1F40 (8000) pixels
0xFFFD, 0xF716, 0xF6A1, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE1, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60,   // 0x1F50 (8016) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1F60 (8032) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1F70 (8048) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1F80 (8064) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1F90 (8080) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1FA0 (8096) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40,   // 0x1FB0 (8112) pixels
0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xE683, 0xCDD7, 0xEF7D, 0xF7FF, 0xFFFD, 0xFF36, 0xF6A1,   // 0x1FC0 (8128) pixels
0xFEC0, 0xFEC1, 0xFEC0, 0xFEE1, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80,   // 0x1FD0 (8144) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1FE0 (8160) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x1FF0 (8176) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2000 (8192) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2010 (8208) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2020 (8224) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00,   // 0x2030 (8240) pixels
0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xE683, 0xCDD7, 0xE77D, 0xF7DF, 0xFFFE, 0xFF37, 0xF6A2, 0xFEC0, 0xFEA1, 0xFEC0,   // 0x2040 (8256) pixels
0xFEE1, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2050 (8272) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2060 (8288) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2070 (8304) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2080 (8320) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2090 (8336) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x20A0 (8352) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0,   // 0x20B0 (8368) pixels
0xFEC0, 0xFEC0, 0xFEC0, 0xE645, 0xCDD8, 0xE77D, 0xF7DE, 0xFFFF, 0xFF37, 0xF6A2, 0xFEA0, 0xFEC1, 0xFEC0, 0xFF01, 0xFEE0, 0xFF00,   // 0x20C0 (8384) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x20D0 (8400) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x20E0 (8416) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x20F0 (8432) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2100 (8448) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2110 (8464) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2120 (8480) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0,   // 0x2130 (8496) pixels
0xDE27, 0xCDD8, 0xE77C, 0xEFDE, 0xFFFF, 0xFF59, 0xF6C3, 0xFEA0, 0xFEA1, 0xFEC0, 0xFF01, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF20,   // 0x2140 (8512) pixels
0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2150 (8528) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2160 (8544) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2170 (8560) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2180 (8576) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2190 (8592) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x21A0 (8608) pixels
0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xDE09, 0xCDF9, 0xE77D,   // 0x21B0 (8624) pixels
0xEFFE, 0xFFFF, 0xFF59, 0xF6C4, 0xFEC0, 0xFEA1, 0xFEE0, 0xFF01, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60,   // 0x21C0 (8640) pixels
0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x21D0 (8656) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x21E0 (8672) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x21F0 (8688) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2200 (8704) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2210 (8720) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40,   // 0x2220 (8736) pixels
0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xDDEB, 0xD61A, 0xE79D, 0xF7FF, 0xFFFF, 0xFF7A,   // 0x2230 (8752) pixels
0xF6E5, 0xFEC0, 0xFEA1, 0xFEE0, 0xFF01, 0xFEC0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80,   // 0x2240 (8768) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2250 (8784) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2260 (8800) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2270 (8816) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2280 (8832) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2290 (8848) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00,   // 0x22A0 (8864) pixels
0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xD5CC, 0xD63B, 0xE7BD, 0xF7FF, 0xFFFF, 0xFF7B, 0xF6E5, 0xFEA0, 0xFEA1,   // 0x22B0 (8880) pixels
0xFEE0, 0xFF01, 0xFEC0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x22C0 (8896) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x22D0 (8912) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x22E0 (8928) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x22F0 (8944) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2300 (8960) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2310 (8976) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0,   // 0x2320 (8992) pixels
0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xD5AD, 0xD65B, 0xE7BD, 0xF7FF, 0xF7FF, 0xFFBF, 0xF6EF, 0xF680, 0xFEC0, 0xFEE0, 0xF6E0, 0xF700,   // 0x2330 (9008) pixels
0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFFA0, 0xFFC0, 0xFF80, 0xFFC0, 0xFF81, 0xFF40, 0xFFC0,   // 0x2340 (9024) pixels
0xFFA3, 0xFF64, 0xFF42, 0xFF60, 0xFF40, 0xFF60, 0xFFC2, 0xEF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2350 (9040) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2360 (9056) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2370 (9072) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2380 (9088) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF61, 0xFF81, 0xFF80, 0xFF60, 0xFFC0, 0xFFA0,   // 0x2390 (9104) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE1, 0xFEE1, 0xFEC1, 0xFEA1, 0xFEA0,   // 0x23A0 (9120) pixels
0xFEC1, 0xC592, 0xDEFC, 0xFFFE, 0xFFFE, 0xF7FF, 0xFFBF, 0xF6F0, 0xF680, 0xFEC0, 0xFEE0, 0xF6C0, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x23B0 (9136) pixels
0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFFC0, 0xFFA0, 0xFF40, 0xFF80, 0xF740, 0xFF60, 0xFF80,   // 0x23C0 (9152) pixels
0xFFC0, 0xFFA0, 0xFF61, 0xFF61, 0xFFC0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x23D0 (9168) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x23E0 (9184) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x23F0 (9200) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2400 (9216) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFC2, 0xFF60, 0xFF80, 0xF720, 0xFF80, 0xFFC1, 0xFFA1, 0xFFA1, 0xFF80, 0xFF80, 0xFF80,   // 0x2410 (9232) pixels
0xFF80, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEA0, 0xEE82, 0xC593, 0xDEFC,   // 0x2420 (9248) pixels
0xFFFE, 0xFFFE, 0xFFFF, 0xFFBF, 0xF6F3, 0xF683, 0xFEC0, 0xFEC0, 0xFEC0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40,   // 0x2430 (9264) pixels
0xFF40, 0xFF40, 0xFF81, 0xFF61, 0xFF61, 0xFF80, 0xFFA0, 0xFF80, 0xFFA0, 0xFFC0, 0xFFE0, 0xFFC0, 0xFF80, 0xFF60, 0xFF80, 0xFF63,   // 0x2440 (9280) pixels
0xF741, 0xFFC0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2450 (9296) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2460 (9312) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2470 (9328) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2480 (9344) pixels
0xFF80, 0xFF80, 0xF762, 0xF760, 0xFFE0, 0xFFE0, 0xF760, 0xFF80, 0xFF80, 0xFF81, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF40,   // 0x2490 (9360) pixels
0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xE646, 0xC5B5, 0xDF1D, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x24A0 (9376) pixels
0xFFDF, 0xF716, 0xF6A7, 0xFEC0, 0xFEC0, 0xFEC0, 0xFF00, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF81,   // 0x24B0 (9392) pixels
0xFFA1, 0xFF81, 0xFF80, 0xFF60, 0xFFA0, 0xFFE1, 0xF784, 0xF7C4, 0xF7A3, 0xFFE1, 0xFFC0, 0xFF60, 0xFF64, 0xFF61, 0xF780, 0xFF80,   // 0x24C0 (9408) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x24D0 (9424) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x24E0 (9440) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x24F0 (9456) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFC0,   // 0x2500 (9472) pixels
0xF7C1, 0xEF61, 0xF7A2, 0xFFE1, 0xFFC0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF21,   // 0x2510 (9488) pixels
0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xD5EA, 0xC5F8, 0xE73D, 0xFFFF, 0xFFFF, 0xF7FF, 0xFFFF, 0xFF3A, 0xF6CB,   // 0x2520 (9504) pixels
0xF6C0, 0xFEC0, 0xFEA0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xF760, 0xFFA0, 0xFF80, 0xFF61,   // 0x2530 (9520) pixels
0xFF60, 0xFFE0, 0xF763, 0xAD04, 0x6301, 0x7380, 0xCE42, 0xFFE3, 0xFFA0, 0xFF41, 0xFFC2, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2540 (9536) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2550 (9552) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2560 (9568) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2570 (9584) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xF7E1, 0xB580, 0x6B20, 0x7BC1,   // 0x2580 (9600) pixels
0xCE43, 0xFFE3, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF21, 0xFF00, 0xFF00, 0xFF00,   // 0x2590 (9616) pixels
0xFEE0, 0xFEE0, 0xFEC0, 0xFEA0, 0xCDCF, 0xCE5A, 0xE77E, 0xFFDF, 0xFFDF, 0xF7FF, 0xFFFF, 0xFF5D, 0xF6CF, 0xF6E0, 0xFEC0, 0xFEA1,   // 0x25A0 (9632) pixels
0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF80, 0xFFA0, 0xFF60, 0xFF61, 0xFF80, 0xFFE0, 0xC5E2,   // 0x25B0 (9648) pixels
0x2920, 0x0000, 0x0800, 0x6B20, 0xEF64, 0xFFE1, 0xF720, 0xFF80, 0xF760, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x25C0 (9664) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x25D0 (9680) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x25E0 (9696) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x25F0 (9712) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xD6E4, 0x2960, 0x0000, 0x0801, 0x4A00, 0xEF24, 0xFFA0,   // 0x2600 (9728) pixels
0xFF60, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF01, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEC0, 0xFE81,   // 0x2610 (9744) pixels
0xF661, 0xBDD3, 0xCEBC, 0xEFBD, 0xFFDF, 0xFFDF, 0xF7FF, 0xFFFF, 0xFF7F, 0xF6F2, 0xF6E0, 0xFEC0, 0xFE82, 0xFEC0, 0xFEE0, 0xFEE0,   // 0x2620 (9760) pixels
0xFF00, 0xFF00, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFFA0, 0xFFA0, 0xFF40, 0xFF41, 0xFF80, 0xFFE0, 0xAD62, 0x0800, 0x0023, 0x0001,   // 0x2630 (9776) pixels
0x20C0, 0xBDA3, 0xFFE3, 0xFF80, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2640 (9792) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2650 (9808) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2660 (9824) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2670 (9840) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0x8C65, 0x0000, 0x0005, 0x0003, 0x18A0, 0xE6E4, 0xFFC1, 0xFF60, 0xFF80, 0xFF80,   // 0x2680 (9856) pixels
0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF01, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEA1, 0xF662, 0xF623, 0xBDD6, 0xD71E,   // 0x2690 (9872) pixels
0xF7FD, 0xFFDF, 0xFFDF, 0xF7FF, 0xFFFF, 0xFF7F, 0xFF14, 0xF701, 0xFEC0, 0xFE82, 0xFEA0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20,   // 0x26A0 (9888) pixels
0xFF20, 0xFF40, 0xFF40, 0xF741, 0xFF80, 0xFF40, 0xFF21, 0xFF40, 0xFFE0, 0xC626, 0x1042, 0x0020, 0x0002, 0x0800, 0x83E0, 0xFFA2,   // 0x26B0 (9904) pixels
0xFF80, 0xFFC0, 0xFFC0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x26C0 (9920) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x26D0 (9936) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x26E0 (9952) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x26F0 (9968) pixels
0xFF80, 0xFF80, 0xFF80, 0x2120, 0x0000, 0x0004, 0x0000, 0x4AA0, 0xFFE7, 0xF720, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60,   // 0x2700 (9984) pixels
0xFF40, 0xFF20, 0xFF20, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEA2, 0xF643, 0xF604, 0xBDD8, 0xDF3F, 0xF7FD, 0xFFDF, 0xFFDF,   // 0x2710 (10000) pixels
0xFFFF, 0xFFFE, 0xFFFF, 0xFF7D, 0xF6E9, 0xFEA0, 0xFEA1, 0xFEA1, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40,   // 0x2720 (10016) pixels
0xFF40, 0xFF81, 0xFF60, 0xFFC0, 0xF740, 0xFFA1, 0xFF45, 0x7B20, 0x0001, 0x0020, 0x0002, 0x1080, 0xCEA3, 0xFFE0, 0xFF60, 0xFF60,   // 0x2730 (10032) pixels
0xFF80, 0xFF80, 0xFFA1, 0xFFC1, 0xFFA0, 0xFFA0, 0xFF81, 0xFF63, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2740 (10048) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2750 (10064) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2760 (10080) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xF762, 0xFF80, 0xFF40, 0xFFA1, 0xFF40, 0xFFC0, 0xF7E4, 0x8461,   // 0x2770 (10096) pixels
0x0061, 0x0020, 0x0821, 0x1000, 0xB523, 0xFFE0, 0xF740, 0xFF83, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20,   // 0x2780 (10112) pixels
0xFEE0, 0xFF20, 0xFEC2, 0xFE62, 0xFE60, 0xFEC0, 0xF6C4, 0xC590, 0xCE79, 0xF79E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2790 (10128) pixels
0xFF9E, 0xFEEE, 0xFEA1, 0xFEA0, 0xFEA1, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF20, 0xFF61, 0xFF40,   // 0x27A0 (10144) pixels
0xFFA0, 0xF760, 0xFFA0, 0xFFE5, 0xCDA0, 0x0000, 0x0860, 0x0000, 0x1061, 0x52A0, 0xFFE2, 0xFFA0, 0xFF61, 0xFF80, 0xFF60, 0xFF40,   // 0x27B0 (10160) pixels
0xFF60, 0xFF80, 0xFF80, 0xFFA0, 0xFF61, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x27C0 (10176) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x27D0 (10192) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x27E0 (10208) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA1, 0xFF61, 0xFF80, 0xFF40, 0xFFE0, 0xD6C6, 0x2940, 0x0020, 0x0041, 0x0000,   // 0x27F0 (10224) pixels
0x4180, 0xF747, 0xFFA0, 0xFFA0, 0xFF81, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xFF20, 0xFEC1,   // 0x2800 (10240) pixels
0xFE82, 0xFEA0, 0xFEC0, 0xE666, 0xC592, 0xD6BA, 0xF7BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFF15, 0xF6C4,   // 0x2810 (10256) pixels
0xFEC0, 0xFEA1, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF80, 0xFF40, 0xFFA0, 0xFF80, 0xFF60,   // 0x2820 (10272) pixels
0xFFE3, 0xFFA3, 0x5AE0, 0x0000, 0x0001, 0x0001, 0x0840, 0xAD61, 0xFFE0, 0xFF61, 0xFFA0, 0xFF80, 0xFF61, 0xFF80, 0xFF80, 0xFF80,   // 0x2830 (10288) pixels
0xFFC0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2840 (10304) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2850 (10320) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2860 (10336) pixels
0xFF80, 0xFF80, 0xFFA0, 0xFF42, 0xFFC5, 0xFF40, 0xFFC0, 0xF7A4, 0x7362, 0x0000, 0x0000, 0x0825, 0x0800, 0xAD22, 0xFFE4, 0xFFA0,   // 0x2870 (10352) pixels
0xFF60, 0xFFA0, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFF01, 0xFEC0, 0xFE81, 0xFEE0, 0xFEC0,   // 0x2880 (10368) pixels
0xD5E9, 0xCDD6, 0xE71C, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFF5B, 0xF6CA, 0xF6C0, 0xFEC0, 0xFEE0,   // 0x2890 (10384) pixels
0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF60, 0xFF80, 0xFF40, 0xFF80, 0xFFA0, 0xFF60, 0xFF80, 0xFFE0, 0xDEC3,   // 0x28A0 (10400) pixels
0x1840, 0x0004, 0x0001, 0x0000, 0x39A0, 0xE6E5, 0xFFE0, 0xF760, 0xFFA0, 0xFFA0, 0xFFC1, 0xFF80, 0xFF80, 0xFFC0, 0xFF80, 0xFF80,   // 0x28B0 (10416) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x28C0 (10432) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x28D0 (10448) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x28E0 (10464) pixels
0xFF42, 0xFF81, 0xFF80, 0xFFE1, 0xB564, 0x1060, 0x0001, 0x0021, 0x0002, 0x5260, 0xFFC4, 0xFFC0, 0xFF80, 0xFF60, 0xFFA1, 0xFF60,   // 0x28F0 (10480) pixels
0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE3, 0xFEC0, 0xFE80, 0xFF00, 0xEEA0, 0xC5AE, 0xD63A, 0xEF7D,   // 0x2900 (10496) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFDF, 0xFFFF, 0xFFFF, 0xFF9F, 0xF711, 0xF6C1, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x2910 (10512) pixels
0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFFE2, 0x7B81, 0x0801, 0x0822,   // 0x2920 (10528) pixels
0x0000, 0x0000, 0x7B85, 0xFFE1, 0xF7A0, 0xF780, 0xF760, 0xFFC0, 0xFFA1, 0xFF80, 0xFFA1, 0xFF40, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2930 (10544) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2940 (10560) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2950 (10576) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFFC1, 0xEF40, 0xFFE1,   // 0x2960 (10592) pixels
0xDEC2, 0x41C0, 0x0000, 0x0020, 0x0000, 0x1860, 0xCE25, 0xFFE0, 0xFFC0, 0xFF40, 0xFFA0, 0xFF41, 0xFF60, 0xFF60, 0xFF40, 0xFF40,   // 0x2970 (10608) pixels
0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEC3, 0xFEC0, 0xFEA0, 0xFEE1, 0xDE85, 0xC5B3, 0xDE9D, 0xF7BE, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2980 (10624) pixels
0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF738, 0xF6C9, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20,   // 0x2990 (10640) pixels
0xFF20, 0xFF20, 0xFF60, 0xFF80, 0xFF40, 0xFF40, 0xFF81, 0xFF80, 0xFF80, 0xFF80, 0xEF24, 0x41C0, 0x0000, 0x0000, 0x0000, 0x1880,   // 0x29A0 (10656) pixels
0xA501, 0xFFE4, 0xFFE2, 0xEF60, 0xF780, 0xFFC0, 0xFF61, 0xFF81, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x29B0 (10672) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x29C0 (10688) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x29D0 (10704) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF81, 0xFF80, 0xFFE0, 0xEF82, 0x6B20, 0x0000, 0x0022,   // 0x29E0 (10720) pixels
0x0020, 0x0800, 0x83E0, 0xFFE4, 0xF780, 0xFFA0, 0xFFA0, 0xFF80, 0xFF40, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x29F0 (10736) pixels
0xFEE0, 0xFF00, 0xFEC2, 0xFEA0, 0xFEA0, 0xF6A3, 0xCE2B, 0xC617, 0xE73F, 0xFFDF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF,   // 0x2A00 (10752) pixels
0xFFDF, 0xF7FF, 0xF7FF, 0xFF7E, 0xF6B0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF21, 0xFF80,   // 0x2A10 (10768) pixels
0xFF80, 0xFF40, 0xFF40, 0xFF61, 0xFF81, 0xFF60, 0xFF60, 0xFFE2, 0xB5A1, 0x18C0, 0x0801, 0x0000, 0x0000, 0x2941, 0xC5E1, 0xFFE6,   // 0x2A20 (10784) pixels
0xFFE1, 0xF760, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2A30 (10800) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2A40 (10816) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2A50 (10832) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF81, 0xFF60, 0xFFA3, 0x8C01, 0x0820, 0x0002, 0x0000, 0x0020, 0x5240, 0xE704,   // 0x2A60 (10848) pixels
0xFFE0, 0xFFA0, 0xFF20, 0xFFE4, 0xFF20, 0xFF80, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xF720, 0xFEC0,   // 0x2A70 (10864) pixels
0xFE60, 0xFEA0, 0xE665, 0xC5F2, 0xD69B, 0xEFBF, 0xFFDF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xF7DF, 0xF7FE, 0xF7FE,   // 0x2A80 (10880) pixels
0xFF9F, 0xFEB6, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF01, 0xFF20, 0xFF20, 0xFF20, 0xFF60,   // 0x2A90 (10896) pixels
0xFF62, 0xFF62, 0xFF81, 0xFFA0, 0xF780, 0xFFE3, 0x73A1, 0x0002, 0x0841, 0x0040, 0x0004, 0x4A20, 0xDEC5, 0xFFE4, 0xEF60, 0xFFA0,   // 0x2AA0 (10912) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2AB0 (10928) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2AC0 (10944) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2AD0 (10960) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF61, 0xFFE2, 0xBDA0, 0x2080, 0x0003, 0x1064, 0x0000, 0x0062, 0xB585, 0xFFE3, 0xFFC0, 0xFFA0, 0xFF20,   // 0x2AE0 (10976) pixels
0xFF44, 0xFF03, 0xFFA0, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xF720, 0xFEC0, 0xFE61, 0xFEA0, 0xDE26,   // 0x2AF0 (10992) pixels
0xC5B6, 0xDEFD, 0xEFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFD, 0xEFB9, 0xD6F4,   // 0x2B00 (11008) pixels
0xFEC0, 0xFEC1, 0xFEA3, 0xFEA0, 0xFEC0, 0xFEE1, 0xFF02, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80,   // 0x2B10 (11024) pixels
0xFF82, 0xF720, 0xFFE0, 0xEEE4, 0x6260, 0x0800, 0x0000, 0x0020, 0x0002, 0x5281, 0xDEE4, 0xFFE2, 0xF760, 0xFF80, 0xFFA0, 0xFF40,   // 0x2B20 (11040) pixels
0xF780, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFFA0, 0xFF81, 0xFF41, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2B30 (11056) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2B40 (11072) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xF780, 0xFFC0, 0xFF80, 0xF780, 0xFFA0, 0xFF80, 0xFF80, 0xFFA2,   // 0x2B50 (11088) pixels
0xFFE2, 0xBDC2, 0x20E0, 0x0001, 0x1083, 0x0001, 0x1840, 0x9C45, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60,   // 0x2B60 (11104) pixels
0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFE61, 0xFE80, 0xFEE0, 0xEE83, 0xC5B2, 0xC63C, 0xEF7E, 0xFFFF,   // 0x2B70 (11120) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFE, 0xF7DB, 0xDF37, 0xFEA1, 0xFEA2, 0xFEA0,   // 0x2B80 (11136) pixels
0xFEC0, 0xFEE0, 0xFEE1, 0xFF01, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF81, 0xFF40, 0xFF80,   // 0x2B90 (11152) pixels
0xFFE4, 0xCE04, 0x41C0, 0x0000, 0x0024, 0x0000, 0x0000, 0x6300, 0xE723, 0xFFE2, 0xF740, 0xEEC0, 0xFFE1, 0xFF80, 0xFF60, 0xFF60,   // 0x2BA0 (11168) pixels
0xFFA0, 0xFFA0, 0xFF60, 0xFF60, 0xFFA1, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2BB0 (11184) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2BC0 (11200) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFC0, 0xFF61, 0xFF62, 0xFFC0, 0xFFE0, 0xFF81, 0xF780, 0xFFC0, 0xC624, 0x2900, 0x0000,   // 0x2BD0 (11216) pixels
0x0060, 0x0002, 0x0802, 0x6B20, 0xF7A1, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20,   // 0x2BE0 (11232) pixels
0xFF20, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFE80, 0xFEC0, 0xFEC0, 0xDE28, 0xC5D5, 0xD6DC, 0xF7BE, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2BF0 (11248) pixels
0xFFFF, 0xFFFF, 0xFFDD, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFD, 0xEF7B, 0xFE8A, 0xF6A3, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x2C00 (11264) pixels
0xFEE0, 0xFEE0, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFFA1, 0xFF40, 0xFFC0, 0xFFE3, 0xAD80,   // 0x2C10 (11280) pixels
0x2940, 0x0004, 0x0060, 0x0000, 0x0000, 0x5AC0, 0xD6A2, 0xFFE0, 0xFFA0, 0xFF60, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFFA1, 0xFFC1,   // 0x2C20 (11296) pixels
0xFFA0, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2C30 (11312) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2C40 (11328) pixels
0xFF80, 0xFF80, 0xFF40, 0xFF61, 0xFF82, 0xFF80, 0xFFA0, 0xFFE0, 0xF7A2, 0xCE23, 0x2920, 0x0000, 0x0000, 0x0043, 0x0002, 0x4A60,   // 0x2C50 (11344) pixels
0xF7A3, 0xFFE0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xFEE0,   // 0x2C60 (11360) pixels
0xFEE0, 0xFEC0, 0xFE80, 0xFEE0, 0xEE63, 0xC5AF, 0xCE59, 0xE79D, 0xFFFF, 0xFFBF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDD,   // 0x2C70 (11376) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xF6B4, 0xEEC7, 0xF6C0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00,   // 0x2C80 (11392) pixels
0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFFA1, 0xFFA1, 0xF740, 0xFFC0, 0xFFE4, 0xA525, 0x20A0, 0x0003,   // 0x2C90 (11408) pixels
0x0000, 0x0040, 0x0000, 0x4A22, 0xDEC5, 0xFFC1, 0xFFE2, 0xFF20, 0xFF60, 0xFFA0, 0xFF80, 0xFF60, 0xFF80, 0xFFA0, 0xFFA0, 0xFF80,   // 0x2CA0 (11424) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2CB0 (11440) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF81,   // 0x2CC0 (11456) pixels
0xFF20, 0xFF60, 0xFFA0, 0xF7C0, 0xF7E0, 0xA543, 0x28C1, 0x0002, 0x0060, 0x0021, 0x0004, 0x4A41, 0xD6E2, 0xFFE2, 0xF740, 0xFF80,   // 0x2CD0 (11472) pixels
0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEA0,   // 0x2CE0 (11488) pixels
0xFEC0, 0xD5CA, 0xBD96, 0xD6FB, 0xF7FE, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2CF0 (11504) pixels
0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF71C, 0xEEED, 0xEEC0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20,   // 0x2D00 (11520) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xF720, 0xFFC1, 0xFFA0, 0xF740, 0xFFE2, 0xFFC6, 0xAD40, 0x0802, 0x0860, 0x0020, 0x0022,   // 0x2D10 (11536) pixels
0x0003, 0x3121, 0xB584, 0xFFE3, 0xFFE0, 0xFF60, 0xFF40, 0xFFA0, 0xFFA0, 0xF740, 0xF760, 0xFFC1, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2D20 (11552) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2D30 (11568) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF40, 0xFFA0, 0xF740, 0xFFE0,   // 0x2D40 (11584) pixels
0xFFE4, 0x8421, 0x0800, 0x0002, 0x10A2, 0x0001, 0x0001, 0x4A60, 0xCEC2, 0xFFE3, 0xFF42, 0xFFA2, 0xFF80, 0xFF60, 0xFF60, 0xFF60,   // 0x2D50 (11600) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xE645, 0xC591, 0xC61A,   // 0x2D60 (11616) pixels
0xE79C, 0xFFFF, 0xFFBF, 0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2D70 (11632) pixels
0xFFFF, 0xF79F, 0xEF35, 0xEEC8, 0xF682, 0xFE80, 0xFEA0, 0xFEE0, 0xFF00, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40,   // 0x2D80 (11648) pixels
0xFF40, 0xFF60, 0xFF40, 0xFF60, 0xFF60, 0xFF40, 0xFF81, 0xFFE1, 0xFFE0, 0xAD43, 0x1860, 0x0001, 0x0000, 0x0000, 0x0001, 0x18A0,   // 0x2D90 (11664) pixels
0x8C60, 0xF763, 0xFFC3, 0xFFE2, 0xFFC0, 0xFF80, 0xFFA0, 0xFF80, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2DA0 (11680) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2DB0 (11696) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFE1, 0xFFA0, 0xFFE2, 0xDEA5, 0x5AA2, 0x0801, 0x0002,   // 0x2DC0 (11712) pixels
0x0020, 0x0000, 0x0801, 0x4A20, 0xD6E2, 0xFFE1, 0xF740, 0xFFC0, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20,   // 0x2DD0 (11728) pixels
0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA0, 0xF683, 0xD5CD, 0xC5B7, 0xD6DC, 0xF7FD, 0xFFDF, 0xFFBF,   // 0x2DE0 (11744) pixels
0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF77C,   // 0x2DF0 (11760) pixels
0xF6F1, 0xF685, 0xFE80, 0xFEA0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF61, 0xFF80,   // 0x2E00 (11776) pixels
0xFF40, 0xFF00, 0xFF40, 0xFF61, 0xFF80, 0xFFA0, 0xFFE1, 0xB544, 0x2900, 0x0040, 0x0060, 0x0000, 0x0020, 0x0000, 0x6B20, 0xB586,   // 0x2E10 (11792) pixels
0xF7A7, 0xFFC2, 0xEF60, 0xF760, 0xFFA0, 0xFF81, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2E20 (11808) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2E30 (11824) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xEF83, 0xFFE6, 0xA522, 0x2900, 0x0801, 0x0001, 0x0000, 0x0020, 0x1000, 0x5AA0,   // 0x2E40 (11840) pixels
0xE724, 0xFFE2, 0xF720, 0xFFA0, 0xFF60, 0xFF00, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x2E50 (11856) pixels
0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA0, 0xDE29, 0xCDD3, 0xD67B, 0xEF9D, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2E60 (11872) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFF, 0xFFFF, 0xF7FF, 0xF79F, 0xFEF7, 0xFE88, 0xFE80,   // 0x2E70 (11888) pixels
0xFEA0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF61, 0xF720, 0xFF60, 0xFFA0, 0xFF60,   // 0x2E80 (11904) pixels
0xFF60, 0xFFA1, 0xFF80, 0xFF40, 0xFFE0, 0xC641, 0x29A0, 0x0003, 0x0062, 0x0000, 0x0823, 0x0000, 0x2920, 0x8C40, 0xE742, 0xFFE1,   // 0x2E90 (11920) pixels
0xFFA0, 0xFF40, 0xFF81, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2EA0 (11936) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x2EB0 (11952) pixels
0xFF80, 0xFF80, 0xFF80, 0xCEE0, 0x52A0, 0x0800, 0x0000, 0x0020, 0x0020, 0x0040, 0x0002, 0x8365, 0xEF43, 0xFFE0, 0xF720, 0xFF80,   // 0x2EC0 (11968) pixels
0xFF80, 0xFF60, 0xFF24, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0,   // 0x2ED0 (11984) pixels
0xFEA0, 0xFEA0, 0xFEA0, 0xCDCD, 0xCDD6, 0xE6FC, 0xFFFE, 0xFFDF, 0xFFFE, 0xFFFD, 0xEFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2EE0 (12000) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FE, 0xFFFF, 0xFF7F, 0xF6D6, 0xF6A7, 0xFEE0, 0xFEE0, 0xFEA0,   // 0x2EF0 (12016) pixels
0xF6E0, 0xF6E0, 0xF720, 0xF740, 0xFF40, 0xFF40, 0xFF20, 0xFF21, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80,   // 0x2F00 (12032) pixels
0xFFA0, 0xFFC0, 0xFFE0, 0xDEC2, 0x7380, 0x0840, 0x0002, 0x0805, 0x0000, 0x0000, 0x0000, 0x3180, 0x9CA4, 0xEF46, 0xFFE3, 0xFFA0,   // 0x2F10 (12048) pixels
0xF761, 0xFFC2, 0xFFA1, 0xF780, 0xFFA0, 0xFFC0, 0xFFA0, 0xFFC0, 0xFF60, 0xFF80, 0xFF80, 0xFF81, 0xFF81, 0xFF61, 0xFF40, 0xF740,   // 0x2F20 (12064) pixels
0xF760, 0xFF80, 0xF780, 0xF760, 0xF780, 0xFFA0, 0xFFC0, 0xF780, 0xFF60, 0xFF60, 0xFF60, 0xFFA0, 0xFFE1, 0xFFE5, 0xC624, 0x83C0,   // 0x2F30 (12080) pixels
0x08C2, 0x0020, 0x0000, 0x1083, 0x0001, 0x0000, 0x3180, 0x8CA4, 0xFFA0, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60,   // 0x2F40 (12096) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xF721, 0xF6C0, 0xFEC0, 0xFEE0, 0xFEC0, 0xFEE0, 0xF6A5, 0xD5E8,   // 0x2F50 (12112) pixels
0xBDD7, 0xDEDB, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2F60 (12128) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FE, 0xFFFF, 0xFF9F, 0xFF39, 0xF6ED, 0xF6C3, 0xFEA0, 0xFEA0, 0xFEC1, 0xFEE1, 0xFEE0,   // 0x2F70 (12144) pixels
0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF60, 0xF740, 0xF780,   // 0x2F80 (12160) pixels
0xFFE3, 0xEF65, 0xA4E4, 0x39C0, 0x0800, 0x0001, 0x0020, 0x0000, 0x0000, 0x1000, 0x3140, 0x8C40, 0xEF62, 0xFFC1, 0xFFE0, 0xFFC0,   // 0x2F90 (12176) pixels
0xF780, 0xFFA0, 0xFFA0, 0xFF42, 0xFF23, 0xFFC0, 0xFFC0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF40, 0xFFA1, 0xFFC1,   // 0x2FA0 (12192) pixels
0xFF80, 0xF760, 0xF760, 0xFF80, 0xFFA0, 0xFFA0, 0xFFE0, 0xFFE0, 0xEF80, 0xBDE2, 0x7BA4, 0x3121, 0x0800, 0x0020, 0x0021, 0x0003,   // 0x2FB0 (12208) pixels
0x0001, 0x0820, 0x52A0, 0xBDE3, 0xFFE6, 0xFFA0, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20,   // 0x2FC0 (12224) pixels
0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xF6E0, 0xFF00, 0xFEC0, 0xFE80, 0xFEA0, 0xFEE0, 0xE668, 0xCDB1, 0xCE79, 0xE73C, 0xFFFF,   // 0x2FD0 (12240) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x2FE0 (12256) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFBE, 0xF736, 0xEE8C, 0xF683, 0xFEC0, 0xFEC0, 0xFEC1, 0xFEE1, 0xFEC1, 0xFEC1, 0xFEE1,   // 0x2FF0 (12272) pixels
0xFF00, 0xFF40, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF81, 0xFF60, 0xF740, 0xFFA0, 0xFFE1, 0xFFC3,   // 0x3000 (12288) pixels
0xBDA2, 0x7B60, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0820, 0x0840, 0x1080, 0x7B60, 0xB523, 0xEF26, 0xFFE5, 0xFFE1, 0xFF60,   // 0x3010 (12304) pixels
0xFF60, 0xFFA0, 0xFF81, 0xFF81, 0xFF81, 0xF760, 0xFF80, 0xFFA0, 0xFFC0, 0xFFC0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFC0, 0xFFE0,   // 0x3020 (12320) pixels
0xFFC0, 0xFFA0, 0xEFA1, 0xCEA3, 0x94A4, 0x5262, 0x1060, 0x0000, 0x0000, 0x0880, 0x0001, 0x0001, 0x0000, 0x2900, 0x8C41, 0xF764,   // 0x3030 (12336) pixels
0xFFE2, 0xF760, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x3040 (12352) pixels
0xFEE0, 0xFEE0, 0xF6C0, 0xFF01, 0xFEA1, 0xFE60, 0xFEA1, 0xE665, 0xCDEE, 0xC5FA, 0xE73C, 0xF7BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3050 (12368) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3060 (12384) pixels
0xFFFE, 0xFFFF, 0xFFFF, 0xFF9F, 0xF6D6, 0xF689, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA1, 0xFEC1, 0xFF00, 0xFF40, 0xFF20,   // 0x3070 (12400) pixels
0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFFC1, 0xFFA1, 0xF740, 0xF740, 0xFFC0, 0xFFC1, 0xFF41, 0xA563,   // 0x3080 (12416) pixels
0x4A40, 0x0800, 0x0001, 0x0823, 0x0002, 0x0003, 0x0004, 0x0000, 0x1040, 0x3140, 0x62C2, 0x9CA3, 0xD643, 0xF761, 0xFFE0, 0xFFC1,   // 0x3090 (12432) pixels
0xFFC1, 0xFFE1, 0xFFE0, 0xFFE0, 0xFFE0, 0xFFE0, 0xFFC0, 0xFFE0, 0xFFE0, 0xFFE1, 0xFFE4, 0xFFA6, 0xE6C6, 0xB563, 0x9440, 0x4AA2,   // 0x30A0 (12448) pixels
0x2120, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x0800, 0x18A0, 0x6B20, 0xCE63, 0xFFE1, 0xFFA0, 0xFF60, 0xFFA1, 0xFF80,   // 0x30B0 (12464) pixels
0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00,   // 0x30C0 (12480) pixels
0xFEA1, 0xFEA0, 0xFEC0, 0xF662, 0xCD8D, 0xBDD7, 0xD6FD, 0xF7BE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x30D0 (12496) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFE, 0xFFFE, 0xFFFF,   // 0x30E0 (12512) pixels
0xFFDF, 0xFF5D, 0xF6F1, 0xEEA6, 0xF6A0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC1, 0xFF00, 0xFF40, 0xFF00, 0xFF00, 0xFF20, 0xFF20,   // 0x30F0 (12528) pixels
0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF61, 0xFFA1, 0xFFA0, 0xFF60, 0xFF60, 0xFFA1, 0xFFA0, 0xFF80, 0xFFE0, 0xE761, 0x9CE1, 0x39A0,   // 0x3100 (12544) pixels
0x0002, 0x0004, 0x0021, 0x0040, 0x0020, 0x0020, 0x0001, 0x0001, 0x0000, 0x0840, 0x3180, 0x5281, 0x8C20, 0x9460, 0x9CC1, 0xAD21,   // 0x3110 (12560) pixels
0xB562, 0xB582, 0xB5A1, 0xB581, 0xA524, 0x94C3, 0x8423, 0x6322, 0x4201, 0x20E0, 0x0820, 0x0000, 0x0002, 0x0000, 0x0000, 0x0040,   // 0x3120 (12576) pixels
0x0001, 0x0002, 0x0002, 0x0842, 0x5AA0, 0xB584, 0xFFE5, 0xFFE0, 0xF740, 0xFFA0, 0xFFA2, 0xFF43, 0xFF80, 0xFF80, 0xFF60, 0xFF60,   // 0x3130 (12592) pixels
0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEE0, 0xFEA0, 0xFEE0, 0xF6C0,   // 0x3140 (12608) pixels
0xD5E7, 0xBD75, 0xCE7D, 0xE7DC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3150 (12624) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFBF, 0xF758,   // 0x3160 (12640) pixels
0xEEF0, 0xF6A4, 0xF6C1, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE1, 0xFF00, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40,   // 0x3170 (12656) pixels
0xFF40, 0xFF64, 0xFF41, 0xFF60, 0xFF60, 0xFF80, 0xFF81, 0xFF60, 0xFF40, 0xF7A0, 0xFFC0, 0xFFE1, 0xE743, 0x9D00, 0x4A80, 0x10A0,   // 0x3180 (12672) pixels
0x0000, 0x0023, 0x0002, 0x0003, 0x0024, 0x0024, 0x0003, 0x0002, 0x0001, 0x0800, 0x0800, 0x0800, 0x0800, 0x0800, 0x0800, 0x0800,   // 0x3190 (12688) pixels
0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0001, 0x0022, 0x0040, 0x0001, 0x0002, 0x0002, 0x0000, 0x2920, 0x73A0,   // 0x31A0 (12704) pixels
0xB5C1, 0xFFC3, 0xFFE1, 0xFFE0, 0xFFA0, 0xFF61, 0xFF83, 0xFF42, 0xFF00, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20,   // 0x31B0 (12720) pixels
0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFE82, 0xFEE0, 0xFF00, 0xDE46, 0xBD90, 0xCE3A, 0xEF9E,   // 0x31C0 (12736) pixels
0xEFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x31D0 (12752) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7BE, 0xEF5C, 0xEECF, 0xEEC8,   // 0x31E0 (12768) pixels
0xF6C1, 0xFEC0, 0xFEC0, 0xFEC1, 0xFEE1, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF00, 0xFF20,   // 0x31F0 (12784) pixels
0xFF60, 0xFFA0, 0xFF80, 0xFF60, 0xFF60, 0xFF80, 0xF720, 0xFF60, 0xFF81, 0xFFA0, 0xFFE0, 0xF7A2, 0xC603, 0x7BA1, 0x2920, 0x1060,   // 0x3200 (12800) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0040, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000,   // 0x3210 (12816) pixels
0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0020, 0x0000, 0x0800, 0x1860, 0x5240, 0xA4E0, 0xDF00, 0xFFE0, 0xFFE0, 0xFFA0, 0xFFC0,   // 0x3220 (12832) pixels
0xFFA0, 0xFF81, 0xFF41, 0xFF61, 0xFF80, 0xFFA0, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x3230 (12848) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFE80, 0xFEA0, 0xE666, 0xC5F1, 0xC639, 0xE73D, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3240 (12864) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3250 (12880) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xF7FE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xF7FF, 0xF7BF, 0xEED8, 0xEECF, 0xF6A4, 0xFEA0, 0xFEA0,   // 0x3260 (12896) pixels
0xFEC1, 0xFEE1, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF42, 0xFF43, 0xFF60,   // 0x3270 (12912) pixels
0xF780, 0xF7A0, 0xF7A0, 0xFF82, 0xFF40, 0xFF60, 0xFFA0, 0xFFA1, 0xFFC2, 0xFFE1, 0xFFC0, 0xF7C1, 0xC620, 0x8420, 0x5242, 0x20A1,   // 0x3280 (12928) pixels
0x0001, 0x0001, 0x0021, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0000, 0x0000, 0x0000, 0x0800, 0x0820, 0x0820, 0x0000,   // 0x3290 (12944) pixels
0x0000, 0x0861, 0x2123, 0x62E1, 0x94A2, 0xD6A3, 0xF7A2, 0xFFC1, 0xFFA1, 0xFF61, 0xFF40, 0xFF60, 0xFF41, 0xFF41, 0xFF60, 0xFFA0,   // 0x32A0 (12960) pixels
0xFFA0, 0xF780, 0xF760, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0,   // 0x32B0 (12976) pixels
0xFEC0, 0xFEC0, 0xFEA0, 0xFEC0, 0xF644, 0xCD6E, 0xC5D8, 0xDF1E, 0xEFDF, 0xFFDE, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x32C0 (12992) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x32D0 (13008) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xE7BF, 0xE739, 0xE6CA, 0xF681, 0xFEA0, 0xFEC0, 0xFEA1, 0xFE81,   // 0x32E0 (13024) pixels
0xFEC1, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF21, 0xFF01, 0xFF00, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60,   // 0x32F0 (13040) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFC0, 0xFFE0, 0xFFE1, 0xFFC1, 0xEEE0, 0xC5C0, 0xA4A0, 0x8BE0,   // 0x3300 (13056) pixels
0x5243, 0x4A02, 0x3981, 0x28E0, 0x20A0, 0x1881, 0x2082, 0x20A3, 0x30E0, 0x4160, 0x5220, 0x6B00, 0x8C00, 0xAD40, 0xD682, 0xF764,   // 0x3310 (13072) pixels
0xFFA0, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60,   // 0x3320 (13088) pixels
0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE1, 0xFEC1, 0xFEE0, 0xFF20, 0xFF00, 0xFE82, 0xFE82, 0xFF00,   // 0x3330 (13104) pixels
0xCE2B, 0xC5EF, 0xCDF5, 0xE6BC, 0xF77F, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3340 (13120) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3350 (13136) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xEFFF, 0xEF9D, 0xEED7, 0xF68D, 0xF6A2, 0xFEC0, 0xFEC0, 0xFEA1, 0xFEC2, 0xFEC0, 0xFEE0,   // 0x3360 (13152) pixels
0xFEE0, 0xFF00, 0xFF01, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF80,   // 0x3370 (13168) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xF740, 0xFF60, 0xFFA0, 0xFFC0, 0xFFC1, 0xFFA2, 0xF764, 0xF745, 0xFFE1, 0xF7E1, 0xEFA1,   // 0x3380 (13184) pixels
0xEF60, 0xE741, 0xE741, 0xE742, 0xEF63, 0xEF64, 0xF7A4, 0xFFE4, 0xFFE2, 0xF7E0, 0xF7C0, 0xFFC0, 0xFFE0, 0xFFA0, 0xFFA0, 0xFF80,   // 0x3390 (13200) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20,   // 0x33A0 (13216) pixels
0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFEC1, 0xFE82, 0xFEC1, 0xFF00, 0xF6C0, 0xE623, 0xC5CF, 0xCE34, 0xE6BA,   // 0x33B0 (13232) pixels
0xF75F, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x33C0 (13248) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x33D0 (13264) pixels
0xFFFF, 0xFFFF, 0xF7FD, 0xFFFF, 0xF75F, 0xF6D9, 0xEEAC, 0xEEA1, 0xF6C0, 0xFEE0, 0xFEA1, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC1, 0xFEE1,   // 0x33E0 (13280) pixels
0xFF00, 0xFF40, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60,   // 0x33F0 (13296) pixels
0xFF60, 0xFF80, 0xFF81, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFFA0, 0xFFA1, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x3400 (13312) pixels
0xFF80, 0xFF80, 0xF780, 0xF7A0, 0xFFC0, 0xFFC0, 0xFFA0, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80,   // 0x3410 (13328) pixels
0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFEE0,   // 0x3420 (13344) pixels
0xFEE0, 0xFEE0, 0xFF00, 0xFEE0, 0xFEA3, 0xFE83, 0xFEC0, 0xFF20, 0xE684, 0xCD8C, 0xCDF5, 0xE6BA, 0xFF7F, 0xFFDF, 0xFFFF, 0xFFFF,   // 0x3430 (13360) pixels
0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3440 (13376) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3450 (13392) pixels
0xFFFF, 0xFFFF, 0xF77F, 0xE6F8, 0xE6AE, 0xEEA5, 0xF6E0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC1, 0xFEC1, 0xFF00, 0xFF40, 0xFF00,   // 0x3460 (13408) pixels
0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40,   // 0x3470 (13424) pixels
0xFF60, 0xFF80, 0xFF80, 0xFFA0, 0xFFA0, 0xFF80, 0xFF80, 0xFF61, 0xFF61, 0xFF81, 0xFF81, 0xFF81, 0xFF81, 0xFF81, 0xFF80, 0xFFA0,   // 0x3480 (13440) pixels
0xFF80, 0xFF60, 0xFF60, 0xFF61, 0xFF62, 0xFF63, 0xFF83, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60,   // 0x3490 (13456) pixels
0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEE0,   // 0x34A0 (13472) pixels
0xFE80, 0xFE82, 0xFEE0, 0xFEE0, 0xE645, 0xCDCF, 0xC5D6, 0xE6BC, 0xF75F, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x34B0 (13488) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x34C0 (13504) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xF7FF,   // 0x34D0 (13520) pixels
0xEF7F, 0xEEFA, 0xE6AF, 0xE687, 0xF6A0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE1, 0xFF00, 0xFF20, 0xFEE0, 0xFF00, 0xFF00, 0xFF00,   // 0x34E0 (13536) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF80, 0xFF80,   // 0x34F0 (13552) pixels
0xFF80, 0xFF80, 0xFF80, 0xFF81, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFFA0, 0xFF80, 0xFF80, 0xFF80,   // 0x3500 (13568) pixels
0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40,   // 0x3510 (13584) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEC0, 0xF6A0,   // 0x3520 (13600) pixels
0xDE25, 0xCD90, 0xCDF9, 0xDEDD, 0xF77F, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3530 (13616) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3540 (13632) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xF79D, 0xEF18,   // 0x3550 (13648) pixels
0xE694, 0xEEC5, 0xEEC2, 0xF6C0, 0xFEC0, 0xFEC0, 0xFEE1, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20,   // 0x3560 (13664) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF41, 0xFF41,   // 0x3570 (13680) pixels
0xFF41, 0xFF62, 0xFF61, 0xFF61, 0xFF61, 0xFF61, 0xFF61, 0xFF81, 0xFF80, 0xFF61, 0xFF61, 0xFF61, 0xFF60, 0xFF60, 0xFF60, 0xFF60,   // 0x3580 (13696) pixels
0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x3590 (13712) pixels
0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFE80, 0xFF00, 0xF6C2, 0xD5EA, 0xC572, 0xCE18, 0xE71C,   // 0x35A0 (13728) pixels
0xF7BF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x35B0 (13744) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x35C0 (13760) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF79D, 0xEF3C, 0xE6D3, 0xE6CD,   // 0x35D0 (13776) pixels
0xEEA5, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20,   // 0x35E0 (13792) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF61, 0xFF61, 0xFF80, 0xFF60, 0xFF60, 0xFF80, 0xFF60,   // 0x35F0 (13808) pixels
0xFF60, 0xFF60, 0xFF80, 0xFF80, 0xFF80, 0xFF80, 0xFF60, 0xFF60, 0xFF60, 0xFF60, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40,   // 0x3600 (13824) pixels
0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0,   // 0x3610 (13840) pixels
0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA0, 0xF662, 0xEE65, 0xD62C, 0xC5D6, 0xC63B, 0xDF3D, 0xF7FE, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3620 (13856) pixels
0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3630 (13872) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3640 (13888) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FC, 0xE6FF, 0xE6B6, 0xEE6B, 0xF663, 0xFEA0,   // 0x3650 (13904) pixels
0xFEA0, 0xFEA0, 0xF6A0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x3660 (13920) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF40, 0xFF40, 0xFF60, 0xFF60, 0xFF60, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x3670 (13936) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF60, 0xFF60, 0xFF80, 0xFF60, 0xFF40, 0xFF40, 0xFF61, 0xFF61, 0xFF40, 0xFF40, 0xFF40, 0xFF40, 0xFF40,   // 0x3680 (13952) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0,   // 0x3690 (13968) pixels
0xFEA0, 0xFEA0, 0xFEA0, 0xF682, 0xD58C, 0xC556, 0xC65B, 0xDF9D, 0xF7FE, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x36A0 (13984) pixels
0xFFDF, 0xFFFE, 0xFFFC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x36B0 (14000) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x36C0 (14016) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7DE, 0xEF7E, 0xE6FB, 0xDEB4, 0xE68B, 0xEEA2, 0xFEC0, 0xFEE0,   // 0x36D0 (14032) pixels
0xFEA2, 0xFEC1, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x36E0 (14048) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x36F0 (14064) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00,   // 0x3700 (14080) pixels
0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF23, 0xFEE1, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC2, 0xE684, 0xCE25,   // 0x3710 (14096) pixels
0xAD75, 0xC618, 0xDEFB, 0xF79E, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3720 (14112) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3730 (14128) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3740 (14144) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFDE, 0xF79D, 0xEF1B, 0xE6B5, 0xE66C, 0xEE84, 0xF6A0, 0xFEE0, 0xFEC0, 0xFEC0,   // 0x3750 (14160) pixels
0xFEA1, 0xFEC2, 0xFEC1, 0xFF00, 0xFF00, 0xFEE1, 0xFEE1, 0xFEE1, 0xFF00, 0xFF00, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x3760 (14176) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x3770 (14192) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEC0, 0xFEC0, 0xFEE0,   // 0x3780 (14208) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEA1, 0xFEE0, 0xFF20, 0xFEE0, 0xEE80, 0xDE26, 0xCE0E, 0xC613, 0xD69A, 0xDEFB, 0xF79E,   // 0x3790 (14224) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x37A0 (14240) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x37B0 (14256) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x37C0 (14272) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFBF, 0xF73E, 0xEEB8, 0xE690, 0xE66A, 0xFEC0, 0xFEA0, 0xFEA0, 0xFEA1, 0xFEA1, 0xFEC0,   // 0x37D0 (14288) pixels
0xFEC0, 0xFEE0, 0xFEA1, 0xFEC1, 0xFEC1, 0xFEC1, 0xFEE0, 0xFF00, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x37E0 (14304) pixels
0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20, 0xFF20,   // 0x37F0 (14320) pixels
0xFF20, 0xFF20, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xF6E0, 0xFEC0, 0xFEC1,   // 0x3800 (14336) pixels
0xFEC1, 0xFEA2, 0xFEA0, 0xFEC0, 0xFEC1, 0xE664, 0xCDE9, 0xC5D0, 0xC638, 0xD69E, 0xF79E, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3810 (14352) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3820 (14368) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3830 (14384) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF,   // 0x3840 (14400) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF79F, 0xEF1B, 0xE6B7, 0xEE2C, 0xEE69, 0xF6A4, 0xFEC0, 0xFEE0, 0xFEC0, 0xFEA0, 0xFE81, 0xFEC0,   // 0x3850 (14416) pixels
0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x3860 (14432) pixels
0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x3870 (14448) pixels
0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF20, 0xFF00, 0xFEE0, 0xFEA1, 0xFEA1, 0xFEC0, 0xFEE0, 0xFF00, 0xFEA0,   // 0x3880 (14464) pixels
0xEE42, 0xD5E9, 0xC5B1, 0xC5D7, 0xCE7B, 0xE71E, 0xEF9E, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3890 (14480) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x38A0 (14496) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x38B0 (14512) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x38C0 (14528) pixels
0xFFFF, 0xFFFF, 0xF7BF, 0xEF5F, 0xE67A, 0xE675, 0xE68E, 0xEEA6, 0xF6A1, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0,   // 0x38D0 (14544) pixels
0xFEC0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFF00, 0xFF00, 0xFF00, 0xFF00,   // 0x38E0 (14560) pixels
0xFF00, 0xFF00, 0xFF00, 0xFF00, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x38F0 (14576) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFE80, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA0, 0xD608, 0xCDEC, 0xC5F3, 0xCE3A,   // 0x3900 (14592) pixels
0xDEDF, 0xEF7F, 0xFFDE, 0xFFFC, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3910 (14608) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3920 (14624) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3930 (14640) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFC, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FE, 0xFFFE,   // 0x3940 (14656) pixels
0xFFFF, 0xF7BF, 0xEF7E, 0xE6FA, 0xE695, 0xE64E, 0xEE47, 0xF682, 0xF6A0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEE0, 0xFEC0, 0xFEC0,   // 0x3950 (14672) pixels
0xFEC1, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x3960 (14688) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0,   // 0x3970 (14704) pixels
0xFEC0, 0xFE81, 0xFEA0, 0xFEC0, 0xFEC0, 0xEEA0, 0xE645, 0xDDCA, 0xD58D, 0xC5D7, 0xCE38, 0xD6DB, 0xE77D, 0xEFDE, 0xFFFE, 0xFFFE,   // 0x3980 (14720) pixels
0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3990 (14736) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x39A0 (14752) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x39B0 (14768) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x39C0 (14784) pixels
0xF79F, 0xEF1F, 0xE6BB, 0xDE95, 0xDE8F, 0xDE8B, 0xEE88, 0xF686, 0xF6A3, 0xF6C0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA1, 0xFEE0, 0xFEE0,   // 0x39D0 (14800) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0,   // 0x39E0 (14816) pixels
0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEE0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xF6A1,   // 0x39F0 (14832) pixels
0xEE83, 0xE667, 0xD62C, 0xCE12, 0xCDF7, 0xC5FB, 0xDEDE, 0xE73E, 0xF7BE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF,   // 0x3A00 (14848) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3A10 (14864) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3A20 (14880) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3A30 (14896) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFC, 0xF7FC, 0xFFFE, 0xFFFF, 0xFFDF, 0xFFDF, 0xF7FD, 0xFFFE, 0xFFFF, 0xFFDF, 0xF79F,   // 0x3A40 (14912) pixels
0xEF5F, 0xDEFE, 0xD6BC, 0xE64F, 0xEE6C, 0xEE87, 0xF6C3, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0,   // 0x3A50 (14928) pixels
0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0,   // 0x3A60 (14944) pixels
0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEC0, 0xFEA0, 0xFEA0, 0xFEA0, 0xEE63, 0xDE27, 0xCDAD, 0xC593, 0xC5D8,   // 0x3A70 (14960) pixels
0xC67B, 0xD75C, 0xDFDC, 0xF7FC, 0xFFFD, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFDF, 0xFFFF,   // 0x3A80 (14976) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3A90 (14992) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3AA0 (15008) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3AB0 (15024) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xF7BE, 0xF7BE,   // 0x3AC0 (15040) pixels
0xDF3F, 0xDEFD, 0xD699, 0xCE34, 0xD60E, 0xDE48, 0xEEA3, 0xF6E0, 0xF6C1, 0xF6C1, 0xFEC1, 0xFEC1, 0xFEC1, 0xFEA1, 0xFEA1, 0xFE81,   // 0x3AD0 (15056) pixels
0xFEA2, 0xFEA1, 0xFEA1, 0xFEA1, 0xFEC1, 0xFEC1, 0xFEC1, 0xFEC1, 0xFEA0, 0xFEA0, 0xFEA0, 0xFEC0, 0xFEC0, 0xFEC0, 0xF6C0, 0xF6C0,   // 0x3AE0 (15072) pixels
0xFEA0, 0xFEC0, 0xFEC0, 0xF6C0, 0xEE80, 0xDE45, 0xD5EA, 0xCDCE, 0xB5B6, 0xBDF7, 0xCE59, 0xDEDB, 0xEF5D, 0xF79E, 0xF7BE, 0xFFDF,   // 0x3AF0 (15088) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3B00 (15104) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3B10 (15120) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3B20 (15136) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3B30 (15152) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FE, 0xF7BE, 0xEF5E,   // 0x3B40 (15168) pixels
0xEEFD, 0xE69B, 0xE639, 0xDE17, 0xDDF5, 0xE666, 0xEE66, 0xEE84, 0xF682, 0xF6A0, 0xFEC0, 0xFEE0, 0xFEE0, 0xFE80, 0xFE80, 0xFE80,   // 0x3B50 (15184) pixels
0xFE80, 0xFE80, 0xFE80, 0xFE80, 0xFE80, 0xFEA0, 0xFEA0, 0xFEA0, 0xFE80, 0xFE81, 0xFE81, 0xFE61, 0xFE61, 0xDE47, 0xDE28, 0xD60A,   // 0x3B60 (15200) pixels
0xCDED, 0xCDF1, 0xC5F5, 0xCE19, 0xCE1B, 0xDEFB, 0xE73C, 0xEF7D, 0xF7BE, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3B70 (15216) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3B80 (15232) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3B90 (15248) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3BA0 (15264) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3BB0 (15280) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFF9F, 0xEF5E,   // 0x3BC0 (15296) pixels
0xE71C, 0xE6DB, 0xD63B, 0xD61A, 0xD618, 0xD615, 0xD5F2, 0xD60F, 0xD60D, 0xD60C, 0xEE85, 0xEE85, 0xEE85, 0xEE84, 0xEE84, 0xEE84,   // 0x3BD0 (15312) pixels
0xEE83, 0xEE63, 0xDE27, 0xDE27, 0xDE28, 0xD609, 0xD60B, 0xD5EC, 0xD60D, 0xD5EE, 0xC615, 0xC616, 0xCE18, 0xCE5A, 0xD69C, 0xDEFD,   // 0x3BE0 (15328) pixels
0xE75E, 0xEF9E, 0xF7BE, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3BF0 (15344) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3C00 (15360) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3C10 (15376) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3C20 (15392) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3C30 (15408) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFE, 0xF7FE, 0xF7FE, 0xEFFE, 0xEFFE, 0xF79F,   // 0x3C40 (15424) pixels
0xEF9F, 0xEF5E, 0xE71C, 0xDEFB, 0xDEB9, 0xD698, 0xD698, 0xCE19, 0xCE19, 0xCDF8, 0xCDF8, 0xC5F8, 0xC5F7, 0xC5D7, 0xC5F7, 0xC636,   // 0x3C50 (15440) pixels
0xC637, 0xC638, 0xC639, 0xC63B, 0xCE5C, 0xCE5D, 0xCE7E, 0xDE7F, 0xDEBF, 0xE6FF, 0xEF3F, 0xF79F, 0xFFBE, 0xFFDE, 0xFFFE, 0xFFFF,   // 0x3C60 (15456) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3C70 (15472) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3C80 (15488) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3C90 (15504) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3CA0 (15520) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3CB0 (15536) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFF, 0xF7FF, 0xF7FF, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFDE,   // 0x3CC0 (15552) pixels
0xFFBF, 0xF77E, 0xF75F, 0xF73E, 0xE75F, 0xE75F, 0xE75E, 0xE75E, 0xE73E, 0xE73E, 0xE73D, 0xE73D, 0xEF3B, 0xEF3B, 0xE73B, 0xEF5C,   // 0x3CD0 (15568) pixels
0xEF7C, 0xEF7D, 0xEF9E, 0xF7BF, 0xF7FD, 0xFFFD, 0xFFFD, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFFE, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3CE0 (15584) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3CF0 (15600) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3D00 (15616) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3D10 (15632) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3D20 (15648) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3D30 (15664) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xF7FF, 0xF7FF, 0xF7FF, 0xF7FF, 0xF7FF, 0xF7FF, 0xF7FF,   // 0x3D40 (15680) pixels
0xF7FF, 0xF7FF, 0xF7FF, 0xF7FF, 0xF7FF, 0xF7FE, 0xF7FE, 0xF7FE, 0xEFFE, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF,   // 0x3D50 (15696) pixels
0xFFFF, 0xFFFE, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3D60 (15712) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3D70 (15728) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3D80 (15744) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3D90 (15760) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3DA0 (15776) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3DB0 (15792) pixels
0xFFFF, 0xFFDF, 0xFFBF, 0xFFBE, 0xFFBD, 0xFFBC, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFFE, 0xFFFD, 0xFFDF, 0xFFDF,   // 0x3DC0 (15808) pixels
0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFE, 0xFFDE, 0xFFBE, 0xFFBE,   // 0x3DD0 (15824) pixels
0xFFBE, 0xFFBE, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFDF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3DE0 (15840) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,   // 0x3DF0 (15856) pixels
0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF
};
 const unsigned short  lion [] PROGMEM = {
  0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xfffd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xfffe, 0xfffe, 0xffdf, 0xffbf, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7df, 0xfffe, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbd, 0xffbd, 0xffdd, 0xff9e, 0xffde, 0xffdd, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffbd, 0xf77c, 0xeed9, 0xee77, 0xedf5, 0xf573, 0xecf1, 0xec2e, 0xe3ec, 0xe3ec, 0xe48f, 0xe4d0, 0xed52, 0xedf5, 0xf6b8, 0xf75c, 0xf7bf, 0xefff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7ff, 0xf7ff, 0xffff, 0xff9d, 0xfed9, 0xfe36, 0xfd72, 0xfcf0, 0xfc6e, 0xfc0c, 0xfb69, 0xfac6, 0xfa64, 0xfa84, 0xfb48, 0xfba9, 0xfc2c, 0xfccf, 0xfd52, 0xfe37, 0xfefb, 0xff9e, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xff9d, 0xfe57, 0xfcd0, 0xfbac, 0xfa86, 0xfa45, 0xfa44, 0xfa43, 0xfa22, 0xf9e1, 0xf9c0, 0xf9e0, 0xf9c1, 0xfa02, 0xfa43, 0xfa64, 0xfaa6, 0xf38a, 0xfcd0, 0xfdd5, 0xffbc, 0xffdd, 0xffff, 0xf7ff, 0xefff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xff3a, 0xfdf5, 0xfc4d, 0xfaa7, 0xf9a2, 0xf900, 0xf940, 0xf9a1, 0xf9e2, 0xfa23, 0xfa63, 0xfa63, 0xfa63, 0xfa23, 0xf9e2, 0xf9a1, 0xf940, 0xe920, 0xe9a2, 0xfae7, 0xfc0b, 0xfe34, 0xfed7, 0xff9c, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff5c, 0xfe57, 0xfcf1, 0xfb8a, 0xfa64, 0xf9a0, 0xf940, 0xf140, 0xf9e2, 0xfa85, 0xf328, 0xfbeb, 0xfc8e, 0xfcaf, 0xfc8f, 0xfbec, 0xfb6a, 0xfac6, 0xf223, 0xf180, 0xe940, 0xf9a0, 0xfa22, 0xfb8a, 0xfc8e, 0xfdf5, 0xff3b, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xfeb9, 0xfcf1, 0xfae8, 0xf1a1, 0xf140, 0xf9a0, 0xfa20, 0xfae6, 0xfbaa, 0xfc8d, 0xfd10, 0xfdd4, 0xfe78, 0xfeba, 0xfe59, 0xfdf6, 0xfd53, 0xfcaf, 0xfc0b, 0xfb27, 0xfa43, 0xf9c0, 0xf980, 0xf962, 0xfaa7, 0xfc6f, 0xfe17, 0xff3c, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7d, 0xfed4, 0xfccd, 0xfaa5, 0xf940, 0xf8e0, 0xe940, 0xea85, 0xfbea, 0xed95, 0xfe37, 0xfeda, 0xff1b, 0xff3c, 0xff7d, 0xffbe, 0xffbf, 0xff7c, 0xff5c, 0xff1b, 0xfed9, 0xfe15, 0xfc8f, 0xfac6, 0xf181, 0xf940, 0xf981, 0xfa24, 0xfbab, 0xfdb3, 0xff5b, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffbf, 0xffdf, 0xf7ff, 0xfffe, 0xff9c, 0xfeb9, 0xfccd, 0xf307, 0xf982, 0xf920, 0xf9c3, 0xfac7, 0xfc4d, 0xfd72, 0xff5b, 0xffbd, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xf7fe, 0xfffe, 0xff7b, 0xfe56, 0xfccf, 0xfba9, 0xf9e2, 0xf960, 0xf120, 0xf203, 0xfbca, 0xfdb3, 0xff3a, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xff9c, 0xfe36, 0xfcf0, 0xfa65, 0xf161, 0xf0c0, 0xf9a3, 0xfb6a, 0xfd11, 0xfe57, 0xff3b, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xffff, 0xff9c, 0xfe98, 0xfdd4, 0xfbeb, 0xfa86, 0xf940, 0xf920, 0xfa22, 0xfbea, 0xfdb3, 0xff19, 0xffbf, 0xffdf, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffbe, 0xfe56, 0xfc4e, 0xf2e7, 0xf940, 0xf940, 0xf1c3, 0xfb8b, 0xfd73, 0xfefb, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffbf, 0xff5d, 0xfe36, 0xfc8e, 0xfa85, 0xf960, 0xf920, 0xfa03, 0xfbeb, 0xfd72, 0xff3d, 0xffbf, 0xffdf, 0xffdf, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7be, 0xffff, 0xffff, 0xff9d, 0xfe57, 0xfc6f, 0xfa86, 0xf981, 0xf940, 0xf223, 0xf3aa, 0xfd73, 0xfefa, 0xffde, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffbf, 0xffdf, 0xffdf, 0xf7df, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xefbd, 0xee57, 0xfc4e, 0xfa86, 0xf920, 0xf0e0, 0xfa26, 0xfb8c, 0xf5f6, 0xfefb, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7c, 0xfe36, 0xfc6f, 0xfaa7, 0xf9a1, 0xf980, 0xf284, 0xfbea, 0xfdd3, 0xff3a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xefff, 0xffde, 0xfeb8, 0xfcd0, 0xfac8, 0xf962, 0xf962, 0xfa04, 0xebec, 0xfd72, 0xff1a, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffbf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xff7c, 0xfe36, 0xfc6e, 0xfac7, 0xf981, 0xf180, 0xfa21, 0xfbeb, 0xfd72, 0xff19, 0xffde, 0xffff, 0xffbf, 0xffbe, 0xffbd, 0xffde, 0xffbd, 0xffbd, 0xffde, 0xfffe, 0xffdd, 0xfffd, 0xfffd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbd, 0xffbd, 0xffdf, 0xfffe, 0xffbc, 0xfe76, 0xfc8e, 0xfaa6, 0xf9a1, 0xf940, 0xfa64, 0xfbca, 0xfd92, 0xff19, 0xffbd, 0xffff, 0xffde, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xff9d, 0xf73c, 0xf6fc, 0xf6db, 0xf6bb, 0xf658, 0xf658, 0xf658, 0xf658, 0xf658, 0xf658, 0xf658, 0xf658, 0xee79, 0xf5f6, 0xf48f, 0xfac7, 0xf981, 0xf100, 0xe9a0, 0xfae3, 0xf3cd, 0xfd32, 0xf698, 0xeedb, 0xee9a, 0xf659, 0xfe57, 0xfe56, 0xfe79, 0xfe58, 0xfe58, 0xfe58, 0xf658, 0xee37, 0xf677, 0xfeb8, 0xf699, 0xf679, 0xfe79, 0xfe58, 0xfe38, 0xfe37, 0xfe38, 0xfe58, 0xfe38, 0xf699, 0xeed8, 0xee35, 0xf4cf, 0xfb47, 0xf9e0, 0xf920, 0xf940, 0xfa43, 0xfbeb, 0xfd52, 0xf657, 0xf679, 0xf679, 0xfe59, 0xf679, 0xf679, 0xf679, 0xfe79, 0xfe99, 0xfe99, 0xfe99, 0xfe99, 0xf75d, 0xf77d, 0xf77e, 0xff9e, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xff5d, 0xfe7a, 0xfdf6, 0xfdb4, 0xfd10, 0xfc8d, 0xfc0a, 0xfb87, 0xfb4a, 0xfb29, 0xf308, 0xf328, 0xfb48, 0xfb68, 0xfb47, 0xfb27, 0xfae6, 0xfac6, 0xfa44, 0xf9c2, 0xf960, 0xf961, 0xf9c2, 0xfa03, 0xfae7, 0xfb07, 0xfb28, 0xfb48, 0xfb48, 0xfb28, 0xfb07, 0xfae7, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb08, 0xfb49, 0xfb49, 0xfb49, 0xfb28, 0xfac6, 0xfa44, 0xf1c2, 0xe981, 0xf980, 0xf9e0, 0xf243, 0xf2c5, 0xfb27, 0xfb48, 0xfb07, 0xfae6, 0xfb06, 0xfb06, 0xfae7, 0xfae7, 0xfae8, 0xfb49, 0xfbca, 0xfc4c, 0xfc8f, 0xfd12, 0xfdb4, 0xfe57, 0xfefa, 0xffbd, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffde, 0xff1b, 0xf657, 0xfd72, 0xfcaf, 0xf42d, 0xfbcb, 0xfb28, 0xfa85, 0xfa23, 0xf1c1, 0xf900, 0xf8e0, 0xf8e0, 0xf900, 0xf941, 0xf961, 0xf180, 0xf180, 0xf9a1, 0xf981, 0xf960, 0xf920, 0xf900, 0xf900, 0xf900, 0xf940, 0xf900, 0xf900, 0xf920, 0xf920, 0xf920, 0xf920, 0xf900, 0xf900, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf120, 0xf120, 0xf900, 0xf900, 0xf900, 0xf900, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf900, 0xf140, 0xf181, 0xf981, 0xf161, 0xf140, 0xf160, 0xf140, 0xf120, 0xf100, 0xf120, 0xf181, 0xf9e2, 0xfa22, 0xfae7, 0xfb29, 0xfbcb, 0xfc4e, 0xfd32, 0xfe36, 0xff1a, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffdf, 0xff9d, 0xfeb8, 0xfd31, 0xebcb, 0xfb05, 0xfa84, 0xfa63, 0xfa22, 0xf9a1, 0xf960, 0xf940, 0xf900, 0xf8c0, 0xf8c0, 0xf8c0, 0xf8e0, 0xf8e0, 0xf900, 0xf900, 0xf900, 0xf920, 0xf900, 0xf900, 0xf940, 0xf960, 0xf940, 0xf920, 0xf920, 0xf8e0, 0xf8e0, 0xf8c0, 0xf8c0, 0xf8c0, 0xf8c0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf900, 0xf920, 0xf940, 0xf960, 0xf962, 0xf941, 0xf920, 0xf900, 0xf920, 0xf920, 0xf940, 0xf140, 0xf120, 0xf940, 0xf120, 0xf0e0, 0xf100, 0xf940, 0xf960, 0xf960, 0xf9c1, 0xf9c1, 0xf9e2, 0xfa23, 0xf2a6, 0xebab, 0xed11, 0xfe15, 0xff7c, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff3b, 0xfe16, 0xfccf, 0xfb47, 0xf9e1, 0xf960, 0xf960, 0xf9a0, 0xfa02, 0xfa23, 0xfa64, 0xfaa6, 0xfae7, 0xfb26, 0xfb48, 0xfb49, 0xfb28, 0xfaa6, 0xfa03, 0xf980, 0xf940, 0xf960, 0xf980, 0xfa02, 0xfac6, 0xfb48, 0xfb48, 0xfb28, 0xfb48, 0xfb49, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb49, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb28, 0xfb49, 0xfb49, 0xfb49, 0xfb69, 0xfb68, 0xfb47, 0xf347, 0xf347, 0xeb69, 0xfb28, 0xfa85, 0xf9e1, 0xf960, 0xf960, 0xf9c0, 0xfa22, 0xf265, 0xfb08, 0xfb6a, 0xfb29, 0xfb08, 0xfb07, 0xfac5, 0xfa43, 0xfa43, 0xfa02, 0xf9a0, 0xf940, 0xf140, 0xe9a1, 0xf2e6, 0xfbeb, 0xfdf5, 0xfed9, 0xffbd, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff1b, 0xfd94, 0xfc0c, 0xfaa6, 0xf9c1, 0xf940, 0xf140, 0xf9e1, 0xfa84, 0xfb28, 0xfbcb, 0xfc8e, 0xfd31, 0xfdb3, 0xf657, 0xfe77, 0xfe97, 0xf5f4, 0xf4ae, 0xf328, 0xf9c2, 0xf900, 0xf9a1, 0xfa44, 0xfbaa, 0xfd31, 0xfe15, 0xfe56, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe57, 0xfe36, 0xfe36, 0xfe57, 0xfe77, 0xfe77, 0xf676, 0xf676, 0xf656, 0xf654, 0xfdb2, 0xfc8c, 0xf2e6, 0xe1a0, 0xe140, 0xf1c0, 0xfa43, 0xf3ec, 0xfd11, 0xfe36, 0xfe78, 0xfe37, 0xfdd5, 0xfd51, 0xf4ae, 0xfc0b, 0xfb89, 0xfae6, 0xfa23, 0xf980, 0xf920, 0xf980, 0xfa22, 0xebab, 0xfcf0, 0xfe98, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xff1a, 0xfd93, 0xfbab, 0xf223, 0xe940, 0xf160, 0xf9e2, 0xf329, 0xfbec, 0xfcaf, 0xfd52, 0xfe15, 0xfeb8, 0xff5b, 0xffdd, 0xffff, 0xffff, 0xffde, 0xfeb8, 0xfcf0, 0xf308, 0xf9a3, 0xf8e0, 0xea65, 0xf3aa, 0xfd73, 0xff1a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xff7b, 0xfe56, 0xfc8e, 0xf2c6, 0xe9a2, 0xf981, 0xf9c2, 0xfc2d, 0xfdb4, 0xff5b, 0xffff, 0xf7ff, 0xf7ff, 0xf77c, 0xf6da, 0xfe36, 0xfdd4, 0xfd31, 0xfc4d, 0xfb28, 0xfa23, 0xf960, 0xf900, 0xe1a2, 0xf2e7, 0xfccf, 0xfe98, 0xffbd, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff3a, 0xfd93, 0xfb89, 0xfa02, 0xf940, 0xf160, 0xf284, 0xfbaa, 0xf594, 0xfe77, 0xfefa, 0xff1b, 0xff7d, 0xffde, 0xffff, 0xffff, 0xffff, 0xff7d, 0xfe57, 0xfcaf, 0xf307, 0xf1e3, 0xf9a2, 0xf9c3, 0xf40d, 0xfd73, 0xfefb, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffde, 0xff5c, 0xfe37, 0xfc8f, 0xfb08, 0xf9c3, 0xf940, 0xfa84, 0xfbcb, 0xfdb3, 0xff3b, 0xf7ff, 0xf7ff, 0xffff, 0xff9e, 0xff7d, 0xff7d, 0xff1b, 0xfe99, 0xfd94, 0xfc2d, 0xfaa6, 0xf981, 0xf920, 0xf181, 0xf2e7, 0xfd10, 0xfef9, 0xffde, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfe56, 0xf42c, 0xea02, 0xf920, 0xf960, 0xfa63, 0xfc0b, 0xfdb2, 0xef1a, 0xffdd, 0xfffe, 0xfffe, 0xffff, 0xffdf, 0xffbf, 0xffff, 0xf79c, 0xfe97, 0xfcaf, 0xfa85, 0xf140, 0xf140, 0xfa43, 0xfb67, 0xfd74, 0xfeba, 0xffbf, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7ff, 0xf7ff, 0xffff, 0xff9d, 0xfe36, 0xfc6e, 0xfaa5, 0xf980, 0xf8e0, 0xf9e1, 0xf3cb, 0xedd5, 0xf75c, 0xffdf, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xff7d, 0xfe37, 0xfc2e, 0xfaa7, 0xf9a1, 0xf920, 0xe9a2, 0xebcb, 0xfe15, 0xff7c, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xff7c, 0xfe76, 0xfcee, 0xfb07, 0xf940, 0xf940, 0xfac5, 0xfd2f, 0xfeb9, 0xfefd, 0xefff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xffdf, 0xff5f, 0xfe17, 0xfc4f, 0xfa45, 0xf920, 0xf920, 0xf223, 0xf3ed, 0xfd55, 0xf7be, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffbd, 0xfe98, 0xfc8f, 0xeae8, 0xf960, 0xf920, 0xf9c3, 0xfb49, 0xfd11, 0xfef9, 0xfffe, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xff9c, 0xfed8, 0xe5b4, 0xfb28, 0xf9e2, 0xf940, 0xfa02, 0xfbcb, 0xfdf5, 0xff9c, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfefa, 0xfd93, 0xf347, 0xf1e3, 0xf941, 0xfa24, 0xfc2b, 0xfe55, 0xff9d, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xff7d, 0xfe7a, 0xfc4f, 0xf2e8, 0xf981, 0xf940, 0xfa42, 0xfbca, 0xfd73, 0xfeba, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xff5c, 0xfdf5, 0xfcaf, 0xfa64, 0xf981, 0xf941, 0xfa24, 0xfbaa, 0xfdb3, 0xff5a, 0xf7dd, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffbd, 0xfef9, 0xfccf, 0xfb07, 0xf980, 0xf960, 0xfaa6, 0xfcd0, 0xfef9, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0xfe16, 0xec4d, 0xf9c2, 0xf941, 0xf9c4, 0xfbcc, 0xfdf4, 0xff9b, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xff7b, 0xfe15, 0xfcb0, 0xfa45, 0xf981, 0xf120, 0xfa03, 0xfbea, 0xfdd3, 0xff3a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xff7c, 0xfeb8, 0xfc4d, 0xfac7, 0xf961, 0xf920, 0xf9e3, 0xfbaa, 0xfdd3, 0xff19, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffbd, 0xfe98, 0xfc8e, 0xfa64, 0xf920, 0xf181, 0xf36a, 0xfdd4, 0xff5b, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff3c, 0xfd52, 0xe348, 0xf940, 0xf961, 0xfae8, 0xfd53, 0xff3b, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffbd, 0xfe35, 0xfc2c, 0xfaa6, 0xf940, 0xf960, 0xf223, 0xfbaa, 0xfdb3, 0xff1a, 0xfffe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7dd, 0xfe77, 0xfcaf, 0xfaa6, 0xf940, 0xf8e0, 0xf9e2, 0xfbcb, 0xfd72, 0xff3b, 0xffbd, 0xffff, 0xf7ff, 0xefff, 0xf7ff, 0xffff, 0xffdf, 0xffbe, 0xfdf5, 0xfb89, 0xf9a1, 0xf920, 0xfa85, 0xfcd0, 0xfe97, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfeb9, 0xfc8e, 0xeaa5, 0xf940, 0xf1e2, 0xf3ec, 0xfe78, 0xffdf, 0xf7ff, 0xffff, 0xffdf, 0xffde, 0xffff, 0xffff, 0xffbd, 0xfe77, 0xfc6e, 0xfa85, 0xf960, 0xf940, 0xfa42, 0xfbea, 0xfdb3, 0xff1a, 0xffdf, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7ff, 0xefff, 0xefff, 0xffdd, 0xfe97, 0xfc8e, 0xfaa6, 0xf940, 0xf8e0, 0xf9e3, 0xfb49, 0xf593, 0xfeb8, 0xffbe, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xf7ff, 0xf6fa, 0xfccf, 0xfaa5, 0xf980, 0xfa03, 0xfc0c, 0xfdf5, 0xff9e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9e, 0xfe17, 0xfbcb, 0xfa43, 0xf9c0, 0xfaa6, 0xfcf0, 0xfefb, 0xf7ff, 0xf7ff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xff7b, 0xfe35, 0xfc6e, 0xfa86, 0xf960, 0xf920, 0xf243, 0xfbea, 0xfdd3, 0xff3a, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xf7ff, 0xffbd, 0xfe76, 0xfcaf, 0xfac7, 0xf961, 0xf120, 0xf9a2, 0xf3ca, 0xfd31, 0xfeb9, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xff7d, 0xfdf4, 0xfb89, 0xf9c2, 0xf9a2, 0xfb6a, 0xfd72, 0xf77e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5d, 0xfd74, 0xf328, 0xfa01, 0xfa22, 0xfb69, 0xfdb3, 0xff5c, 0xf7ff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xff5d, 0xfe15, 0xfc2c, 0xfa85, 0xf140, 0xf160, 0xfa23, 0xf40d, 0xfdb3, 0xff5b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9c, 0xfe77, 0xfcf0, 0xfb08, 0xf9a2, 0xf920, 0xfa43, 0xfb89, 0xfd11, 0xfe99, 0xffbe, 0xffff, 0xfffe, 0xfffe, 0xffdf, 0xffde, 0xfeb7, 0xfc4c, 0xfa23, 0xf961, 0xfac7, 0xfccf, 0xf77d, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff3d, 0xf4f2, 0xf2a6, 0xf9c0, 0xfa03, 0xfb8a, 0xfdf5, 0xff7d, 0xffdf, 0xffff, 0xffff, 0xfffd, 0xff3f, 0xfe79, 0xfc8f, 0xfaa5, 0xf960, 0xf900, 0xfa22, 0xfb88, 0xfd75, 0xfeda, 0xffff, 0xf7ff, 0xefff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xff9f, 0xffff, 0xf7ff, 0xef9c, 0xfe77, 0xfc8e, 0xfa84, 0xf980, 0xf100, 0xf223, 0xf38b, 0xf574, 0xff3c, 0xffff, 0xfffe, 0xfffd, 0xff9e, 0xfffe, 0xff19, 0xf4cf, 0xfa44, 0xf120, 0xf245, 0xfc2d, 0xf75d, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xff1b, 0xfc6e, 0xfa23, 0xf940, 0xf263, 0xf48d, 0xfed8, 0xff9d, 0xffdf, 0xffff, 0xffff, 0xff9f, 0xfe35, 0xfc2c, 0xfa23, 0xf920, 0xf900, 0xea43, 0xf44d, 0xfdb4, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xffbd, 0xfeb8, 0xfccf, 0xeb28, 0xf940, 0xf940, 0xf9c3, 0xfb29, 0xfd31, 0xff19, 0xffde, 0xf7ff, 0xffdf, 0xf7ff, 0xf7bd, 0xfd73, 0xfa65, 0xf8c0, 0xf1a2, 0xfc2d, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeda, 0xfc2c, 0xf9e2, 0xf900, 0xfa85, 0xfd10, 0xff3b, 0xffdf, 0xffdf, 0xfffe, 0xff5b, 0xf638, 0xfc4d, 0xfaa6, 0xf961, 0xf940, 0xfa22, 0xfbca, 0xfdd4, 0xfeda, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xff7c, 0xfe15, 0xfcd0, 0xfa85, 0xf9c2, 0xf941, 0xf9e3, 0xfbaa, 0xfd92, 0xff1a, 0xffde, 0xffff, 0xf7ff, 0xf7de, 0xfd73, 0xfa65, 0xf8c0, 0xf1a2, 0xfc0c, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbcb, 0xf181, 0xf8c0, 0xfa87, 0xfd73, 0xffbe, 0xf7ff, 0xffdf, 0xff7b, 0xfe14, 0xec6e, 0xfa23, 0xf940, 0xf120, 0xfa24, 0xfbeb, 0xfdd4, 0xff5b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xff7c, 0xfeb8, 0xfc8e, 0xfb08, 0xf961, 0xf8e0, 0xf9c2, 0xf389, 0xfd92, 0xff19, 0xffbe, 0xf7ff, 0xf7ff, 0xf593, 0xfa65, 0xf8c0, 0xf181, 0xfbcb, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfe99, 0xf3aa, 0xf140, 0xf8a0, 0xfa87, 0xfdb4, 0xffff, 0xf7ff, 0xff5d, 0xfe36, 0xfc4c, 0xf2a4, 0xf900, 0xf920, 0xf204, 0xfbcc, 0xfdb5, 0xff3c, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffbd, 0xfe97, 0xfcd0, 0xfac6, 0xf960, 0xf900, 0xf9c2, 0xfbaa, 0xfd31, 0xfefb, 0xffff, 0xffff, 0xfdd4, 0xfa86, 0xf8c0, 0xf181, 0xfbaa, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfe99, 0xfb8a, 0xf140, 0xf8c0, 0xfac8, 0xfe15, 0xffff, 0xffdf, 0xfe18, 0xfc2e, 0xfa64, 0xf960, 0xf940, 0xfa43, 0xfbeb, 0xfd94, 0xff1c, 0xffdf, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xefff, 0xf7fd, 0xf697, 0xfcae, 0xfae6, 0xf960, 0xf8e0, 0xf9e3, 0xfb29, 0xfd94, 0xff3b, 0xffdd, 0xfdd4, 0xfa86, 0xf8c0, 0xf161, 0xfbaa, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xfeb9, 0xfb8b, 0xf940, 0xf8c0, 0xfb08, 0xfdf3, 0xffbb, 0xfe98, 0xfc2f, 0xfa45, 0xf140, 0xf120, 0xf243, 0xfbeb, 0xfdd4, 0xff1b, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xefff, 0xf7bc, 0xfe76, 0xfcaf, 0xfac6, 0xf961, 0xf941, 0xf9c3, 0xfbcc, 0xfd93, 0xfed8, 0xfd51, 0xfa65, 0xf8c0, 0xf181, 0xfbca, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xfeba, 0xfb8b, 0xf940, 0xf8c0, 0xfaa7, 0xfd2f, 0xfe33, 0xfc8e, 0xfa66, 0xf941, 0xf180, 0xfa84, 0xec0c, 0xfdd4, 0xff3b, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7bc, 0xf697, 0xfcd0, 0xfb08, 0xf9c2, 0xf940, 0xfa04, 0xfbaa, 0xfd30, 0xfc4d, 0xfa24, 0xf8c0, 0xf1a1, 0xfbeb, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xfeba, 0xfb8b, 0xf920, 0xf8a0, 0xf9e4, 0xfc2b, 0xeccd, 0xeb07, 0xf961, 0xf920, 0xfa43, 0xfc0a, 0xfd94, 0xff1a, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xfffd, 0xfffc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xefff, 0xf7fd, 0xfe97, 0xfc8e, 0xfa85, 0xf940, 0xf900, 0xf264, 0xebcb, 0xf369, 0xf9e2, 0xf8e0, 0xf1a2, 0xfbeb, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9f, 0xffff, 0xffff, 0xffde, 0xfe97, 0xfbcc, 0xf161, 0xf8e0, 0xf9a3, 0xfa43, 0xfa83, 0xf9e2, 0xf941, 0xfa05, 0xfc0d, 0xf5d3, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffbd, 0xfed8, 0xf510, 0xdb68, 0xf961, 0xf981, 0xf9a1, 0xf9a2, 0xf982, 0xf120, 0xe1e1, 0xfbe9, 0xfefc, 0xffbe, 0xffff, 0xf7fe, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfeb9, 0xfbec, 0xf161, 0xf8c0, 0xf940, 0xf981, 0xf1a1, 0xf1a1, 0xfa25, 0xfbac, 0xfdd4, 0xff59, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff7c, 0xfe35, 0xf510, 0xfaa6, 0xfa03, 0xf181, 0xf940, 0xf940, 0xf120, 0xe9e2, 0xfc09, 0xff1c, 0xffdf, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xffff, 0xfed9, 0xf40d, 0xf181, 0xf8c0, 0xf920, 0xf920, 0xf160, 0xea24, 0xf3cb, 0xfdb4, 0xff5b, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbe, 0xff7c, 0xfed8, 0xfc8f, 0xf349, 0xe202, 0xf140, 0xf920, 0xf900, 0xf1c2, 0xfbca, 0xff1c, 0xffff, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xefff, 0xefff, 0xffde, 0xfe98, 0xf3cc, 0xf181, 0xf8e0, 0xf980, 0xf9a0, 0xfa44, 0xfbcc, 0xfdb4, 0xff5b, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xffdf, 0xffdf, 0xffbd, 0xfe78, 0xf4d0, 0xeb28, 0xf9e2, 0xf940, 0xf8e0, 0xf182, 0xfb69, 0xfe79, 0xff9d, 0xffff, 0xeffe, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xff5b, 0xfdb4, 0xf329, 0xf181, 0xf920, 0xf1c0, 0xf283, 0xfbeb, 0xfdb4, 0xff3b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffff, 0xffff, 0xf7ff, 0xffbe, 0xfe77, 0xfd0f, 0xfb27, 0xf9c1, 0xf8e0, 0xf941, 0xfac7, 0xfd33, 0xfeb8, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xff5b, 0xfe15, 0xfc2d, 0xf265, 0xf960, 0xf940, 0xea83, 0xfbea, 0xfdd3, 0xff3b, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffbd, 0xfe97, 0xfc6d, 0xfa44, 0xf900, 0xf900, 0xfa03, 0xfb6a, 0xfd31, 0xfed8, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff1c, 0xfdd5, 0xfbec, 0xfa85, 0xf9a1, 0xf960, 0xf940, 0xfae8, 0xfd10, 0xff3a, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff7b, 0xfd31, 0xf2a7, 0xf141, 0xf8e0, 0xf980, 0xf9e2, 0xfb48, 0xfd10, 0xfeb8, 0xffde, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5f, 0xfe39, 0xfc4f, 0xf265, 0xf140, 0xf920, 0xf940, 0xf140, 0xfac9, 0xfd73, 0xfffe, 0xefff, 0xf7ff, 0xffdf, 0xffdf, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdd, 0xf573, 0xe2c8, 0xf161, 0xf900, 0xf920, 0xf900, 0xfa02, 0xe38a, 0xed93, 0xff3c, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffbf, 0xffdf, 0xf7ff, 0xefff, 0xffff, 0xff7d, 0xfdd5, 0xfbcc, 0xfa02, 0xf1a0, 0xf1a0, 0xf980, 0xf940, 0xf140, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xfdb3, 0xfaa4, 0xf940, 0xf920, 0xe981, 0xf900, 0xf900, 0xf9c2, 0xfb28, 0xfcef, 0xfeb8, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 
0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xfffe, 0xff3b, 0xfe16, 0xfc0d, 0xfa86, 0xf980, 0xf1c0, 0xf1e1, 0xf981, 0xf920, 0xf920, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfdb3, 0xfa84, 0xf920, 0xf920, 0xf1e3, 0xfa45, 0xf9e3, 0xf1a1, 0xf223, 0xfb69, 0xfd52, 0xfeda, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffdf, 0xf7ff, 0xf7ff, 0xffff, 0xff7b, 0xfdd4, 0xfc0d, 0xfa24, 0xf961, 0xf981, 0xf284, 0xfae7, 0xf9e4, 0xf900, 0xf8e0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xfffe, 0xfdb3, 0xfa85, 0xf900, 0xf940, 0xfa86, 0xfc2d, 0xfb69, 0xf223, 0xe960, 0xf1e1, 0xfb49, 0xfd32, 0xfe99, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xff9d, 0xfe36, 0xfc0c, 0xfa45, 0xf920, 0xf960, 0xfaa6, 0xfc6d, 0xfcae, 0xfac8, 0xf921, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xffde, 0xfdb4, 0xfa85, 0xf8c0, 0xf960, 0xfb28, 0xf5d5, 0xfd51, 0xfba9, 0xf9e1, 0xf940, 0xf9c2, 0xfb4a, 0xfd31, 0xf75c, 0xffde, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xf7ff, 0xffff, 0xfed9, 0xfcaf, 0xfa85, 0xf940, 0xf960, 0xfa64, 0xfc6e, 0xfe56, 0xfe35, 0xfbab, 0xf141, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffbe, 0xfd93, 0xfa85, 0xf8a0, 0xf960, 0xfbab, 0xf6da, 0xfef9, 0xfd71, 0xfb27, 0xf981, 0xf100, 0xf1e3, 0xfbaa, 0xf637, 0xff5c, 0xffff, 0xffff, 0xffff, 
0xffbf, 0xffff, 0xfffe, 0xff5b, 0xfd93, 0xfb29, 0xf181, 0xf920, 0xf243, 0xfbcb, 0xfe16, 0xffbc, 0xfef9, 0xfbec, 0xe961, 0xf0c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xfd94, 0xfa65, 0xf8a0, 0xf161, 0xfbcc, 0xff3d, 0xffbd, 0xfef8, 0xfccf, 0xfac7, 0xf141, 0xf140, 0xfa83, 0xfcaf, 0xfe57, 0xffbe, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xff7b, 0xfdf4, 0xfbec, 0xfa24, 0xf181, 0xf9c2, 0xf3cb, 0xfd74, 0xff3d, 0xffff, 0xfefa, 0xfbcc, 0xf120, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xfd74, 0xfa65, 0xf0a0, 0xe961, 0xfbcb, 0xff1d, 0xffff, 0xffde, 0xf678, 0xfc90, 0xfa87, 0xf181, 0xf9c0, 0xfae6, 0xfcd0, 0xfefa, 0xf7ff, 0xf7ff, 
0xffff, 0xffdf, 0xfeb7, 0xf48e, 0xf2a6, 0xf182, 0xf9a2, 0xfaa5, 0xfcf1, 0xfe9a, 0xffdf, 0xf7ff, 0xfeb9, 0xfb6b, 0xf900, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffde, 0xfd73, 0xfa65, 0xf0a0, 0xe961, 0xfbcb, 0xfedd, 0xffdf, 0xefff, 0xf7be, 0xfdf7, 0xfbcc, 0xfa02, 0xf980, 0xf9a0, 0xfbaa, 0xfe57, 0xefdf, 0xefdf, 
0xffff, 0xff3c, 0xfd52, 0xfb27, 0xf980, 0xf120, 0xea86, 0xfcb0, 0xe73c, 0xff9d, 0xffff, 0xffff, 0xfeb9, 0xfba9, 0xf120, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xfffe, 0xfffd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffdf, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdd, 0xfffe, 0xfffe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa85, 0xf8a0, 0xf140, 0xfc0b, 0xfefa, 0xfffe, 0xf7ff, 0xffff, 0xff9d, 0xedf3, 0xf388, 0xf960, 0xe980, 0xfa83, 0xfc4d, 0xfe1a, 0xfffe, 
0xffbf, 0xfeba, 0xfc8f, 0xfaa4, 0xf980, 0xf9c0, 0xfb8a, 0xfdb5, 0xf79d, 0xffde, 0xffff, 0xffff, 0xfeb9, 0xfba9, 0xf120, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefbf, 0xdf5e, 0xcf1d, 0xc73f, 0xcf3f, 0xdf5e, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefbf, 0xdf5f, 0xcf1e, 0xcefe, 0xcf1e, 0xd73e, 0xd79f, 0xefff, 0xffff, 0xfffe, 0xfffe, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa85, 0xf8a0, 0xf140, 0xfc0b, 0xfefa, 0xfffe, 0xf7ff, 0xffff, 0xffde, 0xfe97, 0xfc6d, 0xfa65, 0xf1a0, 0xfa01, 0xfb8a, 0xfd76, 0xff9b, 
0xff7d, 0xfdf6, 0xf3cb, 0xf202, 0xf9a0, 0xfaa5, 0xfcb0, 0xfeba, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfba9, 0xf140, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xe7bf, 0xbefe, 0x961c, 0x7d7a, 0x759b, 0x7d9b, 0x9e1c, 0xc71e, 0xefbf, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xdf9f, 0xbede, 0x9e1c, 0x7d7a, 0x755a, 0x7d9b, 0x85dc, 0x9e5c, 0xc75f, 0xefff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa85, 0xf8a0, 0xf140, 0xfc0b, 0xfef9, 0xfffe, 0xffff, 0xffff, 0xffff, 0xff7c, 0xfdd4, 0xfbac, 0xf9e1, 0xf980, 0xf285, 0xfcb3, 0xfef8, 
0xff3a, 0xfd72, 0xfb08, 0xf9c1, 0xfa02, 0xfb89, 0xfd94, 0xff1d, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbc9, 0xf940, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xdf9f, 0xb6de, 0x7dbc, 0x4cba, 0x2c39, 0x2c18, 0x3417, 0x54b9, 0x85dc, 0xbefe, 0xe7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef9f, 0xcf7f, 0xa67e, 0x757a, 0x5499, 0x3417, 0x2bf7, 0x2c18, 0x2c38, 0x5cf9, 0x8e1c, 0xbf1e, 0xe79f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa85, 0xf8a0, 0xf140, 0xfc0b, 0xfef9, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xfed9, 0xfcb2, 0xfa42, 0xf920, 0xf1e2, 0xfc30, 0xfeb6, 
0xff19, 0xfcf0, 0xfa65, 0xf980, 0xfa64, 0xfc4d, 0xfe58, 0xff7f, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfed9, 0xfbc9, 0xf140, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefdf, 0xbefe, 0x7d9b, 0x3c79, 0x13d8, 0x0398, 0x0377, 0x0356, 0x1bb7, 0x4479, 0x7dbb, 0xc73f, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffbf, 0xf7fe, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xd73e, 0x8e5e, 0x5d1a, 0x3417, 0x1396, 0x0356, 0x0377, 0x0398, 0x0357, 0x23d7, 0x4cb9, 0x85ba, 0xbedd, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa85, 0xf8a0, 0xf140, 0xfc0b, 0xff1a, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xff5c, 0xfd55, 0xfaa4, 0xf900, 0xf960, 0xfbed, 0xfe95, 
0xfef8, 0xfc6e, 0xf9c2, 0xf920, 0xf284, 0xf510, 0xff1b, 0xffdf, 0xffde, 0xffde, 0xffdf, 0xffff, 0xfed9, 0xfbc9, 0xf140, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xdfbf, 0x963d, 0x4499, 0x1397, 0x0357, 0x0358, 0x0378, 0x0337, 0x0357, 0x1397, 0x4498, 0xa69d, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xbebc, 0x553b, 0x2bf7, 0x0b35, 0x0356, 0x0357, 0x0399, 0x03b9, 0x0358, 0x0377, 0x13b6, 0x4c77, 0x9e1b, 0xe7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa85, 0xf8a0, 0xf140, 0xfc0b, 0xff1a, 0xfffe, 0xffff, 0xffbf, 0xffdf, 0xf7ff, 0xffbd, 0xf5d6, 0xfae5, 0xf900, 0xf920, 0xfb8b, 0xfe53, 
0xfed8, 0xfc0d, 0xf981, 0xf900, 0xf2a5, 0xf572, 0xff7d, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xfed9, 0xfbc9, 0xf140, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdd, 0xffff, 0xd79f, 0x7dbc, 0x2bf7, 0x0357, 0x0358, 0x0358, 0x0378, 0x0378, 0x0358, 0x0336, 0x23d7, 0x963d, 0xefff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbf, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xefff, 0xae5a, 0x349a, 0x0b76, 0x0336, 0x0377, 0x0378, 0x0398, 0x03d9, 0x0378, 0x0379, 0x0336, 0x2bd6, 0x85bb, 0xdf9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa85, 0xf8a0, 0xf140, 0xfc0b, 0xf71b, 0xffde, 0xffff, 0xffdf, 0xffdf, 0xf7ff, 0xffdd, 0xfe17, 0xf347, 0xf940, 0xf920, 0xf329, 0xfe12, 
0xf6b8, 0xf3ec, 0xf961, 0xf900, 0xfae6, 0xf5b3, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfba9, 0xf140, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbc, 0xffff, 0xcf7f, 0x6d7b, 0x1bb7, 0x0377, 0x0378, 0x0358, 0x0357, 0x0378, 0x0399, 0x0316, 0x1bb7, 0x963d, 0xefff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffbd, 0xf75c, 0xef1a, 0xeeba, 0xee99, 0xf699, 0xf69a, 0xfe9b, 0xfebb, 0xfefc, 0xff3c, 0xff9d, 0xffde, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xe7ff, 0x9e1a, 0x2c5a, 0x0376, 0x0357, 0x0398, 0x0358, 0x0377, 0x0398, 0x0357, 0x03bb, 0x0337, 0x1b96, 0x7d9b, 0xd79f, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa85, 0xf8a0, 0xf140, 0xfc0b, 0xf71b, 0xffde, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xfffd, 0xfe77, 0xf3a9, 0xf9a1, 0xf940, 0xeb09, 0xfdf1, 
0xfe79, 0xf3cc, 0xf960, 0xf940, 0xfae5, 0xfd71, 0xff5b, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xfed9, 0xfba9, 0xf120, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xd77f, 0x85fb, 0x3457, 0x0396, 0x0378, 0x0399, 0x0399, 0x0378, 0x0378, 0x0377, 0x3438, 0x963d, 0xefdf, 0xfffe, 0xffbe, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xfffe, 0xff1a, 0xfdd5, 0xfcd0, 0xfc2d, 0xfc0b, 0xfc0a, 0xfc09, 0xfc0c, 0xfc0c, 0xfc4e, 0xfd12, 0xfe36, 0xff5b, 0xfffe, 0xf7ff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffde, 0xffdf, 0xe79f, 0xaebe, 0x449b, 0x1bb8, 0x0337, 0x0379, 0x03da, 0x03b9, 0x0376, 0x0b55, 0x03ba, 0x0377, 0x3417, 0x8ddb, 0xdf9f, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa65, 0xf8a0, 0xf920, 0xfc0b, 0xff1d, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xfffe, 0xfffd, 0xfe57, 0xf349, 0xf901, 0xf921, 0xeb29, 0xfe12, 
0xfeda, 0xfc2e, 0xf9c1, 0xf940, 0xfaa5, 0xfd30, 0xff3b, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xfed9, 0xfbaa, 0xf120, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xe79f, 0xa69d, 0x5d39, 0x2417, 0x0377, 0x0358, 0x0357, 0x0357, 0x0398, 0x2418, 0x5d1a, 0xb6de, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7c, 0xfe99, 0xfdb3, 0xfd31, 0xf48f, 0xf3ec, 0xf3cb, 0xf3cb, 0xebea, 0xebea, 0xfc0b, 0xf3eb, 0xfc0c, 0xfc6f, 0xfcd1, 0xfd53, 0xfe16, 0xfed9, 0xff9d, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xf7df, 0xcf1f, 0x6d9d, 0x3c79, 0x0b97, 0x0338, 0x0359, 0x0358, 0x0337, 0x0357, 0x0398, 0x1bf8, 0x5d1a, 0xae9d, 0xe7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa65, 0xf8a0, 0xf920, 0xfc0b, 0xfefc, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7ff, 0xffdd, 0xf617, 0xf307, 0xf8e0, 0xf941, 0xf34a, 0xfe32, 
0xff1a, 0xfcaf, 0xfa44, 0xf960, 0xfa64, 0xfc8e, 0xfeb9, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfed9, 0xfbaa, 0xf920, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xd77f, 0x965c, 0x54f9, 0x23d7, 0x0b56, 0x0b14, 0x0b35, 0x23d6, 0x54d9, 0x963d, 0xd79f, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xfffe, 0xff9c, 0xfe36, 0xfcb0, 0xfbca, 0xfbeb, 0xfc4d, 0xfcaf, 0xfd11, 0xfd32, 0xfd52, 0xfd72, 0xfd51, 0xfd10, 0xfcd0, 0xfc8f, 0xf3ed, 0xeb6b, 0xfbec, 0xfcb0, 0xfeb8, 0xff9d, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xf77f, 0xa71f, 0x75dc, 0x3c58, 0x1397, 0x0337, 0x0317, 0x0337, 0x0b58, 0x2c17, 0x5cf9, 0x9e5d, 0xd77f, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa65, 0xf8a0, 0xf920, 0xfc0b, 0xfefb, 0xffdf, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xff9c, 0xf5b6, 0xfae6, 0xf8e0, 0xf961, 0xfbcc, 0xfe94, 
0xff19, 0xfd30, 0xfae6, 0xf9a1, 0xfa03, 0xfbcc, 0xfe16, 0xff9d, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfed8, 0xfbca, 0xf920, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xcf5e, 0x963c, 0x6519, 0x4c99, 0x4c57, 0x5477, 0x6d19, 0x9e1c, 0xcf3f, 0xf7ff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffbe, 0xff3b, 0xfe35, 0xfccf, 0xfbcb, 0xf38a, 0xfc2d, 0xfd51, 0xfe36, 0xfeb9, 0xfefa, 0xfefa, 0xfeda, 0xff3a, 0xfef9, 0xfe98, 0xfdd5, 0xfcd0, 0xf3ec, 0xf3ab, 0xfbcc, 0xfd52, 0xfe58, 0xff9d, 0xffff, 0xf7ff, 0xf7ff, 0xffdf, 0xffdf, 0xe7ff, 0xbefe, 0x85bb, 0x64f9, 0x4c99, 0x4479, 0x4c7a, 0x4cba, 0x7d59, 0xa65c, 0xd77f, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa65, 0xf8a0, 0xf920, 0xfc0b, 0xfefa, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xff3b, 0xfd14, 0xfaa5, 0xf900, 0xf1c2, 0xfc4f, 0xfed5, 
0xff5a, 0xfdd3, 0xfb89, 0xf9c2, 0xf9a2, 0xfae8, 0xfd32, 0xff1a, 0xfffe, 0xffdf, 0xffff, 0xf7ff, 0xfed8, 0xfbca, 0xf920, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xdf7f, 0xbeff, 0xb6df, 0xb6df, 0xbeff, 0xc71f, 0xdf7f, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xff1a, 0xfdb4, 0xf48f, 0xf44d, 0xfcae, 0xfd94, 0xfe37, 0xfefa, 0xff9d, 0xffde, 0xffde, 0xffbe, 0xff9e, 0xffff, 0xffff, 0xffbe, 0xff3b, 0xfeb9, 0xfe36, 0xfd93, 0xf4d0, 0xfc0e, 0xfcf2, 0xfe58, 0xff9e, 0xffff, 0xf7ff, 0xf7fe, 0xfffe, 0xffff, 0xef9f, 0xd71e, 0xc6dd, 0xbedd, 0xb6de, 0xb6fe, 0xbefe, 0xc6dc, 0xdf7f, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa65, 0xf8a0, 0xf920, 0xfc0b, 0xfefa, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffbd, 0xfe78, 0xfc50, 0xfa43, 0xf940, 0xf244, 0xfcb1, 0xff17, 
0xffbc, 0xfe77, 0xf44d, 0xfa24, 0xf940, 0xf9e3, 0xfc0c, 0xfe35, 0xff9c, 0xffde, 0xffff, 0xffff, 0xfed8, 0xfbca, 0xf920, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xff5b, 0xfdd4, 0xf44e, 0xebed, 0xf511, 0xfe76, 0xffbf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xf7df, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xfffd, 0xff3b, 0xee56, 0xfc4f, 0xf42e, 0xfcf2, 0xfe58, 0xff9e, 0xffff, 0xf7ff, 0xfffe, 0xffdf, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa65, 0xf8a0, 0xf920, 0xfc0b, 0xfefa, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xff19, 0xfd32, 0xfb2a, 0xf9c1, 0xf9a0, 0xeb07, 0xfd34, 0xf739, 
0xfffe, 0xff3b, 0xfd52, 0xfb07, 0xf960, 0xf940, 0xfae6, 0xfccf, 0xf6d9, 0xff7d, 0xffff, 0xffff, 0xfef8, 0xfbca, 0xf920, 0xf880, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xff9d, 0xfe36, 0xfc8f, 0xfc0d, 0xf4f1, 0xfe98, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffde, 0xf75c, 0xfdf5, 0xf48f, 0xf40d, 0xfd11, 0xfeb9, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa65, 0xf8a0, 0xf920, 0xfc0b, 0xfefa, 0xfffe, 0xffff, 0xffff, 0xff7d, 0xfe14, 0xfbeb, 0xf9e3, 0xf180, 0xfa63, 0xfc0c, 0xfdf8, 0xf7bc, 
0xffdf, 0xff9d, 0xfe16, 0xfbca, 0xf9c1, 0xf900, 0xf202, 0xf3aa, 0xe657, 0xff1b, 0xffff, 0xf7ff, 0xfef8, 0xfbca, 0xf920, 0xf880, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xf7ff, 0xffdf, 0xffff, 0xffdf, 0xff9f, 0xffbe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xdfff, 0xff1a, 0xfd52, 0xfbec, 0xfc4d, 0xfe35, 0xffbd, 0xf7ff, 0xffbf, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffdf, 0xff9b, 0xfd51, 0xf3cb, 0xfc2d, 0xfdd6, 0xff3c, 0xffbe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf5b3, 0xfa65, 0xf8a0, 0xf920, 0xfc0b, 0xf6fa, 0xfffe, 0xffff, 0xffdf, 0xff1b, 0xed51, 0xf306, 0xf8e0, 0xf181, 0xfae5, 0xfcef, 0xfe9c, 0xffff, 
0xffff, 0xffff, 0xff3c, 0xfd73, 0xfb4a, 0xf1c2, 0xf960, 0xf9c0, 0xfbec, 0xfdd7, 0xffbf, 0xf7ff, 0xfedb, 0xfb8c, 0xf901, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0xeffc, 0xfd92, 0xfbaa, 0xfc2c, 0xfdf6, 0xff3d, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xfeda, 0xfd94, 0xfc6d, 0xf44a, 0xfe12, 0xffdc, 0xf7ff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xf7fe, 0xfd93, 0xfa66, 0xf8a0, 0xf161, 0xfc0c, 0xfedc, 0xffff, 0xf7ff, 0xff3b, 0xfd12, 0xfae8, 0xf9a0, 0xf9c0, 0xfa44, 0xfc4d, 0xfe99, 0xffdf, 0xffdf, 
0xffdf, 0xffff, 0xffbd, 0xfe78, 0xfcb0, 0xfaa6, 0xf960, 0xf960, 0xf2c6, 0xfcb0, 0xfeda, 0xffff, 0xfef9, 0xfbac, 0xf141, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xff7a, 0xfccf, 0xfb29, 0xfcaf, 0xfefa, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xff5c, 0xfdf6, 0xfc0d, 0xeb48, 0xfd10, 0xff5b, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xfffe, 0xfd93, 0xfa65, 0xf8a0, 0xf181, 0xfc0c, 0xff5d, 0xfffe, 0xff7b, 0xfdd4, 0xfbac, 0xf9e4, 0xf960, 0xfa00, 0xf3aa, 0xfd73, 0xff5b, 0xffff, 0xffff, 
0xffde, 0xffff, 0xffff, 0xff9d, 0xfe57, 0xfc0d, 0xf223, 0xf140, 0xf1a0, 0xfb28, 0xfd72, 0xff38, 0xfeb6, 0xfbeb, 0xf141, 0xf0c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xfeb7, 0xfc0c, 0xf2c8, 0xfcf1, 0xff5c, 0xffff, 0xffbf, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xffff, 0xfeba, 0xfc4f, 0xea87, 0xfbed, 0xfeb9, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xffff, 0xfd93, 0xfa65, 0xf8c0, 0xf981, 0xfbcb, 0xff5c, 0xff5b, 0xfe14, 0xfbcb, 0xfa04, 0xf900, 0xf180, 0xfac4, 0xf594, 0xfef9, 0xfffe, 0xf7ff, 0xf7ff, 
0xfffe, 0xffff, 0xf7ff, 0xf7ff, 0xff5c, 0xfd93, 0xfb69, 0xf202, 0xf920, 0xf9e2, 0xfba9, 0xfd90, 0xfdb1, 0xfb69, 0xf941, 0xf8a0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xff9c, 0xff1a, 0xfed9, 0xfe58, 0xfdf7, 0xfcee, 0xfb28, 0xf308, 0xfd73, 0xffbd, 0xffff, 0xffdf, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffde, 0xefff, 0xffff, 0xff7c, 0xfd11, 0xf2e8, 0xfb09, 0xfcf0, 0xfe36, 0xfdf6, 0xfe37, 0xfeb9, 0xff5c, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfd93, 0xfa65, 0xf8c0, 0xf981, 0xfb6a, 0xf658, 0xfdf5, 0xfc4c, 0xfa23, 0xf920, 0xf940, 0xfa85, 0xfc6c, 0xf6fb, 0xffbe, 0xffff, 0xf7ff, 0xf7ff, 
0xfffd, 0xffff, 0xefff, 0xefff, 0xffff, 0xfed9, 0xfcf0, 0xfb49, 0xf980, 0xf940, 0xfa02, 0xfb87, 0xfbe9, 0xfa66, 0xf901, 0xf8c0, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff9c, 0xfeb7, 0xfdd2, 0xfcef, 0xfc0c, 0xfb6a, 0xf2e5, 0xfac6, 0xfc0c, 0xfe56, 0xfffe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffbd, 0xfe14, 0xfc0a, 0xfae6, 0xfb07, 0xf349, 0xfb28, 0xfbeb, 0xfcf0, 0xfe36, 0xff3b, 0xffde, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfd93, 0xfa64, 0xf8e0, 0xf960, 0xfae7, 0xfc90, 0xfc0d, 0xfa85, 0xf940, 0xf940, 0xfa65, 0xfc6d, 0xfe55, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xfffe, 0xf7ff, 0xf7ff, 0xf7ff, 0xffbd, 0xfe78, 0xfcf1, 0xfae7, 0xf9c2, 0xf140, 0xf201, 0xfa43, 0xf9a2, 0xf901, 0xf900, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xff1a, 0xf615, 0xf52f, 0xfc8c, 0xfbea, 0xfb89, 0xf328, 0xe368, 0xfc2d, 0xfd73, 0xe6b9, 0xc71c, 0xbedd, 0xbebd, 0xb6dd, 0xbefe, 0xbefe, 0xbefe, 0xbefe, 0xbefe, 0xbefe, 0xbefe, 0xbefe, 0xc6dd, 0xbedd, 0xbefe, 0xb71f, 0xb6fe, 0xbebd, 0xd71d, 0xef9e, 0xffff, 0xf7ff, 0xf7de, 0xff39, 0xfdd2, 0xfc6c, 0xfb8a, 0xf329, 0xf327, 0xfb68, 0xfc0b, 0xfcae, 0xfd72, 0xfe77, 0xff5c, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfd93, 0xfa84, 0xf900, 0xf940, 0xfa45, 0xfae8, 0xfa65, 0xf981, 0xf160, 0xfa64, 0xfc2c, 0xfe36, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 
0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xff9d, 0xfeba, 0xfd11, 0xfb49, 0xf9e2, 0xf1a0, 0xf980, 0xf940, 0xf920, 0xf940, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xfe57, 0xfd52, 0xec6d, 0xf42c, 0xfc8d, 0xfcef, 0xfd52, 0xfd93, 0xfe15, 0xfe78, 0xf6fc, 0xb6fc, 0x7dfa, 0x5cb8, 0x4c59, 0x449a, 0x4c99, 0x4c99, 0x4c99, 0x4c99, 0x4c99, 0x4c99, 0x4c99, 0x4c99, 0x4c98, 0x4478, 0x3c99, 0x3c9a, 0x4478, 0x54b8, 0x85ba, 0xb6bd, 0xffff, 0xffff, 0xffff, 0xffde, 0xff7a, 0xfed7, 0xfe36, 0xfdf7, 0xfdd5, 0xfd73, 0xfccf, 0xfc2c, 0xf3eb, 0xf48f, 0xfdd5, 0xfeba, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfd93, 0xf284, 0xf940, 0xf920, 0xf9c3, 0xf9e1, 0xf9a0, 0xf1c1, 0xf2c6, 0xfc4d, 0xfe16, 0xff7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffdf, 0xf7ff, 0xffff, 0xffdf, 0xfef9, 0xfcd0, 0xfac6, 0xf9e1, 0xf980, 0xf940, 0xf940, 0xf180, 0xfae5, 0xfdf4, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xef5d, 0xfd11, 0xfc0c, 0xf38a, 0xfc4d, 0xfd72, 0xfe77, 0xff1b, 0xff9e, 0xffff, 0xffdf, 0xe7df, 0x9f5f, 0x5dbc, 0x2bf8, 0x0b38, 0x0359, 0x0357, 0x0357, 0x0357, 0x0357, 0x0357, 0x0357, 0x0357, 0x0357, 0x0377, 0x0357, 0x0358, 0x0378, 0x0377, 0x2418, 0x6d9c, 0xaf1f, 0xf7fe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7df, 0xff5c, 0xfe16, 0xfcaf, 0xfbab, 0xfbcb, 0xfc90, 0xfd74, 0xf79e, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfd93, 0xf2a4, 0xf940, 0xf920, 0xf161, 0xf960, 0xf960, 0xfa63, 0xfc2b, 0xfdf4, 0xff7c, 0xffdf, 0xffbf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xfedb, 0xfd53, 0xf369, 0xf1e2, 0xf940, 0xf920, 0xf900, 0xeac8, 0xfdb2, 0xfffd, 0xefff, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xfe97, 0xfcf0, 0xec0a, 0xfd10, 0xfe16, 0xf69a, 0xf73d, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xe79e, 0xb6bc, 0x6d39, 0x23d7, 0x0336, 0x0337, 0x0358, 0x0358, 0x0337, 0x0337, 0x0b78, 0x0b57, 0x0b36, 0x0336, 0x0316, 0x0337, 0x0337, 0x1bb7, 0x6d19, 0xbebc, 0xe75d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xff9e, 0xf6fc, 0xf638, 0xf533, 0xfc4e, 0xfc2c, 0xfd94, 0xfeba, 0xffbf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffde, 0xffdf, 0xffff, 0xefff, 0xffff, 0xffdd, 0xf5b3, 0xe2e7, 0xf961, 0xf900, 0xf960, 0xf940, 0xfa85, 0xec6e, 0xf638, 0xff7f, 0xffbf, 0xff9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9e, 0xfe98, 0xfd10, 0xfb49, 0xfa03, 0xf940, 0xf920, 0xf2a6, 0xfcae, 0xfed8, 0xffdd, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffbe, 0xfeb9, 0xfd72, 0xfc6e, 0xf4ce, 0xfdf4, 0xff3b, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xdfdf, 0xa6de, 0x5d5b, 0x2c18, 0x0377, 0x0398, 0x0399, 0x0399, 0x0378, 0x0378, 0x0377, 0x0357, 0x0b78, 0x0337, 0x0377, 0x2419, 0x5d1b, 0xa69e, 0xe7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffdf, 0xff5d, 0xfe78, 0xfd32, 0xfc6e, 0xfcb0, 0xfdf6, 0xff5d, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffbe, 0xff19, 0xfcef, 0xea65, 0xf900, 0xf900, 0xf9e1, 0xfa85, 0xfc0b, 0xfdf4, 0xff5c, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdd, 0xfef9, 0xfd10, 0xf2e7, 0xf180, 0xf940, 0xfa02, 0xfb07, 0xfcaf, 0xfe98, 0xffbe, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfefa, 0xed32, 0xe42d, 0xfc4d, 0xfe57, 0xff3b, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xf7de, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xdfff, 0xa69e, 0x6d39, 0x13b7, 0x0b97, 0x0378, 0x0399, 0x0399, 0x0378, 0x0377, 0x0377, 0x0378, 0x0337, 0x1bb7, 0x5cfa, 0xa69e, 0xdfdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9d, 0xfe77, 0xf552, 0xebec, 0xf511, 0xfe98, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xfefa, 0xfdb3, 0xfbaa, 0xf9e2, 0xf8c0, 0xf920, 0xfaa4, 0xfc6d, 0xfe14, 0xff9b, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffde, 0xfe57, 0xf38a, 0xf181, 0xf900, 0xf960, 0xf9a1, 0xfac7, 0xfcd0, 0xfed9, 0xffde, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffdf, 0xff7c, 0xfe15, 0xec4d, 0xec0c, 0xfcf0, 0xffbd, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xf7ff, 0xd75f, 0xa63b, 0x44b9, 0x1bf7, 0x0356, 0x0377, 0x03b9, 0x0399, 0x0378, 0x0377, 0x0358, 0x13b8, 0x4c99, 0x9e1c, 0xd77f, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xfffe, 0xff7c, 0xf657, 0xf3ec, 0xf46e, 0xfd92, 0xfed8, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xf7ff, 0xefde, 0xff1a, 0xfd94, 0xfbec, 0xfa64, 0xf980, 0xf8e0, 0xf981, 0xfb88, 0xfdf5, 0xff5b, 0xfffe, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xf7ff, 0xffff, 0xfeba, 0xfbcc, 0xf161, 0xf8c0, 0xf960, 0xf960, 0xf9c2, 0xfae8, 0xfcf0, 0xfeb8, 0xffbd, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xff9e, 0xfe98, 0xfd30, 0xf40b, 0xfcaf, 0xfe16, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xf7df, 0xe77e, 0x8e5e, 0x4cd9, 0x1396, 0x0356, 0x03b9, 0x03b9, 0x0378, 0x0377, 0x13b8, 0x44ba, 0x961d, 0xd75f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffde, 0xf71b, 0xfcf1, 0xfc4d, 0xf48c, 0xfdf3, 0xff9c, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffde, 0xff3b, 0xfd73, 0xfbcc, 0xf244, 0xf180, 0xf940, 0xf900, 0xf9a2, 0xfbea, 0xfeda, 0xffde, 0xffff, 0xefff, 0xffbf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7df, 0xffdf, 0xfeda, 0xfbed, 0xf960, 0xf8c0, 0xf960, 0xf980, 0xf960, 0xe9a1, 0xf2e7, 0xfcf0, 0xfeb8, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff7d, 0xfdb4, 0xfc4c, 0xfc4c, 0xfd93, 0xfefb, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xcf7f, 0x8dfb, 0x3c57, 0x1397, 0x0377, 0x0357, 0x0356, 0x0b76, 0x3c58, 0x7ddc, 0xc73f, 0xf7ff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xff9e, 0xfe36, 0xfc6e, 0xf3a9, 0xfd0f, 0xff1a, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdd, 0xfef9, 0xfdf5, 0xfb8a, 0xf245, 0xe960, 0xf140, 0xf940, 0xf900, 0xf1c2, 0xfbe9, 0xfefc, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfeb9, 0xf3cc, 0xf160, 0xf8e0, 0xf9a1, 0xfa02, 0xfa01, 0xf1a0, 0xf9a1, 0xfae8, 0xfcf0, 0xfe96, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff1b, 0xfcf1, 0xfba9, 0xfc6d, 0xfe78, 0xf79f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefdf, 0xc6fe, 0x7d9b, 0x3c59, 0x0b57, 0x0315, 0x1377, 0x2c39, 0x7d7a, 0xb6de, 0xefdf, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xfefb, 0xf48f, 0xf327, 0xfc8d, 0xfeda, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffbd, 0xfed9, 0xfd32, 0xfbcb, 0xfa23, 0xf981, 0xf980, 0xf9c0, 0xf9a0, 0xf920, 0xe9c1, 0xfbe9, 0xf71c, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xf7ff, 0xf7ff, 0xffde, 0xfe98, 0xf3cb, 0xe980, 0xf920, 0xfa24, 0xfac5, 0xfb04, 0xfa41, 0xf920, 0xf962, 0xf329, 0xed0f, 0xef5d, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeda, 0xf46f, 0xf348, 0xfcae, 0xfeda, 0xe7ff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefbf, 0xb6ff, 0x657d, 0x23d8, 0x0b56, 0x3439, 0x5d5d, 0xae9d, 0xdfbf, 0xffff, 0xffde, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xff3c, 0xec8f, 0xf2e7, 0xfc4d, 0xfeb9, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7de, 0xff5b, 0xfdf5, 0xf3ab, 0xd9c3, 0xf960, 0xf960, 0xfa02, 0xfa62, 0xfa01, 0xf140, 0xf1c1, 0xfc09, 0xf73c, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbaa, 0xf940, 0xf880, 0xfa46, 0xf4d0, 0xedb2, 0xebc8, 0xf9c0, 0xf940, 0xf9e2, 0xfa83, 0xf4f0, 0xfe77, 0xffde, 0xf7ff, 0xefff, 0xf7ff, 0xffff, 0xffbd, 0xffdf, 0xffff, 0xfef9, 0xfc4e, 0xfb28, 0xfcef, 0xff3a, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xe7df, 0xaebc, 0x6d38, 0x5476, 0x6d1a, 0x961f, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xf4af, 0xf264, 0xfbeb, 0xfefa, 0xefff, 0xefff, 0xffdd, 0xffbf, 0xffff, 0xf7ff, 0xff1a, 0xfd72, 0xfb89, 0xfa01, 0xf940, 0xe940, 0xf368, 0xf4cf, 0xf3eb, 0xfa03, 0xf8e0, 0xf182, 0xfbcb, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbaa, 0xf940, 0xf880, 0xfb08, 0xfdb3, 0xff18, 0xfd70, 0xfb27, 0xf9c3, 0xf961, 0xf980, 0xeb49, 0xfcaf, 0xfe78, 0xffbe, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xfed9, 0xfc4e, 0xf329, 0xfccf, 0xff1a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xefff, 0xc75e, 0xa67c, 0x95fb, 0xa65e, 0xbeff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf4ef, 0xf2c5, 0xfc0b, 0xfeba, 0xefff, 0xefdf, 0xffde, 0xffff, 0xffff, 0xff1a, 0xfdb3, 0xfbcb, 0xfa44, 0xf9a1, 0xf980, 0xfaa6, 0xfcae, 0xfe35, 0xfccf, 0xfa65, 0xf8e0, 0xf182, 0xfbeb, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbaa, 0xf940, 0xf880, 0xfb07, 0xfe15, 0xfffd, 0xff5a, 0xfd31, 0xfb2a, 0xf9c3, 0xf920, 0xf9a1, 0xfaa6, 0xfc8e, 0xfe77, 0xffbd, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xff1a, 0xfcd0, 0xfb6a, 0xfc8e, 0xfe98, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xefff, 0xdfdf, 0xdf9f, 0xe79f, 0xefbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5b, 0xeccf, 0xf307, 0xfc2d, 0xfeba, 0xf7df, 0xf7ff, 0xffdf, 0xffff, 0xff3b, 0xfdb2, 0xfbaa, 0xf9e3, 0xf100, 0xf182, 0xfa65, 0xfcaf, 0xfe77, 0xff9b, 0xfdb3, 0xfaa6, 0xf8c0, 0xf161, 0xfbcb, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbaa, 0xf940, 0xf880, 0xfa86, 0xfdd5, 0xf7ff, 0xffff, 0xfed9, 0xfd12, 0xfb29, 0xf9c1, 0xf900, 0xf981, 0xfac6, 0xfccf, 0xfe97, 0xff9d, 0xf7ff, 0xefff, 0xf7ff, 0xffff, 0xff3b, 0xfd53, 0xfbed, 0xfc6e, 0xfe15, 0xff3c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xf7dd, 0xfe77, 0xf48e, 0xf369, 0xfcb0, 0xfefc, 0xffff, 0xf7ff, 0xfffe, 0xff3b, 0xfdd3, 0xfbca, 0xfa03, 0xf920, 0xf940, 0xf2a7, 0xfc0e, 0xfe57, 0xff9d, 0xfffe, 0xfdf5, 0xfa86, 0xf880, 0xf140, 0xfbaa, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbaa, 0xf940, 0xf880, 0xfa86, 0xfdb5, 0xf7ff, 0xefff, 0xffbe, 0xfeba, 0xfcf1, 0xf347, 0xf960, 0xf940, 0xf981, 0xfae6, 0xfcae, 0xfe77, 0xffbd, 0xf7ff, 0xf7ff, 0xffff, 0xff5c, 0xfdf5, 0xfc8f, 0xfc4e, 0xfd73, 0xfed9, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xf75b, 0xfd73, 0xfc6e, 0xfc0d, 0xfd94, 0xff7e, 0xffff, 0xffde, 0xff3a, 0xfd72, 0xfbcb, 0xfa03, 0xf920, 0xf960, 0xfaa6, 0xfc8f, 0xfe17, 0xff7d, 0xf7ff, 0xf7ff, 0xf5b4, 0xfa65, 0xf8a0, 0xf140, 0xfb8a, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbaa, 0xf940, 0xf880, 0xfaa6, 0xfdb5, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xfeda, 0xfd72, 0xfac7, 0xf1e3, 0xe920, 0xf180, 0xfac6, 0xfcae, 0xfe97, 0xffbd, 0xffff, 0xffff, 0xffbe, 0xf6b8, 0xfd32, 0xfc0e, 0xfcb0, 0xfe16, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xfeb8, 0xfc2e, 0xfc0d, 0xfcf1, 0xfe99, 0xffdf, 0xffff, 0xfef9, 0xfdd3, 0xfb69, 0xfa24, 0xf120, 0xf940, 0xfaa6, 0xfc8e, 0xfe77, 0xff9d, 0xffff, 0xefff, 0xf7ff, 0xf5b4, 0xfa65, 0xf8c0, 0xf981, 0xfbca, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbaa, 0xf940, 0xf880, 0xfae5, 0xfdd4, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xff3b, 0xfd31, 0xf38a, 0xf1e2, 0xf940, 0xf980, 0xfac6, 0xfcae, 0xfe55, 0xffde, 0xffff, 0xffff, 0xffbc, 0xfe35, 0xfc2e, 0xfbed, 0xfcf1, 0xff3d, 0xff9f, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xf7de, 0xf7ff, 0xffff, 0xffdf, 0xffbf, 0xfefb, 0xf594, 0xfb8a, 0xfc4e, 0xfe15, 0xff9d, 0xffde, 0xfefa, 0xfd51, 0xfbca, 0xf9e1, 0xf980, 0xf982, 0xfaa7, 0xfc8f, 0xfe77, 0xff9c, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xfdb4, 0xfa65, 0xf8c0, 0xf9a1, 0xfbeb, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfeb9, 0xfbaa, 0xf940, 0xf880, 0xeb25, 0xfdf4, 0xfffe, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffbf, 0xff3a, 0xfd11, 0xfae7, 0xf9a1, 0xf900, 0xf180, 0xe327, 0xecef, 0xe6fa, 0xff5d, 0xffff, 0xfffe, 0xff18, 0xfcb0, 0xfbad, 0xfc90, 0xe69a, 0xff3d, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xf7fe, 0xf7ff, 0xffff, 0xffbf, 0xff7e, 0xfe78, 0xe4b1, 0xfb89, 0xfd10, 0xff3a, 0xf7ff, 0xef9d, 0xedd5, 0xfb8a, 0xf9e2, 0xf920, 0xf980, 0xfa86, 0xfc2e, 0xfe37, 0xff9d, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xffff, 0xfdb4, 0xfa45, 0xf8a0, 0xf181, 0xfbeb, 0xfefb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xfeb9, 0xfbcc, 0xe981, 0xf8e0, 0xfaa6, 0xfd31, 0xff7d, 0xf7ff, 0xffff, 0xffdf, 0xffde, 0xffff, 0xffdf, 0xf71b, 0xf593, 0xf3a9, 0xf9e2, 0xf960, 0xf9e1, 0xfa83, 0xfc8f, 0xfe58, 0xffbf, 0xefff, 0xefff, 0xf6fa, 0xfd10, 0xfba9, 0xec8e, 0xfdf5, 0xff7b, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffdd, 0xf7ff, 0xefff, 0xf7ff, 0xff7f, 0xfdf8, 0xfcb0, 0xfc6d, 0xfd12, 0xfeb9, 0xffbe, 0xff3b, 0xfdb3, 0xfb89, 0xf9e3, 0xf941, 0xe9a0, 0xf2c6, 0xfcaf, 0xfe98, 0xffbe, 0xffff, 0xffff, 0xffdf, 0xff9e, 0xffff, 0xffff, 0xfdb5, 0xfa66, 0xf8a0, 0xf161, 0xfc0b, 0xf71c, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfed9, 0xfc2d, 0xf1e3, 0xf900, 0xfa65, 0xfcd0, 0xff3b, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffde, 0xfeb8, 0xfd10, 0xfb28, 0xf9c2, 0xf940, 0xf980, 0xf308, 0xfcb0, 0xfe99, 0xf7bf, 0xffff, 0xff9d, 0xfe36, 0xfccf, 0xf3eb, 0xfc8f, 0xfd93, 0xfe78, 0xff1b, 0xff9e, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffbd, 0xff7c, 0xfeda, 0xfe17, 0xfd74, 0xfcb1, 0xfc8f, 0xfd30, 0xfeb9, 0xff3c, 0xff1b, 0xfdb4, 0xf3eb, 0xf223, 0xf140, 0xf940, 0xfb07, 0xfc4d, 0xfdf5, 0xff5b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xfd73, 0xfa46, 0xf8c0, 0xf181, 0xfc2b, 0xf71c, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfefa, 0xfcaf, 0xf265, 0xf960, 0xfa23, 0xfc4d, 0xfeb8, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xfefa, 0xfd32, 0xfb29, 0xf9c2, 0xf940, 0xf960, 0xfac7, 0xfcb0, 0xfe79, 0xffbe, 0xffdf, 0xff7c, 0xf678, 0xfc2d, 0xf3cb, 0xebcb, 0xf48e, 0xfd93, 0xfe77, 0xff3a, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xfeb9, 0xfe16, 0xfcf0, 0xfbec, 0xfb6a, 0xfbcc, 0xfd11, 0xfe96, 0xffbe, 0xfefa, 0xfd73, 0xfb8a, 0xfa02, 0xf140, 0xf180, 0xfa44, 0xfcf0, 0xfe15, 0xff5b, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf77d, 0xf511, 0xfa45, 0xf920, 0xf202, 0xfc6c, 0xf73c, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff3a, 0xfd31, 0xfae7, 0xf9a2, 0xfa23, 0xfbeb, 0xfe15, 0xff7c, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfefb, 0xfd32, 0xfb48, 0xfa02, 0xf8e0, 0xf980, 0xfae7, 0xfcb0, 0xfe58, 0xff9e, 0xffff, 0xef9e, 0xfdd5, 0xf4d0, 0xec0c, 0xf40b, 0xfc6d, 0xfcce, 0xfd50, 0xfdb2, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdf5, 0xfdd4, 0xfdd4, 0xfdd5, 0xfdd5, 0xfdd5, 0xfdd4, 0xfdb4, 0xfdb4, 0xfcf0, 0xfc8f, 0xfbec, 0xfb6a, 0xfbcb, 0xfcf0, 0xfe77, 0xff9c, 0xff1b, 0xf594, 0xfb8a, 0xf9e2, 0xf940, 0xf980, 0xfae6, 0xfc6d, 0xfe78, 0xff5c, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7df, 0xfefa, 0xfc8f, 0xfa44, 0xf960, 0xf284, 0xfced, 0xf75d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5b, 0xfdb3, 0xfb89, 0xf9e3, 0xf9e2, 0xfb48, 0xfd71, 0xff3a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xfed9, 0xfd10, 0xf389, 0xf980, 0xf920, 0xf181, 0xfac7, 0xfc6f, 0xfe58, 0xffbe, 0xf7ff, 0xff7d, 0xfeb9, 0xfdd4, 0xfd30, 0xfc8d, 0xfc0b, 0xfba9, 0xf389, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfae6, 0xfb07, 0xfb07, 0xfb07, 0xfb07, 0xfb07, 0xfb07, 0xfb27, 0xfb27, 0xfbeb, 0xfc4d, 0xfcaf, 0xfd32, 0xfe15, 0xff1a, 0xff9d, 0xf77d, 0xfd93, 0xf3eb, 0xfa02, 0xf940, 0xf960, 0xfaa6, 0xf4af, 0xfe56, 0xf77d, 0xffff, 0xffff, 0xf7ff, 0xf7df, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffbd, 0xfe77, 0xfc0b, 0xfa23, 0xf9a1, 0xf306, 0xfd50, 0xff7d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79c, 0xfe55, 0xfc2c, 0xfa44, 0xf981, 0xfa85, 0xfc8d, 0xfeb7, 0xffde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffbf, 0xf7df, 0xffff, 0xffde, 0xfed8, 0xf593, 0xfb28, 0xf203, 0xe940, 0xf1a1, 0xfac6, 0xfc8f, 0xfe78, 0xffbe, 0xf7ff, 0xffff, 0xff7c, 0xfe98, 0xfd93, 0xfccf, 0xfc2c, 0xfbca, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb06, 0xfb07, 0xfb07, 0xfb07, 0xfb07, 0xfb07, 0xfb07, 0xfb27, 0xfb48, 0xfccf, 0xfd52, 0xfe57, 0xff5c, 0xfffe, 0xfffe, 0xff3b, 0xf5d6, 0xfb89, 0xf223, 0xf140, 0xf980, 0xfaa6, 0xf46f, 0xf678, 0xff9e, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xff3b, 0xfd72, 0xfb47, 0xf9c1, 0xf9e2, 0xeb8a, 0xfdd3, 0xff9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7dd, 0xfef7, 0xfcef, 0xfac7, 0xf920, 0xf1c1, 0xf368, 0xfdd4, 0xff7d, 0xffdf, 0xffdf, 0xffff, 0xf7fe, 0xffff, 0xffbf, 0xffbf, 0xffff, 0xffff, 0xffde, 0xff3c, 0xfd52, 0xf3cb, 0xf223, 0xf960, 0xf9a0, 0xfaa6, 0xfc8e, 0xfe37, 0xff9e, 0xffff, 0xffff, 0xff9e, 0xfefb, 0xfe99, 0xfe57, 0xfe36, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdb4, 0xfdd4, 0xfdd4, 0xfdd4, 0xfdb4, 0xfdd4, 0xfdf5, 0xfdf5, 0xfeb8, 0xfeda, 0xff9e, 0xffff, 0xffff, 0xff1a, 0xfd32, 0xfb6b, 0xf9e3, 0xf140, 0xf980, 0xfae6, 0xfcaf, 0xfe78, 0xff9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xfe57, 0xfc2b, 0xfa22, 0xf980, 0xfa65, 0xfc4e, 0xfe36, 0xff9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7fd, 0xff59, 0xfd71, 0xfb28, 0xf900, 0xf140, 0xeaa5, 0xfd10, 0xfefb, 0xffbf, 0xffdf, 0xffdf, 0xeffe, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xfefa, 0xfd52, 0xfb27, 0xf9a0, 0xf940, 0xf180, 0xeae7, 0xfcaf, 0xfeba, 0xff5c, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xff3c, 0xfd93, 0xfb69, 0xf9a2, 0xf941, 0xf940, 0xfa64, 0xfc6d, 0xfe57, 0xffbe, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xff5c, 0xf593, 0xeb07, 0xe940, 0xf960, 0xfac7, 0xfcf1, 0xfeb9, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xfe99, 0xe4d1, 0xf221, 0xf9a0, 0xf981, 0xfa86, 0xfcf0, 0xfefa, 0xffbf, 0xff9f, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffdf, 0xff3d, 0xfd94, 0xf369, 0xf1a1, 0xf120, 0xf9c0, 0xfa83, 0xf470, 0xfe37, 0xffbe, 0xffff, 0xefff, 0xefff, 0xfffe, 0xfffd, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xfed9, 0xfd51, 0xfb89, 0xfa02, 0xf920, 0xe9a0, 0xf306, 0xfcef, 0xfe98, 0xffbd, 0xffff, 0xffff, 0xffff, 0xfffd, 0xffdd, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffbf, 0xff1d, 0xfdb2, 0xfbaa, 0xf9c2, 0xf8e0, 0xf9c2, 0xfc2c, 0xfe98, 0xefbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xff1b, 0xf5d5, 0xfb67, 0xfa23, 0xf920, 0xf1c2, 0xf3a9, 0xfdd3, 0xff3c, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfed9, 0xfd31, 0xfb49, 0xf9e2, 0xf960, 0xf980, 0xf2e8, 0xfc8f, 0xfe57, 0xff9d, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffdf, 0xfefa, 0xfd73, 0xfbab, 0xf224, 0xf960, 0xf920, 0xf2e7, 0xfc4d, 0xfe16, 0xff5c, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff5c, 0xfe17, 0xfc4c, 0xf2a5, 0xf161, 0xf981, 0xfae7, 0xfd51, 0xff3b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xff1a, 0xfd30, 0xfb48, 0xf181, 0xf920, 0xf242, 0xebea, 0xfdb2, 0xfed9, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7df, 0xffff, 0xffdf, 0xffbe, 0xffff, 0xffff, 0xffdd, 0xfef9, 0xfd53, 0xfb6a, 0xf9e3, 0xf120, 0xf982, 0xfaa6, 0xfc8e, 0xfe97, 0xffde, 0xffff, 0xffbf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffde, 0xf7ff, 0xfefb, 0xfd73, 0xfb8a, 0xf203, 0xe920, 0xf1a2, 0xfa65, 0xfcf1, 0xfe16, 0xff5c, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xff5a, 0xfdf4, 0xe44e, 0xfa43, 0xf160, 0xe940, 0xfaa6, 0xfcaf, 0xfeb8, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffd, 0xfed8, 0xfcaf, 0xfa65, 0xf940, 0xf960, 0xf242, 0xfba9, 0xfcef, 0xfe58, 0xff3b, 0xffde, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xf7fe, 0xf7ff, 0xf7ff, 0xffff, 0xff1c, 0xfd94, 0xfbab, 0xf265, 0xf960, 0xf9c0, 0xf2e6, 0xfccf, 0xfe78, 0xff5d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xf6fa, 0xf593, 0xfb89, 0xfa02, 0xf940, 0xf1a1, 0xfb49, 0xfcd0, 0xff1b, 0xff9d, 0xffff, 0xf7ff, 0xefff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5b, 0xfe97, 0xfd92, 0xfbeb, 0xf2a6, 0xf900, 0xf920, 0xea24, 0xfc2c, 0xfe56, 0xff9c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xffbd, 0xfdf6, 0xfbcb, 0xfa04, 0xf940, 0xf960, 0xfa02, 0xfac6, 0xf42d, 0xfd72, 0xfed8, 0xff5b, 0xffbd, 0xffff, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff1b, 0xfd52, 0xf3cb, 0xf9e0, 0xf180, 0xf1c0, 0xfae6, 0xfc8f, 0xfe57, 0xffbd, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xf75c, 0xfd51, 0xfbca, 0xfa22, 0xf940, 0xf980, 0xfac6, 0xfcef, 0xfe97, 0xfffe, 0xfffe, 0xfffe, 0xf7fe, 0xf7fe, 0xffff, 0xfffe, 0xfffe, 0xff9f, 0xff7e, 0xfefa, 0xfdd4, 0xfc6e, 0xfb29, 0xfa04, 0xf962, 0xf920, 0xfa03, 0xf3ca, 0xfdd3, 0xff7b, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xff1b, 0xfdb5, 0xfc0d, 0xfaa7, 0xf9c2, 0xf940, 0xf920, 0xe222, 0xfb48, 0xfcae, 0xfd52, 0xfdb4, 0xfdf6, 0xfe37, 0xfe57, 0xfe35, 0xfe37, 0xfe38, 0xfe59, 0xfe99, 0xfe77, 0xfd31, 0xf3cb, 0xfa41, 0xf9c0, 0xf960, 0xf9a1, 0xfac6, 0xfc8e, 0xfdf4, 0xf697, 0xfe57, 0xfe57, 0xfe57, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe36, 0xfe37, 0xfe37, 0xfe36, 0xfe37, 0xfe36, 0xfdf5, 0xf593, 0xfb88, 0xfa83, 0xf960, 0xf940, 0xf9e1, 0xfb27, 0xfccf, 0xfe14, 0xfe76, 0xfe76, 0xfe76, 0xfe55, 0xfe76, 0xfe96, 0xfe56, 0xfe14, 0xfd95, 0xfd73, 0xfcd0, 0xfbaa, 0xf265, 0xf141, 0xf900, 0xf961, 0xfa87, 0xfbec, 0xfd93, 0xff19, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xff7d, 0xfe99, 0xfd12, 0xfb8a, 0xf224, 0xf180, 0xe980, 0xf202, 0xfa85, 0xfac7, 0xfac8, 0xfae9, 0xfb09, 0xfb29, 0xf307, 0xfb29, 0xfb09, 0xfb09, 0xfb6a, 0xfb8a, 0xfb28, 0xfa85, 0xf9e3, 0xf981, 0xf960, 0xf960, 0xf9a0, 0xfa84, 0xfb48, 0xf36a, 0xfb49, 0xfb49, 0xfb49, 0xfb49, 0xfb49, 0xfb49, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xf329, 0xfb49, 0xfb49, 0xfb29, 0xfb49, 0xfb49, 0xfb28, 0xf2c7, 0xfa01, 0xf9a0, 0xf940, 0xf940, 0xf9a1, 0xfa24, 0xfae7, 0xfb69, 0xfb49, 0xfb49, 0xfb49, 0xfb28, 0xfb28, 0xfb49, 0xfb49, 0xf328, 0xfae8, 0xfae7, 0xf284, 0xfa22, 0xf9a1, 0xe940, 0xe9c2, 0xfb06, 0xfcb1, 0xfe36, 0xff5b, 0xf7dd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffde, 0xffff, 0xf7ff, 0xf7ff, 0xf6da, 0xfd52, 0xfbca, 0xfb05, 0xfa42, 0xf9e2, 0xf961, 0xf921, 0xf901, 0xf8e0, 0xf8e0, 0xf8e0, 0xe920, 0xf920, 0xf8e0, 0xf8a0, 0xf8c0, 0xf100, 0xf920, 0xf920, 0xf8e2, 0xf8e0, 0xf940, 0xf960, 0xf940, 0xf940, 0xf961, 0xf921, 0xf920, 0xf920, 0xf920, 0xf920, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf920, 0xf920, 0xf920, 0xf920, 0xf920, 0xf940, 0xf940, 0xf900, 0xf900, 0xf940, 0xf960, 0xf941, 0xf921, 0xf900, 0xf900, 0xf900, 0xf900, 0xf901, 0xf8e0, 0xf8a0, 0xf8a0, 0xf8c0, 0xf900, 0xf921, 0xf940, 0xf160, 0xf160, 0xf9c0, 0xfa02, 0xfa43, 0xf387, 0xfd2e, 0xfe99, 0xffbe, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xff5c, 0xf658, 0xed96, 0xfba9, 0xfb27, 0xf284, 0xf1e2, 0xf181, 0xf940, 0xf900, 0xf8c0, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf940, 0xf940, 0xf940, 0xf940, 0xf940, 0xf920, 0xf921, 0xf921, 0xe980, 0xf940, 0xf8e0, 0xf8c0, 0xf8e0, 0xf920, 0xf900, 0xf900, 0xf900, 0xf8e0, 0xf8e0, 0xf8e0, 0xf8e0, 0xf900, 0xf900, 0xf920, 0xf941, 0xf920, 0xf900, 0xf920, 0xf920, 0xf8e0, 0xf8e0, 0xf900, 0xf8e0, 0xf900, 0xf920, 0xf920, 0xf920, 0xf940, 0xf940, 0xf920, 0xf900, 0xf920, 0xf940, 0xf940, 0xf940, 0xf940, 0xf920, 0xf8c0, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf900, 0xf960, 0xf9c1, 0xfa64, 0xf308, 0xf3ec, 0xfcf1, 0xfe16, 0xfed9, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xff5c, 0xfefb, 0xfdb3, 0xfd51, 0xfcaf, 0xfc2d, 0xfbcb, 0xfb6a, 0xfb29, 0xfae8, 0xfb49, 0xfb49, 0xfb49, 0xfb49, 0xfb49, 0xfb49, 0xfb49, 0xfb49, 0xf329, 0xf329, 0xf349, 0xfb28, 0xfac6, 0xf9e2, 0xf960, 0xf920, 0xf980, 0xf9a0, 0xfa03, 0xfaa7, 0xfb4a, 0xfbab, 0xfb8a, 0xfb49, 0xf349, 0xfb49, 0xfb29, 0xfb29, 0xfb49, 0xfb49, 0xfb48, 0xfb28, 0xfb08, 0xfb08, 0xfb28, 0xfb49, 0xfb49, 0xfb28, 0xfb29, 0xfb2a, 0xf36a, 0xf308, 0xfa65, 0xf9c2, 0xf940, 0xf940, 0xf960, 0xf9a1, 0xf2a6, 0xfb08, 0xfb69, 0xfb69, 0xfb49, 0xfb49, 0xfb29, 0xfb09, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfb29, 0xfbaa, 0xfbec, 0xfc6e, 0xfd11, 0xfdb4, 0xfe98, 0xff5c, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xfffe, 0xffde, 0xff7c, 0xff3b, 0xfeda, 0xfe99, 0xfe78, 0xfe58, 0xfe37, 0xfe16, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe57, 0xfe35, 0xfd30, 0xfb88, 0xfa02, 0xf960, 0xf960, 0xf9c1, 0xfae7, 0xfc8e, 0xfe14, 0xfeb8, 0xfe79, 0xfe19, 0xfe56, 0xfe56, 0xfe56, 0xfe56, 0xfe56, 0xfe57, 0xfe56, 0xfe16, 0xfe16, 0xfe56, 0xfe77, 0xfe56, 0xfe36, 0xfe36, 0xfe57, 0xfe57, 0xf677, 0xf532, 0xfb8a, 0xfa44, 0xf960, 0xf940, 0xf202, 0xf2c5, 0xed12, 0xfdb4, 0xfe57, 0xfe77, 0xfe36, 0xfe36, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe37, 0xfe98, 0xfeb9, 0xfeda, 0xff3b, 0xff7d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xff1a, 0xfd71, 0xfb88, 0xf263, 0xf960, 0xf9a0, 0xfac6, 0xfcae, 0xfeb7, 0xffbd, 0xffff, 0xffdf, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xff5b, 0xfd93, 0xfb6a, 0xf9e3, 0xf940, 0xf9c1, 0xf327, 0xf48d, 0xf6fb, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xfefa, 0xfd52, 0xf3ec, 0xf9e0, 0xf980, 0xf9c1, 0xfb07, 0xfcef, 0xfe77, 0xff9d, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xefff, 0xefff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xefff, 0xe7ff, 0xf7ff, 0xffff, 0xffbe, 0xff1b, 0xfd51, 0xfbcb, 0xfa03, 0xf940, 0xf980, 0xfac6, 0xfccf, 0xfe96, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9e, 0xffdf, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xfeda, 0xf5b6, 0xfb68, 0xfa43, 0xf140, 0xf960, 0xfa85, 0xfc0c, 0xfdb4, 0xfed9, 0xff7e, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xff1b, 0xfdd5, 0xf4f1, 0xfaa5, 0xf9c1, 0xf120, 0xf960, 0xfaa6, 0xfc6e, 0xfe77, 0xffdd, 0xffdf, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xff9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xff3d, 0xfd72, 0xfbec, 0xfa24, 0xf940, 0xf160, 0xf242, 0xfb69, 0xfc6d, 0xfe37, 0xfefa, 0xffbd, 0xfffd, 0xfffd, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffbe, 0xff7d, 0xfe98, 0xfd31, 0xfbaa, 0xfaa5, 0xf960, 0xf160, 0xf1e2, 0xfb08, 0xfcb0, 0xfe57, 0xff9d, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xfefa, 0xfd73, 0xfb6a, 0xfa23, 0xf180, 0xe960, 0xf1c1, 0xfa65, 0xec2f, 0xfd53, 0xfe57, 0xfed8, 0xf719, 0xff5b, 0xff5b, 0xff3b, 0xf6fa, 0xf6da, 0xf6b9, 0xfe37, 0xf4f1, 0xf348, 0xf1e1, 0xf940, 0xf980, 0xfa02, 0xfb28, 0xfcb0, 0xfe78, 0xffbe, 0xffff, 0xefff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9f, 0xff1c, 0xfe15, 0xfc6c, 0xeaa4, 0xe960, 0xf920, 0xf940, 0xfa64, 0xfae6, 0xfb69, 0xfbec, 0xfc6f, 0xfd12, 0xfd74, 0xfd74, 0xfc4f, 0xfbed, 0xfb8a, 0xfb07, 0xfa64, 0xf1c1, 0xe980, 0xe960, 0xfa24, 0xfb6b, 0xfd53, 0xfeda, 0xf79e, 0xf7df, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xff7c, 0xfe56, 0xfccf, 0xfb49, 0xfa04, 0xf941, 0xf8a0, 0xf8e0, 0xf921, 0xf9a3, 0xfa45, 0xfae8, 0xfb29, 0xfb29, 0xf284, 0xf202, 0xf960, 0xf920, 0xf900, 0xf980, 0xfa42, 0xfb05, 0xf4ce, 0xfdd3, 0xff19, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffdf, 0xff7c, 0xfeb8, 0xfd93, 0xfbec, 0xf2a6, 0xf960, 0xf920, 0xf100, 0xf140, 0xf9a0, 0xfa00, 0xfa00, 0xf200, 0xf1e1, 0xf960, 0xf8e0, 0xf8c0, 0xf921, 0xfa45, 0xfbeb, 0xfd10, 0xef1a, 0xf77b, 0xf7dd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xf7ff, 0xfffd, 0xff9b, 0xfe75, 0xed50, 0xfbca, 0xf348, 0xf2e6, 0xf2c5, 0xfaa4, 0xf262, 0xfa21, 0xfa41, 0xeaa4, 0xf2a4, 0xfac6, 0xfb28, 0xfbcc, 0xf4d1, 0xf637, 0xff5b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xff7d, 0xfeba, 0xfe57, 0xfe16, 0xfdb5, 0xfd53, 0xfcb0, 0xfbed, 0xfb8b, 0xfbac, 0xfc4e, 0xfcaf, 0xfd51, 0xfdf4, 0xfe77, 0xfeda, 0xff5d, 0xffdf, 0xf7df, 0xf7df, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xefff, 0xf7ff, 0xffff, 0xff9d, 0xf6da, 0xf638, 0xf5d6, 0xfdd6, 0xfe7b, 0xfedc, 0xff5d, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xfffe, 0xffdc, 0xffdc, 0xfffc, 0xfffc, 0xffbc, 0xffdd, 0xfffd, 0xfffd, 0xffdd, 0xffbc, 0xffbc, 0xff9c, 0xf7ff, 0xffff, 0xfffe, 0xfffe, 0xfffd, 0xffde, 0xffbe, 0xffbf, 0xff7a, 0xff9b, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
  };
  const unsigned short  heart1[] PROGMEM = {
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xef5d, 0xe6fb, 0xd69a, 0xce39, 0xc618, 0xce39, 0xce38, 0xce18, 0xce39, 0xd67a, 0xe6fb, 0xf75d, 0xff9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf79e, 0xef5d, 0xe71c, 0xd659, 0xd659, 0xd659, 0xd659, 0xd659, 0xd659, 0xd659, 0xd659, 0xef7d, 0xf79e, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xfeda, 0xe5b6, 0xd491, 0xe40f, 0xeb8d, 0xf2ca, 0xfa28, 0xfa08, 0xf1e8, 0xf1e8, 0xf1e8, 0xea49, 0xeacb, 0xeb8d, 0xec2e, 0xec90, 0xe555, 0xfedb, 0xfffe, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xff9f, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xe7ff, 0xf7ff, 0xff9f, 0xfe7b, 0xed36, 0xe432, 0xebb1, 0xebb0, 0xf229, 0xea09, 0xe1e8, 0xd9c7, 0xd9c7, 0xe1e8, 0xe208, 0xe229, 0xe430, 0xe491, 0xdcf2, 0xe5f6, 0xff7c, 0xfffe, 0xefff, 0xe7ff, 0xf7ff, 0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xfedb, 0xe577, 0xdc93, 0xe38f, 0xdaed, 0xd26a, 0xda4a, 0xea49, 0xf1e8, 0xf1a7, 0xf9a7, 0xea08, 0xe9e7, 0xe1c7, 0xd9c7, 0xd9c7, 0xd208, 0xca48, 0xca68, 0xc2ab, 0xd3cf, 0xdcf3, 0xe617, 0xf75c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xf6ba, 0xedf7, 0xdcd3, 0xd3af, 0xd2cc, 0xd24a, 0xd209, 0xd9e8, 0xe1e8, 0xe1c7, 0xd9c7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9c7, 0xd9c7, 0xc1e8, 0xc229, 0xb229, 0xb2cb, 0xcc31, 0xd514, 0xe5f7, 0xfefb, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffde, 0xf71b, 0xedd6, 0xec51, 0xeaed, 0xea4b, 0xfa09, 0xf1e9, 0xf1c8, 0xf1e8, 0xf1e8, 0xf208, 0xf1e8, 0xe9c7, 0xe248, 0xea28, 0xea08, 0xe9e8, 0xe9a7, 0xe1a7, 0xd9a7, 0xd9a7, 0xd146, 0xd1a7, 0xc229, 0xcb0d, 0xd4b2, 0xe618, 0xef1c, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xf7df, 0xf7ff, 0xffff, 0xffde, 0xfeb9, 0xe5b5, 0xfbef, 0xeb4d, 0xda69, 0xd9e7, 0xe1c7, 0xf1c7, 0xf1c6, 0xe9a6, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd986, 0xd186, 0xd186, 0xd946, 0xd967, 0xc946, 0xc146, 0xc1e9, 0xca8b, 0xdb6f, 0xfc94, 0xee7a, 0xf73c, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xff7d, 0xf617, 0xdc71, 0xdb2c, 0xe26a, 0xfa49, 0xfa4a, 0xfa48, 0xfa69, 0xfa69, 0xf248, 0xf248, 0xea69, 0xe248, 0xda27, 0xe228, 0xe208, 0xe9e8, 0xf1c8, 0xf1c8, 0xf1c8, 0xf1a8, 0xf1c8, 0xe986, 0xe986, 0xd966, 0xc987, 0xc22a, 0xc32d, 0xccb3, 0xe638, 0xff7f, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xff3c, 0xf5f7, 0xe430, 0xd2ab, 0xf208, 0xe9e8, 0xe9a7, 0xf186, 0xf9a6, 0xf9a6, 0xf1c5, 0xf1c5, 0xe1a7, 0xe1a7, 0xe1a7, 0xe1c7, 0xd9a7, 0xd9a7, 0xd986, 0xd186, 0xe126, 0xe966, 0xe166, 0xd946, 0xd167, 0xc967, 0xd1a8, 0xe26b, 0xbb4d, 0xd4d3, 0xf6da, 0xfffe, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfeda, 0xf575, 0xe3af, 0xe28b, 0xf229, 0xfa69, 0xfaa9, 0xfaa9, 0xf2a8, 0xfae9, 0xfae9, 0xf2c9, 0xeaa9, 0xf2ca, 0xf2ca, 0xea89, 0xf228, 0xf228, 0xf1e8, 0xf1c8, 0xf1a7, 0xe9a7, 0xe9a7, 0xe9a7, 0xd9a5, 0xe9c6, 0xe9a6, 0xe167, 0xd967, 0xc188, 0xc26b, 0xdbaf, 0xe619, 0xf6fc, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefdf, 0xf7ff, 0xffff, 0xf6da, 0xe513, 0xdb4e, 0xea2a, 0xf188, 0xe9a8, 0xf1c8, 0xf1c8, 0xf1a7, 0xe9a7, 0xe1a6, 0xe1c6, 0xd9e6, 0xe1c8, 0xe1c7, 0xe1c7, 0xe1a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd145, 0xd165, 0xd165, 0xd166, 0xc966, 0xc125, 0xb925, 0xc166, 0xb167, 0xc2cb, 0xdcb2, 0xe658, 0xef7c, 0xf7fe, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffbd, 0xfefb, 0xe40f, 0xe36d, 0xeaab, 0xfa4a, 0xfa8a, 0xfaca, 0xfb0a, 0xeb09, 0xf309, 0xfb2a, 0xfb2b, 0xfb0a, 0xfaea, 0xfb0b, 0xfb0b, 0xfaeb, 0xfaca, 0xfa8a, 0xfa49, 0xf208, 0xf1e8, 0xe9e7, 0xe1e7, 0xe1e7, 0xd1e5, 0xd9c6, 0xe1a6, 0xe166, 0xe167, 0xd946, 0xd147, 0xd1c9, 0xbb6e, 0xd4b2, 0xf658, 0xff9d, 0xffff, 0xf7ff, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf77d, 0xee17, 0xdc50, 0xdacb, 0xe1e8, 0xf988, 0xf9a9, 0xe9e9, 0xea09, 0xea09, 0xe9e9, 0xe9e8, 0xe1e8, 0xda08, 0xda28, 0xe1c7, 0xe1a7, 0xe1a7, 0xd987, 0xd986, 0xd986, 0xd986, 0xd986, 0xd1e7, 0xc9c6, 0xc185, 0xc1a5, 0xc1a6, 0xc185, 0xb965, 0xb985, 0xc146, 0xc187, 0xc26a, 0xc3ae, 0xd554, 0xf71b, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffbe, 0xfe59, 0xdcd3, 0xe269, 0xf28a, 0xfacb, 0xfaeb, 0xfaeb, 0xfb0b, 0xfb4b, 0xfb6b, 0xfb2b, 0xfb4c, 0xfb4c, 0xfb2c, 0xfb2b, 0xfb2b, 0xfb2b, 0xfb2b, 0xfb0a, 0xf2ea, 0xf2a9, 0xf249, 0xea28, 0xea08, 0xe1e8, 0xd9e7, 0xda07, 0xd9e7, 0xd186, 0xd166, 0xd986, 0xd986, 0xd145, 0xd166, 0xb966, 0xc249, 0xd3ef, 0xe5d6, 0xff5c, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xff1c, 0xed75, 0xd36d, 0xda29, 0xe9c7, 0xf1a7, 0xf1a7, 0xe9c8, 0xe208, 0xe208, 0xe9e8, 0xe9e8, 0xe9c8, 0xe1e7, 0xd9c7, 0xd9c7, 0xe9a7, 0xe1a7, 0xe1a7, 0xe187, 0xd986, 0xd986, 0xd986, 0xd966, 0xd1c6, 0xc985, 0xc165, 0xc185, 0xc186, 0xc185, 0xc185, 0xc185, 0xb924, 0xb904, 0xb125, 0xb187, 0xbacc, 0xdd15, 0xff3d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xff1b, 0xdcf4, 0xbaed, 0xfa6a, 0xfa8a, 0xfaeb, 0xf34b, 0xf36c, 0xfb6c, 0xfb6c, 0xfb6c, 0xfb8e, 0xfbae, 0xfbcd, 0xfbcd, 0xfbcd, 0xf3cd, 0xf3ec, 0xf3ec, 0xfbac, 0xfb8c, 0xfb2b, 0xfaca, 0xf289, 0xea49, 0xea08, 0xe208, 0xe1a8, 0xe1c8, 0xd9c7, 0xd1c7, 0xd1e7, 0xd1c6, 0xc985, 0xc985, 0xe145, 0xc945, 0xba08, 0xc3ce, 0xddd7, 0xf73d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xef7d, 0xe4b2, 0xd34d, 0xd9e8, 0xf187, 0xf9a7, 0xf9a7, 0xe1e7, 0xd247, 0xea28, 0xea08, 0xf208, 0xf1e8, 0xf9c7, 0xf1e7, 0xf1e8, 0xf208, 0xe9c8, 0xe9c8, 0xe1c7, 0xe1c7, 0xe1a7, 0xd987, 0xd986, 0xd986, 0xd966, 0xd146, 0xd166, 0xd187, 0xd186, 0xc965, 0xc145, 0xc145, 0xb163, 0xc164, 0xc945, 0xb0a5, 0xa0e6, 0xb2ed, 0xdd97, 0xef3d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7c, 0xe4d2, 0xe289, 0xfa08, 0xfaea, 0xfb0a, 0xfb4b, 0xfb8b, 0xf3ac, 0xf3cc, 0xf40c, 0xf42d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc0d, 0xfbed, 0xf38c, 0xf34b, 0xf30b, 0xf2ca, 0xf269, 0xf248, 0xe9e8, 0xe1c7, 0xd9a7, 0xd987, 0xd987, 0xd987, 0xd987, 0xd967, 0xc967, 0xc967, 0xc966, 0xc1c8, 0xd32d, 0xe555, 0xf71b, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xeffe, 0xffff, 0xff9f, 0xff7f, 0xffff, 0xffff, 0xfe9a, 0xe493, 0xf229, 0xe9e8, 0xe9c7, 0xe9e8, 0xea08, 0xe9e8, 0xe9e8, 0xf208, 0xea28, 0xea28, 0xea48, 0xea48, 0xea48, 0xe248, 0xe227, 0xe227, 0xea07, 0xe1c7, 0xe1a6, 0xd9a6, 0xd9a6, 0xd987, 0xd986, 0xd966, 0xd186, 0xc986, 0xc965, 0xc966, 0xc966, 0xc966, 0xc166, 0xc145, 0xb986, 0xb945, 0xb905, 0xb105, 0xa925, 0x9945, 0xaa89, 0xed12, 0xff9d, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7d, 0xedd6, 0xe3ce, 0xf28a, 0xfa49, 0xfb0a, 0xfb4b, 0xfb6b, 0xfbac, 0xfbcc, 0xfbed, 0xfc2d, 0xfc4d, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc2e, 0xfc0d, 0xfbed, 0xfb8c, 0xfb4b, 0xfb0b, 0xf2aa, 0xea89, 0xea28, 0xea08, 0xe1c7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd987, 0xd987, 0xc987, 0xc966, 0xc946, 0xc166, 0xba28, 0xc3ae, 0xdd95, 0xf71b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfe9a, 0xec93, 0xdaed, 0xf209, 0xe9e8, 0xe9c7, 0xe9e8, 0xf208, 0xf208, 0xf208, 0xf229, 0xf269, 0xf269, 0xf289, 0xf289, 0xf269, 0xea68, 0xea48, 0xe248, 0xea07, 0xe1e7, 0xe1c7, 0xd9a6, 0xd9a7, 0xd987, 0xd986, 0xd966, 0xd186, 0xc986, 0xc965, 0xc966, 0xc966, 0xc166, 0xc166, 0xc145, 0xb986, 0xb945, 0xb925, 0xb905, 0xb125, 0x9924, 0xa207, 0xdc0f, 0xee99, 0xff9d, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf638, 0xe3b0, 0xea8b, 0xfa8a, 0xfaa9, 0xfb4b, 0xfb6b, 0xfbac, 0xfbed, 0xfc0d, 0xfc2d, 0xfc6e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc2e, 0xfbed, 0xfbad, 0xfb6c, 0xf32b, 0xf2ea, 0xf289, 0xea49, 0xe208, 0xe1e7, 0xd9c7, 0xd9a7, 0xd9a7, 0xd987, 0xd1a7, 0xd166, 0xd145, 0xc945, 0xb145, 0xa9e7, 0xc38e, 0xe534, 0xf75c, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xf7ff, 0xf7ff, 0xf69a, 0xec52, 0xe28b, 0xe1a8, 0xf1e8, 0xe9e7, 0xe9e7, 0xf208, 0xf249, 0xf249, 0xfa69, 0xfa6a, 0xf2aa, 0xf2ca, 0xf2ca, 0xf2ca, 0xf2aa, 0xf289, 0xea89, 0xea68, 0xea07, 0xe1e7, 0xe1c7, 0xd9a6, 0xd9a7, 0xd9a7, 0xd986, 0xd966, 0xd186, 0xc985, 0xc965, 0xc966, 0xc966, 0xc166, 0xc166, 0xc145, 0xb145, 0xb945, 0xb925, 0xb905, 0xb125, 0xa0e4, 0xa145, 0xc28a, 0xcc92, 0xee79, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf71b, 0xe4b3, 0xe22b, 0xf9c9, 0xfa8a, 0xf32a, 0xfb6b, 0xfb8c, 0xfbed, 0xfc0d, 0xfc2e, 0xfc6e, 0xfc8e, 0xfc8f, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8f, 0xfc6e, 0xfc6e, 0xfc2e, 0xfc0e, 0xfbcd, 0xf38c, 0xeb4b, 0xf2ea, 0xeaa9, 0xea48, 0xe207, 0xd9e7, 0xd9c7, 0xd9a7, 0xd987, 0xd9c7, 0xd166, 0xd965, 0xd965, 0xc945, 0xb145, 0xb208, 0xcb2d, 0xd5d5, 0xeeda, 0xffde, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xff9f, 0xffff, 0xf7ff, 0xeeb9, 0xec72, 0xea8b, 0xf1c8, 0xf1c7, 0xe9e8, 0xe9e8, 0xf208, 0xf249, 0xfa8a, 0xfaaa, 0xfacb, 0xfacb, 0xfb0b, 0xfb0b, 0xfb0b, 0xf2ea, 0xf2ea, 0xf2a9, 0xeaa9, 0xea89, 0xea28, 0xe207, 0xe1e7, 0xd9c7, 0xd9a7, 0xd9a7, 0xd986, 0xd166, 0xd186, 0xc985, 0xc965, 0xc966, 0xc966, 0xc166, 0xc146, 0xc145, 0xb145, 0xb965, 0xb925, 0xb905, 0xb925, 0xa8e4, 0xa0e4, 0xa966, 0xb2ec, 0xdd34, 0xff7d, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf5d7, 0xe34e, 0xf1c9, 0xf9e9, 0xfaaa, 0xf36b, 0xf38b, 0xfbcc, 0xfc0d, 0xfc2e, 0xfc4e, 0xfc6e, 0xfc8e, 0xfc8f, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xf48f, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc2e, 0xfc0d, 0xf3cc, 0xeb8c, 0xf32b, 0xf2ea, 0xea89, 0xe248, 0xe208, 0xd9c7, 0xd9a7, 0xd987, 0xd986, 0xd165, 0xd965, 0xd985, 0xd165, 0xc125, 0xb966, 0xb9a7, 0xbbee, 0xdd54, 0xff1b, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf6da, 0xe472, 0xea6b, 0xf9a8, 0xf9c7, 0xf207, 0xea08, 0xf228, 0xf269, 0xfaaa, 0xfaeb, 0xfb0b, 0xfb2c, 0xfb2c, 0xf34b, 0xf32b, 0xf32b, 0xf30b, 0xf2ea, 0xf2ca, 0xea89, 0xea89, 0xea28, 0xe207, 0xe1e7, 0xd9c7, 0xd9c7, 0xd9a7, 0xd186, 0xd166, 0xd186, 0xc965, 0xc965, 0xc165, 0xc966, 0xc166, 0xc146, 0xb945, 0xb145, 0xb965, 0xb124, 0xb104, 0xb925, 0xb105, 0xa8e4, 0xa8e4, 0x9946, 0xc3af, 0xee79, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xfefb, 0xec52, 0xea4b, 0xfa09, 0xfa69, 0xfaea, 0xf38b, 0xf3cc, 0xf3ec, 0xfc2d, 0xfc4e, 0xfc6e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8f, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc2e, 0xf3ed, 0xf3cc, 0xfb6b, 0xf32b, 0xeaca, 0xea89, 0xe228, 0xe207, 0xd9c7, 0xd9a6, 0xd186, 0xd166, 0xd165, 0xd965, 0xd145, 0xc925, 0xb925, 0xb925, 0xaa07, 0xcb6d, 0xed96, 0xff5d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff3c, 0xecf4, 0xe2ac, 0xf188, 0xf9a7, 0xfa07, 0xe206, 0xf269, 0xf2a9, 0xfaea, 0xfb0b, 0xfb4b, 0xfb8c, 0xfb8c, 0xfb8c, 0xf36b, 0xf36b, 0xf34b, 0xf32b, 0xeaea, 0xeac9, 0xea89, 0xe268, 0xea28, 0xe207, 0xd9e7, 0xd9c7, 0xd9a7, 0xd9a7, 0xd186, 0xd166, 0xc986, 0xc965, 0xc965, 0xc165, 0xc166, 0xc166, 0xc145, 0xb945, 0xb965, 0xb965, 0xb124, 0xb124, 0xb145, 0xa924, 0xa904, 0xa0e4, 0xa0c4, 0xb26a, 0xd534, 0xf75c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xe5b7, 0xe2ee, 0xf9e9, 0xfa49, 0xfac9, 0xf32a, 0xfb8b, 0xf3ec, 0xf40d, 0xfc4e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8f, 0xfc6f, 0xfc6e, 0xfc4e, 0xfc4e, 0xfc2e, 0xfc0d, 0xf3ed, 0xf38c, 0xf36b, 0xf30a, 0xeaca, 0xea89, 0xea28, 0xe1e8, 0xe1a7, 0xd988, 0xd167, 0xd166, 0xd145, 0xc945, 0xc945, 0xc125, 0xb926, 0xb8e4, 0xb9c7, 0xcb8f, 0xedf8, 0xff9e, 0xffff, 0xffff, 0xffdf, 0xffbe, 0xed96, 0xe30d, 0xf1c9, 0xf9a7, 0xf1e7, 0xea27, 0xea68, 0xf2c9, 0xfb0b, 0xfb6c, 0xfb8c, 0xfb8c, 0xfbcc, 0xf3ec, 0xf3cc, 0xf38c, 0xf38c, 0xf36b, 0xf34b, 0xeb0a, 0xeac9, 0xe289, 0xe268, 0xea28, 0xe207, 0xd9e7, 0xd9c6, 0xd9a6, 0xd1a6, 0xd186, 0xd166, 0xc986, 0xc965, 0xc965, 0xc165, 0xc166, 0xc165, 0xc145, 0xb945, 0xb945, 0xb965, 0xb124, 0xb145, 0xa945, 0xa124, 0xa124, 0xa104, 0xa8a3, 0x9945, 0xb3ae, 0xe679, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xd4d4, 0xe22b, 0xf9c9, 0xfa69, 0xeb09, 0xf36a, 0xfb8b, 0xf40c, 0xf44d, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8f, 0xfc6f, 0xfc6e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc2e, 0xfc0d, 0xfbac, 0xf38c, 0xf34b, 0xf30a, 0xf2aa, 0xea69, 0xe208, 0xe1e7, 0xd9c9, 0xd188, 0xd166, 0xd186, 0xd1a6, 0xc986, 0xc166, 0xb946, 0xd0c4, 0xb8c4, 0xa9e8, 0xcc52, 0xee9b, 0xffbf, 0xffff, 0xffff, 0xeeda, 0xdc11, 0xd9c9, 0xf1a7, 0xfa08, 0xe207, 0xea48, 0xfaeb, 0xf30a, 0xfb6b, 0xfbac, 0xfbac, 0xf3cc, 0xf3ed, 0xf40d, 0xebec, 0xf3ac, 0xf3ac, 0xf38c, 0xf34b, 0xeb0a, 0xeac9, 0xe289, 0xe268, 0xe228, 0xe207, 0xd9e7, 0xd9c6, 0xd1a6, 0xd1a6, 0xd186, 0xc966, 0xc986, 0xc965, 0xc965, 0xc165, 0xc166, 0xc165, 0xc145, 0xb925, 0xb945, 0xb944, 0xb124, 0xb185, 0xa964, 0x9923, 0xa144, 0xa124, 0xb8c4, 0x90c3, 0x9aca, 0xddd7, 0xff9e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xe616, 0xdb6e, 0xe9e9, 0xfa29, 0xf289, 0xfaea, 0xfb6c, 0xfbcd, 0xf40d, 0xfc2d, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4d, 0xfc4d, 0xf44d, 0xfbcc, 0xf3cc, 0xf38b, 0xf34b, 0xeb0a, 0xeaa9, 0xe268, 0xda28, 0xe1c7, 0xd9a6, 0xd186, 0xd166, 0xc966, 0xc966, 0xc145, 0xb945, 0xb964, 0xb8a3, 0xb063, 0xd28c, 0xe556, 0xef5d, 0xf7ff, 0xdf7f, 0xfc2f, 0xeaaa, 0xd9e7, 0xe9e8, 0xf208, 0xf228, 0xf2ca, 0xfb2b, 0xf3ac, 0xfbcc, 0xfbec, 0xfc0d, 0xfc0d, 0xf40d, 0xf40c, 0xf40c, 0xfbcc, 0xf3ac, 0xf36b, 0xeb2b, 0xeaea, 0xeaaa, 0xea69, 0xe249, 0xe228, 0xe207, 0xd9e7, 0xd9c7, 0xd1a7, 0xd187, 0xd166, 0xc966, 0xc966, 0xc966, 0xc966, 0xc166, 0xc166, 0xc145, 0xb945, 0xb945, 0xb145, 0xb125, 0xb125, 0xb125, 0xa925, 0xa924, 0xa924, 0xa924, 0xa143, 0xa8e4, 0xb167, 0xd3b1, 0xf6bb, 0xf7ff, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xdd33, 0xdaec, 0xf1c9, 0xfa49, 0xf2a9, 0xfaea, 0xfb6c, 0xfbcd, 0xfc2d, 0xfc4d, 0xfc6e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc4d, 0xfc4d, 0xf44d, 0xfbec, 0xf3cc, 0xf38c, 0xf34b, 0xeb0a, 0xeaca, 0xe269, 0xda28, 0xe1c7, 0xd9a6, 0xd186, 0xd186, 0xc986, 0xc966, 0xc145, 0xc145, 0xb964, 0xc945, 0xc0a4, 0xc1a8, 0xd3d0, 0xee38, 0xff5d, 0xde39, 0xfb2c, 0xe229, 0xe1c7, 0xf1e8, 0xfa29, 0xfa8a, 0xfb2b, 0xfb8c, 0xfbcc, 0xfbcc, 0xfbed, 0xfc0d, 0xfc2d, 0xf40d, 0xf40c, 0xf40c, 0xfbcc, 0xf3ac, 0xf36b, 0xeb2b, 0xeaea, 0xeaaa, 0xea69, 0xe249, 0xe228, 0xe207, 0xd9c7, 0xd1a6, 0xd1a6, 0xd186, 0xd166, 0xc966, 0xc966, 0xc966, 0xc966, 0xc166, 0xc166, 0xc145, 0xb945, 0xb945, 0xb145, 0xb125, 0xb125, 0xb125, 0xa925, 0xa924, 0xa924, 0xa924, 0xa123, 0xa0e3, 0x9884, 0xa22b, 0xddb7, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef5d, 0xd3ef, 0xda2a, 0xf988, 0xfa4a, 0xfaca, 0xfb0a, 0xfb8c, 0xf3cd, 0xfc2d, 0xfc4e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc4d, 0xfc4d, 0xf44d, 0xfc0d, 0xf3ec, 0xf3ac, 0xf36b, 0xf32b, 0xeaea, 0xe289, 0xe268, 0xe1e7, 0xd9c7, 0xd1a6, 0xd186, 0xc986, 0xc966, 0xc145, 0xc145, 0xb124, 0xc945, 0xc8a4, 0xc0e5, 0xc24a, 0xdc50, 0xf555, 0xdc31, 0xea49, 0xe1c8, 0xe9c7, 0xf209, 0xfa6a, 0xfaeb, 0xfb8c, 0xfbcd, 0xfc0d, 0xfc0d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xf40c, 0xf3ec, 0xf3ac, 0xf38b, 0xeb4b, 0xeb0b, 0xeaea, 0xeaa9, 0xe269, 0xe248, 0xe228, 0xda07, 0xd9c7, 0xd1a6, 0xd1a6, 0xd186, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc166, 0xc146, 0xc145, 0xb945, 0xb945, 0xb145, 0xb125, 0xb125, 0xb125, 0xa925, 0xa924, 0xa924, 0xa924, 0x9903, 0xa904, 0x9863, 0x99a8, 0xdd36, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffde, 0xe69a, 0xdaec, 0xe9a9, 0xf988, 0xfa49, 0xfaca, 0xfb0b, 0xfb8c, 0xf3ed, 0xfc2d, 0xfc4e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc0d, 0xf3ec, 0xf3cc, 0xf38c, 0xf36b, 0xeb0b, 0xeaca, 0xe289, 0xe207, 0xd9e7, 0xd1a6, 0xd186, 0xd186, 0xc966, 0xc966, 0xc945, 0xb945, 0xc925, 0xc8c4, 0xc905, 0xc166, 0xc207, 0xda8a, 0xd228, 0xe9a8, 0xf1c8, 0xf1e8, 0xfa49, 0xfaaa, 0xfb4b, 0xfbad, 0xfbed, 0xfc2d, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc2d, 0xfc2d, 0xf40c, 0xf3ec, 0xf3ac, 0xf38b, 0xeb4b, 0xeb0a, 0xeaca, 0xe289, 0xe249, 0xe228, 0xe207, 0xd9e7, 0xd9c7, 0xd1a6, 0xd186, 0xd186, 0xc966, 0xc946, 0xc966, 0xc966, 0xc966, 0xc166, 0xc146, 0xb945, 0xb945, 0xb945, 0xb145, 0xb125, 0xb125, 0xb125, 0xa925, 0xa924, 0xa924, 0xa924, 0x9903, 0xa904, 0xa0c5, 0xa9c9, 0xd472, 0xf6fb, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xff9e, 0xddb7, 0xe24a, 0xf1a8, 0xf9a8, 0xfa69, 0xfaea, 0xfb0b, 0xfb8c, 0xf3ed, 0xfc2d, 0xfc4e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc4e, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc2d, 0xf40d, 0xf3ec, 0xf3ac, 0xf38c, 0xf34b, 0xeaea, 0xe2c9, 0xe228, 0xda07, 0xd9c7, 0xd1a6, 0xd186, 0xd166, 0xc946, 0xc946, 0xc186, 0xc105, 0xc8e4, 0xd926, 0xc924, 0xc0e3, 0xd145, 0xe165, 0xf187, 0xf9e8, 0xfa29, 0xfa8a, 0xfb0b, 0xfb8c, 0xfbed, 0xfc2d, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc0d, 0xf3ec, 0xf3cc, 0xf38b, 0xeb6b, 0xeb2a, 0xeaea, 0xe2a9, 0xe289, 0xe248, 0xda08, 0xda07, 0xd9e7, 0xd1a6, 0xd186, 0xd186, 0xd166, 0xc966, 0xc946, 0xc966, 0xc966, 0xc166, 0xc166, 0xc145, 0xb945, 0xb945, 0xb945, 0xb145, 0xb125, 0xb125, 0xb125, 0xa925, 0xa924, 0xa924, 0xa924, 0x9944, 0xa0e3, 0xa8c4, 0xa105, 0xaaab, 0xdd76, 0xffbe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xff5d, 0xd4d4, 0xea09, 0xf9a8, 0xf9c8, 0xf268, 0xf2e9, 0xfb2b, 0xfb8d, 0xf40e, 0xfc2d, 0xfc4e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc4e, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xf42d, 0xf42d, 0xf3ed, 0xf3cc, 0xf3ac, 0xf36b, 0xeb0b, 0xe2ea, 0xe248, 0xda28, 0xd9e7, 0xd1a6, 0xd186, 0xd186, 0xd166, 0xd146, 0xc165, 0xc125, 0xc925, 0xd145, 0xd104, 0xd104, 0xe9a6, 0xf1c7, 0xf1c7, 0xfa29, 0xfa8a, 0xfaea, 0xfb6c, 0xfbed, 0xfc2d, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4d, 0xfc0d, 0xf3ec, 0xf3cc, 0xeb8b, 0xeb6b, 0xeb0a, 0xe2ea, 0xe2a9, 0xe269, 0xe228, 0xda07, 0xd9e7, 0xd9c6, 0xd1a6, 0xd186, 0xd186, 0xc966, 0xc966, 0xc946, 0xc966, 0xc966, 0xc166, 0xc146, 0xc145, 0xb945, 0xb945, 0xb945, 0xb145, 0xb125, 0xb125, 0xb125, 0xa925, 0xa924, 0xa924, 0xa924, 0x9924, 0x98c3, 0xa8a3, 0x9883, 0x9987, 0xd4d4, 0xff9e, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffbf, 0xffff, 0xf7fe, 0xffff, 0xff3c, 0xcc32, 0xe9c8, 0xf1a7, 0xf1e8, 0xea88, 0xeae9, 0xfb2b, 0xfb8d, 0xf3ee, 0xfc2d, 0xfc4d, 0xfc6e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xf44d, 0xf42d, 0xf40d, 0xf3cc, 0xf3ac, 0xf36c, 0xeb2b, 0xeaea, 0xe269, 0xe248, 0xd9e7, 0xd1a6, 0xd186, 0xd186, 0xd166, 0xd146, 0xc986, 0xc965, 0xc965, 0xc945, 0xc924, 0xd945, 0xe9c7, 0xf1c7, 0xf228, 0xfa8a, 0xfaca, 0xfb4b, 0xfbed, 0xfc2d, 0xf44d, 0xfcaf, 0xfc6e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc2d, 0xfc0d, 0xf3cc, 0xf3ac, 0xeb6b, 0xeb4a, 0xe30a, 0xe2c9, 0xe289, 0xe268, 0xda28, 0xd9e7, 0xd9e7, 0xd1c6, 0xd186, 0xd186, 0xd186, 0xc966, 0xc946, 0xc945, 0xc966, 0xc166, 0xc146, 0xc146, 0xc145, 0xb945, 0xb945, 0xb945, 0xb145, 0xb125, 0xb125, 0xb125, 0xa925, 0xa924, 0xa924, 0xa924, 0x9904, 0xa0e4, 0xa8c4, 0xa083, 0xa166, 0xd472, 0xff5e, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffbf, 0xffff, 0xf7fe, 0xfffe, 0xff1c, 0xcbd1, 0xe1a7, 0xf1c7, 0xf207, 0xe288, 0xeb09, 0xfb2b, 0xfb8d, 0xf3ee, 0xf40d, 0xfc2d, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc8e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xf44d, 0xf42d, 0xf40d, 0xf3ec, 0xf3ac, 0xeb8c, 0xeb2b, 0xe30a, 0xe289, 0xe248, 0xd9e7, 0xd1c6, 0xd186, 0xd186, 0xd166, 0xd146, 0xc965, 0xc124, 0xc144, 0xc985, 0xc965, 0xd166, 0xe1c7, 0xe9e8, 0xf289, 0xfaca, 0xf32b, 0xfbac, 0xfc2e, 0xfc2d, 0xf42d, 0xfc8e, 0xf46e, 0xf46e, 0xfc6e, 0xfc6e, 0xfc2d, 0xf40d, 0xf3cc, 0xf3ab, 0xeb6b, 0xeb4a, 0xe30a, 0xe2c9, 0xe289, 0xe248, 0xda08, 0xd9e7, 0xd9c7, 0xd1c6, 0xd186, 0xd186, 0xc966, 0xc966, 0xc946, 0xc945, 0xc966, 0xc166, 0xc146, 0xc146, 0xc145, 0xb945, 0xb945, 0xb925, 0xb145, 0xb125, 0xb125, 0xb125, 0xa925, 0xa924, 0xa924, 0xa924, 0x9945, 0xa904, 0xa8a3, 0xa062, 0xa146, 0xcbf1, 0xeedc, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xee37, 0xfaec, 0xe9a7, 0xe9c7, 0xf1e8, 0xf249, 0xf2aa, 0xf30b, 0xf38c, 0xfbcc, 0xfc0d, 0xfc2e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xf44e, 0xf44e, 0xf44e, 0xf44e, 0xf42e, 0xf42e, 0xf42d, 0xf42d, 0xf42d, 0xf40d, 0xf3ed, 0xf3cc, 0xf3ac, 0xf38c, 0xeb4b, 0xeb2a, 0xeaa9, 0xe289, 0xda48, 0xda07, 0xd1c6, 0xd186, 0xd186, 0xd166, 0xd146, 0xc945, 0xc945, 0xd165, 0xd165, 0xd986, 0xe9e7, 0xfa69, 0xf32a, 0xf36b, 0xfbac, 0xfc0d, 0xfc4e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc8f, 0xfc6f, 0xfc6e, 0xfc4e, 0xfc2e, 0xf3ed, 0xf3ac, 0xeb8c, 0xeb2b, 0xeb0a, 0xe2c9, 0xe289, 0xda48, 0xda28, 0xd9e7, 0xd1c7, 0xd186, 0xd186, 0xd186, 0xd166, 0xc966, 0xc966, 0xc966, 0xc966, 0xc146, 0xc146, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb124, 0xb124, 0xb124, 0xa924, 0xa924, 0xa924, 0xa904, 0xa904, 0xb104, 0x9923, 0xa8c2, 0xa0a2, 0xa8a4, 0xc20b, 0xd577, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xfffe, 0xffdf, 0xffff, 0xf7ff, 0xe5f6, 0xea6a, 0xe9a7, 0xe9c7, 0xf1e8, 0xf229, 0xf28a, 0xf30a, 0xf36b, 0xf3cc, 0xfc0d, 0xfc0e, 0xfc2e, 0xfc4e, 0xfc4e, 0xfc4e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xf44e, 0xf44e, 0xf44e, 0xf44e, 0xf42e, 0xf42e, 0xf42e, 0xf42d, 0xf42d, 0xf40d, 0xf3ed, 0xf3cc, 0xf3ac, 0xf38c, 0xeb4b, 0xeb2b, 0xeac9, 0xe289, 0xe248, 0xda07, 0xd1c7, 0xd1a6, 0xd186, 0xd166, 0xd146, 0xc945, 0xc965, 0xd165, 0xd165, 0xd186, 0xea08, 0xfaaa, 0xf34b, 0xfb8b, 0xfbcc, 0xfc0d, 0xfc4e, 0xfc6e, 0xfc8e, 0xfc8e, 0xfc6f, 0xfc6e, 0xfc4e, 0xfc2e, 0xfc0d, 0xf3cd, 0xf38c, 0xeb6b, 0xeb0a, 0xeaea, 0xe2a9, 0xda68, 0xda48, 0xda08, 0xd1e7, 0xd1c7, 0xd186, 0xd186, 0xd186, 0xc986, 0xc966, 0xc966, 0xc966, 0xc165, 0xc146, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb124, 0xb124, 0xb124, 0xa924, 0xa924, 0xa904, 0xa904, 0xa904, 0xb0e4, 0x9923, 0xa8c2, 0xa0a2, 0xa8c4, 0xca0b, 0xd557, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xddb5, 0xd9e8, 0xe1a7, 0xe9c7, 0xf1e8, 0xf229, 0xf269, 0xf2ea, 0xf34b, 0xf38c, 0xfbed, 0xfc0d, 0xfc0e, 0xfc2e, 0xfc2e, 0xfc2e, 0xfc4e, 0xfc6e, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4d, 0xfc4e, 0xfc4e, 0xf42e, 0xf42e, 0xf42e, 0xf42e, 0xf42e, 0xf42d, 0xf40d, 0xf40d, 0xf3ed, 0xf3cc, 0xf3ac, 0xf38c, 0xeb4b, 0xeb2b, 0xeac9, 0xe2a9, 0xe268, 0xda27, 0xd1e7, 0xd1a6, 0xd186, 0xd186, 0xd166, 0xd166, 0xd166, 0xd165, 0xd145, 0xd186, 0xea48, 0xfaeb, 0xfbac, 0xfbcc, 0xfc0d, 0xfc4e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xf42e, 0xf40d, 0xf3ed, 0xf3ac, 0xeb6b, 0xeb4b, 0xeaea, 0xe2ca, 0xe289, 0xda48, 0xda28, 0xda08, 0xd1c7, 0xd1a7, 0xd186, 0xd186, 0xc986, 0xc966, 0xc966, 0xc966, 0xc165, 0xc165, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb124, 0xb124, 0xb124, 0xa924, 0xa924, 0xa904, 0xa904, 0xa904, 0xb0e4, 0x9923, 0xa8c3, 0xa8c3, 0xb0c4, 0xca0b, 0xd536, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xffdf, 0xefbe, 0xcd33, 0xd1a8, 0xe1a7, 0xe9a7, 0xe9e8, 0xf208, 0xf249, 0xf2ca, 0xf32a, 0xf36b, 0xfbac, 0xfbcd, 0xfbed, 0xfc0e, 0xfc0e, 0xfc2e, 0xfc2e, 0xfc4e, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2e, 0xfc2e, 0xfc2e, 0xfc2e, 0xfc2e, 0xf42d, 0xf42d, 0xf42d, 0xf40d, 0xf3ed, 0xf3ed, 0xf3cc, 0xf3ac, 0xf38c, 0xf36b, 0xeb4b, 0xeaea, 0xeac9, 0xe289, 0xda48, 0xd9e7, 0xd1c7, 0xd1a6, 0xd186, 0xd186, 0xd166, 0xd186, 0xd166, 0xd145, 0xd9a6, 0xea69, 0xfb4c, 0xfbed, 0xfc0d, 0xfc2e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xf42d, 0xf40d, 0xf3cd, 0xf3ac, 0xeb4b, 0xe32a, 0xe2c9, 0xe2a9, 0xda68, 0xda28, 0xda07, 0xd9e7, 0xd1c7, 0xd186, 0xc986, 0xc986, 0xc966, 0xc966, 0xc966, 0xc165, 0xc145, 0xc165, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb125, 0xb124, 0xb124, 0xa924, 0xa924, 0xa924, 0xa904, 0xa904, 0xa904, 0xb0e4, 0x9923, 0xa8c3, 0xa8a2, 0xb0a4, 0xc1ea, 0xcd16, 0xf77f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xffdf, 0xe75d, 0xcd13, 0xd9c8, 0xe1a7, 0xe1a7, 0xe9c7, 0xf208, 0xf228, 0xf289, 0xf2ea, 0xf32a, 0xf38c, 0xfbac, 0xfbcd, 0xfbed, 0xfbed, 0xfc0d, 0xfc2e, 0xfc2e, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2d, 0xfc2e, 0xfc0d, 0xfc0d, 0xfc0d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf3ed, 0xf3cc, 0xf3cc, 0xf3ac, 0xf38c, 0xeb4b, 0xeb4b, 0xeaea, 0xeaca, 0xe2a9, 0xda68, 0xda28, 0xd9e7, 0xd1a7, 0xd1a7, 0xd186, 0xd186, 0xd986, 0xd966, 0xd165, 0xd9c6, 0xeaca, 0xfbad, 0xfc2d, 0xfc4e, 0xfc4e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4d, 0xfc4e, 0xfc2e, 0xf40d, 0xf3ed, 0xf3ac, 0xeb8b, 0xeb2a, 0xe30a, 0xe2a9, 0xda68, 0xda48, 0xd207, 0xd1e7, 0xd1c7, 0xd1a6, 0xd186, 0xc966, 0xc966, 0xc966, 0xc966, 0xc165, 0xc165, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xa924, 0xa924, 0xa904, 0xa904, 0xa904, 0xa904, 0xb0e4, 0xa123, 0xa8c3, 0xa8a2, 0xa8a4, 0xc1ca, 0xccd5, 0xef5e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xe75d, 0xcd13, 0xd9e8, 0xe1a7, 0xe1a7, 0xe9c7, 0xe9e8, 0xf228, 0xf269, 0xf2c9, 0xf2ea, 0xf34b, 0xf36b, 0xfb8c, 0xfbac, 0xfbcd, 0xf3ed, 0xfc0d, 0xfc0d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3cc, 0xf3cc, 0xebac, 0xf3ac, 0xf38c, 0xeb4b, 0xeb2b, 0xeaea, 0xeaca, 0xe2a9, 0xe269, 0xda48, 0xda08, 0xd1c7, 0xd1c7, 0xd1a7, 0xd186, 0xd986, 0xd966, 0xd986, 0xda07, 0xf30a, 0xfbed, 0xfc4e, 0xfc4e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4d, 0xf44d, 0xfc4e, 0xfc2e, 0xf3ed, 0xf3cc, 0xf3ac, 0xeb4b, 0xe30a, 0xdac9, 0xda68, 0xda48, 0xd207, 0xd1e7, 0xd1c7, 0xd1a6, 0xd186, 0xd166, 0xc966, 0xc966, 0xc966, 0xc165, 0xc165, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb125, 0xb124, 0xa924, 0xa924, 0xa924, 0xa924, 0xa904, 0xa904, 0xa904, 0xa904, 0xb0e4, 0xa103, 0xa8c3, 0xa8a2, 0xb0a4, 0xc1aa, 0xccd5, 0xef5e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xefbe, 0xd554, 0xd9c8, 0xd9a7, 0xe1a7, 0xe9c7, 0xe9c7, 0xea08, 0xea48, 0xf289, 0xf2c9, 0xf32a, 0xf34b, 0xf36c, 0xf38c, 0xf3ac, 0xf3cc, 0xf3ed, 0xfbed, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xebec, 0xebcc, 0xebac, 0xebac, 0xf38c, 0xf36b, 0xeb4b, 0xeb2a, 0xeaea, 0xe2ea, 0xe2a9, 0xe289, 0xda48, 0xda28, 0xd9e7, 0xd9e7, 0xd1c7, 0xd1a6, 0xd966, 0xe166, 0xe1a6, 0xe228, 0xf32b, 0xfc0e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xf44d, 0xf42d, 0xf42d, 0xf40d, 0xf3cc, 0xebac, 0xeb6b, 0xe32a, 0xdac9, 0xdaa8, 0xda47, 0xda27, 0xd1e7, 0xd1c6, 0xd1a6, 0xd186, 0xd166, 0xd146, 0xc966, 0xc966, 0xc165, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb124, 0xb124, 0xa924, 0xa924, 0xa924, 0xa904, 0xa904, 0xa904, 0xa904, 0xa904, 0xb0c4, 0xa103, 0xb0c3, 0xa8a2, 0xb0a4, 0xc9ca, 0xd516, 0xff9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xdd95, 0xd187, 0xd9a7, 0xe1a7, 0xe9c7, 0xe9c7, 0xe9e8, 0xea28, 0xea89, 0xf2c9, 0xeb0a, 0xf32b, 0xf34b, 0xf38c, 0xf38c, 0xf3ac, 0xf3cd, 0xfbed, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf40d, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xf3ed, 0xebcc, 0xebcc, 0xebac, 0xebac, 0xeb8c, 0xf36b, 0xeb4b, 0xeb2a, 0xe2ea, 0xe2ea, 0xe2c9, 0xe289, 0xe269, 0xda28, 0xda08, 0xd9e8, 0xd1c7, 0xd1a6, 0xd966, 0xe166, 0xe1a7, 0xe248, 0xf34b, 0xfc0e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4d, 0xfc2d, 0xf42d, 0xf40d, 0xf3ed, 0xebac, 0xeb8b, 0xeb4b, 0xe30a, 0xdaa9, 0xd288, 0xda27, 0xd207, 0xd1e6, 0xd1c6, 0xd1a6, 0xd186, 0xd166, 0xc946, 0xc966, 0xc165, 0xc165, 0xc165, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xa924, 0xa924, 0xa924, 0xa904, 0xa904, 0xa904, 0xa904, 0xa904, 0xb0c4, 0xa103, 0xb0c3, 0xa8c3, 0xb0c5, 0xca0b, 0xdd57, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xf7ff, 0xf7bf, 0xffdf, 0xffff, 0xf7fe, 0xe5f6, 0xba6a, 0xe166, 0xe186, 0xe1c7, 0xe9e7, 0xea07, 0xe1e7, 0xea07, 0xf248, 0xeaaa, 0xf2ca, 0xf2ca, 0xf30b, 0xf32b, 0xf34c, 0xf36c, 0xfb8c, 0xf3ad, 0xf3ad, 0xf3ad, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xf3cd, 0xebac, 0xebac, 0xebac, 0xeb8c, 0xeb6c, 0xeb4b, 0xeb4b, 0xe32b, 0xeaea, 0xeaea, 0xe2ca, 0xe2a9, 0xe269, 0xda48, 0xda48, 0xda28, 0xd1e7, 0xd9e7, 0xd9e7, 0xd1e7, 0xd207, 0xe2a8, 0xf36b, 0xfc2d, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc6e, 0xfc4e, 0xfc2e, 0xf40d, 0xf40d, 0xf3ec, 0xebac, 0xeb6b, 0xeb2a, 0xeaea, 0xeaa9, 0xe269, 0xe248, 0xd9c8, 0xd9c7, 0xd1a7, 0xd186, 0xd186, 0xc986, 0xc986, 0xc966, 0xc146, 0xc146, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb145, 0xb145, 0xb145, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xa924, 0xa924, 0xa924, 0xa924, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0c4, 0xa123, 0xa901, 0xc062, 0xc8a6, 0xca8f, 0xddb8, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7fe, 0xf658, 0xcb2e, 0xe187, 0xe1a7, 0xe9c7, 0xe9e7, 0xe1e7, 0xe1e7, 0xea07, 0xf248, 0xea89, 0xea89, 0xeaa9, 0xeaea, 0xf30b, 0xf32b, 0xf34b, 0xf36c, 0xf38c, 0xf38c, 0xf38c, 0xf38c, 0xebac, 0xebac, 0xebac, 0xebac, 0xf3ac, 0xf3ac, 0xf3ac, 0xf3ac, 0xf3ac, 0xf3ac, 0xf3ac, 0xf3ac, 0xebac, 0xeb8c, 0xeb8c, 0xeb8c, 0xeb6b, 0xeb4b, 0xe32a, 0xe32a, 0xeaea, 0xeaca, 0xe2ca, 0xe2a9, 0xe289, 0xda48, 0xda48, 0xda28, 0xda07, 0xda07, 0xda07, 0xd9e7, 0xda27, 0xe2a9, 0xf38b, 0xfc2d, 0xfc4e, 0xfc4e, 0xfc6e, 0xfc4e, 0xfc2e, 0xf40d, 0xf3ed, 0xf3ed, 0xebac, 0xeb8b, 0xe34a, 0xe30a, 0xe2c9, 0xe289, 0xda28, 0xda08, 0xd9c7, 0xd9a7, 0xd186, 0xd186, 0xc986, 0xc986, 0xc966, 0xc165, 0xc146, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb145, 0xb145, 0xb145, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xa924, 0xa924, 0xa924, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e3, 0xb0e4, 0xa103, 0xa8e2, 0xc063, 0xc8e8, 0xd331, 0xe63a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfefa, 0xdc11, 0xe1a7, 0xe1c7, 0xe1e7, 0xe1e7, 0xe1c7, 0xe1e7, 0xea07, 0xea28, 0xe248, 0xe248, 0xea69, 0xeaa9, 0xeaca, 0xeb0a, 0xf30b, 0xf32b, 0xeb4b, 0xeb4b, 0xeb4b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb8c, 0xeb8c, 0xeb8c, 0xeb8c, 0xeb8c, 0xeb8c, 0xeb8c, 0xeb8c, 0xeb8c, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb4b, 0xeb4b, 0xe32a, 0xe30a, 0xe30a, 0xeaea, 0xe2ca, 0xe2aa, 0xe2a9, 0xe289, 0xe269, 0xda48, 0xda48, 0xda28, 0xda28, 0xe228, 0xda07, 0xda48, 0xe2c9, 0xf38b, 0xfc0d, 0xf44e, 0xfc4e, 0xfc4e, 0xfc2e, 0xf40d, 0xf3ed, 0xebcc, 0xebac, 0xeb6b, 0xe34a, 0xe30a, 0xe2c9, 0xda89, 0xda48, 0xda07, 0xd1c7, 0xd9a7, 0xd187, 0xc986, 0xc966, 0xc966, 0xc966, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb145, 0xb145, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xa924, 0xa924, 0xb104, 0xb104, 0xb104, 0xb0e3, 0xb0e3, 0xb0e3, 0xb8e4, 0xa902, 0xb0e2, 0xc083, 0xd149, 0xe3f3, 0xf6bc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffde, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xff5c, 0xdc93, 0xd9c7, 0xd9c7, 0xe1c7, 0xe1c7, 0xe1a7, 0xe1c7, 0xea07, 0xe207, 0xe207, 0xe228, 0xe248, 0xe269, 0xea89, 0xeaca, 0xeaea, 0xeaea, 0xeb0a, 0xeb0a, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb4b, 0xeb4b, 0xeb4b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb4b, 0xeb4b, 0xeb4b, 0xeb4b, 0xeb2b, 0xe30a, 0xe2ea, 0xe2ea, 0xe2ca, 0xe2ca, 0xe2aa, 0xe289, 0xe269, 0xe269, 0xda48, 0xda48, 0xda28, 0xe248, 0xe248, 0xe228, 0xe268, 0xeae9, 0xf38b, 0xfc0d, 0xfc2e, 0xfc2e, 0xfc0d, 0xfc0d, 0xf3ed, 0xf3ac, 0xeb8b, 0xeb6b, 0xeb2a, 0xe30a, 0xe2c9, 0xda89, 0xda48, 0xd207, 0xd1c7, 0xc9a6, 0xd1a7, 0xd186, 0xc966, 0xc966, 0xc966, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb125, 0xb145, 0xb145, 0xb125, 0xb124, 0xb124, 0xb124, 0xa904, 0xa904, 0xa924, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e3, 0xb0e3, 0xb0e3, 0xb8e4, 0xa8e2, 0xb0c2, 0xc084, 0xc96a, 0xe475, 0xff3e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf77d, 0xccf4, 0xd1e7, 0xd1a7, 0xd9c7, 0xe1c7, 0xe1a6, 0xe1c7, 0xe207, 0xd9e7, 0xe1e7, 0xe207, 0xe228, 0xe248, 0xe269, 0xea89, 0xeaa9, 0xeaca, 0xeaea, 0xeaea, 0xeaea, 0xeaea, 0xeb0a, 0xeb0a, 0xeb0a, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb2b, 0xeb0a, 0xeb0a, 0xe2ea, 0xe2ca, 0xe2a9, 0xe2a9, 0xe289, 0xe289, 0xda69, 0xda48, 0xda48, 0xda48, 0xe248, 0xe248, 0xe248, 0xe248, 0xe269, 0xeae9, 0xeb6b, 0xf3cc, 0xfc0d, 0xf40d, 0xf3ed, 0xf3ed, 0xf3ac, 0xeb8b, 0xeb6b, 0xe34a, 0xe2ea, 0xe2c9, 0xda89, 0xda48, 0xda28, 0xd1e7, 0xd1a7, 0xc986, 0xd186, 0xc986, 0xc965, 0xc165, 0xc165, 0xc165, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xa904, 0xa904, 0xb104, 0xb104, 0xb104, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0c3, 0xb0c2, 0xb8c3, 0xc0a5, 0xc1ab, 0xd4b6, 0xf75e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xf79d, 0xcd76, 0xda89, 0xc9c7, 0xd1a7, 0xe1c7, 0xe187, 0xe1c7, 0xe207, 0xd1c6, 0xe1e7, 0xe1e7, 0xe207, 0xe228, 0xe248, 0xe268, 0xe269, 0xe289, 0xe2a9, 0xeaa9, 0xe2a9, 0xeac9, 0xeaca, 0xeaea, 0xeaea, 0xeaea, 0xe2ea, 0xe2ea, 0xe2ea, 0xe2ea, 0xe2ea, 0xe2ea, 0xe2ea, 0xe2ea, 0xe30a, 0xe30a, 0xeb0a, 0xeb0a, 0xeaea, 0xeaca, 0xe2c9, 0xe2c9, 0xe289, 0xda89, 0xda89, 0xda69, 0xda68, 0xda48, 0xda48, 0xda48, 0xda28, 0xe228, 0xe248, 0xe248, 0xe269, 0xe2c9, 0xeb4a, 0xebab, 0xf3cc, 0xf3cc, 0xf3ac, 0xf3ac, 0xeb6b, 0xeb4b, 0xe32a, 0xe30a, 0xe289, 0xe269, 0xda48, 0xda28, 0xd1e7, 0xd1c7, 0xc9a6, 0xc966, 0xc986, 0xc966, 0xc165, 0xc145, 0xc165, 0xc165, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb125, 0xb124, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xa904, 0xa904, 0xa904, 0xb104, 0xb104, 0xb104, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0c3, 0xb0c2, 0xc0c4, 0xc8c7, 0xca2e, 0xd538, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xf7df, 0xde59, 0xeb4c, 0xd228, 0xd1a7, 0xe1c8, 0xe187, 0xe1a7, 0xe1e7, 0xd1e6, 0xe1c7, 0xe1c7, 0xe1e7, 0xe207, 0xe207, 0xe228, 0xe248, 0xe248, 0xe268, 0xe268, 0xe269, 0xe289, 0xe289, 0xe2a9, 0xe2a9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2ea, 0xe2ca, 0xe2c9, 0xe2c9, 0xe2a9, 0xe289, 0xe289, 0xda89, 0xda89, 0xda69, 0xda68, 0xda48, 0xda48, 0xda48, 0xda28, 0xda28, 0xda28, 0xe228, 0xe248, 0xe268, 0xe2c9, 0xe32a, 0xe36b, 0xeb6b, 0xeb6b, 0xeb6b, 0xeb4b, 0xeb2a, 0xe30a, 0xe2e9, 0xdac9, 0xe248, 0xda28, 0xda07, 0xd1e7, 0xd1c7, 0xd1a7, 0xc986, 0xc966, 0xc986, 0xc966, 0xc145, 0xc145, 0xc165, 0xc165, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb124, 0xb124, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xa904, 0xa904, 0xa904, 0xb104, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0c3, 0xb0c3, 0xb8e3, 0xb8c2, 0xc0a4, 0xd128, 0xdb11, 0xe5fa, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffde, 0xf7ff, 0xf7ff, 0xffdf, 0xffbf, 0xf7ff, 0xffff, 0xef1c, 0xfbef, 0xd269, 0xd1a7, 0xe1c8, 0xe187, 0xe186, 0xd9e7, 0xd1e7, 0xe1c7, 0xe1c7, 0xe1c7, 0xe1e7, 0xd9e7, 0xda07, 0xda07, 0xda07, 0xe228, 0xe248, 0xe248, 0xe268, 0xe268, 0xe289, 0xe289, 0xe289, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xe2c9, 0xdaa9, 0xe2a9, 0xe2a9, 0xe2a9, 0xe2a9, 0xe289, 0xda68, 0xe268, 0xda68, 0xda68, 0xda68, 0xda48, 0xda48, 0xda48, 0xda28, 0xda28, 0xda08, 0xda08, 0xe228, 0xe228, 0xe268, 0xe2a9, 0xe309, 0xe34a, 0xe34a, 0xe34a, 0xe32a, 0xe32a, 0xe30a, 0xe2e9, 0xdaa9, 0xdaa8, 0xda08, 0xda07, 0xd1e7, 0xd1c7, 0xd1a7, 0xc986, 0xc966, 0xc146, 0xc986, 0xc966, 0xc145, 0xc145, 0xc165, 0xc165, 0xb965, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xa904, 0xa904, 0xa904, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0c3, 0xb0c3, 0xb8e3, 0xb8c3, 0xc0a4, 0xd96a, 0xebb4, 0xee7c, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xd533, 0xca29, 0xe146, 0xe1e7, 0xc9e5, 0xd1c6, 0xe1a7, 0xe187, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9c7, 0xd9c7, 0xe1c7, 0xe1c7, 0xe1e7, 0xe208, 0xe208, 0xe208, 0xe228, 0xe228, 0xe248, 0xe248, 0xe249, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xe269, 0xda28, 0xda28, 0xda08, 0xda08, 0xda08, 0xda08, 0xda08, 0xd208, 0xda27, 0xda07, 0xda07, 0xda27, 0xda28, 0xe248, 0xe289, 0xea89, 0xe2ca, 0xeaca, 0xe2a9, 0xe2a9, 0xe269, 0xda48, 0xda28, 0xda07, 0xd9c7, 0xd1c7, 0xd1a7, 0xc9a6, 0xc986, 0xc986, 0xc166, 0xc165, 0xc146, 0xc146, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xa924, 0xa924, 0xa924, 0xa924, 0xb104, 0xb104, 0xb104, 0xb104, 0xa904, 0xb104, 0xb0e3, 0xb0e3, 0xb0e3, 0xb0e3, 0xb8c3, 0xb8c3, 0xb143, 0xc0c4, 0xd0a6, 0xd20c, 0xdcd5, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xddb5, 0xc26a, 0xd926, 0xd9a6, 0xc9a5, 0xd9a5, 0xe1a7, 0xd9a7, 0xd9a6, 0xd9a7, 0xd9a7, 0xd9c7, 0xd9c7, 0xe1c7, 0xe1c7, 0xe1c7, 0xe1e7, 0xe1e7, 0xe1e7, 0xe208, 0xe208, 0xe228, 0xe228, 0xe228, 0xda48, 0xda48, 0xda48, 0xda48, 0xda48, 0xda48, 0xe248, 0xe248, 0xe248, 0xe248, 0xda48, 0xda48, 0xda48, 0xda48, 0xda48, 0xda48, 0xda08, 0xda08, 0xda08, 0xda08, 0xd208, 0xd208, 0xd207, 0xd207, 0xd207, 0xd207, 0xd207, 0xd207, 0xda27, 0xda48, 0xe268, 0xe289, 0xe2a9, 0xe289, 0xe289, 0xda68, 0xda48, 0xda27, 0xda07, 0xd1e7, 0xd1a7, 0xd1a7, 0xd1a7, 0xc9a6, 0xc986, 0xc966, 0xc165, 0xc165, 0xc146, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xb124, 0xa924, 0xa924, 0xa924, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e4, 0xb0e3, 0xb0e3, 0xb0e3, 0xb8c3, 0xb8c3, 0xb8c3, 0xb123, 0xc0a4, 0xd0e7, 0xda6e, 0xe557, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xeeb9, 0xcb6e, 0xd187, 0xd966, 0xd185, 0xd9a6, 0xd9a6, 0xd1c7, 0xd9a6, 0xd9a6, 0xd9a7, 0xd9a7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9e7, 0xd9e7, 0xd9e7, 0xda07, 0xda07, 0xda07, 0xda08, 0xda08, 0xda08, 0xda28, 0xda28, 0xda28, 0xda28, 0xda28, 0xda28, 0xda28, 0xda28, 0xda08, 0xda08, 0xda08, 0xda07, 0xda08, 0xda07, 0xda07, 0xda07, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xda07, 0xda28, 0xda28, 0xe248, 0xda48, 0xda48, 0xda48, 0xda28, 0xd207, 0xd1e7, 0xd1c6, 0xd1a6, 0xd186, 0xd186, 0xc986, 0xc986, 0xc966, 0xc166, 0xc165, 0xc165, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e4, 0xb0e4, 0xb0e3, 0xb0e3, 0xb8e3, 0xb8c3, 0xb8c3, 0xb8c3, 0xc0e3, 0xc8a4, 0xd96a, 0xdb30, 0xf63b, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xdcb2, 0xd24a, 0xd966, 0xd965, 0xd9a6, 0xd1a6, 0xd1e7, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xda07, 0xda07, 0xda07, 0xda07, 0xda07, 0xda07, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c6, 0xd1c6, 0xd1c6, 0xd1c7, 0xd1e7, 0xd9e7, 0xda07, 0xda08, 0xd227, 0xd207, 0xd207, 0xd1e7, 0xd1e7, 0xd1c6, 0xc9a6, 0xc986, 0xc966, 0xc966, 0xc966, 0xc966, 0xc165, 0xc165, 0xc165, 0xc165, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e4, 0xb0e3, 0xb0e4, 0xb0e3, 0xb8e3, 0xb8c3, 0xb8c3, 0xb8c3, 0xc0c3, 0xc8c4, 0xc8e6, 0xda2c, 0xe434, 0xff3e, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xddb6, 0xcb2d, 0xd1a7, 0xd945, 0xd9a6, 0xc9a6, 0xd1e7, 0xd986, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd9e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1c7, 0xd1c7, 0xc9a6, 0xc986, 0xc986, 0xc945, 0xc945, 0xc145, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e4, 0xb0e4, 0xb0e3, 0xb0c3, 0xb8e3, 0xb8c3, 0xb8c3, 0xc0c3, 0xc0c3, 0xc0c3, 0xc864, 0xc927, 0xdb0f, 0xe537, 0xffdf, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe679, 0xd430, 0xc9e8, 0xd145, 0xd186, 0xc9a6, 0xd9e8, 0xd986, 0xd986, 0xd986, 0xd986, 0xd986, 0xd986, 0xd986, 0xd986, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9c7, 0xd9a7, 0xd9a7, 0xd9a7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd9c7, 0xd1e7, 0xd1e7, 0xd1e7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1c7, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xc986, 0xc986, 0xd1a6, 0xd1a6, 0xd1a7, 0xd1a7, 0xd1a7, 0xd1a7, 0xc9c7, 0xc9c7, 0xd1a7, 0xd1a7, 0xc9a6, 0xc986, 0xc966, 0xc966, 0xc945, 0xc945, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb125, 0xb124, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e4, 0xb0e4, 0xb0e4, 0xb0c3, 0xb8c3, 0xb8c3, 0xb8c3, 0xc0c3, 0xc0c3, 0xc0c3, 0xc0c3, 0xc844, 0xd1ca, 0xdbd1, 0xee1a, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xef5c, 0xdd74, 0xd2aa, 0xd165, 0xc9a6, 0xc986, 0xd9c8, 0xd986, 0xd986, 0xd986, 0xd986, 0xd986, 0xd986, 0xd986, 0xd186, 0xd986, 0xd986, 0xd986, 0xd986, 0xd9a6, 0xd9a6, 0xd1a6, 0xd1a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd9a6, 0xd1c6, 0xd1c6, 0xd1c6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc9a6, 0xc986, 0xc9a6, 0xc986, 0xc986, 0xc966, 0xc966, 0xc966, 0xc945, 0xc945, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb124, 0xb124, 0xb125, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e4, 0xb0e4, 0xb8e4, 0xb8c3, 0xb8c3, 0xb8c3, 0xb8c3, 0xc0c3, 0xc0c3, 0xc8c3, 0xc8c3, 0xd086, 0xe2ae, 0xdcb5, 0xf71d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xee78, 0xdb2c, 0xd1a6, 0xc9a6, 0xc986, 0xe187, 0xd986, 0xd986, 0xd986, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd986, 0xd986, 0xd986, 0xd986, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd986, 0xd986, 0xd986, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc986, 0xc986, 0xc986, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc946, 0xc945, 0xc966, 0xc945, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e4, 0xb8e4, 0xb8e4, 0xb8c3, 0xb8c3, 0xb8c3, 0xc0c3, 0xc0c3, 0xc0c3, 0xc8c3, 0xc8c3, 0xe0e8, 0xfb71, 0xe577, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef1b, 0xd491, 0xca09, 0xd125, 0xd165, 0xc1c5, 0xd1a7, 0xd1a7, 0xd9a7, 0xd1a6, 0xd186, 0xd186, 0xd986, 0xd986, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xd1a6, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc966, 0xc966, 0xc945, 0xc945, 0xc945, 0xc945, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb925, 0xb925, 0xb125, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb103, 0xb103, 0xb103, 0xb0e3, 0xb8e3, 0xb8e3, 0xb8e3, 0xb8e3, 0xb883, 0xb8a3, 0xb8e2, 0xb0e1, 0xb902, 0xc0e3, 0xc884, 0xd8c7, 0xea2f, 0xe434, 0xeebb, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xedd6, 0xd2ec, 0xd187, 0xd186, 0xc9a5, 0xd1a7, 0xd1a6, 0xd1a6, 0xd186, 0xd186, 0xd186, 0xd186, 0xd966, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd1a6, 0xd1a6, 0xd1a6, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc966, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc966, 0xc966, 0xc945, 0xc945, 0xc945, 0xc945, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb925, 0xb925, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb103, 0xb103, 0xb103, 0xb0e3, 0xb8e3, 0xb8e3, 0xb8e3, 0xb8c3, 0xc0c4, 0xb8c3, 0xc103, 0xb8e2, 0xc0e2, 0xc8c4, 0xc885, 0xe108, 0xe2d1, 0xf517, 0xf77e, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xfffe, 0xf6da, 0xd3cf, 0xb9a7, 0xc945, 0xd145, 0xd1a6, 0xd1a6, 0xd1a6, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb925, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb103, 0xb103, 0xb0e3, 0xb0e3, 0xb8e3, 0xb8e3, 0xb8c3, 0xb8c3, 0xc0e4, 0xb8e3, 0xc103, 0xc0e2, 0xc8c3, 0xc8a4, 0xc8c6, 0xe9ac, 0xdbf3, 0xfe5b, 0xffff, 0xf7ff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xe595, 0xc2cb, 0xc186, 0xd966, 0xd1a6, 0xd1a6, 0xd1a6, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc966, 0xc986, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb103, 0xb103, 0xb903, 0xb8e3, 0xb8e3, 0xb8e3, 0xb8e3, 0xc0c3, 0xc0e4, 0xb8c2, 0xc0e2, 0xc8c3, 0xd0a4, 0xd0a6, 0xd149, 0xf2d0, 0xdd57, 0xff3d, 0xffff, 0xf7ff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff1c, 0xd471, 0xb9e8, 0xd146, 0xc986, 0xc986, 0xc986, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb904, 0xb904, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb103, 0xb103, 0xb903, 0xb8e3, 0xb8e3, 0xb8e3, 0xc0c3, 0xc0c3, 0xc104, 0xb8c2, 0xc0e3, 0xc8a3, 0xd8a5, 0xd8e8, 0xda0d, 0xf3f5, 0xeefc, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xf7bf, 0xf7df, 0xffdf, 0xe5d7, 0xc2ec, 0xc987, 0xc986, 0xc986, 0xc986, 0xc986, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc986, 0xc986, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc145, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb925, 0xb125, 0xb125, 0xb125, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb904, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb0e4, 0xb0e4, 0xb103, 0xb903, 0xb8e3, 0xb8e3, 0xb8e3, 0xc0c3, 0xc0c3, 0xc0c3, 0xc924, 0xc103, 0xc903, 0xd0a3, 0xe0c6, 0xe18a, 0xdb11, 0xed39, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7df, 0xf7ff, 0xf75c, 0xdcb2, 0xca69, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb925, 0xb925, 0xb125, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb0e4, 0xb0e4, 0xb0e4, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0c4, 0xc0c4, 0xc104, 0xc103, 0xc903, 0xd0a4, 0xe908, 0xea4e, 0xe456, 0xee9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xfffe, 0xed75, 0xba69, 0xc986, 0xc986, 0xc986, 0xc986, 0xc986, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xd186, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc986, 0xc986, 0xc986, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc966, 0xc966, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb925, 0xb925, 0xb925, 0xb925, 0xb124, 0xb124, 0xb124, 0xb124, 0xb104, 0xb104, 0xb104, 0xb104, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb0e4, 0xb0e4, 0xb0e4, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0c4, 0xc0c4, 0xc0c3, 0xc0e3, 0xc8e3, 0xd0a4, 0xe949, 0xfb11, 0xed59, 0xf7bf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf73d, 0xb535, 0xda29, 0xc9a6, 0xc165, 0xc985, 0xd185, 0xd146, 0xd146, 0xc946, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc165, 0xc165, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e3, 0xb8c3, 0xc0e3, 0xc0e3, 0xc8e2, 0xc8e2, 0xc121, 0xc103, 0xd085, 0xe8ca, 0xea2f, 0xe4b7, 0xf73e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xff9e, 0xce39, 0xeb8e, 0xca08, 0xc145, 0xd186, 0xd986, 0xd166, 0xd166, 0xd187, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc165, 0xc165, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8c3, 0xb8c3, 0xb8c3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e2, 0xc902, 0xd0c3, 0xd8c6, 0xe98c, 0xeb32, 0xed99, 0xff9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf75d, 0xed54, 0xc2ca, 0xc125, 0xd966, 0xd986, 0xc165, 0xc166, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb104, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8c3, 0xb8c3, 0xb8c3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xd0c3, 0xe0a5, 0xe129, 0xe2d0, 0xe4d6, 0xf6bd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf6d9, 0xd410, 0xc1c8, 0xd146, 0xd186, 0xc186, 0xc165, 0xc166, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb104, 0xb104, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8c3, 0xb8c3, 0xc0e3, 0xc0e3, 0xc8c3, 0xc8c3, 0xc8c3, 0xd0e3, 0xe0c5, 0xf0c7, 0xf20d, 0xe455, 0xde5b, 0xf79f, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xedd7, 0xd30d, 0xc167, 0xc966, 0xc9a6, 0xc9a6, 0xc986, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8c3, 0xc8a3, 0xd0c3, 0xd0c4, 0xe0a7, 0xe92a, 0xeb31, 0xe5b9, 0xe77e, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf71c, 0xd492, 0xb209, 0xb945, 0xc145, 0xc965, 0xc9a6, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e3, 0xc903, 0xc903, 0xc8e3, 0xc8c3, 0xc8a3, 0xd0c4, 0xd8e5, 0xe10b, 0xe22e, 0xecb6, 0xeefc, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xde38, 0xbbae, 0xc1e7, 0xc925, 0xc925, 0xc985, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc8e2, 0xc8e3, 0xc8e3, 0xc8e3, 0xd0c3, 0xd0c4, 0xd8e5, 0xe126, 0xf211, 0xdb94, 0xe63a, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xf7dd, 0xe594, 0xdb0c, 0xd967, 0xd145, 0xc986, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc966, 0xc966, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb945, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0c2, 0xc8e2, 0xc8e3, 0xc8c3, 0xd0c3, 0xd0e4, 0xe106, 0xe947, 0xfaf5, 0xe4b8, 0xe75d, 0xffff, 0xffff, 0xffde, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf75e, 0xd5b7, 0xbb6d, 0xc9a6, 0xe8e4, 0xc164, 0xc9a5, 0xc986, 0xc946, 0xc946, 0xd166, 0xd186, 0xc965, 0xc966, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb925, 0xb925, 0xb925, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb903, 0xb903, 0xb903, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e4, 0xc103, 0xb901, 0xc8e1, 0xe0a3, 0xe886, 0xe96c, 0xfab2, 0xc556, 0xf6fc, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffbf, 0xeebb, 0xd492, 0xca49, 0xc8e3, 0xc965, 0xc985, 0xd186, 0xc965, 0xc945, 0xc966, 0xd166, 0xc945, 0xc966, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb925, 0xb925, 0xb925, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xb903, 0xb8e3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc903, 0xc8e2, 0xd8c2, 0xe0a4, 0xe108, 0xe22e, 0xf3b5, 0xe67a, 0xff7e, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffbe, 0xf638, 0xd3ae, 0xb185, 0xc945, 0xc965, 0xd166, 0xc965, 0xc145, 0xc965, 0xc946, 0xd146, 0xc966, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc945, 0xc945, 0xc965, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb925, 0xb925, 0xb925, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xc0e4, 0xb903, 0xc0e3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc902, 0xd103, 0xd8c3, 0xe0a4, 0xe8e7, 0xe1ec, 0xdbb3, 0xed9a, 0xff9e, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0xe574, 0xbb2c, 0xc186, 0xc946, 0xc945, 0xc965, 0xc165, 0xc165, 0xc945, 0xd946, 0xc965, 0xc965, 0xc965, 0xc965, 0xc965, 0xc945, 0xc945, 0xc945, 0xc965, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb925, 0xb925, 0xb925, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8c3, 0xc8c3, 0xc902, 0xd903, 0xe0c4, 0xe8c7, 0xf1ab, 0xe331, 0xe579, 0xef5f, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf6da, 0xd534, 0xc26a, 0xc1a7, 0xc945, 0xc945, 0xc985, 0xc185, 0xc946, 0xd946, 0xc965, 0xc965, 0xc965, 0xc965, 0xc945, 0xc945, 0xc945, 0xc945, 0xc965, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb925, 0xb925, 0xb925, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8c3, 0xd0c3, 0xd0c3, 0xc8e2, 0xd8e4, 0xe8e6, 0xe94a, 0xead0, 0xe496, 0xe6bd, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffbe, 0xeebb, 0xcc31, 0xcacb, 0xc986, 0xd145, 0xc985, 0xc185, 0xc965, 0xd146, 0xc965, 0xc965, 0xc965, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc965, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb925, 0xb925, 0xb925, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8c3, 0xd0c3, 0xd0c3, 0xd0c3, 0xc8c3, 0xd8e6, 0xe94a, 0xea6f, 0xec56, 0xee1b, 0xef7e, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff9f, 0xee98, 0xd430, 0xc9e8, 0xd144, 0xd164, 0xc985, 0xc145, 0xc946, 0xc965, 0xc965, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc965, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb925, 0xb925, 0xb925, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8c3, 0xd0c3, 0xd0c3, 0xd0c4, 0xd0c4, 0xd8c5, 0xe949, 0xea2e, 0xebd5, 0xf61c, 0xf77f, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xfffe, 0xe534, 0xd249, 0xd124, 0xd164, 0xc164, 0xc145, 0xc946, 0xc965, 0xc965, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc965, 0xc965, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xb925, 0xb925, 0xb925, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb904, 0xb8e4, 0xb8e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e4, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8c3, 0xd0c3, 0xd0c3, 0xd0c4, 0xd8c4, 0xe8e7, 0xf1ab, 0xfaf2, 0xfd19, 0xff5f, 0xf7ff, 0xffff, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffbf, 0xddb6, 0xb2cb, 0xb965, 0xd145, 0xd164, 0xc163, 0xd125, 0xd166, 0xc945, 0xc966, 0xd1a6, 0xc145, 0xc145, 0xd186, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc124, 0xc124, 0xc124, 0xc124, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xc104, 0xc104, 0xc104, 0xb903, 0xb8e3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xb8a3, 0xd0c4, 0xd8e4, 0xd103, 0xc123, 0xc123, 0xd8e4, 0xf8a5, 0xf96f, 0xe2f2, 0xdd58, 0xef7e, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf6da, 0xd492, 0xcaab, 0xc986, 0xc924, 0xc963, 0xc945, 0xd166, 0xc945, 0xc965, 0xc986, 0xc945, 0xc104, 0xc125, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc124, 0xc124, 0xc124, 0xc124, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xc104, 0xc104, 0xc104, 0xb903, 0xb8e3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc0e4, 0xc8c3, 0xd0c3, 0xd0c2, 0xc8e2, 0xd0e4, 0xe106, 0xf128, 0xf271, 0xec15, 0xee5b, 0xf7bf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf67a, 0xdc72, 0xca49, 0xc164, 0xd164, 0xc945, 0xc965, 0xc945, 0xc125, 0xc965, 0xc965, 0xc145, 0xc945, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc124, 0xc124, 0xc124, 0xc124, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xc104, 0xc104, 0xc104, 0xc104, 0xb903, 0xc0e3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xd0e4, 0xc8c3, 0xc8c2, 0xd8c2, 0xe0a3, 0xe0c5, 0xe16a, 0xf22e, 0xe435, 0xf5da, 0xff7f, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xff9f, 0xee19, 0xdbf0, 0xd228, 0xd164, 0xc165, 0xc986, 0xc965, 0xc925, 0xc925, 0xc945, 0xc966, 0xc986, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc124, 0xc124, 0xc124, 0xc124, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xb904, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc0e3, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8c3, 0xd0e4, 0xc8c3, 0xd102, 0xe0e3, 0xf0c5, 0xe908, 0xea4f, 0xf3b5, 0xe61a, 0xf73e, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xf7ff, 0xf77e, 0xf5f7, 0xdb8e, 0xb985, 0xb985, 0xc185, 0xc986, 0xd166, 0xc925, 0xc925, 0xc945, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc124, 0xc124, 0xc124, 0xc124, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb904, 0xb904, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc103, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xd0e3, 0xd0c3, 0xc8c3, 0xd0e3, 0xe0e5, 0xe8e7, 0xe9ab, 0xeb94, 0xf57b, 0xef9e, 0xefff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff7d, 0xe534, 0xb2aa, 0xb185, 0xb144, 0xc165, 0xd186, 0xd145, 0xc925, 0xc145, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc124, 0xc124, 0xc124, 0xc124, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc0e4, 0xc0e4, 0xc0e3, 0xc0e3, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xd0e3, 0xd0c3, 0xd0c3, 0xd0c3, 0xd8c4, 0xe107, 0xe1aa, 0xe2f0, 0xed38, 0xfeff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf6db, 0xd535, 0xca88, 0xb985, 0xc124, 0xd166, 0xd966, 0xd145, 0xc966, 0xc186, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc124, 0xc124, 0xc124, 0xc124, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc0e4, 0xc0e4, 0xc0e4, 0xc0e3, 0xc103, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xd0e4, 0xd0e4, 0xd0e3, 0xd8c4, 0xe0e7, 0xe9ab, 0xeb11, 0xecf7, 0xeedc, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xf7fe, 0xf7ff, 0xffff, 0xff7e, 0xfc0f, 0xd268, 0xc165, 0xd145, 0xd145, 0xd125, 0xc965, 0xc165, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc124, 0xc124, 0xc124, 0xc124, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xb924, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc0e4, 0xc0e4, 0xc0e4, 0xc103, 0xc0e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xd0e3, 0xd0e4, 0xd0c4, 0xc903, 0xe0c5, 0xf129, 0xfa70, 0xfc97, 0xfe9d, 0xf7ff, 0xefff, 0xffbf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdeb9, 0xc471, 0xb208, 0xc105, 0xd124, 0xc944, 0xb944, 0xb965, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc125, 0xc125, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc103, 0xc103, 0xc103, 0xc103, 0xc103, 0xc103, 0xc903, 0xc903, 0xd0e5, 0xd0e4, 0xd0e3, 0xc8e2, 0xc8e2, 0xc8e2, 0xd103, 0xd124, 0xf065, 0xe948, 0xdaee, 0xd4b5, 0xde5b, 0xf77f, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0xee17, 0xdbef, 0xd249, 0xc986, 0xc965, 0xc985, 0xc986, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc125, 0xc125, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc103, 0xc103, 0xc103, 0xc103, 0xc103, 0xc103, 0xc903, 0xc903, 0xc8e4, 0xc8e4, 0xd0c3, 0xd0e2, 0xd0c2, 0xd0c2, 0xd0c3, 0xd0e4, 0xe928, 0xea2c, 0xe3f3, 0xe5b9, 0xf73e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7d, 0xedf7, 0xd3ef, 0xc228, 0xc965, 0xc965, 0xc965, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc125, 0xc125, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc103, 0xc103, 0xc103, 0xc103, 0xc103, 0xc903, 0xc903, 0xc8e3, 0xc904, 0xc8c3, 0xd0a3, 0xd8c3, 0xe0c3, 0xd8a4, 0xd8c5, 0xe127, 0xe26d, 0xebb2, 0xf579, 0xff1e, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf75c, 0xdd95, 0xd38d, 0xca08, 0xc965, 0xc124, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc125, 0xc125, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc103, 0xc103, 0xc103, 0xc103, 0xc903, 0xc8e3, 0xc8e3, 0xc8e3, 0xc104, 0xc8c3, 0xd0c3, 0xe0c4, 0xe0a4, 0xd8a5, 0xe148, 0xf20c, 0xd3d3, 0xed58, 0xfefe, 0xffdf, 0xf7ff, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf75c, 0xed96, 0xdb8e, 0xca28, 0xc186, 0xc965, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc965, 0xc965, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc125, 0xc125, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc103, 0xc103, 0xc103, 0xc903, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc103, 0xc8e3, 0xd8c3, 0xe8c4, 0xd8a5, 0xd0e7, 0xe20c, 0xfb52, 0xdd99, 0xfede, 0xffdf, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xff3c, 0xed55, 0xd36e, 0xc26a, 0xd186, 0xc965, 0xc945, 0xc945, 0xc945, 0xc965, 0xc945, 0xc945, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc125, 0xc125, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc103, 0xc103, 0xc903, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc903, 0xd0e3, 0xd8c4, 0xe0c5, 0xd8e7, 0xd1cb, 0xe372, 0xf4f8, 0xf73e, 0xffdf, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfefc, 0xe535, 0xcbaf, 0xd1a6, 0xc965, 0xc945, 0xc124, 0xc945, 0xc965, 0xc945, 0xc124, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc125, 0xc125, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc903, 0xc903, 0xc903, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc902, 0xd0e3, 0xe0c4, 0xe0e6, 0xe1ca, 0xe371, 0xed59, 0xfebe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffdf, 0xf7df, 0xf7ff, 0xffff, 0xfebb, 0xe515, 0xd9c7, 0xd186, 0xc124, 0xc124, 0xc945, 0xc965, 0xc945, 0xc124, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc145, 0xc125, 0xc125, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc104, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xc8e3, 0xd102, 0xd0c2, 0xd8c3, 0xe927, 0xf2ad, 0xfcd6, 0xfefe, 0xffff, 0xffff, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffbe, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xef5d, 0xd410, 0xca4a, 0xc8e5, 0xd8e4, 0xd965, 0xc144, 0xc124, 0xd966, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xb122, 0xb923, 0xc123, 0xc904, 0xc8e4, 0xd0e4, 0xd104, 0xd904, 0xd102, 0xe0c4, 0xf929, 0xf24f, 0xdc55, 0xe6dc, 0xf7ff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xee58, 0xdc71, 0xca49, 0xc925, 0xd104, 0xc944, 0xc164, 0xb964, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xc103, 0xc103, 0xc0e3, 0xc8e3, 0xd0e4, 0xd0e4, 0xd0c3, 0xd0a3, 0xd8c4, 0xe106, 0xea2c, 0xec14, 0xee1a, 0xf7bf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xeeda, 0xd471, 0xc209, 0xc904, 0xd124, 0xc984, 0xb1a4, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xd0e4, 0xc8e3, 0xc8c2, 0xc8e3, 0xd0e3, 0xd8c3, 0xd8a3, 0xd0a2, 0xe908, 0xe20b, 0xe413, 0xee7b, 0xf7df, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe699, 0xcc10, 0xc9c8, 0xd105, 0xd144, 0xc1a4, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xd0e4, 0xc8e3, 0xc903, 0xc903, 0xd8c3, 0xe0a3, 0xe0c4, 0xe125, 0xea0e, 0xebd3, 0xf65b, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9f, 0xffff, 0xf7fe, 0xde38, 0xd3af, 0xd1a8, 0xd104, 0xd103, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xc8e4, 0xc104, 0xc923, 0xd103, 0xd882, 0xd863, 0xe926, 0xf1ea, 0xe3d4, 0xf5da, 0xffbf, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9f, 0xffdf, 0xf7ff, 0xf79d, 0xedf7, 0xdb8e, 0xd1a7, 0xd0a4, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xc8e4, 0xc104, 0xc123, 0xd0e3, 0xd883, 0xd8a5, 0xe20b, 0xeb71, 0xddd9, 0xff3e, 0xffff, 0xffff, 0xff9f, 0xffdf, 0xffff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf77d, 0xedd7, 0xdb8e, 0xd1c8, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xd0e4, 0xc8e3, 0xc903, 0xd8e3, 0xe0e5, 0xe1aa, 0xe3d3, 0xed9a, 0xe75d, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf77c, 0xed75, 0xdb8e, 0xc965, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc945, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc124, 0xc104, 0xc104, 0xc903, 0xc903, 0xc8e3, 0xe0c4, 0xd0a3, 0xc8c2, 0xe0e4, 0xe968, 0xf2cf, 0xed59, 0xef7f, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xce79, 0xdb2d, 0xc9e8, 0xc905, 0xc944, 0xc1c5, 0xb984, 0xc124, 0xd125, 0xc945, 0xc945, 0xc925, 0xc924, 0xc924, 0xc124, 0xc124, 0xc104, 0xc123, 0xc904, 0xd0c4, 0xc8e4, 0xc104, 0xc105, 0xc8e5, 0xd8c5, 0xc161, 0xd8c2, 0xe8a6, 0xe98b, 0xd330, 0xddb7, 0xff9d, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xef5d, 0xed35, 0xd36e, 0xc1a7, 0xc924, 0xd144, 0xc944, 0xc124, 0xc144, 0xc945, 0xc945, 0xc925, 0xc924, 0xc924, 0xc124, 0xc124, 0xc104, 0xc123, 0xc904, 0xc8e4, 0xc0e4, 0xb904, 0xb924, 0xc104, 0xd0c3, 0xe0e2, 0xd8a4, 0xe168, 0xeb30, 0xe516, 0xeefc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xff5c, 0xe596, 0xcb4d, 0xc9c7, 0xd905, 0xd8e4, 0xc944, 0xb984, 0xc945, 0xc945, 0xc925, 0xc924, 0xc924, 0xc124, 0xc124, 0xc104, 0xc904, 0xc8e4, 0xc904, 0xc123, 0xb923, 0xb923, 0xc8e3, 0xd0e3, 0xf064, 0xe127, 0xe30e, 0xed77, 0xf73d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf75c, 0xdd96, 0xd38e, 0xd9a8, 0xd8e5, 0xd124, 0xc9a4, 0xc945, 0xc945, 0xc925, 0xc924, 0xc924, 0xc124, 0xc124, 0xc104, 0xc8e4, 0xc8e4, 0xc903, 0xc923, 0xc922, 0xc8e2, 0xd8c2, 0xe0c3, 0xe8c7, 0xeaad, 0xed35, 0xf73c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf79d, 0xe5b6, 0xd34d, 0xc9a7, 0xc924, 0xc924, 0xc945, 0xc945, 0xc925, 0xc924, 0xc924, 0xc124, 0xc124, 0xc104, 0xc8e4, 0xc0e4, 0xc903, 0xd102, 0xd8c2, 0xd882, 0xe083, 0xe8e5, 0xe2ae, 0xecf5, 0xff3c, 0xf7ff, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9e, 0xffff, 0xf7ff, 0xef3b, 0xd554, 0xcb2d, 0xc9a7, 0xc8e4, 0xc945, 0xc945, 0xc925, 0xc924, 0xc924, 0xc124, 0xc124, 0xc104, 0xc105, 0xc0e4, 0xc8e3, 0xd0c2, 0xd882, 0xd883, 0xe126, 0xea0a, 0xdd56, 0xf6fc, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xeefb, 0xdd55, 0xd32d, 0xd1e9, 0xc945, 0xc945, 0xc925, 0xc924, 0xc924, 0xc124, 0xc124, 0xc104, 0xc105, 0xc104, 0xc8e3, 0xd0c2, 0xd0c3, 0xd166, 0xe30e, 0xf494, 0xe73c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xffde, 0xffbf, 0xffff, 0xffff, 0xf6db, 0xecb3, 0xe30e, 0xc945, 0xc945, 0xc925, 0xc924, 0xc924, 0xc124, 0xc124, 0xc104, 0xc925, 0xc103, 0xc903, 0xd103, 0xd145, 0xd26a, 0xe4d4, 0xfedc, 0xefff, 0xffff, 0xffff, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe6fc, 0xb555, 0xe30b, 0xd1c7, 0xd0e3, 0xd0e3, 0xd123, 0xc924, 0xc905, 0xd106, 0xb921, 0xc102, 0xd0c3, 0xd8e6, 0xe24b, 0xf4b4, 0xf71b, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xef1c, 0xdcd2, 0xcb2c, 0xc986, 0xd124, 0xd124, 0xc923, 0xc124, 0xc945, 0xd0e2, 0xc8c3, 0xc945, 0xdaac, 0xf4b4, 0xfe7a, 0xff9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xef3c, 0xe596, 0xd34d, 0xc9a7, 0xc924, 0xc923, 0xc923, 0xc122, 0xe083, 0xd125, 0xcacc, 0xe535, 0xff3c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xff9f, 0xed97, 0xd32d, 0xc9c7, 0xc944, 0xc902, 0xc8e1, 0xc906, 0xdaac, 0xed35, 0xf73d, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xff1d, 0xed76, 0xd38e, 0xc1c6, 0xc903, 0xe124, 0xc30c, 0xed14, 0xff3d, 0xffff, 0xf7ff, 0xefff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9f, 0xffdf, 0xffff, 0xff7e, 0xedb7, 0xc2ec, 0xb9c7, 0xe28a, 0xcdb5, 0xf73c, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff5d, 0xdd55, 0xcc71, 0xed53, 0xef7c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefbe, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xf7fe, 0xefff, 0xf7ff, 0xffdf, 0xff9f, 0xf77c, 0xf7fd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};
  
const unsigned short  lion2[] PROGMEM = {
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffbf, 0xffff, 0xffff, 0xffff, 0xefff, 0xfffe, 0xffde, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xefdf, 0xf7ff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xffde, 0xffff, 0xffff, 0xff9d, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xff9d, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xef5c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xbdf7, 0xb491, 0xee98, 0xff9c, 0xfffe, 0xffff, 0xef7e, 0xffff, 0xffff, 0xff3a, 0xe677, 0xacd1, 0xef1b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7be, 0x6b4d, 0x6a26, 0x9c0e, 0xb553, 0xef5b, 0xffff, 0xf7ff, 0xf7ff, 0xce9c, 0xac4d, 0x8b6a, 0x51c4, 0xcdd5, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffc, 0xffdd, 0xffff, 0xf7bf, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xf7fd, 0xf7dd, 0xf7ff, 0xceba, 0xbe59, 0xdf1b, 0xa514, 0xe69d, 0xa455, 0x9c32, 0xb557, 0x0003, 0xf4c5, 0xf525, 0xab40, 0x9385, 0xce16, 0xde9a, 0xbd10, 0x9385, 0xdc00, 0xfdab, 0x69c5, 0x4166, 0xbdd7, 0x7c10, 0xce7c, 0xc5fc, 0xb5b4, 0xef5b, 0x9cf4, 0xffff, 0xf7ff, 0xf7ff, 0xf7fe, 0xf7fd, 0xffdf, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffde, 0xffff, 0xffbe, 0xefff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7df, 0xffff, 0xf7df, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xbdd9, 0x0880, 0x39a7, 0x1840, 0x7b44, 0x8345, 0x2020, 0x2020, 0x6261, 0xb2e0, 0xfd45, 0xfda6, 0xd4a5, 0xb407, 0x9b66, 0xc405, 0xf525, 0xfd89, 0xdca5, 0x8ae0, 0x4940, 0x1820, 0x3102, 0x9c4d, 0x4140, 0x0845, 0x20e5, 0x4208, 0xfffe, 0xffdd, 0xff9d, 0xffbf, 0xff9f, 0xffff, 0xffde, 0xffbe, 0xfffe, 0xff9d, 0xffde, 0xffde, 0xffde, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xfffe, 0xfffd, 0xfffe, 0xefbd, 0xefff, 0xefff, 0xefff, 0xefff, 0xefff, 0xefff, 0xefff, 0xdfdd, 0xd79c, 0xd7bd, 0xbeba, 0x1881, 0x4164, 0x30a0, 0x6200, 0xb464, 0xdda6, 0xa3c2, 0x7a61, 0xb383, 0xe4c5, 0xf544, 0xfd44, 0xfd67, 0xfd27, 0xfd03, 0xfd21, 0xf566, 0xdca6, 0x9ae3, 0x82a3, 0xc4c6, 0xe5e7, 0xa3a3, 0x50e0, 0x41e3, 0x1080, 0x5288, 0xffff, 0xf7bf, 0xe75f, 0xf7ff, 0xf7ff, 0xf7df, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xefff, 0xefff, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xc638, 0xffbf, 0xffff, 0xffff, 0xf7bf, 0xe7bf, 0xc6dc, 0xef7d, 0xef1a, 0xf77f, 0xd65c, 0x9473, 0x62ec, 0x39a6, 0x20c3, 0x28e3, 0x20c3, 0x1004, 0x49a3, 0x93c7, 0x82c5, 0x5920, 0xaba5, 0xe548, 0xed88, 0xa385, 0xc445, 0xe504, 0xfd44, 0xfd25, 0xfce5, 0xfd05, 0xfd44, 0xed48, 0xab23, 0xbc05, 0xede6, 0xcd04, 0x8241, 0x6140, 0x9b41, 0x6ac8, 0x2081, 0x1000, 0x28c5, 0x1864, 0x2906, 0x526a, 0x6b4d, 0xb617, 0xdf3c, 0xdf1c, 0xefbe, 0xdf1b, 0xdefa, 0xfffe, 0xffdd, 0xffdc, 0xfffe, 0xf79e, 0xef7d, 0xffff, 0xf7bd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xef7d, 0x52aa, 0x6bd2, 0xe75f, 0xffff, 0xf7ff, 0xdf5f, 0x4208, 0x48e0, 0xaae5, 0x9243, 0x9a43, 0x9200, 0x9a40, 0xbb22, 0xd3c3, 0xd383, 0xbac0, 0x6aa3, 0x1800, 0x2820, 0x8b28, 0xabe9, 0x92e5, 0x8a60, 0xb3e1, 0xccc9, 0xc485, 0xd4a3, 0xf504, 0xfd25, 0xfd46, 0xfd47, 0xece6, 0xc3c8, 0xd4a3, 0xdd02, 0x9b01, 0x92c4, 0x9b84, 0x9ba7, 0x6a06, 0x1800, 0x4101, 0x82c3, 0xa382, 0xbc02, 0xbba1, 0xaaa0, 0x9a20, 0x9240, 0x8a20, 0x9b05, 0x7a66, 0x30c1, 0x8bcf, 0xffdf, 0xffff, 0xfffa, 0xde57, 0x41c8, 0xb577, 0xf7be, 0xfffe, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xffff, 0x6b4d, 0x1000, 0xc50f, 0xbcef, 0xcdd4, 0xf7bf, 0x9493, 0x2841, 0x6963, 0x71e0, 0x92c2, 0xab43, 0xc403, 0xdca4, 0xe4e4, 0xf525, 0xfd86, 0xf688, 0xcd0a, 0x8287, 0x4080, 0x69e0, 0xe56a, 0xfe0b, 0xab41, 0xe4a4, 0xe4c3, 0xed03, 0xfd64, 0xfd24, 0xfce4, 0xf546, 0xe526, 0xed03, 0xf529, 0xc3a5, 0xbbe4, 0xfe8e, 0xabe7, 0x4920, 0x4902, 0xb442, 0xdd86, 0xfe68, 0xf5a5, 0xed44, 0xece4, 0xe465, 0xdbe4, 0xb365, 0x8201, 0x69a3, 0x3081, 0x49e8, 0xce5b, 0xc6bc, 0x9d98, 0xbd0c, 0x7b08, 0x0800, 0xef3f, 0xffff, 0xffff, 0xf79d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xd6ba, 0x2020, 0xaba5, 0xd464, 0xa320, 0x9386, 0x8c2c, 0x2902, 0x1800, 0x0801, 0x1842, 0x30a2, 0x4942, 0x61c2, 0x61c1, 0x8283, 0xb3e9, 0xe4c7, 0xed82, 0xfe44, 0xcc86, 0x71a2, 0x79a0, 0xdce5, 0xfe27, 0xfce4, 0xfd25, 0xf525, 0xfd45, 0xfd04, 0xfcc2, 0xfd45, 0xf545, 0xfcc7, 0xfd05, 0xfd84, 0xfde8, 0xb366, 0x6922, 0x92c4, 0xee08, 0xfdc6, 0xf586, 0xd485, 0xa302, 0x7a01, 0x69a2, 0x69c4, 0x5122, 0x0020, 0x0883, 0x1062, 0x0800, 0x5a05, 0xb46c, 0x9364, 0xa3c3, 0xc509, 0x51a2, 0x51ea, 0xffbf, 0xf7df, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xe73c, 0xffff, 0x2aaf, 0x0800, 0xd485, 0xfe46, 0xf522, 0xdd25, 0xccc6, 0xc425, 0x9b87, 0xa386, 0x9b22, 0xb3c2, 0xf567, 0xfde7, 0xfd44, 0xf503, 0xf4e0, 0xfd04, 0xfd09, 0xfdc9, 0xfda7, 0xb340, 0xbb41, 0xfd08, 0xfd07, 0xfd28, 0xe4a6, 0xf4e7, 0xfd27, 0xfd05, 0xfd45, 0xed03, 0xfce4, 0xfd44, 0xfd25, 0xf4c7, 0xa260, 0xdc85, 0xfda7, 0xfda5, 0xf4e9, 0xf506, 0xece3, 0xf583, 0xfdc5, 0xf586, 0xdce7, 0x9ae1, 0xa383, 0xab84, 0xab44, 0xd468, 0xdca6, 0xecc4, 0xfd84, 0xfe04, 0x82e0, 0x1800, 0xbd37, 0xf77f, 0xef7f, 0xf7fe, 0xfffe, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xf7fe, 0xffff, 0x632c, 0x6b28, 0x8b8c, 0x82e9, 0xbca7, 0x9c2b, 0x1001, 0x1002, 0x7a83, 0xed64, 0xfde5, 0xfd24, 0xfd66, 0xfd04, 0xfd24, 0xe463, 0xb362, 0xbba4, 0xd4c5, 0xdcc5, 0xcc43, 0xd4e1, 0xe505, 0xf4e7, 0xfd48, 0xfd45, 0xfd86, 0xc443, 0xab83, 0xf587, 0xfdc6, 0xdc87, 0xb323, 0xfde4, 0xf523, 0xdc49, 0xab62, 0xfce3, 0xfde6, 0xe506, 0xbb85, 0xdc68, 0xfd67, 0xfd85, 0xecc5, 0xfd26, 0xe484, 0xd463, 0xd484, 0xdca6, 0xe466, 0xd3a5, 0xdb64, 0xfc84, 0xfcc6, 0xfd06, 0xfda5, 0xfde3, 0xf5c5, 0xc468, 0x6143, 0x0002, 0x39a5, 0xbccd, 0xa387, 0x9308, 0x8b8d, 0x4a8b, 0x9597, 0xfffe, 0xffff, 0xe7bf, 0xf7ff, 0xffde, 0xffdf, 0xff9f, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xeefb, 0x8369, 0x8b21, 0xc441, 0xdcc6, 0xf548, 0xe4e1, 0xfdc4, 0xdd28, 0x8325, 0x3920, 0x40c0, 0x9267, 0xeccb, 0xf565, 0xdce6, 0xcc08, 0xa2e6, 0x8a44, 0x79a3, 0x4820, 0x4820, 0x8202, 0xb2a0, 0xe446, 0xfd89, 0xf481, 0xfce1, 0xfd64, 0xfd69, 0xa304, 0xbc05, 0xed87, 0xfda5, 0xb303, 0xc401, 0xfe28, 0xa2c5, 0xbbe1, 0xfdc8, 0xed49, 0x9b00, 0xcc43, 0xfe08, 0xfd04, 0xfcc4, 0xfda8, 0xe4e6, 0xb384, 0x92e6, 0x61a5, 0x2820, 0x38a0, 0x7222, 0x8ae3, 0xabc7, 0xcc87, 0xe4c6, 0xfd28, 0xd3c6, 0x7160, 0x48e0, 0x4120, 0xb445, 0xed87, 0xf545, 0xfd04, 0xfd27, 0xd446, 0x9b42, 0x72a0, 0xad32, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefbf, 0xb4f4, 0x69a0, 0xfd64, 0xfce2, 0xdbc0, 0xfd24, 0xfdc6, 0xfd25, 0xfda6, 0xfec9, 0xcd66, 0x7aa4, 0x48a3, 0x3021, 0x5a23, 0x3941, 0x38e0, 0x69c2, 0x8224, 0x79a0, 0x9ac1, 0xd4c6, 0xd527, 0xfd47, 0xf4c4, 0xf4c3, 0xfd65, 0xfd05, 0xfd06, 0xfd47, 0xd4a4, 0x61e0, 0xc464, 0xfe65, 0xaae4, 0x9b03, 0xf669, 0x71c2, 0xdd05, 0xf5e8, 0x82a1, 0x8ac2, 0xed66, 0xfd21, 0xfd24, 0xfce5, 0xf4c3, 0xfd43, 0xfd64, 0xf567, 0xd4e7, 0xa3e5, 0x82c2, 0x69e1, 0x71c1, 0x51e1, 0x28c0, 0x5a03, 0x5184, 0x3000, 0x5102, 0x9b44, 0xfe6a, 0xfdc6, 0xfda4, 0xfd63, 0xfdc6, 0xec62, 0xe401, 0xfda6, 0xeca0, 0x5204, 0xef3c, 0xf7ff, 0xeffe, 0xffff, 0xffbf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0x83ae, 0xa323, 0xfd27, 0xc2e3, 0x9222, 0x8241, 0x8ae6, 0x6a47, 0x7243, 0xcca4, 0xfe45, 0xfe24, 0xc465, 0x3101, 0x0004, 0x0001, 0x5224, 0xb468, 0xe54a, 0xfda8, 0xfe25, 0xfe64, 0xf646, 0xfda5, 0xfde3, 0xf5a1, 0xfd84, 0xf404, 0xfc87, 0xfd06, 0xfde4, 0x61a0, 0xbc84, 0xede7, 0x9263, 0xbc26, 0xe5c7, 0x8281, 0xabe6, 0xfe68, 0x7240, 0x9b23, 0xfdeb, 0xf4a3, 0xfd24, 0xfd24, 0xfda5, 0xfd04, 0xfd04, 0xfd85, 0xfe26, 0xfe45, 0xfde4, 0xf584, 0xfd66, 0x83e8, 0x1060, 0x0003, 0x1022, 0x5a41, 0xe629, 0xfe87, 0xed63, 0xa3a8, 0x6a21, 0x82e5, 0x82e5, 0x7202, 0x9a82, 0xcba2, 0xfd44, 0x6244, 0xd617, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefde, 0x6246, 0xdca7, 0xcb61, 0x7941, 0x69e6, 0x2923, 0x0002, 0x0042, 0x10a3, 0x30c0, 0xbbe5, 0xfdc5, 0xfe65, 0xcd07, 0x28e0, 0x0882, 0x1840, 0x7a84, 0xcca5, 0xb3a1, 0x9aa2, 0xa348, 0xaba9, 0xac07, 0xb486, 0xddc8, 0xe585, 0xfe07, 0xfd45, 0xfd06, 0xfd27, 0xab43, 0xdda6, 0x9388, 0x71e2, 0xf568, 0xfda5, 0xc482, 0x5183, 0xeda7, 0xcca3, 0xbbe2, 0xfd6a, 0xfd07, 0xfd86, 0xfe08, 0xe569, 0xe567, 0xbc05, 0xabc9, 0xabcb, 0x92e6, 0x9b23, 0xcc45, 0xdc66, 0x1922, 0x20a4, 0x1801, 0x7a43, 0xe5c4, 0xfe83, 0xe5a6, 0x8ac4, 0x1064, 0x0002, 0x0063, 0x0022, 0x4186, 0x7225, 0x81c0, 0xf504, 0x9367, 0xac90, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xd63a, 0x5980, 0xfdc8, 0xf505, 0x9b24, 0x3940, 0x1901, 0x08c4, 0x1923, 0x08e3, 0x0043, 0x3145, 0x6a21, 0xe504, 0xfe06, 0xd3e0, 0x4988, 0x6a69, 0x6a43, 0x8ac2, 0xbc47, 0x9305, 0x3880, 0x2000, 0x4182, 0x38e2, 0x3881, 0x71e1, 0xd4e6, 0xfe06, 0xfd65, 0xfd06, 0xeca6, 0xe5a6, 0x5164, 0x92e5, 0xfdc6, 0xfd63, 0xfe04, 0x5184, 0x9ac3, 0xfda7, 0xf522, 0xfd26, 0xfd89, 0xdd46, 0xa3a3, 0x61a0, 0x2820, 0x59a7, 0x38a6, 0x1000, 0x59a3, 0xa3c7, 0xab64, 0x81e0, 0x6a06, 0x69c4, 0x69a0, 0xdd06, 0xfe88, 0xabc1, 0x5981, 0x2002, 0x0884, 0x10e4, 0x10c3, 0x10a2, 0x20a0, 0x61a0, 0xc404, 0xfe28, 0xa365, 0x7ac8, 0xffdf, 0xf7ff, 0xf7dd, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xc5db, 0x6a41, 0xd4c5, 0xcc68, 0x8347, 0x0860, 0x0060, 0x2123, 0x18a3, 0x08c1, 0x0945, 0x0002, 0x1820, 0xdd2a, 0xfdc7, 0xfd04, 0xab08, 0x9ae3, 0x8240, 0x6180, 0x7a83, 0xb489, 0x93e7, 0x38e0, 0x4982, 0x932a, 0x6965, 0x58e1, 0x6180, 0xbc65, 0xf5a6, 0xf502, 0xfd47, 0xcc63, 0x6982, 0xd4a8, 0xfd85, 0xfcc2, 0xfde5, 0x8b06, 0x6980, 0xf548, 0xfd43, 0xfd43, 0xeda9, 0x8b23, 0x4900, 0x6140, 0x82a4, 0x7224, 0x38a0, 0x5a02, 0xb4c9, 0x9ba5, 0x6961, 0x7986, 0xaaa5, 0xa280, 0xd442, 0xfe28, 0xf5ea, 0x82e5, 0x1000, 0x1024, 0x2104, 0x18c2, 0x10c1, 0x2102, 0x0800, 0x4121, 0xbc6a, 0xccc8, 0xab43, 0x6a25, 0xff9f, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x6bd2, 0x4200, 0x6200, 0x1800, 0x0823, 0x10e7, 0x18c7, 0x1882, 0x10a4, 0x1102, 0x1103, 0x1865, 0x3042, 0xb3c6, 0xdd25, 0xede7, 0xfda2, 0xe442, 0xbb85, 0x8243, 0x4080, 0x40c4, 0x59a7, 0x40e2, 0x2800, 0xab65, 0xe4e5, 0xe506, 0x9b84, 0x61c0, 0xd4c8, 0xfda7, 0xfd27, 0xab00, 0x9aa0, 0xf527, 0xfd25, 0xfd04, 0xfdc8, 0xb3a3, 0x7260, 0xe4e9, 0xfd05, 0xfd64, 0x9b42, 0x5182, 0xccee, 0xdce6, 0xdd07, 0x6180, 0x3040, 0x59c7, 0x4162, 0x28a0, 0x59e2, 0x82e8, 0xb325, 0xfd28, 0xfd84, 0xfd00, 0xed04, 0x7ac2, 0x0040, 0x0147, 0x10a4, 0x18c4, 0x10e3, 0x18e4, 0x18e6, 0x1065, 0x0002, 0x1021, 0x9ac0, 0x5962, 0xde9c, 0xefdf, 0xfffe, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x8471, 0x20e2, 0x6289, 0x1041, 0x1083, 0x10e5, 0x10a4, 0x18a4, 0x1883, 0x10a2, 0x1103, 0x0042, 0x0802, 0x2000, 0xb384, 0xfd85, 0xf4e4, 0xfde7, 0xfd66, 0xc3e1, 0x8260, 0x4122, 0x1065, 0x0069, 0x00a0, 0x3983, 0xedab, 0xc382, 0xf529, 0xbbe1, 0x8260, 0xee2b, 0xecc7, 0xab02, 0xa323, 0xdcc6, 0xfd45, 0xfd44, 0xf507, 0xc3c7, 0xaac7, 0xd3a6, 0xfd8a, 0xd444, 0x8220, 0xf567, 0xe423, 0xf425, 0xaccb, 0x1880, 0x0082, 0x00a5, 0x0884, 0x6205, 0xa2c3, 0xf426, 0xfe07, 0xf586, 0xeda5, 0xd545, 0x6a61, 0x0800, 0x0003, 0x0043, 0x1903, 0x18c5, 0x1084, 0x18c2, 0x2124, 0x10a5, 0x0065, 0x0905, 0x7243, 0x4100, 0xf6fa, 0xffbf, 0xffff, 0xffdf, 0xf7de, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fd, 0x4960, 0x9ac5, 0x5900, 0x1801, 0x1907, 0x18c4, 0x2080, 0x2084, 0x20a2, 0x3122, 0x6a85, 0x9365, 0xb3c3, 0xed24, 0xfd83, 0xfd65, 0xf4e4, 0xd403, 0xbba4, 0x92e5, 0x4962, 0x1020, 0x0000, 0x0802, 0x2000, 0x9262, 0xe449, 0xc384, 0xf547, 0x9ac0, 0xe4e5, 0xcc06, 0xa2c2, 0x9260, 0xdc65, 0xfd45, 0xfd24, 0xfd07, 0xbb43, 0xa363, 0xb2c0, 0xfca5, 0xb385, 0xa325, 0xfd4b, 0xcb22, 0xdc28, 0x50e3, 0x1800, 0x1002, 0x0001, 0x1060, 0x7284, 0x9b22, 0xc381, 0xe424, 0xfce4, 0xfd84, 0xfd86, 0xd486, 0xa385, 0x9325, 0x7ac5, 0x2060, 0x1860, 0x2924, 0x10a0, 0x18c0, 0x28c1, 0x2840, 0x7ac5, 0x6204, 0x93ec, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf79e, 0xc638, 0x5c50, 0x2900, 0xa2e1, 0x8a62, 0x28e2, 0x00a5, 0x0062, 0x10c0, 0x0862, 0x1883, 0x3923, 0x9bc8, 0xd528, 0xf5c7, 0xf586, 0xe4e6, 0xf4e3, 0xeca4, 0xcc26, 0xa346, 0x7202, 0x5140, 0x6a21, 0x9bc6, 0x9be5, 0x9323, 0x8a40, 0xa2c1, 0x89e0, 0xe4a8, 0xc322, 0xec03, 0x92c4, 0x9a83, 0x9220, 0xe445, 0xfd66, 0xfd45, 0xfd68, 0xcb82, 0x8225, 0x89e1, 0xd3a4, 0xaae0, 0xbbc4, 0xc427, 0x81e0, 0x9261, 0x8a82, 0x9304, 0x9b87, 0x82e5, 0x61e1, 0x5980, 0x7a22, 0xbbe9, 0xec25, 0xfcc5, 0xf4a4, 0xf4c7, 0xfd89, 0xed87, 0xbc46, 0x8266, 0x18c0, 0x18e5, 0x00c6, 0x0043, 0x08e4, 0x20a3, 0x38a0, 0xb3c6, 0x3943, 0x5a68, 0x9470, 0xef5c, 0xf79e, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xf79e, 0xffdf, 0xffff, 0xce59, 0x0005, 0x0000, 0x5981, 0x8306, 0x20c0, 0x0000, 0x2965, 0x20c1, 0x1126, 0x08e3, 0x0040, 0x1080, 0x2060, 0x4120, 0x7a83, 0x9323, 0xfce6, 0xecc7, 0xab44, 0x6160, 0x7200, 0xccc9, 0xfe2c, 0xf567, 0xede7, 0xfe6a, 0xfe09, 0xbc05, 0x9ae3, 0xb346, 0xc305, 0xba20, 0x5982, 0x8223, 0xaae3, 0xe445, 0xf525, 0xfd46, 0xfd27, 0xd3c3, 0x9284, 0x6184, 0x79c3, 0xc2e3, 0xc385, 0x8327, 0x93c7, 0xf566, 0xfe46, 0xfe67, 0xfe06, 0xfe28, 0xed68, 0xa343, 0x71c1, 0x6141, 0xd406, 0xf549, 0xdcc6, 0x9ac2, 0x5940, 0x40e0, 0x2882, 0x0802, 0x00a0, 0x08a4, 0x0885, 0x2167, 0x1083, 0x0800, 0x59c4, 0x8b04, 0x20c3, 0x0000, 0x4228, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xce79, 0x38e2, 0x38e3, 0x2040, 0x72a6, 0x9345, 0xa383, 0xd4c7, 0xc444, 0x0021, 0x10e2, 0x21c5, 0x0084, 0x0004, 0x1803, 0xa3a9, 0xf60a, 0xf4a8, 0xa260, 0x9260, 0xd4c7, 0xfe0b, 0xf588, 0xf525, 0xfd46, 0xedc9, 0xcc86, 0x9ae6, 0x6184, 0x3041, 0x48c1, 0xa2c3, 0xbb00, 0x4102, 0x6183, 0xab06, 0xcbc4, 0xe484, 0xfd66, 0xdc44, 0xbb22, 0x8b02, 0x4120, 0x5961, 0xd3c7, 0x8a02, 0x2020, 0x30a0, 0x8200, 0xb423, 0xdd26, 0xed23, 0xf501, 0xfd63, 0xfde7, 0xfda8, 0xbbe3, 0x81c0, 0xb362, 0xe568, 0xddab, 0x6a86, 0x0003, 0x0006, 0x0947, 0x31a4, 0x1000, 0x59a1, 0xcca8, 0xb3a3, 0x92e4, 0xa3ca, 0x4960, 0x0841, 0x18c3, 0x5aeb, 0xf79d, 0xf7bd, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xc638, 0x3186, 0x1082, 0x7a63, 0x5226, 0x0843, 0x2082, 0x9b47, 0xfd88, 0xfd84, 0xfe46, 0x7283, 0x4144, 0x3107, 0x1064, 0x4a04, 0x7ac0, 0xe505, 0xfd66, 0xaac2, 0xd405, 0xf548, 0xf587, 0xed04, 0xfd25, 0xfd46, 0xfce5, 0xc402, 0xab60, 0x8240, 0x8304, 0x8baa, 0x4984, 0x69e1, 0xb388, 0x3924, 0x30c2, 0x7245, 0xa2e3, 0xe464, 0xfdc8, 0xcbe4, 0x9282, 0x3924, 0x4901, 0x8284, 0x8b06, 0x4940, 0x7aa4, 0x9305, 0x8aa3, 0x8a61, 0xb3a4, 0xe4c6, 0xfd46, 0xfce3, 0xfd03, 0xfda6, 0xfd45, 0xeca4, 0xc344, 0xcba7, 0xed69, 0xb4a5, 0x5a40, 0x2962, 0x1902, 0x3988, 0x38c2, 0xb3e6, 0xfe68, 0xfe47, 0xdcea, 0x61e6, 0x0800, 0x3102, 0x62a9, 0x3185, 0x18c2, 0x6b6d, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xef5d, 0x5acb, 0x0000, 0x2860, 0x1821, 0x1003, 0x1800, 0x3800, 0x9aa4, 0xcbe5, 0xcc24, 0x9322, 0x48e0, 0x3820, 0x7243, 0xe5c7, 0xfea5, 0xfd64, 0xcb01, 0xd445, 0xed06, 0xfd67, 0xfd25, 0xfce3, 0xfd45, 0xfd46, 0xf4e4, 0xd405, 0xfd84, 0xfe47, 0xf684, 0xde68, 0x4180, 0x2000, 0x50c7, 0x49a5, 0x1062, 0x2903, 0x7242, 0xe444, 0xfd87, 0xc385, 0x61c4, 0x0001, 0x38c1, 0x69c5, 0x1821, 0x1000, 0x9ba5, 0xfe4b, 0xfe8b, 0xfdea, 0xdc85, 0xdc64, 0xfd27, 0xfd48, 0xfd06, 0xfce6, 0xfd47, 0xfd65, 0xf486, 0xcb65, 0xd3e3, 0xf5a3, 0xfe86, 0xc4a5, 0x5120, 0x1020, 0x4923, 0xb3e8, 0xcc63, 0xbba0, 0x79e0, 0x2000, 0x2860, 0x1800, 0x4142, 0x1860, 0x0000, 0xa555, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xbdf7, 0x0000, 0x4123, 0x8ae5, 0xcc06, 0xece8, 0xdc46, 0xbb63, 0xcb84, 0xbae0, 0x82c8, 0x9323, 0xb441, 0xf5e5, 0xfda5, 0xf506, 0xe466, 0xec66, 0xfde7, 0xf545, 0xfce4, 0xfd05, 0xfce5, 0xfcc4, 0xfce4, 0xfd45, 0xfd48, 0xfd05, 0xfd0a, 0xc405, 0x6a20, 0x59e4, 0x8384, 0x7ae3, 0x5226, 0x0862, 0x0001, 0x59c1, 0xd3c2, 0xfc63, 0xaac3, 0x38c2, 0x0000, 0x28e0, 0x6285, 0x7308, 0x7328, 0x49a0, 0x9323, 0xcc48, 0xfd23, 0xfd24, 0xfd87, 0xf506, 0xf4e6, 0xfd66, 0xfd04, 0xfd43, 0xfd0a, 0xfd86, 0xf501, 0xec81, 0xf4c4, 0xfd46, 0xfd67, 0xece8, 0xb3e4, 0x8a82, 0x9ac3, 0xbb83, 0xbb62, 0xcbc6, 0xe4a8, 0xe4a5, 0xa3c9, 0x61e3, 0x2060, 0x4208, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xf7dd, 0xffdf, 0xffdf, 0xf79e, 0x940d, 0x5960, 0xa2e3, 0xdca5, 0xdc85, 0xd464, 0xd464, 0xe506, 0xf5a7, 0xfde8, 0xfde7, 0xfe29, 0xdde7, 0xedc7, 0xfd02, 0xfd00, 0xfd24, 0xf528, 0xfd46, 0xfd62, 0xf4a4, 0xfd26, 0xfdc7, 0xed05, 0xed04, 0xfd86, 0xfce9, 0xfd46, 0xece4, 0xc402, 0xb3c1, 0xd4a4, 0xf566, 0xfdc6, 0xfde5, 0xfd60, 0xcc67, 0x3942, 0x0802, 0x72a3, 0xb444, 0x5125, 0x1000, 0x8ae0, 0xd4e6, 0xfdc8, 0xfda7, 0xfdc7, 0xf545, 0xc402, 0xa360, 0xec63, 0xfd47, 0xf4e4, 0xfd44, 0xfcc1, 0xfce2, 0xfd46, 0xf589, 0xfce4, 0xfd44, 0xfce7, 0xfcca, 0xfce6, 0xfda3, 0xf501, 0xfd65, 0xf5ea, 0xfe2a, 0xf607, 0xf606, 0xfde6, 0xed66, 0xdcc6, 0xcc05, 0xec65, 0xd465, 0xc4a7, 0x6200, 0x51a2, 0xd5d6, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xad75, 0xa4f2, 0x62c8, 0x5a04, 0x69e3, 0x8224, 0x5040, 0x6901, 0x7184, 0x6122, 0x48a0, 0x4900, 0x61e3, 0x72a5, 0x61a0, 0xabe1, 0xf584, 0xfd25, 0xfd88, 0xecc6, 0xfd26, 0xfd64, 0xf4e3, 0xfda8, 0xfe2d, 0xb362, 0xcc02, 0xfd46, 0xfd05, 0xfd05, 0xfd05, 0xf505, 0xece5, 0xed06, 0xf567, 0xfd66, 0xfd24, 0xfd03, 0xfd26, 0xfde9, 0xd549, 0x59e2, 0x30c0, 0x4962, 0x3020, 0xa3a6, 0xeda9, 0xfdc9, 0xfd66, 0xfd04, 0xfd45, 0xfd66, 0xf547, 0xe547, 0xeca3, 0xfd46, 0xf505, 0xfd25, 0xfd45, 0xfcc4, 0xbb61, 0xdd2b, 0xfd85, 0xece4, 0xfd23, 0xfd65, 0xfd27, 0xeca6, 0xfda8, 0xfd25, 0xdce6, 0x8260, 0x59c0, 0x72c5, 0x51c3, 0x3060, 0x58e0, 0x7161, 0x78e3, 0x6083, 0x5904, 0x6a04, 0x6220, 0x5a20, 0x734a, 0x94f7, 0xadf7, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef9f, 0x31a8, 0x0000, 0x2861, 0x4921, 0x6180, 0x7a62, 0xac00, 0xbc64, 0xcd2a, 0xb4ac, 0x6287, 0x0800, 0x0001, 0x0843, 0x5983, 0xcc44, 0xfdc4, 0xfd68, 0xa2e6, 0xd426, 0xfd43, 0xfd25, 0xd4e8, 0xed89, 0xb3a7, 0x79a0, 0xd444, 0xfda8, 0xfd05, 0xfd42, 0xfd05, 0xfd25, 0xfd26, 0xfd67, 0xfd67, 0xfd25, 0xfd04, 0xfd45, 0xdcc9, 0xfe05, 0xfe69, 0xd4e8, 0x30e0, 0x0801, 0x7a84, 0xfdc9, 0xfe0a, 0xfd67, 0xf4e4, 0xfce3, 0xfd03, 0xfd24, 0xf546, 0xf547, 0xfd64, 0xf545, 0xfd66, 0xfd26, 0xfd05, 0xfd28, 0x9b22, 0x5160, 0xdd8c, 0xe589, 0xdd24, 0xf5c5, 0xf565, 0xbb43, 0xd448, 0xf5c6, 0xfd27, 0xa304, 0x3082, 0x0005, 0x0006, 0x28e5, 0x9348, 0xdd2a, 0xd4a4, 0xbc04, 0x9324, 0x7203, 0x50e1, 0x3881, 0x1862, 0x0002, 0x9d54, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0x41a8, 0x2000, 0x8225, 0x9b26, 0xac07, 0x9ae6, 0x8244, 0x69c3, 0x5982, 0x38e0, 0x28a0, 0x5202, 0x8c09, 0xed6d, 0xfd68, 0xfda4, 0xb425, 0x71c4, 0xfd69, 0xfda4, 0x9ae4, 0x59e3, 0x7283, 0x3020, 0xa2e4, 0xf528, 0xfd46, 0xfd25, 0xfd23, 0xfd05, 0xfd05, 0xfce4, 0xfce4, 0xfce4, 0xfce5, 0xfd26, 0xfd67, 0xed69, 0xfda3, 0xfdcc, 0xfecf, 0x7b24, 0x2060, 0xddcb, 0xfe4e, 0xfdaa, 0xf527, 0xfd26, 0xfd46, 0xfd04, 0xfce4, 0xfd25, 0xf525, 0xfd23, 0xf504, 0xf525, 0xfd46, 0xeca4, 0xfda9, 0xdd29, 0x4940, 0x4146, 0x62a1, 0x59e0, 0xb407, 0xfe65, 0xc422, 0x71a0, 0xe5e7, 0xfd24, 0xfe0a, 0xc4e8, 0x7304, 0x3981, 0x30c0, 0x5121, 0x7183, 0x8220, 0x92e1, 0xa382, 0xaba4, 0xab67, 0x50e0, 0x1800, 0x94b1, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xb574, 0x4120, 0x8223, 0xab06, 0x8a63, 0x5900, 0x7125, 0x7986, 0x89e5, 0x9244, 0xab44, 0xd4a6, 0xf5a7, 0xfde7, 0xfd24, 0xfdc5, 0xe569, 0x4120, 0xabc5, 0xfeaa, 0xb3c4, 0x0000, 0x0800, 0x2040, 0x61e0, 0xf5ca, 0xfd88, 0xf4c4, 0xfd65, 0xfcc6, 0xfce5, 0xfce5, 0xfce4, 0xfce4, 0xfd05, 0xfd27, 0xfd28, 0xf508, 0xfdea, 0xfe08, 0xfe75, 0xfeb1, 0x9bc5, 0x3040, 0xe5e9, 0xff15, 0xfe2e, 0xfdcc, 0xfd8a, 0xfd68, 0xfd26, 0xfd25, 0xfd45, 0xfd45, 0xfd04, 0xfd04, 0xfce5, 0xfd06, 0xfcc4, 0xfd04, 0xfde9, 0xd568, 0x1843, 0x0000, 0x0800, 0x38e3, 0xe5c6, 0xfe67, 0x5960, 0x8327, 0xfdc3, 0xf561, 0xfda2, 0xfe46, 0xe565, 0xbbe3, 0xa304, 0x8a03, 0x79c1, 0x71a3, 0x6922, 0x6900, 0xab02, 0xab84, 0x59a1, 0x5a48, 0xff9e, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xde9a, 0x2860, 0x69a1, 0xbb66, 0x89c0, 0xa2c1, 0xd467, 0xed65, 0xf565, 0xf564, 0xfd64, 0xfd85, 0xfd85, 0xfd24, 0xfcc3, 0xfd02, 0xfe06, 0x8326, 0x2040, 0xf646, 0xf5c7, 0x38c2, 0x1167, 0x62ef, 0x1821, 0xd56c, 0xfe89, 0xfd66, 0xfd25, 0xfd86, 0xfd08, 0xf4e6, 0xfce5, 0xfd05, 0xfd05, 0xfd46, 0xfda9, 0xfdec, 0xf5ac, 0xfe0f, 0xfecf, 0xff3a, 0xff54, 0x8b26, 0x2000, 0xde0a, 0xff78, 0xfeb3, 0xfe51, 0xf5ee, 0xfdec, 0xfdca, 0xfd87, 0xfd25, 0xfce3, 0xfd45, 0xfcc5, 0xfd48, 0xfd06, 0xfd25, 0xfd04, 0xf565, 0xfe8a, 0x8366, 0x20c3, 0x630f, 0x0800, 0x7aa4, 0xfecb, 0xac05, 0x1802, 0xed85, 0xfdc6, 0xfd44, 0xfce3, 0xfd25, 0xfda7, 0xfdc7, 0xed24, 0xf5a6, 0xed68, 0xdcea, 0xc3a7, 0x9a01, 0xa263, 0x9aa5, 0x3860, 0x626a, 0xff7e, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0x3943, 0x5101, 0xb307, 0xa261, 0xe467, 0xfd68, 0xfde9, 0xfd48, 0xeca5, 0xe4a3, 0xf524, 0xfd64, 0xf524, 0xfd45, 0xfdc8, 0xfde9, 0x9bc9, 0x1000, 0x7b02, 0xfee9, 0x8b03, 0x1023, 0xcefb, 0xc63a, 0x20a0, 0xee2e, 0xf587, 0xfd25, 0xfd67, 0xfd67, 0xfd47, 0xfda9, 0xf527, 0xfd05, 0xfce4, 0xfce5, 0xfdaa, 0xfe90, 0xfed3, 0xfeb6, 0xff36, 0xff7d, 0xffb8, 0x51e4, 0x1000, 0xb54a, 0xffbb, 0xff9a, 0xf6f7, 0xfeb4, 0xfed2, 0xfe4e, 0xfd68, 0xfce4, 0xfd03, 0xf505, 0xece5, 0xfdaa, 0xfd28, 0xfd67, 0xfd86, 0xfda7, 0xf609, 0xa403, 0x3948, 0xdf3f, 0x5ae8, 0x2840, 0xc4a8, 0xf66a, 0x2000, 0x38e0, 0xcd0a, 0xfe8b, 0xfd84, 0xfd42, 0xfd24, 0xfd27, 0xf4e9, 0xdc26, 0xed26, 0xf5c4, 0xfe25, 0xf524, 0xcb62, 0xb2e2, 0xa2c3, 0x1801, 0xa472, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x638e, 0x2080, 0xa2e6, 0xb2c1, 0xe423, 0xfd67, 0xe443, 0xc300, 0xc303, 0xd3c5, 0xecc6, 0xfd86, 0xfe07, 0xfde7, 0xdd45, 0xcca3, 0x7260, 0x1008, 0x0821, 0xddc5, 0xed89, 0x1000, 0x2124, 0xffff, 0xc659, 0x39a0, 0xf62e, 0xfe2c, 0xfd65, 0xfd47, 0xfd28, 0xf565, 0xfe4c, 0xfda9, 0xfd26, 0xfce4, 0xf4a4, 0xf549, 0xfe91, 0xff35, 0xff58, 0xff3a, 0xff9f, 0xd5f4, 0x0000, 0x0000, 0x4200, 0xffdf, 0xfffe, 0xef3a, 0xf717, 0xff35, 0xfe0e, 0xe4a5, 0xf483, 0xfd44, 0xed86, 0xfe6c, 0xfdec, 0xf549, 0xfd8a, 0xeca5, 0xf5a9, 0xfeef, 0xbc25, 0x4128, 0xf7ff, 0xb634, 0x1000, 0x71e0, 0xfeaa, 0x8ba2, 0x0002, 0x3923, 0x8304, 0xd525, 0xfe05, 0xfdc3, 0xfda5, 0xfd45, 0xec82, 0xc3a2, 0xa301, 0xb341, 0xfd26, 0xfd47, 0xc321, 0xb283, 0x6229, 0x2042, 0xbdb7, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0xf7de, 0xffff, 0x5b2c, 0x3040, 0xb2e6, 0xd324, 0xb2e2, 0x7a43, 0x4942, 0x7a22, 0xbb00, 0xf5a3, 0xfe45, 0xfde7, 0xd426, 0xc385, 0x9b24, 0x4183, 0x0026, 0x0042, 0x0803, 0x9ae3, 0xfdc7, 0x92c5, 0x0020, 0x7c90, 0xffdf, 0xd65b, 0x3122, 0xaccb, 0xff92, 0xf60b, 0xfdaa, 0xfe0b, 0xf4e6, 0xee4f, 0xfeb4, 0xfeb5, 0xf5ef, 0xe589, 0xa3e1, 0xfef2, 0xff78, 0xf7df, 0xffbe, 0xcdd3, 0x6222, 0x6221, 0x7b04, 0x51c0, 0x7b26, 0xef5b, 0xfffd, 0xff5b, 0xff35, 0xe586, 0xb423, 0xee30, 0xff11, 0xfe76, 0xfed5, 0xe58c, 0xedaa, 0xfe0a, 0xfe0b, 0xfeaf, 0xff12, 0x5a47, 0x5a46, 0xffff, 0xef9f, 0x10a5, 0x0800, 0xccc8, 0xfdc5, 0x2106, 0x0001, 0x0062, 0x1061, 0x6224, 0x9b65, 0xbc25, 0xdd29, 0xfdc7, 0xfe27, 0xcce4, 0x8ae3, 0x6964, 0x7146, 0x9a85, 0xab42, 0xbbc5, 0x7a03, 0x3000, 0xcd56, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffdf, 0xef9d, 0x31c7, 0x0000, 0x7225, 0x7263, 0x5982, 0x4084, 0x6165, 0xbc06, 0xfde8, 0xfde9, 0xa447, 0x49a6, 0x2066, 0x1022, 0x0800, 0x0802, 0x0002, 0x00c0, 0x0025, 0x30c1, 0xed48, 0xdca4, 0x38a0, 0x0883, 0x3a49, 0x7b4e, 0x634d, 0x18e3, 0x1040, 0x7306, 0xfef2, 0xff10, 0xfe2e, 0xfe10, 0xe56c, 0xfe72, 0xff16, 0xff98, 0xff15, 0x7b03, 0xa407, 0xffd7, 0xfffc, 0xbd2f, 0x6220, 0xbca8, 0xff51, 0xff30, 0xfecf, 0x9383, 0x72e5, 0xff18, 0xffda, 0xfed3, 0x7264, 0xa3ee, 0xff9d, 0xf6b8, 0xfed5, 0xfe51, 0xe5ac, 0xfe8f, 0xfe8e, 0xff32, 0xcdaf, 0x4160, 0x0000, 0x5a89, 0x630b, 0x636f, 0x2127, 0x20a1, 0x71e0, 0xfd46, 0x93e4, 0x0800, 0x0887, 0x00a6, 0x0000, 0x0801, 0x0801, 0x0822, 0x30e4, 0x82e5, 0xcc83, 0xfe06, 0xedc8, 0x8ae3, 0x50e0, 0x58e4, 0x5121, 0x830a, 0x28a1, 0x0000, 0x8c70, 0xffff, 0xffff, 0xff9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xdedc, 0x9d15, 0xd6dc, 0x31a6, 0x0801, 0x40e2, 0xbc24, 0xfe03, 0xdd63, 0x6221, 0x0802, 0x2800, 0x38e2, 0x6266, 0x6a85, 0x72a4, 0x8b67, 0x6266, 0x2062, 0x0803, 0xb426, 0xe505, 0x82a1, 0x2901, 0x1083, 0x0002, 0x0001, 0xefff, 0xefdf, 0xad97, 0x5289, 0x5265, 0xbd6f, 0xffd9, 0xf6b5, 0xfe71, 0xff14, 0xee94, 0xe6f8, 0xffde, 0x944e, 0x4980, 0xe5ee, 0x9c0c, 0x59c1, 0x8282, 0xed8b, 0xfe0c, 0xfdec, 0xf5ed, 0xc467, 0x61c0, 0x7a84, 0xcdad, 0x9ca7, 0x49e4, 0xde57, 0xffb7, 0xf774, 0xfeb2, 0xfe91, 0xfed1, 0xfed1, 0xff96, 0x83ca, 0x5268, 0x6b6d, 0xdefd, 0xffff, 0x7c0f, 0x0882, 0x0883, 0x1020, 0x61a1, 0xa2e2, 0xfda3, 0x6162, 0x0805, 0x3167, 0x6ae6, 0x9388, 0x8b26, 0x5a00, 0x49c0, 0x30e0, 0x1801, 0x3840, 0x9ae2, 0xfde8, 0xdda9, 0x62a0, 0x30c0, 0x0800, 0x8431, 0xb5f8, 0xadd6, 0xefdc, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79f, 0xffff, 0xffff, 0xffff, 0xad14, 0x3180, 0x93a6, 0xfe2b, 0xf566, 0x7a40, 0x1820, 0x18a0, 0x6324, 0xd4a8, 0xed67, 0xfe25, 0xfe24, 0xfe46, 0xd4c6, 0x61a3, 0x2003, 0x4901, 0xf5c6, 0xbbe2, 0x4165, 0x0041, 0x0000, 0x1003, 0x10a4, 0x4acd, 0x94d4, 0xc659, 0xffff, 0x736e, 0x3145, 0xe6f9, 0xffd9, 0xfe94, 0xfeb5, 0xf6f8, 0xf75b, 0xffff, 0xd679, 0x20a0, 0x28c0, 0x1800, 0x2800, 0x9304, 0xbbc5, 0xd467, 0xf56b, 0xbbc6, 0xab65, 0x8262, 0x2000, 0x28a0, 0x0020, 0x5aec, 0xffff, 0xf739, 0xff35, 0xff76, 0xf693, 0xff35, 0xfff9, 0x9c8d, 0x2122, 0xadd7, 0xe7bf, 0xb5d8, 0x8410, 0x39c6, 0x0020, 0x0021, 0x0021, 0x4123, 0x71e5, 0xfd43, 0xcc4a, 0x1801, 0x2040, 0x9323, 0xe4c4, 0xfde4, 0xfec4, 0xfe2a, 0xdd49, 0xa3a7, 0x59c5, 0x1000, 0x2020, 0x9bc4, 0xfeaa, 0xd585, 0x6220, 0x624a, 0xf75f, 0xffff, 0xfffd, 0xfffd, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7bf, 0xffdf, 0xffff, 0xe6ba, 0x72a8, 0x5182, 0xed01, 0xfee8, 0xb404, 0x2000, 0x1024, 0x7308, 0xd568, 0xfe26, 0xed83, 0xf5a4, 0xfdc7, 0xdc87, 0x8264, 0x38e0, 0x0800, 0x0021, 0xc4a6, 0xfe26, 0x92e4, 0x2088, 0x428b, 0x840e, 0x41a7, 0x0000, 0x0000, 0x4228, 0x632c, 0x3166, 0x3967, 0x20a4, 0x0800, 0xdeb5, 0xfffc, 0xf73a, 0xff3a, 0xf719, 0xff7a, 0xfffd, 0x52ca, 0x0001, 0x1820, 0xbccc, 0xfeb0, 0xfe4d, 0xfe4c, 0xfe2c, 0xfe4e, 0xfe8f, 0xee0b, 0x7b04, 0x0800, 0x0000, 0xa594, 0xffff, 0xff3f, 0xff1b, 0xef39, 0xfffb, 0xfffb, 0x944d, 0x0000, 0x4a47, 0x2145, 0x31e9, 0x6b0c, 0x1881, 0x0800, 0x0020, 0x530c, 0x6baf, 0x2905, 0x38e4, 0xc442, 0xe62b, 0x6b04, 0x0800, 0x2041, 0x69c1, 0x92a1, 0xe50a, 0xfd26, 0xfde5, 0xfdc2, 0xee27, 0xbd2b, 0x4963, 0x2000, 0x61a6, 0xfd85, 0xfe8c, 0x92e3, 0x61c4, 0x9c51, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffbf, 0xcdf7, 0x4120, 0x7a21, 0xed8c, 0xfde4, 0xab86, 0x1822, 0x30e3, 0xbca5, 0xfe22, 0xfdc4, 0xfd08, 0xfdca, 0xed29, 0x8a43, 0x3020, 0x28c6, 0x1083, 0x18e0, 0x8409, 0xfe67, 0xed88, 0x3880, 0x0802, 0x83f0, 0xffdd, 0xef1b, 0x6b8d, 0x0000, 0xa4d2, 0xffdf, 0x524a, 0x3964, 0xde57, 0x6287, 0x1860, 0xad94, 0xffde, 0xfffe, 0xff7a, 0xfffb, 0xfffc, 0x4a69, 0x0023, 0x5223, 0xe652, 0xff13, 0xfe6f, 0xfe4e, 0xf5ed, 0xfe70, 0xfef3, 0xff70, 0xbd0b, 0x1020, 0x0860, 0x9d4d, 0xfffb, 0xff3c, 0xff9a, 0xf7de, 0xffde, 0x6b4b, 0x18a0, 0xa4b0, 0xacf2, 0x0000, 0xe71b, 0xffde, 0x49e6, 0x1040, 0xad53, 0xf7ff, 0xf7ff, 0x2104, 0x1000, 0x92c2, 0xfe89, 0xddc7, 0x5a03, 0x0803, 0x1883, 0x30e1, 0x3061, 0xcba3, 0xecc8, 0xfd68, 0xfd84, 0xfdc2, 0xfdc6, 0x93a7, 0x0001, 0x78e0, 0xe485, 0xfe46, 0xdce4, 0x50e0, 0x59ea, 0xf7bf, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79f, 0xdedb, 0x1820, 0x8262, 0xed07, 0xfd45, 0xcca8, 0x3060, 0x2881, 0xc489, 0xfe07, 0xfd03, 0xfd05, 0xf5e7, 0x9aa1, 0x5880, 0x7182, 0x9304, 0x59e1, 0x4942, 0x9346, 0xf627, 0xfe26, 0x82c5, 0x2060, 0x30c0, 0x2040, 0x5269, 0xffff, 0xffff, 0x5ac9, 0x0000, 0xdedc, 0xd67a, 0x1020, 0xc5b3, 0xd636, 0x1020, 0x0020, 0x9d11, 0xef9b, 0xfffd, 0xffde, 0x8c0f, 0x0800, 0x0800, 0x2040, 0x4940, 0x7a62, 0x8a60, 0xa302, 0xab64, 0x8262, 0x8a84, 0x69a3, 0x48e3, 0x1800, 0x0800, 0x3183, 0xdebb, 0xffbf, 0xfffd, 0xe75c, 0x4a88, 0x1060, 0x41a5, 0xff3b, 0x732b, 0x2903, 0xffff, 0x634c, 0x0000, 0xad14, 0xffff, 0xdf3b, 0x0020, 0x1000, 0x40a0, 0x4080, 0xdcc6, 0xfe46, 0xdcc5, 0x7aa4, 0x49a2, 0x7aa5, 0x8a43, 0x3923, 0x6981, 0xd3a4, 0xfd66, 0xfd02, 0xf5c5, 0xe5e7, 0x8b20, 0x1800, 0x8242, 0xe503, 0xecc2, 0xcc05, 0x6163, 0x3966, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79f, 0x20e3, 0x6204, 0xd4a8, 0xe461, 0xfce0, 0x7187, 0x3000, 0xaba4, 0xf62a, 0xe543, 0xfde5, 0xdc87, 0x7902, 0x5a22, 0xbca7, 0xed8a, 0x9aa3, 0x60e0, 0xab62, 0xf5a6, 0xfd86, 0xf5c8, 0x2861, 0x62a8, 0xbd27, 0x8b05, 0x1883, 0x4aab, 0xffdf, 0xffff, 0x29a6, 0x0040, 0xe71a, 0xa4d3, 0x3986, 0x5a89, 0x3962, 0x734b, 0x2982, 0x2a03, 0x744f, 0x4acd, 0x0802, 0x5a05, 0xb469, 0xb4ab, 0xb489, 0xbc46, 0xdca6, 0xed27, 0xed28, 0xe4e8, 0xcc67, 0xbc27, 0xb40a, 0xc50b, 0x9405, 0x20a1, 0x0824, 0x7411, 0x638e, 0x20e1, 0x5a88, 0x5a67, 0x4184, 0x6289, 0x49e7, 0xeefb, 0x8c30, 0x0040, 0xa576, 0xffff, 0xce9a, 0x18e1, 0x4a03, 0xb44b, 0xc409, 0x0043, 0x8283, 0xfda6, 0xfe05, 0xdd48, 0x6a23, 0x6920, 0xebc7, 0xd629, 0x8ba4, 0x4920, 0x8a85, 0xf54b, 0xfda7, 0xfd44, 0xfdc6, 0x3208, 0x2081, 0xab48, 0xfcc9, 0xe444, 0xc425, 0x2880, 0x7bd0, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xfffe, 0x8350, 0x40a0, 0xbbc2, 0xbb62, 0xfda6, 0xc324, 0x20e0, 0x7ae4, 0xed47, 0xfda5, 0xfd67, 0xc3e6, 0x8200, 0xab80, 0xfde8, 0xfe29, 0x8a43, 0x58c1, 0xcc83, 0xfe42, 0xfd84, 0xfda9, 0x5285, 0x1002, 0x7ac4, 0xfe27, 0xfe8b, 0xedca, 0x6b01, 0x52a9, 0xdeda, 0xffff, 0x5b4d, 0x1946, 0x5b4d, 0x31e7, 0x08c2, 0x29c5, 0x4145, 0x1922, 0x0040, 0x0000, 0x1000, 0x2880, 0x72a4, 0xabe6, 0xdd8c, 0xfe72, 0xfef1, 0xfeb2, 0xfe50, 0xfe6e, 0xfeb3, 0xfe6f, 0xfef3, 0xeeb2, 0xbd4a, 0x9385, 0x61a3, 0x1840, 0x0000, 0x0003, 0x1040, 0x20e3, 0x3986, 0x28e4, 0x20a2, 0x5248, 0x5229, 0x3126, 0xc658, 0xffdf, 0x9cb3, 0x49e2, 0x9c45, 0xfeab, 0xfeca, 0xf564, 0x2103, 0x0001, 0xb425, 0xfd85, 0xfda6, 0xfdc5, 0xaae0, 0x5120, 0xc403, 0xfe4b, 0xed08, 0x89e0, 0xa282, 0xe4e5, 0xfda6, 0xfd88, 0xe585, 0x38e4, 0x79a5, 0xdc84, 0xdd09, 0xcb22, 0xd342, 0x0800, 0xd6da, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffde, 0xff9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xcf1d, 0x3082, 0x9281, 0x9301, 0xed08, 0xe422, 0x8a03, 0x30a2, 0xc4c7, 0xfe25, 0xfd45, 0xd3e4, 0xb341, 0xdcc5, 0xfdc9, 0xfde8, 0x92a0, 0x8200, 0xe4aa, 0xfd89, 0xf582, 0xf5a5, 0xab65, 0x0840, 0x0801, 0x72e3, 0xfe68, 0xfdaa, 0xfed1, 0xf6b0, 0x9cad, 0x52a8, 0xbdd5, 0xf79d, 0xb595, 0x5acb, 0x4a49, 0x41e7, 0x0841, 0x0822, 0x18e6, 0x00a5, 0x0021, 0x6a03, 0xcbe5, 0xa303, 0x4181, 0x2840, 0x61c0, 0xe5e9, 0xfe0c, 0xfeb1, 0xfe90, 0xfdee, 0xfe8b, 0xdcc4, 0x2040, 0x1080, 0x6a80, 0xbba5, 0x9ae6, 0x4963, 0x0021, 0x1102, 0x08a1, 0x0040, 0x1924, 0x3a28, 0x4aca, 0x7c31, 0xce7b, 0xdf1c, 0x842f, 0x62e7, 0xbd6f, 0xff54, 0xfe2e, 0xfd69, 0xfd26, 0x18e3, 0x0002, 0x3060, 0xed66, 0xfda4, 0xf506, 0xfd8a, 0xbc26, 0x7160, 0xd465, 0xfde8, 0xfdc7, 0xc3a3, 0xaae2, 0xece7, 0xf544, 0xfe06, 0x82a5, 0x3840, 0xa321, 0xfd46, 0xd3a6, 0xab24, 0x5140, 0x6b6c, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0x7436, 0x3080, 0xbb62, 0x9b85, 0xfdea, 0xdba4, 0x48a1, 0x7206, 0xed86, 0xfdc3, 0xdba1, 0xd3c5, 0xed24, 0xfda5, 0xfdab, 0xbb80, 0xa2c1, 0xd485, 0xfd87, 0xfd07, 0xfd87, 0xb423, 0x2880, 0x0802, 0x1043, 0x5a41, 0xf66a, 0xfdec, 0xfdcf, 0xfef1, 0xff33, 0xc6b8, 0x52e9, 0x4207, 0x83f0, 0x94b4, 0x73b0, 0x39e9, 0x0863, 0x00c6, 0x0825, 0x2064, 0x4941, 0x8ae1, 0xc3c4, 0xdcca, 0xfef4, 0xacf2, 0xb4ce, 0xdd87, 0xe4e5, 0xf508, 0xf506, 0xe4c7, 0xe524, 0xbc66, 0x9bac, 0xf696, 0xf60c, 0xd4c8, 0x9b66, 0x7263, 0x3860, 0x0084, 0x00a5, 0x0064, 0x2147, 0x4aac, 0x7412, 0x8c73, 0x632e, 0x3146, 0x9c8e, 0xff75, 0xff54, 0xf5af, 0xfdae, 0xfe6e, 0xe485, 0x08a3, 0x1084, 0x0003, 0x6200, 0xfd64, 0xfca8, 0xfd89, 0xf586, 0xd429, 0x9a40, 0xe4c4, 0xfe03, 0xfd64, 0xec68, 0xc322, 0xf4e2, 0xfdc6, 0xcc44, 0x3080, 0x7222, 0xfce3, 0xdca8, 0x8b68, 0x9ae3, 0x1880, 0xdefb, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0x39cb, 0x7240, 0x8a20, 0xc447, 0xf5a7, 0xb328, 0x4080, 0xc425, 0xfdc7, 0xfd04, 0xe404, 0xe484, 0xfdc4, 0xfdc7, 0xc345, 0xbb61, 0xdca7, 0xfde8, 0xfd43, 0xfce5, 0xf4a6, 0x7222, 0x0002, 0x2083, 0x0802, 0x3982, 0xe62d, 0xfdeb, 0xfd2a, 0xfe0d, 0xfef0, 0xf798, 0xd632, 0x9beb, 0x834a, 0x49a5, 0x0800, 0x1840, 0x4982, 0x3960, 0x1000, 0x3020, 0xab65, 0xe5aa, 0xcd6c, 0xac28, 0x8220, 0xfffe, 0xff9b, 0xabc4, 0xed06, 0xfd04, 0xfd22, 0xfd27, 0xb380, 0xa46c, 0xff9a, 0xe5f1, 0x8a82, 0xbc6a, 0xde2d, 0xc4e8, 0x9222, 0x0800, 0x2881, 0x4123, 0x30c1, 0x0800, 0x1860, 0x6aa7, 0x936a, 0xb451, 0xee53, 0xff33, 0xfe6f, 0xfdcc, 0xfe0b, 0xfdea, 0xbbe4, 0x0043, 0x1063, 0x0005, 0x28e1, 0xbb60, 0xfd08, 0xf4e6, 0xfd63, 0xfdaa, 0xdc67, 0xb300, 0xd440, 0xfde6, 0xfd25, 0xe444, 0xf4c5, 0xfd65, 0xfdc5, 0x7ac2, 0x4902, 0xe403, 0xfe08, 0x8b87, 0x9b23, 0x2080, 0xad13, 0xf7df, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xce9b, 0x40c3, 0x7aa2, 0x69a0, 0xfd47, 0xed45, 0x5123, 0x7a02, 0xfe06, 0xfd66, 0xfce5, 0xfd04, 0xfda6, 0xfd87, 0xdc45, 0xc323, 0xfd2a, 0xf546, 0xfd44, 0xfd43, 0xfd64, 0xdc27, 0x61c6, 0x0862, 0x4143, 0x1042, 0x18a5, 0x7b27, 0xdd05, 0xfda7, 0xfd6a, 0xed6a, 0xfe2b, 0xfda9, 0xfd08, 0xecc9, 0xb385, 0xa343, 0xd485, 0xdc41, 0xecc0, 0xd4e8, 0x9347, 0x82c4, 0x8ae0, 0xcd89, 0xffd5, 0xb44b, 0x6bcd, 0x942e, 0x8b03, 0xfdcb, 0xfdc9, 0xfe28, 0xfe6d, 0xcca5, 0x8326, 0xa4f2, 0x6b6b, 0xde33, 0xff75, 0xb464, 0x72a0, 0x8285, 0xb3e3, 0xdcc5, 0xf547, 0xd464, 0xb405, 0x9302, 0xab83, 0xf549, 0xf56c, 0xfe6d, 0xfe0b, 0xf528, 0xfd45, 0xfda5, 0xb445, 0x51c4, 0x0003, 0x3144, 0x10c2, 0x28c5, 0x9a63, 0xf4c3, 0xf546, 0xfd42, 0xece5, 0xfdc8, 0xd423, 0xc343, 0xe486, 0xfd65, 0xfd85, 0xeca3, 0xf525, 0xfe26, 0xd565, 0x3861, 0xa2e4, 0xfea6, 0xab64, 0x6a21, 0x59c4, 0x730a, 0xf79e, 0xffff, 0xffdf, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x9cd6, 0x50c0, 0x6a22, 0x6a01, 0xfe28, 0xd462, 0x3900, 0xe52a, 0xfe0a, 0xbb80, 0xed03, 0xfe06, 0xed48, 0xcc28, 0xbb42, 0xfce3, 0xfd69, 0xfd44, 0xfd24, 0xf4a2, 0xfe27, 0xcc49, 0x2800, 0x4141, 0x8ae6, 0x28a2, 0x0004, 0x1860, 0xd4c3, 0xfda4, 0xf485, 0xf568, 0xf4a2, 0xfd05, 0xfcc6, 0x9240, 0x48e0, 0x8b03, 0xe527, 0xfe26, 0xf4e3, 0xfe25, 0xfe49, 0xee31, 0x7306, 0x41a0, 0xc529, 0xee73, 0x0000, 0x1840, 0xc529, 0xfeb1, 0xfdf0, 0xfe2f, 0xfe71, 0xfeee, 0x7306, 0x0800, 0x49e4, 0xff93, 0x7b02, 0x2080, 0xb488, 0xfecf, 0xfe68, 0xf501, 0xfd42, 0xfda7, 0xe52a, 0x71e1, 0x6100, 0xbb65, 0xf4c2, 0xed01, 0xed03, 0xfd67, 0xfd65, 0xed43, 0x8304, 0x0005, 0x0801, 0x51c3, 0x7b45, 0x2001, 0x6964, 0xe545, 0xfda7, 0xfce2, 0xfd49, 0xf522, 0xfda3, 0xdc46, 0xc347, 0xe4a7, 0xf585, 0xfdc5, 0xcc23, 0xc442, 0xfea9, 0x92e7, 0x79e1, 0xfd61, 0xe486, 0x4160, 0x69e4, 0x51c5, 0xffbe, 0xffff, 0xf7be, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x8c13, 0x4920, 0x5962, 0x82a2, 0xfdc7, 0xb360, 0xa3e3, 0xfe2b, 0x9b26, 0xaba1, 0xeda4, 0xfe09, 0x9b23, 0x92c1, 0xfd47, 0xfd63, 0xf545, 0xfce4, 0xfcc4, 0xfd44, 0xedc9, 0x7283, 0x2800, 0xa325, 0x9285, 0x28c0, 0x10a5, 0x20a0, 0xdd45, 0xfd44, 0xfce7, 0xfda5, 0xfda7, 0xfd69, 0xa304, 0x2860, 0x0862, 0x1923, 0x5a21, 0xcca6, 0xee53, 0xed05, 0xeca0, 0xfeaf, 0xf6f7, 0x8389, 0x7ac1, 0xe589, 0x3942, 0x1000, 0xcdad, 0xff99, 0xfef9, 0xfef8, 0xf6b6, 0xff93, 0x5aa6, 0x1000, 0x9b43, 0xd505, 0x6262, 0xbe16, 0xfff6, 0xfd02, 0xd509, 0xfe0c, 0xfe0b, 0x9b03, 0x4942, 0x1842, 0x28a3, 0x3881, 0xfca7, 0xfda5, 0xfda4, 0xfd05, 0xfd05, 0xfdc7, 0x8b86, 0x0005, 0x30c1, 0x5160, 0xab84, 0x79e2, 0x2820, 0xc4c9, 0xfde8, 0xfd03, 0xfcc7, 0xfd65, 0xfd43, 0xfde9, 0xcc26, 0x9281, 0xd4e7, 0xf629, 0xd4a4, 0x8300, 0xbc66, 0xf5aa, 0xa2a0, 0xd3e2, 0xfda9, 0x51a1, 0x6161, 0x5183, 0xef3c, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x8370, 0x3100, 0x48c1, 0xbc26, 0xed68, 0xb3a3, 0xfe25, 0x9b40, 0x4081, 0xf62c, 0xee07, 0x7a40, 0x82c3, 0xdd66, 0xfe04, 0xfce2, 0xf582, 0xfd28, 0xfcc4, 0xfe67, 0x8b43, 0x28c0, 0xb428, 0xcb85, 0x68e0, 0x8b68, 0x5b0b, 0x0000, 0xdd46, 0xfd47, 0xfce7, 0xfda1, 0xfd45, 0xbb40, 0x4020, 0x6acc, 0xefff, 0xefff, 0xbd32, 0x9b04, 0xff3a, 0xffdb, 0xfe70, 0xcc41, 0xfe8f, 0xff18, 0xbc6b, 0xfe29, 0xeeb2, 0x51c3, 0x9c2c, 0xff9d, 0xff7d, 0xfffc, 0xffdd, 0xef57, 0x6182, 0x9387, 0xff70, 0xcce7, 0xe591, 0xffd8, 0xccc6, 0xfd47, 0xff39, 0xffd9, 0xdd4d, 0x8348, 0xd71c, 0xe7ff, 0xa619, 0x2163, 0x7020, 0xd404, 0xfda6, 0xfd06, 0xfd07, 0xfda7, 0x8343, 0x0020, 0x9bea, 0x7a61, 0x9a00, 0xdc45, 0x6a85, 0x30c0, 0xed04, 0xfd65, 0xfd04, 0xfce7, 0xfd47, 0xf563, 0xf5c5, 0xc445, 0x7220, 0x9b84, 0xfeac, 0x9be5, 0x3080, 0xfda4, 0xfca2, 0xd3a8, 0xeda8, 0x7a42, 0x6120, 0x59a4, 0xd659, 0xef9e, 0xffff, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x7b90, 0x2000, 0x4941, 0xf4c9, 0xfcc4, 0xfda8, 0xcbea, 0x1800, 0xa488, 0xac6a, 0x5120, 0x8220, 0xfd8a, 0xfd87, 0xf525, 0xfd46, 0xfd68, 0xed63, 0xf60a, 0x8ae9, 0x59a1, 0xd543, 0xf565, 0xaa04, 0x2883, 0xbc85, 0xedc7, 0x4900, 0xabc9, 0xfdc4, 0xfdc4, 0xd4ab, 0x18c3, 0x0000, 0x8410, 0xffff, 0xffff, 0xffdf, 0xffff, 0xd69a, 0xe717, 0xffdf, 0xffbf, 0xff9b, 0xcdac, 0xfef0, 0xfe6d, 0xfd26, 0xffde, 0xff37, 0xcd4c, 0xf672, 0xff79, 0xff1a, 0xff58, 0xfd8f, 0xd5a9, 0xff7b, 0xfeaf, 0xfe26, 0xff52, 0xe60c, 0xe6af, 0xff5f, 0xffdf, 0xffdf, 0xd69a, 0xf79e, 0xffff, 0xffdf, 0xffdf, 0xe73c, 0x31ea, 0x0000, 0x59e3, 0xfded, 0xfd43, 0xfde7, 0x69c0, 0x5a04, 0xeee9, 0x6a62, 0x5863, 0xdb66, 0xfd64, 0x93a3, 0x5182, 0xcc49, 0xfe0a, 0xfd87, 0xf504, 0xfd24, 0xfd46, 0xfdc9, 0xd4c7, 0x5940, 0x61e5, 0xcd4e, 0x6a03, 0x50a0, 0xed2a, 0xfd87, 0xec87, 0xc2c4, 0x48c3, 0x30c4, 0xbdb8, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x7baf, 0x0800, 0x4981, 0xe4e9, 0xfda7, 0xeca5, 0x69a1, 0x1083, 0x7a89, 0x3020, 0x8260, 0xf5c9, 0xfda7, 0xfd65, 0xfd86, 0xf504, 0xfce5, 0xcc25, 0x7a40, 0x9b83, 0xe5a7, 0xf5c7, 0xcc27, 0x7142, 0x4942, 0xe568, 0xfe49, 0x7a42, 0xabc6, 0xfe27, 0xf586, 0x5960, 0x0841, 0xad55, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xef3d, 0xde7a, 0xe674, 0xe60b, 0xed89, 0xcbc6, 0xccc7, 0xf608, 0xfe25, 0xfe46, 0xee29, 0xe5c9, 0xf608, 0xed83, 0xe5ef, 0xedee, 0xc449, 0xbc26, 0xdd88, 0xfef0, 0xde36, 0xe69b, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xe77f, 0x73ad, 0x2040, 0xa345, 0xfe28, 0xf566, 0x8a61, 0xac4a, 0xfec9, 0x9362, 0x4881, 0x9205, 0xed25, 0xfe48, 0xbc46, 0x8260, 0xa341, 0xd485, 0xfd88, 0xfd87, 0xf4e4, 0xfd46, 0xfdc9, 0xe528, 0x58a0, 0x41a3, 0x4205, 0x3020, 0x9a83, 0xf564, 0xfe67, 0xcb44, 0x3040, 0x1000, 0xb5b8, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0x6b6e, 0x0020, 0x7283, 0xf5ca, 0xfd05, 0xbb01, 0x4982, 0x0063, 0x2800, 0x8243, 0xf5aa, 0xfe28, 0xf545, 0xfd46, 0xfd46, 0xfda8, 0xf447, 0xbb63, 0xccc8, 0xedc9, 0xfda4, 0xfda6, 0xa325, 0x2823, 0xac05, 0xfdc8, 0xfdc9, 0xc427, 0xc446, 0xfe07, 0xc486, 0x1000, 0xad55, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xe73c, 0xffff, 0xffff, 0xe73c, 0xe71b, 0xffff, 0xb597, 0x734a, 0xc52c, 0xbc89, 0xb3aa, 0x61c5, 0x7223, 0x7a62, 0x6200, 0x4961, 0x3101, 0x4181, 0x7305, 0x8285, 0x69e0, 0x8265, 0xbc0e, 0xd5aa, 0x8b86, 0x7310, 0xffdf, 0xffff, 0xdedb, 0xffff, 0xffff, 0xffff, 0xd69a, 0xffdf, 0xffff, 0xffff, 0xe73b, 0x3164, 0x40c0, 0xfe0a, 0xf566, 0xbba4, 0xdd0a, 0xfdc8, 0xf605, 0x7223, 0x48e7, 0xc465, 0xfde2, 0xfe09, 0xddc8, 0xa363, 0xc445, 0xed27, 0xfd46, 0xfd45, 0xfd66, 0xfda7, 0xfe09, 0xecc7, 0x4940, 0x0881, 0x20c3, 0x7a44, 0xab20, 0xfda4, 0xed08, 0x38c0, 0x0800, 0xbe39, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xffff, 0x52ee, 0x0020, 0xc3a4, 0xfda9, 0xc3c3, 0x8a23, 0x3122, 0x2062, 0x8a40, 0xf56a, 0xfdc9, 0xfd67, 0xfd69, 0xf4e8, 0xf528, 0xf568, 0xfce9, 0xfdaa, 0xfdc8, 0xf566, 0xfe2a, 0xd446, 0x2820, 0x522b, 0xfe49, 0xfd86, 0xfd06, 0xfd8a, 0xed87, 0xfde8, 0x82c3, 0x20e5, 0xffff, 0xffff, 0xf7be, 0xffff, 0xbdf7, 0xb596, 0xffff, 0xf79e, 0xbe15, 0x8cb4, 0xf7df, 0xffff, 0x5ac8, 0x0800, 0x5184, 0xbcaf, 0xd577, 0xac30, 0x82e8, 0x6205, 0x6228, 0x5209, 0x4186, 0x5a68, 0x8b26, 0xbc8b, 0xe594, 0x9b6d, 0x3900, 0x0800, 0xc5fa, 0xf7bf, 0xd6ba, 0xad55, 0xf7be, 0xffff, 0xffdf, 0xbdd7, 0xef5d, 0xffff, 0xef7e, 0xffff, 0xa535, 0x1820, 0xc4c7, 0xfe09, 0xfd69, 0xfd88, 0xfd26, 0xfe25, 0xdd8d, 0x2084, 0x59c2, 0xf566, 0xfde8, 0xe5c7, 0xfe0c, 0xf58a, 0xfda9, 0xfd47, 0xfd26, 0xf526, 0xed06, 0xfde9, 0xfe47, 0xcbe3, 0x48e1, 0x0062, 0x5243, 0xaae3, 0xec28, 0xf5aa, 0x6a44, 0x0800, 0xb617, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0x31cb, 0x2820, 0xfc04, 0xec24, 0x9306, 0x5986, 0x0800, 0x81e5, 0xc442, 0xfe0b, 0xf52a, 0xd3e5, 0xd3e3, 0xecc5, 0xfdea, 0xf569, 0xfda5, 0xfdaa, 0xf506, 0xfe89, 0xdcc8, 0x4862, 0x1000, 0x840b, 0xfeca, 0xfd46, 0xfce6, 0xfd89, 0xf5a7, 0xfe2a, 0x51a0, 0x6350, 0xffff, 0xf7be, 0xffff, 0xffff, 0xf79e, 0xdedb, 0xd69a, 0xffff, 0xf7fd, 0xbe1a, 0x94d6, 0xffff, 0xce78, 0x1042, 0x49c8, 0x28c2, 0xa348, 0xd50d, 0xed8e, 0xe4eb, 0xe4ac, 0xecee, 0xe50e, 0xdd0d, 0xddd1, 0xc512, 0x59a6, 0x4123, 0x28e4, 0x39c7, 0xffff, 0xdf3f, 0xa534, 0xdefb, 0xffff, 0xffdf, 0xbdf7, 0xf79e, 0xffff, 0xffff, 0xffff, 0xefbd, 0xf7df, 0x3123, 0xa3e5, 0xfe09, 0xfd68, 0xfd45, 0xfd66, 0xfd46, 0xfe4e, 0x41e5, 0x1001, 0x7a03, 0xfdeb, 0xed88, 0xfd88, 0xed06, 0xfd67, 0xfd67, 0xf506, 0xdca6, 0xc424, 0xcc65, 0xfe06, 0xfd27, 0xc307, 0x38c2, 0x0840, 0x7a06, 0xb265, 0xfd27, 0xa388, 0x1000, 0x8c90, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xe71c, 0x2063, 0x9264, 0xfbc5, 0xbac2, 0x51a4, 0x1864, 0x4903, 0xcb06, 0xab64, 0xab04, 0xbb85, 0xdc25, 0xfd65, 0xfda5, 0xf525, 0xfdeb, 0xed85, 0xed24, 0xfe6b, 0xf54a, 0x48c0, 0x51a4, 0x6ae9, 0x5286, 0xee6c, 0xf526, 0xfd46, 0xfd47, 0xf587, 0xfe2b, 0x4120, 0x84d5, 0xffdf, 0xa534, 0xf7be, 0xffff, 0xffff, 0xf7be, 0xa534, 0xf7be, 0xf7df, 0xf7de, 0xc658, 0xffff, 0xffff, 0x630a, 0x18c2, 0x2927, 0x1000, 0x5a24, 0xa40b, 0xccae, 0xd42c, 0xcbeb, 0xd48e, 0xcc8e, 0x836b, 0x28a2, 0x1840, 0x49e7, 0x1883, 0xad76, 0xffff, 0xdefd, 0xc638, 0xffff, 0xffdf, 0xdedb, 0xbdd7, 0xf7be, 0xffff, 0xffff, 0xe6fc, 0xad75, 0xf7ff, 0x41a6, 0x9bc4, 0xfe4a, 0xfd88, 0xfd86, 0xfd88, 0xfdc7, 0xcd0d, 0x49e7, 0x7348, 0x38a0, 0x8a25, 0xfe8c, 0xfd86, 0xfd25, 0xfd67, 0xfda9, 0xfdeb, 0xfdcb, 0xdce8, 0xc425, 0xb381, 0xbb05, 0xc326, 0xaae7, 0x2821, 0x3924, 0x7a62, 0xcb42, 0xcc09, 0x4080, 0x62c9, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xa534, 0x4860, 0xc388, 0x9a83, 0x69c3, 0x1861, 0x10a2, 0x9b29, 0xa241, 0x6980, 0xa345, 0xf58c, 0xfde9, 0xfd86, 0xfe08, 0xfdc9, 0xed07, 0xfd6a, 0xfe89, 0xccc6, 0x50e0, 0x7264, 0xff2f, 0x7b84, 0x28e7, 0xe6b3, 0xed48, 0xfd86, 0xfda8, 0xfda9, 0xfe2c, 0x4960, 0x6c10, 0xffff, 0xce59, 0xffff, 0xffff, 0xf79e, 0xffff, 0xef5d, 0xbdf7, 0xf7bf, 0xffdd, 0xfffd, 0xffff, 0xffff, 0xd6b8, 0x0000, 0x0022, 0x08e2, 0x0060, 0x10e1, 0x6287, 0x8b29, 0x82e7, 0x72e7, 0x4a25, 0x1061, 0x0000, 0x1061, 0x0000, 0x4a89, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xdedb, 0xc618, 0xffff, 0xffdf, 0xffff, 0xffff, 0xef3d, 0xdf1b, 0xffff, 0x3964, 0xa3c4, 0xfde9, 0xfd89, 0xfd87, 0xfd67, 0xf66a, 0xb534, 0x1001, 0xeeac, 0xd5ab, 0x3040, 0x8301, 0xfda9, 0xfe2b, 0xfda9, 0xed27, 0xf569, 0xfdaa, 0xfdea, 0xfdea, 0xd4e7, 0x8a83, 0x7140, 0xb305, 0x71e5, 0x0000, 0x2900, 0x7223, 0xbaa3, 0x8a03, 0x51c5, 0xef5d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf79e, 0x6b6d, 0x91a0, 0x89e2, 0x2900, 0x1061, 0x1082, 0x5287, 0x8a44, 0x58e0, 0xcceb, 0xfe6e, 0xeda8, 0xfde9, 0xfdcb, 0xf4e9, 0xfd8b, 0xfd69, 0xfda9, 0xdd2a, 0x6264, 0x838a, 0xee8d, 0xff29, 0x5a80, 0x1067, 0xf79a, 0xf60c, 0xfda6, 0xfda9, 0xfd8a, 0xfe2c, 0x6220, 0x4aea, 0xffff, 0xffff, 0xad55, 0xd6ba, 0xffff, 0xffdf, 0xffff, 0x8c51, 0xdefa, 0xffff, 0xffff, 0xffdc, 0xfffd, 0xffff, 0x73f0, 0x0060, 0x3168, 0x1885, 0x20a4, 0x4925, 0x5103, 0x5943, 0x5183, 0x2901, 0x0882, 0x2146, 0x10e2, 0x0080, 0xd71b, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xad75, 0x9cf3, 0xffff, 0xffff, 0xef7d, 0xb596, 0xd67b, 0xffff, 0xe71d, 0x3923, 0xc4c8, 0xfe09, 0xfdaa, 0xfde9, 0xfd00, 0xff77, 0xa578, 0x0800, 0xcd05, 0xff2a, 0xde6e, 0x51e4, 0xb382, 0xfdab, 0xfdab, 0xed49, 0xfda9, 0xfd68, 0xfd67, 0xfd87, 0xf66b, 0xee4d, 0x9b25, 0x58e0, 0x8ae4, 0x4165, 0x0824, 0x0082, 0x8060, 0xb2e7, 0x4102, 0xce18, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xa534, 0x18c3, 0x3123, 0x5249, 0x20e3, 0x2942, 0x4a05, 0x4122, 0x5160, 0xdd66, 0xfe4c, 0xf589, 0xfdaa, 0xfd69, 0xfd8a, 0xfdca, 0xf507, 0xfda9, 0xfe08, 0xb424, 0xb468, 0xfe50, 0xfdcc, 0xed8a, 0x28c0, 0x0004, 0xb5ba, 0xffd8, 0xdd25, 0xfdc7, 0xfd88, 0xfe0c, 0xbc8a, 0x4142, 0xf7df, 0xffff, 0xd6db, 0xdefb, 0xf79d, 0xffff, 0xf79d, 0xffff, 0xdedb, 0xbdf7, 0xffff, 0xffff, 0xffdf, 0xffff, 0xdedb, 0x39c7, 0x0820, 0x5a69, 0x3124, 0x28c2, 0x5a68, 0x5a48, 0x49e6, 0x20a1, 0x5228, 0x2923, 0x1061, 0x8c30, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xd69a, 0xf79e, 0xffff, 0xffdf, 0xffff, 0xf79e, 0xdedb, 0xe79d, 0xffff, 0xa4f1, 0x41a1, 0xf670, 0xf5aa, 0xfd88, 0xfd67, 0xe611, 0xffd9, 0x52ad, 0x0803, 0x7b26, 0xeeec, 0xf68b, 0xfdc9, 0xabe3, 0xcc85, 0xfe0a, 0xfd88, 0xfd88, 0xfdaa, 0xf52b, 0xfdae, 0xfd28, 0xfe0c, 0xfe2d, 0x9ba5, 0x4140, 0x4184, 0x5185, 0x40e0, 0x3166, 0x39c7, 0x10a2, 0x39e7, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xc618, 0x8430, 0xcdd7, 0xe6fb, 0x5aa9, 0x4a05, 0x1840, 0x59a2, 0xdd4b, 0xfe8c, 0xf589, 0xfdca, 0xfdca, 0xfdcb, 0xfd69, 0xfd48, 0xfda9, 0xfd88, 0xf526, 0xed69, 0xf5ee, 0xfe4c, 0xfea9, 0x71e0, 0x1801, 0x08a2, 0x3208, 0xffdd, 0xfe72, 0xed27, 0xfd46, 0xfda9, 0xf60f, 0x38c0, 0x8c92, 0xffff, 0xffff, 0xe73c, 0xad55, 0xdedb, 0xffff, 0xffdf, 0xc618, 0xb5b6, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xffff, 0xdedb, 0x5269, 0x1041, 0x2903, 0x2903, 0x1020, 0x1020, 0x1020, 0x3965, 0x1881, 0x3144, 0x8c0f, 0xff9e, 0xffff, 0xffbe, 0xffff, 0xffbe, 0xd6ba, 0xa534, 0xffff, 0xffff, 0xf79e, 0xc618, 0xbdd7, 0xf7be, 0xffff, 0xf79f, 0x3124, 0x7ac5, 0xfe8e, 0xfe09, 0xfdc9, 0xecc7, 0xfff9, 0xd63a, 0x0802, 0x3144, 0x1000, 0xa427, 0xfeeb, 0xfdab, 0xf5ab, 0xfdab, 0xfdaa, 0xfd89, 0xfd47, 0xfd48, 0xfe0c, 0xf569, 0xfde9, 0xf529, 0xfdcc, 0xfece, 0x9ba6, 0x2860, 0x3903, 0x3900, 0x9cd3, 0xe6fb, 0xad75, 0x8c51, 0xe71c, 0xef7d, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xffdf, 0xffdf, 0xc5f6, 0x2922, 0x2880, 0x3080, 0xd4eb, 0xfe6d, 0xfdc9, 0xfda8, 0xfda9, 0xf589, 0xfe8e, 0xfdaa, 0xdca6, 0xfda9, 0xf588, 0xfd6a, 0xfe0c, 0xfe08, 0xf607, 0x82c0, 0x8b45, 0x8ba9, 0x0800, 0x0020, 0xc5fa, 0xffbf, 0xf60f, 0xf5e8, 0xf5c9, 0xfed0, 0x8260, 0x0020, 0xef5d, 0xffff, 0xffff, 0xe73c, 0xf7be, 0xad34, 0xce58, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf79e, 0xa4f3, 0x18c3, 0x0841, 0x2103, 0x3165, 0x20c2, 0x0820, 0x5249, 0xc5d7, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf79e, 0xffff, 0x9cf3, 0xd6ba, 0xdefb, 0xdefb, 0xffff, 0xf7ff, 0x9c94, 0x1800, 0xe58e, 0xfe29, 0xede7, 0xedeb, 0xfed5, 0xffff, 0x5a48, 0x0800, 0x18e4, 0x9c8e, 0x6180, 0xd467, 0xf60a, 0xfdcc, 0xfdab, 0xf508, 0xfdaa, 0xfd48, 0xe4e6, 0xfe8c, 0xf5a8, 0xfde8, 0xfd8b, 0xf54a, 0xfde8, 0xfe6c, 0x9328, 0x1800, 0x3140, 0x52aa, 0xffdf, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8c50, 0x18a0, 0x2860, 0x9b05, 0xfe8d, 0xf567, 0xed28, 0xfdc9, 0xfdeb, 0xfe2d, 0xfe0d, 0xd487, 0xcc44, 0xfda9, 0xfda8, 0xfdad, 0xfe27, 0xed43, 0xb3c3, 0x93a6, 0xde11, 0x5a02, 0x59a3, 0x0001, 0x31aa, 0xef1e, 0xff9a, 0xee4f, 0xee0c, 0xfdeb, 0xf589, 0x0000, 0x41e7, 0xffbe, 0xffbf, 0xffff, 0xffff, 0x8c71, 0xb5b6, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7df, 0xce7a, 0x4229, 0x0861, 0x39a6, 0x1061, 0x8c10, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xef7d, 0x9492, 0xd69a, 0xf79e, 0xffff, 0xf7be, 0xa578, 0x1021, 0x5961, 0xfe8f, 0xfdc9, 0xfeae, 0xee72, 0xfffd, 0xa538, 0x0020, 0x3142, 0x28e2, 0x7b46, 0xe58e, 0x9aa1, 0xd4e4, 0xfd89, 0xfda9, 0xfd89, 0xfdca, 0xed28, 0xc404, 0xe508, 0xfe8e, 0xf5ca, 0xfdcc, 0xfdca, 0xece4, 0xfe2a, 0xf58d, 0x5161, 0x18a0, 0x2924, 0xdedb, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0x73ad, 0x0800, 0x38a0, 0xe4ea, 0xfd66, 0xfde8, 0xfdcc, 0xfe0c, 0xfe8f, 0xfe4f, 0xaba5, 0x8ac0, 0xdce8, 0xfdea, 0xfda7, 0xfd66, 0xece6, 0xed08, 0xdd6a, 0xfed2, 0x4983, 0x7aa6, 0xc4e7, 0x0005, 0x0001, 0x6b6c, 0xded9, 0xde57, 0xfef5, 0xf60d, 0xfead, 0x62e9, 0x0000, 0x2944, 0xdebb, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xf79e, 0xf79e, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xad55, 0x0861, 0x0000, 0x2945, 0xffbe, 0xffff, 0xffff, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xef5d, 0xffff, 0xffdf, 0xffff, 0xffff, 0xef7d, 0x94b2, 0x10a4, 0x0800, 0xddce, 0xfe2d, 0xedce, 0xe613, 0xd657, 0xb5f7, 0x10a1, 0x0003, 0x4205, 0xc54a, 0x40c0, 0xbc6c, 0xf62e, 0xdd07, 0xf505, 0xf4e4, 0xfde8, 0xfda9, 0xf58a, 0xc426, 0x8a81, 0xd4ec, 0xfe91, 0xfe6d, 0xf5c9, 0xfd88, 0xfd67, 0xfda8, 0xac07, 0x0000, 0x10a2, 0xb596, 0xffbe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x3186, 0x1020, 0x61a0, 0xfdaa, 0xfd24, 0xfdc9, 0xfe0e, 0xfef2, 0xd52c, 0x9345, 0x5980, 0xa385, 0xfe6e, 0xfdc9, 0xf504, 0xdcc2, 0xfe0d, 0xeded, 0xff33, 0x5161, 0x5140, 0xfef1, 0xbca8, 0x0003, 0x1080, 0x0020, 0x6bae, 0x9473, 0xd636, 0xffb7, 0xfed2, 0xde96, 0x1040, 0x3985, 0x5aab, 0x83d0, 0xdedc, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0x736d, 0x0000, 0x0800, 0x1061, 0xeefb, 0xef5d, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffdf, 0xad75, 0x528a, 0x4a49, 0x1082, 0x6b27, 0xffb5, 0xf6d2, 0xff9b, 0xb515, 0xa4f5, 0x29c6, 0x0000, 0x0004, 0x28e4, 0xfef0, 0xc485, 0x2000, 0xbcae, 0xfed0, 0xfe2b, 0xed26, 0xf525, 0xece4, 0xfe4c, 0xfe0e, 0x69e1, 0x5162, 0xbc8c, 0xee6f, 0xfecf, 0xfe0d, 0xfd47, 0xfdc6, 0xc4a7, 0x2881, 0x0020, 0x8430, 0xffff, 0xffff, 0xf7be, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xad75, 0x0001, 0x1881, 0x82a2, 0xfd46, 0xfd86, 0xfe0c, 0xfeb1, 0xc50e, 0x7ac5, 0x30a0, 0x6a43, 0xedf0, 0xfe4f, 0xecc5, 0xfd24, 0xf56b, 0xfecc, 0xe671, 0x59c4, 0x5120, 0xe5a9, 0xfef1, 0x8346, 0x2060, 0x3983, 0x0000, 0x1904, 0x2167, 0x4a6a, 0xef5c, 0xffdd, 0xffdb, 0x6b0a, 0x5a8a, 0xff9f, 0x9cb4, 0x9cf4, 0x7c0f, 0xa574, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xbd95, 0x18a2, 0x20a2, 0x3144, 0x0800, 0x5207, 0xffdf, 0xef5d, 0xf79e, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xe71c, 0x7bcf, 0xad55, 0x9492, 0x9cf3, 0xef5d, 0x3143, 0xd695, 0xfffa, 0xffdc, 0xb576, 0x2947, 0x31c7, 0x0040, 0x10a2, 0x3162, 0x3902, 0xd54f, 0xff0c, 0xac45, 0x2000, 0x93a9, 0xfeb2, 0xfeb0, 0xfda9, 0xecc3, 0xfd67, 0xfeaf, 0xb44a, 0x30c0, 0x5142, 0x83a7, 0xe6b1, 0xfef2, 0xfd47, 0xfd64, 0xdcc7, 0x48e2, 0x0000, 0x39e7, 0xf77d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0x9491, 0x31a9, 0x1001, 0x82c2, 0xf504, 0xfd66, 0xff11, 0xcd6d, 0x30c0, 0x4982, 0x4142, 0xac6d, 0xfef5, 0xd4a8, 0xdc02, 0xfe08, 0xff2f, 0xc550, 0x2900, 0x5220, 0xf60a, 0xfe2c, 0xfe71, 0x51e3, 0x9c07, 0x5205, 0x20e5, 0x0882, 0x0080, 0x0001, 0xa559, 0xffdf, 0xfffb, 0xff7a, 0x0800, 0xacf5, 0xff9f, 0xffff, 0x842f, 0x7c2e, 0xffff, 0xffff, 0xf79e, 0xd6ba, 0xe71c, 0xef7d, 0xad55, 0x632c, 0x5248, 0x5a89, 0x18a1, 0x1881, 0x41a5, 0x3964, 0x4184, 0x1820, 0x39c7, 0x52aa, 0x4a49, 0x7bcf, 0xdedb, 0xef7e, 0xd6db, 0xdefc, 0xffff, 0xffff, 0xdedb, 0x5aeb, 0xc638, 0xffff, 0xffff, 0x18e3, 0x4a04, 0xfffd, 0xffff, 0xf7ff, 0x320b, 0x0001, 0x0881, 0x1900, 0x0060, 0x8387, 0x8303, 0x8b67, 0xfed2, 0xfec6, 0xbd45, 0x1866, 0x6a67, 0xf632, 0xfeae, 0xfd86, 0xcbc0, 0xed89, 0xff14, 0x62a5, 0x4921, 0x3141, 0x4243, 0xee90, 0xfecc, 0xfd24, 0xf509, 0x4860, 0x2104, 0x2965, 0xe71c, 0xffdf, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9f, 0xb5d7, 0x0800, 0x9a61, 0xf4c0, 0xff0c, 0xb50f, 0x1061, 0x51a6, 0x30a0, 0x8364, 0xffd1, 0xdd48, 0x9301, 0xdded, 0xffb6, 0x934c, 0x48e0, 0x9ba0, 0xee26, 0xf60c, 0xff54, 0xa428, 0x6a64, 0xb3a7, 0x8305, 0x736a, 0x0000, 0x18a4, 0x0001, 0x3987, 0xffde, 0xffff, 0xffff, 0x8c71, 0x0040, 0x9cf2, 0xffff, 0xffff, 0xffff, 0xffff, 0xacf1, 0x83aa, 0x3982, 0x0881, 0x0041, 0x2144, 0x7bcb, 0x20a1, 0x0800, 0x1020, 0x20a1, 0x3984, 0x28e2, 0x2902, 0x20a1, 0x0000, 0x1060, 0x49e5, 0x6aeb, 0x0841, 0x10a1, 0x1840, 0x72a5, 0x8bed, 0xd659, 0xffdf, 0xffff, 0xffff, 0xf7bd, 0x4247, 0x0000, 0xef5d, 0xffff, 0xf7bf, 0xb5b6, 0x0800, 0x1060, 0x08a3, 0x0084, 0x9b64, 0x9b64, 0xb426, 0x5923, 0xfeb4, 0xf64f, 0xfe48, 0xfd06, 0x5a00, 0x4182, 0xcdd0, 0xff52, 0xbbe6, 0xb382, 0xfeee, 0xe672, 0x4106, 0x6145, 0x08a0, 0x4245, 0xf710, 0xfe04, 0xf445, 0x2800, 0x2945, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xa575, 0x0800, 0x79c0, 0xfd86, 0xdd89, 0x41a4, 0x0841, 0x38c1, 0x6283, 0xff72, 0xeeaf, 0x7a81, 0xd52e, 0xffd7, 0x7302, 0x8242, 0xb423, 0xf5e9, 0xfe2c, 0xfe4d, 0xfe31, 0x7203, 0xbc88, 0xb3a6, 0xb489, 0x41a4, 0x0862, 0x2962, 0x1060, 0x0001, 0x5aa9, 0x9cf4, 0xe75d, 0xf7de, 0x5289, 0x0000, 0x5aca, 0x9cf3, 0xb596, 0x4a08, 0x838b, 0xd5f2, 0x8beb, 0x0860, 0x0001, 0x5aca, 0xffbc, 0xf75c, 0x6aea, 0x4a07, 0x28e2, 0x1060, 0x1040, 0x18a1, 0x41e6, 0x4a68, 0x8c2e, 0xfffd, 0xde99, 0x0841, 0x0000, 0x3122, 0xd5b1, 0xb530, 0x5247, 0x8411, 0x9cf5, 0x94d3, 0x2164, 0x0000, 0xce38, 0xffff, 0xb5d7, 0x73f0, 0x20e3, 0x0800, 0x20a0, 0x2103, 0x0021, 0xac0a, 0xbc67, 0xbc47, 0x9305, 0x9b68, 0xff53, 0xfe4b, 0xfdc9, 0xe568, 0x9b82, 0x59e0, 0xc52f, 0xff36, 0x82c2, 0xa406, 0xffd3, 0xd5b1, 0x4880, 0x2903, 0x0862, 0x6aa3, 0xfeca, 0xdc05, 0x2000, 0x18e3, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xbe79, 0x0001, 0x5920, 0xed49, 0x72a2, 0x0000, 0x1884, 0x6160, 0xe66e, 0xffd3, 0x5ac3, 0x72e7, 0xfed8, 0x7a64, 0x82e0, 0xdca4, 0xfe26, 0xfe8b, 0xf5ce, 0xff34, 0xab68, 0x8202, 0xed88, 0xdd2b, 0xc52b, 0x1020, 0x524b, 0x6b25, 0x8c09, 0x20c3, 0x0000, 0x0000, 0x2124, 0xa554, 0xfffe, 0x18e3, 0x0000, 0x1081, 0x0020, 0x1040, 0xc592, 0xfff9, 0xbd90, 0x20e2, 0x0000, 0x18a2, 0xd637, 0xfffe, 0x7bad, 0xbdb5, 0xc5d6, 0xacf3, 0xad33, 0xa4d2, 0xd658, 0xa533, 0xa4d1, 0xfffd, 0x62eb, 0x0000, 0x10a2, 0x732a, 0xee75, 0xfffa, 0x6b29, 0x0000, 0x0000, 0x0040, 0x0000, 0x8c71, 0xffff, 0x5aeb, 0x0882, 0x0061, 0x0000, 0x836a, 0x838a, 0x6b09, 0x2102, 0x51c4, 0xcd2a, 0xd50a, 0xdd6a, 0x5120, 0xddad, 0xfe90, 0xfeae, 0xfe2a, 0xf585, 0xc427, 0x5141, 0xc56f, 0xeeb5, 0x4940, 0xc4e7, 0xffb2, 0xcc68, 0x1820, 0x1065, 0x1000, 0xc487, 0xd448, 0x0800, 0x39e7, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0x2967, 0x3881, 0x82c4, 0x0800, 0x0001, 0x2063, 0xc3e4, 0xffb1, 0x8c06, 0x3980, 0xee96, 0x92e7, 0x9261, 0xdcc4, 0xfde7, 0xfe0c, 0xfe0b, 0xfe90, 0xedb3, 0x7a02, 0xe548, 0xfe4c, 0xf66e, 0x6a42, 0x0800, 0x93ee, 0x8bc5, 0xe6b0, 0xa46e, 0x0000, 0x2122, 0x0000, 0x0840, 0xe73c, 0xce79, 0x0841, 0x0861, 0x0000, 0x2902, 0xe695, 0xff76, 0xc590, 0x3984, 0x1083, 0x0000, 0x6aa9, 0xad13, 0x1081, 0x2903, 0x39a6, 0x62ea, 0x8c0f, 0x5269, 0x3985, 0x10a1, 0x41e6, 0xb554, 0x20e3, 0x0862, 0x0000, 0x6288, 0xf696, 0xff76, 0x9c8d, 0x0820, 0x18c3, 0x0000, 0x31e6, 0xffde, 0x736e, 0x0000, 0x0881, 0x0861, 0x39a4, 0xee95, 0xbcad, 0x93a9, 0x6aa6, 0x0800, 0xbd0b, 0xf62d, 0xfead, 0xa367, 0x9366, 0xfef3, 0xf68f, 0xfe0d, 0xfe4a, 0xf547, 0xbc05, 0x51c0, 0xcdd1, 0xb4af, 0x4080, 0xee6e, 0xfece, 0x7a82, 0x0801, 0x0802, 0x3880, 0x82c6, 0x0000, 0x94b2, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0x8432, 0x2001, 0x1820, 0x18e3, 0x4a4c, 0x3904, 0xfd47, 0xfe0d, 0x2820, 0xc550, 0xb42a, 0x9260, 0xdc43, 0xfd05, 0xf5ac, 0xfeb3, 0xf62f, 0xff11, 0x9367, 0xb448, 0xfecd, 0xf60c, 0xe62d, 0x1000, 0x51c5, 0xcdb0, 0xac88, 0xff30, 0xeeb2, 0x1843, 0x6b28, 0x738a, 0x0000, 0x20e3, 0xffff, 0x632c, 0x0040, 0x0861, 0x5247, 0xeeb6, 0xff76, 0xd633, 0x18a1, 0x1083, 0x1082, 0x2081, 0x18a2, 0x0820, 0x1061, 0x0820, 0x0000, 0x0000, 0x0820, 0x0820, 0x0881, 0x1081, 0x1881, 0x1062, 0x10a4, 0x0862, 0x5a88, 0xff79, 0xf776, 0xbd91, 0x2964, 0x0020, 0x0861, 0xdf3b, 0xc638, 0x0000, 0x20e0, 0x8c2e, 0x10a0, 0x7349, 0xff57, 0xd52d, 0xccec, 0xddf0, 0x0800, 0x6244, 0xfecf, 0xfe4d, 0xf60c, 0x9347, 0xd5ce, 0xee6f, 0xf6b2, 0xfe50, 0xfd67, 0xf504, 0xbbe5, 0x5160, 0xfed4, 0x7225, 0x59e2, 0xfe6c, 0xaba0, 0x3161, 0x39cb, 0x1002, 0x2881, 0x10c2, 0xe73c, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xeffe, 0xf7df, 0x2083, 0x0000, 0xadf9, 0xad78, 0x5163, 0xfda8, 0x6960, 0x69c3, 0xccec, 0x8a41, 0xcc02, 0xe480, 0xfd8a, 0xfe75, 0xfe70, 0xee0f, 0xcd0c, 0xb486, 0xfeaf, 0xee0f, 0xfead, 0x8ba5, 0x1000, 0xc571, 0xff32, 0xee0f, 0xfef0, 0xf6f1, 0x30e5, 0x5a84, 0xf758, 0x3984, 0x0000, 0xad15, 0xffff, 0x0862, 0x0000, 0x5248, 0xf718, 0xffd9, 0xce13, 0x0040, 0x0042, 0x18e4, 0x1880, 0x0861, 0x2124, 0x1082, 0x18c3, 0x2104, 0x0861, 0x18e3, 0x18c3, 0x1903, 0x10a1, 0x0800, 0x2945, 0x10c4, 0x0000, 0x5a88, 0xffba, 0xffb8, 0xa4f0, 0x0840, 0x0000, 0x73ef, 0xf7dd, 0x2103, 0x0021, 0x8ba9, 0xeef7, 0x0820, 0x83ca, 0xff76, 0xf62f, 0xf60e, 0xff13, 0x52a6, 0x1000, 0xeded, 0xfe0e, 0xfe8b, 0xdd6f, 0xb427, 0xf62f, 0xde2e, 0xfef4, 0xfe4c, 0xec83, 0xecaa, 0xab44, 0x9342, 0xcd0e, 0x1000, 0xcce8, 0xd4a3, 0x41e1, 0xdf3f, 0x59cc, 0x1021, 0x6b6d, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xefdd, 0xffff, 0x49c8, 0x2144, 0xe7ff, 0xbd97, 0x4060, 0xc4c8, 0x2000, 0x9ba8, 0xb3e4, 0xaae5, 0xc3a2, 0xfdc5, 0xfe10, 0xfeb3, 0xedcb, 0xfe0f, 0xc448, 0xfe4c, 0xf62d, 0xedae, 0xfeef, 0x28a0, 0x6268, 0xf6f5, 0xfeaf, 0xfe70, 0xfe4f, 0xee51, 0x30e2, 0x6b05, 0xfffa, 0x5266, 0x0800, 0x1062, 0xffff, 0x7c10, 0x0020, 0x2946, 0xe6f9, 0xfffb, 0xad31, 0x0861, 0x08c4, 0x10c3, 0x18c1, 0x1082, 0x2104, 0x10c3, 0x18e3, 0x2104, 0x10a3, 0x18e4, 0x1904, 0x10c3, 0x18c2, 0x20c2, 0x18c3, 0x10a4, 0x0000, 0x41e6, 0xff18, 0xffda, 0xa4d1, 0x0000, 0x0842, 0xef9e, 0xc637, 0x0040, 0x0000, 0xddcf, 0xff77, 0x1040, 0x83a8, 0xff34, 0xfe90, 0xfeb0, 0xfed1, 0xd6b4, 0x2860, 0x9b48, 0xfe8f, 0xfe6b, 0xff11, 0xd4c9, 0xed4a, 0xf60e, 0xf5ee, 0xfe90, 0xfe0c, 0xeca7, 0xbb83, 0x92c1, 0xac29, 0x3966, 0x61c0, 0xc363, 0x49e4, 0xe7df, 0xeebc, 0x0000, 0xce5a, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xf7de, 0xa4d4, 0x94d2, 0xefff, 0xde9a, 0x8221, 0x4160, 0x1801, 0x7ac3, 0xb442, 0xa2a6, 0xcbe7, 0xf5e7, 0xfed7, 0xeda7, 0xfe0d, 0xfe0c, 0xfdaa, 0xfdef, 0xf56b, 0xfe8d, 0xe56c, 0x2041, 0xcdd4, 0xffb7, 0xee2d, 0xfe90, 0xfe92, 0xfeb4, 0x3121, 0x7ba6, 0xffd9, 0x9c6e, 0x0000, 0x0801, 0x9cd4, 0xffff, 0x0000, 0x0002, 0xb595, 0xffdb, 0x9caf, 0x0020, 0x1125, 0x1104, 0x18e1, 0x1904, 0x10a3, 0x18e3, 0x1082, 0x1082, 0x1904, 0x10a2, 0x10a2, 0x08a2, 0x20e3, 0x1061, 0x18c3, 0x1905, 0x10c4, 0x1880, 0xeeb7, 0xfffc, 0x62eb, 0x0822, 0x5aed, 0xffff, 0x10c2, 0x0000, 0x39c6, 0xfe91, 0xff14, 0x3960, 0x8bc8, 0xff13, 0xfe4f, 0xfeb0, 0xf62e, 0xfff7, 0x6ac7, 0x50e3, 0xfef0, 0xe5a9, 0xedc8, 0xfe6f, 0xfd29, 0xfdf1, 0xfdab, 0xfe70, 0xfe6f, 0xfd86, 0xb340, 0x8201, 0xb44a, 0x630a, 0x2000, 0x70a0, 0x8bd0, 0xefff, 0xfffd, 0x73cb, 0xe71d, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xf7be, 0xf7be, 0xffff, 0xf79e, 0x8410, 0x0805, 0x3921, 0x5aa7, 0x4165, 0x7960, 0xfd28, 0xfdec, 0xfe0d, 0xdd43, 0xfe10, 0xed6f, 0xfece, 0xbca5, 0xac28, 0xff97, 0x7ac0, 0x6226, 0xffb7, 0xe550, 0xfe8d, 0xeef1, 0xfe96, 0xfe2c, 0x6240, 0xcd4d, 0xff36, 0xde34, 0x2060, 0x0800, 0x20e4, 0xffff, 0x634d, 0x0001, 0x6b8d, 0xffff, 0x6b8d, 0x0021, 0x3986, 0x6a07, 0x58c1, 0x0881, 0x1103, 0x0902, 0x00c1, 0x00a1, 0x08c2, 0x10a2, 0x1081, 0x10c1, 0x10e1, 0x1000, 0x6a07, 0x59c6, 0x0860, 0x10a1, 0xeeba, 0xfffd, 0x2103, 0x0000, 0xe73d, 0xc639, 0x1061, 0x0800, 0x6ae8, 0xff72, 0xef16, 0x82e3, 0x8ac2, 0xff53, 0xfe92, 0xfe56, 0xd5ac, 0xf673, 0xfe74, 0x20a0, 0xdd4b, 0xfeaf, 0x8ba7, 0xfe4d, 0xfe09, 0xfdd2, 0xfdc8, 0xdd04, 0xfe6d, 0xfd89, 0xec25, 0x5920, 0x5b26, 0x5229, 0x0800, 0x1882, 0xce59, 0xffff, 0xffdf, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xc618, 0xa515, 0x5a44, 0x2902, 0x1800, 0xc367, 0xfda8, 0xf5a7, 0xe565, 0xe504, 0xfe2f, 0xfe0c, 0xdd88, 0x8284, 0xee10, 0xee4c, 0x5160, 0xc533, 0xc58e, 0xbc4a, 0xfeb0, 0xeed2, 0xfeb5, 0xfdec, 0x8365, 0xddef, 0xfef4, 0xee94, 0x49a4, 0x1040, 0x0000, 0xe71c, 0xc639, 0x0001, 0x31a6, 0xf7bd, 0x73ae, 0x0000, 0x1082, 0x7289, 0x8267, 0x4985, 0x3944, 0x3144, 0x3164, 0x2923, 0x20a1, 0x28c2, 0x4124, 0x3163, 0x41a4, 0x61e6, 0x82aa, 0x51c6, 0x0840, 0x0840, 0xf75d, 0xb5b4, 0x0020, 0x2124, 0xf7bf, 0x5acb, 0x0000, 0x1020, 0x7b6a, 0xff74, 0xff54, 0xac2b, 0x9b86, 0xfef1, 0xfe94, 0xfe74, 0xee4f, 0x9386, 0xf673, 0x732a, 0x9b45, 0xfef1, 0x9c4a, 0x92e0, 0xfe8e, 0xfdce, 0xfd89, 0xd486, 0xf5a9, 0xfe67, 0xfd26, 0x6960, 0x20e2, 0x20c3, 0x6b0c, 0xb535, 0xff9e, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0x5224, 0x1840, 0x3060, 0xc383, 0xfdc5, 0xf649, 0xbc41, 0xe484, 0xfdea, 0xede7, 0x82a1, 0xa36d, 0xff75, 0xe60a, 0x5140, 0xa491, 0x7305, 0xcd2b, 0xff55, 0xeeb3, 0xfed3, 0xdcea, 0x9c29, 0xfef2, 0xf692, 0xff16, 0x5204, 0x4a06, 0x0000, 0x7bce, 0xffff, 0x0862, 0x0000, 0xc5f6, 0x7bef, 0x0041, 0x0821, 0x51c6, 0xa38c, 0x8a69, 0x8248, 0x8268, 0x8289, 0x7247, 0x7227, 0x7a68, 0x8aa9, 0x7ac8, 0x7a47, 0xa34c, 0x7aca, 0x3124, 0x0820, 0x0841, 0xce79, 0x5aea, 0x0000, 0x73ae, 0xffff, 0x0020, 0x5268, 0x41a4, 0x8bcb, 0xff76, 0xfef0, 0xd592, 0x9366, 0xfe8e, 0xfed6, 0xf674, 0xff12, 0x8b82, 0x9be9, 0x7bae, 0x61a0, 0xfed0, 0xde71, 0x7a60, 0xa3e8, 0xfde8, 0xfd69, 0xcc28, 0xc467, 0xfe46, 0xed43, 0x79e1, 0x2064, 0x0000, 0xad14, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xefff, 0x736c, 0x0800, 0x5180, 0xe504, 0xfe89, 0x9383, 0x71e0, 0xfd06, 0xfe28, 0xabe2, 0x69e3, 0xf655, 0xfed1, 0xc50a, 0x4900, 0x28e4, 0x6281, 0xff11, 0xff17, 0xf6d5, 0xff12, 0x9b46, 0x93e9, 0xff33, 0xf6b2, 0xff35, 0x3960, 0x9c8e, 0x5267, 0x1081, 0xffff, 0x4229, 0x0000, 0x4a07, 0x4a28, 0x0842, 0x1062, 0x1820, 0x8b2a, 0xb2ea, 0xb30a, 0xaaea, 0xa2ea, 0xa30a, 0xa32a, 0xa30a, 0xa30a, 0x9b29, 0xaaa9, 0xbb4d, 0x51c6, 0x0860, 0x1882, 0x20e4, 0x5b4d, 0x20e2, 0x0000, 0xbdf7, 0xdefc, 0x0000, 0xce16, 0x62c7, 0x7307, 0xffd8, 0xf66e, 0xee74, 0x7284, 0xe56b, 0xff36, 0xee94, 0xff33, 0xd60a, 0x4940, 0x3188, 0x5920, 0xfe2e, 0xff96, 0xccec, 0x4941, 0xf5c5, 0xfdc7, 0xbba5, 0x7203, 0xd52a, 0xfe49, 0xa384, 0x2001, 0x0841, 0xc618, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xefff, 0xc637, 0x1020, 0x4962, 0xb405, 0x9384, 0x2020, 0x9265, 0xfde6, 0xe549, 0x4900, 0xac4c, 0xfe92, 0xfe6f, 0xa3a8, 0x3040, 0x0000, 0x93a5, 0xff93, 0xe655, 0xff97, 0xf64f, 0x61a1, 0xa44a, 0xfeb1, 0xff34, 0xde10, 0x3920, 0xe6b6, 0x9cb0, 0x2944, 0xdf1c, 0x8410, 0x0800, 0x1840, 0x20c3, 0x1083, 0x2105, 0x1040, 0x51a4, 0xbb6b, 0xb34b, 0xaac9, 0xaae9, 0xbb6b, 0xab4a, 0xa2e8, 0xa309, 0x9aa7, 0xd3ad, 0xaacb, 0x30c3, 0x0061, 0x20e4, 0x20e4, 0x0040, 0x20c2, 0x1061, 0xdefc, 0xbdd7, 0x3185, 0xd677, 0x942c, 0x5203, 0xffb7, 0xfe71, 0xfef3, 0x7aa6, 0x92a3, 0xff54, 0xf6d6, 0xfef3, 0xff0c, 0x51a0, 0x0823, 0x5920, 0xf5ac, 0xe651, 0xee32, 0x6a88, 0x7a60, 0xfe48, 0xf587, 0x4060, 0x40e1, 0xb487, 0x9bc5, 0x1000, 0x31c7, 0xef9e, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffdc, 0x2946, 0x1001, 0x7268, 0x20a2, 0x1000, 0xecea, 0xf5e5, 0x8288, 0x2041, 0xd610, 0xc4eb, 0xfeb1, 0xa3c6, 0x3042, 0x1061, 0xbcc7, 0xff33, 0xeed6, 0xff95, 0xaba6, 0x5981, 0xee31, 0xf671, 0xff75, 0xa44a, 0x72e5, 0xffba, 0x9cb0, 0x9cb2, 0xdedc, 0x9cd3, 0x1020, 0x4164, 0x28c3, 0x1062, 0x1083, 0x2903, 0x28c1, 0xa34a, 0xbbed, 0xb38c, 0xab0a, 0xbb6c, 0xbb8c, 0xb34b, 0xb34b, 0xb34a, 0xcbee, 0x71a6, 0x28a2, 0x10e3, 0x08a2, 0x1061, 0x20a2, 0x3144, 0x2103, 0xdebb, 0xce59, 0x9c91, 0xad11, 0xde55, 0x5a63, 0xf6b3, 0xfeb5, 0xfef1, 0xb44b, 0x48a0, 0xee2e, 0xff56, 0xff35, 0xfecb, 0x7ac4, 0x0002, 0x6141, 0xf54b, 0xd5ce, 0xd56f, 0x9c70, 0x2862, 0xb404, 0xfe25, 0x8b23, 0x1000, 0x51e2, 0x51e1, 0x1003, 0x73ef, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdc, 0xfffd, 0x424a, 0x2127, 0xd61a, 0x4a4d, 0x2040, 0xf4e4, 0xb446, 0x30a4, 0x49e8, 0xaced, 0xb449, 0xfe90, 0x9b44, 0x3042, 0x1060, 0xd526, 0xff36, 0xffb7, 0xedcb, 0x58e0, 0x9ba9, 0xff13, 0xfeb3, 0xff15, 0xac6b, 0xcd90, 0xff59, 0x5268, 0xbd96, 0xef5f, 0xc617, 0x1860, 0x4985, 0x2062, 0x1883, 0x0842, 0x18c2, 0x28e2, 0x61a4, 0xabac, 0xcc4f, 0xc36d, 0xc34d, 0xcb8e, 0xc38d, 0xc38d, 0xd490, 0x930a, 0x40e3, 0x28c3, 0x10a3, 0x08c2, 0x1080, 0x5144, 0x18a2, 0x5249, 0xdebb, 0xdebb, 0x83ef, 0x83ab, 0xff99, 0x9c4b, 0xe5f0, 0xfef7, 0xfe90, 0xf610, 0x5963, 0x8324, 0xfeef, 0xff7a, 0xfeed, 0x82e5, 0x0002, 0x6941, 0xe467, 0xfeb2, 0xb46a, 0x9c8e, 0x0003, 0x7a45, 0xed87, 0xa403, 0x1840, 0xcdf8, 0xad33, 0x0002, 0xadd6, 0xf7ff, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffde, 0xb616, 0xd73b, 0xffff, 0x426d, 0x3943, 0xf461, 0x4922, 0x0800, 0x52aa, 0x7349, 0xc4aa, 0xfeb0, 0x7222, 0x30a1, 0x1080, 0xdd66, 0xff17, 0xff75, 0xa380, 0x3800, 0xe5f3, 0xf62f, 0xfef5, 0xfe93, 0xe611, 0xffb9, 0xe696, 0x0800, 0x83d0, 0xffdf, 0xffbe, 0x3103, 0x30c2, 0x3904, 0x5a8c, 0x422a, 0x0000, 0x2902, 0x3020, 0x8289, 0xd451, 0xe472, 0xe3f0, 0xdbaf, 0xe3f0, 0xfcb3, 0xb3ad, 0x4103, 0x2082, 0x20a4, 0x0021, 0x3a88, 0x4a26, 0x6143, 0x0800, 0x9c92, 0xffdf, 0xdedb, 0x18a1, 0x6b29, 0xffda, 0xf715, 0xee10, 0xff37, 0xf631, 0xfed1, 0x938d, 0x2000, 0xddc7, 0xff5b, 0xff0e, 0x8ae5, 0x0802, 0x6100, 0xc322, 0xff34, 0xa3a7, 0x944c, 0x00a2, 0x1800, 0xa304, 0xbcc6, 0x0800, 0xce3e, 0xffff, 0xadf5, 0xceda, 0xf7ff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7df, 0xffff, 0xffff, 0x838d, 0x5164, 0x7205, 0x0021, 0x1001, 0x5a68, 0x7a65, 0xe5ca, 0xd5d0, 0x69e0, 0x38c4, 0x1060, 0xe4ec, 0xff51, 0xed49, 0x0000, 0x9324, 0xfe4d, 0xfe6e, 0xff13, 0xf5ce, 0xf758, 0xf7fd, 0xd5f3, 0x0000, 0x0905, 0xffff, 0xf7fd, 0x5ae9, 0x0820, 0x20a1, 0x9430, 0xff5d, 0x3165, 0x0000, 0x28e2, 0x1800, 0x5965, 0xb3af, 0xd472, 0xdcb3, 0xb3cf, 0x9b6d, 0x10c3, 0x0041, 0x1082, 0x0800, 0x942f, 0xffbd, 0x3902, 0x4122, 0x0000, 0xb5b8, 0xf7ff, 0xb596, 0x1001, 0x5a23, 0xff94, 0xff9b, 0xfe93, 0xfdd0, 0xfed7, 0xfe2b, 0xe5ed, 0x30c0, 0x7960, 0xfe90, 0xff8e, 0x9ac3, 0x0022, 0x61e1, 0x9225, 0xfed2, 0xa3e3, 0x5a27, 0x2986, 0x0000, 0x1000, 0x7ae9, 0x4122, 0xd616, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0x9450, 0x38e2, 0x2820, 0x42ac, 0x9430, 0x2924, 0x5121, 0xfe6c, 0xc52d, 0x6180, 0x30c4, 0x18c2, 0xed06, 0xfe8b, 0x82a3, 0x1040, 0xd4a8, 0xfe6d, 0xfeb2, 0xfe2d, 0xfe31, 0xff76, 0xfffa, 0x7b4a, 0x20a0, 0x0840, 0xad37, 0xfffe, 0xa553, 0x0000, 0x2081, 0x5a69, 0xffff, 0xe6fb, 0x4207, 0x0040, 0x2185, 0x0800, 0x1841, 0x4104, 0x3904, 0x41a6, 0x0000, 0x0861, 0x31a5, 0x1061, 0x7bad, 0xfffe, 0xd637, 0x3102, 0x2080, 0x18c2, 0xef9e, 0xffff, 0x4207, 0x20a1, 0x30c0, 0xde73, 0xff7a, 0xfed4, 0xfe31, 0xfeb4, 0xfe4d, 0xfe0c, 0x7a85, 0x3840, 0xc48b, 0xfeec, 0xa324, 0x0001, 0x6a43, 0x8266, 0xfeb1, 0xa3a4, 0x2880, 0x632d, 0x9491, 0x1860, 0x28a0, 0x4183, 0xeefa, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xad54, 0x0800, 0x3962, 0xe79f, 0xef3b, 0x0820, 0x40c1, 0xee0b, 0xa429, 0x5121, 0x4165, 0x08a4, 0xfd22, 0xed45, 0x2840, 0x4923, 0xfdc9, 0xfe6e, 0xfeb4, 0xf5eb, 0xff18, 0xff76, 0xff53, 0x1000, 0x7ae9, 0x5202, 0x2927, 0xffff, 0xf79e, 0x2945, 0x1041, 0x28e3, 0xbdb5, 0xfffe, 0xd698, 0x19a4, 0xd73a, 0xa533, 0xc5d6, 0x838d, 0x1000, 0xc5d5, 0x94b0, 0xf75b, 0x7bac, 0x5a88, 0xffbd, 0xfffe, 0x734b, 0x1060, 0x0800, 0x8c30, 0xffff, 0xb5d8, 0x0000, 0xa48c, 0x4161, 0x6aa8, 0xfffc, 0xff97, 0xee32, 0xf5ee, 0xfe8f, 0xfe2b, 0xd489, 0x0800, 0x6a05, 0xfe09, 0xab85, 0x0001, 0x6a24, 0x6a65, 0xfe4f, 0xaba6, 0x1000, 0x52cc, 0xffff, 0x8c2f, 0x1860, 0x41a5, 0xffde, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0xefdf, 0xf7ff, 0xbe37, 0x0040, 0xb5b4, 0xffff, 0xbe15, 0x0000, 0x38a2, 0xd549, 0xac08, 0x38c2, 0x3984, 0x0043, 0xfd03, 0xb382, 0x0800, 0x8a84, 0xfd67, 0xfe8f, 0xfe30, 0xfed2, 0xef5b, 0xfffa, 0x6241, 0x20e1, 0xff18, 0x6222, 0x0001, 0xc619, 0xffdf, 0x9cd3, 0x0000, 0x1081, 0x5288, 0xa532, 0xfffd, 0xc5b2, 0x838a, 0xe655, 0xbcaf, 0x6a04, 0x5141, 0x82e8, 0xddd3, 0xc5d3, 0x83cc, 0xf75a, 0xf77b, 0x8c4f, 0x39a5, 0x0000, 0x0881, 0xff9e, 0xfffe, 0x52ec, 0x0040, 0xd650, 0xbcef, 0x2021, 0xbd71, 0xfffa, 0xf719, 0xedac, 0xfe90, 0xfe2b, 0xf547, 0x20c3, 0x2040, 0xf507, 0x9344, 0x0801, 0x5183, 0x41c2, 0xeded, 0xa348, 0x1000, 0x2987, 0xffff, 0xf79e, 0x39c6, 0x2924, 0xf7be, 0xf7df, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xd73b, 0x5b2b, 0xfffe, 0xffdf, 0xceb7, 0x1022, 0x1800, 0xb468, 0xac07, 0x1000, 0x18c1, 0x0062, 0xbb84, 0x7a03, 0x1021, 0xbb83, 0xfd27, 0xfe4f, 0xee0b, 0xff3a, 0xf7fd, 0xa4d0, 0x1820, 0xd6b5, 0xf737, 0x3900, 0x0060, 0x9493, 0xffff, 0xf79e, 0x10a2, 0x0000, 0x3184, 0x4a47, 0xa4f1, 0xd5b4, 0x2840, 0x5983, 0x4901, 0x5101, 0x5962, 0x40a0, 0x61c4, 0x1020, 0x6287, 0xde77, 0x734b, 0x39e6, 0x18e3, 0x0000, 0x6b8e, 0xffff, 0xfffe, 0x424a, 0x0020, 0x6b03, 0xffdb, 0x82ec, 0x28e0, 0xee95, 0xffff, 0xfeb1, 0xfe4f, 0xfe0c, 0xf504, 0x6a45, 0x0800, 0xbb64, 0x6243, 0x1023, 0x30a1, 0x2940, 0xdd4a, 0x7a67, 0x1000, 0x426a, 0xef9e, 0xffff, 0x9492, 0x6b6d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdf3c, 0xffff, 0xffdf, 0xf7ff, 0x3987, 0x0800, 0x9b88, 0xa365, 0x1842, 0x18e2, 0x08a2, 0x5984, 0x4903, 0x2902, 0xdc23, 0xfdcb, 0xf5ed, 0xee4d, 0xff9d, 0xce95, 0x20e1, 0xc5b4, 0xfff8, 0xaccd, 0x0800, 0x0060, 0x8411, 0xffff, 0xffff, 0x8cb2, 0x0000, 0x0020, 0x20e2, 0x20c2, 0x3145, 0x20a3, 0x1061, 0x1041, 0x3104, 0x28c2, 0x28c2, 0x1020, 0x20a0, 0x3122, 0x28e2, 0x18a1, 0x2103, 0x0000, 0x2125, 0xdf1c, 0xffdf, 0xf7bf, 0x39e8, 0x0000, 0x20a0, 0xff16, 0xff59, 0x6ac5, 0x7a83, 0xef5b, 0xffb8, 0xf5cf, 0xfe2d, 0xf524, 0xa344, 0x2063, 0x61a1, 0x2942, 0x1885, 0x1820, 0x3960, 0xcc87, 0x3903, 0x0800, 0x94d3, 0xffff, 0xffff, 0xef9e, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffdf, 0xe7df, 0x83b0, 0x0800, 0x6a05, 0x92c3, 0x20e4, 0x08c2, 0x18c2, 0x10a4, 0x28a2, 0x4963, 0xdbe5, 0xfe6d, 0xf5cb, 0xfef5, 0xffda, 0x72c1, 0xacad, 0xff7a, 0xfef2, 0x59e2, 0x0001, 0x0000, 0x738e, 0xffff, 0xffff, 0xf7ff, 0x5b2c, 0x0040, 0x0000, 0x0800, 0x0001, 0x0863, 0x0021, 0x0001, 0x0000, 0x0000, 0x0021, 0x0000, 0x0000, 0x0000, 0x0000, 0x0820, 0x0000, 0x1083, 0xa515, 0xffff, 0xffdf, 0xdefd, 0x10a3, 0x1040, 0x2880, 0x9be9, 0xfff7, 0xff57, 0x7a81, 0xc52c, 0xffdb, 0xee12, 0xfdec, 0xfd88, 0xab01, 0x40e5, 0x18c1, 0x08c4, 0x18a7, 0x1821, 0x59e2, 0xb341, 0x0842, 0x1882, 0xe6fb, 0xffff, 0xf79e, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xff9d, 0xffff, 0xff9f, 0xff7f, 0xffdf, 0xffdf, 0xefff, 0xde7b, 0x0800, 0x2800, 0x92c3, 0x2945, 0x08c3, 0x20c1, 0x0126, 0x1080, 0x5163, 0xcb65, 0xfe4c, 0xfe2b, 0xffbd, 0xee0e, 0xdce7, 0xfef2, 0xff76, 0xed2b, 0x3860, 0x1063, 0x0800, 0x5aa9, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0x8c71, 0x41e8, 0x730d, 0x83af, 0x6b0c, 0x83ef, 0x9cf3, 0x8c71, 0x8c71, 0x9491, 0xa4d2, 0x7bf0, 0x6b4d, 0x83d0, 0x4a4a, 0x4a4a, 0xce19, 0xffdf, 0xffdf, 0xffdf, 0xce1b, 0x0041, 0x1882, 0x1000, 0x59e0, 0xeeee, 0xffb8, 0xfe8f, 0xc442, 0xf7dd, 0xf6b7, 0xfd69, 0xfdcb, 0x9a60, 0x50c5, 0x00a3, 0x00c6, 0x10a7, 0x1042, 0x7243, 0x9220, 0x0022, 0x41c8, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0x39a6, 0x0000, 0x4a07, 0x4207, 0x0820, 0x18c1, 0x10e2, 0x0882, 0x51c2, 0xa347, 0xfdec, 0xfe50, 0xffb5, 0xe4c4, 0xfded, 0xfecf, 0xfeee, 0x6a24, 0x2044, 0x1062, 0x0020, 0x6b6d, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xdedb, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xef7d, 0xdedb, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xe71d, 0x2125, 0x0020, 0x10c3, 0x1000, 0xbc6b, 0xfecc, 0xfe91, 0xfdc7, 0xf586, 0xff18, 0xfe2d, 0xf54a, 0x8261, 0x3124, 0x0063, 0x1945, 0x1082, 0x20a1, 0x5a47, 0x3985, 0x0000, 0x9515, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffde, 0xc5f7, 0x0000, 0x2103, 0x3144, 0x1081, 0x20e3, 0x10e2, 0x20e5, 0x4140, 0xa305, 0xfd69, 0xfe4f, 0xee4e, 0xf547, 0xfe4e, 0xf5cb, 0xd56a, 0x38e1, 0x0800, 0x1882, 0x0020, 0x8430, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xb5b6, 0x52aa, 0xad55, 0xef7d, 0x8c51, 0xc618, 0xf7be, 0xf7be, 0xffff, 0x8c71, 0xce79, 0xe71c, 0x7bcf, 0x8410, 0xe71c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x2945, 0x0881, 0x0000, 0x0801, 0x82a5, 0xf589, 0xfe6f, 0xfe2d, 0xe542, 0xfeb6, 0xfe2c, 0xdc85, 0x71a2, 0x49c4, 0x00a4, 0x0062, 0x2103, 0x20a1, 0x3123, 0x0000, 0x4a8a, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x736d, 0x0000, 0x1081, 0x18a2, 0x0000, 0x10a3, 0x1042, 0x59c2, 0x8a00, 0xf4e5, 0xfdaa, 0xf60c, 0xfdeb, 0xfe0c, 0xbc45, 0x8b25, 0x1000, 0x1000, 0x6b4a, 0x2967, 0xa534, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xe73c, 0x8410, 0xa534, 0xffff, 0x5aeb, 0xbdf7, 0xffff, 0xffff, 0xffff, 0x632c, 0x94b2, 0xffff, 0x8430, 0x9cd3, 0xe73c, 0xf79e, 0xffff, 0xffff, 0xfffe, 0xffff, 0x4a48, 0x4247, 0x3a29, 0x0801, 0x3080, 0xaba4, 0xbc66, 0xfe2f, 0xe523, 0xfe10, 0xfe69, 0xcbe3, 0x79a4, 0x41a3, 0x00a4, 0x0041, 0x0000, 0x20e2, 0x1860, 0x0000, 0xce59, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffff, 0xf77d, 0x39c6, 0x0000, 0x3165, 0x4a09, 0x0842, 0x0001, 0x61e2, 0x9241, 0xdc01, 0xfdcb, 0xccc7, 0xfe4d, 0xd4e8, 0x9362, 0x59c3, 0x0801, 0x5aa8, 0xc655, 0x5aad, 0xe71c, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xad55, 0xce79, 0xffff, 0x7bef, 0xe73c, 0xffff, 0xffff, 0xffff, 0x9cf3, 0x7bcf, 0xffff, 0xa514, 0xce79, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xf79e, 0x9491, 0x6bad, 0xb5f7, 0x0842, 0x1000, 0x7242, 0x9b64, 0xfe0e, 0xf568, 0xd509, 0xfe86, 0xb303, 0x79c3, 0x2901, 0x0042, 0x2145, 0x528a, 0x0820, 0x0000, 0x9491, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xbdd6, 0x0841, 0x2965, 0xe6fd, 0x52ab, 0x0002, 0x4961, 0x9a83, 0xdc24, 0xdca8, 0x7240, 0xfe8e, 0xa383, 0x7ac3, 0x3902, 0x0802, 0x840e, 0xc675, 0x7390, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xad75, 0xef5d, 0xd6ba, 0x9cd3, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xdefb, 0x9492, 0xffff, 0xad75, 0xd6ba, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xfffe, 0xffff, 0xdedb, 0x7c0e, 0xceda, 0x2105, 0x1820, 0x59c3, 0x9305, 0xe52c, 0xe529, 0x82c1, 0xe5a5, 0xab04, 0x8245, 0x18a0, 0x0041, 0xad76, 0xce79, 0x0820, 0x41e7, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0x39e7, 0x0000, 0xffff, 0xd6fc, 0x2107, 0x1000, 0x8a44, 0xd447, 0x6180, 0x59c0, 0xfe8c, 0x7a62, 0x59e3, 0x1040, 0x0002, 0x7bef, 0xa551, 0xc619, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe71c, 0xffdf, 0xd69a, 0xb596, 0xffff, 0xffdf, 0xffff, 0xffff, 0xef7d, 0xb5b6, 0xffff, 0xe73c, 0xf7be, 0xf7be, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xffbf, 0x9cd1, 0x9d53, 0x31e8, 0x0800, 0x51a4, 0x5160, 0xc40c, 0xe589, 0x3040, 0xa3e3, 0xb3a5, 0x69a6, 0x0000, 0x634d, 0xffff, 0xb5b7, 0x0000, 0xce38, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xf79e, 0xffff, 0xffff, 0x9cd3, 0x39e7, 0xf7be, 0xf7ff, 0x9d37, 0x0800, 0x69a4, 0x9b05, 0x2000, 0x5266, 0xee08, 0x5981, 0x3903, 0x0820, 0x0002, 0x6baf, 0x94d0, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xef5d, 0xd6ba, 0xffff, 0xffdf, 0xffff, 0xffff, 0xef5d, 0xd69a, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffdf, 0xffbf, 0xbdf5, 0x7c4e, 0x52eb, 0x0000, 0x3943, 0x2860, 0xabaa, 0xe5cb, 0x1800, 0x6a21, 0x9b44, 0x2800, 0x1925, 0xffdf, 0xffff, 0xb5b7, 0x2966, 0xf7bf, 0xffff, 0xf77d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xf7be, 0xe73c, 0xd6bb, 0xffff, 0xf7ff, 0xf7ff, 0x5289, 0x1800, 0x8ae6, 0x2060, 0x39e7, 0xd564, 0x4900, 0x30c4, 0x18c2, 0x0083, 0x6b90, 0x842f, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xc5f6, 0x740d, 0x6bce, 0x0000, 0x20e2, 0x2882, 0x82c3, 0xc4ca, 0x1802, 0x51a1, 0x7a23, 0x1800, 0xbe5d, 0xffff, 0xffff, 0xffff, 0xc659, 0xffff, 0xffdf, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77d, 0x0000, 0x3986, 0x5208, 0x0800, 0x7344, 0x6289, 0x0800, 0x1082, 0x18e5, 0x73eb, 0x6bea, 0xffff, 0xffbf, 0xf7ff, 0xf7ff, 0xf7df, 0xff9f, 0xffbe, 0xfffe, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffde, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xeffe, 0xe7ff, 0xc575, 0x7ae9, 0x7b8f, 0x0020, 0x18c5, 0x1040, 0x732a, 0x5246, 0x0800, 0x62a9, 0x0800, 0x6acb, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0x9450, 0x1041, 0x3945, 0x1020, 0x3123, 0x18a0, 0x20a3, 0x0820, 0x4248, 0xe71d, 0x2984, 0xd6fb, 0xfffc, 0xffff, 0xe79f, 0xffff, 0xffff, 0xf7dd, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79f, 0xffbf, 0xffbd, 0xfffe, 0xffff, 0xffff, 0xfffb, 0xf7bf, 0xffff, 0x7c0d, 0x7b4e, 0xde17, 0x1060, 0x0883, 0x0820, 0x3984, 0x20e2, 0x18a1, 0x3145, 0x1061, 0xef1c, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0x41a6, 0x1000, 0x20a3, 0x0800, 0x3124, 0x28e6, 0x0000, 0x4a64, 0xffff, 0x4a2e, 0x632a, 0xfff9, 0xf79c, 0xffff, 0xff9e, 0xfffd, 0xf7db, 0xe71a, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xf7df, 0xf7fd, 0xffff, 0xffdf, 0xf759, 0xf7de, 0xffff, 0xffde, 0xfffb, 0xffba, 0xded4, 0x1127, 0xd6be, 0xff76, 0x1000, 0x0905, 0x39e6, 0x0000, 0x0860, 0x20e3, 0x0821, 0x8c72, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xbdd7, 0x0800, 0x18a3, 0x18c2, 0x0002, 0x83ee, 0x3927, 0x3140, 0xef74, 0xe6bd, 0x0000, 0xd654, 0xff57, 0xffba, 0xffff, 0xefde, 0xf7b9, 0xd655, 0xffdf, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefdf, 0xfffe, 0xffff, 0xeeda, 0xbdd2, 0xffff, 0xffbf, 0xfffe, 0xff58, 0xff73, 0x7369, 0x0045, 0xfffd, 0x9c6b, 0x1000, 0x5b28, 0x4aaa, 0x0000, 0x18e3, 0x0020, 0x31c7, 0xffff, 0xef9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0x5acb, 0x0000, 0x1904, 0x0840, 0x4a24, 0xb512, 0x1000, 0x7361, 0xfff8, 0x20a5, 0x3186, 0xfed1, 0xcce8, 0xf7bc, 0xf7ff, 0xff9b, 0xacad, 0xd697, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7de, 0xfffd, 0xa48e, 0xbdd2, 0xffff, 0xffdf, 0xde14, 0xe58a, 0xcdf3, 0x0002, 0xa52e, 0xffd6, 0x0801, 0x39a7, 0xad0b, 0x0000, 0x18e3, 0x0862, 0x0021, 0xc639, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xce7a, 0x0000, 0x3a48, 0xce58, 0x3146, 0xb549, 0x8b87, 0x1800, 0xad08, 0xe6b7, 0x0001, 0x9344, 0xe58a, 0x944c, 0xe79f, 0xffdf, 0xbcce, 0x7b26, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xffdf, 0xe677, 0x7ae5, 0xff59, 0xffff, 0xde77, 0xa429, 0xf60c, 0x1864, 0x39c9, 0xfff2, 0x59c1, 0x1001, 0xc631, 0x72a7, 0x7bcf, 0xc618, 0x0021, 0x39c7, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf79e, 0xffff, 0x10a3, 0x4aea, 0xf7df, 0xcddb, 0x3960, 0xd5ae, 0x4924, 0x1820, 0xe6d2, 0x8c0c, 0x2020, 0xdd90, 0xac6a, 0x8c2d, 0xffbf, 0xff7d, 0x6140, 0xad75, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xefde, 0xffdf, 0x6205, 0x93a5, 0xffbb, 0xde99, 0x7b46, 0xdd6b, 0x6a47, 0x0800, 0xe6d5, 0x93c8, 0x2000, 0xb48b, 0x8be5, 0x4126, 0xf7bf, 0xffff, 0x0020, 0x8410, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0x3a08, 0x530e, 0xf7ff, 0xfffd, 0x6a0f, 0x40c0, 0xb4e5, 0x1800, 0x3100, 0xf733, 0x3147, 0x30a4, 0xfe90, 0x4160, 0xbe5d, 0xff9f, 0xaa80, 0x4a69, 0xef7d, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xffff, 0xfffe, 0xc59c, 0x3880, 0xee2d, 0xffdd, 0x6aeb, 0x8ba5, 0xedcb, 0x0004, 0xc58f, 0xd5f0, 0x0800, 0x59c0, 0xc484, 0x2000, 0xdeb9, 0xffff, 0xffbe, 0x18c3, 0xad54, 0xffff, 0xffde, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xef7d, 0x9cf3, 0xa555, 0xffff, 0xffdf, 0xffff, 0x2903, 0x3964, 0x6aea, 0x0800, 0x7b27, 0xcd0c, 0x1000, 0x4a86, 0xa426, 0x7aa8, 0xff7d, 0xed63, 0x1860, 0xd69a, 0xffff, 0xf7bf, 0xffff, 0xffbd, 0xffff, 0xefff, 0xfffb, 0x536e, 0x2920, 0xffd2, 0xbe15, 0x6266, 0xdd49, 0x1000, 0x4960, 0xcd70, 0x2880, 0x1820, 0x8bcd, 0x0800, 0x9c72, 0xffbf, 0xffff, 0xef7d, 0x8430, 0xbdf7, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xe73c, 0xffff, 0xf7df, 0xffff, 0xffbe, 0xce58, 0x41a5, 0x3964, 0x1860, 0x1840, 0x7ac6, 0x3986, 0x0000, 0x7b23, 0x4922, 0xac0f, 0xf606, 0x1820, 0x732a, 0xfffc, 0xfffd, 0xffde, 0xffff, 0xffff, 0xfffe, 0xfed3, 0x1082, 0x7b24, 0xf68e, 0x5288, 0x4182, 0x5980, 0x0001, 0x7b49, 0x6266, 0x1820, 0x3943, 0x2903, 0x62eb, 0xef5d, 0xffff, 0xffff, 0xffff, 0xdedb, 0xef7d, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xbd95, 0x1040, 0x0800, 0x0800, 0x3923, 0x39a8, 0x10a2, 0x3140, 0x4164, 0x2060, 0xe609, 0x3123, 0x2040, 0xe5cf, 0xfff9, 0xffdd, 0xffff, 0xfffd, 0xffb8, 0xbc26, 0x1000, 0xac26, 0xb427, 0x1041, 0x41e3, 0x2840, 0x10a5, 0x41a5, 0x0800, 0x0800, 0x0800, 0x41e7, 0xf7be, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77d, 0xffff, 0x83ce, 0x5268, 0x736f, 0x0840, 0x0001, 0x0021, 0x0840, 0x3967, 0x1001, 0x6ac1, 0x39e8, 0x1820, 0xabe4, 0xff13, 0xfffd, 0xffff, 0xffda, 0xedec, 0x7202, 0x1000, 0x7ae5, 0x59c1, 0x10a2, 0x3184, 0x1000, 0x0024, 0x0000, 0x2904, 0x736e, 0x39a6, 0xef5d, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffdf, 0xf77d, 0xffff, 0x7c2f, 0x18e4, 0x424a, 0x0041, 0x1044, 0x2906, 0x1080, 0x00c5, 0x1020, 0x7aa0, 0xcd2c, 0xf77b, 0xffdf, 0xde12, 0xc403, 0x28e3, 0x0020, 0x20a3, 0x18a0, 0x1904, 0x0001, 0x2923, 0x31ea, 0x2946, 0xce7a, 0xf7df, 0xe71c, 0xf7df, 0xffff, 0xef9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xb5d6, 0xef5d, 0x6370, 0x0003, 0x20a4, 0x10c3, 0x0044, 0x0000, 0x28a0, 0x49c2, 0xc5d6, 0xfffe, 0x8348, 0x61a0, 0x0003, 0x08e3, 0x0003, 0x10c3, 0x10e3, 0x0022, 0xc636, 0xd6db, 0xc639, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7e, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffde, 0xefff, 0xfffe, 0xffff, 0xefbf, 0x1906, 0x0000, 0x0020, 0x738f, 0x630c, 0x0840, 0x0000, 0x62eb, 0xad13, 0x28e2, 0x0800, 0x0042, 0x6b8d, 0x39e9, 0x0001, 0x0000, 0x634d, 0xffff, 0xfffe, 0xffff, 0xffff, 0xf79e, 0xf7bf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xfffd, 0xffde, 0xf7ff, 0x94b3, 0x1060, 0x29e6, 0xffde, 0xffdf, 0x4a6b, 0x0022, 0x0801, 0x1082, 0x0001, 0x0003, 0xad32, 0xfffd, 0xd697, 0x0001, 0x0000, 0xffdc, 0xffdf, 0xfffd, 0xfffe, 0xf79d, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xc618, 0x52aa, 0xf7be, 0xffff, 0xffdf, 0xffff, 0x7bcf, 0x0841, 0x0000, 0x1082, 0xce79, 0xffff, 0xffdf, 0xffff, 0x94b2, 0x738e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x6b4d, 0x2965, 0xce59, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};
const unsigned short  SMF[] PROGMEM = {
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xfffd, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffbc, 0xff9b, 0xff9a, 0xff9a, 0xff33, 0xff33, 0xff33, 0xff33, 0xff33, 0xff32, 0xff32, 0xff32, 0xff33, 0xff34, 0xff35, 0xff36, 0xff38, 0xff3a, 0xff5b, 0xff5c, 0xff9f, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7de, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdd, 0xffbb, 0xff7a, 0xff57, 0xf754, 0xf72f, 0xef0b, 0xeee6, 0xeee3, 0xeee1, 0xf6c2, 0xf6c2, 0xf6c2, 0xf6c1, 0xf6c1, 0xf6c1, 0xf6c1, 0xf6c1, 0xf6c0, 0xf6c1, 0xf6c2, 0xf6c3, 0xf6c5, 0xf6e6, 0xf6e7, 0xf6e8, 0xf6f2, 0xf714, 0xf756, 0xf779, 0xffbc, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbd, 0xff79, 0xff34, 0xff0f, 0xfeed, 0xf702, 0xf702, 0xf6e1, 0xf6c1, 0xf6a0, 0xfe80, 0xfe80, 0xfe80, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xf6c0, 0xfec0, 0xf6c0, 0xf6a0, 0xf6a1, 0xeec5, 0xf6ca, 0xf6ef, 0xf714, 0xff37, 0xff39, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffda, 0xff74, 0xf72d, 0xf6e7, 0xf6a3, 0xf6a1, 0xf680, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfea1, 0xfea1, 0xfea1, 0xfea1, 0xfea1, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xf6a2, 0xf6a3, 0xf6c5, 0xf6c6, 0xef30, 0xf754, 0xff5b, 0xff9f, 0xffdf, 0xffff, 0xf7ff, 0xf7fd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffdb, 0xffb7, 0xff94, 0xfeed, 0xfeea, 0xf6c6, 0xf6c1, 0xf6c0, 0xfec0, 0xfec0, 0xfee0, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfec1, 0xfec1, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfea3, 0xfea3, 0xfea3, 0xfea2, 0xfea2, 0xfea2, 0xfea1, 0xfea1, 0xfec1, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xf683, 0xf6a6, 0xf6cb, 0xfef1, 0xff36, 0xff9a, 0xffdc, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffbb, 0xff54, 0xeeed, 0xe6c8, 0xfe80, 0xfe80, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfea1, 0xfec0, 0xfec1, 0xfee1, 0xfee1, 0xff01, 0xfee1, 0xf6e0, 0xf6e0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfea1, 0xfe81, 0xfe81, 0xfea0, 0xfea0, 0xfe80, 0xf680, 0xeea7, 0xeef1, 0xf71b, 0xff3f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffbf, 0xff57, 0xfeef, 0xfe87, 0xfe82, 0xfe80, 0xfe80, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfea1, 0xfea1, 0xfea1, 0xfea2, 0xf716, 0xf759, 0xf7bd, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffd, 0xfffd, 0xffff, 0xffdf, 0xf775, 0xf732, 0xfeed, 0xfea7, 0xfe83, 0xfe80, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfea0, 0xfea1, 0xfea1, 0xfea1, 0xf6c7, 0xf6ec, 0xf735, 0xff5c, 0xf79f, 0xf7df, 0xf7ff, 0xf7fe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xfffd, 0xfffd, 0xffff, 0xffff, 0xffdb, 0xf777, 0xeee6, 0xeec4, 0xf6c1, 0xf6a0, 0xfea0, 0xfec0, 0xfec0, 0xfee0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec1, 0xfea1, 0xfea0, 0xfea0, 0xfea7, 0xfeaf, 0xf6f6, 0xf75c, 0xf7bf, 0xf7ff, 0xfffe, 0xfffe, 0xf7fe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff79, 0xf70d, 0xeec4, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfe80, 0xfe80, 0xf686, 0xeecf, 0xf739, 0xf77f, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffdf, 0xff9f, 0xf733, 0xf6e7, 0xfea0, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee1, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee2, 0xfee0, 0xfec0, 0xfe80, 0xfe80, 0xf685, 0xf6ac, 0xf6d2, 0xf73d, 0xf79f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff98, 0xf72e, 0xf6c3, 0xf680, 0xfea0, 0xfec0, 0xfe81, 0xfe81, 0xfea1, 0xfec1, 0xfee1, 0xfee1, 0xfee1, 0xfee1, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfea0, 0xfea1, 0xfea1, 0xfea2, 0xee94, 0xf717, 0xffbc, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffc, 0xf773, 0xf6e7, 0xf6a0, 0xfea0, 0xfe80, 0xfec0, 0xfee0, 0xfea0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfec0, 0xfee0, 0xff01, 0xff01, 0xfee1, 0xfec0, 0xfea0, 0xfea0, 0xf667, 0xf6cc, 0xf733, 0xf79a, 0xf7df, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef4b, 0xeec6, 0xf661, 0xfe80, 0xfea0, 0xfea0, 0xfec0, 0xf6c1, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xfec1, 0xfee0, 0xff20, 0xf720, 0xf700, 0xf6e0, 0xfea1, 0xfea2, 0xfee0, 0xf6a2, 0xe6ab, 0xdef5, 0xef7c, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7f, 0xffff, 0xfffe, 0xf7ff, 0xffdf, 0xffdf, 0xff96, 0xff0b, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfe80, 0xfec0, 0xfec0, 0xfea2, 0xf68e, 0xeeda, 0xef9f, 0xefff, 0xfffe, 0xffdf, 0xffdf, 0xfffe, 0xfffc, 0xfffc, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xfffe, 0xffff, 0xffdf, 0xff58, 0xfeec, 0xf6c2, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfea0, 0xfec0, 0xfec0, 0xfea1, 0xf6a7, 0xeed0, 0xef39, 0xef9f, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xfffd, 0xff75, 0xf6ea, 0xf681, 0xfe80, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec1, 0xfea1, 0xfea0, 0xfec0, 0xf6c4, 0xeecf, 0xeed8, 0xf79f, 0xffdf, 0xfffd, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xf754, 0xeee7, 0xf6c0, 0xfea0, 0xfe60, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xff00, 0xfee1, 0xfea2, 0xfea0, 0xfec0, 0xf6a0, 0xf6a5, 0xf66c, 0xe71b, 0xef9c, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xff75, 0xeee8, 0xeea0, 0xfec0, 0xfea0, 0xfe81, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfea0, 0xfea0, 0xfea0, 0xfea1, 0xdeaf, 0xef15, 0xf79c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xff56, 0xeee6, 0xf6c0, 0xfec0, 0xfe80, 0xfe81, 0xfee1, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfec1, 0xfea1, 0xfec0, 0xfec0, 0xe685, 0xeead, 0xef17, 0xf79d, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff76, 0xfeea, 0xf6a0, 0xfec0, 0xfec0, 0xfea2, 0xfea1, 0xff00, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff01, 0xff00, 0xff20, 0xff00, 0xfee0, 0xfec1, 0xfec0, 0xfec0, 0xfea0, 0xf685, 0xeead, 0xe717, 0xef7d, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf6c6, 0xfec3, 0xfea0, 0xfea0, 0xfea0, 0xfee1, 0xff01, 0xef00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff01, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfec1, 0xfea2, 0xfec0, 0xfea0, 0xe666, 0xdeb1, 0xe71c, 0xf79f, 0xffff, 0xfffc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xff7a, 0xff29, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xf6a1, 0xff00, 0xfee0, 0xee64, 0xee51, 0xf6fc, 0xefdf, 0xe7fe, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xfffe, 0xffff, 0xffbd, 0xff30, 0xf6c4, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xf6a2, 0xfee0, 0xfee0, 0xf6a1, 0xee8a, 0xeed4, 0xef5c, 0xefdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fd, 0xfffe, 0xffbf, 0xff53, 0xf6e4, 0xf6a0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec2, 0xfea0, 0xfee0, 0xfee0, 0xf6c1, 0xe68a, 0xe6d6, 0xf75f, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xff58, 0xf707, 0xf6e0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfea0, 0xfea0, 0xff00, 0xf6e0, 0xeea2, 0xee8e, 0xf6b9, 0xf79e, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xff5e, 0xfeee, 0xf6c0, 0xfea0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfec0, 0xfea0, 0xfee0, 0xff00, 0xf6c0, 0xee87, 0xee2e, 0xef3b, 0xff9f, 0xffdf, 0xffff, 0xfffe, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffbf, 0xfef7, 0xf6a4, 0xf680, 0xfe80, 0xfec1, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff20, 0xfee0, 0xfec1, 0xfec0, 0xfee0, 0xfee0, 0xfe82, 0xf624, 0xe6d5, 0xf73b, 0xff9f, 0xffdf, 0xffff, 0xfffd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xff55, 0xfec9, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfec1, 0xfec1, 0xfea0, 0xfe80, 0xde8e, 0xe6d5, 0xf75d, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7c, 0xf70c, 0xfee0, 0xfea0, 0xfec0, 0xfee0, 0xf6e0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xfee2, 0xff21, 0xff40, 0xff00, 0xfec1, 0xfea1, 0xfec0, 0xfee0, 0xde68, 0xdeb0, 0xef3b, 0xffdf, 0xffff, 0xf7fe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffc, 0xffff, 0xffdf, 0xffff, 0xfffd, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xf753, 0xeec4, 0xf6c0, 0xfec0, 0xfea0, 0xfea1, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff40, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf760, 0xffc0, 0xffa0, 0xff60, 0xff60, 0xff41, 0xff42, 0xff41, 0xff80, 0xff60, 0xff82, 0xff60, 0xff60, 0xffa0, 0xff60, 0xff20, 0xf760, 0xffa0, 0xffc1, 0xff60, 0xff40, 0xff80, 0xffa0, 0xf760, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf740, 0xffa0, 0xff80, 0xff60, 0xffa0, 0xff80, 0xff80, 0xff62, 0xff81, 0xff80, 0xffa0, 0xffa0, 0xff80, 0xff60, 0xff60, 0xff60, 0xff80, 0xff62, 0xff60, 0xff60, 0xff81, 0xffa1, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xfea0, 0xf647, 0xe675, 0xef3f, 0xf7ff, 0xf7fe, 0xfffe, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffd, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xff99, 0xf70e, 0xeec2, 0xfec0, 0xfee0, 0xfec1, 0xfec1, 0xff00, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff40, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf780, 0xffa0, 0xff80, 0xff80, 0xffa0, 0xff80, 0xff60, 0xff80, 0xff40, 0xffa0, 0xffe0, 0xffc1, 0xffe4, 0xffe4, 0xff80, 0xffe0, 0xffe0, 0xffa0, 0xff60, 0xff80, 0xffa1, 0xff81, 0xff81, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xffc1, 0xff80, 0xff40, 0xff80, 0xff80, 0xff80, 0xff61, 0xff80, 0xffe0, 0xffe0, 0xffc2, 0xffe4, 0xffe3, 0xffe0, 0xffa2, 0xffe1, 0xf740, 0xf760, 0xffe2, 0xffc1, 0xf740, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfea0, 0xfea0, 0xfe80, 0xf664, 0xe670, 0xe6fb, 0xefdf, 0xf7ff, 0xfffe, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xff0f, 0xf6c7, 0xf6a0, 0xfec0, 0xfee0, 0xfec1, 0xfee1, 0xff20, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff60, 0xff80, 0xffa0, 0xff60, 0xff80, 0xffc0, 0xffa0, 0xffe0, 0xef41, 0xad60, 0x8c40, 0x7ba0, 0x9461, 0xd646, 0xef62, 0xffe2, 0xffe0, 0xff80, 0xff82, 0xff63, 0xff61, 0xffe0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa1, 0xff80, 0xff80, 0xffa0, 0xff80, 0xff80, 0xff60, 0xff80, 0xffe1, 0xef66, 0xb566, 0x83c3, 0x83c0, 0x94a0, 0xcde5, 0xffe5, 0xffe1, 0xffc0, 0xf780, 0xf780, 0xffc0, 0xff82, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfe80, 0xf681, 0xe688, 0xdeb5, 0xe73e, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffbb, 0xfec5, 0xfea1, 0xfea0, 0xfec0, 0xfee0, 0xfee1, 0xff00, 0xff40, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff40, 0xff60, 0xff80, 0xf740, 0xffa0, 0xffe0, 0xffe6, 0xb562, 0x5240, 0x1040, 0x0000, 0x0000, 0x0000, 0x1880, 0x7bc0, 0xdea4, 0xffe2, 0xffa0, 0xff40, 0xff61, 0xff80, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff80, 0xff60, 0xffc0, 0xffa1, 0xbdc2, 0x5280, 0x1040, 0x0001, 0x0000, 0x0000, 0x28e0, 0x7ba0, 0xd6a2, 0xffe3, 0xf7a0, 0xef40, 0xffe0, 0xff41, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfe82, 0xfec0, 0xeea2, 0xde6e, 0xe6da, 0xf79f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffdf, 0xff9b, 0xff74, 0xfea0, 0xfe80, 0xfea0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff41, 0xff60, 0xff60, 0xffa0, 0xffe0, 0xf7a1, 0x9c68, 0x3961, 0x0800, 0x0003, 0x0004, 0x1084, 0x0041, 0x0000, 0x0800, 0x5ac0, 0xce42, 0xffe1, 0xffa0, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff80, 0xff80, 0xffa0, 0xff80, 0xff60, 0xff80, 0xff80, 0xffe4, 0xad20, 0x3180, 0x0000, 0x0002, 0x0004, 0x0024, 0x0004, 0x0800, 0x0800, 0x5241, 0xce64, 0xffe2, 0xffc0, 0xff80, 0xff61, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfea2, 0xfee0, 0xf6e0, 0xe667, 0xe694, 0xf73d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xff76, 0xf70b, 0xfea0, 0xfea0, 0xfec0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa1, 0xff61, 0xff80, 0xffa0, 0xffe0, 0xffa4, 0xbdc2, 0x1880, 0x0000, 0x0000, 0x0041, 0x0002, 0x0002, 0x0000, 0x0040, 0x0003, 0x0000, 0x6300, 0xef25, 0xffe1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xf740, 0xff60, 0xffc2, 0xffc2, 0xbdc5, 0x2940, 0x0000, 0x0823, 0x0861, 0x0020, 0x0020, 0x0000, 0x1062, 0x0805, 0x0802, 0x5280, 0xe703, 0xffe2, 0xf740, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff80, 0xffa0, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec1, 0xfee0, 0xfee0, 0xeea3, 0xe68e, 0xeeda, 0xf79f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7ff, 0xffdf, 0xffbe, 0xff31, 0xeec3, 0xfec0, 0xfec0, 0xfec1, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff00, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff61, 0xffa0, 0xffc0, 0xffe2, 0xd665, 0x5a80, 0x0820, 0x0020, 0x0040, 0x0020, 0x0020, 0x0022, 0x0001, 0x0000, 0x0864, 0x0001, 0x1860, 0x9423, 0xf744, 0xffc0, 0xff60, 0xffa1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff80, 0xffa0, 0xff60, 0xffa1, 0xffc4, 0xeec1, 0x39a0, 0x0000, 0x0000, 0x0842, 0x0000, 0x0020, 0x0840, 0x0820, 0x0020, 0x0002, 0x0003, 0x0800, 0x83e0, 0xff85, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xee88, 0xe676, 0xef3e, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7ff, 0xffdf, 0xff9d, 0xff2e, 0xeea0, 0xfec1, 0xfec1, 0xfee2, 0xfee1, 0xff20, 0xff40, 0xff20, 0xff00, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff41, 0xff80, 0xffa0, 0xffa3, 0xad03, 0x1000, 0x0003, 0x0003, 0x0042, 0x0020, 0x0020, 0x0860, 0x0000, 0x0003, 0x0040, 0x0863, 0x0801, 0x30e0, 0xd604, 0xffe3, 0xff40, 0xff82, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff80, 0xff80, 0xffa0, 0xff60, 0xffa2, 0xf722, 0xb500, 0x0801, 0x0000, 0x0000, 0x0000, 0x0001, 0x0002, 0x0001, 0x0800, 0x0080, 0x0020, 0x0862, 0x0800, 0x3120, 0xce03, 0xffe2, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfec1, 0xfec0, 0xfee0, 0xee84, 0xde53, 0xe6fd, 0xf7fd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffb, 0xffff, 0xefff, 0xffff, 0xffbf, 0xff13, 0xfea2, 0xfea0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff64, 0xff80, 0xf760, 0xffe0, 0xe747, 0x18c0, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0020, 0x0841, 0x6325, 0xffe4, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffe0, 0xf760, 0xff80, 0xffa0, 0xff80, 0xffe0, 0xe744, 0x28e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0040, 0x0000, 0x0000, 0x0020, 0x0843, 0x5ae4, 0xffe1, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfea2, 0xfee1, 0xfee0, 0xfec0, 0xfea0, 0xee28, 0xde94, 0xdf7f, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xfffc, 0xffff, 0xefff, 0xffff, 0xffbf, 0xfef0, 0xfea1, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff43, 0xff80, 0xff80, 0xffc0, 0xb5c4, 0x1060, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0020, 0x0000, 0x39c1, 0xdf01, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffc0, 0xff60, 0xff80, 0xff80, 0xff60, 0xffc0, 0xb580, 0x1020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x0020, 0x0002, 0x31a0, 0xef41, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfec1, 0xfee0, 0xfec0, 0xfec0, 0xfea0, 0xee66, 0xde92, 0xdf3e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xf7ff, 0xffff, 0xff9a, 0xfecb, 0xf680, 0xfee0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff42, 0xff80, 0xffa0, 0xf7a3, 0x7380, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0001, 0x1060, 0xad60, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffc0, 0xff60, 0xff80, 0xffa0, 0xff60, 0xf782, 0x6b60, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0020, 0x0000, 0x0020, 0x0002, 0x0860, 0xbda0, 0xffa1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfec1, 0xfee0, 0xfec0, 0xfea0, 0xfea0, 0xee82, 0xde8e, 0xdedc, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xfffe, 0xff54, 0xf6a6, 0xf680, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff41, 0xff80, 0xffc0, 0xef24, 0x3160, 0x0001, 0x0002, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0040, 0x0001, 0x0000, 0x8400, 0xffc2, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff60, 0xff60, 0xffa0, 0xff80, 0xf785, 0x39a0, 0x0002, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x0020, 0x0001, 0x0000, 0x83e0, 0xff83, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xfee1, 0xfee0, 0xfec0, 0xfea2, 0xfea0, 0xf6a0, 0xe689, 0xd677, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffdc, 0xff2d, 0xf681, 0xf6a0, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xffa0, 0xffc0, 0xde85, 0x1020, 0x0002, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0021, 0x0022, 0x0000, 0x62c0, 0xffc3, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xffa0, 0xffc0, 0xe706, 0x1080, 0x0004, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x5260, 0xff83, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xfee1, 0xfee0, 0xf6e0, 0xfea3, 0xfea0, 0xfec0, 0xee86, 0xde32, 0xe73c, 0xffdf, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xff99, 0xf6e7, 0xf6a0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xffa0, 0xffa0, 0xffc0, 0xc5e4, 0x0800, 0x0002, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0001, 0x4180, 0xf784, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff41, 0xff60, 0xffa0, 0xc624, 0x0000, 0x0003, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0801, 0x0001, 0x0020, 0x0021, 0x3140, 0xff83, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xfee0, 0xf6e0, 0xfec2, 0xfea0, 0xfec0, 0xf6a3, 0xde2b, 0xd6ba, 0xf7be, 0xffff, 0xffff, 0xffff, 
0xffff, 0xfffe, 0xffdf, 0xff37, 0xf6e3, 0xfec0, 0xfee0, 0xfec1, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xffa0, 0xffa0, 0xffc0, 0xad23, 0x0800, 0x0001, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0020, 0x0000, 0x0020, 0x0001, 0x20a0, 0xef23, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff61, 0xff60, 0xffc0, 0xad62, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0001, 0x0000, 0x0040, 0x0020, 0x20c0, 0xf761, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xfee0, 0xff00, 0xfee1, 0xfea0, 0xfea0, 0xfea2, 0xe646, 0xce79, 0xef7d, 0xffff, 0xffff, 0xffff, 
0xffff, 0xfffd, 0xffdf, 0xf715, 0xf6c1, 0xfee0, 0xff01, 0xf6a2, 0xfee0, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xffa0, 0xff80, 0xffc0, 0xa4c1, 0x0801, 0x0000, 0x0040, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0860, 0x0000, 0x0040, 0x0000, 0x1840, 0xef03, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff80, 0xff62, 0xff80, 0xffe0, 0xa501, 0x0000, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0802, 0x0001, 0x0000, 0x0040, 0x0020, 0x20a0, 0xe740, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xfee0, 0xff01, 0xff00, 0xfea0, 0xfea0, 0xfea2, 0xee63, 0xc638, 0xef5d, 0xffdf, 0xffff, 0xffff, 
0xefff, 0xffff, 0xff9c, 0xff07, 0xfea0, 0xfea0, 0xfec0, 0xfee3, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff61, 0xffa0, 0xffe1, 0x9c82, 0x0800, 0x0000, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0060, 0x0020, 0x0020, 0x1860, 0xdec0, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff61, 0xff80, 0xffe0, 0x9481, 0x0841, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0040, 0x0020, 0x0000, 0x1880, 0xe740, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xde4e, 0xdebd, 0xf7df, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xff9b, 0xfee6, 0xfea0, 0xfea0, 0xfec0, 0xfee2, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff62, 0xffa0, 0xffe0, 0xa4e3, 0x0800, 0x0001, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x20a0, 0xe701, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff80, 0xff61, 0xff80, 0xffc0, 0x9ce2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0040, 0x0001, 0x20c0, 0xef40, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xde4c, 0xd69b, 0xefbf, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xff57, 0xfec4, 0xfea0, 0xfea0, 0xfec0, 0xfee2, 0xff00, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff62, 0xff80, 0xffe0, 0xbd84, 0x0800, 0x0822, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0020, 0x0000, 0x0000, 0x3940, 0xf763, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff60, 0xff61, 0xff80, 0xf7a0, 0xb584, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0041, 0x0001, 0x3120, 0xf762, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xde49, 0xd659, 0xe77f, 0xffff, 0xffff, 
0xf7ff, 0xffdf, 0xff33, 0xf6a2, 0xfea0, 0xfec0, 0xfec0, 0xfee1, 0xff00, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff62, 0xff60, 0xffc0, 0xce24, 0x0800, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0002, 0x0000, 0x0041, 0x0000, 0x5240, 0xffa3, 0xff81, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff80, 0xff61, 0xffa1, 0xffa0, 0xd685, 0x0820, 0x0003, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0002, 0x0001, 0x41c0, 0xff83, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xe646, 0xd636, 0xe75d, 0xffff, 0xffff, 
0xffff, 0xffbe, 0xf70f, 0xf6a0, 0xfea0, 0xfec0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff61, 0xff81, 0xffe0, 0xdec2, 0x20c0, 0x0001, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0002, 0x0020, 0x0041, 0x0000, 0x7360, 0xffa2, 0xff81, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf780, 0xffa0, 0xff61, 0xff81, 0xffa0, 0xef25, 0x28e0, 0x0003, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0002, 0x0000, 0x6ae0, 0xffa3, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xee83, 0xd613, 0xdf1c, 0xffff, 0xffff, 
0xffff, 0xff9d, 0xf6eb, 0xf6a0, 0xfec0, 0xfec0, 0xfee1, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff81, 0xffe0, 0xef61, 0x5260, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x94c0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf780, 0xffa0, 0xff61, 0xff61, 0xffa0, 0xf782, 0x5260, 0x0802, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0040, 0x0002, 0x0000, 0x9ca0, 0xffc1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfea1, 0xd611, 0xdefa, 0xffdf, 0xffdf, 
0xfffe, 0xff7c, 0xf6e8, 0xf6c0, 0xfec0, 0xfea0, 0xfec2, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xffc0, 0xffe0, 0x9463, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x18a1, 0xce80, 0xffc0, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf7a0, 0xff80, 0xff61, 0xff60, 0xffa0, 0xffe0, 0x9460, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0021, 0x0000, 0x0000, 0x0040, 0x0002, 0x20e0, 0xd681, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xd5ef, 0xd6b9, 0xffdf, 0xffdf, 
0xfffe, 0xff7c, 0xf6e7, 0xf6c0, 0xfec0, 0xfea0, 0xfec2, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xffa0, 0xffe1, 0xbdc7, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0840, 0x3984, 0xf7e3, 0xffe0, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa1, 0xff80, 0xff80, 0xff80, 0xffc0, 0xffe0, 0xc604, 0x1841, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0042, 0x0000, 0x0000, 0x0040, 0x0002, 0x39a2, 0xffc3, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xd5cd, 0xd698, 0xffbf, 0xffbf, 
0xffdf, 0xff34, 0xfec3, 0xfea0, 0xfec1, 0xfee0, 0xfec0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf780, 0xff81, 0xff61, 0xff20, 0xffe0, 0xef23, 0x6b01, 0x0000, 0x0800, 0x0820, 0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0800, 0x0020, 0x0062, 0x0002, 0x1020, 0xace3, 0xffe0, 0xf760, 0xff63, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff81, 0xff60, 0xffe0, 0xf760, 0xffa1, 0xf745, 0x72e0, 0x0020, 0x0020, 0x0002, 0x0001, 0x0020, 0x0000, 0x0800, 0x1002, 0x0840, 0x0000, 0x0843, 0x0004, 0x0800, 0xad02, 0xffe2, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xe625, 0xce3a, 0xe75e, 0xffff, 
0xffdf, 0xff34, 0xfec3, 0xfea0, 0xfec1, 0xfee0, 0xfec0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xf740, 0xff61, 0xff60, 0xff80, 0xffc4, 0xb545, 0x18c0, 0x0802, 0x0002, 0x0002, 0x0001, 0x0001, 0x0001, 0x0001, 0x0001, 0x0021, 0x0003, 0x0000, 0x5220, 0xef05, 0xffe1, 0xff80, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff81, 0xf740, 0xffa0, 0xff80, 0xffa1, 0xffc5, 0xc580, 0x0001, 0x0000, 0x0020, 0x0020, 0x0000, 0x0021, 0x0821, 0x0000, 0x0020, 0x0042, 0x0005, 0x0000, 0x4a60, 0xdee3, 0xffc1, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xee25, 0xce3a, 0xe75e, 0xffff, 
0xffdf, 0xf734, 0xf6c2, 0xfea0, 0xfec1, 0xfee0, 0xfec0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff40, 0xff41, 0xff80, 0xff40, 0xffe2, 0xef67, 0x7bc0, 0x0801, 0x0001, 0x0000, 0x0040, 0x0020, 0x0020, 0x0020, 0x0040, 0x0843, 0x0001, 0x2100, 0xb5a1, 0xffe2, 0xf740, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa1, 0xf740, 0xff80, 0xffa0, 0xff80, 0xffc3, 0xff83, 0x62e6, 0x1080, 0x0020, 0x0861, 0x0002, 0x0002, 0x0020, 0x0860, 0x0060, 0x0004, 0x0003, 0x18e0, 0xb5a0, 0xffe2, 0xf720, 0xff22, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xee25, 0xc639, 0xe75d, 0xffff, 
0xffdf, 0xf733, 0xf6c2, 0xfea0, 0xfec0, 0xfee0, 0xfec0, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa1, 0xff40, 0xff40, 0xff80, 0xffa0, 0xf7a2, 0xdf02, 0x4220, 0x0880, 0x0020, 0x0041, 0x0062, 0x0000, 0x0000, 0x0040, 0x0000, 0x0820, 0x94a0, 0xffe2, 0xffe0, 0xff60, 0xff60, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff60, 0xff80, 0xffc0, 0xff80, 0xf780, 0xffe0, 0xef67, 0x5ac0, 0x0800, 0x0002, 0x0005, 0x0003, 0x0000, 0x0000, 0x0861, 0x0001, 0x1080, 0x8c60, 0xf7c1, 0xffe0, 0xf6e0, 0xff62, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xee25, 0xc618, 0xe73d, 0xffff, 
0xffdf, 0xf732, 0xf6c2, 0xfea0, 0xfec0, 0xfee0, 0xfec0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff81, 0xff60, 0xffa0, 0xffa0, 0xef60, 0xffe1, 0xdee8, 0x6320, 0x0020, 0x0001, 0x0004, 0x0004, 0x0001, 0x0000, 0x28e0, 0x9460, 0xf781, 0xffc0, 0xff80, 0xffc0, 0xf740, 0xff81, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xffa0, 0xffa0, 0xffe0, 0xd682, 0x7321, 0x1880, 0x0001, 0x0002, 0x0001, 0x0000, 0x0000, 0x20e0, 0x94a2, 0xef83, 0xffe0, 0xff60, 0xff40, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xee25, 0xc618, 0xe73c, 0xffdf, 
0xffdf, 0xf732, 0xf6c1, 0xfea0, 0xfec0, 0xfee0, 0xfec1, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff40, 0xffa0, 0xff80, 0xff80, 0xffe0, 0xff80, 0xff80, 0xffe2, 0xdec2, 0x9ca2, 0x5241, 0x1840, 0x0800, 0x3120, 0x5a60, 0xbd85, 0xffa3, 0xffe0, 0xffa0, 0xff40, 0xff60, 0xffa0, 0xff42, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff80, 0xffc0, 0xff80, 0xf760, 0xffa1, 0xffc0, 0xf780, 0xff60, 0xffe4, 0xef44, 0x9460, 0x4a00, 0x1060, 0x0800, 0x2920, 0x6b01, 0xad23, 0xffa5, 0xffe0, 0xff60, 0xff41, 0xffa1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xee44, 0xc5f7, 0xe73c, 0xffdf, 
0xffdf, 0xf731, 0xf6c1, 0xfea0, 0xfec0, 0xfee0, 0xfec1, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff61, 0xff40, 0xffa0, 0xffc0, 0xff80, 0xffa1, 0xffa0, 0xf720, 0xff80, 0xffe0, 0xffe3, 0xef45, 0xdec5, 0xe6a4, 0xef25, 0xff85, 0xffe4, 0xffc0, 0xff60, 0xffe1, 0xff60, 0xff40, 0xffc1, 0xf780, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xffc0, 0xffc0, 0xff80, 0xf760, 0xff81, 0xffa1, 0xf780, 0xff20, 0xff60, 0xf780, 0xffc2, 0xf785, 0xd685, 0xd644, 0xef07, 0xf786, 0xffe3, 0xffe1, 0xff60, 0xff80, 0xff80, 0xffa0, 0xf7a0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xf644, 0xc5f7, 0xe73c, 0xfffe, 
0xffde, 0xf731, 0xf6c1, 0xfe80, 0xfec0, 0xfee0, 0xfec1, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff42, 0xffa0, 0xff60, 0xffa0, 0xffa1, 0xf720, 0xff61, 0xffa0, 0xff20, 0xff60, 0xff60, 0xffa0, 0xffe0, 0xffc0, 0xffa0, 0xffa0, 0xff80, 0xff60, 0xff81, 0xff40, 0xff20, 0xff83, 0xf720, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff40, 0xffa0, 0xff60, 0xf760, 0xffa0, 0xff82, 0xff61, 0xffa1, 0xffa0, 0xff60, 0xff80, 0xffc0, 0xf7c0, 0xffe0, 0xffe0, 0xff80, 0xffc0, 0xf740, 0xff60, 0xff62, 0xffa1, 0xff80, 0xf7c0, 0xf7c1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xf644, 0xc5f7, 0xe73c, 0xfffe, 
0xfffd, 0xf716, 0xf6a1, 0xfec0, 0xfec0, 0xfec0, 0xfee1, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xe683, 0xcdd7, 0xef7d, 0xf7ff, 
0xfffd, 0xff36, 0xf6a1, 0xfec0, 0xfec1, 0xfec0, 0xfee1, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xe683, 0xcdd7, 0xe77d, 0xf7df, 
0xfffe, 0xff37, 0xf6a2, 0xfec0, 0xfea1, 0xfec0, 0xfee1, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xe645, 0xcdd8, 0xe77d, 0xf7de, 
0xffff, 0xff37, 0xf6a2, 0xfea0, 0xfec1, 0xfec0, 0xff01, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xde27, 0xcdd8, 0xe77c, 0xefde, 
0xffff, 0xff59, 0xf6c3, 0xfea0, 0xfea1, 0xfec0, 0xff01, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xde09, 0xcdf9, 0xe77d, 0xeffe, 
0xffff, 0xff59, 0xf6c4, 0xfec0, 0xfea1, 0xfee0, 0xff01, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xddeb, 0xd61a, 0xe79d, 0xf7ff, 
0xffff, 0xff7a, 0xf6e5, 0xfec0, 0xfea1, 0xfee0, 0xff01, 0xfec0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xd5cc, 0xd63b, 0xe7bd, 0xf7ff, 
0xffff, 0xff7b, 0xf6e5, 0xfea0, 0xfea1, 0xfee0, 0xff01, 0xfec0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xd5ad, 0xd65b, 0xe7bd, 0xf7ff, 
0xf7ff, 0xffbf, 0xf6ef, 0xf680, 0xfec0, 0xfee0, 0xf6e0, 0xf700, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xffa0, 0xffc0, 0xff80, 0xffc0, 0xff81, 0xff40, 0xffc0, 0xffa3, 0xff64, 0xff42, 0xff60, 0xff40, 0xff60, 0xffc2, 0xef60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff61, 0xff81, 0xff80, 0xff60, 0xffc0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee1, 0xfee1, 0xfec1, 0xfea1, 0xfea0, 0xfec1, 0xc592, 0xdefc, 0xfffe, 0xfffe, 
0xf7ff, 0xffbf, 0xf6f0, 0xf680, 0xfec0, 0xfee0, 0xf6c0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xffc0, 0xffa0, 0xff40, 0xff80, 0xf740, 0xff60, 0xff80, 0xffc0, 0xffa0, 0xff61, 0xff61, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffc2, 0xff60, 0xff80, 0xf720, 0xff80, 0xffc1, 0xffa1, 0xffa1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfea0, 0xee82, 0xc593, 0xdefc, 0xfffe, 0xfffe, 
0xffff, 0xffbf, 0xf6f3, 0xf683, 0xfec0, 0xfec0, 0xfec0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff81, 0xff61, 0xff61, 0xff80, 0xffa0, 0xff80, 0xffa0, 0xffc0, 0xffe0, 0xffc0, 0xff80, 0xff60, 0xff80, 0xff63, 0xf741, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf762, 0xf760, 0xffe0, 0xffe0, 0xf760, 0xff80, 0xff80, 0xff81, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xe646, 0xc5b5, 0xdf1d, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xf716, 0xf6a7, 0xfec0, 0xfec0, 0xfec0, 0xff00, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff81, 0xffa1, 0xff81, 0xff80, 0xff60, 0xffa0, 0xffe1, 0xf784, 0xf7c4, 0xf7a3, 0xffe1, 0xffc0, 0xff60, 0xff64, 0xff61, 0xf780, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffc0, 0xf7c1, 0xef61, 0xf7a2, 0xffe1, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff40, 0xff20, 0xff20, 0xff21, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xd5ea, 0xc5f8, 0xe73d, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xff3a, 0xf6cb, 0xf6c0, 0xfec0, 0xfea0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xf760, 0xffa0, 0xff80, 0xff61, 0xff60, 0xffe0, 0xf763, 0xad04, 0x6301, 0x7380, 0xce42, 0xffe3, 0xffa0, 0xff41, 0xffc2, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf7e1, 0xb580, 0x6b20, 0x7bc1, 0xce43, 0xffe3, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff21, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfea0, 0xcdcf, 0xce5a, 0xe77e, 0xffdf, 0xffdf, 
0xf7ff, 0xffff, 0xff5d, 0xf6cf, 0xf6e0, 0xfec0, 0xfea1, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff40, 0xff80, 0xffa0, 0xff60, 0xff61, 0xff80, 0xffe0, 0xc5e2, 0x2920, 0x0000, 0x0800, 0x6b20, 0xef64, 0xffe1, 0xf720, 0xff80, 0xf760, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xd6e4, 0x2960, 0x0000, 0x0801, 0x4a00, 0xef24, 0xffa0, 0xff60, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff01, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfec0, 0xfe81, 0xf661, 0xbdd3, 0xcebc, 0xefbd, 0xffdf, 0xffdf, 
0xf7ff, 0xffff, 0xff7f, 0xf6f2, 0xf6e0, 0xfec0, 0xfe82, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff40, 0xffa0, 0xffa0, 0xff40, 0xff41, 0xff80, 0xffe0, 0xad62, 0x0800, 0x0023, 0x0001, 0x20c0, 0xbda3, 0xffe3, 0xff80, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0x8c65, 0x0000, 0x0005, 0x0003, 0x18a0, 0xe6e4, 0xffc1, 0xff60, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff01, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfea1, 0xf662, 0xf623, 0xbdd6, 0xd71e, 0xf7fd, 0xffdf, 0xffdf, 
0xf7ff, 0xffff, 0xff7f, 0xff14, 0xf701, 0xfec0, 0xfe82, 0xfea0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xf741, 0xff80, 0xff40, 0xff21, 0xff40, 0xffe0, 0xc626, 0x1042, 0x0020, 0x0002, 0x0800, 0x83e0, 0xffa2, 0xff80, 0xffc0, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0x2120, 0x0000, 0x0004, 0x0000, 0x4aa0, 0xffe7, 0xf720, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xfee0, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfea2, 0xf643, 0xf604, 0xbdd8, 0xdf3f, 0xf7fd, 0xffdf, 0xffdf, 
0xffff, 0xfffe, 0xffff, 0xff7d, 0xf6e9, 0xfea0, 0xfea1, 0xfea1, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff81, 0xff60, 0xffc0, 0xf740, 0xffa1, 0xff45, 0x7b20, 0x0001, 0x0020, 0x0002, 0x1080, 0xcea3, 0xffe0, 0xff60, 0xff60, 0xff80, 0xff80, 0xffa1, 0xffc1, 0xffa0, 0xffa0, 0xff81, 0xff63, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf762, 0xff80, 0xff40, 0xffa1, 0xff40, 0xffc0, 0xf7e4, 0x8461, 0x0061, 0x0020, 0x0821, 0x1000, 0xb523, 0xffe0, 0xf740, 0xff83, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xfee0, 0xff20, 0xfec2, 0xfe62, 0xfe60, 0xfec0, 0xf6c4, 0xc590, 0xce79, 0xf79e, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xff9e, 0xfeee, 0xfea1, 0xfea0, 0xfea1, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff20, 0xff61, 0xff40, 0xffa0, 0xf760, 0xffa0, 0xffe5, 0xcda0, 0x0000, 0x0860, 0x0000, 0x1061, 0x52a0, 0xffe2, 0xffa0, 0xff61, 0xff80, 0xff60, 0xff40, 0xff60, 0xff80, 0xff80, 0xffa0, 0xff61, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa1, 0xff61, 0xff80, 0xff40, 0xffe0, 0xd6c6, 0x2940, 0x0020, 0x0041, 0x0000, 0x4180, 0xf747, 0xffa0, 0xffa0, 0xff81, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xfee0, 0xff20, 0xfec1, 0xfe82, 0xfea0, 0xfec0, 0xe666, 0xc592, 0xd6ba, 0xf7be, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffdf, 0xff15, 0xf6c4, 0xfec0, 0xfea1, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff60, 0xff80, 0xff40, 0xffa0, 0xff80, 0xff60, 0xffe3, 0xffa3, 0x5ae0, 0x0000, 0x0001, 0x0001, 0x0840, 0xad61, 0xffe0, 0xff61, 0xffa0, 0xff80, 0xff61, 0xff80, 0xff80, 0xff80, 0xffc0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff42, 0xffc5, 0xff40, 0xffc0, 0xf7a4, 0x7362, 0x0000, 0x0000, 0x0825, 0x0800, 0xad22, 0xffe4, 0xffa0, 0xff60, 0xffa0, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xff01, 0xfec0, 0xfe81, 0xfee0, 0xfec0, 0xd5e9, 0xcdd6, 0xe71c, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffff, 0xff5b, 0xf6ca, 0xf6c0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff60, 0xff80, 0xff40, 0xff80, 0xffa0, 0xff60, 0xff80, 0xffe0, 0xdec3, 0x1840, 0x0004, 0x0001, 0x0000, 0x39a0, 0xe6e5, 0xffe0, 0xf760, 0xffa0, 0xffa0, 0xffc1, 0xff80, 0xff80, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff42, 0xff81, 0xff80, 0xffe1, 0xb564, 0x1060, 0x0001, 0x0021, 0x0002, 0x5260, 0xffc4, 0xffc0, 0xff80, 0xff60, 0xffa1, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee3, 0xfec0, 0xfe80, 0xff00, 0xeea0, 0xc5ae, 0xd63a, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffdf, 0xffff, 0xffff, 0xff9f, 0xf711, 0xf6c1, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffe2, 0x7b81, 0x0801, 0x0822, 0x0000, 0x0000, 0x7b85, 0xffe1, 0xf7a0, 0xf780, 0xf760, 0xffc0, 0xffa1, 0xff80, 0xffa1, 0xff40, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xffc1, 0xef40, 0xffe1, 0xdec2, 0x41c0, 0x0000, 0x0020, 0x0000, 0x1860, 0xce25, 0xffe0, 0xffc0, 0xff40, 0xffa0, 0xff41, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfec3, 0xfec0, 0xfea0, 0xfee1, 0xde85, 0xc5b3, 0xde9d, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf738, 0xf6c9, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff60, 0xff80, 0xff40, 0xff40, 0xff81, 0xff80, 0xff80, 0xff80, 0xef24, 0x41c0, 0x0000, 0x0000, 0x0000, 0x1880, 0xa501, 0xffe4, 0xffe2, 0xef60, 0xf780, 0xffc0, 0xff61, 0xff81, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff80, 0xffe0, 0xef82, 0x6b20, 0x0000, 0x0022, 0x0020, 0x0800, 0x83e0, 0xffe4, 0xf780, 0xffa0, 0xffa0, 0xff80, 0xff40, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xff00, 0xfec2, 0xfea0, 0xfea0, 0xf6a3, 0xce2b, 0xc617, 0xe73f, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffdf, 0xf7ff, 0xf7ff, 0xff7e, 0xf6b0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff21, 0xff80, 0xff80, 0xff40, 0xff40, 0xff61, 0xff81, 0xff60, 0xff60, 0xffe2, 0xb5a1, 0x18c0, 0x0801, 0x0000, 0x0000, 0x2941, 0xc5e1, 0xffe6, 0xffe1, 0xf760, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff60, 0xffa3, 0x8c01, 0x0820, 0x0002, 0x0000, 0x0020, 0x5240, 0xe704, 0xffe0, 0xffa0, 0xff20, 0xffe4, 0xff20, 0xff80, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xf720, 0xfec0, 0xfe60, 0xfea0, 0xe665, 0xc5f2, 0xd69b, 0xefbf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xf7df, 0xf7fe, 0xf7fe, 0xff9f, 0xfeb6, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff01, 0xff20, 0xff20, 0xff20, 0xff60, 0xff62, 0xff62, 0xff81, 0xffa0, 0xf780, 0xffe3, 0x73a1, 0x0002, 0x0841, 0x0040, 0x0004, 0x4a20, 0xdec5, 0xffe4, 0xef60, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff61, 0xffe2, 0xbda0, 0x2080, 0x0003, 0x1064, 0x0000, 0x0062, 0xb585, 0xffe3, 0xffc0, 0xffa0, 0xff20, 0xff44, 0xff03, 0xffa0, 0xff40, 0xff40, 0xff40, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xf720, 0xfec0, 0xfe61, 0xfea0, 0xde26, 0xc5b6, 0xdefd, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xefb9, 0xd6f4, 0xfec0, 0xfec1, 0xfea3, 0xfea0, 0xfec0, 0xfee1, 0xff02, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff82, 0xf720, 0xffe0, 0xeee4, 0x6260, 0x0800, 0x0000, 0x0020, 0x0002, 0x5281, 0xdee4, 0xffe2, 0xf760, 0xff80, 0xffa0, 0xff40, 0xf780, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xffa0, 0xff81, 0xff41, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf780, 0xffc0, 0xff80, 0xf780, 0xffa0, 0xff80, 0xff80, 0xffa2, 0xffe2, 0xbdc2, 0x20e0, 0x0001, 0x1083, 0x0001, 0x1840, 0x9c45, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfe61, 0xfe80, 0xfee0, 0xee83, 0xc5b2, 0xc63c, 0xef7e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xf7db, 0xdf37, 0xfea1, 0xfea2, 0xfea0, 0xfec0, 0xfee0, 0xfee1, 0xff01, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff81, 0xff40, 0xff80, 0xffe4, 0xce04, 0x41c0, 0x0000, 0x0024, 0x0000, 0x0000, 0x6300, 0xe723, 0xffe2, 0xf740, 0xeec0, 0xffe1, 0xff80, 0xff60, 0xff60, 0xffa0, 0xffa0, 0xff60, 0xff60, 0xffa1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffc0, 0xff61, 0xff62, 0xffc0, 0xffe0, 0xff81, 0xf780, 0xffc0, 0xc624, 0x2900, 0x0000, 0x0060, 0x0002, 0x0802, 0x6b20, 0xf7a1, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfe80, 0xfec0, 0xfec0, 0xde28, 0xc5d5, 0xd6dc, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdd, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffd, 0xef7b, 0xfe8a, 0xf6a3, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xffa1, 0xff40, 0xffc0, 0xffe3, 0xad80, 0x2940, 0x0004, 0x0060, 0x0000, 0x0000, 0x5ac0, 0xd6a2, 0xffe0, 0xffa0, 0xff60, 0xff80, 0xff80, 0xff60, 0xff60, 0xffa1, 0xffc1, 0xffa0, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff40, 0xff61, 0xff82, 0xff80, 0xffa0, 0xffe0, 0xf7a2, 0xce23, 0x2920, 0x0000, 0x0000, 0x0043, 0x0002, 0x4a60, 0xf7a3, 0xffe0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfe80, 0xfee0, 0xee63, 0xc5af, 0xce59, 0xe79d, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf6b4, 0xeec7, 0xf6c0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xffa1, 0xffa1, 0xf740, 0xffc0, 0xffe4, 0xa525, 0x20a0, 0x0003, 0x0000, 0x0040, 0x0000, 0x4a22, 0xdec5, 0xffc1, 0xffe2, 0xff20, 0xff60, 0xffa0, 0xff80, 0xff60, 0xff80, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff20, 0xff60, 0xffa0, 0xf7c0, 0xf7e0, 0xa543, 0x28c1, 0x0002, 0x0060, 0x0021, 0x0004, 0x4a41, 0xd6e2, 0xffe2, 0xf740, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfea0, 0xfec0, 0xd5ca, 0xbd96, 0xd6fb, 0xf7fe, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf71c, 0xeeed, 0xeec0, 0xfea0, 0xfea0, 0xfec0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xf720, 0xffc1, 0xffa0, 0xf740, 0xffe2, 0xffc6, 0xad40, 0x0802, 0x0860, 0x0020, 0x0022, 0x0003, 0x3121, 0xb584, 0xffe3, 0xffe0, 0xff60, 0xff40, 0xffa0, 0xffa0, 0xf740, 0xf760, 0xffc1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff40, 0xffa0, 0xf740, 0xffe0, 0xffe4, 0x8421, 0x0800, 0x0002, 0x10a2, 0x0001, 0x0001, 0x4a60, 0xcec2, 0xffe3, 0xff42, 0xffa2, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xe645, 0xc591, 0xc61a, 0xe79c, 0xffff, 0xffbf, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79f, 0xef35, 0xeec8, 0xf682, 0xfe80, 0xfea0, 0xfee0, 0xff00, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff40, 0xff60, 0xff60, 0xff40, 0xff81, 0xffe1, 0xffe0, 0xad43, 0x1860, 0x0001, 0x0000, 0x0000, 0x0001, 0x18a0, 0x8c60, 0xf763, 0xffc3, 0xffe2, 0xffc0, 0xff80, 0xffa0, 0xff80, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffe1, 0xffa0, 0xffe2, 0xdea5, 0x5aa2, 0x0801, 0x0002, 0x0020, 0x0000, 0x0801, 0x4a20, 0xd6e2, 0xffe1, 0xf740, 0xffc0, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xf683, 0xd5cd, 0xc5b7, 0xd6dc, 0xf7fd, 0xffdf, 0xffbf, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf77c, 0xf6f1, 0xf685, 0xfe80, 0xfea0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff61, 0xff80, 0xff40, 0xff00, 0xff40, 0xff61, 0xff80, 0xffa0, 0xffe1, 0xb544, 0x2900, 0x0040, 0x0060, 0x0000, 0x0020, 0x0000, 0x6b20, 0xb586, 0xf7a7, 0xffc2, 0xef60, 0xf760, 0xffa0, 0xff81, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xef83, 0xffe6, 0xa522, 0x2900, 0x0801, 0x0001, 0x0000, 0x0020, 0x1000, 0x5aa0, 0xe724, 0xffe2, 0xf720, 0xffa0, 0xff60, 0xff00, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xde29, 0xcdd3, 0xd67b, 0xef9d, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xf79f, 0xfef7, 0xfe88, 0xfe80, 0xfea0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff61, 0xf720, 0xff60, 0xffa0, 0xff60, 0xff60, 0xffa1, 0xff80, 0xff40, 0xffe0, 0xc641, 0x29a0, 0x0003, 0x0062, 0x0000, 0x0823, 0x0000, 0x2920, 0x8c40, 0xe742, 0xffe1, 0xffa0, 0xff40, 0xff81, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xcee0, 0x52a0, 0x0800, 0x0000, 0x0020, 0x0020, 0x0040, 0x0002, 0x8365, 0xef43, 0xffe0, 0xf720, 0xff80, 0xff80, 0xff60, 0xff24, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xfea0, 0xcdcd, 0xcdd6, 0xe6fc, 0xfffe, 0xffdf, 0xfffe, 0xfffd, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xff7f, 0xf6d6, 0xf6a7, 0xfee0, 0xfee0, 0xfea0, 0xf6e0, 0xf6e0, 0xf720, 0xf740, 0xff40, 0xff40, 0xff20, 0xff21, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffc0, 0xffe0, 0xdec2, 0x7380, 0x0840, 0x0002, 0x0805, 0x0000, 0x0000, 0x0000, 0x3180, 0x9ca4, 0xef46, 0xffe3, 0xffa0, 0xf761, 0xffc2, 0xffa1, 0xf780, 0xffa0, 0xffc0, 0xffa0, 0xffc0, 0xff60, 0xff80, 0xff80, 0xff81, 0xff81, 0xff61, 0xff40, 0xf740, 0xf760, 0xff80, 0xf780, 0xf760, 0xf780, 0xffa0, 0xffc0, 0xf780, 0xff60, 0xff60, 0xff60, 0xffa0, 0xffe1, 0xffe5, 0xc624, 0x83c0, 0x08c2, 0x0020, 0x0000, 0x1083, 0x0001, 0x0000, 0x3180, 0x8ca4, 0xffa0, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xf721, 0xf6c0, 0xfec0, 0xfee0, 0xfec0, 0xfee0, 0xf6a5, 0xd5e8, 0xbdd7, 0xdedb, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xff9f, 0xff39, 0xf6ed, 0xf6c3, 0xfea0, 0xfea0, 0xfec1, 0xfee1, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff60, 0xf740, 0xf780, 0xffe3, 0xef65, 0xa4e4, 0x39c0, 0x0800, 0x0001, 0x0020, 0x0000, 0x0000, 0x1000, 0x3140, 0x8c40, 0xef62, 0xffc1, 0xffe0, 0xffc0, 0xf780, 0xffa0, 0xffa0, 0xff42, 0xff23, 0xffc0, 0xffc0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff40, 0xffa1, 0xffc1, 0xff80, 0xf760, 0xf760, 0xff80, 0xffa0, 0xffa0, 0xffe0, 0xffe0, 0xef80, 0xbde2, 0x7ba4, 0x3121, 0x0800, 0x0020, 0x0021, 0x0003, 0x0001, 0x0820, 0x52a0, 0xbde3, 0xffe6, 0xffa0, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xf6e0, 0xff00, 0xfec0, 0xfe80, 0xfea0, 0xfee0, 0xe668, 0xcdb1, 0xce79, 0xe73c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xf736, 0xee8c, 0xf683, 0xfec0, 0xfec0, 0xfec1, 0xfee1, 0xfec1, 0xfec1, 0xfee1, 0xff00, 0xff40, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff80, 0xff81, 0xff60, 0xf740, 0xffa0, 0xffe1, 0xffc3, 0xbda2, 0x7b60, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0820, 0x0840, 0x1080, 0x7b60, 0xb523, 0xef26, 0xffe5, 0xffe1, 0xff60, 0xff60, 0xffa0, 0xff81, 0xff81, 0xff81, 0xf760, 0xff80, 0xffa0, 0xffc0, 0xffc0, 0xff80, 0xff80, 0xff80, 0xff80, 0xffc0, 0xffe0, 0xffc0, 0xffa0, 0xefa1, 0xcea3, 0x94a4, 0x5262, 0x1060, 0x0000, 0x0000, 0x0880, 0x0001, 0x0001, 0x0000, 0x2900, 0x8c41, 0xf764, 0xffe2, 0xf760, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xf6c0, 0xff01, 0xfea1, 0xfe60, 0xfea1, 0xe665, 0xcdee, 0xc5fa, 0xe73c, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xff9f, 0xf6d6, 0xf689, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfea1, 0xfec1, 0xff00, 0xff40, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xffc1, 0xffa1, 0xf740, 0xf740, 0xffc0, 0xffc1, 0xff41, 0xa563, 0x4a40, 0x0800, 0x0001, 0x0823, 0x0002, 0x0003, 0x0004, 0x0000, 0x1040, 0x3140, 0x62c2, 0x9ca3, 0xd643, 0xf761, 0xffe0, 0xffc1, 0xffc1, 0xffe1, 0xffe0, 0xffe0, 0xffe0, 0xffe0, 0xffc0, 0xffe0, 0xffe0, 0xffe1, 0xffe4, 0xffa6, 0xe6c6, 0xb563, 0x9440, 0x4aa2, 0x2120, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x0800, 0x18a0, 0x6b20, 0xce63, 0xffe1, 0xffa0, 0xff60, 0xffa1, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xfea1, 0xfea0, 0xfec0, 0xf662, 0xcd8d, 0xbdd7, 0xd6fd, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xfffe, 0xffff, 0xffdf, 0xff5d, 0xf6f1, 0xeea6, 0xf6a0, 0xfec0, 0xfee0, 0xfee0, 0xfec0, 0xfec1, 0xff00, 0xff40, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff61, 0xffa1, 0xffa0, 0xff60, 0xff60, 0xffa1, 0xffa0, 0xff80, 0xffe0, 0xe761, 0x9ce1, 0x39a0, 0x0002, 0x0004, 0x0021, 0x0040, 0x0020, 0x0020, 0x0001, 0x0001, 0x0000, 0x0840, 0x3180, 0x5281, 0x8c20, 0x9460, 0x9cc1, 0xad21, 0xb562, 0xb582, 0xb5a1, 0xb581, 0xa524, 0x94c3, 0x8423, 0x6322, 0x4201, 0x20e0, 0x0820, 0x0000, 0x0002, 0x0000, 0x0000, 0x0040, 0x0001, 0x0002, 0x0002, 0x0842, 0x5aa0, 0xb584, 0xffe5, 0xffe0, 0xf740, 0xffa0, 0xffa2, 0xff43, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfee0, 0xfea0, 0xfee0, 0xf6c0, 0xd5e7, 0xbd75, 0xce7d, 0xe7dc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffbf, 0xf758, 0xeef0, 0xf6a4, 0xf6c1, 0xfee0, 0xfee0, 0xfee0, 0xfee1, 0xff00, 0xff20, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff64, 0xff41, 0xff60, 0xff60, 0xff80, 0xff81, 0xff60, 0xff40, 0xf7a0, 0xffc0, 0xffe1, 0xe743, 0x9d00, 0x4a80, 0x10a0, 0x0000, 0x0023, 0x0002, 0x0003, 0x0024, 0x0024, 0x0003, 0x0002, 0x0001, 0x0800, 0x0800, 0x0800, 0x0800, 0x0800, 0x0800, 0x0800, 0x0800, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0001, 0x0022, 0x0040, 0x0001, 0x0002, 0x0002, 0x0000, 0x2920, 0x73a0, 0xb5c1, 0xffc3, 0xffe1, 0xffe0, 0xffa0, 0xff61, 0xff83, 0xff42, 0xff00, 0xff80, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfe82, 0xfee0, 0xff00, 0xde46, 0xbd90, 0xce3a, 0xef9e, 0xeffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xef5c, 0xeecf, 0xeec8, 0xf6c1, 0xfec0, 0xfec0, 0xfec1, 0xfee1, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff00, 0xff20, 0xff60, 0xffa0, 0xff80, 0xff60, 0xff60, 0xff80, 0xf720, 0xff60, 0xff81, 0xffa0, 0xffe0, 0xf7a2, 0xc603, 0x7ba1, 0x2920, 0x1060, 0x0000, 0x0000, 0x0000, 0x0000, 0x0040, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0001, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0020, 0x0000, 0x0800, 0x1860, 0x5240, 0xa4e0, 0xdf00, 0xffe0, 0xffe0, 0xffa0, 0xffc0, 0xffa0, 0xff81, 0xff41, 0xff61, 0xff80, 0xffa0, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfe80, 0xfea0, 0xe666, 0xc5f1, 0xc639, 0xe73d, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xf7bf, 0xeed8, 0xeecf, 0xf6a4, 0xfea0, 0xfea0, 0xfec1, 0xfee1, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff42, 0xff43, 0xff60, 0xf780, 0xf7a0, 0xf7a0, 0xff82, 0xff40, 0xff60, 0xffa0, 0xffa1, 0xffc2, 0xffe1, 0xffc0, 0xf7c1, 0xc620, 0x8420, 0x5242, 0x20a1, 0x0001, 0x0001, 0x0021, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0020, 0x0000, 0x0000, 0x0000, 0x0800, 0x0820, 0x0820, 0x0000, 0x0000, 0x0861, 0x2123, 0x62e1, 0x94a2, 0xd6a3, 0xf7a2, 0xffc1, 0xffa1, 0xff61, 0xff40, 0xff60, 0xff41, 0xff41, 0xff60, 0xffa0, 0xffa0, 0xf780, 0xf760, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfec0, 0xf644, 0xcd6e, 0xc5d8, 0xdf1e, 0xefdf, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe7bf, 0xe739, 0xe6ca, 0xf681, 0xfea0, 0xfec0, 0xfea1, 0xfe81, 0xfec1, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff21, 0xff01, 0xff00, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffc0, 0xffe0, 0xffe1, 0xffc1, 0xeee0, 0xc5c0, 0xa4a0, 0x8be0, 0x5243, 0x4a02, 0x3981, 0x28e0, 0x20a0, 0x1881, 0x2082, 0x20a3, 0x30e0, 0x4160, 0x5220, 0x6b00, 0x8c00, 0xad40, 0xd682, 0xf764, 0xffa0, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee1, 0xfec1, 0xfee0, 0xff20, 0xff00, 0xfe82, 0xfe82, 0xff00, 0xce2b, 0xc5ef, 0xcdf5, 0xe6bc, 0xf77f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xef9d, 0xeed7, 0xf68d, 0xf6a2, 0xfec0, 0xfec0, 0xfea1, 0xfec2, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff01, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf740, 0xff60, 0xffa0, 0xffc0, 0xffc1, 0xffa2, 0xf764, 0xf745, 0xffe1, 0xf7e1, 0xefa1, 0xef60, 0xe741, 0xe741, 0xe742, 0xef63, 0xef64, 0xf7a4, 0xffe4, 0xffe2, 0xf7e0, 0xf7c0, 0xffc0, 0xffe0, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xfec1, 0xfe82, 0xfec1, 0xff00, 0xf6c0, 0xe623, 0xc5cf, 0xce34, 0xe6ba, 0xf75f, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fd, 0xffff, 0xf75f, 0xf6d9, 0xeeac, 0xeea1, 0xf6c0, 0xfee0, 0xfea1, 0xfea0, 0xfec0, 0xfec0, 0xfec1, 0xfee1, 0xff00, 0xff40, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff80, 0xff81, 0xff80, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xffa0, 0xffa1, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xf780, 0xf7a0, 0xffc0, 0xffc0, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xfee0, 0xfea3, 0xfe83, 0xfec0, 0xff20, 0xe684, 0xcd8c, 0xcdf5, 0xe6ba, 0xff7f, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77f, 0xe6f8, 0xe6ae, 0xeea5, 0xf6e0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfec1, 0xfec1, 0xff00, 0xff40, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff60, 0xff80, 0xff80, 0xffa0, 0xffa0, 0xff80, 0xff80, 0xff61, 0xff61, 0xff81, 0xff81, 0xff81, 0xff81, 0xff81, 0xff80, 0xffa0, 0xff80, 0xff60, 0xff60, 0xff61, 0xff62, 0xff63, 0xff83, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfee0, 0xfe80, 0xfe82, 0xfee0, 0xfee0, 0xe645, 0xcdcf, 0xc5d6, 0xe6bc, 0xf75f, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xef7f, 0xeefa, 0xe6af, 0xe687, 0xf6a0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee1, 0xff00, 0xff20, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff81, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xffa0, 0xff80, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfec0, 0xf6a0, 0xde25, 0xcd90, 0xcdf9, 0xdedd, 0xf77f, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf79d, 0xef18, 0xe694, 0xeec5, 0xeec2, 0xf6c0, 0xfec0, 0xfec0, 0xfee1, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff41, 0xff41, 0xff41, 0xff62, 0xff61, 0xff61, 0xff61, 0xff61, 0xff61, 0xff81, 0xff80, 0xff61, 0xff61, 0xff61, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfe80, 0xff00, 0xf6c2, 0xd5ea, 0xc572, 0xce18, 0xe71c, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79d, 0xef3c, 0xe6d3, 0xe6cd, 0xeea5, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff61, 0xff61, 0xff80, 0xff60, 0xff60, 0xff80, 0xff60, 0xff60, 0xff60, 0xff80, 0xff80, 0xff80, 0xff80, 0xff60, 0xff60, 0xff60, 0xff60, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xf662, 0xee65, 0xd62c, 0xc5d6, 0xc63b, 0xdf3d, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fc, 0xe6ff, 0xe6b6, 0xee6b, 0xf663, 0xfea0, 0xfea0, 0xfea0, 0xf6a0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff40, 0xff40, 0xff60, 0xff60, 0xff60, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff60, 0xff60, 0xff80, 0xff60, 0xff40, 0xff40, 0xff61, 0xff61, 0xff40, 0xff40, 0xff40, 0xff40, 0xff40, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xfea0, 0xf682, 0xd58c, 0xc556, 0xc65b, 0xdf9d, 0xf7fe, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xfffc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xef7e, 0xe6fb, 0xdeb4, 0xe68b, 0xeea2, 0xfec0, 0xfee0, 0xfea2, 0xfec1, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfee0, 0xfee0, 0xff00, 0xff23, 0xfee1, 0xfea0, 0xfea0, 0xfec0, 0xfec2, 0xe684, 0xce25, 0xad75, 0xc618, 0xdefb, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xf79d, 0xef1b, 0xe6b5, 0xe66c, 0xee84, 0xf6a0, 0xfee0, 0xfec0, 0xfec0, 0xfea1, 0xfec2, 0xfec1, 0xff00, 0xff00, 0xfee1, 0xfee1, 0xfee1, 0xff00, 0xff00, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfea1, 0xfee0, 0xff20, 0xfee0, 0xee80, 0xde26, 0xce0e, 0xc613, 0xd69a, 0xdefb, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffbf, 0xf73e, 0xeeb8, 0xe690, 0xe66a, 0xfec0, 0xfea0, 0xfea0, 0xfea1, 0xfea1, 0xfec0, 0xfec0, 0xfee0, 0xfea1, 0xfec1, 0xfec1, 0xfec1, 0xfee0, 0xff00, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff20, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xf6e0, 0xfec0, 0xfec1, 0xfec1, 0xfea2, 0xfea0, 0xfec0, 0xfec1, 0xe664, 0xcde9, 0xc5d0, 0xc638, 0xd69e, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79f, 0xef1b, 0xe6b7, 0xee2c, 0xee69, 0xf6a4, 0xfec0, 0xfee0, 0xfec0, 0xfea0, 0xfe81, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff20, 0xff00, 0xfee0, 0xfea1, 0xfea1, 0xfec0, 0xfee0, 0xff00, 0xfea0, 0xee42, 0xd5e9, 0xc5b1, 0xc5d7, 0xce7b, 0xe71e, 0xef9e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xef5f, 0xe67a, 0xe675, 0xe68e, 0xeea6, 0xf6a1, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xff00, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfe80, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xd608, 0xcdec, 0xc5f3, 0xce3a, 0xdedf, 0xef7f, 0xffde, 0xfffc, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffc, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7fe, 0xfffe, 0xffff, 0xf7bf, 0xef7e, 0xe6fa, 0xe695, 0xe64e, 0xee47, 0xf682, 0xf6a0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfee0, 0xfec0, 0xfec0, 0xfec1, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfe81, 0xfea0, 0xfec0, 0xfec0, 0xeea0, 0xe645, 0xddca, 0xd58d, 0xc5d7, 0xce38, 0xd6db, 0xe77d, 0xefde, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79f, 0xef1f, 0xe6bb, 0xde95, 0xde8f, 0xde8b, 0xee88, 0xf686, 0xf6a3, 0xf6c0, 0xfec0, 0xfec0, 0xfea0, 0xfea1, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfee0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xf6a1, 0xee83, 0xe667, 0xd62c, 0xce12, 0xcdf7, 0xc5fb, 0xdede, 0xe73e, 0xf7be, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffc, 0xf7fc, 0xfffe, 0xffff, 0xffdf, 0xffdf, 0xf7fd, 0xfffe, 0xffff, 0xffdf, 0xf79f, 0xef5f, 0xdefe, 0xd6bc, 0xe64f, 0xee6c, 0xee87, 0xf6c3, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfec0, 0xfea0, 0xfea0, 0xfea0, 0xee63, 0xde27, 0xcdad, 0xc593, 0xc5d8, 0xc67b, 0xd75c, 0xdfdc, 0xf7fc, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xf7be, 0xdf3f, 0xdefd, 0xd699, 0xce34, 0xd60e, 0xde48, 0xeea3, 0xf6e0, 0xf6c1, 0xf6c1, 0xfec1, 0xfec1, 0xfec1, 0xfea1, 0xfea1, 0xfe81, 0xfea2, 0xfea1, 0xfea1, 0xfea1, 0xfec1, 0xfec1, 0xfec1, 0xfec1, 0xfea0, 0xfea0, 0xfea0, 0xfec0, 0xfec0, 0xfec0, 0xf6c0, 0xf6c0, 0xfea0, 0xfec0, 0xfec0, 0xf6c0, 0xee80, 0xde45, 0xd5ea, 0xcdce, 0xb5b6, 0xbdf7, 0xce59, 0xdedb, 0xef5d, 0xf79e, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xf7be, 0xef5e, 0xeefd, 0xe69b, 0xe639, 0xde17, 0xddf5, 0xe666, 0xee66, 0xee84, 0xf682, 0xf6a0, 0xfec0, 0xfee0, 0xfee0, 0xfe80, 0xfe80, 0xfe80, 0xfe80, 0xfe80, 0xfe80, 0xfe80, 0xfe80, 0xfea0, 0xfea0, 0xfea0, 0xfe80, 0xfe81, 0xfe81, 0xfe61, 0xfe61, 0xde47, 0xde28, 0xd60a, 0xcded, 0xcdf1, 0xc5f5, 0xce19, 0xce1b, 0xdefb, 0xe73c, 0xef7d, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9f, 0xef5e, 0xe71c, 0xe6db, 0xd63b, 0xd61a, 0xd618, 0xd615, 0xd5f2, 0xd60f, 0xd60d, 0xd60c, 0xee85, 0xee85, 0xee85, 0xee84, 0xee84, 0xee84, 0xee83, 0xee63, 0xde27, 0xde27, 0xde28, 0xd609, 0xd60b, 0xd5ec, 0xd60d, 0xd5ee, 0xc615, 0xc616, 0xce18, 0xce5a, 0xd69c, 0xdefd, 0xe75e, 0xef9e, 0xf7be, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xf7fe, 0xf7fe, 0xeffe, 0xeffe, 0xf79f, 0xef9f, 0xef5e, 0xe71c, 0xdefb, 0xdeb9, 0xd698, 0xd698, 0xce19, 0xce19, 0xcdf8, 0xcdf8, 0xc5f8, 0xc5f7, 0xc5d7, 0xc5f7, 0xc636, 0xc637, 0xc638, 0xc639, 0xc63b, 0xce5c, 0xce5d, 0xce7e, 0xde7f, 0xdebf, 0xe6ff, 0xef3f, 0xf79f, 0xffbe, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffbf, 0xf77e, 0xf75f, 0xf73e, 0xe75f, 0xe75f, 0xe75e, 0xe75e, 0xe73e, 0xe73e, 0xe73d, 0xe73d, 0xef3b, 0xef3b, 0xe73b, 0xef5c, 0xef7c, 0xef7d, 0xef9e, 0xf7bf, 0xf7fd, 0xfffd, 0xfffd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7fe, 0xf7fe, 0xf7fe, 0xeffe, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffbe, 0xffbd, 0xffbc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffd, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};
const unsigned short  clown[] PROGMEM = {
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xfffd, 0xffdc, 0xff9c, 0xf75b, 0xef3a, 0xef19, 0xe719, 0xe6f9, 0xef5a, 0xf79b, 0xffdc, 0xfffd, 0xffdd, 0xffbe, 0xffdf, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xdeda, 0xce78, 0xc658, 0xce58, 0xd674, 0xd654, 0xce33, 0xce13, 0xce13, 0xce13, 0xce33, 0xce34, 0xbdd1, 0xc633, 0xd695, 0xd696, 0xce76, 0xce56, 0xd677, 0xd698, 0xe73c, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbd, 0xef1b, 0xd655, 0xd675, 0xde75, 0xd674, 0xd653, 0xce52, 0xce51, 0xce51, 0xd5f2, 0xd612, 0xd612, 0xd633, 0xd633, 0xd633, 0xd633, 0xd633, 0xd632, 0xd632, 0xd632, 0xd632, 0xd631, 0xd631, 0xd611, 0xd610, 0xce11, 0xd653, 0xd654, 0xce55, 0xdeb8, 0xf79c, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xffde, 0xffde, 0xffff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffbf, 0xffff, 0xffff, 0xf7df, 0xefff, 0xf7fe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf79d, 0xe71a, 0xee16, 0xedf6, 0xf658, 0xff3c, 0xffbe, 0xffdf, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xf79e, 0xf77c, 0xe6f9, 0xde98, 0xde76, 0xce15, 0xcdf2, 0xce13, 0xd633, 0xd653, 0xd673, 0xde73, 0xde93, 0xdeb3, 0xe6b4, 0xe6b4, 0xe6d4, 0xe6d4, 0xeed4, 0xeed4, 0xeed4, 0xeed4, 0xe6b5, 0xe6b4, 0xe6b4, 0xe6b4, 0xe6b4, 0xde93, 0xde93, 0xde73, 0xd632, 0xd653, 0xd633, 0xce13, 0xce34, 0xd676, 0xd697, 0xd677, 0xf7be, 0xf7bd, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffbe, 0xfffd, 0xf71a, 0xe637, 0xe637, 0xf6fb, 0xffbd, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xefff, 0xeffe, 0xf7ff, 0xffff, 0xff1b, 0xed75, 0xdc70, 0xd3cd, 0xe1e7, 0xc985, 0xc1e7, 0xcb2c, 0xcc92, 0xde17, 0xefbd, 0xefff, 0xffff, 0xfffe, 0xf7bd, 0xe71a, 0xd657, 0xde17, 0xfedb, 0xff9f, 0xff9c, 0xef1a, 0xdeb8, 0xd676, 0xce13, 0xcdf2, 0xce12, 0xce11, 0xd652, 0xde73, 0xe693, 0xe6b4, 0xe6b4, 0xe6d4, 0xeed5, 0xeef5, 0xef15, 0xef35, 0xef35, 0xf736, 0xf756, 0xf756, 0xf756, 0xf756, 0xf737, 0xf737, 0xf737, 0xf737, 0xef36, 0xef16, 0xeef6, 0xeef6, 0xeed4, 0xe6b4, 0xde93, 0xde73, 0xd653, 0xce33, 0xce12, 0xc5f2, 0xd656, 0xd656, 0xe6f8, 0xffdb, 0xfffc, 0xff3a, 0xf657, 0xfe17, 0xf698, 0xff3b, 0xff7d, 0xffdf, 0xffdf, 0xff5e, 0xee39, 0xccd3, 0xd36b, 0xd2ea, 0xca27, 0xca28, 0xdb0b, 0xe40f, 0xf594, 0xff5a, 0xffff, 0xffdf, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xf7bf, 0xf7ff, 0xffff, 0xffff, 0xffbe, 0xff3c, 0xff3c, 0xdef7, 0xe6d8, 0xff7b, 0xff3b, 0xf554, 0xdbae, 0xe32c, 0xeb0b, 0xfc0d, 0xfbed, 0xf3ad, 0xdb0a, 0xba48, 0xc2cb, 0xfcd3, 0xfebb, 0xf677, 0xe4d2, 0xdaab, 0xd126, 0xc0e5, 0xb9e8, 0xbbad, 0xc512, 0xde76, 0xd634, 0xce13, 0xd612, 0xd632, 0xd671, 0xdeb2, 0xe6f2, 0xeef3, 0xef14, 0xf735, 0xf736, 0xf736, 0xf737, 0xf737, 0xf738, 0xf758, 0xf758, 0xf778, 0xf778, 0xf778, 0xf778, 0xf778, 0xf778, 0xff9a, 0xff9a, 0xff9a, 0xff79, 0xf779, 0xf779, 0xf758, 0xf758, 0xff57, 0xf716, 0xef16, 0xf736, 0xf735, 0xeef4, 0xe6d3, 0xe6d3, 0xde33, 0xd5f2, 0xd5f2, 0xe613, 0xe551, 0xcb8c, 0xb1e6, 0xa904, 0xd185, 0xcaaa, 0xcc70, 0xeeba, 0xff7d, 0xed96, 0xdb2d, 0xd187, 0xdae8, 0xf36b, 0xfbac, 0xfbad, 0xf38c, 0xdb6b, 0xd3cc, 0xe4af, 0xffbd, 0xff5c, 0xf6fa, 0xe6b9, 0xef1a, 0xf7bc, 0xf7fe, 0xf7fe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xff9e, 0xfe59, 0xe4f3, 0xd3f0, 0xd38e, 0xb9c5, 0xc227, 0xdb4c, 0xec30, 0xdc0f, 0xdc2f, 0xf4d1, 0xfd32, 0xf4f0, 0xec8f, 0xf40d, 0xfbcd, 0xfb6c, 0xf2a9, 0xd1a4, 0xb8e1, 0xd207, 0xe228, 0xfa89, 0xfae9, 0xf32a, 0xe3cb, 0xe4ef, 0xf613, 0xd613, 0xd653, 0xde73, 0xde73, 0xe6b3, 0xeef4, 0xef14, 0xef34, 0xef14, 0xef35, 0xf756, 0xf777, 0xff79, 0xff7a, 0xff9b, 0xffbb, 0xffbc, 0xffbc, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffbb, 0xffbb, 0xf79b, 0xf79a, 0xff99, 0xf758, 0xf737, 0xff77, 0xff77, 0xf755, 0xf735, 0xf755, 0xf6f5, 0xe693, 0xde52, 0xee32, 0xf5b1, 0xf48f, 0xf38c, 0xf30b, 0xf2e7, 0xeac8, 0xdac9, 0xeb6d, 0xeb8e, 0xd2a9, 0xdac8, 0xf36a, 0xe3ec, 0xec2d, 0xf4af, 0xfd10, 0xfd10, 0xf4f1, 0xe46f, 0xcb8b, 0xd229, 0xc9e8, 0xc1a7, 0xc1e8, 0xca8a, 0xe38e, 0xfcd2, 0xfd95, 0xff9e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff1c, 0xed75, 0xd410, 0xdb8e, 0xe38d, 0xeb8d, 0xfb6b, 0xfaea, 0xeb0b, 0xf3ad, 0xf40f, 0xfc70, 0xfc70, 0xebed, 0xeb6c, 0xeb6c, 0xeaea, 0xe288, 0xe266, 0xe245, 0xda24, 0xda43, 0xe2a8, 0xdaa7, 0xdb08, 0xdc0a, 0xe50d, 0xddef, 0xce50, 0xbe71, 0xde53, 0xeed4, 0xeef5, 0xeef5, 0xf736, 0xf757, 0xef56, 0xef56, 0xf778, 0xf799, 0xffba, 0xffdb, 0xffdc, 0xffdd, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xffbb, 0xf79a, 0xff9a, 0xff79, 0xf737, 0xef16, 0xf736, 0xff77, 0xf736, 0xeef5, 0xeeb4, 0xee73, 0xedf2, 0xed30, 0xeccf, 0xeba9, 0xe369, 0xdac8, 0xda88, 0xd226, 0xc9e4, 0xdaa5, 0xeb47, 0xe2c9, 0xdae9, 0xdb4a, 0xdb6b, 0xdbac, 0xfc70, 0xfcb1, 0xfbef, 0xf38b, 0xeb4b, 0xeb4b, 0xf38c, 0xebcd, 0xe3ed, 0xdc0d, 0xdc2d, 0xdd75, 0xff1b, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5c, 0xedb6, 0xdc51, 0xec0f, 0xfcb0, 0xfd31, 0xfd51, 0xf44d, 0xe3ab, 0xdb6b, 0xe38c, 0xf3ad, 0xfbad, 0xf30a, 0xea67, 0xd308, 0xd2c7, 0xd246, 0xd9e5, 0xe1c4, 0xe163, 0xe122, 0xe163, 0xe208, 0xe32a, 0xdc8d, 0xd58f, 0xce30, 0xd692, 0xe694, 0xf6b5, 0xe6d4, 0xf736, 0xf737, 0xf758, 0xf799, 0xf79a, 0xf79a, 0xffdc, 0xfffd, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffde, 0xffdd, 0xffbc, 0xff9b, 0xf75a, 0xf75a, 0xf778, 0xf778, 0xf757, 0xf737, 0xf6f6, 0xee95, 0xe614, 0xddd2, 0xdd70, 0xe4cf, 0xe36b, 0xea68, 0xe184, 0xd142, 0xd1a2, 0xc1c1, 0xc9a4, 0xda26, 0xe2a8, 0xdac9, 0xdae9, 0xe34b, 0xf3cd, 0xfbee, 0xe3ab, 0xe3ab, 0xebcc, 0xfc4e, 0xfcd0, 0xfd11, 0xf4d0, 0xe4af, 0xc42e, 0xe574, 0xff1b, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xe5f7, 0xd471, 0xe450, 0xfd12, 0xfd51, 0xe4cd, 0xbc2a, 0xdb4b, 0xe36c, 0xe3ad, 0xe3cd, 0xdb6b, 0xd308, 0xcaa6, 0xca85, 0xe9c3, 0xe9a3, 0xd942, 0xd922, 0xd122, 0xc902, 0xc143, 0xda06, 0xe430, 0xecd1, 0xed92, 0xe613, 0xe674, 0xe6d5, 0xeef6, 0xeed7, 0xf756, 0xff77, 0xf758, 0xf779, 0xffbb, 0xffbc, 0xffdd, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffbd, 0xf7ba, 0xf779, 0xff58, 0xff18, 0xfef8, 0xfeb7, 0xfe97, 0xfe97, 0xfdd6, 0xfd94, 0xfcf1, 0xfc2e, 0xea88, 0xd902, 0xe0c2, 0xe861, 0xd142, 0xd9a4, 0xd9a4, 0xd9e5, 0xe267, 0xda88, 0xd2c8, 0xdb4a, 0xe3ac, 0xe38c, 0xdb4b, 0xdb2b, 0xe3ad, 0xf46f, 0xfcf1, 0xfd32, 0xe48e, 0xd48f, 0xe5b6, 0xff7e, 0xffff, 0xf7df, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffbc, 0xdcf3, 0xe410, 0xf4b1, 0xf4b0, 0xf40d, 0xeb6a, 0xdb49, 0xe2ca, 0xe2ea, 0xeb0a, 0xe2e9, 0xdaa7, 0xda45, 0xd204, 0xd1e4, 0xd161, 0xe162, 0xe922, 0xe0c2, 0xc8c2, 0xc1a4, 0xd36a, 0xe4cf, 0xdd51, 0xedb3, 0xee14, 0xf674, 0xf6d6, 0xf736, 0xf757, 0xef16, 0xef7b, 0xf7bc, 0xf7dc, 0xfffd, 0xfffe, 0xfffe, 0xf7bd, 0xfffe, 0xffde, 0xfffe, 0xffff, 0xffff, 0xfffe, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xffdd, 0xffbc, 0xf77b, 0xf739, 0xf718, 0xf717, 0xf717, 0xf677, 0xfe97, 0xfdf5, 0xf4f1, 0xfc70, 0xfb6c, 0xe1a6, 0xd0a3, 0xd8a1, 0xe0e1, 0xe123, 0xe163, 0xd984, 0xd1a4, 0xd205, 0xda67, 0xe2c9, 0xeb0a, 0xf30b, 0xe2ea, 0xdae9, 0xdb6b, 0xec2e, 0xecaf, 0xed2f, 0xf42e, 0xfc72, 0xfeba, 0xffff, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xe636, 0xdc71, 0xf410, 0xfc70, 0xf40d, 0xf34a, 0xe287, 0xd225, 0xe2a9, 0xe2c9, 0xe2a8, 0xda67, 0xda05, 0xd9c4, 0xd183, 0xd162, 0xd121, 0xd101, 0xd0c1, 0xd0e2, 0xe206, 0xf38c, 0xf4af, 0xe510, 0xe5b2, 0xee14, 0xfef7, 0xfef7, 0xf717, 0xeef7, 0xe6f7, 0xfffb, 0xf7dd, 0xfffe, 0xfffe, 0xf7dd, 0xf7bd, 0xfffe, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffde, 0xffde, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xf79d, 0xffde, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffd, 0xffdc, 0xffbb, 0xff59, 0xeef7, 0xff19, 0xee97, 0xf656, 0xfe15, 0xfd73, 0xfcd1, 0xfbce, 0xe289, 0xd122, 0xd101, 0xd902, 0xd922, 0xd943, 0xd963, 0xd1c4, 0xd1e4, 0xda67, 0xe2a8, 0xeac9, 0xe288, 0xd268, 0xd2a8, 0xdb4a, 0xe3ac, 0xe4ee, 0xec0e, 0xdbae, 0xdd95, 0xf7de, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xcd52, 0xd40e, 0xf3ae, 0xeb8c, 0xdae9, 0xea87, 0xe205, 0xd1e4, 0xe288, 0xe267, 0xda05, 0xd9c4, 0xd983, 0xd942, 0xd921, 0xd921, 0xd922, 0xc8e1, 0xc922, 0xe267, 0xfbed, 0xfcf1, 0xfd72, 0xf5b3, 0xf696, 0xfef7, 0xff18, 0xeed8, 0xf739, 0xfffd, 0xfffd, 0xfffd, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffde, 0xffde, 0xffff, 0xffff, 0xfffe, 0xffff, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffde, 0xfffe, 0xfffd, 0xfffc, 0xf77a, 0xef59, 0xef39, 0xf718, 0xf6d7, 0xfe96, 0xfdf4, 0xfd31, 0xf4b0, 0xeae8, 0xd1c4, 0xc8c1, 0xd8c1, 0xe102, 0xd922, 0xd142, 0xd1a3, 0xd1e4, 0xda05, 0xe246, 0xea47, 0xda06, 0xd206, 0xda67, 0xe2e9, 0xcbaa, 0xebed, 0xdbae, 0xd574, 0xffff, 0xffff, 0xff9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffbe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9f, 0xf79f, 0xcd30, 0xd3ed, 0xeb6b, 0xe34a, 0xdac8, 0xe266, 0xd9e4, 0xc9c2, 0xe246, 0xd9e4, 0xd983, 0xe162, 0xe142, 0xe101, 0xd8e0, 0xd900, 0xd0e2, 0xd184, 0xe2c9, 0xfc4e, 0xfd31, 0xf593, 0xf5f4, 0xfe76, 0xeef7, 0xf718, 0xeed8, 0xffbc, 0xfffe, 0xf7bd, 0xdefa, 0x8451, 0x5aca, 0x4a48, 0x39e7, 0x528a, 0x8431, 0xd69a, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffde, 0xffff, 0xffde, 0xffde, 0xffff, 0xf7bd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffde, 0xffff, 0xffde, 0xbdd6, 0x840f, 0x426a, 0x3a08, 0x39e7, 0x632c, 0xa554, 0xdefa, 0xffdd, 0xfffe, 0xf79b, 0xf79b, 0xef39, 0xef18, 0xf6f8, 0xf676, 0xedd3, 0xf5b3, 0xfcee, 0xe36a, 0xd1a4, 0xd0e1, 0xe0c1, 0xe0e1, 0xd921, 0xd941, 0xc962, 0xd9a3, 0xe1e4, 0xea05, 0xe9e5, 0xe1c4, 0xe226, 0xf2a8, 0xdb09, 0xfb6c, 0xdb6c, 0xcd12, 0xf7bd, 0xffff, 0xf7df, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffde, 0xffff, 0xffff, 0xf7ff, 0xf7df, 0xffff, 0xffff, 0xfffe, 0xed30, 0xe36b, 0xeaa9, 0xda67, 0xda25, 0xe1c4, 0xd942, 0xd983, 0xd9e4, 0xd983, 0xd942, 0xe122, 0xe0e1, 0xd8c0, 0xd0c0, 0xd900, 0xc944, 0xeae9, 0xfc8f, 0xfd52, 0xedb3, 0xf635, 0xfeb8, 0xfed8, 0xe6d8, 0xffbb, 0xf79b, 0xffdd, 0xe71b, 0x738e, 0x08a3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x5acc, 0xce5a, 0xffff, 0xffff, 0xf79d, 0xfffe, 0xffff, 0xffde, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xf7be, 0xb5b6, 0x4a69, 0x0000, 0x0000, 0x0000, 0x0021, 0x0020, 0x0000, 0x0000, 0x1924, 0x8450, 0xf7de, 0xfffe, 0xff9c, 0xf75b, 0xef19, 0xf6f8, 0xfef8, 0xfeb7, 0xedf4, 0xfdd2, 0xfd31, 0xf3ac, 0xd9e5, 0xd0c1, 0xd8c1, 0xd901, 0xd900, 0xd141, 0xd142, 0xe183, 0xe9a4, 0xe183, 0xd963, 0xd9a4, 0xe205, 0xea88, 0xfa89, 0xeaca, 0xe4d1, 0xff9b, 0xffff, 0xf7ff, 0xdfff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xff3a, 0xee15, 0xeb8c, 0xe208, 0xe9a6, 0xd985, 0xd184, 0xd902, 0xe0c1, 0xe923, 0xd9a3, 0xd942, 0xd901, 0xe0e1, 0xd8c0, 0xd0a0, 0xd121, 0xd9a3, 0xeb6b, 0xfc4f, 0xfd52, 0xf5d4, 0xee35, 0xeeb7, 0xfef9, 0xfefa, 0xff9c, 0xef5b, 0xfffe, 0xc637, 0x4207, 0x0000, 0x0000, 0x0041, 0x0840, 0x1081, 0x0020, 0x0000, 0x0000, 0x0000, 0x0000, 0x18c3, 0x9cf3, 0xffff, 0xffff, 0xf79d, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xf79e, 0xffff, 0xffff, 0x8430, 0x0861, 0x0000, 0x0000, 0x0020, 0x0882, 0x1082, 0x0862, 0x0841, 0x0000, 0x0000, 0x0861, 0x4228, 0xe69a, 0xffbe, 0xfffe, 0xff9c, 0xf73a, 0xff19, 0xfed8, 0xfeb8, 0xf655, 0xfdf4, 0xfd52, 0xfc0d, 0xda46, 0xc0e0, 0xc8a0, 0xe121, 0xd121, 0xd121, 0xd922, 0xd922, 0xd922, 0xd122, 0xd142, 0xd183, 0xd1a5, 0xd965, 0xd9e7, 0xdb6b, 0xf593, 0xfefa, 0xffbd, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xf7ff, 0xffff, 0xffdf, 0xff5d, 0xf5b5, 0xcbac, 0xb245, 0xca47, 0xe1e7, 0xf248, 0xe288, 0xda88, 0xe206, 0xd923, 0xd122, 0xd962, 0xd922, 0xd8e1, 0xd8c1, 0xd0c1, 0xc902, 0xda25, 0xf329, 0xfd12, 0xfd32, 0xf5b3, 0xf676, 0xf6d8, 0xeed8, 0xf6fa, 0xff5b, 0xffbd, 0xfffe, 0xce37, 0x2924, 0x0000, 0x0000, 0x18e3, 0x73ae, 0xc617, 0xdeda, 0xe73b, 0xc638, 0x7bef, 0x3186, 0x0020, 0x0000, 0x2103, 0xa534, 0xffff, 0xffff, 0xf7bd, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0x8410, 0x0020, 0x0000, 0x0861, 0x4a49, 0x8c50, 0xce59, 0xe71c, 0xe6fb, 0xad75, 0x630c, 0x1082, 0x0000, 0x0040, 0x62eb, 0xd699, 0xfffe, 0xfffe, 0xffbc, 0xf73a, 0xf6d8, 0xff3a, 0xfed8, 0xee36, 0xf5f5, 0xfdb3, 0xf44e, 0xd246, 0xc901, 0xd901, 0xd101, 0xd101, 0xd902, 0xd102, 0xd143, 0xd9a4, 0xda05, 0xd225, 0xd2c9, 0xe248, 0xda06, 0xc205, 0xc267, 0xd36c, 0xed33, 0xff7b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xff5e, 0xe535, 0xc2eb, 0xd247, 0xfac8, 0xe3ac, 0xfb8d, 0xfbcd, 0xdbab, 0xd3aa, 0xe36a, 0xdaa7, 0xd246, 0xd142, 0xd102, 0xd8e1, 0xd8e2, 0xd0e2, 0xd1a4, 0xeb29, 0xfcaf, 0xf531, 0xf5b3, 0xfe56, 0xf6b7, 0xf6f9, 0xff3a, 0xff7c, 0xffbd, 0xffff, 0xef3c, 0x5aaa, 0x0000, 0x0000, 0x630b, 0xdefa, 0xfffe, 0xfffd, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xf7be, 0x94b1, 0x10a2, 0x0000, 0x2944, 0xd679, 0xffff, 0xffbe, 0xffff, 0xfffe, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xb5b6, 0x10a2, 0x0000, 0x39e7, 0xa514, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffde, 0xffff, 0xffff, 0xc638, 0x4a49, 0x0000, 0x0000, 0x7c2f, 0xefbd, 0xfffe, 0xfffd, 0xfffd, 0xff5b, 0xf6d9, 0xfefa, 0xf6d9, 0xee76, 0xedf4, 0xfd72, 0xfc4e, 0xea46, 0xc860, 0xd0e1, 0xd102, 0xd102, 0xd123, 0xd9c5, 0xea88, 0xf329, 0xeb4a, 0xcbab, 0xf3ac, 0xfbcd, 0xfb6b, 0xf30a, 0xe269, 0xd2ca, 0xdc70, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xf7ff, 0xfffd, 0xecb1, 0xdb0a, 0xe36b, 0xdbab, 0xe3ac, 0xe38b, 0xe36b, 0xe34a, 0xe329, 0xe2e9, 0xe2a8, 0xe287, 0xe287, 0xe1e5, 0xd963, 0xd0c1, 0xd0c0, 0xd9c4, 0xeb8b, 0xecf0, 0xe592, 0xf635, 0xf656, 0xf697, 0xfed8, 0xff3b, 0xff9c, 0xffdd, 0xfffe, 0xfffe, 0xa533, 0x0040, 0x0000, 0x8c70, 0xf77c, 0xfffd, 0xffdd, 0xfffe, 0xfffe, 0xffbd, 0xfffe, 0xfffe, 0xffff, 0xefbe, 0xc69a, 0x2103, 0x0000, 0x736d, 0xffff, 0xffde, 0xfffe, 0xef7c, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0x4228, 0x0000, 0x39e7, 0xe73b, 0xffde, 0xfffe, 0xffdd, 0xfffe, 0xffdd, 0xfffe, 0xfffe, 0xffde, 0xffff, 0xdf1c, 0x4acb, 0x0000, 0x0840, 0xc637, 0xffff, 0xffdd, 0xfffe, 0xfffe, 0xffdd, 0xf6f9, 0xf6d9, 0xfeb8, 0xfe57, 0xfdd5, 0xfd73, 0xec4f, 0xcac9, 0xd0a1, 0xd0c0, 0xd962, 0xe204, 0xe245, 0xdaa6, 0xe2e8, 0xdb09, 0xeb09, 0xeb4a, 0xe36b, 0xe38b, 0xe3ab, 0xeb8c, 0xe34b, 0xe2ea, 0xe4b1, 0xffde, 0xf7ff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xf6fa, 0xd3ad, 0xdaa9, 0xe32a, 0xe38b, 0xe36b, 0xe309, 0xe329, 0xe2e9, 0xe2c8, 0xe288, 0xe267, 0xda06, 0xd9c5, 0xe1a4, 0xd963, 0xd0e1, 0xd963, 0xf329, 0xf44e, 0xe4f0, 0xedf4, 0xf675, 0xf696, 0xfef8, 0xff3a, 0xff9c, 0xffbd, 0xfffe, 0xfffe, 0xfffe, 0x39e6, 0x0000, 0x6b8d, 0xef7d, 0xffff, 0xffff, 0xf7bd, 0xfffe, 0xffdd, 0xffbd, 0xffdd, 0xffdd, 0xffff, 0xffff, 0xf7ff, 0xc617, 0x18c2, 0x10a2, 0xef5c, 0xffff, 0xf7bd, 0xfffe, 0xffdd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xc617, 0x0000, 0x39e7, 0xc659, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffdd, 0xffbd, 0xffdd, 0xef7c, 0xffff, 0xffff, 0xef9e, 0x31c6, 0x0000, 0x73ad, 0xffde, 0xffbd, 0xffbd, 0xfffe, 0xfffe, 0xff5b, 0xff1a, 0xfef9, 0xfeb8, 0xfe56, 0xfdd5, 0xfd12, 0xe3ee, 0xe1c5, 0xd122, 0xd122, 0xe1a3, 0xe1e4, 0xda25, 0xda87, 0xd287, 0xe2a8, 0xe2e9, 0xe32a, 0xe34a, 0xe36b, 0xeb6b, 0xeb4b, 0xe30a, 0xd36c, 0xee79, 0xf7ff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xd595, 0xc2ca, 0xe2a9, 0xeb2a, 0xe34a, 0xe2e9, 0xe2a8, 0xe2a8, 0xe287, 0xda26, 0xda06, 0xe205, 0xd9c4, 0xd163, 0xe143, 0xd943, 0xd183, 0xeae8, 0xfcaf, 0xfd11, 0xed72, 0xfe56, 0xf6b7, 0xfef8, 0xff5a, 0xffbb, 0xffdc, 0xfffd, 0xfffe, 0xfffe, 0xdefa, 0x0000, 0x1903, 0xdefa, 0xffff, 0xf7be, 0xf7ff, 0xf7ff, 0xffbc, 0xffdd, 0xfffe, 0xfffe, 0xffdd, 0xffbd, 0xfffd, 0xffbd, 0xffff, 0x7bef, 0x0000, 0x9cf2, 0xfffe, 0xf79c, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0x73ef, 0x0000, 0xa554, 0xffff, 0xf7be, 0xef9d, 0xf7df, 0xf7df, 0xfffd, 0xffdd, 0xffdd, 0xfffe, 0xfffe, 0xf7bc, 0xffdd, 0xffbd, 0xc658, 0x0040, 0x18e2, 0xef5c, 0xfffe, 0xffdd, 0xfffe, 0xffdd, 0xffbc, 0xff7b, 0xff5a, 0xff19, 0xfeb8, 0xfe56, 0xfdd5, 0xf532, 0xfb8b, 0xda26, 0xc942, 0xd942, 0xe163, 0xe1a4, 0xd9e5, 0xda06, 0xda46, 0xda87, 0xdac8, 0xdae8, 0xdb09, 0xe32a, 0xeb2a, 0xeb2a, 0xd268, 0xd513, 0xfffe, 0xfffe, 0xfffe, 
0xffdf, 0xffdf, 0xccd2, 0xcaa9, 0xf30a, 0xeb09, 0xe2e9, 0xe247, 0xe227, 0xe246, 0xe206, 0xd9a4, 0xd9a4, 0xe1c4, 0xe1a4, 0xd963, 0xd0e2, 0xd964, 0xeac9, 0xfc4e, 0xfd31, 0xf5b3, 0xf615, 0xfe97, 0xf719, 0xff5a, 0xffbb, 0xfffd, 0xfffd, 0xfffd, 0xfffe, 0xfffe, 0xa595, 0x10a2, 0x73cd, 0xfffe, 0xfffd, 0xffbc, 0xfffe, 0xffdd, 0xfffd, 0xffdd, 0xffdd, 0xffdd, 0xffdc, 0xffbc, 0xffdc, 0xfffc, 0xffde, 0xef3c, 0x2123, 0x738d, 0xfffe, 0xfffe, 0xfffe, 0xffdd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0x31e7, 0x3a07, 0xf79d, 0xfffe, 0xf77c, 0xfffe, 0xfffe, 0xfffe, 0xffbb, 0xfffd, 0xffdd, 0xffdd, 0xffdc, 0xff9b, 0xffbc, 0xfffc, 0xffff, 0x4227, 0x1080, 0xded9, 0xfffe, 0xf79c, 0xffbd, 0xffdc, 0xffdd, 0xfffd, 0xffbc, 0xf73a, 0xf6d8, 0xfeb7, 0xfe36, 0xf5b4, 0xfd11, 0xe38b, 0xd205, 0xd142, 0xd902, 0xe143, 0xe1a4, 0xd9a4, 0xd9e5, 0xda06, 0xda46, 0xda67, 0xda87, 0xe2a8, 0xe309, 0xeb2a, 0xea48, 0xcc30, 0xffde, 0xfffe, 0xfffe, 
0xffdf, 0xffdf, 0xcc70, 0xd2ca, 0xfb0a, 0xe2a7, 0xda47, 0xe1e6, 0xe1c5, 0xe1c5, 0xd9a4, 0xd963, 0xd943, 0xd963, 0xd942, 0xd122, 0xc903, 0xe268, 0xfc0e, 0xf511, 0xed93, 0xee35, 0xfeb7, 0xfeb8, 0xff7a, 0xff9b, 0xffdc, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffe, 0xdf5c, 0xa554, 0xe71a, 0xfffc, 0xff7a, 0xfffc, 0xfffd, 0xffdc, 0xfffe, 0xf7dd, 0xf7dd, 0xffff, 0xfffe, 0xfffd, 0xff9b, 0xff9a, 0xfffe, 0xffff, 0xa533, 0xbdf6, 0xfffe, 0xfffe, 0xfffe, 0xffdd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xadb6, 0xce79, 0xfffe, 0xffdc, 0xffdc, 0xffdc, 0xffbc, 0xfffd, 0xfffe, 0xfffd, 0xf7fe, 0xf7fe, 0xfffe, 0xfffd, 0xffdc, 0xff79, 0xfffe, 0xce98, 0x9d12, 0xffdd, 0xfffd, 0xffbd, 0xfffd, 0xfffd, 0xffdd, 0xfffe, 0xffdd, 0xf77b, 0xf739, 0xf6f8, 0xf677, 0xf635, 0xfdb4, 0xec90, 0xe30a, 0xd1a4, 0xd0c1, 0xe102, 0xe963, 0xd943, 0xd9a4, 0xd9a4, 0xd9e5, 0xda05, 0xda05, 0xda46, 0xe2a8, 0xeb09, 0xfa88, 0xcbef, 0xffde, 0xfffe, 0xfffe, 
0xffff, 0xffde, 0xd491, 0xdaca, 0xeaa8, 0xd225, 0xd1e5, 0xe9a5, 0xd963, 0xd963, 0xd963, 0xd943, 0xd922, 0xd101, 0xd0e1, 0xc8e0, 0xd206, 0xfbed, 0xfcf1, 0xed32, 0xee15, 0xf6b8, 0xf6d8, 0xff19, 0xff9c, 0xffbc, 0xffdc, 0xffdd, 0xffdc, 0xffdc, 0xfffd, 0xfffe, 0xffff, 0xf7dd, 0xfffd, 0xffbb, 0xffdc, 0xfffe, 0xf7fe, 0xe7df, 0xcf7e, 0xbf1d, 0xbefe, 0xc77f, 0xdfff, 0xefff, 0xf7fe, 0xfffd, 0xf7bd, 0xfffe, 0xfffe, 0xfffe, 0xf7dd, 0xf7bc, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xffff, 0xfffe, 0xf77b, 0xf77b, 0xfffd, 0xfffe, 0xffff, 0xe7df, 0xd79f, 0xb6bc, 0xb6dd, 0xc79f, 0xdfff, 0xf7ff, 0xffff, 0xfffd, 0xf7dd, 0xfffe, 0xf7bc, 0xfffe, 0xffdd, 0xffdd, 0xfffd, 0xfffd, 0xffde, 0xfffe, 0xffdd, 0xffdc, 0xffbb, 0xff39, 0xf6d8, 0xfed7, 0xedf5, 0xf552, 0xec2e, 0xda87, 0xd122, 0xd0e1, 0xd922, 0xd8e1, 0xd963, 0xd963, 0xd983, 0xe184, 0xd9a4, 0xd9e5, 0xda46, 0xe2c8, 0xf2a8, 0xcc2f, 0xffdf, 0xffff, 0xffff, 
0xffff, 0xffde, 0xdcd2, 0xdaca, 0xe267, 0xd245, 0xd1e4, 0xe164, 0xd943, 0xd122, 0xd122, 0xd942, 0xd121, 0xc8e0, 0xd101, 0xd962, 0xe36a, 0xfcd0, 0xfd53, 0xedb5, 0xf698, 0xf6f9, 0xf719, 0xff7a, 0xffbc, 0xffbc, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffe, 0xefff, 0xb6fd, 0x6d79, 0x4497, 0x2bb4, 0x1353, 0x0b33, 0x1394, 0x3c57, 0x6559, 0xa69c, 0xe7ff, 0xf7bd, 0xfffe, 0xfffe, 0xffdd, 0xffdd, 0xfffe, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xffdd, 0xfffe, 0xfffe, 0xfffe, 0xe7be, 0xae7c, 0x75bb, 0x3c56, 0x23b4, 0x0b12, 0x1354, 0x1bb5, 0x3436, 0x5d18, 0x9e5b, 0xe7ff, 0xfffd, 0xfffe, 0xf7dd, 0xf7bc, 0xfffd, 0xffdc, 0xffbc, 0xffdc, 0xffbe, 0xffde, 0xffdd, 0xfffd, 0xfffd, 0xff7a, 0xf719, 0xff19, 0xf678, 0xf5d4, 0xf511, 0xf3cc, 0xda25, 0xc921, 0xd0e1, 0xd8e1, 0xd922, 0xd922, 0xd922, 0xe143, 0xd964, 0xd9a4, 0xda25, 0xe2a7, 0xe2c8, 0xccb1, 0xffdf, 0xffff, 0xffff, 
0xf7ff, 0xfffe, 0xed53, 0xe30a, 0xe267, 0xda86, 0xd1e4, 0xe143, 0xd963, 0xd101, 0xd101, 0xd121, 0xd121, 0xd101, 0xd982, 0xf245, 0xf4ae, 0xf4f0, 0xf5b4, 0xfe58, 0xfeb9, 0xf6f9, 0xff5a, 0xffdc, 0xffdd, 0xffbd, 0xffdd, 0xffdd, 0xffdd, 0xfffd, 0xffdd, 0xffdd, 0xffdc, 0xfffd, 0xfffd, 0xe79e, 0x8598, 0x2393, 0x0375, 0x0377, 0x0356, 0x0377, 0x03d9, 0x03b9, 0x0377, 0x0334, 0x1b94, 0x5cf8, 0xef7c, 0xffdd, 0xffdd, 0xfffd, 0xfffd, 0xf7dc, 0xfffd, 0xffdc, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xffdc, 0xfffe, 0xe7be, 0x8db8, 0x2373, 0x0335, 0x0398, 0x03b7, 0x0398, 0x03d9, 0x0398, 0x0397, 0x0354, 0x1b73, 0x5d18, 0xf7bc, 0xef7b, 0xfffe, 0xffdd, 0xfffd, 0xffdc, 0xfffd, 0xfffc, 0xff9e, 0xffff, 0xfffe, 0xffdd, 0xffdd, 0xff9b, 0xf719, 0xf6f8, 0xfeda, 0xf616, 0xfd93, 0xfcd0, 0xeb29, 0xc962, 0xd0e0, 0xe101, 0xd921, 0xd8e1, 0xd8e1, 0xe123, 0xe163, 0xd9a4, 0xda05, 0xda87, 0xdb09, 0xd513, 0xffdf, 0xffff, 0xffff, 
0xffde, 0xffff, 0xf73d, 0xcc71, 0xcaa9, 0xda86, 0xe1e4, 0xe922, 0xd922, 0xd921, 0xd901, 0xe0e1, 0xe0c1, 0xc8c1, 0xd226, 0xf44e, 0xf512, 0xfdd5, 0xfe57, 0xf697, 0xeef8, 0xf79b, 0xfffc, 0xffdc, 0xffbd, 0xffbc, 0xfffd, 0xfffd, 0xefdc, 0xf7fd, 0xfffd, 0xffdc, 0xff98, 0xfffe, 0xb77f, 0x3499, 0x0315, 0x0398, 0x03d9, 0x0378, 0x0376, 0x0376, 0x0377, 0x0377, 0x03b8, 0x03d9, 0x03b8, 0x0377, 0x33f9, 0xa6ff, 0xf7ff, 0xffbb, 0xff5b, 0xffde, 0xfffe, 0xfffd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffbd, 0xffff, 0xf7de, 0xf7bd, 0xfffd, 0xffbc, 0xff98, 0xfffe, 0xb77f, 0x3479, 0x0315, 0x03b8, 0x03d9, 0x0379, 0x0377, 0x0377, 0x0377, 0x0377, 0x0398, 0x03d8, 0x03d7, 0x0396, 0x341a, 0xa71f, 0xf7ff, 0xffbb, 0xff7b, 0xffdd, 0xffdd, 0xfffc, 0xffdc, 0xffdc, 0xfffd, 0xfffd, 0xfffd, 0xffbc, 0xf79b, 0xf77b, 0xeef8, 0xfed8, 0xfe16, 0xf553, 0xec6f, 0xdac8, 0xd122, 0xe8a1, 0xc120, 0xd121, 0xd922, 0xe122, 0xe143, 0xd9a5, 0xda26, 0xdaa8, 0xebcf, 0xee9a, 0xf7ff, 0xfffe, 0xfffe, 
0xffff, 0xefff, 0xf7bf, 0xf5d7, 0xe3cd, 0xdac7, 0xd1e4, 0xe184, 0xd942, 0xd101, 0xd901, 0xe0e1, 0xd8c1, 0xd964, 0xe30a, 0xf48f, 0xf553, 0xfdf5, 0xfe77, 0xf6d8, 0xf739, 0xffbb, 0xfffc, 0xffdc, 0xff9c, 0xffdd, 0xffdd, 0xffdd, 0xfffd, 0xfffd, 0xfffc, 0xffbc, 0xfffd, 0xc71c, 0x4c97, 0x0335, 0x0bd8, 0x0b76, 0x02f4, 0x13d7, 0x4c55, 0x5cf8, 0x655a, 0x4498, 0x1bb6, 0x0355, 0x0377, 0x03d8, 0x0336, 0x33f6, 0xae9c, 0xfffe, 0xffbc, 0xff9b, 0xffdd, 0xf7fd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffbc, 0xffdd, 0xffdd, 0xffdd, 0xfffe, 0xfffd, 0xffdc, 0xffbc, 0xfffd, 0xc71c, 0x4c97, 0x0334, 0x0bd8, 0x0b97, 0x02f4, 0x1bf8, 0x43f5, 0x5cd8, 0x655a, 0x4498, 0x1395, 0x0334, 0x0355, 0x0397, 0x0336, 0x3416, 0xaebc, 0xfffe, 0xffdc, 0xff9b, 0xffdc, 0xfffc, 0xffdc, 0xffdc, 0xfffd, 0xfffd, 0xffdc, 0xffdc, 0xffbc, 0xf79b, 0xef18, 0xf6d8, 0xfe56, 0xfdd5, 0xf511, 0xeb8b, 0xd9e5, 0xd8a0, 0xd120, 0xd921, 0xd921, 0xd922, 0xd943, 0xd9e5, 0xe288, 0xe2e9, 0xe553, 0xff9e, 0xf7ff, 0xffbd, 0xffbd, 
0xf7ff, 0xe7ff, 0xffff, 0xfeba, 0xf46f, 0xd2e7, 0xd245, 0xe1e6, 0xd962, 0xd101, 0xd901, 0xd8c1, 0xd0e1, 0xea67, 0xfc4e, 0xf4f1, 0xfdb4, 0xfe56, 0xfed8, 0xff19, 0xff7a, 0xfffc, 0xfffd, 0xffdc, 0xffbb, 0xfffd, 0xffdd, 0xffbc, 0xfffc, 0xffdc, 0xffdb, 0xfffd, 0xdfbf, 0x5496, 0x0314, 0x0357, 0x0376, 0x1b74, 0x54b7, 0x9e7d, 0xffff, 0xf7ff, 0xf7ff, 0xefff, 0xb71f, 0x5cf9, 0x1b96, 0x0335, 0x03b8, 0x02f4, 0x4416, 0xcf1d, 0xfffd, 0xffda, 0xfffc, 0xf7fe, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xfffe, 0xff9c, 0xfffc, 0xfffc, 0xff9b, 0xfffd, 0xdfbf, 0x5496, 0x0313, 0x0357, 0x0376, 0x1b74, 0x5cb7, 0x9e7e, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xbf1f, 0x5d19, 0x1bb5, 0x0355, 0x03b8, 0x0314, 0x4436, 0xcf3d, 0xfffd, 0xffda, 0xfffc, 0xf7dd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffbc, 0xf779, 0xf6f8, 0xfe97, 0xfe56, 0xfdb3, 0xfcaf, 0xeae9, 0xd122, 0xd8e0, 0xd901, 0xd922, 0xd942, 0xd9a4, 0xe226, 0xeaa8, 0xeac8, 0xe6f8, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xefff, 0xffff, 0xfdf7, 0xe34b, 0xd286, 0xda66, 0xe1e6, 0xd962, 0xd121, 0xd0e1, 0xd0c0, 0xd984, 0xf34b, 0xfd11, 0xf593, 0xfe35, 0xfe97, 0xff19, 0xff5a, 0xffbb, 0xfffc, 0xfffd, 0xffdc, 0xfffc, 0xfffc, 0xffdd, 0xffbc, 0xff9a, 0xff9a, 0xffdc, 0xf7fe, 0x6d9a, 0x0b74, 0x0377, 0x03b9, 0x1375, 0x7539, 0xdfbf, 0xffff, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xe7ff, 0x85dc, 0x2374, 0x03f8, 0x03fa, 0x02d4, 0x64f8, 0xe7fd, 0xfffb, 0xfffc, 0xf7de, 0xfffc, 0xfffc, 0xfffc, 0xfffc, 0xfffc, 0xfffc, 0xfffc, 0xfffc, 0xfffd, 0xfffd, 0xfffd, 0xff9b, 0xff9a, 0xfffb, 0xffdc, 0xffff, 0x6d7a, 0x1375, 0x0357, 0x03d9, 0x1375, 0x6d38, 0xe7df, 0xffff, 0xffde, 0xfffe, 0xfffe, 0xffde, 0xffff, 0xdfdf, 0x85bb, 0x2374, 0x03f8, 0x041a, 0x02f5, 0x64f8, 0xeffd, 0xfffa, 0xfffb, 0xffde, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xfffb, 0xf759, 0xfed8, 0xfe97, 0xf615, 0xfd72, 0xf40d, 0xda46, 0xd8a0, 0xd8c1, 0xd922, 0xd9a4, 0xd9e5, 0xe246, 0xe267, 0xda25, 0xddf4, 0xf7de, 0xf7ff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xff3d, 0xec51, 0xd1c6, 0xd1a3, 0xe205, 0xe165, 0xd162, 0xd942, 0xd0e0, 0xd122, 0xe287, 0xf42e, 0xf552, 0xfe15, 0xf676, 0xfed7, 0xff59, 0xff9a, 0xffdb, 0xfffc, 0xffdc, 0xffbc, 0xfffb, 0xf7dc, 0xfffd, 0xffdc, 0xff79, 0xffdb, 0xf7fd, 0xc73c, 0x0b75, 0x0bd8, 0x0377, 0x0336, 0x6d7b, 0xe7ff, 0xffff, 0xfffd, 0xf7ff, 0xffff, 0xffde, 0xff7c, 0xffff, 0xffff, 0xe7df, 0xa63c, 0x0394, 0x03b8, 0x0358, 0x1bb6, 0x9639, 0xf7fc, 0xfffc, 0xffde, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xfffc, 0xfffd, 0xfffd, 0xffdb, 0xff79, 0xffdb, 0xffff, 0xc6fd, 0x0b55, 0x0bf9, 0x0357, 0x0356, 0x6d9c, 0xdfdf, 0xffff, 0xfffd, 0xf7df, 0xffff, 0xfffe, 0xff9d, 0xffff, 0xffff, 0xdfbf, 0x9dfb, 0x0374, 0x03b8, 0x0358, 0x1bb6, 0x9659, 0xf7fc, 0xfffb, 0xffdd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xfffc, 0xfffc, 0xfffb, 0xff9a, 0xff19, 0xf6d8, 0xf677, 0xf5d4, 0xf4af, 0xeb8b, 0xd8e1, 0xd0c1, 0xd122, 0xd9a4, 0xd9c4, 0xd9e5, 0xd9e4, 0xc963, 0xd38d, 0xf71b, 0xf7ff, 0xffdf, 0xffdf, 
0xffdf, 0xffdf, 0xedf8, 0xe32d, 0xd143, 0xd100, 0xd943, 0xe124, 0xd142, 0xd922, 0xd0e1, 0xd9c4, 0xf3ab, 0xf4d0, 0xedb4, 0xfe77, 0xf6d7, 0xf718, 0xff7a, 0xffbb, 0xfffc, 0xffdc, 0xffbc, 0xff9c, 0xffda, 0xf7bb, 0xfffd, 0xffdb, 0xff99, 0xfffc, 0xd77e, 0x6538, 0x0357, 0x0398, 0x0335, 0x4498, 0xd7bf, 0xffff, 0xffbd, 0xffde, 0xefff, 0xefdf, 0xf7bf, 0xffdf, 0xffde, 0xffbe, 0xf7bf, 0xffff, 0x6559, 0x02f4, 0x03fa, 0x0377, 0x3c34, 0xd7be, 0xfffe, 0xffbd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdb, 0xfffd, 0xfffd, 0xfffc, 0xffba, 0xfffd, 0xdfbf, 0x6518, 0x0336, 0x0398, 0x0315, 0x4498, 0xd7df, 0xffff, 0xffbd, 0xffde, 0xefff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0x5d39, 0x02f3, 0x03fa, 0x0377, 0x3c34, 0xd7bd, 0xfffd, 0xffbc, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdc, 0xffdc, 0xfffc, 0xf7bb, 0xffbb, 0xff5b, 0xff1a, 0xf6f8, 0xf635, 0xf511, 0xf44f, 0xea05, 0xd122, 0xd102, 0xd943, 0xd942, 0xd163, 0xd983, 0xd142, 0xd9e8, 0xdd75, 0xf7ff, 0xffdf, 0xffdf, 
0xffff, 0xffbe, 0xdd55, 0xdaca, 0xe183, 0xd900, 0xd101, 0xd903, 0xd121, 0xd0e0, 0xd942, 0xeaa7, 0xf46e, 0xf572, 0xf616, 0xfe98, 0xf718, 0xf759, 0xffba, 0xfffb, 0xfffc, 0xffdc, 0xffbc, 0xffbc, 0xffba, 0xf7db, 0xfffd, 0xffda, 0xffda, 0xfffd, 0x9e9d, 0x1bb6, 0x03d9, 0x0315, 0x2bf7, 0xb6ff, 0xffff, 0xffbd, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xdf9f, 0x3c16, 0x03b8, 0x0399, 0x0b35, 0x9e1b, 0xffff, 0xffdb, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffda, 0xf7fc, 0xf7fc, 0xffdb, 0xffdb, 0xfffe, 0xa69d, 0x1b96, 0x03d9, 0x02f5, 0x2c17, 0xb6ff, 0xffff, 0xffdd, 0xffde, 0xffff, 0xefde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xd79f, 0x3c16, 0x03b8, 0x0398, 0x0b34, 0x9e1b, 0xfffe, 0xffba, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xf7bb, 0xffdc, 0xff7c, 0xff3a, 0xf719, 0xf697, 0xf594, 0xf4d1, 0xfb29, 0xd1a4, 0xc8e1, 0xd902, 0xd0c1, 0xd0e1, 0xd942, 0xd983, 0xea47, 0xdc92, 0xffff, 0xffff, 0xffff, 
0xffff, 0xfffe, 0xd553, 0xd2a8, 0xe9e3, 0xe181, 0xd140, 0xd102, 0xd101, 0xc8a0, 0xe183, 0xfb6a, 0xf4cf, 0xf5d3, 0xfe77, 0xfe99, 0xf738, 0xff99, 0xffdb, 0xfffc, 0xfffc, 0xffdb, 0xffbc, 0xffbc, 0xffda, 0xfffc, 0xf7fc, 0xffb9, 0xffda, 0xefbd, 0x7dbb, 0x0316, 0x03b9, 0x0356, 0x5d19, 0xe7df, 0xfffd, 0xffbc, 0xffff, 0xe7df, 0xf77b, 0xef1a, 0xdefa, 0xe75c, 0xf7de, 0xffff, 0xffff, 0xfffe, 0xffdf, 0x8dfb, 0x0376, 0x03ba, 0x0378, 0x5c37, 0xf7df, 0xffda, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xfffb, 0xf7db, 0xf7fc, 0xffba, 0xfffb, 0xf7de, 0x757a, 0x0336, 0x0398, 0x0335, 0x653a, 0xe7df, 0xfffd, 0xffdc, 0xffff, 0xe7bf, 0xf759, 0xe719, 0xe73a, 0xef9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0x85db, 0x0375, 0x03b9, 0x0358, 0x5c56, 0xf7de, 0xffd9, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffbb, 0xffdb, 0xffdc, 0xff9c, 0xf71a, 0xf6f9, 0xfed9, 0xfe15, 0xfcf2, 0xfbec, 0xd205, 0xc8e1, 0xd8e2, 0xd8a1, 0xd8a0, 0xe142, 0xe1a3, 0xe287, 0xdc50, 0xffff, 0xeffe, 0xeffe, 
0xffdf, 0xffbf, 0xdd74, 0xc2e9, 0xf267, 0xe902, 0xe121, 0xd141, 0xe0c1, 0xc8c0, 0xdaa8, 0xf4af, 0xed52, 0xee35, 0xfeb8, 0xfed8, 0xff9a, 0xffba, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xff78, 0xfffc, 0xf7dc, 0xffb9, 0xfffb, 0xcf9f, 0x1bb5, 0x03b9, 0x03b8, 0x1b53, 0xdf1f, 0xf79e, 0xffff, 0xffff, 0xf7df, 0xf7bf, 0xdefb, 0x6b6d, 0x52aa, 0x94b2, 0xef7d, 0xf7be, 0xf7be, 0xffff, 0xffdf, 0xefdf, 0x3bf4, 0x0356, 0x03ba, 0x0b56, 0xbf1e, 0xfffb, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xff99, 0xfffd, 0xf7fd, 0xffba, 0xfffc, 0xcf7f, 0x13b6, 0x03b9, 0x03b8, 0x1b33, 0xd71f, 0xffff, 0xffff, 0xefde, 0xffff, 0xff9f, 0xb5b6, 0x4a69, 0x630c, 0xc618, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xd77f, 0x33f5, 0x0337, 0x037a, 0x1377, 0xc71c, 0xfff9, 0xffbb, 0xffbb, 0xffbb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdc, 0xffdc, 0xffdc, 0xffbb, 0xff5a, 0xfef8, 0xf657, 0xedf5, 0xec2f, 0xf34a, 0xd121, 0xd0a0, 0xe123, 0xd102, 0xd983, 0xf204, 0xf2c9, 0xccb0, 0xfffe, 0xffdf, 0xffdf, 
0xffdf, 0xffdf, 0xee37, 0xd3ac, 0xeac8, 0xe183, 0xe163, 0xd121, 0xd8c1, 0xd122, 0xe309, 0xf4d0, 0xedb4, 0xf676, 0xfed7, 0xfef8, 0xff9a, 0xffba, 0xffbb, 0xffbb, 0xffdb, 0xffbb, 0xffbb, 0xffbb, 0xff98, 0xffdc, 0xf7dc, 0xff9a, 0xfffc, 0xaebc, 0x1395, 0x0398, 0x03b7, 0x4c78, 0xefbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xe71c, 0x5aeb, 0x0861, 0x0000, 0x2945, 0x9cf3, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7ff, 0x6d59, 0x0356, 0x0399, 0x0b77, 0x95fa, 0xfffd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xff99, 0xfffd, 0xf7dd, 0xffba, 0xfffc, 0xae9c, 0x1376, 0x0399, 0x0397, 0x4c78, 0xefbf, 0xffff, 0xffff, 0xf7ff, 0xf7bf, 0xc5d7, 0x2945, 0x0000, 0x0841, 0x528a, 0xc638, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0x6539, 0x0357, 0x037a, 0x0b56, 0x9619, 0xfffa, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdc, 0xffdc, 0xffdb, 0xffbb, 0xff7a, 0xfef9, 0xf677, 0xf616, 0xfcf2, 0xfbed, 0xd9c3, 0xd0e0, 0xd902, 0xd123, 0xd9a4, 0xea46, 0xe32b, 0xddb3, 0xfffe, 0xffbf, 0xffbf, 
0xffdf, 0xffff, 0xff1b, 0xdcd1, 0xdb2a, 0xda05, 0xe1a4, 0xc921, 0xd0e1, 0xd9e5, 0xf3ac, 0xf531, 0xf635, 0xf6b7, 0xf6f8, 0xff18, 0xffba, 0xffba, 0xffba, 0xffbb, 0xffdb, 0xffdb, 0xffbb, 0xffbb, 0xffb9, 0xffdc, 0xffbc, 0xffba, 0xffdc, 0x7d58, 0x0b75, 0x0377, 0x0395, 0x861d, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xad75, 0x18c3, 0x0020, 0x0841, 0x0000, 0x4a69, 0xdefb, 0xffdf, 0xffff, 0xffff, 0xffff, 0xaf1f, 0x0b75, 0x0378, 0x0377, 0x5495, 0xf7fe, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffba, 0xffdc, 0xffdd, 0xffbb, 0xffdc, 0x7558, 0x0355, 0x0378, 0x0b75, 0x8e3e, 0xf7ff, 0xffdf, 0xffff, 0xf7ff, 0xdf1c, 0x6b2d, 0x0020, 0x0861, 0x0000, 0x10a2, 0x8c71, 0xffff, 0xf7be, 0xffff, 0xfffe, 0xffff, 0xa6de, 0x1376, 0x0379, 0x0356, 0x5cb5, 0xeffc, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdc, 0xffdb, 0xffdb, 0xffbb, 0xff9a, 0xff39, 0xfeb7, 0xf656, 0xfd53, 0xfc4e, 0xeaa7, 0xd121, 0xd902, 0xd984, 0xda26, 0xe2e9, 0xdc4f, 0xf719, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffde, 0xee16, 0xd40e, 0xd2c8, 0xd9e5, 0xd142, 0xc942, 0xe2c8, 0xf44e, 0xf592, 0xf696, 0xfef8, 0xf718, 0xff59, 0xffba, 0xffba, 0xffba, 0xffbb, 0xffbb, 0xffbb, 0xffdb, 0xffbb, 0xffba, 0xffbb, 0xffbb, 0xffba, 0xefbc, 0x4434, 0x0376, 0x0377, 0x0bb4, 0xb73f, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xef5d, 0x632c, 0x1082, 0x2124, 0x2965, 0x10a2, 0x18c3, 0xa534, 0xffdf, 0xffff, 0xffff, 0xffff, 0xe7ff, 0x2bd6, 0x0377, 0x0377, 0x2b92, 0xd79e, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffba, 0xf7dc, 0xffdc, 0xffbb, 0xef9d, 0x4435, 0x0376, 0x0377, 0x1b74, 0xbf7f, 0xffff, 0xffbe, 0xffff, 0xf7ff, 0xbe18, 0x2904, 0x18e3, 0x2945, 0x2104, 0x0861, 0x4a69, 0xe71c, 0xffff, 0xffff, 0xffbd, 0xffff, 0xdfdf, 0x2bd6, 0x0378, 0x0377, 0x2bd3, 0xd79e, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffba, 0xffba, 0xffba, 0xffbb, 0xffbb, 0xffdb, 0xffdb, 0xff9a, 0xff59, 0xfed8, 0xfe97, 0xf574, 0xf4d0, 0xeb6a, 0xd9a3, 0xd102, 0xd9c5, 0xdac9, 0xdbcd, 0xdd95, 0xffdd, 0xf7ff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf73c, 0xe5b5, 0xe42e, 0xda26, 0xe163, 0xc9c4, 0xeb8b, 0xf4d0, 0xedd3, 0xf6b7, 0xf718, 0xf738, 0xff79, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffda, 0xffda, 0xffbb, 0xffbb, 0xffdb, 0xd75c, 0x2393, 0x0397, 0x0397, 0x2c35, 0xdfff, 0xffbf, 0xffdf, 0xffff, 0xf7ff, 0xce79, 0x2965, 0x18c3, 0x2945, 0x2124, 0x2945, 0x1082, 0x738e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0x5497, 0x0376, 0x0377, 0x1353, 0xa69c, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffba, 0xf7bb, 0xffdc, 0xffdb, 0xd75c, 0x1b93, 0x0397, 0x0398, 0x3c15, 0xdfff, 0xffff, 0xffde, 0xffff, 0xe7be, 0x94b2, 0x1041, 0x2124, 0x2124, 0x3186, 0x18c3, 0x18e3, 0xb5b6, 0xffff, 0xffff, 0xffbd, 0xfffe, 0xf7ff, 0x4c77, 0x0377, 0x03b8, 0x1333, 0xaedd, 0xffda, 0xffda, 0xffda, 0xffda, 0xffba, 0xffba, 0xffba, 0xffba, 0xffbb, 0xffbb, 0xffbb, 0xffdb, 0xffba, 0xff79, 0xff18, 0xfed7, 0xfe15, 0xf552, 0xec2d, 0xe266, 0xd142, 0xd9e6, 0xe3ce, 0xe554, 0xff7d, 0xffff, 0xf7ff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xff9d, 0xfdb5, 0xd247, 0xe943, 0xd2a7, 0xf40d, 0xf552, 0xee35, 0xeed7, 0xef38, 0xf758, 0xff99, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffda, 0xffba, 0xffdb, 0xffbb, 0xffdc, 0xb6bb, 0x0b54, 0x0398, 0x0397, 0x5517, 0xefff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xa535, 0x18c2, 0x3186, 0x3186, 0x2945, 0x39e7, 0x2104, 0x4228, 0xef7d, 0xffdf, 0xffff, 0xffff, 0xffff, 0x859a, 0x0b75, 0x0397, 0x0b74, 0x7dbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffba, 0xffdb, 0xffbb, 0xfffc, 0xb6bb, 0x0b54, 0x03b8, 0x03b7, 0x6d18, 0xefff, 0xffbf, 0xffdf, 0xffff, 0xdf7d, 0x634d, 0x2082, 0x31a6, 0x31a6, 0x39e7, 0x2965, 0x18e3, 0x8c71, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xf7ff, 0x757a, 0x0375, 0x03b7, 0x0313, 0x85db, 0xffda, 0xffda, 0xffda, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffbb, 0xffbb, 0xffba, 0xffdb, 0xffba, 0xff99, 0xff38, 0xfef8, 0xf677, 0xedb4, 0xe48e, 0xe308, 0xd983, 0xda06, 0xf513, 0xff7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xfe58, 0xc1c6, 0xe903, 0xdb4a, 0xec8f, 0xf5b3, 0xf696, 0xef17, 0xef38, 0xf799, 0xffb9, 0xffba, 0xffb9, 0xff99, 0xff99, 0xff99, 0xffba, 0xffba, 0xffda, 0xffdb, 0xffdb, 0xff9a, 0xffdc, 0x9e1a, 0x0375, 0x0398, 0x0376, 0x7df9, 0xf7ff, 0xffdf, 0xfffe, 0xffff, 0xf7ff, 0x8430, 0x20c2, 0x3186, 0x31a6, 0x39e7, 0x39c7, 0x2124, 0x2945, 0xd69a, 0xffff, 0xf7ff, 0xffdf, 0xffff, 0xae7d, 0x0b75, 0x03b7, 0x0396, 0x5d3b, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffba, 0xffdb, 0xffba, 0xffdc, 0x961a, 0x0375, 0x0398, 0x0397, 0x8dda, 0xf7ff, 0xffbf, 0xffde, 0xffff, 0xd73c, 0x3a08, 0x3104, 0x3186, 0x39c7, 0x39e7, 0x31a6, 0x2104, 0x6b4d, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0x967d, 0x0395, 0x0396, 0x0b34, 0x7519, 0xffda, 0xffda, 0xffda, 0xffda, 0xffba, 0xffba, 0xffb9, 0xffb9, 0xff9b, 0xffbb, 0xffba, 0xffda, 0xffda, 0xff99, 0xff58, 0xff18, 0xf697, 0xe5f4, 0xdcaf, 0xf3ab, 0xd9c4, 0xc9c5, 0xfd95, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xf7df, 0xefff, 0xf7ff, 0xf617, 0xb143, 0xe8e2, 0xe3ac, 0xecaf, 0xf5d4, 0xf6f7, 0xef38, 0xe738, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xff99, 0xffb9, 0xffba, 0xffba, 0xffdb, 0xfffc, 0xff9a, 0xffdc, 0x85b8, 0x0376, 0x0378, 0x0356, 0x967b, 0xefdf, 0xffbe, 0xffde, 0xffff, 0xf7ff, 0x6b6d, 0x20e2, 0x39c7, 0x39e7, 0x4a69, 0x2965, 0x3186, 0x2124, 0xc618, 0xffff, 0xf7ff, 0xfffe, 0xffdf, 0xc71f, 0x1374, 0x03d7, 0x0396, 0x4cfa, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffba, 0xfffb, 0xff9a, 0xffdc, 0x85b8, 0x0376, 0x0398, 0x0376, 0x9e3b, 0xf7ff, 0xffbe, 0xffde, 0xffff, 0xcefb, 0x2125, 0x3924, 0x39e7, 0x4228, 0x4208, 0x39c7, 0x2104, 0x528a, 0xf7be, 0xffff, 0xf7ff, 0xffff, 0xf7df, 0xaf1f, 0x03b5, 0x0396, 0x1395, 0x6cf9, 0xffda, 0xffda, 0xffda, 0xffda, 0xffba, 0xffba, 0xffb9, 0xffb9, 0xff9a, 0xffba, 0xffba, 0xffda, 0xffda, 0xff99, 0xff58, 0xf718, 0xf6d8, 0xe656, 0xdd10, 0xfc4e, 0xe1e4, 0xb923, 0xe534, 0xefff, 0xffbf, 0xffdf, 0xffde, 0xfffe, 0xfffe, 
0xffff, 0xf7be, 0xf7ff, 0xffdf, 0xffdf, 0xd534, 0xc8a3, 0xf205, 0xd46e, 0xe551, 0xf634, 0xf6d6, 0xf717, 0xf778, 0xf7b9, 0xffda, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffb9, 0xffb9, 0xffb9, 0xffd9, 0xf7b9, 0xffb9, 0xfffc, 0x7537, 0x0377, 0x0399, 0x0b76, 0xae5b, 0xf7ff, 0xffde, 0xffff, 0xf7df, 0xef9f, 0x52cb, 0x2903, 0x39c7, 0x4228, 0x4228, 0x4208, 0x31a6, 0x2124, 0xad55, 0xffff, 0xefff, 0xfffe, 0xfffe, 0xd75f, 0x1b76, 0x0378, 0x0396, 0x3c97, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xfffb, 0xff9a, 0xff9a, 0xfffd, 0x6537, 0x0357, 0x039a, 0x0376, 0xbebb, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xb617, 0x2165, 0x3186, 0x39e7, 0x4228, 0x4208, 0x39c7, 0x2965, 0x4228, 0xe73c, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xd75f, 0x1395, 0x0398, 0x03b7, 0x34b8, 0xffba, 0xffba, 0xffba, 0xffba, 0xff99, 0xffba, 0xffba, 0xffba, 0xffba, 0xffb9, 0xff99, 0xffba, 0xffda, 0xffda, 0xff99, 0xf758, 0xfeb6, 0xee95, 0xd571, 0xe46d, 0xeaa8, 0xc164, 0xdc71, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xf7ff, 0xffdf, 0xffff, 0xdd95, 0xc124, 0xf286, 0xd48e, 0xe551, 0xf654, 0xf6d6, 0xf717, 0xf778, 0xffb9, 0xffda, 0xffba, 0xffba, 0xffba, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xf7b9, 0xf7b9, 0xffb9, 0xfffc, 0x6d16, 0x0376, 0x0399, 0x0356, 0xbebd, 0xf7ff, 0xffff, 0xffff, 0xf7df, 0xe77e, 0x4a6a, 0x2103, 0x39c7, 0x4228, 0x4228, 0x4208, 0x31a6, 0x2104, 0xa514, 0xffff, 0xf7ff, 0xfffe, 0xfffe, 0xd79f, 0x1b96, 0x0399, 0x0396, 0x3476, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xfffb, 0xff9a, 0xff9a, 0xfffd, 0x6516, 0x0357, 0x039a, 0x0376, 0xc6fc, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xb5d6, 0x2124, 0x3186, 0x39e7, 0x4228, 0x4228, 0x39e7, 0x2945, 0x4208, 0xe73c, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xd77f, 0x1395, 0x0398, 0x0396, 0x3497, 0xffba, 0xffba, 0xffb9, 0xff99, 0xff99, 0xff99, 0xffb9, 0xffb9, 0xffba, 0xff99, 0xff99, 0xffba, 0xffda, 0xffba, 0xff99, 0xf758, 0xfed6, 0xeeb5, 0xd5b1, 0xe48e, 0xe2e8, 0xb984, 0xd491, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xf7fe, 0xffdf, 0xffff, 0xe637, 0xba27, 0xeb48, 0xd4ce, 0xe591, 0xf674, 0xf6f6, 0xf737, 0xf778, 0xffb9, 0xffba, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xf798, 0xffb9, 0xffb9, 0xffbb, 0x6cf6, 0x0356, 0x0399, 0x0356, 0xc6fe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xe77e, 0x3a08, 0x2924, 0x39c7, 0x4a49, 0x4228, 0x4208, 0x39c7, 0x18e3, 0x9cf3, 0xffff, 0xf7ff, 0xfffe, 0xfffe, 0xd7bf, 0x1bb7, 0x03b9, 0x0376, 0x3435, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xf7fa, 0xff9a, 0xff9a, 0xf7fc, 0x5cf6, 0x0336, 0x03b9, 0x0376, 0xc71d, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xadb5, 0x1903, 0x39a7, 0x4208, 0x4228, 0x4a49, 0x4208, 0x2945, 0x39e7, 0xe71c, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xd7bf, 0x1396, 0x0398, 0x0396, 0x3456, 0xffb9, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xffb9, 0xffba, 0xffb9, 0xff79, 0xf758, 0xfef6, 0xeed6, 0xd5f2, 0xe4ef, 0xdb6a, 0xba87, 0xdd54, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xef1b, 0xc3ed, 0xdc0b, 0xd50f, 0xe5d1, 0xf694, 0xf6f6, 0xf737, 0xf778, 0xff99, 0xff99, 0xff99, 0xff79, 0xff79, 0xff79, 0xff78, 0xff78, 0xff78, 0xff78, 0xf758, 0xff99, 0xff98, 0xf77a, 0x6cf5, 0x0356, 0x0398, 0x0355, 0xc6fe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xe79e, 0x3a08, 0x3165, 0x39c7, 0x4a69, 0x4a49, 0x4208, 0x39c7, 0x18c3, 0x9cf3, 0xffff, 0xf7ff, 0xfffe, 0xfffe, 0xd7bf, 0x1bd7, 0x03b9, 0x0376, 0x3415, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xf7da, 0xff9a, 0xff9a, 0xefdb, 0x64f5, 0x0336, 0x0399, 0x0396, 0xc71d, 0xf7ff, 0xffbf, 0xffff, 0xfffe, 0xa595, 0x1903, 0x41c7, 0x4208, 0x4a49, 0x4a49, 0x4228, 0x2945, 0x39e7, 0xe73c, 0xffff, 0xffff, 0xffff, 0xfffe, 0xd7bf, 0x1396, 0x0398, 0x0376, 0x3456, 0xff99, 0xff98, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff99, 0xff79, 0xff79, 0xff99, 0xff99, 0xff99, 0xff78, 0xf758, 0xf6f6, 0xeef6, 0xd633, 0xdd4f, 0xdc4c, 0xd40d, 0xf699, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffbe, 0xd592, 0xd48c, 0xd54f, 0xe5f2, 0xee94, 0xf6f6, 0xf737, 0xff78, 0xff79, 0xff79, 0xff58, 0xff58, 0xff58, 0xff58, 0xff58, 0xff58, 0xff58, 0xff58, 0xff37, 0xff58, 0xff58, 0xf759, 0x7516, 0x0356, 0x0398, 0x0355, 0xbebd, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xefbf, 0x4249, 0x3165, 0x39c7, 0x4a69, 0x4a49, 0x4228, 0x39c7, 0x18e3, 0xa534, 0xffff, 0xffff, 0xffde, 0xfffe, 0xcfbf, 0x13b7, 0x03b9, 0x0356, 0x3c36, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xf7da, 0xff9a, 0xff9a, 0xf7bb, 0x6d16, 0x0336, 0x0399, 0x0396, 0xc6fc, 0xf7ff, 0xffdf, 0xffff, 0xfffe, 0xadb5, 0x1903, 0x39c7, 0x4228, 0x4a49, 0x4a69, 0x4228, 0x2945, 0x4208, 0xef5d, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xcf9f, 0x0b96, 0x0399, 0x0375, 0x4476, 0xff58, 0xff58, 0xff58, 0xff57, 0xff57, 0xff57, 0xff57, 0xff58, 0xff78, 0xff58, 0xff78, 0xff78, 0xff79, 0xff78, 0xff58, 0xff58, 0xf6f6, 0xeef6, 0xde33, 0xd570, 0xd4ee, 0xe551, 0xff9d, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xf7ff, 0xffff, 0xffdf, 0xd696, 0xcccd, 0xd590, 0xde12, 0xeeb4, 0xeef5, 0xf716, 0xf757, 0xff58, 0xff58, 0xff37, 0xff37, 0xff37, 0xff37, 0xff37, 0xff17, 0xff17, 0xff17, 0xff37, 0xff37, 0xff17, 0xf759, 0x7d57, 0x0376, 0x0378, 0x0355, 0xae5b, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xefdf, 0x52aa, 0x2944, 0x39e7, 0x4a49, 0x4a49, 0x4228, 0x31a6, 0x2124, 0xbdd7, 0xffff, 0xffff, 0xffde, 0xfffe, 0xbf5f, 0x0b96, 0x03b9, 0x0356, 0x4c98, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffda, 0xff79, 0xff99, 0xf7db, 0x7577, 0x0356, 0x0399, 0x0396, 0xbebb, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xb617, 0x2124, 0x3186, 0x4228, 0x4a49, 0x4a49, 0x4208, 0x2945, 0x4a69, 0xf7be, 0xffff, 0xffff, 0xfffe, 0xffff, 0xbf3f, 0x0b76, 0x0399, 0x0375, 0x54b7, 0xff57, 0xff37, 0xff37, 0xff37, 0xff37, 0xff37, 0xff37, 0xff37, 0xff58, 0xff58, 0xff58, 0xff58, 0xff58, 0xff58, 0xff58, 0xff37, 0xf6f6, 0xf6d6, 0xde33, 0xcd6f, 0xc50e, 0xddd3, 0xfffe, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xf7ff, 0xffdf, 0xffbf, 0xceb6, 0xccce, 0xcdaf, 0xde32, 0xe6b4, 0xeef5, 0xef16, 0xf737, 0xff37, 0xff17, 0xff17, 0xff17, 0xff17, 0xff17, 0xff17, 0xff17, 0xff17, 0xff17, 0xff17, 0xfed6, 0xfed6, 0xff59, 0x8d98, 0x0376, 0x0377, 0x0375, 0x9db9, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0x632d, 0x2924, 0x39e7, 0x4228, 0x4a49, 0x4228, 0x3186, 0x3186, 0xce79, 0xffff, 0xffdf, 0xfffe, 0xfffe, 0xb71e, 0x0375, 0x0398, 0x0356, 0x5cf9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffda, 0xff79, 0xff79, 0xfffc, 0x85d9, 0x0b76, 0x0378, 0x0396, 0xa619, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xce99, 0x2985, 0x3166, 0x4228, 0x4a49, 0x4a49, 0x39e7, 0x2965, 0x5acb, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xaeff, 0x0356, 0x0399, 0x0b55, 0x64f8, 0xff16, 0xff16, 0xff16, 0xfef6, 0xfef6, 0xfef6, 0xfef6, 0xff16, 0xff37, 0xff37, 0xff37, 0xff37, 0xff37, 0xff37, 0xff37, 0xff37, 0xfed5, 0xf6b5, 0xde33, 0xcd90, 0xbd0d, 0xcdb2, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xff9f, 0xf7ff, 0xffdf, 0xff9f, 0xc676, 0xccce, 0xcdb0, 0xde32, 0xe6b4, 0xe6f5, 0xef16, 0xf737, 0xff17, 0xff17, 0xfef7, 0xfef7, 0xfef7, 0xfef6, 0xfef6, 0xfef6, 0xfef6, 0xfef6, 0xff17, 0xf6b6, 0xfeb5, 0xff59, 0x8db8, 0x0b96, 0x0377, 0x0376, 0x8d37, 0xf7ff, 0xffde, 0xffff, 0xffff, 0xffff, 0x73cf, 0x2924, 0x39e7, 0x4208, 0x4a49, 0x4228, 0x2965, 0x39c7, 0xdefb, 0xffff, 0xffdf, 0xfffe, 0xfffe, 0xaedd, 0x0354, 0x0398, 0x0356, 0x6d5b, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xfffa, 0xff59, 0xff79, 0xfffc, 0x8e1a, 0x0b77, 0x0378, 0x0396, 0x9597, 0xefdf, 0xffff, 0xffff, 0xffff, 0xd71b, 0x3a07, 0x3986, 0x4228, 0x4a49, 0x4a49, 0x39c7, 0x2965, 0x630c, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xf7de, 0xa6be, 0x0356, 0x0399, 0x0b55, 0x6d39, 0xff16, 0xfef6, 0xfef6, 0xfef5, 0xfef5, 0xfef5, 0xfef5, 0xfef6, 0xff17, 0xff17, 0xff37, 0xff37, 0xff37, 0xff17, 0xff37, 0xff37, 0xfeb5, 0xf694, 0xe654, 0xd5d1, 0xbd0e, 0xc5b2, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xde55, 0xb50d, 0xd5d1, 0xde12, 0xe653, 0xf6b4, 0xf6d5, 0xf6d5, 0xfef5, 0xfef5, 0xfed6, 0xfed6, 0xfed6, 0xfeb6, 0xfeb5, 0xfeb5, 0xfeb5, 0xfe95, 0xfeb5, 0xf6d7, 0xf694, 0xfef5, 0xbe16, 0x0b54, 0x03b9, 0x0356, 0x44d9, 0xf7ff, 0xffbe, 0xfffc, 0xf7fe, 0xffff, 0xad55, 0x1943, 0x39c7, 0x4a49, 0x4228, 0x39e7, 0x3186, 0x4a69, 0xffff, 0xffff, 0xffdf, 0xffdd, 0xffff, 0x753a, 0x03d7, 0x0379, 0x1356, 0x95d7, 0xffb9, 0xffd9, 0xffb8, 0xff57, 0xff58, 0xff99, 0xffd9, 0xeff9, 0xff5a, 0xff9b, 0xff79, 0xfff9, 0xa6d9, 0x0333, 0x0398, 0x0335, 0x4cfa, 0xf7ff, 0xff7d, 0xfffc, 0xf7fe, 0xffdf, 0x526a, 0x21c5, 0x39e7, 0x4228, 0x39c7, 0x4228, 0x18e3, 0xa514, 0xf79e, 0xffff, 0xe7ff, 0xffbd, 0xf7ff, 0x6d5a, 0x0b54, 0x03b8, 0x1376, 0x9d95, 0xfed5, 0xfeb5, 0xfeb5, 0xfeb5, 0xfeb5, 0xfeb5, 0xfeb5, 0xfed5, 0xfeb5, 0xfed5, 0xfed5, 0xfef5, 0xfef5, 0xf6f5, 0xf715, 0xf715, 0xf6d4, 0xe6b4, 0xd673, 0xcdd1, 0xbd0d, 0xac8d, 0xf75b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xde35, 0xbd2e, 0xd5d1, 0xddf2, 0xe653, 0xee94, 0xf6b5, 0xf6d5, 0xfed5, 0xfed5, 0xfeb5, 0xfeb5, 0xfeb5, 0xfeb5, 0xfe95, 0xfe95, 0xfe75, 0xfe75, 0xfe94, 0xf6b5, 0xf674, 0xfed5, 0xce57, 0x23b5, 0x0398, 0x0397, 0x23f6, 0xdf9f, 0xffbe, 0xfffd, 0xffff, 0xffff, 0xd67a, 0x29a5, 0x39c7, 0x4228, 0x4a49, 0x4208, 0x2104, 0x7bef, 0xffff, 0xffff, 0xffdf, 0xffdc, 0xffff, 0x5477, 0x0376, 0x0399, 0x1315, 0xb679, 0xf7d9, 0xffb9, 0xffb9, 0xffba, 0xf7da, 0xefd9, 0xf7b9, 0xff99, 0xffbb, 0xffdb, 0xff98, 0xfff9, 0xcf3b, 0x23d6, 0x03b8, 0x03d7, 0x2c17, 0xe7df, 0xffde, 0xfffd, 0xffff, 0xffff, 0x8410, 0x1923, 0x39c7, 0x4a69, 0x4a69, 0x31a6, 0x2965, 0xdedb, 0xffff, 0xef7d, 0xf7ff, 0xffdc, 0xffff, 0x4cd8, 0x0334, 0x03b9, 0x0b74, 0xbdf6, 0xfe95, 0xfe95, 0xfe94, 0xfe94, 0xfe94, 0xfe94, 0xfe95, 0xfe95, 0xfeb5, 0xfeb5, 0xfed5, 0xfed5, 0xfef5, 0xfef5, 0xf6f5, 0xf6f5, 0xf6d3, 0xe6b4, 0xd653, 0xcdd1, 0xbd0d, 0xac8d, 0xf73a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xd614, 0xbd2e, 0xd5b0, 0xddf1, 0xe633, 0xee74, 0xf6b4, 0xf6b4, 0xf6b4, 0xfeb5, 0xfe94, 0xfe94, 0xfe74, 0xfe74, 0xfe74, 0xfe54, 0xfe54, 0xfe54, 0xfe72, 0xfe54, 0xfe74, 0xfe94, 0xde97, 0x5476, 0x0356, 0x03b8, 0x1375, 0xbeff, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xf79e, 0x4aa9, 0x31a6, 0x31a6, 0x39e7, 0x31a6, 0x2965, 0xbdf7, 0xffdf, 0xffff, 0xffff, 0xfffd, 0xdfdf, 0x2bb6, 0x0378, 0x03fa, 0x2b94, 0xdf7c, 0xff7a, 0xff5a, 0xff39, 0xff59, 0xf799, 0xffb9, 0xff99, 0xff79, 0xef78, 0xef98, 0xffd7, 0xfff9, 0xef7c, 0x5437, 0x02f5, 0x0419, 0x1354, 0xc71f, 0xffff, 0xfffe, 0xffff, 0xffff, 0xc618, 0x1943, 0x39c7, 0x4208, 0x39e7, 0x2945, 0x5acb, 0xe73c, 0xffff, 0xffff, 0xffff, 0xfffd, 0xe73e, 0x2436, 0x0356, 0x0bb9, 0x1bb3, 0xde57, 0xfe74, 0xfe74, 0xfe74, 0xfe54, 0xfe54, 0xfe74, 0xfe74, 0xfe74, 0xfe94, 0xfe94, 0xfeb5, 0xfeb5, 0xfed5, 0xfed5, 0xf6d5, 0xf6d5, 0xf6b3, 0xe693, 0xde53, 0xcdd1, 0xbd0e, 0xac8d, 0xef1a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xc5b2, 0xbd2d, 0xd5b0, 0xd5d1, 0xe632, 0xee53, 0xf673, 0xf694, 0xfe94, 0xfe94, 0xfe74, 0xfe54, 0xfe54, 0xfe54, 0xfe33, 0xfe33, 0xfe33, 0xfe33, 0xfe32, 0xfe12, 0xfe53, 0xfe33, 0xf696, 0x8516, 0x0333, 0x03b9, 0x0b76, 0x7dbc, 0xf7ff, 0xffff, 0xfffe, 0xffff, 0xffff, 0x9cf3, 0x2104, 0x4208, 0x4a49, 0x2104, 0x528a, 0xef7d, 0xffff, 0xffff, 0xfffe, 0xffff, 0xae9d, 0x1376, 0x039a, 0x03b8, 0x4c95, 0xeffc, 0xff59, 0xffba, 0xffd9, 0xff98, 0xff37, 0xff57, 0xf776, 0xdf96, 0xff99, 0xfff8, 0xf7f7, 0xf796, 0xf7bc, 0x957a, 0x12f4, 0x0399, 0x0335, 0x7dbc, 0xf7ff, 0xfffe, 0xffde, 0xffff, 0xf79e, 0x52ca, 0x2945, 0x4208, 0x3186, 0x2945, 0x9cd3, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xa61b, 0x0bb6, 0x0398, 0x13b8, 0x5c74, 0xf676, 0xfe53, 0xfe33, 0xfe33, 0xfe33, 0xfe33, 0xfe33, 0xfe33, 0xfe53, 0xfe74, 0xfe74, 0xfe94, 0xfe94, 0xfeb4, 0xf6b4, 0xf6b4, 0xf6b4, 0xf693, 0xee73, 0xde53, 0xcdd1, 0xc52e, 0xac8d, 0xe6d9, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf75c, 0xb530, 0xb4ec, 0xcd8f, 0xd5d0, 0xe611, 0xee52, 0xf653, 0xf653, 0xfe53, 0xfe53, 0xfe33, 0xfe33, 0xfe33, 0xfe33, 0xfe33, 0xfe13, 0xfe12, 0xfe12, 0xfe12, 0xfdd1, 0xfe12, 0xfdf2, 0xfe54, 0xb595, 0x2352, 0x0398, 0x0356, 0x3416, 0xd7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xef5d, 0x4a69, 0x18e3, 0x18e3, 0x31a6, 0xb5b6, 0xffff, 0xffff, 0xffff, 0xffdd, 0xf7ff, 0x64b8, 0x0337, 0x039a, 0x0334, 0x85f7, 0xf7fa, 0xf7f8, 0xe735, 0xcd8f, 0xcc0b, 0xd2c8, 0xd247, 0xca66, 0xcac7, 0xe3ed, 0xfd91, 0xff35, 0xffb7, 0xf7fb, 0xb69a, 0x2353, 0x0378, 0x0376, 0x3c57, 0xd7df, 0xffff, 0xffdf, 0xffff, 0xffff, 0xb576, 0x2945, 0x18c3, 0x18c3, 0x630c, 0xe73c, 0xffff, 0xffff, 0xffdf, 0xffde, 0xf7ff, 0x54d8, 0x0376, 0x0399, 0x0b75, 0xad35, 0xfe54, 0xfe12, 0xfe12, 0xfe12, 0xfe12, 0xfe12, 0xfe12, 0xfe12, 0xfe12, 0xfe33, 0xfe53, 0xfe53, 0xfe73, 0xfe73, 0xf673, 0xf693, 0xf673, 0xf652, 0xe653, 0xde33, 0xcdb0, 0xc52e, 0xac8d, 0xdeb8, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef3b, 0xacce, 0xacec, 0xcd8f, 0xd5b0, 0xe5f1, 0xee32, 0xf632, 0xf632, 0xfe33, 0xfe33, 0xfe12, 0xfe12, 0xfe12, 0xfdf2, 0xfdf2, 0xfdf2, 0xfdf2, 0xfdd2, 0xfdd2, 0xfdb1, 0xfdd1, 0xfdf2, 0xfe12, 0xe5f3, 0x5412, 0x0398, 0x0377, 0x0354, 0x9ede, 0xf7ff, 0xffff, 0xffff, 0xf7df, 0xffdf, 0xce59, 0x52aa, 0x528a, 0x9cd3, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xcf1f, 0x2b96, 0x0336, 0x0358, 0x1b73, 0xcf19, 0xff36, 0xe56f, 0xc328, 0xb142, 0xd143, 0xe9c6, 0xf1c6, 0xf166, 0xf966, 0xc0c5, 0xc143, 0xd307, 0xf5d1, 0xffd9, 0xc779, 0x2c53, 0x03b7, 0x0378, 0x0b74, 0xa6ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xff7f, 0x94b2, 0x528a, 0x632c, 0xce79, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xc73f, 0x1bf5, 0x0356, 0x0378, 0x2393, 0xedd5, 0xfe11, 0xfdf2, 0xfdf1, 0xfdf1, 0xfdf1, 0xfdf1, 0xfdf1, 0xfdf1, 0xfdf2, 0xfe12, 0xfe13, 0xfe33, 0xfe53, 0xfe53, 0xf653, 0xf653, 0xf653, 0xf632, 0xee12, 0xde12, 0xcd90, 0xc52e, 0xac8d, 0xde98, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xef1b, 0xa48d, 0xb4ec, 0xcd6e, 0xd5af, 0xddf1, 0xee11, 0xf612, 0xf612, 0xfe12, 0xfdf2, 0xfdf1, 0xfdf1, 0xfdf1, 0xfdd1, 0xfdd1, 0xfdd1, 0xfdb1, 0xfdb1, 0xf5b3, 0xfdb1, 0xfd91, 0xf5f2, 0xfdd0, 0xfe31, 0x8cf3, 0x0397, 0x03b9, 0x0375, 0x4cd7, 0xe77f, 0xffdf, 0xffff, 0xf7df, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xffff, 0xefff, 0x753b, 0x1376, 0x0356, 0x0317, 0x6496, 0xf6b6, 0xe46c, 0xc841, 0xd0c2, 0xea27, 0xfc90, 0xfeb7, 0xff5a, 0xfef8, 0xfe36, 0xfc31, 0xd1c6, 0xb020, 0xc205, 0xed2f, 0xf7b9, 0x75b7, 0x0396, 0x0378, 0x0375, 0x5518, 0xe79f, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xe73c, 0xf7be, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xe7bf, 0x655c, 0x0375, 0x0376, 0x0377, 0x6454, 0xfdf2, 0xfdaf, 0xfdb1, 0xfdb1, 0xfdb1, 0xfdb0, 0xfdb0, 0xfdb1, 0xfdb1, 0xfdb1, 0xfdf2, 0xfe12, 0xfe12, 0xfe32, 0xfe32, 0xf632, 0xf632, 0xf632, 0xf612, 0xe612, 0xddf2, 0xcd6f, 0xc50e, 0xac6c, 0xde97, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xef1b, 0xa48d, 0xb50c, 0xc56e, 0xd58f, 0xddd0, 0xee11, 0xf612, 0xf5f2, 0xfdf2, 0xfdf2, 0xfdd1, 0xfdd1, 0xfdb1, 0xfdb1, 0xfdb1, 0xfd90, 0xfd90, 0xfd90, 0xf593, 0xfd91, 0xf570, 0xf613, 0xfdae, 0xfe50, 0xb595, 0x13b7, 0x0399, 0x03b6, 0x0b11, 0xc69d, 0xffdf, 0xffff, 0xffff, 0xff9f, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xbf5e, 0x2355, 0x0377, 0x0377, 0x0b37, 0x9d79, 0xed71, 0xa100, 0xc821, 0xf32b, 0xfe14, 0xf6d7, 0xde96, 0xe698, 0xeeb9, 0xee79, 0xee98, 0xfd93, 0xfa68, 0xc041, 0xa921, 0xf5f2, 0xb639, 0x1b56, 0x0378, 0x03b6, 0x1331, 0xc69d, 0xff9f, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xcf1e, 0x0bb6, 0x0b36, 0x0397, 0x0397, 0x9d37, 0xfdf0, 0xfd6e, 0xfdb0, 0xfd90, 0xfd90, 0xfd90, 0xfd90, 0xfd90, 0xfd90, 0xfdb0, 0xfdf2, 0xfdf2, 0xfdf2, 0xfe12, 0xfe32, 0xf632, 0xf632, 0xf632, 0xf612, 0xe5f2, 0xddd2, 0xcd6f, 0xc50e, 0xac6c, 0xde97, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xf7fe, 0xe73a, 0xa44c, 0xbc8b, 0xc50d, 0xd56f, 0xe5b0, 0xedd0, 0xf5d0, 0xfdf1, 0xfdf1, 0xfdd1, 0xfdd1, 0xfdb1, 0xfdb0, 0xfd90, 0xfd70, 0xfd50, 0xfd50, 0xfd2f, 0xf58f, 0xf56f, 0xfd8f, 0xfd90, 0xfd90, 0xfdf2, 0xddb1, 0xacad, 0x0375, 0x03da, 0x0358, 0x2c58, 0xbf3f, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffff, 0xf7ff, 0xe7ff, 0x2cb6, 0x1396, 0x0398, 0x0334, 0x4cd5, 0xe554, 0xc963, 0xc820, 0xeb2a, 0xf38c, 0xfc0e, 0xfc4f, 0xfc2e, 0xfc0e, 0xfc2e, 0xfc4e, 0xfc2d, 0xfc2f, 0xfbae, 0xeaa9, 0xa840, 0xca26, 0xf676, 0x6570, 0x0315, 0x0357, 0x0317, 0x3419, 0xbf3f, 0xffff, 0xffbe, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xf7ff, 0xe7df, 0x2459, 0x0bb7, 0x03b7, 0x0b96, 0x5bf3, 0xe572, 0xfdd0, 0xfd4f, 0xfd4f, 0xfd4f, 0xfd4f, 0xfd4f, 0xfd6f, 0xfd6f, 0xfd90, 0xfd90, 0xfd91, 0xfdb1, 0xfdb1, 0xfdd1, 0xfdf1, 0xfdf1, 0xf611, 0xf611, 0xee10, 0xe5f0, 0xe5d1, 0xd58f, 0xb4ec, 0xa48c, 0xd697, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7b, 0xa44c, 0xc4cc, 0xc50d, 0xd56f, 0xddb0, 0xe5d0, 0xf5d0, 0xfdd1, 0xfdd1, 0xfdb0, 0xfdb0, 0xfd90, 0xfd90, 0xfd70, 0xfd70, 0xfd50, 0xfd2f, 0xfd2f, 0xf56f, 0xfd4f, 0xfd4f, 0xfd4f, 0xfd4f, 0xfdb1, 0xedd2, 0xd571, 0x1bd6, 0x0b75, 0x0398, 0x03b9, 0x4478, 0xd6fb, 0xfffe, 0xf7ff, 0xffff, 0xfffe, 0xffbd, 0xffbc, 0xfffe, 0xf7ff, 0xd79f, 0x8557, 0x03b4, 0x0315, 0x0315, 0x13d4, 0x8db6, 0xcbee, 0xb060, 0xe0e1, 0xf268, 0xf2a9, 0xfac9, 0xf2c9, 0xf2a9, 0xf2a9, 0xf2c9, 0xfaea, 0xf2e9, 0xfaca, 0xfaaa, 0xfaa9, 0xd0c1, 0xc102, 0xdcd0, 0xae96, 0x1bb5, 0x0355, 0x0397, 0x0b97, 0x4c98, 0xcf5f, 0xffff, 0xfffe, 0xffff, 0xfffe, 0xfffe, 0xffbd, 0xffff, 0xf7ff, 0xd77f, 0x8558, 0x0397, 0x0377, 0x0355, 0x3bd4, 0xb555, 0xfdf4, 0xfd4f, 0xfd4e, 0xfd4f, 0xfd2f, 0xfd2f, 0xfd4f, 0xfd4f, 0xfd6f, 0xfd6f, 0xfd90, 0xfd90, 0xfd91, 0xfdb1, 0xfdd1, 0xfdd1, 0xf5f1, 0xf5f1, 0xf5f1, 0xee10, 0xe5d0, 0xdd90, 0xd56f, 0xb4ec, 0xa4ac, 0xdeb8, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf79c, 0x9c0c, 0xc4cc, 0xc50d, 0xd54e, 0xdd90, 0xe5b0, 0xedb0, 0xf5d0, 0xfdb0, 0xfd90, 0xfd90, 0xfd90, 0xfd70, 0xfd6f, 0xfd4f, 0xfd2f, 0xfd2f, 0xfd0f, 0xfd2f, 0xfd0e, 0xfd2e, 0xfd2f, 0xfd2f, 0xfd70, 0xf5d2, 0xf5f3, 0x8d56, 0x2353, 0x0336, 0x0399, 0x0b34, 0x5c76, 0xcf1d, 0xffff, 0xffff, 0xffbe, 0xffbd, 0xffff, 0xf7ff, 0xc75f, 0x6d39, 0x12f1, 0x03f8, 0x02f5, 0x1b13, 0x5cd5, 0xc615, 0xba86, 0xb840, 0xf184, 0xf9e6, 0xf9e6, 0xf9c6, 0xf9c6, 0xf1a5, 0xf1a5, 0xf1c6, 0xf9e6, 0xf9c5, 0xf9c6, 0xf9a6, 0xfa27, 0xf943, 0xc020, 0xbac8, 0xdeb7, 0x75b8, 0x1372, 0x0335, 0x03b8, 0x0375, 0x54d7, 0xc73e, 0xf7ff, 0xffff, 0xfffe, 0xffde, 0xffff, 0xf7ff, 0xcf5f, 0x6d19, 0x12f1, 0x0397, 0x0357, 0x1374, 0x8451, 0xf5b2, 0xfdb2, 0xf50f, 0xfd4e, 0xfd2f, 0xfd2f, 0xfd0e, 0xfd0e, 0xfd2e, 0xfd2f, 0xfd4f, 0xfd6f, 0xfd70, 0xfd70, 0xfd90, 0xfdb0, 0xfdd1, 0xf5d1, 0xf5d1, 0xf5f1, 0xedf0, 0xe5b0, 0xd54f, 0xcd4f, 0xb4cc, 0xa48c, 0xded8, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xf79c, 0x93eb, 0xb46b, 0xc4ed, 0xd54e, 0xdd8f, 0xe58f, 0xed8f, 0xf5b0, 0xf590, 0xf56f, 0xfd6f, 0xfd6f, 0xfd4f, 0xfd4f, 0xfd2f, 0xfd0e, 0xfd0e, 0xfcee, 0xfcef, 0xfcee, 0xfd0e, 0xfd2f, 0xfd2f, 0xfd2f, 0xfd71, 0xfdb2, 0xedf3, 0x7c74, 0x1356, 0x0378, 0x03b8, 0x0336, 0x23f6, 0x7d99, 0xd79f, 0xdfdf, 0xe7ff, 0xcfbf, 0x8e3c, 0x3c78, 0x0bb7, 0x0398, 0x03d8, 0x0b14, 0x5c34, 0xae56, 0xdd91, 0xb141, 0xe102, 0xe964, 0xf964, 0xf985, 0xf9a5, 0xf9a5, 0xf9a5, 0xf9c5, 0xf9a5, 0xf9a5, 0xf964, 0xf9a6, 0xf965, 0xf984, 0xf963, 0xd060, 0xb1c4, 0xcdb2, 0xc698, 0x6cd4, 0x0b74, 0x0398, 0x03b9, 0x0335, 0x2bf5, 0x7dba, 0xd7bf, 0xdfff, 0xe7ff, 0xcf7f, 0x85dc, 0x3c37, 0x0b76, 0x0357, 0x03b9, 0x0b96, 0x6c75, 0xd552, 0xfd4e, 0xfd2e, 0xfd4f, 0xfd2e, 0xfcee, 0xfcee, 0xfcee, 0xfcee, 0xfcee, 0xfd0e, 0xfd2f, 0xfd2f, 0xfd50, 0xfd70, 0xfd70, 0xfd90, 0xfdb0, 0xf5b0, 0xf5d0, 0xf5d0, 0xe5f0, 0xe5b0, 0xd54f, 0xcd4f, 0xb4ac, 0x9c6c, 0xe6f9, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xf7bd, 0x9c4e, 0xb44c, 0xc4cd, 0xcd2e, 0xdd6f, 0xe56f, 0xed6f, 0xf58f, 0xf58f, 0xf54f, 0xfd4f, 0xfd4f, 0xfd4f, 0xfd2e, 0xfd0e, 0xfcee, 0xfcee, 0xfcee, 0xfcef, 0xfcae, 0xfccd, 0xfd0e, 0xfd4f, 0xfd2f, 0xfd2f, 0xfd70, 0xfd70, 0xf615, 0x7cb6, 0x0316, 0x037a, 0x03d9, 0x0376, 0x03b8, 0x1b54, 0x2bf6, 0x3438, 0x1bd6, 0x0376, 0x0377, 0x0399, 0x03ba, 0x0334, 0x5456, 0xae18, 0xd6d6, 0xd4ac, 0xa8a0, 0xe922, 0xe943, 0xf943, 0xf964, 0xf984, 0xf9c5, 0xf9c5, 0xf9c5, 0xf9c5, 0xf9a4, 0xf984, 0xf9a5, 0xf184, 0xe983, 0xf962, 0xd8c0, 0xb1e4, 0xbd30, 0xe633, 0xd6b9, 0x6d17, 0x0315, 0x0358, 0x03ba, 0x0357, 0x0b76, 0x1b74, 0x3417, 0x3437, 0x1b96, 0x0335, 0x0377, 0x0399, 0x037a, 0x0b96, 0x5c34, 0xc574, 0xfe13, 0xfd6e, 0xfd0c, 0xfd4e, 0xed2f, 0xfcee, 0xfcee, 0xfcce, 0xfcce, 0xfcee, 0xfcee, 0xfd0e, 0xfd0e, 0xfd4f, 0xfd4f, 0xfd6f, 0xfd90, 0xf590, 0xf5b0, 0xf5b0, 0xedb0, 0xe5cf, 0xe5b1, 0xdd70, 0xcd4f, 0xac8b, 0x9c6c, 0xef1a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xbd32, 0xbc8d, 0xc4cc, 0xcd0e, 0xdd4f, 0xe56f, 0xed6f, 0xf56f, 0xf56f, 0xf54f, 0xfd4f, 0xfd2f, 0xfd2e, 0xfd0e, 0xfcee, 0xfcee, 0xfcce, 0xfccd, 0xfccf, 0xfcae, 0xf48c, 0xfccd, 0xfd2e, 0xfd4f, 0xfd2f, 0xfd70, 0xfd6e, 0xfe13, 0xd5f7, 0x6cb7, 0x23b6, 0x0396, 0x0398, 0x0378, 0x0b97, 0x0377, 0x0357, 0x0378, 0x0398, 0x0377, 0x0335, 0x0396, 0x5cb5, 0xc6db, 0xdef8, 0xc611, 0xc48c, 0xa901, 0xd8a1, 0xe963, 0xf984, 0xf984, 0xf9a4, 0xf9a4, 0xf9c5, 0xf9c5, 0xf9e5, 0xf9c5, 0xf9c5, 0xf9a5, 0xf1c5, 0xf1e4, 0xe962, 0xc8a0, 0xaa25, 0xbd71, 0xe5f1, 0xf6f7, 0xd6da, 0x7559, 0x1bb7, 0x0337, 0x0378, 0x0378, 0x0377, 0x0377, 0x0377, 0x0357, 0x0398, 0x0397, 0x0376, 0x0b56, 0x6476, 0xc595, 0xfdd2, 0xfd91, 0xfd90, 0xfd2c, 0xfcec, 0xf52f, 0xfcce, 0xfcce, 0xfcce, 0xfccd, 0xfcce, 0xfcee, 0xfd0e, 0xfd0e, 0xfd2f, 0xfd4f, 0xfd6f, 0xfd6f, 0xf58f, 0xf5af, 0xf5af, 0xedaf, 0xdd8f, 0xe5b0, 0xdd70, 0xcd0e, 0xac8b, 0xacee, 0xf77c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xd615, 0xb46d, 0xbcac, 0xcd0d, 0xdd4f, 0xe54f, 0xed6f, 0xf56f, 0xf56f, 0xf54f, 0xfd4e, 0xfd2e, 0xfd2e, 0xfd0e, 0xfcee, 0xfccd, 0xfccd, 0xfccd, 0xfcae, 0xfcce, 0xf4ad, 0xf4cc, 0xfd2e, 0xfd4e, 0xfd4f, 0xfd70, 0xfdae, 0xed71, 0xf635, 0xfe96, 0xad33, 0x43b3, 0x1354, 0x1333, 0x0b76, 0x0356, 0x0398, 0x03b8, 0x0355, 0x0ad1, 0x43d2, 0x95f9, 0xdf3a, 0xffda, 0xdeb4, 0xb5d0, 0xbccf, 0xb9e7, 0xc881, 0xe961, 0xf964, 0xf984, 0xf9a5, 0xf9c5, 0xf9c5, 0xf9e6, 0xf9e6, 0xfa06, 0xf9e5, 0xf9c5, 0xf1c5, 0xf1c4, 0xe101, 0xc860, 0xb266, 0xbd71, 0xd613, 0xe654, 0xff78, 0xfffc, 0x9df8, 0x33d3, 0x1373, 0x1374, 0x0355, 0x0376, 0x0397, 0x03b8, 0x0355, 0x12d0, 0x4391, 0x8d56, 0xddd5, 0xfe34, 0xfd8f, 0xfd2e, 0xf54f, 0xed2f, 0xf50e, 0xfd0e, 0xfcce, 0xfcce, 0xfcce, 0xfccd, 0xfcce, 0xfcee, 0xfcee, 0xfd0e, 0xfd2f, 0xfd4f, 0xfd4f, 0xfd6f, 0xf58f, 0xf58f, 0xf5af, 0xf5af, 0xdd8f, 0xdd70, 0xd550, 0xc4ee, 0xacac, 0xc591, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7fe, 0xffff, 0xfffe, 0xffff, 0xefdf, 0xffff, 0xde57, 0xac2c, 0xbcac, 0xcced, 0xdd4e, 0xe54f, 0xed6f, 0xf56f, 0xfd6f, 0xf54f, 0xfd2e, 0xfd2e, 0xfd0e, 0xfd0e, 0xfcee, 0xfccd, 0xfccd, 0xfcad, 0xf48e, 0xfcef, 0xfd0e, 0xfd0d, 0xfd4e, 0xfd4e, 0xfd2e, 0xfd4f, 0xedd2, 0xfdf0, 0xfdce, 0xfdf0, 0xfe54, 0xe677, 0xa5b8, 0x64d9, 0x3c78, 0x2417, 0x13d8, 0x1c38, 0x555a, 0x9e3a, 0xd6b8, 0xffba, 0xffb8, 0xfed3, 0xd671, 0xbe93, 0xb511, 0xba4a, 0xc081, 0xe100, 0xe903, 0xf144, 0xf985, 0xf9c6, 0xf9e6, 0xf9e6, 0xf9e6, 0xf9e6, 0xf985, 0xf9c6, 0xe964, 0xe143, 0xe0c0, 0xd8c1, 0xcae9, 0xbd51, 0xbe55, 0xe6d5, 0xff13, 0xff96, 0xfffa, 0xcf9c, 0x967b, 0x5cf6, 0x3437, 0x2c38, 0x1bd7, 0x2418, 0x5519, 0x95b8, 0xce15, 0xee54, 0xfe32, 0xfd90, 0xfd4e, 0xfdae, 0xf570, 0xdd72, 0xfd71, 0xfcaa, 0xfcce, 0xfcce, 0xfcae, 0xfcce, 0xfcce, 0xfcee, 0xfcee, 0xfd0e, 0xfd2f, 0xfd4f, 0xfd6f, 0xfd6f, 0xf58f, 0xf58f, 0xf5af, 0xf5af, 0xdd8f, 0xd54f, 0xcd0f, 0xbcad, 0xb4cc, 0xd633, 0xfffe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffde, 0xe6b8, 0x8beb, 0xbc8c, 0xc4cd, 0xccee, 0xe56f, 0xedb0, 0xf58f, 0xf58f, 0xf54e, 0xfd4e, 0xfd4e, 0xfd2e, 0xfd0e, 0xfd0e, 0xfced, 0xfccd, 0xfccd, 0xfd0e, 0xfccd, 0xfd0e, 0xfd0e, 0xfd0e, 0xfd90, 0xee11, 0xd5f0, 0xe5d1, 0xfdd2, 0xfdf3, 0xfe13, 0xf673, 0xeeb4, 0xf6b4, 0xfe95, 0xfef6, 0xfef6, 0xf716, 0xff37, 0xff78, 0xff99, 0xffb9, 0xff99, 0xf7ba, 0xef38, 0xdeb6, 0xc632, 0xb58f, 0xb40b, 0xc1c5, 0xc800, 0xe123, 0xe143, 0xe964, 0xe9a4, 0xf9c5, 0xf9c5, 0xf9a5, 0xf9a5, 0xe9e3, 0xe9c3, 0xf1a4, 0xe103, 0xc081, 0xba06, 0xbc6d, 0xa5d0, 0xce54, 0xded6, 0xf758, 0xff98, 0xff99, 0xff99, 0xff78, 0xff58, 0xff17, 0xf6d6, 0xee95, 0xeed5, 0xfef5, 0xfe94, 0xfe33, 0xfe12, 0xfdd2, 0xfdb1, 0xf590, 0xf5b0, 0xf5b0, 0xf58f, 0xf52e, 0xf4ee, 0xed2d, 0xf4cd, 0xfcef, 0xfcce, 0xecad, 0xf52e, 0xf50f, 0xfcae, 0xfd4e, 0xfd4e, 0xfd4e, 0xf56f, 0xfd8f, 0xf5af, 0xed8f, 0xed6f, 0xe590, 0xdd4e, 0xcd2d, 0xbd0c, 0xa46c, 0xd635, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf71a, 0xa4cf, 0xb48c, 0xc4ed, 0xcd0e, 0xdd4f, 0xed6f, 0xed6f, 0xf58f, 0xf54e, 0xfd4e, 0xfd4e, 0xfd2e, 0xfd2e, 0xfd0e, 0xfcee, 0xfced, 0xfccd, 0xfced, 0xfccd, 0xf4ed, 0xfd4f, 0xfd2f, 0xfd0f, 0xfd70, 0xfd91, 0xfe12, 0xfe12, 0xfe12, 0xfe13, 0xfe33, 0xfe74, 0xfeb5, 0xfef5, 0xfef6, 0xff16, 0xff17, 0xff57, 0xff78, 0xff99, 0xff99, 0xff99, 0xf7b9, 0xf758, 0xe6b6, 0xce33, 0xb5b0, 0xb48d, 0xbac8, 0xc924, 0xe0a2, 0xe0e2, 0xe944, 0xf184, 0xf9a5, 0xf1c5, 0xf1c4, 0xf1c4, 0xfa05, 0xf163, 0xe8e2, 0xd0c2, 0xb964, 0xbb29, 0xbd0f, 0xbdf1, 0xd674, 0xe6f6, 0xf778, 0xff99, 0xff99, 0xff99, 0xff78, 0xff58, 0xff37, 0xff57, 0xff17, 0xfed5, 0xfe74, 0xfe54, 0xfe54, 0xfe53, 0xf632, 0xf612, 0xfdd1, 0xfdd1, 0xfdb1, 0xfd70, 0xfd50, 0xfd0f, 0xfd6f, 0xfcee, 0xfcad, 0xf4ad, 0xfcee, 0xfd2f, 0xfd0f, 0xfd30, 0xfd4e, 0xfd4e, 0xfd4e, 0xfd6f, 0xf58f, 0xf5b0, 0xed8f, 0xed6f, 0xe56f, 0xd52e, 0xd56e, 0xbd0d, 0xa46c, 0xde76, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7fe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xff9c, 0xc5d3, 0xb46b, 0xc4cd, 0xcd0e, 0xdd4f, 0xdd4e, 0xed4f, 0xf56f, 0xed4e, 0xf54f, 0xf54f, 0xfd4e, 0xfd2e, 0xfd0e, 0xfd0e, 0xfcee, 0xfcee, 0xf4ad, 0xfd2f, 0xfd4f, 0xfd0f, 0xfc2c, 0xf2e8, 0xfa67, 0xfa06, 0xf3ab, 0xfd50, 0xfe93, 0xf673, 0xf612, 0xfe34, 0xfeb5, 0xf6d5, 0xff16, 0xff17, 0xff37, 0xff58, 0xff78, 0xff78, 0xff99, 0xff99, 0xefb9, 0xf758, 0xeed6, 0xd674, 0xbe11, 0xb54f, 0xb40b, 0xbae8, 0xc8e1, 0xd0e2, 0xe0e2, 0xf103, 0xf924, 0xf964, 0xf984, 0xf984, 0xf123, 0xe081, 0xd061, 0xc143, 0xb2e8, 0xb48d, 0xc5b1, 0xce33, 0xdeb5, 0xef37, 0xff98, 0xff99, 0xff99, 0xff99, 0xff79, 0xff58, 0xff78, 0xff37, 0xfef6, 0xfeb6, 0xfe95, 0xfe74, 0xfe33, 0xfe12, 0xe672, 0xf632, 0xfd91, 0xfc2c, 0xeaa7, 0xe226, 0xfac8, 0xfbab, 0xfcae, 0xfd0f, 0xfd2e, 0xeced, 0xfd2e, 0xfd0f, 0xfcee, 0xfd50, 0xfd4f, 0xfd6f, 0xfd6f, 0xf58f, 0xf58f, 0xf590, 0xed8f, 0xe56f, 0xe56f, 0xcd0d, 0xcd4e, 0xac6b, 0x940b, 0xde97, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xd657, 0xac4b, 0xb4ac, 0xcd0e, 0xd52f, 0xdd2e, 0xe54f, 0xed8f, 0xed4f, 0xf56f, 0xf56f, 0xf54f, 0xf54e, 0xfd2e, 0xfd2e, 0xfd2e, 0xfd0e, 0xf54e, 0xfd90, 0xfc6d, 0xfaa7, 0xe163, 0xe080, 0xf041, 0xf800, 0xf020, 0xfa47, 0xfcee, 0xfe93, 0xf6f4, 0xf6b4, 0xfeb5, 0xfeb5, 0xff16, 0xff37, 0xff57, 0xff78, 0xff78, 0xff78, 0xff99, 0xffb9, 0xf7b9, 0xff99, 0xf738, 0xe6b5, 0xc673, 0xb5f1, 0xb52e, 0xac6c, 0xba85, 0xb9e4, 0xc122, 0xd8c1, 0xe8a2, 0xf8c3, 0xf8e3, 0xf0e3, 0xc0c1, 0xc102, 0xb9c4, 0xbb08, 0xbc8d, 0xbd6f, 0xc5f2, 0xd654, 0xe716, 0xf758, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xff79, 0xff58, 0xff58, 0xfef6, 0xfeb6, 0xfeb6, 0xfeb5, 0xfe74, 0xf673, 0xf673, 0xfe93, 0xfcad, 0xe266, 0xe0c2, 0xe820, 0xe800, 0xe020, 0xe8a1, 0xf246, 0xfc4c, 0xfdb0, 0xf56f, 0xf52e, 0xfd0f, 0xfcef, 0xf52f, 0xfd6f, 0xfd6f, 0xf56f, 0xf58f, 0xf5b0, 0xedb0, 0xe590, 0xe56f, 0xdd6f, 0xcd0d, 0xcd4e, 0x9c2b, 0xa48e, 0xef3a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xd699, 0xac6c, 0xac6b, 0xc4ee, 0xd54f, 0xd52e, 0xe56f, 0xed8f, 0xed6f, 0xf56f, 0xf56f, 0xf56f, 0xf54f, 0xf54f, 0xfd4f, 0xfd4f, 0xfd4f, 0xf5f0, 0xfcad, 0xfa47, 0xf061, 0xe800, 0xf000, 0xf820, 0xf820, 0xf800, 0xf000, 0xe984, 0xfcad, 0xfef4, 0xf755, 0xf6d5, 0xfeb5, 0xf716, 0xff37, 0xff57, 0xff78, 0xff98, 0xff99, 0xffb9, 0xffda, 0xf7b9, 0xffb9, 0xff79, 0xef17, 0xd6d5, 0xc673, 0xb5f1, 0xad4f, 0xb4ac, 0xb3ea, 0xaac6, 0xb1e4, 0xb984, 0xc163, 0xc163, 0xb942, 0xba66, 0xb328, 0xac2b, 0xb50e, 0xbdb1, 0xc5d1, 0xce13, 0xded6, 0xef57, 0xf798, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xff99, 0xff58, 0xfed6, 0xff17, 0xff17, 0xfed5, 0xf694, 0xf6b4, 0xfed4, 0xfef5, 0xfc4e, 0xf226, 0xe000, 0xf000, 0xf801, 0xf821, 0xf800, 0xe800, 0xd020, 0xea46, 0xfcad, 0xfdb0, 0xfd4f, 0xfd4f, 0xfd70, 0xf54f, 0xfd8f, 0xfd8f, 0xf58f, 0xf5b0, 0xf5b0, 0xedb0, 0xe58f, 0xe56f, 0xd54e, 0xcd0e, 0xc52f, 0xa48d, 0xcdd3, 0xfffe, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xdedb, 0xb4ce, 0xa44b, 0xbccd, 0xd52f, 0xd52f, 0xe56f, 0xed90, 0xed6f, 0xed8f, 0xf58f, 0xf58f, 0xf58f, 0xf56f, 0xfd70, 0xfd70, 0xfd70, 0xfdf1, 0xe2e8, 0xe861, 0xf800, 0xf841, 0xf820, 0xf800, 0xf000, 0xf840, 0xf800, 0xf800, 0xf964, 0xfc2d, 0xfe74, 0xff57, 0xff16, 0xff17, 0xff37, 0xff57, 0xff78, 0xff98, 0xffb9, 0xffd9, 0xffda, 0xffb9, 0xffda, 0xffb9, 0xf758, 0xe717, 0xd6d5, 0xc654, 0xb5f2, 0xb5b0, 0xb54f, 0xb4ee, 0xb46c, 0xac4b, 0xac4b, 0xac6b, 0xac8c, 0xb44c, 0xb50e, 0xa58f, 0xadd0, 0xc612, 0xd633, 0xe6b5, 0xef78, 0xf778, 0xffb9, 0xffb9, 0xffb9, 0xff99, 0xffb9, 0xff99, 0xff78, 0xff17, 0xff58, 0xf737, 0xeef5, 0xff16, 0xff37, 0xfe54, 0xf4ef, 0xf923, 0xf061, 0xf800, 0xf821, 0xf821, 0xf800, 0xf800, 0xf861, 0xe800, 0xd880, 0xe2a7, 0xfd0e, 0xfdb0, 0xfd70, 0xfd90, 0xfd50, 0xfd90, 0xfd90, 0xf590, 0xf5b0, 0xedb0, 0xedb0, 0xe590, 0xdd6f, 0xd54e, 0xc50d, 0xb4ad, 0x9c4d, 0xd656, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7e, 0xcd90, 0xac6c, 0xb48c, 0xcd2f, 0xd52f, 0xdd4f, 0xe56f, 0xed90, 0xedb0, 0xf5b0, 0xf590, 0xf590, 0xf590, 0xfd90, 0xfd90, 0xfd90, 0xfd10, 0xd943, 0xe800, 0xf800, 0xf800, 0xf820, 0xf000, 0xf800, 0xe800, 0xf820, 0xf800, 0xf000, 0xf0e3, 0xfb8c, 0xfdf4, 0xfef6, 0xff37, 0xff57, 0xff57, 0xff78, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xff99, 0xffb9, 0xffba, 0xff99, 0xf758, 0xef17, 0xe6b6, 0xd655, 0xc613, 0xbdf2, 0xbdd2, 0xb591, 0xad70, 0xa56f, 0xa56f, 0xa58f, 0xb590, 0xbdd1, 0xbdf1, 0xbdf2, 0xd674, 0xe6f6, 0xef58, 0xf799, 0xff99, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xffb9, 0xff99, 0xff78, 0xff79, 0xff57, 0xef36, 0xf736, 0xff17, 0xfdf4, 0xfb8c, 0xe965, 0xf801, 0xf800, 0xf000, 0xf800, 0xf800, 0xf800, 0xf000, 0xe800, 0xf821, 0xe800, 0xd902, 0xfc0b, 0xfdd1, 0xedd0, 0xf590, 0xfd70, 0xfdb0, 0xfdb0, 0xf5b0, 0xf5b0, 0xedd0, 0xedb0, 0xe590, 0xdd6f, 0xcd4e, 0xbced, 0xac6c, 0xa48e, 0xde98, 0xffbe, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xde13, 0xac8c, 0xac6c, 0xc50e, 0xd52f, 0xdd4f, 0xe56f, 0xed90, 0xedb0, 0xedb0, 0xf5b0, 0xf5b0, 0xfdb0, 0xfdb0, 0xfdb0, 0xfdb1, 0xfbac, 0xd861, 0xf000, 0xf821, 0xf800, 0xe840, 0xf040, 0xf820, 0xf840, 0xf000, 0xf800, 0xf800, 0xf000, 0xe022, 0xeaea, 0xfdd4, 0xff78, 0xff57, 0xff78, 0xff78, 0xffb9, 0xffb9, 0xffb9, 0xf799, 0xff99, 0xffb9, 0xffba, 0xff99, 0xff79, 0xff59, 0xff18, 0xf6b7, 0xde96, 0xd675, 0xce34, 0xc5f3, 0xc5d3, 0xcdd3, 0xcdb2, 0xd5b2, 0xc652, 0xd653, 0xe634, 0xe655, 0xef17, 0xef99, 0xf799, 0xf758, 0xffb9, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xffb9, 0xff99, 0xff78, 0xff78, 0xef57, 0xf7b8, 0xffd8, 0xfe34, 0xf30a, 0xe863, 0xf001, 0xf800, 0xf800, 0xf800, 0xf000, 0xf000, 0xf040, 0xf840, 0xf820, 0xf801, 0xf000, 0xe040, 0xf329, 0xfdd1, 0xee11, 0xf5b0, 0xfdb1, 0xfdb0, 0xfdb0, 0xf5b0, 0xf5b0, 0xedd1, 0xe5b0, 0xdd90, 0xdd6f, 0xc50d, 0xbced, 0xb4ce, 0xcdb3, 0xffbc, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xd676, 0xa48e, 0xa44c, 0xc4ee, 0xcd0e, 0xdd4e, 0xdd8f, 0xe5b0, 0xe5b0, 0xedd0, 0xedd1, 0xf5f1, 0xf5f1, 0xf5f1, 0xfdf1, 0xfe12, 0xfb4b, 0xc820, 0xf000, 0xf800, 0xf800, 0xf000, 0xf840, 0xf800, 0xe880, 0xe840, 0xf020, 0xf820, 0xf841, 0xf000, 0xf840, 0xf0a1, 0xeced, 0xfe53, 0xffb7, 0xfff9, 0xf7d9, 0xf7db, 0xffbc, 0xff9c, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffba, 0xff99, 0xff79, 0xf779, 0xe737, 0xe717, 0xdef6, 0xd6b5, 0xd695, 0xd695, 0xdeb5, 0xdeb6, 0xe674, 0xe6b5, 0xeef6, 0xf737, 0xff78, 0xff78, 0xff78, 0xff78, 0xff99, 0xffb9, 0xffba, 0xff99, 0xff79, 0xff7a, 0xff7a, 0xff9b, 0xefb8, 0xfff9, 0xff36, 0xfc6d, 0xe943, 0xf000, 0xf800, 0xf800, 0xf820, 0xf820, 0xf000, 0xf840, 0xf840, 0xf000, 0xf800, 0xf800, 0xf000, 0xf800, 0xe820, 0xdaa7, 0xfe53, 0xedf0, 0xfdd0, 0xfdd0, 0xf5f1, 0xf5f1, 0xedf1, 0xedd1, 0xe5d1, 0xe5b0, 0xd58f, 0xd54f, 0xcd4c, 0xb4ab, 0xa48d, 0xce16, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9b, 0xc5b3, 0xac8e, 0xbccd, 0xcd0e, 0xd52e, 0xd56e, 0xe5b0, 0xe5b0, 0xedd1, 0xedf1, 0xf5f1, 0xf5f1, 0xf5f1, 0xfe12, 0xfe12, 0xfbcd, 0xc040, 0xf000, 0xf820, 0xf800, 0xf000, 0xf820, 0xf800, 0xf000, 0xf800, 0xf820, 0xf000, 0xf800, 0xf800, 0xf840, 0xe800, 0xe800, 0xf9e6, 0xfcef, 0xff16, 0xf7f9, 0xeffa, 0xf7da, 0xf75a, 0xff79, 0xff79, 0xff99, 0xff99, 0xff79, 0xff99, 0xf799, 0xf799, 0xff58, 0xff58, 0xff37, 0xff37, 0xf737, 0xf717, 0xf6f6, 0xf6f6, 0xff79, 0xff59, 0xf758, 0xff38, 0xff58, 0xff79, 0xff9a, 0xffbb, 0xffba, 0xffb9, 0xf799, 0xf7b9, 0xf7fa, 0xf7fa, 0xefd9, 0xefd9, 0xff78, 0xfd10, 0xea67, 0xf081, 0xf000, 0xf800, 0xf820, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf000, 0xf000, 0xf820, 0xf800, 0xf800, 0xf820, 0xe020, 0xe309, 0xfe53, 0xee11, 0xfdf1, 0xfdd0, 0xf611, 0xf5f1, 0xedf1, 0xedf1, 0xe5d1, 0xddb0, 0xd590, 0xcd4f, 0xc52c, 0xac8c, 0xb4ef, 0xdeb8, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xd676, 0xac8e, 0xac4c, 0xc50e, 0xd52e, 0xd56f, 0xe5d0, 0xe5d0, 0xedf1, 0xee11, 0xf612, 0xf612, 0xf612, 0xf612, 0xfe32, 0xfc8f, 0xc0a1, 0xf000, 0xf841, 0xf800, 0xf000, 0xf800, 0xf800, 0xf800, 0xf000, 0xf800, 0xf801, 0xf821, 0xf800, 0xf800, 0xf840, 0xf821, 0xf000, 0xe020, 0xea07, 0xfcd0, 0xff17, 0xfffa, 0xfffa, 0xe7b8, 0xefd9, 0xf7f9, 0xffda, 0xffba, 0xff79, 0xff79, 0xff7a, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff78, 0xf7ba, 0xf7da, 0xf7da, 0xf7fb, 0xf7fa, 0xf7da, 0xefda, 0xefba, 0xefb9, 0xefb9, 0xefd9, 0xf7f9, 0xfffa, 0xffb8, 0xfed5, 0xfe13, 0xe267, 0xe903, 0xf800, 0xf800, 0xf800, 0xf820, 0xf820, 0xf800, 0xf021, 0xf800, 0xf821, 0xf841, 0xf800, 0xf020, 0xf040, 0xf000, 0xf800, 0xf821, 0xd020, 0xf3ec, 0xfe73, 0xf632, 0xfe32, 0xf5f1, 0xf632, 0xf612, 0xee11, 0xedf1, 0xe5f1, 0xddb0, 0xd56f, 0xcd4f, 0xbcec, 0xacad, 0xc5b3, 0xf77c, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdd, 0xe6f9, 0xacd0, 0x9c0b, 0xbcee, 0xcd4e, 0xd56f, 0xddb0, 0xe5d0, 0xe5f1, 0xee12, 0xf632, 0xf632, 0xf632, 0xf632, 0xfe53, 0xfd92, 0xb922, 0xe000, 0xf821, 0xf800, 0xf800, 0xf800, 0xf800, 0xf821, 0xc800, 0xb020, 0xb800, 0xe801, 0xf800, 0xf800, 0xf800, 0xf020, 0xf800, 0xf800, 0xf800, 0xf822, 0xe9a6, 0xf40d, 0xfe13, 0xfff9, 0xfff9, 0xfffa, 0xfff9, 0xf7d9, 0xf7b9, 0xf7d9, 0xfffa, 0xffda, 0xffda, 0xffda, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffd9, 0xff5a, 0xff5a, 0xff7a, 0xff7a, 0xff9a, 0xffba, 0xffdb, 0xfffb, 0xffda, 0xfffa, 0xfffa, 0xfff8, 0xfeb5, 0xfc6e, 0xf9c6, 0xf000, 0xf000, 0xf800, 0xf800, 0xf820, 0xf820, 0xf040, 0xe820, 0xe000, 0xa040, 0xd040, 0xe800, 0xf800, 0xf820, 0xe800, 0xf040, 0xf800, 0xf800, 0xf821, 0xc860, 0xfcef, 0xfe74, 0xf633, 0xfe52, 0xee31, 0xf632, 0xee32, 0xee12, 0xe5f1, 0xddf1, 0xd5b0, 0xcd6f, 0xc52e, 0xac8c, 0xb50f, 0xde77, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bd, 0xc594, 0xa44d, 0xb48d, 0xc50e, 0xcd4e, 0xcd4e, 0xddd0, 0xe5f1, 0xee32, 0xee32, 0xf653, 0xf653, 0xf653, 0xf653, 0xfe54, 0xc246, 0xc800, 0xf800, 0xf800, 0xf820, 0xf800, 0xf800, 0xd820, 0xca05, 0xbbaa, 0x91a4, 0xa800, 0xf000, 0xf821, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf000, 0xf020, 0xf862, 0xea89, 0xfbac, 0xfd52, 0xfeb7, 0xffb9, 0xfff9, 0xf7f9, 0xeff8, 0xffbb, 0xffba, 0xffba, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xefb9, 0xf7b9, 0xf7d9, 0xfffa, 0xffda, 0xffda, 0xffba, 0xffba, 0xff98, 0xfe34, 0xfbed, 0xf9c7, 0xf863, 0xf801, 0xf800, 0xf000, 0xf881, 0xf820, 0xf800, 0xf040, 0xe860, 0xd020, 0xb800, 0xa040, 0xab69, 0xd2c8, 0xd000, 0xf000, 0xf860, 0xe800, 0xf820, 0xf800, 0xf000, 0xe000, 0xc143, 0xfdd2, 0xf6b4, 0xf653, 0xfe53, 0xee72, 0xf652, 0xee32, 0xe612, 0xddf1, 0xddd1, 0xcd90, 0xc54f, 0xbd0e, 0xa48d, 0xbd92, 0xef3b, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdeb8, 0xacd0, 0xa46c, 0xbced, 0xc54f, 0xcd8f, 0xd5d0, 0xddf1, 0xe632, 0xee53, 0xee53, 0xf673, 0xf673, 0xf694, 0xf6d5, 0xdbeb, 0xc060, 0xe800, 0xf800, 0xf820, 0xf820, 0xf800, 0xd800, 0xe38a, 0xff78, 0xcdf3, 0xa1e7, 0xb000, 0xc800, 0xe061, 0xf821, 0xf800, 0xf800, 0xf820, 0xf821, 0xf800, 0xf800, 0xf800, 0xf801, 0xf821, 0xf0a3, 0xf165, 0xf288, 0xfbed, 0xfd51, 0xfe14, 0xef37, 0xf758, 0xf7b9, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xf7fa, 0xfff9, 0xfff8, 0xffb8, 0xff17, 0xfe34, 0xfd31, 0xfc4e, 0xf3cd, 0xe924, 0xf0e3, 0xf862, 0xf801, 0xf800, 0xf800, 0xf800, 0xf820, 0xf800, 0xf000, 0xf040, 0xf060, 0xd000, 0xa800, 0xa1a5, 0xbc2e, 0xf798, 0xfd52, 0xe0e3, 0xf800, 0xf861, 0xe800, 0xf800, 0xf000, 0xe000, 0xc820, 0xd308, 0xfe94, 0xeed5, 0xf654, 0xf673, 0xeeb3, 0xee52, 0xee32, 0xe612, 0xddf1, 0xcdd0, 0xc56f, 0xbd2e, 0xb4ed, 0xacf0, 0xd656, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77c, 0xcdd4, 0xa46d, 0xacad, 0xc56f, 0xcd8f, 0xcdb0, 0xd5d1, 0xde12, 0xee53, 0xee73, 0xf673, 0xf694, 0xf694, 0xe715, 0xfd91, 0xc102, 0xd800, 0xf020, 0xe800, 0xf020, 0xf800, 0xf801, 0xe227, 0xfeb7, 0xf7db, 0xcdd5, 0xaacb, 0x98a2, 0xa040, 0xe020, 0xe800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf840, 0xf800, 0xf800, 0xf800, 0xf800, 0xf000, 0xf000, 0xe800, 0xe820, 0xe965, 0xe9a5, 0xf207, 0xfa68, 0xfaa9, 0xfac9, 0xfac9, 0xfac9, 0xfa87, 0xf226, 0xf1a5, 0xf123, 0xf082, 0xf821, 0xf801, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf000, 0xf000, 0xe800, 0xf040, 0xd800, 0xb800, 0xa020, 0x99e6, 0xc4f2, 0xfffd, 0xff79, 0xebee, 0xe842, 0xf000, 0xf820, 0xf020, 0xe820, 0xf000, 0xd000, 0xb080, 0xecee, 0xef15, 0xe6f5, 0xfe95, 0xfe74, 0xe6b3, 0xee52, 0xe632, 0xde11, 0xd5f1, 0xcdb0, 0xbd4f, 0xb50e, 0xa4cd, 0xc5d4, 0xef1a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xe697, 0xa48d, 0xa46c, 0xbd0e, 0xbd4e, 0xcd8f, 0xd5d0, 0xde12, 0xe653, 0xee73, 0xf694, 0xf6b4, 0xf6b4, 0xdf55, 0xfeb5, 0xc9a4, 0xd800, 0xe820, 0xe000, 0xf020, 0xf821, 0xf800, 0xf0c4, 0xf4d2, 0xdef9, 0xdffd, 0xe73a, 0xc3ee, 0x90e3, 0xb000, 0xc800, 0xe821, 0xf821, 0xf800, 0xf800, 0xf800, 0xf820, 0xf820, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf820, 0xf820, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf820, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf860, 0xf020, 0xf000, 0xf000, 0xf820, 0xf841, 0xf820, 0xf000, 0xf000, 0xe800, 0xb800, 0x9860, 0xbb8b, 0xeed8, 0xef7c, 0xd6ba, 0xee15, 0xc9e7, 0xf802, 0xf800, 0xf800, 0xf060, 0xd820, 0xd800, 0xc820, 0xa8c0, 0xfe13, 0xef76, 0xdef5, 0xfeb5, 0xfe94, 0xde93, 0xe652, 0xe632, 0xde11, 0xd5d1, 0xc590, 0xbd4f, 0xaced, 0xa4ac, 0xd677, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffbd, 0xce36, 0x9c8d, 0x9cac, 0xb54d, 0xb54f, 0xc5d1, 0xcdf1, 0xde73, 0xe693, 0xe693, 0xeed4, 0xf6f5, 0xe6d4, 0xff97, 0xcc6d, 0x98a0, 0xc800, 0xf800, 0xf800, 0xf840, 0xf820, 0xf000, 0xf228, 0xfdf5, 0xe75a, 0xdef9, 0xef19, 0xe6b8, 0x9289, 0x88c3, 0xa000, 0xd000, 0xe020, 0xe820, 0xf020, 0xf000, 0xf800, 0xf800, 0xf820, 0xf820, 0xf000, 0xf000, 0xf020, 0xf020, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf820, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf820, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf000, 0xe800, 0xb801, 0x9000, 0x9227, 0xc5b4, 0xff3b, 0xfebb, 0xeeda, 0xcf7a, 0xfaa8, 0xe020, 0xf800, 0xf820, 0xf800, 0xf060, 0xd800, 0xd800, 0x8000, 0xdc6e, 0xf6b5, 0xef15, 0xf6f6, 0xf694, 0xeed5, 0xded4, 0xe673, 0xde73, 0xc5d0, 0xbd8f, 0xbdb0, 0xa50e, 0xa4ef, 0xce34, 0xe71c, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xdeb8, 0xad10, 0xa4cd, 0xad0d, 0xb54f, 0xc5d1, 0xcdf1, 0xd632, 0xe693, 0xe693, 0xeed4, 0xeed4, 0xf735, 0xf735, 0xfe54, 0xaa25, 0xa800, 0xf041, 0xf000, 0xf000, 0xf820, 0xf000, 0xe882, 0xfb8d, 0xfe97, 0xdf7a, 0xdf3a, 0xf6da, 0xffbc, 0xccf1, 0x9a27, 0x88a1, 0x9800, 0xb800, 0xe000, 0xf801, 0xf000, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf820, 0xf820, 0xf020, 0xf000, 0xf800, 0xf800, 0xf800, 0xf820, 0xf000, 0xf000, 0xf800, 0xf820, 0xf820, 0xf820, 0xf800, 0xf800, 0xf841, 0xf800, 0xf800, 0xf021, 0xe842, 0xc821, 0xa800, 0x9800, 0x91e6, 0xbc8f, 0xeed9, 0xef1a, 0xdefa, 0xe75a, 0xf6b8, 0xfcf3, 0xe8e2, 0xf040, 0xf000, 0xf800, 0xf800, 0xe800, 0xe041, 0xc800, 0x9963, 0xf592, 0xff36, 0xe6f5, 0xeeb5, 0xf6b5, 0xeed5, 0xd6b3, 0xd612, 0xd611, 0xc5af, 0xbd8f, 0xb58f, 0xa4ce, 0xa50f, 0xce55, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77b, 0xc5f4, 0xad2f, 0x9ccc, 0xb52f, 0xc5b0, 0xc5b0, 0xcdf1, 0xde73, 0xe693, 0xeeb4, 0xeed4, 0xf755, 0xef14, 0xffb8, 0xd48d, 0x9080, 0xc000, 0xe800, 0xf800, 0xe820, 0xf820, 0xf800, 0xf8e4, 0xfc2f, 0xe718, 0xe7bb, 0xf6db, 0xe75a, 0xf77b, 0xf73a, 0xd5b3, 0x9ae9, 0x80c1, 0x9800, 0xb800, 0xc800, 0xd000, 0xe001, 0xf021, 0xf821, 0xf820, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xe800, 0xe800, 0xe021, 0xc000, 0x9000, 0x8040, 0x9a47, 0xcc2e, 0xd656, 0xf79c, 0xfffe, 0xdf3b, 0xd77b, 0xf7db, 0xfd52, 0xf145, 0xe800, 0xf841, 0xf800, 0xf000, 0xf800, 0xe800, 0xc800, 0xa800, 0xcc0c, 0xfeb5, 0xff77, 0xe6f5, 0xeed5, 0xf694, 0xeed4, 0xd693, 0xd632, 0xd612, 0xc5d0, 0xbd8f, 0xad2e, 0xa4ef, 0xbdd3, 0xef5a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xe6f9, 0xbdd3, 0x948d, 0xa4ed, 0xb570, 0xc5b0, 0xc5d1, 0xd632, 0xde73, 0xe693, 0xeed4, 0xeef4, 0xef35, 0xef76, 0xf6d5, 0xb328, 0x8800, 0xc800, 0xf041, 0xe020, 0xf800, 0xf820, 0xf820, 0xe964, 0xe4d0, 0xff5b, 0xf75c, 0xff5c, 0xf73b, 0xef5b, 0xf79c, 0xf77b, 0xe637, 0xb3ad, 0x8985, 0x9041, 0x9020, 0xa000, 0xb800, 0xd020, 0xe020, 0xf000, 0xf000, 0xf000, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf801, 0xf020, 0xe000, 0xd800, 0xd000, 0xb861, 0xa000, 0x8800, 0x9103, 0xb30b, 0xd533, 0xeef9, 0xffdd, 0xfffe, 0xff1d, 0xeefc, 0xdf7c, 0xe75a, 0xfd73, 0xfa68, 0xe000, 0xf801, 0xf800, 0xf841, 0xf000, 0xf821, 0xe821, 0xa000, 0xb164, 0xf674, 0xff57, 0xe735, 0xe715, 0xf716, 0xee94, 0xde93, 0xce73, 0xc5d1, 0xcdd1, 0xbd90, 0xad0e, 0x9cad, 0xa510, 0xd677, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bc, 0xd677, 0x9cf0, 0x9cad, 0xad2e, 0xbd90, 0xc5d1, 0xce12, 0xd632, 0xde73, 0xe6d4, 0xe6b3, 0xef55, 0xdf15, 0xf7b8, 0xddf2, 0x8962, 0x9000, 0xc800, 0xe041, 0xf000, 0xf800, 0xf820, 0xf000, 0xe9a7, 0xfcf2, 0xff5b, 0xef3a, 0xf7bc, 0xf7dd, 0xef9d, 0xef7d, 0xf77c, 0xef5b, 0xe719, 0xdd53, 0xbc0e, 0x9a67, 0x78e2, 0x7820, 0x8800, 0xa020, 0xb040, 0xd000, 0xd000, 0xd000, 0xd001, 0xd801, 0xd821, 0xd821, 0xe021, 0xe001, 0xd800, 0xc000, 0xb000, 0xa000, 0x9000, 0x8820, 0x8840, 0x81e5, 0xab4b, 0xd512, 0xf698, 0xff5b, 0xffbd, 0xefdd, 0xe7bd, 0xf6fb, 0xeefb, 0xef7c, 0xef9c, 0xf574, 0xf208, 0xf020, 0xf840, 0xf821, 0xf000, 0xf820, 0xe800, 0xe800, 0xc000, 0xa0e2, 0xe48f, 0xff77, 0xf777, 0xdef5, 0xe715, 0xf6f5, 0xe694, 0xde53, 0xce52, 0xc590, 0xc5b0, 0xb56f, 0xa4ee, 0xa50f, 0xc5f4, 0xef3b, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe73b, 0xb5d4, 0xa50e, 0xa4ee, 0xb54f, 0xbdb0, 0xc5d1, 0xcdf1, 0xd632, 0xe6b4, 0xe6d3, 0xef15, 0xef36, 0xef77, 0xf757, 0xc46d, 0x8080, 0x9800, 0xc800, 0xe801, 0xf800, 0xf800, 0xf800, 0xf801, 0xe1a7, 0xe4b0, 0xef58, 0xefba, 0xef9c, 0xe75c, 0xf77e, 0xff9e, 0xf79d, 0xef7c, 0xf7dc, 0xf79b, 0xf71a, 0xee77, 0xdd94, 0xc44f, 0xa2e9, 0x8a06, 0x9103, 0x88e2, 0x80a1, 0x7840, 0x7820, 0x7820, 0x7840, 0x8040, 0x8881, 0x88a2, 0x8923, 0x91e6, 0xa309, 0xbc4e, 0xd572, 0xde14, 0xef3a, 0xf77b, 0xef9b, 0xe79b, 0xe79c, 0xefbd, 0xef9c, 0xe73b, 0xff5c, 0xe7fd, 0xdf9a, 0xed32, 0xfa6a, 0xf8a3, 0xf800, 0xf800, 0xf800, 0xf800, 0xf000, 0xe020, 0xc000, 0x9840, 0xc36a, 0xff18, 0xef56, 0xef56, 0xe715, 0xe6d4, 0xde94, 0xde73, 0xd653, 0xc5f1, 0xc5d1, 0xbd90, 0xad0e, 0xad0f, 0xc5f3, 0xe73a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xdefa, 0xbdd1, 0x9ccd, 0xa4ee, 0xb56f, 0xbd90, 0xc5d0, 0xcdf1, 0xd653, 0xe6b3, 0xeeb4, 0xeef6, 0xe716, 0xef78, 0xeeb5, 0xbb8a, 0x8880, 0xb000, 0xd861, 0xe840, 0xf000, 0xf800, 0xf800, 0xe000, 0xe923, 0xec4e, 0xfdf4, 0xff3a, 0xf77d, 0xf77e, 0xff5d, 0xff5d, 0xff9d, 0xef9c, 0xef7c, 0xef7c, 0xf77c, 0xff9c, 0xff7c, 0xff5c, 0xf73b, 0xee98, 0xee77, 0xe616, 0xddd5, 0xd594, 0xd594, 0xd594, 0xd594, 0xe617, 0xe657, 0xeeb8, 0xeefa, 0xf75b, 0xef7c, 0xef7c, 0xef7c, 0xe75c, 0xf7bd, 0xf7fe, 0xefdd, 0xefbc, 0xf79c, 0xff9c, 0xff7c, 0xff7a, 0xf718, 0xecd0, 0xe9c6, 0xf021, 0xf800, 0xf800, 0xf800, 0xf000, 0xf800, 0xf000, 0xd000, 0xa880, 0xb2c7, 0xedf3, 0xff99, 0xeef5, 0xeef5, 0xeef5, 0xe6b4, 0xd652, 0xd632, 0xce32, 0xbdb0, 0xbd90, 0xad0e, 0x9cad, 0xad30, 0xd676, 0xf79c, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xd674, 0x9ccd, 0x9cac, 0xad2f, 0xb570, 0xc5b0, 0xc5f1, 0xce12, 0xde72, 0xee93, 0xe633, 0xef16, 0xe716, 0xff78, 0xfe96, 0x99e4, 0xb000, 0xb000, 0xd000, 0xf800, 0xf800, 0xf820, 0xf800, 0xf840, 0xe862, 0xfaec, 0xfd75, 0xef1b, 0xef9e, 0xf77d, 0xff5c, 0xffbd, 0xffde, 0xffbe, 0xff9e, 0xf79e, 0xf79e, 0xf7be, 0xef9e, 0xef9e, 0xef7c, 0xef9c, 0xf79c, 0xf79c, 0xf79d, 0xf79c, 0xf77c, 0xf77c, 0xef9d, 0xef9d, 0xef9d, 0xf79d, 0xf79e, 0xff9e, 0xff9f, 0xffbf, 0xff7e, 0xff7e, 0xffbe, 0xf7bd, 0xf7bd, 0xff9c, 0xff5b, 0xff1a, 0xde35, 0xfb8d, 0xf8c4, 0xf800, 0xf840, 0xf800, 0xf800, 0xf801, 0xe840, 0xe800, 0xf000, 0xc000, 0xa942, 0xf5f3, 0xffb9, 0xe738, 0xf716, 0xe694, 0xe694, 0xe6d4, 0xd653, 0xc5f1, 0xc5d0, 0xbd90, 0xb54f, 0xad0e, 0xad0e, 0xc5f3, 0xef5a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7c, 0xce36, 0xa510, 0x9ccd, 0xad2e, 0xbd6f, 0xc5b1, 0xcdf2, 0xce12, 0xd653, 0xde94, 0xe6d5, 0xeef5, 0xef15, 0xef16, 0xf736, 0x8162, 0x88a0, 0xb000, 0xd800, 0xf000, 0xf000, 0xf800, 0xf020, 0xf840, 0xf0a0, 0xe984, 0xf3ab, 0xfe15, 0xff7a, 0xdfdb, 0xcffc, 0xff9e, 0xff9e, 0xff9e, 0xff9e, 0xff9e, 0xff9e, 0xff9e, 0xff9d, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79d, 0xf79d, 0xf77d, 0xf77d, 0xffbc, 0xffbc, 0xffbc, 0xffbd, 0xf7bd, 0xf7bd, 0xf7be, 0xf7de, 0xff9f, 0xf79f, 0xe77d, 0xdf7c, 0xef9b, 0xff3a, 0xf636, 0xed32, 0xf985, 0xf8a2, 0xf820, 0xf820, 0xf800, 0xf800, 0xf800, 0xf000, 0xf802, 0xd802, 0x9000, 0x89c3, 0xddb1, 0xff97, 0xef15, 0xf715, 0xdeb5, 0xdeb4, 0xde93, 0xd652, 0xcdf1, 0xc5b0, 0xc570, 0xbd30, 0xad0d, 0xad0f, 0xc5b4, 0xe6fb, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xdefa, 0xbdd4, 0xa50f, 0xa50e, 0xb54e, 0xbd90, 0xc590, 0xcdf1, 0xce12, 0xde73, 0xe6b4, 0xe6d4, 0xeef5, 0xef16, 0xf736, 0xfe14, 0x9a04, 0x8800, 0xc020, 0xd800, 0xe800, 0xf841, 0xf020, 0xf000, 0xf800, 0xf020, 0xe8a3, 0xf229, 0xfbef, 0xfdb5, 0xff3a, 0xdf7c, 0xe79c, 0xefbd, 0xf7de, 0xf7de, 0xffbe, 0xffbe, 0xff9f, 0xf7de, 0xf7de, 0xf7de, 0xf7de, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xf7de, 0xf7be, 0xf7be, 0xffbe, 0xff9e, 0xffbe, 0xff9e, 0xff9e, 0xef7c, 0xe79c, 0xefbc, 0xef9a, 0xfeb8, 0xfcf2, 0xfaab, 0xf0e6, 0xf861, 0xf000, 0xf000, 0xf800, 0xf800, 0xf000, 0xe800, 0xe020, 0xc801, 0xa000, 0xa984, 0xe530, 0xff36, 0xf756, 0xeef5, 0xeed4, 0xdeb4, 0xdeb3, 0xd672, 0xce31, 0xc5f0, 0xc5b0, 0xbd70, 0xb50f, 0xa4ac, 0xb550, 0xd677, 0xff9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbe, 0xe6f9, 0xb5b2, 0x9ccd, 0xa4ed, 0xb54f, 0xbd8f, 0xc5b0, 0xcdf1, 0xd632, 0xde73, 0xde94, 0xe6d4, 0xeef5, 0xef16, 0xff17, 0xe5b2, 0xa266, 0x7800, 0xa000, 0xd020, 0xe000, 0xe800, 0xf800, 0xf840, 0xf820, 0xf800, 0xf801, 0xf0e4, 0xfa48, 0xfb6c, 0xe657, 0xee98, 0xf71a, 0xff5c, 0xf79d, 0xef9d, 0xe79d, 0xe79d, 0xf79d, 0xf79d, 0xff9d, 0xff9d, 0xff9e, 0xff9e, 0xffbe, 0xffbe, 0xff9f, 0xf79f, 0xf79f, 0xf7be, 0xf7be, 0xf7bd, 0xef7c, 0xe75b, 0xf799, 0xf718, 0xf5f4, 0xf44f, 0xea69, 0xe8c4, 0xf801, 0xf801, 0xf000, 0xf820, 0xf821, 0xf800, 0xf000, 0xe821, 0xd041, 0xc020, 0x9020, 0xa9c5, 0xed30, 0xff78, 0xf756, 0xe714, 0xef15, 0xe693, 0xde93, 0xd672, 0xce31, 0xc5f0, 0xc5cf, 0xbd8f, 0xb52f, 0xa4ce, 0xa4ee, 0xce14, 0xf75b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffde, 0xd677, 0xa510, 0x946c, 0xa4ed, 0xbd8f, 0xbd8f, 0xc5b0, 0xcdf1, 0xd632, 0xd653, 0xde93, 0xe6d4, 0xeef5, 0xef16, 0xff78, 0xee74, 0xa328, 0x7060, 0x9800, 0xc841, 0xd800, 0xe800, 0xf000, 0xf800, 0xf800, 0xf800, 0xf820, 0xf841, 0xf861, 0xd9c7, 0xeaaa, 0xfc0f, 0xfd74, 0xfe57, 0xf6f9, 0xef5a, 0xe79b, 0xf77c, 0xf77c, 0xf77c, 0xf77c, 0xef7c, 0xef7c, 0xef5b, 0xe73b, 0xf77d, 0xf77d, 0xf77c, 0xff7c, 0xff7b, 0xf739, 0xe6b7, 0xde55, 0xfcaf, 0xfb8b, 0xea06, 0xf0e3, 0xf020, 0xf800, 0xf800, 0xf840, 0xf820, 0xf800, 0xf000, 0xf000, 0xe821, 0xc820, 0xa000, 0x9000, 0x9ac6, 0xedb1, 0xff98, 0xf736, 0xd6d3, 0xdef4, 0xe6d4, 0xde93, 0xd652, 0xce31, 0xc5f0, 0xc5ef, 0xbdaf, 0xb54e, 0xacee, 0xa4ef, 0xce35, 0xef1a, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf77c, 0xce15, 0xa4ef, 0x9cad, 0xa4ed, 0xbd6f, 0xbd90, 0xc5d0, 0xcdf1, 0xd632, 0xd653, 0xde93, 0xe6b4, 0xe736, 0xe736, 0xf7b8, 0xf6f6, 0xb3eb, 0x8101, 0x9000, 0xa800, 0xd000, 0xd800, 0xe000, 0xe800, 0xf000, 0xf800, 0xf800, 0xf800, 0xf800, 0xf840, 0xf8c2, 0xf184, 0xea68, 0xeb8c, 0xf4b0, 0xfd72, 0xee36, 0xee77, 0xf6b8, 0xfef8, 0xff19, 0xff19, 0xff19, 0xf719, 0xf6d8, 0xf676, 0xf5f4, 0xf532, 0xfc6f, 0xf38c, 0xeaa9, 0xe207, 0xf8c2, 0xf840, 0xf000, 0xf820, 0xf860, 0xf840, 0xf820, 0xf000, 0xf800, 0xe800, 0xe000, 0xd821, 0xa800, 0x8000, 0x88e1, 0xc30a, 0xe673, 0xff56, 0xef35, 0xd6b3, 0xdef4, 0xded4, 0xd652, 0xd672, 0xce11, 0xc5f0, 0xc5cf, 0xbdaf, 0xad2d, 0x9ccd, 0xad30, 0xc5d3, 0xef5b, 0xffde, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77c, 0xce36, 0xa4f0, 0x946d, 0xb52e, 0xb54f, 0xbd90, 0xc5d0, 0xcdf1, 0xce12, 0xd652, 0xde73, 0xd673, 0xdef5, 0xdf15, 0xef56, 0xff57, 0xd4ef, 0x91e4, 0x7880, 0x9820, 0xa800, 0xd000, 0xe801, 0xf000, 0xf000, 0xf000, 0xf040, 0xf820, 0xf820, 0xf820, 0xf840, 0xf840, 0xf061, 0xf0a2, 0xf8e3, 0xd9c6, 0xda07, 0xea49, 0xf2aa, 0xf2eb, 0xf30b, 0xf32b, 0xf30b, 0xeaa8, 0xea67, 0xe9c5, 0xf144, 0xf8e3, 0xf882, 0xf821, 0xf800, 0xf000, 0xf800, 0xf800, 0xf800, 0xf800, 0xf000, 0xe800, 0xe820, 0xc800, 0xc820, 0xb000, 0x8800, 0x7800, 0x91e4, 0xd4af, 0xfef7, 0xffb7, 0xe715, 0xded3, 0xded4, 0xded4, 0xde93, 0xd652, 0xce11, 0xcdd1, 0xc5b0, 0xbd8f, 0xad2e, 0x9ccd, 0xa4ef, 0xc615, 0xef3a, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf75c, 0xce16, 0xacf1, 0xa4cc, 0xaced, 0xb54e, 0xbd8f, 0xc5b0, 0xcdf1, 0xce11, 0xd632, 0xe693, 0xde52, 0xe6f4, 0xe715, 0xeef5, 0xffd8, 0xf6b5, 0x9b89, 0x7922, 0x7820, 0x9000, 0xb800, 0xd000, 0xd800, 0xe020, 0xe060, 0xf000, 0xf000, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf801, 0xf821, 0xf841, 0xf842, 0xf841, 0xf841, 0xf841, 0xf841, 0xf820, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xf800, 0xe060, 0xe820, 0xf000, 0xf000, 0xf800, 0xf021, 0xd020, 0xb800, 0xa041, 0x9020, 0x7820, 0x70e0, 0xa348, 0xee33, 0xff77, 0xf736, 0xe6f4, 0xde93, 0xe6d4, 0xeed4, 0xd632, 0xd632, 0xd672, 0xbdaf, 0xc591, 0xbd70, 0xb52f, 0xa4ee, 0xa510, 0xc5f4, 0xe71a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xef1b, 0xce36, 0x9c6b, 0xa4ac, 0xad0e, 0xbd6f, 0xbd90, 0xc5d0, 0xcdf1, 0xce11, 0xe611, 0xde12, 0xe673, 0xe6d4, 0xded4, 0xe6f4, 0xef76, 0xf7b7, 0xedb3, 0xab2a, 0x78e1, 0x8020, 0x9800, 0xb800, 0xc800, 0xd000, 0xf000, 0xf000, 0xf000, 0xf000, 0xf001, 0xf000, 0xf000, 0xf000, 0xf800, 0xf800, 0xf800, 0xf820, 0xf820, 0xf820, 0xf840, 0xf040, 0xf820, 0xf820, 0xf820, 0xf820, 0xf820, 0xf000, 0xf000, 0xf000, 0xf800, 0xf800, 0xf020, 0xe000, 0xd000, 0xc020, 0xb000, 0xa000, 0x7800, 0x7860, 0xa2a7, 0xedb2, 0xff77, 0xf776, 0xdf14, 0xd6f4, 0xe6b4, 0xde53, 0xe653, 0xe653, 0xde12, 0xcdd1, 0xc5d0, 0xbdd0, 0xbd51, 0xb530, 0xa4ae, 0xa4ce, 0xbdb3, 0xe71a, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xce37, 0x9c6f, 0x946d, 0xad0e, 0xb54e, 0xc5b0, 0xc5d1, 0xc5b1, 0xc5b0, 0xd632, 0xde52, 0xd632, 0xe694, 0xeeb5, 0xeeb5, 0xeef6, 0xe776, 0xef36, 0xddd1, 0xab69, 0x8121, 0x7800, 0x9000, 0x9800, 0xb800, 0xc000, 0xc800, 0xd000, 0xd800, 0xe001, 0xe001, 0xe801, 0xf020, 0xf020, 0xf000, 0xf000, 0xf000, 0xf000, 0xf800, 0xf800, 0xf821, 0xf001, 0xf000, 0xe800, 0xe800, 0xe820, 0xe020, 0xe000, 0xe002, 0xd801, 0xc801, 0xb021, 0x9820, 0x7800, 0x7060, 0x7901, 0x8bc9, 0xc590, 0xf716, 0xff56, 0xeef5, 0xeed5, 0xe6b4, 0xde73, 0xde93, 0xd652, 0xde73, 0xd632, 0xcdf2, 0xcdf2, 0xc590, 0xc570, 0xb52d, 0x9c8b, 0xa4ce, 0xc615, 0xe71b, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9d, 0xd678, 0xc5f4, 0xad2f, 0x9cad, 0xb52e, 0xbd90, 0xc5b1, 0xc5af, 0xd611, 0xd652, 0xd632, 0xde73, 0xde93, 0xde73, 0xe6b4, 0xdeb4, 0xf756, 0xff78, 0xfed6, 0xed92, 0xcbec, 0x9a05, 0x7080, 0x9040, 0x9000, 0x9800, 0xa800, 0xb800, 0xc800, 0xd000, 0xd000, 0xd800, 0xd800, 0xd800, 0xe000, 0xe000, 0xe000, 0xe000, 0xe000, 0xe000, 0xe000, 0xd800, 0xd800, 0xd000, 0xc800, 0xc000, 0xc000, 0xb000, 0xa000, 0x9000, 0x7800, 0x7860, 0x89a3, 0xbbcb, 0xed71, 0xe6d5, 0xf757, 0xff77, 0xeef5, 0xe694, 0xe6b4, 0xe6d5, 0xe6b4, 0xde93, 0xce31, 0xce11, 0xcdf1, 0xcdf1, 0xc5b1, 0xb50e, 0xaccd, 0x944b, 0xa4ee, 0xce15, 0xef3b, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0xe71a, 0xc5d3, 0xa4ee, 0xa4ed, 0xad2e, 0xc5f1, 0xbd8f, 0xc5d0, 0xce11, 0xce11, 0xd631, 0xde52, 0xde52, 0xe693, 0xde73, 0xe6b4, 0xeef5, 0xf716, 0xff37, 0xff37, 0xf694, 0xddd1, 0xb369, 0x9a65, 0x7921, 0x7040, 0x7800, 0x9000, 0x9800, 0xa000, 0xa800, 0xb000, 0xb000, 0xb800, 0xb800, 0xb800, 0xb800, 0xb800, 0xb800, 0xb800, 0xb820, 0xb020, 0xa000, 0x9800, 0x9000, 0x9000, 0x6840, 0x78e0, 0x9225, 0xbbaa, 0xdd30, 0xf674, 0xff36, 0xff78, 0xf736, 0xf716, 0xe6b4, 0xde53, 0xd653, 0xde73, 0xde73, 0xd632, 0xd651, 0xc5f0, 0xc5d0, 0xbdb0, 0xbd90, 0xb52f, 0xa4cd, 0xacee, 0x9c8e, 0xcdf5, 0xf77c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xff9d, 0xe6f9, 0xce34, 0xa50f, 0x944b, 0xad0e, 0xb56e, 0xbd8f, 0xc5d0, 0xc5d0, 0xcdf0, 0xd631, 0xd631, 0xde92, 0xe6b4, 0xe6b4, 0xe694, 0xde93, 0xdeb4, 0xef36, 0xf777, 0xf777, 0xffb8, 0xf6f6, 0xddd2, 0xccae, 0xbbab, 0xaa87, 0x9163, 0x80a0, 0x7840, 0x7820, 0x7820, 0x7800, 0x7800, 0x7800, 0x8020, 0x8020, 0x8000, 0x7800, 0x7000, 0x7040, 0x78c0, 0x8983, 0x9a86, 0xab08, 0xc50e, 0xddb1, 0xee94, 0xf716, 0xff56, 0xf756, 0xe715, 0xded4, 0xde94, 0xde93, 0xde93, 0xde93, 0xde73, 0xd652, 0xce11, 0xc5d1, 0xcdf0, 0xc5f0, 0xc5d0, 0xb56f, 0xa4ee, 0x9c8d, 0xa4ef, 0xce13, 0xd658, 0xf77d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xf75b, 0xc615, 0x9cae, 0x9ccd, 0xad0d, 0xaced, 0xbd6f, 0xbd8f, 0xbdaf, 0xcdf0, 0xc5f0, 0xce30, 0xd612, 0xde53, 0xe694, 0xe694, 0xde94, 0xde94, 0xde94, 0xde93, 0xdef5, 0xe716, 0xf757, 0xff58, 0xff37, 0xfed6, 0xf654, 0xedf3, 0xd510, 0xcccf, 0xc46e, 0xbc0d, 0xb3cc, 0xb3ab, 0xb38b, 0xb38b, 0xbbec, 0xc44d, 0xccef, 0xdd71, 0xe613, 0xee94, 0xf6f6, 0xf737, 0xf777, 0xff77, 0xf756, 0xe6d4, 0xdeb4, 0xe6d4, 0xe6f5, 0xded4, 0xdeb4, 0xde93, 0xde93, 0xde73, 0xd652, 0xce11, 0xcdf1, 0xcdf1, 0xc5b0, 0xc5b0, 0xb54f, 0xa4ee, 0x9cce, 0x9cef, 0xbdd3, 0xe739, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffbd, 0xd677, 0xc5f4, 0xa4ae, 0x946c, 0xacee, 0xad2f, 0xb56f, 0xc5d0, 0xbdaf, 0xc5f0, 0xce11, 0xce12, 0xd612, 0xd632, 0xde73, 0xe694, 0xeeb4, 0xeeb4, 0xe6f5, 0xe6f5, 0xe6f5, 0xe6f5, 0xe6d5, 0xe6f5, 0xef36, 0xf777, 0xf757, 0xf757, 0xf737, 0xff57, 0xff57, 0xff78, 0xff78, 0xff78, 0xff37, 0xf757, 0xf757, 0xf757, 0xef56, 0xef56, 0xe776, 0xe777, 0xdef4, 0xded4, 0xdeb4, 0xde93, 0xe6d4, 0xeef5, 0xde94, 0xd612, 0xd673, 0xd652, 0xce32, 0xce11, 0xc5f1, 0xc5d0, 0xbdb0, 0xbdb0, 0xb54f, 0xa4ee, 0x944c, 0x9cae, 0xc5f4, 0xd697, 0xe73b, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7bd, 0xef5b, 0xcdf4, 0xad10, 0xad10, 0xa4ce, 0xa4ee, 0xb56f, 0xb56f, 0xbdd0, 0xc5d0, 0xc5f1, 0xce11, 0xd652, 0xde73, 0xde73, 0xde73, 0xde73, 0xd672, 0xde93, 0xe6d4, 0xe6f4, 0xe6f4, 0xe6f4, 0xe6f4, 0xe6f4, 0xe6f4, 0xe6f4, 0xe6f5, 0xe715, 0xeef5, 0xeef5, 0xeef5, 0xe6d4, 0xded4, 0xe6f4, 0xe715, 0xe735, 0xe735, 0xe715, 0xdef4, 0xdeb4, 0xded4, 0xe6d4, 0xe6d4, 0xde93, 0xd652, 0xd632, 0xde53, 0xde73, 0xd652, 0xce32, 0xce11, 0xc5f1, 0xc5d0, 0xbdb0, 0xad4e, 0xa4ed, 0xa4ae, 0xa4cf, 0xa4af, 0xbdb4, 0xef5b, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffd, 0xd656, 0xbd93, 0x9cae, 0x944c, 0xa4ce, 0xa4ed, 0xb54f, 0xb56f, 0xbdb0, 0xbdf0, 0xc611, 0xc5f1, 0xc611, 0xce32, 0xce72, 0xd652, 0xd652, 0xd652, 0xde72, 0xde72, 0xde93, 0xde93, 0xde93, 0xe6d3, 0xe6d3, 0xe6d3, 0xe6b3, 0xe6b3, 0xe6b3, 0xe693, 0xe693, 0xe6d4, 0xded3, 0xdeb3, 0xde93, 0xe6b3, 0xe693, 0xe673, 0xe672, 0xdeb4, 0xd693, 0xd673, 0xd673, 0xd673, 0xd632, 0xce11, 0xcdd1, 0xc5f1, 0xc5f1, 0xbdb0, 0xb56f, 0xad2e, 0xad2e, 0xa4cc, 0x946b, 0x944d, 0xc5b3, 0xde97, 0xef5b, 0xffff, 0xffdf, 0xf7df, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef5c, 0xdeb8, 0xbdb3, 0x9cce, 0x9cad, 0x948c, 0xa4ed, 0xb54e, 0xb56f, 0xbd6f, 0xc5b0, 0xcdd1, 0xcdd1, 0xcdd1, 0xce12, 0xce13, 0xd653, 0xd673, 0xd673, 0xd673, 0xd693, 0xde93, 0xde92, 0xde92, 0xde92, 0xde92, 0xde92, 0xde92, 0xde92, 0xde92, 0xdeb4, 0xdeb4, 0xde93, 0xdeb3, 0xdeb3, 0xd693, 0xd692, 0xd672, 0xde52, 0xd631, 0xd632, 0xd632, 0xc5f1, 0xc5d1, 0xc5d1, 0xbdb0, 0xc5b0, 0xbd8f, 0xad0d, 0xa50e, 0x946d, 0x946e, 0x946e, 0xc615, 0xd69a, 0xe71c, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffdd, 0xf77b, 0xd676, 0xbd92, 0x9cce, 0x946c, 0x944b, 0x9c8c, 0xacee, 0xad0e, 0xb52e, 0xbd6f, 0xc5b0, 0xc5b1, 0xc5d1, 0xc5f1, 0xcdf1, 0xcdf1, 0xcdf1, 0xce11, 0xce31, 0xce12, 0xd632, 0xd632, 0xd632, 0xd653, 0xd653, 0xd653, 0xd653, 0xd633, 0xd633, 0xd633, 0xd633, 0xd633, 0xd632, 0xce32, 0xce12, 0xd631, 0xcdf1, 0xce11, 0xce11, 0xc5d0, 0xbdb0, 0xbd90, 0xad2e, 0xa4ed, 0xa4cd, 0x944c, 0x9c8d, 0x9c8e, 0xc5d4, 0xd677, 0xef1a, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xef5b, 0xd677, 0xc5f4, 0x9caf, 0x8c2c, 0x946d, 0x946c, 0x9c8c, 0xaced, 0xaced, 0xad0e, 0xb52e, 0xbd6f, 0xbd6f, 0xbd8f, 0xc5af, 0xc5cf, 0xc5d0, 0xc5d2, 0xc5d2, 0xcdf2, 0xcdf2, 0xce13, 0xce13, 0xce13, 0xcdf2, 0xcdf2, 0xcdf2, 0xcdf2, 0xcdf2, 0xcdf2, 0xcdf2, 0xcdd2, 0xcdd2, 0xc5d0, 0xbd8f, 0xbd8f, 0xb58f, 0xad4e, 0xad4f, 0xad2e, 0xa4ed, 0x9c8e, 0x944d, 0x948e, 0xc5f4, 0xd657, 0xf75b, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdd, 0xdeb9, 0xce56, 0xbdb3, 0x9cae, 0x944c, 0x9c8c, 0x946b, 0xa4ac, 0xaced, 0xb50e, 0xb52e, 0xb52e, 0xbd4e, 0xbd6e, 0xbd6e, 0xbd70, 0xbd90, 0xbd90, 0xbdb0, 0xc5b0, 0xbdb0, 0xbd90, 0xbd90, 0xc5b0, 0xc5b0, 0xc5b0, 0xc5b0, 0xc590, 0xbd6f, 0xbd6f, 0xbd6f, 0xb54f, 0xb54f, 0xb56f, 0xb54f, 0x9ccd, 0x946c, 0x8c4b, 0x83ea, 0xce15, 0xc615, 0xd657, 0xffdd, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xfffe, 0xf79c, 0xd697, 0xce34, 0xbdd3, 0x9cce, 0x944c, 0x9c6c, 0x9c6c, 0x942b, 0x944b, 0x9c8c, 0xa4cd, 0xa4ed, 0xa4cc, 0xa4ec, 0xa4ed, 0xad0d, 0xad0d, 0xad0d, 0xad0d, 0xad0d, 0xb54d, 0xb54d, 0xb54d, 0xb54d, 0xb52d, 0xb52d, 0xad0d, 0xad0d, 0xa4ef, 0x9cae, 0x948d, 0x8c4d, 0x840c, 0x9ccf, 0xc614, 0xded7, 0xf77c, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xf7bc, 0xd677, 0xd677, 0xd656, 0xbdb3, 0xa4cf, 0x944d, 0x8c2d, 0x8c4d, 0x8c2c, 0x946b, 0x946b, 0x948b, 0x9c8b, 0x9cac, 0x9cac, 0x9ccc, 0xa4cc, 0xa4cb, 0x9cab, 0x9cab, 0x9cac, 0xa4ad, 0xa4ad, 0x9c8d, 0x9c6d, 0x8c2d, 0x9cd0, 0xbdd4, 0xd697, 0xd6b8, 0xe71a, 0xffdd, 0xfffe, 0xffbe, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xf79d, 0xdeda, 0xd678, 0xd698, 0xd698, 0xce77, 0x8c2c, 0x8c0c, 0x8c0c, 0x8c0c, 0x8c0c, 0x8c0c, 0x8c2c, 0x8c2c, 0x840b, 0x840b, 0x946d, 0xa4f0, 0xbdb4, 0xce36, 0xd678, 0xde98, 0xdeda, 0xef1b, 0xffde, 0xffff, 0xffdf, 0xffde, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf77b, 0xf75b, 0xef3a, 0xeefa, 0xe6f9, 0xe6d9, 0xe6d9, 0xe6f9, 0xe71a, 0xe6fa, 0xe71a, 0xef5c, 0xffbf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};

const unsigned short  Questions[] PROGMEM = {
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7ff, 0xf7df, 0xf7bf, 0xf79e, 0xf79e, 0xff9e, 0xffbe, 0xffbe, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xf7bd, 0xf7bd, 0xf7bd, 0xf7bd, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7fe, 0xf7fe, 0xf7de, 0xf7df, 0xffff, 0xffff, 0xf7df, 0xf7bf, 0xf7be, 0xf7be, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffbf, 0xffbf, 0xffbf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xff9f, 0xff9f, 0xf7be, 0xf79e, 0xf79d, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffbe, 0xffbe, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffbf, 0xffbf, 0xf7fe, 0xf7fe, 0xf7fe, 0xf7fe, 0xf7fd, 0xf7fd, 0xf7fd, 0xf7fd, 0xf7bd, 0xf7bd, 0xf7be, 0xf7be, 0xf7be, 0xf7de, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffdf, 0xffdf, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdd, 0xf7dd, 0xf7dd, 0xf7dd, 0xf7dd, 0xf7de, 0xf7de, 0xf7fe, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7de, 0xf7de, 0xf7de, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xffdf, 0xffbf, 0xf7bf, 0xf7bf, 0xf7df, 0xefde, 0xefde, 0xefde, 0xf7be, 0xf79e, 0xf79e, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7ff, 0xf7ff, 0xf7fe, 0xff7f, 0xff7f, 0xff7f, 0xff7f, 0xff7f, 0xff5f, 0xff5f, 0xff7e, 0xf75d, 0xf75d, 0xf75d, 0xf77d, 0xf77e, 0xff7e, 0xff7f, 0xff9f, 0xf7bf, 0xffbf, 0xffdf, 0xf7df, 0xf7df, 0xefdf, 0xefdf, 0xefdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79f, 0xf79f, 0xffbf, 0xff9f, 0xff9e, 0xf77d, 0xf73b, 0xf71b, 0xfeb5, 0xf6b5, 0xf694, 0xee53, 0xe632, 0xe612, 0xddf1, 0xddd1, 0xddae, 0xddcf, 0xddef, 0xe610, 0xee31, 0xee52, 0xf672, 0xf672, 0xf6fa, 0xf71a, 0xff3b, 0xf77d, 0xff7e, 0xf79f, 0xf7bf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf79e, 0xf79e, 0xffbd, 0xff7c, 0xff19, 0xf6b6, 0xee33, 0xe5d0, 0xe56e, 0xdd4d, 0xdd47, 0xdd47, 0xdd47, 0xdd47, 0xdd67, 0xdd66, 0xdd67, 0xdd67, 0xe566, 0xe566, 0xe566, 0xe566, 0xe567, 0xe567, 0xe567, 0xe567, 0xd52a, 0xd54b, 0xdd8e, 0xe5f0, 0xee53, 0xf6b6, 0xff19, 0xff7a, 0xef5d, 0xf79e, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf79e, 0xef7d, 0xef5d, 0xe610, 0xddcf, 0xdd6c, 0xd529, 0xdd07, 0xed26, 0xf565, 0xfd86, 0xf589, 0xf589, 0xfda9, 0xfdc9, 0xfdc9, 0xfde9, 0xfe09, 0xfe0a, 0xfe0b, 0xfe0a, 0xfdea, 0xfdca, 0xfdca, 0xf5aa, 0xf58a, 0xf589, 0xfda5, 0xf5a5, 0xed66, 0xe547, 0xdd28, 0xd52a, 0xdd4c, 0xdd8d, 0xd6ba, 0xe71c, 0xef7d, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffbe, 0xffdf, 0xffdf, 0xf7bf, 0xf7df, 0xffff, 0xf7be, 0xef7c, 0xe79f, 0xf7bf, 0xffdf, 0xff7c, 0xfed7, 0xf5f2, 0xed6d, 0xe50b, 0xe548, 0xe569, 0xed89, 0xf5aa, 0xf5ca, 0xfdea, 0xfde9, 0xfde9, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4b, 0xfe4b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe4b, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe0a, 0xf5ea, 0xeda9, 0xe569, 0xe548, 0xe526, 0xdd28, 0xe58b, 0xee31, 0xfef7, 0xff7c, 0xff9e, 0xf79f, 0xf79f, 0xefbf, 0xefff, 0xefff, 0xefff, 0xf7df, 0xf7bf, 0xff9f, 0xffbf, 0xf79f, 0xf7bf, 0xf7df, 0xffff, 0xf7de, 0xefbe, 0xefbd, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf75d, 0xffde, 0xfffe, 0xf7dd, 0xef9d, 0xef9e, 0xffdf, 0xffdf, 0xffbf, 0xf75b, 0xe695, 0xd5ef, 0xd58b, 0xdd4a, 0xe54a, 0xed4b, 0xf5c9, 0xf5e9, 0xf609, 0xfe2a, 0xfe4a, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8a, 0xfeaa, 0xfeaa, 0xfeaa, 0xfecb, 0xfeeb, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfecb, 0xfeab, 0xfeab, 0xfeaa, 0xfeaa, 0xfe6a, 0xfe6a, 0xfe6a, 0xfe6a, 0xfe4a, 0xfe4a, 0xfe2a, 0xfe2a, 0xf5ab, 0xed89, 0xdd48, 0xcd28, 0xcd4a, 0xd5ef, 0xee96, 0xff3a, 0xffbc, 0xffbd, 0xf7be, 0xefbf, 0xefbf, 0xefbf, 0xf7de, 0xffde, 0xffbf, 0xf7bf, 0xf7bf, 0xffdf, 0xf7df, 0xf7de, 0xf7ff, 0xffff, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffbd, 0xf7bd, 0xf7bd, 0xf7bd, 0xf7de, 0xffde, 0xff7d, 0xf6fc, 0xee33, 0xe5cf, 0xd56a, 0xd567, 0xdd86, 0xedc7, 0xf5c8, 0xf5e9, 0xfe49, 0xfe49, 0xfe6a, 0xfe6a, 0xfe8b, 0xf6ac, 0xf6cc, 0xf6cd, 0xf6ed, 0xf6ed, 0xf70e, 0xf70e, 0xf72f, 0xff2f, 0xff4f, 0xff50, 0xff50, 0xff50, 0xff2f, 0xff2f, 0xf72f, 0xf70e, 0xf70e, 0xf70e, 0xf6cd, 0xf6cc, 0xf6ac, 0xf6ab, 0xfe8b, 0xfe8a, 0xfe69, 0xfe89, 0xf5cb, 0xfe0a, 0xf609, 0xede7, 0xdd86, 0xd567, 0xdd6a, 0xddac, 0xee52, 0xf6d6, 0xff7c, 0xffdf, 0xffdf, 0xf7bf, 0xefde, 0xf7fd, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xf7be, 0xf7be, 0xf7de, 0xffff, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7fd, 0xf7de, 0xf7bf, 0xffbf, 0xff9e, 0xff1a, 0xee33, 0xdd6e, 0xdd07, 0xdd07, 0xe548, 0xeda9, 0xfe29, 0xfe69, 0xfe88, 0xfe87, 0xfe6a, 0xfe8b, 0xfeac, 0xfecd, 0xf6ef, 0xf710, 0xf731, 0xf751, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffd8, 0xfff8, 0xfff9, 0xfff9, 0xffd9, 0xffd9, 0xffd8, 0xffd8, 0xffd8, 0xffb8, 0xffb7, 0xffb7, 0xff93, 0xff72, 0xff51, 0xff0f, 0xfeee, 0xfeac, 0xfe8b, 0xfe6a, 0xfe6a, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe09, 0xf5c8, 0xed86, 0xe565, 0xd4e9, 0xe58d, 0xf673, 0xff39, 0xffbd, 0xffdf, 0xf7df, 0xefdf, 0xf79e, 0xf7be, 0xffde, 0xffde, 0xf7de, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xefdf, 0xf7ff, 0xffdf, 0xf73c, 0xe655, 0xdd6e, 0xdd28, 0xe546, 0xf567, 0xfda8, 0xfdea, 0xfe2b, 0xfe4b, 0xfe6a, 0xfe8a, 0xf6aa, 0xfecf, 0xfef0, 0xff31, 0xff73, 0xffb5, 0xffd7, 0xfff8, 0xfff9, 0xfffc, 0xfffc, 0xfffc, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xfff9, 0xfff9, 0xfff8, 0xffd6, 0xff94, 0xff52, 0xff31, 0xfef0, 0xfecd, 0xfe8c, 0xf64b, 0xfe2b, 0xfe2b, 0xfe2a, 0xfde9, 0xfdc8, 0xed69, 0xdd28, 0xdd29, 0xddad, 0xee73, 0xf73a, 0xff9f, 0xffbf, 0xffbd, 0xf7bd, 0xf79d, 0xf7be, 0xffde, 0xffff, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf75d, 0xee96, 0xddef, 0xd549, 0xdd06, 0xed46, 0xfda7, 0xfdab, 0xfdeb, 0xfe4a, 0xfe6a, 0xf68a, 0xf6ad, 0xf6f0, 0xff12, 0xff75, 0xff96, 0xffd7, 0xfff8, 0xfffa, 0xfffb, 0xfffb, 0xfffc, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xf7fb, 0xf7fc, 0xf7dc, 0xf7dc, 0xf7db, 0xffdc, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffc, 0xfffc, 0xfffb, 0xfffb, 0xfffa, 0xfff8, 0xffd7, 0xffb6, 0xff34, 0xff12, 0xfeef, 0xfecd, 0xfeac, 0xfe4c, 0xfe0c, 0xf5ac, 0xfe0a, 0xf5c9, 0xe567, 0xd526, 0xd529, 0xddb0, 0xee97, 0xff3d, 0xfffe, 0xffdd, 0xffbd, 0xf7bd, 0xf7be, 0xffdf, 0xffdf, 0xf7bf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf79e, 0xef7d, 0xfef9, 0xee13, 0xd52b, 0xdd07, 0xed66, 0xf5c7, 0xfe09, 0xfe0a, 0xfe2c, 0xfe2c, 0xf66b, 0xf6ab, 0xf70e, 0xff71, 0xffb5, 0xfff8, 0xfff8, 0xfff9, 0xfff9, 0xfffa, 0xfffa, 0xfffb, 0xffdb, 0xf7db, 0xfffa, 0xfffa, 0xfffa, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffa, 0xf7dc, 0xf7dc, 0xfffc, 0xfffb, 0xfffb, 0xfffa, 0xfffa, 0xfff9, 0xfff9, 0xfff8, 0xffd4, 0xff90, 0xff2e, 0xf6cd, 0xf68d, 0xf66e, 0xf62b, 0xfe4b, 0xfe4a, 0xf5c9, 0xe527, 0xdd09, 0xdd8d, 0xee10, 0xef3a, 0xff9c, 0xffdd, 0xffbe, 0xf7be, 0xf7be, 0xf7bf, 0xf7bf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xef7d, 0xef5d, 0xe56b, 0xe529, 0xe508, 0xf568, 0xfdc9, 0xfe2a, 0xfe6b, 0xf68c, 0xfeaa, 0xfeab, 0xff0e, 0xff71, 0xffd4, 0xfff6, 0xfff6, 0xfff6, 0xfff9, 0xfff9, 0xfff9, 0xfffa, 0xfffa, 0xfffb, 0xfffb, 0xfffc, 0xffda, 0xffda, 0xfffa, 0xfffa, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xffdb, 0xfffb, 0xffda, 0xffda, 0xffda, 0xfffc, 0xfffc, 0xfffb, 0xfffb, 0xf7fa, 0xf7fa, 0xf7fa, 0xf7f9, 0xf7d8, 0xfff8, 0xfff7, 0xfff6, 0xffd3, 0xff8f, 0xff2c, 0xf70b, 0xfeac, 0xfe6c, 0xfe0b, 0xfdeb, 0xfdca, 0xf5a9, 0xdd46, 0xcce4, 0xc5f5, 0xdeb8, 0xf79c, 0xffde, 0xffbe, 0xffbe, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xef5e, 0xffdf, 0xffff, 0xf7be, 0xf7be, 0xf7be, 0xef9d, 0xf7de, 0xf7bd, 0xf7de, 0xe7df, 0xe79f, 0xefbf, 0xff7c, 0xf630, 0xdce5, 0xe526, 0xe567, 0xf5c9, 0xfe0a, 0xfe4b, 0xfe4c, 0xfe6c, 0xfe6c, 0xf791, 0xf7b2, 0xffd3, 0xfff5, 0xfff6, 0xfff7, 0xfff7, 0xfff8, 0xfff9, 0xfff9, 0xfff9, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffb, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfff9, 0xfff9, 0xfff8, 0xfff7, 0xffd6, 0xffd5, 0xffd4, 0xffd3, 0xfeed, 0xfeac, 0xf66b, 0xf64b, 0xfe2b, 0xfe0a, 0xf5a9, 0xed67, 0xe4a5, 0xe509, 0xee12, 0xff5b, 0xffdf, 0xef9f, 0xefbf, 0xf7ff, 0xfffe, 0xffde, 0xffbf, 0xff9f, 0xff7f, 0xff9f, 0xf7bf, 0xffde, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bf, 0xffff, 0xffbf, 0xf79e, 0xf7de, 0xffdf, 0xf7df, 0xffff, 0xf7dd, 0xef9d, 0xf7df, 0xffff, 0xef3a, 0xd5d0, 0xd50a, 0xe528, 0xeda8, 0xf5c9, 0xf5c9, 0xf60a, 0xf64b, 0xfe8c, 0xfeee, 0xff2f, 0xffb2, 0xffd3, 0xfff4, 0xfff5, 0xfff6, 0xfff7, 0xfff7, 0xfff8, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfff9, 0xfff9, 0xfff8, 0xfff7, 0xfff6, 0xffd5, 0xffd4, 0xffd4, 0xff90, 0xff4f, 0xfeed, 0xfeac, 0xf66b, 0xfe2a, 0xfe0a, 0xfe0a, 0xfd87, 0xe548, 0xd52b, 0xddd2, 0xeef9, 0xff9e, 0xf7bf, 0xef9f, 0xf7de, 0xf7be, 0xf7bf, 0xff9f, 0xff9f, 0xff9f, 0xf7bf, 0xffbf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xfffe, 0xffde, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7bf, 0xffdf, 0xefbd, 0xf7be, 0xff7e, 0xf6f8, 0xddcf, 0xcd08, 0xdd28, 0xf5ab, 0xfe0a, 0xf60a, 0xf62a, 0xf66b, 0xf6ac, 0xff2e, 0xff90, 0xfff1, 0xfff4, 0xfff4, 0xfff5, 0xfff6, 0xfff7, 0xfff7, 0xfff8, 0xffd8, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfffa, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff8, 0xfff8, 0xfff7, 0xfff6, 0xfff5, 0xffd4, 0xffd4, 0xfff1, 0xfff1, 0xffb0, 0xff2e, 0xfecc, 0xfe6b, 0xfe4b, 0xfe4b, 0xfe29, 0xf588, 0xdd07, 0xcce9, 0xddaf, 0xf6d8, 0xff5d, 0xff7f, 0xefbf, 0xefbf, 0xf7bf, 0xf7be, 0xf7be, 0xf7bf, 0xffbf, 0xff9f, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7dd, 0xf7dd, 0xf7be, 0xffdf, 0xffdf, 0xff9f, 0xf77e, 0xf77e, 0xffdf, 0xff9d, 0xf696, 0xdd4d, 0xd4e7, 0xe567, 0xf5e9, 0xfe0b, 0xf62a, 0xfe4b, 0xfeac, 0xff0e, 0xff4f, 0xffb0, 0xfff2, 0xfff2, 0xfff5, 0xfff5, 0xfff6, 0xfff6, 0xfff7, 0xfff7, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff9, 0xfff8, 0xfff8, 0xfff7, 0xfff7, 0xfff6, 0xfff5, 0xfff5, 0xfff4, 0xf7f2, 0xfff2, 0xfff1, 0xffb0, 0xff4f, 0xfeed, 0xfe8b, 0xfe4b, 0xfe0b, 0xfe0a, 0xfda8, 0xed26, 0xdce7, 0xdd6d, 0xf676, 0xff5c, 0xf7bf, 0xf7bf, 0xf7df, 0xf7de, 0xf7de, 0xf7be, 0xffbf, 0xff9f, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bc, 0xf7dd, 0xffde, 0xffdf, 0xffbf, 0xff9e, 0xff9e, 0xff9d, 0xffbe, 0xee96, 0xdd6c, 0xdd07, 0xed26, 0xf588, 0xf5e9, 0xfe49, 0xf64a, 0xfeac, 0xff0e, 0xff8f, 0xffd1, 0xfff2, 0xfff2, 0xfff3, 0xfff5, 0xfff5, 0xfff6, 0xfff6, 0xfff7, 0xfff7, 0xfff8, 0xfff8, 0xfff7, 0xfff7, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff7, 0xfff7, 0xfff6, 0xfff6, 0xfff5, 0xfff5, 0xfff5, 0xf7f3, 0xf7f2, 0xfff2, 0xfff2, 0xffd1, 0xff6f, 0xfeed, 0xf68b, 0xf60d, 0xfe0b, 0xfe09, 0xfdc7, 0xed25, 0xd4c7, 0xdd6d, 0xee73, 0xff7d, 0xffbe, 0xf7de, 0xf7fe, 0xf7de, 0xf7be, 0xffbf, 0xffbf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7dd, 0xf7de, 0xffdf, 0xffbf, 0xf77e, 0xffbe, 0xffdd, 0xff9c, 0xee14, 0xd54d, 0xd507, 0xed87, 0xfde9, 0xfdca, 0xf5e9, 0xfe69, 0xfecc, 0xff0d, 0xff4e, 0xffb0, 0xffd1, 0xfff2, 0xfff3, 0xfff4, 0xfff5, 0xffd5, 0xfff6, 0xfff6, 0xfff6, 0xfff7, 0xfff7, 0xfff8, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff8, 0xfff8, 0xfff8, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff8, 0xfff7, 0xfff7, 0xfff6, 0xfff6, 0xfff6, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff4, 0xffd3, 0xffd2, 0xfff2, 0xffd1, 0xff8f, 0xff2d, 0xfeaf, 0xf62c, 0xf5e9, 0xfe08, 0xfde7, 0xe546, 0xd507, 0xcd29, 0xf6b7, 0xf719, 0xff9c, 0xffde, 0xf7df, 0xf7bf, 0xf7bf, 0xffbf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7de, 0xf7df, 0xffbf, 0xf79f, 0xf77e, 0xffbe, 0xff7b, 0xe6b6, 0xd4c9, 0xdce8, 0xe548, 0xf5e9, 0xfe2a, 0xfe2b, 0xfe6b, 0xfeac, 0xff6d, 0xff6e, 0xff8f, 0xffb0, 0xffb1, 0xffd2, 0xfff3, 0xfff4, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff5, 0xfff5, 0xfff5, 0xfff6, 0xfff5, 0xffd3, 0xffd2, 0xffd2, 0xfff1, 0xffd0, 0xffcf, 0xff70, 0xf6ad, 0xee0a, 0xfe0a, 0xfe2a, 0xf5e9, 0xdd47, 0xd506, 0xdd4e, 0xee13, 0xff19, 0xffbe, 0xf7df, 0xefbf, 0xf7be, 0xffde, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7de, 0xf7bf, 0xffbf, 0xf79f, 0xff7e, 0xff9d, 0xe6d7, 0xbd70, 0xed04, 0xed27, 0xf58a, 0xf60c, 0xf64a, 0xee49, 0xfe8c, 0xfef0, 0xff8e, 0xffaf, 0xffd0, 0xffd1, 0xffd2, 0xffd3, 0xffb3, 0xffd4, 0xfff4, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff7, 0xfff6, 0xfff6, 0xfff6, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xffb5, 0xffd5, 0xffd4, 0xffd3, 0xffd1, 0xffd0, 0xffd0, 0xffcf, 0xffae, 0xff6e, 0xfecd, 0xf64b, 0xf60b, 0xf5eb, 0xf5c9, 0xed88, 0xcc48, 0xdd4e, 0xf6b7, 0xff9e, 0xf7bf, 0xefbf, 0xf7be, 0xffdd, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff9e, 0xfffe, 0xef9d, 0xe77e, 0xffdf, 0xf697, 0xe4ea, 0xecc4, 0xed49, 0xedaa, 0xf5ea, 0xee29, 0xee6a, 0xf6eb, 0xff8e, 0xff8e, 0xffae, 0xff8e, 0xffaf, 0xffd0, 0xffb1, 0xfff3, 0xffd4, 0xf753, 0xeef2, 0xd650, 0xce0f, 0xd650, 0xe6b1, 0xe6d2, 0xef13, 0xff95, 0xffd5, 0xfff5, 0xfff5, 0xfff5, 0xf7f5, 0xf7f5, 0xfff6, 0xfff7, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xfff6, 0xffd4, 0xffd4, 0xffd4, 0xfff4, 0xfff4, 0xfff4, 0xfff5, 0xfff5, 0xfff4, 0xfff3, 0xfff3, 0xfff3, 0xffd2, 0xffd1, 0xffb1, 0xf790, 0xffd0, 0xffaf, 0xff6e, 0xf6ec, 0xf66b, 0xf60a, 0xf5e9, 0xf5e9, 0xfd47, 0xd485, 0xd52a, 0xeeb5, 0xff7d, 0xf79f, 0xf7bf, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7bf, 0xf7de, 0xffbe, 0xf6d9, 0xdd70, 0xdcc9, 0xf506, 0xf5aa, 0xf5ca, 0xede9, 0xf64a, 0xf6cb, 0xff4d, 0xffaf, 0xffaf, 0xff8e, 0xfff0, 0xffb0, 0xff71, 0xff93, 0xe670, 0xaca9, 0x93e7, 0x6a62, 0x6a21, 0x59e0, 0x59a0, 0x5180, 0x6200, 0x8b25, 0xac69, 0xe650, 0xff95, 0xfff6, 0xfff5, 0xfff5, 0xfff6, 0xfff6, 0xffb5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff3, 0xfff3, 0xfff3, 0xfff2, 0xfff2, 0xffd2, 0xffd1, 0xffd1, 0xffaf, 0xffaf, 0xff6e, 0xff0d, 0xfeac, 0xf64b, 0xf60a, 0xf5e9, 0xfd68, 0xed48, 0xd4e8, 0xd56e, 0xf6d8, 0xffbf, 0xf7bf, 0xf7df, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xefdf, 0xf7bf, 0xffdf, 0xff3a, 0xd56f, 0xcca8, 0xe508, 0xf568, 0xf5cb, 0xf5ea, 0xee0a, 0xfeab, 0xff4d, 0xff6e, 0xff8f, 0xff8f, 0xffaf, 0xffb0, 0xfff4, 0xf6d2, 0x9be8, 0x6201, 0x5180, 0x4920, 0x5920, 0x5920, 0x5940, 0x6160, 0x5940, 0x5940, 0x5920, 0x5100, 0x61c0, 0xa3e8, 0xde30, 0xffd6, 0xfff7, 0xffd4, 0xf793, 0xfff4, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xfff5, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xffd2, 0xffd2, 0xffb1, 0xffb1, 0xffb0, 0xffb0, 0xffaf, 0xffaf, 0xff8f, 0xff6e, 0xff0d, 0xfeac, 0xf64a, 0xf5e9, 0xf58a, 0xfdca, 0xe507, 0xcc87, 0xddb0, 0xff3a, 0xf7df, 0xe7df, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xdf9f, 0xf7bf, 0xff5d, 0xe5d2, 0xcc87, 0xdce5, 0xf588, 0xf58a, 0xedca, 0xf60a, 0xf66b, 0xff2d, 0xff8e, 0xff4e, 0xff8f, 0xff90, 0xfff1, 0xff30, 0xbceb, 0x7263, 0x5140, 0x5961, 0x6160, 0x5940, 0x5940, 0x6180, 0x69a1, 0x6180, 0x6180, 0x61a0, 0x69a1, 0x61a0, 0x5920, 0x5140, 0x7263, 0xbcec, 0xf713, 0xfff5, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff3, 0xfff3, 0xfff3, 0xfff2, 0xffd2, 0xffd1, 0xffd1, 0xffd1, 0xffaf, 0xffaf, 0xffaf, 0xff8f, 0xff4e, 0xfeed, 0xfe8b, 0xf62a, 0xf5cb, 0xf5aa, 0xf567, 0xe4a5, 0xd488, 0xddf2, 0xf77c, 0xefdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xefbe, 0xff9e, 0xee36, 0xcc8b, 0xdca5, 0xf585, 0xf5c8, 0xf5aa, 0xedea, 0xfe8c, 0xfeec, 0xff6e, 0xff6e, 0xff4e, 0xffd1, 0xffd2, 0xf710, 0xac88, 0x6221, 0x4920, 0x4920, 0x5960, 0x6a01, 0x8283, 0xa429, 0xb4ab, 0xbcec, 0xb48a, 0x9c08, 0x8b45, 0x6a62, 0x51a0, 0x6a01, 0x5100, 0x40e0, 0x61e1, 0xa429, 0xeed2, 0xfff5, 0xffd2, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff4, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xffd3, 0xffd3, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd1, 0xffd1, 0xffd0, 0xffd1, 0xffd0, 0xffaf, 0xffaf, 0xff8f, 0xff6e, 0xff2d, 0xfecc, 0xf68b, 0xee0c, 0xeda9, 0xfda8, 0xfd46, 0xdc85, 0xccca, 0xde55, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdd, 0xeed8, 0xcd0d, 0xcc66, 0xed26, 0xfda7, 0xed88, 0xedcb, 0xee4b, 0xfeed, 0xff2d, 0xff6e, 0xff4e, 0xff6f, 0xfff2, 0xf730, 0xac68, 0x59c0, 0x4100, 0x59c1, 0x6a22, 0x9386, 0xddef, 0xff53, 0xffd5, 0xffd5, 0xffd5, 0xfff5, 0xfff6, 0xffd5, 0xef11, 0xce2e, 0x8b65, 0x72a3, 0x59a0, 0x40c0, 0x5160, 0x93c7, 0xe66f, 0xfff4, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xfff3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xfff3, 0xfff3, 0xfff3, 0xffd2, 0xffd2, 0xffd2, 0xffd1, 0xffb1, 0xffb0, 0xff90, 0xff8f, 0xffd0, 0xffd0, 0xffaf, 0xff8e, 0xff6e, 0xff2e, 0xff0d, 0xfeec, 0xee4b, 0xf60a, 0xfda8, 0xfd88, 0xf526, 0xcc66, 0xcd2d, 0xf6d7, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xf79e, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff39, 0xd58f, 0xc487, 0xe4e6, 0xf568, 0xf589, 0xf5aa, 0xf60c, 0xf6cc, 0xff2e, 0xff2d, 0xff4e, 0xff4e, 0xffb0, 0xff50, 0xad08, 0x5980, 0x5980, 0x59a0, 0x7ae3, 0xc56c, 0xffb4, 0xfff5, 0xffd2, 0xffb2, 0xffb2, 0xffb2, 0xf7b2, 0xffd2, 0xfff3, 0xfff3, 0xfff3, 0xfff5, 0xe691, 0xac4a, 0x6a43, 0x4920, 0x4920, 0x8b85, 0xff73, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffd2, 0xffb2, 0xffb2, 0xffb1, 0xffb2, 0xffd2, 0xfff2, 0xfff2, 0xfff2, 0xffd1, 0xffd0, 0xffb0, 0xffaf, 0xffaf, 0xffaf, 0xff8e, 0xff6e, 0xff4e, 0xff2d, 0xff2d, 0xf6cc, 0xf64b, 0xf5ca, 0xfda9, 0xfd88, 0xe4c6, 0xd4a8, 0xed6d, 0xe73c, 0xef7d, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf675, 0xc4a9, 0xcca4, 0xf586, 0xf548, 0xf56a, 0xfe0c, 0xf62c, 0xfeed, 0xff2e, 0xff0d, 0xff4d, 0xff8f, 0xffb1, 0xde6d, 0x6ac0, 0x48e0, 0x5140, 0xac29, 0xff33, 0xfff4, 0xffd2, 0xfff2, 0xffd1, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xffd1, 0xffd1, 0xfff1, 0xf7d2, 0xfff6, 0xff96, 0xee12, 0x9b89, 0x38a0, 0x51a0, 0xee90, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xfff2, 0xf771, 0xf770, 0xef30, 0xe6ef, 0xdeae, 0xd66d, 0xce2c, 0xce2b, 0xd68d, 0xdead, 0xe6ee, 0xf74f, 0xff70, 0xff90, 0xffb0, 0xffb0, 0xff8f, 0xffaf, 0xffaf, 0xff8f, 0xff6e, 0xff4d, 0xff4d, 0xff4d, 0xff0c, 0xf66b, 0xf5eb, 0xf5aa, 0xf547, 0xf526, 0xece7, 0xdc46, 0xdefb, 0xef5d, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bf, 0xffdf, 0xf7bc, 0xfffe, 0xf7be, 0xf77f, 0xffbe, 0xef1a, 0xdc65, 0xdca6, 0xed07, 0xed89, 0xeda9, 0xedc9, 0xf64b, 0xfeed, 0xf70c, 0xff0c, 0xff2d, 0xff4e, 0xff4f, 0xffd1, 0xde4c, 0x49c0, 0x3980, 0xad09, 0xffb3, 0xfff3, 0xffb1, 0xff90, 0xff90, 0xfff1, 0xffd0, 0xffd1, 0xffd2, 0xffd3, 0xffd3, 0xffd2, 0xffd1, 0xfff0, 0xfff1, 0xfff2, 0xffd3, 0xfff6, 0xffb5, 0xb58c, 0xad2a, 0xffb4, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xf7f1, 0xf7f1, 0xf7d2, 0xfff4, 0xff93, 0xeef1, 0xde2f, 0xc54b, 0xa40b, 0x9388, 0x7aa5, 0x6222, 0x59c1, 0x59c1, 0x59a0, 0x51a0, 0x59a0, 0x61c0, 0x7242, 0x8b25, 0xa3e8, 0xbc8a, 0xddae, 0xfed2, 0xff6f, 0xffd0, 0xffaf, 0xff8e, 0xff8e, 0xff8f, 0xff6f, 0xf6ee, 0xfeec, 0xfeab, 0xf64a, 0xedea, 0xeda9, 0xed68, 0xe4e7, 0xdca6, 0xd4ca, 0xf6f7, 0xefbf, 0xe7df, 0xf7df, 0xff9c, 0xffbd, 0xff9e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7dd, 0xf7de, 0xf79e, 0xff9f, 0xff5b, 0xd5f4, 0xdc86, 0xe4c6, 0xed28, 0xed88, 0xedc9, 0xf60a, 0xfe6b, 0xfecc, 0xff4d, 0xff4d, 0xff4e, 0xff6e, 0xff2e, 0xffb1, 0xffd1, 0xc589, 0xc5ab, 0xf751, 0xfff3, 0xffb1, 0xffb1, 0xffb0, 0xff8f, 0xffd0, 0xffd0, 0xffd1, 0xffd1, 0xfff2, 0xfff2, 0xffb1, 0xffd1, 0xffd1, 0xf78f, 0xfff1, 0xffd1, 0xffb2, 0xfff4, 0xfff3, 0xf792, 0xfff4, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd0, 0xfff2, 0xffd3, 0xe68f, 0xac89, 0x8324, 0x6a00, 0x5140, 0x5140, 0x5120, 0x4900, 0x5120, 0x5140, 0x5960, 0x5980, 0x5980, 0x6181, 0x5140, 0x5100, 0x5100, 0x5120, 0x5940, 0x69e1, 0x82a4, 0xb4e8, 0xd62c, 0xff91, 0xffd0, 0xff4d, 0xff2c, 0xff4d, 0xff4d, 0xff0d, 0xfeac, 0xf66b, 0xf60a, 0xf5c9, 0xed69, 0xe508, 0xe4c7, 0xcc87, 0xddd1, 0xef5d, 0xf7df, 0xf79f, 0xffbd, 0xffde, 0xffde, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf79d, 0xf7de, 0xefbf, 0xefbf, 0xffbd, 0xee76, 0xbccd, 0xdca6, 0xe4e7, 0xed48, 0xed89, 0xf5e9, 0xf64b, 0xfeac, 0xfecc, 0xff2d, 0xff4d, 0xff4e, 0xff8f, 0xff2e, 0xff2e, 0xfff2, 0xffb1, 0xffd2, 0xfff2, 0xffb1, 0xff70, 0xffd0, 0xfff0, 0xffaf, 0xffcf, 0xffd1, 0xffd1, 0xffd0, 0xffb0, 0xff90, 0xffb1, 0xffd2, 0xffd3, 0xfff1, 0xfff2, 0xfff0, 0xf78f, 0xffd0, 0xfff1, 0xfff1, 0xfff1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xff6f, 0xffd2, 0xff31, 0x9ba6, 0x4900, 0x5120, 0x6140, 0x6140, 0x61a0, 0x6180, 0x6180, 0x6180, 0x6180, 0x6180, 0x6180, 0x6180, 0x61a0, 0x61a0, 0x5980, 0x5960, 0x5140, 0x5100, 0x48c0, 0x40c0, 0x30c0, 0x7302, 0xe66e, 0xffb0, 0xff4d, 0xff4c, 0xff2b, 0xff6c, 0xff0d, 0xfeec, 0xfeac, 0xfe4b, 0xf5ea, 0xf589, 0xed48, 0xe507, 0xd485, 0xc48a, 0xe6b8, 0xffdf, 0xf79f, 0xffdf, 0xffde, 0xf7fe, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdd, 0xf79d, 0xf7ff, 0xefbf, 0xf7df, 0xff5a, 0xd54f, 0xc428, 0xe4c7, 0xed28, 0xed69, 0xeda9, 0xf60a, 0xfe8c, 0xfecc, 0xfeac, 0xff0c, 0xff2d, 0xff2d, 0xff6e, 0xff6f, 0xf70d, 0xff6f, 0xff6f, 0xff8f, 0xffb0, 0xff8f, 0xff8f, 0xffd0, 0xffaf, 0xff8e, 0xffcf, 0xffd1, 0xffd0, 0xffd0, 0xffcf, 0xffd1, 0xffb2, 0xff11, 0xe66f, 0xe68f, 0xf70f, 0xffd1, 0xfff1, 0xffcf, 0xf76e, 0xf790, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xffd1, 0xff90, 0xfff2, 0xff52, 0x8b44, 0x3880, 0x5100, 0x6180, 0x69c2, 0x61e0, 0x6a40, 0x8303, 0xa3c6, 0xbc89, 0xcd4b, 0xddcd, 0xe60e, 0xe64e, 0xe64f, 0xe62f, 0xd5ce, 0xcd6d, 0xb4cb, 0x9be8, 0x8325, 0x5a40, 0x8ba5, 0xeecf, 0xffd1, 0xff6e, 0xffae, 0xff4c, 0xff6c, 0xff0d, 0xfeec, 0xfeac, 0xfe6b, 0xf60a, 0xf5a9, 0xed69, 0xed28, 0xe4c4, 0xc426, 0xddb1, 0xff5c, 0xf79f, 0xf7bf, 0xf7df, 0xefde, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbc, 0xf7be, 0xf7df, 0xefbf, 0xffde, 0xee74, 0xc469, 0xdc86, 0xed07, 0xed48, 0xf589, 0xf5c9, 0xfe2a, 0xfeac, 0xfecc, 0xfecc, 0xff0d, 0xff4e, 0xf70d, 0xff4e, 0xffaf, 0xff8e, 0xff6e, 0xff6e, 0xff6e, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xff8e, 0xff8e, 0xffcf, 0xffd1, 0xffb0, 0xffb0, 0xffd0, 0xff2f, 0xcd6a, 0x93a5, 0x7282, 0x7283, 0x9386, 0xcd8b, 0xff50, 0xfff2, 0xffd1, 0xffb1, 0xffb2, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xfff0, 0xffd1, 0xfff3, 0xd60e, 0xa448, 0x9c08, 0x9be8, 0xac8a, 0xde6e, 0xeed0, 0xff52, 0xffb3, 0xffd3, 0xffd3, 0xffd3, 0xffd3, 0xfff1, 0xfff1, 0xfff2, 0xfff2, 0xfff3, 0xfff4, 0xfff4, 0xffb3, 0xff72, 0xf710, 0xfff3, 0xffb0, 0xf70d, 0xff6e, 0xff0d, 0xff2e, 0xff0d, 0xfeec, 0xfecc, 0xfe8b, 0xf62a, 0xf5ca, 0xed69, 0xed48, 0xf505, 0xd485, 0xccaa, 0xee56, 0xff9e, 0xefbf, 0xf7df, 0xefbd, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7dc, 0xf7df, 0xf7bf, 0xf7bf, 0xff5a, 0xd58e, 0xc425, 0xece6, 0xed28, 0xf569, 0xf5a9, 0xf5ea, 0xfe4b, 0xfeac, 0xfecc, 0xfecc, 0xff0d, 0xff6e, 0xff4e, 0xff2d, 0xff6e, 0xff8e, 0xff8e, 0xffaf, 0xff8f, 0xffaf, 0xffaf, 0xff8e, 0xff8f, 0xffaf, 0xffaf, 0xffd0, 0xff8f, 0xffb0, 0xffd1, 0xf6ce, 0xac86, 0x61c0, 0x40a0, 0x48c0, 0x48e0, 0x4900, 0x6a62, 0xbd0a, 0xff52, 0xfff3, 0xff91, 0xff91, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffb0, 0xffef, 0xf78f, 0xfff2, 0xffd2, 0xf772, 0xffb3, 0xffb3, 0xfff5, 0xffd2, 0xfff2, 0xfff2, 0xffd2, 0xffb1, 0xf7b0, 0xf7b0, 0xffb0, 0xffef, 0xffef, 0xf7ae, 0xef8e, 0xf7af, 0xfff0, 0xfff0, 0xf7d0, 0xfff2, 0xff6f, 0xff8f, 0xf74d, 0xf70d, 0xff8f, 0xff4f, 0xff2f, 0xff0d, 0xfeec, 0xfecc, 0xfe8c, 0xfe4b, 0xf5ea, 0xed89, 0xed48, 0xf527, 0xe4e6, 0xc425, 0xd56f, 0xf73b, 0xf7bf, 0xf7ff, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xeffd, 0xf7df, 0xf79f, 0xff7e, 0xee55, 0xcca9, 0xd465, 0xf506, 0xed48, 0xed69, 0xf5a9, 0xfe2b, 0xfe6b, 0xfe8c, 0xfecc, 0xfeec, 0xf70d, 0xff4e, 0xff4e, 0xff4d, 0xff4d, 0xff4d, 0xff6d, 0xff8e, 0xffaf, 0xff8f, 0xff6f, 0xff8f, 0xff8f, 0xff8f, 0xff6f, 0xff6f, 0xff8e, 0xfff1, 0xff50, 0xb4c9, 0x6a20, 0x48e0, 0x5940, 0x7202, 0x7203, 0x61a1, 0x5140, 0x7ae3, 0xde0e, 0xff92, 0xffaf, 0xffcf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xf78e, 0xffae, 0xfff1, 0xffd1, 0xffb0, 0xfff2, 0xfff0, 0xef4e, 0xffd1, 0xffd1, 0xffd0, 0xffb0, 0xff8f, 0xffaf, 0xffd0, 0xffd0, 0xffb0, 0xffd0, 0xffd0, 0xffaf, 0xffaf, 0xffaf, 0xff8e, 0xf76e, 0xff6f, 0xf74d, 0xff8e, 0xff8e, 0xff8d, 0xff6e, 0xff2e, 0xf6cd, 0xff2d, 0xfeec, 0xfecc, 0xfeac, 0xfe6b, 0xfe0b, 0xf5aa, 0xed69, 0xed28, 0xed06, 0xd443, 0xc4a9, 0xde96, 0xf7be, 0xffdf, 0xff9e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xe7fe, 0xefdf, 0xf79f, 0xff5c, 0xdd90, 0xc446, 0xe4c6, 0xece5, 0xed48, 0xed69, 0xf5ca, 0xfe4b, 0xfe8c, 0xfe8b, 0xfeac, 0xff0d, 0xff0d, 0xf70d, 0xff2d, 0xff4e, 0xff4d, 0xff4d, 0xff8d, 0xff8e, 0xff6f, 0xff6e, 0xff8f, 0xffb0, 0xff90, 0xff90, 0xff90, 0xff90, 0xff8e, 0xffd1, 0xd5ec, 0x7281, 0x4900, 0x69c2, 0x8264, 0x71e2, 0x69c1, 0x8284, 0x5980, 0x4940, 0xac67, 0xff70, 0xffef, 0xffcd, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffae, 0xffae, 0xffaf, 0xffd0, 0xffaf, 0xff8e, 0xff8d, 0xef0a, 0xd60a, 0xe66b, 0xf70d, 0xff8f, 0xffd0, 0xffd0, 0xffaf, 0xff8e, 0xff51, 0xff71, 0xff71, 0xff90, 0xff6f, 0xff6f, 0xff6e, 0xff8f, 0xff6f, 0xff8e, 0xff6d, 0xff8d, 0xff6c, 0xff4c, 0xff6d, 0xff4e, 0xff2d, 0xff0d, 0xfecc, 0xfeac, 0xfe8c, 0xfe2b, 0xf5ca, 0xed69, 0xed2a, 0xed07, 0xe4a4, 0xbc45, 0xcdf2, 0xf79e, 0xf79f, 0xff7e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xefbf, 0xffdf, 0xf6b7, 0xcc49, 0xe486, 0xe4c6, 0xe548, 0xe547, 0xeda8, 0xfe0a, 0xfe4b, 0xfe6b, 0xfe8b, 0xfeac, 0xfeec, 0xff0c, 0xff0d, 0xff0d, 0xff2d, 0xff2d, 0xff4d, 0xff4e, 0xff6e, 0xff6e, 0xff6e, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff8f, 0xffaf, 0xff71, 0x9365, 0x6180, 0x71e0, 0x8260, 0x7a40, 0x8ac2, 0x8261, 0x8a82, 0x7a21, 0x69a0, 0x7a81, 0xf6f0, 0xfff1, 0xf7ae, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffef, 0xfff0, 0xff8f, 0xff91, 0xff93, 0xee2f, 0xabe8, 0x7a43, 0x59c0, 0x7242, 0x8b25, 0xddad, 0xff52, 0xffb1, 0xff8f, 0xffef, 0xff8f, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff4d, 0xff4d, 0xff2d, 0xff2d, 0xff2d, 0xfeec, 0xfecc, 0xfeac, 0xfe8b, 0xfe6b, 0xfe2a, 0xf5e9, 0xedc9, 0xf548, 0xe529, 0xdd08, 0xd4c5, 0xcc67, 0xfe97, 0xffbf, 0xe7de, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7de, 0xefbe, 0xf77d, 0xddf4, 0xcc28, 0xe486, 0xece6, 0xe548, 0xed67, 0xeda8, 0xfe0a, 0xfe4b, 0xfe6b, 0xfe8b, 0xfeac, 0xfeec, 0xfeec, 0xff0c, 0xff0d, 0xff2d, 0xff2d, 0xff4d, 0xff4e, 0xff4e, 0xff6e, 0xff6e, 0xff6e, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff8f, 0xee8e, 0x7aa2, 0x69a0, 0x7a20, 0x8ac2, 0x8aa1, 0x8ae3, 0x8ac2, 0x8aa3, 0x7a21, 0x69e0, 0x6a20, 0xee6e, 0xffd1, 0xffcf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffae, 0xf76e, 0xffb0, 0xff91, 0xcd8b, 0x82e3, 0x5980, 0x5940, 0x5160, 0x5140, 0x5140, 0x7a81, 0xcd6b, 0xffb2, 0xff8f, 0xf78d, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff4d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xfeec, 0xfecc, 0xfeac, 0xfe8b, 0xfe6b, 0xfe4a, 0xf60a, 0xf5c9, 0xf548, 0xe529, 0xdd08, 0xd4c5, 0xcc66, 0xedf4, 0xff7e, 0xe7de, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xeefa, 0xc4ee, 0xcc27, 0xe486, 0xed07, 0xed48, 0xed88, 0xf5a9, 0xfe0a, 0xfe4b, 0xfe6b, 0xfe8b, 0xfeac, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff2d, 0xff4d, 0xff4d, 0xff4e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff8f, 0xc569, 0x61e0, 0x71e0, 0x8a82, 0x9303, 0x9303, 0x9303, 0x9303, 0x8ac3, 0x8262, 0x7a41, 0x61c0, 0xde0c, 0xff8f, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffaf, 0xffae, 0xf74e, 0xfff1, 0xee8e, 0x8b63, 0x5160, 0x5940, 0x7221, 0x6a21, 0x61e0, 0x61a0, 0x5120, 0x8b22, 0xf6ce, 0xffb0, 0xf78e, 0xff8e, 0xff8e, 0xff8e, 0xff8e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff4d, 0xff4d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xfeec, 0xfecc, 0xfeac, 0xfe8b, 0xfe8b, 0xfe4b, 0xf60a, 0xf5e9, 0xf568, 0xed29, 0xe508, 0xd4c5, 0xcc46, 0xccee, 0xf71b, 0xefbd, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xefbf, 0xffbd, 0xee76, 0xbc29, 0xd447, 0xe4a6, 0xed27, 0xed28, 0xed88, 0xf5c9, 0xfe0a, 0xfe4b, 0xfe6b, 0xfeab, 0xfeac, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff2d, 0xff2d, 0xff4d, 0xff4d, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff8e, 0xffaf, 0xb4a6, 0x5980, 0x7a42, 0x8ac3, 0x9302, 0x9303, 0x92e3, 0x9303, 0x92e3, 0x8ac3, 0x82a3, 0x59a0, 0xddec, 0xff6f, 0xf7ae, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xffaf, 0xffd0, 0xff50, 0xa446, 0x59c0, 0x61a0, 0x7200, 0x8262, 0x7a61, 0x7221, 0x8262, 0x6180, 0x59a0, 0xc528, 0xffd0, 0xffae, 0xff8e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff4e, 0xff4e, 0xff4d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfecc, 0xfeac, 0xfe8b, 0xfe8b, 0xfe4b, 0xf60a, 0xf5e9, 0xf589, 0xed48, 0xe528, 0xdcc6, 0xd466, 0xbc29, 0xee97, 0xf79d, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xefbf, 0xff9c, 0xe5d1, 0xbbe6, 0xdc86, 0xe4c7, 0xed07, 0xed27, 0xf5a9, 0xf5c9, 0xfe0a, 0xfe4b, 0xfe6b, 0xfeab, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff2d, 0xff2d, 0xff4d, 0xff4e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xffaf, 0xac66, 0x59a0, 0x8aa3, 0x92c3, 0x92e2, 0x9323, 0x9304, 0x9303, 0x9303, 0x92c3, 0x8282, 0x6a00, 0xe64d, 0xffb0, 0xf7ae, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff8f, 0xff6e, 0xfff1, 0xde4d, 0x7280, 0x5160, 0x7a41, 0x8261, 0x8241, 0x82a1, 0x7a41, 0x8262, 0x7201, 0x5960, 0x9be4, 0xff90, 0xff8e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff4e, 0xff4d, 0xff4d, 0xff4d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xff0d, 0xfecc, 0xfecc, 0xfeac, 0xfe8b, 0xfe8b, 0xfe4b, 0xf60a, 0xf5e9, 0xf589, 0xed48, 0xe528, 0xe4c7, 0xdc86, 0xbbe5, 0xe5f2, 0xff7d, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xefbf, 0xf73a, 0xdd0d, 0xcbe4, 0xe4a6, 0xe4e7, 0xed08, 0xed28, 0xf5c9, 0xf5c9, 0xfe0a, 0xfe2a, 0xfe6b, 0xfe8b, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xff0d, 0xff2d, 0xff2d, 0xff2d, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff6e, 0xff6e, 0xff8f, 0xb4a6, 0x61c0, 0x8aa3, 0x92c3, 0x92e2, 0x9b44, 0x9b45, 0x9b23, 0x9b24, 0x8ac3, 0x7a21, 0x82c1, 0xf6cf, 0xffd0, 0xffce, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6e, 0xffb1, 0xbd08, 0x6200, 0x6a00, 0x8aa3, 0x8a82, 0x92e3, 0x9302, 0x9303, 0x8a83, 0x8263, 0x69c0, 0x8301, 0xf70e, 0xffae, 0xff6e, 0xff6e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4d, 0xff4d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfecc, 0xfeac, 0xfeab, 0xfe8b, 0xfe6b, 0xfe4a, 0xf60a, 0xf5e9, 0xf589, 0xed68, 0xe527, 0xe4e7, 0xe4a6, 0xc404, 0xcd2d, 0xff1b, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xe79f, 0xeeb8, 0xcc68, 0xd403, 0xe4a5, 0xe507, 0xe507, 0xf548, 0xf5c9, 0xf5c9, 0xfe0a, 0xfe2a, 0xfe6b, 0xfe8b, 0xfeab, 0xfeab, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff2d, 0xff2d, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff8f, 0xc529, 0x6a20, 0x8283, 0x92c3, 0x9b23, 0x9b44, 0x9b45, 0x9b23, 0x9b23, 0x8aa2, 0x7220, 0xac06, 0xff50, 0xffd0, 0xf7ae, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6f, 0xff6e, 0xff50, 0x9c05, 0x59a0, 0x7a42, 0x8a83, 0x8a82, 0x9b03, 0x8ae1, 0x9303, 0x8aa3, 0x8a84, 0x69c0, 0x7aa0, 0xf6ad, 0xff8e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4d, 0xff2d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfeac, 0xfeac, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe2a, 0xf60a, 0xf5e9, 0xf589, 0xed87, 0xe527, 0xecc8, 0xeca6, 0xd443, 0xbc69, 0xf6ba, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xe77f, 0xe656, 0xc3e6, 0xdc23, 0xe4a5, 0xe507, 0xe508, 0xfd69, 0xf5c9, 0xf5c9, 0xf5ea, 0xf62a, 0xfe4b, 0xfe8b, 0xfe8b, 0xf6ab, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff2d, 0xff2e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xffaf, 0xd5aa, 0x7261, 0x7a62, 0x92e3, 0x9b43, 0x9b23, 0x9324, 0x9302, 0x9303, 0x8aa2, 0x7a41, 0xcd0a, 0xffb2, 0xffaf, 0xef6c, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff50, 0x93a4, 0x59a0, 0x82a3, 0x9b05, 0x9b04, 0x9b03, 0x9b62, 0x92e2, 0x9ae4, 0x92c5, 0x71c0, 0x8b22, 0xff0e, 0xff4d, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff2e, 0xff2d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfeec, 0xfeac, 0xfeab, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe2a, 0xf60a, 0xf5c9, 0xf5aa, 0xed87, 0xe527, 0xecc8, 0xeca6, 0xd462, 0xabc5, 0xee38, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 
0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf79e, 0xff5e, 0xcd2e, 0xc405, 0xdc45, 0xecc6, 0xe505, 0xe526, 0xf56a, 0xedc9, 0xf5ea, 0xf60a, 0xf62b, 0xf64b, 0xf66b, 0xfe8b, 0xfe8c, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff8e, 0xf6ad, 0x9383, 0x69e0, 0x9b46, 0xa366, 0x8a82, 0xa324, 0x9ae5, 0x9b05, 0x7a20, 0x9bc4, 0xff0f, 0xffb0, 0xef2c, 0xf78d, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6e, 0xff6d, 0xff4f, 0x8b21, 0x71c0, 0x92a5, 0x8a63, 0x9b46, 0x9b44, 0xa324, 0xa325, 0x9263, 0x9ae5, 0x71e0, 0x8b42, 0xff8f, 0xef2c, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfeac, 0xf68b, 0xf68b, 0xf66b, 0xfe6b, 0xf64a, 0xf60a, 0xf5e9, 0xf5ca, 0xed68, 0xe527, 0xe527, 0xe508, 0xcc46, 0xcc07, 0xe4ca, 0xef7c, 0xf79f, 0xf79f, 0xf7dd, 0xf7dd, 
0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf79e, 0xf71c, 0xc4cd, 0xc405, 0xe466, 0xecc7, 0xe526, 0xe526, 0xf58a, 0xf5c9, 0xf5ea, 0xf60a, 0xf62b, 0xf64b, 0xf66b, 0xf66b, 0xfe8c, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff4d, 0xffb0, 0xd58a, 0x7aa1, 0x7241, 0x9304, 0x9b24, 0x9b43, 0x9304, 0x7240, 0x9323, 0xee2d, 0xffd2, 0xff8f, 0xf76d, 0xff8d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff8e, 0xff0e, 0x8b42, 0x71e0, 0x92a4, 0x8aa4, 0x9b25, 0x8ae3, 0xa344, 0x9ae4, 0x9ac4, 0x92a4, 0x69c0, 0x9be4, 0xff8f, 0xffce, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfeab, 0xf68b, 0xf66b, 0xf66b, 0xfe4b, 0xfe2a, 0xf60a, 0xf5e9, 0xf5aa, 0xed88, 0xe527, 0xe527, 0xe4e7, 0xd446, 0xcc07, 0xdc89, 0xef5b, 0xf79f, 0xf79f, 0xf7de, 0xf7de, 
0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf79e, 0xee99, 0xbc6a, 0xc3e4, 0xe487, 0xece7, 0xe506, 0xe527, 0xf58a, 0xf5a9, 0xf5ca, 0xf60a, 0xfe2b, 0xf64b, 0xf64b, 0xfe6b, 0xfe8c, 0xfeab, 0xfeac, 0xfeac, 0xfecc, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xeeeb, 0xff8f, 0xf6ef, 0xbcc8, 0x82e2, 0x7a81, 0x82e1, 0x82e1, 0x72a0, 0x8b62, 0xd5aa, 0xff91, 0xff6f, 0xf74d, 0xffae, 0xff6c, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff6e, 0xff4f, 0xac25, 0x7220, 0x8aa3, 0x9b05, 0x9b25, 0x9b44, 0x9b44, 0x9b04, 0xab87, 0x8a82, 0x7a40, 0xcd69, 0xff8f, 0xff8d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfecc, 0xfeac, 0xfeac, 0xfe8b, 0xf68b, 0xf66b, 0xf64b, 0xfe4b, 0xfe2a, 0xf60a, 0xf5e9, 0xf5aa, 0xed89, 0xe527, 0xe507, 0xe4e7, 0xd466, 0xcc26, 0xd427, 0xe6f9, 0xf77e, 0xf79f, 0xf7de, 0xf7de, 
0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf79e, 0xef7d, 0xe616, 0xb408, 0xc3e4, 0xe4a7, 0xe4c7, 0xdd06, 0xe547, 0xf58a, 0xf5a9, 0xf5c9, 0xf60a, 0xfe2a, 0xf62b, 0xf64b, 0xf66b, 0xfe6b, 0xfe8b, 0xfeab, 0xfeac, 0xfeac, 0xfecc, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff2d, 0xff2d, 0xff2d, 0xffce, 0xff6e, 0xffb1, 0xff50, 0xcd8a, 0x9be4, 0x8b62, 0x9382, 0xace6, 0xe6cd, 0xfff2, 0xffaf, 0xf72d, 0xff4d, 0xff8d, 0xff4c, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff90, 0xbd07, 0x6a40, 0x7a81, 0x9b45, 0x9304, 0x9b24, 0x92e3, 0x9303, 0x9b44, 0x6a00, 0x8b42, 0xf6ce, 0xff8f, 0xef0b, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfecc, 0xfeac, 0xfeac, 0xfeab, 0xfe8b, 0xf68b, 0xf66b, 0xfe4b, 0xfe4a, 0xfe2a, 0xf60a, 0xf5c9, 0xf589, 0xf589, 0xed48, 0xe4e6, 0xdcc6, 0xdc87, 0xd426, 0xc3c5, 0xde76, 0xff7d, 0xf79f, 0xf7de, 0xf7de, 
0xffdf, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf79e, 0xef7d, 0xe5b3, 0xb406, 0xcc03, 0xe4a7, 0xdca7, 0xdce6, 0xe527, 0xf56a, 0xf5a9, 0xf5c9, 0xf5ea, 0xfe0a, 0xf62a, 0xf64b, 0xf66b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfeab, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xf72c, 0xf70c, 0xff4e, 0xffd1, 0xffb1, 0xff70, 0xff50, 0xff90, 0xff8f, 0xfff0, 0xffaf, 0xf74d, 0xff6d, 0xff4d, 0xf70b, 0xff4c, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff4d, 0xff8f, 0xe62b, 0x8321, 0x7240, 0x9b44, 0x9b45, 0x9b24, 0xa365, 0x9303, 0x7a80, 0x7280, 0xc508, 0xff90, 0xff6e, 0xff2c, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfeac, 0xfe8b, 0xfe8b, 0xfe8b, 0xf66b, 0xf64b, 0xfe4a, 0xfe2a, 0xfe0a, 0xf5e9, 0xf5c9, 0xf569, 0xf589, 0xed48, 0xe4e6, 0xdcc6, 0xdca6, 0xd426, 0xc3a4, 0xd5f3, 0xff5d, 0xff9f, 0xf7de, 0xf7de, 
0xffdf, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf79e, 0xef5d, 0xdd4f, 0xbc06, 0xd423, 0xe4a7, 0xdca7, 0xdce6, 0xe527, 0xf54a, 0xf589, 0xf5a9, 0xf5ea, 0xf60a, 0xf60a, 0xf62b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfeab, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xf70c, 0xff2d, 0xf70c, 0xf6ec, 0xff2d, 0xff6f, 0xff6f, 0xff6f, 0xffaf, 0xf70c, 0xf70c, 0xf72d, 0xf70c, 0xff4d, 0xff4d, 0xff0c, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff0c, 0xff6e, 0xff90, 0xbd28, 0x7280, 0x7a80, 0x9b24, 0x9ae4, 0x92e3, 0x8280, 0x7a80, 0xb486, 0xff2f, 0xffb0, 0xff0c, 0xff6d, 0xff2d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfeac, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xf66b, 0xf64a, 0xf64a, 0xfe2a, 0xfe0a, 0xf5e9, 0xf5c9, 0xf56a, 0xf569, 0xed48, 0xe507, 0xdca6, 0xdca6, 0xd445, 0xc3a4, 0xc551, 0xff3c, 0xf79f, 0xf7de, 0xf7de, 
0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xef7d, 0xef5d, 0xcccc, 0xbc05, 0xd463, 0xe4a7, 0xdcc7, 0xdd27, 0xe527, 0xf549, 0xf589, 0xf5a9, 0xf5ea, 0xfdea, 0xf60a, 0xf62a, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff2c, 0xff0c, 0xff0c, 0xff2c, 0xff2c, 0xff0c, 0xff0d, 0xff2e, 0xff2d, 0xff0c, 0xff8f, 0xff6e, 0xf6cc, 0xff2e, 0xff6f, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xfeed, 0xf70d, 0xffb0, 0xeecd, 0xa445, 0x82e1, 0x8aa2, 0x92a3, 0x8281, 0x8ae2, 0xac66, 0xe66c, 0xffb0, 0xff4e, 0xfeeb, 0xff0c, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfeac, 0xfeab, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xf66b, 0xf64a, 0xfe2a, 0xfe2a, 0xfe0a, 0xf5c9, 0xf5c9, 0xf56a, 0xf549, 0xed48, 0xed07, 0xdca5, 0xdc86, 0xdc45, 0xc3c4, 0xbcee, 0xff3b, 0xf77e, 0xf7de, 0xf7de, 
0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xef7d, 0xef5d, 0xc46a, 0xc404, 0xdc84, 0xe4a7, 0xdcc8, 0xdd47, 0xe547, 0xf529, 0xf589, 0xf5a9, 0xfdca, 0xfdea, 0xf60a, 0xf62a, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfeab, 0xfeac, 0xfeac, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff2d, 0xfeec, 0xff2c, 0xff4c, 0xff0b, 0xff2c, 0xff2d, 0xff0d, 0xff0d, 0xfecc, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xf6ed, 0xff4f, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff8f, 0xf6ec, 0xeeec, 0xffd1, 0xff92, 0xd58c, 0xabc6, 0xab86, 0xbc27, 0xdd6b, 0xff72, 0xffd1, 0xf70d, 0xff2d, 0xff2d, 0xfecb, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeab, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xf64a, 0xfe2a, 0xfe2a, 0xfe0a, 0xf5c9, 0xf5a9, 0xf56a, 0xed49, 0xf548, 0xed27, 0xdca5, 0xdc85, 0xdc65, 0xcbc4, 0xbcad, 0xff1b, 0xf77e, 0xefde, 0xefde, 
0xf7df, 0xf7bf, 0xffdf, 0xffdf, 0xf79e, 0xff9e, 0xf77d, 0xe6fb, 0xc3a5, 0xcc06, 0xd446, 0xdca6, 0xe4c6, 0xe4e7, 0xed28, 0xed49, 0xed88, 0xf5a9, 0xf5c9, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xfe2b, 0xfe4b, 0xf66b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0c, 0xff0c, 0xff0c, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff2d, 0xff4e, 0xff6e, 0xff8e, 0xff8f, 0xffaf, 0xff8f, 0xff6e, 0xff4e, 0xff2d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfecc, 0xfeac, 0xfeac, 0xfeab, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe2b, 0xfe2b, 0xfe0a, 0xfe0a, 0xfdea, 0xf5ea, 0xf5c9, 0xf5a9, 0xf568, 0xed69, 0xed48, 0xe4e7, 0xe4c7, 0xdca7, 0xd465, 0xcbe4, 0xc428, 0xf6fb, 0xe79e, 0xf7be, 0xf7be, 
0xf7df, 0xf7bf, 0xffdf, 0xffdf, 0xffbe, 0xff9e, 0xf77d, 0xe6fb, 0xc3a5, 0xcbe6, 0xd446, 0xdca6, 0xe4c6, 0xe4e7, 0xed28, 0xed49, 0xed88, 0xf5a9, 0xf5c9, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfeab, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0c, 0xff0c, 0xff0c, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff4e, 0xff4d, 0xff2d, 0xff0d, 0xff0c, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfeab, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe2b, 0xfe2a, 0xf60a, 0xfdea, 0xfdea, 0xf5ea, 0xf5c9, 0xf5a9, 0xf568, 0xed68, 0xed28, 0xe4e7, 0xe4c7, 0xdca7, 0xd465, 0xcc04, 0xc407, 0xf6da, 0xe79e, 0xf7bf, 0xf7bf, 
0xf7df, 0xf7bf, 0xffdf, 0xffdf, 0xffbe, 0xff9e, 0xf77d, 0xdeda, 0xc3a5, 0xcbe6, 0xd446, 0xdca6, 0xe4c6, 0xe4e7, 0xed28, 0xed49, 0xed88, 0xf5a9, 0xf5c9, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xfe2a, 0xfe4a, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfeab, 0xfeac, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xf70c, 0xff0c, 0xff0c, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xfeed, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfeac, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe2b, 0xfe2a, 0xf60a, 0xfdea, 0xfdea, 0xf5ea, 0xf5a9, 0xf5a9, 0xed68, 0xed68, 0xed28, 0xe4e7, 0xe4c7, 0xdca7, 0xd465, 0xcc04, 0xbbc6, 0xee99, 0xe79d, 0xf7de, 0xf7de, 
0xffdf, 0xf7bf, 0xffdf, 0xffdf, 0xffbe, 0xff9e, 0xf75d, 0xdeba, 0xc3a5, 0xcbe5, 0xd446, 0xdca6, 0xe4c6, 0xe4e7, 0xed28, 0xed49, 0xed68, 0xf589, 0xf5c9, 0xf5ca, 0xf5ea, 0xf5ea, 0xf60a, 0xfe2a, 0xf64a, 0xfe4a, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfeab, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xf6ec, 0xf6ec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2b, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5a9, 0xf589, 0xed68, 0xed48, 0xe528, 0xe4e7, 0xdcc7, 0xdca7, 0xd465, 0xcc04, 0xbb85, 0xe679, 0xe77d, 0xf7be, 0xf7be, 
0xffdf, 0xf7bf, 0xffdf, 0xffdf, 0xffbe, 0xff9e, 0xef5c, 0xdeba, 0xc3a5, 0xcbe5, 0xd446, 0xdca6, 0xe4c6, 0xe4e7, 0xe508, 0xed29, 0xed68, 0xed89, 0xf5a9, 0xf5c9, 0xf5ca, 0xf5ea, 0xf60a, 0xf60a, 0xfe2a, 0xfe2a, 0xfe4a, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff0d, 0xff2d, 0xf6ec, 0xfeec, 0xfeec, 0xff0d, 0xfeed, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2a, 0xfe2a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5a9, 0xed89, 0xed48, 0xed48, 0xe527, 0xe4e7, 0xdcc7, 0xdca7, 0xd465, 0xcc04, 0xbb85, 0xe658, 0xe77d, 0xf79e, 0xf79e, 
0xffdf, 0xf7bf, 0xffdf, 0xffdf, 0xffbe, 0xffbe, 0xef5c, 0xd699, 0xc385, 0xcbe5, 0xd446, 0xdca6, 0xe4c6, 0xe4e7, 0xe508, 0xed29, 0xed68, 0xed88, 0xf5a9, 0xf5c9, 0xf5c9, 0xf5ea, 0xf5ea, 0xf60a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xff0d, 0xfeed, 0xfeed, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe4b, 0xfe4b, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5a9, 0xed88, 0xed48, 0xed48, 0xe527, 0xe4e7, 0xdcc7, 0xdca7, 0xd465, 0xcc04, 0xbb85, 0xe658, 0xef7d, 0xf79d, 0xf79d, 
0xffdf, 0xf7bf, 0xf7bf, 0xffdf, 0xffbe, 0xffbe, 0xef5c, 0xd699, 0xc385, 0xcbe5, 0xd446, 0xdca6, 0xe4c6, 0xe4e7, 0xe508, 0xed28, 0xed68, 0xed88, 0xf5a9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5ea, 0xf60a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe4a, 0xfe4b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe2a, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ca, 0xf5ca, 0xf5c9, 0xf5a9, 0xed88, 0xed48, 0xed48, 0xe507, 0xe4e7, 0xdcc7, 0xdca7, 0xd465, 0xcc04, 0xbb85, 0xe638, 0xef9d, 0xf7bd, 0xf7bd, 
0xffdf, 0xf7bf, 0xf7bf, 0xffdf, 0xffbf, 0xffbe, 0xef3c, 0xd679, 0xc385, 0xcbe5, 0xd446, 0xdca6, 0xe4c6, 0xe4e7, 0xe508, 0xed28, 0xed68, 0xed88, 0xeda9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5ea, 0xf60a, 0xfe0a, 0xfe2a, 0xfe2a, 0xfe4a, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeec, 0xfeec, 0xfeec, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe2a, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5c9, 0xf589, 0xed88, 0xed48, 0xed48, 0xe507, 0xdcc7, 0xdcc7, 0xdca7, 0xd465, 0xcc04, 0xbb64, 0xe637, 0xef9d, 0xffbe, 0xffbe, 
0xf7df, 0xf7df, 0xf7df, 0xf7be, 0xffdf, 0xf7be, 0xef3c, 0xdeba, 0xc3a5, 0xcbe5, 0xdc25, 0xdc46, 0xe488, 0xe4c9, 0xe507, 0xe546, 0xed48, 0xed68, 0xf589, 0xf5a9, 0xf5a9, 0xf5c9, 0xf5ca, 0xf5ea, 0xf60a, 0xf60a, 0xfe0a, 0xfe2a, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfeab, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfeab, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4b, 0xfe2a, 0xfe2a, 0xfe0a, 0xf60a, 0xf60a, 0xf5ea, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf589, 0xed68, 0xed28, 0xed28, 0xe4e7, 0xdca6, 0xdca6, 0xdc86, 0xd425, 0xcbe4, 0xb366, 0xe658, 0xef9c, 0xffbe, 0xffbe, 
0xf7df, 0xf7df, 0xf7df, 0xf7be, 0xffdf, 0xf7be, 0xef3d, 0xdebb, 0xc3a5, 0xc3e5, 0xd425, 0xdc66, 0xe488, 0xe4c9, 0xe4e7, 0xe546, 0xed48, 0xed68, 0xf589, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5ca, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xfe2a, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf589, 0xed68, 0xed28, 0xed28, 0xe4e7, 0xdca6, 0xdca6, 0xdc86, 0xd425, 0xcbe4, 0xbba7, 0xe678, 0xef9c, 0xffbe, 0xffbe, 
0xf7df, 0xf7df, 0xf7df, 0xf7be, 0xffdf, 0xf7be, 0xef5d, 0xdedb, 0xbbc6, 0xc3c5, 0xd425, 0xdc66, 0xe487, 0xe4a8, 0xe4e7, 0xe526, 0xed48, 0xed48, 0xf589, 0xf589, 0xf5a9, 0xf5a9, 0xf5c9, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfeab, 0xfeac, 0xfeac, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfecc, 0xfeac, 0xfeac, 0xfeab, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2a, 0xfe0a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xed88, 0xed48, 0xed28, 0xed28, 0xe4e7, 0xdca6, 0xdc86, 0xdc66, 0xd425, 0xc3c4, 0xbbe8, 0xeeb9, 0xef9d, 0xff9e, 0xff9e, 
0xf7de, 0xf7df, 0xf7df, 0xf7be, 0xf7be, 0xf7be, 0xef5d, 0xe6fb, 0xc3e8, 0xbba5, 0xcc25, 0xdc66, 0xe487, 0xe4a8, 0xe4c7, 0xe527, 0xed27, 0xed48, 0xf568, 0xf589, 0xf5a9, 0xf5a9, 0xf5c9, 0xf5ca, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xf62a, 0xf62b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeab, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5c9, 0xf5a9, 0xf589, 0xed68, 0xed48, 0xed28, 0xe508, 0xe4e7, 0xdca6, 0xdc86, 0xdc66, 0xd405, 0xc3a3, 0xbc2a, 0xeeba, 0xef9d, 0xff9e, 0xff9e, 
0xf7be, 0xf7df, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf77d, 0xe71c, 0xc44a, 0xb3a5, 0xcc25, 0xdc65, 0xdc86, 0xe4a8, 0xdcc7, 0xe507, 0xed27, 0xed48, 0xed68, 0xf589, 0xf589, 0xf5a9, 0xf5c9, 0xf5c9, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xf62b, 0xfe4b, 0xf64b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfeab, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeab, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2a, 0xf60a, 0xf60a, 0xf60a, 0xf5e9, 0xf5ea, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xed68, 0xed48, 0xe508, 0xe507, 0xe4e7, 0xdca6, 0xdc86, 0xd466, 0xcc05, 0xc3a3, 0xbc6b, 0xeedb, 0xef9d, 0xff9e, 0xff9e, 
0xf7be, 0xf7df, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf77d, 0xef3c, 0xd4ad, 0xb3a6, 0xc404, 0xd465, 0xdc66, 0xe4a7, 0xdca7, 0xe507, 0xed27, 0xed48, 0xed68, 0xf589, 0xed89, 0xf5a9, 0xf5a9, 0xf5c9, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xf62a, 0xf62b, 0xf64b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfeab, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeab, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4b, 0xfe4a, 0xf64a, 0xf62a, 0xf60a, 0xf60a, 0xf5e9, 0xf5e9, 0xf5ea, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xed68, 0xed48, 0xe507, 0xe507, 0xe4e7, 0xdca6, 0xdc86, 0xd446, 0xcbe4, 0xbb83, 0xc4ad, 0xef1c, 0xefbd, 0xff9e, 0xff9e, 
0xf7be, 0xf7df, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf77e, 0xef3d, 0xdd0f, 0xb3a6, 0xbbe4, 0xd465, 0xdc86, 0xe4a7, 0xdca6, 0xe4e7, 0xe527, 0xed48, 0xed68, 0xed88, 0xed89, 0xf589, 0xf5a9, 0xf5c9, 0xf5c9, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xf62a, 0xf62b, 0xf64b, 0xfe4a, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4b, 0xf64a, 0xf64a, 0xf62a, 0xf62a, 0xf60a, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5c9, 0xf5c9, 0xeda9, 0xeda9, 0xf5a9, 0xed88, 0xed68, 0xed48, 0xe507, 0xe507, 0xe4c7, 0xdca6, 0xdc86, 0xd445, 0xcbe4, 0xbb62, 0xcd0f, 0xef5d, 0xefbe, 0xff9e, 0xff9e, 
0xf7be, 0xf7df, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xef5d, 0xe551, 0xaba7, 0xbbe4, 0xd464, 0xdc86, 0xe4c7, 0xdca6, 0xe4e7, 0xe527, 0xed48, 0xed68, 0xed68, 0xed88, 0xf589, 0xf5a9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5ea, 0xf60a, 0xf60a, 0xf62a, 0xf62b, 0xf62b, 0xfe4a, 0xfe4a, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4b, 0xfe4b, 0xf64a, 0xf64a, 0xf62a, 0xf62a, 0xf60a, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5c9, 0xf5c9, 0xeda9, 0xeda9, 0xf589, 0xed88, 0xed68, 0xed48, 0xe507, 0xe507, 0xe4c7, 0xdc86, 0xdc66, 0xd445, 0xcbc4, 0xbb62, 0xd571, 0xf77e, 0xefbe, 0xff9d, 0xff9d, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xef7d, 0xee56, 0xa388, 0xc3a4, 0xdc03, 0xd424, 0xdcc7, 0xd487, 0xe4e8, 0xe4e7, 0xed08, 0xed28, 0xed49, 0xf569, 0xf589, 0xf5a9, 0xf5a9, 0xf5ca, 0xf5a9, 0xf5ca, 0xfe2b, 0xfe2b, 0xf5e9, 0xfde9, 0xfe2a, 0xfe2b, 0xfe4b, 0xf62b, 0xfe4b, 0xfe8b, 0xfe8b, 0xf66a, 0xfeab, 0xf68b, 0xf68b, 0xf68c, 0xfeac, 0xfeac, 0xfeac, 0xfeac, 0xfecc, 0xfea8, 0xfea8, 0xfec9, 0xfeca, 0xfeab, 0xfeac, 0xfeac, 0xfead, 0xfeab, 0xfeab, 0xfeab, 0xfeab, 0xfeab, 0xfeab, 0xfecc, 0xfecc, 0xfeaa, 0xfeaa, 0xfe8b, 0xfe8c, 0xfe8c, 0xfe6d, 0xfe6e, 0xfe6e, 0xfeab, 0xf66b, 0xf66b, 0xfeac, 0xfecd, 0xfecc, 0xf6cb, 0xf6ca, 0xfeab, 0xfeab, 0xfeab, 0xfe8b, 0xfe8b, 0xf68b, 0xf68b, 0xf68b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe4a, 0xf62b, 0xf62b, 0xf62a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xf569, 0xed49, 0xed28, 0xed28, 0xe4c5, 0xdce7, 0xd4a7, 0xdc87, 0xe445, 0xdbe4, 0xcba5, 0xbb86, 0xd67a, 0xe71c, 0xf79e, 0xffbf, 0xffbf, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xef7d, 0xee97, 0xb3e9, 0xbb84, 0xdc04, 0xdc44, 0xdca7, 0xd487, 0xe4c8, 0xe4e7, 0xe508, 0xed28, 0xed48, 0xf569, 0xf589, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5ca, 0xfdea, 0xfe0a, 0xf5ea, 0xf5c9, 0xf5e9, 0xfe2a, 0xf60a, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6a, 0xfe8b, 0xfe8c, 0xfeac, 0xfeac, 0xfeac, 0xf66b, 0xfe8b, 0xfeac, 0xfe8c, 0xfeed, 0xfead, 0xf66c, 0xf62c, 0xee0c, 0xe5cc, 0xe5ab, 0xdd6b, 0xdd89, 0xdd89, 0xdd89, 0xe5a9, 0xe5ea, 0xee0b, 0xf64c, 0xf66c, 0xfeac, 0xfeab, 0xfeab, 0xfecb, 0xfeab, 0xfeaa, 0xfeca, 0xfeca, 0xfecb, 0xfeab, 0xfe8b, 0xfe8b, 0xfe8c, 0xf68c, 0xf68b, 0xf68b, 0xfeab, 0xfeab, 0xfeab, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xf64a, 0xf62b, 0xf62a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xf569, 0xed48, 0xed28, 0xed28, 0xe4c6, 0xdcc7, 0xd4a7, 0xd487, 0xe446, 0xd3e4, 0xbb84, 0xbbc7, 0xdebb, 0xef3d, 0xf7be, 0xffbe, 0xffbe, 
0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xef7d, 0xf6f9, 0xbc8c, 0xb364, 0xd404, 0xdc65, 0xd486, 0xdca7, 0xe4c7, 0xe4e7, 0xe508, 0xed28, 0xed48, 0xed68, 0xf589, 0xf5a9, 0xf5a9, 0xeda9, 0xf5ea, 0xfdea, 0xeda9, 0xe568, 0xe568, 0xed88, 0xe588, 0xedc9, 0xf60a, 0xfe2b, 0xfe4b, 0xfe4a, 0xfe6b, 0xfe8b, 0xf66a, 0xf66b, 0xf66b, 0xfeac, 0xfeac, 0xf66b, 0xfeac, 0xfe8c, 0xee0a, 0xcd0c, 0xbc8a, 0xa3c7, 0x8b25, 0x82a3, 0x7241, 0x61e0, 0x5980, 0x5980, 0x61a0, 0x61a0, 0x69e1, 0x7243, 0x82c5, 0x9347, 0xa3a8, 0xc4a9, 0xd50a, 0xe5ab, 0xee2b, 0xf66b, 0xf68a, 0xfea9, 0xfea9, 0xfeab, 0xfeab, 0xfeab, 0xfeab, 0xfe8b, 0xfe6c, 0xfe8d, 0xfe8e, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2a, 0xfe2a, 0xf62a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5a9, 0xf5a9, 0xf589, 0xf589, 0xf569, 0xed48, 0xed28, 0xed08, 0xe4e6, 0xdcc6, 0xdca7, 0xd466, 0xe466, 0xd3c4, 0xb324, 0xcc6b, 0xe71c, 0xef7d, 0xf7be, 0xf7be, 0xf7be, 
0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xef7d, 0xef3b, 0xcd30, 0xab65, 0xcbc4, 0xdc65, 0xd446, 0xdca7, 0xe4a7, 0xe4e7, 0xe4e7, 0xe507, 0xed28, 0xed68, 0xed68, 0xed88, 0xf589, 0xf589, 0xfdca, 0xf5c9, 0xe568, 0xe568, 0xedc9, 0xedca, 0xe568, 0xe588, 0xed89, 0xf5ea, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe4a, 0xfe6b, 0xf64b, 0xfe8c, 0xfe8c, 0xf66b, 0xfe8c, 0xf62a, 0xcd06, 0x5120, 0x48e0, 0x40a0, 0x40c0, 0x4920, 0x5980, 0x6201, 0x6a22, 0x6a03, 0x6a03, 0x69e3, 0x61c2, 0x5981, 0x5120, 0x48e0, 0x40c0, 0x48c0, 0x5120, 0x69c1, 0x82a3, 0xa3a6, 0xc4a8, 0xdd8b, 0xee2d, 0xfe4d, 0xfe6d, 0xfe8c, 0xfe8b, 0xfe6b, 0xfe8b, 0xfe6c, 0xfe6c, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe8b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2a, 0xf62a, 0xfe2a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf589, 0xf569, 0xed48, 0xed28, 0xed08, 0xe508, 0xe4c6, 0xdca6, 0xdca7, 0xd425, 0xe466, 0xcbc5, 0xa325, 0xd50f, 0xe73c, 0xf77e, 0xf7be, 0xf7be, 0xf7be, 
0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xef3d, 0xd5b3, 0xab86, 0xc3a4, 0xd445, 0xd425, 0xdc87, 0xe486, 0xe4c7, 0xe4e7, 0xe507, 0xed28, 0xed48, 0xed68, 0xed88, 0xed88, 0xf588, 0xf5c9, 0xeda9, 0xe568, 0xf5ea, 0xfece, 0xfece, 0xf64c, 0xe568, 0xdd27, 0xe588, 0xfe2b, 0xfe6b, 0xfe4b, 0xfe6b, 0xfe4b, 0xfe8c, 0xf64b, 0xfe6b, 0xfe8c, 0xf66b, 0xfeac, 0xf64b, 0xd547, 0x7281, 0x9344, 0xb489, 0xddad, 0xf68f, 0xfed0, 0xff11, 0xff11, 0xff51, 0xff51, 0xff30, 0xfeef, 0xf68e, 0xe60c, 0xd58a, 0xcd49, 0x9b67, 0x82a4, 0x61a1, 0x48e0, 0x40a0, 0x5100, 0x69c1, 0x7a64, 0xabe7, 0xccea, 0xeded, 0xfe8e, 0xfe8c, 0xfe8b, 0xfe8a, 0xfecb, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xed68, 0xed48, 0xed28, 0xe508, 0xe4e7, 0xe4c6, 0xdc86, 0xdc87, 0xd425, 0xdc25, 0xc3a5, 0xa367, 0xddd3, 0xef3d, 0xf77d, 0xf7be, 0xf7be, 0xf7be, 
0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xe75e, 0xde57, 0xb409, 0xbb64, 0xcc05, 0xcc25, 0xdc66, 0xe486, 0xdcc7, 0xe4c7, 0xe4e7, 0xe508, 0xed48, 0xed68, 0xed68, 0xed68, 0xf588, 0xf5a9, 0xed88, 0xe568, 0xf60b, 0xff0f, 0xff30, 0xfe8e, 0xed89, 0xdd07, 0xdd07, 0xf5ca, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xf66b, 0xf64b, 0xfe6b, 0xf66b, 0xf64b, 0xfeac, 0xfecd, 0xfe6b, 0xfeee, 0xff2f, 0xff4f, 0xff2e, 0xfeec, 0xfecb, 0xfecb, 0xfeeb, 0xf6ac, 0xfecc, 0xfecc, 0xfeec, 0xfeed, 0xff0d, 0xff2e, 0xff4e, 0xff30, 0xff10, 0xfed0, 0xee0e, 0xc4ea, 0x9365, 0x69e0, 0x4900, 0x4900, 0x5980, 0x7a82, 0xb428, 0xe5ab, 0xfe4c, 0xfe6a, 0xfe69, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xf66b, 0xf66b, 0xfe4b, 0xfe4b, 0xfe4a, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xed88, 0xed68, 0xed28, 0xe508, 0xe4e7, 0xe4e7, 0xe4c6, 0xd486, 0xdc66, 0xd425, 0xd3e5, 0xbb85, 0xac0b, 0xe677, 0xef5d, 0xf77d, 0xf79e, 0xffbe, 0xffbe, 
0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xe77f, 0xeefa, 0xccac, 0xb364, 0xcbe5, 0xd426, 0xdc45, 0xe466, 0xdca6, 0xdcc7, 0xe4e7, 0xe507, 0xe528, 0xed48, 0xed68, 0xed68, 0xf588, 0xf5a9, 0xed88, 0xdd48, 0xe5aa, 0xfe8d, 0xfecf, 0xf66d, 0xfdeb, 0xe528, 0xd4a6, 0xe528, 0xf60a, 0xfe4b, 0xfe2b, 0xfe2b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xf62a, 0xfe4b, 0xfeac, 0xfeac, 0xfeab, 0xfeab, 0xfe8b, 0xf66a, 0xf66a, 0xf66a, 0xfeab, 0xfecb, 0xfe8c, 0xfe8c, 0xfe8d, 0xfe8d, 0xfe8d, 0xfe8c, 0xfe6c, 0xf66c, 0xfecb, 0xfeec, 0xff0d, 0xff2e, 0xff2f, 0xfeef, 0xfeae, 0xee4e, 0xa426, 0x6a60, 0x38c0, 0x38a0, 0x69c0, 0xa385, 0xdd6a, 0xfecd, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4a, 0xfe4a, 0xfe2a, 0xf62a, 0xf60a, 0xf60a, 0xfe0a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5a9, 0xf5a9, 0xf589, 0xf589, 0xf589, 0xed88, 0xed68, 0xed48, 0xed28, 0xe507, 0xe4e7, 0xe4c7, 0xdca6, 0xd466, 0xd446, 0xdc25, 0xcbc4, 0xb365, 0xbcae, 0xeefa, 0xef7d, 0xf79e, 0xf79e, 0xffbe, 0xffbe, 
0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xe79f, 0xf75c, 0xd52f, 0xb384, 0xc3e4, 0xd446, 0xd425, 0xe466, 0xdca6, 0xdcc7, 0xe4e7, 0xe507, 0xe528, 0xed48, 0xed68, 0xed68, 0xf588, 0xfdc9, 0xf5a9, 0xe568, 0xe5aa, 0xfe6d, 0xfecf, 0xfeaf, 0xfe2c, 0xed69, 0xcc85, 0xd4c6, 0xedc9, 0xfe4b, 0xfe2b, 0xf62a, 0xf62a, 0xf62a, 0xf62b, 0xfe4b, 0xf64b, 0xf64b, 0xfe4b, 0xfe6b, 0xfe6c, 0xfe6c, 0xf64c, 0xfe4c, 0xfe6c, 0xfe6c, 0xf64c, 0xf64c, 0xfe8b, 0xfe8a, 0xfe8a, 0xfe6a, 0xfe6a, 0xfe6a, 0xfe6a, 0xfe6a, 0xf68b, 0xee6b, 0xee4a, 0xee6b, 0xf6ac, 0xfeed, 0xfeed, 0xfeed, 0xff6f, 0xff30, 0xde10, 0x9ba9, 0x4900, 0x3880, 0x9324, 0xf64e, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4b, 0xfe4a, 0xf64a, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf5ea, 0xf5e9, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf589, 0xf589, 0xf589, 0xed88, 0xed68, 0xed48, 0xed28, 0xe507, 0xe4e7, 0xe4c7, 0xdc86, 0xd466, 0xd425, 0xdc25, 0xcb84, 0xb366, 0xc530, 0xef3c, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xef7e, 0xf77d, 0xee37, 0xb3ea, 0xab43, 0xd424, 0xd424, 0xd426, 0xdc86, 0xe486, 0xe4c7, 0xe4e7, 0xed07, 0xed27, 0xed48, 0xf568, 0xed69, 0xf589, 0xf568, 0xe527, 0xed88, 0xf62b, 0xfead, 0xf6ad, 0xf64b, 0xedaa, 0xdc86, 0xd426, 0xf5ab, 0xf60b, 0xf5ea, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6c, 0xfe6c, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xf66c, 0xfe8c, 0xff0e, 0xff2f, 0xedea, 0xbca5, 0xcd27, 0xfead, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xf64b, 0xf64b, 0xf64b, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf589, 0xf589, 0xf589, 0xf588, 0xed68, 0xed48, 0xed27, 0xed07, 0xe4e7, 0xe4c7, 0xdca6, 0xd486, 0xdc65, 0xdc03, 0xd3c4, 0xbb64, 0xb40b, 0xde57, 0xef5e, 0xf79e, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xef9e, 0xff7e, 0xee98, 0xc46c, 0xab64, 0xc3e3, 0xd425, 0xd426, 0xdc66, 0xdc86, 0xe4c7, 0xe4e7, 0xe4e7, 0xed07, 0xed48, 0xed68, 0xed48, 0xf589, 0xf568, 0xe527, 0xed68, 0xf62b, 0xfe8d, 0xf6ad, 0xf64c, 0xf5aa, 0xdc66, 0xcc05, 0xed8a, 0xf5eb, 0xf5ea, 0xfe0a, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe4a, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe8c, 0xfe6c, 0xfe6c, 0xfead, 0xfecd, 0xfead, 0xfead, 0xfead, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xf62b, 0xf62b, 0xf62b, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xf589, 0xf589, 0xf588, 0xed68, 0xed48, 0xed27, 0xe507, 0xe4e7, 0xe4c7, 0xdca6, 0xd486, 0xd445, 0xdc24, 0xd3c4, 0xb344, 0xbc8d, 0xeeb9, 0xef5e, 0xf79e, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff9e, 0xf6fa, 0xd571, 0xaba7, 0xb363, 0xd426, 0xd426, 0xdc66, 0xdc86, 0xe4a7, 0xe4c7, 0xe4e7, 0xe507, 0xed28, 0xed48, 0xed48, 0xf589, 0xf568, 0xe527, 0xe567, 0xf60a, 0xf68d, 0xf6ae, 0xfe6c, 0xf5aa, 0xd446, 0xc3e4, 0xed6a, 0xedeb, 0xedca, 0xfdea, 0xf60a, 0xf60a, 0xfe2a, 0xfe2a, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xf64a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe6b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe6b, 0xfe6b, 0xf64b, 0xf64b, 0xf62b, 0xee0a, 0xfe6c, 0xfead, 0xfe6c, 0xee0a, 0xfe4b, 0xfe4b, 0xf62b, 0xf62b, 0xf62b, 0xf62b, 0xf62b, 0xf62b, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf589, 0xf589, 0xf568, 0xf568, 0xed68, 0xed48, 0xe527, 0xe507, 0xe4e7, 0xe4c7, 0xdca6, 0xdc86, 0xdc66, 0xd425, 0xdc46, 0xc3a4, 0xab86, 0xd571, 0xf73b, 0xef7f, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bf, 0xf79e, 0xf73b, 0xee76, 0xb44b, 0xa324, 0xcbe6, 0xd405, 0xd446, 0xdc66, 0xdc87, 0xe4a7, 0xe4c7, 0xe4e7, 0xe508, 0xed28, 0xe528, 0xed69, 0xf568, 0xe527, 0xe547, 0xedea, 0xf68d, 0xf6ae, 0xfe8c, 0xf5aa, 0xd445, 0xc3a4, 0xe549, 0xedea, 0xedca, 0xfde9, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe4a, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe4b, 0xfe4b, 0xf64b, 0xf64b, 0xfe4b, 0xfe6b, 0xf64b, 0xf60a, 0xf62a, 0xf64b, 0xfe2b, 0xfe2b, 0xfe2b, 0xf62a, 0xf62a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xf568, 0xf568, 0xf568, 0xed48, 0xed48, 0xe507, 0xe4e7, 0xe4e7, 0xe4a7, 0xdc86, 0xdc66, 0xdc46, 0xd425, 0xcc06, 0xab45, 0xb40a, 0xee76, 0xf77d, 0xef9f, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbf, 0xef7d, 0xf75c, 0xf73a, 0xc510, 0x9b47, 0xbba6, 0xd3e5, 0xd425, 0xd446, 0xdc86, 0xdca7, 0xe4a7, 0xe4c7, 0xe507, 0xed28, 0xe508, 0xed69, 0xf568, 0xe527, 0xe568, 0xf60b, 0xfe8d, 0xfece, 0xfe6c, 0xf5ca, 0xd445, 0xbb83, 0xe529, 0xedea, 0xf5ea, 0xfdea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xf64a, 0xf64a, 0xf64a, 0xf64a, 0xf64a, 0xf64a, 0xf64a, 0xf64a, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe6b, 0xfe2a, 0xfe2b, 0xfe6b, 0xfe6b, 0xfe2b, 0xfe2a, 0xfe4b, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ca, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xed89, 0xed88, 0xed68, 0xed68, 0xed68, 0xed48, 0xe527, 0xe507, 0xe4e7, 0xdcc7, 0xdca6, 0xdc86, 0xd466, 0xdc25, 0xd426, 0xbb85, 0x9b26, 0xc510, 0xf73a, 0xf77d, 0xf7bf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbf, 0xef9e, 0xef9d, 0xef7c, 0xd616, 0xac0b, 0xb366, 0xcba4, 0xd405, 0xd426, 0xdc66, 0xdc86, 0xdca7, 0xdcc7, 0xe4e7, 0xe508, 0xe508, 0xed49, 0xed48, 0xe527, 0xed68, 0xf62b, 0xfeae, 0xfecf, 0xfe8c, 0xf5eb, 0xd466, 0xbba3, 0xe529, 0xedea, 0xf5ea, 0xfde9, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xfe0a, 0xfe0a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe4b, 0xfe4b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xf60a, 0xfe2a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xedc9, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xeda9, 0xeda9, 0xed89, 0xed88, 0xed68, 0xed68, 0xed48, 0xed48, 0xe528, 0xe507, 0xdce7, 0xdcc7, 0xdca6, 0xdc86, 0xd466, 0xd446, 0xdc05, 0xcbe6, 0xab65, 0xa3c9, 0xde35, 0xff9d, 0xef7d, 0xf7bf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79f, 0xf7be, 0xefde, 0xe77d, 0xe6da, 0xcd11, 0xb366, 0xcb63, 0xcc05, 0xd426, 0xd446, 0xdc66, 0xdc86, 0xdca6, 0xdcc7, 0xe4e7, 0xe4e8, 0xed28, 0xed28, 0xe527, 0xed68, 0xfe4c, 0xfece, 0xfeef, 0xfead, 0xfe0b, 0xdc87, 0xc3c4, 0xdd29, 0xedca, 0xedc9, 0xf5c9, 0xf5c9, 0xf5ca, 0xf5ca, 0xf5ca, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xfe0a, 0xfe0a, 0xfe0a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe2a, 0xfe0a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5c9, 0xeda8, 0xf5c9, 0xf5e9, 0xf5e9, 0xf5e9, 0xfe0a, 0xfe2a, 0xfe0a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xeda9, 0xed89, 0xed88, 0xed88, 0xed68, 0xed48, 0xed48, 0xed48, 0xe528, 0xe507, 0xdcc7, 0xdca7, 0xdc86, 0xdc86, 0xd446, 0xd425, 0xdbc4, 0xc3a5, 0xab87, 0xc4ef, 0xeefa, 0xf79d, 0xef9e, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xf7ff, 0xeffe, 0xdf7d, 0xef5d, 0xddd5, 0xb367, 0xc342, 0xcc05, 0xd426, 0xd446, 0xd466, 0xdc86, 0xdca7, 0xdcc7, 0xe4e7, 0xe4e8, 0xed28, 0xed28, 0xe527, 0xed89, 0xfe4c, 0xfeef, 0xfef0, 0xfecd, 0xfe4c, 0xe4c7, 0xc3c4, 0xdd29, 0xedaa, 0xeda9, 0xf5a9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5ca, 0xf5ca, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xfe0a, 0xfe0a, 0xfe0a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xedc9, 0xedc9, 0xeda9, 0xeda9, 0xed88, 0xe588, 0xe588, 0xe568, 0xed88, 0xdd27, 0xdd26, 0xeda8, 0xfe0a, 0xfe0a, 0xf5ea, 0xfe0a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf589, 0xed89, 0xed89, 0xed89, 0xed88, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xe508, 0xe4e7, 0xdcc7, 0xdca6, 0xdc86, 0xdc66, 0xd446, 0xd425, 0xd3a4, 0xbb64, 0xabc8, 0xddf4, 0xf77c, 0xe75d, 0xefbf, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbd, 0xffbe, 0xffff, 0xf7bf, 0xf75c, 0xf6d8, 0xdd50, 0x9b06, 0xbbc4, 0xcc25, 0xcc25, 0xd425, 0xdc86, 0xdc86, 0xd486, 0xdce8, 0xecc7, 0xe4c7, 0xe4e7, 0xe528, 0xee0b, 0xfeef, 0xff51, 0xff52, 0xff2e, 0xfead, 0xed89, 0xdc66, 0xdc86, 0xf56a, 0xfdeb, 0xedca, 0xf5ca, 0xf5ca, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5ca, 0xf5ca, 0xf5ea, 0xf60a, 0xf609, 0xede9, 0xedc9, 0xede9, 0xf5e9, 0xf5e9, 0xf609, 0xfe4a, 0xfe2a, 0xf5e9, 0xf5c9, 0xf5a9, 0xf589, 0xf568, 0xed48, 0xe508, 0xed49, 0xed8a, 0xedcb, 0xf62c, 0xf68e, 0xf6ce, 0xeeae, 0xfead, 0xfe4b, 0xed88, 0xdd06, 0xe548, 0xfdea, 0xfe0b, 0xf5aa, 0xf5ea, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xedc9, 0xedc9, 0xf5a9, 0xf5a9, 0xf5a9, 0xeda9, 0xeda9, 0xed89, 0xed88, 0xed88, 0xed88, 0xed88, 0xed88, 0xed68, 0xed48, 0xed28, 0xe507, 0xe4e7, 0xe4c6, 0xdca6, 0xdca7, 0xd4a7, 0xcc46, 0xcc46, 0xd446, 0xcbe5, 0xc382, 0xab44, 0xc4ef, 0xef1b, 0xef9d, 0xef9d, 0xffbf, 0xff9f, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbd, 0xffbe, 0xffdf, 0xf7bf, 0xef5c, 0xf71a, 0xe5f4, 0xabeb, 0xb343, 0xc3c5, 0xd425, 0xd445, 0xdc65, 0xd465, 0xd486, 0xdcc7, 0xecc7, 0xe4c7, 0xe4e7, 0xe548, 0xf62b, 0xfeef, 0xff51, 0xff52, 0xff50, 0xff0f, 0xf60c, 0xdce7, 0xdc66, 0xe4e7, 0xed89, 0xeda9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xfdc9, 0xfde9, 0xfdea, 0xfdea, 0xfdea, 0xfdea, 0xf5ea, 0xf5ca, 0xed67, 0xe567, 0xe567, 0xe568, 0xe589, 0xedaa, 0xedcb, 0xedeb, 0xf64d, 0xfe8e, 0xfece, 0xfeee, 0xfeee, 0xff0e, 0xff0e, 0xfeed, 0xfe2c, 0xfdcb, 0xe528, 0xd4a6, 0xdce7, 0xf589, 0xfdea, 0xfdca, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xeda9, 0xeda9, 0xed89, 0xed88, 0xed88, 0xed88, 0xed88, 0xed88, 0xed68, 0xed68, 0xed48, 0xed28, 0xe508, 0xe4e7, 0xe4a6, 0xdca6, 0xdca6, 0xd486, 0xd426, 0xd446, 0xd426, 0xc3a4, 0xb342, 0xbbe9, 0xddb4, 0xef3c, 0xef9d, 0xefbd, 0xffdf, 0xff9f, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdd, 0xffbe, 0xffff, 0xefbf, 0xef7e, 0xf77d, 0xeeb9, 0xc552, 0xab24, 0xbb64, 0xd405, 0xdc45, 0xd424, 0xd444, 0xdca6, 0xd4c6, 0xe4a7, 0xdca6, 0xdce7, 0xed89, 0xfe6c, 0xff10, 0xff51, 0xff52, 0xff71, 0xff51, 0xfeae, 0xf5ab, 0xe4e8, 0xdcc6, 0xe527, 0xe568, 0xf589, 0xf589, 0xfda9, 0xfda9, 0xfda9, 0xfda9, 0xfda9, 0xf5a9, 0xfda9, 0xfda9, 0xfda9, 0xf589, 0xf589, 0xed69, 0xe549, 0xe549, 0xed88, 0xeda9, 0xede9, 0xf62b, 0xf66c, 0xfeae, 0xfeef, 0xff10, 0xff10, 0xff30, 0xff4f, 0xff0e, 0xfecd, 0xfe8b, 0xfe29, 0xf5c8, 0xf5ac, 0xed4b, 0xdcc8, 0xcc66, 0xd4c6, 0xed69, 0xfdea, 0xfdca, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xeda9, 0xeda9, 0xf5a9, 0xf589, 0xf589, 0xed89, 0xed88, 0xed88, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed28, 0xe507, 0xe4e7, 0xe4c7, 0xdca6, 0xdc86, 0xdc86, 0xd445, 0xd425, 0xd425, 0xd3e4, 0xbb42, 0xa346, 0xcd10, 0xeeba, 0xef5e, 0xef9e, 0xf7fe, 0xfffe, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbe, 0xffbe, 0xf7df, 0xefbf, 0xef9e, 0xf7bf, 0xef5c, 0xd678, 0xc3e9, 0xb345, 0xc364, 0xd405, 0xd404, 0xd424, 0xd485, 0xd4a6, 0xe486, 0xdc86, 0xe507, 0xf5ea, 0xfead, 0xff10, 0xff51, 0xff72, 0xf772, 0xff52, 0xff11, 0xfe8e, 0xf5ec, 0xed89, 0xe547, 0xe547, 0xed48, 0xed68, 0xf568, 0xf568, 0xf568, 0xf568, 0xf568, 0xf568, 0xed47, 0xed47, 0xed47, 0xe548, 0xe589, 0xedca, 0xedec, 0xf62c, 0xfe8d, 0xfeae, 0xfeef, 0xff10, 0xff30, 0xff0f, 0xff0f, 0xff0f, 0xf6ac, 0xf68c, 0xee4b, 0xedea, 0xeda9, 0xed69, 0xed48, 0xed28, 0xd489, 0xcc68, 0xc426, 0xcc46, 0xdce7, 0xf5aa, 0xfdca, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xeda9, 0xeda9, 0xeda9, 0xeda9, 0xed89, 0xed89, 0xed88, 0xed88, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xed28, 0xe508, 0xe4e7, 0xe4c7, 0xe4c7, 0xdca7, 0xd466, 0xdc45, 0xdc45, 0xdc05, 0xd3c4, 0xc363, 0xb302, 0xac2c, 0xe617, 0xff5e, 0xef7f, 0xe7be, 0xf7fe, 0xf7de, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbe, 0xffbe, 0xffdf, 0xf7df, 0xefbf, 0xf7bf, 0xef9e, 0xdefc, 0xe571, 0xb3a9, 0xab04, 0xcba4, 0xd3e4, 0xd404, 0xd465, 0xd486, 0xdc45, 0xdc86, 0xe528, 0xfe2b, 0xfece, 0xff30, 0xff51, 0xff72, 0xff73, 0xff32, 0xff11, 0xff11, 0xfecf, 0xfe6d, 0xf60b, 0xedc9, 0xed89, 0xed89, 0xed69, 0xed69, 0xed69, 0xed89, 0xed89, 0xed89, 0xede9, 0xedea, 0xee0a, 0xee2b, 0xf68d, 0xfeef, 0xff30, 0xff71, 0xff31, 0xff11, 0xff10, 0xfeef, 0xfeae, 0xfe4c, 0xf60b, 0xf5ea, 0xf5a8, 0xf588, 0xf589, 0xed49, 0xe509, 0xdc88, 0xd427, 0xcbe7, 0xb365, 0xb3a5, 0xc3e6, 0xd487, 0xe529, 0xf5ca, 0xf5c9, 0xed88, 0xf5a9, 0xf5a9, 0xf589, 0xf589, 0xed89, 0xed89, 0xed89, 0xed88, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xe528, 0xe527, 0xe508, 0xe507, 0xe4e7, 0xe4c7, 0xe4a7, 0xdc87, 0xd487, 0xd446, 0xd425, 0xdc25, 0xd3e5, 0xc364, 0xb344, 0xb365, 0xcd94, 0xeefb, 0xf77f, 0xef7f, 0xefdf, 0xf7fe, 0xf7bd, 0xffde, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf79e, 0xe75d, 0xf6b9, 0xc4cf, 0xa347, 0xbb44, 0xcbc4, 0xd3e4, 0xd425, 0xd446, 0xd425, 0xdca6, 0xed69, 0xfe4c, 0xfece, 0xff30, 0xff51, 0xff72, 0xff53, 0xff32, 0xff32, 0xff11, 0xff11, 0xfeef, 0xfecf, 0xfece, 0xfe6d, 0xfe6d, 0xf64c, 0xf64c, 0xf64c, 0xfe6d, 0xfe6d, 0xfe6d, 0xff0f, 0xff0f, 0xff30, 0xff50, 0xff50, 0xff50, 0xff30, 0xff2f, 0xf6d0, 0xf6af, 0xf66e, 0xf62c, 0xf60b, 0xf5ca, 0xf589, 0xf568, 0xfd28, 0xecc7, 0xdc67, 0xcc06, 0xbb85, 0xb325, 0xa305, 0xa2e5, 0xbbc5, 0xcc46, 0xdce8, 0xed4a, 0xf58a, 0xf5aa, 0xf5a9, 0xf589, 0xf589, 0xf589, 0xed88, 0xed88, 0xed88, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed27, 0xe507, 0xe507, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4a7, 0xdc86, 0xdc66, 0xd487, 0xd446, 0xd405, 0xd405, 0xcbc5, 0xab44, 0xaba7, 0xc48c, 0xe6da, 0xf75e, 0xf79f, 0xef9f, 0xf7df, 0xf7dd, 0xf79d, 0xffbf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bf, 0xf7bf, 0xf7be, 0xffde, 0xffde, 0xffbe, 0xf79d, 0xf77d, 0xef7e, 0xd637, 0xbc6d, 0xb366, 0xc364, 0xcbc4, 0xcbe5, 0xcc06, 0xcc04, 0xdca6, 0xf5a9, 0xfe4c, 0xfecd, 0xff0f, 0xff51, 0xff52, 0xff32, 0xff32, 0xff32, 0xff11, 0xff11, 0xff31, 0xff31, 0xff31, 0xff30, 0xff30, 0xff30, 0xff30, 0xff31, 0xff31, 0xff51, 0xff51, 0xff52, 0xff51, 0xff51, 0xff50, 0xff0f, 0xfece, 0xfe8d, 0xf66c, 0xf62b, 0xf5ea, 0xedaa, 0xed89, 0xed69, 0xed29, 0xe4c8, 0xdc67, 0xcc09, 0xb366, 0x9ac4, 0x9262, 0x9282, 0x9ae4, 0xb3a6, 0xc449, 0xdce7, 0xed49, 0xf5aa, 0xfdcb, 0xf5aa, 0xed89, 0xed69, 0xf589, 0xed88, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed27, 0xed27, 0xed27, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4a7, 0xdc86, 0xdc66, 0xdc66, 0xd426, 0xd426, 0xd405, 0xcbc5, 0xbb65, 0xa366, 0xb48d, 0xde35, 0xef5b, 0xf79e, 0xf79f, 0xf7bf, 0xffde, 0xffdd, 0xff9e, 0xff9f, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7df, 0xf7bf, 0xf7be, 0xffbe, 0xffde, 0xffbd, 0xff9d, 0xff9d, 0xdf9f, 0xef3c, 0xcd51, 0xb387, 0xbb23, 0xcb84, 0xcbc5, 0xcbe7, 0xc3e3, 0xdcc7, 0xf5ca, 0xfe6c, 0xfead, 0xff0f, 0xff51, 0xff52, 0xff11, 0xff32, 0xff31, 0xff11, 0xf731, 0xff52, 0xff32, 0xf711, 0xf731, 0xff51, 0xff51, 0xff51, 0xff72, 0xff51, 0xff51, 0xff51, 0xff32, 0xff12, 0xfef1, 0xfecf, 0xfe8e, 0xfe4c, 0xfe0b, 0xfdea, 0xf5a7, 0xf566, 0xed26, 0xe507, 0xdca7, 0xcc06, 0xb344, 0xa2a2, 0x71e4, 0x71e4, 0x8244, 0x9306, 0xabc7, 0xbc48, 0xccea, 0xdd6b, 0xe547, 0xed68, 0xed89, 0xed89, 0xed68, 0xed48, 0xed69, 0xf589, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed27, 0xed27, 0xed27, 0xed27, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4c7, 0xdca7, 0xdc87, 0xdc66, 0xdc46, 0xcc05, 0xd426, 0xd405, 0xc384, 0xab44, 0xa388, 0xc531, 0xf75b, 0xe75b, 0xef9e, 0xffdf, 0xffdf, 0xffbe, 0xffde, 0xffbe, 0xff5e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xef3c, 0xe6d9, 0xcd72, 0x9b68, 0xab25, 0xd3c6, 0xd363, 0xc383, 0xece8, 0xf5ca, 0xf64c, 0xfecd, 0xfece, 0xff0f, 0xfef0, 0xff11, 0xff11, 0xff11, 0xff11, 0xff11, 0xff11, 0xff11, 0xff11, 0xff31, 0xff31, 0xff31, 0xff31, 0xff31, 0xff31, 0xff31, 0xff31, 0xff30, 0xfeef, 0xfeae, 0xfe8d, 0xfe4c, 0xfe0b, 0xed89, 0xed27, 0xed27, 0xdca7, 0xcc27, 0xb3a8, 0x92e7, 0x7a05, 0x71a3, 0x71a4, 0x8a25, 0x9aa6, 0xb387, 0xc447, 0xd4a7, 0xdce7, 0xe527, 0xed47, 0xed89, 0xed89, 0xed69, 0xed69, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed28, 0xed28, 0xe508, 0xe507, 0xe4e7, 0xe4e7, 0xed09, 0xdca7, 0xe4a7, 0xe4a8, 0xdc46, 0xd425, 0xdc26, 0xdc25, 0xcbc6, 0xd407, 0xcbc5, 0xab03, 0xa346, 0xcd51, 0xef1b, 0xe75e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xef9e, 0xe73c, 0xef1b, 0xe657, 0xbcae, 0xa346, 0xaae4, 0xc344, 0xc383, 0xed08, 0xf5ca, 0xfe4c, 0xfead, 0xfece, 0xfeef, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xff31, 0xff31, 0xff31, 0xff31, 0xff31, 0xff30, 0xff30, 0xff30, 0xff0f, 0xfeef, 0xfeae, 0xfe8d, 0xfe2c, 0xf5ca, 0xe527, 0xdcc6, 0xd407, 0xb325, 0x9243, 0x79e3, 0x71c3, 0x71c4, 0x7a04, 0x9286, 0xa307, 0xab87, 0xc428, 0xd4a8, 0xe508, 0xe528, 0xed48, 0xed68, 0xed69, 0xed69, 0xed69, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed27, 0xed27, 0xe507, 0xe4e7, 0xe4e7, 0xdcc7, 0xdcc7, 0xdca7, 0xd466, 0xdc66, 0xdc86, 0xdc46, 0xdc46, 0xd426, 0xd405, 0xd3c6, 0xcba5, 0xb324, 0xab45, 0xc4cd, 0xe656, 0xef1b, 0xef7e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xef9f, 0xef7e, 0xef5d, 0xf73b, 0xe656, 0xb42c, 0x9ac5, 0xa2c4, 0xcba4, 0xed08, 0xf5ca, 0xfe4b, 0xfead, 0xfead, 0xfeef, 0xfecf, 0xfed0, 0xfed0, 0xfed0, 0xfed0, 0xfed0, 0xfed0, 0xfed0, 0xfed0, 0xff10, 0xff10, 0xff10, 0xff10, 0xff10, 0xff10, 0xff10, 0xff10, 0xfeef, 0xfece, 0xfead, 0xfe6d, 0xf60b, 0xed89, 0xdce6, 0xcc64, 0x9a44, 0x8182, 0x7122, 0x7183, 0x8206, 0x8a86, 0x9ac6, 0xab47, 0xbbe7, 0xcc48, 0xdcc9, 0xe529, 0xed48, 0xed68, 0xed68, 0xed69, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed27, 0xed27, 0xed07, 0xe507, 0xe4e7, 0xe4e7, 0xe4c7, 0xdcc7, 0xdca6, 0xdca7, 0xdca6, 0xdc86, 0xdc86, 0xdc66, 0xd425, 0xd425, 0xd405, 0xcbe4, 0xd3a4, 0xbb23, 0xa305, 0xb44c, 0xe636, 0xf73b, 0xef5c, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bf, 0xf7df, 0xef9e, 0xf75d, 0xf71a, 0xddf4, 0xac0b, 0x8aa5, 0xcbe4, 0xed29, 0xf5ca, 0xfe4b, 0xfe8c, 0xfead, 0xfece, 0xfeaf, 0xfecf, 0xfecf, 0xfecf, 0xfecf, 0xfecf, 0xfecf, 0xfecf, 0xfecf, 0xfeef, 0xfeef, 0xfeef, 0xfeef, 0xfecf, 0xfecf, 0xfecf, 0xfecf, 0xfeae, 0xfeae, 0xfe8d, 0xfe6c, 0xf60b, 0xed89, 0xdd06, 0xd4a5, 0xcbc8, 0xaae6, 0x9245, 0x81e5, 0x8a46, 0xa307, 0xb387, 0xc408, 0xd4a7, 0xdcc8, 0xe528, 0xed68, 0xed68, 0xed48, 0xed48, 0xed29, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed28, 0xed28, 0xed28, 0xed28, 0xed28, 0xed27, 0xed27, 0xe507, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4c7, 0xdca7, 0xdca7, 0xdc86, 0xdc87, 0xdc86, 0xdc86, 0xdc86, 0xd445, 0xcc25, 0xcc05, 0xcc05, 0xc3e5, 0xc342, 0xab03, 0xb40b, 0xd5d5, 0xeefb, 0xf77e, 0xf7be, 0xffbe, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7df, 0xf7df, 0xf7bf, 0xef7e, 0xf75c, 0xf71a, 0xd5b4, 0x9b8b, 0xcc05, 0xed49, 0xf5ea, 0xf62b, 0xfe6b, 0xfe6c, 0xfeae, 0xfe8e, 0xfeae, 0xfeae, 0xfeae, 0xfeae, 0xfeae, 0xfeae, 0xfeae, 0xfeae, 0xfece, 0xfece, 0xfece, 0xfece, 0xfece, 0xfeae, 0xfeae, 0xfeae, 0xfe8d, 0xfe8d, 0xfe6c, 0xfe4c, 0xf62b, 0xf5c9, 0xed88, 0xe547, 0xfd8a, 0xdcc9, 0xbbc7, 0x9284, 0x8a64, 0xb367, 0xcc48, 0xdcc9, 0xdce7, 0xe507, 0xe547, 0xed47, 0xed47, 0xed48, 0xed28, 0xed29, 0xed48, 0xed48, 0xed28, 0xed28, 0xed28, 0xed28, 0xed28, 0xed28, 0xed28, 0xed28, 0xed08, 0xed08, 0xe507, 0xe507, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4c7, 0xe4a7, 0xdca7, 0xdc86, 0xdc86, 0xdc66, 0xd445, 0xd445, 0xd425, 0xcc25, 0xcc26, 0xcc05, 0xbbc5, 0xbba4, 0xab03, 0xbbe9, 0xd5b3, 0xeefb, 0xe73e, 0xef7f, 0xffdf, 0xffbe, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf79f, 0xf7df, 0xf7bf, 0xef5d, 0xf75c, 0xeeb9, 0xbd32, 0xd425, 0xf569, 0xf5ea, 0xf62a, 0xf66b, 0xf64b, 0xfe6d, 0xfe6e, 0xfead, 0xfead, 0xfead, 0xfead, 0xfead, 0xfead, 0xfead, 0xfead, 0xfead, 0xfead, 0xfead, 0xfe8d, 0xfe8d, 0xfe8d, 0xfe8d, 0xfe8d, 0xfe6d, 0xfe6d, 0xfe4c, 0xfe4b, 0xfe2b, 0xf60a, 0xf5e9, 0xf5c9, 0xed45, 0xe506, 0xcc87, 0xa304, 0x9ac4, 0xc408, 0xd488, 0xe4e8, 0xe528, 0xe527, 0xe547, 0xed47, 0xed47, 0xed48, 0xed28, 0xed29, 0xed28, 0xed28, 0xed28, 0xed28, 0xed28, 0xed27, 0xed27, 0xed27, 0xed08, 0xed07, 0xed07, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4a7, 0xdc87, 0xdc86, 0xdc66, 0xdc66, 0xd446, 0xd425, 0xd405, 0xcbe5, 0xcc05, 0xcc06, 0xbba5, 0xab24, 0xa324, 0xabea, 0xd592, 0xeef9, 0xef5d, 0xef9f, 0xef9f, 0xf79e, 0xffbe, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff9e, 0xf79e, 0xffdf, 0xffdf, 0xf77e, 0xf77d, 0xeefb, 0xd5f6, 0xd445, 0xf569, 0xf5ea, 0xf60a, 0xf64b, 0xf62b, 0xfe4d, 0xfe4d, 0xfe8c, 0xfe8c, 0xfe8c, 0xfe8c, 0xfe8c, 0xfe8c, 0xfe8c, 0xfe8c, 0xfe8d, 0xfe8d, 0xfe8c, 0xfe8c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe2b, 0xfe2a, 0xf60a, 0xf5e9, 0xf5e9, 0xf586, 0xe527, 0xd4a8, 0xa304, 0x9ac4, 0xc3e7, 0xd466, 0xe4c6, 0xe529, 0xe528, 0xe527, 0xed47, 0xed27, 0xed27, 0xed28, 0xed28, 0xed28, 0xed28, 0xed27, 0xed27, 0xed07, 0xed07, 0xed07, 0xe507, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4a7, 0xdca6, 0xe486, 0xdc86, 0xdc86, 0xdc66, 0xdc66, 0xd446, 0xd426, 0xd426, 0xd426, 0xd406, 0xcbc6, 0xc3e6, 0xbba6, 0xab25, 0xa325, 0xbbc8, 0xc594, 0xe6d9, 0xf77d, 0xef7e, 0xefbf, 0xf7bf, 0xff9e, 0xffbf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff9d, 0xffbe, 0xffbf, 0xf79f, 0xffbf, 0xffbf, 0xeefb, 0xcdd6, 0xd445, 0xf569, 0xf5ea, 0xf60a, 0xf62a, 0xf60b, 0xfe4c, 0xfe2d, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe2c, 0xfe2c, 0xfe2c, 0xfe2b, 0xf60a, 0xf5e9, 0xf5c9, 0xf5c8, 0xed46, 0xdce7, 0xcc68, 0xa305, 0xa306, 0xd469, 0xe4c8, 0xf547, 0xe529, 0xe529, 0xe507, 0xe507, 0xe507, 0xed07, 0xed08, 0xed08, 0xed27, 0xed27, 0xed27, 0xed07, 0xed07, 0xe507, 0xe507, 0xe507, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4c7, 0xe4a7, 0xe4a6, 0xdca6, 0xdca6, 0xdc86, 0xdc66, 0xdc66, 0xdc46, 0xd446, 0xd426, 0xd406, 0xd405, 0xd3c5, 0xcbc6, 0xcbc6, 0xc3a6, 0xb366, 0xa305, 0xbbc8, 0xed4f, 0xe6fc, 0xef3d, 0xf7bf, 0xf7bf, 0xef9e, 0xffdf, 0xffff, 0xff9e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbf, 0xffbe, 0xf7de, 0xf7de, 0xefbd, 0xf7be, 0xff7d, 0xcdf7, 0xdca5, 0xf547, 0xf5a9, 0xf5aa, 0xfe0a, 0xf60a, 0xf60a, 0xf64a, 0xf64b, 0xf64b, 0xf64b, 0xfe4b, 0xfe4b, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe2a, 0xf60a, 0xfe2a, 0xfe2a, 0xfdea, 0xf5a9, 0xed68, 0xe4e7, 0xdca9, 0xc3c8, 0x9aa4, 0xab44, 0xd487, 0xdcc7, 0xe4e7, 0xed28, 0xed28, 0xe508, 0xe508, 0xe507, 0xe507, 0xe507, 0xe507, 0xece8, 0xece8, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4a6, 0xdc86, 0xdc86, 0xdc66, 0xdc66, 0xd488, 0xd487, 0xd446, 0xcc05, 0xcc05, 0xcc26, 0xc426, 0xbbe6, 0xcbe4, 0xd3e4, 0xcb84, 0xbb04, 0xab07, 0xac2e, 0xc5d7, 0xdf1d, 0xef7d, 0xef7d, 0xf79e, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbf, 0xffbe, 0xf7de, 0xf7de, 0xf7bd, 0xf7be, 0xf77d, 0xcdf7, 0xd484, 0xed48, 0xfda9, 0xf5aa, 0xf5ea, 0xf60a, 0xf60a, 0xf64a, 0xf62b, 0xf62b, 0xf62b, 0xfe2b, 0xfe2b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4c, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe2b, 0xfe4b, 0xfe2a, 0xf60a, 0xf60a, 0xfe0a, 0xf5c9, 0xed88, 0xe547, 0xe4a6, 0xbb85, 0x9aa4, 0x9aa4, 0xbbc6, 0xdca8, 0xdcc7, 0xed28, 0xe507, 0xe507, 0xe507, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4a7, 0xe4a7, 0xe4a6, 0xe4a6, 0xdca6, 0xdc86, 0xdc86, 0xdc66, 0xdc66, 0xd446, 0xcc26, 0xd446, 0xdc46, 0xd425, 0xcbe4, 0xcbe5, 0xc3e5, 0xc3e5, 0xc3c4, 0xb343, 0xaae3, 0xab26, 0xc44d, 0xd5b4, 0xe6bb, 0xe75e, 0xef7d, 0xf79e, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff9e, 0xffbf, 0xf7de, 0xf7ff, 0xf7be, 0xf7bd, 0xf75c, 0xcdf7, 0xd445, 0xed28, 0xfdaa, 0xf5a9, 0xf5c9, 0xf60a, 0xf60a, 0xf62a, 0xf62b, 0xf62b, 0xf62b, 0xf62b, 0xf62b, 0xf62b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xfe4b, 0xf62b, 0xfe2a, 0xf60a, 0xf5e9, 0xf5e9, 0xf5c9, 0xf5a9, 0xed67, 0xe527, 0xcc24, 0xa2c1, 0x8a21, 0x9263, 0xbbc7, 0xd4a8, 0xdca7, 0xed08, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xdcc7, 0xdcc7, 0xdcc7, 0xdcc7, 0xe4a7, 0xe4a7, 0xdca7, 0xdca6, 0xdca6, 0xdca6, 0xdc86, 0xdc86, 0xdc86, 0xdc86, 0xdc66, 0xdc66, 0xd446, 0xd446, 0xd426, 0xd426, 0xcc26, 0xd426, 0xd405, 0xd3c4, 0xd3c3, 0xcbc4, 0xcbc4, 0xc3a4, 0xab44, 0xa304, 0xa367, 0xbc8e, 0xe616, 0xf71b, 0xf77d, 0xef7e, 0xf79e, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff9e, 0xffdf, 0xf7be, 0xf7ff, 0xf7de, 0xf79d, 0xf73c, 0xd618, 0xcc25, 0xe508, 0xf5aa, 0xf5a9, 0xf5a9, 0xf5ea, 0xfe0a, 0xf5ea, 0xf60a, 0xf60a, 0xf60a, 0xf62a, 0xf62a, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xfe2b, 0xf62a, 0xf60a, 0xf5e9, 0xf5e9, 0xf5c9, 0xf5c9, 0xf5a8, 0xed68, 0xe547, 0xe4a6, 0xcc26, 0xbba6, 0xa304, 0xb386, 0xd468, 0xdca7, 0xe4a6, 0xe4a7, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca7, 0xdca7, 0xdc86, 0xdc86, 0xdc86, 0xdc86, 0xdc86, 0xdc66, 0xdc66, 0xd466, 0xd446, 0xd446, 0xd426, 0xd426, 0xcc06, 0xcc05, 0xd426, 0xcc05, 0xcbc4, 0xd3a3, 0xd3c4, 0xcba4, 0xbb64, 0xb323, 0x9b46, 0xabea, 0xcd31, 0xde77, 0xef3c, 0xf77e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff9e, 0xffdf, 0xf7be, 0xf7de, 0xf7de, 0xf79d, 0xf75c, 0xd659, 0xcc46, 0xe509, 0xf5aa, 0xf5a9, 0xeda8, 0xf5e9, 0xfe0a, 0xf5ca, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xfe2a, 0xfe2a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf5e9, 0xf5e9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf588, 0xed68, 0xf528, 0xf549, 0xe50a, 0xb386, 0xa325, 0xc407, 0xdc87, 0xdc85, 0xdca6, 0xdca6, 0xdca6, 0xdc86, 0xdc86, 0xdc86, 0xdc86, 0xdc86, 0xdc87, 0xdc86, 0xdc86, 0xdc66, 0xdc66, 0xd466, 0xd466, 0xd466, 0xd446, 0xd446, 0xd426, 0xd426, 0xcc06, 0xcc06, 0xcbe6, 0xcbe6, 0xc3c5, 0xcbc5, 0xcbc4, 0xcba4, 0xc384, 0xbb45, 0xab25, 0xab05, 0xb48d, 0xd593, 0xe6d9, 0xef5c, 0xe77e, 0xef7e, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbf, 0xffdf, 0xf7be, 0xf7de, 0xf7de, 0xf79d, 0xf75d, 0xe69a, 0xcc68, 0xdce9, 0xed69, 0xf5a8, 0xeda7, 0xf5a8, 0xfdea, 0xf5aa, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60a, 0xf60a, 0xf60a, 0xf60a, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5ea, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf588, 0xf588, 0xed27, 0xed28, 0xdce8, 0xb3a5, 0xa2e4, 0xbba6, 0xd446, 0xdca5, 0xdc86, 0xdc86, 0xdc66, 0xdc66, 0xdc66, 0xdc66, 0xdc66, 0xdc66, 0xd466, 0xd466, 0xd466, 0xd466, 0xd446, 0xd446, 0xd446, 0xd446, 0xd426, 0xd426, 0xcc06, 0xcc06, 0xcbe6, 0xcbe6, 0xcbc5, 0xcbc5, 0xc3c5, 0xc3a5, 0xbb64, 0xb324, 0xa2e4, 0xa327, 0xb40c, 0xc4cf, 0xde37, 0xe6ba, 0xef5c, 0xef9d, 0xef9e, 0xf7bf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbf, 0xffdf, 0xf7be, 0xf7de, 0xf7de, 0xf7bd, 0xf77d, 0xeedb, 0xd4aa, 0xd4c9, 0xe548, 0xeda8, 0xed87, 0xf588, 0xf5a9, 0xf5aa, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf60a, 0xf60a, 0xf60a, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf588, 0xf588, 0xf568, 0xf569, 0xed07, 0xdcc7, 0xbbc5, 0xa305, 0xbba7, 0xcc26, 0xdc85, 0xdc46, 0xd446, 0xd446, 0xd446, 0xd446, 0xd446, 0xd446, 0xd446, 0xd446, 0xd446, 0xd446, 0xd426, 0xd425, 0xcc25, 0xcc25, 0xcc25, 0xcc05, 0xcbe5, 0xcbe5, 0xcbe5, 0xc3c5, 0xc3a5, 0xc3a5, 0xc3a5, 0xc3a5, 0xb364, 0xab24, 0xab46, 0xaba9, 0xb46f, 0xd5b5, 0xeeba, 0xef1d, 0xef5d, 0xef7d, 0xf7bd, 0xf7de, 0xf7de, 0xffdf, 0xf7bf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbf, 0xffff, 0xf7be, 0xf7de, 0xf7fe, 0xf7be, 0xff7d, 0xef1b, 0xdceb, 0xd4a9, 0xdd28, 0xeda8, 0xed87, 0xed87, 0xf5a9, 0xf58a, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5e9, 0xf5c9, 0xf5c9, 0xedc9, 0xedc9, 0xedc9, 0xedc9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf588, 0xf568, 0xed68, 0xf568, 0xed07, 0xdcc6, 0xd486, 0xab84, 0x9ae4, 0xbb87, 0xcc06, 0xcc23, 0xd425, 0xd425, 0xd425, 0xd425, 0xd425, 0xd425, 0xd425, 0xd425, 0xd425, 0xcc25, 0xcc25, 0xcc25, 0xcc05, 0xcc05, 0xcc05, 0xcc05, 0xcbe5, 0xcbc5, 0xc3c5, 0xc3a5, 0xc3a5, 0xc385, 0xc385, 0xbb85, 0xb343, 0xa2e2, 0xa325, 0xbc2a, 0xd552, 0xe658, 0xe6dc, 0xe73e, 0xef7f, 0xef7f, 0xf7be, 0xf7de, 0xf7dd, 0xf79d, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf79e, 0xef5d, 0xe5d5, 0xc4ac, 0xd4c7, 0xf5a7, 0xfd88, 0xed68, 0xedaa, 0xe5ea, 0xf5a9, 0xf5a9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5c9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a8, 0xf5a8, 0xf5a8, 0xf588, 0xf587, 0xed87, 0xf588, 0xf588, 0xed68, 0xed47, 0xe527, 0xe4e8, 0xdca9, 0xb368, 0x9a85, 0xa2e4, 0xc3a5, 0xcbe5, 0xd3c4, 0xcbe5, 0xcbe5, 0xcc05, 0xd405, 0xd406, 0xd405, 0xd405, 0xcc05, 0xcc06, 0xc3e6, 0xc3c5, 0xc3c5, 0xc3e6, 0xc3e6, 0xc3c5, 0xc3a5, 0xcba5, 0xcba5, 0xcba5, 0xcb85, 0xc344, 0xbb03, 0xbae3, 0xb2e3, 0x9329, 0xac0d, 0xc532, 0xde37, 0xe6b9, 0xe71b, 0xe75d, 0xef9e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf79e, 0xef5d, 0xee58, 0xcd0f, 0xcc87, 0xe506, 0xf526, 0xed27, 0xe568, 0xe589, 0xf588, 0xf588, 0xf5a8, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a9, 0xf5a8, 0xf5a8, 0xf588, 0xf588, 0xf588, 0xf588, 0xed88, 0xed88, 0xf588, 0xf588, 0xed87, 0xed68, 0xed68, 0xed68, 0xe527, 0xe507, 0xc425, 0xab24, 0x8203, 0x8203, 0xa325, 0xc3c6, 0xcbc5, 0xcbe5, 0xcbe5, 0xcbe5, 0xcbe5, 0xcbe6, 0xcbe6, 0xcbe5, 0xc3c5, 0xc3c5, 0xcbe7, 0xcbc6, 0xc3a5, 0xc3a5, 0xc3a5, 0xc3a4, 0xc3a4, 0xc3a4, 0xcb84, 0xc364, 0xbb24, 0xab04, 0xa2e4, 0xa326, 0xab88, 0xb3c9, 0xcd52, 0xddd5, 0xee98, 0xf71b, 0xf75c, 0xf77d, 0xf79e, 0xf7bf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf79e, 0xef7d, 0xf71c, 0xd5b3, 0xc488, 0xdc84, 0xece5, 0xf506, 0xed28, 0xe548, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed88, 0xed88, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed67, 0xed68, 0xed68, 0xed48, 0xed27, 0xe507, 0xdce7, 0xcc25, 0xa303, 0x81e2, 0x8a24, 0xab46, 0xc3c6, 0xc3a5, 0xcbc5, 0xc3a5, 0xc3a5, 0xc3c5, 0xc3c5, 0xc3c5, 0xc3c5, 0xc3c5, 0xc3c5, 0xcb85, 0xc385, 0xc384, 0xc384, 0xc384, 0xc384, 0xbb83, 0xbb63, 0xb303, 0xab03, 0xa304, 0x9b26, 0xa3aa, 0xb46e, 0xc573, 0xd5f6, 0xeeda, 0xef1b, 0xf75c, 0xff9d, 0xffbe, 0xf7be, 0xf7be, 0xf7df, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xef7d, 0xef5e, 0xde77, 0xcd0d, 0xcc46, 0xe4a5, 0xf527, 0xf528, 0xed28, 0xed48, 0xed48, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed68, 0xed48, 0xed48, 0xed47, 0xed27, 0xed27, 0xed27, 0xed28, 0xed27, 0xe4e7, 0xdcc7, 0xece7, 0xd407, 0xaae5, 0x9a85, 0xb325, 0xc3a5, 0xc3a4, 0xcb84, 0xc385, 0xc385, 0xc385, 0xc385, 0xc385, 0xc384, 0xc384, 0xc384, 0xc363, 0xbb63, 0xbb44, 0xb323, 0xb323, 0xab03, 0xa2e3, 0xa2c3, 0xa346, 0xaba8, 0xb44c, 0xc510, 0xcdd5, 0xde78, 0xe71c, 0xef5d, 0xef5e, 0xef5e, 0xef7e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xe77e, 0xef3c, 0xddf3, 0xc48a, 0xcc46, 0xe4a6, 0xece7, 0xf508, 0xed27, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed48, 0xed27, 0xed27, 0xed27, 0xed27, 0xed28, 0xed28, 0xed28, 0xed28, 0xed08, 0xe4e7, 0xf4c6, 0xd406, 0xaac5, 0x9a23, 0xa2a3, 0xb303, 0xb322, 0xbb23, 0xc364, 0xbb44, 0xbb44, 0xbb24, 0xbb23, 0xb303, 0xb303, 0xb303, 0xa302, 0xa302, 0xa303, 0xa304, 0xa346, 0xab89, 0xb3cb, 0xbc0c, 0xbd31, 0xc593, 0xde36, 0xe6d9, 0xef3c, 0xef5d, 0xef5d, 0xef5d, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7be, 0xf7be, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xef9e, 0xffbe, 0xeeda, 0xc551, 0xbc49, 0xc426, 0xdc66, 0xecc8, 0xe4e7, 0xe507, 0xe507, 0xe507, 0xed27, 0xed28, 0xed28, 0xed27, 0xed27, 0xe507, 0xe507, 0xe507, 0xe507, 0xe507, 0xe507, 0xe507, 0xed07, 0xed08, 0xed08, 0xed08, 0xed28, 0xed08, 0xed08, 0xe4c8, 0xd446, 0xb365, 0x9265, 0x8a45, 0x9ae6, 0x9b05, 0x9ae3, 0xa304, 0x9ac4, 0x9ac4, 0x9ac4, 0xa2c4, 0xa2e5, 0xa2e5, 0xa305, 0xab05, 0xa3a7, 0xabc8, 0xac2a, 0xb46d, 0xc4f0, 0xd574, 0xddf6, 0xe658, 0xdeda, 0xdefb, 0xe73c, 0xef5c, 0xef5d, 0xef7d, 0xf79e, 0xf79e, 0xf7df, 0xf7df, 0xf7bf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bd, 0xffdf, 0xef7f, 0xd679, 0xc571, 0xbc6a, 0xc406, 0xdc26, 0xdc86, 0xdca6, 0xdca6, 0xdcc6, 0xe4c7, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4e7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xdcc6, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xe4c7, 0xdca7, 0xdc86, 0xd466, 0xc48a, 0xbc4c, 0xac0e, 0xac30, 0xb4b0, 0xb48e, 0xac4c, 0xb44d, 0xb46e, 0xb46e, 0xbc8f, 0xbcaf, 0xc4d0, 0xcd10, 0xcd31, 0xd551, 0xd5d4, 0xd5f5, 0xde57, 0xde98, 0xdeba, 0xe6fb, 0xe71c, 0xe73d, 0xe73c, 0xe75d, 0xef7d, 0xf79e, 0xf79e, 0xf7be, 0xffbf, 0xffdf, 0xf79e, 0xf79e, 0xffbe, 0xf7bf, 0xf7bf, 0xf7df, 0xf7df, 0xf7df, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbc, 0xf79e, 0xef9f, 0xef7f, 0xe6d9, 0xcd4f, 0xc407, 0xcba5, 0xd445, 0xd465, 0xd465, 0xdc86, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdca6, 0xdc86, 0xdc66, 0xd465, 0xd446, 0xd446, 0xd425, 0xcbe5, 0xc3c4, 0xb4ee, 0xd615, 0xe69a, 0xde7b, 0xde9b, 0xdeb9, 0xde98, 0xd657, 0xde59, 0xde59, 0xde59, 0xde79, 0xde79, 0xde99, 0xe6ba, 0xe6ba, 0xe69c, 0xe6dd, 0xef1e, 0xef5e, 0xe77e, 0xe79e, 0xe7de, 0xe7ff, 0xf7bd, 0xffbe, 0xffde, 0xffde, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xf7be, 0xf7be, 0xf7df, 0xf7df, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xff9e, 0xffbf, 0xffbe, 0xf77d, 0xf73c, 0xe6ba, 0xcdf7, 0xb554, 0xc3e8, 0xc3c7, 0xc3a5, 0xc384, 0xcba3, 0xd3e3, 0xdc02, 0xdc02, 0xd424, 0xd424, 0xd424, 0xcc24, 0xcc24, 0xcc24, 0xcc04, 0xcc04, 0xdba3, 0xd3a4, 0xcb85, 0xbb86, 0xb3c9, 0xbc6d, 0xc531, 0xd5d4, 0xdedb, 0xdefb, 0xe71c, 0xef3d, 0xef5d, 0xef3d, 0xef3c, 0xef3d, 0xe71c, 0xe71c, 0xe71c, 0xe73c, 0xe73c, 0xef3d, 0xef3d, 0xef5d, 0xef7d, 0xef7d, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bf, 0xffbf, 0xffbe, 0xf79e, 0xf77d, 0xf75c, 0xe6fb, 0xde99, 0xd5b7, 0xcd75, 0xc513, 0xbcd1, 0xbc90, 0xb46e, 0xb44d, 0xb42d, 0xbbe9, 0xbbe9, 0xbbe9, 0xb3c9, 0xb3c9, 0xb3c9, 0xb3c9, 0xbbe9, 0xbc6c, 0xbc8d, 0xc4ef, 0xc552, 0xcdd5, 0xce38, 0xd6bb, 0xdf1c, 0xe73c, 0xef5d, 0xf77d, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xffbe, 0xffbe, 0xffbf, 0xffbf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7de, 0xf7be, 0xf79d, 0xf79d, 0xf79d, 0xf77d, 0xef5c, 0xe73c, 0xdf1c, 0xd6da, 0xd699, 0xd678, 0xd658, 0xce37, 0xce16, 0xd5f8, 0xd5f8, 0xd5d8, 0xd5d8, 0xd5d8, 0xd5f8, 0xd5f8, 0xd5f8, 0xcdf7, 0xce38, 0xd679, 0xdedb, 0xe71d, 0xe75e, 0xef5f, 0xef7f, 0xef7d, 0xf77e, 0xf79e, 0xf7be, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xefbe, 0xf7ff, 0xffff, 0xf7de, 0xf7de, 0xfffe, 0xffde, 0xf7bd, 0xef7d, 0xef5d, 0xe73c, 0xef3c, 0xef1c, 0xef1c, 0xeefc, 0xeefc, 0xe6fc, 0xe6dc, 0xe6dc, 0xe6dc, 0xe6dc, 0xe6fc, 0xeefc, 0xef1d, 0xef5d, 0xef5d, 0xef3c, 0xef3c, 0xf73c, 0xff5d, 0xff7d, 0xff7d, 0xf7be, 0xffbf, 0xffdf, 0xffdf, 0xffbf, 0xffbf, 0xffdf, 0xffdf, 0xffbf, 0xffbf, 0xffbf, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xefde, 0xf7ff, 0xf7ff, 0xf7de, 0xf7be, 0xf7de, 0xf7bd, 0xf79d, 0xf7be, 0xf79e, 0xf77e, 0xf77e, 0xf79e, 0xf77e, 0xf75e, 0xef5e, 0xf77c, 0xf75c, 0xf75c, 0xf75c, 0xf75c, 0xf77c, 0xff7c, 0xff7c, 0xf79f, 0xf79e, 0xf77e, 0xf77e, 0xff9e, 0xffbe, 0xffbe, 0xffde, 0xf79e, 0xf7be, 0xffbf, 0xffbe, 0xf7be, 0xf79e, 0xf7be, 0xffbe, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffbe, 0xffbe, 0xffbe, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xf7be, 0xffde, 0xffde, 0xffde, 0xf7ff, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xefbf, 0xefbf, 0xefbf, 0xefdf, 0xefdf, 0xefdf, 0xefdf, 0xefdf, 0xef9f, 0xefbf, 0xf7df, 0xf7df, 0xf7df, 0xefbf, 0xefbf, 0xef9f, 0xf79e, 0xf7be, 0xffdf, 0xffdf, 0xffbe, 0xf7be, 0xf7be, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffbf, 0xffbf, 0xffbe, 0xffde, 0xffdf, 0xffbe, 0xff7d, 0xff9e, 0xff7e, 0xff7d, 0xff5d, 0xff7d, 0xff9d, 0xff9c, 0xff7c, 0xffbd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffbd, 0xffbd, 0xffbb, 0xffbb, 0xffdc, 0xffbc, 0xffbd, 0xffbd, 0xffdf, 0xffff, 0xf79e, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffbf, 0xffbf, 0xf7be, 0xffbe, 0xffbe, 0xffbf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be
};

const unsigned short  Party[] PROGMEM = {
0xfffc, 0xfffd, 0xffde, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffd, 0xfffd, 0xfffd, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xfffe, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xfffe, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffdd, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xe7ff, 0xf7ff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xfffe, 0xf7fd, 0xf79f, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffbf, 0xffbf, 0xffff, 0xfffe, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xfffe, 0xf7dd, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bb, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x1231, 0x3a10, 0x620f, 0x8b10, 0xf6dc, 0xffde, 0xf75b, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffdf, 0xef19, 0xc5d1, 0xff1a, 0xff9d, 0xffff, 0xf7df, 0xffff, 0xffff, 0xf7dd, 0xfffe, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x2a15, 0x7af8, 0xdc7c, 0xf4fa, 0xfe3c, 0xddf9, 0xcdf9, 0xf7df, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf7de, 0xfffe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xee95, 0xd5ae, 0xfe53, 0xee33, 0xff9b, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7dd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x72d7, 0xcbbb, 0xfc7d, 0xfd3e, 0xfe5f, 0xcdbd, 0x949a, 0x845a, 0x8d59, 0xb65d, 0xdf7f, 0xffdf, 0xffdf, 0xffde, 0xfffd, 0xfffd, 0xffbf, 0xffdf, 0xffdf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xff5b, 0xf652, 0xfe2d, 0xf5ab, 0xfe0f, 0xf672, 0xe695, 0xffdc, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x92f3, 0xebf9, 0xfc5c, 0xfcbd, 0xcd1e, 0x6b78, 0x3256, 0x3258, 0x2255, 0x4b59, 0x741a, 0x949a, 0xc5bc, 0xf73f, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffbe, 0xee55, 0xedce, 0xf589, 0xfdeb, 0xf569, 0xf5ec, 0xf62f, 0xee73, 0xeef8, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef9f, 0xffff, 0xffff, 0xf7de, 0xfffe, 0xfffd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf63c, 0xec58, 0xfcdd, 0xe4de, 0x6b78, 0x1a55, 0x2278, 0x29f8, 0x227a, 0x2a18, 0x41f6, 0x6a96, 0xabf9, 0xdd7c, 0xe5db, 0xddb9, 0xef5f, 0xf77f, 0xffbf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xff9c, 0xf654, 0xfe0d, 0xfda8, 0xfd8b, 0xfdaa, 0xfd88, 0xfda9, 0xfe2d, 0xe5f1, 0xeefa, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xae1c, 0x9d79, 0xc6be, 0xefdf, 0xffff, 0xffff, 0xfffe, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffbf, 0xe4f8, 0xdbf9, 0x7ad6, 0x1a34, 0x0ab6, 0x22b9, 0x3259, 0x2a99, 0x29f7, 0x5a77, 0xac1c, 0xed7f, 0xfd9d, 0xfd9b, 0xfddb, 0xd67c, 0xb5b8, 0xb598, 0xdebc, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef9c, 0xe698, 0xf633, 0xfdcc, 0xfd87, 0xfd8d, 0xfd6a, 0xfd87, 0xfdc7, 0xf588, 0xd52b, 0xf6f8, 0xffff, 0xffff, 0xffdf, 0xf79e, 0xe73c, 0xe71c, 0xdefb, 0xdefb, 0xe71c, 0xdefb, 0xe73c, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x7cda, 0x5395, 0x7c98, 0xadfc, 0xcebd, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7df, 0xbd5a, 0x6ad4, 0x3215, 0x2238, 0x325a, 0x2ada, 0x12d9, 0x1a16, 0x6af9, 0xdc3b, 0xfcdb, 0xfd1a, 0xfd9c, 0xfdbf, 0xed1e, 0x6bbf, 0x52dd, 0x4add, 0x63be, 0x7c5e, 0x951c, 0xce9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xff9c, 0xee34, 0xe54d, 0xfdcc, 0xfd69, 0xfdca, 0xed69, 0xfdab, 0xfdcc, 0xe4e9, 0xd488, 0xdd2b, 0xedad, 0xe5c9, 0xe588, 0xdd47, 0xd526, 0xdd05, 0xdd25, 0xe525, 0xe525, 0xe546, 0xdd06, 0xdd07, 0xe54a, 0xed8c, 0xe58e, 0xe58f, 0xe590, 0xde55, 0xf6fa, 0xffdf, 0xffff, 0xf7de, 0xf7fd, 0xffff, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xfffd, 0xffdf, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xb5d8, 0x6c9c, 0x3b1a, 0x2aba, 0x4b9c, 0x74db, 0x9dda, 0xd71d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xe71f, 0x8459, 0x3235, 0x2258, 0x2299, 0x2237, 0x2a16, 0x7318, 0xc43c, 0xfcbc, 0xfcdb, 0xfd9d, 0xf5bf, 0xb47d, 0x82d9, 0x4a9c, 0x4a9c, 0x4abc, 0x52dc, 0x4ada, 0x5b19, 0x6bda, 0x847c, 0x8d1a, 0xc67f, 0xefbf, 0xffdf, 0xffdf, 0xffff, 0xfffe, 0xf7fd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xefbf, 0xffff, 0xffff, 0xfffd, 0xe633, 0xc489, 0xed48, 0xfdc9, 0xf5c8, 0xfda9, 0xfdea, 0xfd89, 0xdca6, 0xd485, 0xdd27, 0xdd68, 0xe5a8, 0xe588, 0xe567, 0xe567, 0xed87, 0xed87, 0xed86, 0xed86, 0xedc4, 0xe584, 0xe585, 0xe5a6, 0xeda8, 0xe5a8, 0xdd89, 0xdd89, 0xd588, 0xd5ab, 0xddcf, 0xd5b1, 0xd5d2, 0xeed8, 0xff9e, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdf5f, 0x9d39, 0x3b18, 0x32f9, 0x2abb, 0x2adb, 0x3af9, 0x5397, 0x8499, 0xadbc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffde, 0xf7ff, 0x8d1b, 0x2a14, 0x1237, 0x1298, 0x2a15, 0x7a57, 0xe3fa, 0xfc5b, 0xfcdc, 0xfdbf, 0xe5bf, 0x945c, 0x5299, 0x421a, 0x425b, 0x4abc, 0x52bc, 0x52bc, 0x4a9d, 0x4a9c, 0x425c, 0x425c, 0x52d8, 0x8c3c, 0xbd3d, 0xd55a, 0xe5d9, 0xfefc, 0xffdd, 0xfffd, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xf7fe, 0xffde, 0xffbf, 0xffbf, 0xffff, 0xf7df, 0xfffe, 0xfffb, 0xe671, 0xac66, 0xc483, 0xd4e3, 0xed48, 0xfda9, 0xfdc9, 0xf547, 0xe505, 0xed66, 0xf5e7, 0xede7, 0xedc7, 0xedc7, 0xedc7, 0xf5e7, 0xf607, 0xfe07, 0xf607, 0xfe07, 0xfe25, 0xf605, 0xee05, 0xee05, 0xede5, 0xe5c5, 0xe5a5, 0xe5c5, 0xe583, 0xe564, 0xdd46, 0xdd48, 0xdd49, 0xe5ad, 0xedb0, 0xdd71, 0xeed9, 0xf73b, 0xff9d, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xefff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xb67f, 0x6c3a, 0x2ad8, 0x333a, 0x335b, 0x2b1c, 0x229a, 0x3298, 0x63d9, 0xa57d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0x9d9b, 0x2ab4, 0x0a36, 0x2277, 0x6a97, 0xd39b, 0xfb99, 0xfbd9, 0xfcfd, 0xe59f, 0x943b, 0x4298, 0x323a, 0x42be, 0x429b, 0x4abc, 0x42bd, 0x4abe, 0x52be, 0x527d, 0x62bd, 0x7b3f, 0xbc5e, 0xd4be, 0xf4fd, 0xfcfc, 0xfcfa, 0xf53a, 0xdd39, 0xcd18, 0xff9e, 0xffde, 0xf7fd, 0xf7fd, 0xf7fe, 0xffff, 0xffdf, 0xffbf, 0xffde, 0xe6b7, 0xcdf2, 0xe650, 0xddeb, 0xc505, 0xcd04, 0xd503, 0xdcc7, 0xed08, 0xe507, 0xe4c5, 0xed46, 0xfde8, 0xfe48, 0xf647, 0xee26, 0xf626, 0xf646, 0xf646, 0xfe46, 0xfe46, 0xf646, 0xf626, 0xfe48, 0xfe47, 0xf647, 0xf647, 0xf626, 0xee26, 0xee26, 0xf626, 0xf627, 0xedc6, 0xed85, 0xeda4, 0xed84, 0xe5a4, 0xdd85, 0xd545, 0xd54a, 0xddad, 0xe651, 0xf6f6, 0xff7b, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdf7f, 0x851c, 0x4339, 0x3339, 0x2b38, 0x2b79, 0x2b7b, 0x2b1b, 0x3b19, 0x7cba, 0xcefd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xcede, 0x5c38, 0x2a96, 0x6278, 0xbaf9, 0xfbda, 0xfb59, 0xfc5c, 0xdcde, 0x83ba, 0x3a56, 0x3279, 0x42fd, 0x42be, 0x4adb, 0x4afd, 0x42de, 0x429e, 0x527c, 0x72db, 0xabfc, 0xe53f, 0xfd1b, 0xfd1c, 0xfd3d, 0xfd1d, 0xfcfd, 0xe47d, 0xbc1c, 0x9bbb, 0x8c5b, 0x9cdc, 0xb5fe, 0xdf5f, 0xf7ff, 0xffff, 0xf75c, 0xe678, 0xe60f, 0xd58c, 0xcd08, 0xd547, 0xdd66, 0xe565, 0xf5e7, 0xf5e6, 0xeda8, 0xed67, 0xdd05, 0xe525, 0xf5e6, 0xfe47, 0xf646, 0xee66, 0xf666, 0xf686, 0xf687, 0xf687, 0xf687, 0xf687, 0xf687, 0xf687, 0xf669, 0xf669, 0xf669, 0xf668, 0xf668, 0xf667, 0xf667, 0xf667, 0xe626, 0xe626, 0xf626, 0xf626, 0xf5e5, 0xe584, 0xdda4, 0xee26, 0xe543, 0xe524, 0xdd26, 0xdd6a, 0xe5f0, 0xeeb6, 0xff5b, 0xffde, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xb65c, 0x6418, 0x3ad8, 0x3afa, 0x2af8, 0x2338, 0x235a, 0x2b3a, 0x53d9, 0xa5fb, 0xeffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xf7df, 0x8d19, 0x5a55, 0xaa59, 0xf2fa, 0xfb58, 0xfc3e, 0xd43d, 0x7b3a, 0x3a57, 0x3279, 0x42bb, 0x4abc, 0x429b, 0x4afd, 0x4add, 0x4a9c, 0x5abc, 0x93bd, 0xccfe, 0xf59c, 0xfd9a, 0xfdbb, 0xfdfd, 0xfdbe, 0xdcde, 0xabdd, 0x831c, 0x627b, 0x421a, 0x4a5e, 0x4a3c, 0x5a9a, 0x83ba, 0xb539, 0xd615, 0xd62f, 0xcdca, 0xd505, 0xe566, 0xed85, 0xf5c5, 0xf5c5, 0xf5e6, 0xfe27, 0xede7, 0xfec7, 0xf646, 0xede5, 0xf626, 0xfea8, 0xfec8, 0xeea7, 0xf6c7, 0xf6aa, 0xf6aa, 0xf6ca, 0xf6ca, 0xf6cb, 0xf6cb, 0xf6eb, 0xf6ec, 0xf6cb, 0xf6cb, 0xf6cb, 0xf6aa, 0xf6a9, 0xf6a9, 0xf6a8, 0xee68, 0xee86, 0xf6a7, 0xfe89, 0xfe0b, 0xed2b, 0xcc49, 0xd48a, 0xed8c, 0xfde5, 0xfda5, 0xed44, 0xdd25, 0xdd47, 0xdd8b, 0xe5ce, 0xee10, 0xff5d, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xcedc, 0x955a, 0x747b, 0x42f9, 0x3b1a, 0x331b, 0x22da, 0x333a, 0x7cfc, 0xd71f, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xff9f, 0xf7ff, 0xf7ff, 0xbd19, 0xa214, 0xe239, 0xfa99, 0xfb16, 0xd43d, 0x82f9, 0x3216, 0x2a79, 0x42fd, 0x427b, 0x3a39, 0x52bb, 0x42bd, 0x4a7b, 0x6aba, 0xa3bb, 0xe4fe, 0xfdff, 0xfdfd, 0xf559, 0xee3f, 0xcd9e, 0x9c7d, 0x6b5c, 0x4a9b, 0x425c, 0x427d, 0x4abe, 0x4a5e, 0x525a, 0x6a94, 0x8b4e, 0xb44a, 0xd508, 0xdd46, 0xdd65, 0xe584, 0xf5c5, 0xf5e5, 0xfe05, 0xfe26, 0xfe47, 0xf668, 0xee68, 0xf6a8, 0xf687, 0xf668, 0xfe89, 0xfecb, 0xfecc, 0xf6cd, 0xf70e, 0xfef0, 0xfef0, 0xff11, 0xff31, 0xff31, 0xff32, 0xff53, 0xff53, 0xff30, 0xff50, 0xff30, 0xff0f, 0xff0f, 0xff0f, 0xfecd, 0xee6c, 0xfeae, 0xfdec, 0xf4cb, 0xebcc, 0xdaed, 0xca8c, 0xdb6d, 0xfd11, 0xfe28, 0xf607, 0xf5e6, 0xedc5, 0xe5a5, 0xe586, 0xdd46, 0xdd27, 0xe5cf, 0xee74, 0xff7a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xe75f, 0xc69e, 0x8cdb, 0x747c, 0x437b, 0x2ad9, 0x4bd9, 0xa5fd, 0xef9f, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffbf, 0xefff, 0xefff, 0xe559, 0xea76, 0xfa19, 0xfa37, 0xfb17, 0x8296, 0x4a15, 0x2a77, 0x2adc, 0x327c, 0x423c, 0x4a7b, 0x4aba, 0x427d, 0x6afc, 0xb43d, 0xf55e, 0xfd7c, 0xfd3b, 0xfd9d, 0xfdff, 0xac9f, 0x735b, 0x427a, 0x42de, 0x4b3f, 0x4aff, 0x4a9e, 0x5abe, 0x52f9, 0x7394, 0xac8c, 0xd504, 0xe540, 0xed20, 0xf545, 0xfd69, 0xede5, 0xf606, 0xfe27, 0xfe47, 0xf646, 0xee47, 0xee88, 0xe6c9, 0xf6ab, 0xfeed, 0xff0f, 0xfef0, 0xfef2, 0xfef3, 0xff35, 0xff77, 0xff35, 0xff56, 0xff77, 0xff77, 0xff77, 0xff57, 0xff78, 0xff78, 0xff96, 0xff96, 0xff76, 0xff55, 0xff56, 0xff55, 0xff14, 0xf6b2, 0xf471, 0xe38e, 0xda8c, 0xe24f, 0xea30, 0xd9ed, 0xe2ab, 0xfbeb, 0xf669, 0xf648, 0xee46, 0xee25, 0xee05, 0xedc5, 0xe565, 0xe545, 0xdd67, 0xd58a, 0xd5f0, 0xded7, 0xf7bd, 0xffff, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xef9f, 0xf7ff, 0xb67d, 0x643a, 0x4378, 0x751a, 0xcefd, 0xffde, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xf7bd, 0xffff, 0xfefe, 0xdad4, 0xfa17, 0xeb1c, 0x8298, 0x2217, 0x2277, 0x3258, 0x3a38, 0x3278, 0x3a9a, 0x429b, 0x32bb, 0x7ab7, 0xcbbd, 0xfc7e, 0xfcda, 0xfd79, 0xfe1c, 0xcd7e, 0x6c3c, 0x3b1c, 0x331e, 0x335f, 0x3b7e, 0x3b3d, 0x3abd, 0x52bc, 0x6b19, 0xc406, 0xcc86, 0xd505, 0xdd44, 0xe584, 0xe5a5, 0xede7, 0xf609, 0xf625, 0xf626, 0xf647, 0xf669, 0xf68b, 0xf6cd, 0xf6ee, 0xf6ef, 0xf734, 0xf734, 0xff55, 0xff76, 0xff98, 0xff99, 0xff99, 0xff9a, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffbb, 0xfffc, 0xf7db, 0xffdb, 0xff7b, 0xff7b, 0xfe58, 0xb30c, 0xea6e, 0xda2d, 0xeaae, 0xe28e, 0xda4d, 0xe26d, 0xda4d, 0xeaaf, 0xedc9, 0xfeab, 0xf688, 0xee05, 0xfe25, 0xfe26, 0xeda5, 0xdda6, 0xed84, 0xe544, 0xd525, 0xd548, 0xde0f, 0xf717, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xfffe, 0xffdf, 0xffdf, 0xf7df, 0xffff, 0xffff, 0xf79e, 0xb5b6, 0xb5b6, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xff5f, 0xe3b7, 0xd1f6, 0xaa38, 0x51f6, 0x1a97, 0x3258, 0x3a99, 0x2a99, 0x3258, 0x3278, 0x4a99, 0x727b, 0xd43c, 0xe41a, 0xfc99, 0xfd5b, 0xf57d, 0xc45d, 0x7b3c, 0x42bb, 0x3b3f, 0x335b, 0x2b5b, 0x2b1f, 0x3adf, 0x5afb, 0x83b0, 0xac49, 0xd4c6, 0xdd06, 0xe586, 0xedc5, 0xede5, 0xee06, 0xf628, 0xfe29, 0xf648, 0xf669, 0xf68a, 0xf6ac, 0xfeee, 0xff10, 0xff32, 0xff33, 0xff76, 0xff76, 0xff97, 0xff98, 0xffb9, 0xffba, 0xffbb, 0xffbb, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xfffc, 0xf7dc, 0xfffc, 0xff9b, 0xff9c, 0xfeda, 0xc410, 0xda6d, 0xe28e, 0xe26d, 0xda2d, 0xe24d, 0xe26e, 0xe26d, 0xe28e, 0xed0b, 0xfe4d, 0xfeab, 0xee27, 0xf647, 0xfe47, 0xf607, 0xee08, 0xedc6, 0xeda6, 0xe566, 0xd547, 0xd54a, 0xd5ef, 0xe6d6, 0xf77a, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffde, 0xffde, 0xffff, 0xffbf, 0xe53b, 0xb2b6, 0x6194, 0x2217, 0x1277, 0x3258, 0x2a99, 0x22d9, 0x2a78, 0x4277, 0x7ab9, 0xcadb, 0xfbdc, 0xfbf9, 0xfcb8, 0xe53b, 0xb43e, 0x72bd, 0x4a3d, 0x42df, 0x3b7d, 0x333c, 0x2afd, 0x3afe, 0x6359, 0x940e, 0xc4a4, 0xe500, 0xe546, 0xed86, 0xedc6, 0xf605, 0xf605, 0xf626, 0xf628, 0xf649, 0xf68c, 0xf6ad, 0xfeef, 0xff11, 0xff54, 0xff76, 0xff97, 0xff98, 0xffb9, 0xffb9, 0xffda, 0xffdb, 0xffdc, 0xffdc, 0xffdd, 0xffdd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdd, 0xfffd, 0xffdc, 0xfffd, 0xffdc, 0xffbd, 0xff7c, 0xdd95, 0xb9eb, 0xda8d, 0xe28e, 0xea4e, 0xea6e, 0xe24d, 0xe22d, 0xe22d, 0xec0d, 0xfdf1, 0xff11, 0xeecd, 0xf68a, 0xfe89, 0xfe49, 0xfe69, 0xf5e8, 0xf5e8, 0xf5c7, 0xe565, 0xd505, 0xcd27, 0xd58b, 0xde0e, 0xff7c, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffff, 0xff1f, 0xac19, 0x39d4, 0x12b9, 0x2216, 0x1297, 0x1a98, 0x2299, 0x3298, 0x7278, 0xcab9, 0xfb5b, 0xfafb, 0xfbdc, 0xe45c, 0x9bba, 0x5ab9, 0x427c, 0x4abf, 0x52ff, 0x333e, 0x3adf, 0x4afc, 0x73b2, 0xa488, 0xcd03, 0xe522, 0xf521, 0xed85, 0xf5c5, 0xf5e5, 0xf626, 0xf626, 0xf648, 0xf66a, 0xfe8c, 0xf6f1, 0xff12, 0xff54, 0xff76, 0xff99, 0xffba, 0xffbc, 0xffbc, 0xffdb, 0xffdc, 0xffdc, 0xfffd, 0xfffd, 0xfffe, 0xfffe, 0xfffe, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xfffd, 0xf7dd, 0xffdd, 0xffdd, 0xf6fa, 0xd2ce, 0xd22c, 0xea2d, 0xf20d, 0xea2d, 0xea4d, 0xea4d, 0xf28e, 0xcacc, 0xfd53, 0xff36, 0xf752, 0xef0f, 0xf6ac, 0xf64a, 0xf609, 0xf628, 0xf627, 0xf606, 0xf5c5, 0xeda4, 0xe564, 0xdd25, 0xd526, 0xd5d0, 0xeeb6, 0xffbd, 0xffff, 0xffff, 0xf7df, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xf7df, 0xf7ff, 0xf7ff, 0xa51a, 0x21f3, 0x0298, 0x3216, 0x12b7, 0x12b8, 0x2a58, 0x6238, 0xb238, 0xf299, 0xfb39, 0xfb7a, 0xe39c, 0xa2fc, 0x5a39, 0x3a59, 0x431d, 0x531f, 0x4a7f, 0x429f, 0x5b1a, 0x8bcf, 0xb485, 0xd4e3, 0xed25, 0xed66, 0xe5a3, 0xf605, 0xf606, 0xf627, 0xf648, 0xf68a, 0xfecd, 0xff0f, 0xff31, 0xff56, 0xff77, 0xff78, 0xff9a, 0xffbb, 0xffbd, 0xffbd, 0xff9e, 0xffdc, 0xffdc, 0xffdd, 0xfffd, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffbd, 0xffbd, 0xffbc, 0xffdd, 0xf7dd, 0xf7dc, 0xfffd, 0xffdd, 0xf473, 0xca2b, 0xf22d, 0xfa6e, 0xf22d, 0xea8d, 0xd20b, 0xda0c, 0xb22c, 0xdcb3, 0xfef8, 0xf796, 0xf773, 0xff31, 0xfece, 0xf68c, 0xf669, 0xf648, 0xf626, 0xfe05, 0xfe05, 0xf5c5, 0xed65, 0xdd04, 0xc4e7, 0xd5ac, 0xeeb5, 0xff9c, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffbf, 0xffbf, 0xefff, 0xefff, 0xbe3b, 0x32b4, 0x0257, 0x2215, 0x2236, 0x1a76, 0x4a36, 0xb198, 0xf1f9, 0xf2b8, 0xf2f7, 0xdbf7, 0x9ad7, 0x51f9, 0x423b, 0x42dc, 0x431c, 0x4abd, 0x5a5f, 0x6adb, 0x93cf, 0xc4c4, 0xe4e2, 0xecc6, 0xed28, 0xe5c7, 0xe626, 0xee27, 0xf628, 0xf649, 0xf68c, 0xf6cf, 0xff11, 0xff54, 0xff75, 0xff99, 0xff9a, 0xffba, 0xffbb, 0xffbc, 0xff9c, 0xff9d, 0xff9d, 0xffbc, 0xffdc, 0xffdc, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xf7dd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xff9c, 0xffbc, 0xff9c, 0xffbc, 0xffdc, 0xf7bc, 0xfffc, 0xfffd, 0xfdd7, 0xcaac, 0xea4d, 0xf24d, 0xd20b, 0xc28c, 0xc2cc, 0xdb90, 0xed16, 0xfe9a, 0xffbb, 0xf7b9, 0xf756, 0xff34, 0xff12, 0xf6f1, 0xf6ed, 0xf6ab, 0xf648, 0xf626, 0xfe06, 0xf5e6, 0xeda6, 0xed66, 0xdd44, 0xd526, 0xd56b, 0xe653, 0xff9c, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7fd, 0xefdf, 0x7458, 0x2297, 0x1235, 0x21f4, 0x39f4, 0x81d5, 0xe957, 0xf9d8, 0xf298, 0xdad7, 0x8337, 0x5297, 0x3a59, 0x429e, 0x42be, 0x3a7a, 0x4a98, 0x72f9, 0xabea, 0xc486, 0xdd04, 0xed05, 0xed26, 0xf5a6, 0xf607, 0xee29, 0xee49, 0xf66a, 0xf68d, 0xf6d0, 0xff13, 0xff36, 0xf758, 0xff59, 0xff9b, 0xff9b, 0xff9b, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xff9b, 0xffdc, 0xff9b, 0xffbb, 0xffdc, 0xffbb, 0xf7bb, 0xfffc, 0xff7c, 0xd431, 0xc24b, 0xca2b, 0xc2cd, 0xc451, 0xe5d6, 0xff1b, 0xff9d, 0xffdd, 0xfffd, 0xf7ba, 0xff78, 0xff77, 0xff77, 0xf775, 0xff32, 0xfef0, 0xf6ad, 0xf649, 0xf628, 0xf607, 0xede7, 0xede7, 0xf5c5, 0xe545, 0xd506, 0xdd6b, 0xee53, 0xff5a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xff9f, 0xffbf, 0xfffd, 0xf7fc, 0xffff, 0x8cb9, 0x2a15, 0x1275, 0x1a54, 0x61b4, 0xc156, 0xf977, 0xf997, 0xf1d6, 0xba96, 0x31f9, 0x2a79, 0x2abb, 0x3a7d, 0x423d, 0x4279, 0x6314, 0x8bb1, 0xdcc0, 0xe4e4, 0xe526, 0xe564, 0xede4, 0xf627, 0xfe28, 0xfe07, 0xf6ab, 0xfecd, 0xff10, 0xff54, 0xff98, 0xff9a, 0xff9b, 0xf77c, 0xffbc, 0xffbc, 0xff9b, 0xffbb, 0xffbb, 0xffba, 0xffba, 0xffda, 0xff9b, 0xffbb, 0xffbb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xf79a, 0xffdb, 0xffbb, 0xff9b, 0xffdc, 0xffbb, 0xff9a, 0xffbb, 0xfffd, 0xdd95, 0xc30d, 0xec11, 0xfe79, 0xffbc, 0xfffd, 0xf7dc, 0xffbb, 0xf7bb, 0xefba, 0xf79a, 0xff9b, 0xffba, 0xff99, 0xef97, 0xff36, 0xff14, 0xfed0, 0xfead, 0xf66a, 0xf648, 0xee28, 0xe628, 0xf5a5, 0xf586, 0xed46, 0xdd07, 0xd52b, 0xde12, 0xf77a, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffbe, 0xef9f, 0xb63d, 0x3271, 0x02b6, 0x41f5, 0xe0b6, 0xf895, 0xe155, 0xf998, 0x9a17, 0x22f6, 0x4257, 0x3237, 0x2a9a, 0x2abd, 0x325b, 0x62b4, 0xabaa, 0xe482, 0xe503, 0xe544, 0xeda5, 0xf5e5, 0xf5e7, 0xf608, 0xf64b, 0xfe6d, 0xf712, 0xf733, 0xff55, 0xff76, 0xff98, 0xff99, 0xf79a, 0xf79b, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xff77, 0xff57, 0xff15, 0xfef3, 0xfeaf, 0xfe8c, 0xf648, 0xf606, 0xf5c6, 0xf5e6, 0xeda4, 0xe564, 0xdd46, 0xd54a, 0xe611, 0xff79, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xdf7f, 0x7478, 0x0a74, 0x98d5, 0xe0b6, 0xe8f5, 0xf0d6, 0xb996, 0x5215, 0x2a35, 0x3a37, 0x2a56, 0x1a99, 0x2a7b, 0x5ab4, 0x9bcb, 0xcca6, 0xdcc7, 0xed44, 0xed65, 0xf5c5, 0xf5e6, 0xf608, 0xf64b, 0xfe8d, 0xfecf, 0xff14, 0xff35, 0xff56, 0xff77, 0xff98, 0xff99, 0xff9a, 0xf79a, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xff98, 0xff78, 0xff56, 0xff34, 0xfef1, 0xfece, 0xf68b, 0xf649, 0xf608, 0xfe07, 0xf5e5, 0xeda4, 0xe565, 0xd507, 0xd52b, 0xedf1, 0xffbc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffde, 0xffff, 0xefff, 0x9d9a, 0x5a34, 0xf015, 0xf8b6, 0xd916, 0xd8d5, 0x69d5, 0x1234, 0x29f6, 0x3276, 0x1a37, 0x1a58, 0x4ad4, 0x93a9, 0xd4a3, 0xe544, 0xd528, 0xf585, 0xf5a5, 0xf5c6, 0xf608, 0xf64b, 0xf6ae, 0xfef1, 0xff33, 0xff37, 0xff57, 0xff78, 0xff78, 0xff99, 0xffba, 0xffba, 0xff9a, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xff9a, 0xff99, 0xff79, 0xff57, 0xff55, 0xff12, 0xfecf, 0xf6ad, 0xf629, 0xf608, 0xf5e6, 0xf5c5, 0xf5a5, 0xe525, 0xd4e7, 0xdd0a, 0xe673, 0xff7a, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffbf, 0xffdf, 0xffde, 0xffff, 0xefbf, 0xadfa, 0xb9b5, 0xf855, 0xf896, 0xd8d6, 0x8955, 0x2a35, 0x0a35, 0x2a37, 0x1ab5, 0x19f9, 0x3a56, 0x8baa, 0xcca1, 0xe4c2, 0xe525, 0xe5a5, 0xfda5, 0xfdc6, 0xf5e8, 0xf64b, 0xf68e, 0xf6f1, 0xff34, 0xff75, 0xff59, 0xff59, 0xff79, 0xff99, 0xff99, 0xff99, 0xffb9, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xffbb, 0xffba, 0xff9a, 0xff99, 0xff78, 0xff55, 0xff13, 0xf6f1, 0xf68c, 0xee2a, 0xede7, 0xf5e5, 0xfdc5, 0xf585, 0xed45, 0xe526, 0xcd4a, 0xe653, 0xff7d, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xd6dc, 0xf9b6, 0xe8d4, 0xf876, 0xb8f6, 0x39d4, 0x0a75, 0x1276, 0x2257, 0x0a36, 0x3a36, 0x82ef, 0xc465, 0xdd01, 0xdd05, 0xe526, 0xfdc3, 0xf5c6, 0xf5e8, 0xf62a, 0xfe8e, 0xfed1, 0xff34, 0xf756, 0xf777, 0xff79, 0xff79, 0xff79, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xf7ba, 0xf79a, 0xff9a, 0xff9a, 0xff99, 0xff77, 0xff55, 0xf734, 0xff30, 0xf68d, 0xf62a, 0xf607, 0xf5e6, 0xf5a5, 0xf565, 0xed24, 0xd4e6, 0xd52b, 0xe655, 0xffbe, 0xffff, 0xf7ff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffbf, 0xfa56, 0xd8f3, 0xd895, 0x7196, 0x1215, 0x0a56, 0x0a76, 0x21f5, 0x19d3, 0x6b0d, 0xc407, 0xe484, 0xe506, 0xdd66, 0xeda5, 0xfda5, 0xee08, 0xf64a, 0xfe8e, 0xfed1, 0xff14, 0xff36, 0xf757, 0xf778, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xf7b9, 0xf799, 0xff99, 0xff79, 0xff79, 0xff78, 0xff56, 0xf755, 0xff32, 0xf6af, 0xf66d, 0xf64a, 0xf5e8, 0xf5c6, 0xed85, 0xe544, 0xe4e5, 0xd4c6, 0xd56d, 0xf6f7, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffd, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xffde, 0xffff, 0xffdf, 0xe3da, 0xd154, 0x9134, 0x2a55, 0x0a56, 0x1236, 0x1255, 0x29d4, 0x5a8d, 0xa407, 0xdce3, 0xecc4, 0xed07, 0xeda6, 0xf5e5, 0xf5e7, 0xee6b, 0xf68d, 0xfef1, 0xff14, 0xff36, 0xff57, 0xff58, 0xff78, 0xff97, 0xff97, 0xff97, 0xff78, 0xff78, 0xff78, 0xff78, 0xff99, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xffb7, 0xff98, 0xff78, 0xff78, 0xff78, 0xff78, 0xff77, 0xff56, 0xf734, 0xf6d2, 0xfeb0, 0xfe6d, 0xf60a, 0xede8, 0xede7, 0xe5a5, 0xf526, 0xe4e4, 0xd4e6, 0xddae, 0xf6f8, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffc, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xe53d, 0xd1d6, 0x59d4, 0x0295, 0x0a76, 0x1a56, 0x29f5, 0x2a34, 0xabc5, 0xc4a6, 0xd524, 0xe523, 0xf565, 0xfd86, 0xedc6, 0xee27, 0xee8c, 0xf6cf, 0xff12, 0xff35, 0xff37, 0xff58, 0xff78, 0xff99, 0xf796, 0xf796, 0xf796, 0xff77, 0xff77, 0xff78, 0xff78, 0xff79, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xffb7, 0xff97, 0xff77, 0xff77, 0xff78, 0xff77, 0xff77, 0xff76, 0xff76, 0xff34, 0xff13, 0xfeaf, 0xee0b, 0xe5e9, 0xee08, 0xe5e7, 0xfd47, 0xed24, 0xd4a2, 0xcc86, 0xe5d3, 0xff9f, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbc, 0x94bd, 0x1976, 0x1a15, 0x1ab8, 0x01da, 0x31d3, 0x930a, 0xdc44, 0xe4a4, 0xed24, 0xed64, 0xeda5, 0xede7, 0xee2a, 0xf64d, 0xeed3, 0xf6f4, 0xff35, 0xff56, 0xff57, 0xff57, 0xff78, 0xff78, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xf776, 0xff76, 0xff76, 0xff96, 0xff97, 0xff97, 0xff97, 0xffb7, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xf757, 0xff77, 0xff78, 0xff98, 0xff98, 0xff78, 0xf757, 0xf757, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xf757, 0xf757, 0xff56, 0xff55, 0xf734, 0xf712, 0xf6af, 0xf66c, 0xee08, 0xedc6, 0xed86, 0xf585, 0xed24, 0xe4c4, 0xe54a, 0xf694, 0xffbd, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xad5b, 0x3a74, 0x1234, 0x0a36, 0x11f6, 0x5ab0, 0xabe7, 0xe484, 0xe4c4, 0xed44, 0xed85, 0xedc6, 0xee09, 0xf64c, 0xfe8e, 0xf6f3, 0xf714, 0xff35, 0xff56, 0xff56, 0xff57, 0xff78, 0xff78, 0xff57, 0xff77, 0xff77, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff76, 0xff96, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xffb8, 0xff98, 0xff97, 0xf777, 0xf777, 0xff77, 0xff97, 0xffb8, 0xff77, 0xff77, 0xff57, 0xff57, 0xff57, 0xff57, 0xff57, 0xff57, 0xff56, 0xff56, 0xff35, 0xf713, 0xf6d0, 0xf68d, 0xee2a, 0xede8, 0xedc7, 0xf5a6, 0xf544, 0xe4e4, 0xd4a6, 0xd54e, 0xeeb8, 0xffff, 0xffdf, 0xffbe, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdedc, 0x6c36, 0x1ab6, 0x0a16, 0x3a72, 0x9389, 0xcc82, 0xe4c4, 0xed05, 0xed65, 0xeda6, 0xede8, 0xf62a, 0xfe8d, 0xfed0, 0xf714, 0xff14, 0xff55, 0xff56, 0xff56, 0xff57, 0xff57, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff56, 0xff56, 0xf756, 0xff76, 0xff97, 0xff97, 0xff97, 0xff76, 0xff76, 0xff76, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff76, 0xff76, 0xff97, 0xff77, 0xf756, 0xf756, 0xff56, 0xff77, 0xff77, 0xf756, 0xff36, 0xff36, 0xff35, 0xff34, 0xfef2, 0xfeaf, 0xf64c, 0xf60a, 0xf607, 0xf5a6, 0xf585, 0xf525, 0xdca5, 0xcc89, 0xe5f3, 0xffbc, 0xff9e, 0xf75a, 0xf79a, 0xfffe, 0xfffe, 0xfffc, 0xfffd, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0x8d39, 0x1297, 0x1a34, 0x732c, 0xbc23, 0xe4c1, 0xe505, 0xed25, 0xed86, 0xedc7, 0xf62a, 0xf66c, 0xfecf, 0xfef1, 0xff14, 0xff35, 0xff55, 0xff56, 0xff56, 0xff56, 0xff56, 0xff57, 0xf736, 0xff56, 0xff56, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff76, 0xff76, 0xff97, 0xff97, 0xff76, 0xff76, 0xff97, 0xffb7, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff75, 0xff76, 0xff96, 0xff96, 0xff96, 0xff96, 0xff75, 0xf755, 0xff97, 0xff77, 0xf736, 0xf736, 0xff56, 0xff56, 0xff56, 0xff56, 0xff36, 0xff36, 0xff36, 0xff35, 0xff34, 0xfef1, 0xf68f, 0xf64d, 0xee08, 0xeda6, 0xf585, 0xfd86, 0xed06, 0xd4a7, 0xdd0c, 0xf613, 0xdeb4, 0xf7b5, 0xfff5, 0xf795, 0xe734, 0xdf12, 0xd6d2, 0xce54, 0xef5d, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0x953a, 0x19f4, 0x3a50, 0x9bc7, 0xd461, 0xf4e4, 0xe525, 0xed65, 0xeda7, 0xede9, 0xf62b, 0xf68e, 0xfed1, 0xff13, 0xff35, 0xff35, 0xff55, 0xff56, 0xff55, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff76, 0xff76, 0xff56, 0xff56, 0xff35, 0xf735, 0xf755, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff75, 0xff75, 0xff75, 0xff96, 0xff96, 0xff76, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff36, 0xff36, 0xff36, 0xff56, 0xff35, 0xff13, 0xfeb0, 0xf68f, 0xee29, 0xedc7, 0xed86, 0xf565, 0xf525, 0xdca5, 0xcc46, 0xc427, 0xb587, 0xef6b, 0xffed, 0xf7ad, 0xf7cd, 0xffee, 0xfff0, 0xfff3, 0xd6ba, 0xffdf, 0xffff, 0xffdf, 0xffdf, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xb5fe, 0x52d3, 0x7b0c, 0xc445, 0xdc81, 0xece6, 0xe564, 0xed86, 0xedc8, 0xf60b, 0xf66d, 0xfeb0, 0xfef2, 0xff14, 0xff35, 0xff35, 0xff55, 0xff55, 0xff55, 0xf735, 0xf755, 0xff55, 0xff56, 0xff55, 0xff55, 0xff35, 0xff55, 0xff76, 0xff96, 0xff97, 0xff96, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff75, 0xff75, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xf755, 0xff55, 0xff76, 0xff96, 0xff76, 0xff75, 0xf755, 0xf735, 0xff55, 0xff55, 0xff56, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff35, 0xff36, 0xf736, 0xf736, 0xf735, 0xff33, 0xfef2, 0xfeb0, 0xf64c, 0xf60a, 0xeda7, 0xed65, 0xed45, 0xed25, 0xd484, 0xc403, 0xd687, 0xf7c8, 0xffe8, 0xf7c8, 0xf7c9, 0xefc8, 0xef8a, 0xfff0, 0xd6ba, 0xffdf, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xef7f, 0xb4d3, 0xbc09, 0xdc84, 0xdcc3, 0xed06, 0xed85, 0xeda6, 0xf5e9, 0xf64c, 0xfe8f, 0xfed2, 0xfef4, 0xff14, 0xff15, 0xff35, 0xff35, 0xff35, 0xf735, 0xf735, 0xf755, 0xff55, 0xff35, 0xff35, 0xff55, 0xff75, 0xff76, 0xff96, 0xff96, 0xff96, 0xffd7, 0xffb7, 0xff96, 0xffb7, 0xffb7, 0xffb7, 0xffb7, 0xff96, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xffd8, 0xffd8, 0xffb7, 0xff97, 0xff97, 0xffb7, 0xffb7, 0xffb7, 0xff35, 0xff55, 0xff76, 0xff76, 0xff55, 0xff35, 0xff35, 0xff55, 0xff55, 0xff35, 0xf735, 0xf735, 0xf734, 0xf733, 0xf6f2, 0xf6f1, 0xfe6e, 0xf62c, 0xf5c9, 0xf5a7, 0xf5a6, 0xed65, 0xe525, 0xdce4, 0xe6e9, 0xffc8, 0xffe7, 0xf7a8, 0xffe9, 0xf7c9, 0xf7ab, 0xfff1, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xefff, 0xfffe, 0xedf0, 0xdc45, 0xdc64, 0xe506, 0xed86, 0xedc5, 0xedc7, 0xf609, 0xfe6d, 0xfeb0, 0xfef3, 0xff14, 0xff15, 0xff15, 0xff15, 0xff35, 0xff35, 0xf734, 0xf734, 0xf754, 0xff75, 0xff75, 0xff96, 0xff96, 0xff75, 0xeed3, 0xd610, 0xbd2d, 0xa4aa, 0x9408, 0x9429, 0xa48a, 0xbd4d, 0xde51, 0xf714, 0xff75, 0xff96, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xcdd0, 0xbd4e, 0xa48b, 0x9409, 0x9409, 0xa48b, 0xbd4e, 0xcdd0, 0xf734, 0xff55, 0xff96, 0xff96, 0xff55, 0xff35, 0xff35, 0xff55, 0xff54, 0xff34, 0xf734, 0xef34, 0xf734, 0xf733, 0xf712, 0xf6f1, 0xfe8f, 0xf62d, 0xedca, 0xf5c8, 0xeda6, 0xe564, 0xdd24, 0xe524, 0xeecb, 0xffaa, 0xffc9, 0xf789, 0xffab, 0xffab, 0xf76d, 0xf751, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xffff, 0xff39, 0xdd49, 0xdca3, 0xe4a5, 0xf526, 0xf544, 0xf5a7, 0xf5e9, 0xf64c, 0xf6af, 0xf6d2, 0xf6f3, 0xfef4, 0xff14, 0xf734, 0xf713, 0xf734, 0xff54, 0xf734, 0xf734, 0xff75, 0xffb5, 0xffd8, 0xe632, 0xac6b, 0x8b26, 0x7223, 0x6980, 0x6960, 0x71a1, 0x69c1, 0x69c1, 0x69c1, 0x61c1, 0x61c0, 0x7283, 0xac6b, 0xee52, 0xff55, 0xffd7, 0xff74, 0xf732, 0xffb4, 0xffb5, 0xff74, 0xff95, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xf753, 0xff54, 0xfff7, 0xffb6, 0xe631, 0xa429, 0x7263, 0x69a1, 0x69a1, 0x69a1, 0x69a1, 0x69a1, 0x69a0, 0x61a0, 0x6180, 0x69e3, 0x8b07, 0xbcee, 0xee94, 0xff77, 0xff76, 0xef55, 0xef35, 0xff56, 0xff55, 0xff34, 0xf712, 0xf712, 0xff14, 0xff15, 0xf6b4, 0xee91, 0xf68f, 0xfe2c, 0xfdc8, 0xf565, 0xe545, 0xe586, 0xe5a7, 0xe78d, 0xefe9, 0xefc7, 0xffe9, 0xf7a5, 0xf7c4, 0xffee, 0xdeb6, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xe635, 0xcc86, 0xd462, 0xecc5, 0xf526, 0xf564, 0xf5c8, 0xf60a, 0xf66d, 0xfeb0, 0xf6d2, 0xf6f3, 0xff14, 0xff14, 0xeef3, 0xff75, 0xff55, 0xf6f3, 0xff35, 0xffb7, 0xf6f4, 0xc54e, 0x7aa5, 0x6a23, 0x61c1, 0x69c2, 0x7a02, 0x8203, 0x8a43, 0x9264, 0x8a64, 0x8a64, 0x8a84, 0x8a84, 0x7a43, 0x71c1, 0x69c1, 0x71e2, 0xb50c, 0xf6f4, 0xffb6, 0xff53, 0xff73, 0xff94, 0xf754, 0xff54, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xffb5, 0xff74, 0xfff6, 0xff14, 0xa449, 0x6a21, 0x6a01, 0x7a83, 0x8a64, 0x8a84, 0x8aa5, 0x92a5, 0x92a5, 0x8a85, 0x8a84, 0x8a64, 0x71e3, 0x69a2, 0x5961, 0x61a1, 0x9368, 0xd590, 0xff16, 0xff97, 0xff15, 0xf714, 0xf6d3, 0xff13, 0xff74, 0xfef3, 0xf6b3, 0xff15, 0xf6b2, 0xf6b0, 0xfe4d, 0xfde9, 0xf586, 0xed65, 0xe586, 0xe5a7, 0xf78c, 0xffe9, 0xffc8, 0xffeb, 0xffe9, 0xf7e7, 0xf7ef, 0xde95, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0xddb0, 0xcc65, 0xe4c4, 0xf506, 0xf546, 0xf585, 0xf5e9, 0xf62b, 0xf66e, 0xfed0, 0xf6f2, 0xf6f3, 0xff13, 0xff13, 0xff54, 0xf6f3, 0xff14, 0xff76, 0xfef5, 0xc4ee, 0x82c6, 0x61a1, 0x71c2, 0x71c2, 0x7a03, 0x8224, 0x8244, 0x8244, 0x7a23, 0x79e2, 0x8244, 0x8223, 0x8223, 0x8a44, 0x9265, 0x9264, 0x8a23, 0x81e2, 0x51e0, 0xc58e, 0xff95, 0xff54, 0xff53, 0xff95, 0xff74, 0xff75, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xf794, 0xf754, 0xff75, 0xbd0c, 0x61e1, 0x69e1, 0x8264, 0x8264, 0x92a5, 0x9285, 0x8a64, 0x8223, 0x79e2, 0x79e2, 0x8203, 0x8223, 0x7a04, 0x7a04, 0x8244, 0x7a24, 0x6981, 0x6161, 0x9307, 0xd4ef, 0xff56, 0xff35, 0xff55, 0xff13, 0xeeb1, 0xff13, 0xff55, 0xee92, 0xf6d2, 0xfed0, 0xfe8e, 0xfe0a, 0xf5a7, 0xed86, 0xed86, 0xe5a7, 0xf6c9, 0xff28, 0xf729, 0xff8e, 0xf7ce, 0xefcc, 0xefb1, 0xe717, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xe696, 0xccea, 0xcc64, 0xe4e5, 0xed06, 0xed26, 0xed86, 0xf60b, 0xf62c, 0xf68f, 0xfed0, 0xf6f2, 0xf6f2, 0xff13, 0xff13, 0xe671, 0xff76, 0xff76, 0xd58f, 0x8b07, 0x69c2, 0x69a2, 0x71c4, 0x71c2, 0x71e3, 0x7203, 0x69e2, 0x7243, 0x82c4, 0x8b46, 0x9387, 0x9326, 0x9306, 0x8aa4, 0x7a22, 0x71c1, 0x79e2, 0x8203, 0x8a23, 0x3920, 0xb50c, 0xff75, 0xff74, 0xff74, 0xff95, 0xff74, 0xff75, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xf753, 0xff94, 0xffb6, 0xac6a, 0x5160, 0x7222, 0x8a84, 0x79e2, 0x6180, 0x7202, 0x8ac5, 0x9b27, 0x9b47, 0x9b27, 0x9306, 0x9306, 0x7a64, 0x6a23, 0x69c2, 0x69e2, 0x7203, 0x79e3, 0x71a2, 0x6961, 0x8b26, 0xddd0, 0xff35, 0xff34, 0xff14, 0xf6d2, 0xf6b2, 0xff13, 0xf6f2, 0xfed1, 0xfeae, 0xfe4b, 0xf5e9, 0xeda7, 0xed87, 0xed87, 0xdd25, 0xdd23, 0xcd46, 0xd5ed, 0xd6d1, 0xd732, 0xdf34, 0xef19, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9c, 0xd5af, 0xc486, 0xdca5, 0xece6, 0xed06, 0xed46, 0xedc7, 0xf62c, 0xf66e, 0xfeaf, 0xf6d1, 0xf6f2, 0xfef2, 0xff12, 0xff12, 0xff97, 0xe611, 0xa3e9, 0x6a02, 0x5960, 0x69c2, 0x7203, 0x69c3, 0x7283, 0x9ba8, 0xc4ed, 0xde11, 0xf6f4, 0xff96, 0xffd6, 0xff95, 0xff96, 0xff76, 0xf6d3, 0xcd8e, 0xac29, 0x9346, 0x7a83, 0x6a01, 0x8bc7, 0xde30, 0xff95, 0xff74, 0xff93, 0xff73, 0xf733, 0xff74, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff93, 0xff94, 0xf733, 0xffd5, 0xd5ce, 0x82e4, 0x7242, 0x7a22, 0x92c5, 0xb4eb, 0xcd8e, 0xee92, 0xff55, 0xffb7, 0xff96, 0xff76, 0xff55, 0xeed3, 0xde10, 0xb4cc, 0x8b66, 0x6a42, 0x61c1, 0x69c2, 0x7203, 0x5980, 0x6a01, 0xb46b, 0xf693, 0xfef4, 0xfef3, 0xfef3, 0xf6d1, 0xf6f2, 0xf6d1, 0xfeaf, 0xfe4c, 0xf5ea, 0xf5a8, 0xed66, 0xed66, 0xed27, 0xdca4, 0xcc86, 0xdd90, 0xf759, 0xfffd, 0xffdd, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5a, 0xd54b, 0xcc83, 0xece5, 0xf4e6, 0xf526, 0xf5a7, 0xf5e9, 0xf64d, 0xf66e, 0xf6b0, 0xf6d1, 0xf6f2, 0xf6f2, 0xfef2, 0xff11, 0xcd2e, 0x82e5, 0x59a0, 0x59a0, 0x59a0, 0x61c0, 0x8b26, 0xbcac, 0xf713, 0xff55, 0xff95, 0xff94, 0xf774, 0xf774, 0xf793, 0xef73, 0xf733, 0xff74, 0xff94, 0xff94, 0xff74, 0xff74, 0xf712, 0xe6b1, 0xeeb2, 0xff74, 0xffb4, 0xff72, 0xff92, 0xff72, 0xf773, 0xffb4, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff93, 0xef11, 0xffb4, 0xffb4, 0xff12, 0xf6b2, 0xfeb2, 0xff75, 0xff94, 0xffb5, 0xffb5, 0xff94, 0xf753, 0xf753, 0xf753, 0xf753, 0xff94, 0xff74, 0xff95, 0xffd6, 0xf6d3, 0xb4cb, 0x7b05, 0x6222, 0x69c1, 0x5960, 0x5980, 0x82c5, 0xd5af, 0xff55, 0xf6d1, 0xeed0, 0xf6d1, 0xf6d1, 0xf6af, 0xf66d, 0xf60b, 0xf5a9, 0xed67, 0xed46, 0xed07, 0xdc84, 0xdc66, 0xdd4e, 0xf73a, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe5d3, 0xc466, 0xcc60, 0xe4c3, 0xecc6, 0xf526, 0xf5c7, 0xee0a, 0xf64e, 0xf66f, 0xf6b1, 0xf6d1, 0xf6d2, 0xf6f1, 0xfef1, 0xfef1, 0x8264, 0x5960, 0x5140, 0x6a22, 0x9386, 0xd5ce, 0xff74, 0xff94, 0xf733, 0xff53, 0xff73, 0xff73, 0xf752, 0xf752, 0xf772, 0xff72, 0xff52, 0xff72, 0xff72, 0xff72, 0xff93, 0xffb3, 0xffd3, 0xffb3, 0xff94, 0xffb4, 0xff92, 0xff71, 0xff91, 0xff92, 0xff92, 0xffb3, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff51, 0xff71, 0xff92, 0xff72, 0xff72, 0xff93, 0xff94, 0xff94, 0xff72, 0xff72, 0xff72, 0xf772, 0xf752, 0xf752, 0xf772, 0xff72, 0xf731, 0xff72, 0xff53, 0xf712, 0xff54, 0xffb6, 0xfef3, 0xd5af, 0x92e5, 0x7202, 0x71e2, 0x5960, 0x8b26, 0xee91, 0xff53, 0xeed0, 0xf6d1, 0xf6d1, 0xf6b0, 0xf68e, 0xf62c, 0xf5ca, 0xf587, 0xf546, 0xdd05, 0xdca2, 0xe463, 0xd488, 0xde14, 0xffdf, 0xffdf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xd4ef, 0xc485, 0xe501, 0xf504, 0xf4e7, 0xf547, 0xedc7, 0xee0a, 0xf66f, 0xf690, 0xf6b1, 0xf6d2, 0xf6d2, 0xf6f1, 0xfef1, 0xfef0, 0x92e7, 0x69a1, 0x8ac5, 0xddaf, 0xfef3, 0xff33, 0xf752, 0xf751, 0xff12, 0xff32, 0xff32, 0xff31, 0xff11, 0xff10, 0xff31, 0xff51, 0xff31, 0xff51, 0xff52, 0xff51, 0xf751, 0xef30, 0xef51, 0xf791, 0xff32, 0xff51, 0xff71, 0xff70, 0xff90, 0xff91, 0xf771, 0xef30, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff92, 0xff71, 0xff91, 0xf750, 0xf751, 0xf771, 0xf792, 0xf792, 0xef52, 0xff51, 0xff51, 0xff51, 0xff51, 0xff72, 0xff72, 0xff52, 0xff52, 0xff10, 0xff31, 0xff11, 0xfef1, 0xfef2, 0xff13, 0xff14, 0xfef3, 0xfef5, 0xcccd, 0x92e6, 0x5980, 0x9367, 0xf6d2, 0xff11, 0xf6f0, 0xf6d1, 0xf6d1, 0xf6d0, 0xf68f, 0xfe4d, 0xf5ea, 0xf588, 0xf546, 0xe5a5, 0xed42, 0xecc1, 0xcc23, 0xd590, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffbf, 0xffbe, 0xffff, 0xf7ff, 0xffff, 0xf75c, 0xe4a7, 0xdc86, 0xe4a5, 0xe4e5, 0xed25, 0xe567, 0xedc9, 0xf64c, 0xf670, 0xf690, 0xf690, 0xf6b0, 0xf6d1, 0xf6d1, 0xf6d1, 0xf6d1, 0xf6f1, 0xf6f1, 0xf6f1, 0xfef0, 0xff10, 0xff10, 0xff10, 0xff10, 0xff11, 0xff11, 0xff31, 0xff31, 0xff31, 0xff31, 0xf751, 0xff51, 0xff31, 0xff31, 0xff31, 0xff31, 0xff51, 0xff51, 0xff51, 0xff51, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff52, 0xff52, 0xff51, 0xff31, 0xff31, 0xff11, 0xff11, 0xff11, 0xfef1, 0xfef1, 0xfef1, 0xfef1, 0xfef1, 0xf6d0, 0xf6d0, 0xf6d0, 0xf6b0, 0xf6b0, 0xf6b0, 0xf6af, 0xf66d, 0xf60b, 0xf5a8, 0xed66, 0xed67, 0xe4e3, 0xe4c1, 0xdc43, 0xe52d, 0xff1b, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7fe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffdf, 0xde77, 0xdc46, 0xdc65, 0xe4a5, 0xed05, 0xed46, 0xed87, 0xedea, 0xf64c, 0xf66f, 0xf690, 0xf690, 0xf6b0, 0xf6b0, 0xf6d0, 0xf6d0, 0xf6d0, 0xf6f0, 0xf6f1, 0xf6f0, 0xfef0, 0xff10, 0xff10, 0xff10, 0xff10, 0xff10, 0xff30, 0xff30, 0xff31, 0xff31, 0xff51, 0xff51, 0xf751, 0xff30, 0xff31, 0xff31, 0xff31, 0xff51, 0xff51, 0xff51, 0xff51, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff31, 0xff31, 0xff11, 0xff11, 0xff10, 0xff10, 0xfef1, 0xfef1, 0xfef1, 0xfed1, 0xfed0, 0xfed0, 0xfed0, 0xf6d0, 0xf6b0, 0xf6b0, 0xf6b0, 0xf68f, 0xf66d, 0xf62b, 0xf5a8, 0xed66, 0xe527, 0xe504, 0xece2, 0xdc43, 0xd48a, 0xee36, 0xffbf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xff9e, 0xcdb3, 0xcc04, 0xdc44, 0xe4c5, 0xed25, 0xf566, 0xeda8, 0xedea, 0xf64d, 0xf66f, 0xf66f, 0xf690, 0xf6b0, 0xf6b0, 0xf6b0, 0xf6b0, 0xf6d0, 0xf6f0, 0xf6f0, 0xfef0, 0xfef0, 0xfef0, 0xff10, 0xff10, 0xff10, 0xff10, 0xff10, 0xff30, 0xff30, 0xff30, 0xff30, 0xf730, 0xff51, 0xff30, 0xff30, 0xff30, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff31, 0xff31, 0xff31, 0xff31, 0xff30, 0xff10, 0xff10, 0xff10, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfed0, 0xfed0, 0xf6d0, 0xf6d0, 0xf6d0, 0xf6b0, 0xf6b0, 0xf6b0, 0xf68f, 0xf66d, 0xf62b, 0xf5c9, 0xed87, 0xe526, 0xed25, 0xed03, 0xdc63, 0xc407, 0xdd72, 0xffbe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffbd, 0xd570, 0xcc04, 0xdc64, 0xece5, 0xf546, 0xf566, 0xeda8, 0xf60b, 0xf64d, 0xf66e, 0xf66f, 0xf68f, 0xf68f, 0xf6af, 0xf6af, 0xf6af, 0xf6af, 0xfed0, 0xfed0, 0xfed0, 0xfef0, 0xfef0, 0xff0f, 0xff10, 0xff0f, 0xff10, 0xff10, 0xff10, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xff10, 0xff10, 0xff10, 0xfef0, 0xfef0, 0xfef0, 0xfef0, 0xfed0, 0xfed0, 0xfed0, 0xfecf, 0xf6cf, 0xf6af, 0xf6af, 0xf68f, 0xf6af, 0xf68f, 0xf68f, 0xf66e, 0xf62b, 0xf5c9, 0xeda8, 0xed27, 0xed25, 0xe503, 0xe4a4, 0xcc05, 0xdd4f, 0xffbd, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xfffe, 0xf7fe, 0xffff, 0xff3a, 0xcd0c, 0xd424, 0xdc85, 0xed05, 0xed25, 0xed46, 0xed88, 0xf5eb, 0xf64d, 0xf64e, 0xf66e, 0xf66e, 0xf68f, 0xf68f, 0xf6af, 0xf6af, 0xf6af, 0xf6cf, 0xf6cf, 0xfecf, 0xfeef, 0xfeef, 0xfeef, 0xfeef, 0xff0f, 0xff0f, 0xff0f, 0xff0f, 0xff0f, 0xff2f, 0xff2f, 0xff30, 0xff30, 0xff2f, 0xff2f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff50, 0xff50, 0xff50, 0xff50, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff50, 0xff50, 0xff50, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xff10, 0xff10, 0xff10, 0xff0f, 0xfeef, 0xfeef, 0xfecf, 0xfecf, 0xfecf, 0xfecf, 0xfeaf, 0xf6af, 0xf6af, 0xf6af, 0xfe8f, 0xf68f, 0xf68f, 0xf68e, 0xf66e, 0xf62c, 0xf5ea, 0xeda8, 0xf547, 0xed46, 0xe504, 0xe4c4, 0xd424, 0xdd0c, 0xff5a, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xf7fd, 0xf7ff, 0xffff, 0xee35, 0xc447, 0xd464, 0xe4a5, 0xed05, 0xed25, 0xed46, 0xeda9, 0xf60c, 0xf62d, 0xf64e, 0xf64e, 0xf66e, 0xf68e, 0xf68e, 0xf68e, 0xf6ae, 0xf6ae, 0xf6cf, 0xf6cf, 0xf6cf, 0xfecf, 0xfeef, 0xfeee, 0xfeee, 0xfeee, 0xfeef, 0xff0f, 0xff0f, 0xff0f, 0xff0f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff0f, 0xff0f, 0xff0f, 0xfeef, 0xfeef, 0xfeef, 0xfecf, 0xfeaf, 0xfeaf, 0xfeaf, 0xfeae, 0xf6ae, 0xf68e, 0xf68e, 0xfe8e, 0xfe8e, 0xf66e, 0xf66e, 0xf66e, 0xf62c, 0xedea, 0xedc9, 0xf547, 0xed26, 0xe525, 0xe4e4, 0xdc23, 0xd468, 0xe655, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffdf, 0xdd71, 0xc405, 0xd464, 0xe4a4, 0xed05, 0xed25, 0xed66, 0xf5c9, 0xf60c, 0xf60d, 0xf64d, 0xf64d, 0xf66e, 0xf66e, 0xf68e, 0xf68e, 0xf68e, 0xf68e, 0xf6ae, 0xf6ae, 0xf6ae, 0xfece, 0xfece, 0xfece, 0xfece, 0xfeee, 0xfeee, 0xfeee, 0xff0e, 0xff0f, 0xff0f, 0xff0f, 0xff2f, 0xff2f, 0xf72e, 0xf72e, 0xff4e, 0xff4e, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff0f, 0xff0f, 0xff0f, 0xff0f, 0xff0f, 0xfeef, 0xfeef, 0xfeee, 0xfece, 0xfece, 0xfece, 0xfeae, 0xfeae, 0xfeae, 0xf6ae, 0xf6ae, 0xf68e, 0xf68e, 0xfe6e, 0xfe6e, 0xf66e, 0xf66e, 0xf66e, 0xf64c, 0xf60b, 0xedc9, 0xf527, 0xe506, 0xe546, 0xe4e3, 0xdc21, 0xcc05, 0xd591, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7fd, 0xffff, 0xffdf, 0xdd50, 0xcc45, 0xd444, 0xe4a4, 0xed05, 0xed25, 0xf567, 0xf5ea, 0xf60c, 0xee0d, 0xf64d, 0xf64d, 0xf66d, 0xf66d, 0xf68e, 0xf68e, 0xf68e, 0xf68e, 0xf6ae, 0xf6ae, 0xf6ae, 0xf6ae, 0xfece, 0xfece, 0xfece, 0xfece, 0xfeee, 0xff0e, 0xff0e, 0xff0e, 0xff0e, 0xff0e, 0xff2e, 0xff2e, 0xf72e, 0xf72e, 0xff4e, 0xff4e, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4e, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2e, 0xff2e, 0xff2e, 0xfeef, 0xfeef, 0xfeee, 0xfeee, 0xfece, 0xfece, 0xfece, 0xfeae, 0xfeae, 0xfeae, 0xfeae, 0xf6ae, 0xf6ae, 0xf68e, 0xf68e, 0xf68e, 0xfe6e, 0xfe6e, 0xf66e, 0xf66e, 0xf66e, 0xf64c, 0xf60b, 0xedca, 0xf527, 0xe506, 0xe546, 0xe4e3, 0xe442, 0xd425, 0xcd50, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xf7ff, 0xffff, 0xffde, 0xdd4d, 0xcc03, 0xe464, 0xe4a5, 0xed05, 0xed46, 0xed88, 0xf5c9, 0xf5eb, 0xf60c, 0xf64d, 0xf64d, 0xf64d, 0xf64d, 0xfe6d, 0xfe6d, 0xfe6d, 0xfe6d, 0xfe6c, 0xfe6c, 0xf64c, 0xf64c, 0xf64c, 0xfe6c, 0xfe6c, 0xfe6c, 0xfeab, 0xfeac, 0xfead, 0xfe8d, 0xf6ae, 0xff0f, 0xff4f, 0xff4f, 0xff2f, 0xff2f, 0xf72f, 0xf72f, 0xf72f, 0xf72f, 0xff2f, 0xff4f, 0xff4f, 0xff4f, 0xff4e, 0xff4d, 0xff6e, 0xff6d, 0xff4d, 0xff4d, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff6e, 0xf74d, 0xf74e, 0xff4f, 0xff90, 0xff6f, 0xf72e, 0xf72e, 0xf76f, 0xf76f, 0xf74e, 0xf74e, 0xf74e, 0xf74d, 0xf74d, 0xff4d, 0xff4d, 0xff4d, 0xff2d, 0xf72d, 0xff2e, 0xff2e, 0xff2e, 0xf70e, 0xfead, 0xfead, 0xfead, 0xfeae, 0xfead, 0xfe4c, 0xfe4b, 0xfe8c, 0xfe6c, 0xfe6c, 0xfe4c, 0xf64c, 0xf64c, 0xf66c, 0xf66d, 0xf66d, 0xfe6d, 0xf66d, 0xf66c, 0xf66c, 0xf66c, 0xf62c, 0xf5eb, 0xf5ab, 0xed46, 0xfd45, 0xf505, 0xe4c6, 0xdca5, 0xd443, 0xdd4c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xf7ff, 0xffff, 0xffdd, 0xd50c, 0xd403, 0xe484, 0xe4a5, 0xed05, 0xed46, 0xed88, 0xf5c9, 0xf5eb, 0xf60c, 0xf64d, 0xf64d, 0xf64d, 0xf64d, 0xf64d, 0xfe4c, 0xfe4d, 0xfe4c, 0xf62b, 0xf62b, 0xf62b, 0xf62b, 0xf62b, 0xf64c, 0xfe4c, 0xfe4c, 0xfe6c, 0xf62b, 0xfe8c, 0xff0e, 0xff0e, 0xf6cd, 0xf6ed, 0xf70d, 0xff4d, 0xff4d, 0xff6d, 0xff6d, 0xff6d, 0xff6d, 0xff4d, 0xff4d, 0xff4e, 0xff4e, 0xff6e, 0xff4e, 0xf72d, 0xff4e, 0xff6e, 0xf72d, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4d, 0xf72d, 0xff8f, 0xf72e, 0xeeed, 0xff4e, 0xf72e, 0xff4e, 0xf76e, 0xf72d, 0xef0d, 0xf72d, 0xff6e, 0xff8e, 0xff4e, 0xff2d, 0xff2d, 0xff4e, 0xff6e, 0xff4e, 0xf70d, 0xf6ec, 0xf6ed, 0xf70d, 0xfecd, 0xfead, 0xfe6c, 0xfe6c, 0xfe6c, 0xfe4c, 0xfe2b, 0xfe2b, 0xfe4c, 0xfe2c, 0xf62b, 0xf62b, 0xf62c, 0xf62c, 0xf64c, 0xf64c, 0xf64d, 0xf64c, 0xf64c, 0xf64c, 0xf64c, 0xf62c, 0xf5eb, 0xf5ab, 0xed46, 0xf525, 0xf505, 0xdca6, 0xdca5, 0xdc43, 0xdd2c, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xff5b, 0xccab, 0xd403, 0xe484, 0xe4a5, 0xed05, 0xed46, 0xed88, 0xf5a9, 0xf5eb, 0xf60c, 0xf62d, 0xf62d, 0xf62c, 0xf62c, 0xf62c, 0xf62c, 0xfe2b, 0xf60b, 0xf60b, 0xf60b, 0xf5ea, 0xf5ea, 0xf5ea, 0xf60b, 0xf60b, 0xfe0b, 0xfe2d, 0xf62c, 0xfe6c, 0xf66b, 0xee4a, 0xf6ac, 0xff2e, 0xff2e, 0xff4e, 0xff4e, 0xff2e, 0xff2e, 0xff4e, 0xff4e, 0xff6f, 0xff8f, 0xff6f, 0xff6f, 0xff6f, 0xf72e, 0xf72d, 0xf72d, 0xf74e, 0xffaf, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4e, 0xf72d, 0xff6e, 0xf72c, 0xf72d, 0xff6e, 0xf72c, 0xff4d, 0xff4d, 0xff6e, 0xff6e, 0xff6f, 0xff4f, 0xff4f, 0xff70, 0xff71, 0xff70, 0xff50, 0xff4f, 0xff4f, 0xff6f, 0xff4e, 0xff0d, 0xf6cc, 0xfe6b, 0xfe8c, 0xfe6b, 0xfe6b, 0xfe6c, 0xfe2b, 0xf5ea, 0xfe0b, 0xf60a, 0xf60b, 0xf60b, 0xf5eb, 0xf5eb, 0xf60b, 0xf60b, 0xf60c, 0xfe2c, 0xf62c, 0xf62c, 0xf64c, 0xf64c, 0xf60b, 0xf5eb, 0xf5aa, 0xed46, 0xf525, 0xece5, 0xdca6, 0xe4a5, 0xdc42, 0xd4ea, 0xff3c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xf6d9, 0xc449, 0xdc23, 0xe484, 0xe4a5, 0xed05, 0xed46, 0xed87, 0xf5a9, 0xf5eb, 0xf60c, 0xf62c, 0xf60c, 0xf60c, 0xf60b, 0xf5eb, 0xf5eb, 0xf5ea, 0xf5ca, 0xf5ca, 0xf5ca, 0xf5ca, 0xf5ca, 0xf5ca, 0xf5ca, 0xfdca, 0xfdea, 0xfdeb, 0xfe2b, 0xfe6c, 0xfe6b, 0xf66b, 0xfeee, 0xfeef, 0xee4d, 0xd58d, 0xc50b, 0xac48, 0x9b86, 0x9344, 0x9365, 0xa3c6, 0xac07, 0xbd08, 0xde0c, 0xf6ef, 0xff71, 0xffd1, 0xf74d, 0xe6eb, 0xf76c, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff6e, 0xff6e, 0xff2c, 0xff2c, 0xff6d, 0xff4c, 0xf70c, 0xff6e, 0xff4f, 0xff2f, 0xf6ae, 0xe60c, 0xc52a, 0xac47, 0x9ba5, 0x9364, 0x9364, 0x9ba5, 0xac26, 0xc4e9, 0xe5cc, 0xf68e, 0xfece, 0xfece, 0xfead, 0xfe8c, 0xf62a, 0xf62a, 0xfe4a, 0xfdea, 0xf5a9, 0xfdeb, 0xfdca, 0xfdca, 0xf5ca, 0xf5ca, 0xf5ca, 0xf5ca, 0xf5eb, 0xf5eb, 0xfe0b, 0xf60b, 0xf60b, 0xf62b, 0xf62b, 0xf60b, 0xf5ca, 0xf5aa, 0xed47, 0xf525, 0xecc5, 0xdca6, 0xe4a5, 0xdc22, 0xcc89, 0xeeb9, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xee77, 0xbbe7, 0xe422, 0xe484, 0xe4c5, 0xed05, 0xed46, 0xed67, 0xeda9, 0xf5eb, 0xf5ec, 0xf60b, 0xf5eb, 0xf5eb, 0xf5ca, 0xf5ca, 0xf5aa, 0xf5a9, 0xf5a9, 0xfda9, 0xfd89, 0xfd89, 0xf589, 0xfd89, 0xfda9, 0xfdaa, 0xfdaa, 0xf5a8, 0xf5c9, 0xfe2b, 0xfe6d, 0xf60c, 0xcd0a, 0xabe6, 0x8ae3, 0x6981, 0x69a2, 0x71c2, 0x71e3, 0x71e3, 0x71e3, 0x69c2, 0x69a2, 0x5980, 0x6a20, 0x8303, 0xb468, 0xe64d, 0xff8f, 0xff8d, 0xf72a, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xf70c, 0xff4d, 0xff2c, 0xff4c, 0xf72b, 0xf70c, 0xff8f, 0xff6f, 0xee4f, 0xc4ea, 0x8b03, 0x69c0, 0x6180, 0x69a0, 0x71e2, 0x71e2, 0x7203, 0x7202, 0x69c1, 0x61a0, 0x69c0, 0x82a2, 0xb407, 0xd50b, 0xf62d, 0xfe6d, 0xf60b, 0xeda8, 0xf5a8, 0xfdc9, 0xfdaa, 0xfd69, 0xfd89, 0xfd89, 0xf589, 0xf589, 0xf589, 0xf5a9, 0xf5aa, 0xfdca, 0xfdcb, 0xf5ca, 0xf5ea, 0xee0b, 0xf60b, 0xf60b, 0xf5ca, 0xf5aa, 0xed67, 0xf525, 0xece5, 0xdca6, 0xe4a4, 0xdc01, 0xc447, 0xe637, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe636, 0xbbc6, 0xe422, 0xe484, 0xe4c5, 0xed05, 0xed46, 0xed67, 0xeda9, 0xedcb, 0xf5ec, 0xf5cb, 0xf5ca, 0xf5ca, 0xf5aa, 0xf5a9, 0xf589, 0xf589, 0xf588, 0xfd69, 0xfd69, 0xfd48, 0xfd48, 0xfd69, 0xfd69, 0xfd69, 0xfd69, 0xed86, 0xfe09, 0xfdcb, 0xd4a9, 0xa325, 0x7a21, 0x69a0, 0x69a0, 0x8263, 0x8a64, 0x8a84, 0x8a84, 0x92a5, 0x92a5, 0x92c5, 0x92c5, 0x8aa5, 0x7a23, 0x69c1, 0x69e0, 0x8b23, 0xd58a, 0xff4e, 0xff6c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xf70c, 0xf70b, 0xf72b, 0xff4b, 0xf6eb, 0xff4e, 0xff0f, 0xc529, 0x7a43, 0x7202, 0x71c1, 0x7a02, 0x8a65, 0x92c6, 0x92c7, 0x92a6, 0x8265, 0x8a86, 0x92c6, 0x8a85, 0x7a23, 0x71c1, 0x69a0, 0x69a0, 0x9b44, 0xd4e9, 0xfe0c, 0xfdea, 0xf568, 0xfd88, 0xfd89, 0xfd29, 0xfd68, 0xfd48, 0xfd68, 0xf568, 0xf568, 0xfd69, 0xfd89, 0xfd89, 0xfdaa, 0xf5aa, 0xf5aa, 0xedca, 0xedea, 0xf5ea, 0xedca, 0xedaa, 0xed88, 0xf545, 0xece5, 0xe4a6, 0xe4a4, 0xdc00, 0xc426, 0xde16, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe616, 0xbba5, 0xec22, 0xe484, 0xe4c5, 0xed05, 0xed46, 0xed67, 0xeda9, 0xedca, 0xf5ec, 0xf5aa, 0xf5aa, 0xf5aa, 0xf589, 0xf589, 0xf568, 0xf568, 0xf568, 0xfd28, 0xfd28, 0xfd28, 0xfd28, 0xfd28, 0xfd28, 0xfd28, 0xfd48, 0xf5a7, 0xfdca, 0xd468, 0x8a43, 0x7161, 0x71c2, 0x8263, 0x92e5, 0x92a3, 0x92a3, 0x92c3, 0x9ac4, 0x9ae4, 0x9ae4, 0x9ae4, 0x9ae4, 0x9a84, 0xa2c6, 0x9aa6, 0x7a03, 0x6180, 0x7240, 0xbcc8, 0xff70, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff8d, 0xf6ea, 0xff4b, 0xf72b, 0xff2c, 0xff0f, 0xb488, 0x6a41, 0x71c1, 0x8243, 0x92a5, 0x9ae6, 0x9ae6, 0x9ae6, 0x9ac5, 0x9ac5, 0x9ae6, 0x92c5, 0x92a5, 0x9ac5, 0x9ae6, 0x92a5, 0x8a43, 0x7a02, 0x6160, 0x8a83, 0xd488, 0xfdcb, 0xfd89, 0xf527, 0xfd48, 0xfd29, 0xfd27, 0xfd27, 0xf527, 0xf527, 0xf528, 0xfd48, 0xfd48, 0xfd69, 0xfd69, 0xf589, 0xf5a9, 0xedca, 0xedea, 0xedea, 0xedaa, 0xeda9, 0xe567, 0xed25, 0xece5, 0xe4a6, 0xeca4, 0xdc00, 0xcc26, 0xe615, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe615, 0xbba5, 0xec21, 0xe484, 0xe4c5, 0xed05, 0xed46, 0xed67, 0xeda9, 0xedca, 0xedec, 0xf5aa, 0xf5a9, 0xf589, 0xf589, 0xf568, 0xf568, 0xf548, 0xf548, 0xfd07, 0xfd07, 0xfd07, 0xf4e7, 0xfd07, 0xfd07, 0xfd08, 0xfd08, 0xfda9, 0xd446, 0x8a01, 0x6900, 0x81e5, 0x92c6, 0x8aa4, 0x8aa2, 0xa2e5, 0x9ae4, 0x9ac4, 0x9ac4, 0x9ac4, 0x9ac4, 0x9ac4, 0x9ac4, 0x9a62, 0xa2a5, 0x9224, 0x9246, 0x8a65, 0x5940, 0x7a62, 0xf670, 0xff2b, 0xff2b, 0xff2b, 0xff2b, 0xff2b, 0xff2b, 0xff2b, 0xff2b, 0xf70b, 0xeec9, 0xff8c, 0xf6ea, 0xff6e, 0xe64d, 0x6a61, 0x59c1, 0x8a63, 0x8a63, 0x9283, 0x92a3, 0x92a3, 0x9aa3, 0x9ac3, 0x9ac3, 0x9ae4, 0x9ac3, 0x92c3, 0x92c3, 0x9ac4, 0x92c4, 0x92a4, 0x8a63, 0x8a46, 0x6120, 0x8220, 0xdca7, 0xfda9, 0xf527, 0xf4e6, 0xfd08, 0xf506, 0xf506, 0xf506, 0xf507, 0xf507, 0xf527, 0xfd28, 0xf548, 0xfd69, 0xf569, 0xf589, 0xedaa, 0xedea, 0xedca, 0xedaa, 0xeda9, 0xe547, 0xed25, 0xece5, 0xe4a6, 0xeca4, 0xdc00, 0xcc26, 0xee36, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffde, 0xffff, 0xffff, 0xfffe, 0xd614, 0xcbe4, 0xe3e2, 0xe464, 0xe4a5, 0xece6, 0xed27, 0xf548, 0xf568, 0xf588, 0xf589, 0xf5a9, 0xf589, 0xf568, 0xf568, 0xf548, 0xf528, 0xf528, 0xf508, 0xfce7, 0xfce7, 0xfce7, 0xfcc6, 0xfcc6, 0xfcc6, 0xfcc6, 0xfcc7, 0xf548, 0x92c2, 0x6181, 0x7a25, 0x9266, 0x9264, 0x9263, 0x92a4, 0x8a66, 0x8a45, 0x8224, 0x79e3, 0x71c2, 0x71e2, 0x71e2, 0x7202, 0x69e0, 0x7201, 0x71e2, 0x7a25, 0x7a05, 0x5940, 0x9305, 0xfeb2, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf70b, 0xff4b, 0xff4b, 0xeeea, 0xff6e, 0xee8e, 0x8345, 0x5180, 0x7203, 0x7a23, 0x7203, 0x69c2, 0x71e2, 0x7a23, 0x7202, 0x69a0, 0x71e3, 0x7a23, 0x8264, 0x8285, 0x8aa5, 0x8aa4, 0x8aa4, 0x8aa4, 0x7a84, 0x7a44, 0x6140, 0xa325, 0xf54a, 0xece6, 0xeca6, 0xfce8, 0xfca6, 0xfca6, 0xfcc6, 0xfcc6, 0xfce7, 0xfd07, 0xfd07, 0xfd07, 0xf528, 0xf548, 0xf568, 0xf568, 0xf588, 0xf589, 0xed88, 0xed88, 0xed27, 0xed47, 0xed05, 0xe4a5, 0xdc65, 0xf402, 0xdbe4, 0xde57, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffde, 0xffff, 0xffff, 0xfffe, 0xde15, 0xcbe5, 0xe403, 0xe464, 0xe4a5, 0xece6, 0xed27, 0xf548, 0xf568, 0xf588, 0xf589, 0xf568, 0xf568, 0xf568, 0xf548, 0xf528, 0xf527, 0xf507, 0xf507, 0xfcc6, 0xfcc6, 0xf4c6, 0xfcc6, 0xfca6, 0xfca6, 0xfca6, 0xfca6, 0xed09, 0x8a42, 0x6182, 0x8267, 0x9266, 0x89e2, 0x8202, 0x8222, 0x7a00, 0x8241, 0x92e3, 0xa385, 0xb427, 0xc488, 0xc4e9, 0xcd09, 0xc4e7, 0xb446, 0x9b85, 0x7a61, 0x5140, 0x6a00, 0xc4c8, 0xff30, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xff8d, 0xff2b, 0xff4b, 0xf70a, 0xff2c, 0xff50, 0xbd09, 0x6220, 0x5980, 0x7aa1, 0xa3c5, 0xb468, 0xc4c9, 0xcd0a, 0xcd0a, 0xc4c9, 0xabe6, 0x9b65, 0x82a2, 0x7221, 0x71e0, 0x7a01, 0x8263, 0x8aa4, 0x7a63, 0x8ac6, 0x6961, 0x9282, 0xece9, 0xfd07, 0xf4a6, 0xfca6, 0xfc86, 0xfca6, 0xfca6, 0xfcc6, 0xfcc6, 0xf4e7, 0xfd07, 0xf507, 0xf528, 0xf528, 0xf548, 0xf568, 0xf588, 0xf588, 0xed88, 0xed88, 0xf547, 0xed27, 0xece5, 0xe4a4, 0xdc65, 0xf402, 0xdbe5, 0xde77, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdd, 0xffff, 0xffff, 0xfffe, 0xde35, 0xcbe5, 0xe423, 0xe464, 0xe4a5, 0xece6, 0xed26, 0xf547, 0xed48, 0xf568, 0xf588, 0xf568, 0xf548, 0xf547, 0xf527, 0xf507, 0xf4e7, 0xf4e7, 0xf4e6, 0xf4a6, 0xf4a6, 0xf4a6, 0xf486, 0xf485, 0xfc85, 0xfc86, 0xfc86, 0xf50b, 0x9aa4, 0x5941, 0x6983, 0x79e3, 0x8a02, 0x92a2, 0x9b24, 0xd548, 0xe589, 0xee2b, 0xfead, 0xff2e, 0xff4e, 0xff4d, 0xff4d, 0xff4c, 0xff2c, 0xff2e, 0xe64b, 0xbce6, 0xd5a8, 0xff2d, 0xff6c, 0xf72a, 0xf72a, 0xf72a, 0xf72a, 0xf72a, 0xf72a, 0xf72a, 0xf72a, 0xf70b, 0xeeea, 0xff2a, 0xf709, 0xf6ea, 0xff8e, 0xff0e, 0xbd28, 0xc567, 0xe64a, 0xff4e, 0xff8f, 0xff6e, 0xff6e, 0xff6e, 0xff4d, 0xff4e, 0xfeed, 0xf66c, 0xe58b, 0xcc88, 0xab65, 0x8a42, 0x71a0, 0x7243, 0x7203, 0x6940, 0xab05, 0xf509, 0xf4a6, 0xf465, 0xfc66, 0xfc65, 0xfc85, 0xfc86, 0xfca6, 0xfcc6, 0xf4c6, 0xf4e6, 0xf4e7, 0xf527, 0xf527, 0xf548, 0xf548, 0xf568, 0xf568, 0xed68, 0xed68, 0xf547, 0xed27, 0xece5, 0xe4a4, 0xdc85, 0xec02, 0xdbe5, 0xde78, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdd, 0xffff, 0xffff, 0xffff, 0xde36, 0xc3c5, 0xe403, 0xe463, 0xe484, 0xecc5, 0xed06, 0xed27, 0xed47, 0xed48, 0xf568, 0xf547, 0xf547, 0xf527, 0xf507, 0xf4e6, 0xf4e6, 0xf4c6, 0xf4c6, 0xfc86, 0xf485, 0xf465, 0xf465, 0xf445, 0xf445, 0xf445, 0xfc45, 0xfd0b, 0xcc29, 0x8243, 0x69a0, 0x9b04, 0xd488, 0xed8a, 0xfe8e, 0xf649, 0xf669, 0xf689, 0xf6ca, 0xf6ea, 0xf6e9, 0xf6e9, 0xeee9, 0xf729, 0xff6a, 0xff8c, 0xff8c, 0xff4b, 0xff4a, 0xf729, 0xef08, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xeeca, 0xff2a, 0xff29, 0xff29, 0xf709, 0xf70a, 0xff4c, 0xff4d, 0xf70a, 0xff4b, 0xff4b, 0xf70a, 0xeec8, 0xeee9, 0xeee9, 0xf709, 0xfec9, 0xfec9, 0xfeca, 0xfeac, 0xfe8d, 0xfe0d, 0xed8c, 0xe50b, 0x8ae5, 0x69c1, 0x8202, 0xdc49, 0xfd09, 0xf444, 0xfc44, 0xfc46, 0xf445, 0xf445, 0xf465, 0xf485, 0xf4a6, 0xf4a6, 0xf4c6, 0xf4c6, 0xf507, 0xf507, 0xf527, 0xf547, 0xf547, 0xf547, 0xed67, 0xed67, 0xf526, 0xed06, 0xecc4, 0xe4a5, 0xdc85, 0xec02, 0xd3c5, 0xd658, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdd, 0xf7ff, 0xffff, 0xffff, 0xde57, 0xc3a5, 0xd3c3, 0xe463, 0xe484, 0xecc5, 0xece6, 0xed06, 0xed27, 0xed27, 0xed47, 0xf547, 0xf527, 0xf527, 0xf507, 0xf4e6, 0xf4c6, 0xf4c6, 0xf4c6, 0xfc65, 0xf465, 0xf445, 0xf424, 0xf424, 0xf424, 0xf424, 0xfc25, 0xf4a7, 0xfd8c, 0xe52b, 0xcca8, 0xf58a, 0xfe0a, 0xf5c8, 0xeda7, 0xf628, 0xf628, 0xf648, 0xf688, 0xf6c9, 0xf709, 0xf749, 0xf76a, 0xf728, 0xf729, 0xeec8, 0xeee9, 0xff4a, 0xf72a, 0xef08, 0xf729, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf70a, 0xff4b, 0xf6e8, 0xf729, 0xff8a, 0xf6e8, 0xeec8, 0xff4a, 0xf70a, 0xf72a, 0xf72a, 0xf709, 0xf729, 0xff4a, 0xff4a, 0xf729, 0xff09, 0xfec8, 0xf648, 0xf608, 0xf5e8, 0xf5c9, 0xf5a9, 0xf589, 0xf5ce, 0xdcec, 0xecec, 0xfd6d, 0xfce8, 0xf424, 0xfc24, 0xf383, 0xf424, 0xf424, 0xf445, 0xf445, 0xf485, 0xf486, 0xf4a6, 0xf4a6, 0xf4e6, 0xf4e7, 0xf507, 0xf527, 0xf527, 0xf547, 0xed47, 0xed47, 0xf505, 0xe4e5, 0xecc4, 0xe4a5, 0xdc65, 0xe3e1, 0xcba4, 0xce58, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xfffd, 0xf7ff, 0xffff, 0xffff, 0xe6b8, 0xc3c6, 0xd3a3, 0xe443, 0xe484, 0xeca4, 0xece5, 0xed06, 0xed06, 0xed26, 0xed27, 0xf527, 0xf527, 0xf527, 0xf506, 0xf4e6, 0xf4c6, 0xf4c6, 0xf4a6, 0xfc65, 0xfc45, 0xf425, 0xf404, 0xf404, 0xf404, 0xfc04, 0xfc04, 0xf443, 0xf4c7, 0xf529, 0xed28, 0xed26, 0xf565, 0xfda5, 0xf5c6, 0xf608, 0xf628, 0xf649, 0xf689, 0xf6c9, 0xf6e9, 0xf709, 0xf729, 0xf709, 0xf729, 0xf72a, 0xf709, 0xf709, 0xf72a, 0xf709, 0xf6e9, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf6e8, 0xff29, 0xf6e8, 0xf6e8, 0xf708, 0xf6e8, 0xf708, 0xf6e8, 0xf70a, 0xf70a, 0xf72a, 0xf72a, 0xf72a, 0xf72a, 0xf709, 0xf6e9, 0xf6a8, 0xf688, 0xf647, 0xf627, 0xfe07, 0xfdc7, 0xf586, 0xf545, 0xf549, 0xfd6b, 0xfd0b, 0xf4a8, 0xf465, 0xfc23, 0xfc04, 0xfbe5, 0xf404, 0xf404, 0xf424, 0xf445, 0xf465, 0xf485, 0xf486, 0xf4a6, 0xf4c6, 0xf4e6, 0xf4e6, 0xf506, 0xf527, 0xf527, 0xed27, 0xed27, 0xf4e5, 0xece5, 0xecc4, 0xe4a4, 0xd465, 0xe3c1, 0xcbc5, 0xd6b9, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xfffd, 0xf7ff, 0xffdf, 0xffff, 0xf73b, 0xcc28, 0xd3a4, 0xe443, 0xe463, 0xeca4, 0xece5, 0xece6, 0xed06, 0xed06, 0xed26, 0xf527, 0xf506, 0xf506, 0xf4e6, 0xf4c6, 0xf4c6, 0xf4a5, 0xf4a5, 0xfc45, 0xfc45, 0xfc24, 0xf3e4, 0xf3e4, 0xf3e4, 0xfbe4, 0xfc04, 0xfc43, 0xf464, 0xecc7, 0xece7, 0xecc4, 0xf4e3, 0xfd86, 0xfde8, 0xf5e7, 0xfe08, 0xfe48, 0xfe89, 0xfec9, 0xfee9, 0xf709, 0xf728, 0xf709, 0xff29, 0xff29, 0xf708, 0xeec7, 0xf6e8, 0xf709, 0xf6e9, 0xf708, 0xf708, 0xf708, 0xf708, 0xf708, 0xf708, 0xf708, 0xf708, 0xf6e8, 0xff09, 0xff29, 0xf6e9, 0xeea7, 0xf6e8, 0xff29, 0xf6e8, 0xf70a, 0xf709, 0xf6e9, 0xf6e9, 0xf6e8, 0xf6e8, 0xf708, 0xf709, 0xfee8, 0xfea8, 0xf647, 0xf606, 0xf5c6, 0xf5a6, 0xf586, 0xfd66, 0xf4e4, 0xf4c5, 0xf486, 0xec45, 0xf444, 0xf423, 0xf3e3, 0xfc26, 0xf3e4, 0xf404, 0xf404, 0xf425, 0xf445, 0xf465, 0xfc86, 0xf486, 0xf4c6, 0xf4c6, 0xf4e6, 0xf4e6, 0xf506, 0xf506, 0xed06, 0xed26, 0xf4e4, 0xece5, 0xecc4, 0xe4a4, 0xd444, 0xe3c2, 0xd427, 0xe73c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xfffd, 0xf7ff, 0xffdf, 0xffff, 0xff9c, 0xd469, 0xd3c4, 0xdc42, 0xe463, 0xeca4, 0xecc5, 0xece5, 0xed06, 0xed06, 0xed26, 0xf506, 0xf506, 0xf4e6, 0xf4e6, 0xf4c6, 0xf4a5, 0xf4a5, 0xf485, 0xfc65, 0xfc45, 0xfc04, 0xf3e4, 0xfbe4, 0xfbe4, 0xfbe4, 0xfc04, 0xfc03, 0xfc86, 0xf4c7, 0xf4c7, 0xfd06, 0xfd26, 0xfd26, 0xf547, 0xfdc6, 0xfde7, 0xfe27, 0xfe68, 0xfea8, 0xfee8, 0xf708, 0xf728, 0xff08, 0xff08, 0xf6e7, 0xff07, 0xff08, 0xf6e7, 0xf6e8, 0xff29, 0xf708, 0xf708, 0xf708, 0xf708, 0xf708, 0xf708, 0xf708, 0xf708, 0xff08, 0xf6e8, 0xf6e8, 0xf6e9, 0xff0a, 0xff2a, 0xff09, 0xf6c8, 0xff09, 0xfee8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e7, 0xf6c7, 0xf6a7, 0xf667, 0xf627, 0xf5c7, 0xfd87, 0xfd67, 0xfd47, 0xfd44, 0xfcc4, 0xfca5, 0xfc85, 0xf422, 0xf422, 0xf3e3, 0xf3c4, 0xf3e4, 0xf3e4, 0xf404, 0xf425, 0xf445, 0xfc65, 0xfc86, 0xfc86, 0xf4a5, 0xf4c6, 0xf4e6, 0xf4e6, 0xf506, 0xf506, 0xed06, 0xed06, 0xf4e4, 0xecc5, 0xecc4, 0xe4a4, 0xd444, 0xe3e2, 0xdc68, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffbf, 0xd4ce, 0xdba2, 0xd403, 0xdc24, 0xe485, 0xecc5, 0xecc5, 0xece5, 0xece5, 0xed05, 0xf4e5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4a5, 0xf4a5, 0xf484, 0xf465, 0xf444, 0xf444, 0xf424, 0xf424, 0xf424, 0xf424, 0xf424, 0xf464, 0xf485, 0xfcc5, 0xfce5, 0xf505, 0xf526, 0xfd66, 0xfd87, 0xf5e6, 0xf606, 0xf627, 0xfe67, 0xfea8, 0xfec8, 0xfee8, 0xfee8, 0xff07, 0xff07, 0xff07, 0xff07, 0xff07, 0xff07, 0xff07, 0xff07, 0xff08, 0xf6a7, 0xf6e7, 0xff28, 0xff08, 0xfee8, 0xff08, 0xf6e8, 0xff06, 0xff06, 0xff07, 0xff07, 0xfee8, 0xfee8, 0xfee8, 0xff09, 0xf707, 0xf707, 0xf707, 0xf707, 0xf707, 0xf707, 0xf707, 0xff07, 0xfea7, 0xfe87, 0xfe47, 0xfe07, 0xfde6, 0xfda6, 0xf566, 0xf546, 0xfce6, 0xfcc5, 0xfcc5, 0xf485, 0xf464, 0xf444, 0xf424, 0xf424, 0xf404, 0xf424, 0xf424, 0xf444, 0xf465, 0xfc65, 0xfc85, 0xfc85, 0xf4e3, 0xdd06, 0xdd48, 0xfce6, 0xfc83, 0xfcc4, 0xed27, 0xd4e7, 0xd48a, 0xc40b, 0xb42e, 0x948e, 0x840a, 0x9bc8, 0xcdcf, 0xfff9, 0xfffd, 0xffff, 0xf7bf, 0xffff, 0xffff, 
0xffdf, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xd52f, 0xdbc3, 0xd3e3, 0xdc24, 0xe485, 0xeca5, 0xecc5, 0xece5, 0xece5, 0xece5, 0xf4c5, 0xf4e5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4a5, 0xf4a5, 0xf484, 0xf465, 0xf465, 0xf444, 0xf444, 0xf424, 0xf424, 0xf424, 0xfc24, 0xf464, 0xf484, 0xfcc5, 0xf4e5, 0xf505, 0xf525, 0xfd66, 0xfd86, 0xf5e6, 0xf606, 0xf646, 0xfe67, 0xfea8, 0xfec8, 0xfee8, 0xf6e8, 0xff07, 0xff07, 0xff07, 0xff07, 0xff07, 0xff07, 0xff07, 0xff07, 0xff08, 0xf6a7, 0xf6e7, 0xff08, 0xf6e7, 0xf6c7, 0xf6e7, 0xf6e7, 0xf6e8, 0xf6e8, 0xf6c8, 0xf6e8, 0xf6e8, 0xfee8, 0xff08, 0xff08, 0xf6e7, 0xf6e7, 0xf707, 0xf707, 0xf707, 0xf707, 0xf707, 0xf707, 0xfea7, 0xfe87, 0xf647, 0xf606, 0xfde6, 0xfda6, 0xf566, 0xf546, 0xfd05, 0xfce5, 0xfcc5, 0xf4a5, 0xf464, 0xf444, 0xf444, 0xf424, 0xf424, 0xf424, 0xf444, 0xf444, 0xf465, 0xf485, 0xfc85, 0xfc85, 0xf4c5, 0xe4c5, 0xe505, 0xfce5, 0xfca5, 0xe488, 0xcc6b, 0xbbec, 0xa373, 0x9394, 0x7416, 0x6458, 0x5c18, 0x6bd6, 0x9cf9, 0xcebd, 0xefff, 0xefff, 0xffff, 0xffff, 0xffdf, 
0xffbf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xdd91, 0xcba4, 0xd3e3, 0xdc24, 0xe465, 0xe4a5, 0xecc5, 0xecc5, 0xece5, 0xece4, 0xf4e5, 0xf4c5, 0xf4e5, 0xf4c5, 0xf4c5, 0xf4a5, 0xf4a5, 0xf484, 0xf485, 0xf464, 0xf464, 0xf444, 0xf444, 0xf444, 0xf444, 0xfc44, 0xf484, 0xf4a4, 0xf4c5, 0xf4e5, 0xf505, 0xf545, 0xfd66, 0xfda6, 0xf5e6, 0xf606, 0xf647, 0xfe67, 0xfea7, 0xfec8, 0xf6e8, 0xf6e8, 0xfee7, 0xfee7, 0xfee7, 0xfee7, 0xfee7, 0xfee7, 0xfee7, 0xfee7, 0xff08, 0xf6c7, 0xfee7, 0xff07, 0xf6c7, 0xf6e6, 0xff06, 0xff27, 0xf6a8, 0xf6a8, 0xf6a8, 0xf6a7, 0xf6c7, 0xf6e7, 0xfee7, 0xff07, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xfea7, 0xf687, 0xf646, 0xf606, 0xf5e6, 0xf5a6, 0xf586, 0xf546, 0xfd05, 0xfce5, 0xf4c5, 0xf4a5, 0xf484, 0xf464, 0xf444, 0xf444, 0xf444, 0xf444, 0xf444, 0xf464, 0xf465, 0xf485, 0xf485, 0xf4a5, 0xf4a7, 0xf4a3, 0xf4c2, 0xf4e5, 0xd4c9, 0xb46f, 0xa3f3, 0xa375, 0xa3ba, 0x845a, 0x5c99, 0x547a, 0x541c, 0x53bb, 0x6bfa, 0x94da, 0xc5b9, 0xffbf, 0xffff, 0xffff, 0xfffe, 
0xffdf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xddf4, 0xbba5, 0xd3c3, 0xdc03, 0xe444, 0xe485, 0xeca5, 0xecc5, 0xecc4, 0xece4, 0xecc5, 0xf4e5, 0xf4e5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4a5, 0xf4a5, 0xf484, 0xf484, 0xf484, 0xf464, 0xf464, 0xf464, 0xfc64, 0xfc64, 0xf4a4, 0xf4c4, 0xf4e5, 0xf505, 0xf525, 0xf545, 0xf586, 0xfda6, 0xf5e6, 0xf606, 0xfe46, 0xfe87, 0xfea7, 0xfec7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xfee7, 0xf6c7, 0xff07, 0xf6e7, 0xf6c6, 0xf6e6, 0xf6c5, 0xf6e6, 0xff28, 0xff08, 0xff07, 0xf6e7, 0xf6e7, 0xf6c7, 0xf6c7, 0xf6c6, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6a7, 0xf686, 0xf646, 0xf626, 0xf5e6, 0xf5c6, 0xf586, 0xf565, 0xfd26, 0xfd05, 0xf4e5, 0xf4c5, 0xf4a4, 0xf484, 0xf485, 0xf465, 0xf464, 0xf464, 0xf464, 0xf484, 0xf485, 0xf4a5, 0xf4a5, 0xf4a5, 0xf487, 0xfca2, 0xfce2, 0xd4e8, 0x9cd0, 0x7c96, 0x7c5a, 0x8c1d, 0x9bdb, 0x7c59, 0x6415, 0x6b54, 0x7335, 0x62f5, 0x52f5, 0x7357, 0x9970, 0xed1b, 0xff7f, 0xf7fe, 0xfffe, 
0xffdf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xee98, 0xbc08, 0xd3a2, 0xd3e3, 0xdc24, 0xe464, 0xeca5, 0xeca4, 0xecc4, 0xecc4, 0xecc5, 0xecc5, 0xf4e5, 0xf4e5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4a5, 0xf4a4, 0xf4a4, 0xf4a4, 0xf484, 0xf484, 0xf484, 0xfc84, 0xfca5, 0xf4c4, 0xf4e5, 0xf505, 0xf525, 0xf545, 0xf565, 0xf5a6, 0xf5c6, 0xf606, 0xfe26, 0xfe46, 0xfe87, 0xfea7, 0xf6c7, 0xf6e7, 0xf6c7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6a7, 0xf6c6, 0xff07, 0xf6c6, 0xf6c6, 0xf6e7, 0xf6a6, 0xfee8, 0xf6e5, 0xf6e5, 0xf6e5, 0xf6e6, 0xf6e6, 0xff07, 0xff07, 0xff07, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c6, 0xf6c6, 0xf6a7, 0xf686, 0xf666, 0xf626, 0xf606, 0xf5c6, 0xf5a6, 0xf585, 0xfd46, 0xfd25, 0xf505, 0xf4e5, 0xf4c5, 0xf4a5, 0xf4a5, 0xf4a5, 0xf484, 0xf484, 0xf484, 0xf4a4, 0xf4a5, 0xf4a5, 0xf4c5, 0xf4c5, 0xf485, 0xfcc2, 0xece4, 0xacad, 0x6cb6, 0x5cbb, 0x649c, 0x647c, 0x6bd5, 0x63f4, 0x6b70, 0x8aac, 0x9aac, 0x7a8c, 0x528f, 0x5ad4, 0xa973, 0x816f, 0xdddb, 0xffdf, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xff7c, 0xcccc, 0xd382, 0xd3c3, 0xdc24, 0xe464, 0xec84, 0xeca4, 0xecc4, 0xecc4, 0xecc5, 0xecc5, 0xecc5, 0xf4e5, 0xf4e5, 0xf4c5, 0xf4c5, 0xeca5, 0xf4a5, 0xf4a5, 0xf4a4, 0xf4a4, 0xf4a5, 0xfca5, 0xfca5, 0xfca5, 0xf4e5, 0xf505, 0xf525, 0xf545, 0xf565, 0xf585, 0xf5a6, 0xf5e6, 0xf606, 0xfe26, 0xfe66, 0xfe87, 0xfea7, 0xf6c7, 0xf6c7, 0xf6c6, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6c7, 0xf6c6, 0xff07, 0xeea5, 0xf6c6, 0xff09, 0xfeca, 0xff2c, 0xf6e7, 0xfee7, 0xff07, 0xff07, 0xf6e7, 0xf6e6, 0xf6c6, 0xeea6, 0xfee7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf686, 0xf666, 0xf646, 0xf606, 0xfde6, 0xf5a6, 0xf586, 0xf565, 0xf545, 0xf525, 0xf505, 0xf4e5, 0xf4c5, 0xf4c5, 0xfcc5, 0xf4a5, 0xf4a5, 0xf4a5, 0xf4a5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4c5, 0xec84, 0xfcc3, 0xd4a7, 0x8472, 0x5c7b, 0x647a, 0x6436, 0x4bf5, 0x4435, 0x5435, 0x63b2, 0x830e, 0x92cb, 0x7269, 0x39ea, 0x21cd, 0x6234, 0x5a11, 0xacf9, 0xde9d, 0xff9f, 
0xffdf, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xd56f, 0xcb82, 0xd3c3, 0xdc04, 0xe444, 0xe484, 0xeca4, 0xeca4, 0xeca4, 0xecc5, 0xecc5, 0xece5, 0xece5, 0xf4e5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4c4, 0xf4c4, 0xf4c4, 0xf4c4, 0xfcc5, 0xfcc5, 0xfcc5, 0xf505, 0xf525, 0xfd45, 0xf565, 0xf565, 0xf5a6, 0xf5c6, 0xfde6, 0xfe26, 0xfe46, 0xfe66, 0xfe86, 0xfea6, 0xf6c7, 0xf6c6, 0xf6c6, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xfee8, 0xf6c7, 0xff06, 0xeea5, 0xfee7, 0xf6ca, 0xd567, 0xc508, 0xee6b, 0xf68b, 0xf6ab, 0xfeeb, 0xff0a, 0xff09, 0xff08, 0xff07, 0xfee7, 0xfec7, 0xfec7, 0xf6c7, 0xf6c7, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6c7, 0xf6a6, 0xf666, 0xf646, 0xfe26, 0xfe06, 0xfdc6, 0xfda6, 0xf566, 0xf565, 0xf525, 0xf505, 0xf505, 0xf4e5, 0xf4c5, 0xfcc5, 0xfcc5, 0xfcc5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4e5, 0xf4e5, 0xf4a5, 0xf4e5, 0xb48b, 0x6c16, 0x6bdc, 0x8bb7, 0x8370, 0x6b8f, 0x33da, 0x43fa, 0x4bb9, 0x5357, 0x62f4, 0x5a11, 0x28eb, 0x0027, 0x3273, 0x2a10, 0x42b1, 0xadbd, 0xd6df, 
0xffdf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xddb1, 0xcb62, 0xd3a2, 0xdc03, 0xe444, 0xe464, 0xec84, 0xeca4, 0xeca4, 0xecc5, 0xece5, 0xece5, 0xece5, 0xf4e5, 0xf4e5, 0xf4c5, 0xecc5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4c5, 0xf4c5, 0xfcc5, 0xfcc5, 0xfce5, 0xfd05, 0xfd25, 0xfd45, 0xf565, 0xf585, 0xf5a5, 0xf5c6, 0xfe06, 0xfe26, 0xfe46, 0xfe66, 0xfe86, 0xfea6, 0xf6c6, 0xf6c6, 0xf6c6, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6e8, 0xf6c6, 0xff06, 0xf6e6, 0xff08, 0xdde8, 0x82e0, 0x4940, 0x61a0, 0x7240, 0x8b22, 0xac44, 0xcd66, 0xe647, 0xfee7, 0xff48, 0xfee7, 0xfee7, 0xfec7, 0xfec7, 0xf6c7, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6c7, 0xf6a6, 0xf686, 0xf666, 0xfe26, 0xfe06, 0xfde6, 0xf5a6, 0xfd65, 0xf565, 0xf545, 0xf525, 0xf505, 0xf4e5, 0xf4e5, 0xfce5, 0xfce5, 0xf4e5, 0xf4e5, 0xf4c5, 0xf4e5, 0xf4e5, 0xf4e5, 0xf4e5, 0xf4c7, 0xe4e7, 0xa48d, 0x63d8, 0x735b, 0xaaf3, 0xb30d, 0x9b8e, 0x3b78, 0x4bb9, 0x43d9, 0x33d9, 0x4bba, 0x6ad7, 0x518c, 0x1062, 0x00ac, 0x3273, 0x2a92, 0x09ae, 0x2a92, 
0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7bf, 0xe73d, 0xec8b, 0xbba5, 0xc403, 0xdc64, 0xf423, 0xfc43, 0xf483, 0xdcc3, 0xecc5, 0xecc5, 0xecc5, 0xece5, 0xece5, 0xf4e5, 0xf4e5, 0xf505, 0xf4e5, 0xf4e5, 0xf4e5, 0xf505, 0xf505, 0xf505, 0xf505, 0xf525, 0xf545, 0xf565, 0xf585, 0xf5a5, 0xf5c5, 0xf5e6, 0xf606, 0xf606, 0xf667, 0xf667, 0xf667, 0xf687, 0xf687, 0xf686, 0xf6a7, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xff06, 0xfee6, 0xf6c6, 0xfee7, 0xff08, 0xf6a7, 0xd5c4, 0xb4c0, 0x9b64, 0x8282, 0x61a0, 0x5940, 0x5920, 0x6181, 0x8ac5, 0xb409, 0xd568, 0xfecc, 0xfee9, 0xfec6, 0xf6c5, 0xf6c5, 0xfee7, 0xf6a7, 0xfea6, 0xf686, 0xf665, 0xf645, 0xfe25, 0xfe05, 0xfde5, 0xf5c5, 0xfda6, 0xf566, 0xf547, 0xf547, 0xfd47, 0xfd47, 0xf505, 0xf4e3, 0xf504, 0xf504, 0xf504, 0xf4e5, 0xece5, 0xece5, 0xece5, 0xece5, 0xed20, 0xf50a, 0x8b6f, 0x53d8, 0x6bb9, 0x9a31, 0xd36c, 0xbca6, 0x5b91, 0x536d, 0x732b, 0x530f, 0x32f5, 0x81d7, 0xa0d1, 0x30c7, 0x0041, 0x21cf, 0x2255, 0x3a13, 0x4234, 
0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffde, 0xe4cd, 0xc3a4, 0xd3c0, 0xec21, 0xe424, 0xe446, 0xe485, 0xe4c3, 0xecc5, 0xecc5, 0xecc5, 0xece5, 0xece5, 0xece5, 0xf4e5, 0xf505, 0xf4e5, 0xf4e5, 0xf505, 0xf505, 0xf505, 0xf525, 0xf525, 0xf525, 0xf565, 0xf565, 0xf585, 0xf5a5, 0xf5c6, 0xf5e6, 0xf606, 0xf606, 0xf667, 0xf667, 0xf667, 0xf667, 0xf687, 0xf686, 0xf6a7, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xfec7, 0xfec7, 0xfec7, 0xfec7, 0xfee6, 0xff06, 0xfee6, 0xf6c7, 0xfee7, 0xff08, 0xfee9, 0xf6c8, 0xff0c, 0xfecc, 0xee2c, 0xcd09, 0xa385, 0x7a40, 0x6180, 0x5960, 0x7220, 0x82a0, 0xbc86, 0xf64a, 0xfeea, 0xfec8, 0xf6a6, 0xf6a6, 0xf686, 0xf686, 0xfe66, 0xfe67, 0xfe47, 0xfe27, 0xfde7, 0xfdc7, 0xf5a5, 0xf585, 0xf546, 0xf526, 0xf526, 0xf506, 0xf525, 0xfd25, 0xf504, 0xf504, 0xf505, 0xf505, 0xf4e5, 0xece5, 0xece5, 0xece5, 0xe521, 0xece8, 0x9b0c, 0x6315, 0x53ba, 0x5ab1, 0xab29, 0xfc86, 0xc40a, 0xc408, 0xcba8, 0x932c, 0x5292, 0x8955, 0xa0b0, 0x38c7, 0x0041, 0x094c, 0x1233, 0x3294, 0x3294, 
0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xd50f, 0xc3a5, 0xd360, 0xebe1, 0xe425, 0xd468, 0xdca6, 0xecc4, 0xeca5, 0xecc5, 0xecc5, 0xecc5, 0xece5, 0xece5, 0xf4e5, 0xf505, 0xf505, 0xf505, 0xf505, 0xf505, 0xf525, 0xf525, 0xf545, 0xf545, 0xf565, 0xf585, 0xf5a6, 0xf5c6, 0xf5e6, 0xf606, 0xf606, 0xf626, 0xf647, 0xfe67, 0xf667, 0xf667, 0xf686, 0xf686, 0xf686, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xfec7, 0xfec7, 0xfee6, 0xff07, 0xff07, 0xfec7, 0xf6a7, 0xf6c7, 0xfee8, 0xff09, 0xfee4, 0xfee5, 0xfec8, 0xfeea, 0xff0d, 0xf66c, 0xc4c6, 0x9341, 0x5940, 0x6160, 0x71e2, 0x82a3, 0xd52a, 0xfecc, 0xee46, 0xf6a5, 0xf685, 0xf666, 0xf667, 0xfe47, 0xf627, 0xf5e7, 0xf5c8, 0xf5c8, 0xfe05, 0xfdc5, 0xfda5, 0xfd86, 0xf566, 0xf505, 0xf525, 0xfd46, 0xf525, 0xf525, 0xf505, 0xf505, 0xf505, 0xed05, 0xece5, 0xece5, 0xe542, 0xf508, 0xb36b, 0x5ad2, 0x43fb, 0x4b76, 0x92ea, 0xfc27, 0xfc01, 0xf421, 0xebc4, 0xa2e8, 0x5a0e, 0x8113, 0x98b0, 0x48c9, 0x0000, 0x090b, 0x2274, 0x2a93, 0x2a92, 
0xffdf, 0xffff, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xffdf, 0xffbe, 0xeeb7, 0xcccf, 0xc3a8, 0xd3e6, 0xdc45, 0xdc85, 0xe4a5, 0xeca5, 0xeca5, 0xeca4, 0xeca4, 0xecc4, 0xece4, 0xece4, 0xf4e5, 0xf504, 0xf505, 0xf505, 0xf525, 0xf525, 0xf545, 0xf545, 0xf565, 0xf565, 0xf586, 0xf586, 0xf5a6, 0xf5c6, 0xf5e6, 0xf606, 0xf626, 0xf626, 0xfe47, 0xf646, 0xfe67, 0xf666, 0xf666, 0xf686, 0xf686, 0xf686, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xf6a6, 0xfea6, 0xfea6, 0xf6a5, 0xf6a6, 0xf6c6, 0xf6c6, 0xf6c7, 0xf6a7, 0xf6a7, 0xf6a7, 0xf6c3, 0xfee4, 0xfec5, 0xfec6, 0xfec8, 0xfeea, 0xfeca, 0xf689, 0xb3e9, 0x71e3, 0x69a3, 0x6142, 0x69c1, 0xccc8, 0xfeca, 0xf6a6, 0xf686, 0xfe86, 0xfe87, 0xfe87, 0xfe67, 0xfe47, 0xfe27, 0xfe27, 0xfe05, 0xf5e4, 0xf5c5, 0xfdc6, 0xfda6, 0xf545, 0xf525, 0xfd46, 0xf525, 0xf525, 0xf525, 0xf505, 0xf505, 0xf505, 0xece5, 0xece5, 0xed03, 0xfce5, 0xc409, 0x42ee, 0x2b59, 0x5b1a, 0x81cd, 0xba65, 0xf423, 0xdc23, 0xbbc6, 0x72ea, 0x3a2f, 0x6152, 0x788e, 0x3827, 0x0000, 0x10ca, 0x41b2, 0x398f, 0x316f, 
0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xbdfb, 0x9436, 0xabf0, 0xcc27, 0xe461, 0xec62, 0xe444, 0xe4a4, 0xe4a4, 0xeca4, 0xecc4, 0xecc4, 0xece4, 0xece5, 0xf504, 0xf525, 0xf525, 0xf525, 0xf545, 0xf545, 0xf565, 0xf585, 0xf585, 0xf5a6, 0xf5a6, 0xf5c6, 0xf5e6, 0xf5e6, 0xf606, 0xf626, 0xf646, 0xf647, 0xf646, 0xfe46, 0xfe66, 0xf666, 0xf666, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xfea6, 0xfea6, 0xf6a6, 0xf686, 0xf686, 0xf6a6, 0xfec7, 0xfee7, 0xfec7, 0xf6a7, 0xfec7, 0xfec6, 0xfec6, 0xf6a6, 0xf686, 0xee65, 0xfec7, 0xff29, 0xfe6e, 0x7a41, 0x71c2, 0x8246, 0x5920, 0x9302, 0xf64a, 0xf687, 0xf646, 0xf666, 0xf666, 0xfe86, 0xfe65, 0xf645, 0xf625, 0xf625, 0xf5e5, 0xeda4, 0xed84, 0xf5a4, 0xfda5, 0xf585, 0xf545, 0xf546, 0xf545, 0xf545, 0xf525, 0xf525, 0xed05, 0xed05, 0xed05, 0xece5, 0xece2, 0xf483, 0xdca8, 0x6b4c, 0x2ab5, 0x52bb, 0x7193, 0x894b, 0xa1c7, 0x8a08, 0x624a, 0x2a8f, 0x1ab4, 0x4235, 0x510e, 0x2826, 0x0021, 0x28cb, 0x78f2, 0x710e, 0x712f, 
0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xef9f, 0xa5bb, 0x749c, 0x4b7b, 0x6396, 0xa42d, 0xdc65, 0xec83, 0xe423, 0xe484, 0xe484, 0xe4a4, 0xecc4, 0xecc4, 0xece4, 0xece5, 0xf504, 0xed25, 0xed25, 0xed45, 0xed45, 0xf565, 0xf585, 0xf585, 0xf585, 0xf5a6, 0xf5c6, 0xf5c6, 0xf5e6, 0xf606, 0xf626, 0xf626, 0xf626, 0xf626, 0xf626, 0xf646, 0xfe46, 0xfe66, 0xf666, 0xf666, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xfec7, 0xf6a6, 0xf686, 0xfea6, 0xfea7, 0xf6a6, 0xf686, 0xf686, 0xfea9, 0xf688, 0xf687, 0xfec7, 0xff07, 0xfec7, 0xf6a7, 0xfec7, 0xfead, 0x8ac0, 0x69a0, 0x7a24, 0x6980, 0x9322, 0xee09, 0xf687, 0xf647, 0xf626, 0xee24, 0xee24, 0xf644, 0xf665, 0xf666, 0xf647, 0xfe28, 0xf607, 0xf5c6, 0xf5a5, 0xf5a5, 0xfda6, 0xf586, 0xf566, 0xf545, 0xf545, 0xf545, 0xf525, 0xed05, 0xed05, 0xed05, 0xece5, 0xed04, 0xe4a2, 0xfce6, 0xbbcb, 0x5aaf, 0x32d5, 0x51f4, 0x9112, 0x786f, 0x60af, 0x3971, 0x1a74, 0x1af7, 0x2a94, 0x214c, 0x0823, 0x0003, 0x416f, 0x9071, 0x702a, 0x786b, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xe79f, 0xbe7e, 0x959c, 0x4316, 0x3319, 0x22d9, 0x3339, 0x6bf5, 0xac6e, 0xdc87, 0xec42, 0xe484, 0xe484, 0xe4a4, 0xeca4, 0xecc4, 0xece4, 0xece5, 0xf504, 0xed25, 0xed25, 0xed45, 0xed45, 0xed65, 0xed85, 0xeda5, 0xeda5, 0xf5a6, 0xf5c6, 0xf5c6, 0xf5e6, 0xf606, 0xf606, 0xf626, 0xf626, 0xfe26, 0xfe26, 0xf626, 0xf646, 0xf646, 0xfe66, 0xf666, 0xf666, 0xf666, 0xf666, 0xf666, 0xf686, 0xf686, 0xfe86, 0xfe86, 0xfe86, 0xf666, 0xf666, 0xf686, 0xfea6, 0xfea6, 0xf666, 0xf665, 0xf686, 0xf688, 0xfea8, 0xfec7, 0xf6a6, 0xee65, 0xf687, 0xfec9, 0xff0b, 0xc4a8, 0x7a40, 0x8243, 0x7a23, 0x69a0, 0xc486, 0xff0b, 0xf686, 0xfe68, 0xf646, 0xf645, 0xf665, 0xfe87, 0xfe69, 0xf62a, 0xedeb, 0xeda9, 0xf5e9, 0xfe08, 0xf5c6, 0xf5a5, 0xf5a5, 0xf586, 0xf545, 0xf545, 0xf545, 0xed45, 0xed25, 0xed05, 0xed05, 0xed05, 0xe4e5, 0xece5, 0xe4e3, 0xecc4, 0xe426, 0xa368, 0x52cc, 0x39ef, 0x5951, 0x69b5, 0x59d5, 0x3a35, 0x2ab5, 0x1a94, 0x11ce, 0x00c6, 0x0021, 0x00a8, 0x4212, 0x782f, 0x68ea, 0x818d, 
0xffff, 0xffff, 0xfffe, 0xffff, 0xef9f, 0xc69d, 0x7cb9, 0x4334, 0x32fa, 0x3b39, 0x2b18, 0x233a, 0x3b9b, 0x7416, 0xc46b, 0xf420, 0xe484, 0xe484, 0xe484, 0xeca4, 0xecc4, 0xece4, 0xece5, 0xf504, 0xed25, 0xed24, 0xed45, 0xed45, 0xed65, 0xed85, 0xed85, 0xeda5, 0xf5a6, 0xf5c6, 0xf5c6, 0xf5e6, 0xf606, 0xf626, 0xf626, 0xf626, 0xfe26, 0xfe26, 0xf626, 0xfe46, 0xfe46, 0xf666, 0xf666, 0xf666, 0xf666, 0xf666, 0xf666, 0xf686, 0xf686, 0xfe86, 0xfe86, 0xfe86, 0xfea7, 0xf686, 0xf686, 0xfea6, 0xfea6, 0xf686, 0xf6a6, 0xfec6, 0xf6c6, 0xf6c5, 0xf684, 0xee85, 0xfee7, 0xff2a, 0xf649, 0xcd26, 0x7a23, 0x69a1, 0x7a23, 0x7a02, 0xbc07, 0xfece, 0xfea8, 0xf664, 0xf627, 0xf646, 0xf645, 0xf666, 0xee27, 0xdd68, 0xbc48, 0xa388, 0xbc24, 0xdd07, 0xedc8, 0xf5a6, 0xed84, 0xf5a5, 0xf585, 0xed44, 0xf545, 0xf545, 0xed45, 0xed25, 0xed05, 0xed05, 0xe4e5, 0xe4e5, 0xe445, 0xe4c4, 0xd4c1, 0xe4c2, 0xeca7, 0xb38a, 0x62ad, 0x2a91, 0x2a93, 0x2272, 0x1a51, 0x0a30, 0x016c, 0x0086, 0x0002, 0x0000, 0x19ce, 0x3233, 0x8132, 0xcd79, 0xe63c, 
0xffdf, 0xffff, 0xffff, 0xf7be, 0xbe5c, 0x6c79, 0x3339, 0x231c, 0x331a, 0x32fb, 0x32fb, 0x2b1a, 0x2af9, 0x4359, 0x8434, 0xacac, 0xe444, 0xe464, 0xec85, 0xeca4, 0xeca4, 0xecc4, 0xece5, 0xed05, 0xed05, 0xed05, 0xed25, 0xed45, 0xed45, 0xed65, 0xf585, 0xf585, 0xf585, 0xf585, 0xf5a5, 0xf5c5, 0xf5c5, 0xf5e5, 0xf5e5, 0xf605, 0xf606, 0xf606, 0xf606, 0xf626, 0xf626, 0xf646, 0xf646, 0xf646, 0xf666, 0xf666, 0xfe66, 0xfe66, 0xfe66, 0xfe66, 0xfe66, 0xfe66, 0xf665, 0xf666, 0xf665, 0xf666, 0xf666, 0xf666, 0xf686, 0xfe87, 0xfea5, 0xee66, 0xf6a9, 0xf6e9, 0xeee8, 0xd5c8, 0x9387, 0x69e7, 0x69e2, 0x7202, 0x9305, 0xc4ca, 0xeded, 0xe5ec, 0xe5ca, 0xe5ea, 0xe588, 0xe5e8, 0xd5c7, 0xde0a, 0xc58e, 0x7b4e, 0x5212, 0x59f7, 0x51b2, 0x9baf, 0xee0b, 0xee04, 0xe5a3, 0xdd86, 0xdda7, 0xdd87, 0xdd47, 0xed27, 0xed27, 0xe526, 0xeca5, 0xf446, 0xec87, 0xd4e8, 0xec45, 0xdca6, 0xc4c5, 0xcca5, 0xec86, 0xec06, 0xdba5, 0xcbc6, 0x9b0a, 0x9a29, 0x50c4, 0x0020, 0x0021, 0x0002, 0x0804, 0x1149, 0x1254, 0x2255, 0x3231, 0xa57a, 0xf7ff, 
0xffff, 0xffdf, 0xfffe, 0xffff, 0xe77f, 0x955c, 0x4379, 0x22b9, 0x3317, 0x32f9, 0x333a, 0x337c, 0x2b3c, 0x32db, 0x6356, 0x93f0, 0xe444, 0xe444, 0xec84, 0xec84, 0xe484, 0xeca4, 0xecc4, 0xece5, 0xed04, 0xed05, 0xed05, 0xed25, 0xed45, 0xf565, 0xf565, 0xf585, 0xf585, 0xf585, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf606, 0xfe06, 0xf606, 0xf606, 0xf626, 0xf626, 0xf646, 0xf646, 0xf646, 0xf666, 0xf666, 0xf666, 0xfe66, 0xfe66, 0xfe66, 0xfe66, 0xf666, 0xf666, 0xf666, 0xf666, 0xf666, 0xf666, 0xfe67, 0xfe87, 0xf644, 0xfea7, 0xff0d, 0xcdaf, 0x8b8f, 0x6230, 0x51b1, 0x59f2, 0x51f4, 0x51d4, 0x5a14, 0x6a95, 0x6ab4, 0x6272, 0x5a31, 0x5a30, 0x6a34, 0x6a53, 0x5a10, 0x6290, 0x62b2, 0x4a13, 0x4a38, 0x62dd, 0x31f4, 0x73f7, 0xbe39, 0xc5d6, 0xcd76, 0xd579, 0xd599, 0xcd77, 0xc5d7, 0xadf6, 0x9e35, 0x9e15, 0xa5d5, 0xa595, 0x9d55, 0x9536, 0x8d34, 0x94d3, 0x93f0, 0x9b4e, 0xab2e, 0xaaee, 0x9ace, 0x9acf, 0x62f1, 0x6311, 0x42cf, 0x224d, 0x0a0d, 0x0a0e, 0x1a31, 0x2273, 0x2295, 0x3295, 0x3a91, 0xb5fa, 0xf7ff, 
0xffff, 0xf7bf, 0xffde, 0xffff, 0xffff, 0xcedf, 0x7cbb, 0x4316, 0x3358, 0x2ad9, 0x2ada, 0x2b3a, 0x2b1b, 0x32b9, 0x52b3, 0x836f, 0xe424, 0xe444, 0xe444, 0xe464, 0xe484, 0xe484, 0xeca4, 0xecc4, 0xece4, 0xece5, 0xed05, 0xed25, 0xed25, 0xed45, 0xf565, 0xed65, 0xf565, 0xf565, 0xf585, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf606, 0xf606, 0xf606, 0xf626, 0xf626, 0xf626, 0xf646, 0xf646, 0xf646, 0xf646, 0xf646, 0xfe46, 0xfe46, 0xfe46, 0xf666, 0xf666, 0xf666, 0xf666, 0xf666, 0xf666, 0xfe67, 0xfe87, 0xff49, 0xd58a, 0xa410, 0x6a93, 0x49d5, 0x5239, 0x5a5c, 0x5a7e, 0x529c, 0x5add, 0x5adc, 0x529b, 0x527a, 0x529a, 0x52ba, 0x52ba, 0x625e, 0x627c, 0x5239, 0x5a57, 0x4a35, 0x39d3, 0x4235, 0x5297, 0x3a31, 0x6c99, 0xaedf, 0xae7f, 0xc5ff, 0xdddf, 0xddff, 0xd5df, 0xbe3f, 0x9e7f, 0x8e7f, 0x9e3f, 0x9e1f, 0x863f, 0x6e1f, 0x6ddf, 0x657e, 0x74dd, 0x93da, 0xb318, 0xc2d7, 0xba76, 0xa235, 0x9214, 0x4398, 0x43b8, 0x5377, 0x6ab6, 0x5a35, 0x3ab6, 0x22f6, 0x1a96, 0x32b5, 0x3272, 0x9539, 0xdf5d, 0xf7ff, 
0xf7ff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xce9e, 0x8498, 0x2b1a, 0x2adb, 0x3b1b, 0x3b79, 0x4356, 0x4ad1, 0x7b0b, 0xc469, 0xe403, 0xe424, 0xe444, 0xe444, 0xe464, 0xe484, 0xe484, 0xeca4, 0xe4c4, 0xecc4, 0xece4, 0xed05, 0xed25, 0xed25, 0xed45, 0xed45, 0xf565, 0xf565, 0xf565, 0xf585, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5c6, 0xf5e5, 0xf5e5, 0xf5e6, 0xf5e6, 0xf606, 0xf606, 0xf626, 0xf626, 0xf626, 0xf626, 0xf646, 0xf646, 0xf646, 0xf646, 0xf646, 0xf646, 0xfe66, 0xf666, 0xf666, 0xf646, 0xf646, 0xfe66, 0xfe67, 0xfe67, 0xcd8d, 0x7aec, 0x4151, 0x3955, 0x4217, 0x5b18, 0x5af9, 0x52b9, 0x5a7a, 0x62db, 0x62dc, 0x5a9b, 0x5a9b, 0x62dc, 0x62fc, 0x62dc, 0x627b, 0x6a9b, 0x627b, 0x627a, 0x51f7, 0x4195, 0x51f6, 0x51f6, 0x4991, 0x6bd8, 0x963f, 0x8dfe, 0xa55d, 0xbd3c, 0xbd1d, 0xa51d, 0xad1c, 0xacdc, 0xbc7b, 0xdbfb, 0xd3db, 0xa45b, 0x6cfb, 0x4d5b, 0x6cff, 0x64bd, 0x73da, 0x9b17, 0xc276, 0xc255, 0xa275, 0x8ad4, 0x3398, 0x52b7, 0x89b5, 0xc0f4, 0xc0f4, 0x9174, 0x5a35, 0x32b5, 0x3ad3, 0x84b9, 0xbe3a, 0xf7fe, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xffbf, 0xce7c, 0x6cff, 0x3319, 0x3ad7, 0x7498, 0xb619, 0xbd53, 0xbba5, 0xdba0, 0xdbe3, 0xe404, 0xe424, 0xe444, 0xe444, 0xe464, 0xec84, 0xeca4, 0xe4a4, 0xecc4, 0xecc4, 0xece4, 0xed05, 0xed25, 0xed25, 0xed45, 0xed45, 0xf545, 0xf565, 0xf565, 0xf585, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c6, 0xf5e6, 0xf5e6, 0xf5e6, 0xf606, 0xf606, 0xf626, 0xf626, 0xf626, 0xf626, 0xf626, 0xf626, 0xf626, 0xf626, 0xf646, 0xf646, 0xf646, 0xf646, 0xf646, 0xfe46, 0xfe47, 0xfe67, 0x51ef, 0x30ed, 0x3971, 0x5237, 0x4a38, 0x4217, 0x4234, 0x52b3, 0x5256, 0x5a76, 0x5256, 0x5256, 0x5256, 0x5a77, 0x5236, 0x4a15, 0x4a34, 0x5235, 0x5236, 0x5216, 0x4194, 0x3952, 0x51f4, 0x51f4, 0x4972, 0x4af7, 0x5cfd, 0x54bc, 0x6c7b, 0x7c7b, 0x747b, 0x5c9b, 0x9316, 0xb296, 0xd1f6, 0xe9b6, 0xe195, 0xb9d5, 0x7b17, 0x4c59, 0x3c1d, 0x341b, 0x33d9, 0x4b58, 0x62d6, 0x6295, 0x52d5, 0x3335, 0x42f6, 0x81d4, 0xb892, 0xd851, 0xe871, 0xc00f, 0x80af, 0x6273, 0x8cd9, 0xb61b, 0xffff, 0xfffe, 0xf7bd, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0x95fa, 0x6c56, 0x8d19, 0xd71d, 0xf79c, 0xdd71, 0xbae3, 0xdae0, 0xdba3, 0xdbc3, 0xe404, 0xe424, 0xe444, 0xe444, 0xec84, 0xec85, 0xe4a4, 0xe4a4, 0xe4a4, 0xecc4, 0xece4, 0xed05, 0xed05, 0xed25, 0xed25, 0xed45, 0xed45, 0xf565, 0xf565, 0xf585, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c6, 0xf5e6, 0xf5e6, 0xf5e6, 0xf606, 0xf606, 0xf606, 0xf606, 0xf606, 0xf606, 0xf606, 0xf606, 0xf626, 0xf626, 0xf626, 0xf626, 0xf626, 0xf626, 0xfe47, 0xfe47, 0x72f0, 0x392c, 0x28ce, 0x3132, 0x3994, 0x41d5, 0x4195, 0x49d6, 0x4213, 0x41f3, 0x41f3, 0x41f3, 0x4213, 0x4214, 0x4213, 0x41f3, 0x3a15, 0x3a14, 0x39f4, 0x39f3, 0x2990, 0x214f, 0x39d1, 0x39f0, 0x21b1, 0x2274, 0x2b98, 0x2358, 0x333a, 0x3b5a, 0x2b79, 0x1b97, 0x6911, 0x8091, 0x9851, 0x9871, 0x9030, 0x8031, 0x6133, 0x4295, 0x1ad9, 0x1ad9, 0x22f9, 0x2af8, 0x1ab7, 0x1ad8, 0x1b39, 0x1b5a, 0x5232, 0x8171, 0x906e, 0x808d, 0x90cd, 0x984d, 0xa191, 0xb459, 0xbe1c, 0xf7df, 0xf7de, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffde, 0xffff, 0xeffd, 0xce9c, 0xe75f, 0xffff, 0xfffe, 0xff1a, 0xd44c, 0xd365, 0xd362, 0xd382, 0xdbc3, 0xe404, 0xe424, 0xe444, 0xe444, 0xe464, 0xe484, 0xe484, 0xe4a4, 0xecc4, 0xecc4, 0xece5, 0xed05, 0xed05, 0xed25, 0xed25, 0xed45, 0xf545, 0xf565, 0xf565, 0xf585, 0xf585, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5c6, 0xf5c6, 0xf5c6, 0xf5e6, 0xf5e6, 0xf5e5, 0xf5e5, 0xf605, 0xf605, 0xf606, 0xf606, 0xf606, 0xf606, 0xf625, 0xf625, 0xf626, 0xf606, 0xf626, 0xf626, 0xf627, 0xf627, 0xe64b, 0x93ca, 0x498b, 0x206c, 0x28ec, 0x41af, 0x3930, 0x28b2, 0x2912, 0x2912, 0x3132, 0x2911, 0x2911, 0x28f0, 0x28f0, 0x28f0, 0x28f3, 0x28f2, 0x20d0, 0x2930, 0x20ef, 0x18cf, 0x2952, 0x3173, 0x10f0, 0x29d0, 0x52f0, 0x4a8e, 0x5270, 0x5251, 0x424f, 0x3a4d, 0x78c8, 0x70a7, 0x70c7, 0x78e7, 0x78c7, 0x7087, 0x6109, 0x61cb, 0x520d, 0x51ec, 0x5a0d, 0x520d, 0x4a2e, 0x6353, 0x851b, 0xa61f, 0xcdfc, 0xe61d, 0xee3d, 0xe67d, 0xee7d, 0xee1c, 0xee5d, 0xff5f, 0xffff, 0xf7de, 0xffff, 0xffdf, 0xffdf, 
0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xff9f, 0xffdf, 0xf7df, 0xefde, 0xffff, 0xe5f5, 0xd48c, 0xcb21, 0xd362, 0xdba3, 0xdbe3, 0xe403, 0xe424, 0xe444, 0xe444, 0xe484, 0xe484, 0xe4a4, 0xe4a4, 0xe4c4, 0xece4, 0xed04, 0xed05, 0xed25, 0xed25, 0xed25, 0xed45, 0xf565, 0xf565, 0xf585, 0xf585, 0xf585, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5c6, 0xf5c6, 0xf5c6, 0xf5c6, 0xf5e5, 0xf5e6, 0xf5e6, 0xf5e6, 0xf5e6, 0xf5e6, 0xf606, 0xf606, 0xf626, 0xf626, 0xf605, 0xf606, 0xf606, 0xf606, 0xf626, 0xf627, 0xfec3, 0xf6a9, 0xd5ae, 0x7b0d, 0x310a, 0x20ca, 0x2908, 0x3188, 0x3129, 0x418a, 0x49eb, 0x49ea, 0x41c9, 0x41c9, 0x41c9, 0x49e9, 0x5188, 0x4987, 0x4986, 0x51e7, 0x4188, 0x28e8, 0x30ec, 0x30ee, 0x38cb, 0x7a69, 0xcc47, 0xd442, 0xd423, 0xd405, 0xd405, 0xcbe3, 0xeb84, 0xcba2, 0xbbc2, 0xd3c3, 0xdba3, 0xc383, 0xc3a4, 0xd3e6, 0xd3c4, 0xc3c4, 0xbbe4, 0xbb64, 0xbae4, 0xd40a, 0xee53, 0xf7f9, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xf7fe, 0xeffe, 0xeffe, 0xffff, 0xfffe, 0xffff, 0xffbf, 0xffdf, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xad75, 0xcb22, 0xd322, 0xdb43, 0xdba3, 0xd403, 0xdc43, 0xe443, 0xf423, 0xe464, 0xec84, 0xeca4, 0xeca4, 0xeca4, 0xecc4, 0xecc4, 0xece4, 0xece4, 0xed05, 0xed04, 0xed24, 0xed25, 0xed45, 0xed65, 0xf565, 0xf565, 0xf565, 0xf585, 0xf585, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5c5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e6, 0xf5e6, 0xf5e6, 0xf606, 0xf606, 0xf606, 0xf606, 0xf606, 0xf606, 0xf606, 0xf606, 0xede4, 0xf626, 0xfe89, 0xfeab, 0xe589, 0xabc5, 0x8aa3, 0x8243, 0x8244, 0xa347, 0xdcea, 0xfe0b, 0xfe09, 0xeda6, 0xed46, 0xed66, 0xed45, 0xed24, 0xe4c2, 0xe4c4, 0xcc86, 0x82c5, 0x3903, 0x20c5, 0x48e0, 0x92e5, 0xcc06, 0xdbe2, 0xdbc0, 0xdbc0, 0xdbc1, 0xd3c2, 0xd3a2, 0xd3a2, 0xd382, 0xcb61, 0xd381, 0xdbc2, 0xdbc2, 0xd381, 0xcbc5, 0xd382, 0xe360, 0xd300, 0xbb45, 0xd551, 0xff7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xdefb, 0xd408, 0xcb65, 0xd323, 0xdb82, 0xdbe2, 0xd3e2, 0xe402, 0xec24, 0xe444, 0xe464, 0xec84, 0xec84, 0xeca4, 0xeca4, 0xeca4, 0xecc4, 0xece4, 0xece4, 0xed05, 0xed05, 0xed25, 0xed45, 0xed45, 0xed65, 0xf565, 0xf565, 0xf565, 0xf585, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e6, 0xf5e6, 0xf5e6, 0xf5e6, 0xf5e6, 0xf5e6, 0xf5e6, 0xf5e6, 0xfe46, 0xf605, 0xedc5, 0xf607, 0xfe8b, 0xfe6d, 0xdd0a, 0xaba5, 0x8243, 0x8242, 0x9b03, 0xc426, 0xdd08, 0xed88, 0xf5a8, 0xed66, 0xe545, 0xe504, 0xe4c3, 0xece4, 0xece6, 0xcc26, 0xa366, 0xa389, 0x9b24, 0xbbe6, 0xd425, 0xd3a1, 0xdb80, 0xdb80, 0xd381, 0xcb83, 0xcb41, 0xd361, 0xd382, 0xcb61, 0xd381, 0xd381, 0xd381, 0xcb60, 0xcb62, 0xd341, 0xd320, 0xcb42, 0xd4ab, 0xf6b8, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xe5f2, 0xcc6b, 0xc324, 0xd342, 0xe3a2, 0xe3c1, 0xdbe2, 0xe404, 0xe423, 0xe443, 0xe464, 0xe464, 0xe484, 0xe483, 0xe483, 0xe4a4, 0xecc4, 0xece4, 0xece4, 0xed04, 0xed05, 0xed25, 0xed44, 0xed45, 0xf545, 0xf545, 0xf565, 0xed65, 0xf585, 0xf585, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e5, 0xf5e5, 0xed63, 0xf5c5, 0xfe06, 0xf5c5, 0xf5c6, 0xfe08, 0xfe09, 0xeda9, 0xaba6, 0x8aa2, 0x8221, 0x8a62, 0xab44, 0xe508, 0xfde9, 0xe525, 0xed66, 0xe505, 0xe4a3, 0xec82, 0xf482, 0xe462, 0xe463, 0xdc84, 0xd444, 0xd444, 0xdbe2, 0xdba1, 0xdba1, 0xdb82, 0xcb82, 0xcba3, 0xcb41, 0xcb61, 0xd381, 0xcb61, 0xcb61, 0xcb61, 0xcb61, 0xcb61, 0xdb20, 0xd300, 0xc301, 0xcc29, 0xf675, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffbd, 0xddf4, 0xc3e9, 0xcb02, 0xdb41, 0xe3c2, 0xe403, 0xd3e4, 0xdc03, 0xe423, 0xe444, 0xe444, 0xe463, 0xe463, 0xe483, 0xe484, 0xecc4, 0xecc4, 0xecc4, 0xece4, 0xed04, 0xed05, 0xed24, 0xed25, 0xed25, 0xed45, 0xed45, 0xed65, 0xed65, 0xed85, 0xf585, 0xf585, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5c5, 0xf5a5, 0xf5a5, 0xf5c5, 0xf5c4, 0xeda3, 0xeda4, 0xf5e6, 0xfe68, 0xe58b, 0xa324, 0x8a84, 0x92a5, 0x8a43, 0xbbe6, 0xfdca, 0xed86, 0xf5a6, 0xf566, 0xf525, 0xf4c4, 0xec62, 0xec61, 0xe460, 0xdc60, 0xdc01, 0xdbe1, 0xdbc1, 0xe3c2, 0xe3a2, 0xd382, 0xd382, 0xd3c2, 0xd3a2, 0xd381, 0xd381, 0xcb61, 0xcb61, 0xd362, 0xd382, 0xd382, 0xe320, 0xcac1, 0xbb86, 0xddb2, 0xffbd, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf75c, 0xdd71, 0xc366, 0xc2c1, 0xdb62, 0xe3e4, 0xd3e3, 0xdbe3, 0xe403, 0xe424, 0xe444, 0xe444, 0xe463, 0xe484, 0xec84, 0xeca4, 0xe4a4, 0xecc4, 0xecc4, 0xece4, 0xed04, 0xed04, 0xed04, 0xed25, 0xed25, 0xed25, 0xed45, 0xed45, 0xed65, 0xed65, 0xed85, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xf5a5, 0xfdc7, 0xf5a5, 0xf584, 0xfdc4, 0xf5c4, 0xed83, 0xed84, 0xf5e6, 0xfe6e, 0x9b03, 0x92a4, 0xab49, 0x8a43, 0xa303, 0xed47, 0xf5c7, 0xed44, 0xed24, 0xf546, 0xf526, 0xece5, 0xece4, 0xed04, 0xdcc2, 0xe422, 0xe422, 0xe3e2, 0xe3c2, 0xdb82, 0xd381, 0xd3a0, 0xcbc0, 0xdbc2, 0xd381, 0xcb61, 0xcb61, 0xd382, 0xd382, 0xd362, 0xcb62, 0xd301, 0xc345, 0xd50f, 0xf75b, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf719, 0xccce, 0xb305, 0xc302, 0xdb83, 0xdbc3, 0xdbc3, 0xe3e3, 0xe424, 0xe424, 0xe444, 0xe443, 0xe464, 0xec84, 0xe484, 0xe484, 0xe4a4, 0xeca4, 0xecc4, 0xece4, 0xece4, 0xed04, 0xed05, 0xed05, 0xed05, 0xed25, 0xed45, 0xed45, 0xed45, 0xed65, 0xed65, 0xed85, 0xed85, 0xed85, 0xed85, 0xed85, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xed44, 0xf585, 0xf5c6, 0xf5a5, 0xed84, 0xed85, 0xf5c7, 0xfe09, 0xd4ea, 0x92e3, 0x9284, 0x9aa5, 0x8a22, 0xbbc5, 0xf588, 0xe544, 0xed03, 0xe4e3, 0xed05, 0xed26, 0xe4e5, 0xe506, 0xe526, 0xdce5, 0xf484, 0xec64, 0xec44, 0xe403, 0xdbc2, 0xdbe2, 0xdbe1, 0xd3a0, 0xd381, 0xcb61, 0xcb61, 0xd382, 0xd3a2, 0xd382, 0xcb42, 0xcb22, 0xbb24, 0xd4ac, 0xf6f9, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xfffe, 0xe697, 0xcc8d, 0xc366, 0xd322, 0xdb61, 0xdba2, 0xdbc3, 0xe3e3, 0xe403, 0xe423, 0xe423, 0xe443, 0xe464, 0xe484, 0xe484, 0xe484, 0xe4a4, 0xecc4, 0xecc4, 0xece4, 0xece4, 0xece5, 0xece5, 0xed05, 0xed05, 0xed25, 0xed45, 0xed45, 0xed45, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf585, 0xf5a6, 0xed86, 0xed85, 0xed86, 0xf5c8, 0xfdea, 0xed8a, 0xdce8, 0x92e4, 0x92c4, 0x92a3, 0x92a3, 0xab64, 0xe529, 0xfde8, 0xe524, 0xfd46, 0xf525, 0xed25, 0xed25, 0xe505, 0xe4e4, 0xe4e5, 0xe4c5, 0xeca5, 0xe484, 0xe484, 0xe464, 0xdc23, 0xe444, 0xe424, 0xdbc3, 0xd3a1, 0xd381, 0xd381, 0xd3a2, 0xd362, 0xcb42, 0xcb42, 0xd383, 0xc4ac, 0xee96, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffff, 0xf7ff, 0xfffd, 0xee55, 0xdc2a, 0xcb03, 0xd300, 0xd382, 0xdba2, 0xdbe3, 0xe403, 0xdc03, 0xe423, 0xe423, 0xe443, 0xe464, 0xe484, 0xe484, 0xeca4, 0xeca4, 0xecc4, 0xece4, 0xece4, 0xece5, 0xece5, 0xed05, 0xed05, 0xed25, 0xed25, 0xed45, 0xed44, 0xed45, 0xed45, 0xed45, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xed65, 0xf5c7, 0xf5c7, 0xf5e7, 0xf5c8, 0xed69, 0xc466, 0xa343, 0x8a62, 0x8243, 0x8a84, 0x9ae4, 0xc408, 0xf5ac, 0xf5a9, 0xdce4, 0xe544, 0xf4e6, 0xecc4, 0xecc3, 0xed03, 0xece3, 0xecc2, 0xeca3, 0xf483, 0xecc5, 0xe483, 0xe4a3, 0xe4a3, 0xdc43, 0xe424, 0xec26, 0xe3c6, 0xdbe2, 0xdbe2, 0xdbc2, 0xd3a2, 0xcb42, 0xc321, 0xd384, 0xe406, 0xe675, 0xfffd, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffde, 0xee97, 0xccad, 0xab26, 0xdb21, 0xdb62, 0xd3c3, 0xd3e4, 0xdc04, 0xe424, 0xec24, 0xec03, 0xec44, 0xec63, 0xe463, 0xe483, 0xe483, 0xeca3, 0xeca4, 0xecc4, 0xeca4, 0xeca4, 0xecc4, 0xece4, 0xece4, 0xed05, 0xed04, 0xed04, 0xed24, 0xed24, 0xed24, 0xed25, 0xed25, 0xed25, 0xf525, 0xf525, 0xed06, 0xed46, 0xed45, 0xe523, 0xe524, 0xf588, 0xf56a, 0xed2b, 0xdd4a, 0xccc9, 0xb3e6, 0x9303, 0x8262, 0x8242, 0x8a84, 0x92c5, 0xb3c4, 0xcc87, 0xed69, 0xfda9, 0xf547, 0xece5, 0xecc4, 0xf4e4, 0xecc4, 0xecc4, 0xecc4, 0xeca4, 0xeca4, 0xe484, 0xe484, 0xe484, 0xece6, 0xe484, 0xdc43, 0xe463, 0xec64, 0xe443, 0xe423, 0xe403, 0xd425, 0xd3c3, 0xe380, 0xeb60, 0xd300, 0xbb24, 0xc4ae, 0xe678, 0xffff, 0xf7ff, 0xef5e, 0xdd8f, 0xfdee, 0xf5ae, 0xf611, 0xf60f, 0xfe0f, 0xfdcb, 0xfe70, 0xef5a, 0xf7ff, 0xffdf, 0xfffe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffbe, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xff7b, 0xedf3, 0xccad, 0xcb23, 0xcb23, 0xd363, 0xdbc3, 0xdc03, 0xdbe2, 0xdbe2, 0xdc23, 0xe443, 0xe443, 0xe443, 0xe463, 0xe463, 0xe483, 0xe4a3, 0xe4a3, 0xeca4, 0xeca4, 0xecc4, 0xecc4, 0xece4, 0xece4, 0xed04, 0xed04, 0xed04, 0xed04, 0xed04, 0xed04, 0xed24, 0xed24, 0xf525, 0xf525, 0xed06, 0xed45, 0xed45, 0xed64, 0xf586, 0xe506, 0xbbe3, 0x9aa0, 0x8220, 0x8220, 0x8a60, 0x92a1, 0xa323, 0xbbe5, 0xd4a8, 0xdd2a, 0xed69, 0xed69, 0xed69, 0xed47, 0xed26, 0xece5, 0xece4, 0xece4, 0xecc4, 0xecc4, 0xeca4, 0xeca4, 0xeca4, 0xe484, 0xe484, 0xe484, 0xe484, 0xe463, 0xe443, 0xe464, 0xe443, 0xe423, 0xdbe2, 0xdbc2, 0xd3a3, 0xdba3, 0xdb61, 0xcb00, 0xc343, 0xd48c, 0xee56, 0xff9d, 0xfffe, 0xf7ff, 0xef7c, 0xdd8d, 0xfdeb, 0xf5ac, 0xf5ee, 0xf5ec, 0xfdad, 0xf58a, 0xf64f, 0xe739, 0xf7ff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xff7b, 0xee97, 0xd42b, 0xc366, 0xc2e3, 0xd342, 0xe3c2, 0xdbc1, 0xd3e2, 0xd423, 0xe423, 0xe423, 0xe423, 0xe443, 0xe443, 0xe463, 0xe463, 0xe463, 0xec84, 0xeca4, 0xeca4, 0xecc4, 0xecc4, 0xecc4, 0xece4, 0xece4, 0xece4, 0xed04, 0xed04, 0xed04, 0xed04, 0xed04, 0xed05, 0xed05, 0xed06, 0xed05, 0xed04, 0xed24, 0xf566, 0xed26, 0xcc04, 0xa2e0, 0xbba5, 0xc407, 0xdca8, 0xed29, 0xf589, 0xf5a9, 0xf588, 0xf587, 0xed67, 0xed26, 0xe4e5, 0xe4e5, 0xece5, 0xed05, 0xf4e5, 0xece4, 0xecc3, 0xeca3, 0xeca3, 0xeca3, 0xe483, 0xe483, 0xe483, 0xe463, 0xe422, 0xe443, 0xe443, 0xe423, 0xe423, 0xe403, 0xe3c2, 0xdbc2, 0xdb82, 0xdb62, 0xc322, 0xbb65, 0xcc8c, 0xf656, 0xff9d, 0xffdf, 0xfffd, 0xffff, 0xf77a, 0xdd6b, 0xfdc9, 0xf5aa, 0xf5cb, 0xf5a9, 0xfdad, 0xf58a, 0xf62e, 0xe6f8, 0xf7ff, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffde, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffde, 0xf677, 0xd4ce, 0xbb25, 0xc2e2, 0xdb41, 0xe3a2, 0xdbe2, 0xd403, 0xe403, 0xe403, 0xe403, 0xe423, 0xe443, 0xe443, 0xe443, 0xe443, 0xe464, 0xe484, 0xec84, 0xeca4, 0xe4a4, 0xecc4, 0xecc4, 0xe4c4, 0xece4, 0xece4, 0xece4, 0xece4, 0xece4, 0xece4, 0xece4, 0xece4, 0xece5, 0xed05, 0xed04, 0xe4e4, 0xed05, 0xf546, 0xed27, 0xe4e7, 0xf54a, 0xf54a, 0xf549, 0xf548, 0xf546, 0xed25, 0xed04, 0xe4e3, 0xe4e3, 0xe4e3, 0xe4e3, 0xe4e4, 0xe4c4, 0xecc4, 0xe4a4, 0xe4a4, 0xeca3, 0xeca3, 0xe4a3, 0xe483, 0xe483, 0xe463, 0xe463, 0xe463, 0xe422, 0xe423, 0xe423, 0xe403, 0xe403, 0xe403, 0xe3c3, 0xdba2, 0xdb21, 0xc2e2, 0xbb66, 0xcccf, 0xee98, 0xff9e, 0xffdf, 0xffdf, 0xfffd, 0xffff, 0xf77a, 0xdd4a, 0xfda8, 0xfda9, 0xfdab, 0xfda9, 0xfdac, 0xfdaa, 0xf64e, 0xded7, 0xf7ff, 0xffdf, 0xfffe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffbe, 0xff5d, 0xf7bd, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xeed8, 0xccee, 0xc387, 0xc302, 0xd342, 0xdb62, 0xd383, 0xdbc3, 0xdbe3, 0xe403, 0xe424, 0xe424, 0xe444, 0xe444, 0xe443, 0xe464, 0xe464, 0xe464, 0xe484, 0xe484, 0xe4a4, 0xe4a4, 0xe4a4, 0xecc4, 0xecc4, 0xecc4, 0xecc4, 0xecc4, 0xecc4, 0xecc4, 0xecc4, 0xecc4, 0xed05, 0xf505, 0xece4, 0xe4c4, 0xe4e5, 0xed06, 0xed07, 0xf506, 0xf505, 0xece5, 0xece4, 0xece4, 0xece4, 0xed04, 0xf524, 0xece3, 0xed04, 0xed24, 0xed04, 0xecc4, 0xe4a3, 0xe484, 0xe4a4, 0xe483, 0xe483, 0xe483, 0xe463, 0xe463, 0xe463, 0xdc43, 0xdc43, 0xec43, 0xe423, 0xe403, 0xe3e3, 0xe3e3, 0xdbc3, 0xd383, 0xc342, 0xc302, 0xc386, 0xccce, 0xee98, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xff7c, 0xdd4c, 0xfda9, 0xfdab, 0xfdac, 0xfd8a, 0xfd8b, 0xfd89, 0xf62d, 0xdeb7, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xf7ff, 0xffbe, 0xedf8, 0xdcf5, 0xee18, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xf73a, 0xdd71, 0xc3e9, 0xc324, 0xcb02, 0xd322, 0xdb82, 0xdba3, 0xdbc3, 0xe3e3, 0xe404, 0xe424, 0xe423, 0xe423, 0xe424, 0xe444, 0xe444, 0xe464, 0xe464, 0xe484, 0xe484, 0xe4a4, 0xeca4, 0xeca4, 0xeca4, 0xeca4, 0xeca4, 0xeca4, 0xeca4, 0xeca4, 0xecc4, 0xecc4, 0xecc4, 0xecc4, 0xecc4, 0xe4c4, 0xe4c4, 0xe4a4, 0xecc3, 0xecc3, 0xece4, 0xf504, 0xf505, 0xece4, 0xecc4, 0xe4a3, 0xecc3, 0xecc4, 0xecc4, 0xecc4, 0xeca4, 0xe4a4, 0xe4a4, 0xeca4, 0xe484, 0xe463, 0xe464, 0xe464, 0xdc44, 0xdc43, 0xdc24, 0xdc23, 0xdc25, 0xdbe3, 0xdbc3, 0xe3c2, 0xdba3, 0xcb63, 0xbb43, 0xbb44, 0xc42a, 0xe571, 0xff19, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xdd6d, 0xfdaa, 0xfdab, 0xfdac, 0xfdaa, 0xfd8b, 0xfda9, 0xf62d, 0xd676, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffbe, 0xf639, 0xe3d2, 0xd2cf, 0xe413, 0xfdf9, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77c, 0xe615, 0xcc8c, 0xcb65, 0xd302, 0xd342, 0xd362, 0xdb82, 0xdbc3, 0xdbe3, 0xe403, 0xe403, 0xe403, 0xe424, 0xe423, 0xe424, 0xe444, 0xe464, 0xe463, 0xe484, 0xe484, 0xe484, 0xe484, 0xe484, 0xe484, 0xeca4, 0xeca4, 0xeca4, 0xeca4, 0xecc4, 0xeca4, 0xe483, 0xe484, 0xecc4, 0xece5, 0xece5, 0xece4, 0xecc4, 0xe4a3, 0xe483, 0xe463, 0xe483, 0xeca4, 0xecc4, 0xecc5, 0xec84, 0xec84, 0xec84, 0xe484, 0xe484, 0xe463, 0xdc63, 0xdc43, 0xe464, 0xe444, 0xe444, 0xdc44, 0xdc24, 0xdc24, 0xdc24, 0xdc24, 0xd406, 0xd3c4, 0xd3a3, 0xdb82, 0xd342, 0xc322, 0xc3a7, 0xd48b, 0xe636, 0xff5b, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xfffe, 0xdd8d, 0xfda9, 0xfdaa, 0xfdab, 0xfd89, 0xfd8a, 0xfda8, 0xf62d, 0xd655, 0xffff, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9e, 0xe659, 0xdc74, 0xe2af, 0xea0d, 0xead0, 0xec13, 0xef1c, 0xffbe, 0xffff, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9f, 0xf7ff, 0xf7ff, 0xfffe, 0xee54, 0xd449, 0xcb22, 0xcb21, 0xd342, 0xd362, 0xdba3, 0xdbc3, 0xdbe3, 0xdbe3, 0xdbe3, 0xe403, 0xe424, 0xe423, 0xe443, 0xe444, 0xe464, 0xe463, 0xe484, 0xe483, 0xe483, 0xe484, 0xe484, 0xe484, 0xec84, 0xec84, 0xec84, 0xeca3, 0xeca4, 0xeca4, 0xecc5, 0xeca4, 0xe4a4, 0xe4a3, 0xe4c3, 0xece5, 0xecc5, 0xecc4, 0xecc4, 0xecc4, 0xe4c4, 0xe4a3, 0xdc63, 0xec65, 0xec65, 0xec64, 0xe464, 0xe464, 0xe463, 0xdc63, 0xdc63, 0xe445, 0xe445, 0xe445, 0xdc25, 0xdc25, 0xdc05, 0xdc05, 0xdc05, 0xcc07, 0xcbc5, 0xd383, 0xd341, 0xc2e0, 0xbb03, 0xd48b, 0xfe33, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xf7ff, 0xfffd, 0xddac, 0xfda8, 0xfda9, 0xf589, 0xfd87, 0xf549, 0xf567, 0xedec, 0xce34, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xee39, 0xec13, 0xe28e, 0xe26d, 0xeaaf, 0xe26e, 0xea2e, 0xe453, 0xfebb, 0xfffe, 0xf7fe, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xc618, 0xdcee, 0xab26, 0xbb03, 0xdb42, 0xdb21, 0xf3c3, 0xeba3, 0xdb63, 0xe3e2, 0xe403, 0xe423, 0xe445, 0xdc24, 0xe3e4, 0xec04, 0xfc25, 0xe443, 0xe464, 0xe463, 0xe443, 0xe443, 0xec83, 0xeca4, 0xec83, 0xe464, 0xe464, 0xe464, 0xec84, 0xec84, 0xec84, 0xec84, 0xec84, 0xec84, 0xec84, 0xec84, 0xe464, 0xe464, 0xe464, 0xe464, 0xe464, 0xe484, 0xdc83, 0xdca3, 0xdca3, 0xdc84, 0xec64, 0xec23, 0xebe2, 0xd446, 0x738f, 0x5c5c, 0x641a, 0x73f7, 0x6c3a, 0x541b, 0x4bf9, 0x53fa, 0x9c0f, 0xc323, 0xcb23, 0xd46d, 0xddf6, 0xff9c, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79d, 0xd6ba, 0xc658, 0xce79, 0xd6da, 0xd6ba, 0xdefb, 0xe73c, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xee39, 0xd432, 0xdaae, 0xe20c, 0xe22c, 0xda6d, 0xda4d, 0xe24e, 0xdaef, 0xec74, 0xf69a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xf636, 0xe571, 0xd46a, 0xbb02, 0xcb21, 0xc301, 0xcb42, 0xcb84, 0xd3c1, 0xd402, 0xd3e1, 0xd3e1, 0xe443, 0xdc22, 0xdbe1, 0xe422, 0xdc23, 0xe464, 0xe464, 0xe464, 0xe443, 0xe463, 0xe463, 0xe442, 0xe463, 0xe463, 0xe463, 0xe464, 0xe464, 0xe464, 0xe464, 0xe464, 0xe464, 0xe464, 0xe464, 0xe464, 0xe463, 0xe463, 0xe463, 0xe463, 0xe424, 0xe423, 0xdc23, 0xdc44, 0xdc44, 0xe444, 0xec23, 0xec03, 0xc3c5, 0x5ace, 0x3339, 0x3318, 0x42f6, 0x3b18, 0x2b19, 0x22f7, 0x337a, 0x9453, 0xcc6b, 0xed0e, 0xf657, 0xff7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf7be, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xd69a, 0xec54, 0xdacf, 0xe22d, 0xf22d, 0xf24d, 0xe28d, 0xda4d, 0xe28e, 0xe1ed, 0xd2ef, 0xe576, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffbe, 0xee15, 0xd4ed, 0xa344, 0xab43, 0xcc86, 0xfe6e, 0xe528, 0xc3c3, 0xc361, 0xe403, 0xe423, 0xdc02, 0xdc63, 0xdca4, 0xdbe3, 0xe423, 0xe444, 0xe423, 0xe423, 0xe443, 0xe443, 0xe443, 0xe444, 0xe444, 0xe444, 0xe444, 0xe444, 0xe444, 0xe444, 0xe444, 0xe464, 0xe444, 0xe444, 0xe444, 0xe444, 0xe444, 0xe444, 0xe444, 0xec05, 0xec05, 0xe404, 0xe424, 0xe444, 0xe424, 0xe403, 0xe403, 0xcbe6, 0x5aef, 0x1b1b, 0x231b, 0x3319, 0x2b1a, 0x233b, 0x2b3a, 0x339d, 0x9d5a, 0xf676, 0xff3a, 0xffff, 0xf7ff, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf79e, 0xce79, 0xe371, 0xda8e, 0xea6d, 0xf24c, 0xf22c, 0xea4d, 0xe24c, 0xda4d, 0xe28f, 0xdbd2, 0xee19, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xff1a, 0xddd1, 0xb4c9, 0xff2e, 0xffef, 0xff52, 0xdd0a, 0xc363, 0xd343, 0xe383, 0xe3a3, 0xdbc3, 0xd3e3, 0xdbe3, 0xe404, 0xe404, 0xdbe3, 0xdbe3, 0xdc03, 0xe423, 0xec44, 0xe423, 0xe423, 0xe423, 0xe423, 0xe424, 0xe424, 0xe424, 0xe444, 0xe444, 0xe444, 0xe444, 0xe444, 0xe424, 0xe424, 0xe424, 0xe423, 0xe404, 0xe404, 0xdbe3, 0xe403, 0xe403, 0xdbe2, 0xdba1, 0xe3e2, 0xd3a5, 0x6b10, 0x231c, 0x233d, 0x331a, 0x231b, 0x233c, 0x2b1a, 0x3b7d, 0xaddd, 0xff9d, 0xffff, 0xf7ff, 0xefff, 0xf7ff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xf4f6, 0xd390, 0xdace, 0xe24c, 0xf22c, 0xf22c, 0xe24d, 0xe2ae, 0xd453, 0xee19, 0xffbe, 0xf7ff, 0xf7ff, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xf7bf, 0xffff, 0xdeb6, 0xf793, 0xffee, 0xef88, 0xffaf, 0xff2f, 0xdca7, 0xbaa0, 0xdb02, 0xf3a4, 0xe362, 0xdb82, 0xdbe4, 0xdbe4, 0xdbe4, 0xdbe4, 0xdbe3, 0xdbc3, 0xdbe3, 0xdc03, 0xdc03, 0xe404, 0xe404, 0xe404, 0xe404, 0xe404, 0xe424, 0xe424, 0xe424, 0xe424, 0xe424, 0xe424, 0xe424, 0xe404, 0xe404, 0xe404, 0xd422, 0xdc22, 0xdc02, 0xdbe2, 0xe402, 0xdba1, 0xd360, 0xe3a2, 0xbae1, 0x6aef, 0x2afb, 0x2b3c, 0x32f9, 0x32fa, 0x2b1a, 0x32f8, 0x3b3b, 0xadbd, 0xffbe, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xff9f, 0xe577, 0xcbb0, 0xd2cd, 0xea6d, 0xea4d, 0xdaae, 0xe3f2, 0xde59, 0xffde, 0xf7ff, 0xefff, 0xffff, 0xffff, 0xffbf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xfffd, 0xf7bb, 0xdef6, 0xf7b5, 0xf78f, 0xffeb, 0xf7c7, 0xefa8, 0xffeb, 0xfeec, 0xdca6, 0xbac1, 0xc2a0, 0xd341, 0xd340, 0xd383, 0xd363, 0xd3a3, 0xdbc4, 0xdbe4, 0xdbc3, 0xdbc3, 0xdbc3, 0xdbc3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xdbe3, 0xd422, 0xdc22, 0xd3c1, 0xd382, 0xdba3, 0xcb41, 0xc301, 0xcb83, 0xb303, 0x6310, 0x1ab9, 0x22da, 0x32b7, 0x32d8, 0x3319, 0x32d7, 0x433a, 0xad9c, 0xffdd, 0xfffe, 0xf7df, 0xffff, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xef1c, 0xdd56, 0xd390, 0xdaae, 0xd2ce, 0xcbd1, 0xe5d8, 0xf7be, 0xffff, 0xf7ff, 0xf7ff, 0xffbf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xf779, 0xef74, 0xfff2, 0xffed, 0xffea, 0xef47, 0xffe9, 0xf7e6, 0xf7c9, 0xfff0, 0xf6b1, 0xb409, 0xa305, 0xbb65, 0xb342, 0xd363, 0xcb22, 0xcb22, 0xd363, 0xd383, 0xd383, 0xd383, 0xdba3, 0xd3a3, 0xd3a3, 0xd3a3, 0xdba3, 0xdba3, 0xdba3, 0xdba3, 0xdba3, 0xdba3, 0xdba3, 0xdba3, 0xdba3, 0xd3a3, 0xd3a3, 0xd383, 0xd383, 0xcb61, 0xd362, 0xc301, 0xc302, 0xcb65, 0xbb66, 0xb387, 0xcc6b, 0xedaf, 0x8cf9, 0x237d, 0x2b3b, 0x4317, 0x3b18, 0x333a, 0x3318, 0x3b39, 0xa59b, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xffff, 0xff5d, 0xecb5, 0xe371, 0xe413, 0xe5d8, 0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xefff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xe6b6, 0xf790, 0xffea, 0xf7c5, 0xffc5, 0xffa8, 0xff69, 0xf7e7, 0xf7ec, 0xe731, 0xe6d6, 0xff7c, 0xfeda, 0xdd92, 0xd50e, 0xe406, 0xd384, 0xcb02, 0xc301, 0xcb21, 0xc301, 0xcb21, 0xcb42, 0xd362, 0xd362, 0xd362, 0xd382, 0xd382, 0xd382, 0xd382, 0xd382, 0xd382, 0xd382, 0xd362, 0xd362, 0xd362, 0xd362, 0xd362, 0xd362, 0xd2e2, 0xd303, 0xcac3, 0xd326, 0xe42b, 0xdcae, 0xdd71, 0xfeb7, 0xff99, 0x9e1f, 0x239e, 0x231b, 0x3af7, 0x2af8, 0x231a, 0x2318, 0x333a, 0x9d9c, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xff9f, 0xbd55, 0xce18, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xefbc, 0xe755, 0xe78c, 0xf7c7, 0xffa7, 0xffa9, 0xffa8, 0xefea, 0xdf6d, 0xe754, 0xf7bc, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xde79, 0xd5d5, 0xd531, 0xdcce, 0xd42a, 0xc325, 0xbac3, 0xd301, 0xd301, 0xd301, 0xd321, 0xd321, 0xd321, 0xd321, 0xd321, 0xe301, 0xe322, 0xdae1, 0xd302, 0xd323, 0xc303, 0xcb64, 0xec89, 0xbd11, 0xc552, 0xcdd5, 0xe699, 0xf77c, 0xffdf, 0xffff, 0xffff, 0xffff, 0xe73c, 0xd69a, 0xd69a, 0xdedb, 0xdefc, 0xe73c, 0xef7e, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9e, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xef5b, 0xe732, 0xefab, 0xffeb, 0xffeb, 0xff4b, 0xe733, 0xe737, 0xf77d, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffbe, 0xff9d, 0xeeda, 0xeeb9, 0xcd94, 0xcd94, 0xcd73, 0xc553, 0xc552, 0xbd32, 0xbd12, 0xbd11, 0xbcf2, 0xc533, 0xc534, 0xc595, 0xce17, 0xce58, 0xdeba, 0xf79d, 0xffdd, 0xffdd, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xef59, 0xdf2f, 0xe78a, 0xef8b, 0xef50, 0xffbd, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xefdf, 0xefdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffbf, 0xe739, 0xd6d1, 0xdf13, 0xef79, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffc, 0xfffd, 0xffff, 0xffff, 0xf7dd, 0xf7dd, 0xffff, 0xffde, 0xffbf, 0xffbf, 0xffdf, 0xfffe, 0xfffe, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xffdd, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xfffe, 0xfffd, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffde, 0xf7df, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7df, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9e, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xfffd, 0xfffb, 0xffdd, 0xffde, 0xfffe, 0xfffa, 0xfffd, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffde, 0xffdf, 0xffde, 0xffbd, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xffdf, 0xffdd, 0xffdd, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};
const unsigned short  Poop[] PROGMEM = {
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffde, 0xffde, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xfffe, 0xffff, 0xffde, 0xfffe, 0xfffe, 0xffbe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xf73b, 0xbd13, 0x93cc, 0x8b6b, 0x834b, 0x93ed, 0xb533, 0xde99, 0xff9d, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xf7ff, 0xefde, 0xffff, 0xffbd, 0x836c, 0x38e2, 0x40a0, 0x48e0, 0x4900, 0x38c0, 0x30a0, 0x4942, 0x72a8, 0x9bed, 0xe6db, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xefde, 0xfffe, 0xde98, 0x4144, 0x38a1, 0x6160, 0x6981, 0x69a2, 0x6161, 0x48e0, 0x38a0, 0x40c0, 0x4101, 0x41c7, 0x83ef, 0xd679, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xcdf6, 0x30a0, 0x4942, 0x7a84, 0x8b05, 0x8ac5, 0x8263, 0x7a42, 0x71e2, 0x5940, 0x48e0, 0x4900, 0x40a0, 0x4101, 0x8b6c, 0xeeb9, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffde, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xeed9, 0x6226, 0x38c0, 0x61e2, 0x7a84, 0x8ac5, 0x8283, 0x8263, 0x7a43, 0x69e2, 0x61c2, 0x48e0, 0x5941, 0x40e0, 0x38c0, 0x6a88, 0xb4f2, 0xef1b, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffbe, 0xac90, 0x30c1, 0x4900, 0x6a02, 0x8284, 0x8a84, 0x8263, 0x7a43, 0x7244, 0x7264, 0x7a23, 0x6181, 0x4900, 0x4900, 0x38c0, 0x30a0, 0x72ea, 0xde37, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xe698, 0x6247, 0x40a0, 0x5981, 0x7a23, 0x8263, 0x7a43, 0x7a23, 0x7223, 0x7244, 0x6981, 0x8244, 0x7a44, 0x5941, 0x40c0, 0x40c0, 0x4121, 0x5183, 0x9cb1, 0xef3c, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffdd, 0xa490, 0x3880, 0x5120, 0x71e2, 0x7a23, 0x7a23, 0x7a22, 0x7223, 0x6a02, 0x7a02, 0x71c1, 0x69c1, 0x71e3, 0x7203, 0x5961, 0x40c0, 0x40c0, 0x3101, 0x730a, 0xd616, 0xfffe, 0xffff, 0xffdf, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffdf, 0xffff, 0xd5f6, 0x40a0, 0x5100, 0x69a2, 0x7a23, 0x8243, 0x7a43, 0x7243, 0x6a02, 0x7a22, 0x7a02, 0x71e2, 0x71e2, 0x71e3, 0x69e3, 0x5981, 0x5120, 0x40e0, 0x30a0, 0x6226, 0xbd53, 0xff7c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xce17, 0x40a0, 0x4900, 0x69c3, 0x7a44, 0x7a43, 0x7a43, 0x7243, 0x6a22, 0x71c2, 0x7203, 0x7203, 0x71e2, 0x69e2, 0x69e3, 0x69e2, 0x5982, 0x5920, 0x5120, 0x38a0, 0x3901, 0x8bcd, 0xf75b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffbe, 0xbd75, 0x40a0, 0x5101, 0x69c3, 0x7a44, 0x7a02, 0x7202, 0x7222, 0x6a02, 0x7203, 0x69c2, 0x69c2, 0x69e3, 0x6a03, 0x69e2, 0x69e3, 0x6a03, 0x79e2, 0x5920, 0x5100, 0x40e0, 0x30e1, 0x730a, 0xd658, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7df, 0xf7ff, 0xffff, 0xffde, 0xffbd, 0x6a26, 0x4080, 0x6181, 0x7a44, 0x7a44, 0x7203, 0x7203, 0x7a23, 0x7203, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x71e2, 0x69c2, 0x6181, 0x4900, 0x48e0, 0x40e0, 0x6225, 0xc531, 0xfffd, 0xfffe, 0xf7de, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff9d, 0xb4d1, 0x4902, 0x50e0, 0x69a1, 0x7a44, 0x7a44, 0x7203, 0x7203, 0x7203, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x71c2, 0x71e2, 0x69e2, 0x6181, 0x5141, 0x38a0, 0x38c0, 0x6a45, 0xa46f, 0xffbc, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xcdd5, 0x51a4, 0x3880, 0x6181, 0x7203, 0x7a44, 0x7a23, 0x7203, 0x7203, 0x7203, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69a1, 0x71e2, 0x7203, 0x69e3, 0x69e3, 0x5162, 0x40c0, 0x40e0, 0x4942, 0x9c0e, 0xff5c, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xd658, 0x72c8, 0x3080, 0x5120, 0x7203, 0x7a44, 0x7a44, 0x7a23, 0x7203, 0x7203, 0x7203, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x71e2, 0x7203, 0x69e3, 0x69e3, 0x7224, 0x6a03, 0x5982, 0x4920, 0x3880, 0x3880, 0x93ad, 0xff5c, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0x838c, 0x30a0, 0x4900, 0x7203, 0x8264, 0x8264, 0x7a44, 0x7a23, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x7203, 0x69e2, 0x69c2, 0x69e2, 0x6a03, 0x69e3, 0x61a2, 0x5961, 0x50e1, 0x40a0, 0x40c0, 0x8b8c, 0xff7c, 0xffff, 0xefbe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xcdd6, 0x4122, 0x3880, 0x61a1, 0x8263, 0x8264, 0x8264, 0x7a44, 0x7a23, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69c2, 0x69e2, 0x69e3, 0x69e2, 0x7203, 0x69e2, 0x6182, 0x6182, 0x40a0, 0x40e0, 0x9c0e, 0xff7c, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffbd, 0x72ea, 0x3080, 0x5961, 0x7222, 0x8263, 0x8264, 0x7a44, 0x7a44, 0x7a23, 0x7203, 0x71e2, 0x71e2, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x7203, 0x7224, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7203, 0x7203, 0x6a03, 0x5981, 0x5961, 0x40a0, 0x4101, 0xb4d1, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xd637, 0x3902, 0x40e0, 0x6a03, 0x7a63, 0x8282, 0x7a44, 0x7a44, 0x7a23, 0x7a23, 0x7203, 0x71e2, 0x71e2, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x61a2, 0x6a03, 0x69c2, 0x69e2, 0x7203, 0x71e2, 0x7202, 0x69c1, 0x6a03, 0x69e2, 0x61a1, 0x4900, 0x38c0, 0x6227, 0xbd75, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xac6f, 0x40c0, 0x5920, 0x8264, 0x8263, 0x7a64, 0x7a23, 0x7a22, 0x7a23, 0x7222, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x71e2, 0x69c1, 0x7223, 0x61a1, 0x5140, 0x38c0, 0x6a46, 0xff1a, 0xffff, 0xefbe, 0xffff, 0xffff, 0xf7bd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0x72e9, 0x40a0, 0x6980, 0x8aa5, 0x8264, 0x7a43, 0x7a23, 0x7a22, 0x7a23, 0x7222, 0x7202, 0x7203, 0x71e3, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x7a03, 0x71e2, 0x7223, 0x69e2, 0x61c2, 0x4100, 0x4101, 0x93ac, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf75c, 0x4142, 0x40c0, 0x7202, 0x8aa5, 0x8263, 0x7a43, 0x7a23, 0x7a22, 0x7a23, 0x7222, 0x7203, 0x7203, 0x71e3, 0x71e3, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x71e2, 0x69a1, 0x7202, 0x69e2, 0x6a23, 0x59a2, 0x3080, 0x4102, 0xce58, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77c, 0x2880, 0x5120, 0x7a43, 0x8263, 0x7a43, 0x8264, 0x7a23, 0x7a22, 0x7a23, 0x7222, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x71e2, 0x69c1, 0x69e2, 0x61c1, 0x6a02, 0x69e3, 0x4901, 0x40a0, 0x83cd, 0xffbd, 0xffde, 0xffdf, 0xffdf, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf75c, 0x2880, 0x5120, 0x7a23, 0x8243, 0x7a23, 0x7a64, 0x7a22, 0x7a22, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x7203, 0x69e2, 0x7202, 0x69e1, 0x69e2, 0x69e3, 0x5962, 0x4901, 0x49a4, 0xde78, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf75c, 0x4142, 0x40c0, 0x71e2, 0x8264, 0x7a43, 0x7223, 0x7a22, 0x7a22, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x7202, 0x7222, 0x7202, 0x69e2, 0x6182, 0x5100, 0x38e0, 0xac90, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbe, 0x7b09, 0x40a0, 0x6160, 0x8a84, 0x7a43, 0x7a43, 0x7a22, 0x7a22, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x61c2, 0x61c2, 0x69e2, 0x7202, 0x7202, 0x71e2, 0x71c3, 0x6141, 0x40e0, 0x6246, 0xff9d, 0xffff, 0xf7df, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xb4d0, 0x48e0, 0x5920, 0x8243, 0x7a43, 0x8284, 0x7a22, 0x7a22, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x6a03, 0x6a03, 0x69c2, 0x69e1, 0x69e1, 0x71e2, 0x7203, 0x6982, 0x4900, 0x30a0, 0xeeda, 0xffff, 0xf7df, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffbc, 0xd5d4, 0x832a, 0x4962, 0x4100, 0x61c2, 0x7a65, 0x82a6, 0x8aa4, 0x8284, 0x7a43, 0x7202, 0x69c1, 0x69c1, 0x69c1, 0x69c1, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x5120, 0x40e1, 0xbd74, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xff9d, 0xa491, 0x5a05, 0x4962, 0x38c0, 0x38a0, 0x40e0, 0x5120, 0x5960, 0x6181, 0x69c0, 0x69c0, 0x69a0, 0x69a1, 0x69c1, 0x71e2, 0x7202, 0x7a23, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x4900, 0x40e0, 0xacb1, 0xffdf, 0xf7df, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffdd, 0xc5b4, 0x5a26, 0x4122, 0x38c0, 0x4900, 0x61a2, 0x7224, 0x7a64, 0x7a43, 0x7a02, 0x7202, 0x71e1, 0x71e1, 0x7201, 0x7202, 0x7202, 0x7a23, 0x7a43, 0x7a44, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x5941, 0x40e1, 0x9c2f, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf73b, 0x940d, 0x30c0, 0x38a0, 0x40c0, 0x6180, 0x7202, 0x8284, 0x8ac5, 0x92c5, 0x92c4, 0x92a4, 0x8a83, 0x8aa4, 0x82a4, 0x8284, 0x8284, 0x8264, 0x7a44, 0x7a43, 0x7a43, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x5941, 0x3880, 0x9c0e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9e, 0xe6b9, 0x7ae9, 0x2840, 0x48e0, 0x6180, 0x8284, 0x92e4, 0x9b05, 0x9b05, 0x92e4, 0x92a4, 0x92a4, 0x92a3, 0x8a83, 0x82a4, 0x82a4, 0x8284, 0x8284, 0x8264, 0x7a44, 0x7a43, 0x7a23, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x71e2, 0x71e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x6161, 0x3880, 0xa470, 0xffbe, 0xf7df, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdd, 0xde37, 0x6a47, 0x38a0, 0x5100, 0x6980, 0x8aa4, 0x8aa3, 0x9b05, 0x9ae4, 0x92c4, 0x92c4, 0x92c4, 0x92a3, 0x8aa3, 0x8aa3, 0x8283, 0x8283, 0x8283, 0x8263, 0x7a63, 0x7a44, 0x7a43, 0x7a43, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x71e2, 0x71e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x5100, 0x40c0, 0xc553, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xde36, 0x5a05, 0x3880, 0x5100, 0x71a2, 0x8a84, 0x92c4, 0x92e4, 0x9ae4, 0x92c3, 0x92a3, 0x8aa3, 0x8aa3, 0x8a83, 0x8a83, 0x8aa4, 0x82a4, 0x8284, 0x8284, 0x8263, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x71e2, 0x69e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x48c0, 0x5162, 0xc553, 0xffde, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xe71c, 0x51c3, 0x4100, 0x48e0, 0x7a04, 0x9ae6, 0x9b06, 0x9b05, 0x8ac4, 0x92a3, 0x9ae4, 0x9b05, 0x92e4, 0x8ac4, 0x8ac4, 0x8aa4, 0x82a4, 0x8283, 0x8263, 0x7a63, 0x7a43, 0x7a23, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x71e2, 0x69e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x50e0, 0x48e0, 0x6247, 0x7bae, 0x8c51, 0xbdf7, 0xf77d, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xff5c, 0x51c5, 0x40c0, 0x5940, 0x7a22, 0x92e5, 0x9b05, 0x92e4, 0x92c3, 0x92c3, 0x92c4, 0x92c4, 0x92a4, 0x8aa4, 0x8a84, 0x8284, 0x8264, 0x8263, 0x7a44, 0x7a44, 0x7a44, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x7203, 0x7203, 0x7203, 0x69e3, 0x69c2, 0x69c2, 0x71e3, 0x7203, 0x69e3, 0x71e3, 0x7203, 0x7203, 0x7203, 0x71e2, 0x6181, 0x5940, 0x4920, 0x48e0, 0x40e0, 0x40e0, 0x38a0, 0x38c0, 0x59c3, 0x82e8, 0xd5f6, 0xffbd, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbd, 0x93cd, 0x4122, 0x5120, 0x69e1, 0x82a4, 0x9305, 0x92e4, 0x92c3, 0x92c3, 0x92c3, 0x92c4, 0x92c4, 0x92a4, 0x8aa4, 0x8a84, 0x8283, 0x8263, 0x8263, 0x7a44, 0x7a44, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x69c2, 0x69e2, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x71e3, 0x7203, 0x71e3, 0x69e3, 0x7203, 0x7203, 0x69a1, 0x5940, 0x6160, 0x69e2, 0x7224, 0x6a03, 0x69e3, 0x61a2, 0x5140, 0x40e0, 0x40e0, 0x4921, 0x40e1, 0x72c9, 0xce17, 0xffdf, 0xffff, 0xf7ff, 0xf7be, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xcdd5, 0x38e1, 0x38c0, 0x69e1, 0x8284, 0x9306, 0x9b05, 0x92c4, 0x8aa3, 0x92c3, 0x9ae4, 0x92c4, 0x92c4, 0x8aa4, 0x8a84, 0x8283, 0x8263, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x69c2, 0x69c2, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x71e3, 0x71e3, 0x69c2, 0x7203, 0x71e3, 0x6181, 0x5960, 0x61a1, 0x7203, 0x7a43, 0x7a44, 0x7a43, 0x7a44, 0x7a44, 0x7203, 0x61a2, 0x5120, 0x48e0, 0x40a0, 0x38c0, 0x6247, 0x9450, 0xef5c, 0xffff, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5c, 0x72c9, 0x3080, 0x5161, 0x8a84, 0x92e5, 0x9b26, 0x9305, 0x92c4, 0x8aa3, 0x92c4, 0x92e4, 0x92a4, 0x8aa4, 0x8a84, 0x8283, 0x8263, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x69e3, 0x71e3, 0x71e3, 0x71e3, 0x69e3, 0x69e2, 0x69e3, 0x69e3, 0x7203, 0x7203, 0x69a2, 0x5960, 0x69a1, 0x7a44, 0x8264, 0x7223, 0x7a02, 0x7a22, 0x7a22, 0x7a23, 0x8264, 0x8284, 0x7a23, 0x69c2, 0x6181, 0x5120, 0x38a0, 0x30e1, 0x8bee, 0xef5c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xbd73, 0x38e0, 0x5120, 0x7a44, 0x9ae5, 0x92e5, 0x92c5, 0x92e4, 0x8ac4, 0x8aa4, 0x8ac3, 0x8ac4, 0x8a84, 0x8a84, 0x8283, 0x8263, 0x7a43, 0x7a43, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x69e3, 0x69e3, 0x71e3, 0x71e3, 0x7203, 0x7203, 0x7a24, 0x6181, 0x5960, 0x69e2, 0x7a64, 0x7a43, 0x7202, 0x7202, 0x8222, 0x8263, 0x8243, 0x7a22, 0x7a22, 0x8263, 0x8243, 0x7a23, 0x71e2, 0x6160, 0x5140, 0x38a0, 0x30c0, 0x942f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0x6a88, 0x38c0, 0x5960, 0x92e5, 0x9b05, 0x92c4, 0x8a83, 0x8ac4, 0x8ac4, 0x8ac4, 0x82a4, 0x82a4, 0x8283, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a43, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x69e2, 0x69e2, 0x69c2, 0x69e3, 0x7203, 0x7203, 0x7203, 0x7203, 0x5960, 0x5940, 0x61a1, 0x7223, 0x7a64, 0x7a43, 0x7222, 0x7222, 0x7a22, 0x8263, 0x8283, 0x7a43, 0x7a22, 0x7a23, 0x7a43, 0x7a43, 0x8284, 0x7202, 0x61a1, 0x5140, 0x38a0, 0x5a26, 0xcdf7, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xe699, 0x3901, 0x4920, 0x7202, 0x9ae4, 0x92c4, 0x92a4, 0x92a3, 0x8aa4, 0x8aa4, 0x82a4, 0x82a4, 0x8283, 0x8243, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x69e2, 0x69e2, 0x69e3, 0x7203, 0x7203, 0x71e3, 0x69a2, 0x6181, 0x5100, 0x69a1, 0x7223, 0x7223, 0x7223, 0x7a63, 0x7a63, 0x7a43, 0x7202, 0x7a22, 0x7a43, 0x7a43, 0x7223, 0x7243, 0x7244, 0x7a44, 0x69e2, 0x7a43, 0x7202, 0x6180, 0x5140, 0x38a0, 0x6aa9, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xacf2, 0x38e0, 0x5120, 0x9b05, 0x92c3, 0x9283, 0x92c4, 0x92c4, 0x8aa4, 0x8a83, 0x8284, 0x8283, 0x7a83, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7223, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x69a2, 0x5940, 0x5100, 0x7203, 0x7a23, 0x7a64, 0x8284, 0x7a63, 0x7222, 0x7222, 0x7a43, 0x7a63, 0x7a43, 0x7243, 0x7223, 0x7223, 0x7223, 0x6a23, 0x7223, 0x7244, 0x69e2, 0x7a63, 0x69c1, 0x69a1, 0x40a0, 0x40e1, 0xe637, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xfffe, 0x7b4a, 0x38a0, 0x69e2, 0x8a84, 0x92a3, 0x8aa3, 0x8283, 0x8283, 0x8283, 0x7a64, 0x7a64, 0x7a44, 0x7244, 0x7a24, 0x7a24, 0x7a24, 0x7a03, 0x7a03, 0x7a03, 0x7a03, 0x7a23, 0x7204, 0x71e3, 0x69e3, 0x6a03, 0x6a03, 0x6a03, 0x6a02, 0x6a22, 0x69e2, 0x71e3, 0x71e3, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x69e2, 0x7223, 0x7223, 0x61a1, 0x5120, 0x5100, 0x61a1, 0x7a64, 0x7a44, 0x7a64, 0x7a44, 0x7a23, 0x7a24, 0x8244, 0x8244, 0x7a03, 0x7a43, 0x7a23, 0x7a44, 0x8264, 0x7a44, 0x7203, 0x7203, 0x7224, 0x7a23, 0x7203, 0x7a02, 0x7a02, 0x69c2, 0x40c0, 0x4941, 0x9c0d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdd, 0x6266, 0x38c0, 0x7202, 0x8aa4, 0x92a3, 0x8aa4, 0x8aa4, 0x8aa4, 0x8283, 0x8263, 0x7a43, 0x7a43, 0x7a44, 0x7a24, 0x7a24, 0x7a23, 0x7a23, 0x7a03, 0x7202, 0x71e2, 0x71e1, 0x7203, 0x7223, 0x7223, 0x7223, 0x7223, 0x6a03, 0x6a02, 0x69e2, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x61a1, 0x5960, 0x5960, 0x61a1, 0x7203, 0x7a44, 0x7a44, 0x7a23, 0x8264, 0x8284, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a02, 0x71e2, 0x71e2, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x7202, 0x7a02, 0x7223, 0x5120, 0x38c0, 0x6a66, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0x3942, 0x40e0, 0x7223, 0x8aa4, 0x8a83, 0x8aa4, 0x8aa4, 0x8283, 0x8263, 0x8243, 0x8243, 0x8243, 0x8263, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7222, 0x7a22, 0x7a43, 0x7202, 0x7202, 0x7222, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7223, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x7203, 0x7203, 0x7223, 0x61a1, 0x6160, 0x5960, 0x69c1, 0x7a43, 0x8285, 0x8264, 0x7a44, 0x8242, 0x8242, 0x7a42, 0x7a22, 0x7a43, 0x7a43, 0x7a23, 0x71e2, 0x7a64, 0x7223, 0x7202, 0x7202, 0x7202, 0x7202, 0x6a02, 0x7202, 0x69e3, 0x71e2, 0x71c2, 0x71e2, 0x7a44, 0x61c2, 0x38c0, 0x4121, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0x28a0, 0x4100, 0x7223, 0x92c5, 0x8a83, 0x8263, 0x8283, 0x8284, 0x8264, 0x8263, 0x7a43, 0x7a22, 0x7a02, 0x6a03, 0x6a03, 0x6a03, 0x6a03, 0x6a03, 0x6a03, 0x6a02, 0x69e2, 0x7222, 0x7222, 0x7201, 0x7a01, 0x79e2, 0x7a03, 0x7a03, 0x7204, 0x69c2, 0x7203, 0x7223, 0x7a44, 0x7a23, 0x71e2, 0x61a1, 0x5960, 0x6180, 0x69c1, 0x7223, 0x7a44, 0x7a64, 0x7a64, 0x7a64, 0x7a64, 0x8262, 0x8242, 0x7a22, 0x7a22, 0x7a43, 0x7243, 0x7223, 0x6a03, 0x6a23, 0x6a03, 0x69e3, 0x61e2, 0x61e2, 0x61c2, 0x69e2, 0x6a02, 0x7224, 0x7223, 0x71e2, 0x69a1, 0x71e2, 0x69e3, 0x4900, 0x38c0, 0xe71c, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9d, 0x3943, 0x4100, 0x69e3, 0x8aa4, 0x8a84, 0x8263, 0x8284, 0x8aa4, 0x8284, 0x7a44, 0x7224, 0x7244, 0x7a65, 0x8308, 0x8329, 0x8b6a, 0x8b6a, 0x8b49, 0x7ae7, 0x6a86, 0x6224, 0x6a23, 0x6a22, 0x7201, 0x7a01, 0x7a01, 0x7a02, 0x7203, 0x71e3, 0x7a43, 0x7223, 0x69e2, 0x69c2, 0x61a1, 0x61a1, 0x61a1, 0x69a1, 0x7a43, 0x7a43, 0x8264, 0x8264, 0x7a63, 0x7a43, 0x7a43, 0x7a63, 0x8262, 0x8263, 0x8263, 0x7243, 0x6a23, 0x6a24, 0x72a7, 0x8329, 0x834a, 0x834a, 0x8b4a, 0x8329, 0x7ac7, 0x6a65, 0x61e3, 0x59a2, 0x6a24, 0x7224, 0x7a23, 0x69c2, 0x69c2, 0x69c2, 0x4900, 0x38a0, 0xd6ba, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0x72e9, 0x4100, 0x61a2, 0x8264, 0x9284, 0x8a63, 0x8a83, 0x8264, 0x7224, 0x6a45, 0x7aa7, 0x8b8b, 0x9c2e, 0xa491, 0xacd2, 0xb512, 0xb513, 0xb4f2, 0xa4b0, 0x9c2f, 0x93ed, 0x6a66, 0x6a44, 0x6a02, 0x7a02, 0x8222, 0x8243, 0x7a24, 0x6a04, 0x7202, 0x69c2, 0x6180, 0x5960, 0x6180, 0x69e2, 0x7a44, 0x82a5, 0x8284, 0x8264, 0x8264, 0x8264, 0x8264, 0x8264, 0x7a43, 0x7a23, 0x7a43, 0x7202, 0x6a03, 0x7265, 0x7ac8, 0x838c, 0x942f, 0xa4b1, 0xad13, 0xb533, 0xb513, 0xacf2, 0xac90, 0x9bee, 0x7b0a, 0x6247, 0x61e3, 0x61a2, 0x7203, 0x7a23, 0x7202, 0x69a1, 0x4900, 0x40a0, 0xd69a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xb4d1, 0x40e0, 0x5920, 0x7a23, 0x9284, 0x8a83, 0x8263, 0x7a44, 0x7a86, 0x832a, 0x940e, 0xa4f3, 0xb575, 0xad56, 0xb556, 0xb576, 0xb596, 0xb596, 0xb576, 0xb575, 0xad55, 0x93ee, 0x834a, 0x7a86, 0x7202, 0x7a02, 0x7a22, 0x6a23, 0x61e3, 0x5960, 0x6180, 0x69e2, 0x7a43, 0x8284, 0x8284, 0x8284, 0x8284, 0x8263, 0x8263, 0x8264, 0x8264, 0x8264, 0x8263, 0x7a23, 0x7a02, 0x7203, 0x69e3, 0x7246, 0x834b, 0x9c50, 0xad14, 0xad56, 0xb597, 0xa536, 0xad56, 0xb577, 0xb576, 0xbd96, 0xbd55, 0xacd3, 0x9c30, 0x7ac7, 0x59a2, 0x69c2, 0x7a23, 0x7a03, 0x69a1, 0x4900, 0x40e0, 0xdefb, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xde16, 0x38c0, 0x50e0, 0x7a03, 0x92a5, 0x9283, 0x8a63, 0x8285, 0x934a, 0xa470, 0xb534, 0xad56, 0x9d36, 0xb598, 0xb599, 0xb5b9, 0xb5b9, 0xb5b9, 0xb5d8, 0xb5b8, 0xb5b8, 0xce18, 0xacd2, 0x8b29, 0x7203, 0x69a0, 0x6180, 0x5980, 0x4960, 0x7222, 0x7223, 0x7a43, 0x7a64, 0x8284, 0x8284, 0x7a64, 0x7a64, 0x8284, 0x8263, 0x8243, 0x7a43, 0x7a43, 0x7a23, 0x7a22, 0x7a22, 0x61c3, 0x7a66, 0x938c, 0xacb1, 0xb535, 0xad56, 0xad78, 0xadb9, 0xb5da, 0xb5fb, 0xb5da, 0xb5b9, 0xbdb8, 0xc5b8, 0xbd97, 0xbd56, 0xb48e, 0x7265, 0x61a2, 0x71e2, 0x71e2, 0x6160, 0x48c0, 0x40c0, 0xe73c, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xff9d, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffde, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7bd, 0x942e, 0x3080, 0x5940, 0x92a5, 0x8a83, 0x7243, 0x8b8b, 0xa4d2, 0xa535, 0xad56, 0xb576, 0xc5d7, 0xc618, 0xc618, 0xc638, 0xce59, 0xce59, 0xce59, 0xc638, 0xce59, 0xbe18, 0xb597, 0xb537, 0x7b0b, 0x4940, 0x69e0, 0x8262, 0x8a83, 0x8aa3, 0x8a84, 0x8a84, 0x8a84, 0x8a84, 0x8a84, 0x8a84, 0x8a84, 0x8243, 0x8243, 0x8284, 0x7223, 0x7203, 0x7a43, 0x7222, 0x7201, 0x5227, 0x8bae, 0xad14, 0xb536, 0xa4d5, 0xb597, 0xbdd8, 0xbe17, 0xce39, 0xc5f8, 0xc618, 0xc619, 0xce5a, 0xce5a, 0xbdd8, 0xbdd8, 0xad98, 0xad34, 0x6aa8, 0x59c2, 0x6a02, 0x5120, 0x48e0, 0x5101, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xf79f, 0xffff, 0xffff, 0xfffe, 0xc593, 0x59a2, 0x48c0, 0x7181, 0x8285, 0x9349, 0xac90, 0xa4f3, 0xa556, 0xbe19, 0xbe18, 0xbdd7, 0xd69a, 0xce59, 0xd6ba, 0xdedb, 0xd6ba, 0xd69a, 0xd69a, 0xd6ba, 0xc679, 0xce5a, 0xcdf9, 0xb4f3, 0x8b49, 0x7a63, 0x8283, 0x8a83, 0x8aa4, 0x8aa4, 0x8a84, 0x8a84, 0x8a84, 0x8a64, 0x8264, 0x8264, 0x8264, 0x8243, 0x8264, 0x7223, 0x7223, 0x7223, 0x6a02, 0x7222, 0x838d, 0xb514, 0xad15, 0xbd77, 0xc5d9, 0xc619, 0xc619, 0xc679, 0xd67a, 0xd69a, 0xdefc, 0xd69a, 0xce39, 0xdedb, 0xdedb, 0xce59, 0xc65b, 0xbdd7, 0x9c6f, 0x6a85, 0x5160, 0x4900, 0x48e0, 0x5121, 0xcdf7, 0xf75c, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9d, 0xcdf6, 0xbd32, 0x93ab, 0x4920, 0x4060, 0x58e0, 0x7247, 0xa42f, 0xbd55, 0xa555, 0xadb8, 0xbe59, 0xbe38, 0xce58, 0xdedb, 0xdefb, 0xe71c, 0xdefb, 0xef5d, 0xef5d, 0xd6ba, 0xd6ba, 0xce9a, 0xdedc, 0xce1a, 0xd638, 0xbd11, 0x82c6, 0x8283, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8284, 0x8264, 0x8264, 0x8264, 0x8264, 0x8264, 0x7a43, 0x7223, 0x7203, 0x7a44, 0x6a03, 0x6a03, 0x82c6, 0x9c91, 0xbd75, 0xacf4, 0xbdb8, 0xc619, 0xbdd8, 0xd6bb, 0xdf1c, 0xe73c, 0xdefc, 0xe73d, 0xef7d, 0xe73d, 0xdedb, 0xce7a, 0xd69a, 0xd6bc, 0xce38, 0xce16, 0x8b8a, 0x4920, 0x4900, 0x48c0, 0x5100, 0x30c1, 0x5a26, 0xa46f, 0xe699, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xf7df, 0xffff, 0xfffe, 0xf73b, 0xbcf2, 0x830b, 0x4122, 0x40c0, 0x40c0, 0x4080, 0x5900, 0x6141, 0x72eb, 0xacf4, 0xb556, 0xad97, 0xbe39, 0xbe38, 0xc699, 0xdf1b, 0xdedb, 0x9cf3, 0x738e, 0x738e, 0x9cf3, 0xdefb, 0xef7d, 0xdefb, 0xd6db, 0xdefc, 0xce39, 0xd679, 0xd5f6, 0x9bcb, 0x82a5, 0x8ac5, 0x8aa4, 0x8aa4, 0x8a84, 0x8284, 0x8263, 0x8243, 0x7a43, 0x7a23, 0x7a23, 0x7222, 0x71e2, 0x7202, 0x7224, 0x69e3, 0x7266, 0x9bcc, 0xb534, 0xb555, 0xbd96, 0xce59, 0xc639, 0xd69a, 0xe71c, 0xbdd7, 0x7bef, 0x73ae, 0x73ae, 0xa534, 0xe73c, 0xef7d, 0xdedb, 0xe73c, 0xd6bb, 0xce59, 0xdeb9, 0xb512, 0x6a66, 0x5161, 0x5120, 0x5100, 0x5120, 0x38c0, 0x3080, 0x51a4, 0x9c2f, 0xe6da, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xfffe, 0xde77, 0x7b4a, 0x4902, 0x3880, 0x3880, 0x5960, 0x7a23, 0x8244, 0x8a86, 0x8aa7, 0x9c73, 0xb577, 0xad56, 0xbdf9, 0xc65a, 0xc69a, 0xdf3c, 0xbe17, 0x52aa, 0x0000, 0x0000, 0x0000, 0x0000, 0x528a, 0xbdd7, 0xef7d, 0xe71c, 0xdefc, 0xdedb, 0xd6bb, 0xe6ba, 0xc573, 0x8b28, 0x82a4, 0x8aa4, 0x8284, 0x8284, 0x8263, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7202, 0x7203, 0x71e2, 0x71e2, 0x69e3, 0x61e4, 0x7b0a, 0xb4d2, 0xb576, 0xb597, 0xc618, 0xce59, 0xd6ba, 0xe71c, 0xa534, 0x39e8, 0x0000, 0x0000, 0x0000, 0x18c3, 0x7bcf, 0xd6ba, 0xef5d, 0xd6ba, 0xdefb, 0xd6ba, 0xdeba, 0xde78, 0xa44f, 0x6205, 0x61c2, 0x61a1, 0x5100, 0x5940, 0x5141, 0x38c0, 0x38e1, 0x6aa8, 0xc5b5, 0xfffe, 0xfffe, 0xffff, 0xffde, 0xffde, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xc594, 0x72a7, 0x38a0, 0x48c0, 0x69c2, 0x8243, 0x92e5, 0xa367, 0x92e6, 0x82a6, 0x9b8a, 0xad56, 0xb597, 0xb597, 0xc619, 0xc659, 0xdefc, 0xce79, 0x52aa, 0x0000, 0x0000, 0x1082, 0x1082, 0x0000, 0x0000, 0x4a69, 0xdefb, 0xef3c, 0xdf1b, 0xe75d, 0xd6bb, 0xe6dc, 0xe679, 0x9bec, 0x7a84, 0x8284, 0x8264, 0x8263, 0x7a43, 0x7a43, 0x7a23, 0x7203, 0x7203, 0x7223, 0x7223, 0x7202, 0x71e2, 0x69a2, 0x6a06, 0x93ce, 0xbd55, 0xb577, 0xbdb8, 0xc5f8, 0xce79, 0xe73b, 0xa534, 0x31a6, 0x0000, 0x0020, 0x0841, 0x0840, 0x0000, 0x0861, 0x7bef, 0xe71c, 0xe71c, 0xdf1b, 0xe71c, 0xd67a, 0xe6fb, 0xc5b5, 0x72c8, 0x69e3, 0x7222, 0x8223, 0x6981, 0x5940, 0x5120, 0x40c0, 0x38c0, 0x5a05, 0x93cc, 0xff7c, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffbd, 0xbd53, 0x5a05, 0x3880, 0x5120, 0x7a43, 0x92e5, 0x9ae4, 0x92c3, 0x9b04, 0x82a4, 0x82e7, 0xb48e, 0xad76, 0xb596, 0xc618, 0xc618, 0xd69a, 0xdeda, 0x7bef, 0x0000, 0x0000, 0x0020, 0x0000, 0x0000, 0x10a2, 0x0000, 0x0020, 0x738e, 0xe71b, 0xe71b, 0xdf3c, 0xd6fc, 0xd6dd, 0xe6bb, 0xbcd0, 0x7aa4, 0x7a63, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x71e3, 0x6a23, 0x7222, 0x7202, 0x7202, 0x69c3, 0x7aa8, 0xa4b2, 0xb577, 0xbdd9, 0xc63a, 0xce59, 0xe73b, 0xd699, 0x4a69, 0x0000, 0x0842, 0x0020, 0x0840, 0x0881, 0x0000, 0x0000, 0x1903, 0x9d13, 0xf7be, 0xdf1a, 0xe73c, 0xd6bb, 0xdedc, 0xde79, 0x93cd, 0x61e3, 0x7202, 0x71e2, 0x7a24, 0x7a23, 0x61a2, 0x5940, 0x5120, 0x4900, 0x40e0, 0x9c4f, 0xeed9, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xc5d6, 0x5a46, 0x38a0, 0x5960, 0x7a22, 0x92e5, 0x92c4, 0x9ae3, 0x9ae3, 0x9303, 0x8ae5, 0x8b69, 0xac8e, 0xad75, 0xbdf7, 0xd699, 0xce38, 0xef1c, 0xce38, 0x39a7, 0x0000, 0x0861, 0x0000, 0x0861, 0x0841, 0x0000, 0x0020, 0x0841, 0x2104, 0xdeda, 0xe73c, 0xdf3b, 0xdf5e, 0xdf1e, 0xe6bc, 0xd5d5, 0x8306, 0x7a43, 0x7a43, 0x7a43, 0x7223, 0x7203, 0x7203, 0x7203, 0x71e3, 0x6a03, 0x69e2, 0x71e1, 0x71e2, 0x69e3, 0x8b2b, 0xbd55, 0xb598, 0xbdfa, 0xc65a, 0xce9a, 0xdf1b, 0xa533, 0x18c2, 0x0000, 0x0841, 0x0020, 0x0840, 0x0000, 0x0860, 0x0860, 0x0000, 0x5aca, 0xe71b, 0xdf1a, 0xe73c, 0xe73d, 0xdedc, 0xeefc, 0xbd32, 0x6a24, 0x7201, 0x7a24, 0x7a23, 0x7a44, 0x8244, 0x71e2, 0x5940, 0x50e0, 0x48c0, 0x20a0, 0xacd1, 0xffde, 0xfffe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xeeb8, 0x59c3, 0x4900, 0x5120, 0x7a43, 0x9306, 0x9ac4, 0x9ae4, 0x92e4, 0x9ae4, 0x9ac3, 0x8284, 0x9c0d, 0xad34, 0xbdd7, 0xbdf7, 0xce79, 0xd6ba, 0xe71c, 0x9492, 0x0000, 0x0861, 0x0841, 0x0841, 0x0841, 0x0841, 0x0841, 0x0841, 0x0841, 0x0020, 0x8c10, 0xf79e, 0xe73d, 0xdefc, 0xdf1c, 0xdeda, 0xdeb9, 0x7b8c, 0x7203, 0x7203, 0x7223, 0x7223, 0x7203, 0x71e2, 0x71e2, 0x7202, 0x69e3, 0x7203, 0x71e2, 0x69c2, 0x61c4, 0x9c2e, 0xb596, 0xb5d8, 0xbdf7, 0xd69a, 0xd6ba, 0xef7d, 0x52aa, 0x0000, 0x0020, 0x0020, 0x0861, 0x0861, 0x0020, 0x0020, 0x0841, 0x0841, 0x10a2, 0xbdf7, 0xe75d, 0xef3c, 0xef1b, 0xe71b, 0xdefc, 0xce37, 0x72a7, 0x71e2, 0x7223, 0x7223, 0x7223, 0x7203, 0x7223, 0x7203, 0x6180, 0x48e0, 0x5100, 0x59a3, 0xcd95, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0x7b2a, 0x4941, 0x48e0, 0x69c1, 0x8ac5, 0x9b26, 0x9ac4, 0x92e4, 0x92e4, 0x9ae4, 0x9ac3, 0x8aa4, 0xa42e, 0xb555, 0xc618, 0xce59, 0xd69a, 0xd6ba, 0xdefb, 0x73ae, 0x0000, 0x0841, 0x0841, 0x0841, 0x0841, 0x0841, 0x0861, 0x0841, 0x0841, 0x0020, 0x62cb, 0xe71c, 0xe75d, 0xdf1c, 0xdf1c, 0xdefb, 0xef1a, 0x942f, 0x7202, 0x7203, 0x7223, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x71e2, 0x69e3, 0x7203, 0x71e2, 0x69e2, 0x61e4, 0xa44f, 0xbdb7, 0xb5f9, 0xce59, 0xd6ba, 0xd6ba, 0xd6ba, 0x39e7, 0x0000, 0x0841, 0x0861, 0x0841, 0x0841, 0x0841, 0x0841, 0x0841, 0x0020, 0x0020, 0x8c71, 0xe75d, 0xe71c, 0xef1b, 0xe71c, 0xdf1c, 0xd678, 0x7ae8, 0x71e2, 0x7223, 0x7223, 0x7223, 0x7203, 0x7223, 0x7223, 0x69c2, 0x5960, 0x48e0, 0x4900, 0x7b0a, 0xf73c, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xc594, 0x2880, 0x4900, 0x5960, 0x8ac5, 0x9305, 0x92e5, 0x9ac4, 0x92c4, 0x92e4, 0x92e4, 0x9ae3, 0x8aa5, 0xa44e, 0xbdb6, 0xc638, 0xce79, 0xd6ba, 0xdedb, 0xd6ba, 0x4a69, 0x0000, 0x0020, 0x0861, 0x0841, 0x0841, 0x0841, 0x0861, 0x0861, 0x0841, 0x0020, 0x3165, 0xd69a, 0xef7e, 0xe73d, 0xdf1c, 0xe6fb, 0xf75c, 0xa4d1, 0x69e2, 0x7203, 0x7203, 0x7203, 0x7202, 0x69e2, 0x69e2, 0x71e2, 0x69e3, 0x7203, 0x71e2, 0x69e3, 0x6a25, 0xacb1, 0xc5f7, 0xbe19, 0xd69a, 0xd6ba, 0xdedb, 0xbdf7, 0x2104, 0x0000, 0x0861, 0x1082, 0x0841, 0x0020, 0x0861, 0x0861, 0x0020, 0x0841, 0x0000, 0x5aeb, 0xe75d, 0xe71b, 0xef3b, 0xe71c, 0xe71c, 0xe6da, 0x8b6a, 0x7203, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7223, 0x7223, 0x71e2, 0x5100, 0x40c0, 0x30c1, 0xb534, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9c, 0x6287, 0x38c0, 0x5120, 0x7a43, 0x9b47, 0x92e5, 0x8aa4, 0x9ac4, 0x92c4, 0x92e4, 0x92e4, 0x92c3, 0x8ac5, 0xac8f, 0xc5f8, 0xc638, 0xd69a, 0xd6ba, 0xdedb, 0xd6ba, 0x3186, 0x0841, 0x0861, 0x0861, 0x0861, 0x0861, 0x0861, 0x0861, 0x0861, 0x0841, 0x0841, 0x18a2, 0xce39, 0xef7e, 0xe75d, 0xe73c, 0xdefb, 0xf77c, 0xb533, 0x69e2, 0x71e2, 0x7203, 0x7203, 0x71e2, 0x69e2, 0x69e2, 0x71e2, 0x69e3, 0x7203, 0x71e2, 0x71e3, 0x7246, 0xbd12, 0xce39, 0xc63a, 0xd69a, 0xd6ba, 0xe71c, 0xb596, 0x1082, 0x0841, 0x0861, 0x0861, 0x0861, 0x0841, 0x1082, 0x0861, 0x0020, 0x10a2, 0x0020, 0x4a49, 0xe75d, 0xe71b, 0xef3c, 0xe71c, 0xe71c, 0xef3c, 0x9bec, 0x71e2, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7223, 0x7a23, 0x7a43, 0x5960, 0x4920, 0x2860, 0x730b, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xd5d5, 0x38c0, 0x4921, 0x6181, 0x8ac5, 0x9ae5, 0x92c4, 0x92e4, 0x92a4, 0x92c4, 0x8ac4, 0x92c4, 0x92c3, 0x8ac5, 0xacb0, 0xce39, 0xce59, 0xd69a, 0xd6ba, 0xdefb, 0xd6ba, 0x2124, 0x0861, 0x1082, 0x0861, 0x0861, 0x0861, 0x0861, 0x1082, 0x0861, 0x0861, 0x0841, 0x1082, 0xc618, 0xe73d, 0xe73d, 0xe73d, 0xe6fb, 0xf77c, 0xbd73, 0x69e2, 0x71e2, 0x7203, 0x7203, 0x71e2, 0x69e2, 0x71e2, 0x7202, 0x6a03, 0x7203, 0x71e2, 0x69e3, 0x7266, 0xc553, 0xd679, 0xc67b, 0xd6ba, 0xd6ba, 0xe73c, 0xad75, 0x0841, 0x0841, 0x0861, 0x0841, 0x1082, 0x0861, 0x1082, 0x0861, 0x0020, 0x18c3, 0x0841, 0x4208, 0xe75d, 0xe71b, 0xef3c, 0xe71c, 0xe71c, 0xf77c, 0xa40d, 0x71e2, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7223, 0x7a23, 0x6a02, 0x5160, 0x4100, 0x4122, 0xeeda, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x8309, 0x4100, 0x40c0, 0x7a23, 0x92e5, 0x8a83, 0x92a4, 0x92e4, 0x92a4, 0x8aa4, 0x8aa4, 0x8aa3, 0x8aa3, 0x82c5, 0xacd1, 0xce5a, 0xd69a, 0xdedb, 0xdefb, 0xe71c, 0xdedb, 0x2965, 0x0841, 0x1082, 0x1082, 0x0861, 0x0861, 0x0861, 0x1082, 0x1082, 0x0861, 0x0841, 0x18a2, 0xc618, 0xe71c, 0xdf1c, 0xe75d, 0xe73c, 0xff7c, 0xbd74, 0x69e2, 0x71e2, 0x7203, 0x7203, 0x7202, 0x71e2, 0x7202, 0x7203, 0x6a03, 0x7203, 0x71e2, 0x69c2, 0x7266, 0xc574, 0xd69a, 0xce9b, 0xdedb, 0xdedb, 0xef5d, 0xad75, 0x0841, 0x0841, 0x1082, 0x0861, 0x0861, 0x0861, 0x0861, 0x1082, 0x0861, 0x10a2, 0x0000, 0x39e7, 0xe75d, 0xe71b, 0xef3c, 0xe71c, 0xe71c, 0xf75c, 0x9c0d, 0x69c2, 0x7203, 0x7202, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7203, 0x7a84, 0x5140, 0x4900, 0x3060, 0xcd74, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0x4101, 0x5120, 0x5100, 0x92c5, 0x9ac4, 0x8a62, 0x92a3, 0x8a83, 0x92a4, 0x8aa4, 0x82a4, 0x8283, 0x8a83, 0x82a5, 0xacd1, 0xce7a, 0xd6ba, 0xdedb, 0xdefb, 0xe73c, 0xdefb, 0x39e7, 0x0841, 0x1082, 0x1082, 0x1082, 0x1082, 0x1082, 0x1082, 0x1082, 0x0861, 0x0861, 0x20c3, 0xce7a, 0xe73d, 0xdefc, 0xe75d, 0xe73c, 0xf77c, 0xb533, 0x69e2, 0x71e2, 0x7203, 0x7203, 0x7203, 0x7202, 0x7203, 0x7203, 0x6a03, 0x7203, 0x71e2, 0x69c2, 0x7245, 0xc594, 0xde9a, 0xcebc, 0xdefb, 0xdefb, 0xef5d, 0xbdd7, 0x10a2, 0x0841, 0x10a2, 0x0861, 0x0861, 0x1082, 0x0861, 0x1082, 0x1082, 0x1082, 0x0000, 0x4a49, 0xe75d, 0xe71b, 0xef3c, 0xe71c, 0xe71c, 0xef3c, 0x93cc, 0x69a1, 0x7203, 0x71e2, 0x69e2, 0x7203, 0x7223, 0x7202, 0x7202, 0x7203, 0x7a83, 0x5980, 0x48e0, 0x38a0, 0x9bee, 0xffde, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xe73c, 0x38a0, 0x48e0, 0x71e2, 0x92c5, 0x9283, 0x8a63, 0x92a4, 0x8262, 0x9284, 0x8aa4, 0x8284, 0x8282, 0x8262, 0x8285, 0xacd1, 0xce7a, 0xd6ba, 0xdedb, 0xdefb, 0xef5d, 0xe71c, 0x4a69, 0x0841, 0x1082, 0x1082, 0x1082, 0x1082, 0x1082, 0x1082, 0x1082, 0x0861, 0x0861, 0x2104, 0xdedb, 0xef7e, 0xdefc, 0xe73c, 0xe71b, 0xf75b, 0xacf1, 0x69e2, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7223, 0x6a03, 0x7203, 0x71e2, 0x69a2, 0x6a25, 0xc594, 0xde9a, 0xcebc, 0xdefb, 0xdefb, 0xef5d, 0xce59, 0x2104, 0x0841, 0x10a2, 0x0841, 0x1082, 0x1082, 0x0841, 0x1082, 0x1082, 0x1082, 0x0841, 0x630c, 0xe75d, 0xe71c, 0xef3c, 0xe71c, 0xe71c, 0xef1b, 0x938b, 0x69a1, 0x7223, 0x69e2, 0x69e2, 0x7203, 0x7223, 0x7203, 0x7203, 0x7223, 0x7242, 0x7243, 0x48c0, 0x4921, 0x7aa9, 0xffde, 0xffbf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xfffe, 0xbd54, 0x40c0, 0x5100, 0x7a23, 0x8a84, 0x8a63, 0x8a84, 0x8264, 0x8284, 0x7a85, 0x8263, 0x8a63, 0x8a62, 0x8a63, 0x7a85, 0x93ec, 0xde98, 0xd6dd, 0xdf1d, 0xdefb, 0xef5c, 0xe75b, 0x73ad, 0x0000, 0x18a3, 0x1082, 0x18c3, 0x10a2, 0x1082, 0x10a2, 0x1082, 0x0861, 0x0841, 0x4a28, 0xef9d, 0xdf3c, 0xdf5d, 0xe77e, 0xe6fb, 0xff9c, 0x9c0d, 0x71e3, 0x7203, 0x7203, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7245, 0x7224, 0x7a44, 0x6181, 0x61e4, 0xacb1, 0xdeda, 0xd6dc, 0xe71c, 0xe73c, 0xef7d, 0xd69a, 0x528a, 0x0000, 0x18e3, 0x10a2, 0x10a2, 0x0841, 0x18e3, 0x0861, 0x18c3, 0x0841, 0x0020, 0x8c71, 0xff9c, 0xe6fb, 0xe73c, 0xe75e, 0xef5d, 0xe698, 0x7ac8, 0x6a03, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7202, 0x71e2, 0x5100, 0x48e0, 0x4142, 0xffbd, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xacf2, 0x40c0, 0x5120, 0x7a44, 0x8a84, 0x8263, 0x8a84, 0x8264, 0x8284, 0x7a64, 0x8263, 0x8a63, 0x8a62, 0x8263, 0x7244, 0x8b8a, 0xde77, 0xd6bc, 0xdefc, 0xdefb, 0xdefa, 0xf7bd, 0xa513, 0x1082, 0x1083, 0x1082, 0x0861, 0x10a2, 0x1082, 0x0861, 0x18c3, 0x18c3, 0x0000, 0x842f, 0xef5d, 0xdf3c, 0xdf3d, 0xdf1c, 0xef1b, 0xf73a, 0x8349, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7203, 0x7a23, 0x7a44, 0x7a44, 0x7224, 0x69c2, 0x69c2, 0x5961, 0x5182, 0x9c2e, 0xdeda, 0xd6db, 0xdefb, 0xe71c, 0xdefb, 0xef5d, 0x7bcf, 0x0000, 0x1082, 0x0861, 0x10a2, 0x10a2, 0x1082, 0x0020, 0x18e3, 0x1082, 0x18e3, 0xb596, 0xf75c, 0xe6fb, 0xe73d, 0xdf1c, 0xf77d, 0xd636, 0x6a45, 0x69c2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x5100, 0x48e0, 0x4122, 0xff9d, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0x9c70, 0x40c0, 0x5941, 0x8264, 0x8a84, 0x8243, 0x8284, 0x8284, 0x7a64, 0x7a44, 0x8263, 0x8a63, 0x8a62, 0x8263, 0x6a23, 0x8308, 0xd5d4, 0xdefc, 0xdedc, 0xe73c, 0xd6da, 0xf7bd, 0xd6ba, 0x4208, 0x0000, 0x10a2, 0x0861, 0x10a2, 0x0841, 0x0861, 0x10a2, 0x0841, 0x18c3, 0xc637, 0xe73c, 0xe75d, 0xdf3d, 0xdefc, 0xf75c, 0xde56, 0x6a66, 0x71e2, 0x7203, 0x7a23, 0x7a44, 0x7a44, 0x7a44, 0x7a23, 0x7203, 0x61a2, 0x5960, 0x69a1, 0x71e2, 0x61a2, 0x93ac, 0xde99, 0xdefb, 0xe71c, 0xe73c, 0xdefb, 0xf7be, 0xb596, 0x2104, 0x0020, 0x18e3, 0x18c3, 0x0841, 0x0861, 0x18e3, 0x18c3, 0x0020, 0x4a49, 0xe73c, 0xef3c, 0xe71b, 0xe73c, 0xdefb, 0xf77c, 0xbd32, 0x61c3, 0x69c2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x5100, 0x48e0, 0x4122, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0x942f, 0x40a0, 0x5961, 0x8285, 0x8a84, 0x8222, 0x8284, 0x8284, 0x7a63, 0x7a43, 0x8264, 0x8263, 0x8242, 0x8263, 0x7223, 0x7285, 0xb4af, 0xe71c, 0xdeba, 0xef3c, 0xe71b, 0xe73c, 0xf79d, 0x94b2, 0x0861, 0x18c3, 0x18e3, 0x18e3, 0x10a2, 0x2124, 0x0861, 0x0020, 0x630c, 0xef7c, 0xe73c, 0xe77d, 0xdf1c, 0xe73c, 0xf75b, 0xbcf0, 0x6204, 0x7a44, 0x7a64, 0x8264, 0x7a44, 0x7a23, 0x69e2, 0x6181, 0x6160, 0x61a1, 0x69c1, 0x7a22, 0x8aa4, 0x7a44, 0x8b29, 0xcdf5, 0xe71b, 0xdefb, 0xe73c, 0xe73c, 0xe73c, 0xdefb, 0x738e, 0x0000, 0x18c3, 0x18e3, 0x1082, 0x18e3, 0x2104, 0x0000, 0x18c3, 0x9cd3, 0xf7be, 0xef5c, 0xe71c, 0xe73c, 0xef3c, 0xeefa, 0x93ab, 0x61c2, 0x7203, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7202, 0x7203, 0x4900, 0x4900, 0x51a4, 0xff7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0x9c70, 0x40c0, 0x5961, 0x8285, 0x8a84, 0x8222, 0x8283, 0x8264, 0x7a43, 0x7a43, 0x8284, 0x8263, 0x7a22, 0x8264, 0x7a64, 0x7244, 0x9369, 0xde99, 0xe6fa, 0xe6fb, 0xef3c, 0xe6fc, 0xf79e, 0xdf1b, 0x634c, 0x0020, 0x0841, 0x2104, 0x10a2, 0x0841, 0x0841, 0x4228, 0xd69a, 0xef5c, 0xe73c, 0xe73d, 0xd6fb, 0xffbe, 0xeef9, 0x938a, 0x7244, 0x8264, 0x7a23, 0x71e2, 0x69a1, 0x6180, 0x69a1, 0x69c1, 0x7202, 0x7a64, 0x8ac5, 0x8a84, 0x92c4, 0x8264, 0x7285, 0xb4d0, 0xef1a, 0xe71c, 0xe71c, 0xe73c, 0xe71c, 0xf7be, 0xbdf7, 0x31a6, 0x0000, 0x10a2, 0x18e3, 0x18c3, 0x0020, 0x0020, 0x6b6d, 0xe73c, 0xe71c, 0xe73d, 0xe71c, 0xef3c, 0xff9d, 0xde15, 0x6a45, 0x69e3, 0x7203, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7222, 0x7203, 0x4900, 0x40e1, 0x6a88, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xb533, 0x40c0, 0x5941, 0x8264, 0x8a84, 0x8242, 0x8283, 0x8263, 0x7a43, 0x8263, 0x8263, 0x8264, 0x7a22, 0x8264, 0x8284, 0x7223, 0x7a64, 0xbd94, 0xf75b, 0xe6da, 0xe71c, 0xef3d, 0xe71c, 0xf79e, 0xc679, 0x528a, 0x0861, 0x0020, 0x0000, 0x0000, 0x4a49, 0xad75, 0xef7d, 0xe6fb, 0xe73c, 0xdf1c, 0xe73c, 0xffbd, 0xcd93, 0x7245, 0x69e2, 0x69a1, 0x61a0, 0x6180, 0x69a1, 0x69e1, 0x7a23, 0x8284, 0x8ac5, 0x8284, 0x92e5, 0x92a3, 0x8a83, 0x8a83, 0x7244, 0x93cb, 0xde56, 0xe73c, 0xe71c, 0xdefb, 0xef5d, 0xef5d, 0xe71c, 0xad75, 0x4228, 0x0020, 0x0020, 0x0000, 0x18c3, 0x6b4d, 0xce59, 0xf7be, 0xdefb, 0xdf1c, 0xe71c, 0xef5c, 0xff3b, 0xb4b0, 0x61a2, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7222, 0x69e2, 0x48e0, 0x40c0, 0x93cd, 0xffbd, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xd637, 0x40c0, 0x5120, 0x7a44, 0x8a84, 0x8243, 0x8263, 0x7a43, 0x7a43, 0x8243, 0x7a43, 0x8263, 0x7a43, 0x7a63, 0x8264, 0x7202, 0x7a43, 0x8c0d, 0xe698, 0xeefb, 0xe6fc, 0xef3d, 0xdedc, 0xe73c, 0xe77c, 0xef7d, 0x9492, 0x5aeb, 0x632c, 0x8430, 0xd69a, 0xffff, 0xe73c, 0xe71b, 0xef5d, 0xe75d, 0xf79e, 0xde98, 0x836a, 0x5161, 0x6180, 0x69a1, 0x69e1, 0x7202, 0x7a43, 0x8284, 0x8284, 0x82a4, 0x8aa4, 0x7a64, 0x8283, 0x92a3, 0x9262, 0x92a3, 0x82a4, 0x82e7, 0xb4af, 0xe71c, 0xe73c, 0xe71c, 0xef5d, 0xe71c, 0xef5d, 0xf79e, 0xbdf7, 0x8410, 0x632c, 0x6b4d, 0x9cf3, 0xe71c, 0xf79e, 0xe71c, 0xef5d, 0xdf1d, 0xe73d, 0xef3b, 0xcdd5, 0x7ae8, 0x61c2, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7223, 0x69e2, 0x48e0, 0x38c0, 0xbd12, 0xffde, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xe6d9, 0x40c0, 0x5100, 0x7a23, 0x8a84, 0x8263, 0x8263, 0x7a43, 0x7a63, 0x8243, 0x7a22, 0x8264, 0x7a43, 0x7a23, 0x7a43, 0x7a22, 0x8242, 0x5a66, 0xb512, 0xeefa, 0xe6fc, 0xe6fc, 0xef3d, 0xdf1c, 0xdf3b, 0xe73c, 0xf79e, 0xef5d, 0xef5d, 0xf79e, 0xef5d, 0xe73c, 0xe71c, 0xe71b, 0xe71b, 0xdf1b, 0xef7d, 0xad13, 0x51c4, 0x61a1, 0x8243, 0x8263, 0x8264, 0x8284, 0x8284, 0x82a4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8ac5, 0x8a84, 0x9ae4, 0x9282, 0x92a3, 0x8ac5, 0x7244, 0x8328, 0xce79, 0xdefb, 0xef5d, 0xe71c, 0xef5d, 0xe73c, 0xe71c, 0xffdf, 0xffdf, 0xdefb, 0xef7d, 0xf7be, 0xef7d, 0xe73c, 0xdedb, 0xe73c, 0xdf3e, 0xe75d, 0xef1b, 0xa44e, 0x5162, 0x7203, 0x71c1, 0x7a02, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7223, 0x69c2, 0x48e0, 0x38a0, 0xd5d5, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffbf, 0x6a87, 0x38e0, 0x7223, 0x8a84, 0x8263, 0x8a63, 0x8a63, 0x8243, 0x7a63, 0x7a63, 0x7a63, 0x7a43, 0x7a43, 0x7a42, 0x7222, 0x7222, 0x79e0, 0x9307, 0xcd94, 0xf77d, 0xe77e, 0xd6fd, 0xe73d, 0xf75c, 0xe73d, 0xdf1c, 0xdefc, 0xe73c, 0xe73c, 0xe6fb, 0xe71b, 0xef3c, 0xdf1e, 0xe6fd, 0xf73c, 0xddf5, 0x8b48, 0x6a02, 0x7a83, 0x82a3, 0x8a84, 0x8a84, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8ac4, 0x8aa4, 0x8aa4, 0x8a84, 0x8264, 0x8263, 0x8243, 0x8243, 0xa40c, 0xde36, 0xff5c, 0xe71b, 0xd6db, 0xef5d, 0xef5d, 0xe6fb, 0xef5c, 0xe73c, 0xe71c, 0xe73c, 0xe75d, 0xe75d, 0xdf3d, 0xdf3d, 0xe77e, 0xf77d, 0xb4d0, 0x69e3, 0x69c1, 0x7a03, 0x69c2, 0x69e3, 0x7202, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x71e2, 0x7203, 0x7a23, 0x79e2, 0x6140, 0x40a0, 0x4101, 0xf71b, 0xffff, 0xffff, 0xf7ff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xa44e, 0x38a0, 0x48e0, 0x7a23, 0x8264, 0x8243, 0x8243, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a63, 0x8264, 0x8264, 0x8264, 0x8243, 0x7203, 0x938b, 0xd637, 0xef7d, 0xef5d, 0xe71c, 0xe6fb, 0xdf1c, 0xe71d, 0xe75d, 0xef7d, 0xef5d, 0xe71c, 0xe71b, 0xe73c, 0xf77e, 0xf75d, 0xd5f5, 0x9bab, 0x7a85, 0x82a4, 0x8ac4, 0x8263, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8a84, 0x8a84, 0x8263, 0x8243, 0x8243, 0x8243, 0x7245, 0xa42d, 0xe678, 0xff9d, 0xef5d, 0xe71c, 0xe71c, 0xef5d, 0xd6db, 0xdf1c, 0xe75d, 0xe73c, 0xdefb, 0xdefb, 0xe75c, 0xef9d, 0xf77d, 0xbd53, 0x7286, 0x6181, 0x7202, 0x7a03, 0x69c2, 0x61e3, 0x69e2, 0x69e2, 0x69e2, 0x7203, 0x7223, 0x7203, 0x7203, 0x7223, 0x7a23, 0x50e0, 0x40c0, 0x7288, 0xffbd, 0xffff, 0xf7df, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xd5f4, 0x4982, 0x40e0, 0x7223, 0x8284, 0x8284, 0x82a4, 0x8264, 0x7a44, 0x7a44, 0x7a44, 0x7a44, 0x7a44, 0x7a44, 0x7a44, 0x7a44, 0x8264, 0x69e3, 0x6a04, 0x834a, 0xbd32, 0xeeda, 0xf75c, 0xe71b, 0xe75d, 0xe75d, 0xe73d, 0xdefc, 0xdefb, 0xe71c, 0xe73c, 0xef3c, 0xf71a, 0xd5f4, 0x9bcb, 0x7244, 0x8264, 0x92c5, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8284, 0x8264, 0x8263, 0x8243, 0x7a43, 0x7a43, 0x7203, 0x7a65, 0xa42d, 0xde57, 0xf75c, 0xf77d, 0xe71c, 0xdedb, 0xe75d, 0xe75d, 0xdf1c, 0xdefb, 0xe71b, 0xf77c, 0xf75c, 0xe6fa, 0xb4f1, 0x72a7, 0x5981, 0x71e2, 0x7a02, 0x71e2, 0x69e3, 0x6a04, 0x69e2, 0x69e2, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7223, 0x69c2, 0x40c0, 0x5162, 0xa44e, 0xffde, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xeefa, 0xb513, 0x8b8b, 0x4100, 0x40e0, 0x5940, 0x6180, 0x69a1, 0x69e2, 0x61a1, 0x6181, 0x6181, 0x6181, 0x6161, 0x6161, 0x6161, 0x6161, 0x6161, 0x5981, 0x61c2, 0x6181, 0x5981, 0x82e7, 0xbd11, 0xeed9, 0xff9d, 0xe71b, 0xe73c, 0xe71b, 0xe71b, 0xef5c, 0xf77c, 0xef3b, 0xe6da, 0xc50f, 0x8b68, 0x7a64, 0x8aa4, 0x92a4, 0x9283, 0x92a4, 0x92c5, 0x92c5, 0x92c5, 0x92c4, 0x92c4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8284, 0x8283, 0x8264, 0x8263, 0x8243, 0x7a43, 0x7a23, 0x7a23, 0x8264, 0x7203, 0x7224, 0x938b, 0xc574, 0xef1b, 0xffbe, 0xf79d, 0xdf3c, 0xe73d, 0xe73c, 0xf75c, 0xffbd, 0xff7b, 0xd5f5, 0xa46f, 0x6a03, 0x6181, 0x71e2, 0x7a22, 0x71a1, 0x69c1, 0x7223, 0x69e3, 0x71e2, 0x7203, 0x7203, 0x71e2, 0x69e2, 0x7203, 0x7223, 0x7223, 0x61a2, 0x3880, 0x3080, 0x836a, 0xde37, 0xfffe, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xcdd5, 0x836b, 0x51c4, 0x3901, 0x4100, 0x4100, 0x5981, 0x6160, 0x69c1, 0x69c1, 0x69c2, 0x61a1, 0x71c2, 0x71c2, 0x71e2, 0x71e2, 0x7203, 0x7a03, 0x7a03, 0x7a23, 0x7a65, 0x7a64, 0x8243, 0x8243, 0x8263, 0x7a85, 0x8b8a, 0xb511, 0xde78, 0xe6d9, 0xf73a, 0xf71a, 0xeed9, 0xd636, 0xb511, 0x942e, 0x8ae5, 0x7a63, 0x8a83, 0x9ae4, 0x9aa3, 0x92a4, 0x92c5, 0x9284, 0x92c5, 0x92c5, 0x92c4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8a84, 0x8263, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x71e2, 0x7a23, 0x7203, 0x69e3, 0x7286, 0x9c0d, 0xbd73, 0xd637, 0xe6fa, 0xef3b, 0xf73b, 0xde77, 0xc573, 0xa44e, 0x72c7, 0x5182, 0x69c1, 0x71e2, 0x7a02, 0x69a0, 0x6160, 0x71e2, 0x7223, 0x61a2, 0x71e2, 0x7223, 0x7203, 0x69e2, 0x7202, 0x7a43, 0x7223, 0x69c2, 0x48e0, 0x5140, 0x4100, 0x4121, 0x30c0, 0x6287, 0xacd1, 0xf75b, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9d, 0xde78, 0x838c, 0x38e1, 0x30a0, 0x4100, 0x4900, 0x61c2, 0x7a64, 0x8ac5, 0x8a84, 0x9b05, 0x8aa4, 0x8284, 0x8ac6, 0x8284, 0x8284, 0x8284, 0x8a84, 0x8a84, 0x8a84, 0x8a84, 0x8a84, 0x7a84, 0x82a4, 0x8aa3, 0x92a3, 0x92a3, 0x7a43, 0x7264, 0x82e7, 0x8308, 0x8b69, 0x9bcb, 0x9bcb, 0x9baa, 0x8b48, 0x7ac6, 0x7264, 0x8284, 0x92e5, 0x9ae4, 0x9ac3, 0x9ac3, 0x92c3, 0x8aa3, 0x8ac4, 0x92c5, 0x92c4, 0x8aa4, 0x8aa4, 0x8a84, 0x8a84, 0x8a83, 0x8263, 0x7a63, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x71e2, 0x7a43, 0x7a23, 0x69c1, 0x61a2, 0x59a3, 0x6205, 0x6aa8, 0x8329, 0x8b6a, 0x8b4a, 0x72a7, 0x6224, 0x61e3, 0x61e3, 0x61e3, 0x7a03, 0x7202, 0x69c1, 0x69a1, 0x71e2, 0x7202, 0x71e2, 0x71e2, 0x69e2, 0x7203, 0x7203, 0x7203, 0x7a44, 0x7a64, 0x69e2, 0x5940, 0x5120, 0x5940, 0x4900, 0x5141, 0x30a0, 0x38c0, 0x3900, 0x51c4, 0xa4b2, 0xe699, 0xffff, 0xffff, 0xffbe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xb4d2, 0x5a06, 0x38e0, 0x38a0, 0x5981, 0x8263, 0x92e5, 0x8ac5, 0x92e5, 0x92c4, 0x9283, 0x9ae4, 0x8a63, 0x8a84, 0x92c5, 0x92c4, 0x92c4, 0x92c4, 0x8aa4, 0x8aa4, 0x8a83, 0x8a83, 0x8a83, 0x8283, 0x92c4, 0x92a3, 0x8a42, 0x8a83, 0x92e4, 0x8ac4, 0x8263, 0x8ac5, 0x8ac5, 0x8ac5, 0x8ac4, 0x8aa4, 0x8aa4, 0x92c4, 0x9b05, 0x92e6, 0x9b06, 0x92c4, 0x92a3, 0x9b04, 0x92a3, 0x8282, 0x9304, 0x8aa4, 0x8aa4, 0x8aa4, 0x8a84, 0x8a83, 0x8263, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7a44, 0x7203, 0x71c1, 0x79e1, 0x7a22, 0x7203, 0x69e3, 0x61c3, 0x69c2, 0x69e2, 0x69e2, 0x69c2, 0x61c2, 0x69e2, 0x6a02, 0x6a03, 0x69c2, 0x69c2, 0x69e3, 0x7223, 0x7223, 0x71e2, 0x71e2, 0x7a02, 0x7202, 0x7202, 0x7203, 0x7a43, 0x7a43, 0x7202, 0x61a1, 0x5960, 0x8264, 0x7a43, 0x7223, 0x7223, 0x5981, 0x4900, 0x4900, 0x5120, 0x30a0, 0x7ac9, 0xcdb5, 0xff9d, 0xfffe, 0xffff, 0xffdf, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x836c, 0x4143, 0x3080, 0x4920, 0x69e3, 0x92e5, 0x9b05, 0x92c3, 0x9ae5, 0x9ae4, 0x9ac4, 0x9a83, 0x9aa3, 0x8a62, 0x92c4, 0x92c5, 0x8aa3, 0x8aa3, 0x8aa3, 0x8aa3, 0x8aa3, 0x8aa3, 0x8ac4, 0x8ac4, 0x92c4, 0x8a83, 0x8a83, 0x92c4, 0x92c4, 0x8a83, 0x92a3, 0x9b05, 0x92a3, 0x9282, 0x92a3, 0xa2e4, 0xa2e4, 0x9ac3, 0x9aa2, 0x9ac3, 0x92c6, 0x92c5, 0x92a4, 0x92a3, 0x92c3, 0x92e3, 0x8ac3, 0x82e3, 0x8aa4, 0x8aa4, 0x8a84, 0x8a84, 0x8263, 0x8263, 0x8243, 0x8243, 0x7a43, 0x7a43, 0x7a43, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x61e3, 0x69e3, 0x7a02, 0x79e1, 0x79c0, 0x79e1, 0x7a23, 0x7203, 0x79e1, 0x71c1, 0x71c1, 0x71e1, 0x71e1, 0x71e2, 0x69e2, 0x7203, 0x6a03, 0x69e3, 0x6a04, 0x6a03, 0x69c2, 0x71e2, 0x7a02, 0x71c1, 0x7203, 0x7203, 0x7a23, 0x7a44, 0x69e2, 0x5960, 0x6180, 0x71e2, 0x8263, 0x7a23, 0x8263, 0x8263, 0x8264, 0x7a23, 0x69c1, 0x5120, 0x5121, 0x3880, 0x5183, 0xac90, 0xf75c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xff5c, 0x82eb, 0x40e0, 0x48e0, 0x5980, 0x7a63, 0x9305, 0x92e4, 0x92c4, 0x9ac4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92e4, 0x92e4, 0x92e4, 0x9345, 0x92e4, 0x92c4, 0x92e4, 0x92a3, 0x92a2, 0x92c2, 0x92e3, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x8a63, 0x8a62, 0x8a42, 0x8242, 0x8222, 0x8221, 0x8221, 0x8221, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a02, 0x7202, 0x7202, 0x71c1, 0x71e1, 0x71e2, 0x7202, 0x7202, 0x7202, 0x69e2, 0x69c2, 0x69c1, 0x61a0, 0x69c1, 0x61a0, 0x7243, 0x61e2, 0x6a02, 0x6a03, 0x69e2, 0x69e2, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7223, 0x7223, 0x61a1, 0x5940, 0x69c1, 0x82a5, 0x8283, 0x8263, 0x8263, 0x7a63, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x6142, 0x50e0, 0x5101, 0x40c0, 0x834b, 0xff9d, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xefbe, 0xffff, 0xef3c, 0x9c0f, 0x4903, 0x4900, 0x5981, 0x7a63, 0x9305, 0x9b05, 0x92e4, 0x92c4, 0x9ac3, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x82c5, 0x9367, 0x9ba9, 0x9348, 0x9307, 0x9327, 0x8b06, 0x8ae5, 0x8ac5, 0x8ac5, 0x82a5, 0x8284, 0x8284, 0x7a64, 0x7a63, 0x7a43, 0x8284, 0x8284, 0x7a64, 0x7a63, 0x7a43, 0x7a43, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x69e2, 0x61c2, 0x61c2, 0x61a2, 0x61c2, 0x61e3, 0x61e3, 0x6204, 0x6a65, 0x7265, 0x7265, 0x6a03, 0x6a03, 0x61c2, 0x6a02, 0x7223, 0x69e2, 0x71e2, 0x7203, 0x7203, 0x7202, 0x69e2, 0x71e2, 0x7202, 0x7243, 0x7a64, 0x7223, 0x5980, 0x5980, 0x7223, 0x8284, 0x7a43, 0x8263, 0x8263, 0x8263, 0x7a63, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a24, 0x69a2, 0x5100, 0x40c0, 0x4122, 0x8bee, 0xef3c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xbd54, 0x59e5, 0x40c1, 0x61a0, 0x7a64, 0x9326, 0x9b26, 0x9305, 0x92e4, 0x9ae4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92c4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x93eb, 0xb4cf, 0xbd11, 0xb4b1, 0xb4d1, 0xb4f1, 0xacaf, 0xa46e, 0xa40c, 0x9c0c, 0x9bcb, 0x93ab, 0x8b6a, 0x8329, 0x8308, 0x7ae8, 0x72a7, 0x7286, 0x6a86, 0x6a66, 0x6a45, 0x6245, 0x6225, 0x6225, 0x6225, 0x6225, 0x6225, 0x6a25, 0x6a25, 0x6a45, 0x6a45, 0x6a45, 0x6a87, 0x6aa7, 0x72c8, 0x7b09, 0x838b, 0x940d, 0xa46f, 0xacb0, 0xacd1, 0xacd1, 0xa46f, 0x93ab, 0x6a25, 0x61c2, 0x69c2, 0x7203, 0x7202, 0x7203, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x7203, 0x7a23, 0x7a64, 0x7202, 0x6180, 0x6180, 0x7202, 0x8284, 0x82a5, 0x7a64, 0x8263, 0x8263, 0x7a63, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x8264, 0x7223, 0x69a2, 0x5140, 0x3080, 0x4162, 0xacf2, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffde, 0xffff, 0xf7be, 0xffff, 0xdeb9, 0x6267, 0x40e0, 0x5141, 0x8284, 0x9305, 0x9b26, 0x92e5, 0x92c4, 0x92e4, 0x9b05, 0x9ae4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0xa4b0, 0xbd53, 0xb555, 0xad55, 0xbdd8, 0xbdf8, 0xb5b6, 0xbdb5, 0xc5b4, 0xc5b4, 0xbd94, 0xbd74, 0xbd73, 0xb553, 0xb533, 0xb533, 0xad12, 0xad12, 0xacf1, 0xa4d1, 0xa4d1, 0xa4d1, 0xa4d1, 0xa4d1, 0xacd1, 0xacd1, 0xacd1, 0xacf1, 0xb4f2, 0xb512, 0xb512, 0xb512, 0xbd94, 0xbdb5, 0xc5d5, 0xc5d6, 0xc5d6, 0xc5d6, 0xbdd6, 0xbdd6, 0xb5b7, 0xb596, 0xbd75, 0xb4d1, 0x6a66, 0x61c3, 0x71e3, 0x71e3, 0x7223, 0x7223, 0x7203, 0x7203, 0x7223, 0x7a23, 0x7a44, 0x7a44, 0x69e2, 0x5960, 0x5940, 0x7222, 0x82a5, 0x8284, 0x7a63, 0x8284, 0x7a63, 0x7a63, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7a43, 0x7a63, 0x61a1, 0x5160, 0x3900, 0x5a25, 0xe6d8, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffde, 0xfffe, 0x83ac, 0x3080, 0x40c0, 0x7223, 0x9305, 0x9305, 0x92e5, 0x92c4, 0x92c4, 0x92e4, 0x9ae5, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x9c2e, 0xb513, 0xb576, 0xa557, 0xad98, 0xb5d9, 0xb5f8, 0xbe18, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdd6, 0xbdd6, 0xbdf7, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xc5f6, 0xc5f6, 0xc5f7, 0xce17, 0xce37, 0xce38, 0xce58, 0xd658, 0xc617, 0xc638, 0xc638, 0xc658, 0xc638, 0xbe18, 0xb5d7, 0xadb7, 0xa597, 0xa556, 0xb596, 0xb533, 0x6a67, 0x61c3, 0x71e3, 0x71e2, 0x7223, 0x7203, 0x7203, 0x7223, 0x7a44, 0x7a44, 0x7203, 0x69c2, 0x6160, 0x69c1, 0x7222, 0x8263, 0x8284, 0x8284, 0x8263, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7222, 0x7222, 0x7a43, 0x69c1, 0x69e2, 0x4100, 0x30a0, 0x8bcc, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 
0xffff, 0xf7be, 0xffff, 0xeeb9, 0x51a4, 0x4100, 0x61a0, 0x9b26, 0x92e4, 0x92c4, 0x92c4, 0x92c4, 0x92e4, 0x92c4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92c4, 0x9369, 0xb4f0, 0xce17, 0xbdf9, 0xb5d9, 0xbe3a, 0xc69a, 0xc679, 0xce7a, 0xce7a, 0xce79, 0xce59, 0xc659, 0xc639, 0xc638, 0xc638, 0xc618, 0xc618, 0xc618, 0xc618, 0xc618, 0xc638, 0xc639, 0xc639, 0xc638, 0xc638, 0xce59, 0xce59, 0xce59, 0xce79, 0xce79, 0xce79, 0xce79, 0xce79, 0xce79, 0xce79, 0xc659, 0xbe39, 0xbe18, 0xb618, 0xbe19, 0xbdf8, 0xc5d6, 0xacd1, 0x7287, 0x69e3, 0x7202, 0x71c1, 0x71e2, 0x7203, 0x7223, 0x7a43, 0x7a43, 0x7203, 0x61a1, 0x5940, 0x71e1, 0x8284, 0x8ac5, 0x8aa4, 0x8263, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7223, 0x7223, 0x69c1, 0x7a22, 0x69e2, 0x5120, 0x4900, 0x5162, 0xe6fb, 0xffff, 0xffde, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffde, 0x9c0f, 0x38c0, 0x5140, 0x7a42, 0x9324, 0x92c4, 0x92c3, 0x92c4, 0x9ae4, 0x9ae5, 0x92e4, 0x92e4, 0x92e5, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x8ac5, 0x9baa, 0xc573, 0xd659, 0xc65a, 0xce9b, 0xdefa, 0xdeb9, 0xd6ba, 0xd6ba, 0xd6ba, 0xd69a, 0xd69a, 0xd69a, 0xd69a, 0xd69a, 0xce7a, 0xce79, 0xce79, 0xce79, 0xce79, 0xce7a, 0xd69a, 0xd69a, 0xce9a, 0xce9a, 0xce9a, 0xce9a, 0xd6ba, 0xd6bb, 0xd6bb, 0xd6bb, 0xdeba, 0xdeba, 0xd6ba, 0xd6ba, 0xd6ba, 0xce9a, 0xce9a, 0xce9a, 0xbdf7, 0xc617, 0xb553, 0x838b, 0x6a45, 0x69e2, 0x7a22, 0x7a01, 0x7203, 0x7223, 0x7a43, 0x7223, 0x69e2, 0x61a1, 0x69a1, 0x69c2, 0x8a84, 0x8aa4, 0x8aa5, 0x8aa4, 0x8264, 0x7a43, 0x7a43, 0x8263, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x71e3, 0x6a03, 0x6a02, 0x71e2, 0x7a23, 0x71e3, 0x69a2, 0x5962, 0x40c0, 0x9cd2, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7df, 0xffff, 0xf73c, 0x5a07, 0x40e0, 0x5960, 0x9304, 0x92e3, 0x9ae4, 0x9ac4, 0x92c4, 0x9ae4, 0x9ae5, 0x9305, 0x9305, 0x9305, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92a2, 0x7a63, 0xa40c, 0xd678, 0xdefb, 0xdeda, 0xe6fa, 0xe6f9, 0xe6fb, 0xdefb, 0xdedb, 0xdedb, 0xdebb, 0xdeba, 0xd6ba, 0xd69a, 0xdedb, 0xdedb, 0xdeba, 0xdeba, 0xd6ba, 0xdeba, 0xdebb, 0xdebb, 0xdefc, 0xdefc, 0xdefc, 0xdefc, 0xdefc, 0xdefc, 0xdefc, 0xdefc, 0xe71b, 0xe71b, 0xe71b, 0xe71b, 0xdefb, 0xd6da, 0xd69a, 0xce79, 0xc637, 0xd698, 0xb552, 0x6a86, 0x6203, 0x69e1, 0x7a21, 0x7a21, 0x7a43, 0x7a64, 0x7a44, 0x69e2, 0x6160, 0x6181, 0x7223, 0x8ac6, 0x8ac4, 0x8a84, 0x8263, 0x8263, 0x8283, 0x8263, 0x8243, 0x7a42, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x71e3, 0x71e3, 0x6a03, 0x69e3, 0x7a44, 0x6981, 0x71c3, 0x7a04, 0x48c0, 0x48c0, 0x5aaa, 0xffbe, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xde36, 0x30a0, 0x48e0, 0x7a43, 0x92e5, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92e4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x9ae5, 0x92e4, 0x92e4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x8aa4, 0x9ac4, 0x7a02, 0x7224, 0xa3ec, 0xd636, 0xef5c, 0xe75d, 0xd6fc, 0xe73d, 0xdf1c, 0xdf1b, 0xe73b, 0xef1b, 0xe6fa, 0xeed9, 0xeef9, 0xdeda, 0xdeda, 0xdeba, 0xdedb, 0xdefb, 0xdf1c, 0xdefc, 0xdefb, 0xe6fa, 0xe6fb, 0xe6fb, 0xe6fb, 0xdedb, 0xdefb, 0xdefb, 0xe71c, 0xdf1b, 0xe75c, 0xe75d, 0xe73c, 0xdf1c, 0xdf1d, 0xdefd, 0xdedd, 0xf6f9, 0xb4f1, 0x72c8, 0x61e3, 0x69c2, 0x71e1, 0x7a01, 0x8221, 0x8264, 0x71c2, 0x5940, 0x6180, 0x7a22, 0x8aa4, 0x8aa3, 0x8282, 0x8a84, 0x8284, 0x8263, 0x8243, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x69e1, 0x7202, 0x71e2, 0x7203, 0x71e2, 0x69e2, 0x69c2, 0x48e0, 0x40e1, 0xef3a, 0xfffe, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xc594, 0x38c0, 0x5100, 0x7a43, 0x92e5, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92e4, 0x92e4, 0x92e4, 0x92c4, 0x92c4, 0x8ac4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8222, 0x8264, 0x7a44, 0x6a25, 0x8b8b, 0xd616, 0xf77d, 0xf79d, 0xe73c, 0xdf1c, 0xdf1b, 0xe73c, 0xe73c, 0xe71b, 0xe6fb, 0xe6fa, 0xe73c, 0xe71c, 0xe71c, 0xe71c, 0xe71c, 0xdf1c, 0xdefc, 0xd6db, 0xe6fb, 0xe71b, 0xe71c, 0xe73c, 0xe73c, 0xe73c, 0xe73d, 0xe73d, 0xdf1c, 0xe75d, 0xe75d, 0xe73c, 0xe6fc, 0xe6fb, 0xe6db, 0xdeba, 0xac8f, 0x8329, 0x59e4, 0x61e3, 0x7a64, 0x8284, 0x7a42, 0x71e1, 0x6160, 0x6181, 0x71c1, 0x7a43, 0x8aa4, 0x8ac4, 0x8ac4, 0x8aa3, 0x8284, 0x8283, 0x8263, 0x8243, 0x7a23, 0x7a23, 0x7a23, 0x7a03, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x69e2, 0x7202, 0x71e2, 0x7203, 0x71e2, 0x69e2, 0x69c2, 0x50e0, 0x38a0, 0xde97, 0xfffe, 0xffff, 0xffff, 
0xf7df, 0xffff, 0xa46f, 0x4100, 0x5940, 0x8284, 0x92e5, 0x8ac4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x8ac4, 0x8ac3, 0x8aa3, 0x8aa3, 0x8a83, 0x8283, 0x8283, 0x8263, 0x71e2, 0x8264, 0x8264, 0x6a04, 0x61e3, 0x7b09, 0xbd11, 0xf6d9, 0xf79d, 0xef5c, 0xe6fb, 0xdedb, 0xdefc, 0xe75d, 0xe77e, 0xe75e, 0xe71c, 0xe71c, 0xe71c, 0xdf1c, 0xe73d, 0xdf3d, 0xdf1d, 0xdf1c, 0xe75d, 0xe73d, 0xe71c, 0xe71c, 0xe71c, 0xe73c, 0xe73d, 0xe75d, 0xf7df, 0xe73d, 0xd6bb, 0xe71b, 0xffbd, 0xff7b, 0xd5f5, 0xa46e, 0x7245, 0x6a04, 0x6a04, 0x7a64, 0x7a65, 0x7203, 0x61a1, 0x6180, 0x6981, 0x7202, 0x8284, 0x8ac5, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8283, 0x8263, 0x8263, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7a03, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x69e2, 0x7202, 0x69e2, 0x7203, 0x71e2, 0x7203, 0x71e3, 0x5100, 0x38a0, 0xc5d5, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0x730a, 0x40e0, 0x6181, 0x8aa4, 0x92c5, 0x8aa4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x92c4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa3, 0x8aa3, 0x8283, 0x8283, 0x8263, 0x8243, 0x7a43, 0x7a43, 0x8264, 0x71e2, 0x7203, 0x7a64, 0x7203, 0x61a2, 0x7245, 0xa3aa, 0xde78, 0xe6fa, 0xf75c, 0xef7d, 0xe77d, 0xe75e, 0xd73d, 0xcefc, 0xe73c, 0xe71c, 0xe73c, 0xe73c, 0xe73d, 0xdf3d, 0xdf5d, 0xdf5d, 0xe73d, 0xe73d, 0xe73d, 0xe73d, 0xe73d, 0xe73c, 0xe71c, 0xdefb, 0xdefd, 0xe73d, 0xf77d, 0xff5c, 0xee97, 0xbd10, 0x8328, 0x59e1, 0x7203, 0x7a23, 0x7a44, 0x7223, 0x61c2, 0x5960, 0x5981, 0x69e2, 0x8284, 0x8aa4, 0x8ac5, 0x8aa4, 0x8284, 0x8283, 0x8283, 0x8283, 0x8263, 0x7a63, 0x7a43, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x69e2, 0x7202, 0x69e2, 0x7203, 0x7203, 0x7203, 0x7203, 0x5920, 0x40c0, 0xb573, 0xffff, 0xffdf, 0xffdf, 
0xffff, 0xffde, 0x5a27, 0x38c0, 0x61c2, 0x8ac5, 0x92c4, 0x8aa3, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8a84, 0x8283, 0x8263, 0x8263, 0x8263, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7203, 0x7203, 0x7202, 0x71e2, 0x69c1, 0x69a1, 0x6a87, 0xa44e, 0xde77, 0xf75c, 0xef5c, 0xe73d, 0xdf5d, 0xdf7e, 0xe71c, 0xe71c, 0xe71c, 0xe71c, 0xe73c, 0xe73d, 0xe75d, 0xe75d, 0xe75d, 0xe73d, 0xdf1c, 0xdefb, 0xe71c, 0xef3c, 0xef5c, 0xf75c, 0xf75d, 0xf75d, 0xeeda, 0xc552, 0x8b6a, 0x6a23, 0x69e1, 0x7242, 0x8243, 0x71e2, 0x6180, 0x6160, 0x61a1, 0x69e2, 0x7264, 0x82a5, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8284, 0x8264, 0x7a63, 0x7a43, 0x7a43, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x7202, 0x69e2, 0x7203, 0x7203, 0x7203, 0x7203, 0x5940, 0x40a0, 0xb573, 0xffff, 0xffdf, 0xffdf, 
0xffff, 0xffbe, 0x5a47, 0x38a0, 0x69e2, 0x8aa4, 0x8aa4, 0x8a83, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x82a3, 0x8284, 0x8284, 0x8284, 0x8284, 0x8284, 0x8284, 0x8263, 0x8263, 0x7a63, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x71e2, 0x7a23, 0x7a44, 0x7203, 0x71c2, 0x71e2, 0x7a02, 0x7202, 0x59c2, 0x59c3, 0x6a66, 0x8bab, 0xc593, 0xeef9, 0xf75c, 0xef5b, 0xef3c, 0xef3c, 0xef5c, 0xef3c, 0xef3c, 0xe71c, 0xe71c, 0xe73c, 0xe75d, 0xe73c, 0xe71c, 0xef1b, 0xef3b, 0xf73b, 0xf73b, 0xef1a, 0xeed8, 0xc552, 0x8b8b, 0x6a65, 0x6a23, 0x7223, 0x7222, 0x7a42, 0x6960, 0x6160, 0x6180, 0x71e2, 0x7a43, 0x82a5, 0x8ac5, 0x8ac5, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8284, 0x8284, 0x8264, 0x8264, 0x7a43, 0x7a43, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x7202, 0x71e2, 0x7203, 0x7203, 0x7203, 0x7203, 0x5920, 0x3880, 0xc5d4, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffde, 0x7b4b, 0x38c0, 0x69c2, 0x8284, 0x8aa4, 0x8262, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8283, 0x8284, 0x8284, 0x8263, 0x8263, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7a44, 0x71e2, 0x69c2, 0x71e2, 0x7223, 0x7203, 0x7203, 0x7203, 0x6a02, 0x69e2, 0x69e3, 0x61e3, 0x6204, 0x7ae8, 0xac6e, 0xd5b3, 0xe698, 0xe6d9, 0xef1b, 0xf75b, 0xf75c, 0xf75c, 0xf73c, 0xef5c, 0xef3c, 0xef5c, 0xff9d, 0xff9d, 0xff5b, 0xeeb8, 0xcdb4, 0xbd11, 0x8b27, 0x7264, 0x61e2, 0x6a02, 0x7244, 0x7223, 0x6181, 0x5100, 0x6140, 0x69c1, 0x8243, 0x8aa5, 0x92c5, 0x8aa4, 0x8283, 0x8263, 0x8ac3, 0x8aa3, 0x8283, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a44, 0x7243, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x69e1, 0x7202, 0x71e2, 0x7203, 0x7203, 0x7203, 0x7203, 0x5120, 0x40e1, 0xdeb8, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0x942e, 0x40e0, 0x61c2, 0x8263, 0x8a84, 0x8242, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8264, 0x8264, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7223, 0x7223, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x69c1, 0x7202, 0x7203, 0x69c2, 0x61a2, 0x69e3, 0x6a03, 0x69e3, 0x71e2, 0x69c1, 0x69e1, 0x7202, 0x69e2, 0x61a1, 0x61a2, 0x61c2, 0x6ac9, 0x7b4b, 0x942e, 0xacf2, 0xbd74, 0xc5d5, 0xce16, 0xd617, 0xce58, 0xc5d6, 0xb533, 0xa4b0, 0x93ed, 0x7b2a, 0x6a66, 0x59e4, 0x7242, 0x7262, 0x7263, 0x7202, 0x5960, 0x5120, 0x6181, 0x7224, 0x8285, 0x8285, 0x8a85, 0x8a84, 0x8a84, 0x8a83, 0x8a83, 0x8a83, 0x8282, 0x8262, 0x7a62, 0x8263, 0x8263, 0x8264, 0x7a44, 0x7a23, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x69e2, 0x69e1, 0x7202, 0x71e2, 0x7223, 0x7203, 0x7203, 0x71e3, 0x5100, 0x5983, 0xff9b, 0xffff, 0xffdf, 0xffdf, 
0xffff, 0xffff, 0xb4f1, 0x40e0, 0x5940, 0x92c5, 0x7a23, 0x7a43, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8243, 0x8243, 0x8243, 0x8243, 0x8243, 0x7a43, 0x7a43, 0x7a44, 0x7a44, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x7202, 0x7202, 0x69c2, 0x69c2, 0x69c2, 0x71e3, 0x71e3, 0x7203, 0x7203, 0x7203, 0x7224, 0x7203, 0x69e3, 0x69c2, 0x69e2, 0x7203, 0x7223, 0x7a43, 0x71c3, 0x6181, 0x5920, 0x5940, 0x69a1, 0x7a22, 0x8284, 0x8aa4, 0x8aa3, 0x8a84, 0x8a84, 0x8a84, 0x8a84, 0x8a84, 0x8a64, 0x8a64, 0x8264, 0x7a64, 0x7a44, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7223, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x6a45, 0x6a03, 0x7224, 0x71e2, 0x7a03, 0x7a44, 0x5981, 0x4900, 0x6b4c, 0xffde, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xd616, 0x38a0, 0x5940, 0x7a23, 0x8243, 0x8aa5, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8243, 0x8243, 0x8243, 0x8243, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x7203, 0x71e3, 0x71e3, 0x69c2, 0x69c2, 0x71e3, 0x7203, 0x7203, 0x69c3, 0x71e3, 0x7a24, 0x7a44, 0x7a44, 0x7203, 0x69c1, 0x6181, 0x6140, 0x6981, 0x7203, 0x8264, 0x8aa4, 0x8ac4, 0x8ac4, 0x8ac4, 0x8aa4, 0x8a84, 0x8a83, 0x8a84, 0x8a84, 0x8264, 0x8264, 0x8264, 0x7a64, 0x7a44, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x61e3, 0x7203, 0x7203, 0x71e2, 0x71e2, 0x7223, 0x69e3, 0x38a0, 0xad34, 0xffff, 0xffde, 0xffff, 0xffff, 
0xffff, 0xffff, 0xf73b, 0x3901, 0x5141, 0x69c2, 0x8284, 0x8aa5, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7223, 0x7223, 0x7223, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x7202, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x7203, 0x71e3, 0x71e3, 0x71e3, 0x7203, 0x7203, 0x7a23, 0x7a23, 0x7a44, 0x7a23, 0x7203, 0x69c2, 0x69a1, 0x6180, 0x6180, 0x6180, 0x7a22, 0x8284, 0x92e5, 0x92e5, 0x8ae4, 0x8aa3, 0x8aa3, 0x8aa3, 0x8aa4, 0x8a83, 0x8284, 0x8264, 0x8264, 0x8263, 0x8243, 0x8243, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7a23, 0x7a02, 0x71c1, 0x7a23, 0x69e2, 0x5120, 0x5162, 0xef5c, 0xffff, 0xffbe, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffbd, 0x6a67, 0x40e0, 0x61a2, 0x8284, 0x8243, 0x8263, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x69c2, 0x71e2, 0x7203, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x71c2, 0x69a1, 0x6160, 0x6160, 0x69a1, 0x7202, 0x8284, 0x8ac5, 0x8ac4, 0x8ae4, 0x92e4, 0x8ac4, 0x82a3, 0x8283, 0x8aa3, 0x8ac4, 0x8284, 0x8284, 0x8264, 0x8263, 0x8243, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7a23, 0x7a02, 0x8223, 0x79e2, 0x8aa5, 0x5981, 0x3080, 0x9bec, 0xffff, 0xffdf, 0xffde, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfffe, 0xacd1, 0x2880, 0x5161, 0x7a23, 0x8243, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7223, 0x7223, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x69e2, 0x69e2, 0x71e2, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7a44, 0x7a23, 0x7a23, 0x7203, 0x71e2, 0x69c2, 0x69a1, 0x69a1, 0x6981, 0x71c1, 0x7a23, 0x8264, 0x8aa5, 0x92e5, 0x9305, 0x9305, 0x8aa3, 0x8aa3, 0x8ac3, 0x8ac4, 0x8ac4, 0x8aa4, 0x8aa3, 0x8283, 0x8284, 0x8263, 0x8263, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7223, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x71e1, 0x79e2, 0x7a22, 0x7a23, 0x69e3, 0x38c0, 0x59e5, 0xeed9, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xe6da, 0x3922, 0x40e0, 0x61a1, 0x8264, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7223, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x69e2, 0x69e2, 0x69e2, 0x71e2, 0x7202, 0x7203, 0x7203, 0x7203, 0x7223, 0x7202, 0x69c2, 0x69a1, 0x69a1, 0x69c1, 0x71e2, 0x7202, 0x8284, 0x8aa4, 0x8ac5, 0x92e5, 0x92e5, 0x8ac4, 0x8a83, 0x8263, 0x9304, 0x8ac4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8284, 0x8263, 0x7a43, 0x7a63, 0x7a43, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7a43, 0x71e2, 0x69e2, 0x38a0, 0x38e1, 0xad12, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xffff, 0x83ac, 0x38a0, 0x5100, 0x79e2, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7223, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x7202, 0x7202, 0x7202, 0x71e2, 0x69e2, 0x69e2, 0x69e2, 0x69e2, 0x61a0, 0x69a1, 0x69c1, 0x71e2, 0x7a23, 0x8284, 0x8ac5, 0x92e6, 0x8aa5, 0x8aa4, 0x8a84, 0x8a83, 0x8a83, 0x8aa3, 0x8ac4, 0x92c4, 0x92e5, 0x8ac4, 0x8283, 0x8263, 0x7a43, 0x8264, 0x8264, 0x8264, 0x7a43, 0x7a43, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7223, 0x7223, 0x7a23, 0x71e2, 0x6181, 0x4920, 0x4121, 0x8bee, 0xf77d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffdf, 0xffff, 0xd616, 0x38e0, 0x40a0, 0x6120, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7a23, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x7202, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x69e2, 0x69e2, 0x69e2, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x7223, 0x7203, 0x7203, 0x71e2, 0x69e2, 0x69c2, 0x69c2, 0x69c1, 0x7a23, 0x7a43, 0x8264, 0x8284, 0x8aa5, 0x8aa5, 0x8aa5, 0x8aa5, 0x8aa4, 0x92c5, 0x92c5, 0x92e5, 0x92e4, 0x92c4, 0x8aa3, 0x8aa3, 0x8263, 0x8263, 0x8264, 0x8264, 0x8244, 0x7a44, 0x7a24, 0x7a25, 0x7222, 0x7223, 0x7223, 0x7223, 0x7223, 0x7203, 0x7203, 0x7203, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7202, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7223, 0x7223, 0x69c2, 0x5100, 0x5140, 0x38a0, 0x7b2a, 0xffbd, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xffdd, 0xffff, 0xf7df, 0xffff, 0xff9f, 0x8bae, 0x3860, 0x50c0, 0x5100, 0x69a1, 0x7a64, 0x7a64, 0x69e3, 0x69e3, 0x7224, 0x7203, 0x71e4, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71e3, 0x71c2, 0x6a04, 0x6a04, 0x6a04, 0x6a04, 0x6a03, 0x6a03, 0x7203, 0x7223, 0x71e3, 0x71e3, 0x71c3, 0x71a2, 0x71c2, 0x79e2, 0x79c1, 0x7181, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x7a02, 0x7a23, 0x69e2, 0x69e1, 0x69e1, 0x71e1, 0x7202, 0x7a42, 0x8263, 0x8283, 0x82a4, 0x82a4, 0x8aa4, 0x8aa4, 0x8aa3, 0x8aa3, 0x8aa3, 0x92c3, 0x8ae5, 0x8ae5, 0x8ac4, 0x8ac4, 0x82a4, 0x82a4, 0x82a4, 0x82a4, 0x8263, 0x8263, 0x8243, 0x7a43, 0x7a22, 0x7a22, 0x7a02, 0x7a02, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x7203, 0x71c1, 0x71e2, 0x71e2, 0x71c2, 0x71e2, 0x7203, 0x7203, 0x69e3, 0x7202, 0x71e2, 0x69e2, 0x69e2, 0x6a02, 0x6a03, 0x7223, 0x7223, 0x6a02, 0x7203, 0x7223, 0x7223, 0x7222, 0x69e1, 0x6180, 0x5960, 0x4921, 0x38a0, 0x59e5, 0xb4f2, 0xff9d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xe699, 0x82e9, 0x3020, 0x48e0, 0x5120, 0x61c2, 0x7203, 0x7203, 0x7a23, 0x7a44, 0x7203, 0x7224, 0x7203, 0x69e3, 0x69e2, 0x69e2, 0x7203, 0x7223, 0x7a43, 0x7224, 0x69e3, 0x61c2, 0x69c2, 0x7203, 0x7203, 0x71e2, 0x69a1, 0x71e3, 0x71e3, 0x69e3, 0x69c2, 0x6182, 0x5941, 0x5940, 0x5940, 0x48e0, 0x4900, 0x4900, 0x5120, 0x5120, 0x5140, 0x5140, 0x5140, 0x5981, 0x5981, 0x61a2, 0x69e2, 0x7203, 0x7223, 0x7a43, 0x7a43, 0x8284, 0x8284, 0x8ac4, 0x8ac5, 0x92e5, 0x92e5, 0x92e4, 0x92e4, 0x8284, 0x8aa4, 0x8aa4, 0x8aa4, 0x8aa4, 0x8263, 0x7a43, 0x7a22, 0x7242, 0x7242, 0x7242, 0x7222, 0x7222, 0x7222, 0x7222, 0x7222, 0x7223, 0x7223, 0x7223, 0x6a23, 0x6a03, 0x6a02, 0x6a02, 0x6a02, 0x71e2, 0x7202, 0x7202, 0x69e2, 0x69e2, 0x7203, 0x6a23, 0x69e3, 0x71c1, 0x71e2, 0x7202, 0x7203, 0x7223, 0x7203, 0x7203, 0x69e3, 0x7203, 0x6a02, 0x61c2, 0x5960, 0x4920, 0x48e0, 0x40e0, 0x4900, 0x38e1, 0x836b, 0xe678, 0xffde, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xde77, 0x72e8, 0x4100, 0x38a0, 0x40c0, 0x5140, 0x61a1, 0x71e2, 0x7a02, 0x71c1, 0x69e2, 0x6a02, 0x6a02, 0x6a22, 0x6a22, 0x6a02, 0x6a01, 0x6a01, 0x71e2, 0x7203, 0x7a23, 0x7203, 0x69c2, 0x69c2, 0x71c2, 0x71e2, 0x61a2, 0x5962, 0x5121, 0x4901, 0x38c0, 0x30a0, 0x38c1, 0x3902, 0x3921, 0x4122, 0x4122, 0x4122, 0x3901, 0x38e1, 0x30a0, 0x28a0, 0x38a0, 0x38a0, 0x38a0, 0x40e0, 0x4900, 0x4920, 0x4900, 0x48e0, 0x5120, 0x5940, 0x5960, 0x6181, 0x69a1, 0x69c1, 0x71e2, 0x71e2, 0x8264, 0x8243, 0x8223, 0x7a23, 0x7a23, 0x8243, 0x8264, 0x8264, 0x7243, 0x7243, 0x7242, 0x7242, 0x7222, 0x7222, 0x7222, 0x6a22, 0x7243, 0x7223, 0x6a23, 0x6a02, 0x6a02, 0x6a02, 0x6a23, 0x7223, 0x69e2, 0x7202, 0x7222, 0x6a02, 0x6a02, 0x7223, 0x6a23, 0x6a23, 0x71c2, 0x71e2, 0x79e3, 0x71e3, 0x71e3, 0x69a2, 0x6161, 0x5961, 0x5940, 0x5120, 0x4900, 0x40c0, 0x40e0, 0x4942, 0x5a05, 0x6aa8, 0xd658, 0xf77d, 0xffff, 0xffff, 0xffbe, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xf7be, 0xffff, 0xf7ff, 0xefbe, 0xffff, 0xfffe, 0xe6f8, 0x6a87, 0x4983, 0x38e0, 0x40e0, 0x4900, 0x5960, 0x69a1, 0x69a1, 0x7203, 0x7203, 0x71e2, 0x69e2, 0x69e1, 0x69e1, 0x69e1, 0x7202, 0x7202, 0x71e2, 0x71e2, 0x71e2, 0x71e2, 0x69a1, 0x5940, 0x5100, 0x38c0, 0x38c0, 0x4983, 0x832b, 0xbd33, 0xde79, 0xef1b, 0xef1b, 0xffdd, 0xffdd, 0xffbd, 0xffbd, 0xf77c, 0xef3b, 0xe6fa, 0xe6d9, 0xc533, 0xa42f, 0x72a9, 0x4143, 0x30a0, 0x3080, 0x38c0, 0x38e1, 0x4901, 0x48e0, 0x48e0, 0x48e0, 0x48e0, 0x48e0, 0x5100, 0x5100, 0x50c0, 0x50e0, 0x5920, 0x6140, 0x6161, 0x6161, 0x6140, 0x5940, 0x6181, 0x61a1, 0x61a1, 0x61a1, 0x69c2, 0x69c2, 0x69e2, 0x69e2, 0x69c2, 0x69c2, 0x69e2, 0x69e2, 0x69e3, 0x69e3, 0x69e3, 0x69e3, 0x71e2, 0x69c2, 0x69c2, 0x61a1, 0x6181, 0x5981, 0x5961, 0x5961, 0x5920, 0x5920, 0x5900, 0x50e0, 0x50e0, 0x48e0, 0x48e0, 0x50e0, 0x40a0, 0x40a0, 0x38c0, 0x4122, 0x6247, 0x9c70, 0xe6da, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xfffe, 0xfffe, 0xd616, 0x93ed, 0x5a25, 0x40e0, 0x38a0, 0x4900, 0x5940, 0x5900, 0x6141, 0x69a2, 0x71e3, 0x71e3, 0x71c2, 0x69c2, 0x69c2, 0x5960, 0x5961, 0x5141, 0x4920, 0x40e0, 0x38c0, 0x38a0, 0x38c0, 0x9c2e, 0xcdb5, 0xff7c, 0xfffe, 0xffff, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xff7d, 0xeeda, 0xcdb5, 0xa470, 0x838d, 0x4123, 0x4123, 0x4102, 0x40e1, 0x38e1, 0x38c0, 0x38a0, 0x38a0, 0x48e0, 0x48e0, 0x48e0, 0x48c0, 0x48c0, 0x48c0, 0x48c0, 0x48e0, 0x50e0, 0x50e0, 0x50e0, 0x50e0, 0x50e0, 0x50e0, 0x50e0, 0x50e0, 0x50c0, 0x50c0, 0x58e0, 0x5901, 0x5901, 0x5900, 0x50e0, 0x50c0, 0x5900, 0x58e0, 0x58e0, 0x50e0, 0x50e0, 0x50e0, 0x50e0, 0x50e0, 0x48e0, 0x48e0, 0x48e0, 0x48c0, 0x40c0, 0x40a0, 0x38a0, 0x38a0, 0x5183, 0x7ae9, 0xbd12, 0xeeb9, 0xff9e, 0xffff, 0xffff, 0xffff, 0xefdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xffff, 0xfffe, 0xffdd, 0xf73b, 0xc594, 0x8bac, 0x59e5, 0x30c0, 0x40a0, 0x40c0, 0x48c0, 0x40c0, 0x40a0, 0x40a0, 0x48e0, 0x4900, 0x4921, 0x4121, 0x38c0, 0x30a0, 0x3901, 0x6ac9, 0xbd53, 0xf71a, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffde, 0xffbd, 0xff9d, 0xff5c, 0xeefa, 0xde58, 0xcdb5, 0xbd33, 0xb4d2, 0x93cc, 0x834a, 0x6a67, 0x51a4, 0x3902, 0x30c1, 0x30c1, 0x30c1, 0x40c1, 0x40c1, 0x40c1, 0x40c1, 0x40c1, 0x40c1, 0x40c1, 0x40c1, 0x48e1, 0x48e1, 0x48c0, 0x48c0, 0x48c0, 0x48e1, 0x5101, 0x5122, 0x48e0, 0x48c0, 0x48c0, 0x48c0, 0x40c0, 0x4080, 0x3880, 0x40a0, 0x38e1, 0x38e1, 0x3902, 0x4984, 0x6aa9, 0x9c2f, 0xcdb5, 0xe698, 0xff5b, 0xff9d, 0xffde, 0xffff, 0xffdf, 0xf7bf, 0xf7df, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7df, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xff9d, 0xf77c, 0xeefb, 0xc595, 0xacd1, 0x838c, 0x5a27, 0x4163, 0x4163, 0x51c5, 0x6247, 0x7309, 0x8bac, 0xacd1, 0xce17, 0xef1b, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffbd, 0xf77c, 0xf73c, 0xef1b, 0xef1b, 0xce16, 0xcdf6, 0xc595, 0xb533, 0xa4d1, 0x9c70, 0x940f, 0x8bee, 0x836b, 0x7b0a, 0x6a88, 0x51e5, 0x4184, 0x3922, 0x3922, 0x3902, 0x4142, 0x4163, 0x5a05, 0x72e9, 0x8bcd, 0xa490, 0xb512, 0xc594, 0xde78, 0xe6da, 0xf75c, 0xffde, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xf7df, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf7bd, 0xf7bd, 0xffdd, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffde, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xfffd, 0xffdd, 0xffdd, 0xffdd, 0xfffd, 0xffdc, 0xffdc, 0xfffd, 0xfffd, 0xfffd, 0xf7fd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};

const unsigned short  Tears[] PROGMEM = {
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffd, 0xffdc, 0xffdc, 0xfffe, 0xffde, 0xffdd, 0xffbd, 0xffbd, 0xffbd, 0xffdd, 0xffde, 0xffbc, 0xffbd, 0xffdd, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffbc, 0xf739, 0xe6b6, 0xde55, 0xedeb, 0xe5ca, 0xddaa, 0xdd69, 0xd548, 0xd548, 0xd548, 0xd569, 0xcd48, 0xd569, 0xd58a, 0xddec, 0xe62f, 0xe671, 0xeeb2, 0xeed3, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffdf, 0xffdf, 0xeffe, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffbf, 0xffdc, 0xff58, 0xf6b4, 0xee2f, 0xe5ab, 0xdd26, 0xdce3, 0xdce2, 0xdd24, 0xdd24, 0xdd45, 0xdd65, 0xe566, 0xe586, 0xe586, 0xe586, 0xe564, 0xe564, 0xe564, 0xe544, 0xe524, 0xdd03, 0xdd03, 0xdce3, 0xddcc, 0xe64f, 0xf6f3, 0xff98, 0xffdc, 0xfffe, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xfffb, 0xff97, 0xf6d3, 0xe62f, 0xcd8b, 0xcd49, 0xcd28, 0xd547, 0xdd66, 0xe585, 0xeda4, 0xf5c4, 0xedc5, 0xedc5, 0xedc5, 0xede6, 0xede6, 0xede6, 0xede6, 0xede6, 0xee06, 0xee06, 0xede6, 0xede6, 0xedc6, 0xe5a6, 0xe586, 0xe585, 0xe565, 0xdd45, 0xd526, 0xcd07, 0xd56a, 0xe62e, 0xf6f3, 0xff96, 0xffde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xf7ff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdc, 0xfffe, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffbc, 0xf6d5, 0xddac, 0xcd06, 0xd523, 0xe583, 0xdda5, 0xe5a5, 0xe5a5, 0xe5a4, 0xedc5, 0xf605, 0xf605, 0xf605, 0xfe45, 0xfe66, 0xfe66, 0xfe66, 0xfe66, 0xf666, 0xf646, 0xf646, 0xee68, 0xee68, 0xee68, 0xee68, 0xee47, 0xee47, 0xee27, 0xee27, 0xfe05, 0xfde5, 0xf5c4, 0xed84, 0xdd64, 0xd544, 0xd544, 0xd545, 0xd5f0, 0xe694, 0xff5a, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xeffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xfffe, 0xffbc, 0xff14, 0xee30, 0xd54a, 0xcce7, 0xdd26, 0xed85, 0xed84, 0xed62, 0xfde5, 0xfe26, 0xfe27, 0xfe06, 0xf627, 0xfe48, 0xfe48, 0xf628, 0xfe86, 0xfe86, 0xfe86, 0xf686, 0xf686, 0xf686, 0xf686, 0xf686, 0xf688, 0xf688, 0xf688, 0xf688, 0xf667, 0xf667, 0xf667, 0xee47, 0xf5e5, 0xf605, 0xf626, 0xf627, 0xf607, 0xede6, 0xdda6, 0xdd85, 0xd525, 0xdd68, 0xddcc, 0xe652, 0xeed7, 0xf77b, 0xfffe, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xffba, 0xfed4, 0xe60e, 0xd4e3, 0xdd24, 0xe565, 0xeda5, 0xedc5, 0xf5e6, 0xfe26, 0xfe67, 0xfde6, 0xfe27, 0xfe48, 0xfe27, 0xf648, 0xfea9, 0xfeaa, 0xf689, 0xf688, 0xf688, 0xf6a9, 0xf6a9, 0xf6a9, 0xf6a9, 0xf6a9, 0xeea9, 0xf689, 0xf689, 0xfea9, 0xfe89, 0xfe88, 0xfe68, 0xf667, 0xf667, 0xfea8, 0xf688, 0xf667, 0xee27, 0xee27, 0xe607, 0xee08, 0xee28, 0xfda4, 0xf584, 0xe544, 0xcd05, 0xcd08, 0xd5ae, 0xf6b5, 0xff7a, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xff99, 0xf692, 0xddab, 0xd527, 0xd4e5, 0xf564, 0xf585, 0xfdc5, 0xfe06, 0xf626, 0xf646, 0xee46, 0xee46, 0xfe68, 0xfe89, 0xfea9, 0xfea9, 0xf6a9, 0xf6ca, 0xf6eb, 0xf6eb, 0xf6ce, 0xf6ee, 0xf6ef, 0xf70f, 0xf70f, 0xf710, 0xf710, 0xf710, 0xfeee, 0xfeee, 0xfeee, 0xfeed, 0xfecd, 0xfecc, 0xfecc, 0xfeab, 0xf6c8, 0xf6a8, 0xf6a7, 0xf688, 0xf688, 0xf687, 0xf667, 0xf647, 0xfde7, 0xfdc6, 0xfdc4, 0xed83, 0xe564, 0xdd46, 0xdd69, 0xdd6b, 0xfed8, 0xff5a, 0xffde, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbb, 0xf6d4, 0xe5ed, 0xd506, 0xcca2, 0xd503, 0xe5a5, 0xfe07, 0xf607, 0xf607, 0xf607, 0xee27, 0xf647, 0xf688, 0xfec9, 0xf68a, 0xf6ab, 0xf6cc, 0xfeee, 0xf70f, 0xf70f, 0xf731, 0xff52, 0xf735, 0xff55, 0xff75, 0xff76, 0xff76, 0xff96, 0xff97, 0xff97, 0xff76, 0xff75, 0xff75, 0xff54, 0xff53, 0xff33, 0xff32, 0xff12, 0xfeed, 0xf6cd, 0xf6ac, 0xf6ab, 0xfe89, 0xf688, 0xf647, 0xf646, 0xfe49, 0xf628, 0xf626, 0xf625, 0xf605, 0xeda5, 0xe545, 0xdd05, 0xcca6, 0xddac, 0xf6f4, 0xfffb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9a, 0xde11, 0xc4a8, 0xd4a4, 0xed43, 0xf5c5, 0xf606, 0xee47, 0xee86, 0xee66, 0xf667, 0xf688, 0xfeaa, 0xfeab, 0xfeac, 0xfeac, 0xff0f, 0xff10, 0xff32, 0xff94, 0xff96, 0xff57, 0xff58, 0xff9a, 0xff99, 0xff99, 0xffba, 0xffba, 0xffba, 0xffba, 0xffbb, 0xffbb, 0xffdb, 0xffdb, 0xffba, 0xffb9, 0xffb8, 0xf798, 0xf777, 0xf776, 0xff36, 0xff15, 0xff13, 0xff11, 0xff0f, 0xfecd, 0xfe8b, 0xf649, 0xe688, 0xee88, 0xee68, 0xee47, 0xee07, 0xf5c6, 0xf5c6, 0xf5a6, 0xed62, 0xd523, 0xc527, 0xce0f, 0xe759, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9f, 0xffff, 0xffff, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffbd, 0xffff, 0xf7ff, 0xefff, 0xf7ff, 0xfffd, 0xff97, 0xee71, 0xdce6, 0xdd26, 0xe565, 0xeda5, 0xede5, 0xee05, 0xf647, 0xf668, 0xee65, 0xf666, 0xf688, 0xf6ab, 0xf6cd, 0xf6f0, 0xf712, 0xf713, 0xf797, 0xf798, 0xf798, 0xf799, 0xf7ba, 0xffbb, 0xffbb, 0xffbb, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xf779, 0xf798, 0xff97, 0xff96, 0xff75, 0xff33, 0xff11, 0xf6f0, 0xf6ab, 0xf68a, 0xf689, 0xf669, 0xfe68, 0xfe47, 0xf626, 0xf605, 0xf606, 0xeda5, 0xe523, 0xdd04, 0xe56a, 0xee72, 0xff9b, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xffde, 0xfffe, 0xffdf, 0xffbf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xfffe, 0xff37, 0xddef, 0xcd09, 0xe546, 0xed66, 0xeda5, 0xede5, 0xee05, 0xee26, 0xf648, 0xf669, 0xf6aa, 0xf6ab, 0xfeed, 0xff10, 0xff32, 0xff55, 0xff76, 0xff77, 0xffd9, 0xffd9, 0xffda, 0xffda, 0xffdb, 0xffdc, 0xffdc, 0xffdc, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbb, 0xffbb, 0xffba, 0xffba, 0xff98, 0xff77, 0xff55, 0xff35, 0xff30, 0xff0f, 0xfecd, 0xf6ab, 0xf66a, 0xf648, 0xf626, 0xf605, 0xede7, 0xf607, 0xfde7, 0xed85, 0xdd26, 0xd56a, 0xde31, 0xeef6, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xffbb, 0xf6b4, 0xd58c, 0xd4e7, 0xd506, 0xeda5, 0xf5c5, 0xf5e6, 0xf606, 0xf627, 0xf648, 0xf66a, 0xfe8b, 0xfef1, 0xff12, 0xff34, 0xff56, 0xff98, 0xffba, 0xffbb, 0xffbc, 0xfffb, 0xfffb, 0xfffb, 0xfffc, 0xfffc, 0xfffd, 0xfffd, 0xfffd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdd, 0xffdd, 0xffdd, 0xffdc, 0xffbc, 0xff9b, 0xff9a, 0xff7a, 0xffb7, 0xff75, 0xff33, 0xf6f0, 0xf6ad, 0xf68b, 0xf649, 0xf628, 0xede9, 0xfe28, 0xfe27, 0xfde5, 0xe544, 0xd504, 0xd527, 0xd569, 0xf6d7, 0xffbc, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7ff, 0xffff, 0xffba, 0xee31, 0xd508, 0xdce5, 0xe545, 0xf5a5, 0xf5e4, 0xf5e5, 0xf626, 0xf648, 0xf66a, 0xf68c, 0xfeae, 0xfeef, 0xff35, 0xff36, 0xff57, 0xff79, 0xff9b, 0xffbc, 0xffbd, 0xffde, 0xffdb, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffbc, 0xffbd, 0xffbd, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xfffd, 0xffdd, 0xffdd, 0xffbd, 0xffbd, 0xff9d, 0xff9d, 0xff9d, 0xffdc, 0xff9a, 0xf778, 0xf735, 0xff12, 0xfeef, 0xfecd, 0xfeab, 0xf64a, 0xf628, 0xfe06, 0xfe05, 0xfdc4, 0xf583, 0xe544, 0xdd04, 0xd52b, 0xee51, 0xff99, 0xffff, 0xf7ff, 0xf7ff, 0xf7fe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffdf, 0xffdf, 0xfffd, 0xff59, 0xddcf, 0xccc7, 0xdce4, 0xf585, 0xfdc5, 0xf584, 0xede5, 0xf606, 0xf648, 0xf66b, 0xf6ae, 0xfef0, 0xff32, 0xff53, 0xff78, 0xff78, 0xff99, 0xff9a, 0xffbb, 0xffbb, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xf7fb, 0xf7fb, 0xf7db, 0xf7dc, 0xf7bc, 0xf7bc, 0xffbc, 0xffbc, 0xf7be, 0xf7bd, 0xff9b, 0xff99, 0xff76, 0xff53, 0xff11, 0xfef0, 0xf68b, 0xf669, 0xf627, 0xf605, 0xfe05, 0xfde5, 0xfda5, 0xf564, 0xdd05, 0xccc6, 0xd5ce, 0xffba, 0xfffe, 0xf7ff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xfffe, 0xfffd, 0xff36, 0xddce, 0xc4a7, 0xd4e5, 0xf585, 0xfde5, 0xf5e5, 0xf606, 0xee27, 0xf649, 0xf68c, 0xfecf, 0xff12, 0xff34, 0xff76, 0xff97, 0xffba, 0xffba, 0xffba, 0xffda, 0xffdb, 0xffdb, 0xffbb, 0xffbb, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffbc, 0xffbc, 0xffbc, 0xffbc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xffdc, 0xfffb, 0xfffb, 0xffdb, 0xffdb, 0xffdb, 0xf7db, 0xffdb, 0xffdb, 0xffbe, 0xffbd, 0xffbc, 0xffbb, 0xffb9, 0xff97, 0xff55, 0xf733, 0xff0f, 0xf6cd, 0xf66a, 0xf648, 0xf607, 0xfde6, 0xfdc6, 0xfda6, 0xf5a4, 0xd4e3, 0xccc6, 0xddcd, 0xff37, 0xfffd, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xfffe, 0xfffc, 0xef17, 0xe549, 0xdce7, 0xdd05, 0xeda6, 0xf5e6, 0xedc5, 0xee07, 0xfe8a, 0xf66b, 0xf6ad, 0xfef1, 0xff34, 0xff56, 0xf778, 0xf7b9, 0xf7b9, 0xffbb, 0xffbb, 0xffbb, 0xffdb, 0xffdb, 0xffdb, 0xffbb, 0xffbb, 0xffbc, 0xffbc, 0xffbc, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffdb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffdc, 0xffdc, 0xffdb, 0xffdb, 0xffdb, 0xffda, 0xffda, 0xf7da, 0xffbc, 0xffbb, 0xffbb, 0xffbb, 0xffba, 0xffb9, 0xf798, 0xf757, 0xff55, 0xff13, 0xf6d0, 0xf68d, 0xf66a, 0xf628, 0xf5e7, 0xf5c6, 0xf5c6, 0xf5a6, 0xe524, 0xd4a5, 0xdd6b, 0xff37, 0xfffe, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xfffd, 0xef17, 0xbd6f, 0xe4c4, 0xed45, 0xf5a6, 0xedc5, 0xede6, 0xee27, 0xee29, 0xee29, 0xf6ce, 0xfef0, 0xff34, 0xff77, 0xff79, 0xf79a, 0xefba, 0xefdb, 0xff7c, 0xff9c, 0xff9c, 0xffbc, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffba, 0xffba, 0xffba, 0xffba, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xffbb, 0xff7c, 0xff9c, 0xff9c, 0xff9c, 0xffbb, 0xf7ba, 0xf79a, 0xf79a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xffba, 0xffba, 0xffba, 0xf7ba, 0xff38, 0xff57, 0xff34, 0xff11, 0xf6ad, 0xee4a, 0xf628, 0xf627, 0xf5e8, 0xf5a6, 0xfd85, 0xf524, 0xd4a5, 0xd54c, 0xef18, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7e, 0xffff, 0xffff, 0xf7bf, 0xffdf, 0xfed8, 0xdd09, 0xe4c2, 0xe545, 0xe586, 0xedc6, 0xee06, 0xee08, 0xee29, 0xf66c, 0xfeae, 0xef15, 0xf736, 0xff77, 0xff99, 0xffba, 0xffba, 0xff9a, 0xff9a, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff7a, 0xff5a, 0xff38, 0xff15, 0xfef2, 0xfeae, 0xf66a, 0xee48, 0xede6, 0xf606, 0xedc5, 0xed84, 0xe525, 0xd4c5, 0xe54a, 0xfef2, 0xffff, 0xf7ff, 0xefdf, 0xffff, 0xfffe, 0xffbd, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xf719, 0xddae, 0xdce7, 0xe4e4, 0xed85, 0xeda5, 0xede6, 0xee07, 0xf649, 0xf66c, 0xfeaf, 0xfef1, 0xf736, 0xf757, 0xff78, 0xff99, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff9a, 0xff79, 0xff58, 0xff56, 0xff34, 0xfef0, 0xf6ad, 0xf68b, 0xf628, 0xf627, 0xf5e6, 0xf5c5, 0xed65, 0xd4c4, 0xccc6, 0xe56a, 0xff3b, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xff7a, 0xddad, 0xccc5, 0xdd05, 0xed26, 0xf5a5, 0xf5c5, 0xf607, 0xf629, 0xf66c, 0xf6cf, 0xff13, 0xff55, 0xff77, 0xff77, 0xff78, 0xff98, 0xff99, 0xff99, 0xff9a, 0xff9a, 0xff99, 0xff99, 0xff99, 0xffb9, 0xffb9, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xffba, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xffb9, 0xff99, 0xff99, 0xff77, 0xff56, 0xff33, 0xff11, 0xf6ef, 0xf64b, 0xf609, 0xf5e7, 0xf5e6, 0xf5c6, 0xe545, 0xd4e5, 0xd4c5, 0xe58f, 0xff59, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff5a, 0xddae, 0xccc5, 0xdd03, 0xed64, 0xed86, 0xfde5, 0xf5e6, 0xf628, 0xfe6c, 0xfecf, 0xff13, 0xff56, 0xff78, 0xff98, 0xff98, 0xff98, 0xff98, 0xff79, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xffb8, 0xf7b8, 0xff99, 0xff98, 0xff98, 0xff76, 0xff54, 0xff33, 0xfeaf, 0xf64c, 0xf609, 0xf5e7, 0xf5c6, 0xfdc6, 0xf586, 0xe525, 0xd486, 0xe5ae, 0xff79, 0xffff, 0xf7df, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdc, 0xe62f, 0xcc84, 0xdca3, 0xed45, 0xeda5, 0xedc5, 0xf5e6, 0xf608, 0xfe4b, 0xfeaf, 0xfef3, 0xff36, 0xff58, 0xf779, 0xff98, 0xff98, 0xff98, 0xff78, 0xff78, 0xff78, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xffb9, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff99, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xf7b7, 0xf798, 0xf798, 0xff98, 0xff98, 0xff78, 0xff77, 0xf756, 0xff33, 0xfeb0, 0xfe6c, 0xf608, 0xf5a6, 0xf5c6, 0xfdc6, 0xed85, 0xe4c3, 0xd4c6, 0xee31, 0xffbc, 0xffff, 0xf7ff, 0xffff, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xe673, 0xcd07, 0xd4c2, 0xed04, 0xf545, 0xf5a6, 0xee06, 0xf609, 0xf64b, 0xfeaf, 0xfef2, 0xff35, 0xff57, 0xf758, 0xf758, 0xff98, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xf797, 0xf797, 0xf778, 0xf778, 0xff78, 0xff98, 0xff77, 0xf776, 0xff35, 0xf6f2, 0xfeaf, 0xfe4b, 0xf5c7, 0xf5c6, 0xf5c6, 0xf5a6, 0xed24, 0xdca4, 0xdce9, 0xf674, 0xfffe, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfed4, 0xcd2a, 0xcc84, 0xed25, 0xf565, 0xf565, 0xf5c7, 0xf609, 0xf66d, 0xf68f, 0xfed2, 0xff15, 0xff36, 0xff37, 0xf757, 0xff57, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff97, 0xff77, 0xff78, 0xff78, 0xff78, 0xff98, 0xff77, 0xff76, 0xef36, 0xeef3, 0xf6f0, 0xfead, 0xf62a, 0xf5e8, 0xf5e7, 0xf5c7, 0xe565, 0xe504, 0xdca5, 0xdd0b, 0xfed7, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xd549, 0xc487, 0xd4a6, 0xf546, 0xfd84, 0xfdc5, 0xfe09, 0xf60c, 0xf6b0, 0xfed2, 0xff14, 0xff16, 0xff17, 0xff37, 0xff56, 0xff76, 0xff58, 0xff78, 0xff78, 0xff78, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff98, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff78, 0xff97, 0xff77, 0xff78, 0xff78, 0xff78, 0xff77, 0xff76, 0xff76, 0xf7b8, 0xef55, 0xf712, 0xfeef, 0xfe8b, 0xf609, 0xedc8, 0xeda8, 0xdda7, 0xed65, 0xece5, 0xd446, 0xdd4f, 0xff7b, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdd, 0xffff, 0xefbf, 0xf7ff, 0xffdd, 0xee12, 0xdc64, 0xe4c4, 0xed24, 0xed85, 0xeda6, 0xf5e8, 0xf62b, 0xfe4d, 0xf713, 0xf734, 0xff55, 0xff76, 0xff56, 0xf757, 0xf757, 0xf757, 0xff76, 0xff76, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff77, 0xff77, 0xff77, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff55, 0xf734, 0xf713, 0xf6d0, 0xf68d, 0xee09, 0xedc7, 0xede6, 0xe584, 0xed64, 0xe4e3, 0xcc86, 0xee31, 0xffdd, 0xffff, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf6d7, 0xd4eb, 0xdca5, 0xe4e5, 0xed65, 0xeda5, 0xf5c7, 0xf609, 0xfe4c, 0xfe6e, 0xf713, 0xf734, 0xff55, 0xff56, 0xff56, 0xf756, 0xf757, 0xf757, 0xff76, 0xff76, 0xff76, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff97, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff97, 0xff97, 0xff97, 0xff97, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff77, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xf735, 0xf733, 0xf6f1, 0xf68e, 0xf62b, 0xede9, 0xede7, 0xeda6, 0xed64, 0xe4e4, 0xd4a5, 0xdd6d, 0xf6f8, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffdd, 0xdd4e, 0xcc25, 0xe4e5, 0xed25, 0xed86, 0xf5c7, 0xf608, 0xf64b, 0xfe8e, 0xfeb0, 0xf713, 0xf734, 0xff55, 0xff55, 0xff56, 0xf756, 0xf756, 0xf757, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff76, 0xff76, 0xff76, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xff56, 0xf735, 0xf734, 0xf712, 0xf6b0, 0xf66d, 0xf62b, 0xedc8, 0xf5c7, 0xf565, 0xed04, 0xe4e5, 0xc487, 0xd58f, 0xffba, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xf695, 0xd467, 0xe442, 0xed25, 0xed46, 0xf5a7, 0xf5e8, 0xf62a, 0xf66d, 0xfeb0, 0xfed1, 0xf714, 0xff34, 0xff35, 0xff55, 0xff55, 0xf755, 0xff56, 0xf756, 0xff55, 0xff55, 0xff56, 0xff56, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff76, 0xff56, 0xff56, 0xff56, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff36, 0xff36, 0xf736, 0xf735, 0xff14, 0xfef2, 0xfe8f, 0xfe6e, 0xedc9, 0xf5c8, 0xf565, 0xf545, 0xed25, 0xcc64, 0xccc8, 0xfe91, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xf7df, 0xffff, 0xff5a, 0xd50b, 0xd443, 0xf4c3, 0xed45, 0xed66, 0xeda8, 0xf60a, 0xf64c, 0xf68f, 0xfed1, 0xfef2, 0xf714, 0xff14, 0xff35, 0xff35, 0xff35, 0xf735, 0xf755, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff96, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff76, 0xff76, 0xff76, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff36, 0xff36, 0xf736, 0xf736, 0xff35, 0xff13, 0xfed1, 0xfe90, 0xf60b, 0xf5c9, 0xf586, 0xf585, 0xf545, 0xdcc4, 0xd4a5, 0xdd08, 0xf79c, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xfffe, 0xf652, 0xc404, 0xdc63, 0xf504, 0xed65, 0xed86, 0xf5c8, 0xf62b, 0xf66e, 0xf6b0, 0xf6f2, 0xf713, 0xff14, 0xff35, 0xff35, 0xff35, 0xff35, 0xff35, 0xf754, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff55, 0xff35, 0xff35, 0xff34, 0xff34, 0xff35, 0xff35, 0xf735, 0xf735, 0xff35, 0xff13, 0xfef2, 0xfeb1, 0xf66c, 0xede9, 0xeda8, 0xf5a6, 0xf565, 0xed45, 0xdcc5, 0xcc43, 0xe694, 0xffbc, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xff59, 0xdd0a, 0xd422, 0xece4, 0xe525, 0xed85, 0xf5a6, 0xf5e9, 0xf64c, 0xfeb0, 0xfed2, 0xf714, 0xf714, 0xff15, 0xff15, 0xff35, 0xff35, 0xff34, 0xf734, 0xff34, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff75, 0xff75, 0xff75, 0xff75, 0xff74, 0xff74, 0xff54, 0xff54, 0xff54, 0xff54, 0xff34, 0xff34, 0xff34, 0xff34, 0xff34, 0xff34, 0xff33, 0xff34, 0xf734, 0xf734, 0xf734, 0xf713, 0xfef2, 0xfed1, 0xf68d, 0xf62b, 0xee09, 0xf5c7, 0xed66, 0xed46, 0xe505, 0xd464, 0xcd2b, 0xff17, 0xffdf, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf77f, 0xffff, 0xee74, 0xc404, 0xe482, 0xf565, 0xe547, 0xf585, 0xf5a7, 0xf60a, 0xfe6d, 0xfed1, 0xff13, 0xf715, 0xf735, 0xff15, 0xff15, 0xff35, 0xff34, 0xf734, 0xf734, 0xff34, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff75, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff95, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff94, 0xff75, 0xff75, 0xff75, 0xff74, 0xff74, 0xff54, 0xff54, 0xff54, 0xff54, 0xff34, 0xff34, 0xff34, 0xff34, 0xff34, 0xff34, 0xff34, 0xff33, 0xff33, 0xf733, 0xf734, 0xf734, 0xf713, 0xfef2, 0xf6d1, 0xf6ad, 0xf68c, 0xf62a, 0xedc7, 0xed66, 0xed25, 0xed05, 0xece6, 0xb425, 0xfe74, 0xffbe, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xff99, 0xdc86, 0xd423, 0xd507, 0xe527, 0xfd24, 0xeda7, 0xf5e9, 0xf64c, 0xf6af, 0xf6d2, 0xf6f3, 0xf6d3, 0xf6f4, 0xff14, 0xfef4, 0xfef4, 0xfef4, 0xff14, 0xff13, 0xf713, 0xf713, 0xff53, 0xf733, 0xf774, 0xff95, 0xf754, 0xf753, 0xff93, 0xf731, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff94, 0xf753, 0xff74, 0xff74, 0xf753, 0xff74, 0xf754, 0xff33, 0xff74, 0xff54, 0xff33, 0xff74, 0xff53, 0xf732, 0xff32, 0xff53, 0xff33, 0xff13, 0xf6f3, 0xf6f3, 0xf6f3, 0xf6f3, 0xf6f3, 0xfe91, 0xfe8f, 0xf64c, 0xede9, 0xeda6, 0xed86, 0xed25, 0xe4e4, 0xdc62, 0xdd09, 0xffba, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xf6b4, 0xd445, 0xdc63, 0xdd27, 0xe506, 0xfd44, 0xeda8, 0xf5ea, 0xf66d, 0xf6b0, 0xf6d2, 0xf6d3, 0xf6f3, 0xf6d3, 0xf6d3, 0xfef3, 0xff34, 0xff54, 0xff33, 0xf6f3, 0xff33, 0xff94, 0xff33, 0xff54, 0xf733, 0xf754, 0xff74, 0xef12, 0xf732, 0xffb3, 0xff53, 0xff54, 0xff54, 0xff54, 0xff54, 0xff54, 0xff74, 0xff74, 0xff73, 0xff73, 0xff73, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xff74, 0xf753, 0xff73, 0xf732, 0xf753, 0xff54, 0xf753, 0xff74, 0xff54, 0xf733, 0xff54, 0xff33, 0xf712, 0xf712, 0xf712, 0xf733, 0xff94, 0xff33, 0xff33, 0xff13, 0xf6f3, 0xff13, 0xff54, 0xff14, 0xf6b2, 0xfeb1, 0xfe90, 0xf66d, 0xede9, 0xeda7, 0xed86, 0xed25, 0xe4e4, 0xdc83, 0xcc87, 0xfeb5, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdc, 0xd56e, 0xcc24, 0xe4a4, 0xe547, 0xdd06, 0xfd86, 0xf5c9, 0xf60b, 0xf66d, 0xf6b0, 0xf6d2, 0xf6f2, 0xf6f3, 0xfef3, 0xf712, 0xff33, 0xf733, 0xf6f2, 0xf712, 0xff73, 0xff53, 0xeef1, 0xff33, 0xff74, 0xff34, 0xff34, 0xff75, 0xff74, 0xff73, 0xff73, 0xff53, 0xff53, 0xff53, 0xff53, 0xff53, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff52, 0xff73, 0xff73, 0xff74, 0xff53, 0xf733, 0xff74, 0xf733, 0xf6f3, 0xf733, 0xff34, 0xff74, 0xffb5, 0xff74, 0xf712, 0xf712, 0xff13, 0xff34, 0xff54, 0xff13, 0xf6d2, 0xf6d2, 0xf6f3, 0xff13, 0xfeb1, 0xfeb0, 0xfe8e, 0xf60a, 0xedc8, 0xed86, 0xed45, 0xed05, 0xe4c4, 0xc424, 0xd54e, 0xffdc, 0xffff, 0xf7df, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xff18, 0xc468, 0xd444, 0xe4e5, 0xe547, 0xe526, 0xfd86, 0xf5ea, 0xf62c, 0xf68e, 0xfed0, 0xf6f1, 0xf6f2, 0xfef2, 0xfef2, 0xf732, 0xef11, 0xef11, 0xf712, 0xf712, 0xf712, 0xff33, 0xff94, 0xff54, 0xff34, 0xfef4, 0xfef4, 0xfef4, 0xff75, 0xffb5, 0xeef1, 0xff53, 0xff53, 0xff53, 0xff53, 0xff53, 0xff53, 0xff73, 0xff73, 0xff72, 0xff72, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff73, 0xff52, 0xff93, 0xff73, 0xff93, 0xff32, 0xf732, 0xff74, 0xff33, 0xffd7, 0xff55, 0xf6f3, 0xf713, 0xff54, 0xff54, 0xff33, 0xf712, 0xf6d2, 0xf6d2, 0xfef3, 0xff13, 0xff13, 0xf6d2, 0xf6d2, 0xff12, 0xf6b1, 0xfeb0, 0xfe8f, 0xf64c, 0xf5e9, 0xed87, 0xed46, 0xed25, 0xe505, 0xcc24, 0xc448, 0xff18, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xee12, 0xc3e5, 0xdca5, 0xe4e5, 0xed46, 0xf587, 0xf587, 0xf60b, 0xf64d, 0xf68f, 0xfed0, 0xf6f1, 0xf6f1, 0xfed1, 0xfed1, 0xeef0, 0xf752, 0xff52, 0xf711, 0xff32, 0xff94, 0xff33, 0xee71, 0xcd4d, 0xbc8a, 0xa3a8, 0x9b67, 0x9346, 0xa429, 0xe671, 0xffd5, 0xff52, 0xff52, 0xff52, 0xff52, 0xff52, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff52, 0xff52, 0xff52, 0xff52, 0xff52, 0xff52, 0xff52, 0xff52, 0xff52, 0xff52, 0xf731, 0xff52, 0xf732, 0xff52, 0xff94, 0xf6f2, 0xb48b, 0x9be8, 0x9386, 0x93a7, 0xa449, 0xc52c, 0xee71, 0xff34, 0xff34, 0xff13, 0xf6d2, 0xf6b2, 0xfef2, 0xff33, 0xff12, 0xf6d1, 0xf6b0, 0xfeb0, 0xfe8f, 0xfe4d, 0xf60b, 0xeda8, 0xed66, 0xed45, 0xe526, 0xdca5, 0xc3e4, 0xee11, 0xffdd, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbb, 0xd4eb, 0xd403, 0xe4e5, 0xe505, 0xed45, 0xf586, 0xedc8, 0xf62d, 0xf64e, 0xf68f, 0xfed1, 0xf6d1, 0xf6d1, 0xfed0, 0xfed0, 0xeed0, 0xff32, 0xff53, 0xff33, 0xff13, 0xee50, 0xbcaa, 0x8b04, 0x6a01, 0x6a01, 0x69a1, 0x8223, 0x71e1, 0x5180, 0x9c28, 0xff74, 0xff52, 0xff52, 0xff52, 0xff52, 0xff52, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff52, 0xff31, 0xf731, 0xff52, 0xff52, 0xff52, 0xf732, 0xd60d, 0x61a0, 0x61c0, 0x7222, 0x7242, 0x69e1, 0x6a00, 0x82a3, 0x9366, 0xd5cf, 0xfed3, 0xff75, 0xff13, 0xf6b1, 0xf6d1, 0xfef1, 0xf6d0, 0xf6d1, 0xf6b0, 0xfe90, 0xfe6e, 0xfe0c, 0xf5a9, 0xed66, 0xed45, 0xe546, 0xece5, 0xd403, 0xdceb, 0xff9b, 0xffff, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff17, 0xc406, 0xe443, 0xece5, 0xe525, 0xf545, 0xed65, 0xee0a, 0xf62d, 0xf66e, 0xfe90, 0xf6d1, 0xf6d1, 0xf6d0, 0xfed0, 0xfed0, 0xf6f1, 0xf6b0, 0xfef2, 0xfed2, 0xcd0c, 0x82a3, 0x61a0, 0x71e1, 0x8283, 0x92c5, 0x9285, 0x9ac6, 0x8223, 0x61c1, 0xa469, 0xf754, 0xff51, 0xff51, 0xff52, 0xff52, 0xff72, 0xff72, 0xff72, 0xff72, 0xff51, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff51, 0xff51, 0xff51, 0xff92, 0xff32, 0xff32, 0xf711, 0xd5cd, 0x71c1, 0x71c1, 0x8263, 0x92e6, 0x8aa4, 0x7a22, 0x7a01, 0x71e1, 0x72a2, 0xa449, 0xe630, 0xff33, 0xff33, 0xf6d1, 0xf6b0, 0xf6d0, 0xf6d0, 0xf6b0, 0xf690, 0xfe6f, 0xfe2d, 0xf5c9, 0xed66, 0xed45, 0xe547, 0xecc3, 0xe462, 0xcc06, 0xfef8, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xee74, 0xbb83, 0xec62, 0xe4c4, 0xe546, 0xf544, 0xed24, 0xf64b, 0xf64e, 0xf66f, 0xf6b0, 0xf6d1, 0xf6d1, 0xf6b0, 0xfeaf, 0xfecf, 0xee70, 0xff54, 0xf691, 0xa3c7, 0x61c0, 0x69c1, 0x8264, 0x8264, 0x8263, 0x8a84, 0x81e3, 0x7982, 0x7161, 0x8ae5, 0xde10, 0xff95, 0xff51, 0xff51, 0xff52, 0xff52, 0xff72, 0xff72, 0xff72, 0xff72, 0xff51, 0xff51, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff72, 0xff31, 0xff51, 0xff72, 0xff72, 0xf6f0, 0xff31, 0xffb3, 0xf6f1, 0xb368, 0x8203, 0x6940, 0x71a1, 0x8223, 0x92a4, 0x9ac5, 0x8a63, 0x6200, 0x59c0, 0x8304, 0xcd6c, 0xff12, 0xfef1, 0xf6af, 0xf6f0, 0xf6d0, 0xf690, 0xf670, 0xfe6f, 0xfe2e, 0xf5ca, 0xed66, 0xe545, 0xe567, 0xe482, 0xf4a3, 0xc3a4, 0xf676, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xdc67, 0xdc66, 0xe485, 0xece5, 0xed25, 0xe566, 0xe5a8, 0xee0a, 0xee6e, 0xee6e, 0xfed0, 0xf690, 0xf66f, 0xfef1, 0xfed0, 0xf68e, 0xff11, 0xf650, 0x92e5, 0x6961, 0x8204, 0x8a65, 0x8a85, 0x69e2, 0x6201, 0x6a42, 0x7ac3, 0x9c07, 0xd5ad, 0xff11, 0xff72, 0xff31, 0xff50, 0xff50, 0xff50, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff71, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xf730, 0xff32, 0xde2e, 0xac89, 0x8344, 0x6a62, 0x6a22, 0x6a22, 0x6a23, 0x8a84, 0x8244, 0x71c2, 0x69e2, 0xcced, 0xff34, 0xf6d0, 0xeeaf, 0xfef1, 0xee6f, 0xee6f, 0xf68f, 0xfe6e, 0xf5ea, 0xed66, 0xf5a6, 0xed47, 0xed05, 0xe482, 0xdc65, 0xc4ac, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff9c, 0xdc26, 0xdc45, 0xe485, 0xece5, 0xed45, 0xed67, 0xedc9, 0xf62b, 0xee4e, 0xf68f, 0xee6f, 0xfeb0, 0xfed0, 0xf68f, 0xfef1, 0xff31, 0xf650, 0x7a62, 0x6140, 0x8244, 0x8224, 0x69a1, 0x69e1, 0x8b26, 0xcd2d, 0xe610, 0xfef3, 0xff53, 0xff32, 0xff11, 0xff10, 0xff10, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff51, 0xff51, 0xff51, 0xff51, 0xff51, 0xf730, 0xf730, 0xf730, 0xff31, 0xff52, 0xff73, 0xff54, 0xf6b2, 0xcd4d, 0x9366, 0x6a21, 0x6160, 0x8284, 0x7a64, 0x7203, 0x61a1, 0xbccb, 0xff53, 0xf6af, 0xee6f, 0xf690, 0xf6b0, 0xf66f, 0xfe6e, 0xf60b, 0xed87, 0xf566, 0xe527, 0xed05, 0xe482, 0xdc44, 0xc46a, 0xff7b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffbf, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf6f8, 0xd405, 0xdc45, 0xe4a5, 0xed05, 0xed46, 0xed87, 0xedca, 0xf62c, 0xee4d, 0xfeaf, 0xee2d, 0xfeb0, 0xfeb0, 0xf64f, 0xff32, 0xee0e, 0x8aa4, 0x6980, 0x8244, 0x7a03, 0x6160, 0x9306, 0xcd2d, 0xf6b2, 0xff13, 0xff74, 0xff73, 0xff32, 0xf6f0, 0xf6ef, 0xff2f, 0xff70, 0xff30, 0xff30, 0xff30, 0xff30, 0xff50, 0xff50, 0xff50, 0xff50, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff70, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff50, 0xff30, 0xff30, 0xff30, 0xff30, 0xff30, 0xf730, 0xf730, 0xff50, 0xff10, 0xf710, 0xff11, 0xff32, 0xff33, 0xfef3, 0xfeb2, 0x9365, 0x6a01, 0x61e2, 0x7224, 0x6a03, 0x7202, 0xd54d, 0xfeb1, 0xf66e, 0xf68f, 0xf68f, 0xf68f, 0xf66e, 0xf60b, 0xf5a9, 0xed27, 0xe527, 0xed05, 0xeca3, 0xd444, 0xbc28, 0xfed7, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffbf, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffde, 0xe613, 0xd3e4, 0xdc44, 0xecc5, 0xf505, 0xed46, 0xed87, 0xf5ea, 0xf62c, 0xee4e, 0xf68e, 0xf66e, 0xf68e, 0xee4e, 0xfeb1, 0xf670, 0x9366, 0x6121, 0x8245, 0x79e3, 0x69c1, 0x9b87, 0xee50, 0xffb5, 0xff12, 0xfef0, 0xfed0, 0xf6af, 0xf6ce, 0xf70f, 0xff2f, 0xff2f, 0xff2e, 0xf72f, 0xff2f, 0xff2f, 0xff2f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff30, 0xff30, 0xff30, 0xff30, 0xf72f, 0xf72f, 0xf72f, 0xf72f, 0xff0f, 0xff0f, 0xff0f, 0xff0f, 0xff10, 0xff11, 0xfef1, 0xfef1, 0xfef2, 0xb4aa, 0x6201, 0x6a03, 0x7224, 0x71e2, 0x71e1, 0xed8e, 0xfef0, 0xf68f, 0xee6e, 0xf6af, 0xf64d, 0xedeb, 0xf5cb, 0xed48, 0xe546, 0xed25, 0xecc4, 0xdc43, 0xbbc5, 0xedf2, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffbf, 0xffdf, 0xfffe, 0xf7ff, 0xffff, 0xff9c, 0xd52e, 0xd404, 0xdc65, 0xece5, 0xf505, 0xed46, 0xed88, 0xf5ea, 0xf62c, 0xf66e, 0xfe8e, 0xfe8e, 0xf66d, 0xfeb0, 0xfe71, 0xb429, 0x61a0, 0x8a45, 0x6982, 0x69a1, 0xb46a, 0xfef2, 0xff32, 0xf6d0, 0xeeaf, 0xfeef, 0xff0f, 0xff2f, 0xff50, 0xff4f, 0xff4f, 0xff2e, 0xf70e, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xf72f, 0xf72f, 0xf72f, 0xf70e, 0xff2e, 0xff2f, 0xff2f, 0xff0f, 0xfeef, 0xfeef, 0xfecf, 0xff31, 0xff73, 0xddef, 0x7242, 0x7202, 0x69a1, 0x71c1, 0x92c5, 0xee0e, 0xfeb0, 0xf68f, 0xf66d, 0xf66d, 0xf60c, 0xf5cb, 0xed6a, 0xed46, 0xed25, 0xf505, 0xe464, 0xc3c4, 0xdd2d, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffbf, 0xffff, 0xffff, 0xf7ff, 0xffdf, 0xff7b, 0xc469, 0xd424, 0xe485, 0xece5, 0xed05, 0xed46, 0xed88, 0xf5eb, 0xf60d, 0xf64d, 0xfe8e, 0xf66d, 0xf68d, 0xff11, 0xd52c, 0x6a02, 0x61a2, 0x6981, 0x71e2, 0xcd0c, 0xff12, 0xff10, 0xf6cf, 0xeeae, 0xff71, 0xff2f, 0xff0f, 0xfeee, 0xf6ee, 0xf6ed, 0xf6ed, 0xf70e, 0xff4e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff4f, 0xff4f, 0xff4f, 0xff4f, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff2f, 0xff4f, 0xff2e, 0xf70e, 0xf6ee, 0xf6ee, 0xf6ee, 0xf6ee, 0xfece, 0xe64c, 0xff71, 0xff11, 0xee0f, 0x8ac3, 0x69a0, 0x71c2, 0x71a1, 0xabe7, 0xfe70, 0xfed0, 0xee2c, 0xf68d, 0xfe4c, 0xed8a, 0xed8a, 0xed66, 0xed26, 0xf506, 0xec84, 0xd3e3, 0xcc69, 0xffbb, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffbf, 0xffff, 0xfffe, 0xf7ff, 0xffdf, 0xff39, 0xbbe5, 0xd444, 0xe484, 0xecc5, 0xed05, 0xed46, 0xf5a9, 0xf60c, 0xf60d, 0xee2d, 0xf66d, 0xf64c, 0xfe8e, 0xe5ec, 0x9304, 0x5960, 0x7205, 0x69e1, 0xbc8a, 0xff32, 0xf6ef, 0xde4b, 0xff0e, 0xff0e, 0xfe8d, 0xff2f, 0xfeee, 0xf6cd, 0xff0e, 0xff2f, 0xff0e, 0xf70e, 0xf70e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff4f, 0xff4f, 0xff4f, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2f, 0xff2f, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xf70e, 0xf6ee, 0xf6ee, 0xf6cd, 0xf6cd, 0xf6cd, 0xf6ce, 0xff4f, 0xee6c, 0xf6ae, 0xff51, 0xddad, 0x7a41, 0x71e2, 0x7a03, 0x7201, 0xd50c, 0xfe90, 0xee2c, 0xf66c, 0xf64b, 0xeda9, 0xedaa, 0xe545, 0xe505, 0xece5, 0xec84, 0xdc03, 0xbbc5, 0xff7a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffbf, 0xffff, 0xfffe, 0xf7df, 0xffdf, 0xff19, 0xb383, 0xdc44, 0xe484, 0xecc4, 0xece4, 0xed46, 0xf5c9, 0xfe0c, 0xf62d, 0xee2d, 0xee2c, 0xf64c, 0xfead, 0xac25, 0x6180, 0x71e3, 0x69a4, 0xb48a, 0xff33, 0xf6cf, 0xde8c, 0xf72e, 0xf6ac, 0xfead, 0xfece, 0xfeee, 0xfeee, 0xff0f, 0xff50, 0xff70, 0xff4f, 0xff4f, 0xff70, 0xff2e, 0xff2e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff4e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2f, 0xff2f, 0xff2f, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2e, 0xff2f, 0xff4f, 0xff70, 0xff4f, 0xff0e, 0xf6ee, 0xfeee, 0xff0f, 0xf68c, 0xff0e, 0xf6ad, 0xf66d, 0xff52, 0xe5ce, 0x7a43, 0x69c3, 0x6140, 0xa366, 0xedee, 0xf68e, 0xee2b, 0xee0a, 0xedea, 0xf5ea, 0xe545, 0xe4e5, 0xecc5, 0xf484, 0xe422, 0xb363, 0xff38, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xf632, 0xcba4, 0xdc44, 0xe484, 0xece5, 0xed46, 0xed87, 0xeda8, 0xf5ca, 0xf5eb, 0xee0a, 0xfe6d, 0xfe8f, 0xdd8d, 0x7a83, 0x6180, 0x5960, 0xa3a9, 0xff30, 0xfe8d, 0xfeae, 0xfeee, 0xfecd, 0xf6ed, 0xfeec, 0xff0c, 0xff51, 0xfed0, 0xee4e, 0xdd8c, 0xc4a9, 0xa3a6, 0x9b25, 0x9304, 0x8b25, 0x8b25, 0x9b86, 0xac48, 0xc54b, 0xde0e, 0xf6f1, 0xff93, 0xff6e, 0xff4d, 0xf70c, 0xff6d, 0xf72c, 0xf72d, 0xff6e, 0xef0e, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xfef0, 0xff30, 0xf74d, 0xf76c, 0xef4b, 0xff8d, 0xffd0, 0xff2f, 0xf650, 0xdd6d, 0xbc69, 0xa3c7, 0x9b66, 0x9326, 0x9326, 0x9326, 0x9b47, 0xb3e9, 0xcd0c, 0xee0e, 0xfecf, 0xff4f, 0xff2e, 0xf6ec, 0xf68c, 0xfeac, 0xfeec, 0xf68b, 0xf64c, 0xfe8f, 0xdd6e, 0x6181, 0x69c3, 0x7223, 0xabe7, 0xfeb0, 0xf62c, 0xedea, 0xf60a, 0xeda9, 0xe526, 0xed25, 0xe4c5, 0xdcc6, 0xe444, 0xd3a3, 0xf5f2, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xedf1, 0xcb63, 0xe444, 0xe484, 0xece5, 0xed46, 0xed67, 0xeda8, 0xf5ca, 0xf5eb, 0xf64b, 0xfe6d, 0xedee, 0xb409, 0x6180, 0x5140, 0x8ac4, 0xedf0, 0xf68d, 0xfead, 0xee4c, 0xee4c, 0xf68d, 0xfeee, 0xff2f, 0xfece, 0xcd0b, 0xac07, 0x82c2, 0x69e0, 0x69a0, 0x69a0, 0x71c2, 0x7a03, 0x7202, 0x69c0, 0x6180, 0x59a0, 0x61c0, 0x7260, 0x8b63, 0xa426, 0xf6ce, 0xffb0, 0xf70e, 0xf70d, 0xff8e, 0xff6e, 0xef0c, 0xff6d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff4d, 0xff2e, 0xff8f, 0xef0c, 0xf76d, 0xfff1, 0xf70f, 0xc509, 0xa3e6, 0x7220, 0x69c0, 0x61a0, 0x69c0, 0x71e1, 0x7201, 0x7202, 0x7202, 0x71c2, 0x69a1, 0x6180, 0x7200, 0x8b23, 0xbca8, 0xee2d, 0xff31, 0xff30, 0xf64c, 0xf68c, 0xfecc, 0xf68c, 0xfeae, 0xfe91, 0xabe8, 0x6182, 0x6180, 0x9324, 0xeded, 0xfe4d, 0xedaa, 0xedca, 0xeda9, 0xed26, 0xed26, 0xe4e5, 0xdcc6, 0xdc44, 0xd3a3, 0xedd1, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xe58f, 0xc362, 0xe444, 0xe484, 0xece5, 0xed26, 0xed67, 0xeda8, 0xf5ca, 0xf5eb, 0xee0b, 0xfe4e, 0xe56e, 0x8284, 0x6160, 0x7a63, 0xc4ca, 0xff11, 0xe60a, 0xfecd, 0xf66c, 0xee2b, 0xfecf, 0xff10, 0xddcc, 0x9ba4, 0x7202, 0x71e1, 0x71e2, 0x7a03, 0x8224, 0x8245, 0x8a46, 0x8a66, 0x8a44, 0x8a64, 0x8a84, 0x8a83, 0x7a42, 0x71e0, 0x69c0, 0x69c0, 0x72a1, 0xc509, 0xfed0, 0xff50, 0xf70e, 0xff6d, 0xff8d, 0xf76b, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xf74d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff2d, 0xff6c, 0xf72b, 0xf74d, 0xff70, 0xd5cc, 0x9365, 0x7202, 0x69a2, 0x8242, 0x7a22, 0x7a22, 0x8263, 0x8a84, 0x8a64, 0x8264, 0x8264, 0x8245, 0x8244, 0x7a23, 0x71c2, 0x6160, 0x69c1, 0x9325, 0xbc6a, 0xf62e, 0xfecf, 0xfead, 0xf64b, 0xfeac, 0xf66c, 0xfe8e, 0xf66e, 0x8ae6, 0x6180, 0x69e0, 0xc488, 0xfe6e, 0xf5eb, 0xedca, 0xeda9, 0xed47, 0xed26, 0xe4e5, 0xdcc6, 0xe443, 0xd3a2, 0xe590, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xfffe, 0xdd2e, 0xcb62, 0xe444, 0xe484, 0xece5, 0xed26, 0xed67, 0xed88, 0xf5ca, 0xf5cb, 0xedea, 0xf60d, 0xc46a, 0x4880, 0x5940, 0xabe7, 0xee2d, 0xfecc, 0xf6ab, 0xee2a, 0xf68c, 0xff51, 0xfeb0, 0xc489, 0x8282, 0x61a0, 0x79e2, 0x7a23, 0x8a64, 0x8a85, 0x8a65, 0x8a45, 0x8a45, 0x8a45, 0x8a44, 0x8a44, 0x8a44, 0x9284, 0x9284, 0x8a64, 0x8a43, 0x8222, 0x6180, 0x6180, 0x9385, 0xe62e, 0xff30, 0xff4d, 0xf74b, 0xf74a, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xf72c, 0xff8e, 0xff4f, 0xbce9, 0x6a21, 0x69c2, 0x8a66, 0x81e5, 0x8a84, 0x8a64, 0x8a64, 0x8a64, 0x8a64, 0x8a64, 0x8a64, 0x8a64, 0x8a44, 0x8a64, 0x8a85, 0x8a85, 0x8244, 0x79e2, 0x71a2, 0x69a2, 0x9b85, 0xedee, 0xfef0, 0xf66d, 0xfe8c, 0xee2a, 0xf66b, 0xfecd, 0xbc8b, 0x69e0, 0x48c0, 0x8ac1, 0xf60d, 0xfe0c, 0xf5ca, 0xed69, 0xed47, 0xf526, 0xe4e5, 0xe4c5, 0xdc43, 0xd3a2, 0xdd4e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffde, 0xffff, 0xf7ff, 0xfffe, 0xd50c, 0xd3a2, 0xe444, 0xe484, 0xece5, 0xed26, 0xed67, 0xed88, 0xf5aa, 0xf5cb, 0xf60b, 0xf60d, 0xccaa, 0x69c0, 0x9305, 0xdd4b, 0xfead, 0xf649, 0xf66a, 0xf66b, 0xff50, 0xfe4f, 0xabe7, 0x7201, 0x6980, 0x8264, 0x8a83, 0x8a83, 0x8a83, 0x8a64, 0x8a64, 0x8a84, 0x8aa4, 0x8aa4, 0x9aa5, 0x9285, 0x9264, 0x8a64, 0x9264, 0x9284, 0x9284, 0x9264, 0x8a65, 0x69a2, 0x5940, 0x8b04, 0xdded, 0xff4f, 0xff4c, 0xf74a, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff4c, 0xff4c, 0xff4c, 0xff4c, 0xff4c, 0xff4c, 0xff4c, 0xff4c, 0xffb1, 0xee8e, 0xa427, 0x69e0, 0x69a1, 0x8a65, 0x9286, 0x8a65, 0x8a85, 0x9285, 0x92a5, 0x9285, 0x9285, 0x9285, 0x92a5, 0x92a5, 0x8aa2, 0x8aa3, 0x8a83, 0x8a83, 0x8a84, 0x8a64, 0x8224, 0x79e2, 0x69c1, 0x9305, 0xdd6c, 0xfed0, 0xfe8d, 0xee2a, 0xfecc, 0xee29, 0xedee, 0xabe6, 0x7a40, 0xa343, 0xf5ed, 0xf5eb, 0xf5aa, 0xed89, 0xed47, 0xf526, 0xe4e5, 0xe4a5, 0xe443, 0xd3a2, 0xd50d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xfffd, 0xcccb, 0xdbc2, 0xe444, 0xe484, 0xecc5, 0xed26, 0xf547, 0xed88, 0xf5a9, 0xf5ca, 0xf5eb, 0xf62d, 0xf5ed, 0xdd2b, 0xedcc, 0xf64d, 0xfe8b, 0xf68a, 0xe629, 0xff2e, 0xfef0, 0xa386, 0x6160, 0x79e2, 0x8a64, 0x9285, 0x8242, 0x8a62, 0x8a63, 0x8282, 0x8283, 0x82a3, 0x8282, 0x7a62, 0x7a22, 0x8263, 0x8a64, 0x8a64, 0x8a64, 0x8a64, 0x8a64, 0x8a43, 0x8224, 0x92c6, 0x8244, 0x6180, 0x82c3, 0xd5ab, 0xffd0, 0xf70c, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff13, 0x9ba6, 0x61a0, 0x71c2, 0x8a65, 0x8a64, 0x8223, 0x8242, 0x8a64, 0x8a84, 0x8a64, 0x8243, 0x8243, 0x8a83, 0x8a83, 0x8a83, 0x8281, 0x8aa2, 0x8ac3, 0x8282, 0x8242, 0x8a63, 0x9284, 0x9284, 0x7203, 0x69a1, 0x8ae4, 0xdd4c, 0xfeaf, 0xf64b, 0xf66a, 0xee29, 0xfe6e, 0xf62d, 0xdd6a, 0xe58b, 0xfe2d, 0xed8a, 0xed88, 0xf5e9, 0xf528, 0xf506, 0xe4c5, 0xe4a5, 0xe443, 0xdbc2, 0xd4ec, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffd, 0xc469, 0xd3c2, 0xe444, 0xec84, 0xecc5, 0xed26, 0xf547, 0xed68, 0xf589, 0xf5aa, 0xf5eb, 0xf5eb, 0xf60a, 0xfe6b, 0xf64a, 0xf64a, 0xee09, 0xfe8b, 0xf6ab, 0xfead, 0xbc68, 0x7a22, 0x79e3, 0x8a44, 0x8203, 0x8a23, 0x8a64, 0x8a84, 0x8263, 0x7201, 0x69e0, 0x7201, 0x7241, 0x7262, 0x7241, 0x7241, 0x7221, 0x69e0, 0x71e1, 0x7a22, 0x8263, 0x8243, 0x9a84, 0x81e3, 0x8244, 0x8245, 0x5980, 0x7ae2, 0xee8e, 0xff2f, 0xf70b, 0xf70b, 0xf70b, 0xf70b, 0xf70b, 0xf70b, 0xf70b, 0xf70b, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xb429, 0x7a22, 0x8203, 0x9285, 0x8a03, 0x8a44, 0x92c4, 0x7a62, 0x7202, 0x7a22, 0x7a22, 0x7201, 0x7221, 0x7a41, 0x7a41, 0x7200, 0x7241, 0x7221, 0x7200, 0x7a22, 0x8263, 0x8a84, 0x8a84, 0x8a44, 0x8245, 0x8244, 0x6980, 0x92e4, 0xf62e, 0xfe6d, 0xee0a, 0xf66a, 0xe5e9, 0xfe6c, 0xf60b, 0xfe2c, 0xf5eb, 0xed68, 0xed67, 0xf5c8, 0xed27, 0xf4e6, 0xecc5, 0xe4a5, 0xe442, 0xdbc1, 0xd4cb, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdc, 0xbc28, 0xd380, 0xe444, 0xec84, 0xecc5, 0xf506, 0xf547, 0xed68, 0xf589, 0xf5aa, 0xedca, 0xf60a, 0xeda7, 0xf648, 0xede6, 0xfe8a, 0xee0a, 0xf62b, 0xee6a, 0xf66d, 0x9324, 0x6160, 0x8a66, 0x8a25, 0x81c2, 0x81c1, 0x69a1, 0x7a44, 0x92e6, 0xa389, 0xb44b, 0xcd0d, 0xdd8f, 0xddd0, 0xe650, 0xe610, 0xddae, 0xc4ec, 0xb449, 0xa387, 0x82a4, 0x71e1, 0x8a01, 0x7981, 0x79c2, 0x92a7, 0x7203, 0x61c0, 0xc54b, 0xff72, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xf72b, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0xff2c, 0x7a42, 0x71c1, 0x8203, 0x8a24, 0x81c2, 0x71a1, 0x71e1, 0x8282, 0x9b67, 0xabe9, 0xbc6b, 0xccec, 0xdd6e, 0xe5cf, 0xe5ce, 0xdd8d, 0xcd2e, 0xc4ac, 0xabea, 0x9b47, 0x8285, 0x7a03, 0x71c2, 0x79e3, 0x71c4, 0x8aa6, 0x71c2, 0x71e1, 0xcceb, 0xfe8f, 0xfead, 0xede9, 0xee08, 0xf64a, 0xe588, 0xedca, 0xedaa, 0xf5c9, 0xed87, 0xed86, 0xed27, 0xece6, 0xe4c5, 0xe4a5, 0xe442, 0xdbe1, 0xccaa, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdd, 0xbc08, 0xd360, 0xdc65, 0xe485, 0xe4c5, 0xed05, 0xed25, 0xed46, 0xed68, 0xf589, 0xf5a9, 0xfd8a, 0xfd8a, 0xf5c9, 0xee29, 0xee28, 0xee09, 0xfe0a, 0xfe4d, 0xe58c, 0x8262, 0x5940, 0x69c1, 0x7242, 0x9b85, 0xb468, 0xe60d, 0xee4e, 0xf6cf, 0xff0f, 0xff4f, 0xff6e, 0xff4c, 0xff2b, 0xf70c, 0xff2c, 0xff4d, 0xff6d, 0xff6d, 0xff4d, 0xf72c, 0xef0b, 0xcd8a, 0xac68, 0x7ac4, 0x6a23, 0x5160, 0x5160, 0xac68, 0xff31, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70b, 0xf70b, 0xf70b, 0xf70b, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0x6222, 0x59c0, 0x59c0, 0x6a81, 0x93a5, 0xbd0a, 0xe62e, 0xf6f0, 0xff8d, 0xff8d, 0xff6d, 0xff6d, 0xff6d, 0xff4d, 0xff4d, 0xff4d, 0xff6d, 0xff4d, 0xff2d, 0xff0e, 0xfeaf, 0xe5ed, 0xc4ea, 0xac27, 0x7ac2, 0x69a2, 0x6960, 0x6141, 0xbc2a, 0xfe2c, 0xfe0a, 0xfdc5, 0xf5ec, 0xf5ec, 0xedea, 0xeda8, 0xfda6, 0xfdc7, 0xf588, 0xdd29, 0xe507, 0xed05, 0xe4c5, 0xdca4, 0xe422, 0xdba1, 0xccab, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffde, 0xc44a, 0xd380, 0xdc65, 0xe485, 0xe4c5, 0xed05, 0xed25, 0xed46, 0xed68, 0xf589, 0xf5ca, 0xfdca, 0xfdaa, 0xf5ca, 0xf62b, 0xe62a, 0xede8, 0xfe27, 0xfe6b, 0xf62b, 0xbc87, 0xb427, 0xd50b, 0xdd8c, 0xfe8e, 0xff2f, 0xfecd, 0xfecd, 0xfeec, 0xfeec, 0xfeeb, 0xfeea, 0xfee9, 0xfee9, 0xf70b, 0xff0b, 0xff2c, 0xff4c, 0xff4c, 0xf72b, 0xf72b, 0xf70b, 0xff4e, 0xff70, 0xf68f, 0xddcd, 0xac68, 0x93c4, 0xcda9, 0xff4e, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xff0b, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xac67, 0xb4a8, 0xcd6a, 0xee6d, 0xff2f, 0xff4f, 0xff2e, 0xff2e, 0xf70b, 0xf70b, 0xf70b, 0xf6eb, 0xf6eb, 0xf6eb, 0xf6ca, 0xf6ca, 0xf70a, 0xf6ca, 0xf6ca, 0xfecb, 0xfeed, 0xff0e, 0xfeee, 0xfeae, 0xf66d, 0xcccb, 0xb3e6, 0xa366, 0xe58c, 0xfeac, 0xf60b, 0xf5c7, 0xfdc9, 0xfd87, 0xfda6, 0xf5e8, 0xe5ea, 0xdd8a, 0xed48, 0xfd46, 0xe506, 0xed05, 0xe4c5, 0xdca5, 0xe422, 0xdba1, 0xd4ab, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xd4cc, 0xd3a1, 0xdc44, 0xe484, 0xe4a5, 0xed05, 0xed05, 0xed46, 0xed67, 0xf588, 0xeda8, 0xed89, 0xf589, 0xfdc9, 0xf64a, 0xde4b, 0xd5ca, 0xee09, 0xfe68, 0xfeca, 0xf64a, 0xfe6c, 0xfecd, 0xfeac, 0xfeab, 0xfeaa, 0xfee9, 0xf6e9, 0xf6c9, 0xf6c8, 0xf6c8, 0xf6c8, 0xf6e8, 0xff09, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf72a, 0xf709, 0xff4b, 0xff0b, 0xff2d, 0xff2d, 0xf6eb, 0xff2b, 0xf6e9, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xf70a, 0xff0a, 0xff0a, 0xff0a, 0xff2d, 0xff0c, 0xff0c, 0xff2c, 0xff4b, 0xff2a, 0xf709, 0xf709, 0xf6ea, 0xf6ea, 0xf6ea, 0xf6ea, 0xf6ca, 0xf6ca, 0xf6ca, 0xf6ca, 0xf6e8, 0xf6c8, 0xeea8, 0xee88, 0xf688, 0xf6a9, 0xfeaa, 0xfeaa, 0xfeeb, 0xfe6d, 0xfe8b, 0xedea, 0xf64b, 0xe648, 0xcdab, 0xde8e, 0xfde5, 0xfda5, 0xed87, 0xedc9, 0xedca, 0xed88, 0xed47, 0xed26, 0xed06, 0xece5, 0xe4c5, 0xe4a5, 0xe422, 0xd381, 0xd4ec, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xdd2e, 0xcb61, 0xdc24, 0xe464, 0xe4a4, 0xece5, 0xed05, 0xed26, 0xed47, 0xf568, 0xe547, 0xeda8, 0xfde7, 0xfdc7, 0xd5ab, 0x9d2e, 0x950c, 0xd5ec, 0xf626, 0xfe48, 0xf649, 0xfe6a, 0xfe8a, 0xf669, 0xf688, 0xf688, 0xee87, 0xf687, 0xf6a7, 0xf6c8, 0xfec8, 0xfee9, 0xfee9, 0xfee9, 0xfee9, 0xf6e9, 0xf6e9, 0xf6e8, 0xf6e9, 0xf709, 0xf709, 0xf729, 0xf6e7, 0xff29, 0xf6e8, 0xff09, 0xff29, 0xff29, 0xff69, 0xf6e7, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xf709, 0xff0a, 0xff0a, 0xff0a, 0xff0a, 0xff2a, 0xff2a, 0xff09, 0xf6e9, 0xf6e8, 0xf6e7, 0xf6e7, 0xf707, 0xff48, 0xff0a, 0xff0a, 0xff0a, 0xfeea, 0xfeea, 0xfeea, 0xfeca, 0xfeca, 0xf6a8, 0xf6c8, 0xf6c8, 0xf6a8, 0xf6a8, 0xf688, 0xf667, 0xf667, 0xf646, 0xf62a, 0xfeca, 0xfe69, 0xf689, 0xd608, 0x94cb, 0x8d30, 0xedc7, 0xee09, 0xede9, 0xe587, 0xf565, 0xfd86, 0xf547, 0xdce7, 0xece6, 0xecc5, 0xe4a5, 0xe4a5, 0xe423, 0xd381, 0xdd4e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffde, 0xe5b0, 0xc340, 0xdc24, 0xdc44, 0xe484, 0xecc4, 0xed05, 0xed26, 0xed27, 0xed48, 0xfd46, 0xedc6, 0xe627, 0xbd89, 0x7cb1, 0x3bf5, 0x642e, 0xd609, 0xf627, 0xf628, 0xf628, 0xf628, 0xf628, 0xf648, 0xfe88, 0xfea9, 0xf687, 0xf6a8, 0xf6a8, 0xfec9, 0xfec9, 0xfeaa, 0xf6aa, 0xf68a, 0xf6e8, 0xfee8, 0xf6e8, 0xfee8, 0xff08, 0xf708, 0xf708, 0xf708, 0xf6e8, 0xff29, 0xff29, 0xff28, 0xf6e7, 0xeea7, 0xff29, 0xff49, 0xff09, 0xff09, 0xff09, 0xff09, 0xff09, 0xff09, 0xff09, 0xff09, 0xf6e8, 0xf6e8, 0xff09, 0xff09, 0xff09, 0xff09, 0xff09, 0xff09, 0xff09, 0xff29, 0xff29, 0xff49, 0xff29, 0xff28, 0xff08, 0xf707, 0xf6e9, 0xf6e9, 0xf6e9, 0xf6e9, 0xf6c9, 0xf6c9, 0xf6c9, 0xf6a9, 0xf689, 0xf689, 0xfe89, 0xfea9, 0xfe89, 0xfe89, 0xfea9, 0xfea9, 0xfe68, 0xfe4a, 0xfe48, 0xf5e7, 0xfe48, 0xd62a, 0x6c2e, 0x3bd1, 0x7cef, 0xad8d, 0xe5c9, 0xf585, 0xf544, 0xf566, 0xed48, 0xed07, 0xece5, 0xecc4, 0xe4a4, 0xdca5, 0xe423, 0xcb61, 0xedb0, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffdf, 0xf612, 0xbb20, 0xdc03, 0xdc24, 0xe484, 0xecc4, 0xece5, 0xed06, 0xed27, 0xed27, 0xfdc3, 0xcd49, 0x8cee, 0x6491, 0x3cd8, 0x1c99, 0x5c4f, 0xf5c9, 0xf608, 0xf608, 0xf5e8, 0xf608, 0xf608, 0xf628, 0xf648, 0xf648, 0xfea9, 0xfe88, 0xfe89, 0xfe89, 0xfe89, 0xfe89, 0xfe8a, 0xfeaa, 0xfec8, 0xfec8, 0xfee8, 0xff08, 0xff08, 0xff08, 0xff08, 0xf708, 0xfee8, 0xf6e8, 0xf6c7, 0xff09, 0xff29, 0xf6e8, 0xf6e8, 0xf6c8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xff08, 0xff08, 0xff08, 0xf6e9, 0xff09, 0xfee9, 0xf6c8, 0xf6e8, 0xfee8, 0xff08, 0xfee8, 0xf6e9, 0xf6e9, 0xf6e8, 0xfec8, 0xfec8, 0xf6a8, 0xfea8, 0xfea8, 0xfeaa, 0xfeaa, 0xfe89, 0xf669, 0xf648, 0xf628, 0xf628, 0xf628, 0xfe27, 0xfe2b, 0xfe49, 0xf5c7, 0xfde7, 0xde2b, 0x6c71, 0x3477, 0x4495, 0x64b1, 0x9d0c, 0xcd48, 0xed87, 0xf567, 0xed27, 0xe4e7, 0xecc5, 0xeca4, 0xe484, 0xdc85, 0xdc23, 0xc341, 0xf612, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xfe94, 0xb321, 0xdbe3, 0xdc23, 0xe464, 0xecc4, 0xece5, 0xed05, 0xed06, 0xed27, 0xbd68, 0x74d0, 0x5477, 0x5c98, 0x559b, 0x2d79, 0x64af, 0xfdaa, 0xfe29, 0xfe28, 0xf5e7, 0xf607, 0xfe47, 0xfe47, 0xfe68, 0xfe67, 0xf668, 0xf668, 0xf668, 0xf668, 0xf688, 0xfe88, 0xfea9, 0xfec9, 0xfea7, 0xfea8, 0xfec8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xfee8, 0xff08, 0xfee8, 0xff08, 0xfee8, 0xf6e8, 0xff08, 0xff08, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6c8, 0xfee8, 0xf6e8, 0xf6c8, 0xf6e8, 0xff09, 0xfee8, 0xf6c8, 0xfee8, 0xfee8, 0xfee8, 0xfec8, 0xfec8, 0xfec8, 0xfea8, 0xfea8, 0xfea8, 0xfea8, 0xfe88, 0xfe88, 0xfe68, 0xfe68, 0xfe68, 0xfe68, 0xfe47, 0xf5ea, 0xede8, 0xfdc8, 0xfde7, 0xe62a, 0x6cb1, 0x34f9, 0x5d18, 0x54f7, 0x54d4, 0x7cf0, 0xb52b, 0xe548, 0xed26, 0xdcc6, 0xecc5, 0xec83, 0xe463, 0xdc65, 0xdc03, 0xc321, 0xfe54, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xfed6, 0xbb42, 0xd3e3, 0xdc23, 0xe464, 0xecc4, 0xece5, 0xed05, 0xed06, 0xed07, 0x4455, 0x3cd8, 0x65b9, 0x95d8, 0x7ddc, 0x3cfb, 0x544f, 0xf5e8, 0xf5c7, 0xfde7, 0xedc5, 0xfe26, 0xfe87, 0xfe67, 0xfe66, 0xf625, 0xf667, 0xf667, 0xfe87, 0xfe87, 0xfe87, 0xfe86, 0xfe86, 0xfe86, 0xfea8, 0xfea8, 0xfea8, 0xf6c8, 0xf6c8, 0xf6c8, 0xfee8, 0xfee8, 0xf6e7, 0xff07, 0xf6e7, 0xf6c7, 0xf6c7, 0xff07, 0xff07, 0xf6c6, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xf6e8, 0xff07, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e8, 0xff08, 0xf6e8, 0xf6c7, 0xf6e7, 0xff08, 0xff28, 0xf6e8, 0xf6c8, 0xf6c7, 0xf6c7, 0xf6a7, 0xf6a7, 0xf6a7, 0xf687, 0xf687, 0xfea6, 0xf686, 0xf665, 0xf646, 0xf666, 0xfe67, 0xfe68, 0xfe68, 0xfea7, 0xf60a, 0xedc7, 0xfdc7, 0xfdc5, 0xdde7, 0x648f, 0x3d7a, 0x6ddc, 0x75fc, 0x6579, 0x4c94, 0x6450, 0x9cec, 0xe526, 0xfce1, 0xeca4, 0xec83, 0xe463, 0xdc64, 0xdc03, 0xc321, 0xfe95, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffde, 0xffde, 0xffff, 0xf7ff, 0xffff, 0xff59, 0xab45, 0xcbc2, 0xd404, 0xe444, 0xfc63, 0xfca4, 0xcca9, 0x6491, 0x1499, 0x5d39, 0x7e5b, 0x965c, 0xa63b, 0x867b, 0x4538, 0x74ae, 0xfde5, 0xc487, 0x8262, 0x71c2, 0x8aa5, 0xb3a7, 0xd4c9, 0xf58a, 0xfe4d, 0xfea6, 0xfea6, 0xfea6, 0xf686, 0xf685, 0xf686, 0xf6c6, 0xfee7, 0xfe87, 0xfea7, 0xfea7, 0xfea7, 0xfec7, 0xf6c7, 0xf6c7, 0xf6a6, 0xf6e6, 0xf6e6, 0xf6e6, 0xf6e7, 0xf6e7, 0xf6e7, 0xf707, 0xf707, 0xf6c7, 0xf6c7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e7, 0xf706, 0xf706, 0xf706, 0xf6e6, 0xf6e6, 0xf6e7, 0xf6e6, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e8, 0xfee8, 0xfec8, 0xfec7, 0xfec7, 0xfea7, 0xf6c6, 0xf6c6, 0xf6c6, 0xf6a7, 0xf6a7, 0xfe88, 0xfe88, 0xfe88, 0xee63, 0xf6a5, 0xfea6, 0xfea7, 0xfea8, 0xfe69, 0xeda7, 0xd505, 0xb365, 0x82a4, 0x8a00, 0x71a4, 0xcc09, 0xfe2a, 0x646e, 0x4559, 0x9dfa, 0xa67c, 0x8e3c, 0x75dc, 0x5519, 0x4412, 0x7490, 0xad70, 0xfc43, 0xfc83, 0xdc62, 0xe423, 0xdb84, 0xb2e5, 0xff79, 0xf7fd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffde, 0xffdf, 0xffff, 0xf7df, 0xffff, 0xffba, 0xc449, 0xd382, 0xec02, 0xf462, 0xd466, 0x9c8c, 0x64b2, 0x54d6, 0x5d59, 0x861c, 0x9efd, 0xaede, 0xb69d, 0x869c, 0x3d38, 0x6c8e, 0xf5e6, 0x8281, 0x5940, 0x5100, 0x5921, 0x5940, 0x69a0, 0x7a00, 0x8a60, 0xbc46, 0xccc7, 0xe589, 0xf64a, 0xfe8a, 0xfea8, 0xfea7, 0xf6a6, 0xf6c8, 0xf6c8, 0xf6c7, 0xf6c7, 0xf6c6, 0xf6c6, 0xf6e6, 0xf707, 0xfee8, 0xff08, 0xff08, 0xfee8, 0xf6c7, 0xf6c7, 0xf6a7, 0xf6a7, 0xf6e6, 0xf6e6, 0xf6e6, 0xf6c6, 0xf6c6, 0xf6c6, 0xf6c6, 0xf6c6, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6e8, 0xf6e8, 0xfee8, 0xfee8, 0xfee8, 0xf727, 0xef06, 0xeee6, 0xf6e6, 0xf6e6, 0xf6e6, 0xfee6, 0xf6e6, 0xf6c8, 0xf6c7, 0xf6a7, 0xeea6, 0xf6a6, 0xf6c6, 0xf6c6, 0xfec6, 0xfea9, 0xf668, 0xe5a7, 0xccc6, 0xabc5, 0x92e4, 0x71e2, 0x6120, 0x6140, 0x5140, 0x6920, 0x58e1, 0x9ac4, 0xf588, 0x64af, 0x457a, 0x9e1b, 0xaedd, 0xaede, 0x9edf, 0x7e5e, 0x5d38, 0x5473, 0x5c0f, 0x9caa, 0xcca9, 0xec24, 0xf3c1, 0xd381, 0xbc48, 0xfffc, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xffba, 0xcccd, 0xd341, 0xe3e3, 0xc446, 0x7c6d, 0x3cb5, 0x2d1a, 0x5dbb, 0xa67c, 0xb6de, 0xbf7f, 0xc73f, 0xc6fe, 0x8e9d, 0x3cf8, 0x644f, 0xf5c6, 0x69c0, 0x5940, 0x61a4, 0x61c5, 0x5162, 0x5160, 0x5960, 0x6180, 0x6120, 0x6981, 0x7a01, 0x8ac2, 0xa383, 0xc485, 0xdd67, 0xede8, 0xee87, 0xf6c7, 0xfee8, 0xff07, 0xff06, 0xf705, 0xf705, 0xf705, 0xeea6, 0xf6c6, 0xf6e7, 0xf6e7, 0xf6e7, 0xf6e6, 0xf6e6, 0xff06, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xfee8, 0xff08, 0xf6e7, 0xf6e7, 0xf6e7, 0xfee7, 0xf6e7, 0xf6e7, 0xf6c7, 0xf6c7, 0xef26, 0xef06, 0xef06, 0xf706, 0xf707, 0xf727, 0xf6e7, 0xf6c6, 0xfee8, 0xfee8, 0xfee9, 0xfea9, 0xf669, 0xddc8, 0xcd26, 0xbca4, 0x9b04, 0x8a82, 0x7201, 0x6180, 0x5920, 0x5120, 0x5942, 0x6183, 0x5120, 0x59c5, 0x71a1, 0x50e2, 0x79e0, 0xe546, 0x64cf, 0x3d79, 0x963c, 0xb6fe, 0xbf1e, 0xbf5f, 0xa75f, 0x7e9f, 0x5d7a, 0x4475, 0x2cd3, 0x6c4f, 0xc3e8, 0xebc3, 0xc360, 0xc4ea, 0xfffd, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdc, 0xde13, 0xbb64, 0x93e9, 0x5c50, 0x34b6, 0x355a, 0x5dfd, 0x8e9e, 0xbf5f, 0xcf3e, 0xcf7e, 0xcf1f, 0xc6df, 0x867d, 0x34d9, 0x6450, 0xf5c7, 0x7200, 0x5961, 0x7ac9, 0x93cf, 0x834b, 0x72c7, 0x6204, 0x5182, 0x6161, 0x6161, 0x6161, 0x6160, 0x6160, 0x6180, 0x69a0, 0x69c0, 0x8b00, 0x9b81, 0xb444, 0xcd26, 0xdda7, 0xee28, 0xf688, 0xfec9, 0xf6c7, 0xfee7, 0xff08, 0xff07, 0xfee7, 0xf6e6, 0xfee6, 0xfee6, 0xfee7, 0xfee7, 0xfee7, 0xfee7, 0xf6c7, 0xf6c7, 0xf6c7, 0xf6c7, 0xeea4, 0xf6c4, 0xf6c5, 0xf6e6, 0xff06, 0xff06, 0xfee6, 0xfee6, 0xff09, 0xff09, 0xff0a, 0xff0a, 0xff0a, 0xfeca, 0xf689, 0xee48, 0xe588, 0xd506, 0xbc24, 0xa363, 0x8aa2, 0x7a21, 0x69a1, 0x6161, 0x6982, 0x6161, 0x6161, 0x6182, 0x61a2, 0x59a2, 0x6204, 0x6a45, 0x8b4c, 0x9410, 0x8aa6, 0x5943, 0x7a00, 0xe566, 0x64ef, 0x3559, 0x8e3d, 0xb71f, 0xcf1c, 0xcf3d, 0xc77f, 0xa73f, 0x8edf, 0x6e1d, 0x253b, 0x3454, 0x642d, 0x9c29, 0xa365, 0xe590, 0xffbd, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xffbf, 0xffde, 0xffff, 0xffff, 0xe77c, 0x6bce, 0x4c53, 0x24b9, 0x2d5c, 0x6e3d, 0xa6dd, 0xbf3e, 0xc79f, 0xdf5e, 0xd77e, 0xcf1f, 0xc6df, 0x865d, 0x34d9, 0x6c70, 0xfde8, 0x8a62, 0x5120, 0x7aea, 0xbd55, 0xbdb6, 0xb554, 0xacd2, 0xa471, 0x8b2a, 0x82a8, 0x6a26, 0x61c3, 0x5982, 0x6182, 0x69c2, 0x69e2, 0x6143, 0x6142, 0x6142, 0x6961, 0x71a1, 0x7a01, 0x8a82, 0x9ac3, 0xac43, 0xbc84, 0xc505, 0xd566, 0xe5e8, 0xee49, 0xf6aa, 0xfeea, 0xf6c6, 0xfec7, 0xfee7, 0xff08, 0xff08, 0xff08, 0xff08, 0xff07, 0xff29, 0xff2a, 0xff29, 0xfee9, 0xfec9, 0xf6a8, 0xf688, 0xee67, 0xe569, 0xdd28, 0xccc7, 0xbc45, 0xaba3, 0x9321, 0x8280, 0x7a20, 0x6920, 0x6940, 0x6920, 0x6940, 0x6961, 0x6982, 0x6982, 0x6962, 0x5980, 0x61a1, 0x6a24, 0x7ac8, 0x8b6b, 0x9c0f, 0xacd3, 0xc576, 0xbd35, 0xbd77, 0x82a6, 0x5102, 0x92a2, 0xf5c7, 0x64cf, 0x2d39, 0x867f, 0xbf3f, 0xd73c, 0xe75b, 0xdf9d, 0xc75f, 0xb73f, 0x9ede, 0x663f, 0x3d5a, 0x2cd4, 0x4471, 0x6c0f, 0xeeda, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xd7bf, 0x9e7c, 0x1c99, 0x2d1b, 0x457b, 0x661d, 0x96de, 0xb73e, 0xcf3d, 0xdf7d, 0xdf7f, 0xd79f, 0xcf3f, 0xbedf, 0x763d, 0x2cd9, 0x6c90, 0xfdc7, 0xbba6, 0x5920, 0x6a48, 0xb535, 0xc638, 0xc638, 0xce18, 0xd619, 0xd5f9, 0xcdb7, 0xbd54, 0xacb1, 0x9c0d, 0x8349, 0x72a5, 0x6a63, 0x61a5, 0x69a4, 0x69a4, 0x69a3, 0x69a2, 0x71a2, 0x7181, 0x7180, 0x6160, 0x6160, 0x6180, 0x69c0, 0x7200, 0x7221, 0x7a41, 0x7a61, 0x9321, 0x9341, 0x9b82, 0xa3c3, 0xabe4, 0xac04, 0xac04, 0xac04, 0xabe5, 0xa3c4, 0xa383, 0x9342, 0x8b01, 0x82c0, 0x7a80, 0x7a60, 0x79e0, 0x71c0, 0x71a0, 0x6980, 0x6980, 0x69a1, 0x71c2, 0x71e3, 0x79e2, 0x71c2, 0x69a2, 0x6182, 0x69c3, 0x7246, 0x8ae9, 0x934a, 0x9c30, 0xac92, 0xbd34, 0xcdd7, 0xd618, 0xce19, 0xce19, 0xce39, 0xcdf9, 0xad76, 0x69e3, 0x48e0, 0xb385, 0xfde7, 0x6ccf, 0x2cf9, 0x867f, 0xb73f, 0xd73c, 0xef7c, 0xefbe, 0xd77e, 0xc73e, 0xbedd, 0x96df, 0x661c, 0x3d9b, 0x2d19, 0x3496, 0x967c, 0xe79e, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffd, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xd77e, 0x85db, 0x44fa, 0x1d1d, 0x45bd, 0x763c, 0x96bd, 0xaf3f, 0xbf5f, 0xc73e, 0xdf7e, 0xd77f, 0xcfbf, 0xc75f, 0xb6bf, 0x6e1c, 0x2cd8, 0x6c8f, 0xfda5, 0xcc06, 0x6100, 0x5163, 0x9471, 0xbdf7, 0xc638, 0xc619, 0xd61a, 0xce7b, 0xce7b, 0xd69b, 0xde9a, 0xde99, 0xd637, 0xcdd5, 0xc594, 0xbd30, 0xac8e, 0x93cb, 0x7b08, 0x7286, 0x7265, 0x7244, 0x7224, 0x71e6, 0x71c5, 0x69a4, 0x69a3, 0x69a3, 0x69c2, 0x69c2, 0x69a1, 0x6161, 0x6182, 0x69a2, 0x69c3, 0x69c3, 0x69c3, 0x69c3, 0x69a2, 0x69c1, 0x69a1, 0x69a1, 0x69a1, 0x69a2, 0x69c2, 0x71e2, 0x71e3, 0x71e2, 0x71e2, 0x69e2, 0x69c3, 0x61a3, 0x69c5, 0x6a06, 0x7247, 0x7ae7, 0x8349, 0x9bec, 0xac90, 0xb533, 0xc596, 0xcdf8, 0xd63a, 0xce5c, 0xd67d, 0xd69c, 0xd67b, 0xce7a, 0xce79, 0xce58, 0xce38, 0xc619, 0x9493, 0x6180, 0x5940, 0xd467, 0xfdc7, 0x6caf, 0x2c99, 0x7e3e, 0xaf1f, 0xcf3d, 0xdf7d, 0xdfbf, 0xcf7f, 0xc75f, 0xc71e, 0xa6fe, 0x865d, 0x663e, 0x3ddd, 0x1cf9, 0x3d38, 0x7dd9, 0xd75f, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffd, 0xf7ff, 0xf7ff, 0xf7ff, 0xe77e, 0x8d57, 0x3c56, 0x2cdc, 0x453a, 0x5dfc, 0x7e7d, 0x9efd, 0xb75e, 0xbf5e, 0xc73f, 0xc77f, 0xcf3e, 0xc79f, 0xbf3f, 0xa69f, 0x65fb, 0x2cd8, 0x6c8f, 0xfd84, 0xf509, 0x79c0, 0x5162, 0x8c0e, 0xbe17, 0xce99, 0xce59, 0xd63b, 0xcefa, 0xceda, 0xceba, 0xcebb, 0xd6dd, 0xdede, 0xe6df, 0xe6bf, 0xdefc, 0xdebb, 0xde9b, 0xde7a, 0xd639, 0xcdd8, 0xbd36, 0xb4b4, 0xbc0e, 0xb3ac, 0xa34a, 0x92e8, 0x8ac6, 0x8aa5, 0x7a43, 0x7a22, 0x7a22, 0x7a22, 0x7a22, 0x7a22, 0x7202, 0x7202, 0x71e1, 0x71e1, 0x7a03, 0x7203, 0x7203, 0x7203, 0x7a04, 0x7a25, 0x8265, 0x8266, 0x7aa5, 0x8b07, 0x93aa, 0xa40c, 0xac6e, 0xb4f1, 0xc553, 0xcdb5, 0xcdfa, 0xd65c, 0xdebd, 0xdefd, 0xd6dc, 0xcedb, 0xcedb, 0xcefb, 0xc6d9, 0xcefa, 0xceda, 0xce99, 0xc699, 0xce7a, 0xce5a, 0xc639, 0xbdb7, 0x7bcf, 0x5940, 0x69a1, 0xece9, 0xfd86, 0x74b0, 0x2479, 0x75fd, 0xa6ff, 0xc73e, 0xcf7f, 0xc79f, 0xbf5f, 0xbf5f, 0xbf3f, 0xb6ff, 0xa6ff, 0x7e9f, 0x4dfd, 0x2d7a, 0x2cf8, 0x3cd8, 0x6d9b, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 
0xefff, 0xf7de, 0xffff, 0xd79f, 0x6d98, 0x34f8, 0x2d1c, 0x357f, 0x45bd, 0x665f, 0x8edf, 0xaf1f, 0xb71f, 0xbf5f, 0xbf7f, 0xb77f, 0xcf5d, 0xbf5f, 0xaf1f, 0x8ebd, 0x4dfd, 0x24b9, 0x7c8e, 0xfd45, 0xf5c7, 0xa342, 0x50e0, 0x7a89, 0xcd75, 0xd638, 0xce5a, 0xce7b, 0xd67a, 0xd69b, 0xd69b, 0xd6bb, 0xd6bc, 0xd6dc, 0xdefd, 0xdf1e, 0xe71d, 0xe71d, 0xe71d, 0xe73d, 0xe73d, 0xe73d, 0xe73d, 0xdf3d, 0xdefc, 0xdefc, 0xdedb, 0xd6bb, 0xce5a, 0xc618, 0xb5d7, 0xb597, 0xb534, 0xad13, 0xa4d2, 0x9c92, 0x9c71, 0x9451, 0x9471, 0x9c71, 0x9c71, 0x9c92, 0xa4d3, 0xad14, 0xb575, 0xc5b6, 0xc5f7, 0xcdf7, 0xce7a, 0xd69b, 0xd6bb, 0xdefc, 0xe71d, 0xe73d, 0xe73d, 0xe73d, 0xef1d, 0xe71d, 0xe6fc, 0xdefc, 0xdedc, 0xdedc, 0xdedc, 0xdedd, 0xdefc, 0xdedc, 0xd6bb, 0xd6dc, 0xd6bb, 0xce9b, 0xd6bb, 0xbe19, 0xbd95, 0x7ac8, 0x50e0, 0x9b02, 0xfd87, 0xe525, 0x84ad, 0x24ba, 0x5dfb, 0x8edf, 0xb73f, 0xc71f, 0xcf3f, 0xc75f, 0xb75e, 0xaf7e, 0xb73f, 0xa71f, 0x8edf, 0x765f, 0x4ddd, 0x353a, 0x2cf8, 0x2d18, 0x65d9, 0xdfdf, 0xffdf, 0xfffd, 0xfffd, 
0xf7fe, 0xffff, 0xe7bf, 0x8dd9, 0x44d6, 0x3539, 0x357d, 0x357f, 0x561d, 0x6e9f, 0x96ff, 0xa71f, 0xb71f, 0xb73f, 0xb75f, 0xb75f, 0xc75d, 0xbf5f, 0xa6ff, 0x869d, 0x45bc, 0x24b9, 0x7c8e, 0xfd24, 0xf5a7, 0xbbe4, 0x5940, 0x61a5, 0xb4b2, 0xd659, 0xce5a, 0xc67b, 0xde9a, 0xdebb, 0xe6db, 0xe6dc, 0xe6fc, 0xe6fc, 0xe71c, 0xe71d, 0xe71d, 0xe71d, 0xe73d, 0xef5d, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef7e, 0xef5e, 0xe73d, 0xe71d, 0xdf1c, 0xef5d, 0xef3d, 0xef1c, 0xe6fb, 0xe6db, 0xe6db, 0xe6db, 0xe6fb, 0xe6fb, 0xe6fb, 0xe6fc, 0xe6fc, 0xe71c, 0xef1c, 0xef3c, 0xef3c, 0xef5e, 0xef5e, 0xef5e, 0xef5e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef5d, 0xef5d, 0xef3d, 0xe73d, 0xe73d, 0xe73e, 0xe73e, 0xe73e, 0xe6fc, 0xdedb, 0xd67a, 0xd69a, 0xce59, 0xce39, 0xd67a, 0xc618, 0xa4b1, 0x61c3, 0x6160, 0xbc05, 0xfda7, 0xed46, 0x84ce, 0x1c99, 0x55bb, 0x86be, 0xaf3f, 0xbf1f, 0xc73f, 0xc75f, 0xb75e, 0xaf7f, 0xb73e, 0xa71f, 0x96df, 0x769f, 0x561d, 0x3d7b, 0x2d3a, 0x2d5a, 0x3cb6, 0x85b9, 0xf7ff, 0xfffe, 0xfffe, 
0xffde, 0xffff, 0xae7b, 0x4c75, 0x2cd7, 0x359b, 0x359d, 0x359e, 0x5e7e, 0x76df, 0x971f, 0xa73f, 0xaf1e, 0xaf3e, 0xaf5e, 0xaf3e, 0xbf3e, 0xaf3f, 0x9edf, 0x763c, 0x3d9c, 0x24b9, 0x7c8e, 0xfd04, 0xfda6, 0xdce7, 0x8a83, 0x5142, 0x93ae, 0xd659, 0xce9b, 0xc65b, 0xd67a, 0xd69b, 0xdedb, 0xe6db, 0xe6fb, 0xeefb, 0xef1c, 0xef1c, 0xef3d, 0xef3d, 0xef5d, 0xef7e, 0xef7e, 0xef9e, 0xefbf, 0xf7bf, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79f, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf79f, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef5e, 0xef5d, 0xef5e, 0xe73d, 0xe73d, 0xe71d, 0xe71d, 0xdefc, 0xdedb, 0xdedb, 0xdebb, 0xe6db, 0xdeba, 0xde79, 0xde79, 0xc5d7, 0x836b, 0x40e0, 0x8241, 0xdd08, 0xfd86, 0xed46, 0x84ce, 0x1c98, 0x4d7a, 0x767e, 0x9f1f, 0xb73f, 0xbf3f, 0xb75f, 0xaf5f, 0xa75f, 0xaf1e, 0xa71e, 0x8eff, 0x76df, 0x5e5f, 0x3ddd, 0x2d9c, 0x2dbc, 0x34b8, 0x4475, 0xc71d, 0xfffe, 0xfffe, 
0xffdf, 0xef9f, 0x7557, 0x3496, 0x359b, 0x2dbc, 0x2dbc, 0x3ddd, 0x66bf, 0x7eff, 0x8f3f, 0x9f3f, 0x9f1e, 0xa73e, 0xa73e, 0xa73e, 0xaf3e, 0x9f3f, 0x86bf, 0x65fb, 0x357b, 0x24d9, 0x84af, 0xfd03, 0xf545, 0xf548, 0xb3a6, 0x5140, 0x6247, 0xb575, 0xce5a, 0xc67b, 0xce9b, 0xcebc, 0xd6dc, 0xdefd, 0xe71c, 0xe71c, 0xef3c, 0xef3d, 0xe73d, 0xef3d, 0xef5d, 0xef7e, 0xef7e, 0xef9e, 0xf7bf, 0xf7df, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf7bf, 0xf7bf, 0xef9f, 0xef9f, 0xef9f, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xef9f, 0xef9f, 0xef9f, 0xef9f, 0xef9f, 0xef9f, 0xef9f, 0xf7bf, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xf79f, 0xf79f, 0xef7e, 0xef5e, 0xef5e, 0xe73d, 0xe73d, 0xe73d, 0xe71d, 0xe71c, 0xdefc, 0xdedc, 0xd69a, 0xd69a, 0xd67a, 0xd659, 0xce38, 0xb534, 0x6266, 0x4900, 0xab84, 0xed69, 0xf524, 0xed26, 0x84ad, 0x1c98, 0x3d5a, 0x661d, 0x8eff, 0xa73f, 0xaf3f, 0xa75f, 0x9f3f, 0x9f5f, 0xa71e, 0x9f1e, 0x8f1f, 0x76ff, 0x5ebf, 0x3e1e, 0x2ddd, 0x2dbe, 0x355c, 0x34f7, 0x7577, 0xf79e, 0xffff, 
0xffff, 0xbe9b, 0x4c95, 0x2cf8, 0x35dd, 0x259c, 0x35dd, 0x463e, 0x66bf, 0x76ff, 0x873f, 0x8f1f, 0x8f1e, 0x973e, 0x9f3f, 0x9f3f, 0x971f, 0x8f1f, 0x767e, 0x55db, 0x2d5b, 0x24d9, 0x84af, 0xfce3, 0xf504, 0xf546, 0xd4a7, 0x7201, 0x5162, 0x9c2f, 0xce59, 0xd6da, 0xcebc, 0xcebc, 0xcedc, 0xd6dc, 0xd6dc, 0xd6dc, 0xdefd, 0xe71d, 0xe71c, 0xe73d, 0xef5e, 0xef7e, 0xef7e, 0xef9e, 0xf7df, 0xf7ff, 0xffdf, 0xf7df, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7df, 0xefbf, 0xf7bf, 0xf7bf, 0xf7df, 0xf7df, 0xf7df, 0xf7bf, 0xf7bf, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7bf, 0xf7bf, 0xf7bf, 0xefbf, 0xf79f, 0xf79f, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf79f, 0xef9f, 0xef7e, 0xe73d, 0xe73d, 0xe71c, 0xe71c, 0xe6fb, 0xe6db, 0xcebc, 0xcedc, 0xce9b, 0xd6bb, 0xd6bb, 0xd69a, 0xc5f7, 0x9451, 0x5161, 0x7200, 0xdcc7, 0xf588, 0xf4e3, 0xed05, 0x848d, 0x24d8, 0x353a, 0x4ddd, 0x76bf, 0x8f1f, 0x9f3f, 0x973f, 0x975f, 0x8f3f, 0x971f, 0x8eff, 0x7f1f, 0x6f1f, 0x56bf, 0x3e3e, 0x2dde, 0x25be, 0x2d5d, 0x3539, 0x3412, 0xcefd, 0xf7ff, 
0xdf7f, 0x8598, 0x3495, 0x2d19, 0x257c, 0x259c, 0x35fe, 0x3e3d, 0x5e9f, 0x66df, 0x6f1f, 0x771e, 0x7efe, 0x871f, 0x873f, 0x871f, 0x86ff, 0x76bf, 0x5e1e, 0x4dbb, 0x255c, 0x24da, 0x84af, 0xfce3, 0xf524, 0xf546, 0xf568, 0xab64, 0x5960, 0x7287, 0xac90, 0xb511, 0xbdd7, 0xc638, 0xd69a, 0xdedb, 0xdefc, 0xdefc, 0xdefc, 0xd6dc, 0xe71d, 0xef5d, 0xef7e, 0xef9e, 0xef7e, 0xef7e, 0xef9e, 0xf7bf, 0xf79f, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf7bf, 0xf7bf, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf79f, 0xef7e, 0xef7e, 0xef9f, 0xe77e, 0xe73d, 0xe73d, 0xe73c, 0xef1c, 0xe6fb, 0xe6ba, 0xdefc, 0xdefc, 0xce7a, 0xce59, 0xc5f7, 0xbd54, 0x9c50, 0x6289, 0x5140, 0xa343, 0xf568, 0xf546, 0xfd03, 0xf526, 0x84ad, 0x24d8, 0x2d3b, 0x3dbc, 0x5e7e, 0x7eff, 0x86ff, 0x873f, 0x8f3f, 0x871f, 0x7eff, 0x76ff, 0x6eff, 0x671f, 0x4ebf, 0x3e3e, 0x2ddd, 0x2d9e, 0x2d7c, 0x353a, 0x2bf3, 0x95fa, 0xcfdf, 
0x9e7c, 0x54f6, 0x2cd6, 0x2d5a, 0x2d5b, 0x359d, 0x35fe, 0x363e, 0x569f, 0x5edf, 0x5eff, 0x66fe, 0x66fe, 0x6f1f, 0x76ff, 0x76df, 0x6edf, 0x5e5f, 0x4dbd, 0x3d7a, 0x255c, 0x24b9, 0x848e, 0xfce3, 0xf504, 0xf525, 0xf567, 0xcc66, 0x7a01, 0x5920, 0x6a04, 0x6a23, 0x8309, 0x938b, 0xac8f, 0xc573, 0xd617, 0xde99, 0xdeba, 0xdeda, 0xdebb, 0xe6fc, 0xe73d, 0xef5d, 0xe75d, 0xe75d, 0xe75d, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf7bf, 0xf7bf, 0xf7df, 0xffdf, 0xf79f, 0xf79f, 0xf79f, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79f, 0xef7e, 0xef7e, 0xef5e, 0xe73d, 0xe73d, 0xe75e, 0xdf5e, 0xdf1d, 0xe71c, 0xe6fb, 0xdeda, 0xd678, 0xce17, 0xd637, 0xc574, 0xa470, 0x93cd, 0x82e9, 0x7246, 0x6a04, 0x5120, 0x7242, 0xcc66, 0xf566, 0xed04, 0xfd03, 0xed06, 0x8cad, 0x24d7, 0x253c, 0x2d5c, 0x4e1d, 0x669e, 0x6ebe, 0x76ff, 0x7f1f, 0x76df, 0x6edf, 0x66df, 0x5eff, 0x56ff, 0x4ebe, 0x3e3d, 0x35dd, 0x35bd, 0x2ddc, 0x3519, 0x3c56, 0x54d6, 0x8ebe, 
0x75da, 0x3495, 0x2cf7, 0x357a, 0x355b, 0x359d, 0x35de, 0x3e9f, 0x4e9f, 0x56bf, 0x56ff, 0x56ff, 0x5edf, 0x66ff, 0x6edf, 0x6ebf, 0x66bf, 0x4e1f, 0x3d7c, 0x355a, 0x255c, 0x2499, 0x846e, 0xfce3, 0xecc4, 0xece4, 0xf545, 0xed48, 0xab65, 0x71a1, 0x7202, 0x7201, 0x71c1, 0x71c1, 0x69c2, 0x6a04, 0x7287, 0x8b6b, 0xa44f, 0xacf2, 0xbdd8, 0xc639, 0xd69b, 0xdefc, 0xe73d, 0xe75d, 0xef7e, 0xf7bf, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf79e, 0xf79e, 0xf79e, 0xf77e, 0xef7e, 0xef7e, 0xf79f, 0xf79f, 0xef7e, 0xef7e, 0xef5e, 0xef5e, 0xef5e, 0xef5e, 0xdf3d, 0xd6fc, 0xce9b, 0xc639, 0xbdb6, 0xad13, 0x9450, 0x83ad, 0x7287, 0x6a25, 0x61c4, 0x7203, 0x71c2, 0x6981, 0x81e2, 0x79c1, 0x9b67, 0xed49, 0xf545, 0xe4c2, 0xfd03, 0xe4c5, 0x8cad, 0x24d7, 0x253c, 0x253b, 0x3ddc, 0x565e, 0x669e, 0x6edf, 0x76ff, 0x6ebf, 0x5edf, 0x56bf, 0x56df, 0x56ff, 0x4ede, 0x465d, 0x3dfd, 0x3dbd, 0x257a, 0x34d8, 0x4496, 0x2c54, 0x65fb, 
0x655a, 0x3cb7, 0x2cf8, 0x3539, 0x357a, 0x357b, 0x2ddb, 0x369e, 0x469e, 0x469e, 0x4e9f, 0x4ebf, 0x4ebf, 0x4edf, 0x56df, 0x56df, 0x465f, 0x25ff, 0x2dbd, 0x3d3a, 0x34d8, 0x44f6, 0x9ced, 0xfc82, 0xf4e4, 0xf504, 0xf504, 0xf586, 0xe507, 0x92c2, 0x6961, 0x8228, 0x7a22, 0x7a22, 0x8a83, 0x8a83, 0x7a22, 0x8243, 0x8264, 0x7a03, 0x7a86, 0x7ac7, 0x8b29, 0x93cc, 0xac8f, 0xbd53, 0xcdd5, 0xd637, 0xde99, 0xdeda, 0xe71c, 0xe73d, 0xe75d, 0xe75e, 0xdf7f, 0xdf7f, 0xef5f, 0xef7f, 0xef9f, 0xef9f, 0xef9f, 0xef7f, 0xe77f, 0xe75f, 0xdf7f, 0xdf7f, 0xdf7f, 0xe79f, 0xe77f, 0xe77e, 0xe77e, 0xe75e, 0xef9f, 0xef5e, 0xe6fc, 0xdedb, 0xde9a, 0xd637, 0xc595, 0xb513, 0xb46d, 0xa40b, 0x9369, 0x82c6, 0x7a64, 0x7222, 0x7222, 0x7201, 0x8202, 0x8242, 0x8261, 0x7a62, 0x7a44, 0x7a05, 0x7a04, 0x8223, 0xe569, 0xf524, 0xf504, 0xe4e6, 0xf4c5, 0xf4e4, 0xa4ec, 0x3496, 0x253a, 0x2d7b, 0x2dbd, 0x35de, 0x463f, 0x569f, 0x66bf, 0x669f, 0x46bf, 0x46bf, 0x46bf, 0x469f, 0x465f, 0x3e1e, 0x35dd, 0x35bc, 0x355c, 0x353a, 0x3cd7, 0x4c95, 0x54f7, 
0x6d9a, 0x44f7, 0x2cf8, 0x2d39, 0x355b, 0x359c, 0x2dbc, 0x2e3d, 0x465e, 0x467e, 0x469f, 0x4e9f, 0x4e9f, 0x469f, 0x469f, 0x467f, 0x3e1f, 0x2dde, 0x2dbd, 0x2d5b, 0x2cd8, 0x54b4, 0xaccb, 0xfca2, 0xec83, 0xecc3, 0xece3, 0xed45, 0xe527, 0xbbe5, 0x8a43, 0x7a04, 0x8a84, 0x8a63, 0x8263, 0x8263, 0x8a83, 0x8a84, 0x8a64, 0x8a84, 0x8263, 0x8264, 0x7a44, 0x7244, 0x7265, 0x7265, 0x7286, 0x7286, 0x8329, 0x8b6a, 0x93ec, 0xa44f, 0xacd1, 0xbd53, 0xc5b5, 0xcdf6, 0xd637, 0xd658, 0xde78, 0xdeb9, 0xe6da, 0xe6fa, 0xe6fa, 0xe6fa, 0xdeb9, 0xde99, 0xde78, 0xd637, 0xce16, 0xc5d5, 0xc594, 0xbd74, 0xacb1, 0xa44f, 0x93cd, 0x8b6b, 0x8329, 0x7ac7, 0x7266, 0x6a24, 0x7244, 0x7224, 0x7224, 0x7a43, 0x8264, 0x8aa4, 0x8ac4, 0x92c4, 0x9284, 0x8aa3, 0x7a42, 0x7a63, 0x8285, 0x71c3, 0x8202, 0xbbe8, 0xe548, 0xf504, 0xf504, 0xe4e6, 0xecc4, 0xf4c3, 0xb4ca, 0x5473, 0x2d1a, 0x2d5c, 0x2d9d, 0x2dbe, 0x361f, 0x467f, 0x4e9f, 0x4e9f, 0x469f, 0x469f, 0x469f, 0x467f, 0x3e5e, 0x3dfd, 0x35bd, 0x359c, 0x3d9c, 0x2cf9, 0x3d18, 0x4cd7, 0x659a, 
0x6559, 0x3cb6, 0x24d7, 0x2d39, 0x2d3b, 0x355b, 0x359c, 0x2dfd, 0x363e, 0x3e3e, 0x3e7f, 0x467f, 0x467f, 0x3e5f, 0x363e, 0x361d, 0x2ddf, 0x35bd, 0x359d, 0x1d5c, 0x24b8, 0x6c90, 0xcca8, 0xfca3, 0xec84, 0xecc4, 0xed04, 0xed04, 0xed46, 0xdce7, 0xab64, 0x79c0, 0x8223, 0x92c5, 0x8aa4, 0x8263, 0x92a4, 0x92c4, 0x8aa3, 0x92e4, 0x9ac3, 0x9ac3, 0x9ac3, 0x92c3, 0x92c4, 0x8ac4, 0x8aa4, 0x8aa4, 0x8243, 0x8243, 0x8243, 0x7a23, 0x7223, 0x7223, 0x7244, 0x7a65, 0x7ac6, 0x7ac6, 0x82e7, 0x8327, 0x8328, 0x8348, 0x8348, 0x8348, 0x8b08, 0x8b07, 0x8ae7, 0x82c6, 0x8285, 0x7a64, 0x7223, 0x7223, 0x7a64, 0x7243, 0x7222, 0x7a22, 0x7a42, 0x8a63, 0x92a3, 0x92a3, 0x8aa5, 0x8aa5, 0x8aa5, 0x92c5, 0x92e4, 0x9ae4, 0x92c4, 0x92a3, 0x9ae4, 0x9ae5, 0x8a84, 0x8265, 0x8245, 0x7a02, 0xa323, 0xed6a, 0xe507, 0xf4e4, 0xece3, 0xe4e5, 0xeca3, 0xf4a2, 0xcca8, 0x844f, 0x2cda, 0x2d1b, 0x2d5d, 0x2d9d, 0x2ddd, 0x363e, 0x367f, 0x367f, 0x3e7e, 0x3e7e, 0x467e, 0x3e5e, 0x3e1e, 0x3ddd, 0x359c, 0x359c, 0x355a, 0x24f8, 0x3518, 0x3476, 0x65db, 
0x7dd9, 0x4cf6, 0x2cf7, 0x355a, 0x353c, 0x351b, 0x357c, 0x35dd, 0x35fd, 0x361e, 0x3e3e, 0x3e3f, 0x3e3e, 0x361e, 0x35dd, 0x2dbd, 0x259e, 0x3d7b, 0x355b, 0x1d1c, 0x34b6, 0x946c, 0xe465, 0xfc83, 0xec84, 0xeca4, 0xece4, 0xe4e3, 0xe504, 0xed67, 0xd486, 0x92a0, 0x71a0, 0x9284, 0x9ae6, 0x92a4, 0x92a4, 0x9ae4, 0x9ae4, 0x92e3, 0x9ac2, 0x9ae3, 0x9ae3, 0x9b03, 0x9b04, 0x9b04, 0x9ae4, 0x9ae4, 0x9aa3, 0x9aa3, 0x9aa3, 0x9283, 0x9283, 0x9283, 0x92a4, 0x92a4, 0x8a63, 0x8a63, 0x8a83, 0x8a83, 0x8283, 0x8283, 0x8262, 0x7a62, 0x8a63, 0x8a63, 0x8a63, 0x8a63, 0x8a83, 0x9283, 0x9283, 0x9283, 0x9ae4, 0x9ae4, 0x9ae3, 0x9ae3, 0x9ac3, 0x9ae3, 0x9ae3, 0xa2c3, 0xa306, 0x9ae5, 0x9ae4, 0x92c4, 0x9ac4, 0x92c3, 0x92c3, 0x92a3, 0x92a3, 0x92a4, 0x9ae6, 0x8265, 0x71c2, 0x9b03, 0xdcc7, 0xf566, 0xecc6, 0xecc4, 0xece3, 0xe4e4, 0xe482, 0xf482, 0xe486, 0xb46b, 0x3497, 0x2cf9, 0x253b, 0x257c, 0x2dbc, 0x2dfd, 0x2e1e, 0x263f, 0x3e3d, 0x3e3d, 0x3e3d, 0x3e1d, 0x3ddd, 0x3dbc, 0x357b, 0x357b, 0x2d19, 0x357a, 0x3518, 0x3435, 0x6e1c, 
0xc79f, 0x7df9, 0x3d17, 0x355a, 0x3d5c, 0x351b, 0x353b, 0x359c, 0x2dbc, 0x35dd, 0x35dd, 0x35fd, 0x35fd, 0x35dd, 0x35bc, 0x2dbc, 0x2d7d, 0x3d3a, 0x34d9, 0x2cb8, 0x5cb2, 0xbc69, 0xf443, 0xf463, 0xe464, 0xe464, 0xecc4, 0xece3, 0xe4c3, 0xf546, 0xed47, 0xd464, 0x8241, 0x8221, 0x8a63, 0x92a5, 0x92a5, 0x9ae4, 0x9b04, 0x92c2, 0x9b04, 0x9b04, 0x9b04, 0x9b04, 0x9b04, 0x9b04, 0x92e4, 0x92c4, 0xa305, 0xa304, 0xa2e4, 0xa2e4, 0x9ae4, 0x9ae4, 0x9ac4, 0x9ac4, 0x9a84, 0x9a84, 0x9aa4, 0x9aa4, 0x9aa4, 0x9aa4, 0x9aa4, 0x9aa4, 0x92a4, 0x92a4, 0x92a4, 0x92c4, 0x9ac4, 0x9ac4, 0xa2c4, 0xa2e4, 0x92a3, 0x92c3, 0x9ae3, 0x9ae4, 0x9ae3, 0x9ae3, 0x9ae3, 0x9ae3, 0x9ac4, 0x9aa4, 0x92a3, 0x92a3, 0x9aa3, 0x9ac3, 0x9ae3, 0x9ac3, 0x9283, 0x9284, 0x8a85, 0x7a03, 0x8221, 0xcc46, 0xfda8, 0xe4e3, 0xecc5, 0xeca4, 0xecc4, 0xe4c4, 0xe483, 0xf462, 0xec85, 0xd447, 0x4472, 0x34b5, 0x2519, 0x2d5c, 0x359c, 0x359c, 0x35bd, 0x2dde, 0x35fc, 0x35fc, 0x3ddc, 0x3ddc, 0x3d9c, 0x357b, 0x355b, 0x353b, 0x3559, 0x3d79, 0x34b6, 0x6538, 0x9f1f, 
0xf7ff, 0xa6bb, 0x4cd6, 0x2cb7, 0x3d1b, 0x351b, 0x351a, 0x2d5a, 0x357b, 0x359b, 0x359b, 0x359c, 0x359c, 0x359c, 0x359b, 0x359b, 0x353a, 0x34f9, 0x3496, 0x4c52, 0x946c, 0xdc66, 0xf422, 0xec23, 0xec84, 0xe463, 0xecc4, 0xecc4, 0xe4a3, 0xe4c4, 0xf546, 0xf547, 0xbbe6, 0x8a61, 0x79e0, 0x9284, 0x9aa5, 0x92a4, 0x9ae4, 0x9ac3, 0x92e4, 0x92e5, 0x9b05, 0x9b25, 0x9b25, 0x9b26, 0x9b26, 0x9b25, 0x9b05, 0x9ae5, 0x9ae5, 0x9b05, 0x9b05, 0x9b05, 0x9b05, 0x9ae5, 0xaac5, 0xa2e5, 0xa2e5, 0xa2e5, 0xa2e5, 0xa2e5, 0xa2e5, 0xa2e5, 0x9b05, 0x9b05, 0x9ae5, 0x9ae4, 0x9ae4, 0x9ae4, 0x9ae4, 0x9ae4, 0x9b25, 0x9b25, 0x9b25, 0x9b05, 0x9b05, 0x9b04, 0x9b05, 0x9b05, 0xa2e4, 0xa2e4, 0xa2e4, 0x9ae4, 0x9b04, 0x9ae4, 0x92c4, 0x92a3, 0x9284, 0x9284, 0x8202, 0x8221, 0xb3a4, 0xed27, 0xf546, 0xecc4, 0xe4e4, 0xeca4, 0xf4a4, 0xeca4, 0xe463, 0xec63, 0xec64, 0xdc44, 0x7c4c, 0x5c70, 0x34b6, 0x2d1a, 0x355b, 0x3d5a, 0x3d5b, 0x357d, 0x35bb, 0x359b, 0x359b, 0x359b, 0x357b, 0x355b, 0x353a, 0x353a, 0x3559, 0x2cb6, 0x4c95, 0xaebd, 0xdfff, 
0xfffe, 0xdf7d, 0x7db8, 0x3cd7, 0x34f9, 0x351a, 0x3539, 0x2d59, 0x353a, 0x355a, 0x355a, 0x355a, 0x355a, 0x355a, 0x353a, 0x353a, 0x44d8, 0x2cd9, 0x3c75, 0x7c0d, 0xcc26, 0xec23, 0xe423, 0xe444, 0xec84, 0xe484, 0xec84, 0xeca4, 0xe4a3, 0xe484, 0xe4c5, 0xed06, 0xdd28, 0xb3a4, 0x8a82, 0x8a43, 0x9285, 0x92a5, 0x92a4, 0x9ac3, 0x9ae5, 0x9ae5, 0x9ae5, 0x9b05, 0x9b05, 0xa305, 0xa2e4, 0xa2e4, 0x9b05, 0x9b05, 0x9b05, 0x9b05, 0xa325, 0xa325, 0xa325, 0xa305, 0xab26, 0xab26, 0xa305, 0xa305, 0xa305, 0x9b05, 0x9b05, 0x9b05, 0x9b25, 0x9b05, 0x9b05, 0x9b04, 0xa304, 0xa304, 0xa304, 0xa304, 0xa325, 0xa305, 0xa304, 0xa305, 0x9b05, 0xa325, 0xa325, 0xa325, 0x9aa3, 0x9aa4, 0x9ac4, 0x9ac4, 0x9ae5, 0x92e4, 0x92c4, 0x8aa3, 0x9284, 0x8a43, 0x8a62, 0xb3a4, 0xe506, 0xed24, 0xeca4, 0xf4c6, 0xe4e3, 0xe483, 0xf484, 0xf484, 0xe444, 0xe445, 0xe444, 0xdc22, 0xbc06, 0x840c, 0x4c53, 0x2cb8, 0x34f9, 0x3cf9, 0x3d19, 0x353a, 0x357a, 0x357a, 0x355a, 0x355a, 0x353a, 0x353a, 0x351a, 0x351a, 0x2d19, 0x34b6, 0x85b8, 0xef7f, 0xffff, 
0xffbc, 0xffff, 0xbf7e, 0x65ba, 0x3cf9, 0x34f9, 0x3539, 0x2d58, 0x3519, 0x3539, 0x3539, 0x3d5a, 0x3539, 0x3539, 0x3519, 0x2cf8, 0x4496, 0x2cd8, 0x4474, 0x9be9, 0xebe2, 0xec01, 0xdc03, 0xe445, 0xe443, 0xe443, 0xe443, 0xe484, 0xecc5, 0xeca5, 0xe485, 0xeca6, 0xe568, 0xdd08, 0xb386, 0x8a43, 0x8a44, 0x9285, 0x92a4, 0x9ac4, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0xaae4, 0xaae4, 0xaae4, 0xaae4, 0x9b05, 0x9b05, 0x9ae4, 0x9b04, 0xa304, 0xa324, 0xa304, 0xa304, 0x9b04, 0x9b04, 0x9b04, 0x9b04, 0x9b04, 0x9b24, 0x9324, 0x9b24, 0xa304, 0xa304, 0xa2e4, 0xa2e3, 0xa2e3, 0xa2e3, 0xa2e3, 0xa2e3, 0xa2c3, 0xa2c3, 0xa2e4, 0xa2e4, 0xa305, 0xa305, 0x9ae4, 0x9ac4, 0xa305, 0xa2e4, 0x9ae4, 0x9ac4, 0x92e4, 0x92c4, 0x8ac4, 0x8aa4, 0x9244, 0x79e2, 0xab45, 0xed69, 0xf5a6, 0xe4c2, 0xec84, 0xf487, 0xdce3, 0xe483, 0xf443, 0xf464, 0xe424, 0xdc25, 0xdc44, 0xd420, 0xebe3, 0xabc9, 0x5bf1, 0x3457, 0x2cb8, 0x34d8, 0x34f8, 0x2d39, 0x2d5a, 0x2d5a, 0x355a, 0x353a, 0x353a, 0x351a, 0x3519, 0x34f9, 0x3519, 0x5d79, 0xd79f, 0xffbf, 0xffdf, 
0xffbe, 0xffff, 0xffff, 0xd71d, 0x8598, 0x3cb5, 0x24f7, 0x25ba, 0x3cfb, 0x34fb, 0x34fb, 0x34fa, 0x351a, 0x34f8, 0x34d7, 0x3cb6, 0x4495, 0x638c, 0xaba6, 0xd382, 0xdb61, 0xe3c3, 0xe3e4, 0xec05, 0xe423, 0xe444, 0xec64, 0xe464, 0xe484, 0xec84, 0xeca4, 0xecc4, 0xeca4, 0xfd47, 0xece8, 0xb343, 0x8200, 0x8222, 0x8aa5, 0x92e6, 0x8aa2, 0x92e3, 0x9b04, 0x9b04, 0x9b04, 0x9ae4, 0x9ae4, 0xa2e4, 0xa304, 0xa304, 0xa304, 0xa324, 0xa324, 0xa304, 0xa304, 0xa304, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa325, 0xa324, 0x9ae4, 0x9ae4, 0x9b04, 0x9b24, 0x9b04, 0x9ae5, 0x9ae5, 0x9ac5, 0x9aa4, 0x9284, 0x9284, 0x9284, 0x9284, 0x8200, 0xbba5, 0xed08, 0xed26, 0xe4c4, 0xeca4, 0xeca5, 0xec65, 0xe4a3, 0xe484, 0xec44, 0xec25, 0xec05, 0xe404, 0xdbe4, 0xd3e3, 0xeb21, 0xcb43, 0x9327, 0x6bce, 0x4c74, 0x2476, 0x1c97, 0x255a, 0x34bb, 0x2cdb, 0x251b, 0x255b, 0x2d5a, 0x355a, 0x3cf9, 0x3cd8, 0x7516, 0xc71d, 0xffff, 0xffbe, 0xffbe, 
0xffff, 0xffff, 0xffff, 0xf7ff, 0xbf1d, 0x7dd9, 0x3cf6, 0x2495, 0x3539, 0x353a, 0x355a, 0x2cf8, 0x2cb7, 0x34b6, 0x4d16, 0x5d57, 0xb71f, 0xce78, 0xaba8, 0xbac0, 0xe381, 0xdb61, 0xdbc3, 0xdc05, 0xe423, 0xe423, 0xe444, 0xe464, 0xe463, 0xe483, 0xeca4, 0xeca4, 0xecc4, 0xeca5, 0xece7, 0xe4e8, 0xbba5, 0x8221, 0x7a02, 0x92c5, 0x92c4, 0x92c4, 0x92c4, 0x92c3, 0x9ac4, 0x9ae4, 0xa305, 0xa325, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0x9ae4, 0xa304, 0xa305, 0x9b04, 0x9b04, 0xa325, 0x9b25, 0x9ae4, 0x9b04, 0x9ae4, 0x92c4, 0x9284, 0x92a5, 0x9ac5, 0x8a43, 0x79c1, 0xbbc6, 0xdca8, 0xed28, 0xed05, 0xe4a3, 0xe483, 0xec64, 0xe424, 0xe463, 0xe464, 0xe444, 0xe403, 0xe3e4, 0xe3e4, 0xdbc3, 0xdbc3, 0xeb41, 0xbaa1, 0xb3c9, 0xce57, 0xbf3d, 0x75fa, 0x44d6, 0x3cb6, 0x3519, 0x353a, 0x2d7a, 0x2559, 0x2517, 0x34f7, 0x4cf7, 0x5d38, 0xcf5f, 0xf7ff, 0xffff, 0xffde, 0xffde, 
0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xd7bf, 0xa6dd, 0x863b, 0x2c54, 0x3474, 0x3475, 0x3c75, 0x4cb5, 0x7598, 0xaedd, 0xd7df, 0xf7ff, 0xff9e, 0xcd31, 0xaac3, 0xcae0, 0xeb81, 0xdb81, 0xd3e4, 0xe403, 0xe403, 0xe424, 0xe444, 0xe443, 0xe463, 0xe484, 0xec84, 0xeca5, 0xe484, 0xe4c5, 0xf547, 0xe508, 0xbbe5, 0x92a3, 0x8222, 0x8a84, 0x8a84, 0x9284, 0x92a5, 0x9ac5, 0x9ae4, 0x9ae4, 0x9ae4, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa304, 0xa325, 0xa325, 0xa305, 0x9b04, 0x9b04, 0x9b04, 0x9ae4, 0x9303, 0x8aa2, 0x92a4, 0x9ac6, 0x8a64, 0x79e1, 0x9283, 0xb3a7, 0xe508, 0xed07, 0xe4e5, 0xe4c3, 0xe4a3, 0xeca4, 0xec64, 0xe424, 0xe423, 0xe444, 0xe423, 0xdc03, 0xdbe3, 0xe3e3, 0xe3a3, 0xe362, 0xd301, 0xbb03, 0xdd2e, 0xfffd, 0xf7ff, 0xd77e, 0xae7a, 0x95f8, 0x3c74, 0x3c94, 0x3494, 0x3473, 0x44b4, 0x7598, 0xaefd, 0xdfff, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xfffe, 
0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xefff, 0xe7ff, 0xdfff, 0xdfdf, 0xdfbf, 0xdf9f, 0xefbf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff7c, 0xcc8d, 0xb280, 0xdb00, 0xe382, 0xd363, 0xdbe3, 0xe3e3, 0xe424, 0xe424, 0xe424, 0xe444, 0xe464, 0xe464, 0xec85, 0xeca5, 0xe4a3, 0xe4c3, 0xed26, 0xed48, 0xcc27, 0x9ac3, 0x81c2, 0x8a23, 0x9aa5, 0x9ae6, 0x9ac5, 0x9284, 0x92a4, 0x9b05, 0xa2e4, 0xa2e4, 0x9ae4, 0xa2e4, 0xa2e4, 0xa304, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa304, 0xa304, 0xa304, 0xa305, 0xa325, 0xa325, 0x9ae4, 0x92c4, 0x92c4, 0x9ae4, 0x9b05, 0x8aa3, 0x9b05, 0x92c5, 0x7a02, 0x79c1, 0x9ac3, 0xcc67, 0xe549, 0xed06, 0xe4c4, 0xdca3, 0xe4a3, 0xeca3, 0xeca4, 0xec64, 0xe424, 0xe404, 0xe424, 0xdc23, 0xdc23, 0xdc03, 0xe3e3, 0xdb42, 0xd2e1, 0xa2e3, 0xd4cc, 0xff18, 0xfffd, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xdf7f, 0xdfbf, 0xdfff, 0xe7ff, 0xefff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xfffe, 0xfffe, 0xfffe, 
0xf7ff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbe, 0xffff, 0xffff, 0xffff, 0xfef9, 0xd409, 0xc280, 0xe363, 0xdb64, 0xdba3, 0xdbc3, 0xe3e4, 0xe404, 0xe424, 0xe424, 0xe444, 0xe464, 0xe465, 0xec85, 0xeca3, 0xe4c2, 0xe4e3, 0xe4e5, 0xe4c7, 0xdc88, 0xab26, 0x9a84, 0x8201, 0x8a22, 0x92a4, 0x9ae5, 0x9ae5, 0x9ac5, 0x9ae4, 0x9ae4, 0x9ae4, 0xa2e4, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa305, 0xa2e5, 0xa2e5, 0xa2e5, 0xa2e5, 0x9ac4, 0x9ac4, 0x9ac4, 0x9ae4, 0x9ae4, 0x9ae4, 0x9ae4, 0x92c5, 0x8a84, 0x8223, 0x8a22, 0xab44, 0xdca7, 0xed27, 0xe505, 0xece4, 0xe4a3, 0xe482, 0xe483, 0xeca3, 0xec64, 0xe423, 0xdc03, 0xe424, 0xe404, 0xdc03, 0xdc03, 0xdbe3, 0xd382, 0xc2e2, 0xba81, 0xb46d, 0xf6f8, 0xfffd, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xfffe, 
0xf7df, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffdf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xfed8, 0xcc09, 0xba82, 0xd303, 0xd362, 0xdba3, 0xdbc4, 0xe3e4, 0xe404, 0xe424, 0xe444, 0xe444, 0xec65, 0xe464, 0xec83, 0xecc3, 0xe4a3, 0xdc83, 0xe4c5, 0xf548, 0xed2b, 0xc3e6, 0x9aa2, 0x8a41, 0x8a62, 0x9283, 0x92a4, 0x92c4, 0x9ac4, 0x9ac4, 0x9ae4, 0x9ae4, 0xa305, 0xa305, 0xa305, 0xa305, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa305, 0xa2e5, 0xa2e5, 0xa2e5, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa305, 0x9ac4, 0x9aa4, 0x9ae4, 0x9ae5, 0x92c4, 0x8a83, 0x8a62, 0x8a44, 0x8202, 0x9ac3, 0xcc47, 0xed49, 0xed06, 0xe4a4, 0xecc3, 0xeca4, 0xec83, 0xe483, 0xe483, 0xec64, 0xe444, 0xe444, 0xe444, 0xe425, 0xdbe3, 0xdbc2, 0xdba2, 0xcb62, 0xbb02, 0xbb24, 0xc387, 0xef3b, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xf7ff, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffde, 0xffde, 
0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xeeb7, 0xb3a8, 0xbac2, 0xcb22, 0xd342, 0xdb83, 0xdbc3, 0xdbe4, 0xe404, 0xe424, 0xe424, 0xec65, 0xe444, 0xe464, 0xe464, 0xeca4, 0xecc4, 0xecc4, 0xeca4, 0xed27, 0xed07, 0xdcc7, 0xc406, 0x9ae2, 0x8200, 0x8222, 0x92e5, 0x9283, 0x92a3, 0x9ac4, 0x9ae4, 0x9ae4, 0x9ae4, 0x9ac4, 0x9ac4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e4, 0xa2e5, 0xa2e5, 0xa2e5, 0xa2e5, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0x9ae5, 0x9ac4, 0x9ac4, 0x92c4, 0x92a3, 0x8a62, 0x8a62, 0x8a83, 0x9263, 0xb385, 0xdcc8, 0xed27, 0xed05, 0xecc4, 0xeca4, 0xec64, 0xe464, 0xec64, 0xe444, 0xe444, 0xe444, 0xe444, 0xe443, 0xe423, 0xdc24, 0xdbc3, 0xdba2, 0xdb62, 0xc302, 0xb304, 0xcc6c, 0xf613, 0xffff, 0xffff, 0xf7de, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffbf, 0xffbf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xe7ff, 0xffff, 0xff37, 0xbba4, 0xcb01, 0xcb22, 0xd362, 0xdba3, 0xdbc3, 0xdbe3, 0xdc04, 0xe404, 0xe424, 0xe424, 0xe444, 0xe465, 0xec85, 0xeca4, 0xec83, 0xe482, 0xdca3, 0xe4c4, 0xed27, 0xed49, 0xdcc9, 0xab85, 0x8a62, 0x7a01, 0x8a62, 0x9283, 0x92a3, 0x9ac4, 0x9ac4, 0x9ac4, 0x9aa4, 0x92a3, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2e5, 0xa2e5, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0xa2c4, 0x9ac4, 0x8a43, 0x9263, 0x9284, 0x8a83, 0x8222, 0x8202, 0x92a4, 0xab67, 0xe4ea, 0xed09, 0xed27, 0xed04, 0xecc3, 0xec83, 0xec65, 0xec46, 0xe444, 0xec45, 0xe445, 0xe404, 0xe424, 0xe423, 0xdbe2, 0xd3a0, 0xd403, 0xd3a2, 0xdb82, 0xdb62, 0xc2e2, 0xbb67, 0xedd2, 0xffdc, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffde, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffbf, 0xffbf, 0xffbf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xc345, 0xc303, 0xcb23, 0xd363, 0xd383, 0xdba3, 0xdbe4, 0xdc25, 0xdc04, 0xe445, 0xdc24, 0xd423, 0xdc64, 0xdc43, 0xe462, 0xf4c3, 0xe483, 0xe483, 0xe483, 0xecc5, 0xf527, 0xf547, 0xe4e6, 0xdc85, 0x9ac2, 0x9282, 0x8221, 0x8222, 0x8a63, 0x92a5, 0x92a6, 0x8a86, 0x92a3, 0x92a3, 0x92c4, 0x9ae5, 0x9ae5, 0x92c5, 0x92a5, 0x92a4, 0x92c3, 0x92e3, 0x92e4, 0x92e4, 0x92c4, 0x92a4, 0x9284, 0x8a64, 0x8245, 0x7a24, 0x7a02, 0x8a42, 0xa303, 0xc3e5, 0xdcc7, 0xed48, 0xecc4, 0xecc4, 0xeca4, 0xeca4, 0xec84, 0xec84, 0xec84, 0xec64, 0xec65, 0xe424, 0xdc03, 0xdc43, 0xe444, 0xdc24, 0xdbe5, 0xdbc5, 0xf361, 0xeb82, 0xd322, 0xaac3, 0xbc2b, 0xf697, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xff18, 0xc40a, 0xaaa2, 0xd322, 0xdb41, 0xe3a2, 0xe425, 0xd405, 0xdbc3, 0xdc03, 0xe423, 0xdc23, 0xe463, 0xdc22, 0xdc42, 0xeca3, 0xeca3, 0xe483, 0xe483, 0xe484, 0xe4a5, 0xecc5, 0xecc6, 0xe4c6, 0xf58b, 0xdcc9, 0xbbc5, 0xa2e2, 0x9262, 0x8a42, 0x8222, 0x8222, 0x8a83, 0x9283, 0x9284, 0x92a4, 0x92a4, 0x92a5, 0x92a5, 0x92a5, 0x92e4, 0x92c4, 0x8a83, 0x8a43, 0x8242, 0x8242, 0x8a42, 0x8a43, 0x92a3, 0xa324, 0xbbe6, 0xd4c8, 0xed29, 0xf548, 0xed26, 0xece5, 0xe4a4, 0xe4a4, 0xeca4, 0xe484, 0xe484, 0xe464, 0xe444, 0xe444, 0xdbe3, 0xec65, 0xec84, 0xdbe2, 0xd3c2, 0xe404, 0xe3e4, 0xd342, 0xe342, 0xc280, 0xaa82, 0xcc4b, 0xfeb6, 0xfffd, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf6d8, 0xcc4b, 0xb2a1, 0xcac0, 0xd321, 0xcb62, 0xcba4, 0xe3c2, 0xec03, 0xec23, 0xec44, 0xec64, 0xe443, 0xdc43, 0xe484, 0xe463, 0xe484, 0xe484, 0xe464, 0xdc43, 0xdc64, 0xe4a5, 0xece6, 0xece7, 0xed07, 0xf528, 0xf549, 0xed09, 0xd487, 0xc3c5, 0xb363, 0x9282, 0x9262, 0x8a41, 0x8201, 0x8201, 0x81e1, 0x8201, 0x8201, 0x8202, 0x8222, 0x8a42, 0x9263, 0xa2c4, 0xab45, 0xbbc7, 0xc408, 0xe528, 0xe528, 0xed48, 0xed27, 0xed06, 0xe4e4, 0xe4a3, 0xe483, 0xe4a4, 0xe484, 0xe484, 0xe464, 0xe464, 0xe444, 0xe444, 0xe424, 0xe465, 0xdc03, 0xd3c1, 0xdbe2, 0xe3e2, 0xdb61, 0xdb22, 0xe363, 0xbaa2, 0xb2e5, 0xcc6d, 0xfed8, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xffff, 0xff5a, 0xe54f, 0xbb44, 0xc2e1, 0xd362, 0xd362, 0xdb82, 0xe382, 0xe3a2, 0xe3c1, 0xe402, 0xe423, 0xdc43, 0xdc44, 0xe423, 0xe463, 0xec84, 0xe484, 0xe464, 0xdc64, 0xe464, 0xe4a5, 0xeca4, 0xeca4, 0xecc4, 0xecc5, 0xece6, 0xf507, 0xf528, 0xf548, 0xed2a, 0xed09, 0xe4c9, 0xdc88, 0xd447, 0xcc27, 0xcc07, 0xcc07, 0xd449, 0xd469, 0xdca9, 0xe4c9, 0xed09, 0xed49, 0xf569, 0xf569, 0xed05, 0xece5, 0xe4c4, 0xe4a3, 0xe463, 0xe463, 0xeca4, 0xecc4, 0xe484, 0xe484, 0xe464, 0xe444, 0xe444, 0xe423, 0xe424, 0xe403, 0xdc24, 0xdc24, 0xdbe2, 0xdba2, 0xe3a2, 0xdb62, 0xd2e1, 0xc2a1, 0xb348, 0xe531, 0xff5b, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xe614, 0xbbe8, 0xbb02, 0xcae0, 0xd363, 0xdb83, 0xe3a2, 0xe3a2, 0xe3c2, 0xe403, 0xe444, 0xdc45, 0xe423, 0xe423, 0xe444, 0xe464, 0xe464, 0xe464, 0xe463, 0xe463, 0xe462, 0xec82, 0xec82, 0xec83, 0xe4a3, 0xeca4, 0xe4a4, 0xeca4, 0xe4e5, 0xece6, 0xece6, 0xed06, 0xed27, 0xf547, 0xf548, 0xf548, 0xed08, 0xed28, 0xed27, 0xed07, 0xed05, 0xe4c4, 0xdc83, 0xdc62, 0xe463, 0xe484, 0xeca4, 0xeca5, 0xec85, 0xec64, 0xec64, 0xec65, 0xe464, 0xe464, 0xe464, 0xe444, 0xe423, 0xe403, 0xe403, 0xe3e3, 0xd3c3, 0xdc24, 0xe404, 0xdbc3, 0xd343, 0xc2e2, 0xbae3, 0xc366, 0xedf5, 0xff7c, 0xffff, 0xf7ff, 0xe7df, 0xf7ff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xf677, 0xcc2a, 0xbb03, 0xb2e3, 0xc303, 0xdb83, 0xebc3, 0xe3c2, 0xe3e3, 0xdc04, 0xd404, 0xe424, 0xe403, 0xe403, 0xe423, 0xe443, 0xe463, 0xe463, 0xe443, 0xec62, 0xec63, 0xec83, 0xec83, 0xeca3, 0xeca4, 0xeca4, 0xeca4, 0xe482, 0xe482, 0xe4a3, 0xe4a3, 0xe4a3, 0xe4a3, 0xe4a4, 0xe4a3, 0xe4c4, 0xe4c4, 0xe4c4, 0xe4c3, 0xecc3, 0xecc3, 0xeca2, 0xeca2, 0xf485, 0xec85, 0xec85, 0xec65, 0xe445, 0xe445, 0xe445, 0xec45, 0xe444, 0xe444, 0xe424, 0xe423, 0xdc03, 0xdbe3, 0xdbc3, 0xdbc3, 0xdbe4, 0xdbc3, 0xd362, 0xc302, 0xb2c3, 0xa2c5, 0xc46c, 0xfed6, 0xffde, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffbe, 0xf7ff, 0xf7ff, 0xf7df, 0xffff, 0xffbc, 0xd531, 0xbba9, 0xb2e5, 0xbac2, 0xd322, 0xdb62, 0xdb82, 0xd3a3, 0xd3a3, 0xe3e3, 0xe3e3, 0xe3e3, 0xe403, 0xe423, 0xe422, 0xe442, 0xe442, 0xec64, 0xe464, 0xe443, 0xe443, 0xe443, 0xe464, 0xe464, 0xe484, 0xeca3, 0xeca3, 0xeca3, 0xec83, 0xec83, 0xe483, 0xe463, 0xe463, 0xeca3, 0xeca3, 0xe483, 0xe483, 0xe463, 0xe462, 0xe462, 0xe462, 0xec44, 0xec44, 0xe444, 0xe444, 0xe444, 0xe444, 0xdc24, 0xdc24, 0xdc23, 0xe423, 0xdc03, 0xdbe3, 0xdbc3, 0xdba3, 0xdba3, 0xdba2, 0xcb42, 0xdba4, 0xcb23, 0xb282, 0xbba9, 0xdd92, 0xff5a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xfeb6, 0xdcad, 0xbb04, 0xc302, 0xd321, 0xd321, 0xd382, 0xd3c4, 0xd382, 0xdbc3, 0xe3e3, 0xe423, 0xe402, 0xdc02, 0xe422, 0xe442, 0xdc04, 0xdc24, 0xe444, 0xe465, 0xe485, 0xe485, 0xe465, 0xdc64, 0xe443, 0xe443, 0xe443, 0xe444, 0xec64, 0xec65, 0xec65, 0xec65, 0xe442, 0xe463, 0xe463, 0xec64, 0xec64, 0xec44, 0xec44, 0xe424, 0xec64, 0xe443, 0xe423, 0xe423, 0xe443, 0xe443, 0xdc43, 0xdc22, 0xdc03, 0xdc03, 0xdbe3, 0xdbc2, 0xdba2, 0xd382, 0xd382, 0xd362, 0xcae1, 0xcae2, 0xc2e3, 0xdc0a, 0xfeb6, 0xffdc, 0xffff, 0xe7ff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffe, 0xffde, 0xffdf, 0xffdf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xee76, 0xbc2b, 0xaac3, 0xc2a0, 0xe300, 0xeb20, 0xd3a2, 0xd3a2, 0xd3a3, 0xdbe4, 0xe405, 0xe425, 0xdc05, 0xdbe5, 0xe403, 0xe423, 0xec24, 0xec23, 0xe403, 0xe402, 0xec02, 0xec02, 0xdc24, 0xe444, 0xe445, 0xe465, 0xe464, 0xe464, 0xe464, 0xe444, 0xec04, 0xec24, 0xec24, 0xec44, 0xe423, 0xe423, 0xe422, 0xe442, 0xdc62, 0xd442, 0xdc22, 0xdc23, 0xe404, 0xe404, 0xe3e4, 0xe3a4, 0xdc24, 0xdbc3, 0xdb82, 0xe383, 0xe382, 0xdb41, 0xcb00, 0xc300, 0x9aa5, 0xc46d, 0xee78, 0xff9e, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xff7a, 0xf5f2, 0xcc08, 0xb2c2, 0xb2a1, 0xd342, 0xd322, 0xd342, 0xd362, 0xdb82, 0xdbc2, 0xdbc2, 0xdbc2, 0xd3c2, 0xd403, 0xdc23, 0xdc24, 0xdc23, 0xdc23, 0xdc23, 0xe423, 0xdc04, 0xdc04, 0xdc04, 0xdc03, 0xe423, 0xe423, 0xe423, 0xdc23, 0xe424, 0xe424, 0xe424, 0xdc24, 0xdc23, 0xdc23, 0xdc23, 0xdc43, 0xec25, 0xe404, 0xdbe3, 0xdbe3, 0xdbe3, 0xd3e3, 0xd3e3, 0xd3e3, 0xdb82, 0xe382, 0xe383, 0xdb43, 0xc2c2, 0xb2a2, 0xbb24, 0xc3c6, 0xfe35, 0xff19, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe7df, 0xf7ff, 0xffff, 0xffff, 0xffdd, 0xff5a, 0xddf4, 0xb46d, 0xb241, 0xbaa2, 0xcb03, 0xd322, 0xd321, 0xd340, 0xdb80, 0xebc1, 0xd3e3, 0xd3e3, 0xd3e3, 0xd3e3, 0xd3e3, 0xd403, 0xdc24, 0xdc45, 0xe424, 0xe424, 0xe424, 0xe403, 0xe403, 0xe403, 0xe403, 0xe403, 0xd424, 0xd424, 0xd404, 0xd404, 0xdc24, 0xdc24, 0xe424, 0xe444, 0xdbc4, 0xdbc4, 0xdbc4, 0xdbc4, 0xdbc3, 0xdba3, 0xd382, 0xd382, 0xd300, 0xd301, 0xcae2, 0xb2a3, 0xaaa5, 0xbbaa, 0xedd4, 0xff7b, 0xffbd, 0xffdd, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xfe34, 0xe4ce, 0xb347, 0xa282, 0xb2c2, 0xcb22, 0xd321, 0xd2e0, 0xdb82, 0xdb82, 0xdba2, 0xdbc3, 0xdbc3, 0xdbc3, 0xdbc3, 0xe3e4, 0xdbc3, 0xdbc3, 0xdbc3, 0xe3e3, 0xe3e3, 0xe3e3, 0xe3e3, 0xe3e3, 0xdc43, 0xdc23, 0xdc03, 0xd3e3, 0xdbc2, 0xdbc2, 0xdba2, 0xd382, 0xd3e3, 0xd3c3, 0xd3a3, 0xd362, 0xdb42, 0xdb22, 0xdae2, 0xdae2, 0xbb03, 0xb303, 0xbb67, 0xd4ce, 0xfe97, 0xffdd, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xfffe, 0xfffd, 0xff5a, 0xe5d3, 0xc40b, 0xaae5, 0xb2c3, 0xc304, 0xcac1, 0xcac1, 0xd2e1, 0xdb42, 0xe363, 0xdb22, 0xdb21, 0xe322, 0xdb83, 0xdba3, 0xdba3, 0xdbc3, 0xdbc3, 0xdba3, 0xdba3, 0xdba2, 0xdba1, 0xdbc1, 0xdba1, 0xdbc2, 0xdba2, 0xdb82, 0xdb82, 0xdb62, 0xd320, 0xd320, 0xd341, 0xcb22, 0xc2e2, 0xbaa2, 0xb262, 0xb242, 0xb44c, 0xddd2, 0xff9a, 0xfffc, 0xfffe, 0xffde, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xefff, 0xf7ff, 0xffff, 0xfffe, 0xffdd, 0xfef9, 0xed93, 0xcc6e, 0xbb26, 0xb2c4, 0xb2a3, 0xbac3, 0xc2c3, 0xcac2, 0xd302, 0xe343, 0xcb23, 0xcb23, 0xcb43, 0xcb63, 0xd363, 0xcb63, 0xcb42, 0xcb42, 0xd340, 0xdb61, 0xdb61, 0xd362, 0xd341, 0xcb21, 0xcb22, 0xcb22, 0xd2c2, 0xc281, 0xb261, 0xaaa3, 0xb367, 0xcccd, 0xee53, 0xff58, 0xfffd, 0xfffe, 0xfffe, 0xf7fe, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffde, 0xffde, 0xffbc, 0xfed8, 0xe5f4, 0xd50f, 0xc40a, 0xab05, 0xa282, 0xa261, 0xbae3, 0xbac2, 0xbac2, 0xbac2, 0xbae2, 0xc302, 0xc302, 0xc323, 0xc2c2, 0xcae2, 0xc2e2, 0xbac2, 0xaa81, 0xa282, 0xa2a2, 0xaae3, 0xc3eb, 0xd4af, 0xedd3, 0xfed8, 0xff9b, 0xfffd, 0xfffe, 0xfffe, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xfffd, 0xffbb, 0xfe95, 0xe5b0, 0xdd4e, 0xe449, 0xe408, 0xd3c7, 0xcb65, 0xc344, 0xc324, 0xc323, 0xc323, 0xcb25, 0xd387, 0xdbe9, 0xdc2a, 0xdc8b, 0xe50e, 0xf5d1, 0xfe53, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff9f, 0xffff, 0xffde, 0xffde, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};
const unsigned short  Fantastic[] PROGMEM = {
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xf7fd, 0xf7fd, 0xf7fd, 0xf7fd, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xfffe, 0xffff, 0xf7bf, 0xf7df, 0xffff, 0xffff, 0xffff, 0xff9e, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffbe, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdd, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffdf, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xffbc, 0xf6d6, 0xe5f1, 0xddae, 0xe5ed, 0xe633, 0xff59, 0xfffd, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe7ff, 0xffff, 0xff9c, 0xe5b1, 0xd4a8, 0xd484, 0xdce3, 0xe564, 0xc486, 0xcd2b, 0xee73, 0xffdc, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffdc, 0xffbc, 0xff9b, 0xffbf, 0xff9e, 0xff9e, 0xff7d, 0xff7c, 0xff7b, 0xff9c, 0xff9b, 0xff9a, 0xff9b, 0xff9c, 0xffbe, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xfffe, 0xfe54, 0xdc67, 0xec42, 0xfd02, 0xfdc2, 0xfea4, 0xfe27, 0xe546, 0xccc9, 0xee54, 0xfffd, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffbc, 0xf718, 0xe653, 0xcd8f, 0xc50d, 0xeca3, 0xe482, 0xe461, 0xdc60, 0xdc60, 0xdc60, 0xdc60, 0xdc80, 0xd461, 0xd462, 0xd484, 0xd4e8, 0xdd6c, 0xee10, 0xfeb4, 0xff16, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff7a, 0xed4c, 0xec02, 0xfcc1, 0xfd40, 0xf560, 0xf601, 0xfe64, 0xfea8, 0xe548, 0xb48b, 0xe697, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7ff, 0xefdf, 0xf7ff, 0xfffe, 0xffde, 0xff7f, 0xffff, 0xf7fe, 0xf7fe, 0xf7ff, 0xffff, 0xffdf, 0xfffc, 0xffb7, 0xfe50, 0xf5cd, 0xed07, 0xe463, 0xe440, 0xf4a0, 0xfd21, 0xfd83, 0xfda1, 0xfda1, 0xfda1, 0xfda0, 0xfda0, 0xfda0, 0xfda0, 0xfda0, 0xfdc2, 0xfdc2, 0xfda1, 0xfd81, 0xfd60, 0xf540, 0xed00, 0xece0, 0xd485, 0xe529, 0xfe30, 0xff37, 0xffbd, 0xffdf, 0xf7df, 0xefbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff39, 0xdc21, 0xfd20, 0xf4c1, 0xf4a1, 0xf5c0, 0xfdc0, 0xfe26, 0xf6c7, 0xfeaa, 0xece5, 0xd444, 0xffbd, 0xf7bf, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffbb, 0xc5d2, 0xc531, 0xcd32, 0xce35, 0xfffd, 0xfffe, 0xff7d, 0xff3c, 0xf6b6, 0xd54b, 0xbc84, 0xdd85, 0xeda4, 0xfdc3, 0xfde2, 0xfde1, 0xfdc0, 0xfda0, 0xfd80, 0xfda2, 0xfda2, 0xfda2, 0xfda1, 0xfd80, 0xf580, 0xf580, 0xf580, 0xf560, 0xf581, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd83, 0xf542, 0xdce3, 0xd4e5, 0xd54a, 0xe630, 0xff56, 0xfffa, 0xffdf, 0xffff, 0xfffe, 0xf7fe, 0xfffe, 0xffff, 0xffdf, 0xffbf, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff18, 0xd401, 0xfd00, 0xfcc2, 0xfca1, 0xf580, 0xfd81, 0xfe04, 0xfea8, 0xfe8b, 0xfde9, 0xdc85, 0xee55, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffdf, 0xff9f, 0xffde, 0xd5d2, 0x9386, 0x9305, 0x9ae5, 0x7aa4, 0xc4ee, 0xee33, 0xe5ae, 0xdd28, 0xe523, 0xfd61, 0xfdc1, 0xedc0, 0xf5c0, 0xf5c0, 0xfdc0, 0xfdc0, 0xfdc0, 0xfdc0, 0xfdc0, 0xfdc3, 0xfdc3, 0xfdc2, 0xfdc2, 0xf5c1, 0xf5e1, 0xf5e1, 0xf5e1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda0, 0xfdc0, 0xfdc0, 0xfda2, 0xf562, 0xe543, 0xd503, 0xd503, 0xf633, 0xff38, 0xfffd, 0xffff, 0xffff, 0xf7df, 0xffdf, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfef7, 0xd3c0, 0xfd00, 0xfce2, 0xfca2, 0xf560, 0xfd41, 0xfde2, 0xfe87, 0xfe6b, 0xfeed, 0xed46, 0xc4eb, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xff3a, 0x93a8, 0x7a20, 0x79e0, 0x7980, 0x7202, 0x71c2, 0x7a01, 0xab61, 0xed42, 0xfde0, 0xfd80, 0xfd20, 0xfda0, 0xfda0, 0xfda0, 0xfda0, 0xfda1, 0xfdc1, 0xfde2, 0xfde3, 0xfda0, 0xfda0, 0xfdc1, 0xfdc1, 0xf5c1, 0xf5c1, 0xf5e2, 0xf5e2, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfda1, 0xfd81, 0xfd81, 0xfd81, 0xfd80, 0xfd80, 0xfd80, 0xfd81, 0xfd81, 0xfd61, 0xfd61, 0xf541, 0xd4c2, 0xdd48, 0xee11, 0xf6fa, 0xff9f, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xfef7, 0xd3c1, 0xfd00, 0xfd03, 0xfca2, 0xf520, 0xfd02, 0xfde1, 0xfe26, 0xf62a, 0xff0d, 0xfe69, 0xbc86, 0xf6d7, 0xff9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xd615, 0x6201, 0x69a0, 0x71a0, 0x81e0, 0x71e0, 0x79e1, 0x7181, 0x8200, 0xc402, 0xf562, 0xfd81, 0xfd61, 0xfd60, 0xfd61, 0xfd81, 0xfd81, 0xfda1, 0xfda1, 0xfda1, 0xfdc1, 0xfde0, 0xfde0, 0xfdc0, 0xfdc0, 0xfdc1, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda1, 0xfda2, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd60, 0xfdc0, 0xf521, 0xe4c4, 0xdd0b, 0xee14, 0xff5b, 0xffff, 0xf7ff, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff59, 0xd402, 0xfd00, 0xfd23, 0xfcc2, 0xf520, 0xfd02, 0xfda0, 0xfdc4, 0xfe28, 0xfeaa, 0xff4d, 0xd527, 0xcd4d, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xfffe, 0xa46d, 0x5980, 0x8280, 0xab61, 0xcc65, 0xdd20, 0xc461, 0xa342, 0x69a0, 0x6980, 0xc482, 0xfe84, 0xe580, 0xfda2, 0xfdc2, 0xf5c2, 0xedc3, 0xede2, 0xede2, 0xf5e1, 0xf5e1, 0xf5c2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfde2, 0xfdc1, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfda1, 0xf5c1, 0xf5a1, 0xf5a1, 0xf5a0, 0xfda1, 0xfda0, 0xfda0, 0xfda0, 0xfd81, 0xfda1, 0xfd80, 0xf520, 0xe524, 0xddad, 0xeef8, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbb, 0xdc65, 0xfd21, 0xfd22, 0xfce1, 0xf560, 0xfd22, 0xfd60, 0xfda3, 0xfe45, 0xee67, 0xff6e, 0xfe09, 0xbc46, 0xffbd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xee98, 0x82c5, 0x9b00, 0xcc81, 0xf583, 0xfe05, 0xfe20, 0xfe00, 0xfe66, 0xcce5, 0x7240, 0x82e0, 0xd5a6, 0xf6c6, 0xf68a, 0xf6ab, 0xff0d, 0xff4f, 0xff4f, 0xff2e, 0xfeec, 0xfecb, 0xee2a, 0xee29, 0xee08, 0xee06, 0xf5e4, 0xf5c3, 0xf5c1, 0xf5c0, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfda1, 0xfda1, 0xfe01, 0xf5e1, 0xfde1, 0xfde1, 0xfde1, 0xfdc1, 0xfda1, 0xf580, 0xf541, 0xfd81, 0xfda0, 0xfd60, 0xf520, 0xe503, 0xe528, 0xe56c, 0xff7b, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xfffe, 0xe4e8, 0xfd42, 0xfd42, 0xfd20, 0xf580, 0xfd41, 0xfd42, 0xfd82, 0xfe41, 0xee85, 0xff2e, 0xfe6b, 0xc424, 0xff39, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0xbc6f, 0x8241, 0xfd87, 0xfe03, 0xfde0, 0xfd80, 0xfd65, 0xfd42, 0xf5c2, 0xff0a, 0xfe8f, 0xa409, 0xa42c, 0xff99, 0xffd6, 0xffd7, 0xffd8, 0xf7b9, 0xf799, 0xff99, 0xff78, 0xff78, 0xffd6, 0xffb4, 0xff71, 0xff0d, 0xfea9, 0xf665, 0xf622, 0xf600, 0xfde2, 0xfde2, 0xfe02, 0xfe02, 0xfe02, 0xfde2, 0xfdc2, 0xfdc2, 0xfde2, 0xfdc1, 0xfda1, 0xfda1, 0xfda2, 0xfda3, 0xfd83, 0xfd83, 0xf5a0, 0xf581, 0xfd61, 0xfd82, 0xfda2, 0xfd81, 0xfd20, 0xfcc0, 0xbd53, 0xeed9, 0xfffe, 0xfffe, 0xffde, 0xffdf, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xffff, 0xe52a, 0xf563, 0xf541, 0xfd40, 0xf5c0, 0xfd61, 0xfd43, 0xfd81, 0xf600, 0xeee5, 0xfecd, 0xfeac, 0xd485, 0xfe95, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xf7bf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xfed7, 0xd4eb, 0xcc01, 0xf500, 0xfdc0, 0xfd80, 0xf581, 0xfe05, 0xeecb, 0xf710, 0xff76, 0xffba, 0xffb9, 0xff55, 0xfef4, 0xfed4, 0xff74, 0xff54, 0xff35, 0xff16, 0xff37, 0xff56, 0xf774, 0xef73, 0xff75, 0xff54, 0xff33, 0xff53, 0xff53, 0xff32, 0xf6d0, 0xe66f, 0xf626, 0xf5e4, 0xf5a1, 0xfdc0, 0xfde0, 0xfde2, 0xfdc3, 0xf5c5, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc1, 0xfdc1, 0xfda1, 0xfd82, 0xfd82, 0xfd62, 0xfd41, 0xfd61, 0xf521, 0xe526, 0xf652, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xfffd, 0xffbf, 0xffbf, 0xffff, 0xefff, 0xefff, 0xf7ff, 0xffff, 0xffbe, 0xfffe, 0xf7df, 0xff7a, 0xd484, 0xfd81, 0xfd60, 0xfd81, 0xfd60, 0xfd41, 0xfd61, 0xf5c0, 0xf624, 0xfe8b, 0xfeaa, 0xe566, 0xf58d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffd, 0xffdb, 0xffdd, 0xffbe, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xf7bd, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffdd, 0xe695, 0xdce6, 0xf566, 0xfda4, 0xf560, 0xed60, 0xf5e5, 0xfeab, 0xff30, 0xff97, 0xff97, 0xff97, 0xf7b6, 0xf7d4, 0xf7d4, 0xffb7, 0xff99, 0xf757, 0xf756, 0xf736, 0xf735, 0xff55, 0xff74, 0xff74, 0xff74, 0xff54, 0xff34, 0xf713, 0xff33, 0xff53, 0xff53, 0xff12, 0xf6f1, 0xfeaa, 0xfe68, 0xf604, 0xfdc2, 0xfde1, 0xfe02, 0xfe03, 0xf5c4, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfdc1, 0xfdc1, 0xfda1, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd40, 0xf542, 0xf548, 0xf58d, 0xf5d0, 0xedaf, 0xdcea, 0xcc66, 0xe58f, 0xe610, 0xeeb4, 0xffdb, 0xffff, 0xffff, 0xffbf, 0xfffe, 0xfffe, 0xffff, 0xff7b, 0xcc64, 0xfd60, 0xfd60, 0xfd81, 0xfd60, 0xfd61, 0xfd81, 0xf5c0, 0xf603, 0xfe69, 0xfea9, 0xe565, 0xed4c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xfffe, 0xfffe, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xf7fc, 0xffff, 0xffdf, 0xff3e, 0xf612, 0xed67, 0xfd60, 0xfd60, 0xed40, 0xeda4, 0xfe8b, 0xff72, 0xffb6, 0xff97, 0xff77, 0xff76, 0xf775, 0xef94, 0xefd3, 0xf7b5, 0xf798, 0xf77b, 0xf778, 0xf777, 0xf796, 0xf775, 0xf774, 0xf753, 0xff54, 0xff54, 0xff54, 0xff33, 0xff33, 0xff33, 0xff53, 0xff53, 0xff52, 0xff52, 0xff30, 0xff0d, 0xfe89, 0xf605, 0xf5e3, 0xfe03, 0xfe03, 0xfe03, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfda1, 0xfda1, 0xf580, 0xfda1, 0xfda0, 0xfda0, 0xfda1, 0xf4e0, 0xd3e0, 0xcba0, 0xe442, 0xf504, 0xfd23, 0xf501, 0xe524, 0xed43, 0xdd24, 0xe56b, 0xfed9, 0xffbf, 0xffff, 0xf7ff, 0xfffe, 0xffff, 0xffbc, 0xcca6, 0xfd61, 0xfda1, 0xfda2, 0xfd60, 0xfd80, 0xfda1, 0xf5c0, 0xf5e2, 0xfe47, 0xfe87, 0xe564, 0xe52b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xf7ff, 0xf7ff, 0xefdf, 0xf7ff, 0xf7ff, 0xf7bf, 0xfffd, 0xfffd, 
0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff7d, 0xedf2, 0xe4c5, 0xfd20, 0xfdc0, 0xfda2, 0xfe28, 0xff30, 0xffb5, 0xff97, 0xf778, 0xf799, 0xff74, 0xff74, 0xff75, 0xff95, 0xff94, 0xff52, 0xff31, 0xff32, 0xff11, 0xff32, 0xff73, 0xff74, 0xf754, 0xf734, 0xff33, 0xff33, 0xff54, 0xff53, 0xff33, 0xff32, 0xff32, 0xff31, 0xff31, 0xff31, 0xff52, 0xff51, 0xff0e, 0xfe8a, 0xf626, 0xf604, 0xfe03, 0xfe23, 0xfe03, 0xfe03, 0xfe03, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfdc1, 0xf5a0, 0xfda0, 0xfdc0, 0xfdc0, 0xfdc0, 0xf503, 0xdc20, 0xdc20, 0xece3, 0xf5a5, 0xfe68, 0xff0a, 0xff2a, 0xfec7, 0xfe44, 0xf581, 0xdca1, 0xdce9, 0xfed7, 0xffff, 0xf7df, 0xffdd, 0xffff, 0xffdd, 0xdd28, 0xfda2, 0xfde2, 0xfdc2, 0xfda1, 0xfda0, 0xfdc1, 0xf5c0, 0xf5c0, 0xfe05, 0xfe85, 0xe563, 0xe4e9, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xfffe, 0xfffd, 0xffbc, 0xff7c, 0xff9c, 0xfffc, 0xffff, 0xffdf, 0xffff, 0xf7de, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffdf, 0xff7d, 0xee0f, 0xe525, 0xfd61, 0xfd61, 0xf5e9, 0xfeae, 0xff94, 0xffd8, 0xff98, 0xf758, 0xff57, 0xff77, 0xff78, 0xff36, 0xfef3, 0xfe90, 0xfe0b, 0xed66, 0xed43, 0xf582, 0xf5c6, 0xfe29, 0xfeae, 0xff12, 0xff34, 0xff34, 0xff33, 0xf733, 0xff33, 0xff33, 0xff32, 0xff32, 0xff11, 0xff10, 0xff10, 0xfef0, 0xf713, 0xff32, 0xff31, 0xfeee, 0xfe8a, 0xf626, 0xfe03, 0xfe22, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfde3, 0xfde3, 0xfde3, 0xf5c3, 0xfde2, 0xfde1, 0xf5c0, 0xfdc0, 0xfdc1, 0xfda1, 0xf560, 0xcbe1, 0xd442, 0xed66, 0xfe8a, 0xfeeb, 0xf6ec, 0xef0d, 0xe70e, 0xff0b, 0xfea8, 0xfea6, 0xfe22, 0xe540, 0xd567, 0xf6d7, 0xffbf, 0xfffe, 0xffff, 0xfffe, 0xe5ab, 0xfdc3, 0xfde3, 0xfde3, 0xfde1, 0xfde1, 0xfdc2, 0xfdc0, 0xf5c0, 0xfde3, 0xfe63, 0xed83, 0xdcca, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffbc, 0xfeb4, 0xed8d, 0xcc67, 0xcc25, 0xdca7, 0xed8c, 0xfe96, 0xffdf, 0xffff, 0xffdf, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff3e, 0xf613, 0xe545, 0xed60, 0xfde3, 0xfde7, 0xff35, 0xff56, 0xff78, 0xf758, 0xff78, 0xff77, 0xff55, 0xff33, 0xff16, 0xfeb2, 0xfe4c, 0xeda8, 0xdcc4, 0xcc02, 0xc3e2, 0xcc02, 0xcc41, 0xdcc4, 0xf5a9, 0xfe8e, 0xff12, 0xff33, 0xff53, 0xf733, 0xf6f1, 0xff12, 0xff12, 0xff11, 0xff11, 0xff10, 0xfef0, 0xfef0, 0xff12, 0xf6f1, 0xf6f1, 0xff10, 0xfeee, 0xfe89, 0xf625, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xf5e3, 0xfde2, 0xfde1, 0xf5c0, 0xfde0, 0xfdc2, 0xf562, 0xe4c0, 0xc400, 0xf564, 0xfe47, 0xfe68, 0xfeca, 0xfeab, 0xf64b, 0xf66c, 0xe64a, 0xee29, 0xf626, 0xfe82, 0xfe40, 0xdd61, 0xdd8c, 0xfeda, 0xfffe, 0xffff, 0xfffe, 0xe5cc, 0xf5a3, 0xfde3, 0xfe03, 0xfe22, 0xfe02, 0xfde3, 0xfdc0, 0xfdc0, 0xfdc2, 0xfe22, 0xed82, 0xe4eb, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xff1a, 0xedd0, 0xed08, 0xf4c3, 0xf480, 0xfca0, 0xfce2, 0xec41, 0xd486, 0xee13, 0xffbe, 0xffdf, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xf7ff, 0xffde, 0xfe52, 0xed06, 0xfd41, 0xfde4, 0xee4a, 0xf712, 0xff97, 0xf776, 0xff76, 0xff97, 0xff96, 0xff34, 0xff34, 0xff75, 0xff71, 0xfe8c, 0xc4c5, 0x82c0, 0x5140, 0x3880, 0x2020, 0x1000, 0x59e0, 0x7aa2, 0xb3e4, 0xed48, 0xfe6c, 0xfef0, 0xff32, 0xff14, 0xff11, 0xff11, 0xff11, 0xff11, 0xff10, 0xff10, 0xff10, 0xff10, 0xfef0, 0xfed0, 0xfed0, 0xfef1, 0xff0f, 0xfecc, 0xfe68, 0xf605, 0xfe23, 0xfe23, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfde3, 0xfe02, 0xfe01, 0xfde0, 0xfde1, 0xfdc3, 0xed02, 0xd421, 0xe4c0, 0xfe04, 0xfe66, 0xfe65, 0xfe87, 0xfe66, 0xfde4, 0xfdc4, 0xfe27, 0xfe06, 0xf5a3, 0xf5a1, 0xfe21, 0xf603, 0xdd46, 0xd509, 0xff7c, 0xffff, 0xffff, 0xe5ed, 0xeda4, 0xfe24, 0xfe23, 0xfe22, 0xfe23, 0xfde3, 0xfda1, 0xfde1, 0xfdc2, 0xfe01, 0xf583, 0xed0d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff18, 0xed8f, 0xd444, 0xe440, 0xfcc0, 0xfd00, 0xfd00, 0xfcc0, 0xfd41, 0xe4c0, 0xd527, 0xee55, 0xffdb, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xd6ba, 0xc618, 0xefdf, 0xe694, 0xed87, 0xfd20, 0xfd20, 0xfe29, 0xff74, 0xf7fa, 0xffb5, 0xff94, 0xf773, 0xff73, 0xff73, 0xff74, 0xff55, 0xff56, 0xf669, 0xc505, 0x7aa0, 0x2840, 0x0800, 0x0044, 0x0125, 0x0143, 0x0002, 0x1020, 0x61e0, 0xb3e0, 0xed85, 0xfe8b, 0xfef1, 0xfef4, 0xff32, 0xff32, 0xff11, 0xff10, 0xff10, 0xff10, 0xff10, 0xfeef, 0xfeee, 0xfeef, 0xfef0, 0xfed0, 0xfef0, 0xfeed, 0xfe8a, 0xf626, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfde3, 0xfe02, 0xfe01, 0xfde0, 0xfde2, 0xfdc4, 0xe4c3, 0xc3c1, 0xfd82, 0xfd82, 0xf5c3, 0xee03, 0xee02, 0xede1, 0xf5c0, 0xfdc0, 0xfda1, 0xfdc2, 0xfe03, 0xfde4, 0xfde4, 0xfe46, 0xfe25, 0xdd21, 0xeeb9, 0xf79f, 0xffff, 0xe62e, 0xf5c5, 0xfe65, 0xfe44, 0xfe01, 0xfe23, 0xfde4, 0xfda2, 0xfe02, 0xfdc2, 0xfde0, 0xf583, 0xed2d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdc88, 0xdc45, 0xf4a2, 0xfd20, 0xfd20, 0xfce0, 0xfce1, 0xf503, 0xfda1, 0xfe61, 0xdd62, 0xbc49, 0xff76, 
0xffff, 0xffff, 0xf7ff, 0xffff, 0xff9e, 0xc46e, 0xab88, 0x8ae3, 0x79e1, 0xc3e2, 0xf541, 0xed83, 0xf66d, 0xff56, 0xef55, 0xf792, 0xff34, 0xff34, 0xff95, 0xef54, 0xef34, 0xf774, 0xf771, 0xf74e, 0xfdc7, 0x7a60, 0x0000, 0x0966, 0x5cd5, 0x7e5a, 0x8e7a, 0x85f8, 0x4c13, 0x01a7, 0x0002, 0x4121, 0xd4c2, 0xf562, 0xff0f, 0xf710, 0xeef1, 0xf6f0, 0xfef0, 0xfed0, 0xfed0, 0xfed0, 0xfef0, 0xfef0, 0xfeef, 0xfeef, 0xfeef, 0xfeee, 0xfeee, 0xfeed, 0xfecc, 0xf6cc, 0xfe23, 0xf603, 0xfe24, 0xf604, 0xfe04, 0xfe25, 0xf5e4, 0xfde4, 0xee61, 0xee01, 0xfde2, 0xfde4, 0xfde5, 0xf4e1, 0xd400, 0xf522, 0xfda3, 0xfda2, 0xf560, 0xf560, 0xfe01, 0xfe02, 0xfdc2, 0xfde3, 0xfe02, 0xfde2, 0xfe44, 0xfe44, 0xf624, 0xf604, 0xf604, 0xfea6, 0xcce8, 0xff7a, 0xffdf, 0xc54f, 0xfe28, 0xfde3, 0xfe44, 0xe665, 0xfe04, 0xfe24, 0xf5e4, 0xf645, 0xfe22, 0xfe00, 0xed23, 0xfe32, 0xffdf, 0xffff, 0xfffd, 0xf7fc, 0xf7ff, 0xffbf, 0xffbe, 0xe54d, 0xecc0, 0xf4e0, 0xfce2, 0xfcc1, 0xfcc1, 0xfd01, 0xfd60, 0xfda0, 0xfe01, 0xedc3, 0xee66, 0xdc43, 0xfffd, 
0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xee79, 0x92e8, 0x8242, 0x71e0, 0x79c0, 0xab20, 0xe502, 0xfe49, 0xff31, 0xffb6, 0xf775, 0xff73, 0xff34, 0xff54, 0xff74, 0xf754, 0xf754, 0xf752, 0xff91, 0xf6ed, 0xa3e3, 0x1000, 0x3a69, 0x967c, 0x9f3f, 0x9f3f, 0x9efd, 0xb75f, 0xbf9d, 0x9e59, 0x428c, 0x1000, 0x92c0, 0xf585, 0xfe2b, 0xff12, 0xf710, 0xff0f, 0xfeef, 0xfecf, 0xfecf, 0xfecf, 0xfecf, 0xfeef, 0xfeaf, 0xfeaf, 0xfecf, 0xfecf, 0xfece, 0xfece, 0xfece, 0xfecd, 0xfe45, 0xf604, 0xfe24, 0xfe04, 0xfe04, 0xfe24, 0xfde4, 0xfe04, 0xf623, 0xfe24, 0xfde4, 0xece1, 0xdc20, 0xcba0, 0xc3a0, 0xecc2, 0xf501, 0xfd82, 0xfde3, 0xfde1, 0xfda0, 0xfde2, 0xfe03, 0xfe04, 0xfe44, 0xfe44, 0xfe44, 0xfe04, 0xf624, 0xfe65, 0xfe65, 0xfe66, 0xdd88, 0xee53, 0xffbd, 0xddae, 0xeda5, 0xfe24, 0xf5e4, 0xf646, 0xfe25, 0xfe04, 0xfe04, 0xf625, 0xfe22, 0xfe00, 0xe4e3, 0xfe73, 0xffff, 0xffff, 0xf7dd, 0xf7ff, 0xf7ff, 0xffdf, 0xf634, 0xe509, 0xf500, 0xfd21, 0xfd02, 0xfce1, 0xfcc1, 0xfd01, 0xfd60, 0xfda0, 0xfdc1, 0xf605, 0xfec8, 0xdc84, 0xfffd, 
0xffff, 0xffff, 0xf7ff, 0xffff, 0xc512, 0x69a1, 0x71a0, 0x8240, 0xd482, 0xdce4, 0xfe2b, 0xff51, 0xffb4, 0xff94, 0xff33, 0xff13, 0xff34, 0xff54, 0xff34, 0xff74, 0xff72, 0xff30, 0xff91, 0xcd68, 0x08a0, 0x21c5, 0x9e5b, 0xafbf, 0x973f, 0xa79f, 0x9edd, 0xaefe, 0xcffc, 0xc75f, 0xbe5e, 0x3986, 0x3040, 0xb403, 0xeda8, 0xfeb1, 0xf70e, 0xff0e, 0xff0f, 0xfeef, 0xfeef, 0xfece, 0xf6ce, 0xf6ce, 0xfeaf, 0xfeaf, 0xfeaf, 0xfeaf, 0xfeae, 0xfece, 0xfece, 0xfece, 0xfe67, 0xf625, 0xfe05, 0xfe25, 0xfe24, 0xfe24, 0xfe03, 0xfe24, 0xfe47, 0xe503, 0xcc00, 0xcbc0, 0xe460, 0xf4c2, 0xe460, 0xdc20, 0xd420, 0xd420, 0xf541, 0xfe24, 0xfde3, 0xf5a2, 0xfde3, 0xfe04, 0xfe04, 0xfe04, 0xfe24, 0xf5e4, 0xf624, 0xfe66, 0xf645, 0xf625, 0xfec9, 0xe5ac, 0xf5f2, 0xedcc, 0xfe67, 0xfea6, 0xf5e4, 0xfe67, 0xfe45, 0xfe04, 0xfe05, 0xf605, 0xfe43, 0xfe01, 0xd483, 0xfeb6, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xff39, 0xd4e8, 0xf504, 0xfd21, 0xfd21, 0xfd22, 0xfce1, 0xf4e1, 0xfd21, 0xfd81, 0xfdc1, 0xf5c2, 0xfe26, 0xff09, 0xecc6, 0xfffe, 
0xffdf, 0xffff, 0xffff, 0xffbe, 0xa3ec, 0x6980, 0x9260, 0xc443, 0xfdc3, 0xfe09, 0xfeb1, 0xff55, 0xf774, 0xf752, 0xff32, 0xff14, 0xff33, 0xff34, 0xff13, 0xff53, 0xff51, 0xff50, 0xfeef, 0x7aa0, 0x00a0, 0x8df8, 0xb79f, 0x9f1f, 0xa75f, 0xb75f, 0xc77f, 0xd77f, 0x8535, 0x2a13, 0x4ad6, 0x4a6f, 0x1842, 0x7260, 0xd524, 0xfe2c, 0xfeee, 0xff0f, 0xfeef, 0xfef0, 0xfecf, 0xf6cf, 0xf6ef, 0xff2f, 0xff0e, 0xfeee, 0xfecd, 0xfeac, 0xfeac, 0xfeab, 0xfeab, 0xfeab, 0xfea8, 0xfe26, 0xf605, 0xfe45, 0xfe24, 0xfe24, 0xfe23, 0xfe43, 0xf505, 0xdc41, 0xdc40, 0xf502, 0xfd84, 0xfda4, 0xfd83, 0xfd63, 0xed01, 0xcc20, 0xd460, 0xf583, 0xfe25, 0xfe25, 0xfe25, 0xfe25, 0xfe05, 0xfe25, 0xfe46, 0xfe66, 0xfe46, 0xf625, 0xf646, 0xfea7, 0xee64, 0xe568, 0xab23, 0xdcc5, 0xfea7, 0xf685, 0xf606, 0xfde7, 0xfe66, 0xfe24, 0xfe25, 0xf605, 0xfe63, 0xfe22, 0xcc64, 0xff3a, 0xffff, 0xf7de, 0xf7ff, 0xf7df, 0xffdf, 0xe5ee, 0xe4e2, 0xfd20, 0xfd21, 0xfd21, 0xfd01, 0xfce0, 0xf501, 0xfd61, 0xfdc2, 0xfe03, 0xfe05, 0xf607, 0xff0b, 0xecc6, 0xffff, 
0xffff, 0xf7df, 0xffff, 0xffbc, 0x7aa6, 0x79e0, 0xc3c1, 0xf585, 0xe541, 0xfe8c, 0xff14, 0xef16, 0xf794, 0xff72, 0xff11, 0xff14, 0xff32, 0xff13, 0xff13, 0xff52, 0xff0f, 0xff70, 0xd58c, 0x2840, 0x43ae, 0xb75f, 0xb73f, 0xbf5f, 0xcfbf, 0xd7be, 0xefff, 0xa557, 0x08ed, 0x29b8, 0x2a18, 0x21d2, 0x0006, 0x28e0, 0xcd03, 0xfde8, 0xff10, 0xfef0, 0xf6b0, 0xf6b0, 0xfed0, 0xfef0, 0xff10, 0xff2f, 0xfeca, 0xfec9, 0xfe88, 0xfe67, 0xf667, 0xf666, 0xf666, 0xf666, 0xfea9, 0xfe47, 0xf626, 0xfe46, 0xfe24, 0xfe24, 0xfe44, 0xfe23, 0xcba0, 0xdc20, 0xf502, 0xfdc3, 0xfd81, 0xed20, 0xf561, 0xfdc2, 0xfde5, 0xf563, 0xd480, 0xcc60, 0xed63, 0xfe46, 0xfe46, 0xfe25, 0xfe88, 0xed84, 0xdd22, 0xf5e5, 0xfe87, 0xfe67, 0xf667, 0xfea7, 0xfee5, 0xfe49, 0xc381, 0xed45, 0xfea6, 0xf687, 0xfea9, 0xfe07, 0xfe87, 0xfe25, 0xfe25, 0xf605, 0xfe44, 0xfe03, 0xcca6, 0xff7d, 0xffdf, 0xf7be, 0xffff, 0xffdf, 0xf6b6, 0xd4c4, 0xfd60, 0xfd60, 0xfd21, 0xfd01, 0xfce0, 0xf500, 0xf520, 0xfd82, 0xfde3, 0xfe44, 0xfe68, 0xf629, 0xfecb, 0xdc45, 0xffdf, 
0xffff, 0xf7bf, 0xffff, 0xffbc, 0x6180, 0x9280, 0xe4c2, 0xf562, 0xf607, 0xff91, 0xff96, 0xf735, 0xff74, 0xff52, 0xff11, 0xff13, 0xff31, 0xff13, 0xff14, 0xff32, 0xff0e, 0xff70, 0x8bc6, 0x1860, 0xa69a, 0xcfbf, 0xcf9f, 0xdfbf, 0xefde, 0xffff, 0xce5a, 0x3148, 0x4298, 0x5b9f, 0x4bbe, 0x64df, 0x2af3, 0x0060, 0x9340, 0xfd64, 0xfeef, 0xfeaf, 0xf6b0, 0xfed0, 0xff10, 0xff0f, 0xfeab, 0xfe49, 0xfe24, 0xfe24, 0xf603, 0xf5e2, 0xf5e2, 0xf602, 0xf602, 0xf622, 0xfea8, 0xfe46, 0xf626, 0xfe46, 0xf625, 0xfe24, 0xfe45, 0xedc3, 0xdc00, 0xf4e2, 0xf562, 0xf5c1, 0xfde1, 0xfde1, 0xfde2, 0xf581, 0xfdc3, 0xfde4, 0xe522, 0xd4c1, 0xe543, 0xf5e4, 0xf604, 0xfe44, 0xe545, 0xcca2, 0xc481, 0xe585, 0xfe88, 0xfe88, 0xfe87, 0xfe88, 0xff29, 0xed66, 0xd443, 0xfe27, 0xf686, 0xf688, 0xfe88, 0xfe26, 0xfe87, 0xfe25, 0xfe25, 0xfe26, 0xfe44, 0xfe04, 0xd509, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffbc, 0xd54a, 0xdce0, 0xfd80, 0xfd80, 0xfd41, 0xfd21, 0xfd00, 0xfd20, 0xfd61, 0xf5a2, 0xf5e4, 0xfe45, 0xfe6a, 0xfe8c, 0xf66a, 0xd3e5, 0xf79f, 
0xffdf, 0xffdf, 0xffff, 0xff5a, 0x6180, 0xbba2, 0xfd63, 0xf560, 0xfef0, 0xff73, 0xf733, 0xf713, 0xff12, 0xfef1, 0xf732, 0xf793, 0xff30, 0xff33, 0xff14, 0xff11, 0xff4f, 0xef10, 0x4a43, 0x5aca, 0xcfdf, 0xbf1d, 0xd75f, 0xe79e, 0xf7fe, 0xef9d, 0xa516, 0x528f, 0x6bfc, 0x74fc, 0x7ddf, 0x7e7f, 0x4d1a, 0x0126, 0x6a01, 0xfd44, 0xf6ac, 0xf6cd, 0xfeee, 0xff0e, 0xfeed, 0xfe89, 0xfe04, 0xf5a1, 0xf5a1, 0xf5a1, 0xf5a1, 0xf5a0, 0xf5a0, 0xfdc0, 0xfde0, 0xfde0, 0xfe86, 0xfe46, 0xfe45, 0xfe66, 0xf625, 0xfe25, 0xfe46, 0xe562, 0xd3a0, 0xfd24, 0xf582, 0xf5e2, 0xfe42, 0xf623, 0xfe25, 0xfde5, 0xfdc3, 0xfde4, 0xfe05, 0xfe26, 0xfe26, 0xfe25, 0xf624, 0xfe64, 0xbbe0, 0xe525, 0xfe28, 0xfe89, 0xfe68, 0xf667, 0xfec9, 0xfee9, 0xeda7, 0xc444, 0xe506, 0xfe88, 0xfe87, 0xfea9, 0xf668, 0xfea7, 0xf688, 0xfe46, 0xfe26, 0xfe67, 0xfe24, 0xfe05, 0xdd8c, 0xffdf, 0xffff, 0xffff, 0xff7c, 0xee50, 0xdce2, 0xfd60, 0xfd60, 0xf561, 0xfd62, 0xfd21, 0xfd20, 0xfd60, 0xfd81, 0xfdc3, 0xfe25, 0xfe87, 0xfe8c, 0xfeee, 0xd588, 0xdc47, 0xffbf, 
0xff9f, 0xffff, 0xf7be, 0xeeb7, 0x71e0, 0xe4c6, 0xfde4, 0xfe01, 0xff96, 0xf733, 0xef11, 0xff72, 0xff32, 0xfed1, 0xf732, 0xef92, 0xff2f, 0xff33, 0xff14, 0xfef1, 0xff70, 0xdecf, 0x2140, 0x9d36, 0xdfff, 0xcf9f, 0xefff, 0xefdf, 0xf7de, 0xf7ff, 0xe75f, 0xf7df, 0xd7bf, 0x7576, 0x2390, 0x13f5, 0x7f3f, 0x4bd1, 0x40c1, 0xfcc4, 0xf6cb, 0xff0c, 0xff2d, 0xfeeb, 0xf647, 0xedc3, 0xf580, 0xfda0, 0xfd81, 0xfd81, 0xfd80, 0xfd80, 0xfda0, 0xfda0, 0xfdc0, 0xfde0, 0xfe65, 0xfe65, 0xfe65, 0xfe66, 0xf605, 0xfe26, 0xfe47, 0xdd22, 0xd3a0, 0xf504, 0xed43, 0xfe44, 0xff07, 0xfe86, 0xfe47, 0xfe48, 0xfe23, 0xfe24, 0xfe46, 0xfe06, 0xf5e5, 0xfe66, 0xfe64, 0xe5a1, 0xcc62, 0xfde8, 0xfe8a, 0xfe69, 0xfe69, 0xfeca, 0xfea8, 0xd584, 0xbbc2, 0xe529, 0xfead, 0xfea9, 0xf667, 0xfe8a, 0xf688, 0xf6e6, 0xf687, 0xfe66, 0xfe25, 0xfe67, 0xfe24, 0xfe05, 0xe5ee, 0xffdf, 0xfffe, 0xffff, 0xff5b, 0xc4a6, 0xf540, 0xfde1, 0xfd62, 0xed62, 0xfd42, 0xfd00, 0xfd20, 0xfd60, 0xfdc2, 0xfe24, 0xfe66, 0xfec8, 0xfecd, 0xff0f, 0xbcc6, 0xf4ca, 0xffdf, 
0xffff, 0xffdd, 0xffde, 0xe6b9, 0x8b01, 0xf5a1, 0xeda4, 0xff33, 0xff55, 0xff12, 0xfecf, 0xfe8e, 0xfef1, 0xff73, 0xe732, 0xdf72, 0xff13, 0xff30, 0xf6d0, 0xff11, 0xff71, 0xb52c, 0x29a6, 0xc73d, 0xdf9d, 0xefff, 0xe7be, 0xf7ff, 0xefdf, 0xef9e, 0xffff, 0xffbe, 0xffff, 0xad94, 0x0001, 0x0002, 0x330b, 0x75f8, 0x52c8, 0xfca1, 0xf6e7, 0xff0b, 0xfe8b, 0xfde8, 0xfd21, 0xfd40, 0xfd83, 0xdc00, 0xec80, 0xf4e0, 0xfd60, 0xfda0, 0xf5c0, 0xfde0, 0xfe01, 0xfe43, 0xfec7, 0xfe66, 0xfe46, 0xfe47, 0xfe46, 0xfe46, 0xfe66, 0xf625, 0xcba0, 0xf522, 0xf5a3, 0xede5, 0xfeaa, 0xfecd, 0xee6b, 0xf6ab, 0xfe2a, 0xfe6a, 0xfeab, 0xf6a9, 0xee47, 0xfec9, 0xfe88, 0xc420, 0xdd83, 0xfe67, 0xfec9, 0xfe68, 0xf648, 0xfe89, 0xf669, 0xe5c6, 0xf68b, 0xfeaa, 0xfeaa, 0xfeca, 0xfeca, 0xfea9, 0xfea9, 0xfe89, 0xfe88, 0xfe66, 0xfe44, 0xfe43, 0xfe65, 0xc4a5, 0xff99, 0xf7df, 0xffbf, 0xf698, 0xdd4b, 0xed44, 0xfdc1, 0xfdc0, 0xfda1, 0xfd82, 0xfd82, 0xfd41, 0xecc0, 0xfd61, 0xfde4, 0xfe07, 0xfecc, 0xeead, 0xff8d, 0xfd88, 0xd4cd, 0xf7ff, 0xf7ff, 
0xffff, 0xfffd, 0xffdf, 0xcd32, 0xb400, 0xfde3, 0xfe29, 0xff30, 0xfe6c, 0xf5c7, 0xfe05, 0xed84, 0xe526, 0xfe2d, 0xfef1, 0xff32, 0xff32, 0xff50, 0xff10, 0xfef1, 0xff50, 0xacab, 0x4a6a, 0xd7bf, 0xe79e, 0xe7be, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xffff, 0xd698, 0x18a4, 0x0001, 0x0103, 0x5d36, 0x73cd, 0xec21, 0xfe69, 0xfe89, 0xf626, 0xf5a2, 0xfde3, 0xf4e0, 0xbb80, 0xd4a6, 0xfdc9, 0xf586, 0xf562, 0xfd60, 0xfd80, 0xfdc1, 0xfe05, 0xfe47, 0xfe66, 0xfe46, 0xfe67, 0xfe67, 0xf606, 0xf605, 0xfe25, 0xf605, 0xdba3, 0xeca3, 0xfda3, 0xfe23, 0xfe66, 0xfeca, 0xff0d, 0xff0e, 0xfeee, 0xfecd, 0xfeed, 0xee8b, 0xfecc, 0xfeab, 0xe546, 0xcc01, 0xf626, 0xfe88, 0xfea9, 0xfe88, 0xfe68, 0xfea9, 0xfeaa, 0xfe89, 0xf6ab, 0xfeab, 0xfecb, 0xfeca, 0xfeca, 0xfeaa, 0xfea9, 0xfea9, 0xf648, 0xf688, 0xfec8, 0xfe66, 0xfe47, 0xccc7, 0xff99, 0xf7be, 0xf6b5, 0xe5ee, 0xe567, 0xf5a3, 0xfde1, 0xfdc0, 0xfd80, 0xf581, 0xf541, 0xfd61, 0xfda2, 0xf582, 0xfe46, 0xfe89, 0xee4a, 0xff70, 0xfecc, 0xcc66, 0xfe75, 0xf7ff, 0xf7ff, 
0xffff, 0xfffe, 0xffbf, 0xbc2a, 0xe500, 0xfde4, 0xfe8d, 0xfecb, 0xed41, 0xcc62, 0x9ac0, 0xa341, 0xc463, 0xe545, 0xfe8d, 0xfe70, 0xff10, 0xff2e, 0xff30, 0xfef0, 0xff50, 0x93e8, 0x6b8f, 0xdfff, 0xefdf, 0xefbe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf79e, 0xffdf, 0xffbe, 0xdeb9, 0x3105, 0x1022, 0x0040, 0x33d1, 0x7c50, 0xd3a0, 0xfe29, 0xfe46, 0xeda0, 0xf5a0, 0xe4a0, 0xcbe1, 0xedab, 0xf68f, 0xfeef, 0xfe49, 0xf5a2, 0xfda0, 0xfdc0, 0xfe02, 0xfe67, 0xfeab, 0xfe87, 0xfe67, 0xfe67, 0xfe46, 0xf626, 0xfe67, 0xfea8, 0xfe88, 0xd383, 0xd3c0, 0xe460, 0xf520, 0xfdc3, 0xfe68, 0xfecb, 0xfecb, 0xff2d, 0xff2d, 0xff2d, 0xfeec, 0xff0d, 0xfe09, 0xd463, 0xdc63, 0xfe88, 0xfea8, 0xfe88, 0xfe89, 0xfea9, 0xfeca, 0xfeeb, 0xff0b, 0xfecb, 0xfecb, 0xfecb, 0xfecb, 0xfeca, 0xfeca, 0xfea9, 0xfea9, 0xfecb, 0xfeaa, 0xfe8a, 0xfe49, 0xfde8, 0xd4c7, 0xff35, 0xff58, 0xdd87, 0xe585, 0xf5a3, 0xfde2, 0xfde1, 0xfda0, 0xfd80, 0xf581, 0xfd20, 0xfd81, 0xfe24, 0xf604, 0xfe68, 0xfecb, 0xfeac, 0xff90, 0xe568, 0xc4ab, 0xffdd, 0xffff, 0xffff, 
0xffff, 0xffff, 0xfefa, 0xd464, 0xfd80, 0xf5c5, 0xfeae, 0xeda6, 0x9360, 0x2800, 0x1800, 0x1000, 0x1000, 0x6a40, 0xc483, 0xfe4a, 0xff0f, 0xf6ec, 0xf70f, 0xfed0, 0xff50, 0x7b46, 0x8c73, 0xe7ff, 0xf7df, 0xffff, 0xffdf, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xc594, 0x1842, 0x0800, 0x0020, 0x128c, 0x7cb2, 0xcb62, 0xfe47, 0xfdc2, 0xfda0, 0xdca0, 0xbc22, 0xee0d, 0xffb4, 0xff91, 0xee05, 0xeda2, 0xedc0, 0xfe21, 0xfe82, 0xfe84, 0xee87, 0xeea9, 0xfe68, 0xfe67, 0xfe67, 0xfe87, 0xfe87, 0xfe67, 0xf5c5, 0xdcc2, 0xe420, 0xe420, 0xdbe0, 0xe420, 0xf503, 0xfd85, 0xfde5, 0xfe67, 0xf687, 0xfea8, 0xf667, 0xfea8, 0xf5e6, 0xd4a1, 0xe4e2, 0xfe07, 0xfe67, 0xfe88, 0xfe88, 0xfea9, 0xfeaa, 0xfeca, 0xfeeb, 0xfecb, 0xfecc, 0xfecc, 0xfeec, 0xfeeb, 0xfeeb, 0xfeca, 0xfeca, 0xfea9, 0xfe69, 0xe5a7, 0xed67, 0xfda8, 0xfd47, 0xbb82, 0xcc86, 0xbc47, 0xeda2, 0xf5e2, 0xfe03, 0xfde2, 0xfdc1, 0xfda1, 0xfda1, 0xf5c1, 0xfd40, 0xfda1, 0xf5e4, 0xfea8, 0xee89, 0xfeec, 0xff90, 0xfe4c, 0xcc68, 0xf6d8, 0xffff, 0xfffe, 0xfffe, 
0xfffe, 0xffdf, 0xedf1, 0xf521, 0xfd61, 0xfe29, 0xf64b, 0xa341, 0x1022, 0x0000, 0x1966, 0x5350, 0x320c, 0x0820, 0x51e0, 0xdde4, 0xff30, 0xff2c, 0xf6ce, 0xfecf, 0xff50, 0x72e4, 0x9cf4, 0xe7ff, 0xf7df, 0xffff, 0xffbf, 0xffff, 0xffdf, 0xffff, 0xdf3e, 0xf7ff, 0xdf7e, 0x62aa, 0x0800, 0x0800, 0x0840, 0x020b, 0x8d76, 0xc343, 0xf683, 0xfde1, 0xec60, 0xd402, 0xf690, 0xfff7, 0xef0f, 0xee8a, 0xfde1, 0xfe02, 0xf644, 0xf6c8, 0xf70b, 0xf70b, 0xf70b, 0xff2b, 0xfe89, 0xfe68, 0xfe87, 0xfea7, 0xfea7, 0xfe87, 0xed44, 0xbba0, 0xfd61, 0xfd42, 0xeca1, 0xdc00, 0xdbe0, 0xd420, 0xe4a1, 0xf584, 0xfd84, 0xfd84, 0xed02, 0xed22, 0xdc81, 0xbbc0, 0xe4e2, 0xfeaa, 0xfe68, 0xfe88, 0xfea9, 0xfea9, 0xfeca, 0xfeca, 0xfecb, 0xfeaa, 0xfeec, 0xfeec, 0xfeec, 0xfeec, 0xfeeb, 0xfeea, 0xfeca, 0xfeca, 0xfec9, 0xdd64, 0xc420, 0xcc00, 0xdc83, 0xd462, 0xfda6, 0xfe68, 0xfe04, 0xfe24, 0xfe04, 0xfdc3, 0xfda2, 0xfda2, 0xfda1, 0xfdc1, 0xfd81, 0xfde3, 0xee05, 0xf6c9, 0xf6ec, 0xff2f, 0xfecf, 0xd4c8, 0xe56f, 0xffff, 0xf7ff, 0xfffe, 0xfffe, 
0xf7ff, 0xffbf, 0xdd08, 0xfd60, 0xfd43, 0xfeac, 0xc506, 0x40e0, 0x0003, 0x536e, 0xbf1a, 0xcfde, 0xe7ff, 0x9d36, 0x2921, 0x62a2, 0xf68d, 0xff8e, 0xf6ce, 0xfecf, 0xff0e, 0x8345, 0xad55, 0xe7ff, 0xf7df, 0xffdf, 0xffdf, 0xffbe, 0xffff, 0xef9f, 0x7453, 0xbedd, 0x64d4, 0x0000, 0x0000, 0x1061, 0x0000, 0x0188, 0x8576, 0xbb23, 0xfea2, 0xed41, 0xd443, 0xfe2f, 0xfff8, 0xf793, 0xe6cc, 0xee46, 0xfde4, 0xfe47, 0xfeed, 0xff72, 0xffb4, 0xff93, 0xff50, 0xff0e, 0xfe8a, 0xfea9, 0xfea8, 0xf686, 0xf666, 0xfe67, 0xf545, 0xcbc0, 0xf541, 0xf562, 0xfd83, 0xfd81, 0xed00, 0xe4c0, 0xd460, 0xcc01, 0xdbe0, 0xdbe0, 0xd420, 0xd441, 0xdca3, 0xdc83, 0xdc64, 0xfda9, 0xfea9, 0xfe88, 0xfea9, 0xfeca, 0xfeca, 0xfeaa, 0xfecb, 0xfeec, 0xfeec, 0xff0d, 0xff0c, 0xff0c, 0xfeeb, 0xfeeb, 0xfeca, 0xfeca, 0xff29, 0xfee9, 0xfe67, 0xfe27, 0xfe69, 0xfe68, 0xfe65, 0xfe23, 0xfe25, 0xfe05, 0xfde5, 0xfdc4, 0xfdc3, 0xfdc2, 0xfda1, 0xfda0, 0xfdc4, 0xfe26, 0xfea8, 0xeeaa, 0xff6f, 0xff51, 0xd54c, 0xcccb, 0xff5b, 0xffff, 0xf7ff, 0xffff, 0xffff, 
0xf7ff, 0xff17, 0xe4c2, 0xfd40, 0xfdc6, 0xfe4b, 0x72c1, 0x0800, 0x3aca, 0xcf3d, 0xe7ff, 0xcf5d, 0xdfbd, 0xf7fe, 0xbdb6, 0x1864, 0xb466, 0xff4e, 0xf6ee, 0xfecf, 0xfeed, 0x9c27, 0xb5b5, 0xe7ff, 0xf7df, 0xf7df, 0xffde, 0xffbd, 0xffff, 0xe7bf, 0x4b6f, 0x6cf6, 0x5516, 0x0022, 0x0042, 0x0000, 0x0800, 0x334f, 0x7554, 0xc363, 0xfda3, 0xc4a2, 0xfed0, 0xfff6, 0xf752, 0xf6ed, 0xf6a9, 0xfeea, 0xfecd, 0xff71, 0xffb4, 0xff53, 0xf690, 0xedcc, 0xe508, 0xdc85, 0xdd46, 0xede7, 0xf687, 0xf6c7, 0xfea7, 0xfe68, 0xf546, 0xd3c1, 0xfe04, 0xfe25, 0xfe05, 0xf5e3, 0xf5e1, 0xfde2, 0xfdc3, 0xf564, 0xfda4, 0xfda4, 0xfe06, 0xf5e6, 0xfe28, 0xfde8, 0xdca4, 0xcbe2, 0xf668, 0xfe88, 0xfea9, 0xfeca, 0xfeca, 0xfeca, 0xfecb, 0xff0c, 0xff0d, 0xff0d, 0xff0c, 0xff0c, 0xfeec, 0xfeeb, 0xfeca, 0xfeca, 0xeea9, 0xfec9, 0xfe88, 0xfe48, 0xfe48, 0xfea9, 0xfe65, 0xf602, 0xfe24, 0xf604, 0xf603, 0xfe03, 0xfe03, 0xfdc2, 0xfda1, 0xfda1, 0xfe07, 0xfe68, 0xfeca, 0xf6eb, 0xff6f, 0xee6f, 0xcd0d, 0xfe74, 0xffff, 0xefbd, 0xfffe, 0xffdf, 0xffdf, 
0xefff, 0xf690, 0xf4e0, 0xfd41, 0xfe48, 0xdd67, 0x3900, 0x0003, 0xa619, 0xe7bf, 0xd73f, 0xef9f, 0xef9f, 0xf7bf, 0xffff, 0x9493, 0x6a40, 0xf6cd, 0xf6ce, 0xfecf, 0xfecd, 0xb4c9, 0xbdf5, 0xdfde, 0xefff, 0xf7ff, 0xfffe, 0xfffe, 0xfffe, 0xefff, 0x74f5, 0x4c12, 0x8f5f, 0x2a0a, 0x0021, 0x0020, 0x6ae9, 0xbf9f, 0x85d6, 0xc343, 0xd3a0, 0xfe6d, 0xf7f5, 0xdf92, 0xef0d, 0xfea9, 0xfe89, 0xff0c, 0xe7b5, 0xf7f5, 0xf731, 0xdda9, 0xc463, 0xd443, 0xf4c4, 0xfd26, 0xe587, 0xf628, 0xfec9, 0xfee7, 0xfea7, 0xfe88, 0xfd66, 0xdbe2, 0xd500, 0xfe86, 0xfeca, 0xfe68, 0xfe66, 0xfe22, 0xf5c0, 0xfe42, 0xf642, 0xee22, 0xee63, 0xf6a5, 0xee45, 0xfe88, 0xfe28, 0xcbe0, 0xe606, 0xf688, 0xfec9, 0xfeaa, 0xf6aa, 0xfecb, 0xfeeb, 0xfecb, 0xff0d, 0xff0d, 0xff0c, 0xff0c, 0xfeec, 0xfeeb, 0xfeca, 0xfeaa, 0xfe8b, 0xfe69, 0xfe48, 0xfe49, 0xf609, 0xfe69, 0xfe26, 0xfe03, 0xf664, 0xf623, 0xf622, 0xfe42, 0xfe22, 0xfdc1, 0xfdc1, 0xfdc2, 0xfe49, 0xfe8a, 0xf689, 0xff6e, 0xfeee, 0xc52b, 0xe612, 0xffbb, 0xf7ff, 0xfffe, 0xfffc, 0xffdf, 0xffdf, 
0xffde, 0xd54a, 0xf543, 0xf520, 0xfea7, 0xac48, 0x0000, 0x426a, 0xd7df, 0xd79f, 0xefff, 0xdf7d, 0xf7fd, 0xfffe, 0xe75d, 0xc67c, 0x5167, 0xe589, 0xfeeb, 0xfece, 0xff0d, 0xc487, 0xb532, 0xd7ff, 0xe7de, 0xf7ff, 0xffff, 0xffff, 0xffdf, 0xf7df, 0xcefe, 0x2a6c, 0x7f1f, 0x5e78, 0x2227, 0x0021, 0x8db4, 0xe7ff, 0xa4f7, 0xb220, 0xe631, 0xffb5, 0xf750, 0xff90, 0xfecd, 0xf6ad, 0xf770, 0xf7f3, 0xffb2, 0xe589, 0xc4a5, 0xcce4, 0xee08, 0xff2b, 0xff0a, 0xfec8, 0xfeea, 0xfec9, 0xfe88, 0xfe68, 0xfe88, 0xfe67, 0xf626, 0xede5, 0xc3a0, 0xe4a1, 0xfdc5, 0xfe26, 0xfe04, 0xf562, 0xf5e3, 0xf623, 0xfe24, 0xfe03, 0xfe04, 0xfe05, 0xf605, 0xfe67, 0xfe47, 0xe584, 0xcc42, 0xfe8a, 0xfeaa, 0xf6a9, 0xfeea, 0xf6ca, 0xff2c, 0xf6cc, 0xff0c, 0xfeeb, 0xfeeb, 0xff0c, 0xff0b, 0xfeaa, 0xf6a9, 0xfeaa, 0xfea8, 0xfea8, 0xfe88, 0xfe87, 0xfe67, 0xfe46, 0xfe46, 0xfe45, 0xfe24, 0xfe23, 0xfe01, 0xfdc0, 0xfdc0, 0xedc1, 0xee03, 0xf665, 0xf6aa, 0xee8b, 0xff71, 0xfeef, 0xe52a, 0xe5b0, 0xffbd, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xff5b, 0xd528, 0xf542, 0xf520, 0xfe46, 0x8323, 0x0000, 0x84b3, 0xe7ff, 0xd79e, 0xe7df, 0xf7ff, 0xf7ff, 0xa577, 0x424f, 0x190d, 0x3108, 0xac66, 0xfeeb, 0xfead, 0xfecb, 0xdd49, 0xa4af, 0xd7ff, 0xdf9e, 0xefff, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xd73e, 0x4b0e, 0x44f9, 0x86be, 0x6e3b, 0x5536, 0x761b, 0x9ede, 0x83ac, 0xcbe7, 0xff54, 0xffb4, 0xfeef, 0xfeed, 0xee8b, 0xff2e, 0xffb1, 0xf750, 0xdd07, 0xd4e6, 0xedc9, 0xf66a, 0xfeaa, 0xfeea, 0xfea9, 0xfea8, 0xfea9, 0xfe88, 0xfe68, 0xfe68, 0xfe88, 0xfe88, 0xfe67, 0xf646, 0xe4c3, 0xcc00, 0xcbc0, 0xd400, 0xe4c1, 0xe4e1, 0xe501, 0xe521, 0xe500, 0xed82, 0xfe24, 0xfe25, 0xf605, 0xfe26, 0xfe46, 0xede5, 0xc3c1, 0xfe4a, 0xfe49, 0xf648, 0xff0a, 0xfeea, 0xfeeb, 0xf6ab, 0xfeeb, 0xf6cb, 0xfecb, 0xfeeb, 0xfeeb, 0xfeaa, 0xf6aa, 0xfeaa, 0xfea8, 0xfea8, 0xfe88, 0xfe87, 0xfe67, 0xfe46, 0xfe45, 0xfe45, 0xfe04, 0xfe24, 0xfe02, 0xfdc1, 0xfde2, 0xfe04, 0xf646, 0xf667, 0xee6a, 0xff8f, 0xfe8c, 0xcce9, 0xdd8f, 0xff7a, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf634, 0xdcc5, 0xfd41, 0xfd81, 0xfe26, 0x51e0, 0x0883, 0xc6dc, 0xdf9d, 0xdf7d, 0xf7ff, 0xffff, 0xcebc, 0x424e, 0x18ee, 0x3a17, 0x4271, 0x83a7, 0xfeab, 0xfeab, 0xfe8a, 0xf5ca, 0x93ec, 0xd7df, 0xdfbf, 0xe7df, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffdf, 0xa575, 0x122f, 0x855e, 0x5e5f, 0x3ddd, 0x5e1f, 0x7dba, 0x9385, 0xfed6, 0xffd3, 0xff51, 0xfead, 0xfecc, 0xf6ec, 0xff8f, 0xfeed, 0xdd89, 0xb3a2, 0xd4e6, 0xfeac, 0xff2d, 0xfeeb, 0xfeca, 0xfe88, 0xfea9, 0xf688, 0xf688, 0xfe88, 0xfe88, 0xfe88, 0xfe88, 0xfe87, 0xfe67, 0xfeec, 0xfdc7, 0xdca3, 0xc3a0, 0xc3a0, 0xd420, 0xcbe0, 0xcc00, 0xcc60, 0xe500, 0xfde3, 0xfe25, 0xfe25, 0xfe46, 0xfea8, 0xfe88, 0xc381, 0xfe0a, 0xfeab, 0xfeaa, 0xfeca, 0xf688, 0xfeaa, 0xfe8a, 0xf6ca, 0xf6aa, 0xfeaa, 0xfeca, 0xfeca, 0xfeaa, 0xfea9, 0xfeca, 0xfe88, 0xfe88, 0xfe87, 0xfe67, 0xfe66, 0xfe46, 0xfe45, 0xfe25, 0xfe05, 0xfde4, 0xfdc3, 0xfde2, 0xfe03, 0xfe25, 0xfe48, 0xfe69, 0xff4f, 0xfeac, 0xdd28, 0xcd2c, 0xff5b, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xe54e, 0xdc81, 0xfd40, 0xfde3, 0xfe28, 0x3960, 0x1947, 0xd7bf, 0xe79e, 0xf7ff, 0xf7df, 0xef9e, 0xf7ff, 0xd6ff, 0xbe3f, 0x7c1e, 0x74dd, 0x83cb, 0xee2a, 0xfeaa, 0xfe69, 0xfe0a, 0x93c9, 0xcf3e, 0xd7bf, 0xdfdf, 0xefff, 0xffff, 0xffdf, 0xffde, 0xffff, 0xf79d, 0x52af, 0x4253, 0x5d3f, 0x667f, 0x653f, 0x8c52, 0xe58a, 0xff76, 0xff90, 0xf70e, 0xfeac, 0xfeec, 0xff2d, 0xfeec, 0xdd88, 0xd4c6, 0xcc64, 0xeda9, 0xfecc, 0xfecb, 0xf6ca, 0xfeca, 0xfea9, 0xfea9, 0xfe89, 0xfea9, 0xfea9, 0xfea8, 0xfe88, 0xfe67, 0xfe67, 0xfe67, 0xf648, 0xfe48, 0xfe48, 0xe4c3, 0xdc40, 0xfdc5, 0xfde5, 0xfde4, 0xf581, 0xfde2, 0xfe24, 0xfe24, 0xfe04, 0xfe25, 0xfe66, 0xfe47, 0xd3e3, 0xe4a5, 0xe525, 0xedc6, 0xf607, 0xfe68, 0xff0b, 0xfeaa, 0xfeca, 0xfeaa, 0xfeaa, 0xfeaa, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe87, 0xfe87, 0xfe66, 0xfe46, 0xfe45, 0xfe25, 0xfe25, 0xfe04, 0xfdc3, 0xf5c2, 0xf5e2, 0xf603, 0xf626, 0xfe89, 0xff0c, 0xfead, 0xd4e7, 0xd54c, 0xff9a, 0xffff, 0xf7ff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xe50a, 0xe4a0, 0xfd20, 0xfdc3, 0xede7, 0x3120, 0x428c, 0xdfff, 0xf7df, 0xf7bf, 0xffdf, 0xffff, 0xfffe, 0xf7fe, 0xf7ff, 0x9d5b, 0x6cbc, 0x83ee, 0xe5c9, 0xfec9, 0xfe69, 0xfe6a, 0xb468, 0xad75, 0xcfbf, 0xd7bf, 0xdf9f, 0xf7ff, 0xffdf, 0xf79e, 0xfffe, 0xfffe, 0xdebc, 0x4ab1, 0x2a32, 0x3bbb, 0x6376, 0xbc0b, 0xfef0, 0xff91, 0xff0e, 0xff0d, 0xeeec, 0xf6cb, 0xfeab, 0xe587, 0xd506, 0xfe4b, 0xd4c5, 0xfe2a, 0xfecc, 0xf6aa, 0xf6eb, 0xfeeb, 0xfeca, 0xfe89, 0xfea9, 0xfea9, 0xfec9, 0xfea9, 0xfe88, 0xfe67, 0xfe67, 0xfe67, 0xf665, 0xf646, 0xfea8, 0xf543, 0xcc00, 0xfd83, 0xfda2, 0xfd60, 0xfe02, 0xfe23, 0xfe03, 0xfde3, 0xfe04, 0xfe45, 0xfe66, 0xfe66, 0xd402, 0xdc63, 0xd462, 0xd4a2, 0xd4e2, 0xd503, 0xf5c7, 0xfeab, 0xfeca, 0xfeca, 0xfeca, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfe89, 0xfe87, 0xfe87, 0xfe67, 0xfe46, 0xfe46, 0xfe25, 0xfe25, 0xfe04, 0xfe02, 0xfe22, 0xf601, 0xee01, 0xf643, 0xfec8, 0xfeca, 0xfeac, 0xcc65, 0xd52c, 0xff59, 0xffff, 0xf7bf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xe4c8, 0xf501, 0xfd40, 0xfda3, 0xe5c7, 0x2900, 0x636f, 0xdfdf, 0xefdf, 0xef9f, 0xffff, 0xf79d, 0xef9a, 0xf7db, 0xffff, 0x8cb3, 0x19ee, 0x7309, 0xe5a8, 0xfec9, 0xf66a, 0xfeca, 0xdd68, 0x838a, 0xc77e, 0xd7bf, 0xcf5e, 0xdfbf, 0xefdf, 0xefbf, 0xf7de, 0xfffe, 0xf7ff, 0xb6bd, 0x528f, 0x296e, 0x6249, 0xfdcd, 0xff93, 0xffce, 0xfeac, 0xff2d, 0xf72c, 0xeeeb, 0xfe8b, 0xdd26, 0xeda8, 0xff6f, 0xbc43, 0xf64a, 0xfeec, 0xfeeb, 0xff0b, 0xfeca, 0xfeaa, 0xfeaa, 0xfe88, 0xfea9, 0xfea9, 0xfea8, 0xfe88, 0xfe67, 0xfe67, 0xfe88, 0xfea5, 0xf624, 0xfe66, 0xfdc5, 0xcc00, 0xf520, 0xfdc1, 0xfde0, 0xfdc1, 0xfde2, 0xfde2, 0xfde3, 0xfe24, 0xfe25, 0xfe25, 0xfe46, 0xcc01, 0xfde7, 0xfe69, 0xfe27, 0xf607, 0xd4e3, 0xcc83, 0xfe0a, 0xfea9, 0xfec9, 0xfec9, 0xfe89, 0xfe88, 0xfea8, 0xfe88, 0xfe68, 0xfe67, 0xfe67, 0xfe66, 0xfe46, 0xfe25, 0xfe25, 0xfe04, 0xfe04, 0xfde2, 0xfe43, 0xf601, 0xee01, 0xfec6, 0xff0a, 0xee09, 0xcce6, 0xd50b, 0xff38, 0xffff, 0xffff, 0xffdf, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xd465, 0xfd61, 0xfd60, 0xfda4, 0xf629, 0x2900, 0x73d0, 0xe7df, 0xe7fd, 0xe7bd, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0x7bf0, 0x0022, 0x51a2, 0xdd46, 0xf6c9, 0xee6b, 0xfea9, 0xfe27, 0x9b66, 0xa65a, 0xcf9f, 0xc75f, 0xcf7f, 0xdfbf, 0xe7bf, 0xefdf, 0xefdf, 0xdfbd, 0xe7ff, 0xffff, 0xcd75, 0xa3c7, 0xff31, 0xffd3, 0xeecb, 0xfe8b, 0xfecc, 0xff4d, 0xff4e, 0xff0d, 0xe62a, 0xfecc, 0xf66b, 0xc4a4, 0xfeab, 0xfeec, 0xfecb, 0xfeec, 0xf6aa, 0xfeaa, 0xfecb, 0xfe88, 0xfe88, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe87, 0xfe65, 0xf625, 0xfe47, 0xfe07, 0xcc00, 0xe4c0, 0xfdc2, 0xfe42, 0xf5a0, 0xfde1, 0xfde2, 0xfde2, 0xfe23, 0xfe04, 0xfe04, 0xfe66, 0xc400, 0xf585, 0xfe67, 0xfe67, 0xfeea, 0xfe49, 0xd4c5, 0xcc64, 0xf668, 0xfe88, 0xfe89, 0xfe88, 0xfe88, 0xfe88, 0xfe88, 0xfe47, 0xfe67, 0xfe67, 0xfe46, 0xfe45, 0xfe25, 0xfe24, 0xfe04, 0xfe04, 0xfdc4, 0xfe04, 0xede3, 0xf665, 0xfee9, 0xee29, 0xd508, 0xd50a, 0xff7b, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xcc24, 0xfd82, 0xfd40, 0xfd83, 0xfe6a, 0x3120, 0x7bf0, 0xefff, 0xe7fb, 0xf7fe, 0xefbf, 0xb577, 0xd63a, 0xffdf, 0xde9c, 0x20c6, 0x0000, 0x40e0, 0xcce4, 0xf6c9, 0xe66c, 0xfe47, 0xfe86, 0xcc68, 0x6c92, 0xb71d, 0xc75f, 0xc75f, 0xcf5f, 0xd77f, 0xdfbf, 0xdf9f, 0xdfde, 0xe7be, 0xefdf, 0xd50d, 0xedab, 0xff94, 0xf68e, 0xfead, 0xff0c, 0xfeab, 0xfeed, 0xff4e, 0xf74e, 0xef4e, 0xff8f, 0xc4a5, 0xe5a7, 0xff2d, 0xfeec, 0xfeab, 0xff0c, 0xfeca, 0xfeaa, 0xfeca, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe67, 0xfe67, 0xfe67, 0xfe26, 0xfe48, 0xfe28, 0xfe09, 0xd441, 0xed02, 0xfde3, 0xf5e2, 0xfde1, 0xfe02, 0xfde2, 0xf5c2, 0xfe03, 0xfe04, 0xfe24, 0xfe66, 0xf5a4, 0xf5c4, 0xfe46, 0xf626, 0xf627, 0xfeec, 0xfe0a, 0xbbe3, 0xee27, 0xf668, 0xfe68, 0xfe68, 0xfe67, 0xfe88, 0xfe67, 0xfe47, 0xfe67, 0xfe67, 0xfe46, 0xfe45, 0xfe25, 0xfe04, 0xfe04, 0xfe04, 0xfda5, 0xf5c5, 0xf606, 0xfeea, 0xfecb, 0xcd07, 0xdd2b, 0xff97, 0xf7ff, 0xffff, 0xffbd, 0xffbd, 0xffdf, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xcc41, 0xf563, 0xf542, 0xfdc3, 0xfec9, 0x4100, 0x7bd2, 0xe7ff, 0xdfbd, 0xffbf, 0xffbf, 0x8414, 0x32ae, 0x74d5, 0x2105, 0x1800, 0x0020, 0x3040, 0xe4c9, 0xfea9, 0xee85, 0xf646, 0xfe27, 0xfe67, 0x8346, 0xbdd5, 0xc77f, 0x9f3f, 0x975f, 0xb7df, 0xcfbe, 0xd75d, 0x9f7f, 0xc7ff, 0xc697, 0xbc6a, 0xfe8e, 0xffaf, 0xeecc, 0xfead, 0xfeeb, 0xf76d, 0xf6ce, 0xff10, 0xf72e, 0xf74d, 0xfe4b, 0xdc45, 0xfeed, 0xfeed, 0xfeec, 0xfeec, 0xfecb, 0xfecb, 0xfeca, 0xfeaa, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe67, 0xfe47, 0xfe67, 0xfe46, 0xfe46, 0xc3e0, 0xed02, 0xfe05, 0xf645, 0xfde2, 0xfda2, 0xfda2, 0xfdc4, 0xfde4, 0xfe04, 0xf604, 0xf644, 0xfe65, 0xfe45, 0xfe45, 0xfe25, 0xfe47, 0xfeca, 0xfecc, 0xe62a, 0xc401, 0xfe08, 0xfe68, 0xf626, 0xfea7, 0xf666, 0xfe66, 0xfe46, 0xfe46, 0xfe46, 0xfe25, 0xfe05, 0xfe04, 0xfde3, 0xfe02, 0xfe02, 0xf5e4, 0xfe25, 0xfe88, 0xfe49, 0xcd07, 0xc56e, 0xfffe, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xd441, 0xfd62, 0xfd41, 0xfda1, 0xfe88, 0x51e2, 0x5aef, 0xdfff, 0xefff, 0xffff, 0xffdf, 0x8c54, 0x328f, 0x32ef, 0x0042, 0x1020, 0x3208, 0x61c4, 0xc3a4, 0xfe88, 0xfec6, 0xf687, 0xf647, 0xfe88, 0xcd09, 0x9409, 0x9d95, 0xbf9f, 0x971f, 0x869e, 0xa71f, 0xb71f, 0xaf7f, 0xbf3d, 0xb571, 0xcd0b, 0xfeee, 0xff2c, 0xf6cb, 0xfeab, 0xff2c, 0xf6eb, 0xfeed, 0xfecd, 0xf74d, 0xff2d, 0xe507, 0xe508, 0xfeed, 0xfeec, 0xfeec, 0xfeec, 0xfecb, 0xfeca, 0xfeca, 0xfeca, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe67, 0xfe47, 0xfe46, 0xfe46, 0xfe47, 0xcbe0, 0xf522, 0xfe46, 0xf645, 0xfe02, 0xfdc2, 0xfda2, 0xfdc3, 0xfde4, 0xfe03, 0xfe03, 0xfe43, 0xfe04, 0xfe04, 0xfe04, 0xfe25, 0xfe47, 0xfecb, 0xff0d, 0xeeac, 0xcc62, 0xed65, 0xfe48, 0xf646, 0xfe86, 0xf645, 0xfe46, 0xfe26, 0xfe46, 0xfe25, 0xfe25, 0xfe25, 0xfe04, 0xfe03, 0xf5e2, 0xf5e2, 0xf5e5, 0xfea7, 0xfea8, 0xeda8, 0xd52c, 0xff9b, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xdc21, 0xfd62, 0xfd41, 0xf561, 0xfe67, 0x7b67, 0x320b, 0xd7ff, 0xe7de, 0xfffe, 0xffff, 0x9cf6, 0x2a4f, 0x3b53, 0x0043, 0x0040, 0xb67c, 0xd593, 0xd426, 0xfe27, 0xf645, 0xee45, 0xee26, 0xeec8, 0xfe68, 0xbc85, 0x8c0a, 0x9d96, 0xaeff, 0xaf5f, 0x9f1f, 0x96bf, 0xbf1c, 0xbdf6, 0xb4ac, 0xf64e, 0xff2d, 0xf689, 0xf6ca, 0xf6eb, 0xf70c, 0xfeec, 0xfecc, 0xfeeb, 0xff8d, 0xee09, 0xc3a2, 0xfe8d, 0xff0d, 0xfeec, 0xfeec, 0xfeec, 0xfecb, 0xfeca, 0xfeca, 0xfeaa, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe67, 0xfe48, 0xfe27, 0xfe47, 0xfe27, 0xcc00, 0xed03, 0xfe68, 0xfe67, 0xfe23, 0xf5e2, 0xfda2, 0xfdc2, 0xfde2, 0xfde2, 0xfe03, 0xfe43, 0xf5e3, 0xf603, 0xfe04, 0xfe25, 0xfe47, 0xfeeb, 0xff2e, 0xff0e, 0xe4e4, 0xd4a2, 0xfe27, 0xfe46, 0xfe66, 0xf645, 0xfe25, 0xfe05, 0xfe25, 0xfe04, 0xfe04, 0xfe24, 0xfe24, 0xf5e3, 0xf5c2, 0xf5c2, 0xfe27, 0xfe87, 0xfe69, 0xc4c8, 0xfed8, 0xffbf, 0xffdf, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xdc01, 0xfd61, 0xfd40, 0xfd61, 0xfe66, 0xb52b, 0x29a7, 0xcfbf, 0xdfbf, 0xf7fe, 0xfffe, 0xbe1a, 0x19ce, 0x7d1c, 0x09cb, 0x0060, 0x9e5d, 0xc592, 0xdcc7, 0xfe07, 0xfe46, 0xfe65, 0xf666, 0xee87, 0xfe64, 0xfe68, 0xbcc7, 0x7b67, 0x8c6f, 0xa5d7, 0xa619, 0x9e39, 0x7c6b, 0x8b67, 0xb3c5, 0xfead, 0xfeeb, 0xfe89, 0xfeeb, 0xff4d, 0xfeec, 0xfeeb, 0xfecb, 0xff4d, 0xe6ab, 0xb484, 0xc404, 0xff2f, 0xfeec, 0xfeec, 0xfeec, 0xfecb, 0xfecb, 0xfeca, 0xfeaa, 0xfeaa, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe67, 0xfe47, 0xfe27, 0xfe68, 0xfe27, 0xcc00, 0xe4a2, 0xfe69, 0xfea9, 0xfe45, 0xf603, 0xf5c2, 0xfdc2, 0xfde1, 0xfde1, 0xfe02, 0xfe22, 0xfe03, 0xfe03, 0xfe04, 0xfe25, 0xfe47, 0xfeab, 0xff0d, 0xff2f, 0xf566, 0xcc20, 0xfe06, 0xfe46, 0xf624, 0xfe25, 0xfe25, 0xfe05, 0xfe25, 0xfe04, 0xfe03, 0xfe24, 0xfe03, 0xf5c3, 0xf5e4, 0xfe25, 0xfe88, 0xfe6a, 0xcd29, 0xee74, 0xffbf, 0xffbf, 0xffdf, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xdc23, 0xfd21, 0xfd41, 0xfd41, 0xfe24, 0xde0b, 0x39e5, 0xbe9b, 0xe7ff, 0xe7dd, 0xf7fe, 0xe77f, 0x21ad, 0x6c5a, 0x5c37, 0x2ace, 0x64f6, 0x7ba8, 0xe566, 0xfe06, 0xfe67, 0xfe86, 0xfe45, 0xf647, 0xf622, 0xfea6, 0xfeca, 0xedea, 0xbc87, 0xa406, 0x9c26, 0x8c04, 0xc5aa, 0xbc45, 0xed67, 0xff2b, 0xee88, 0xfecb, 0xfe8c, 0xf6cd, 0xfeec, 0xeeea, 0xff2c, 0xfeae, 0xbd09, 0xa487, 0xdd49, 0xfeac, 0xfeec, 0xfeec, 0xfeec, 0xfeeb, 0xfeca, 0xfeca, 0xfeca, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe67, 0xfe47, 0xfe47, 0xfe88, 0xfe27, 0xd441, 0xd421, 0xfe28, 0xfeea, 0xfe87, 0xf625, 0xf5e3, 0xfde2, 0xfde1, 0xfde1, 0xfde1, 0xfe02, 0xfe03, 0xfe03, 0xfe04, 0xfe25, 0xfe68, 0xfeaa, 0xfeed, 0xff50, 0xfdc7, 0xc3e0, 0xfde5, 0xfe25, 0xf604, 0xfe24, 0xfe24, 0xfe25, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xf5e2, 0xf5c3, 0xfe26, 0xfea8, 0xfe89, 0xe5cb, 0xddd2, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xe485, 0xf501, 0xfd41, 0xfd22, 0xfda2, 0xede6, 0x6aa3, 0x9cd0, 0xe7ff, 0xdfbe, 0xeffe, 0xffff, 0x5b11, 0x21ae, 0x7d1d, 0x85bf, 0x8598, 0x83c6, 0xfe06, 0xfe05, 0xfe47, 0xfe24, 0xfe24, 0xfe47, 0xfea6, 0xf645, 0xfe86, 0xfec9, 0xfe89, 0xfe48, 0xfea8, 0xff08, 0xf68a, 0xdd24, 0xfe07, 0xfe88, 0xe667, 0xff2c, 0xfecc, 0xfead, 0xfe6a, 0xff8c, 0xf6cd, 0xd4cb, 0xbd0f, 0xc5f1, 0xcd29, 0xfe8a, 0xfeec, 0xfeec, 0xfeeb, 0xfecb, 0xfeca, 0xfeca, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe67, 0xfe26, 0xfe66, 0xfe87, 0xfe47, 0xe4c2, 0xcbe0, 0xf586, 0xfeaa, 0xfeaa, 0xf668, 0xf605, 0xfe02, 0xfde1, 0xfdc1, 0xfdc1, 0xfde2, 0xfde2, 0xfde2, 0xfde3, 0xfe05, 0xfe88, 0xfeab, 0xf6ee, 0xff91, 0xfda6, 0xcc00, 0xfde5, 0xfe04, 0xf603, 0xfe03, 0xfe04, 0xfe04, 0xfde3, 0xfe03, 0xfe02, 0xfe02, 0xf5e2, 0xf604, 0xfe67, 0xfea9, 0xede9, 0xd54d, 0xff9d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xe4e9, 0xed01, 0xfd41, 0xfd22, 0xfd40, 0xf561, 0xb3e4, 0x9367, 0xcfdf, 0xdfdf, 0xefdf, 0xffff, 0xbdb9, 0x298c, 0x4af7, 0x647f, 0x73f1, 0xac25, 0xfde3, 0xfe25, 0xf627, 0xf644, 0xfe44, 0xfe47, 0xf628, 0xfea8, 0xfe66, 0xfe66, 0xfec9, 0xfe89, 0xf646, 0xfec6, 0xfe28, 0xe5a5, 0xfe47, 0xfe67, 0xfee9, 0xf72a, 0xff0b, 0xfe6b, 0xfe68, 0xff6c, 0xcd8b, 0xac6f, 0xce5a, 0xce17, 0xc4a8, 0xff09, 0xfeec, 0xfeec, 0xfeeb, 0xfecb, 0xfeca, 0xfeca, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe67, 0xfe45, 0xfe65, 0xfe66, 0xfe46, 0xfd85, 0xcbe0, 0xe503, 0xfe47, 0xfecc, 0xf689, 0xf626, 0xfe04, 0xfde2, 0xfda1, 0xfda2, 0xfda2, 0xfde1, 0xfdc1, 0xf5a2, 0xfe05, 0xfea9, 0xfeab, 0xf6ee, 0xff91, 0xf524, 0xd440, 0xfe05, 0xfde3, 0xfe03, 0xfde3, 0xfe03, 0xfdc3, 0xfda3, 0xfde2, 0xfde1, 0xf5e1, 0xfe23, 0xfe66, 0xfe68, 0xf628, 0xd4eb, 0xf675, 0xffdf, 0xffff, 0xdf9e, 0xf7ff, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xe54b, 0xe4e1, 0xfd22, 0xfd03, 0xfd20, 0xfd40, 0xe505, 0x92c2, 0xa6bb, 0xcfbf, 0xe7bf, 0xf79e, 0xffdf, 0x8c15, 0x008f, 0x1199, 0x5209, 0xdd08, 0xfe03, 0xfe66, 0xee27, 0xf665, 0xfea4, 0xf646, 0xfe29, 0xfe68, 0xf667, 0xee67, 0xf68a, 0xeeab, 0xeeaa, 0xf6e9, 0xfe8b, 0xfeaa, 0xfec9, 0xfea9, 0xff09, 0xdea7, 0xf70a, 0xfe8a, 0xff09, 0xe5e8, 0xac28, 0xce18, 0xc6ff, 0xb4f5, 0xe52c, 0xff48, 0xfeec, 0xfeeb, 0xfeeb, 0xfecb, 0xfeca, 0xfec9, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfea9, 0xfe88, 0xfe88, 0xfe87, 0xfe87, 0xfe67, 0xfe45, 0xfe65, 0xf644, 0xfe46, 0xfe27, 0xcc00, 0xd481, 0xede6, 0xfeee, 0xf68b, 0xf647, 0xfe24, 0xfde3, 0xfda1, 0xfd82, 0xfd83, 0xfde2, 0xfdc1, 0xf5a2, 0xfe05, 0xfea9, 0xf6ab, 0xeecd, 0xff71, 0xecc3, 0xdc60, 0xfe05, 0xf5c3, 0xfe23, 0xf5c2, 0xfde3, 0xfda2, 0xfda2, 0xfdc2, 0xf5c1, 0xf5e1, 0xfe63, 0xfec7, 0xfe48, 0xe587, 0xd4ef, 0xffbb, 0xfffd, 0xefff, 0xefff, 0xefff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xe511, 0xe4a4, 0xfd80, 0xfd20, 0xfcc3, 0xf462, 0xdc21, 0xc340, 0x9b4a, 0xf6da, 0xefbf, 0xd7df, 0xd7ff, 0xdfbf, 0xce5b, 0x626b, 0xaba0, 0xf5e4, 0xfe45, 0xfe25, 0xfe66, 0xf625, 0xfe46, 0xfe66, 0xfe67, 0xfe67, 0xfe67, 0xfe68, 0xfe88, 0xfe88, 0xfe88, 0xfe89, 0xfe49, 0xfec9, 0xf6c8, 0xf688, 0xfe8b, 0xfe6b, 0xfec9, 0xff89, 0xe589, 0xa429, 0xbe7b, 0xaeff, 0xc6de, 0xc4cd, 0xf5a9, 0xff0c, 0xfeca, 0xfeca, 0xfeca, 0xfeaa, 0xfea9, 0xfea9, 0xfea9, 0xfe89, 0xfe88, 0xfe88, 0xfe88, 0xfe88, 0xfe68, 0xfe67, 0xfe67, 0xfe67, 0xfe65, 0xfe45, 0xfe45, 0xfe25, 0xfe26, 0xece2, 0xd3e0, 0xfca2, 0xfe48, 0xfe89, 0xf689, 0xee47, 0xe604, 0xf5c3, 0xfda1, 0xfd80, 0xfde0, 0xfdc1, 0xf5a1, 0xfe45, 0xfe88, 0xfecb, 0xff2d, 0xf6cd, 0xcc00, 0xed02, 0xfd83, 0xfda2, 0xfe02, 0xfe02, 0xf5a1, 0xfde2, 0xedc0, 0xfd81, 0xfde1, 0xfe21, 0xf624, 0xfeab, 0xfdeb, 0xdc02, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xee35, 0xd4c4, 0xfd60, 0xfce0, 0xf481, 0xecc2, 0xe4c3, 0xdc83, 0xab64, 0xc4ab, 0xbd50, 0xc636, 0xefbd, 0xfffe, 0xeeb9, 0xa3ed, 0xdd21, 0xfe66, 0xfe25, 0xfe04, 0xfe66, 0xfe25, 0xfe66, 0xfe66, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe88, 0xfe88, 0xfe88, 0xfe88, 0xfeea, 0xf669, 0xfe69, 0xfe89, 0xee88, 0xff0a, 0xfe8a, 0xe526, 0xbd0c, 0xc5d3, 0xc6be, 0x9e3f, 0xd73e, 0xc4aa, 0xf5e8, 0xfec9, 0xfeca, 0xfeca, 0xfeaa, 0xfeaa, 0xfea9, 0xfea9, 0xfe89, 0xfe89, 0xfe88, 0xfe88, 0xfe88, 0xfe88, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe45, 0xfe65, 0xfe45, 0xfe25, 0xfe67, 0xfd84, 0xdc20, 0xe400, 0xf5a6, 0xfe48, 0xfea9, 0xfea8, 0xf625, 0xf5c3, 0xfd81, 0xfd80, 0xf580, 0xfda1, 0xf5a1, 0xfe04, 0xfe47, 0xfea9, 0xfecb, 0xee09, 0xcc00, 0xf543, 0xfdc4, 0xfdc2, 0xfde1, 0xfdc1, 0xf580, 0xfdc1, 0xf5a1, 0xfe64, 0xf603, 0xf5e5, 0xfea8, 0xede5, 0xdd48, 0xfe73, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffbb, 0xcd48, 0xf5a1, 0xfd60, 0xf521, 0xfdc5, 0xfe27, 0xfe28, 0xfe89, 0xf5a7, 0xd508, 0xbca9, 0xcd2c, 0xcd0d, 0xabc7, 0xaba6, 0xfe25, 0xfe86, 0xf5e4, 0xf604, 0xfe66, 0xfe25, 0xfe66, 0xfe66, 0xfe47, 0xfe47, 0xfe67, 0xfe67, 0xfe87, 0xfe88, 0xfe88, 0xfe88, 0xeec8, 0xfeca, 0xfe8a, 0xfe67, 0xf6e7, 0xf6e9, 0xe58a, 0xcbe9, 0xbe37, 0xcf1d, 0xb6bf, 0xae9f, 0xc617, 0xbc46, 0xfea9, 0xfee9, 0xfeca, 0xfeaa, 0xfeaa, 0xfea9, 0xfea9, 0xfe89, 0xfe89, 0xfe88, 0xfe88, 0xfe88, 0xfe88, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe47, 0xfe45, 0xfe65, 0xfe45, 0xf605, 0xfe46, 0xfe06, 0xecc1, 0xd3e0, 0xdc61, 0xfda6, 0xfeaa, 0xfea9, 0xf626, 0xf604, 0xfde3, 0xfda1, 0xf580, 0xfdc2, 0xfdc2, 0xfdc3, 0xfde4, 0xfe26, 0xfe06, 0xd4e2, 0xd420, 0xfd62, 0xfde3, 0xfda1, 0xfdc0, 0xfdc0, 0xf5a0, 0xfdc1, 0xfde2, 0xede3, 0xf648, 0xfecc, 0xfe07, 0xd4c2, 0xd5ad, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffd, 0xd5ac, 0xe563, 0xfd81, 0xf541, 0xf584, 0xfde5, 0xfde5, 0xfdc2, 0xfde4, 0xfe69, 0xfdc8, 0xdca5, 0xbbc1, 0xb3a0, 0xf5c7, 0xfe04, 0xfe24, 0xf5e3, 0xfe25, 0xfe45, 0xf605, 0xfe45, 0xfe45, 0xfe46, 0xfe47, 0xfe67, 0xfe67, 0xfe67, 0xfe87, 0xfe88, 0xfe88, 0xfe87, 0xf6c7, 0xf6e7, 0xff09, 0xfe8a, 0xd509, 0xb4ad, 0xcdf7, 0xc73f, 0xa6bd, 0xa69f, 0xd73f, 0x8b8b, 0xc485, 0xff0a, 0xff0a, 0xfeaa, 0xfeaa, 0xfea9, 0xfea9, 0xfe89, 0xfe89, 0xfe88, 0xfe88, 0xfe88, 0xfe88, 0xfe87, 0xfe67, 0xfe67, 0xfe67, 0xfe47, 0xfe46, 0xfe45, 0xfe66, 0xfe45, 0xf604, 0xfe05, 0xfe05, 0xfd43, 0xe480, 0xcba0, 0xe481, 0xfda5, 0xfe68, 0xfe88, 0xfe46, 0xfe04, 0xfdc2, 0xfd61, 0xfda2, 0xfd82, 0xfd82, 0xfd82, 0xfda3, 0xfd82, 0xdc60, 0xece0, 0xfd82, 0xfdc1, 0xfd80, 0xfda0, 0xfdc0, 0xfdc0, 0xfdc1, 0xfe00, 0xf5a4, 0xfe8a, 0xfe68, 0xd4c2, 0xdd4b, 0xff5b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xfffe, 0xee32, 0xdcc4, 0xfd41, 0xfd40, 0xed21, 0xf563, 0xf541, 0xfde2, 0xf5a3, 0xfd84, 0xfda6, 0xfe48, 0xfde5, 0xe541, 0xedc2, 0xf5a2, 0xfde3, 0xfe04, 0xfe25, 0xfe45, 0xfe04, 0xfe45, 0xfe45, 0xfe46, 0xfe46, 0xfe46, 0xfe67, 0xfe67, 0xfe67, 0xfe87, 0xfe88, 0xfe86, 0xfea6, 0xff07, 0xfe49, 0xd489, 0xc4b0, 0xbe19, 0xb6fe, 0xa69d, 0xa6dd, 0xb73f, 0xad77, 0x69c2, 0xe547, 0xfeea, 0xf6ab, 0xfea9, 0xfea9, 0xfea9, 0xfe89, 0xfe89, 0xfe88, 0xfe88, 0xfe88, 0xfe88, 0xfe87, 0xfe67, 0xfe67, 0xfe67, 0xfe46, 0xfe46, 0xfe46, 0xfe45, 0xfe45, 0xfe25, 0xfe25, 0xfe05, 0xfde4, 0xfda3, 0xfd42, 0xec60, 0xd3e0, 0xd400, 0xf564, 0xfe68, 0xfe47, 0xfde4, 0xf5c3, 0xf541, 0xf541, 0xf520, 0xfd41, 0xfd41, 0xfd61, 0xfd82, 0xf4e0, 0xfd82, 0xfda2, 0xfda1, 0xf580, 0xf580, 0xfd80, 0xfda0, 0xfde2, 0xfe22, 0xfe86, 0xfde6, 0xdca2, 0xcd08, 0xff19, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xff18, 0xe4c7, 0xfd41, 0xfda1, 0xfd42, 0xfda3, 0xfda1, 0xed82, 0xf5a3, 0xed22, 0xed02, 0xfd63, 0xf5a2, 0xf602, 0xfe62, 0xfde3, 0xfe24, 0xfe24, 0xfe24, 0xfe24, 0xfe25, 0xfe66, 0xfe45, 0xfe46, 0xfe46, 0xfe46, 0xfe66, 0xfe67, 0xfe67, 0xfe87, 0xfe67, 0xf6c8, 0xfe67, 0xf566, 0xcc68, 0xb4d1, 0xc67c, 0xc71f, 0xaebe, 0xb65c, 0xd7ff, 0xc71c, 0x49a6, 0x81e1, 0xfe49, 0xfea9, 0xf68b, 0xfea9, 0xfea9, 0xfe89, 0xfe89, 0xfe88, 0xfe88, 0xfe68, 0xfe68, 0xfe87, 0xfe67, 0xfe67, 0xfe67, 0xfe66, 0xfe46, 0xfe46, 0xfe46, 0xfe25, 0xfe05, 0xf604, 0xfe65, 0xfe65, 0xfe04, 0xfdc3, 0xfd82, 0xfd42, 0xec80, 0xd3e0, 0xd400, 0xece2, 0xfda5, 0xfda4, 0xf563, 0xfd41, 0xfd21, 0xf500, 0xfd41, 0xfd21, 0xfd20, 0xfd82, 0xfd20, 0xfd62, 0xfd61, 0xfd60, 0xfd60, 0xfd80, 0xfd80, 0xfdc2, 0xfe24, 0xf5e6, 0xfd62, 0xe4a1, 0xe52a, 0xff18, 0xfffe, 0xffdf, 0xff9f, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffbd, 0xed2b, 0xf520, 0xfd80, 0xfd82, 0xfd62, 0xfd80, 0xf5c2, 0xfdc2, 0xf562, 0xf541, 0xfd82, 0xfdc2, 0xfde2, 0xfe01, 0xfe04, 0xfe44, 0xfe04, 0xfe04, 0xfe04, 0xfe24, 0xfe45, 0xfe45, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe28, 0xe528, 0xbc4b, 0xbd74, 0xcf1e, 0xbf1f, 0xb69d, 0xd73f, 0xef1e, 0xcf3c, 0x740f, 0x2800, 0xbb85, 0xfea9, 0xfea7, 0xfeaa, 0xfea9, 0xfe89, 0xfe89, 0xfe88, 0xfe88, 0xfe68, 0xfe68, 0xfe68, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe25, 0xfe25, 0xf604, 0xfe45, 0xfe65, 0xfe24, 0xfde3, 0xf581, 0xfd62, 0xfd63, 0xf4c2, 0xdc00, 0xd3e0, 0xe481, 0xf4e2, 0xece2, 0xfd41, 0xfd21, 0xfd21, 0xfd62, 0xfd21, 0xf500, 0xfd62, 0xf541, 0xf521, 0xf520, 0xf520, 0xfd60, 0xfd81, 0xfda2, 0xfdc3, 0xfdc3, 0xed27, 0xcc86, 0xd54d, 0xff3a, 0xffff, 0xfffe, 0xfffe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffde, 0xed8d, 0xed20, 0xf580, 0xfdc2, 0xf561, 0xfda0, 0xfdc0, 0xfdc1, 0xfde2, 0xfdc2, 0xfda2, 0xfdc2, 0xfda1, 0xfdc2, 0xfde3, 0xfe04, 0xfe03, 0xfde3, 0xfe04, 0xfe04, 0xfe24, 0xfe45, 0xfe45, 0xfe46, 0xfe46, 0xfe46, 0xfe66, 0xfe67, 0xfe67, 0xfe67, 0xdb62, 0xcc6b, 0xc658, 0xc75f, 0xbf3f, 0xc71e, 0xdf5e, 0xe77d, 0xff1f, 0x7c10, 0x0000, 0x50e1, 0xfd2b, 0xfec7, 0xf6c4, 0xf687, 0xfe89, 0xfe89, 0xfe88, 0xfe88, 0xfe88, 0xfe68, 0xfe68, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe66, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe26, 0xfe66, 0xf625, 0xf604, 0xfe44, 0xfe24, 0xfe03, 0xf581, 0xf541, 0xf521, 0xfd43, 0xfd44, 0xec82, 0xd3a0, 0xd3c0, 0xe481, 0xf4e0, 0xfd00, 0xfd21, 0xfd82, 0xfd42, 0xed21, 0xfd62, 0xf542, 0xfd42, 0xfd42, 0xf521, 0xfd61, 0xfda2, 0xfda2, 0xf541, 0xe4c0, 0xece7, 0xfeb6, 0xffff, 0xefff, 0xeffe, 0xfffe, 0xffff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xff39, 0xccc4, 0xfda1, 0xfd40, 0xfd82, 0xf581, 0xfda2, 0xfda2, 0xfdc2, 0xfde2, 0xfde2, 0xfe02, 0xfde1, 0xf5c0, 0xfde3, 0xfde2, 0xfe03, 0xfe44, 0xfe44, 0xf603, 0xf603, 0xfe44, 0xee47, 0xee25, 0xf644, 0xfea3, 0xfe84, 0xf5e5, 0xd4e5, 0xc424, 0xae5a, 0xcf3d, 0xd73e, 0xef9f, 0xe75d, 0xe75d, 0xffff, 0xdf5c, 0x5bce, 0x1000, 0x3000, 0xa282, 0xfde8, 0xff09, 0xee46, 0xfeaa, 0xfe87, 0xfe87, 0xfe87, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe66, 0xfe46, 0xfe46, 0xfe45, 0xfe45, 0xfe45, 0xfe25, 0xfe24, 0xfe24, 0xfe24, 0xfe04, 0xfe03, 0xfe03, 0xf541, 0xf520, 0xf520, 0xfd41, 0xfd62, 0xfd21, 0xeca0, 0xe420, 0xd3c0, 0xc380, 0xd400, 0xec80, 0xf462, 0xfc46, 0xfcc5, 0xf520, 0xf4e0, 0xf500, 0xed01, 0xd4a2, 0xc464, 0xc4c9, 0xddb1, 0xf676, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xff9b, 0xdd4a, 0xed01, 0xfd80, 0xfd40, 0xf561, 0xfda1, 0xfda1, 0xf581, 0xfda1, 0xfdc1, 0xf5c1, 0xf5c1, 0xf5c1, 0xfe03, 0xf5e3, 0xf5e3, 0xf603, 0xf604, 0xf624, 0xf624, 0xf644, 0xfe84, 0xfe85, 0xfe66, 0xf565, 0xd445, 0xbc29, 0xd552, 0xeeb9, 0xcf1e, 0xdf7f, 0xd73d, 0xdf5e, 0xf7ff, 0xffff, 0xce58, 0x62eb, 0x2041, 0x3000, 0x60c0, 0xc3a4, 0xfe48, 0xfee7, 0xfea8, 0xfeaa, 0xfe87, 0xfe87, 0xfe87, 0xfe87, 0xfe87, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe66, 0xfe46, 0xfe46, 0xfe25, 0xfe45, 0xfe25, 0xfe24, 0xfe24, 0xfe24, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfd81, 0xf561, 0xf520, 0xf521, 0xfd42, 0xfd42, 0xfd22, 0xfd01, 0xf4a1, 0xe481, 0xdc60, 0xdc20, 0xe3e0, 0xdb80, 0xd380, 0xc3c0, 0xdcca, 0xdd0b, 0xe58d, 0xf630, 0xfed5, 0xff5a, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xffff, 0xffdf, 0xf632, 0xdca3, 0xfda0, 0xfd20, 0xfd62, 0xfda0, 0xfd80, 0xf580, 0xfdc1, 0xfdc2, 0xfda2, 0xfde3, 0xfe24, 0xfe02, 0xfe23, 0xfe23, 0xf623, 0xf624, 0xfe45, 0xfe86, 0xfea6, 0xfde6, 0xe504, 0xc444, 0xbc49, 0xcd51, 0xde7a, 0xe73f, 0xe79f, 0xf7ff, 0xe79f, 0xf7ff, 0xf7ff, 0xdf3c, 0x8c30, 0x3945, 0x1800, 0x4000, 0x8103, 0xb284, 0xed07, 0xfea8, 0xf685, 0xfe87, 0xfe28, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe66, 0xfe46, 0xfe46, 0xfe45, 0xfe25, 0xfe25, 0xfe24, 0xfe24, 0xfe24, 0xfe24, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfdc2, 0xfda2, 0xfd61, 0xf521, 0xfd41, 0xfd42, 0xfd42, 0xfd42, 0xfd42, 0xfda3, 0xfd63, 0xfd23, 0xfd41, 0xfd00, 0xecc4, 0xed2b, 0xff9f, 0xff9e, 0xff9e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xf7ff, 0xf7ff, 0xffff, 0xff1b, 0xe529, 0xf520, 0xfd40, 0xfd43, 0xfdc0, 0xfda0, 0xfda0, 0xfde2, 0xfdc2, 0xf561, 0xf582, 0xfdc4, 0xf581, 0xfde3, 0xfe24, 0xfe05, 0xfe05, 0xfde6, 0xf585, 0xe503, 0xd409, 0xdced, 0xd614, 0xd6f9, 0xd7bd, 0xe7ff, 0xe7ff, 0xe7df, 0xff7f, 0xffdf, 0xe71c, 0x7c0f, 0x2944, 0x1800, 0x2000, 0x3000, 0xb8c3, 0xd225, 0xe3c5, 0xfde8, 0xfec7, 0xf685, 0xfe66, 0xfe47, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe67, 0xfe66, 0xfe66, 0xfe46, 0xfe46, 0xfe25, 0xfe25, 0xfe25, 0xfe25, 0xfe24, 0xfe24, 0xfe24, 0xfe04, 0xfe03, 0xfe03, 0xfde3, 0xfde2, 0xfdc2, 0xfda2, 0xfd81, 0xfd61, 0xfd41, 0xfd21, 0xfd01, 0xfd01, 0xfce0, 0xfd41, 0xf501, 0xf501, 0xfd60, 0xf520, 0xe567, 0xfe97, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xf7ff, 0xffff, 0xffbf, 0xfe52, 0xdca1, 0xfd80, 0xfd62, 0xfda0, 0xfd80, 0xfd80, 0xfdc2, 0xf581, 0xe4e0, 0xdcc0, 0xe4e0, 0xeca1, 0xeca2, 0xe462, 0xdbe2, 0xcb62, 0xbaa1, 0x99a0, 0x80c0, 0xbb4c, 0xe554, 0xff5d, 0xffff, 0xefff, 0xefde, 0xef5b, 0xe6b7, 0xcd35, 0x832d, 0x3924, 0x1000, 0x1800, 0x3800, 0x5000, 0x80e4, 0xf206, 0xe283, 0xfce6, 0xfe67, 0xfea6, 0xfea6, 0xfe66, 0xfe67, 0xfe66, 0xfe66, 0xfe66, 0xfe66, 0xfe66, 0xfe66, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe45, 0xfe25, 0xfe25, 0xfe25, 0xfe24, 0xfe24, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfde2, 0xfde2, 0xfde2, 0xf581, 0xf581, 0xfd81, 0xfd61, 0xfd41, 0xfd41, 0xfd21, 0xfd21, 0xfd20, 0xfd60, 0xfd41, 0xfd42, 0xfd60, 0xe500, 0xe5cc, 0xff7e, 0xf7de, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xff5a, 0xdd09, 0xf564, 0xfdc2, 0xfd60, 0xf560, 0xfd81, 0xfda2, 0xfd82, 0xed21, 0xe500, 0xe500, 0xec63, 0xdbe2, 0xbac0, 0x9180, 0x7860, 0x7000, 0x7000, 0x7000, 0x5840, 0x60e2, 0x7165, 0x79a8, 0x8a4b, 0x9aac, 0x81e8, 0x60e3, 0x4020, 0x3800, 0x3800, 0x4000, 0x6081, 0x78a2, 0x90c3, 0xd229, 0xe242, 0xdb62, 0xfe28, 0xfec7, 0xf645, 0xfe86, 0xfe25, 0xfe25, 0xfe66, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe25, 0xfe25, 0xfe25, 0xfe24, 0xfe24, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfda1, 0xfd81, 0xfd61, 0xfd41, 0xfd41, 0xfd41, 0xfd20, 0xfd20, 0xfd61, 0xfd82, 0xf563, 0xe567, 0xee94, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xefff, 0xffff, 0xffbe, 0xfe54, 0xdce6, 0xfe01, 0xfd61, 0xfd61, 0xfd81, 0xfda2, 0xfdc2, 0xfda2, 0xfdc2, 0xfdc2, 0xfe66, 0xfdc5, 0xecc3, 0xbb21, 0x8960, 0x7020, 0x6800, 0x7002, 0x6000, 0x7020, 0x7841, 0x7000, 0x6800, 0x6800, 0x6801, 0x6801, 0x5860, 0x5820, 0x5000, 0x7840, 0xb185, 0xc165, 0xc103, 0xe1c6, 0xcb01, 0xe4e5, 0xfea8, 0xf6c7, 0xf646, 0xfe27, 0xfe26, 0xf624, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe45, 0xfe45, 0xfe25, 0xfe25, 0xfe25, 0xfe24, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfde3, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfe22, 0xfe02, 0xfdc2, 0xfd81, 0xfd61, 0xfd61, 0xfd41, 0xfd41, 0xfd01, 0xfce0, 0xfd21, 0xf521, 0xe4e4, 0xf5d0, 0xff7c, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffbf, 0xffff, 0xefff, 0xf7fe, 0xffbf, 0xff7d, 0xc466, 0xf641, 0xfda3, 0xfda3, 0xfd82, 0xfd61, 0xfd81, 0xfda2, 0xfdc2, 0xfdc2, 0xede0, 0xf620, 0xfe43, 0xfe06, 0xe4c6, 0xaac3, 0x7900, 0x6020, 0x8802, 0x8002, 0x7821, 0x7060, 0x6860, 0x7020, 0x7800, 0x8000, 0x5800, 0x6020, 0x7820, 0xb985, 0xea68, 0xd123, 0xc081, 0xe985, 0xdcc5, 0xfea9, 0xe6c6, 0xe685, 0xfe47, 0xfdc7, 0xfe46, 0xfe65, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe46, 0xfe45, 0xfe45, 0xfe25, 0xfe45, 0xfe25, 0xfe25, 0xfe24, 0xfe04, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xf5a0, 0xf5a1, 0xfda1, 0xfda1, 0xfda2, 0xfd82, 0xfd61, 0xfd41, 0xfd22, 0xfd02, 0xfd82, 0xfd61, 0xed07, 0xfe98, 0xffdf, 0xefff, 0xfffd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xff38, 0xcccd, 0xfe41, 0xfe27, 0xfd67, 0xf542, 0xfdc0, 0xfd81, 0xf541, 0xfde1, 0xfde2, 0xfde1, 0xfdc1, 0xfde2, 0xfe44, 0xfde4, 0xd480, 0xa300, 0x80a1, 0x7020, 0x6800, 0x7002, 0x7802, 0x7001, 0x7000, 0x7801, 0x6860, 0x6800, 0xc127, 0xf9ed, 0xe128, 0xc0e3, 0xb1c0, 0xdbe5, 0xfe46, 0xfe46, 0xfe66, 0xfe46, 0xfe25, 0xfe25, 0xfe45, 0xfe45, 0xfe25, 0xfe45, 0xfe25, 0xfe25, 0xfe25, 0xfe25, 0xfe24, 0xfe24, 0xf624, 0xfe24, 0xfe24, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfe02, 0xfe02, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfd83, 0xfdc1, 0xfde0, 0xfdc0, 0xf581, 0xf563, 0xfd62, 0xfd41, 0xf4e0, 0xfdc0, 0xf520, 0xd4a3, 0xee55, 0xffbf, 0xf7ff, 0xf7fd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7df, 0xfffe, 0xffbb, 0xe614, 0xdd02, 0xf5c5, 0xfe27, 0xfd84, 0xf520, 0xfd80, 0xfdc1, 0xfda2, 0xfde1, 0xfdc1, 0xf5c1, 0xfde1, 0xfe03, 0xfe25, 0xfde5, 0xf564, 0xd384, 0xa220, 0x78a0, 0x6800, 0x6800, 0x6800, 0x7001, 0x7822, 0x7020, 0x8842, 0xd1c9, 0xd167, 0xb8c1, 0xc221, 0xdc03, 0xfe07, 0xfe66, 0xfe25, 0xfde4, 0xfe05, 0xfe25, 0xfe45, 0xfe45, 0xfe45, 0xfe25, 0xfe25, 0xfe25, 0xfe25, 0xfe25, 0xfe24, 0xfe24, 0xfe24, 0xfe24, 0xfe24, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe02, 0xfe02, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfda1, 0xf560, 0xf580, 0xfda0, 0xfda2, 0xfd63, 0xfd62, 0xfd21, 0xfd60, 0xfd40, 0xe4c1, 0xe58b, 0xff7b, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffbe, 0xffdf, 0xffff, 0xf7ff, 0xf7df, 0xffff, 0xfffe, 0xff7b, 0xdd0b, 0xe545, 0xfe25, 0xfe28, 0xf544, 0xf540, 0xfdc0, 0xfd82, 0xfde2, 0xfde1, 0xfde1, 0xfde0, 0xfdc1, 0xfdc2, 0xfde4, 0xfe25, 0xfe25, 0xf523, 0xcbc1, 0xaaa0, 0x9180, 0x7080, 0x6000, 0x6000, 0x6800, 0x8861, 0xc1c5, 0xb9a1, 0xba20, 0xe483, 0xf604, 0xf6c3, 0xfe46, 0xf5c4, 0xed82, 0xf5c3, 0xfe25, 0xfe45, 0xfe25, 0xfe45, 0xfe25, 0xfe25, 0xfe25, 0xfe25, 0xfe24, 0xfe24, 0xfe24, 0xfe24, 0xfe24, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfda2, 0xfde1, 0xf560, 0xfd60, 0xfda1, 0xfd62, 0xfd22, 0xfd41, 0xfd20, 0xfd60, 0xecc2, 0xe529, 0xfef6, 0xfffe, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xfed8, 0xdd6b, 0xe565, 0xfe69, 0xfe48, 0xfd82, 0xf560, 0xfdc1, 0xfdc1, 0xf5c1, 0xfdc0, 0xfdc0, 0xfdc0, 0xf5a0, 0xf5a1, 0xfdc2, 0xfe21, 0xfe02, 0xfde4, 0xfd85, 0xe484, 0xbb41, 0xa260, 0x9a00, 0x9140, 0x99a0, 0xc2e2, 0xdbc2, 0xf4e3, 0xfe86, 0xfea4, 0xe641, 0xfde4, 0xed62, 0xe541, 0xf5c3, 0xfe45, 0xfe25, 0xfe24, 0xfe25, 0xfe25, 0xfe25, 0xfe24, 0xfe24, 0xfe04, 0xfe24, 0xfe24, 0xfe24, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfde3, 0xfde3, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfdc2, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfde1, 0xfda0, 0xfda1, 0xfd82, 0xfd21, 0xfd00, 0xfd60, 0xfd60, 0xece0, 0xe528, 0xf655, 0xffdf, 0xf7ff, 0xf7fe, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffbd, 0xf696, 0xd54b, 0xedc7, 0xfe89, 0xfe09, 0xf584, 0xfde0, 0xfda2, 0xfda1, 0xfda0, 0xfdc0, 0xfde0, 0xfe01, 0xfde2, 0xfdc1, 0xf5e1, 0xf5c1, 0xf5c1, 0xfe03, 0xfe25, 0xfde5, 0xf564, 0xed23, 0xf546, 0xf524, 0xfda5, 0xfde5, 0xfe05, 0xfe24, 0xedc3, 0xe582, 0xed42, 0xe521, 0xed82, 0xfe04, 0xfe45, 0xfe04, 0xf604, 0xfe45, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe04, 0xfe03, 0xfe03, 0xfde3, 0xfde3, 0xfde2, 0xfde2, 0xfde2, 0xfde1, 0xfde1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda1, 0xf581, 0xf582, 0xfd83, 0xfd42, 0xfd21, 0xfd60, 0xfd80, 0xfd40, 0xdce5, 0xfe51, 0xff9e, 0xffff, 0xefff, 0xf7dd, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xee75, 0xcd49, 0xede8, 0xfe8d, 0xfe29, 0xf5e2, 0xfda3, 0xfda3, 0xfda2, 0xfda1, 0xfdc0, 0xfde1, 0xfdc1, 0xfdc1, 0xfe24, 0xfe03, 0xfde2, 0xfe01, 0xfe21, 0xfe22, 0xfe02, 0xfe02, 0xfe85, 0xfe64, 0xfe43, 0xfde3, 0xf583, 0xf563, 0xf544, 0xf524, 0xe521, 0xed41, 0xf5c3, 0xfe25, 0xfe45, 0xfe04, 0xf5e4, 0xfe24, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfde3, 0xfe03, 0xfde3, 0xfde3, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xf582, 0xfd82, 0xfd42, 0xfd21, 0xfd61, 0xfd61, 0xed21, 0xdcc1, 0xee10, 0xff7a, 0xffff, 0xf7ff, 0xf7ff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefdf, 0xffff, 0xffbd, 0xe612, 0xddab, 0xf62b, 0xfe8a, 0xfe48, 0xfd64, 0xfd63, 0xfd82, 0xfda1, 0xfda1, 0xfda0, 0xfda1, 0xfdc1, 0xf5a2, 0xfde2, 0xfe02, 0xfe21, 0xfde1, 0xfdc1, 0xfdc2, 0xfdc3, 0xf5a1, 0xf5a1, 0xed61, 0xed21, 0xed22, 0xf523, 0xf523, 0xece2, 0xf5a2, 0xfdc3, 0xfde4, 0xfe24, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfde3, 0xfde3, 0xfde3, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfdc1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda1, 0xfd80, 0xfd80, 0xf5a0, 0xfd81, 0xfd40, 0xfd40, 0xfd61, 0xed02, 0xdd06, 0xed8b, 0xff7c, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xffde, 0xfffe, 0xfffe, 0xf7ff, 0xf7ff, 0xffff, 0xff7d, 0xe611, 0xdda7, 0xf668, 0xfeae, 0xfde7, 0xfd85, 0xfd63, 0xfda2, 0xfdc1, 0xfd80, 0xfda0, 0xfde2, 0xfe02, 0xfdc1, 0xf5a0, 0xfdc0, 0xfde2, 0xfe04, 0xfda4, 0xfd64, 0xf521, 0xf542, 0xed02, 0xf523, 0xf523, 0xf522, 0xfd63, 0xfd83, 0xfe04, 0xfe04, 0xfe04, 0xfde4, 0xfde4, 0xfe04, 0xfe04, 0xf603, 0xfe04, 0xfe04, 0xfe04, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfde3, 0xfde3, 0xfde3, 0xfde2, 0xfde2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfd80, 0xfd80, 0xed80, 0xf580, 0xfd40, 0xfd60, 0xfd41, 0xdcc2, 0xe56b, 0xff58, 0xffdf, 0xf7ff, 0xeffe, 0xfffe, 0xfffe, 0xffdf, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xff9e, 0xe613, 0xdd4a, 0xf5c8, 0xef33, 0xfe8c, 0xfda3, 0xfd61, 0xfdc2, 0xf5a0, 0xed80, 0xf601, 0xfda0, 0xfda0, 0xfda1, 0xfda2, 0xfdc2, 0xfdc2, 0xf5c1, 0xf5a1, 0xf5a1, 0xf5a1, 0xf5a1, 0xf5a1, 0xf5a1, 0xfdc2, 0xfde2, 0xfde2, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe03, 0xfe01, 0xfde1, 0xfde1, 0xfde1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc0, 0xfdc0, 0xfda0, 0xf5a1, 0xf582, 0xf5a1, 0xf5a0, 0xfdc0, 0xfd22, 0xfd41, 0xfd82, 0xf521, 0xd4a3, 0xe5ee, 0xff9c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9b, 0xf652, 0xdd2b, 0xfe05, 0xff0e, 0xff0f, 0xfda7, 0xf4e1, 0xfda3, 0xfe03, 0xf5a0, 0xfdc0, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfde1, 0xf5c2, 0xf5a2, 0xf5a1, 0xf5a1, 0xf5a2, 0xfdc2, 0xfdc2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde2, 0xfde1, 0xfde1, 0xfde1, 0xfde1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda2, 0xfd81, 0xf580, 0xfd80, 0xfda0, 0xfda0, 0xfd61, 0xfd41, 0xfd60, 0xfd20, 0xf503, 0xe527, 0xedef, 0xff79, 0xfffe, 0xefdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdc, 0xfffe, 0xffff, 0xf7ff, 0xffff, 0xfffe, 0xff9c, 0xee77, 0xcc82, 0xee09, 0xf6ce, 0xfeef, 0xfe8a, 0xfd63, 0xf500, 0xfe24, 0xfd80, 0xfda0, 0xfdc0, 0xfda0, 0xfda0, 0xfda0, 0xfde1, 0xfe22, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfde1, 0xfde1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda1, 0xf543, 0xfd83, 0xfda2, 0xfd80, 0xfd60, 0xfd20, 0xfd40, 0xfd41, 0xfd60, 0xece0, 0xe508, 0xf633, 0xff7c, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdd, 0xfffe, 0xfffe, 0xffff, 0xf7de, 0xffff, 0xffff, 0xffdf, 0xff18, 0xdd2b, 0xe527, 0xfecc, 0xff4e, 0xfe89, 0xfdc5, 0xf4e3, 0xf561, 0xf581, 0xfd80, 0xfda0, 0xfda0, 0xfda0, 0xfda0, 0xfda0, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc2, 0xfdc1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfd80, 0xf5a1, 0xfd82, 0xfd62, 0xfd42, 0xfd21, 0xfd20, 0xfd40, 0xfd40, 0xe502, 0xed89, 0xfe93, 0xff9d, 0xffff, 0xffff, 0xf7df, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xfffe, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffbf, 0xff9d, 0xe5f0, 0xdce5, 0xf5e8, 0xff0e, 0xfecc, 0xfe48, 0xfdc4, 0xf5a3, 0xf582, 0xf5a1, 0xfda0, 0xfda0, 0xfda0, 0xfd80, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfde2, 0xfde2, 0xfde2, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfda1, 0xfd81, 0xfd80, 0xfd80, 0xfd80, 0xf5c0, 0xf560, 0xf520, 0xfd41, 0xfd63, 0xfd63, 0xf521, 0xe4c0, 0xdd8f, 0xff37, 0xfffd, 0xffff, 0xf7df, 0xffff, 0xffff, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffbf, 0xffdf, 0xffff, 0xfef7, 0xdcea, 0xdce6, 0xf66b, 0xff2e, 0xfeaa, 0xfe68, 0xfde5, 0xf583, 0xf582, 0xf581, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfdc1, 0xfda1, 0xfda1, 0xfd81, 0xfd80, 0xfd80, 0xfd80, 0xfd60, 0xfd60, 0xf560, 0xfd81, 0xfda0, 0xfd60, 0xed01, 0xe504, 0xe56a, 0xedee, 0xf75e, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff5b, 0xed8d, 0xd4e8, 0xcdac, 0xfe8c, 0xfe8c, 0xfe6a, 0xfe08, 0xf5a5, 0xf583, 0xf582, 0xf581, 0xfda0, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda0, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfd81, 0xfd81, 0xfd80, 0xfd80, 0xfd60, 0xfd60, 0xfd60, 0xfd40, 0xfd61, 0xfd81, 0xfd81, 0xf522, 0xdd06, 0xdd8d, 0xf6d8, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xff17, 0xf4ea, 0xc4c6, 0xe589, 0xfe6c, 0xfecd, 0xfe8a, 0xfe07, 0xf5c4, 0xf5a3, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfd80, 0xf580, 0xf560, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfda1, 0xfd81, 0xfd80, 0xfd80, 0xfd80, 0xfd60, 0xfd60, 0xfd40, 0xfd40, 0xfd80, 0xf4e0, 0xe481, 0xf528, 0xfe73, 0xff9c, 0xffdf, 0xf7ff, 0xefdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffbf, 0xefff, 0xefff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfed8, 0xe590, 0xd487, 0xe4e3, 0xfe05, 0xfea8, 0xfe8a, 0xee0a, 0xfde4, 0xfdc3, 0xf5a2, 0xf581, 0xf5a1, 0xf5c1, 0xf5c1, 0xf5c1, 0xfd81, 0xfd81, 0xfda1, 0xfda1, 0xfd81, 0xfd80, 0xfda0, 0xfda1, 0xfd81, 0xfd81, 0xfd81, 0xfd81, 0xfd80, 0xfd80, 0xfd80, 0xfd80, 0xfd61, 0xfd61, 0xfd41, 0xfd20, 0xfd20, 0xfd20, 0xfd20, 0xfd21, 0xc4a7, 0xdd8d, 0xeed6, 0xffde, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xfed6, 0xedcf, 0xd4c8, 0xd484, 0xed25, 0xfe08, 0xfe28, 0xfe08, 0xfde7, 0xfdc5, 0xfd83, 0xf562, 0xf541, 0xf540, 0xf563, 0xf563, 0xf583, 0xf583, 0xf583, 0xf583, 0xf582, 0xf582, 0xfd81, 0xfd80, 0xfd81, 0xfd80, 0xf560, 0xf560, 0xf540, 0xed40, 0xfd40, 0xfd40, 0xfd40, 0xf542, 0xed43, 0xe524, 0xdd05, 0xdce5, 0xfef6, 0xff79, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefff, 0xf7ff, 0xffff, 0xffbf, 0xff7b, 0xfe73, 0xe54a, 0xd4c6, 0xe505, 0xed46, 0xfda6, 0xfe06, 0xfe05, 0xfe03, 0xfdc1, 0xfd80, 0xfd60, 0xfd60, 0xfd60, 0xfd80, 0xfd80, 0xfd80, 0xfd80, 0xfd60, 0xfd60, 0xfd60, 0xfd60, 0xfd60, 0xfd81, 0xfd82, 0xf583, 0xf584, 0xfd62, 0xed02, 0xdca2, 0xcca5, 0xcd2a, 0xe631, 0xff57, 0xfffb, 0xffbf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xf7bf, 0xffbf, 0xffdf, 0xffff, 0xfffc, 0xffda, 0xfe51, 0xe5ad, 0xd4e9, 0xc485, 0xcc84, 0xdce3, 0xe523, 0xed22, 0xfd62, 0xfd62, 0xfd41, 0xfd41, 0xfd41, 0xfd61, 0xfd40, 0xfd40, 0xfd40, 0xfd40, 0xfd21, 0xf502, 0xece3, 0xe4c4, 0xdca4, 0xd4a5, 0xdd2c, 0xe5af, 0xfe73, 0xff39, 0xffdd, 0xffff, 0xffdf, 0xf7df, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbc, 0xfffe, 0xffff, 0xf7ff, 0xefff, 0xefff, 0xf7ff, 0xf7ff, 0xffbf, 0xff9f, 0xff7e, 0xff7c, 0xff59, 0xfed6, 0xee11, 0xdd6e, 0xdca4, 0xdc83, 0xd442, 0xcc41, 0xcc41, 0xd441, 0xd461, 0xd441, 0xc403, 0xcc24, 0xd4a7, 0xdd4b, 0xedcf, 0xfe72, 0xfef5, 0xff16, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7ff, 0xf7ff, 0xf7fe, 0xf7ff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffdd, 0xffdf, 0xffbe, 0xff7d, 0xff5c, 0xff5c, 0xff5c, 0xff7c, 0xff7c, 0xff9b, 0xff9b, 0xffbc, 0xffbd, 0xffde, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffd, 0xfffd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0xf7ff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffdf, 0xffbf, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffbf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};

const unsigned short  Cat[] PROGMEM = {
0xce5a, 0xce5a, 0xc639, 0xc619, 0xbdd8, 0xb5b7, 0xb597, 0xb597, 0xad77, 0xad77, 0xad56, 0xad56, 0xad56, 0xad56, 0xa536, 0xa536, 0x9cf5, 0x9cd4, 0x94b4, 0x8c93, 0x8c73, 0x8472, 0x8452, 0x7c32, 0x7c52, 0x7c52, 0x7432, 0x7412, 0x7411, 0x7411, 0x7412, 0x7432, 0x7411, 0x7411, 0x7411, 0x7431, 0x7c31, 0x7c32, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c32, 0x7c32, 0x7c32, 0x7c52, 0x7c52, 0x7c52, 0x7c32, 0x7c32, 0x7c31, 0x7c31, 0x7c31, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x8431, 0x8431, 0x7c31, 0x7c31, 0x7c31, 0x8451, 0x8431, 0x8431, 0x8431, 0x8431, 0x8451, 0x8451, 0x8452, 0x8452, 0x8452, 0x8452, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8452, 0x8452, 0x8452, 0x8452, 0x8452, 0x8452, 0x8452, 0x8452, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8c93, 0x8c93, 0x8cb3, 0x8cb3, 0x8cb3, 
0xce5a, 0xc639, 0xc639, 0xbdf8, 0xbdd8, 0xb5b7, 0xb597, 0xb597, 0xad77, 0xad56, 0xad56, 0xad56, 0xad56, 0xad56, 0xa536, 0xa536, 0x9cf5, 0x9cd4, 0x94b4, 0x8c93, 0x8c73, 0x8472, 0x8452, 0x7c32, 0x7c32, 0x7412, 0x73f1, 0x73f1, 0x73f1, 0x7411, 0x7412, 0x7412, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c32, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c52, 0x7c32, 0x7c32, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c11, 0x7c11, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73d0, 0x73cf, 0x73cf, 0x73d0, 0x73f0, 0x73f0, 0x7bf0, 0x7bf0, 0x7c10, 0x7c10, 0x7c10, 0x7bf0, 0x7bf0, 0x7bf0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x7bf0, 0x7bf0, 0x7bf0, 0x7bf0, 0x7bf0, 0x7bf0, 0x7bf0, 0x7bf0, 0x7c11, 0x7c11, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x8452, 0x8452, 0x8452, 0x8472, 0x8472, 
0xce5a, 0xc639, 0xc619, 0xbdf8, 0xbdd8, 0xb5b7, 0xb597, 0xb597, 0xad56, 0xad56, 0xad56, 0xad56, 0xad56, 0xad56, 0xa536, 0xa536, 0x9cf5, 0x9cd4, 0x94b4, 0x8c93, 0x8c73, 0x8472, 0x8452, 0x7c32, 0x7c32, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x73f1, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c32, 0x7c32, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c32, 0x7c32, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7411, 0x7411, 0x73f1, 0x73f1, 0x73f1, 0x73f1, 0x73f1, 0x73f1, 0x73f1, 0x73f1, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73cf, 0x73af, 0x73cf, 0x73af, 0x73af, 0x73af, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x73cf, 0x73cf, 0x73cf, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x7411, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 
0xce5a, 0xc639, 0xc619, 0xbdf8, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad56, 0xad56, 0xad56, 0xad56, 0xad56, 0xa536, 0xa536, 0xa536, 0x9cf5, 0x9cd4, 0x94b4, 0x8c93, 0x8c73, 0x8472, 0x8452, 0x7c32, 0x7c52, 0x7c11, 0x73f0, 0x73f0, 0x73f0, 0x73f1, 0x73f1, 0x73f0, 0x73f1, 0x7411, 0x7411, 0x7411, 0x7411, 0x7431, 0x7431, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7431, 0x7431, 0x7431, 0x7c31, 0x7c31, 0x7c31, 0x7431, 0x7431, 0x7411, 0x7411, 0x7411, 0x7c11, 0x7c11, 0x7411, 0x7411, 0x73f1, 0x73f1, 0x73f1, 0x73f1, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73d0, 0x73f0, 0x73f0, 0x73f0, 0x7bf0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73af, 0x73af, 0x73af, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6b8f, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x73d0, 0x73d0, 0x73f0, 0x73f0, 0x73f0, 
0xc639, 0xc639, 0xc619, 0xbdf8, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad56, 0xad56, 0xad56, 0xad56, 0xad56, 0xa536, 0xa536, 0xa536, 0x9cf5, 0x9cd4, 0x94b4, 0x8c93, 0x8c73, 0x8472, 0x8452, 0x7c32, 0x7c31, 0x7c11, 0x73d0, 0x6bd0, 0x73d0, 0x73f0, 0x7c11, 0x7c11, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7431, 0x7431, 0x7c31, 0x7c31, 0x7c31, 0x7431, 0x7431, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x73f1, 0x73f1, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73cf, 0x73cf, 0x73af, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x73af, 0x73cf, 0x73d0, 0x73cf, 0x73cf, 0x73cf, 0x73af, 0x73af, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x73d0, 0x73d0, 0x73d0, 0x73f0, 0x73f0, 
0xc639, 0xc639, 0xc619, 0xbdf8, 0xb5b7, 0xb597, 0xad76, 0xad76, 0xad56, 0xad56, 0xad56, 0xad56, 0xa536, 0xa536, 0xa536, 0xa536, 0x9cf5, 0x9cd4, 0x94b4, 0x8c93, 0x8c73, 0x8472, 0x8452, 0x7c32, 0x7c11, 0x7c11, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7431, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x73f1, 0x73f1, 0x73f1, 0x73f1, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73cf, 0x73cf, 0x73d0, 0x73d0, 0x73f0, 0x73d0, 0x73d0, 0x73cf, 0x73d0, 0x73d0, 0x73cf, 0x73af, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 
0xc639, 0xc619, 0xc619, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad76, 0xad56, 0xad56, 0xad56, 0xad56, 0xa536, 0xa536, 0xa536, 0xa536, 0x9cf5, 0x9cd4, 0x94b4, 0x8c93, 0x8c73, 0x8472, 0x8452, 0x7c32, 0x7c11, 0x7c11, 0x7c11, 0x73f0, 0x73af, 0x6b8f, 0x6b8f, 0x6baf, 0x6bf0, 0x73f0, 0x73f0, 0x7411, 0x7411, 0x7c31, 0x7c31, 0x7c32, 0x7c32, 0x7c31, 0x7c31, 0x7431, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x73f1, 0x73f1, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73af, 0x73cf, 0x73d0, 0x73f0, 0x73f0, 0x73d0, 0x73af, 0x6baf, 0x6baf, 0x73af, 0x73cf, 0x73d0, 0x73cf, 0x73af, 0x6b8f, 0x6b8e, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6bb0, 0x6bb0, 0x6bd0, 0x73d0, 0x73d0, 
0xc639, 0xc619, 0xbdf8, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad76, 0xad56, 0xad56, 0xad56, 0xad56, 0xa536, 0xa536, 0xa536, 0xa536, 0x9cf5, 0x9cd4, 0x94b4, 0x8c93, 0x8c73, 0x8472, 0x8452, 0x7c32, 0x7c11, 0x73d0, 0x6b6e, 0x52cc, 0x4a6a, 0x424a, 0x4a8b, 0x5aec, 0x5b4e, 0x636e, 0x638f, 0x6bd0, 0x73f0, 0x7431, 0x7c52, 0x7c52, 0x7c32, 0x7c32, 0x7c31, 0x7c31, 0x7431, 0x7411, 0x7411, 0x7411, 0x73f1, 0x73f1, 0x73f1, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73d0, 0x73d0, 0x6bd0, 0x6bd0, 0x6bb0, 0x6bb0, 0x6bb0, 0x6bd0, 0x6bd0, 0x6bd0, 0x6bd0, 0x6bd0, 0x6bd0, 0x6bd0, 0x6bd0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73d0, 0x73f0, 0x73f0, 0x73d0, 0x73cf, 0x6b8e, 0x634d, 0x5b0c, 0x52cc, 0x52cc, 0x5b0c, 0x634d, 0x6b8e, 0x73af, 0x73cf, 0x6baf, 0x6baf, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 
0xc619, 0xc619, 0xbdf8, 0xbdd8, 0xb597, 0xad76, 0xad76, 0xad56, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0x9d15, 0x9cf5, 0x94b4, 0x8c93, 0x8c93, 0x8c73, 0x8452, 0x8432, 0x8432, 0x7bd0, 0x39c7, 0x3165, 0x5aa9, 0x6b6d, 0x94b2, 0xb5d6, 0xb575, 0xad55, 0xa513, 0x8c51, 0x7bcf, 0x738e, 0x7bef, 0x8431, 0x8472, 0x7c52, 0x7c31, 0x7411, 0x7411, 0x7411, 0x7411, 0x7411, 0x73f1, 0x73b0, 0x73d0, 0x73f0, 0x73d0, 0x73b0, 0x73d0, 0x6baf, 0x73f0, 0x5b2d, 0x6baf, 0x73d0, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6baf, 0x6b8f, 0x6b8f, 0x6b8f, 0x73d0, 0x73f0, 0x6b8f, 0x73d0, 0x73f1, 0x6bb0, 0x6bb0, 0x7c31, 0x7c51, 0x7410, 0x73f0, 0x7c30, 0x7bef, 0x6bae, 0x636d, 0x6b6d, 0x73ae, 0x73ef, 0x73cf, 0x6bae, 0x5acb, 0x528a, 0x52cb, 0x52cb, 0x73cf, 0x73d0, 0x638e, 0x6bd0, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b6e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 
0xc619, 0xc619, 0xbdf8, 0xbdd8, 0xb597, 0xad76, 0xad56, 0xad56, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0x9d15, 0x9cf5, 0x94b4, 0x8c93, 0x8c93, 0x8c73, 0x8452, 0x8432, 0x8412, 0x6b4e, 0x4a08, 0x734c, 0xbd95, 0xd679, 0xd6ba, 0xd6db, 0xdeba, 0xdeba, 0xd699, 0xce59, 0xbdd7, 0xa514, 0x8431, 0x738e, 0x73d0, 0x7c11, 0x8452, 0x7c52, 0x7c11, 0x73f0, 0x73f0, 0x73f1, 0x73af, 0x636e, 0x73af, 0x73f0, 0x6baf, 0x6b8f, 0x6baf, 0x6baf, 0x6b8e, 0x634d, 0x634d, 0x5aec, 0x5b0c, 0x6b6e, 0x634d, 0x634d, 0x636e, 0x634e, 0x6baf, 0x6b8f, 0x636e, 0x6b8f, 0x6b8f, 0x6baf, 0x636f, 0x73d0, 0x7c11, 0x7c11, 0x7410, 0x73f0, 0x73cf, 0x6bae, 0x6b8e, 0x73cf, 0x8c71, 0x9d14, 0xb5d7, 0xc638, 0xce79, 0xce99, 0xc618, 0xa514, 0x73af, 0x4a8a, 0x634d, 0x73f0, 0x6baf, 0x638e, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 
0xc619, 0xbdf8, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad56, 0xad56, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa536, 0xa515, 0x9d15, 0x9cf5, 0x94b4, 0x8c93, 0x8c93, 0x8c73, 0x8452, 0x8452, 0x8432, 0x738f, 0x736e, 0xad14, 0xe6ba, 0xe6da, 0xd699, 0xce79, 0xd658, 0xd658, 0xd658, 0xdeba, 0xdefb, 0xd6ba, 0xbdf7, 0xad55, 0x8452, 0x7c31, 0x7c11, 0x7c51, 0x7c31, 0x73f0, 0x73d0, 0x73f0, 0x6b8f, 0x5b0d, 0x6b4e, 0x6b6e, 0x632d, 0x6b8e, 0x73cf, 0x6b8f, 0x5aaa, 0x62eb, 0x5aaa, 0x41e7, 0x4a48, 0x5289, 0x4a48, 0x62eb, 0x6b8f, 0x634e, 0x6b8e, 0x634e, 0x5b0d, 0x634d, 0x6b6e, 0x6b6e, 0x73d0, 0x73d0, 0x7bf0, 0x7c31, 0x7c30, 0x73cf, 0x6b8e, 0x6b8e, 0xa555, 0xb5d6, 0xce59, 0xdedb, 0xdf1c, 0xe71c, 0xe71c, 0xe73c, 0xef5d, 0xdedb, 0xb596, 0x73af, 0x632d, 0x73cf, 0x6bcf, 0x63af, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 
0xbdf8, 0xbdf8, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad56, 0xa535, 0xa536, 0xa536, 0xa536, 0xa536, 0xa515, 0xa515, 0xa515, 0xa515, 0x9d15, 0x9cf4, 0x94b4, 0x94b3, 0x8c93, 0x8c73, 0x8c72, 0x8452, 0x7bf1, 0x7bd0, 0x9472, 0xbdb6, 0xcdf7, 0xbd75, 0xbd95, 0xc5f7, 0xc5f6, 0xc5d6, 0xc5d6, 0xce17, 0xd679, 0xdeba, 0xdeba, 0xd6ba, 0xbdf8, 0x94f4, 0x7c10, 0x73f0, 0x7c10, 0x73d0, 0x6baf, 0x6baf, 0x6b6e, 0x5acb, 0x5acb, 0x4a6a, 0x528a, 0x73af, 0x7bcf, 0x5aec, 0x39a6, 0x5a89, 0x5248, 0x39c6, 0x4a27, 0x39a6, 0x2923, 0x5a89, 0x73af, 0x6b6e, 0x5acb, 0x4a6a, 0x5aec, 0x6b4d, 0x6b4d, 0x738e, 0x73af, 0x7bf0, 0x8431, 0x7c10, 0x6b8e, 0x6b8e, 0x8c71, 0xb5b6, 0xdefb, 0xe71b, 0xe71c, 0xe71b, 0xdeda, 0xd679, 0xce59, 0xce59, 0xd69a, 0xdedb, 0xdebb, 0xa514, 0x73af, 0x6b8e, 0x6baf, 0x73cf, 0x6b8f, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 
0xbdf8, 0xbdf8, 0xbdd8, 0xb5b7, 0xad76, 0xad56, 0xa535, 0xa535, 0xa536, 0xa536, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0x9d15, 0x9cf4, 0x94b4, 0x94b3, 0x8c93, 0x8c93, 0x8c73, 0x8452, 0x8452, 0x8431, 0xa514, 0xc595, 0xbd54, 0xbd34, 0xc595, 0xcdf7, 0xc5d6, 0xcdf6, 0xcdf7, 0xce17, 0xce38, 0xd659, 0xd679, 0xd69a, 0xdefc, 0xc659, 0xa535, 0x8431, 0x73af, 0x73ae, 0x73ae, 0x73ae, 0x62ec, 0x528a, 0x4208, 0x2945, 0x4a29, 0x8410, 0x736e, 0x3186, 0x2923, 0x5a89, 0x5268, 0x41c6, 0x5a89, 0x49e7, 0x20c2, 0x39a5, 0x630c, 0x6b4d, 0x39c7, 0x3166, 0x5aec, 0x6b4d, 0x632d, 0x738e, 0x73af, 0x7bf0, 0x73cf, 0x738e, 0x7c10, 0xa554, 0xd699, 0xe73c, 0xe6fb, 0xdeda, 0xd69a, 0xd679, 0xd679, 0xd679, 0xce58, 0xce58, 0xd679, 0xce59, 0xce79, 0xad75, 0x7bf0, 0x6bae, 0x6b8e, 0x6bcf, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b8f, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 
0xbdf8, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad56, 0xa535, 0xa535, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0x9d15, 0x9cf4, 0x94b4, 0x94b3, 0x8c93, 0x8c93, 0x8c73, 0x8c72, 0x8472, 0x8c92, 0xb575, 0xc575, 0xacd2, 0xacb2, 0xb513, 0xc575, 0xc595, 0xc595, 0xc5d6, 0xcdd7, 0xcdf7, 0xce18, 0xd638, 0xd659, 0xd69a, 0xe71c, 0xdedb, 0xa534, 0x7bcf, 0x738e, 0x7bcf, 0x7bcf, 0x5acb, 0x5269, 0x3185, 0x1082, 0x4a49, 0x9471, 0x5acb, 0x0840, 0x18c2, 0x5269, 0x5269, 0x3985, 0x5a89, 0x5aaa, 0x20e3, 0x1061, 0x5aaa, 0x736d, 0x3165, 0x2103, 0x5acb, 0x62eb, 0x5acb, 0x6b4d, 0x8410, 0x7bcf, 0x7bcf, 0x94b2, 0xce38, 0xef5c, 0xe73c, 0xd699, 0xdeba, 0xde99, 0xd659, 0xd659, 0xd679, 0xd679, 0xd658, 0xce18, 0xce17, 0xbdb6, 0xc618, 0xb5b6, 0x8430, 0x73ae, 0x6b8e, 0x73cf, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 
0xbdd8, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad56, 0xa535, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0x9d15, 0x9cf4, 0x94b4, 0x94b4, 0x8c93, 0x8c93, 0x8c73, 0x8c73, 0x8451, 0x8c72, 0xbd96, 0xbd74, 0xa450, 0xa430, 0x9c30, 0xac92, 0xb513, 0xb533, 0xb533, 0xb534, 0xb534, 0xbd75, 0xc5b6, 0xc5d7, 0xc618, 0xdeba, 0xe73c, 0xd679, 0xa513, 0x7bef, 0x7bcf, 0x8c30, 0x734d, 0x62cb, 0x3165, 0x1061, 0x62eb, 0x9cb2, 0x5269, 0x0800, 0x1061, 0x4a48, 0x5289, 0x3185, 0x4a48, 0x5aca, 0x2924, 0x0820, 0x62ca, 0x7bae, 0x3144, 0x20e3, 0x5269, 0x5aaa, 0x6b2c, 0x7bae, 0x83ef, 0x9492, 0xbdb6, 0xdeda, 0xef3c, 0xdefa, 0xd678, 0xce37, 0xd659, 0xd638, 0xce18, 0xce17, 0xce17, 0xcdf7, 0xc5b6, 0xbd95, 0xad34, 0xad34, 0xce38, 0xc5f7, 0x8410, 0x6b8e, 0x6b8e, 0x73cf, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 
0xbdd8, 0xbdd8, 0xb5b7, 0xb597, 0xad76, 0xad56, 0xa535, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0x9d15, 0x9cf4, 0x94b4, 0x94b4, 0x94b3, 0x8c93, 0x8c73, 0x8c73, 0x8c93, 0x9492, 0xbd95, 0xbd74, 0xac91, 0xac50, 0x9bef, 0x9bef, 0x9c50, 0xa491, 0xacd2, 0xacd2, 0xacf3, 0xb513, 0xbd75, 0xc5d6, 0xc638, 0xbdd7, 0xce79, 0xef5c, 0xce79, 0x9471, 0x7bef, 0x9492, 0x8c30, 0x734d, 0x3985, 0x18a2, 0x734c, 0xa4f3, 0x5a89, 0x1881, 0x0861, 0x4a49, 0x5aeb, 0x4208, 0x4228, 0x528a, 0x2965, 0x18e3, 0x62eb, 0x7b8e, 0x2903, 0x20c2, 0x5248, 0x62ca, 0x8c30, 0x9c91, 0x8410, 0xbdb6, 0xef3c, 0xef3c, 0xd699, 0xce38, 0xce58, 0xd698, 0xc5d6, 0xc5b6, 0xbd96, 0xbd75, 0xb555, 0xb534, 0xad14, 0xad13, 0xad13, 0xad34, 0xc617, 0xbdb6, 0x7bcf, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8f, 
0xbdd7, 0xbdb7, 0xb5b7, 0xb596, 0xad56, 0xa535, 0xa515, 0xa514, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0x9cf5, 0x9cd4, 0x94b4, 0x94b4, 0x94b3, 0x8cb3, 0x8cb3, 0x8cb3, 0x94b3, 0x8c92, 0xb595, 0xbd94, 0xa4b1, 0xa470, 0x9bef, 0x9baf, 0xa410, 0xac72, 0xac72, 0xac71, 0xacb2, 0xacb2, 0xacd3, 0xbd55, 0xbd55, 0xbd75, 0xbdb6, 0xd6b9, 0xdf1b, 0xb595, 0x9471, 0xad13, 0xad13, 0x8c0f, 0x3165, 0x20e3, 0x5289, 0x738d, 0x632c, 0x39e7, 0x3144, 0x5269, 0x62ca, 0x62eb, 0x5269, 0x5a89, 0x41e6, 0x5248, 0x6b4d, 0x738e, 0x2924, 0x1881, 0x5a69, 0x9470, 0xad13, 0x9450, 0xa513, 0xce58, 0xef1c, 0xe6bb, 0xce38, 0xce18, 0xce18, 0xce18, 0xbdb6, 0xbdb6, 0xbdb6, 0xbd96, 0xbd55, 0xb4f4, 0xb493, 0xac52, 0xacd3, 0xb534, 0xce18, 0xa555, 0x73ef, 0x73f0, 0x73d0, 0x73b0, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x634e, 0x636d, 0x636d, 0x636d, 0x636d, 0x636d, 0x636d, 0x636d, 0x636d, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b6e, 0x638e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6b8f, 
0xbdd7, 0xbdb7, 0xb597, 0xb576, 0xad56, 0xa535, 0xa515, 0xa514, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0xa515, 0x9cf5, 0x9cd4, 0x94b4, 0x94b4, 0x94b4, 0x94b4, 0x8cb4, 0x8cb3, 0x8cb3, 0x94b3, 0xb5b6, 0xbdb5, 0xacf2, 0xacb1, 0xa430, 0x9bcf, 0x938e, 0xa3f0, 0xa431, 0xac71, 0xb4b3, 0xacd3, 0xacb2, 0xb4f3, 0xbd55, 0xb554, 0xb595, 0xce58, 0xd6b9, 0xbdd6, 0xad33, 0xbdb5, 0xb554, 0x9470, 0x5248, 0x2944, 0x3185, 0x5289, 0x6b6d, 0x5aeb, 0x5aaa, 0x6b2b, 0x736c, 0x6b2b, 0x62ca, 0x6b2b, 0x6b2c, 0x736c, 0x8c30, 0x6b4c, 0x18a2, 0x0820, 0x5249, 0x9c91, 0xbd95, 0xa4d2, 0xb596, 0xd679, 0xe6db, 0xd659, 0xc5d7, 0xc5d7, 0xcdf7, 0xc5d7, 0xb555, 0xb575, 0xbd76, 0xbd75, 0xb535, 0xb4f4, 0xb4b3, 0xb493, 0xb4f3, 0xbd75, 0xc618, 0x9d14, 0x73ef, 0x73f0, 0x73b0, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6b8f, 0x6b8f, 
0xbdb7, 0xb5b7, 0xb597, 0xad76, 0xad55, 0xa535, 0xa514, 0xa4f4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf5, 0x9cd4, 0x94b4, 0x94b4, 0x94b4, 0x94d4, 0x94d4, 0x8cd4, 0x8cd3, 0x94d3, 0xb595, 0xb595, 0xad12, 0xb4f2, 0xac92, 0xa431, 0x9baf, 0x9baf, 0x93af, 0x9bef, 0xa451, 0xac92, 0xa492, 0xacd2, 0xb513, 0xacf3, 0xb575, 0xc637, 0xce78, 0xce37, 0xc5f7, 0xce17, 0xbd75, 0xa4d2, 0x7b8d, 0x39c6, 0x1061, 0x3165, 0x73ae, 0x840f, 0x736d, 0x6b2c, 0x736c, 0x630b, 0x6b2b, 0x734c, 0x8c50, 0x9470, 0x8c30, 0x4a28, 0x0820, 0x1061, 0x62cb, 0xad34, 0xc5d6, 0xb554, 0xc5f7, 0xd679, 0xde9a, 0xce17, 0xbd96, 0xbd96, 0xbd75, 0xb534, 0xb555, 0xb555, 0xb555, 0xb514, 0xb4d4, 0xacb3, 0xb4d3, 0xb4d4, 0xb514, 0xc5b6, 0xc5f7, 0x94b2, 0x73cf, 0x73f0, 0x6baf, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6baf, 0x6baf, 
0xb5b7, 0xb5b7, 0xb596, 0xad76, 0xad35, 0xa515, 0xa4f4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf5, 0x9cd4, 0x94b4, 0x94b4, 0x94d4, 0x94d4, 0x94f4, 0x94f4, 0x94f4, 0x94d3, 0xa534, 0xad74, 0xad13, 0xb4f3, 0xb4d3, 0xac92, 0xac11, 0x9bcf, 0x8b6e, 0x8b6e, 0x93cf, 0x9c30, 0xa471, 0xacb2, 0xacb2, 0xacf3, 0xbdd6, 0xd699, 0xd699, 0xd699, 0xd679, 0xc5f7, 0xb574, 0xad13, 0x9471, 0x4a48, 0x0820, 0x3165, 0x8c30, 0x9cd2, 0x8c0f, 0x736c, 0x7b8d, 0x734c, 0x83ce, 0x6b2b, 0x9c91, 0xad13, 0x8c30, 0x41e7, 0x0800, 0x20e3, 0x8bef, 0xc5d6, 0xbd95, 0xbd75, 0xc5f7, 0xd679, 0xd699, 0xce18, 0xbd96, 0xbd75, 0xb534, 0xacf3, 0xbd76, 0xb555, 0xb4f4, 0xacb3, 0xac93, 0xb4d3, 0xb514, 0xbd35, 0xb534, 0xc5d7, 0xb596, 0x8451, 0x6bcf, 0x73f0, 0x6baf, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6baf, 0x6baf, 
0xb597, 0xb597, 0xad76, 0xad56, 0xa535, 0xa514, 0x9cf4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cf5, 0x9cd4, 0x94b4, 0x94b4, 0x94d4, 0x94f4, 0x94f5, 0x94f4, 0x9515, 0x94d4, 0x9d13, 0xb575, 0xb554, 0xacd2, 0xacb2, 0xac72, 0xac11, 0x9baf, 0x936e, 0x938e, 0x9bcf, 0x9c10, 0xa471, 0xacb2, 0xacd3, 0xb534, 0xce38, 0xdeda, 0xd6b9, 0xdeda, 0xde99, 0xc5d6, 0xbd95, 0xb554, 0xa4d2, 0x5289, 0x18a2, 0x5289, 0xa514, 0xad55, 0x8c50, 0x736c, 0x736d, 0x734c, 0x83ce, 0x5269, 0x8c0f, 0xad13, 0xad54, 0x5acb, 0x1061, 0x3145, 0xa4d2, 0xce17, 0xb554, 0xc5b5, 0xc617, 0xd699, 0xdeda, 0xd658, 0xc5d7, 0xbdb6, 0xbd95, 0xbd75, 0xb575, 0xacf4, 0xac92, 0xac72, 0xb4b3, 0xbd14, 0xbd55, 0xbd76, 0xb534, 0xc5f7, 0xa534, 0x7c10, 0x73ef, 0x73f0, 0x6bcf, 0x6bb0, 0x6b8f, 0x6b8f, 0x6b8f, 0x6b8e, 0x6b8e, 0x6b6e, 0x6b6e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b6e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 
0xb597, 0xb596, 0xad76, 0xad55, 0xa515, 0xa4f4, 0x9cd4, 0x9cd3, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x94b4, 0x94b4, 0x94b4, 0x94d4, 0x94f5, 0x9515, 0x9515, 0x9515, 0x9514, 0x9d14, 0xbdd6, 0xc5b6, 0xacf3, 0xac72, 0xa431, 0xa3f0, 0x9b6e, 0x936e, 0x9baf, 0x9bef, 0xa410, 0xac92, 0xb4d3, 0xbd34, 0xc596, 0xd679, 0xdeda, 0xd699, 0xd699, 0xd679, 0xc5f7, 0xc5d6, 0xbd95, 0xa4f2, 0x5269, 0x2944, 0x7bae, 0xb5b6, 0xad34, 0x83ce, 0x62ca, 0x62ca, 0x630b, 0x736c, 0x4a28, 0x8c2f, 0xa4d2, 0xad55, 0x6b4c, 0x1081, 0x3985, 0xacf3, 0xc5f7, 0xb554, 0xc5d6, 0xd678, 0xdeda, 0xe6fa, 0xde99, 0xce17, 0xcdf7, 0xcdf7, 0xcdf7, 0xb555, 0xb514, 0xb493, 0xb493, 0xbcb4, 0xbcf4, 0xb514, 0xad14, 0xbd75, 0xc5f7, 0x9cf3, 0x740f, 0x7430, 0x7410, 0x73f0, 0x73f0, 0x73cf, 0x73cf, 0x73cf, 0x73af, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6b8f, 0x6b8f, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6bcf, 0x73cf, 0x73cf, 
0xb596, 0xad76, 0xad56, 0xad35, 0xa515, 0x9cf4, 0x9cd4, 0x9cd3, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x9cd4, 0x94b4, 0x94b4, 0x9493, 0x94b4, 0x94d4, 0x94f5, 0x9d15, 0x9d15, 0x9515, 0x9d35, 0x9d14, 0xbdd6, 0xc617, 0xbd55, 0xb4f4, 0xac73, 0xac11, 0x9b8f, 0x9b8e, 0x9bcf, 0x93af, 0x9bf0, 0xac92, 0xbd14, 0xbd55, 0xcdf7, 0xd679, 0xd699, 0xce58, 0xce58, 0xd658, 0xce37, 0xc5f6, 0xbdb5, 0xa513, 0x4a48, 0x2944, 0x83ef, 0xa534, 0x7bef, 0x7bad, 0x5248, 0x5aa9, 0x6b2b, 0x62eb, 0x5aa9, 0xa4d2, 0x8c50, 0x8c51, 0x6b2c, 0x2944, 0x5a89, 0xb554, 0xc5d6, 0xbd95, 0xcdf7, 0xd699, 0xdeda, 0xdeda, 0xde99, 0xd658, 0xce38, 0xcdf7, 0xc5b6, 0xb534, 0xb4f4, 0xb4b3, 0xbc73, 0xb473, 0xb4b3, 0xacf4, 0xad34, 0xcdf7, 0xce38, 0x9cd2, 0x7c30, 0x7c71, 0x7c31, 0x7c31, 0x7c31, 0x7c10, 0x7c10, 0x7c10, 0x7bf0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73d0, 0x73d0, 0x73d0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 
0xb596, 0xad76, 0xad56, 0xa535, 0xa514, 0x9cf4, 0x9cd3, 0x9cb3, 0x94b3, 0x94b3, 0x94b3, 0x94b3, 0x94b3, 0x94b3, 0x94b3, 0x94b3, 0x94b4, 0x94b4, 0x9493, 0x94b4, 0x94d4, 0x94f5, 0x9d15, 0x9d15, 0x9535, 0x9d35, 0x94f4, 0xb5b6, 0xce17, 0xc596, 0xcd96, 0xbd15, 0xb431, 0xa3af, 0x9baf, 0xa3f0, 0x93ae, 0x93cf, 0xac72, 0xbcf4, 0xbd34, 0xcdf7, 0xd679, 0xce78, 0xce58, 0xce37, 0xce37, 0xce38, 0xc5f6, 0xc5d6, 0xad33, 0x4a28, 0x2103, 0x738d, 0x8c30, 0x4a49, 0x736c, 0x41e7, 0x5269, 0x6b0b, 0x5248, 0x5a89, 0x9cb2, 0x62ca, 0x83ef, 0x738e, 0x5269, 0x83ef, 0xc5b6, 0xbdb6, 0xcdf7, 0xce17, 0xd678, 0xd699, 0xd699, 0xd699, 0xd678, 0xce37, 0xbd95, 0xad13, 0xa4d3, 0xacb3, 0xb472, 0xb432, 0xac11, 0xac93, 0xb555, 0xbdf7, 0xd638, 0xce58, 0x9cd3, 0x8471, 0x84b2, 0x7c51, 0x7c51, 0x7c52, 0x8431, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c11, 0x7c11, 0x7c11, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c10, 0x7c10, 0x7c11, 0x7c31, 0x7c31, 
0xad76, 0xad56, 0xad35, 0xa515, 0x9cf4, 0x9cb3, 0x9493, 0x9493, 0x94b3, 0x9493, 0x9493, 0x9493, 0x9493, 0x9493, 0x9493, 0x94b3, 0x94b3, 0x94b3, 0x9493, 0x94b3, 0x9cd4, 0x9cf4, 0xa535, 0xa535, 0x9d15, 0xa556, 0x9cf4, 0xa555, 0xc617, 0xc617, 0xc5f6, 0xb575, 0xb4d2, 0x93ad, 0x93ad, 0xa3ef, 0x9bce, 0xa450, 0xb513, 0xacf2, 0xad33, 0xbdd6, 0xd678, 0xd679, 0xce58, 0xce37, 0xc5f7, 0xbdd6, 0xbdd6, 0xbd95, 0xb575, 0x7bce, 0x5aaa, 0x83ef, 0x5269, 0x3144, 0x5289, 0x41e7, 0x41e7, 0x5acb, 0x41e7, 0x6b2c, 0x7bcf, 0x4a49, 0x736d, 0x9cd2, 0x9cd2, 0xa533, 0xbdb6, 0xbdd6, 0xc637, 0xc638, 0xce58, 0xce58, 0xd678, 0xd699, 0xd678, 0xc5f7, 0xbd95, 0xb595, 0xacf2, 0xb4f3, 0xa410, 0x9b4d, 0xac10, 0xcd55, 0xd617, 0xd657, 0xc638, 0xbdd7, 0x9cf3, 0x8c51, 0x8c92, 0x8c92, 0x8451, 0x8c72, 0x8471, 0x8471, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x7c31, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x7c31, 0x7c31, 0x8451, 0x8451, 0x8451, 
0xad56, 0xad56, 0xad35, 0xa514, 0x9cd4, 0x9cb3, 0x9493, 0x9492, 0x9493, 0x9493, 0x9492, 0x9492, 0x9492, 0x9492, 0x9493, 0x9493, 0x9493, 0x9493, 0x9493, 0x94b3, 0x9cd4, 0x9cf4, 0xa515, 0xa535, 0xa535, 0xa556, 0x9cf3, 0xa534, 0xbdf7, 0xc617, 0xc5f7, 0xbd95, 0xb4f2, 0x93ce, 0x938d, 0xac50, 0xbcd3, 0xb4d2, 0xb513, 0xbd95, 0xbd95, 0xc5f7, 0xce38, 0xce37, 0xc617, 0xc617, 0xc617, 0xc617, 0xc5f7, 0xbdd6, 0xc5f7, 0xa513, 0x8c50, 0xad34, 0x6b4c, 0x2944, 0x39a6, 0x39a6, 0x3165, 0x4a48, 0x4a28, 0x6b2c, 0x6b2c, 0x5aaa, 0x9471, 0xb5b6, 0xb595, 0xb5b6, 0xc617, 0xbdf7, 0xc638, 0xc638, 0xce58, 0xce37, 0xce37, 0xce58, 0xce38, 0xc617, 0xbdd6, 0xbdd6, 0xbd74, 0xc554, 0xac30, 0x932c, 0x9b6e, 0xb492, 0xc5b5, 0xd678, 0xc638, 0xbdd7, 0x9cf3, 0x8c71, 0x8c92, 0x8c92, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8471, 0x8451, 0x8451, 0x8451, 0x8451, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8431, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 
0xad56, 0xad55, 0xa535, 0xa4f4, 0x9cd4, 0x9cb3, 0x9493, 0x9472, 0x9492, 0x9492, 0x9492, 0x9472, 0x9472, 0x9492, 0x9492, 0x9492, 0x9493, 0x9493, 0x9493, 0x9493, 0x94b3, 0x9cf4, 0xa515, 0xa535, 0xa555, 0xa555, 0x94d3, 0xa534, 0xbdf7, 0xce38, 0xce37, 0xbdb5, 0xbd34, 0xa491, 0x93ae, 0xac51, 0xd5b6, 0xcd95, 0xb533, 0xc5b5, 0xc5f7, 0xc617, 0xc617, 0xc617, 0xc617, 0xce37, 0xce38, 0xce37, 0xc617, 0xc5f7, 0xc617, 0xc5f7, 0xb575, 0xc617, 0x9471, 0x3165, 0x3165, 0x4207, 0x3165, 0x41e7, 0x4a48, 0x62eb, 0x41e7, 0x630b, 0xb595, 0xce78, 0xc637, 0xc617, 0xce58, 0xc638, 0xce78, 0xce58, 0xce58, 0xce17, 0xc617, 0xce37, 0xce37, 0xc617, 0xc5f7, 0xc5f6, 0xd638, 0xcdb6, 0xac51, 0x934d, 0x936d, 0xa451, 0xbd95, 0xd678, 0xce59, 0xbdd7, 0x9cf3, 0x8c92, 0x94b3, 0x94b3, 0x8c92, 0x8c72, 0x8c92, 0x8c92, 0x8472, 0x8472, 0x8472, 0x8471, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8471, 0x8472, 0x8472, 0x8472, 
0xad56, 0xad35, 0xa515, 0xa4f4, 0x9cd4, 0x94b3, 0x9492, 0x9472, 0x9472, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x9472, 0x8c72, 0x8c72, 0x8c72, 0x9493, 0x94b3, 0x9cd4, 0x9cf4, 0xa515, 0x9d35, 0xa535, 0x9cf4, 0xad55, 0xc618, 0xce59, 0xd678, 0xc5d6, 0xbd75, 0xacd2, 0x836d, 0x8b6d, 0xb4f3, 0xcdb6, 0xbdb5, 0xc616, 0xc617, 0xc617, 0xc617, 0xce37, 0xce58, 0xd658, 0xce58, 0xce17, 0xce38, 0xc617, 0xc5d6, 0xc5f7, 0xbdd6, 0xd658, 0xb575, 0x4a48, 0x3985, 0x5268, 0x3165, 0x3185, 0x4a48, 0x5268, 0x2903, 0x83ef, 0xce38, 0xd6ba, 0xc638, 0xc617, 0xce58, 0xce38, 0xce78, 0xce58, 0xce58, 0xce38, 0xce37, 0xce38, 0xce38, 0xce37, 0xc5f7, 0xbdd6, 0xcdf6, 0xb513, 0x9bef, 0x8b8d, 0x9c10, 0xbd34, 0xce37, 0xdeb9, 0xd69a, 0xbdf7, 0xa514, 0x9492, 0x94b3, 0x94d3, 0x8cb3, 0x8c72, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8472, 0x8472, 0x8472, 0x8c92, 0x8c92, 
0xad35, 0xad35, 0xa515, 0xa4f4, 0x9cb3, 0x9493, 0x9472, 0x9472, 0x8c72, 0x8c72, 0x8c52, 0x8c52, 0x8c52, 0x8c52, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x9493, 0x94b3, 0x9cf4, 0xa515, 0xa555, 0xa555, 0x9d14, 0xad75, 0xbdf7, 0xce59, 0xdeba, 0xd658, 0xb554, 0x9c71, 0x838d, 0x8bae, 0xb4f3, 0xce17, 0xd658, 0xce78, 0xce58, 0xce37, 0xce37, 0xce38, 0xce58, 0xce58, 0xce37, 0xc617, 0xd679, 0xce38, 0xbdb6, 0xb595, 0xb595, 0xce38, 0xce38, 0x7bae, 0x3144, 0x41c6, 0x2903, 0x20e2, 0x41e6, 0x41e6, 0x3164, 0xb574, 0xd699, 0xce78, 0xb5b6, 0xb595, 0xbdf7, 0xc617, 0xc638, 0xc617, 0xce58, 0xce38, 0xce37, 0xce37, 0xce38, 0xce58, 0xce38, 0xce37, 0xc5d6, 0xacf3, 0x940f, 0x93ef, 0xacd2, 0xcdf7, 0xdeb9, 0xdeba, 0xd6ba, 0xbdf7, 0xa514, 0x94b2, 0x94b2, 0x94b3, 0x94b3, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8472, 0x8472, 0x8472, 0x8472, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8472, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 
0xad35, 0xa535, 0xa514, 0x9cd4, 0x9cb3, 0x9493, 0x9472, 0x8c52, 0x8c52, 0x8c52, 0x8c51, 0x8c51, 0x8c51, 0x8c51, 0x8c52, 0x8c52, 0x8c52, 0x8c52, 0x8c52, 0x8c52, 0x8c72, 0x94b3, 0x9cd4, 0x9cf4, 0xa576, 0xa576, 0xa534, 0xa555, 0xb595, 0xc617, 0xe6da, 0xdeda, 0xc5f7, 0xad13, 0xacd3, 0xc5b6, 0xde58, 0xdeba, 0xdeda, 0xd6d9, 0xde99, 0xd678, 0xce38, 0xce17, 0xc617, 0xc5f6, 0xc5f6, 0xc617, 0xd679, 0xce38, 0xb575, 0x9491, 0x9cd2, 0xbd95, 0xd679, 0xa4f3, 0x39a5, 0x3965, 0x2903, 0x20c2, 0x3985, 0x39a5, 0x5a89, 0xce37, 0xce58, 0xb5b5, 0x9cd2, 0xa4f3, 0xbdd6, 0xce58, 0xce58, 0xbdf7, 0xc5f6, 0xc617, 0xc617, 0xc617, 0xce38, 0xd679, 0xdeba, 0xdeda, 0xde9a, 0xcdf7, 0xb534, 0xad13, 0xbd95, 0xd679, 0xe6fb, 0xdeba, 0xce58, 0xb596, 0xa514, 0x94b2, 0x8c92, 0x94b3, 0x94d3, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8472, 0x8472, 0x8472, 0x8472, 0x8471, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8472, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 
0xad35, 0xa515, 0xa4f4, 0x9cd4, 0x9cb3, 0x9492, 0x8c72, 0x8c52, 0x8c51, 0x8c51, 0x8c31, 0x8431, 0x8431, 0x8c31, 0x8c51, 0x8c51, 0x8c52, 0x8c52, 0x8c52, 0x8c52, 0x8c72, 0x9493, 0x9cd4, 0x9cf4, 0xa556, 0xa576, 0xa555, 0xad55, 0xad54, 0xbdb6, 0xdeb9, 0xdeba, 0xdeda, 0xce37, 0xd638, 0xe6ba, 0xe6fb, 0xe6fa, 0xdefa, 0xdf1a, 0xdeda, 0xd699, 0xce58, 0xc617, 0xbdb5, 0xad54, 0xb574, 0xbdb5, 0xd658, 0xce38, 0xad54, 0x83ef, 0x9471, 0xb575, 0xd679, 0xc5d6, 0x734c, 0x4a27, 0x4a07, 0x3964, 0x41c6, 0x4a27, 0x8c0f, 0xd637, 0xce38, 0xad54, 0x8c70, 0x9cd2, 0xbdd6, 0xd699, 0xce58, 0xb595, 0xad34, 0xbdb5, 0xc5f7, 0xce37, 0xd658, 0xdeba, 0xe6fa, 0xe6fb, 0xe6db, 0xde9a, 0xd658, 0xc617, 0xce38, 0xe6fb, 0xef3c, 0xd69a, 0xb596, 0xa514, 0x9cd3, 0x94b2, 0x8c72, 0x8c92, 0x94b3, 0x8c92, 0x8c92, 0x8472, 0x8472, 0x8472, 0x8472, 0x8471, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8c92, 0x8c92, 0x8c92, 
0xa535, 0xa515, 0xa4f4, 0x9cd4, 0x94b3, 0x9492, 0x8c72, 0x8c52, 0x8c51, 0x8c31, 0x8431, 0x8431, 0x8431, 0x8431, 0x8c31, 0x8c51, 0x8c52, 0x8431, 0x8431, 0x8c52, 0x8c72, 0x9493, 0x9cd4, 0x9cd4, 0x9d14, 0xa576, 0xad96, 0xb596, 0xad54, 0xb595, 0xd678, 0xd678, 0xce79, 0xd699, 0xde99, 0xde99, 0xde99, 0xdeda, 0xdeda, 0xceda, 0xdeda, 0xdeb9, 0xd679, 0xc617, 0xb575, 0xa4f3, 0xa4f3, 0xad34, 0xce58, 0xce58, 0xb595, 0x840f, 0x9cd2, 0xbdd6, 0xd699, 0xce58, 0xa4d1, 0x6aea, 0x6b0b, 0x5248, 0x5a68, 0x62ca, 0xb574, 0xd637, 0xdeda, 0xb595, 0x9491, 0x9cf2, 0xc5f7, 0xd699, 0xbdf7, 0x9cf3, 0x9cb1, 0xb554, 0xc617, 0xd679, 0xdeb9, 0xdeda, 0xe6da, 0xdeda, 0xe6ba, 0xdeba, 0xd69a, 0xce79, 0xce79, 0xdefb, 0xdeda, 0xc5f7, 0xa4f3, 0x94b2, 0x94b2, 0x94b2, 0x8c72, 0x8c92, 0x94b3, 0x8c72, 0x8472, 0x8472, 0x8472, 0x8472, 0x8471, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8472, 0x8472, 0x8472, 0x8c92, 0x8c92, 
0xa534, 0xa514, 0xa4f4, 0x9cd3, 0x9492, 0x8c72, 0x8c51, 0x8c31, 0x8430, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8430, 0x8431, 0x8431, 0x8431, 0x8c31, 0x8c52, 0x9492, 0x9cb3, 0x9cd4, 0x9d14, 0xa555, 0xad76, 0xad76, 0xad55, 0xb596, 0xc618, 0xd699, 0xd678, 0xd678, 0xd699, 0xdeba, 0xdeb9, 0xdeb9, 0xdeda, 0xdeda, 0xdedb, 0xe71b, 0xdeba, 0xce59, 0xce38, 0xbdb6, 0xb574, 0xbd95, 0xcdf7, 0xde79, 0xc5b6, 0x9430, 0xa4d2, 0xbd95, 0xde79, 0xce58, 0xbd94, 0x8bee, 0x732a, 0x7b4a, 0x838b, 0xa48f, 0xc5b5, 0xce16, 0xde58, 0xc5b6, 0x9c71, 0x9cb2, 0xc617, 0xd698, 0xc5f5, 0xb532, 0xad34, 0xc617, 0xd658, 0xd679, 0xd699, 0xdeda, 0xe71b, 0xe6da, 0xde99, 0xce17, 0xce38, 0xd679, 0xd699, 0xdeba, 0xce78, 0xb595, 0x8cd3, 0x8cb2, 0x8c92, 0x8492, 0x8492, 0x8492, 0x8472, 0x8471, 0x8451, 0x8451, 0x8451, 0x8451, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x8451, 0x8452, 0x8472, 0x8472, 0x8472, 
0xa534, 0xa514, 0x9cf4, 0x9cd3, 0x9492, 0x8c72, 0x8c51, 0x8c31, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8431, 0x8431, 0x8431, 0x8431, 0x8c52, 0x9492, 0x94b3, 0x9cd3, 0x9d14, 0xa535, 0xad76, 0xad76, 0xad75, 0xb596, 0xc618, 0xd679, 0xdeb9, 0xd678, 0xce78, 0xd699, 0xdeb9, 0xdeb9, 0xdeda, 0xdeda, 0xdefb, 0xdefb, 0xd699, 0xce38, 0xce38, 0xc617, 0xc5d6, 0xc5d6, 0xc5f7, 0xce38, 0xc5d6, 0x9450, 0x9450, 0xad13, 0xd638, 0xce17, 0xce17, 0xb532, 0x9c6f, 0x9c4e, 0xacb0, 0xb532, 0xc5b4, 0xce37, 0xd5f6, 0xacd2, 0x9c91, 0xad55, 0xce58, 0xd679, 0xc5d5, 0xb553, 0xc5f6, 0xce38, 0xd679, 0xe6fa, 0xe71b, 0xdeba, 0xdeb9, 0xd699, 0xde99, 0xde99, 0xd658, 0xce37, 0xd678, 0xdeba, 0xce58, 0xb595, 0x8cb2, 0x8492, 0x8471, 0x8471, 0x8471, 0x8451, 0x7c51, 0x7c51, 0x7c31, 0x7c31, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c51, 0x8451, 0x8451, 0x8451, 
0xa514, 0xa514, 0x9cf4, 0x9cb3, 0x9492, 0x8c71, 0x8c51, 0x8c31, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8431, 0x8431, 0x8431, 0x8431, 0x8c51, 0x9472, 0x94b3, 0x9cd3, 0x9d14, 0xa535, 0xa555, 0xa555, 0xad75, 0xb5b6, 0xc618, 0xce79, 0xce38, 0xce17, 0xc5f6, 0xce17, 0xd699, 0xdeb9, 0xd699, 0xde99, 0xd699, 0xdeba, 0xd679, 0xce38, 0xce38, 0xce38, 0xc5d6, 0xbd95, 0xc5f7, 0xbdd6, 0xd658, 0xc5d6, 0xb554, 0xb554, 0xc5f6, 0xc5f6, 0xbdb5, 0xbd74, 0xacd1, 0xacd0, 0xbd32, 0xb512, 0xad12, 0xbdb5, 0xc595, 0xad13, 0xbdd6, 0xce79, 0xce79, 0xce78, 0xce37, 0xce37, 0xce17, 0xce17, 0xce17, 0xd678, 0xde99, 0xdeba, 0xe6fa, 0xdeda, 0xdeb9, 0xe6ba, 0xd658, 0xbdb6, 0xc5f7, 0xd678, 0xc637, 0xb5b5, 0x8471, 0x8451, 0x7c31, 0x7c30, 0x7c30, 0x7c30, 0x7c10, 0x7410, 0x73f0, 0x73f0, 0x73ef, 0x73ef, 0x73ef, 0x73ef, 0x73ef, 0x73ef, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 0x7410, 0x7410, 0x7410, 0x7410, 0x7c10, 0x7c11, 0x7c11, 0x7c31, 0x7c31, 
0xa514, 0xa514, 0x9cf3, 0x9cb3, 0x9492, 0x8c51, 0x8c31, 0x8431, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8411, 0x8411, 0x8411, 0x8431, 0x8c31, 0x8c72, 0x9493, 0x94b3, 0x9d14, 0x9d14, 0x9d35, 0xa555, 0xad75, 0xb5b6, 0xc618, 0xce58, 0xc5d6, 0xc5f7, 0xbdb5, 0xb595, 0xce17, 0xd658, 0xd658, 0xd679, 0xce37, 0xde99, 0xdeba, 0xce58, 0xbdd6, 0xad34, 0x8c51, 0x7bae, 0x630c, 0x52aa, 0x7bce, 0xa513, 0xbdd6, 0xbdb5, 0xbd95, 0xc5b5, 0xb554, 0xbd74, 0xb532, 0xb512, 0xbd53, 0xbd53, 0xb553, 0xc5f6, 0xc5b5, 0xce17, 0xc618, 0xa555, 0x8451, 0x7bef, 0x9491, 0xb574, 0xc5f6, 0xd678, 0xdeb9, 0xd699, 0xd679, 0xe6da, 0xe6fa, 0xce58, 0xbdb6, 0xbdb6, 0xc5d6, 0xbdb6, 0xbdb5, 0xc617, 0xc637, 0xbdd6, 0x7c31, 0x7c30, 0x7410, 0x73f0, 0x73f0, 0x73f0, 0x73ef, 0x73cf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6bae, 0x6bae, 0x6bae, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6baf, 0x6baf, 0x6bcf, 0x6bcf, 0x6bcf, 0x6bcf, 0x6bcf, 0x73cf, 0x73d0, 0x73f0, 0x73f0, 0x73f0, 0x73f0, 
0xa514, 0xa4f4, 0x9cd3, 0x94b3, 0x9492, 0x8c51, 0x8c31, 0x8430, 0x8410, 0x8410, 0x83f0, 0x83f0, 0x83f0, 0x83f0, 0x8410, 0x8410, 0x8411, 0x8410, 0x8410, 0x8411, 0x8431, 0x8c52, 0x9472, 0x9493, 0x9cf4, 0x9cf4, 0x9d14, 0xa534, 0xad55, 0xb596, 0xbdf7, 0xc618, 0xc5f7, 0xc5d6, 0x9c91, 0x734c, 0x734c, 0x7bae, 0x83ef, 0x9c91, 0xad33, 0xc5d6, 0xce37, 0xb575, 0x83ef, 0x4a69, 0x2945, 0x1082, 0x0041, 0x0021, 0x0841, 0x41e7, 0x8c50, 0xc5d6, 0xc5d5, 0xc5b5, 0xb575, 0xb554, 0xb553, 0xbd53, 0xbd53, 0xbd74, 0xc5f6, 0xce58, 0xc5f6, 0xbd95, 0x6b4c, 0x2986, 0x10c3, 0x0021, 0x10a3, 0x39a6, 0x5aca, 0x8c30, 0xc5f7, 0xd699, 0xd658, 0xce58, 0xbdd6, 0x9cd2, 0x6b2c, 0x732c, 0x9c91, 0xc5d6, 0xbdd6, 0xbdd6, 0xbdf6, 0xb595, 0x7c30, 0x7410, 0x73f0, 0x73ef, 0x73ef, 0x73ef, 0x73cf, 0x6bcf, 0x6bae, 0x6bae, 0x6bae, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x636e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6bae, 0x6bae, 0x6bae, 0x6baf, 0x6baf, 0x6bcf, 0x6bcf, 0x6bcf, 
0xa514, 0xa4f4, 0x9cd3, 0x94b3, 0x9472, 0x8c51, 0x8431, 0x8410, 0x8410, 0x83f0, 0x83f0, 0x83f0, 0x83f0, 0x83f0, 0x83f0, 0x8410, 0x8410, 0x8410, 0x83f0, 0x8410, 0x8411, 0x8c51, 0x8c72, 0x9492, 0x94d3, 0x94d3, 0x9cf4, 0x9d14, 0xa534, 0xad75, 0xb5b6, 0xbdd7, 0xc5d6, 0xb554, 0x6b0b, 0x20c2, 0x18a1, 0x28e3, 0x39a5, 0x62ca, 0x83ad, 0x9c70, 0xad13, 0x9cb1, 0x62eb, 0x2965, 0x1082, 0x0021, 0x08a3, 0x2166, 0x0861, 0x1082, 0x5289, 0xb534, 0xd657, 0xcdf6, 0xb5b5, 0xad53, 0xb553, 0xb532, 0xacf2, 0xb553, 0xc616, 0xce37, 0xd678, 0x8c50, 0x2986, 0x08a3, 0x2146, 0x10c4, 0x0000, 0x0021, 0x2924, 0x5aa9, 0xa4f3, 0xc5d6, 0xa513, 0x83ef, 0x5aca, 0x39a6, 0x2903, 0x2924, 0x6b4c, 0xb575, 0xc5f6, 0xbdd6, 0xb5b5, 0xa513, 0x7c30, 0x7c10, 0x73f0, 0x73ef, 0x73ef, 0x73ef, 0x73cf, 0x6bcf, 0x6baf, 0x6baf, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x638e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6bae, 0x6bae, 0x6baf, 0x6baf, 0x6bcf, 0x6bcf, 0x6bcf, 
0xa514, 0x9cf4, 0x9cd3, 0x94b2, 0x9472, 0x8c51, 0x8431, 0x8410, 0x83f0, 0x83f0, 0x83f0, 0x7bf0, 0x7bf0, 0x83f0, 0x83f0, 0x83f0, 0x8410, 0x83f0, 0x7bf0, 0x83f0, 0x8411, 0x8431, 0x8c52, 0x8c72, 0x94b3, 0x94d3, 0x94d3, 0x9cf4, 0x9d14, 0xa534, 0xad75, 0xb5b6, 0xbd75, 0xa4d2, 0x5a89, 0x28e3, 0x3124, 0x3985, 0x5228, 0x83ae, 0xb533, 0xc594, 0xce17, 0xb574, 0x6b4c, 0x2945, 0x0862, 0x0041, 0x10e4, 0x3a09, 0x10e4, 0x18e3, 0x3185, 0x83cd, 0xcdf6, 0xd616, 0xc5f7, 0xbdb5, 0xbd94, 0xbd74, 0xbd73, 0xc5b5, 0xce17, 0xce38, 0xbdd5, 0x52a9, 0x2144, 0x1925, 0x3209, 0x424a, 0x18c4, 0x0842, 0x2944, 0x5aa9, 0xa513, 0xc5d6, 0xa513, 0x840f, 0x62eb, 0x41e6, 0x3985, 0x3165, 0x5269, 0x8c30, 0xad74, 0xb595, 0xad54, 0x9cd2, 0x7c51, 0x7c30, 0x7410, 0x73f0, 0x73f0, 0x73f0, 0x73ef, 0x73cf, 0x6bcf, 0x6bcf, 0x6bcf, 0x6bcf, 0x6bcf, 0x6baf, 0x6baf, 0x6baf, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6bae, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6bcf, 0x73cf, 0x73d0, 0x73f0, 0x73f0, 0x73f0, 
0xa4f4, 0x9cf4, 0x9cd3, 0x9492, 0x9472, 0x8c51, 0x8430, 0x8410, 0x83f0, 0x83f0, 0x7bf0, 0x7bf0, 0x7bf0, 0x7bf0, 0x83f0, 0x83f0, 0x8410, 0x83f0, 0x7bf0, 0x7bf0, 0x8410, 0x8431, 0x8c52, 0x8c72, 0x8c92, 0x94b3, 0x94d3, 0x9cf3, 0x9cf3, 0xa514, 0xad55, 0xb595, 0xb554, 0xa4d2, 0x6b0b, 0x5248, 0x6b0b, 0x6b2c, 0x734c, 0xa4d2, 0xcdd5, 0xcdf6, 0xd657, 0xbdb6, 0x738d, 0x2945, 0x0062, 0x0021, 0x0022, 0x10e4, 0x0021, 0x2125, 0x2924, 0x5268, 0xb533, 0xcdf6, 0xbdf7, 0xc5f6, 0xbdb5, 0xbd94, 0xc5d5, 0xc5d5, 0xc5f6, 0xc617, 0x9cd1, 0x2944, 0x2144, 0x0883, 0x0063, 0x31c8, 0x10a4, 0x0001, 0x2103, 0x62ea, 0xbd95, 0xd679, 0xce37, 0xce17, 0xad54, 0x83ee, 0x734c, 0x62ca, 0x5248, 0x62eb, 0x9491, 0xad54, 0xa513, 0x9cd2, 0x8451, 0x7c31, 0x7c10, 0x7c10, 0x7c10, 0x7410, 0x73f0, 0x73f0, 0x73ef, 0x73ef, 0x73ef, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6baf, 0x6bcf, 0x6bcf, 0x6bcf, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73cf, 0x73f0, 0x73f0, 0x7410, 0x7c10, 0x7c10, 
0xa4f4, 0x9cd3, 0x9cb3, 0x9492, 0x8c51, 0x8c31, 0x8430, 0x8410, 0x8410, 0x83f0, 0x83f0, 0x7bf0, 0x7bef, 0x7bf0, 0x7bf0, 0x83f0, 0x8410, 0x8410, 0x8410, 0x8410, 0x8410, 0x8431, 0x8c51, 0x8c71, 0x8c72, 0x9492, 0x94b3, 0x9cd3, 0x9cf4, 0x9cf4, 0x9cf4, 0x9cf4, 0xad54, 0x8c2f, 0x630b, 0x62ea, 0x83cd, 0x9cb1, 0x9c91, 0x8c0e, 0xb574, 0xce16, 0xce37, 0xc5f6, 0x8c30, 0x39a5, 0x1061, 0x1081, 0x0001, 0x0021, 0x0862, 0x18e3, 0x0840, 0x3985, 0xad12, 0xce16, 0xde38, 0xc575, 0xbd54, 0xbd95, 0xbd95, 0xcdf6, 0xce37, 0xcdf7, 0x8430, 0x0861, 0x2124, 0x1904, 0x0021, 0x0000, 0x0000, 0x08a3, 0x2903, 0x732c, 0xbdb5, 0xde99, 0xce37, 0xc5d6, 0xb554, 0x9c91, 0xa4d1, 0x83ee, 0x5248, 0x4207, 0x7bcf, 0xa514, 0x9cf3, 0x8cb3, 0x8472, 0x8472, 0x8472, 0x8452, 0x8451, 0x8431, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c11, 0x7c11, 0x7c10, 0x7c10, 0x7c10, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7c10, 0x7c10, 0x7c10, 0x7c30, 0x7c30, 0x7c30, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 
0x9cf4, 0x9cd3, 0x9cb3, 0x9492, 0x8c51, 0x8c31, 0x8430, 0x8410, 0x8410, 0x83f0, 0x83f0, 0x7bf0, 0x7bef, 0x7bef, 0x7bf0, 0x7bf0, 0x8410, 0x8410, 0x7bf0, 0x7bf0, 0x8410, 0x8410, 0x8430, 0x8431, 0x8c51, 0x8c72, 0x94b2, 0x9cd3, 0x9cd3, 0x9cd3, 0x94d3, 0x94b3, 0x7bce, 0x630b, 0x5aca, 0x7b8d, 0x9450, 0x9c91, 0x9c91, 0x9c90, 0xa4b1, 0xbd94, 0xce37, 0xce57, 0xa513, 0x5aaa, 0x20e3, 0x0840, 0x0021, 0x0041, 0x0861, 0x18c3, 0x0840, 0x3164, 0xa4f2, 0xde78, 0xcdb5, 0xbd54, 0xc595, 0xc5b5, 0xb533, 0xb533, 0xc5d6, 0xce16, 0x736d, 0x1082, 0x18c3, 0x1082, 0x0021, 0x0862, 0x0882, 0x1925, 0x3144, 0x8c0f, 0xc5f6, 0xce37, 0xc5f6, 0xad33, 0x9cb1, 0xa4d2, 0xb554, 0x9c91, 0x736c, 0x5aaa, 0x6b4c, 0x8c71, 0x9cf3, 0x94b3, 0x8c93, 0x8c92, 0x8c92, 0x8c72, 0x8472, 0x8472, 0x8452, 0x8452, 0x8451, 0x8451, 0x8451, 0x8431, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 
0x9cf4, 0x9cd3, 0x94b3, 0x9492, 0x8c51, 0x8c31, 0x8410, 0x8410, 0x8410, 0x83f0, 0x7bf0, 0x7bef, 0x7bef, 0x7bef, 0x7bf0, 0x7bf0, 0x8410, 0x8410, 0x7bf0, 0x7bef, 0x7bf0, 0x7bf0, 0x8410, 0x8410, 0x8451, 0x8c71, 0x9492, 0x94b3, 0x94d3, 0x94b3, 0x9492, 0x8c92, 0x5aea, 0x5aaa, 0x738d, 0x9c91, 0xa4b1, 0x9c90, 0x9c90, 0x9c70, 0x944f, 0x9c90, 0xad12, 0xbdb5, 0xce17, 0xa513, 0x5aaa, 0x2123, 0x18c3, 0x2966, 0x4a69, 0x736d, 0x6b0b, 0x6aea, 0xa4d1, 0xc5b5, 0xbd54, 0xb4f2, 0xbd33, 0xbd74, 0xacf2, 0xacd2, 0xbd74, 0xc5b5, 0x9cb2, 0x7bce, 0x7bae, 0x4a28, 0x18c3, 0x0861, 0x10a2, 0x2986, 0x734c, 0xb574, 0xce17, 0xb574, 0xad13, 0xa4b1, 0x9cb1, 0xb533, 0xb533, 0xa4f2, 0x9c91, 0x7bae, 0x630b, 0x7bcf, 0x94b3, 0x8c92, 0x94b3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8c93, 0x8c92, 0x8c92, 0x8c72, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8452, 0x8452, 0x8452, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8471, 0x8471, 0x8471, 0x8471, 0x8471, 0x8472, 0x8472, 0x8472, 0x8492, 0x8492, 0x8492, 0x8492, 0x8492, 
0x9cf3, 0x9cd3, 0x94b2, 0x9472, 0x8c51, 0x8431, 0x8410, 0x8410, 0x83f0, 0x83f0, 0x7bf0, 0x7bef, 0x7bcf, 0x7bef, 0x7bef, 0x7bf0, 0x7bf0, 0x7bf0, 0x7bef, 0x7bef, 0x7bf0, 0x8410, 0x8410, 0x8430, 0x8451, 0x8c51, 0x8c72, 0x9492, 0x94b2, 0x94b2, 0x94b2, 0x9492, 0x6b6c, 0x73ad, 0x9491, 0xad13, 0xa4d2, 0xa4d1, 0xa4d1, 0x9c70, 0x7b8c, 0x83cd, 0x8c2f, 0x942f, 0xad12, 0xbdb5, 0xb594, 0xb575, 0xa534, 0xb595, 0xbdf6, 0xd658, 0xc5b6, 0xad13, 0xbd94, 0xc5b5, 0xbd12, 0xacd1, 0xbd33, 0xc574, 0xb4f2, 0xa4b1, 0xb512, 0xbd74, 0xc5d6, 0xe6da, 0xdeda, 0xb575, 0x8c30, 0x736d, 0x7bef, 0x94b2, 0xc5d5, 0xc5f6, 0xb574, 0x9470, 0x83ee, 0x9c91, 0xb533, 0xb553, 0xa4d1, 0xad13, 0xb554, 0x9492, 0x7bce, 0x8430, 0x94d3, 0x8c72, 0x94d3, 0x94d3, 0x94b3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8c93, 0x8c93, 0x8c93, 0x8c92, 0x8c92, 0x8c92, 0x8c72, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8492, 0x8492, 0x8492, 0x8492, 0x8492, 0x8cb2, 0x8cb2, 0x8cb2, 0x8cb2, 0x8cb2, 
0x9cd3, 0x9cd3, 0x9492, 0x9472, 0x8c51, 0x8430, 0x8410, 0x8410, 0x83f0, 0x83f0, 0x7bef, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x7bef, 0x7bf0, 0x7bef, 0x7bef, 0x7bef, 0x7bf0, 0x8410, 0x8431, 0x8c51, 0x8c51, 0x8c51, 0x8c71, 0x8c72, 0x9492, 0x94b3, 0x9cd3, 0x9cf3, 0x8c50, 0x8c50, 0xa4d2, 0xb554, 0xa4f2, 0xa4d2, 0xa4f2, 0x9c90, 0x940e, 0x940e, 0x83cd, 0x734b, 0x83ee, 0xa4d2, 0xb554, 0xc5f6, 0xc617, 0xd678, 0xd658, 0xce17, 0xc5b5, 0xb533, 0xacd2, 0xa471, 0x9c0e, 0xacb1, 0xcd94, 0xcdb5, 0xb4f1, 0x940e, 0x942e, 0xacb1, 0xacf2, 0xd637, 0xde78, 0xde78, 0xde99, 0xd678, 0xd658, 0xd679, 0xb554, 0xa4b1, 0x944f, 0x83cd, 0x83ad, 0xa4b1, 0xbd94, 0xb513, 0xad13, 0xbd95, 0xb595, 0xa4f3, 0x94b2, 0x9cd3, 0x9cf4, 0x94b3, 0x94d3, 0x94d3, 0x94b3, 0x94b3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8c93, 0x8c93, 0x8c93, 0x8c92, 0x8c92, 0x8c72, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 
0x9cd3, 0x9cb3, 0x9492, 0x8c72, 0x8c51, 0x8410, 0x8410, 0x83f0, 0x83f0, 0x7bf0, 0x7bef, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x7bef, 0x7bef, 0x7bef, 0x7bef, 0x7bf0, 0x8410, 0x8431, 0x8c51, 0x8451, 0x8451, 0x8c51, 0x8c51, 0x8c72, 0x94b2, 0x9cd3, 0x9cf4, 0x9cb2, 0x8c2f, 0x9c91, 0xb574, 0xad33, 0x9470, 0x8c2f, 0x8c0e, 0x9c4f, 0x8bed, 0x732b, 0x6aea, 0x734b, 0x7b8d, 0x7b8c, 0x7bad, 0x840e, 0xa512, 0xbd94, 0xbd94, 0xbd74, 0xacf2, 0x838d, 0x5a48, 0x7b0a, 0x9c0e, 0xb4d1, 0xbd12, 0xac90, 0x838c, 0x72e9, 0x7309, 0x9c6f, 0xc594, 0xc5b5, 0xc5b5, 0xb554, 0x9c91, 0x83ee, 0x7b6c, 0x734b, 0x7b6c, 0x83ad, 0x940f, 0xa4b1, 0xb533, 0xb533, 0xacf2, 0xb553, 0xb574, 0xa4f3, 0x9471, 0x94b2, 0x9cd3, 0x94b3, 0x94d3, 0x94d3, 0x94d3, 0x94b3, 0x94b3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8c93, 0x8c93, 0x8c93, 0x8c92, 0x8c92, 0x8c72, 0x8c72, 0x8472, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 
0x9cd3, 0x9cb3, 0x9492, 0x8c71, 0x8c31, 0x8410, 0x8410, 0x83f0, 0x83f0, 0x7bf0, 0x7bef, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x7bef, 0x7bcf, 0x7bcf, 0x7bef, 0x8410, 0x8410, 0x8430, 0x8410, 0x8410, 0x8430, 0x8431, 0x8c51, 0x8c72, 0x9492, 0x94b3, 0x9cd2, 0x842f, 0x8c30, 0xa4d2, 0x9cb1, 0x83ee, 0x7b8d, 0x83ad, 0x942e, 0x942f, 0x83cd, 0x732b, 0x62a9, 0x5227, 0x62ea, 0x8c0e, 0x9c90, 0xad32, 0xbd73, 0xad12, 0xb533, 0xacd2, 0x7b2b, 0x4985, 0x7ac9, 0x93cd, 0xa42e, 0xa44e, 0xa46f, 0x8bac, 0x6aa8, 0x6287, 0xa490, 0xbd73, 0xc5b4, 0xc574, 0xa490, 0x8bee, 0x7b4b, 0x6aea, 0x62a9, 0x6aea, 0x838c, 0x9c6f, 0xacf2, 0xacf1, 0x9c70, 0x942f, 0x944f, 0x9450, 0x8c30, 0x8c30, 0x8c71, 0x8c92, 0x8c92, 0x8c92, 0x94d3, 0x94d3, 0x94d3, 0x94d3, 0x94b3, 0x94b3, 0x94b3, 0x94b3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8c93, 0x8c93, 0x8c92, 0x8c92, 0x8c92, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 
0x9cd3, 0x9cb3, 0x9492, 0x8c71, 0x8c31, 0x8410, 0x83f0, 0x83f0, 0x83f0, 0x7bf0, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x7bef, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x7bf0, 0x8410, 0x7bf0, 0x7bf0, 0x8410, 0x8410, 0x8431, 0x8c51, 0x8c51, 0x8c71, 0x9cd2, 0x8c50, 0x7bce, 0x7bad, 0x7bad, 0x7bad, 0x83ee, 0x8c2f, 0xa490, 0xa4b0, 0xa490, 0x9c70, 0x83cd, 0x6b0a, 0x7b8d, 0xa4b1, 0xb573, 0xbdb3, 0xbd93, 0xb532, 0xc5b5, 0xd5d6, 0x9c2f, 0x6a69, 0x830a, 0xac4f, 0xac8f, 0xa44e, 0xac8f, 0x9c0d, 0x838b, 0x8bcc, 0xcd94, 0xcdb4, 0xcdb4, 0xcdd5, 0xc574, 0xc594, 0xacf2, 0x8c0e, 0x838c, 0x6aea, 0x7b4b, 0x940e, 0x942f, 0x940e, 0x83ad, 0x730a, 0x6b0a, 0x732c, 0x83ee, 0x9471, 0x9492, 0x9492, 0x94b2, 0x8c92, 0x94d4, 0x94d3, 0x94d3, 0x94d3, 0x94d3, 0x94d3, 0x94d3, 0x94d3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8c93, 0x8c93, 0x8c93, 0x8c93, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x9493, 0x9493, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 
0x9cb3, 0x9c93, 0x9472, 0x8c31, 0x8c10, 0x83ef, 0x83ef, 0x83ef, 0x83ef, 0x7bef, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x83f0, 0x7bf0, 0x7bef, 0x7bef, 0x7c10, 0x8430, 0x8451, 0x8c71, 0x9cf3, 0x9cb2, 0x9470, 0x8c2f, 0x944f, 0x9c90, 0xacd1, 0xacf2, 0xad12, 0xb533, 0xb553, 0xb553, 0xb553, 0xb574, 0xbd94, 0xc5b5, 0xc5d6, 0xb554, 0x8c0f, 0x9450, 0xc5d6, 0xde78, 0xacd2, 0x5207, 0x5a48, 0x836d, 0x9c50, 0x940f, 0x9c70, 0x7b4c, 0x5a47, 0xa4b1, 0xe699, 0xcdb6, 0xb513, 0xb533, 0xc5b5, 0xcdf6, 0xc5d5, 0xbdb4, 0xbd74, 0xad12, 0xa4f2, 0xb533, 0xb533, 0xa4d2, 0x9cb1, 0xa4d1, 0x7bae, 0x7bae, 0x8c51, 0x9cf3, 0x9cd3, 0x94b3, 0x8cb3, 0x8c93, 0x94b3, 0x94b3, 0x94b3, 0x8cb3, 0x8cb3, 0x8cb3, 0x8c93, 0x8c93, 0x8c93, 0x8c93, 0x8c93, 0x8c93, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c72, 0x8c72, 0x8c72, 0x8472, 0x8472, 0x8451, 0x8451, 0x8451, 0x8472, 0x8472, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c72, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 
0x9cb3, 0x9c93, 0x9472, 0x8c31, 0x8c10, 0x83ef, 0x83ef, 0x83ef, 0x83ef, 0x7bef, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x73af, 0x73af, 0x7bcf, 0x7bcf, 0x7c10, 0x8430, 0x8451, 0x8471, 0x94b2, 0x9cd2, 0x9cd2, 0x9cb1, 0x9470, 0x944f, 0x9c70, 0xa490, 0xa4d1, 0xad33, 0xbd74, 0xbdb5, 0xc5d5, 0xc5f6, 0xd637, 0xde78, 0xe6da, 0xd658, 0xb534, 0xa4d2, 0xbd74, 0xd637, 0x942f, 0x1840, 0x28c2, 0x4165, 0x5a69, 0x5a28, 0x5207, 0x49a5, 0x49c5, 0x942f, 0xcdf7, 0xbd34, 0xacd2, 0xb533, 0xc5f6, 0xd657, 0xd657, 0xce37, 0xcdf6, 0xc5d5, 0xbdb5, 0xc5b5, 0xbd94, 0xad33, 0xad13, 0xb553, 0x9cb2, 0x9471, 0x9491, 0x94b2, 0x8c72, 0x8c72, 0x8cb3, 0x8cb3, 0x8c93, 0x8c93, 0x8c93, 0x8c93, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c72, 0x8c72, 0x8472, 0x8472, 0x8472, 0x8472, 0x8c92, 0x8c92, 0x8c92, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8472, 0x8472, 0x8c92, 0x8c92, 0x8c92, 
0x9c93, 0x9492, 0x9472, 0x8c31, 0x8410, 0x83ef, 0x83ef, 0x83ef, 0x7bef, 0x7bef, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7baf, 0x73af, 0x7bcf, 0x7bcf, 0x7bef, 0x7bef, 0x7bef, 0x7bef, 0x7bef, 0x8c50, 0x9cb2, 0x9cb1, 0x944f, 0x8c0e, 0x942f, 0x9c90, 0xad12, 0xbd94, 0xcdf6, 0xce37, 0xce37, 0xd637, 0xde78, 0xe6b9, 0xe6da, 0xd678, 0xcdf6, 0xc5d5, 0xcdf6, 0xde78, 0xacf2, 0x3102, 0x0800, 0x1820, 0x3964, 0x4164, 0x3103, 0x3964, 0x6268, 0xa4b1, 0xde78, 0xcdd6, 0xbd74, 0xc5d5, 0xd678, 0xe6b9, 0xdeb9, 0xde98, 0xd657, 0xd657, 0xd637, 0xcdf6, 0xbdb5, 0xb574, 0xb554, 0xb574, 0xa513, 0x9cb2, 0x94b2, 0x94b2, 0x8c72, 0x8472, 0x8c93, 0x8493, 0x8c92, 0x8c92, 0x8c92, 0x8c92, 0x8c72, 0x8c72, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8452, 0x8452, 0x8452, 0x8452, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x8471, 0x8471, 0x8472, 0x8472, 0x8472, 
0x9c93, 0x9472, 0x9451, 0x8c30, 0x8410, 0x83ef, 0x83ef, 0x83ef, 0x7bef, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7baf, 0x7bcf, 0x7bcf, 0x73af, 0x73ae, 0x73ae, 0x6bae, 0x6bae, 0x73ae, 0x7bef, 0x8c50, 0x9491, 0x9cb1, 0x9470, 0x9450, 0xa4d1, 0xb553, 0xbd94, 0xc5d5, 0xce16, 0xd637, 0xd657, 0xd657, 0xde78, 0xde98, 0xe6d9, 0xce16, 0xbd95, 0xc5d5, 0xc5d5, 0xd616, 0xd616, 0x9c6f, 0x4185, 0x28a1, 0x2081, 0x2061, 0x3103, 0x6aa9, 0xa470, 0xde57, 0xcdf6, 0xc594, 0xbd74, 0xc5d5, 0xd657, 0xdeb9, 0xdeb9, 0xd678, 0xd637, 0xd658, 0xd657, 0xcdf6, 0xc5d5, 0xc5b5, 0xbd95, 0xb554, 0x9471, 0x8c71, 0x8c71, 0x8c92, 0x8cb2, 0x8cb3, 0x8c93, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x8451, 0x8451, 0x8451, 0x8451, 0x8451, 0x7c51, 0x7c51, 0x7c51, 0x7c31, 0x7c31, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c10, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c31, 0x7c31, 0x7c31, 0x7c51, 0x8451, 0x8451, 0x8451, 0x8451, 
0x9c93, 0x9472, 0x9451, 0x8c30, 0x83f0, 0x83ef, 0x83cf, 0x83cf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7baf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7baf, 0x7baf, 0x738e, 0x738e, 0x738e, 0x6b6e, 0x6b8e, 0x6bae, 0x73ae, 0x73cf, 0x7c0f, 0x8410, 0x8c50, 0x9471, 0x9470, 0x9450, 0xa4d1, 0xb553, 0xb574, 0xbd74, 0xbdb5, 0xc5f6, 0xce37, 0xd657, 0xde78, 0xde78, 0xe6fa, 0xdeb9, 0xd658, 0xe6b9, 0xde98, 0xcdf5, 0xcdd5, 0xc594, 0x9c50, 0x6289, 0x28c2, 0x28c1, 0x6288, 0xa46f, 0xc574, 0xde57, 0xe698, 0xde77, 0xd657, 0xde77, 0xdeb9, 0xe6d9, 0xde99, 0xd658, 0xde78, 0xde78, 0xd637, 0xc5f6, 0xc5d5, 0xc5b5, 0xb553, 0xa4b1, 0x842f, 0x8430, 0x8430, 0x8430, 0x8471, 0x8492, 0x8472, 0x8472, 0x7c51, 0x7c51, 0x7c51, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c31, 0x7c10, 0x7c10, 0x7c10, 0x7410, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c10, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c30, 0x7c10, 0x7c10, 0x7c30, 0x7c30, 0x7c30, 
0x9492, 0x9472, 0x8c51, 0x8c10, 0x83f0, 0x83cf, 0x83cf, 0x7bce, 0x7bcf, 0x7bcf, 0x7bcf, 0x7baf, 0x7baf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x7bf0, 0x7bef, 0x7bcf, 0x7baf, 0x7baf, 0x7baf, 0x73ae, 0x738e, 0x6b6e, 0x6b6d, 0x6b8e, 0x6bae, 0x73ae, 0x6b8e, 0x6b8e, 0x7bcf, 0x8430, 0x8c2f, 0x8c0f, 0x9450, 0xa4b1, 0xad12, 0xad12, 0xb553, 0xbd94, 0xc5f6, 0xce37, 0xd637, 0xd657, 0xd658, 0xd678, 0xc5d5, 0xc5b5, 0xbd94, 0xacf1, 0xa4b0, 0xa4b0, 0xac91, 0x93ce, 0x6268, 0x6268, 0x93ee, 0xacd1, 0xb4f2, 0xc573, 0xbd72, 0xbd93, 0xc5b4, 0xcdf5, 0xd677, 0xdeb9, 0xde99, 0xd678, 0xce37, 0xcdf6, 0xbdb5, 0xb574, 0xb554, 0xb533, 0x9cb1, 0x8c0f, 0x842f, 0x8c50, 0x8430, 0x7c10, 0x7c51, 0x8451, 0x7c31, 0x7c51, 0x7c31, 0x7c31, 0x7c31, 0x7431, 0x7431, 0x7431, 0x7430, 0x7430, 0x7430, 0x7430, 0x7430, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7410, 0x7430, 0x7430, 
0x9492, 0x9472, 0x8c51, 0x8c10, 0x83ef, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7baf, 0x7bae, 0x7baf, 0x7baf, 0x7bcf, 0x7bcf, 0x7bef, 0x7bf0, 0x83f0, 0x83f0, 0x83f0, 0x7bcf, 0x7bcf, 0x7baf, 0x7bcf, 0x7bcf, 0x73ae, 0x738e, 0x6b6e, 0x6b8e, 0x6b8e, 0x6b8e, 0x6b6e, 0x6bae, 0x8410, 0x8c71, 0x8c50, 0x83ee, 0x83ee, 0x9470, 0x9cb1, 0xa4f2, 0xb553, 0xbd74, 0xbd94, 0xc5b5, 0xc5f6, 0xce16, 0xce16, 0xd678, 0xce36, 0xce36, 0xce16, 0xbd73, 0xad11, 0x9c6f, 0x8bad, 0x93ce, 0x834c, 0x7b2b, 0x8bad, 0x9c2e, 0xacb0, 0xc553, 0xc5b3, 0xcdd4, 0xce15, 0xd636, 0xd677, 0xde99, 0xd678, 0xce38, 0xb574, 0xb533, 0xacf2, 0xa4d1, 0xa4d1, 0x9cb1, 0x9450, 0x8c0e, 0x7bef, 0x8c50, 0x8c71, 0x8451, 0x8492, 0x8492, 0x7c72, 0x7c72, 0x8492, 0x8472, 0x8472, 0x8472, 0x8472, 0x8472, 0x7c72, 0x7c72, 0x8472, 0x8472, 0x8472, 0x8472, 0x7c72, 0x7c72, 0x7c71, 0x7c71, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c31, 0x7c31, 0x7c31, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c51, 0x7c71, 0x7c71, 0x8471, 0x8472, 0x8472, 
0x9472, 0x9472, 0x8c51, 0x8c10, 0x83ef, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7baf, 0x7baf, 0x7bae, 0x7baf, 0x7baf, 0x7bcf, 0x7bcf, 0x7bf0, 0x83f0, 0x83f0, 0x8410, 0x83f0, 0x7bef, 0x7bcf, 0x7baf, 0x738e, 0x73ae, 0x73ae, 0x738e, 0x73ae, 0x6bae, 0x6bae, 0x6bae, 0x73cf, 0x7bef, 0x8451, 0x8c71, 0x7bee, 0x6b2c, 0x6b4b, 0x7bad, 0x8c2f, 0x9cb1, 0xb553, 0xbd94, 0xbd94, 0xbd94, 0xc5d5, 0xce37, 0xce36, 0xce16, 0xc5d5, 0xc5d5, 0xbd94, 0xb532, 0xb511, 0xa490, 0xa430, 0xa470, 0x93ee, 0x93cd, 0x9c0e, 0xa44f, 0xb4d1, 0xbd12, 0xbd72, 0xc5b3, 0xcdf4, 0xce15, 0xce36, 0xd637, 0xce17, 0xc5b6, 0xbdb5, 0xbd74, 0xad33, 0xa4d1, 0x9c70, 0x942f, 0x8c0e, 0x83ee, 0x73ce, 0x8450, 0x8c71, 0x8471, 0x8cd3, 0x8cf4, 0x8cd3, 0x8cf4, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cd3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cd3, 0x8cf3, 0x8cf3, 0x8cf3, 0x8cf3, 
0x9472, 0x9452, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7baf, 0x7baf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x83d0, 0x83f0, 0x8410, 0x83f0, 0x83f0, 0x7bef, 0x7bef, 0x7bf0, 0x73cf, 0x73cf, 0x73cf, 0x73ef, 0x73f0, 0x7c10, 0x7c30, 0x7c31, 0x7c51, 0x8492, 0x94d3, 0x94f3, 0x8430, 0x6b4c, 0x6b0b, 0x736c, 0x8c2f, 0x9450, 0x8c2f, 0x9470, 0xad33, 0xbd95, 0xbd95, 0xc5d6, 0xcdf5, 0xcdf5, 0xce16, 0xcdf5, 0xc5d5, 0xbd73, 0xacf1, 0xa4b0, 0xb48f, 0xbcd1, 0xc532, 0xbd11, 0xacb0, 0xa46f, 0xacb0, 0xb4f1, 0xbdb4, 0xc5f5, 0xce36, 0xce36, 0xc616, 0xc5d5, 0xc5d5, 0xc5f6, 0xb574, 0xbd95, 0xbdb5, 0xad13, 0x83ee, 0x6b0b, 0x6b4c, 0x83ce, 0x840f, 0x8430, 0x8430, 0x8451, 0x8cb2, 0x94f4, 0x9d35, 0x9d56, 0xa596, 0xa596, 0xa5b6, 0xa596, 0xa596, 0xa596, 0xa596, 0xa596, 0xa5b7, 0xa5b7, 0xa5b7, 0xa5b7, 0xa5b7, 0xa5b7, 0xa5b7, 0xa5b7, 0xa596, 0xa596, 0xa596, 0xa596, 0xa596, 0xa596, 0xa596, 0xa596, 0xa597, 0xa597, 0xa597, 0xa597, 0xa597, 0xa597, 0xa597, 0xa597, 0xa5b7, 0xa5b7, 0xa5b7, 0xa5b7, 0xa5b7, 
0x9472, 0x9452, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x83d0, 0x83f0, 0x8410, 0x83f0, 0x83f0, 0x7bf0, 0x7bf0, 0x8410, 0x7bd0, 0x7bf0, 0x7bf0, 0x7c10, 0x7c51, 0x8471, 0x8492, 0x8cb2, 0x8492, 0x84b2, 0x8cb2, 0x8c91, 0x7bef, 0x6b2b, 0x62ea, 0x6b2b, 0x6b0b, 0x6b2b, 0x6b2b, 0x83ce, 0xad13, 0xbdb5, 0xbdb5, 0xbdb5, 0xc5d5, 0xc5d5, 0xc5d5, 0xc5d5, 0xc5d5, 0xc5d5, 0xc5b4, 0xbd94, 0xbd12, 0xc552, 0xc573, 0xc573, 0xc573, 0xc593, 0xc5b4, 0xcdd4, 0xce36, 0xce36, 0xce36, 0xc616, 0xc5f5, 0xc5f6, 0xc5f6, 0xc5f6, 0xce17, 0xb554, 0x9cb2, 0x9470, 0x7bae, 0x62ea, 0x62eb, 0x7b8d, 0x83ef, 0x7c0f, 0x7bef, 0x8451, 0x94f4, 0xa576, 0xa597, 0xadd8, 0xadd7, 0xadf7, 0xb5f8, 0xb5f8, 0xadf8, 0xadf7, 0xadf7, 0xb5f8, 0xadf8, 0xadf8, 0xadf8, 0xadf8, 0xadf8, 0xadf8, 0xadf8, 0xadf8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 0xb5f8, 
0x9472, 0x9452, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x83ef, 0x83f0, 0x83f0, 0x8410, 0x83f0, 0x83f0, 0x8410, 0x8410, 0x8430, 0x8411, 0x8431, 0x8451, 0x8472, 0x8cb2, 0x8cd3, 0x94f3, 0x9514, 0x8cf3, 0x94f3, 0x94d3, 0x8c91, 0x7c0f, 0x736d, 0x6b0b, 0x62ca, 0x41e6, 0x5268, 0x630b, 0x840f, 0xad13, 0xbdb5, 0xbdb5, 0xbdb5, 0xc5b4, 0xc5b4, 0xc5b4, 0xc5b5, 0xc5d5, 0xce16, 0xce16, 0xd636, 0xcdf5, 0xcdd5, 0xcdd4, 0xcdd5, 0xce15, 0xce36, 0xce36, 0xce36, 0xce56, 0xce36, 0xce16, 0xc5f6, 0xc5f5, 0xc5d5, 0xbd95, 0xb574, 0xad34, 0x9cd2, 0x8c0f, 0x736d, 0x6b2c, 0x6b4c, 0x736d, 0x7bad, 0x83ef, 0x7bce, 0x6b6d, 0x7bef, 0x94f3, 0xad96, 0xb5f8, 0xbe39, 0xbe39, 0xbe59, 0xbe7a, 0xbe7a, 0xbe79, 0xbe59, 0xbe79, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe79, 0xbe79, 0xbe79, 0xbe79, 0xbe79, 0xbe79, 0xbe79, 0xbe79, 0xbe5a, 0xbe5a, 0xbe5a, 0xbe5a, 0xbe5a, 0xbe5a, 0xbe5a, 0xbe5a, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe7a, 0xbe7a, 
0x9472, 0x9452, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x83ef, 0x83f0, 0x83f0, 0x83f0, 0x8410, 0x8410, 0x8410, 0x8430, 0x8451, 0x8c71, 0x8c92, 0x8c92, 0x94b3, 0x94d3, 0x94f4, 0x9d14, 0x9d35, 0x9d55, 0x9d55, 0x9d55, 0x9d34, 0x94f3, 0x9491, 0x840f, 0x736c, 0x62ca, 0x39c6, 0x5a89, 0x7b8d, 0x9450, 0x9cb1, 0x9cd2, 0xa4f2, 0xad13, 0xad12, 0xb533, 0xb573, 0xbdb4, 0xc5d5, 0xce16, 0xce16, 0xce16, 0xd657, 0xd636, 0xce36, 0xce36, 0xce56, 0xce56, 0xce36, 0xc636, 0xc616, 0xce16, 0xc616, 0xc5f6, 0xc5d5, 0xbd94, 0xa4f2, 0x9470, 0x7bad, 0x8c0f, 0x83ee, 0x6b2b, 0x62ca, 0x6b4c, 0x7bae, 0x83ce, 0x840f, 0x7bae, 0x632c, 0x632c, 0x8431, 0xa555, 0xb5d8, 0xbe39, 0xc67a, 0xce9a, 0xcebb, 0xcedb, 0xcebb, 0xcebb, 0xcebb, 0xcedb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcebb, 0xcedb, 0xcedb, 0xcedb, 0xcedb, 0xcedb, 
0x9472, 0x9452, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x83ef, 0x8410, 0x8410, 0x83f0, 0x8410, 0x8431, 0x8431, 0x8451, 0x8c71, 0x8c92, 0x94b2, 0x94d3, 0x9cd4, 0x9cf4, 0x9d34, 0xa555, 0xa576, 0xa596, 0xa596, 0xa5b6, 0xa5b6, 0xa575, 0x9d13, 0x9cf2, 0x9491, 0x83ee, 0x6b2b, 0x5248, 0x5aa9, 0x6b2b, 0x7b8d, 0x83ce, 0x83ee, 0x8c0f, 0x8c2f, 0x9470, 0x9cb0, 0xa4f2, 0xb553, 0xbd94, 0xc5d5, 0xc5f5, 0xc5f6, 0xce36, 0xce57, 0xd657, 0xce77, 0xce57, 0xc636, 0xc636, 0xc636, 0xbdb4, 0xbdb4, 0xb573, 0xa512, 0xa4d1, 0x9c91, 0x8c0f, 0x7b8d, 0x736d, 0x7b8d, 0x736d, 0x6b0b, 0x5a89, 0x5a89, 0x6b0b, 0x7b8d, 0x8c30, 0x83ef, 0x6b2c, 0x52ab, 0x6b6e, 0x94d4, 0xb5d8, 0xbe5a, 0xce9a, 0xcebb, 0xd6dc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 0xd6fc, 
0x9472, 0x9452, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x83f0, 0x8410, 0x8410, 0x8430, 0x8c31, 0x8c51, 0x8c51, 0x8c72, 0x8c92, 0x94d3, 0x9cf3, 0x9cf4, 0x9d14, 0xa535, 0xa576, 0xadb6, 0xb5d7, 0xb5f7, 0xb5f8, 0xb618, 0xadd7, 0xa575, 0x9d13, 0x9cd2, 0x9cb1, 0x8c2f, 0x7bad, 0x6b0b, 0x5aa9, 0x4a48, 0x5a89, 0x736c, 0x8c0f, 0x9450, 0x9470, 0x9c90, 0x9cb1, 0x9cb1, 0xa4d1, 0xa4f2, 0xad33, 0xb574, 0xbdb5, 0xc5d5, 0xc5f6, 0xce16, 0xc616, 0xbdd5, 0xb594, 0xad74, 0xad74, 0xad32, 0xa4f2, 0x8c4f, 0x7b8c, 0x6b2b, 0x734c, 0x6b4c, 0x6b0b, 0x7bce, 0x7b8d, 0x6b0b, 0x5268, 0x4a28, 0x5269, 0x62ea, 0x6b2b, 0x9450, 0x9451, 0x7bce, 0x5acb, 0x5b0c, 0x8cb3, 0xbe19, 0xce9b, 0xcebb, 0xd6db, 0xd6fc, 0xdf1c, 0xdf1d, 0xdf1c, 0xdf1d, 0xdf1d, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1d, 0xdf1d, 0xdf1d, 0xdf1d, 0xdf1d, 0xdf1d, 0xdf1d, 0xdf1d, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf3c, 0xdf3c, 0xdf3c, 0xdf3c, 0xdf3c, 
0x9472, 0x9452, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bef, 0x8410, 0x8410, 0x8430, 0x8c51, 0x8c51, 0x8c71, 0x8c92, 0x94b2, 0x94d3, 0x9d14, 0x9d54, 0xa535, 0xa555, 0xad96, 0xb5d7, 0xb5f8, 0xbe18, 0xbe38, 0xbe39, 0xbe59, 0xb618, 0xad96, 0xa534, 0x9cf3, 0x9cb2, 0x9470, 0x8c0e, 0x7bad, 0x734c, 0x5a89, 0x5268, 0x734c, 0x840f, 0x9470, 0xa4d2, 0xa4d2, 0xa4d2, 0x9cd1, 0x9cb1, 0x9cb1, 0xa4d2, 0xad33, 0xb554, 0xbd74, 0xbd95, 0xbd95, 0xbd74, 0xb553, 0xad13, 0xa4f2, 0xa4f2, 0xa4f2, 0x9cd1, 0x8c2f, 0x736c, 0x62ea, 0x6b2b, 0x734c, 0x6b2c, 0x83ce, 0x7b8d, 0x62ca, 0x4a07, 0x4a27, 0x62eb, 0x7b8d, 0x7bad, 0x9471, 0x9cb2, 0x9471, 0x736e, 0x62ec, 0x8452, 0xbe19, 0xcebb, 0xd6bb, 0xd6fc, 0xdf1d, 0xe73d, 0xe75d, 0xe73d, 0xe73d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 0xe75d, 
0x9472, 0x9452, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x7bce, 0x7bce, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x83ef, 0x8410, 0x8410, 0x8430, 0x8c51, 0x8c71, 0x8c92, 0x8c92, 0x94d3, 0x9cf3, 0x9d34, 0xa575, 0xad96, 0xb5b7, 0xb5d7, 0xb5f8, 0xbe18, 0xbe38, 0xbe39, 0xbe39, 0xbe59, 0xb638, 0xb5d7, 0xad95, 0xad54, 0x9cf2, 0x9470, 0x8c2f, 0x8c2f, 0x9450, 0x7bad, 0x6b0b, 0x6b0b, 0x6b2b, 0x7b8d, 0x9470, 0x9cd1, 0x9cd1, 0x9cd1, 0x9cd1, 0x9cd1, 0xa4f2, 0xad33, 0xb574, 0xbd54, 0xb554, 0xb534, 0xb554, 0xb554, 0xb554, 0xad54, 0xad33, 0xad33, 0xb574, 0xad33, 0x9470, 0x8c0f, 0x8c0f, 0x8c0f, 0x83ef, 0x8c0f, 0x736d, 0x62ca, 0x5a89, 0x5a89, 0x630b, 0x83ce, 0x9c91, 0x9c91, 0xa4d3, 0xa4f3, 0x83f0, 0x630c, 0x7c10, 0xb5d8, 0xce7b, 0xd6dc, 0xdf1c, 0xe73d, 0xe75e, 0xe77e, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 
0x9472, 0x9471, 0x8c51, 0x8c10, 0x83f0, 0x83cf, 0x7bcf, 0x7baf, 0x7bcf, 0x7bcf, 0x83ef, 0x8410, 0x8410, 0x8430, 0x8451, 0x8c71, 0x8c91, 0x9492, 0x94d2, 0x9cf3, 0x9d13, 0xa534, 0xad75, 0xb596, 0xb5f7, 0xbdf8, 0xbe18, 0xc659, 0xc679, 0xce7a, 0xce7a, 0xce7a, 0xc679, 0xb5d7, 0xad95, 0xa534, 0xa4f3, 0xa4f3, 0x9c91, 0x9cb2, 0x8c2f, 0x7bac, 0x7bad, 0x8c2e, 0x736c, 0x4a06, 0x4a06, 0x6b0a, 0x8c0f, 0x8c0f, 0x9c71, 0xa4b2, 0x9c71, 0x9c91, 0xa4d2, 0xa4b2, 0x9cb1, 0xb595, 0xbdd5, 0xb594, 0xb594, 0xad33, 0xa513, 0xbdb5, 0xb574, 0xbd95, 0xad33, 0x9cb1, 0x9cd2, 0xa4d2, 0x9491, 0x9450, 0x732c, 0x6b0b, 0x5aaa, 0x62ca, 0x7bad, 0x840f, 0x8c2f, 0x8c70, 0xa534, 0x9cf3, 0xa513, 0x8c50, 0x6b4c, 0x630c, 0x8c51, 0xc639, 0xcebb, 0xd6db, 0xdf3d, 0xe75d, 0xef7d, 0xef7d, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0x9472, 0x9471, 0x8c51, 0x8c10, 0x83f0, 0x83cf, 0x7bcf, 0x7bcf, 0x7bcf, 0x83ef, 0x83f0, 0x8410, 0x8430, 0x8450, 0x8c71, 0x8c92, 0x94b2, 0x94d3, 0x9cf3, 0x9d14, 0xa534, 0xad75, 0xb596, 0xb5d6, 0xbdf8, 0xbe18, 0xc639, 0xc659, 0xce7a, 0xce9a, 0xce9a, 0xce9a, 0xceba, 0xbe38, 0xad96, 0x94b2, 0x8430, 0x9471, 0x9c91, 0xa4f3, 0x9c90, 0x7b8c, 0x7b8c, 0x9470, 0x944f, 0x6b0a, 0x5a88, 0x6b0a, 0x8bef, 0x7b8d, 0x83ae, 0x83ae, 0x7b8d, 0x83ce, 0x8c0f, 0x8bef, 0x9491, 0xa513, 0x9cd1, 0x8c2f, 0x8c50, 0x8c50, 0x8c50, 0x9cd1, 0xad13, 0xad13, 0x9c91, 0x8c2f, 0x9470, 0x9470, 0x83ce, 0x6b2b, 0x62aa, 0x6aeb, 0x6b0b, 0x734c, 0x83ee, 0x8c50, 0x9491, 0xa4f3, 0xad95, 0xad54, 0xa534, 0x8c50, 0x630b, 0x4a69, 0x738e, 0xb5b7, 0xce9a, 0xd6fb, 0xe75d, 0xef7e, 0xef9e, 0xef9e, 0xf7be, 0xf7be, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0x9472, 0x9471, 0x8c51, 0x8c10, 0x83f0, 0x83ef, 0x83cf, 0x7bcf, 0x7bcf, 0x83ef, 0x8410, 0x8430, 0x8430, 0x8c71, 0x8c92, 0x94b2, 0x9cf3, 0x9d13, 0xa534, 0xad55, 0xad75, 0xb5b6, 0xbdd7, 0xbdf7, 0xbe38, 0xc638, 0xc679, 0xce9a, 0xce9a, 0xceba, 0xd6ba, 0xceba, 0xc679, 0xc659, 0xb5d7, 0x8c71, 0x7bef, 0x8c70, 0x9c91, 0xa4d2, 0xa4d1, 0x83ee, 0x7bad, 0x9490, 0xa512, 0x9c90, 0x8c0e, 0x83ee, 0x9c71, 0x83ce, 0x7b8d, 0x6b2b, 0x62ca, 0x732c, 0x83ee, 0x83ce, 0x9cb1, 0xa4f2, 0x8c50, 0x738d, 0x738c, 0x736c, 0x630a, 0x5aca, 0x83ee, 0x8c2f, 0x83ce, 0x736c, 0x7bad, 0x83ce, 0x6b2b, 0x5268, 0x5228, 0x6aeb, 0x7b8d, 0x83ce, 0x83ef, 0x8c2f, 0x9cb1, 0xad33, 0xad74, 0xa534, 0x9cf3, 0x7bef, 0x528a, 0x31a6, 0x528a, 0x9cf3, 0xc679, 0xd6fb, 0xe75d, 0xef9e, 0xf7bf, 0xf7be, 0xf7be, 0xf7de, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 
0x9471, 0x9451, 0x8c31, 0x8c10, 0x83f0, 0x83ef, 0x83cf, 0x7bcf, 0x7bcf, 0x83ef, 0x8410, 0x8430, 0x8c51, 0x8c91, 0x94b2, 0x94d3, 0xa514, 0xa534, 0xad75, 0xad96, 0xb5b6, 0xbdd7, 0xbe17, 0xc638, 0xc659, 0xc659, 0xce79, 0xd6ba, 0xd6ba, 0xd6da, 0xd6da, 0xd6da, 0xc699, 0xc679, 0xb5d7, 0x8430, 0x73ae, 0x9471, 0x9cb2, 0x9cb2, 0x9cd2, 0x9490, 0x840e, 0x83ee, 0x9470, 0xad33, 0xb594, 0xad53, 0xb554, 0x9cb1, 0x9470, 0x83ce, 0x734c, 0x83ce, 0xa4b2, 0xa4d2, 0xad54, 0xb595, 0xad33, 0x8c50, 0x8c2f, 0x738d, 0x4a47, 0x2923, 0x5268, 0x6b2b, 0x6b2b, 0x62ca, 0x630b, 0x6b2b, 0x62ca, 0x5268, 0x5228, 0x6b0b, 0x83ce, 0x83ef, 0x83ef, 0x8c2f, 0x9cb2, 0xad34, 0xad54, 0xa533, 0x94b2, 0x73ae, 0x52aa, 0x3186, 0x39e7, 0x8431, 0xbe18, 0xcedb, 0xe75d, 0xef9e, 0xf7df, 0xf7df, 0xf7be, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x9471, 0x9451, 0x8c31, 0x8c10, 0x83f0, 0x83cf, 0x83cf, 0x7bcf, 0x83ef, 0x83f0, 0x8430, 0x8c51, 0x8c71, 0x94b2, 0x94d3, 0x9d13, 0xa534, 0xad55, 0xad95, 0xb5b6, 0xbdd7, 0xbdf7, 0xc638, 0xc658, 0xce79, 0xce79, 0xd69a, 0xd6ba, 0xdedb, 0xdedb, 0xdedb, 0xdedb, 0xd6db, 0xce9a, 0xb5b6, 0x73ae, 0x62eb, 0x7bce, 0x9450, 0x9c91, 0x9cd1, 0xa4f2, 0x9cb1, 0x83ee, 0x7bce, 0x9491, 0xad54, 0xb595, 0xb574, 0xb554, 0xb554, 0xad13, 0x9cb1, 0xad33, 0xc5f6, 0xc5f6, 0xc5f6, 0xce58, 0xce37, 0xbdb5, 0xad54, 0x9cb1, 0x6b2b, 0x41e6, 0x4a07, 0x62ea, 0x6b2b, 0x62ea, 0x630b, 0x6b2b, 0x6b2b, 0x6b2b, 0x6b2c, 0x7b8d, 0x8c0f, 0x8c2f, 0x8c30, 0x9c91, 0xa533, 0xad54, 0xad74, 0x9cf3, 0x8430, 0x632c, 0x4a69, 0x2945, 0x2104, 0x5aec, 0xadb6, 0xce9a, 0xdf3d, 0xef7e, 0xf7df, 0xf7df, 0xf7be, 0xf7de, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x8c51, 0x8c31, 0x8c30, 0x8410, 0x83ef, 0x83cf, 0x7bcf, 0x7bcf, 0x83ef, 0x8410, 0x8c30, 0x8c71, 0x9492, 0x94d3, 0x9d13, 0xa534, 0xa555, 0xad75, 0xb5b6, 0xbdd7, 0xbdf7, 0xc618, 0xc658, 0xce59, 0xce79, 0xd699, 0xd6ba, 0xdeda, 0xdedb, 0xdedb, 0xdedb, 0xdedb, 0xce9a, 0xc679, 0xad96, 0x73ce, 0x52aa, 0x5aea, 0x6b2c, 0x7b8d, 0x8c50, 0x9cd2, 0xad34, 0xa533, 0x94b1, 0x8c50, 0x9470, 0x9cd2, 0xa513, 0xad53, 0xb574, 0xb595, 0xbdb5, 0xce37, 0xd678, 0xce37, 0xce37, 0xd698, 0xd678, 0xce37, 0xc617, 0xc5f6, 0xad33, 0x8c50, 0x7bad, 0x9450, 0x9470, 0x8c2f, 0x9450, 0x9470, 0x9470, 0x9470, 0xa4d2, 0xa4d2, 0x9cb2, 0x9471, 0x9471, 0xa4f2, 0xad54, 0xa533, 0xb595, 0x9d13, 0x7bef, 0x5aca, 0x4228, 0x2104, 0x1082, 0x39c7, 0xa555, 0xc679, 0xdf1c, 0xe75d, 0xf7be, 0xf7df, 0xf7be, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x8c31, 0x8c30, 0x8c10, 0x83f0, 0x83cf, 0x7bcf, 0x7bcf, 0x7baf, 0x83ef, 0x8410, 0x8c51, 0x8c71, 0x94b2, 0x9cf3, 0xa534, 0xa555, 0xad75, 0xad96, 0xb5d7, 0xbdf7, 0xc618, 0xc638, 0xce59, 0xce79, 0xd699, 0xd699, 0xd6ba, 0xdeda, 0xdefa, 0xdefb, 0xdefa, 0xdefa, 0xc659, 0xbe17, 0xad75, 0x7c0f, 0x5aca, 0x5269, 0x4a28, 0x5a89, 0x6b6c, 0x7bce, 0x94b1, 0xad54, 0xad54, 0x9cd2, 0x8c70, 0x9491, 0xa4f2, 0xad54, 0xad54, 0xad53, 0xb595, 0xc5f6, 0xc637, 0xc617, 0xce37, 0xd678, 0xd678, 0xce58, 0xce37, 0xce37, 0xce37, 0xc5f6, 0xbd95, 0xc5d6, 0xbdb5, 0xbd95, 0xbdb5, 0xbd95, 0xb574, 0xb595, 0xc5b6, 0xb554, 0xa4f2, 0x9471, 0x9450, 0x9cd2, 0xa533, 0x9cd2, 0xad74, 0x9cf2, 0x7bce, 0x5289, 0x4207, 0x2124, 0x18c3, 0x39c7, 0x9d14, 0xc659, 0xd6fc, 0xdf3c, 0xf7be, 0xf7df, 0xf7be, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x8c31, 0x8c30, 0x8410, 0x83ef, 0x83cf, 0x7bcf, 0x7baf, 0x7baf, 0x83ef, 0x8410, 0x8c51, 0x9492, 0x94b2, 0x9cf3, 0xa534, 0xad75, 0xad75, 0xb5b6, 0xbdf7, 0xc618, 0xc638, 0xce59, 0xce79, 0xce9a, 0xd699, 0xd699, 0xd6ba, 0xdeda, 0xdeda, 0xdeda, 0xdeda, 0xdeda, 0xceba, 0xb5f7, 0x9d14, 0x7bce, 0x5aaa, 0x4a48, 0x4a07, 0x5a89, 0x4a69, 0x52aa, 0x632c, 0x7bee, 0x94b2, 0xa513, 0xa513, 0x9cd2, 0xad54, 0xbdb5, 0xad74, 0x9cd2, 0xa4f2, 0xad54, 0xbdb5, 0xc5f6, 0xc617, 0xce58, 0xd698, 0xce58, 0xc617, 0xc5f6, 0xc617, 0xce37, 0xd658, 0xd678, 0xce37, 0xce37, 0xce37, 0xc5f6, 0xbdb5, 0xbdd6, 0xb554, 0xa4f3, 0x9c71, 0x8c0f, 0x8c0f, 0x9cb2, 0xa533, 0x9cd2, 0x8c50, 0x7bee, 0x5aeb, 0x31a6, 0x2124, 0x18c3, 0x1082, 0x3186, 0x9514, 0xc659, 0xd6fc, 0xdf1c, 0xf7be, 0xf7df, 0xf7be, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x83ef, 0x83ef, 0x83ef, 0x7bef, 0x7bcf, 0x7bcf, 0x7bef, 0x7bef, 0x7c10, 0x8431, 0x8c72, 0x94b3, 0x94d3, 0x9d14, 0xa555, 0xad76, 0xb5b6, 0xb5d7, 0xbdf8, 0xbe18, 0xc638, 0xc659, 0xce79, 0xce7a, 0xd69a, 0xd6ba, 0xd6bb, 0xd6db, 0xdedb, 0xdedb, 0xdedb, 0xdedb, 0xc659, 0xb5b7, 0xad76, 0x6b4d, 0x41e7, 0x5269, 0x4a28, 0x5269, 0x4a27, 0x39c6, 0x39a5, 0x5288, 0x7bcd, 0x9470, 0x7bce, 0x62ea, 0x736c, 0x840f, 0xa4f2, 0xad33, 0x9cb1, 0x9cb1, 0xad33, 0xb574, 0xb595, 0xc5f6, 0xd678, 0xd699, 0xce57, 0xbdd6, 0xc5f6, 0xce37, 0xd678, 0xce37, 0xce57, 0xd678, 0xce58, 0xc617, 0xbdb5, 0xad33, 0x9491, 0x8c50, 0x8c70, 0x94b2, 0x9cf3, 0xa534, 0x9cd3, 0x8430, 0x6b4d, 0x4228, 0x2944, 0x2104, 0x18c2, 0x0840, 0x10a2, 0x3186, 0x94b3, 0xce7a, 0xce9a, 0xd6db, 0xef9e, 0xef9e, 0xf7df, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x7bcf, 0x73cf, 0x7bcf, 0x7bef, 0x7c10, 0x8451, 0x8c72, 0x94b3, 0x9cf3, 0x9d14, 0xa555, 0xad96, 0xb5b6, 0xb5d7, 0xbe18, 0xc638, 0xc639, 0xc659, 0xce79, 0xce9a, 0xd69a, 0xd6ba, 0xd6bb, 0xd6bb, 0xdedb, 0xdedb, 0xdedb, 0xdedb, 0xd6db, 0xc639, 0xb5d7, 0x73ae, 0x528a, 0x6b2c, 0x62ca, 0x5aa9, 0x5269, 0x4a48, 0x41e6, 0x39c6, 0x41c6, 0x41e6, 0x39a5, 0x2944, 0x2944, 0x4a27, 0x736c, 0x83ee, 0x8c2f, 0xa4f2, 0xb595, 0xbdb5, 0xbdd5, 0xc5f6, 0xce37, 0xd678, 0xd678, 0xce37, 0xce37, 0xce58, 0xdeb9, 0xd678, 0xce58, 0xc617, 0xbdb5, 0xb574, 0xad54, 0xa4f2, 0x94b1, 0x94b1, 0xa513, 0xad54, 0xad54, 0xa534, 0x9471, 0x738e, 0x5aeb, 0x4207, 0x2945, 0x2104, 0x18e3, 0x18c3, 0x2965, 0x4228, 0x8451, 0xbe39, 0xce7a, 0xd6bb, 0xe75d, 0xef7e, 0xf7bf, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x738e, 0x7bae, 0x73ae, 0x73ae, 0x73ae, 0x73ae, 0x73cf, 0x73cf, 0x7c10, 0x8451, 0x8c92, 0x94d3, 0x9cf4, 0xa535, 0xad76, 0xadb7, 0xb5d7, 0xb5f7, 0xbe18, 0xc639, 0xc659, 0xc659, 0xce7a, 0xce9a, 0xce9a, 0xd6ba, 0xd6bb, 0xd6bb, 0xd6db, 0xd6db, 0xd6db, 0xd6db, 0xce9b, 0xbdf8, 0xad76, 0x6b6d, 0x52aa, 0x736d, 0x62ca, 0x4a07, 0x5aca, 0x630b, 0x6b2c, 0x5aca, 0x4a07, 0x3185, 0x3165, 0x3185, 0x4a48, 0x630b, 0x7bce, 0x83ee, 0x840f, 0xa4f2, 0xbdb5, 0xc5f6, 0xc617, 0xc617, 0xc617, 0xce58, 0xd698, 0xd678, 0xd678, 0xd678, 0xd699, 0xd678, 0xce58, 0xbdb5, 0xad33, 0xad33, 0xad54, 0xad33, 0xa533, 0xad74, 0xb5b5, 0xad75, 0x94b2, 0x840f, 0x6b4c, 0x4a69, 0x4207, 0x39a6, 0x3185, 0x3185, 0x39a6, 0x4207, 0x4a48, 0x5289, 0x632d, 0xad76, 0xc67a, 0xcebb, 0xdf1c, 0xe75d, 0xef9e, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x736e, 0x738e, 0x738e, 0x738e, 0x738e, 0x73ae, 0x73cf, 0x73ef, 0x7c31, 0x8452, 0x8c93, 0x94d4, 0x9d15, 0xa556, 0xad97, 0xb5b7, 0xb5d7, 0xb5f8, 0xbe38, 0xc659, 0xc659, 0xc679, 0xc67a, 0xce9a, 0xce9a, 0xd6ba, 0xd6bb, 0xd6bb, 0xd6bb, 0xd6bb, 0xd6bb, 0xd6bb, 0xce9b, 0xb5f8, 0xa555, 0x73af, 0x632c, 0x7bcf, 0x62ea, 0x41c6, 0x3985, 0x4a07, 0x630b, 0x7bce, 0x840f, 0x83ef, 0x840f, 0x9471, 0x9cb1, 0xad33, 0xb574, 0xad33, 0x9cb1, 0xa4f2, 0xbdb5, 0xce57, 0xd678, 0xce57, 0xce37, 0xce58, 0xd699, 0xd699, 0xd699, 0xd678, 0xce58, 0xce58, 0xce37, 0xbdb5, 0xad54, 0xbdb5, 0xc5f6, 0xbdb5, 0xad54, 0xad54, 0xa513, 0x840f, 0x62eb, 0x4a69, 0x4208, 0x3186, 0x10a2, 0x20e3, 0x2965, 0x41e7, 0x52aa, 0x630c, 0x5aaa, 0x4228, 0x3a08, 0x8c92, 0xc659, 0xd6db, 0xdf1c, 0xe77e, 0xef9e, 0xf7bf, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x6b4d, 0x6b6e, 0x6b8e, 0x738e, 0x73ae, 0x73af, 0x73ef, 0x7c10, 0x7c51, 0x8472, 0x8cb3, 0x94f4, 0x9d35, 0xa576, 0xadb7, 0xb5d8, 0xb5f7, 0xb618, 0xbe39, 0xbe59, 0xc659, 0xc679, 0xc69a, 0xce9a, 0xce9a, 0xce9a, 0xcebb, 0xd6bb, 0xd6bb, 0xd6bb, 0xcebb, 0xcebb, 0xcebb, 0xbdf8, 0xad76, 0x8410, 0x738e, 0x83ef, 0x62ca, 0x39a6, 0x18c2, 0x1081, 0x2103, 0x4a28, 0x6b4c, 0x840f, 0x9cd2, 0xb595, 0xb574, 0xb574, 0xb595, 0xbdb5, 0xb574, 0xad54, 0xbdd5, 0xd678, 0xd699, 0xd699, 0xd698, 0xd678, 0xd698, 0xd699, 0xd698, 0xd678, 0xc617, 0xc616, 0xbdd6, 0xad54, 0xa4f2, 0xa513, 0xa4f2, 0x9470, 0x840e, 0x73ad, 0x630b, 0x4227, 0x31a6, 0x41e7, 0x4a28, 0x39e7, 0x2104, 0x2965, 0x39e7, 0x52aa, 0x738d, 0x7bae, 0x5aca, 0x3186, 0x2986, 0x7bf0, 0xc639, 0xd6db, 0xdefc, 0xe75d, 0xef9e, 0xf7bf, 0xf7df, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x6b2d, 0x6b4e, 0x6b6e, 0x6b8e, 0x6baf, 0x73cf, 0x73f0, 0x7c10, 0x8452, 0x8472, 0x8cb3, 0x94f4, 0x9d35, 0xa576, 0xadb7, 0xb5d8, 0xb5f8, 0xb618, 0xbe39, 0xbe59, 0xc659, 0xc67a, 0xc67a, 0xce9a, 0xce9a, 0xce9b, 0xce9b, 0xcebb, 0xcebb, 0xce9b, 0xce9b, 0xce9b, 0xc67a, 0xb5d8, 0xa555, 0x7bcf, 0x62eb, 0x630b, 0x4a07, 0x2944, 0x18c2, 0x0820, 0x0000, 0x0820, 0x18a2, 0x3185, 0x6b2c, 0x9cb2, 0xbdd6, 0xb594, 0xad33, 0xad54, 0xb595, 0xbdb5, 0xc5f6, 0xd678, 0xd699, 0xdeb9, 0xdeb9, 0xd699, 0xd698, 0xd698, 0xd678, 0xce58, 0xc616, 0xbdd6, 0xb595, 0xa513, 0x9491, 0x8c50, 0x840e, 0x6b4c, 0x630a, 0x4a48, 0x3185, 0x2103, 0x2944, 0x4228, 0x4a69, 0x39c7, 0x39e7, 0x39c6, 0x39e7, 0x5269, 0x632c, 0x6b4c, 0x4a49, 0x2944, 0x2966, 0x6b6e, 0xbdf8, 0xd6bb, 0xd6bb, 0xdf3d, 0xef7e, 0xf7bf, 0xf7de, 0xf7df, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x630d, 0x632d, 0x6b4e, 0x6b6e, 0x6b8e, 0x6baf, 0x73f0, 0x7c10, 0x8472, 0x8493, 0x8cd4, 0x94f5, 0x9d35, 0xa576, 0xadb7, 0xadd8, 0xb5f8, 0xb618, 0xbe39, 0xbe59, 0xbe5a, 0xc67a, 0xc67a, 0xc69a, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xc65a, 0xbdf8, 0xa555, 0x634d, 0x39e7, 0x41e7, 0x3165, 0x20c2, 0x1061, 0x1041, 0x0820, 0x0000, 0x0000, 0x0820, 0x3186, 0x62cb, 0xa513, 0xb574, 0xb574, 0xad33, 0xb574, 0xbdd5, 0xc617, 0xd678, 0xdeb9, 0xdeb9, 0xdeb9, 0xd699, 0xd699, 0xdeb9, 0xd678, 0xce37, 0xc617, 0xc5f6, 0xc617, 0xc5f6, 0xb574, 0xad54, 0xad33, 0xa4f2, 0x9cf2, 0x8c4f, 0x738d, 0x630b, 0x632c, 0x7bae, 0x736d, 0x5269, 0x31a6, 0x2124, 0x18e3, 0x2924, 0x31a6, 0x31a6, 0x2124, 0x18c2, 0x1904, 0x52cb, 0xad96, 0xd6bb, 0xd6db, 0xe73d, 0xe75d, 0xf7bf, 0xf7de, 0xf7de, 0xf7df, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x5b0c, 0x630d, 0x634d, 0x636e, 0x6b8e, 0x6baf, 0x73ef, 0x7410, 0x8472, 0x8c93, 0x8cd4, 0x94f5, 0x9d35, 0xa576, 0xad97, 0xadd8, 0xb5f8, 0xb618, 0xbe39, 0xbe59, 0xbe5a, 0xc65a, 0xc67a, 0xc69a, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xce9b, 0xc69a, 0xbe39, 0xb5f8, 0x9d14, 0x528a, 0x18c3, 0x20e3, 0x20c2, 0x1060, 0x1882, 0x2104, 0x2945, 0x2104, 0x1061, 0x0000, 0x0000, 0x0000, 0x5268, 0x8c50, 0xb574, 0xb574, 0xb595, 0xc5f6, 0xce37, 0xce58, 0xdeb9, 0xdeb9, 0xd699, 0xd699, 0xdeb9, 0xdeda, 0xd678, 0xc5f6, 0xc617, 0xc617, 0xd678, 0xd678, 0xc616, 0xc5f6, 0xc617, 0xce37, 0xc617, 0xb5b5, 0xa533, 0x94b2, 0x94b2, 0xa4f3, 0x9492, 0x738e, 0x4a48, 0x2965, 0x18c3, 0x18c3, 0x18c3, 0x1061, 0x0840, 0x0841, 0x0882, 0x4229, 0xa555, 0xd6db, 0xdf1c, 0xe77e, 0xe75d, 0xef9e, 0xf7de, 0xf7de, 0xf7de, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0x52cc, 0x5aec, 0x5b2d, 0x634d, 0x636e, 0x6b8f, 0x73d0, 0x7bf0, 0x8472, 0x8c93, 0x94d4, 0x9d15, 0x9d35, 0xa576, 0xad97, 0xadb7, 0xb5d8, 0xb5f8, 0xbe19, 0xbe39, 0xbe39, 0xbe59, 0xc65a, 0xc67a, 0xce9a, 0xc67a, 0xc67a, 0xce9a, 0xce9a, 0xce9a, 0xc67a, 0xc659, 0xbe18, 0xc659, 0x94d3, 0x31c7, 0x0881, 0x1081, 0x0840, 0x1081, 0x2124, 0x39c7, 0x52aa, 0x52aa, 0x31a6, 0x10a2, 0x0020, 0x0000, 0x0860, 0x39c6, 0x840e, 0x9cf2, 0xa533, 0xbdf5, 0xce57, 0xd698, 0xce78, 0xd699, 0xd6b9, 0xdeda, 0xdeda, 0xd6b9, 0xd699, 0xce78, 0xc637, 0xc617, 0xce78, 0xd699, 0xc637, 0xc637, 0xc637, 0xbdf6, 0xbdb6, 0xb575, 0xa533, 0x94b2, 0x94b1, 0x9cd2, 0x840f, 0x52a9, 0x39c7, 0x2124, 0x10a2, 0x1082, 0x1082, 0x0861, 0x0841, 0x0841, 0x10a3, 0x3a08, 0x9d14, 0xd6db, 0xd6dc, 0xdf1d, 0xe77e, 0xef9f, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 
0x52cc, 0x52ec, 0x5b0d, 0x634d, 0x636e, 0x6b8f, 0x73d0, 0x7c10, 0x8472, 0x8c93, 0x94d4, 0x9d15, 0x9d35, 0xa556, 0xad97, 0xadb7, 0xb5d8, 0xb5f8, 0xbe19, 0xbe39, 0xbe39, 0xbe59, 0xc65a, 0xc67a, 0xce9a, 0xc67a, 0xc67a, 0xce9a, 0xce9a, 0xce9a, 0xc67a, 0xc659, 0xbe18, 0xbe18, 0x8471, 0x31a6, 0x1082, 0x0861, 0x0860, 0x2103, 0x2945, 0x3165, 0x4207, 0x52aa, 0x5acb, 0x5289, 0x39c6, 0x2124, 0x0860, 0x0840, 0x31a5, 0x6b6c, 0x94b1, 0xb5b4, 0xbdf5, 0xbe16, 0xce78, 0xd699, 0xd6b9, 0xdeda, 0xdeda, 0xd6b9, 0xd699, 0xce78, 0xad54, 0xad74, 0xc617, 0xce78, 0xc637, 0xc637, 0xc637, 0xc617, 0xb595, 0xad54, 0xa513, 0x9491, 0x73ad, 0x5aeb, 0x4227, 0x2944, 0x18c3, 0x10a2, 0x1082, 0x0861, 0x0841, 0x0020, 0x0861, 0x18c3, 0x31a7, 0x4a8a, 0x9d14, 0xcebb, 0xd6dc, 0xdf1d, 0xe77e, 0xefbf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7df, 0xf7df, 0xf7bf, 0xf7df, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 
0x52cb, 0x52ec, 0x5b0d, 0x634d, 0x636e, 0x6baf, 0x73f0, 0x7c10, 0x8472, 0x8c93, 0x94d4, 0x9514, 0x9d35, 0xa556, 0xa596, 0xadb7, 0xb5d7, 0xb5f8, 0xbe18, 0xbe39, 0xbe39, 0xbe39, 0xc659, 0xc67a, 0xc67a, 0xc67a, 0xc67a, 0xce9a, 0xce9a, 0xce9a, 0xc67a, 0xc659, 0xbe18, 0xb5b7, 0x7c10, 0x31c7, 0x2104, 0x18c3, 0x18c2, 0x39e7, 0x630c, 0x4a48, 0x3186, 0x39c7, 0x5aca, 0x738e, 0x7bef, 0x8410, 0x5289, 0x1081, 0x0020, 0x39e6, 0x842f, 0xb594, 0xb5b5, 0xbdd5, 0xce78, 0xce78, 0xd699, 0xd699, 0xd699, 0xce78, 0xce58, 0xc637, 0x94b1, 0xa533, 0xc617, 0xce78, 0xce58, 0xce58, 0xce58, 0xc637, 0xbdb6, 0xb595, 0xa534, 0x83ef, 0x4227, 0x18e3, 0x1081, 0x0861, 0x0020, 0x0020, 0x0020, 0x0000, 0x0000, 0x0000, 0x18c3, 0x3186, 0x5aec, 0x632d, 0x9d14, 0xc65a, 0xcebb, 0xd6fc, 0xdf1d, 0xe77e, 0xef9e, 0xef9e, 0xefbf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7df, 0xf7df, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7df, 0xf7df, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 
0x52cb, 0x52ec, 0x5b0d, 0x634d, 0x6b6e, 0x6baf, 0x73f0, 0x7c31, 0x8472, 0x8c93, 0x94d4, 0x9d15, 0x9d35, 0xa556, 0xa596, 0xadb7, 0xadd7, 0xb5f7, 0xbe18, 0xbe38, 0xbe39, 0xbe59, 0xc659, 0xc679, 0xc67a, 0xc67a, 0xc67a, 0xce9a, 0xce9a, 0xce9a, 0xc67a, 0xc659, 0xbe18, 0xb5d7, 0x8451, 0x4228, 0x31c6, 0x39c6, 0x39e7, 0x630b, 0x73ae, 0x630b, 0x4228, 0x39e7, 0x5269, 0x6b4d, 0x8430, 0xa513, 0x9491, 0x4a28, 0x0840, 0x18e2, 0x73ad, 0xad53, 0xad74, 0xc616, 0xce58, 0xce58, 0xce78, 0xce78, 0xce58, 0xc637, 0xc617, 0xbdf6, 0x9cd2, 0xad54, 0xc617, 0xce78, 0xc637, 0xc637, 0xc637, 0xbdf6, 0xc617, 0xa513, 0x7bce, 0x4a48, 0x18c2, 0x1061, 0x18c2, 0x2103, 0x2965, 0x2965, 0x2104, 0x10a2, 0x10a2, 0x2965, 0x4a69, 0x6b4d, 0x6b8e, 0x6b6d, 0x94b3, 0xb5f8, 0xc67a, 0xcebb, 0xd6fc, 0xe75e, 0xef9e, 0xef9e, 0xef9e, 0xefbf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7be, 0xf7be, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 
0x52ec, 0x5b0c, 0x5b2d, 0x636e, 0x6b8f, 0x73cf, 0x7c10, 0x8431, 0x8492, 0x8cb3, 0x94f4, 0x9d14, 0x9d35, 0xa556, 0xa596, 0xadb7, 0xadd7, 0xb5f7, 0xb618, 0xbe38, 0xbe38, 0xbe39, 0xc659, 0xc679, 0xc67a, 0xc67a, 0xc67a, 0xce9a, 0xce9a, 0xce9a, 0xc679, 0xc659, 0xbdf8, 0xbdf8, 0x8cb2, 0x4a69, 0x31a6, 0x39e7, 0x4a48, 0x6b6d, 0x630c, 0x632c, 0x5aca, 0x4a69, 0x4a69, 0x5aca, 0x738d, 0x8c50, 0xa513, 0x840f, 0x39e7, 0x2944, 0x73ad, 0xad54, 0xad54, 0xc637, 0xce58, 0xce58, 0xce58, 0xce58, 0xc637, 0xc617, 0xbdf6, 0xbdd6, 0x9cf2, 0xad54, 0xbdf6, 0xc637, 0xbdf6, 0xbdf6, 0xc617, 0xb5b5, 0xad54, 0x632c, 0x2944, 0x18a2, 0x18e3, 0x3185, 0x4227, 0x4a69, 0x6b6d, 0x6b4d, 0x630c, 0x52aa, 0x630c, 0x73ae, 0x8c51, 0x9492, 0x6b8e, 0x634d, 0x8472, 0xadb7, 0xc67a, 0xd6dc, 0xd6fd, 0xe77f, 0xe77e, 0xef7e, 0xef9e, 0xef9e, 0xefbf, 0xefbf, 0xefbf, 0xefbf, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 0xf7bf, 
0x5b0c, 0x5b2d, 0x634e, 0x6b8e, 0x6baf, 0x73f0, 0x7c31, 0x8451, 0x8c92, 0x8cd3, 0x94f4, 0x9d34, 0x9d55, 0xa575, 0xad96, 0xadb7, 0xadd7, 0xb5f7, 0xb618, 0xbe38, 0xbe38, 0xbe39, 0xc659, 0xc679, 0xc67a, 0xc67a, 0xc67a, 0xc67a, 0xce9a, 0xce9a, 0xc679, 0xc659, 0xbe18, 0xbe18, 0x94f3, 0x4a69, 0x1903, 0x18c3, 0x2124, 0x4228, 0x5aeb, 0x632c, 0x630c, 0x52aa, 0x52aa, 0x632c, 0x7bce, 0x8c30, 0x8c51, 0x9491, 0x6b4c, 0x4a48, 0x7bce, 0xa533, 0xa533, 0xbdf6, 0xce58, 0xce58, 0xce78, 0xce58, 0xce58, 0xc637, 0xc617, 0xc617, 0xad74, 0xb5b5, 0xc617, 0xc637, 0xbdf6, 0xc617, 0xbdf6, 0xad74, 0x738d, 0x3185, 0x10a2, 0x31a6, 0x5aca, 0x632c, 0x6b4c, 0x6b6d, 0x8410, 0x8c51, 0x8c71, 0x8c71, 0x94b2, 0xa514, 0x9cf3, 0x9492, 0x73af, 0x6b8e, 0x8c92, 0xad97, 0xbe59, 0xce9b, 0xcebc, 0xdf3e, 0xe75d, 0xe75d, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0x5b2d, 0x634e, 0x6b6e, 0x6baf, 0x73cf, 0x7c10, 0x8431, 0x8472, 0x8cb2, 0x94d3, 0x9514, 0x9d34, 0xa555, 0xa576, 0xad96, 0xadb7, 0xadd6, 0xb5f7, 0xb617, 0xbe18, 0xbe38, 0xbe38, 0xbe59, 0xc679, 0xc67a, 0xc67a, 0xc67a, 0xc67a, 0xce9a, 0xc67a, 0xc679, 0xc659, 0xbe18, 0xbdf8, 0xa555, 0x6b6d, 0x31c6, 0x18e3, 0x10a1, 0x2124, 0x5289, 0x632c, 0x6b6d, 0x630c, 0x632c, 0x7bef, 0x9471, 0x8c71, 0x736d, 0x736d, 0x630c, 0x4a69, 0x6b2c, 0x94b1, 0xa533, 0xb5b5, 0xc617, 0xc617, 0xc637, 0xc637, 0xc637, 0xc637, 0xc637, 0xc637, 0xbdf6, 0xc617, 0xc637, 0xc637, 0xbdf6, 0xb5b5, 0xa533, 0x8c50, 0x4a69, 0x4228, 0x5aca, 0x7bef, 0x9471, 0x8c50, 0x7bce, 0x632c, 0x6b6d, 0x8430, 0x94b2, 0x9492, 0x8c71, 0x9492, 0x8c51, 0x7bef, 0x73af, 0x73cf, 0x94d3, 0xa576, 0xb5f8, 0xbe39, 0xc65a, 0xd6dc, 0xdf3d, 0xe73d, 0xe75d, 0xef7e, 0xef9e, 0xef9e, 0xef7e, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 
0x634e, 0x636e, 0x6b8f, 0x73af, 0x73d0, 0x7c10, 0x8451, 0x8472, 0x8cb3, 0x94d3, 0x9d14, 0x9d35, 0xa555, 0xa596, 0xadb6, 0xadd7, 0xadd6, 0xb5d7, 0xb617, 0xbe18, 0xbe38, 0xbe38, 0xbe59, 0xc679, 0xc67a, 0xc67a, 0xc67a, 0xc67a, 0xce9a, 0xc67a, 0xc659, 0xc659, 0xc639, 0xb5d7, 0xb5b6, 0x9cf3, 0x73ae, 0x4a49, 0x3185, 0x39a6, 0x4a49, 0x630b, 0x6b6d, 0x62eb, 0x5aeb, 0x83ef, 0x9cd2, 0x94b2, 0x8430, 0x6b2c, 0x5aeb, 0x5289, 0x5aca, 0x8c50, 0xad74, 0xbdd6, 0xb5b5, 0xb5b5, 0xbdd6, 0xbdf6, 0xc617, 0xc637, 0xc637, 0xc637, 0xc617, 0xc617, 0xc617, 0xbdd6, 0xad74, 0x9cf2, 0x7bee, 0x52a9, 0x4a69, 0x73ae, 0x9cf3, 0xa513, 0x9cd2, 0x94b2, 0x73ae, 0x4228, 0x4228, 0x630c, 0x738e, 0x630c, 0x52aa, 0x5acb, 0x630c, 0x5aeb, 0x632c, 0x6b8e, 0x8c92, 0x9d15, 0xad97, 0xbe19, 0xbe5a, 0xd6fc, 0xdf1c, 0xdf3d, 0xe75d, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x638e, 0x6bae, 0x73cf, 0x73ef, 0x7c10, 0x7c30, 0x8471, 0x8c92, 0x94d3, 0x94f3, 0x9d34, 0x9d54, 0xa555, 0xa575, 0xad96, 0xadb6, 0xb5d7, 0xb5f7, 0xbdf7, 0xbe18, 0xc638, 0xc659, 0xc659, 0xc659, 0xc659, 0xc659, 0xc679, 0xce79, 0xce79, 0xc679, 0xc659, 0xc659, 0xbe18, 0xbdf8, 0xa575, 0x8c71, 0x73ae, 0x5acb, 0x4a48, 0x4a48, 0x52aa, 0x632c, 0x5aeb, 0x4a49, 0x52aa, 0x7bef, 0x8c71, 0x840f, 0x8430, 0x7bce, 0x6b4d, 0x4a69, 0x4228, 0x738e, 0xa534, 0xad55, 0xb5b5, 0xb5d5, 0xb5b5, 0xb5b5, 0xbdd6, 0xc637, 0xc637, 0xbe16, 0xce58, 0xc617, 0xc617, 0xbdf7, 0xad75, 0x94b1, 0x6b4c, 0x39e6, 0x5aeb, 0x8430, 0x94b2, 0x9cf3, 0xa514, 0x94b2, 0x73ae, 0x528a, 0x39c7, 0x4208, 0x4a49, 0x3186, 0x18c3, 0x2104, 0x3186, 0x4a49, 0x52aa, 0x6b8e, 0x6bae, 0x6bae, 0x8cd2, 0xadd7, 0xbe58, 0xc699, 0xd6fc, 0xd71d, 0xdf3d, 0xe77e, 0xe75e, 0xe75d, 0xef7d, 0xe75d, 0xe75d, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x6bae, 0x6bae, 0x73ef, 0x740f, 0x7c30, 0x8451, 0x8491, 0x8cb2, 0x94d3, 0x94f3, 0x9d34, 0xa555, 0xa575, 0xa575, 0xad96, 0xadb6, 0xb5d7, 0xb5f7, 0xbe18, 0xbe18, 0xc638, 0xc659, 0xc659, 0xc659, 0xc659, 0xc659, 0xc679, 0xce79, 0xce79, 0xc679, 0xc659, 0xc659, 0xb5d7, 0xb5d7, 0xad96, 0x8451, 0x5acb, 0x31a6, 0x2944, 0x2944, 0x3185, 0x4208, 0x4a69, 0x5269, 0x5aeb, 0x6b6d, 0x6b4c, 0x52aa, 0x632c, 0x6b4d, 0x6b6d, 0x5289, 0x31a6, 0x5acb, 0x9491, 0xa534, 0xad95, 0xb595, 0xb5b5, 0xb5b5, 0xbdd6, 0xc617, 0xc617, 0xbdf6, 0xbdd6, 0xb5b6, 0xbdd6, 0xbdd6, 0xad75, 0x94d2, 0x738d, 0x4a48, 0x5acb, 0x738e, 0x73ae, 0x8410, 0x8c51, 0x8c51, 0x7bef, 0x630c, 0x39e7, 0x3186, 0x2965, 0x18c3, 0x10a2, 0x18c3, 0x18c3, 0x18e3, 0x31c7, 0x5aeb, 0x6b6d, 0x6bae, 0x8471, 0xa575, 0xb617, 0xc6ba, 0xd6dc, 0xd6fc, 0xdf3d, 0xdf5d, 0xe75e, 0xe75d, 0xef7d, 0xe75d, 0xe75d, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x6bce, 0x73cf, 0x740f, 0x7c30, 0x7c30, 0x8471, 0x8c92, 0x8cd2, 0x94f3, 0x9d14, 0x9d34, 0xa555, 0xa575, 0xad96, 0xadb6, 0xadd6, 0xb5f7, 0xbdf7, 0xbe18, 0xbe38, 0xc638, 0xc659, 0xc659, 0xc659, 0xc659, 0xc659, 0xc679, 0xce79, 0xce79, 0xc679, 0xc659, 0xc659, 0xbe18, 0xbdf8, 0xb5d7, 0x8451, 0x39e7, 0x1081, 0x0881, 0x1081, 0x2124, 0x31a6, 0x4228, 0x4a69, 0x4a49, 0x4207, 0x3185, 0x2104, 0x2965, 0x4a49, 0x632c, 0x5acb, 0x39c6, 0x4228, 0x7bcf, 0xa513, 0xa513, 0xad54, 0xb595, 0xb595, 0xb5b5, 0xbdd6, 0xbdd6, 0xbdd6, 0xa554, 0xa554, 0xad95, 0xb595, 0xad54, 0x94d2, 0x7bce, 0x52aa, 0x5aeb, 0x632c, 0x632c, 0x6b6d, 0x7bef, 0x8c51, 0x8c51, 0x738e, 0x52aa, 0x39e7, 0x2965, 0x18c3, 0x1082, 0x1082, 0x0861, 0x18e3, 0x2986, 0x52ab, 0x634d, 0x634d, 0x73cf, 0x8471, 0x9d55, 0xc699, 0xcebb, 0xd6dc, 0xd6fc, 0xdf1d, 0xe75d, 0xe77e, 0xe75d, 0xe75d, 0xe75d, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x73ef, 0x7bef, 0x7c10, 0x8430, 0x8451, 0x8c92, 0x94b2, 0x94d3, 0x94f3, 0x9d14, 0xa555, 0xa575, 0xa595, 0xad96, 0xadb6, 0xb5d7, 0xb5f7, 0xbdf7, 0xbe18, 0xbe38, 0xc638, 0xc659, 0xc659, 0xc659, 0xc659, 0xc679, 0xce79, 0xce79, 0xce79, 0xc679, 0xc659, 0xc659, 0xbe18, 0xb5b7, 0xad75, 0x7bef, 0x2945, 0x0000, 0x0840, 0x1081, 0x2104, 0x2965, 0x39c7, 0x39a6, 0x2124, 0x10a2, 0x1081, 0x10a2, 0x0841, 0x2124, 0x528a, 0x630c, 0x4a48, 0x39c7, 0x5aeb, 0x9492, 0x9491, 0x9cf2, 0xa554, 0xad74, 0xad74, 0xad74, 0xad95, 0xb595, 0x9cf3, 0x9d13, 0xad54, 0xad54, 0x9cf3, 0x8c70, 0x6b8d, 0x4a89, 0x528a, 0x52aa, 0x52aa, 0x6b4d, 0x7bcf, 0x8c51, 0x8c71, 0x73ae, 0x5aeb, 0x39c7, 0x2104, 0x1082, 0x0861, 0x0861, 0x10a2, 0x39c7, 0x5acb, 0x6b8e, 0x6b6d, 0x5aeb, 0x52eb, 0x5b2c, 0x7c10, 0xa596, 0xbe5a, 0xcebb, 0xd6dc, 0xd6fc, 0xe73d, 0xe77e, 0xe75d, 0xe75d, 0xe75d, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x7c10, 0x7c10, 0x8431, 0x8451, 0x8c71, 0x8c92, 0x94d3, 0x9cf3, 0x9d14, 0x9d34, 0xa555, 0xa595, 0xad96, 0xadb6, 0xb5d7, 0xb5f7, 0xbdf7, 0xbe18, 0xbe18, 0xc638, 0xc659, 0xc659, 0xc659, 0xc659, 0xc679, 0xce79, 0xce79, 0xce9a, 0xce79, 0xc679, 0xc659, 0xc659, 0xbe18, 0xad96, 0xa555, 0x7bef, 0x3186, 0x0861, 0x10a2, 0x18c2, 0x1082, 0x18a2, 0x18c3, 0x18a2, 0x0861, 0x0020, 0x0840, 0x1061, 0x0020, 0x0841, 0x2944, 0x4a69, 0x5289, 0x39c6, 0x4a48, 0x73ae, 0x840f, 0x8c71, 0x9cd2, 0xa513, 0x9cf3, 0x9cf3, 0xa533, 0xad54, 0x9cf3, 0x9cf3, 0xa534, 0x9cf3, 0x8c71, 0x73ae, 0x5aca, 0x39c6, 0x2965, 0x2965, 0x3186, 0x4a49, 0x5aeb, 0x6b4d, 0x6b6d, 0x5acb, 0x4208, 0x18e3, 0x0841, 0x0861, 0x18e3, 0x2124, 0x31a6, 0x632c, 0x8410, 0x8451, 0x738e, 0x52cb, 0x4a69, 0x4269, 0x5b2c, 0x8471, 0xb5d8, 0xc67b, 0xcebb, 0xd6dc, 0xdf3d, 0xe75d, 0xe75d, 0xef7d, 0xe75d, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x7c10, 0x8430, 0x8451, 0x8c71, 0x8c92, 0x94b2, 0x94d3, 0x9cf4, 0x9d14, 0x9d54, 0xa575, 0xad96, 0xadb6, 0xadd6, 0xb5f7, 0xb5f7, 0xbe18, 0xbe18, 0xbe38, 0xc638, 0xc659, 0xc659, 0xc659, 0xc659, 0xce79, 0xce79, 0xce9a, 0xce9a, 0xce9a, 0xc679, 0xc659, 0xc659, 0xc659, 0xad96, 0x9d14, 0x7bef, 0x39e7, 0x1082, 0x0861, 0x0861, 0x0000, 0x0020, 0x0020, 0x0861, 0x1082, 0x1081, 0x0840, 0x0000, 0x0020, 0x0000, 0x0000, 0x2104, 0x4207, 0x39c7, 0x4228, 0x6b4c, 0x7bce, 0x840f, 0x8c71, 0x94b2, 0x94b1, 0x9491, 0x9cd2, 0xa534, 0xa534, 0xa514, 0xa514, 0x94b2, 0x7bef, 0x632c, 0x4208, 0x2104, 0x0861, 0x0861, 0x0861, 0x18e3, 0x2945, 0x2945, 0x2965, 0x2104, 0x2104, 0x10a2, 0x1082, 0x18c3, 0x2124, 0x2124, 0x31a6, 0x6b4d, 0x7baf, 0x7bef, 0x632d, 0x4a8a, 0x4a69, 0x4a8a, 0x5b0c, 0x7c10, 0xa576, 0xc65a, 0xcebb, 0xd6dc, 0xdf3d, 0xe75d, 0xe73d, 0xef7d, 0xe75d, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x8430, 0x8431, 0x8c51, 0x8c72, 0x9492, 0x94b2, 0x9cd3, 0x9cf4, 0x9d34, 0xa555, 0xa575, 0xadb6, 0xadb6, 0xb5d7, 0xb5f7, 0xb617, 0xbe18, 0xbe18, 0xc638, 0xc659, 0xc659, 0xc659, 0xc659, 0xc659, 0xce79, 0xce9a, 0xce9a, 0xce9a, 0xce9a, 0xc679, 0xc659, 0xc659, 0xbdf8, 0xa555, 0x8c71, 0x6b6d, 0x39e7, 0x18c3, 0x1081, 0x18c2, 0x10a2, 0x18c2, 0x18e3, 0x2124, 0x2104, 0x18c2, 0x0841, 0x0000, 0x0000, 0x0000, 0x0000, 0x0020, 0x2124, 0x31a6, 0x4208, 0x630b, 0x73ae, 0x7bcf, 0x8430, 0x8c51, 0x8c51, 0x8c51, 0x94b2, 0xa534, 0xad55, 0xa514, 0x9cf3, 0x9492, 0x73ae, 0x5acb, 0x31a6, 0x1082, 0x0020, 0x0841, 0x0020, 0x1082, 0x1082, 0x0020, 0x0020, 0x0000, 0x10a2, 0x2104, 0x2945, 0x18e3, 0x18c3, 0x1082, 0x18c3, 0x4228, 0x6b4d, 0x736e, 0x5aeb, 0x4229, 0x4229, 0x4a69, 0x52cb, 0x6bae, 0x9515, 0xbe39, 0xcebb, 0xd6dc, 0xdf3d, 0xe73d, 0xe73c, 0xef7d, 0xe75d, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x8431, 0x8451, 0x8c71, 0x8c72, 0x9492, 0x94b3, 0x9cd3, 0x9cf4, 0x9d34, 0xa555, 0xa595, 0xadb6, 0xadb6, 0xb5d7, 0xb5f7, 0xbe18, 0xbe18, 0xbe38, 0xc638, 0xc659, 0xc659, 0xc659, 0xc659, 0xc659, 0xce79, 0xce9a, 0xce9a, 0xce9a, 0xce9a, 0xc679, 0xc659, 0xc659, 0xb5f7, 0xa555, 0x8471, 0x6b6d, 0x52aa, 0x39e7, 0x4207, 0x52aa, 0x4a48, 0x4a69, 0x5289, 0x4228, 0x2945, 0x0861, 0x0000, 0x0000, 0x0020, 0x18e3, 0x10a2, 0x0000, 0x1081, 0x2124, 0x39c6, 0x528a, 0x73ae, 0x73ae, 0x7bef, 0x8430, 0x8c50, 0x8c50, 0x94b2, 0xa534, 0xad55, 0xa514, 0x9cd3, 0x8c71, 0x738e, 0x52ab, 0x3186, 0x0862, 0x0000, 0x0861, 0x0861, 0x18c3, 0x18e3, 0x0861, 0x0841, 0x0861, 0x10a2, 0x2124, 0x2945, 0x18e3, 0x2945, 0x3186, 0x3186, 0x4a49, 0x738e, 0x7bcf, 0x630c, 0x4208, 0x31c7, 0x31c7, 0x3a08, 0x52cb, 0x8cd4, 0xbe19, 0xcebb, 0xd6dc, 0xdf3d, 0xe73d, 0xdf1c, 0xef7d, 0xe75d, 0xe77e, 0xe77e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x8450, 0x8471, 0x8c71, 0x8c91, 0x8c91, 0x94b2, 0x94d2, 0x94f3, 0xa514, 0xa535, 0xad75, 0xad96, 0xb5b6, 0xb5d7, 0xbdf8, 0xc618, 0xc638, 0xc638, 0xc638, 0xc638, 0xc658, 0xce59, 0xce79, 0xce79, 0xce59, 0xce79, 0xce99, 0xce79, 0xce79, 0xce79, 0xce59, 0xc618, 0xb596, 0x9cf3, 0x73ae, 0x630c, 0x6b6d, 0x632c, 0x630c, 0x73ae, 0x8c50, 0x7bef, 0x632c, 0x4a48, 0x2945, 0x0840, 0x0000, 0x1082, 0x4a49, 0x6b6d, 0x738d, 0x528a, 0x18c3, 0x0820, 0x39c7, 0x5acb, 0x73ae, 0x6b8d, 0x6b6d, 0x6b6d, 0x73ce, 0x8471, 0x94b2, 0x94d2, 0x94d3, 0x9d14, 0x8451, 0x73ae, 0x6b8e, 0x5aec, 0x31c7, 0x2145, 0x39c7, 0x52aa, 0x630c, 0x6b4d, 0x6b4d, 0x62ec, 0x528a, 0x39a7, 0x2945, 0x31a6, 0x4208, 0x4249, 0x634d, 0x7c10, 0x73f0, 0x73f0, 0x8c71, 0x7bcf, 0x5acb, 0x4228, 0x39e8, 0x3186, 0x2945, 0x3186, 0x6b6e, 0xa555, 0xce9a, 0xd69b, 0xd6bb, 0xd6fc, 0xdf3d, 0xe75d, 0xef5d, 0xef5d, 0xef7d, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xef9e, 0xef7d, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 
0x8471, 0x8c71, 0x8c71, 0x8c91, 0x8cb2, 0x94b2, 0x94d2, 0x94f3, 0xa534, 0xa534, 0xad75, 0xad96, 0xb5b6, 0xb5d7, 0xbdf7, 0xc618, 0xc638, 0xc638, 0xc638, 0xc658, 0xce58, 0xce59, 0xce79, 0xce79, 0xce79, 0xce9a, 0xd69a, 0xce79, 0xce79, 0xce79, 0xc638, 0xbdf7, 0xad75, 0x8c51, 0x52aa, 0x4228, 0x5aeb, 0x5aeb, 0x528a, 0x52aa, 0x6b4c, 0x632c, 0x52aa, 0x39a6, 0x18c3, 0x1082, 0x39c6, 0x738e, 0x9cd2, 0xad34, 0xad55, 0x94b2, 0x5289, 0x10a2, 0x2924, 0x5aca, 0x632c, 0x5b2c, 0x632c, 0x632c, 0x634c, 0x73ce, 0x8450, 0x8c71, 0x8451, 0x8c92, 0x7bf0, 0x6b6d, 0x632d, 0x4a6a, 0x39e7, 0x4249, 0x8430, 0x9cd3, 0xa514, 0xad55, 0xad55, 0xad35, 0xad34, 0x94b2, 0x738e, 0x73ae, 0x8451, 0x94b3, 0xa535, 0x9d14, 0x8cb3, 0x9d14, 0x8c51, 0x73af, 0x52aa, 0x39e7, 0x31a6, 0x2945, 0x2124, 0x2966, 0x4a6a, 0x7bcf, 0xa515, 0xbdf8, 0xce9a, 0xcebb, 0xd6fb, 0xdf5d, 0xe73d, 0xe75d, 0xef5d, 0xef7e, 0xef7e, 0xef9e, 0xef7e, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x8c71, 0x8c71, 0x8c91, 0x8c91, 0x94b2, 0x94d2, 0x9cd2, 0x9cf3, 0xa534, 0xa554, 0xad75, 0xad96, 0xb5b6, 0xb5d6, 0xbdf7, 0xbe18, 0xc638, 0xc638, 0xc638, 0xc658, 0xce58, 0xce79, 0xce79, 0xce79, 0xce99, 0xd69a, 0xd6ba, 0xce9a, 0xce99, 0xce79, 0xc638, 0xb5d7, 0xa534, 0x7bcf, 0x4a69, 0x4a69, 0x6b4d, 0x632c, 0x4228, 0x39c7, 0x4a28, 0x39e7, 0x2944, 0x18c3, 0x18c3, 0x3186, 0x738d, 0xb596, 0xbdd7, 0xb5b6, 0xbdf7, 0xb5b6, 0x83ef, 0x2945, 0x18a2, 0x5289, 0x630c, 0x5aeb, 0x630b, 0x630c, 0x5aeb, 0x6b4c, 0x7bef, 0x7c0f, 0x7bef, 0x8410, 0x73af, 0x6b4d, 0x5aeb, 0x39c7, 0x39c7, 0x6b4d, 0xad55, 0xbdd7, 0xbdd7, 0xbdf7, 0xbdd7, 0xbdb6, 0xbdd7, 0xad75, 0xad55, 0xad34, 0xa534, 0x9cd3, 0x8c92, 0x8431, 0x8431, 0x94d3, 0x7bef, 0x6b4d, 0x4a69, 0x31a6, 0x2945, 0x2104, 0x2124, 0x3186, 0x39e8, 0x4a6a, 0x6b6e, 0x9cf4, 0xc639, 0xce9a, 0xce9a, 0xdf1c, 0xe73c, 0xe73d, 0xef5d, 0xef7d, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x9491, 0x9492, 0x9492, 0x94b2, 0x94b2, 0x9cd2, 0x9cd3, 0x9cf3, 0xa534, 0xa554, 0xad75, 0xad95, 0xb5b6, 0xb5b6, 0xbdf7, 0xbe17, 0xc638, 0xc638, 0xc638, 0xc658, 0xce59, 0xce79, 0xce79, 0xce79, 0xce79, 0xd69a, 0xd6ba, 0xd69a, 0xce99, 0xce79, 0xbe17, 0xb596, 0x9492, 0x6b4d, 0x4a49, 0x4a69, 0x630c, 0x5acb, 0x4208, 0x3186, 0x2944, 0x2124, 0x2124, 0x3186, 0x4a69, 0x738e, 0x9cf3, 0xc618, 0xc638, 0xbdd7, 0xc5f7, 0xbdd7, 0xa514, 0x5acb, 0x2124, 0x4208, 0x6b6d, 0x632c, 0x632c, 0x630b, 0x52aa, 0x632c, 0x7bce, 0x73ae, 0x6b6d, 0x7bcf, 0x6b6d, 0x632c, 0x5acb, 0x39e7, 0x4a49, 0x8410, 0xb595, 0xc617, 0xbdf7, 0xbdd7, 0xad55, 0x9492, 0x8410, 0x6b4d, 0x840f, 0x8c30, 0x7bef, 0x630c, 0x528a, 0x52ab, 0x634d, 0x7c10, 0x7bcf, 0x6b4d, 0x528a, 0x39e7, 0x2965, 0x2124, 0x2965, 0x39e7, 0x4229, 0x4229, 0x4a8a, 0x73af, 0xa555, 0xbe18, 0xc67a, 0xd6db, 0xdf1c, 0xe73c, 0xef5d, 0xef7d, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x94b2, 0x94b2, 0x94b2, 0x9cd2, 0x9cd2, 0x9cf3, 0x9cf3, 0x9cf3, 0xa533, 0xa554, 0xad75, 0xad95, 0xb595, 0xb5b6, 0xbdd6, 0xbdf7, 0xc618, 0xc638, 0xc638, 0xc658, 0xce58, 0xce79, 0xce79, 0xce99, 0xce79, 0xce99, 0xd69a, 0xce9a, 0xce99, 0xce59, 0xbdd7, 0xad55, 0x8c51, 0x5aeb, 0x4208, 0x4208, 0x528a, 0x5acb, 0x5acb, 0x52aa, 0x39e7, 0x4a69, 0x6b4c, 0x8410, 0x9cb2, 0xad55, 0xbdd6, 0xc617, 0xc638, 0xce58, 0xc638, 0xb5b6, 0xb596, 0x9471, 0x4a69, 0x4207, 0x73ae, 0x6b6d, 0x6b4d, 0x5acb, 0x4a48, 0x52aa, 0x6b4d, 0x632c, 0x5aeb, 0x632c, 0x5acb, 0x528a, 0x528a, 0x4a69, 0x632c, 0x9cd3, 0xbdb6, 0xc638, 0xc638, 0xc638, 0xb595, 0x8c50, 0x632c, 0x4207, 0x39a6, 0x4207, 0x4a28, 0x4228, 0x39e7, 0x4a49, 0x632c, 0x73cf, 0x7bef, 0x6b6d, 0x5acb, 0x4a49, 0x39e7, 0x31a6, 0x39c7, 0x39e8, 0x4a8a, 0x52ab, 0x4a6a, 0x4a8a, 0x73af, 0x9d14, 0xbe18, 0xcebb, 0xdedb, 0xdf1c, 0xe75d, 0xef7d, 0xef7e, 0xef7e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7be, 0xf7be, 0xf7be, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0x9cf3, 0x9cf3, 0x9cf3, 0x9cf3, 0x9cf3, 0xa4f3, 0xa513, 0xa514, 0xa533, 0xa554, 0xad74, 0xad95, 0xb595, 0xb5b6, 0xbdd6, 0xbdf7, 0xbe17, 0xc617, 0xc638, 0xc638, 0xc658, 0xce79, 0xce79, 0xce79, 0xce79, 0xce79, 0xce99, 0xce79, 0xce79, 0xc638, 0xb596, 0x9d13, 0x7bef, 0x52aa, 0x4228, 0x528a, 0x630c, 0x73ae, 0x7bef, 0x7bcf, 0x73ae, 0x7bce, 0x9471, 0xad34, 0xb5b6, 0xbdf7, 0xbdf7, 0xb5b6, 0xb5b6, 0xc638, 0xc618, 0xad75, 0xb5b6, 0xb595, 0x7bef, 0x528a, 0x632c, 0x632c, 0x632c, 0x528a, 0x39c7, 0x41e7, 0x52aa, 0x5aeb, 0x630b, 0x62eb, 0x4a48, 0x31a6, 0x39e7, 0x528a, 0x7bce, 0xa534, 0xb595, 0xbdd6, 0xbdd6, 0xce38, 0xc638, 0xad75, 0x9471, 0x6b6d, 0x39c6, 0x3165, 0x2944, 0x39a6, 0x3186, 0x31a6, 0x5acb, 0x73af, 0x6b6e, 0x5acb, 0x4a69, 0x4a49, 0x4228, 0x4208, 0x4208, 0x39e8, 0x4a6a, 0x5acc, 0x4a8a, 0x31c7, 0x4229, 0x6b8e, 0x9d14, 0xbe59, 0xd69a, 0xdedb, 0xe73c, 0xef5d, 0xef7d, 0xef7d, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0xa513, 0xa513, 0xa4f3, 0xa4f3, 0xa513, 0xa514, 0xa514, 0xa514, 0xa533, 0xa554, 0xad74, 0xad95, 0xb595, 0xb5b5, 0xb5d6, 0xbdf6, 0xbdf7, 0xbe17, 0xc617, 0xc638, 0xc658, 0xce59, 0xce79, 0xce79, 0xce79, 0xce99, 0xce99, 0xce79, 0xce59, 0xbdf7, 0xa554, 0x9492, 0x630c, 0x4208, 0x39e7, 0x52aa, 0x632c, 0x73ae, 0x8410, 0x7bcf, 0x73ae, 0x632c, 0x6b6d, 0x8c71, 0xa513, 0xad54, 0xad75, 0xad54, 0xb5b6, 0xce38, 0xc618, 0xbdd7, 0xc617, 0xc618, 0xa534, 0x73ae, 0x5acb, 0x5aca, 0x5acb, 0x528a, 0x41e7, 0x39a6, 0x4a49, 0x62eb, 0x630c, 0x62eb, 0x4208, 0x2945, 0x3186, 0x5aca, 0x8c30, 0xad54, 0xb5b5, 0xad54, 0x9cd2, 0xad54, 0xbdf6, 0xc617, 0xbdf6, 0xad54, 0x83ef, 0x62eb, 0x4a28, 0x4a48, 0x4228, 0x4228, 0x632c, 0x7bcf, 0x632d, 0x5acb, 0x52aa, 0x52aa, 0x4a69, 0x4a49, 0x4a69, 0x4a69, 0x4a6a, 0x52ab, 0x4a6a, 0x31a7, 0x2966, 0x3a08, 0x6baf, 0xa555, 0xc659, 0xd69a, 0xdefb, 0xe73c, 0xe73d, 0xef5d, 0xef7d, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0xa514, 0xa514, 0xa514, 0xa514, 0xa514, 0xa514, 0xad34, 0xad34, 0xa533, 0xa554, 0xad74, 0xad95, 0xb595, 0xb5b5, 0xb5d6, 0xbdf6, 0xbdf7, 0xbdf7, 0xbe17, 0xc638, 0xc638, 0xce58, 0xce79, 0xce79, 0xce99, 0xd69a, 0xce99, 0xce79, 0xc638, 0xbdd7, 0x9d14, 0x8c51, 0x5acb, 0x31a6, 0x31a6, 0x4a49, 0x528a, 0x632c, 0x7bcf, 0x7bcf, 0x5269, 0x4207, 0x528a, 0x7bce, 0x8430, 0x8430, 0x9471, 0x9cd3, 0xb575, 0xbdd7, 0xb5b6, 0xc617, 0xce58, 0xc638, 0xbdd7, 0x8c71, 0x5acb, 0x528a, 0x5aaa, 0x5acb, 0x5269, 0x41e7, 0x4a49, 0x6b2c, 0x62eb, 0x5aaa, 0x4208, 0x3165, 0x39c6, 0x6b2c, 0x9cb2, 0xbdb6, 0xb5b5, 0x94b2, 0x736d, 0x738d, 0x8c70, 0xa513, 0xb595, 0xad54, 0xb574, 0x9cd2, 0x8c30, 0x8c30, 0x840f, 0x8c50, 0x9cd3, 0x9492, 0x7bef, 0x73ae, 0x73af, 0x6b6e, 0x52ab, 0x4a69, 0x52aa, 0x5acb, 0x528b, 0x4a8a, 0x4229, 0x39e8, 0x2966, 0x2145, 0x4aaa, 0x8492, 0xc618, 0xce59, 0xd6db, 0xdf1c, 0xe71c, 0xe73d, 0xef5d, 0xef7e, 0xef7d, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 
0xb575, 0xb575, 0xb554, 0xad54, 0xad54, 0xad34, 0xad34, 0xad34, 0xad54, 0xad54, 0xad74, 0xad75, 0xb595, 0xb5b5, 0xb5b6, 0xb5d6, 0xbdd7, 0xbdf7, 0xc617, 0xc618, 0xc618, 0xc638, 0xc658, 0xce79, 0xce59, 0xce79, 0xce79, 0xce58, 0xc638, 0xb5b6, 0x9cd2, 0x7bef, 0x5aaa, 0x4207, 0x2965, 0x2944, 0x39a6, 0x5acb, 0x736d, 0x6b4c, 0x4208, 0x4a69, 0x6b4d, 0x5269, 0x2944, 0x52aa, 0x94b2, 0xad34, 0xbdd6, 0xad54, 0xad54, 0xc617, 0xd699, 0xce79, 0xc638, 0xad75, 0x6b6d, 0x4a49, 0x4a49, 0x62eb, 0x5aca, 0x4a49, 0x4a49, 0x4a48, 0x4a48, 0x52aa, 0x4a48, 0x31a5, 0x39e7, 0x738d, 0xa534, 0xbdd6, 0xb595, 0xa534, 0x8c50, 0x738d, 0x632c, 0x632b, 0x7bee, 0xa513, 0x9cd3, 0xa513, 0xa514, 0xa534, 0xb596, 0xc617, 0xb5b6, 0xa534, 0x94b2, 0x94b3, 0x8c51, 0x6b6e, 0x5aec, 0x5aeb, 0x5acb, 0x528a, 0x4a49, 0x4229, 0x4a6a, 0x4a8a, 0x39e8, 0x2986, 0x4a6a, 0x7c10, 0xad75, 0xb5d7, 0xce79, 0xdedb, 0xdf1c, 0xe73c, 0xef5d, 0xef7d, 0xef7d, 0xef7d, 0xef7e, 0xef9e, 0xf79e, 0xef9e, 0xef9e, 0xef7e, 0xf77e, 0xf77e, 0xf77e, 0xf77e, 0xf77e, 
0xb575, 0xb575, 0xb575, 0xb554, 0xad54, 0xad54, 0xad34, 0xad34, 0xad54, 0xad54, 0xad74, 0xad75, 0xad95, 0xb595, 0xb5b6, 0xb5d6, 0xbdd7, 0xbdf7, 0xbe17, 0xc617, 0xc638, 0xc658, 0xce79, 0xce79, 0xce79, 0xce79, 0xce79, 0xce58, 0xc617, 0xad75, 0x8c71, 0x738e, 0x5aca, 0x39e7, 0x2945, 0x2945, 0x39e7, 0x5aeb, 0x738e, 0x6b6d, 0x62eb, 0x5aaa, 0x4a48, 0x2103, 0x2944, 0x8410, 0xbdd6, 0xad54, 0x94b2, 0x9cd2, 0xad54, 0xce58, 0xd6b9, 0xd699, 0xd699, 0xbdf7, 0x8c51, 0x630b, 0x5aaa, 0x630c, 0x5aca, 0x4a48, 0x4228, 0x39e7, 0x4228, 0x4a69, 0x4228, 0x39c6, 0x4a69, 0x840f, 0xad75, 0xbdd6, 0xb595, 0xad54, 0x9491, 0x7bae, 0x6b6d, 0x630b, 0x5289, 0x5289, 0x73ae, 0x8430, 0x9cd3, 0xad55, 0xbdf7, 0xc638, 0xc617, 0xb596, 0x9cf3, 0x9cd3, 0x8c51, 0x73ae, 0x634d, 0x632d, 0x630c, 0x52ab, 0x4a49, 0x4a8a, 0x52ab, 0x4a6a, 0x39c8, 0x39e8, 0x630c, 0x8c72, 0xb596, 0xbdd7, 0xc638, 0xce79, 0xd6ba, 0xdefb, 0xe71c, 0xe75c, 0xe75d, 0xef5d, 0xef5d, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 0xef7d, 
0xb595, 0xb575, 0xb575, 0xb575, 0xb554, 0xad54, 0xad54, 0xad54, 0xad54, 0xad54, 0xad74, 0xad74, 0xad75, 0xb595, 0xb5b5, 0xb5b6, 0xbdd6, 0xbdd7, 0xbdf7, 0xc617, 0xc658, 0xce79, 0xce99, 0xd699, 0xd699, 0xd699, 0xce79, 0xce58, 0xbdf7, 0xad54, 0x8430, 0x6b4d, 0x52aa, 0x39e7, 0x2945, 0x2965, 0x39e7, 0x52aa, 0x6b4d, 0x738e, 0x8410, 0x840f, 0x6b2c, 0x4a48, 0x6b4d, 0xb596, 0xbdb6, 0x8430, 0x83ef, 0x9cb2, 0xb5b6, 0xce79, 0xd699, 0xd699, 0xce79, 0xc617, 0xad54, 0x7bef, 0x632c, 0x6b4c, 0x5aeb, 0x5269, 0x4a49, 0x4208, 0x4207, 0x4228, 0x39c6, 0x3185, 0x5269, 0x8430, 0xad54, 0xb595, 0xbdd6, 0xb595, 0x94b2, 0x840f, 0x8c50, 0x9cd2, 0x9cb2, 0x9471, 0x9cd3, 0xad54, 0xbdd7, 0xc638, 0xce58, 0xc618, 0xb5b6, 0xad75, 0xa535, 0x9d14, 0x8c72, 0x7bef, 0x738e, 0x6b6d, 0x630c, 0x52aa, 0x528b, 0x5b0c, 0x630c, 0x4a6a, 0x4229, 0x5acc, 0x8451, 0xad56, 0xbdf7, 0xbdf7, 0xbe18, 0xc638, 0xce59, 0xd69a, 0xdefb, 0xdf1c, 0xe71c, 0xe73c, 0xe73c, 0xe73d, 0xe75d, 0xef5d, 0xef5d, 0xef5d, 0xef5d, 0xef5d, 0xef5d, 0xef5d, 0xef5d, 
0xb595, 0xb595, 0xb595, 0xb575, 0xb575, 0xb575, 0xb575, 0xb554, 0xad54, 0xad54, 0xad74, 0xad74, 0xad75, 0xb595, 0xb5b5, 0xb5b6, 0xbdd6, 0xbdd6, 0xbdf7, 0xc638, 0xce79, 0xd69a, 0xd6ba, 0xd6ba, 0xd69a, 0xd69a, 0xce79, 0xc638, 0xbdf7, 0xad54, 0x8c51, 0x6b6d, 0x52aa, 0x4207, 0x3185, 0x3185, 0x31a6, 0x41e7, 0x5aca, 0x738d, 0x9cf3, 0xad75, 0xad55, 0xa534, 0xb5b6, 0xbdf7, 0x9cd3, 0x7bae, 0x94b2, 0xb595, 0xce58, 0xdeda, 0xdeba, 0xd6ba, 0xd699, 0xce58, 0xbdd7, 0x8c71, 0x736d, 0x6b4c, 0x630b, 0x5acb, 0x5aca, 0x528a, 0x5289, 0x4a68, 0x39c6, 0x2965, 0x4a48, 0x7bef, 0xad34, 0xb595, 0xbdf6, 0xbdd6, 0xad75, 0xad54, 0xb595, 0xc617, 0xce58, 0xce38, 0xbdf7, 0xc617, 0xc638, 0xce59, 0xc638, 0xbdf7, 0xb596, 0xad75, 0xad55, 0xa514, 0x94b2, 0x8410, 0x73ae, 0x634d, 0x5aeb, 0x52aa, 0x632d, 0x6b4d, 0x630c, 0x52cb, 0x630c, 0x8c51, 0xb596, 0xc639, 0xc638, 0xc638, 0xc618, 0xc638, 0xc659, 0xce99, 0xd6ba, 0xdedb, 0xdefc, 0xdf1c, 0xe71c, 0xe71c, 0xe73c, 0xe73c, 0xe73c, 0xe73c, 0xe73d, 0xe73d, 0xe73d, 0xe73d, 0xe73d, 
0xbdb6, 0xbdb6, 0xbd95, 0xb595, 0xb595, 0xb575, 0xb575, 0xb575, 0xad74, 0xad74, 0xad74, 0xad75, 0xad75, 0xb595, 0xb5b5, 0xb5b5, 0xbdd6, 0xbdf7, 0xbe17, 0xce58, 0xd69a, 0xd6da, 0xd6da, 0xd6ba, 0xd6ba, 0xd69a, 0xce59, 0xc618, 0xbdf7, 0xad75, 0x94b2, 0x7bef, 0x630b, 0x5269, 0x39e7, 0x39c6, 0x31a6, 0x39c6, 0x5269, 0x6b6d, 0xa513, 0xbdf7, 0xc638, 0xc638, 0xc638, 0xb596, 0xa513, 0xad34, 0xb595, 0xc617, 0xce78, 0xce58, 0xce79, 0xd699, 0xd699, 0xd699, 0xc638, 0x9cf3, 0x7bce, 0x6b2c, 0x5aeb, 0x5aca, 0x5aaa, 0x528a, 0x5aca, 0x52aa, 0x4227, 0x31a6, 0x4a48, 0x7bef, 0xad54, 0xbdf6, 0xc638, 0xbdd6, 0xbdd6, 0xc617, 0xce38, 0xc637, 0xc617, 0xbdf7, 0xc638, 0xc618, 0xc618, 0xc638, 0xce58, 0xc638, 0xbdf7, 0xb5b6, 0xad55, 0xa514, 0x9cd3, 0x8c51, 0x73cf, 0x632d, 0x5aec, 0x5aec, 0x6b6e, 0x632c, 0x5acb, 0x630c, 0x8431, 0xb596, 0xc659, 0xce79, 0xce59, 0xce59, 0xce59, 0xce59, 0xce79, 0xd69a, 0xd6ba, 0xd6db, 0xdefb, 0xdefb, 0xdefc, 0xe71c, 0xe71c, 0xe71c, 0xe71c, 0xe71c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 0xdf1c, 
0xbdb6, 0xbdb6, 0xbdb6, 0xb595, 0xb595, 0xb595, 0xb575, 0xb575, 0xad75, 0xad75, 0xad75, 0xad75, 0xad95, 0xb595, 0xb5b5, 0xb5b6, 0xbdd7, 0xbe17, 0xc658, 0xce99, 0xd6da, 0xdedb, 0xd6da, 0xd6ba, 0xd69a, 0xce79, 0xc638, 0xbdf7, 0xbdd7, 0xad75, 0x9cd2, 0x8430, 0x738d, 0x630b, 0x4a69, 0x4228, 0x4228, 0x4a28, 0x5acb, 0x7bae, 0x9cf3, 0xc617, 0xce58, 0xc638, 0xc638, 0xbdf7, 0xc617, 0xce79, 0xd679, 0xce58, 0xc617, 0xb5b6, 0xbdd6, 0xc638, 0xc638, 0xce79, 0xce79, 0xad75, 0x8c50, 0x6b4d, 0x52aa, 0x4a48, 0x4208, 0x39e7, 0x4228, 0x4228, 0x39e7, 0x31a6, 0x4a48, 0x7bce, 0xa533, 0xbdd6, 0xb595, 0x9cf3, 0x9cf3, 0xad75, 0xbdd6, 0xbdb6, 0xb5b5, 0xb595, 0xb5b6, 0xb5b6, 0xbdf7, 0xc638, 0xce79, 0xce79, 0xc638, 0xbdd7, 0xa535, 0x9cf3, 0x94b2, 0x8c51, 0x7bef, 0x6b4d, 0x632c, 0x634d, 0x632c, 0x52aa, 0x52aa, 0x73ae, 0xa514, 0xbe18, 0xc659, 0xc658, 0xc659, 0xce79, 0xce99, 0xd69a, 0xd6ba, 0xd6ba, 0xd6ba, 0xd6da, 0xdedb, 0xdedb, 0xdefb, 0xdefb, 0xdefc, 0xdefb, 0xdefb, 0xdefb, 0xdefb, 0xdefb, 0xdefb, 0xdefb, 0xdefb, 
0xbdb6, 0xbdb6, 0xbdb6, 0xbd95, 0xb595, 0xb595, 0xb575, 0xb575, 0xad95, 0xad95, 0xad95, 0xad95, 0xb595, 0xb595, 0xb5b5, 0xb5b6, 0xbdf7, 0xc638, 0xce99, 0xd6da, 0xdefb, 0xdefb, 0xd6da, 0xd6ba, 0xce79, 0xce59, 0xc618, 0xbdd7, 0xb5b6, 0xad55, 0x94b2, 0x7bef, 0x738e, 0x6b4c, 0x52aa, 0x4a69, 0x528a, 0x5acb, 0x6b6d, 0x8c71, 0xa534, 0xc638, 0xce59, 0xce59, 0xce79, 0xce59, 0xce58, 0xce38, 0xd699, 0xc617, 0xad75, 0xa4f3, 0xad54, 0xb5b6, 0xbdf7, 0xd699, 0xd699, 0xbdf7, 0x9cf3, 0x7bce, 0x5acb, 0x4208, 0x31a6, 0x2965, 0x2965, 0x2965, 0x2944, 0x2944, 0x4227, 0x738d, 0x9cf2, 0xad75, 0x8c71, 0x840f, 0x840f, 0x8430, 0x8430, 0x8c50, 0x8c71, 0x8c50, 0x8430, 0x9cd2, 0xad55, 0xb5b6, 0xc618, 0xce59, 0xc638, 0xbdf7, 0xa535, 0x94b2, 0x8431, 0x8410, 0x7bcf, 0x6b4d, 0x5aec, 0x5aec, 0x52aa, 0x4a8a, 0x632c, 0x8c71, 0xb596, 0xbdf7, 0xbdf7, 0xbe18, 0xc618, 0xc659, 0xce9a, 0xd6ba, 0xd6ba, 0xd6ba, 0xd6ba, 0xd6db, 0xd6db, 0xd6db, 0xdedb, 0xdedb, 0xd6db, 0xd6bb, 0xd6bb, 0xd6ba, 0xd6db, 0xd6db, 0xd6db, 0xd6db, 0xd6db, 
0xbdb6, 0xbdb6, 0xbdb6, 0xbd95, 0xb595, 0xb595, 0xb575, 0xb575, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb5b5, 0xb5b6, 0xb5b6, 0xbdf7, 0xc658, 0xd6ba, 0xdefb, 0xdf1b, 0xdefb, 0xd6da, 0xd6ba, 0xce59, 0xce58, 0xc617, 0xbdd6, 0xb596, 0xa534, 0x8c71, 0x73ae, 0x6b4d, 0x6b4d, 0x5aeb, 0x528a, 0x52aa, 0x630c, 0x7bef, 0x9cf3, 0xb5b6, 0xc638, 0xc638, 0xce58, 0xce58, 0xc617, 0xc617, 0xbdf7, 0xa533, 0x9491, 0x840f, 0x7bae, 0x8c50, 0x9cd2, 0xad54, 0xce38, 0xce79, 0xc638, 0xad55, 0x8c50, 0x632c, 0x4a48, 0x31a6, 0x2965, 0x2944, 0x2924, 0x20e3, 0x2103, 0x4207, 0x73ad, 0x9cf3, 0xad75, 0x8c71, 0x8c30, 0x7bce, 0x630b, 0x4a69, 0x62eb, 0x7bef, 0x8c50, 0x8430, 0x9cf3, 0xb5b6, 0xbdd7, 0xbdf7, 0xc638, 0xc638, 0xbdf7, 0xad55, 0x8c72, 0x7bcf, 0x73af, 0x738e, 0x630c, 0x528a, 0x4a69, 0x4228, 0x528a, 0x73ae, 0xa534, 0xbdd7, 0xb5d6, 0xb5d6, 0xbe17, 0xbdf7, 0xc638, 0xce79, 0xd6ba, 0xd69a, 0xd69a, 0xd6ba, 0xd6db, 0xd6ba, 0xd6bb, 0xd6bb, 0xd6bb, 0xd6ba, 0xd69a, 0xd69a, 0xce9a, 0xceba, 0xceba, 0xceba, 0xceba, 0xceba, 
0xbdd6, 0xbdd6, 0xbdb6, 0xb5b5, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb596, 0xb5b6, 0xb5b6, 0xbdb6, 0xc617, 0xc658, 0xd699, 0xd6ba, 0xd6da, 0xd6ba, 0xce99, 0xce58, 0xc638, 0xc617, 0xbdd7, 0xbdd6, 0xb596, 0xa513, 0x8430, 0x73ae, 0x6b6c, 0x6b4c, 0x632b, 0x5aaa, 0x5269, 0x5aca, 0x7bee, 0x9cd2, 0xa534, 0xc638, 0xce79, 0xce59, 0xc5f7, 0xb575, 0x9cf3, 0x7bef, 0x5aca, 0x5aaa, 0x738d, 0x8c50, 0x94b2, 0x94b2, 0x94b2, 0xa514, 0xc5f7, 0xce79, 0xc5f7, 0xa534, 0x83ef, 0x5acb, 0x5289, 0x4a28, 0x3985, 0x39a6, 0x2924, 0x20e3, 0x4a28, 0x83ef, 0xa4f3, 0xad54, 0x9491, 0x8c30, 0x8c30, 0x83ef, 0x736d, 0x83ef, 0x9cd2, 0xa4f3, 0xad75, 0xbdd7, 0xc618, 0xc618, 0xce38, 0xce79, 0xce58, 0xbdf7, 0x9cf4, 0x7c10, 0x634d, 0x632d, 0x632d, 0x52ab, 0x4209, 0x39c8, 0x39e7, 0x6b6d, 0x9492, 0xa514, 0xad75, 0xad75, 0xad75, 0xb595, 0xbdf7, 0xc638, 0xce79, 0xce79, 0xce79, 0xd699, 0xd699, 0xd69a, 0xd6ba, 0xd6ba, 0xd6ba, 0xd6ba, 0xd69a, 0xce79, 0xce79, 0xce79, 0xc679, 0xc679, 0xc679, 0xc679, 0xc679, 
0xbdd6, 0xbdd6, 0xbdb6, 0xb5b6, 0xb5b5, 0xb595, 0xb595, 0xb595, 0xb596, 0xb596, 0xb596, 0xb596, 0xb596, 0xb5b6, 0xb5b6, 0xbdb6, 0xbe17, 0xc637, 0xc658, 0xce58, 0xc638, 0xbe17, 0xbe17, 0xc617, 0xc638, 0xbdd6, 0xad54, 0xa513, 0x9cf3, 0x9cd2, 0x8c50, 0x73ae, 0x630b, 0x630b, 0x62eb, 0x5aca, 0x52aa, 0x5aca, 0x738d, 0x9471, 0xb595, 0xce59, 0xce79, 0xc617, 0xad75, 0x9cd3, 0x9492, 0x7bef, 0x73ae, 0x7bef, 0x9491, 0x9cf3, 0xa513, 0xa513, 0xa513, 0xad75, 0xbdf7, 0xd679, 0xce79, 0xbdf7, 0x9cd2, 0x6b6d, 0x5aaa, 0x4228, 0x4207, 0x3185, 0x20e3, 0x3185, 0x734c, 0x9cd2, 0xb575, 0xbd95, 0xad34, 0x9cd2, 0x9cd2, 0x9cd2, 0x9cb2, 0xad54, 0xbdb6, 0xad34, 0xad55, 0xbdd7, 0xce38, 0xce58, 0xce59, 0xd699, 0xce58, 0xbdd6, 0x94b3, 0x73af, 0x52cb, 0x4a6a, 0x4229, 0x31a7, 0x2946, 0x2945, 0x4a49, 0x7bce, 0x9492, 0x9cd2, 0xa534, 0xad55, 0xa513, 0x9cf3, 0xbdd7, 0xbdf7, 0xbdd7, 0xbdf7, 0xc618, 0xc617, 0xbdf7, 0xc618, 0xce9a, 0xd69a, 0xd69a, 0xce79, 0xce59, 0xc638, 0xc618, 0xc618, 0xc659, 0xc659, 0xc659, 0xc659, 0xc659, 
0xbdd6, 0xbdd6, 0xbdb6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xbdf7, 0xbdf6, 0xbdf7, 0xbdf6, 0xad95, 0xa533, 0xa554, 0xb5b6, 0xbdd6, 0xad54, 0x9491, 0x7bef, 0x7bcf, 0x840f, 0x7bce, 0x6b4c, 0x5289, 0x4a69, 0x5289, 0x5aeb, 0x630b, 0x632c, 0x7bce, 0x94b2, 0xb596, 0xce38, 0xce58, 0xc618, 0xb596, 0xad54, 0xb595, 0xad75, 0xb595, 0xbdf7, 0xce58, 0xc638, 0xc617, 0xc617, 0xc638, 0xce58, 0xce58, 0xd699, 0xd699, 0xd679, 0xbdd6, 0x8c71, 0x6b4c, 0x4207, 0x3165, 0x20e3, 0x2103, 0x5aaa, 0x9c91, 0xb554, 0xb575, 0xb595, 0xc5f7, 0xb595, 0xb595, 0xb595, 0xb575, 0xbdb6, 0xbdb6, 0xa513, 0xb595, 0xc638, 0xce79, 0xce58, 0xce58, 0xd679, 0xce58, 0xbdd6, 0x9cf4, 0x7bf0, 0x52cb, 0x39e8, 0x2945, 0x18c4, 0x18c3, 0x20e4, 0x52aa, 0x7bef, 0x8c51, 0x8c71, 0xa514, 0xa534, 0x9492, 0x8c71, 0xb5b6, 0xbdf7, 0xbdd7, 0xbdd6, 0xb5b6, 0xad55, 0xb595, 0xce58, 0xc638, 0xce59, 0xce79, 0xc659, 0xc638, 0xbe18, 0xbdf7, 0xbdf7, 0xb617, 0xb617, 0xb617, 0xb617, 0xb617, 
0xbdd6, 0xbdd6, 0xbdb6, 0xb5b6, 0xb5b6, 0xb5b6, 0xbdb6, 0xbdb6, 0xbdd6, 0xbdb6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xbdf6, 0xbdd6, 0xb5d6, 0xad75, 0x94b1, 0x7bee, 0x7bee, 0x8c70, 0x94b2, 0x8c51, 0x738d, 0x52aa, 0x4a49, 0x528a, 0x5289, 0x4228, 0x39c6, 0x3185, 0x39c6, 0x5269, 0x5aeb, 0x6b4c, 0x842f, 0xa513, 0xbdd6, 0xce58, 0xce79, 0xce79, 0xc638, 0xc617, 0xce79, 0xd699, 0xce79, 0xdeba, 0xdeda, 0xd679, 0xce58, 0xd699, 0xd699, 0xd699, 0xd69a, 0xd69a, 0xce79, 0xd6ba, 0xce59, 0xad54, 0x7bef, 0x4228, 0x20e3, 0x18c2, 0x39a6, 0x738d, 0xa513, 0xb575, 0xb575, 0xbdb6, 0xbd95, 0xb554, 0xb574, 0xb595, 0xb595, 0xbdb6, 0xc5f6, 0xbdb5, 0xc617, 0xce79, 0xd699, 0xce38, 0xc617, 0xce58, 0xce58, 0xc617, 0xad96, 0x8c92, 0x5b0c, 0x31c7, 0x18e4, 0x0862, 0x1082, 0x18e4, 0x4228, 0x632c, 0x7bce, 0x8c50, 0x9cd3, 0x8c50, 0x738d, 0x73ae, 0xa534, 0xb596, 0xb596, 0xa513, 0x8430, 0x6b6d, 0x840f, 0xbdd6, 0xbdf7, 0xc638, 0xc659, 0xc638, 0xbdf7, 0xbdf7, 0xbdd7, 0xb5b6, 0xb5d6, 0xb5d6, 0xb5d6, 0xb5d6, 0xb5d6, 
0xbdd6, 0xbdd6, 0xbdb6, 0xb5b6, 0xb5b6, 0xb5b6, 0xbdb6, 0xbdb6, 0xbdd6, 0xbdd6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xbdf6, 0xbdd6, 0xb5b6, 0xad54, 0x842f, 0x5b0b, 0x52aa, 0x630b, 0x6b6d, 0x6b6d, 0x5aeb, 0x4208, 0x3186, 0x31a6, 0x39c6, 0x31a6, 0x3185, 0x2123, 0x2124, 0x39c6, 0x4a69, 0x5aeb, 0x7bef, 0x9cf3, 0xbdd6, 0xce58, 0xce59, 0xd699, 0xce79, 0xce59, 0xd6ba, 0xd699, 0xd6b9, 0xd6b9, 0xce79, 0xce58, 0xce58, 0xd6b9, 0xd6ba, 0xce78, 0xce79, 0xd679, 0xce79, 0xd69a, 0xce79, 0xb5b6, 0x8c71, 0x5289, 0x2103, 0x2924, 0x4a28, 0x7bce, 0xa513, 0xb575, 0xbd95, 0xbdb6, 0xad33, 0xa4f2, 0xad33, 0xb595, 0xbdb5, 0xbdb5, 0xc616, 0xce57, 0xc5f7, 0xce58, 0xce79, 0xce58, 0xc617, 0xc617, 0xc638, 0xce58, 0xbe18, 0x9cf3, 0x6b6d, 0x39e7, 0x18c3, 0x0861, 0x1082, 0x18e4, 0x39c7, 0x52aa, 0x6b4d, 0x8430, 0x8c51, 0x5aeb, 0x4208, 0x5aca, 0x9cd3, 0xa514, 0x9492, 0x738d, 0x4a48, 0x2965, 0x5289, 0x94b2, 0xb596, 0xbdf7, 0xc618, 0xbdf7, 0xb5b6, 0xb5b6, 0xad96, 0xad75, 0xad96, 0xad96, 0xad96, 0xad96, 0xad96, 
0xbdd6, 0xbdd6, 0xbdb6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb596, 0xb596, 0xb596, 0xb596, 0xb596, 0xbdd6, 0xbdf6, 0xbdf7, 0xb595, 0x94b2, 0x73ae, 0x6b6c, 0x738d, 0x73ae, 0x7bce, 0x738d, 0x5aeb, 0x5289, 0x5289, 0x52aa, 0x528a, 0x5289, 0x4207, 0x39c6, 0x4228, 0x5289, 0x5aeb, 0x7bce, 0x94b1, 0xb595, 0xc638, 0xce59, 0xce79, 0xce59, 0xce59, 0xdeba, 0xd69a, 0xdeda, 0xd699, 0xc637, 0xce78, 0xd6b9, 0xdeda, 0xdeda, 0xd6b9, 0xce38, 0xce59, 0xce58, 0xce59, 0xce59, 0xc638, 0xa513, 0x5aca, 0x20e3, 0x20e3, 0x4a07, 0x83ef, 0xad54, 0xbdb6, 0xad34, 0x9491, 0xa4f2, 0xa4f2, 0xb574, 0xbdd6, 0xb595, 0xa513, 0xad54, 0xc5f6, 0xb595, 0xbdf6, 0xce58, 0xce78, 0xc617, 0xb5b5, 0xbdd6, 0xce58, 0xc638, 0xa555, 0x7bef, 0x4a8a, 0x3186, 0x2124, 0x2965, 0x3186, 0x4207, 0x4a49, 0x52aa, 0x632c, 0x5acb, 0x2945, 0x18c2, 0x39e7, 0x6b4d, 0x5aeb, 0x4207, 0x2104, 0x0861, 0x0020, 0x2945, 0x632c, 0x94d3, 0xa555, 0xb5b6, 0xb596, 0xad96, 0xb5b6, 0xb5b6, 0xad95, 0xadb6, 0xadb6, 0xadb6, 0xadb6, 0xadb6, 
0xbdd6, 0xbdd6, 0xbdb6, 0xb5b6, 0xb5b5, 0xb595, 0xb595, 0xb595, 0xb596, 0xb596, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb596, 0xb5d6, 0xbdf7, 0xc637, 0xbdf7, 0xad95, 0xa513, 0x9cf3, 0xa513, 0x9cd3, 0x9cd2, 0x9492, 0x8c51, 0x8410, 0x840f, 0x840f, 0x7bef, 0x738d, 0x6b4c, 0x632c, 0x6b2c, 0x6b4c, 0x738d, 0x840f, 0x9491, 0xb596, 0xce79, 0xd679, 0xc638, 0xbdd6, 0xbdf7, 0xd69a, 0xd6ba, 0xce78, 0xc617, 0xbdd6, 0xce58, 0xd699, 0xce58, 0xce78, 0xd699, 0xce59, 0xce79, 0xc618, 0xbdf7, 0xc5f7, 0xce79, 0xb5b6, 0x6b4d, 0x20c2, 0x18a2, 0x41c6, 0x840f, 0xb575, 0xb575, 0x9491, 0x7b8d, 0x9cb1, 0xa4f2, 0xb574, 0xbdd5, 0xad53, 0x9cb1, 0xa512, 0xbdd5, 0xad74, 0xb5b5, 0xc637, 0xce78, 0xbdd6, 0x9cf2, 0xa513, 0xbdf6, 0xc658, 0xad96, 0x8c71, 0x634d, 0x52aa, 0x528a, 0x52aa, 0x5aab, 0x528a, 0x52aa, 0x528a, 0x5289, 0x4208, 0x2124, 0x2104, 0x4208, 0x39e7, 0x2945, 0x1082, 0x0020, 0x0020, 0x0841, 0x2124, 0x4a49, 0x8c71, 0xa514, 0xad96, 0xb596, 0xb596, 0xb5d6, 0xbdd7, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 
0xbdd6, 0xbdd6, 0xbdb6, 0xb5b5, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb575, 0xb575, 0xb575, 0xb575, 0xb595, 0xb595, 0xbdd6, 0xbe17, 0xc617, 0xbdf7, 0xb5b6, 0xb595, 0xb595, 0xb5b5, 0xb5b6, 0xad75, 0xa514, 0x9cf3, 0x9cf3, 0x9cd2, 0x94b2, 0x9491, 0x7bef, 0x7bce, 0x7bce, 0x7bef, 0x7bef, 0x840f, 0x8c50, 0x9491, 0xad75, 0xce79, 0xce79, 0xb5b6, 0xa514, 0xad55, 0xce59, 0xd6ba, 0xc637, 0xb5b5, 0xb595, 0xce58, 0xce78, 0xbdd6, 0xc616, 0xce78, 0xce79, 0xd69a, 0xc638, 0xb596, 0xad75, 0xce59, 0xc638, 0x8430, 0x3185, 0x20e3, 0x39c6, 0x83ef, 0xad34, 0xad34, 0x9491, 0x840f, 0xa512, 0xad33, 0xb574, 0xbdb5, 0xb574, 0xa512, 0xad53, 0xc5f6, 0xbdd5, 0xbdd5, 0xc617, 0xc637, 0xad54, 0x842f, 0x9490, 0xb595, 0xbe17, 0xad75, 0x8c91, 0x73ce, 0x6b6d, 0x6b4d, 0x6b6d, 0x6b6d, 0x7bcf, 0x840f, 0x840f, 0x7bce, 0x6b6d, 0x630b, 0x630c, 0x73ae, 0x632c, 0x5acb, 0x528a, 0x52aa, 0x52aa, 0x5aca, 0x632c, 0x7bce, 0x9cd3, 0xad75, 0xbdf7, 0xb5d7, 0xb5b6, 0xb5d6, 0xb5d6, 0xb596, 0xb5d6, 0xb5d6, 0xb5d6, 0xb5d6, 0xb5d6, 
0xbdf6, 0xbdd6, 0xbdd6, 0xb5b6, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb575, 0xad75, 0xad75, 0xb575, 0xb595, 0xb595, 0xbdd6, 0xc617, 0xce58, 0xce58, 0xc638, 0xbdf7, 0xbdd6, 0xbdd6, 0xbdf7, 0xbdd6, 0xb595, 0xad75, 0xad74, 0xad54, 0xa513, 0x9cd2, 0x9491, 0x842f, 0x842f, 0x8c70, 0x8c70, 0x8c50, 0x8c70, 0x9cf2, 0xbdd6, 0xc637, 0xd699, 0xb5b5, 0x9491, 0x9cf2, 0xc617, 0xce78, 0xce37, 0xc617, 0xbdb5, 0xb595, 0xdeda, 0xad33, 0x9450, 0xce38, 0xce58, 0xce78, 0xce79, 0xc5f7, 0xa534, 0xb5b5, 0xc617, 0x94b2, 0x5289, 0x41e6, 0x4207, 0x83ef, 0xa4f3, 0x7b8d, 0x6b2b, 0x9cb1, 0x9cf2, 0xad54, 0xc617, 0xad54, 0x6b4c, 0x840f, 0xc617, 0xb5b5, 0x9491, 0xb575, 0xce38, 0xc617, 0xa513, 0x7bef, 0x7bee, 0x9cd2, 0xb5b5, 0xad74, 0x94b2, 0x7bef, 0x73ad, 0x6b6d, 0x738d, 0x7bef, 0x840f, 0x9491, 0x9cd2, 0x9cd2, 0x9cd2, 0x9471, 0x8c50, 0x9471, 0xa513, 0x9cd2, 0x9491, 0x8c50, 0x8c30, 0x8c70, 0x94b2, 0x9cf3, 0xb596, 0xb5b6, 0xbdf7, 0xbdf7, 0xbdd6, 0xb5b6, 0xbdd6, 0xbdf7, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 0xb5b6, 
0xc5f7, 0xbdf7, 0xbdd6, 0xbdd6, 0xb5b6, 0xb5b6, 0xb5b5, 0xb5b5, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xbdd6, 0xc617, 0xce78, 0xd699, 0xd679, 0xce58, 0xce38, 0xc638, 0xce79, 0xce58, 0xc617, 0xbdf7, 0xbdd6, 0xb595, 0xad54, 0xa513, 0x9cf2, 0x94b1, 0x9491, 0x9491, 0x9491, 0x8c70, 0x94b1, 0xa513, 0xb5b5, 0xce58, 0xce78, 0xa513, 0x6b6c, 0x738d, 0x9cf2, 0xc637, 0xce38, 0xd658, 0xb554, 0x9470, 0xd679, 0xc617, 0x9cb2, 0xa513, 0xce58, 0xc638, 0xc617, 0xc638, 0xb595, 0xa513, 0x94b1, 0x6b6c, 0x5aca, 0x5269, 0x5269, 0x630b, 0x630b, 0x4a07, 0x5289, 0x8c50, 0x7bef, 0x6b4c, 0x630b, 0x5aca, 0x4a48, 0x73ae, 0xa534, 0x8c71, 0x5aea, 0x8c50, 0xb575, 0xb5b6, 0x9cf3, 0x7bce, 0x6b2c, 0x6b6d, 0x9491, 0x94d2, 0x9491, 0x8c50, 0x8c50, 0x840f, 0x7bef, 0x842f, 0x94b2, 0xa513, 0xad54, 0xad54, 0xa534, 0x9cf2, 0x94b1, 0x9cd2, 0xad74, 0xad74, 0xad34, 0x9cf2, 0x9491, 0x94b2, 0xa513, 0xad75, 0xbdd7, 0xbdf7, 0xc618, 0xc618, 0xbdf7, 0xbdd6, 0xbdd7, 0xbdf7, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 
0xbdf7, 0xbdf6, 0xbdd6, 0xbdb6, 0xb5b6, 0xb5b5, 0xb5b5, 0xb5b5, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xb595, 0xbdd6, 0xc617, 0xce58, 0xd699, 0xd6b9, 0xd6b9, 0xd699, 0xd699, 0xce78, 0xce58, 0xc637, 0xc617, 0xc5f7, 0xbdd6, 0xb595, 0xad54, 0xad54, 0xa533, 0xa513, 0x9cf2, 0x9cd2, 0x9cd2, 0xa513, 0xad54, 0xb595, 0xc617, 0xbdd6, 0x8c50, 0x5aca, 0x5289, 0x840f, 0xb5b5, 0xbdd6, 0xce58, 0x9471, 0x5268, 0xad54, 0xe6fa, 0xad54, 0x738d, 0x9cd2, 0x8c71, 0x7bce, 0x8430, 0x94b2, 0x9491, 0x8430, 0x6b6d, 0x6b4c, 0x6b4c, 0x6b4c, 0x6b2c, 0x6b0b, 0x6b0b, 0x738d, 0x8c30, 0x4a28, 0x3165, 0x2924, 0x39e7, 0x5aca, 0x840f, 0x9cd2, 0x73ae, 0x4a68, 0x738d, 0x9491, 0xa4f3, 0xa534, 0x9cf2, 0x8c50, 0x842f, 0x94b1, 0x9cf2, 0x9cf2, 0x9cf2, 0x9cf3, 0x94d2, 0x8c91, 0x9491, 0x9cf3, 0xad54, 0xad75, 0xb595, 0xb5b5, 0xad75, 0xa533, 0xad34, 0xbdd6, 0xbdd6, 0xbdd6, 0xb575, 0xa513, 0xa513, 0xad75, 0xbdf6, 0xc618, 0xc638, 0xce58, 0xc638, 0xc617, 0xbdd7, 0xbdd6, 0xbdd6, 0xbdd7, 0xbdd7, 0xbdd7, 0xbdd7, 0xbdd7, 
0xc617, 0xc617, 0xc5f7, 0xbdf7, 0xbdf6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xb5b6, 0xbdd6, 0xc617, 0xce58, 0xd699, 0xd6b9, 0xd6ba, 0xd6ba, 0xd699, 0xce79, 0xce78, 0xce58, 0xce38, 0xc617, 0xbdb6, 0xb595, 0xb595, 0xb595, 0xb595, 0xad54, 0xad54, 0xad74, 0xb5b5, 0xbdd6, 0xc617, 0xce58, 0xb5b5, 0x94b1, 0x840f, 0x7bee, 0x9491, 0xbdd6, 0xad33, 0xb554, 0x7bce, 0x39a5, 0x8c2f, 0xce58, 0xb574, 0x736d, 0x5289, 0x4a69, 0x2965, 0x39c6, 0x6b4c, 0x8c50, 0x9471, 0x840f, 0x8c50, 0x840f, 0x8c50, 0x9cd2, 0xa4f3, 0xa4f2, 0xa4f2, 0x9cd2, 0x83ef, 0x73ae, 0x738d, 0x842f, 0x9491, 0xa4f3, 0xa534, 0x8c71, 0x8430, 0x9cf2, 0xad54, 0xad75, 0xb5b5, 0xb5b6, 0xb595, 0xb595, 0xbdf6, 0xbdf6, 0xb595, 0xa554, 0xa534, 0xa513, 0x9cf2, 0xa513, 0xa534, 0xb575, 0xb595, 0xbdb6, 0xc5f7, 0xbdd6, 0xb595, 0xb5b5, 0xc617, 0xc617, 0xc637, 0xbdf7, 0xb5b6, 0xb5b5, 0xbdd6, 0xc637, 0xce59, 0xce59, 0xce58, 0xc638, 0xbdf7, 0xbdd6, 0xb5b6, 0xbdd6, 0xbdd7, 0xbdd7, 0xbdd7, 0xbdd7, 0xbdd7, 
0xc617, 0xc5f7, 0xbdf7, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdf6, 0xbdf6, 0xbdd6, 0xbdd6, 0xbdd6, 0xbdb6, 0xbdd6, 0xbdf6, 0xc617, 0xce58, 0xd699, 0xd6b9, 0xdeba, 0xd6ba, 0xd699, 0xd699, 0xce79, 0xce58, 0xc617, 0xbdd6, 0xb595, 0xb595, 0xb5b5, 0xb5b5, 0xb595, 0xb595, 0xb595, 0xb5b5, 0xbdd6, 0xce78, 0xd699, 0xc617, 0xb5b5, 0xb5b5, 0xb595, 0xb595, 0xc617, 0xbdd6, 0xb595, 0xad33, 0x83ce, 0xa4d2, 0xc5d6, 0xc617, 0xb574, 0x840f, 0x8c30, 0x738d, 0x7bce, 0x9cf3, 0xb595, 0xb595, 0xa513, 0x9cd2, 0x8c50, 0x9cb2, 0xbd95, 0xbdb5, 0xad33, 0xad33, 0xb575, 0xbdd6, 0xb5b5, 0xad54, 0xad54, 0xa533, 0xad34, 0xbdd6, 0xb595, 0xad54, 0xbdd6, 0xc638, 0xc617, 0xb5b5, 0xa534, 0xad54, 0xbdd6, 0xc637, 0xc617, 0xb595, 0xa534, 0xa533, 0xa513, 0x9cf2, 0xa513, 0xad34, 0xb575, 0xb595, 0xbdb6, 0xc617, 0xbdf7, 0xb5b6, 0xb5b6, 0xc637, 0xc637, 0xc638, 0xc638, 0xc637, 0xc638, 0xc638, 0xc638, 0xd69a, 0xd699, 0xce59, 0xc638, 0xbdf7, 0xbdd7, 0xbdd7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 
0xc617, 0xc617, 0xbdf7, 0xbdf7, 0xbdf6, 0xbdf6, 0xbdf6, 0xbdf6, 0xbdf6, 0xbdf6, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf6, 0xbdf6, 0xbdf7, 0xbdf7, 0xc617, 0xc637, 0xce38, 0xce78, 0xd699, 0xd6b9, 0xd699, 0xd699, 0xd699, 0xd699, 0xd679, 0xce58, 0xc638, 0xc617, 0xc617, 0xbdf6, 0xbdf6, 0xbdf6, 0xbdd6, 0xbdd6, 0xbdd6, 0xc617, 0xc637, 0xd699, 0xd699, 0xce58, 0xc617, 0xbdd6, 0xbdf6, 0xc637, 0xce58, 0xc617, 0xc617, 0xad34, 0xc5d6, 0xce58, 0xce38, 0xbd95, 0xb5b5, 0xb5b6, 0xb575, 0xbdd6, 0xc5f7, 0xbdd6, 0xbdd6, 0xad75, 0xad33, 0xad33, 0xad34, 0xb575, 0xbdd6, 0xbdb6, 0xb595, 0xb575, 0xbdd6, 0xbdd6, 0xbdb6, 0xbdd6, 0xad75, 0xb575, 0xc617, 0xb5b5, 0xbdd6, 0xbdf7, 0xc5f7, 0xc617, 0xc617, 0xb5b6, 0xb5b6, 0xce58, 0xc638, 0xc638, 0xbdf6, 0xb5b6, 0xbdd6, 0xb5b5, 0xad75, 0xb595, 0xad54, 0xb5b5, 0xbdd6, 0xc617, 0xce79, 0xce79, 0xce58, 0xce78, 0xce58, 0xce58, 0xce58, 0xce58, 0xce79, 0xd699, 0xd699, 0xce79, 0xd6ba, 0xd699, 0xce59, 0xc638, 0xc617, 0xbdf7, 0xc617, 0xc618, 0xc617, 0xc617, 0xc617, 0xc617, 0xc617, 
0xce58, 0xce58, 0xc638, 0xc638, 0xc637, 0xc637, 0xc637, 0xc638, 0xc617, 0xc617, 0xc617, 0xc617, 0xc617, 0xc617, 0xc617, 0xc617, 0xc5f7, 0xc617, 0xc638, 0xce38, 0xc638, 0xc638, 0xce38, 0xce58, 0xce79, 0xce79, 0xd679, 0xce79, 0xce79, 0xce58, 0xce58, 0xce38, 0xc617, 0xbdd6, 0xb5b5, 0xb5b5, 0xb5b5, 0xb595, 0xb5b5, 0xc617, 0xc637, 0xd699, 0xdeda, 0xce58, 0xb595, 0xb595, 0xc637, 0xce78, 0xd699, 0xce58, 0xce37, 0xb575, 0xd699, 0xd678, 0xbdd6, 0xb574, 0xc638, 0xc637, 0xce38, 0xce79, 0xc617, 0xc617, 0xd699, 0xbdf7, 0xad54, 0xb554, 0xad34, 0xbdb5, 0xd678, 0xce38, 0xbdb5, 0xbdb5, 0xb5b5, 0xbdf6, 0xce58, 0xce58, 0xb595, 0xb5b6, 0xd679, 0xc617, 0xc617, 0xc617, 0xc637, 0xce58, 0xce58, 0xbdd6, 0xbdb6, 0xce58, 0xce79, 0xce78, 0xbdf7, 0xb5b5, 0xb5b6, 0xb595, 0xad74, 0xad95, 0xad54, 0xb595, 0xbdd6, 0xbdf7, 0xce58, 0xce58, 0xc638, 0xce58, 0xd6b9, 0xd699, 0xd699, 0xd679, 0xd699, 0xd699, 0xdeba, 0xdeda, 0xce58, 0xc638, 0xc638, 0xc618, 0xc617, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7, 0xbdf7
};

const unsigned short  Dog[] PROGMEM = {
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xffdd, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xfffd, 0xfffd, 0xfffe, 0xfffe, 0xffbd, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffbf, 0xffdf, 0xffdf, 0xffbf, 0xffdf, 0xffff, 0xffdf, 0xffbf, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xf7be, 0xf7de, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xf7be, 0xf7be, 0xf7be, 0xf7be, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbd, 0xffbd, 0xffde, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xffde, 0xf7bd, 0xffdd, 0xffdd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xf7be, 0xf7de, 0xfffe, 0xffde, 0xffde, 0xffbd, 0xffbd, 0xffdd, 0xffbf, 0xffbf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffd, 0xfffd, 0xfffd, 0xffdd, 0xf7dd, 0xfffd, 0xfffd, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffbf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xf7de, 0xfffe, 0xfffe, 0xffde, 0xf7bd, 0xffbd, 0xffbd, 0xffdd, 0xffbd, 0xffbd, 0xffbd, 0xffbd, 0xffbd, 0xffdd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xffde, 0xffde, 0xffdd, 0xffbd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xfffd, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xf7bd, 0xffdd, 0xfffe, 0xfffe, 0xffdd, 0xffbc, 0xff9b, 0xf79b, 0xff7a, 0xff7a, 0xf759, 0xf739, 0xf739, 0xf759, 0xff7a, 0xff7a, 0xf79b, 0xff9b, 0xff9c, 0xffdc, 0xfffd, 0xfffd, 0xfffd, 0xffdd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xfffd, 0xfffd, 0xfffd, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffde, 0xffbe, 0xffbe, 0xffdf, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbf, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbd, 0xffbc, 0xffbc, 0xffbc, 0xff9b, 0xf75a, 0xe6b8, 0xd655, 0xcdf4, 0xc591, 0xc591, 0xbd70, 0xbd50, 0xbd50, 0xbd50, 0xc570, 0xc591, 0xce14, 0xd615, 0xd655, 0xe697, 0xeef8, 0xef18, 0xeef8, 0xeed8, 0xf73a, 0xf75a, 0xf75a, 0xff7a, 0xff9b, 0xff9b, 0xffbb, 0xffbc, 0xffbe, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffde, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffbd, 0xff9d, 0xff5a, 0xf718, 0xe6b7, 0xde35, 0xcdb2, 0xbd10, 0xac8e, 0x9c2c, 0x93eb, 0x93eb, 0x93eb, 0x93eb, 0x93eb, 0x93eb, 0x940b, 0x9c0b, 0x9c2c, 0x9c2c, 0xa44d, 0xac8e, 0xb4ef, 0xb50f, 0xb4ef, 0xb4cf, 0xbd31, 0xbd51, 0xbd51, 0xc592, 0xcdb2, 0xcdd3, 0xd5f4, 0xd614, 0xe6b8, 0xeed9, 0xf73a, 0xff7b, 0xff7b, 0xff5a, 0xff7b, 0xffbc, 0xff9c, 0xff9c, 0xffbd, 0xffdd, 0xffdd, 0xffbd, 0xffbd, 0xffbd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffbd, 0xf79d, 0xe696, 0xd614, 0xbd51, 0xacae, 0x9c2c, 0x93ca, 0x8b89, 0x8348, 0x834a, 0x834a, 0x836a, 0x8b6b, 0x8b8b, 0x8b8b, 0x8b6b, 0x8b6a, 0x9c0b, 0x9bea, 0x9bea, 0x9c0b, 0xa42b, 0xa44c, 0xa42b, 0x9c0b, 0x9c0c, 0x9c0c, 0x9c0c, 0x9c2c, 0x9c2c, 0x9c2c, 0x9c2c, 0x9c2c, 0xa4ad, 0xacce, 0xbd30, 0xc591, 0xc5b1, 0xc591, 0xcdb2, 0xd613, 0xd656, 0xde97, 0xe6f9, 0xf75a, 0xff9c, 0xffbd, 0xffbd, 0xffbd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xffdd, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xffdd, 0xf7bc, 0xf79b, 0xde13, 0xb4ef, 0x9c2c, 0x93eb, 0x8baa, 0x8369, 0x7b49, 0x7b28, 0x8349, 0x72e8, 0x72c7, 0x72e8, 0x7b29, 0x7b29, 0x7b29, 0x7b29, 0x8baa, 0x93eb, 0x8b8a, 0x93cb, 0x93eb, 0x838a, 0x8b8a, 0x8369, 0x8b89, 0x93ca, 0x9c2c, 0x93cb, 0x93eb, 0x9c2c, 0x8bca, 0x9c0c, 0x9c2c, 0x93eb, 0x93eb, 0x9c4d, 0x9c2c, 0x8baa, 0x8b8a, 0x8bcb, 0x9c2c, 0xa46d, 0xacae, 0xcd92, 0xde34, 0xe675, 0xff38, 0xff9a, 0xffbc, 0xffbc, 0xffbc, 0xffdd, 0xfffe, 0xfffe, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffff, 0xffff, 0xffbe, 0xffbe, 0xffbd, 0xffdd, 0xffdd, 0xf77b, 0xe6f9, 0xde97, 0xc550, 0xa46d, 0x93eb, 0x8baa, 0x7b49, 0x72e8, 0x72e8, 0x72e7, 0x7b08, 0x72c7, 0x72c7, 0x72e8, 0x7b08, 0x7b08, 0x7b08, 0x7b29, 0x838a, 0x8baa, 0x93cb, 0x8baa, 0x8baa, 0x8b8a, 0x8b8a, 0x9c2c, 0x93cb, 0x9c2c, 0x9c0c, 0x93eb, 0x9c0c, 0x940b, 0x93eb, 0x93eb, 0x93eb, 0x8bcb, 0x8baa, 0x8bcb, 0x838a, 0x7b28, 0x8349, 0x8baa, 0x8b8a, 0x8baa, 0x8baa, 0x9c2c, 0xac8e, 0xacae, 0xbd30, 0xc571, 0xde97, 0xe6d8, 0xf75a, 0xffbc, 0xffbd, 0xff9d, 0xffbd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xf7be, 0xffde, 0xffde, 0xffdd, 0xff7b, 0xe6b7, 0xcdd3, 0xbd31, 0xa44d, 0x93cb, 0x8b8a, 0x8369, 0x72e7, 0x6286, 0x6aa7, 0x6ac7, 0x72e8, 0x6aa7, 0x6aa7, 0x72c7, 0x72e8, 0x72e8, 0x72e8, 0x7b29, 0x8369, 0x836a, 0x93eb, 0x836a, 0x8369, 0x8b8a, 0x8baa, 0xbd10, 0xacae, 0xb4ef, 0x9c2c, 0x93eb, 0x93eb, 0x8baa, 0x93cb, 0x8b8a, 0x8b8a, 0x8b8a, 0x8b8a, 0x838a, 0x7b28, 0x72e7, 0x7b28, 0x8b8a, 0x8349, 0x8349, 0x7b08, 0x8349, 0x8369, 0x8369, 0x8bcb, 0x93cb, 0xac8e, 0xbd31, 0xde35, 0xf73a, 0xff9c, 0xffbd, 0xffde, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffbe, 0xffbe, 0xffbe, 0xffde, 0xffbe, 0xffbe, 0xfffe, 0xfffe, 0xfffe, 0xff9c, 0xe6b7, 0xcdb2, 0xb4ae, 0xa42b, 0x93ab, 0x8349, 0x8349, 0x7b28, 0x6aa7, 0x6286, 0x6ac7, 0x72e8, 0x72c7, 0x6aa7, 0x72c7, 0x72e8, 0x72e8, 0x72c7, 0x72e8, 0x7b29, 0x8b8a, 0x8b8a, 0x93cb, 0x8349, 0x8369, 0x8baa, 0x9c0c, 0xcdb2, 0xd5f3, 0xd5d3, 0xacae, 0x93cb, 0x8369, 0x8349, 0x8369, 0x7b28, 0x836a, 0x8b8a, 0x8bab, 0x8bab, 0x836a, 0x7b29, 0x7b29, 0x836a, 0x8349, 0x8349, 0x72e8, 0x7b08, 0x7b29, 0x7b29, 0x836a, 0x836a, 0x8b48, 0x9beb, 0xb4f0, 0xde35, 0xf73a, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffff, 0xffdf, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xf79c, 0xef5a, 0xde96, 0xc592, 0xacae, 0x9beb, 0x93a9, 0x93aa, 0x8329, 0x7ae8, 0x72e8, 0x6aa7, 0x6a87, 0x6ac8, 0x6ac8, 0x72e8, 0x72e8, 0x7b08, 0x7b29, 0x7b08, 0x72e8, 0x7b08, 0x8349, 0x8bab, 0x93cb, 0x8369, 0x7b28, 0x8369, 0x8baa, 0xa46d, 0xd5f4, 0xf6d7, 0xe655, 0xc551, 0x8bcb, 0x7b28, 0x7b28, 0x72e7, 0x7b28, 0x836a, 0x8b8a, 0x8b8b, 0x8b8b, 0x8b8b, 0x8b8b, 0x836a, 0x8349, 0x7b08, 0x7b09, 0x6aa7, 0x72e8, 0x7b08, 0x7b09, 0x836a, 0x834a, 0x8b48, 0x938a, 0x9c0c, 0xb4f0, 0xd636, 0xef3a, 0xffbd, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xffde, 0xffdd, 0xff9c, 0xff7b, 0xe6f8, 0xde75, 0xc5b2, 0xb4ef, 0xa46d, 0x9beb, 0x93aa, 0x9369, 0x8b8a, 0x7b08, 0x72c7, 0x6aa7, 0x6287, 0x6a87, 0x6ac8, 0x6287, 0x7b08, 0x7b08, 0x7b29, 0x836a, 0x8349, 0x7b29, 0x7b29, 0x8349, 0x8b8a, 0x8baa, 0x7b08, 0x72e7, 0x8349, 0x836a, 0xa44d, 0xd5f3, 0xf6f8, 0xe655, 0xcdb3, 0xa44d, 0x8b8a, 0x7b29, 0x6aa7, 0x8349, 0x834a, 0x834a, 0x7b29, 0x7b29, 0x8349, 0x8b8b, 0x8b8a, 0x8349, 0x7b08, 0x7b29, 0x72c8, 0x72e8, 0x72e8, 0x7b08, 0x834a, 0x7b29, 0x8b8a, 0x8b69, 0x8b6a, 0x93ec, 0xaccf, 0xcdf4, 0xef19, 0xffdc, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xffdd, 0xff9b, 0xf739, 0xe697, 0xd615, 0xc570, 0xb50e, 0xa46d, 0x9c0b, 0x93eb, 0x93aa, 0x8b69, 0x8349, 0x8329, 0x72e8, 0x72c8, 0x72c8, 0x6aa7, 0x72c8, 0x7309, 0x72c8, 0x7b29, 0x7b29, 0x836a, 0x8b8a, 0x8b8a, 0x8349, 0x7b29, 0x7b29, 0x7b28, 0x7b28, 0x72e7, 0x6a86, 0x72e8, 0x7b49, 0x93cb, 0xd5f3, 0xeeb7, 0xde35, 0xd5f4, 0xcd92, 0xac8f, 0x7b09, 0x6a86, 0x8349, 0x7b09, 0x7b29, 0x7b09, 0x72c8, 0x72e8, 0x834a, 0x836a, 0x834a, 0x834a, 0x8b8b, 0x834a, 0x7b29, 0x7b29, 0x7b09, 0x836a, 0x7b29, 0x8b6a, 0x7b29, 0x7b29, 0x8b8a, 0x93eb, 0xacae, 0xd613, 0xff58, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xffdc, 0xffbb, 0xf739, 0xde76, 0xc571, 0xaccf, 0xa42a, 0xa42a, 0x9c0a, 0x9c0b, 0x93eb, 0x8b8a, 0x8349, 0x7b08, 0x72c7, 0x72a7, 0x7ae8, 0x7b09, 0x72e8, 0x7b29, 0x836b, 0x836a, 0x7b29, 0x8349, 0x836a, 0x8bab, 0x8bab, 0x836a, 0x7b29, 0x7b29, 0x6aa7, 0x6a86, 0x72e7, 0x6245, 0x6a86, 0x7b08, 0x8369, 0xd5f3, 0xe676, 0xde35, 0xde14, 0xee96, 0xc572, 0x72e8, 0x6266, 0x7b09, 0x6aa7, 0x7b09, 0x7b09, 0x72c8, 0x72c8, 0x7b29, 0x836a, 0x834a, 0x836a, 0x93cc, 0x8b8b, 0x836a, 0x834a, 0x7b29, 0x836a, 0x7b29, 0x838b, 0x7b29, 0x7b29, 0x8baa, 0x8bca, 0x93ca, 0xb4ee, 0xde53, 0xffbe, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffd, 0xfffe, 0xffde, 0xffbe, 0xffde, 0xffde, 0xffbc, 0xf75a, 0xff9a, 0xf718, 0xf6f7, 0xf6f7, 0xde55, 0xc551, 0xacae, 0xa44d, 0xa44d, 0x9c0c, 0x93cb, 0x8baa, 0x8369, 0x8349, 0x7b08, 0x72e7, 0x72c7, 0x6a86, 0x6a86, 0x7b29, 0x8b8a, 0x8349, 0x8349, 0x8349, 0x7b28, 0x7b28, 0x7b28, 0x7b28, 0x7b08, 0x72e7, 0x72c7, 0x6aa7, 0x5a66, 0x6287, 0x6ac8, 0x6266, 0x5a45, 0x6266, 0x836a, 0xc571, 0xddf2, 0xee74, 0xe654, 0xf6d6, 0xacaf, 0x7308, 0x5a66, 0x5a46, 0x6266, 0x6aa7, 0x6ac8, 0x6a87, 0x6287, 0x72e8, 0x6ac8, 0x834a, 0x8349, 0x834a, 0x836a, 0x836a, 0x8369, 0x8349, 0x8369, 0x8369, 0x836a, 0x836a, 0x836a, 0x836a, 0x8349, 0x8349, 0x93ec, 0xac8e, 0xee77, 0xf6f9, 0xff7c, 0xffbd, 0xffbe, 0xffbe, 0xffdf, 0xffff, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffd, 0xfffd, 0xf7be, 0xf79d, 0xff9d, 0xff7c, 0xf73a, 0xeef8, 0xe675, 0xcd92, 0xbd30, 0xbd10, 0xaccf, 0xa46d, 0x9c4d, 0x9c0c, 0x8baa, 0x8baa, 0x8369, 0x8349, 0x7b28, 0x7b28, 0x7b08, 0x7b08, 0x6aa7, 0x6a86, 0x6a86, 0x72c7, 0x7b29, 0x7b29, 0x7b08, 0x72e8, 0x7b29, 0x7b08, 0x72e8, 0x72c7, 0x6aa7, 0x6aa7, 0x6aa7, 0x72c7, 0x5a66, 0x5a66, 0x6287, 0x6266, 0x6266, 0x6266, 0x7b29, 0xbd10, 0xcd70, 0xe654, 0xe674, 0xe655, 0x9c2d, 0x6aa7, 0x5205, 0x49c4, 0x6246, 0x6a87, 0x6a87, 0x6266, 0x6267, 0x72e9, 0x6aa8, 0x7b29, 0x7b09, 0x7b29, 0x8349, 0x836a, 0x8b8a, 0x8b8a, 0x8baa, 0x8baa, 0x836a, 0x8349, 0x8349, 0x836a, 0x836a, 0x8b8a, 0x93cb, 0xa44d, 0xb4f0, 0xd5d4, 0xf6f9, 0xffbc, 0xfffe, 0xffde, 0xffde, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xf7de, 0xffde, 0xffde, 0xffbe, 0xffbd, 0xff7b, 0xe6d7, 0xd634, 0xbd10, 0x9c2c, 0x8bab, 0x8bcb, 0x8bcb, 0x8bcb, 0x8bcb, 0x8b8a, 0x8b8a, 0x836a, 0x8349, 0x7b28, 0x7308, 0x72e7, 0x72e7, 0x72e8, 0x72c7, 0x72e8, 0x72e8, 0x72c7, 0x7b08, 0x8349, 0x7b29, 0x72c7, 0x7b08, 0x72e8, 0x72c7, 0x6a86, 0x6a86, 0x6a86, 0x6a86, 0x6a86, 0x5a46, 0x5a46, 0x5a46, 0x6266, 0x6aa7, 0x6a86, 0x72e8, 0xac8e, 0xbcee, 0xde13, 0xe634, 0xc571, 0x7b49, 0x5205, 0x41a4, 0x3963, 0x5205, 0x5a46, 0x6266, 0x5a25, 0x6266, 0x72e8, 0x6aa7, 0x72e8, 0x72c8, 0x72e8, 0x7b09, 0x8349, 0x836a, 0x8baa, 0x8baa, 0x8baa, 0x7b29, 0x7b08, 0x7b29, 0x836a, 0x8b8a, 0x8bab, 0x93cb, 0x93ec, 0x9bec, 0xb4cf, 0xd5f4, 0xeef9, 0xff9b, 0xffdd, 0xffbd, 0xf7bd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffde, 0xffdd, 0xffdc, 0xf759, 0xde54, 0xbd70, 0x9c2d, 0x838a, 0x8349, 0x836a, 0x8369, 0x8349, 0x7b49, 0x7308, 0x7b29, 0x7b29, 0x7b08, 0x72e8, 0x6aa7, 0x6aa7, 0x72c7, 0x72c7, 0x72c7, 0x7b29, 0x8349, 0x7b29, 0x7b08, 0x7b29, 0x7b29, 0x72e8, 0x6ac7, 0x72e8, 0x6ac7, 0x6aa7, 0x6ac7, 0x6286, 0x5a45, 0x5a45, 0x5225, 0x5225, 0x5a25, 0x5a25, 0x6ac7, 0x72e8, 0x7b08, 0x9c2c, 0xb4ce, 0xcdb1, 0xcdb2, 0xa48e, 0x6aa7, 0x41a3, 0x3963, 0x3963, 0x41a3, 0x5205, 0x5a46, 0x51e5, 0x5225, 0x62a7, 0x6267, 0x62a7, 0x6a87, 0x6aa7, 0x72e8, 0x7b09, 0x7b49, 0x8369, 0x8369, 0x7b49, 0x836a, 0x836a, 0x836a, 0x8b8a, 0x8b8a, 0x836a, 0x836a, 0x836a, 0x93eb, 0x9c4c, 0xaccf, 0xc5b2, 0xe6b7, 0xf77a, 0xffbc, 0xffdc, 0xff9c, 0xffbd, 0xffbd, 0xffbd, 0xffbd, 0xffbe, 0xffde, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffbe, 0xff9d, 0xffbc, 0xff9b, 0xeef7, 0xc591, 0x9c6c, 0x838a, 0x7b29, 0x7b29, 0x7b29, 0x72e8, 0x6ac8, 0x72e8, 0x72e8, 0x6aa7, 0x6aa7, 0x6aa7, 0x6aa7, 0x6aa7, 0x6aa7, 0x72c8, 0x7b08, 0x72c7, 0x7b08, 0x8349, 0x7b29, 0x7b08, 0x72e8, 0x72c7, 0x72c7, 0x6287, 0x6ac8, 0x6ac7, 0x6aa7, 0x6ac8, 0x6287, 0x5a25, 0x5a45, 0x49e5, 0x5205, 0x5225, 0x5205, 0x6aa7, 0x7b29, 0x8349, 0x9c0c, 0xb4ce, 0xbd2f, 0xbd30, 0x93eb, 0x6287, 0x41a3, 0x3142, 0x3143, 0x3922, 0x51e5, 0x5a67, 0x49c4, 0x49c4, 0x5a46, 0x5a26, 0x5a67, 0x6267, 0x6287, 0x6ac8, 0x7308, 0x7b29, 0x7b29, 0x7b29, 0x7b29, 0x836a, 0x8b8a, 0x8bab, 0x8b8a, 0x836a, 0x8349, 0x8349, 0x8349, 0x93ca, 0x93ca, 0x940b, 0xacae, 0xc5b2, 0xe6b7, 0xff79, 0xffbb, 0xff7b, 0xff9b, 0xffbc, 0xffbd, 0xffbd, 0xffbe, 0xffde, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbc, 0xff9b, 0xf738, 0xde34, 0xacae, 0x8349, 0x7308, 0x6ae8, 0x72e8, 0x72e8, 0x6aa7, 0x6ac7, 0x7308, 0x7308, 0x72c8, 0x72e8, 0x72e8, 0x72e8, 0x72e8, 0x7b08, 0x7b29, 0x7b29, 0x7b29, 0x7b08, 0x7b08, 0x7b29, 0x7b08, 0x72e8, 0x6aa7, 0x6a86, 0x6287, 0x6aa7, 0x6287, 0x5a46, 0x6287, 0x5a46, 0x5205, 0x5a46, 0x49e5, 0x51e4, 0x5205, 0x51e4, 0x6266, 0x8349, 0x8bab, 0x9c2c, 0xac8d, 0xacae, 0xb4cf, 0x7b69, 0x6286, 0x41a4, 0x3122, 0x2902, 0x3101, 0x49e5, 0x5a46, 0x4183, 0x4183, 0x51e5, 0x5205, 0x5205, 0x5a26, 0x5a66, 0x62a7, 0x6ac8, 0x7308, 0x7329, 0x7b29, 0x7b49, 0x7b29, 0x836a, 0x8bab, 0x8b8a, 0x836a, 0x836a, 0x8b8a, 0x8b8a, 0x8369, 0x8b8a, 0x93eb, 0xa44d, 0xb4ef, 0xc592, 0xd634, 0xe675, 0xeef8, 0xf739, 0xff9b, 0xffbc, 0xffbd, 0xffbe, 0xffde, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbd, 0xffbc, 0xff7a, 0xe6d7, 0xcdd3, 0xacae, 0x836a, 0x6a87, 0x6286, 0x5a46, 0x6286, 0x62a7, 0x62a7, 0x6ac8, 0x7309, 0x72e8, 0x7b29, 0x7b29, 0x7b29, 0x7b29, 0x834a, 0x834a, 0x7b29, 0x7b29, 0x8349, 0x7b29, 0x72e8, 0x72e8, 0x72c7, 0x6aa7, 0x6266, 0x6266, 0x5a46, 0x6266, 0x5225, 0x49e4, 0x5a25, 0x5205, 0x49e4, 0x5a25, 0x5205, 0x49c4, 0x51e4, 0x49c3, 0x5a05, 0x7b29, 0x93cb, 0xa44d, 0xa44c, 0xacae, 0xacae, 0x62a7, 0x49e4, 0x3983, 0x2922, 0x20e1, 0x3122, 0x49e5, 0x5226, 0x3122, 0x3963, 0x49e5, 0x49e5, 0x41a4, 0x49c4, 0x5205, 0x5a66, 0x6287, 0x62a7, 0x6ac7, 0x7308, 0x7b29, 0x8349, 0x8b8a, 0x8bab, 0x8bab, 0x8bab, 0x8bab, 0x8b8a, 0x836a, 0x7b28, 0x8369, 0x8baa, 0x93cb, 0x9c0c, 0xa44d, 0xacaf, 0xb4f0, 0xd5f4, 0xde56, 0xeef8, 0xf77b, 0xff9c, 0xffbd, 0xffde, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xff9c, 0xff7b, 0xe6b7, 0xbd50, 0x8beb, 0x72e8, 0x6267, 0x6227, 0x5225, 0x49c4, 0x49e4, 0x5205, 0x5a45, 0x62a7, 0x6ac8, 0x62a7, 0x6aa7, 0x6aa7, 0x72c8, 0x72e8, 0x7b29, 0x7b29, 0x7b29, 0x7b09, 0x7b29, 0x72e8, 0x6aa7, 0x6a86, 0x6245, 0x5a04, 0x5a04, 0x5a04, 0x49e4, 0x5a46, 0x49e4, 0x49c4, 0x5205, 0x49e4, 0x41a3, 0x5205, 0x5226, 0x49c4, 0x49c4, 0x49a3, 0x51e4, 0x72e8, 0x93cb, 0xa46d, 0x9c2c, 0xacce, 0xacae, 0x5204, 0x3141, 0x3142, 0x3122, 0x28e1, 0x3963, 0x49e5, 0x4a05, 0x2901, 0x3963, 0x5205, 0x49c4, 0x3943, 0x4183, 0x49c4, 0x5226, 0x5a46, 0x5a45, 0x5a46, 0x62a7, 0x6ae8, 0x8349, 0x836a, 0x8b8a, 0x8bab, 0x93cb, 0x93ec, 0x8bab, 0x8349, 0x7ae8, 0x7b08, 0x7b09, 0x8329, 0x836a, 0x93ab, 0x9c0c, 0xa44d, 0xaccf, 0xc572, 0xd635, 0xeef9, 0xf75b, 0xf79d, 0xffde, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbb, 0xfffd, 0xffff, 0xffbf, 0xff9e, 0xffbe, 0xffbd, 0xffbc, 0xff7a, 0xe696, 0xb510, 0x7b6a, 0x5a66, 0x5225, 0x5226, 0x5246, 0x5206, 0x49e5, 0x49e5, 0x5205, 0x5225, 0x5a46, 0x62a7, 0x7309, 0x7b29, 0x7308, 0x72e8, 0x72e8, 0x7308, 0x7b29, 0x7b49, 0x7b49, 0x72e7, 0x6ac7, 0x6286, 0x6266, 0x5a25, 0x51e5, 0x49a4, 0x4184, 0x39a4, 0x49e5, 0x49e5, 0x49e5, 0x4183, 0x41a4, 0x5205, 0x4183, 0x4984, 0x49a4, 0x4163, 0x49a3, 0x49a3, 0x51e4, 0x6ac8, 0x7b4a, 0xacae, 0xcd92, 0x8bcb, 0x5204, 0x3942, 0x3942, 0x41a4, 0x28e1, 0x3143, 0x41c5, 0x3984, 0x3122, 0x3984, 0x49e5, 0x3143, 0x3122, 0x3963, 0x5205, 0x49e5, 0x49e5, 0x49c4, 0x49c4, 0x6266, 0x6286, 0x62a7, 0x7309, 0x7b4a, 0x838b, 0x8bab, 0x7b4a, 0x6ac8, 0x72e8, 0x72e7, 0x7328, 0x7b49, 0x7b49, 0x7b49, 0x8369, 0x8baa, 0x93eb, 0x93ea, 0xa46d, 0xd5f3, 0xff79, 0xfffc, 0xffbd, 0xf7be, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xfffe, 0xffde, 0xffbe, 0xffde, 0xfffe, 0xffbc, 0xf77a, 0xc592, 0x9c6e, 0x7b49, 0x62a7, 0x5225, 0x41a3, 0x3983, 0x41c4, 0x41a4, 0x41c4, 0x4a05, 0x5a66, 0x6287, 0x6266, 0x62a7, 0x6ac8, 0x7b29, 0x7b29, 0x7b29, 0x7b29, 0x7b49, 0x7b29, 0x7308, 0x6ac8, 0x7308, 0x6ac7, 0x6265, 0x5a25, 0x51e4, 0x49a4, 0x4984, 0x4183, 0x3983, 0x3142, 0x3983, 0x41a4, 0x3962, 0x3963, 0x49a3, 0x3942, 0x4163, 0x4184, 0x3963, 0x4183, 0x4183, 0x41a3, 0x5a66, 0x6ae8, 0x8baa, 0xcdb2, 0x8baa, 0x4183, 0x3942, 0x3963, 0x3143, 0x3964, 0x3963, 0x41a4, 0x3143, 0x2902, 0x41a4, 0x41c5, 0x2902, 0x2902, 0x41a4, 0x41a4, 0x4184, 0x3963, 0x4184, 0x49e5, 0x4a05, 0x5205, 0x5a46, 0x6aa7, 0x6ac8, 0x6ac8, 0x7309, 0x72e8, 0x6ac8, 0x72e8, 0x7b29, 0x7b49, 0x8369, 0x7b49, 0x7b29, 0x7b28, 0x7b49, 0x836a, 0x9c0b, 0xacae, 0xd613, 0xf759, 0xffdb, 0xffdd, 0xffde, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffbe, 0xffbe, 0xffde, 0xffdc, 0xef39, 0xce54, 0x93ec, 0x7308, 0x5a25, 0x5204, 0x49c4, 0x3962, 0x2901, 0x2901, 0x3122, 0x3142, 0x3983, 0x49e5, 0x5a46, 0x5a66, 0x62a7, 0x6ac8, 0x72e8, 0x72e8, 0x7309, 0x7309, 0x7309, 0x72e8, 0x6aa7, 0x6266, 0x6286, 0x6265, 0x5a45, 0x5a25, 0x5205, 0x51e4, 0x49c4, 0x49a3, 0x41a4, 0x3942, 0x3962, 0x3963, 0x3962, 0x3942, 0x3121, 0x3942, 0x3943, 0x3943, 0x3943, 0x3963, 0x3962, 0x3962, 0x51e4, 0x5a66, 0x6a86, 0xc571, 0x93eb, 0x49c4, 0x3101, 0x3963, 0x2902, 0x3984, 0x3143, 0x3963, 0x28e1, 0x2902, 0x41c5, 0x3963, 0x20c1, 0x2902, 0x4a06, 0x41a5, 0x3984, 0x3143, 0x3984, 0x4a06, 0x41a4, 0x41c4, 0x5205, 0x6266, 0x62a7, 0x6aa7, 0x6ae8, 0x7309, 0x72e8, 0x7309, 0x7b49, 0x7b49, 0x8369, 0x7b49, 0x7328, 0x72e8, 0x72e7, 0x72e7, 0x8349, 0x93eb, 0xacce, 0xc5b2, 0xde96, 0xe719, 0xf77c, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffbe, 0xff9d, 0xffbc, 0xf739, 0xcdd3, 0x9c8c, 0x7b29, 0x6ac7, 0x5a45, 0x49c4, 0x41a3, 0x3983, 0x3142, 0x28e1, 0x28e1, 0x2901, 0x3142, 0x4183, 0x49e5, 0x5a66, 0x6ae8, 0x7b29, 0x6ac8, 0x6ac8, 0x6ac8, 0x6ac7, 0x6aa7, 0x6aa7, 0x6287, 0x6287, 0x5a45, 0x5a45, 0x5a25, 0x5a25, 0x5205, 0x5204, 0x51e4, 0x51e4, 0x49c4, 0x51e4, 0x49a3, 0x3942, 0x4183, 0x3942, 0x28e0, 0x3962, 0x3122, 0x3122, 0x3942, 0x3963, 0x3942, 0x3962, 0x41a3, 0x5205, 0x5a24, 0xacae, 0xa48e, 0x7309, 0x28e1, 0x3943, 0x3122, 0x2902, 0x3122, 0x3143, 0x20c1, 0x3122, 0x49e5, 0x3122, 0x20c1, 0x3963, 0x41a5, 0x3984, 0x3144, 0x2923, 0x39a4, 0x41c5, 0x3984, 0x41e5, 0x5a66, 0x5a66, 0x5a46, 0x5a46, 0x62a7, 0x7309, 0x7b29, 0x7b4a, 0x7308, 0x7b29, 0x7b49, 0x7b49, 0x7b29, 0x72e8, 0x6ac7, 0x6aa7, 0x6266, 0x72e8, 0x8baa, 0xa48e, 0xc5f3, 0xef19, 0xff9c, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbf, 0xffbf, 0xffbe, 0xffbc, 0xff7a, 0xde55, 0xa48d, 0x7327, 0x6aa7, 0x5a66, 0x5204, 0x41a3, 0x41a3, 0x41a3, 0x3983, 0x3142, 0x3122, 0x3142, 0x3983, 0x49e5, 0x5a46, 0x6ac8, 0x7329, 0x7b29, 0x7309, 0x7309, 0x72e8, 0x6ac8, 0x6aa7, 0x6aa7, 0x6aa7, 0x6aa7, 0x6ac7, 0x6287, 0x5a25, 0x49c4, 0x49a3, 0x4183, 0x49a3, 0x49c3, 0x49a2, 0x51e4, 0x51e4, 0x4162, 0x3921, 0x3121, 0x3122, 0x3142, 0x3102, 0x3102, 0x3122, 0x3963, 0x3963, 0x3963, 0x41a3, 0x5205, 0x6265, 0x9c2c, 0xb4ef, 0x93ec, 0x3942, 0x3963, 0x3122, 0x20c1, 0x28e1, 0x3122, 0x20c1, 0x3963, 0x41a4, 0x28e1, 0x28e1, 0x41a4, 0x3944, 0x3984, 0x3123, 0x3984, 0x4a06, 0x41c5, 0x41c5, 0x5226, 0x5205, 0x51e4, 0x5205, 0x5a66, 0x6287, 0x62a7, 0x6aa7, 0x62a7, 0x72e8, 0x7309, 0x7b29, 0x7b29, 0x7b29, 0x7308, 0x6ac7, 0x6287, 0x6267, 0x6ac8, 0x7308, 0x8bcb, 0xbd51, 0xe6b7, 0xff7b, 0xffbc, 0xffdd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbf, 0xffbf, 0xffdd, 0xffbc, 0xeef7, 0xc571, 0x8baa, 0x6a85, 0x6286, 0x49c3, 0x3941, 0x3962, 0x4183, 0x3142, 0x3121, 0x3122, 0x3943, 0x3983, 0x49e4, 0x5226, 0x6287, 0x6ac8, 0x72e8, 0x6ac8, 0x7309, 0x7308, 0x72e8, 0x6ac8, 0x6287, 0x6266, 0x5a46, 0x5a46, 0x5a46, 0x5a46, 0x5a25, 0x51e4, 0x49a3, 0x4182, 0x4182, 0x4182, 0x4961, 0x4982, 0x51c3, 0x51e4, 0x3121, 0x28e0, 0x3983, 0x2901, 0x2902, 0x28e2, 0x3122, 0x3142, 0x3963, 0x3983, 0x41a4, 0x4a05, 0x72c7, 0x93eb, 0xb4cf, 0x8bab, 0x41a4, 0x41a4, 0x3122, 0x2902, 0x28e1, 0x3122, 0x28e1, 0x3963, 0x3963, 0x20c1, 0x3143, 0x41a4, 0x4184, 0x49c5, 0x4184, 0x5206, 0x5226, 0x3963, 0x4183, 0x41a3, 0x4183, 0x49c4, 0x6266, 0x6ac8, 0x5a66, 0x5225, 0x5a46, 0x6287, 0x72e8, 0x72e8, 0x7309, 0x7b29, 0x7b29, 0x7309, 0x6aa7, 0x6266, 0x6267, 0x6267, 0x6266, 0x6ae7, 0x942c, 0xc5b2, 0xe6d7, 0xf73a, 0xffbd, 0xffbd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbf, 0xffbe, 0xffbc, 0xff5a, 0xd614, 0x9c2c, 0x7ae7, 0x6a66, 0x5a45, 0x41a3, 0x3941, 0x3962, 0x3962, 0x3121, 0x28e1, 0x2901, 0x3963, 0x41a4, 0x4a05, 0x5246, 0x6287, 0x6ae8, 0x6ae8, 0x6aa7, 0x6ac8, 0x6ac8, 0x6aa7, 0x6287, 0x5a46, 0x5a25, 0x5205, 0x5205, 0x49c4, 0x51c5, 0x51e5, 0x5204, 0x51e4, 0x51e3, 0x51e3, 0x5204, 0x59c3, 0x5a03, 0x4982, 0x6266, 0x5a25, 0x3101, 0x3963, 0x2902, 0x28e2, 0x20c1, 0x28e2, 0x2902, 0x3122, 0x3963, 0x3983, 0x4a05, 0x8348, 0x93ab, 0xacae, 0x7b4a, 0x5205, 0x49c4, 0x3122, 0x20c1, 0x2902, 0x2902, 0x20c1, 0x3963, 0x2902, 0x20c1, 0x41a4, 0x3143, 0x4163, 0x4163, 0x5a26, 0x6ac8, 0x5205, 0x3941, 0x4162, 0x4982, 0x5a46, 0x5a46, 0x6266, 0x5a46, 0x49e4, 0x5205, 0x62a7, 0x7309, 0x6aa7, 0x6aa7, 0x6ac8, 0x72e8, 0x7309, 0x72e8, 0x6aa7, 0x5a46, 0x51c5, 0x51e5, 0x5a25, 0x62a6, 0x8389, 0xacef, 0xde75, 0xf739, 0xf79d, 0xffbd, 0xffbe, 0xffde, 0xffdf, 0xffde, 0xffdf, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffbd, 0xff9b, 0xeef7, 0xbd50, 0x8329, 0x6a45, 0x6a46, 0x51e4, 0x49e4, 0x49c3, 0x4183, 0x3962, 0x3962, 0x3142, 0x3122, 0x3963, 0x41c4, 0x5226, 0x6287, 0x6ae8, 0x7b29, 0x7329, 0x72e8, 0x6ac8, 0x6ac7, 0x6aa7, 0x6266, 0x5a45, 0x5a25, 0x5a46, 0x6266, 0x5a26, 0x5205, 0x49c4, 0x4183, 0x49a3, 0x5204, 0x6aa6, 0x7328, 0x6a65, 0x7ae7, 0x51a2, 0x72e8, 0x838a, 0x3962, 0x2901, 0x3143, 0x28e2, 0x20a1, 0x28c1, 0x28e1, 0x2901, 0x3143, 0x3963, 0x49e5, 0x8b8a, 0x8b6a, 0xacae, 0x7b29, 0x5225, 0x49c4, 0x3122, 0x1040, 0x3143, 0x2902, 0x20c1, 0x3122, 0x20c1, 0x20c1, 0x41c5, 0x20c1, 0x4983, 0x4963, 0x834a, 0x9bec, 0x72a7, 0x6245, 0x6a86, 0x7b08, 0x5a66, 0x5205, 0x5205, 0x5225, 0x5a46, 0x62a7, 0x6aa7, 0x5a25, 0x6266, 0x6266, 0x6287, 0x6ac8, 0x7309, 0x72e9, 0x6aa8, 0x6266, 0x51e6, 0x51e5, 0x5225, 0x5a24, 0x6285, 0x8bca, 0xc5b2, 0xeed7, 0xf79c, 0xf79d, 0xffbd, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffff, 0xffbd, 0xff9b, 0xe695, 0xa44c, 0x72c6, 0x6266, 0x5a26, 0x51c3, 0x49a2, 0x49c2, 0x49e2, 0x41a1, 0x4181, 0x3962, 0x3101, 0x28e1, 0x3142, 0x49c4, 0x6266, 0x6ae8, 0x7308, 0x6ac7, 0x6286, 0x6ac8, 0x6ac8, 0x6287, 0x5a46, 0x5205, 0x51e4, 0x5205, 0x5205, 0x5203, 0x5224, 0x5245, 0x5266, 0x5224, 0x6224, 0x82a5, 0x9b66, 0xcc46, 0xc448, 0xb3c7, 0x8ae4, 0x93c7, 0x62a4, 0x3122, 0x2904, 0x3122, 0x28e1, 0x20c1, 0x20c1, 0x28e1, 0x3122, 0x3143, 0x3963, 0x7b08, 0x8369, 0xa48e, 0x6ac8, 0x49c4, 0x3963, 0x3123, 0x1860, 0x2922, 0x3143, 0x2902, 0x3163, 0x2901, 0x3943, 0x2901, 0x2901, 0x51e4, 0x7ae5, 0xb48a, 0xb428, 0xc48a, 0xcccc, 0xd50c, 0xbc47, 0x7265, 0x61c3, 0x59e4, 0x5a46, 0x5a47, 0x5a67, 0x5a47, 0x51e5, 0x5a06, 0x5a46, 0x6267, 0x6a88, 0x6ac8, 0x72e9, 0x72e9, 0x6aa8, 0x5a68, 0x5206, 0x49c5, 0x49c4, 0x5225, 0x5a66, 0x83ca, 0xde55, 0xff3b, 0xffbd, 0xffde, 0xffde, 0xffff, 0xffff, 0xf7bd, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xf79c, 0xff7a, 0xde34, 0x9c0b, 0x6ac6, 0x6266, 0x5a05, 0x5204, 0x4182, 0x4161, 0x4161, 0x3960, 0x3941, 0x3101, 0x20a0, 0x3122, 0x3963, 0x49e4, 0x5a66, 0x6ac8, 0x7308, 0x7308, 0x72e8, 0x6ac8, 0x6287, 0x5a46, 0x5205, 0x51e4, 0x51e4, 0x5205, 0x5a25, 0x6aa6, 0x6a86, 0x6286, 0x6aa6, 0x72e6, 0x8b26, 0xa3c7, 0xbc49, 0xdce8, 0xdd0a, 0xd4ca, 0xabe7, 0xb469, 0x7b05, 0x3962, 0x28e3, 0x3122, 0x2902, 0x20c1, 0x20c1, 0x28e1, 0x3122, 0x3143, 0x3143, 0x6aa6, 0x836a, 0xaccf, 0x7309, 0x49e5, 0x3943, 0x28e2, 0x1860, 0x2922, 0x2943, 0x28e1, 0x3142, 0x2901, 0x3943, 0x3122, 0x3942, 0x6a44, 0x9387, 0xcd2c, 0xd50b, 0xe54d, 0xed8e, 0xe58d, 0xccc9, 0x9b68, 0x7aa6, 0x6a66, 0x6aa7, 0x6aa8, 0x6ac8, 0x6ac8, 0x6a87, 0x5205, 0x5a26, 0x5a46, 0x6267, 0x6aa8, 0x72e9, 0x72e9, 0x6aa8, 0x5a68, 0x5206, 0x51e6, 0x49e5, 0x5205, 0x5225, 0x7308, 0xb550, 0xeef9, 0xff7b, 0xffde, 0xffff, 0xffff, 0xf7de, 0xf7dd, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffbc, 0xf739, 0xc5b2, 0x8ba9, 0x6aa6, 0x5a46, 0x49a4, 0x4162, 0x3941, 0x4181, 0x41a2, 0x3961, 0x3141, 0x3942, 0x3963, 0x49e5, 0x5226, 0x6287, 0x6ac8, 0x72e8, 0x72e8, 0x72e8, 0x6ac7, 0x6287, 0x6266, 0x5a25, 0x51e4, 0x51e4, 0x5205, 0x5a46, 0x6266, 0x5a04, 0x51c3, 0x51c3, 0x6a64, 0x8b26, 0xabe7, 0xc489, 0xdce9, 0xe508, 0xed2a, 0xf56c, 0xdcea, 0xd52a, 0xa3e7, 0x5a03, 0x3923, 0x3122, 0x2902, 0x28e1, 0x28e1, 0x2902, 0x3122, 0x3122, 0x3143, 0x6265, 0x8b8a, 0xaccf, 0x72e8, 0x49c4, 0x3102, 0x20a1, 0x20a1, 0x2922, 0x2943, 0x20e1, 0x2922, 0x2901, 0x3943, 0x3942, 0x41a4, 0x82e6, 0xbc6a, 0xeded, 0xedac, 0xfdef, 0xfe10, 0xf5ce, 0xe56a, 0xd50d, 0xac2a, 0x8b47, 0x72e7, 0x6ac7, 0x6ae8, 0x72e8, 0x6aa7, 0x6267, 0x6287, 0x6287, 0x6287, 0x6aa8, 0x72e8, 0x6ac8, 0x6287, 0x49c5, 0x4184, 0x4184, 0x4183, 0x41a3, 0x41a3, 0x5a65, 0x944d, 0xe697, 0xf71a, 0xffdd, 0xffff, 0xf7de, 0xf7be, 0xffde, 0xffdd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffdc, 0xeef8, 0xb50f, 0x7b28, 0x6285, 0x5205, 0x3122, 0x3101, 0x3942, 0x49c3, 0x4a03, 0x4182, 0x3101, 0x3121, 0x3963, 0x41a3, 0x5205, 0x62a8, 0x7329, 0x7b29, 0x7309, 0x72e8, 0x6ac7, 0x6266, 0x5a46, 0x5a25, 0x5a25, 0x5a46, 0x6266, 0x6287, 0x6287, 0x6226, 0x6204, 0x6a44, 0x8b26, 0xb408, 0xccc9, 0xe549, 0xf58a, 0xe508, 0xed29, 0xfd6b, 0xf54a, 0xed8a, 0xc4a9, 0x7ac5, 0x4963, 0x3122, 0x3122, 0x2902, 0x2902, 0x2902, 0x3122, 0x3122, 0x3122, 0x6aa6, 0x93cb, 0xa48e, 0x5a46, 0x3963, 0x28c1, 0x20a1, 0x2902, 0x2922, 0x3143, 0x20e1, 0x2922, 0x2902, 0x3142, 0x3942, 0x49c4, 0xa3a8, 0xdd2c, 0xfe0d, 0xf5cc, 0xfdce, 0xfdee, 0xf5ad, 0xedab, 0xe58d, 0xbc8a, 0x9366, 0x6aa5, 0x5a44, 0x5a45, 0x5a65, 0x5a45, 0x6aa7, 0x6ac8, 0x6ac8, 0x6ac8, 0x7309, 0x7b4a, 0x7b29, 0x72e8, 0x6288, 0x5226, 0x49e5, 0x49a4, 0x41a3, 0x41a3, 0x5205, 0x838a, 0xd615, 0xf73a, 0xffdd, 0xffde, 0xfffe, 0xffff, 0xffde, 0xffbd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xff9c, 0xde76, 0xa48d, 0x72e7, 0x5a45, 0x49c4, 0x2902, 0x3122, 0x3121, 0x3941, 0x3961, 0x3141, 0x28e0, 0x20a0, 0x20c1, 0x3142, 0x49c4, 0x6287, 0x7309, 0x7329, 0x72e8, 0x6ac7, 0x6aa7, 0x6266, 0x6266, 0x6266, 0x6287, 0x6287, 0x6266, 0x5a46, 0x5205, 0x59e5, 0x6204, 0x7aa5, 0xa387, 0xc468, 0xdce9, 0xe528, 0xed48, 0xf58a, 0xf54a, 0xf54a, 0xfd49, 0xf569, 0xdd2a, 0x8b26, 0x4962, 0x3122, 0x3122, 0x2902, 0x2902, 0x3122, 0x3122, 0x3122, 0x3122, 0x72c7, 0x8baa, 0x9c2d, 0x51e4, 0x3122, 0x28c1, 0x20c1, 0x3143, 0x2943, 0x3143, 0x2901, 0x2922, 0x3122, 0x3122, 0x3122, 0x49c4, 0xb3c8, 0xe54c, 0xfdec, 0xf5ab, 0xfdad, 0xfdce, 0xf5ac, 0xedcb, 0xe54b, 0xc489, 0x9366, 0x72a4, 0x6265, 0x62a6, 0x6ac7, 0x6ac8, 0x6aa7, 0x6ac8, 0x72e8, 0x72e8, 0x7b29, 0x836a, 0x7b4a, 0x7309, 0x7309, 0x6287, 0x5a46, 0x49e4, 0x41a4, 0x4183, 0x41a3, 0x62a7, 0xbd51, 0xf739, 0xffdd, 0xf79d, 0xffff, 0xffff, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xffbc, 0xf719, 0xcdd3, 0x940b, 0x6ac6, 0x5224, 0x3983, 0x28e2, 0x28c1, 0x3101, 0x3101, 0x28e0, 0x20c0, 0x20c0, 0x28e1, 0x3144, 0x5205, 0x5a67, 0x6ae8, 0x7329, 0x7309, 0x6ac8, 0x6aa7, 0x6286, 0x6266, 0x6287, 0x6287, 0x6287, 0x5a46, 0x5205, 0x49a3, 0x4183, 0x4162, 0x51a2, 0x7263, 0xa386, 0xcc88, 0xe509, 0xed49, 0xf569, 0xfdec, 0xf58b, 0xf529, 0xf528, 0xf528, 0xe56a, 0x9366, 0x5183, 0x3122, 0x2902, 0x2902, 0x2902, 0x2902, 0x3122, 0x3122, 0x3122, 0x6a86, 0x8349, 0x93ec, 0x51e4, 0x3122, 0x28e1, 0x28e2, 0x3123, 0x2943, 0x3163, 0x2902, 0x2922, 0x3142, 0x3122, 0x3121, 0x49c4, 0xab86, 0xe52b, 0xf5ab, 0xfdcb, 0xfdcd, 0xfdee, 0xf5cd, 0xedcc, 0xf5cc, 0xdd2b, 0xabe8, 0x7ae5, 0x6a85, 0x6286, 0x6287, 0x6aa8, 0x6287, 0x6aa7, 0x6ac8, 0x72e8, 0x7309, 0x7b4a, 0x7b4a, 0x7b29, 0x6287, 0x5225, 0x5205, 0x49c4, 0x41a4, 0x41a4, 0x4183, 0x5205, 0x93eb, 0xde76, 0xffbc, 0xffbd, 0xffff, 0xffde, 0xff9e, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xff7b, 0xe697, 0xb510, 0x8baa, 0x6aa5, 0x49c3, 0x3122, 0x20c2, 0x28a1, 0x3943, 0x3962, 0x28e0, 0x20c0, 0x28e1, 0x3164, 0x49e6, 0x5a67, 0x62a8, 0x7309, 0x7329, 0x7309, 0x6ac8, 0x6aa7, 0x6a87, 0x6266, 0x6266, 0x6266, 0x5a46, 0x5205, 0x49c4, 0x4183, 0x4162, 0x3982, 0x4181, 0x6201, 0x9324, 0xc447, 0xe4e9, 0xed4a, 0xed6a, 0xedab, 0xed6b, 0xf529, 0xf528, 0xed06, 0xe56a, 0x9387, 0x51c4, 0x3122, 0x2902, 0x28e1, 0x28e1, 0x2902, 0x3122, 0x3122, 0x3122, 0x5a24, 0x72c7, 0x93ec, 0x5a25, 0x3122, 0x28e1, 0x2902, 0x2902, 0x2922, 0x3143, 0x2902, 0x2902, 0x3142, 0x2901, 0x3101, 0x49e5, 0xaba6, 0xdd2a, 0xed8a, 0xfdec, 0xfdcd, 0xfe0f, 0xedcd, 0xedec, 0xe529, 0xd4c9, 0xa3a6, 0x7284, 0x6204, 0x5a05, 0x5a06, 0x6247, 0x5a25, 0x6266, 0x6286, 0x6aa7, 0x72e8, 0x7b49, 0x838a, 0x8bab, 0x7309, 0x6287, 0x5a66, 0x5205, 0x49c4, 0x49c4, 0x4184, 0x49c4, 0x6285, 0xacef, 0xef39, 0xfffe, 0xffde, 0xffbe, 0xffbe, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xff7b, 0xde56, 0xaccf, 0x8389, 0x6285, 0x3982, 0x20c1, 0x1881, 0x28c1, 0x3963, 0x3142, 0x28e0, 0x2921, 0x3983, 0x39a5, 0x41c6, 0x5205, 0x5a66, 0x6ac8, 0x72e8, 0x6ae8, 0x6aa7, 0x6266, 0x5a45, 0x5a46, 0x5a46, 0x5a46, 0x5205, 0x51e4, 0x49c4, 0x49c4, 0x49c4, 0x4204, 0x49c1, 0x59e0, 0x8ac3, 0xbc06, 0xe4ea, 0xed4b, 0xed6b, 0xe58b, 0xed8b, 0xf54a, 0xf527, 0xe4c5, 0xdd29, 0x8b46, 0x51c4, 0x3122, 0x2902, 0x28e1, 0x28e1, 0x2902, 0x2902, 0x3122, 0x3122, 0x51e3, 0x6a86, 0x940c, 0x5a46, 0x3101, 0x28e1, 0x3123, 0x3123, 0x2922, 0x3143, 0x28e1, 0x20e1, 0x3142, 0x2901, 0x3121, 0x5205, 0xb3c7, 0xe54b, 0xed6a, 0xfdcc, 0xf5ad, 0xfe0f, 0xedee, 0xe5ed, 0xed29, 0xdce9, 0xabc7, 0x7284, 0x5a04, 0x59e5, 0x5206, 0x6248, 0x5a45, 0x6266, 0x6287, 0x6286, 0x6ac7, 0x7b29, 0x8bab, 0x8bcb, 0x838a, 0x6ac8, 0x5a66, 0x49c4, 0x4183, 0x4163, 0x3942, 0x3963, 0x49c2, 0x8bca, 0xde97, 0xfffe, 0xffde, 0xffbe, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffd, 0xfffe, 0xffde, 0xffdf, 0xffdf, 0xffbf, 0xffbe, 0xffbe, 0xff59, 0xcdb2, 0xa46d, 0x7309, 0x41a3, 0x2901, 0x18a0, 0x20e1, 0x3141, 0x3142, 0x2901, 0x2901, 0x3963, 0x3143, 0x3142, 0x41c5, 0x5a46, 0x72e8, 0x7328, 0x7307, 0x7307, 0x6ae7, 0x6aa7, 0x6aa7, 0x6a86, 0x6a87, 0x5a46, 0x5a25, 0x49c4, 0x3963, 0x3963, 0x3122, 0x30c2, 0x51c4, 0x5a23, 0x6a62, 0x9ba5, 0xd4e9, 0xed6b, 0xf56b, 0xdd8c, 0xe54b, 0xf54b, 0xed08, 0xe4e6, 0xccc7, 0x8b25, 0x4142, 0x3122, 0x3143, 0x3143, 0x3122, 0x2902, 0x2902, 0x3122, 0x3963, 0x3962, 0x6287, 0x8bec, 0x5a46, 0x28e1, 0x28e1, 0x2922, 0x3142, 0x2922, 0x2901, 0x2902, 0x28e1, 0x3122, 0x3142, 0x3122, 0x49e5, 0xb3c6, 0xdd0b, 0xed8d, 0xf58c, 0xf5ac, 0xf5cd, 0xfe0e, 0xf5ee, 0xe54c, 0xbc29, 0x82e6, 0x6246, 0x5206, 0x49e5, 0x4a25, 0x5244, 0x5a46, 0x5a67, 0x6267, 0x6266, 0x6a87, 0x72e8, 0x836a, 0x93cb, 0x7b2a, 0x62a8, 0x5205, 0x41a3, 0x3962, 0x3921, 0x3941, 0x4182, 0x5a06, 0x6ac7, 0xcdf2, 0xffba, 0xff9c, 0xffff, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffd, 0xfffd, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffde, 0xffbe, 0xf6d7, 0xc551, 0x940c, 0x62a7, 0x3962, 0x20e1, 0x18c0, 0x20e1, 0x2921, 0x3141, 0x2901, 0x28e1, 0x2901, 0x28e1, 0x2902, 0x3984, 0x5a25, 0x6ac7, 0x7308, 0x7307, 0x72e7, 0x6aa6, 0x5a46, 0x5a46, 0x6266, 0x6266, 0x5205, 0x49c4, 0x4163, 0x3122, 0x3942, 0x3122, 0x3944, 0x3943, 0x4161, 0x51a0, 0x7aa2, 0xc468, 0xed4b, 0xed2a, 0xdd4b, 0xdce9, 0xece9, 0xecc7, 0xdcc6, 0xc487, 0x7ac5, 0x3921, 0x2902, 0x3122, 0x3143, 0x3122, 0x2902, 0x2902, 0x3122, 0x3963, 0x3121, 0x5a46, 0x83ac, 0x5a46, 0x2901, 0x28e1, 0x2922, 0x3122, 0x3122, 0x2922, 0x3122, 0x2901, 0x3122, 0x3142, 0x3122, 0x41c5, 0xab85, 0xdcea, 0xed6c, 0xf5ac, 0xf5ac, 0xed8c, 0xed8c, 0xe56b, 0xbc28, 0x9305, 0x61e2, 0x4141, 0x3102, 0x3963, 0x41a3, 0x41c3, 0x5226, 0x5a46, 0x5a66, 0x6266, 0x6a87, 0x72e8, 0x834a, 0x8bab, 0x83ac, 0x72e9, 0x5a46, 0x51e4, 0x49e4, 0x49c3, 0x41a3, 0x4182, 0x51e6, 0x62a6, 0xbd90, 0xff79, 0xff9c, 0xffde, 0xffdf, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffd, 0xffdd, 0xffde, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffbd, 0xddf3, 0xb4cf, 0x8b8a, 0x5205, 0x2901, 0x20e0, 0x18c0, 0x18c1, 0x20e0, 0x2901, 0x2901, 0x2901, 0x2901, 0x2902, 0x3963, 0x49e5, 0x5a46, 0x72e8, 0x7b49, 0x7b28, 0x7307, 0x6aa6, 0x5a46, 0x5a46, 0x6266, 0x5a25, 0x49a3, 0x4163, 0x3942, 0x3943, 0x41a4, 0x41a4, 0x5a68, 0x49e5, 0x49c4, 0x51e2, 0x6201, 0xa385, 0xdce9, 0xe509, 0xe52a, 0xdca8, 0xe4a7, 0xe4c7, 0xd486, 0xabc5, 0x6223, 0x28c0, 0x28e1, 0x2902, 0x3122, 0x3122, 0x2902, 0x2902, 0x3122, 0x3143, 0x28e1, 0x5225, 0x7b6b, 0x5246, 0x3122, 0x2901, 0x2922, 0x2922, 0x3143, 0x3122, 0x3142, 0x2902, 0x3122, 0x3142, 0x3122, 0x39a4, 0x9b44, 0xd4c9, 0xed4b, 0xed6a, 0xed4a, 0xe54a, 0xe56b, 0xd50a, 0x9b66, 0x69e2, 0x4120, 0x3942, 0x3122, 0x2901, 0x3962, 0x41a3, 0x49e5, 0x5205, 0x5a46, 0x6266, 0x6287, 0x72c8, 0x8349, 0x8bab, 0x8bcc, 0x7309, 0x5a26, 0x49e4, 0x5204, 0x5204, 0x49c3, 0x4182, 0x49c5, 0x5a45, 0xacee, 0xef38, 0xffbc, 0xffbe, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xffdd, 0xffde, 0xffdf, 0xffde, 0xfffe, 0xffdd, 0xf77b, 0xc550, 0xa44d, 0x7b49, 0x49a3, 0x20c0, 0x20c0, 0x18a0, 0x18a0, 0x20e0, 0x28e0, 0x2901, 0x2901, 0x3122, 0x3963, 0x41e5, 0x5226, 0x6267, 0x7b29, 0x8369, 0x7b48, 0x7307, 0x6aa6, 0x5a46, 0x5a46, 0x6287, 0x5205, 0x4183, 0x4163, 0x41a4, 0x49c4, 0x4a06, 0x5226, 0x4a27, 0x41c5, 0x41c5, 0x41a3, 0x4961, 0x7242, 0xb3e6, 0xdce9, 0xdcc9, 0xdc67, 0xdc66, 0xdca7, 0xc426, 0x8b04, 0x49a2, 0x20c1, 0x28e1, 0x28e1, 0x2902, 0x2902, 0x2902, 0x3122, 0x3122, 0x3143, 0x28e0, 0x5205, 0x7329, 0x5205, 0x3142, 0x2902, 0x2922, 0x2902, 0x3963, 0x3122, 0x3143, 0x2902, 0x2902, 0x3142, 0x2902, 0x3143, 0x82c2, 0xc488, 0xe50a, 0xe4e8, 0xe4e8, 0xe52a, 0xdd4b, 0xc4c9, 0x82e6, 0x59c2, 0x49a3, 0x5a46, 0x5226, 0x41e5, 0x49c4, 0x41a3, 0x41a4, 0x49c4, 0x5a26, 0x6266, 0x6a87, 0x72c8, 0x8349, 0x8bab, 0x83ac, 0x6ac8, 0x49c4, 0x3962, 0x4182, 0x49a3, 0x41a3, 0x4182, 0x4184, 0x51e4, 0x944b, 0xe6d7, 0xffdd, 0xffbe, 0xffbe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xffde, 0xfffe, 0xffff, 0xffde, 0xfffe, 0xffbc, 0xe6f9, 0xb4cf, 0x9c2c, 0x7b08, 0x4183, 0x20c0, 0x20c0, 0x1880, 0x10a0, 0x2901, 0x2901, 0x28e0, 0x28e1, 0x2922, 0x3963, 0x39a4, 0x41c5, 0x5a46, 0x72e8, 0x7b28, 0x7307, 0x6ac6, 0x6286, 0x5a25, 0x5a46, 0x5a66, 0x49e4, 0x4183, 0x41a4, 0x49e5, 0x49e5, 0x41a4, 0x3984, 0x2101, 0x20e1, 0x18a1, 0x20c1, 0x3921, 0x5181, 0x7aa3, 0xb407, 0xc3e7, 0xcc26, 0xcc46, 0xc447, 0xa386, 0x6a43, 0x3942, 0x2902, 0x20c1, 0x28e1, 0x2902, 0x2902, 0x2902, 0x3122, 0x3122, 0x3143, 0x3101, 0x5205, 0x6ae8, 0x49e5, 0x3142, 0x2902, 0x2902, 0x2902, 0x3163, 0x3122, 0x3143, 0x2902, 0x2901, 0x3122, 0x2901, 0x2922, 0x6201, 0xabe7, 0xcca9, 0xd4a8, 0xdce9, 0xdd2a, 0xc4aa, 0x9386, 0x59e4, 0x51e4, 0x5225, 0x5246, 0x5246, 0x5a88, 0x5a67, 0x4183, 0x4183, 0x41a4, 0x5205, 0x6266, 0x6a87, 0x72c8, 0x8349, 0x93cb, 0x838b, 0x6ae9, 0x5205, 0x3962, 0x3942, 0x3962, 0x4162, 0x3962, 0x4143, 0x49a3, 0x8389, 0xd675, 0xffdd, 0xffde, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xffde, 0xffff, 0xffff, 0xffde, 0xfffe, 0xffbb, 0xdeb7, 0xb4ce, 0x9c0c, 0x72e8, 0x4182, 0x28e0, 0x20c0, 0x1080, 0x18a0, 0x20e0, 0x2900, 0x20e0, 0x20a0, 0x28e1, 0x2922, 0x3122, 0x3143, 0x5a46, 0x72e8, 0x7b28, 0x7307, 0x6ae7, 0x6286, 0x6266, 0x6287, 0x5a26, 0x49c4, 0x41a4, 0x41c4, 0x41a4, 0x3963, 0x20c1, 0x20c1, 0x18a0, 0x1080, 0x0820, 0x1881, 0x3143, 0x4182, 0x51a1, 0x6a42, 0x9b26, 0xb3c7, 0xb406, 0x9b85, 0x7284, 0x4161, 0x28e1, 0x20e2, 0x28e1, 0x28e1, 0x2902, 0x2902, 0x3122, 0x3122, 0x3122, 0x3143, 0x3101, 0x5205, 0x62a8, 0x49e4, 0x3963, 0x3122, 0x2922, 0x2902, 0x3143, 0x2902, 0x3143, 0x2922, 0x2901, 0x3142, 0x2922, 0x2901, 0x4161, 0x7ae5, 0xa3a7, 0xc448, 0xd4ca, 0xc48a, 0x8b67, 0x5a22, 0x41a4, 0x3984, 0x3163, 0x2942, 0x2942, 0x41e5, 0x5226, 0x49c5, 0x4183, 0x41a4, 0x49e4, 0x6266, 0x6aa7, 0x72c8, 0x8349, 0x93cb, 0x8bac, 0x7b4a, 0x6287, 0x49e4, 0x4183, 0x4182, 0x3962, 0x3941, 0x3102, 0x3961, 0x62c5, 0xc5b2, 0xffbc, 0xffde, 0xffbe, 0xf7bd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xffde, 0xffdf, 0xffff, 0xffde, 0xfffd, 0xffbb, 0xdeb6, 0xb4cf, 0x9c0c, 0x72c7, 0x3962, 0x28e0, 0x20c0, 0x1880, 0x20e1, 0x2901, 0x3982, 0x3162, 0x2901, 0x2901, 0x2901, 0x2901, 0x3143, 0x5a25, 0x72e8, 0x7b49, 0x7b28, 0x7307, 0x6ac7, 0x6aa7, 0x6ac8, 0x5205, 0x49c4, 0x49c4, 0x41a4, 0x3963, 0x2902, 0x2902, 0x3163, 0x5a65, 0x41e4, 0x39a5, 0x3144, 0x20e2, 0x2922, 0x3962, 0x3100, 0x6a04, 0x8b26, 0x8b25, 0x6a63, 0x4981, 0x28c1, 0x20c1, 0x18c1, 0x28e1, 0x28e1, 0x2902, 0x3122, 0x3122, 0x3122, 0x3122, 0x3122, 0x28e1, 0x49e5, 0x6287, 0x49e5, 0x41a4, 0x3163, 0x3142, 0x2922, 0x3143, 0x2902, 0x3163, 0x3122, 0x2902, 0x3963, 0x3142, 0x2902, 0x3122, 0x51c3, 0x7243, 0xa366, 0xabe8, 0x8305, 0x5a44, 0x41e4, 0x39a6, 0x2923, 0x2102, 0x2122, 0x2101, 0x2922, 0x3963, 0x49a5, 0x49e5, 0x49a4, 0x49e4, 0x6266, 0x6aa7, 0x72c8, 0x7b29, 0x8bab, 0x8bcc, 0x7b6b, 0x62a7, 0x5205, 0x49c4, 0x49c3, 0x41a3, 0x3941, 0x28a1, 0x3100, 0x4a02, 0xa4ef, 0xf77b, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffff, 0xf7be, 0xffde, 0xfffe, 0xffbd, 0xfffd, 0xffdb, 0xdeb6, 0xb4ef, 0x9c0c, 0x6aa7, 0x3942, 0x20c0, 0x20c0, 0x18a0, 0x2922, 0x41a3, 0x5266, 0x5246, 0x39a3, 0x3142, 0x28e1, 0x28e1, 0x3143, 0x49c4, 0x6aa7, 0x7328, 0x7328, 0x7307, 0x6aa6, 0x6287, 0x6aa7, 0x5226, 0x49e5, 0x49e5, 0x3984, 0x3122, 0x2922, 0x41c5, 0x62ea, 0xcdb2, 0xacf0, 0x9c90, 0x630a, 0x10a1, 0x18c2, 0x39c5, 0x2922, 0x38e1, 0x6223, 0x6242, 0x4180, 0x3100, 0x28c1, 0x2902, 0x2102, 0x28e1, 0x2902, 0x2902, 0x3122, 0x3122, 0x3122, 0x3122, 0x3122, 0x28c0, 0x49e4, 0x5a87, 0x49e5, 0x49e5, 0x3983, 0x3143, 0x2922, 0x3143, 0x2902, 0x3963, 0x3143, 0x3122, 0x3984, 0x3963, 0x3122, 0x2924, 0x3101, 0x4920, 0x7a64, 0x82a5, 0x5181, 0x41a3, 0x5288, 0x2945, 0x3165, 0x39c5, 0x39e5, 0x39c4, 0x3143, 0x30e2, 0x30c1, 0x5205, 0x49c4, 0x49e4, 0x6266, 0x6aa7, 0x72c8, 0x7b29, 0x8b8b, 0x8bac, 0x732a, 0x5a46, 0x49a3, 0x41a3, 0x49e4, 0x49c3, 0x4182, 0x2080, 0x28c0, 0x3960, 0x944d, 0xef3a, 0xffdf, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffff, 0xffff, 0xffde, 0xffde, 0xfffe, 0xf79c, 0xe6fa, 0xbcee, 0x9c2c, 0x6aa7, 0x3142, 0x20c1, 0x18a0, 0x1880, 0x20a0, 0x7b4c, 0xd657, 0xc5b4, 0x9c6e, 0x83ab, 0x49c4, 0x30e1, 0x3102, 0x49a4, 0x5a26, 0x7308, 0x7b48, 0x72e7, 0x6ac7, 0x6aa7, 0x5a46, 0x5a26, 0x49e5, 0x4184, 0x3102, 0x4164, 0x3102, 0x41a5, 0xc595, 0xf6f6, 0xacef, 0x7b8b, 0x5248, 0x20a2, 0x28e2, 0x5226, 0x6266, 0x3142, 0x3122, 0x28c1, 0x20a0, 0x20c0, 0x20a0, 0x20a1, 0x2902, 0x20e1, 0x2902, 0x2901, 0x2902, 0x3963, 0x3163, 0x2922, 0x3122, 0x3122, 0x41a4, 0x6267, 0x5a05, 0x4183, 0x3963, 0x3143, 0x2103, 0x3143, 0x3143, 0x3122, 0x3143, 0x3143, 0x3143, 0x3143, 0x3122, 0x3122, 0x28c1, 0x3143, 0x41a4, 0x3963, 0x3984, 0x5a88, 0x3143, 0x3185, 0x4a48, 0x7bce, 0xad54, 0x9470, 0x4a27, 0x2943, 0x2923, 0x4184, 0x49e5, 0x5a46, 0x5a67, 0x5a66, 0x7309, 0x8b8b, 0x8bab, 0x7b6a, 0x6ac8, 0x5226, 0x4184, 0x28e2, 0x2902, 0x3162, 0x3162, 0x20e2, 0x18a0, 0x2901, 0x5a87, 0xe6b7, 0xfffd, 0xffbd, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffff, 0xffff, 0xffbe, 0xffde, 0xfffe, 0xf79c, 0xe71a, 0xc52f, 0x9c2c, 0x62a7, 0x3142, 0x20c1, 0x20c0, 0x20a0, 0x28e1, 0xb554, 0xfffe, 0xfffd, 0xf75a, 0xde76, 0x838b, 0x4184, 0x3923, 0x4164, 0x5205, 0x72e8, 0x7b49, 0x7307, 0x6ac7, 0x6aa7, 0x5a46, 0x5205, 0x3942, 0x28e1, 0x4184, 0x6ac9, 0x49a5, 0x3964, 0xb512, 0xb52f, 0x7b69, 0x62a8, 0x5a69, 0x41a6, 0x41a5, 0x6288, 0x7b29, 0x49e5, 0x3962, 0x28e1, 0x20c1, 0x20c1, 0x20c1, 0x28e1, 0x2902, 0x2901, 0x3122, 0x2902, 0x2922, 0x3963, 0x3963, 0x3122, 0x3142, 0x3983, 0x5205, 0x6266, 0x5a05, 0x49c4, 0x41c4, 0x3143, 0x2923, 0x3143, 0x3143, 0x3122, 0x3143, 0x3963, 0x3963, 0x3963, 0x3143, 0x3122, 0x28e1, 0x3102, 0x3143, 0x3143, 0x49e5, 0x734b, 0x5226, 0x2985, 0x52aa, 0x7bee, 0xc5f6, 0xce58, 0x7bad, 0x3985, 0x3984, 0x3963, 0x4184, 0x5226, 0x6aa8, 0x6ae8, 0x7b29, 0x8bcc, 0x93ec, 0x7b6a, 0x6ae8, 0x5a67, 0x5206, 0x4184, 0x3983, 0x3982, 0x2941, 0x20c1, 0x18a0, 0x28c1, 0x5205, 0xd615, 0xfffd, 0xffdd, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffff, 0xffff, 0xffbe, 0xffde, 0xfffe, 0xffbd, 0xef5b, 0xd5b1, 0x9c2c, 0x62a7, 0x3142, 0x20c1, 0x20c1, 0x20c0, 0x3122, 0xd658, 0xfffe, 0xff9c, 0xf739, 0xd635, 0x7b4a, 0x4183, 0x3963, 0x4164, 0x5205, 0x72e8, 0x8369, 0x7b28, 0x6ac7, 0x6aa7, 0x6266, 0x49c4, 0x3122, 0x28c0, 0x49c5, 0x838c, 0x6288, 0x3943, 0x838c, 0x8beb, 0x6ae8, 0x5a87, 0x5aa9, 0x5aa9, 0x62c9, 0x83ac, 0xa48e, 0x62c8, 0x3983, 0x28e1, 0x28e1, 0x20c1, 0x28c1, 0x3102, 0x2902, 0x2922, 0x3122, 0x3122, 0x3122, 0x3163, 0x3163, 0x3142, 0x3163, 0x3984, 0x5226, 0x5a46, 0x5a05, 0x5a05, 0x49e5, 0x3143, 0x3164, 0x3143, 0x3122, 0x3122, 0x3143, 0x3963, 0x3984, 0x3984, 0x3984, 0x3122, 0x2902, 0x2902, 0x3102, 0x41a4, 0x732a, 0xacf1, 0x8c0e, 0x4207, 0x5aea, 0x736c, 0xb574, 0xd678, 0x736c, 0x3163, 0x5268, 0x5226, 0x41a4, 0x51e5, 0x6ac8, 0x7329, 0x7b4a, 0x8b8b, 0x93cc, 0x838b, 0x6ae9, 0x5a67, 0x5206, 0x41a5, 0x41a4, 0x3983, 0x2921, 0x18a1, 0x1880, 0x20a0, 0x4183, 0xb532, 0xffbc, 0xffdd, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffff, 0xffde, 0xffbe, 0xffde, 0xfffe, 0xffdd, 0xf79c, 0xddf2, 0x9c0b, 0x62a7, 0x3142, 0x20c1, 0x20c1, 0x20a0, 0x3942, 0xde9a, 0xffbe, 0xff9c, 0xff7a, 0xde96, 0x8bec, 0x5205, 0x49e5, 0x49a4, 0x5a26, 0x7b29, 0x8baa, 0x7b49, 0x6ae7, 0x6aa7, 0x6287, 0x49e4, 0x49c4, 0x3942, 0x3963, 0x6ae9, 0x730a, 0x49c5, 0x49c5, 0x7308, 0x7309, 0x62c8, 0x5268, 0x5268, 0x6ae9, 0x8bed, 0xaccf, 0x7b6a, 0x41a3, 0x28e1, 0x2902, 0x20c1, 0x28e1, 0x3123, 0x28e2, 0x2922, 0x3122, 0x3122, 0x3142, 0x3143, 0x3143, 0x3142, 0x3143, 0x3142, 0x5225, 0x5a46, 0x5a05, 0x6246, 0x51e5, 0x3143, 0x3164, 0x3143, 0x3122, 0x3122, 0x3143, 0x3963, 0x3984, 0x3984, 0x3984, 0x3122, 0x3122, 0x3122, 0x2902, 0x49e5, 0x8bed, 0xc5b4, 0xacf1, 0x6b2b, 0x630a, 0x6b0b, 0x9cb1, 0xa4f2, 0x4a26, 0x3964, 0x7b8c, 0x6b09, 0x49e5, 0x41a4, 0x6267, 0x7329, 0x836a, 0x838b, 0x8bab, 0x7b6a, 0x6287, 0x4184, 0x3102, 0x28e2, 0x2902, 0x2921, 0x20e0, 0x1880, 0x1860, 0x20a0, 0x3122, 0x9c4e, 0xf77b, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdf, 0xffff, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xffbd, 0xe633, 0x9c0b, 0x62a7, 0x3142, 0x20c1, 0x20c1, 0x1880, 0x41a4, 0xe6bb, 0xffbe, 0xffdd, 0xff9b, 0xdeb7, 0x944d, 0x5266, 0x41a3, 0x4984, 0x5a26, 0x7b29, 0x83aa, 0x7b48, 0x72e7, 0x6ac7, 0x6aa7, 0x5a66, 0x5a45, 0x49c4, 0x3942, 0x5205, 0x7309, 0x6267, 0x4184, 0x5205, 0x6287, 0x5a67, 0x4205, 0x41e5, 0x5226, 0x6ae8, 0x8bab, 0x734a, 0x3983, 0x28e1, 0x3102, 0x28e1, 0x28e1, 0x3123, 0x28e2, 0x2902, 0x2902, 0x3122, 0x3143, 0x3142, 0x3142, 0x3142, 0x3122, 0x3122, 0x6246, 0x72c7, 0x6aa7, 0x6aa7, 0x51e5, 0x3143, 0x3984, 0x3143, 0x3122, 0x3122, 0x3143, 0x3963, 0x3984, 0x3984, 0x3984, 0x3143, 0x3963, 0x3143, 0x28e1, 0x41a4, 0x732a, 0x9c90, 0x8bed, 0x738c, 0x5aa9, 0x5a88, 0x736b, 0x5a88, 0x3143, 0x5226, 0x83cd, 0x62a8, 0x41a4, 0x4163, 0x5a46, 0x7309, 0x838b, 0x93cc, 0x93cc, 0x7b6a, 0x62a7, 0x41a4, 0x3102, 0x2902, 0x3122, 0x2921, 0x2900, 0x1060, 0x1060, 0x20a0, 0x2901, 0x838b, 0xf73a, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xe633, 0x9c0b, 0x6aa7, 0x3142, 0x20c1, 0x20c0, 0x20a0, 0x5a47, 0xf75e, 0xffde, 0xffbd, 0xf75a, 0xde96, 0xad10, 0x6b28, 0x4a04, 0x4164, 0x5a26, 0x7309, 0x7b69, 0x7307, 0x72e7, 0x72e8, 0x6aa7, 0x6ac8, 0x5a46, 0x49e4, 0x41a3, 0x49c4, 0x6287, 0x6ac8, 0x5a47, 0x49a5, 0x51e6, 0x5226, 0x4a26, 0x4205, 0x49e4, 0x5a66, 0x7309, 0x5a87, 0x3962, 0x28e1, 0x3122, 0x2902, 0x2902, 0x3122, 0x2902, 0x2922, 0x2902, 0x3142, 0x3143, 0x3122, 0x3122, 0x3142, 0x3122, 0x41a3, 0x6ac8, 0x834a, 0x8b6a, 0x8329, 0x5a46, 0x41a4, 0x3984, 0x3963, 0x3143, 0x3143, 0x3143, 0x3963, 0x3963, 0x3984, 0x3984, 0x3963, 0x3984, 0x3963, 0x2902, 0x3963, 0x5247, 0x732a, 0x6ac9, 0x62c9, 0x4a26, 0x5226, 0x5247, 0x3984, 0x49c4, 0x730a, 0x7309, 0x5226, 0x41a4, 0x49e5, 0x6ac8, 0x7b4a, 0x838b, 0x93cc, 0x93ec, 0x7b6a, 0x6ae8, 0x5226, 0x41a5, 0x41a4, 0x3963, 0x2921, 0x2100, 0x1080, 0x1040, 0x20a0, 0x28c0, 0x6ae9, 0xef19, 0xfffe, 0xf7de, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xe633, 0x9c2c, 0x6ac7, 0x3121, 0x20c1, 0x20c1, 0x28c1, 0x734a, 0xffbf, 0xffbe, 0xffdd, 0xffbc, 0xf77a, 0xde96, 0x946d, 0x5a85, 0x49c5, 0x6a88, 0x836a, 0x7b49, 0x6ae7, 0x72e7, 0x7308, 0x6ac8, 0x6ac8, 0x6287, 0x5205, 0x49e4, 0x49e4, 0x5205, 0x5a46, 0x5a47, 0x51e6, 0x49c5, 0x4a05, 0x4a25, 0x4a05, 0x4a25, 0x5a46, 0x6266, 0x41a3, 0x3142, 0x2901, 0x3122, 0x3143, 0x3122, 0x3102, 0x3102, 0x3143, 0x3122, 0x3142, 0x3142, 0x2901, 0x3122, 0x3963, 0x3163, 0x5205, 0x72e8, 0x8bab, 0x9bec, 0x8baa, 0x6aa7, 0x5226, 0x41c5, 0x41a4, 0x3984, 0x3963, 0x3963, 0x3963, 0x3984, 0x3984, 0x3984, 0x3984, 0x4184, 0x41a4, 0x3143, 0x3984, 0x41a4, 0x5a47, 0x5a88, 0x5247, 0x5a67, 0x6288, 0x6ac9, 0x5a87, 0x6ac8, 0x7b4a, 0x62a7, 0x5246, 0x5206, 0x6287, 0x7b4a, 0x838b, 0x838b, 0x8bcc, 0x93ec, 0x7329, 0x6ae8, 0x5226, 0x4184, 0x3143, 0x2901, 0x18a0, 0x18a0, 0x18a0, 0x1040, 0x1880, 0x20a0, 0x5a66, 0xe6b8, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xe633, 0x9c2c, 0x6ac7, 0x2901, 0x20c1, 0x20e1, 0x2902, 0x8bed, 0xffff, 0xffbe, 0xffbd, 0xffbc, 0xfffb, 0xf779, 0xad0f, 0x62c6, 0x6247, 0x7b2a, 0x8bcb, 0x8389, 0x72e7, 0x7308, 0x7309, 0x6aa7, 0x6286, 0x7308, 0x5a66, 0x49c4, 0x49c4, 0x41a4, 0x41a4, 0x41a4, 0x4985, 0x4185, 0x41c4, 0x39a3, 0x39a3, 0x4a24, 0x49e4, 0x3101, 0x2901, 0x3122, 0x3122, 0x3143, 0x3963, 0x3143, 0x3102, 0x3123, 0x3983, 0x3142, 0x3143, 0x3122, 0x28e1, 0x2922, 0x3983, 0x3984, 0x5a25, 0x6ac8, 0x8b8a, 0xa42c, 0x93cb, 0x7b09, 0x62a8, 0x49e5, 0x41c5, 0x41a4, 0x3984, 0x3984, 0x3984, 0x3984, 0x3984, 0x3984, 0x3984, 0x4184, 0x41a4, 0x3963, 0x3963, 0x3122, 0x41c5, 0x5a47, 0x5247, 0x62a8, 0x62a8, 0x6ae9, 0x6ae9, 0x6287, 0x6287, 0x6287, 0x5a67, 0x5a46, 0x6ac8, 0x83ac, 0x8bcc, 0x8bab, 0x93cc, 0x9c0d, 0x8bcb, 0x7b6a, 0x5a47, 0x3964, 0x3102, 0x20c1, 0x20c0, 0x2900, 0x18a1, 0x1040, 0x1860, 0x2080, 0x5205, 0xde97, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xe697, 0x9c2d, 0x6286, 0x2900, 0x2900, 0x20c0, 0x3144, 0xce17, 0xfffe, 0xffde, 0xffde, 0xf79c, 0xf77b, 0xde76, 0xa44d, 0x8348, 0xa388, 0xac0a, 0xa40a, 0x8b68, 0x7b07, 0x7b28, 0x7b09, 0x6a87, 0x6266, 0x6266, 0x6266, 0x5a46, 0x5205, 0x49e4, 0x41a3, 0x4183, 0x3984, 0x3984, 0x3963, 0x3943, 0x3984, 0x41a4, 0x3963, 0x28e1, 0x3102, 0x3122, 0x3962, 0x3941, 0x3961, 0x4162, 0x3942, 0x3102, 0x3163, 0x39a4, 0x3963, 0x3943, 0x4183, 0x3942, 0x4183, 0x6287, 0x6247, 0x7ae9, 0x8369, 0x8ba9, 0x8baa, 0x8bab, 0x836a, 0x5a26, 0x4a06, 0x49e5, 0x41c5, 0x41c5, 0x41c5, 0x41a4, 0x41c4, 0x49e5, 0x49e5, 0x41c5, 0x3984, 0x4183, 0x49c4, 0x3942, 0x3921, 0x49c4, 0x5a47, 0x5226, 0x49c5, 0x41a4, 0x49c4, 0x49e5, 0x5206, 0x5205, 0x5a25, 0x6287, 0x7b29, 0x8bab, 0x8bab, 0x838a, 0x8bab, 0x940c, 0x9beb, 0x8349, 0x5225, 0x2901, 0x20e1, 0x2901, 0x20c0, 0x20a0, 0x20e1, 0x1040, 0x1020, 0x20a0, 0x49c3, 0xc5f3, 0xfffd, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xee97, 0xa46e, 0x5204, 0x3121, 0x28e0, 0x1880, 0x62a9, 0xf77d, 0xffde, 0xffde, 0xffde, 0xf79c, 0xef5a, 0xd635, 0xa44d, 0x93a9, 0xa3c9, 0xbc8c, 0xbccd, 0xa42a, 0x8368, 0x7b07, 0x72c7, 0x6a87, 0x6287, 0x6266, 0x6266, 0x5a46, 0x5a25, 0x5205, 0x49c4, 0x49a3, 0x3984, 0x3143, 0x3143, 0x3984, 0x41a4, 0x3963, 0x3122, 0x3142, 0x3123, 0x3964, 0x41a4, 0x41c3, 0x49c3, 0x49c4, 0x49a4, 0x4184, 0x3142, 0x3963, 0x3142, 0x3983, 0x49e4, 0x41a3, 0x4183, 0x5a25, 0x72c8, 0x834a, 0x93ca, 0x9c2b, 0x9c2b, 0x93eb, 0x834a, 0x5a05, 0x49e5, 0x41c4, 0x41e5, 0x5226, 0x5267, 0x5226, 0x49e5, 0x41c4, 0x41c5, 0x41c5, 0x41a4, 0x41c5, 0x49e5, 0x4183, 0x3922, 0x4183, 0x5205, 0x51e5, 0x49e5, 0x49c5, 0x49a4, 0x41a4, 0x49c4, 0x51e5, 0x5a46, 0x6aa8, 0x7b29, 0x836a, 0x838a, 0x8bab, 0x8bcb, 0x8bcb, 0x9beb, 0x8baa, 0x6ae8, 0x20c0, 0x20c0, 0x20e1, 0x28e0, 0x20c0, 0x18e1, 0x1040, 0x1040, 0x20a0, 0x49c3, 0xc5d3, 0xfffd, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xf719, 0xacaf, 0x5204, 0x3962, 0x20c0, 0x3143, 0xb554, 0xffff, 0xffde, 0xffbe, 0xfffe, 0xf7bd, 0xef3a, 0xcdf4, 0xa46d, 0xa42b, 0xbc8b, 0xd56e, 0xddd0, 0xc50c, 0x93c8, 0x7b06, 0x72c7, 0x6aa7, 0x6287, 0x6266, 0x5a66, 0x5a66, 0x5a66, 0x5a46, 0x5205, 0x49c4, 0x3963, 0x3142, 0x3143, 0x3983, 0x3963, 0x3122, 0x3122, 0x3963, 0x3123, 0x3984, 0x41c4, 0x41c4, 0x49e4, 0x49e5, 0x49c5, 0x49a4, 0x41a4, 0x41a4, 0x3983, 0x49c4, 0x5a66, 0x5a46, 0x5a45, 0x6aa7, 0x7b28, 0x93cb, 0xa46d, 0xb50e, 0xb4cd, 0x9c2b, 0x8369, 0x6245, 0x5226, 0x49c4, 0x41a4, 0x49e5, 0x5246, 0x5a46, 0x5246, 0x5205, 0x41c5, 0x41c5, 0x49e5, 0x4a06, 0x4a06, 0x41a4, 0x3963, 0x3984, 0x4184, 0x41a4, 0x49e5, 0x5206, 0x49e5, 0x49a4, 0x49e5, 0x5a46, 0x62a8, 0x6ae8, 0x7b29, 0x7b29, 0x836a, 0x93cb, 0x9c2c, 0x9c2c, 0x9c0b, 0x9c0c, 0x8bcb, 0x20a0, 0x18a0, 0x18a0, 0x20a0, 0x2080, 0x18c0, 0x1060, 0x1840, 0x20a0, 0x41a3, 0xc5d3, 0xfffd, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xff9b, 0xa4af, 0x5a66, 0x3962, 0x2100, 0x83cd, 0xffbd, 0xffff, 0xfffe, 0xffbe, 0xfffe, 0xffdd, 0xf75b, 0xd635, 0xb4cf, 0xb4ad, 0xdd8f, 0xee31, 0xf671, 0xd56d, 0xa408, 0x7b06, 0x6ac6, 0x6aa6, 0x5a66, 0x5a46, 0x5a46, 0x6266, 0x6287, 0x5a66, 0x5205, 0x49c4, 0x3983, 0x3983, 0x3943, 0x3122, 0x3122, 0x3963, 0x3963, 0x3963, 0x3985, 0x41a4, 0x41a4, 0x41c3, 0x49e4, 0x5205, 0x49c5, 0x4184, 0x49c4, 0x41a4, 0x4182, 0x41a3, 0x5a25, 0x6266, 0x6ac7, 0x8349, 0x8b89, 0xa44c, 0xbd0f, 0xd5b1, 0xc570, 0xac8d, 0x93ea, 0x72c6, 0x62a8, 0x5225, 0x49e4, 0x5205, 0x5225, 0x5a66, 0x6287, 0x6287, 0x4a05, 0x5206, 0x5226, 0x5226, 0x49e5, 0x41a4, 0x3984, 0x41a4, 0x3963, 0x3963, 0x41a4, 0x5a26, 0x5a47, 0x5226, 0x5a67, 0x6ac9, 0x62a8, 0x6ae9, 0x7309, 0x7b29, 0x8369, 0x9c0c, 0xb4cf, 0xc550, 0xbcef, 0xb4cf, 0xacd0, 0x3122, 0x20e1, 0x1880, 0x20a0, 0x1880, 0x18c0, 0x1060, 0x1860, 0x20a0, 0x41a3, 0xc5d3, 0xfffd, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdc, 0xacf0, 0x5a66, 0x2900, 0x5266, 0xd678, 0xffff, 0xf79e, 0xffff, 0xffbe, 0xffde, 0xfffe, 0xffbc, 0xe6b7, 0xc551, 0xc52f, 0xee52, 0xfeb3, 0xfeb1, 0xe5ce, 0xb489, 0x8b46, 0x6aa6, 0x5a66, 0x5a46, 0x5a46, 0x5a46, 0x5a66, 0x6266, 0x5a66, 0x5205, 0x49c4, 0x49e5, 0x4183, 0x3122, 0x3101, 0x3922, 0x4163, 0x4183, 0x4163, 0x49e6, 0x49c5, 0x49c4, 0x49e4, 0x5a45, 0x6286, 0x5a46, 0x51c4, 0x51e4, 0x5204, 0x51e4, 0x51e4, 0x5a25, 0x6aa7, 0x8369, 0x9c2c, 0xac8d, 0xbd0f, 0xd5b1, 0xe654, 0xe633, 0xcd70, 0xb4ad, 0x8b68, 0x7309, 0x6aa7, 0x6aa7, 0x6ac8, 0x6287, 0x6287, 0x6aa7, 0x6aa7, 0x6287, 0x6266, 0x5a46, 0x5205, 0x5206, 0x5206, 0x49e5, 0x41c5, 0x4183, 0x3942, 0x3963, 0x5206, 0x6287, 0x6288, 0x6ac8, 0x730a, 0x6ae9, 0x7309, 0x7329, 0x7b29, 0x8329, 0x93cb, 0xbd0f, 0xe613, 0xe654, 0xd5f3, 0xcdf4, 0x4a05, 0x2922, 0x20c0, 0x28e1, 0x20a0, 0x10a0, 0x1060, 0x1861, 0x20a0, 0x4182, 0xc5b3, 0xfffd, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdc, 0xc5b3, 0x62c7, 0x39a3, 0xa4d0, 0xfffd, 0xffde, 0xffdf, 0xffff, 0xffde, 0xffde, 0xffdd, 0xffdd, 0xf739, 0xd5d3, 0xcd91, 0xf694, 0xfeb3, 0xfeb2, 0xf60f, 0xcceb, 0x93a8, 0x6aa6, 0x5226, 0x5a25, 0x5225, 0x5225, 0x5a46, 0x5a46, 0x5a46, 0x5a25, 0x5205, 0x5a66, 0x4183, 0x3101, 0x3942, 0x41a3, 0x4183, 0x4183, 0x49e4, 0x51c5, 0x51e4, 0x51e4, 0x5a24, 0x6a86, 0x72c7, 0x7286, 0x6225, 0x5a45, 0x6266, 0x6a86, 0x6a86, 0x72c7, 0x8329, 0x9c0c, 0xb4cf, 0xd5b1, 0xe613, 0xee75, 0xfed7, 0xf696, 0xe614, 0xcd91, 0xac6c, 0x8bcb, 0x7b29, 0x7b29, 0x7308, 0x6286, 0x6286, 0x72c8, 0x6ac7, 0x8328, 0x8308, 0x7286, 0x6245, 0x6266, 0x6aa7, 0x5a46, 0x5205, 0x49e5, 0x4183, 0x3963, 0x49e5, 0x5a67, 0x62a8, 0x6ac8, 0x6ac9, 0x62c9, 0x6ae9, 0x7309, 0x72e8, 0x7b08, 0x93aa, 0xcd2f, 0xf694, 0xfef7, 0xee96, 0xe6b7, 0x6b09, 0x20e1, 0x18a0, 0x28e0, 0x2080, 0x1080, 0x1060, 0x2081, 0x20a0, 0x3962, 0xc5b3, 0xfffd, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffd, 0xe6d8, 0x8c2d, 0x8c2d, 0xe6f9, 0xfffe, 0xffbe, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xffdd, 0xffdc, 0xff5a, 0xe654, 0xde13, 0xf695, 0xfeb4, 0xfeb3, 0xfe30, 0xd52c, 0x9bc9, 0x72c7, 0x5a67, 0x5a25, 0x5225, 0x5205, 0x5205, 0x5225, 0x5a46, 0x6266, 0x6287, 0x5a46, 0x4183, 0x3942, 0x49a4, 0x49e4, 0x49a4, 0x49c4, 0x5a46, 0x59c4, 0x6225, 0x7285, 0x7ac6, 0x82e6, 0x8307, 0x82c6, 0x7a66, 0x6266, 0x6a86, 0x6aa7, 0x72c7, 0x7ae8, 0x8b8a, 0xac6d, 0xc510, 0xe634, 0xf6b6, 0xfed8, 0xfef9, 0xf6b8, 0xf697, 0xee55, 0xcd50, 0xac8e, 0x93cb, 0x836a, 0x8349, 0x72c7, 0x72e7, 0x7b29, 0x7b08, 0x9368, 0x9ba9, 0x9348, 0x7ac7, 0x7ae7, 0x7ae8, 0x6a87, 0x6266, 0x5226, 0x49e5, 0x49a4, 0x51e5, 0x5a67, 0x6aa8, 0x6ac8, 0x6aa8, 0x5247, 0x6288, 0x6ac8, 0x72c7, 0x8328, 0xa40b, 0xdd90, 0xfed5, 0xf6d6, 0xeeb6, 0xff5a, 0xa4b0, 0x2922, 0x1880, 0x20a0, 0x1840, 0x1080, 0x1060, 0x2081, 0x20a0, 0x3962, 0xc5b2, 0xfffd, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffd, 0xffbb, 0xc5d4, 0xded7, 0xfffd, 0xf7bd, 0xffff, 0xf79e, 0xffde, 0xffde, 0xfffe, 0xf7bd, 0xff9c, 0xff5a, 0xe695, 0xee74, 0xfeb6, 0xfeb5, 0xfe93, 0xfe30, 0xd50c, 0x9ba9, 0x72e8, 0x62c9, 0x5a46, 0x5225, 0x51e4, 0x49c4, 0x51e4, 0x5a46, 0x6aa7, 0x7309, 0x49c4, 0x49a4, 0x49a4, 0x49c4, 0x51e4, 0x51e5, 0x5a25, 0x5a46, 0x6a04, 0x7ac6, 0x9368, 0x9ba8, 0x9b88, 0x9347, 0x8b07, 0x8ae7, 0x7308, 0x72e8, 0x7ae8, 0x7ae8, 0x8349, 0x9c0b, 0xbcef, 0xd591, 0xee75, 0xfeb7, 0xf698, 0xf698, 0xfeb9, 0xfef9, 0xfed7, 0xd5b2, 0xbd10, 0xa44d, 0x9c2c, 0xa44d, 0x93eb, 0x93cb, 0x8bab, 0x7b28, 0x9b47, 0xb40a, 0xac0a, 0x9368, 0x8b28, 0x7ae8, 0x72a7, 0x72c7, 0x5a47, 0x5a26, 0x5206, 0x5226, 0x6287, 0x6ae9, 0x6ae9, 0x6ae9, 0x62a9, 0x6ae9, 0x7309, 0x72e8, 0x8348, 0xac2b, 0xd590, 0xf653, 0xf6d6, 0xf6d7, 0xfffc, 0xde77, 0x41e5, 0x20c1, 0x1880, 0x1860, 0x1060, 0x1060, 0x2081, 0x20a0, 0x3962, 0xbdb2, 0xfffd, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffdf, 0xffbe, 0xffbe, 0xfffe, 0xffdd, 0xf75a, 0xeef7, 0xeeb6, 0xff17, 0xff16, 0xfed3, 0xfe50, 0xdd6d, 0xa3e8, 0x72c7, 0x62c8, 0x5a46, 0x5a25, 0x5a46, 0x5a45, 0x51e4, 0x5a25, 0x6266, 0x6266, 0x59e3, 0x49c4, 0x41c5, 0x39c5, 0x39a5, 0x5225, 0x72a5, 0x7a84, 0xa346, 0xaba7, 0xbc09, 0xc449, 0xbc49, 0xac09, 0xa3e9, 0x9bc9, 0x9389, 0x9389, 0x9389, 0x9bca, 0xac4d, 0xc510, 0xddf4, 0xf6b7, 0xff19, 0xf6f8, 0xf6d8, 0xf6f8, 0xff18, 0xff19, 0xff18, 0xf6f8, 0xee34, 0xd591, 0xcd30, 0xc50f, 0xbcce, 0xb4ad, 0xac4c, 0x9bc9, 0x93cb, 0xac2c, 0xc46b, 0xc429, 0xbc09, 0xb3e9, 0x9347, 0x72a5, 0x6a88, 0x6288, 0x5a47, 0x5a46, 0x6287, 0x6ae8, 0x6ae8, 0x62a7, 0x5ac6, 0x5a87, 0x6a69, 0x72a9, 0x8b29, 0xbcac, 0xee52, 0xff15, 0xf717, 0xeef8, 0xffbd, 0xf77c, 0x734a, 0x20a0, 0x2080, 0x1840, 0x10a1, 0x10a0, 0x20c1, 0x20c0, 0x41a4, 0xd636, 0xffbc, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffbe, 0xffde, 0xffff, 0xffdd, 0xff7a, 0xf6f8, 0xf6d6, 0xfed6, 0xfed5, 0xfeb3, 0xfe50, 0xdd4d, 0x9bc8, 0x72c6, 0x6ac8, 0x5a46, 0x5a46, 0x6266, 0x6266, 0x5a46, 0x6266, 0x6287, 0x5a46, 0x51e4, 0x51c4, 0x49e5, 0x41e6, 0x49e5, 0x6a86, 0x9347, 0xa387, 0xbc08, 0xc449, 0xcc8a, 0xcc8a, 0xbc28, 0xabc7, 0x9b87, 0x9388, 0x9ba9, 0xac2b, 0xbcce, 0xcd30, 0xd5b2, 0xe635, 0xf6d7, 0xff19, 0xff39, 0xff39, 0xff39, 0xff39, 0xff5a, 0xff5a, 0xff39, 0xf719, 0xf6b6, 0xee55, 0xe634, 0xe614, 0xd5d2, 0xcd70, 0xbcee, 0xa42b, 0x9beb, 0xb44c, 0xc48c, 0xd48b, 0xd48b, 0xc46a, 0xa3c9, 0x8327, 0x72e9, 0x72c9, 0x6a88, 0x6287, 0x6aa8, 0x6ae8, 0x6ae8, 0x62a7, 0x6b27, 0x6ae8, 0x72ca, 0x7aea, 0x938a, 0xc50e, 0xf693, 0xff36, 0xf717, 0xf73a, 0xfffe, 0xffbd, 0x8c0d, 0x3141, 0x28c0, 0x2060, 0x1080, 0x1080, 0x18a0, 0x20c0, 0x4a05, 0xde98, 0xffbd, 0xffbd, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffde, 0xffdf, 0xfffe, 0xffbd, 0xf75a, 0xeed7, 0xee95, 0xfef7, 0xfef6, 0xfed4, 0xfe71, 0xdd6d, 0x9ba8, 0x72a5, 0x6aa7, 0x5a45, 0x5a45, 0x6266, 0x6246, 0x5a45, 0x6266, 0x6266, 0x5a25, 0x6246, 0x5a46, 0x5a47, 0x5a46, 0x6265, 0x8307, 0xabe9, 0xc449, 0xcc69, 0xcc69, 0xd469, 0xcc68, 0xc428, 0xb3e8, 0xa3c8, 0x9ba8, 0x9389, 0xb48d, 0xddd2, 0xee75, 0xf6b6, 0xfef8, 0xff19, 0xff19, 0xff3a, 0xff39, 0xff3a, 0xff3a, 0xff3a, 0xff3a, 0xff3a, 0xff19, 0xff39, 0xfef8, 0xfef8, 0xff18, 0xf6b7, 0xe655, 0xd5d2, 0xbd0f, 0xac2c, 0xb44b, 0xc46b, 0xd48a, 0xd4ab, 0xcc8a, 0xb429, 0xa3c9, 0x834a, 0x7b09, 0x72e8, 0x72c8, 0x7308, 0x7329, 0x7309, 0x6ae8, 0x6b27, 0x6ae9, 0x72ca, 0x82ea, 0x9baa, 0xcd2e, 0xf693, 0xff16, 0xf718, 0xff9b, 0xffde, 0xfffe, 0xbdb3, 0x5245, 0x2080, 0x2080, 0x18a0, 0x20c1, 0x2901, 0x2901, 0x62a8, 0xf73a, 0xfffe, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xf79c, 0xef19, 0xe696, 0xde34, 0xfed6, 0xff16, 0xff15, 0xfe92, 0xdd8e, 0xa409, 0x7ae6, 0x7ae7, 0x6266, 0x6266, 0x5a45, 0x5a25, 0x5a45, 0x6286, 0x6286, 0x6266, 0x6266, 0x6287, 0x6a87, 0x6aa6, 0x8307, 0xa3a8, 0xc449, 0xd489, 0xd489, 0xcc47, 0xcc06, 0xcc27, 0xd448, 0xcc69, 0xbc4a, 0xb40a, 0x9bca, 0xc50f, 0xee54, 0xfed7, 0xfef8, 0xff18, 0xff19, 0xfef8, 0xff5a, 0xff5a, 0xff5a, 0xff3a, 0xff3a, 0xff3a, 0xff5a, 0xff5a, 0xff5b, 0xff3a, 0xff5a, 0xff5a, 0xf719, 0xf718, 0xeeb7, 0xde35, 0xcd2f, 0xc4ad, 0xc46b, 0xcc6a, 0xcc6a, 0xcc6a, 0xc46a, 0xc46b, 0x938a, 0x8b49, 0x8308, 0x7b08, 0x7b29, 0x7b29, 0x7b2a, 0x7329, 0x6ae7, 0x6ae8, 0x72c9, 0x8309, 0xa3eb, 0xd56f, 0xf6b4, 0xff17, 0xf718, 0xffbc, 0xff7d, 0xffff, 0xef5a, 0x7bab, 0x20c0, 0x2060, 0x1080, 0x2902, 0x2901, 0x2901, 0x7b4a, 0xf75b, 0xfffe, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xffbd, 0xf739, 0xe676, 0xd5f3, 0xee54, 0xfed5, 0xfef5, 0xfe93, 0xe5cf, 0xb46b, 0x9368, 0x8b27, 0x6aa7, 0x6a86, 0x6266, 0x6266, 0x6a86, 0x6a86, 0x6aa7, 0x6aa7, 0x6a66, 0x7286, 0x72c6, 0x8b06, 0xabc8, 0xcc69, 0xdca9, 0xdca8, 0xd488, 0xd467, 0xd447, 0xd427, 0xd468, 0xcc8a, 0xccab, 0xc4ac, 0xc52f, 0xe613, 0xfef7, 0xff18, 0xff18, 0xff39, 0xff39, 0xff19, 0xff19, 0xff19, 0xff39, 0xff39, 0xff19, 0xff19, 0xff19, 0xff39, 0xff5b, 0xff3a, 0xff5b, 0xff5a, 0xf739, 0xff5a, 0xff5a, 0xeed8, 0xf654, 0xe5b1, 0xd50e, 0xd4cc, 0xd4ab, 0xccab, 0xd4cb, 0xdd0c, 0xb42b, 0xa3ca, 0x9369, 0x8b69, 0x8349, 0x7b29, 0x7b09, 0x7b2a, 0x6ae7, 0x7309, 0x7b0a, 0x8b4a, 0xb48d, 0xe612, 0xfef6, 0xff39, 0xf739, 0xffbd, 0xf77d, 0xffdf, 0xfffd, 0xbdb3, 0x5a88, 0x28a1, 0x18a0, 0x3122, 0x3101, 0x3962, 0x9c8f, 0xffbc, 0xf7bd, 0xffdf, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffdd, 0xff7a, 0xe696, 0xcdb2, 0xe613, 0xfed6, 0xff16, 0xf6b3, 0xe5f0, 0xc4ed, 0xa3c8, 0x8b27, 0x6aa7, 0x6a86, 0x6245, 0x6a86, 0x6aa6, 0x6a66, 0x6a66, 0x72c7, 0x8b07, 0x9347, 0x9b67, 0xaba7, 0xc469, 0xdcca, 0xdca9, 0xdc68, 0xd468, 0xdca8, 0xe4c9, 0xdca9, 0xd469, 0xd48b, 0xdd2e, 0xe5b1, 0xee54, 0xfed6, 0xff38, 0xff18, 0xfef8, 0xff19, 0xff5a, 0xff3a, 0xfef8, 0xfef8, 0xfef8, 0xfef8, 0xff18, 0xfef8, 0xfef8, 0xfed8, 0xff3a, 0xff3a, 0xff5b, 0xff5a, 0xff19, 0xff5a, 0xff7a, 0xf6f8, 0xfed6, 0xee54, 0xe5d2, 0xe590, 0xdd4e, 0xdd0d, 0xdd0c, 0xe52d, 0xd50d, 0xbc6b, 0xac0a, 0xa40b, 0x93aa, 0x7b29, 0x72e9, 0x730a, 0x6ac7, 0x7b09, 0x830a, 0x938a, 0xbcee, 0xee73, 0xff17, 0xff39, 0xff7a, 0xffbd, 0xffdf, 0xffff, 0xfffe, 0xf77b, 0xbd73, 0x5207, 0x28e0, 0x20c0, 0x3100, 0x5a67, 0xce15, 0xfffe, 0xf7de, 0xf7df, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffdf, 0xffde, 0xffdd, 0xf75a, 0xde35, 0xbd30, 0xddd2, 0xfed6, 0xff36, 0xfed4, 0xee52, 0xdd8f, 0xbc6b, 0x9b67, 0x8328, 0x72a7, 0x6245, 0x6a86, 0x72a6, 0x6265, 0x6a86, 0x8b69, 0xabe9, 0xbc4a, 0xc44a, 0xcc69, 0xdcca, 0xdcea, 0xdca9, 0xdca8, 0xd4c9, 0xdce9, 0xe50a, 0xe50b, 0xdceb, 0xe54e, 0xedf2, 0xfe75, 0xf6d6, 0xfef7, 0xfef7, 0xfef7, 0xf6f8, 0xfef8, 0xff19, 0xff19, 0xfef7, 0xfed7, 0xfe75, 0xf655, 0xf675, 0xfeb6, 0xfed7, 0xfed7, 0xff19, 0xff19, 0xff39, 0xfef9, 0xf6d8, 0xff19, 0xff59, 0xfef8, 0xf6d7, 0xf6b7, 0xf696, 0xf654, 0xee12, 0xe5b0, 0xed8f, 0xed8e, 0xedaf, 0xd50d, 0xcccd, 0xc4ad, 0xac4d, 0x8b6a, 0x72e9, 0x72ea, 0x6ac7, 0x7b29, 0x832a, 0x9bab, 0xc52f, 0xf6b4, 0xff17, 0xf719, 0xff9b, 0xffbd, 0xffff, 0xffdf, 0xffdd, 0xfffd, 0xf75b, 0xa4b2, 0x5a87, 0x4183, 0x5a66, 0xa48f, 0xf73a, 0xfffe, 0xffdf, 0xf7ff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffde, 0xffbe, 0xffbd, 0xef19, 0xcdb3, 0xac8d, 0xcd50, 0xf695, 0xff36, 0xfef5, 0xfed4, 0xf673, 0xdd4e, 0xbc2a, 0x9c0c, 0x8349, 0x72a7, 0x72c7, 0x72e7, 0x72a6, 0x8328, 0xac6d, 0xc44a, 0xd4cb, 0xdceb, 0xdcca, 0xe50a, 0xe50b, 0xe50a, 0xe52b, 0xed6c, 0xe54b, 0xe50a, 0xe52b, 0xed8e, 0xf611, 0xfe54, 0xfe95, 0xfed6, 0xf6d6, 0xf6d7, 0xf6f7, 0xfef8, 0xfef8, 0xf6d8, 0xf6d8, 0xfe75, 0xedf3, 0xd530, 0xccef, 0xcd0f, 0xdd71, 0xedf3, 0xf654, 0xf6d8, 0xf6d8, 0xf6d8, 0xee76, 0xe656, 0xf6f8, 0xff59, 0xff18, 0xfef8, 0xff19, 0xff39, 0xff17, 0xfeb6, 0xfe73, 0xfe52, 0xfe31, 0xf5ef, 0xe56e, 0xd52e, 0xd52f, 0xbcae, 0x93ab, 0x7b0a, 0x7b0a, 0x7308, 0x8b6b, 0x938b, 0xa40c, 0xd5b0, 0xff15, 0xff59, 0xff3a, 0xff9b, 0xffbd, 0xffbf, 0xf7bf, 0xfffe, 0xffdd, 0xffdd, 0xef1b, 0xd635, 0xa48e, 0xc5b3, 0xff7a, 0xfffd, 0xffdd, 0xf7be, 0xf7ff, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffff, 0xffde, 0xffbe, 0xfffe, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffdd, 0xfffd, 0xfffc, 0xff38, 0xddf3, 0xbcce, 0x9bcb, 0xabea, 0xe5f2, 0xfef6, 0xff17, 0xfef6, 0xfeb4, 0xfe51, 0xedae, 0xc46a, 0xabe9, 0x8b89, 0x7308, 0x62a6, 0x6a85, 0x8b67, 0xb44a, 0xd4eb, 0xd4ca, 0xdcc9, 0xe4e9, 0xece9, 0xe4c9, 0xe4c9, 0xe4ea, 0xed2a, 0xe50a, 0xdceb, 0xe54e, 0xedd0, 0xf5f1, 0xedb0, 0xed6f, 0xe612, 0xf695, 0xfed6, 0xf695, 0xf675, 0xfeb7, 0xfed8, 0xfeb7, 0xf674, 0xcd2f, 0xa3c9, 0xa3c9, 0xc4ce, 0xdd91, 0xedf2, 0xf674, 0xf696, 0xfef8, 0xfef8, 0xee96, 0xeeb7, 0xff7a, 0xff9b, 0xf759, 0xfef7, 0xfed7, 0xfef8, 0xff19, 0xff18, 0xff18, 0xfef7, 0xee54, 0xfe33, 0xedb0, 0xdd2d, 0xdd2c, 0xd52d, 0xb46b, 0x8b69, 0x7b29, 0x7329, 0x8369, 0x9beb, 0xbcad, 0xe5f3, 0xfef7, 0xff18, 0xff5a, 0xf7fe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdd, 0xf79c, 0xef5c, 0xef7d, 0xf7bd, 0xffde, 0xffff, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xfffe, 0xffff, 0xffde, 0xffde, 0xfffe, 0xffff, 0xfffe, 0xfffd, 0xf759, 0xde54, 0xc550, 0xac4c, 0x8b49, 0xac0a, 0xddd2, 0xfed6, 0xfef6, 0xfed5, 0xf673, 0xf5f0, 0xe56d, 0xd4eb, 0xb429, 0x8b67, 0x7b07, 0x72e7, 0x8327, 0xa3e9, 0xccab, 0xe54c, 0xe52b, 0xe50a, 0xed2a, 0xf52a, 0xed0a, 0xed0a, 0xed2b, 0xf56c, 0xe54c, 0xe58e, 0xedf1, 0xf632, 0xf612, 0xedd1, 0xedb0, 0xee33, 0xf674, 0xf674, 0xee13, 0xe5f3, 0xedf3, 0xee34, 0xee34, 0xe5f2, 0xcd0f, 0xac2b, 0xac0b, 0xbc8d, 0xc4ce, 0xcd0f, 0xdd91, 0xe634, 0xf696, 0xf6d7, 0xf6b6, 0xf6f7, 0xff39, 0xff38, 0xeed7, 0xf695, 0xf696, 0xfef8, 0xff39, 0xff19, 0xff39, 0xff18, 0xf6b6, 0xfe12, 0xedd0, 0xe56e, 0xe58e, 0xe5af, 0xc4ed, 0x93a9, 0x8329, 0x8369, 0x93ca, 0xbcce, 0xddb1, 0xfeb6, 0xff39, 0xff19, 0xff7b, 0xf7de, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0xf79d, 0xf7bd, 0xffde, 0xfffe, 0xffff, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xffde, 0xffbe, 0xffde, 0xfffe, 0xffdd, 0xf77a, 0xde75, 0xbd50, 0xacae, 0x9bcb, 0x7ac7, 0x9389, 0xcd2f, 0xee74, 0xfef6, 0xfef6, 0xfeb4, 0xfe52, 0xedef, 0xdd0b, 0xbc49, 0x9b67, 0x8b47, 0x9388, 0xa3e9, 0xc46a, 0xdceb, 0xed8c, 0xe54b, 0xed2a, 0xed2a, 0xed0a, 0xecea, 0xed0b, 0xed4c, 0xedcf, 0xedd0, 0xf632, 0xfeb5, 0xfeb5, 0xf633, 0xedd2, 0xedd1, 0xedf1, 0xe5d1, 0xdd90, 0xd54f, 0xccee, 0xc4ae, 0xbcae, 0xc4ae, 0xbcae, 0xac4c, 0xa3eb, 0x9baa, 0x9baa, 0x9389, 0x9bca, 0xac2c, 0xbccf, 0xcd51, 0xddd3, 0xe614, 0xe655, 0xeeb6, 0xf6d6, 0xeeb6, 0xee55, 0xee76, 0xf6f8, 0xff5a, 0xff5a, 0xff5a, 0xff5a, 0xff39, 0xfe54, 0xf5f1, 0xe58f, 0xedcf, 0xf631, 0xd56f, 0xac4b, 0x93aa, 0x9368, 0xa40a, 0xcd2f, 0xee33, 0xfef7, 0xff39, 0xf719, 0xff9c, 0xffdd, 0xfffe, 0xffff, 0xffff, 0xffdf, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xf75b, 0xde96, 0xc592, 0xacad, 0xa42b, 0x938a, 0x7ac7, 0x8307, 0xac6c, 0xddd2, 0xf695, 0xfef6, 0xfed4, 0xfe93, 0xf631, 0xed4c, 0xccaa, 0xbc28, 0xb429, 0xc48a, 0xcccb, 0xdd0b, 0xe52b, 0xed8d, 0xed6b, 0xed2a, 0xed0a, 0xed09, 0xe4ea, 0xe50b, 0xed6c, 0xedf1, 0xf653, 0xfed5, 0xff37, 0xfef7, 0xf674, 0xee12, 0xedf2, 0xe5b0, 0xd52e, 0xcccd, 0xc48d, 0xb44b, 0xa3ca, 0x9389, 0x9389, 0x93ab, 0x938a, 0x8b49, 0x8329, 0x8308, 0x7ae7, 0x7ae8, 0x8b49, 0x9bca, 0xac2c, 0xb4ae, 0xc4ef, 0xc530, 0xd591, 0xe613, 0xf695, 0xee96, 0xeeb7, 0xf719, 0xff7b, 0xff9c, 0xff7b, 0xff7b, 0xff7b, 0xfed6, 0xf633, 0xe5af, 0xedcf, 0xfe30, 0xe5cf, 0xc4cd, 0xac4b, 0xabe9, 0xb44a, 0xd54f, 0xee53, 0xfef7, 0xff18, 0xeef9, 0xffbc, 0xffbd, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffde, 0xffde, 0xffdd, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffd, 0xe6b7, 0xc592, 0xb50f, 0xa46c, 0x9bea, 0x8b69, 0x7ae7, 0x6a65, 0x8b69, 0xbcee, 0xee33, 0xfeb4, 0xfed5, 0xfe93, 0xf652, 0xf5ce, 0xed6d, 0xdd2c, 0xdd2c, 0xe54c, 0xed6c, 0xf56c, 0xfd8c, 0xf5ad, 0xf58c, 0xf56b, 0xed2a, 0xed0a, 0xe4ea, 0xed4c, 0xf5ae, 0xee33, 0xf6b5, 0xff17, 0xff38, 0xfef7, 0xf695, 0xee12, 0xe5d0, 0xe590, 0xcccd, 0xb44b, 0xb44b, 0xac2b, 0x9389, 0x8328, 0x8328, 0x72e8, 0x72c7, 0x72a7, 0x6a87, 0x6245, 0x6225, 0x6a86, 0x72c7, 0x8328, 0x9389, 0xa40c, 0xac4d, 0xb48d, 0xbcee, 0xd591, 0xee54, 0xf6b6, 0xfef8, 0xff3a, 0xff7b, 0xffbd, 0xff9c, 0xff9c, 0xff7b, 0xff17, 0xfe74, 0xe5d0, 0xedae, 0xfe30, 0xedef, 0xd52d, 0xc4cc, 0xe58e, 0xdd8f, 0xee12, 0xf6b5, 0xff18, 0xf6f7, 0xe676, 0xeeb7, 0xffbc, 0xffbd, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xffde, 0xffbe, 0xffde, 0xfffe, 0xfffe, 0xffde, 0xff5a, 0xd5d4, 0xacce, 0xa48c, 0xa42b, 0x93a9, 0x8328, 0x7ac7, 0x6a86, 0x7ae7, 0xac4c, 0xe5d1, 0xfeb4, 0xff15, 0xfef5, 0xfeb4, 0xfe0f, 0xf5ce, 0xed8d, 0xed6c, 0xed4b, 0xed4b, 0xf56b, 0xfd8b, 0xf56b, 0xf56b, 0xf54a, 0xf52a, 0xe4c9, 0xdcca, 0xe54c, 0xf5ef, 0xf675, 0xfed6, 0xff18, 0xf6f7, 0xf6d6, 0xf694, 0xe5f1, 0xd54e, 0xc4ce, 0xac2b, 0xa3ca, 0xa40b, 0xa40b, 0x8ba9, 0x7b28, 0x7b28, 0x6aa7, 0x6287, 0x6287, 0x6266, 0x5a25, 0x5a25, 0x6287, 0x6ac8, 0x72c8, 0x8349, 0x9bec, 0xac8e, 0xb4ce, 0xc50f, 0xcd50, 0xd590, 0xee54, 0xfed7, 0xff5a, 0xff7b, 0xffbc, 0xffbc, 0xff9c, 0xff7b, 0xff18, 0xfe95, 0xedf1, 0xedce, 0xfe2f, 0xf60f, 0xe56e, 0xdd2d, 0xedef, 0xedf0, 0xf673, 0xfed6, 0xff38, 0xf6b6, 0xd5b2, 0xd592, 0xff7a, 0xffbc, 0xffde, 0xffbe, 0xffbe, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffde, 0xfffe, 0xffbd, 0xef5c, 0xde14, 0xbcf0, 0x9c2c, 0x9bea, 0x93a9, 0x8b68, 0x8328, 0x7ac7, 0x6ae8, 0x72c7, 0x9bea, 0xd54f, 0xf652, 0xfed4, 0xfed5, 0xfed5, 0xfe30, 0xf5ef, 0xedad, 0xed6b, 0xed2b, 0xed2a, 0xed4a, 0xf54a, 0xed2a, 0xed4a, 0xf54a, 0xed0a, 0xe4a9, 0xdca9, 0xe54d, 0xfe10, 0xfed7, 0xfed7, 0xf6d7, 0xf6d7, 0xf6d6, 0xf674, 0xdd8f, 0xc4cb, 0x9b89, 0x8b48, 0x8b68, 0xa40c, 0xa46d, 0x940c, 0x7349, 0x62c7, 0x62a8, 0x5a67, 0x5a67, 0x6287, 0x5a67, 0x62a8, 0x6ae9, 0x6ac8, 0x6aa8, 0x7b09, 0x8bcc, 0xac8e, 0xbd30, 0xc530, 0xb4ad, 0xa40b, 0xd52f, 0xf675, 0xff39, 0xff5a, 0xff7b, 0xff9c, 0xff7b, 0xff7b, 0xfef8, 0xf6b5, 0xee11, 0xedce, 0xfe0f, 0xfe0f, 0xf5cf, 0xf5af, 0xedf0, 0xee32, 0xfed5, 0xf6d6, 0xf6d6, 0xddf3, 0xb48d, 0xac0a, 0xcdf4, 0xf6f9, 0xffdd, 0xffde, 0xff9e, 0xffde, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffde, 0xffde, 0xf77d, 0xe6fa, 0xb4cf, 0xa44d, 0x93ca, 0x8b68, 0x8327, 0x8b48, 0x8b48, 0x82e7, 0x6287, 0x5a24, 0x8307, 0xbc8c, 0xe5b0, 0xfe73, 0xf6b4, 0xfed5, 0xfe91, 0xfe50, 0xf5ee, 0xf5ad, 0xf5ac, 0xf58b, 0xf56b, 0xed4a, 0xed2a, 0xf56b, 0xfd8b, 0xf54a, 0xe4e9, 0xdcca, 0xed8e, 0xfe72, 0xff18, 0xfed7, 0xf6b6, 0xf6d6, 0xfed6, 0xf653, 0xd54d, 0xbc49, 0x7ac6, 0x7ac6, 0x8b69, 0xac8e, 0xb531, 0x9c8e, 0x736a, 0x5aa7, 0x41c5, 0x3963, 0x3963, 0x41c4, 0x4a06, 0x5a67, 0x5a87, 0x4a06, 0x5226, 0x6287, 0x732a, 0x9c4d, 0xbd51, 0xc571, 0xac6c, 0x8328, 0xb42b, 0xe5f2, 0xff18, 0xff39, 0xff5a, 0xff7b, 0xff7b, 0xff9b, 0xfef8, 0xfeb6, 0xee11, 0xe5ae, 0xf5ce, 0xfe0f, 0xfe0f, 0xfe31, 0xee31, 0xf693, 0xff16, 0xf6d6, 0xe675, 0xcd70, 0xa3c9, 0x9346, 0x940c, 0xcdd4, 0xff9c, 0xffde, 0xffbe, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 0xfffe, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbd, 0xffdd, 0xfffe, 0xfffe, 0xf7bd, 0xfffd, 0xff9b, 0xc5b3, 0xb4ae, 0xa44c, 0x93aa, 0x8328, 0x7ae8, 0x72e7, 0x72e7, 0x72e7, 0x5a06, 0x6206, 0x6a67, 0x93aa, 0xcd50, 0xee53, 0xfeb4, 0xff15, 0xfef3, 0xfe50, 0xf5ce, 0xf58c, 0xfd6b, 0xf509, 0xf509, 0xf52a, 0xf56b, 0xf58b, 0xed2a, 0xe4a8, 0xdca8, 0xe4ea, 0xed6c, 0xfe30, 0xfeb6, 0xfef7, 0xff18, 0xf6d7, 0xee96, 0xee54, 0xd590, 0xc4ac, 0x7348, 0x4182, 0x72c8, 0xac4d, 0xb4cd, 0xa48c, 0x7329, 0x5a89, 0x3163, 0x20c1, 0x20c0, 0x2922, 0x3163, 0x39a4, 0x41c5, 0x39a4, 0x41c3, 0x4a04, 0x6309, 0x7bac, 0x9c6f, 0xbd32, 0x9bec, 0x6204, 0x9bc9, 0xddd2, 0xf6d7, 0xff19, 0xff5b, 0xff3a, 0xff5a, 0xff7b, 0xff18, 0xf634, 0xf612, 0xfdf0, 0xf5af, 0xf5cf, 0xfe0f, 0xfe91, 0xf652, 0xfe93, 0xff16, 0xfe95, 0xd571, 0xbcce, 0xac4c, 0x8b47, 0x9368, 0xac6c, 0xe695, 0xffbc, 0xfffe, 0xffde, 0xffbf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbd, 0xffdd, 0xfffe, 0xfffe, 0xffde, 0xfffd, 0xf75a, 0xc5b3, 0xa42c, 0x93aa, 0x7b28, 0x72a6, 0x6a86, 0x6a86, 0x6aa6, 0x6aa6, 0x6a88, 0x6246, 0x6205, 0x7ae7, 0xb48d, 0xddd1, 0xf673, 0xfef5, 0xfef4, 0xfe71, 0xf5ee, 0xf5ac, 0xf56b, 0xf52a, 0xed0a, 0xf52a, 0xf5ac, 0xfdac, 0xf54a, 0xece9, 0xe4e9, 0xe4e9, 0xe54c, 0xf5ef, 0xf695, 0xfed7, 0xfef7, 0xf6f7, 0xf6d6, 0xf695, 0xddb1, 0xc4cd, 0x7b69, 0x4983, 0x6a67, 0xb48e, 0xc52f, 0xacad, 0x7b4a, 0x5a89, 0x4a06, 0x3143, 0x28e1, 0x28e1, 0x28e1, 0x2902, 0x3143, 0x3143, 0x41a3, 0x41a3, 0x62c8, 0x8c2e, 0xbd73, 0xbd52, 0x938b, 0x6a45, 0x9b89, 0xd591, 0xee96, 0xf719, 0xff7b, 0xff5a, 0xff5a, 0xff5a, 0xfef7, 0xf613, 0xf612, 0xf5f0, 0xf5ae, 0xf5cf, 0xf5ef, 0xfe50, 0xfe73, 0xfed4, 0xfef6, 0xe5f3, 0xb46d, 0x9bca, 0x9bc9, 0x8b68, 0x8b27, 0x93ca, 0xc571, 0xef19, 0xfffd, 0xffff, 0xffbf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbd, 0xffde, 0xfffe, 0xf7de, 0xfffe, 0xffdd, 0xe697, 0xbd31, 0xa42b, 0x93aa, 0x7b07, 0x72a6, 0x6a86, 0x6286, 0x6266, 0x6265, 0x6266, 0x6225, 0x5a04, 0x7ae6, 0xac6c, 0xd58f, 0xe611, 0xf692, 0xff15, 0xfed3, 0xfe71, 0xfe0f, 0xfdad, 0xf56b, 0xf56b, 0xf58c, 0xf58c, 0xf58b, 0xed4a, 0xed09, 0xed09, 0xdcc9, 0xdcea, 0xed8d, 0xf675, 0xfeb6, 0xfef7, 0xfef7, 0xfef7, 0xf695, 0xdd90, 0xbc8b, 0x8368, 0x51c3, 0x6205, 0xa40d, 0xac8d, 0x8368, 0x5a66, 0x41a5, 0x3984, 0x2902, 0x20c1, 0x20c1, 0x20c1, 0x28e1, 0x3122, 0x3122, 0x41a3, 0x41a4, 0x5267, 0x83ac, 0xbd53, 0xbd52, 0x938b, 0x8308, 0xac0b, 0xddb2, 0xee96, 0xf6f8, 0xff5a, 0xff5a, 0xff5a, 0xff3a, 0xfeb6, 0xee12, 0xf5f1, 0xf5d0, 0xf5ae, 0xf5ce, 0xf5ce, 0xfe0f, 0xfeb4, 0xff15, 0xfeb5, 0xd571, 0xa3eb, 0x8b48, 0x8b89, 0x93c9, 0x8b48, 0x8b68, 0x9c4d, 0xcdd3, 0xf77b, 0xfffe, 0xffde, 0xffbf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xf7bd, 0xfffe, 0xf75a, 0xc5b3, 0xacae, 0xa42c, 0x93aa, 0x7b08, 0x72c7, 0x6a86, 0x6265, 0x5a45, 0x5a24, 0x5a45, 0x5a24, 0x5a24, 0x72c6, 0xa40a, 0xc50e, 0xddd0, 0xf673, 0xf6b4, 0xfeb4, 0xfe72, 0xfdef, 0xed8c, 0xed4b, 0xed4b, 0xed6b, 0xf58b, 0xed6b, 0xed2a, 0xf52a, 0xed2a, 0xdce9, 0xdcea, 0xedae, 0xf654, 0xfeb6, 0xfef7, 0xfef7, 0xfed6, 0xee54, 0xcd2e, 0xabe9, 0x8b68, 0x6225, 0x59c5, 0x8b6a, 0x8b8a, 0x5a45, 0x49e4, 0x3964, 0x3122, 0x3102, 0x2902, 0x3102, 0x3122, 0x3122, 0x3963, 0x3963, 0x3122, 0x41c5, 0x4a06, 0x62a9, 0x9c6f, 0xb4f0, 0x9bcb, 0x9baa, 0xcd2f, 0xee54, 0xf6b6, 0xf6f8, 0xff5a, 0xff5a, 0xff7a, 0xff5a, 0xfe94, 0xedf1, 0xf5f1, 0xf5cf, 0xf5ae, 0xf5ce, 0xf5ce, 0xf60f, 0xfe93, 0xfe94, 0xe5f2, 0xbcae, 0x9baa, 0x8328, 0x8348, 0x93c9, 0x9baa, 0x9389, 0x8baa, 0xa48e, 0xde56, 0xffbc, 0xffde, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xf7bd, 0xffdd, 0xeef8, 0xbd30, 0xa46d, 0x9c0b, 0x8349, 0x6aa6, 0x6245, 0x5a24, 0x5a04, 0x51e4, 0x5204, 0x5204, 0x6265, 0x6aa6, 0x7b07, 0x8b68, 0x93a8, 0xa40a, 0xbcac, 0xe633, 0xf693, 0xfe92, 0xfe0f, 0xed8c, 0xed4b, 0xed6b, 0xed6b, 0xed4b, 0xed4a, 0xed4a, 0xf56b, 0xf56b, 0xed2a, 0xe54c, 0xfe0f, 0xf654, 0xfeb6, 0xfef7, 0xfef7, 0xfed6, 0xee33, 0xcced, 0xabc8, 0x9bc9, 0x72a6, 0x51a4, 0x6a67, 0x6ac7, 0x5225, 0x5206, 0x41c6, 0x41a4, 0x49c5, 0x49c5, 0x4184, 0x3964, 0x3964, 0x4184, 0x41a5, 0x49c5, 0x5a47, 0x5a68, 0x62c9, 0x93ed, 0x9c0d, 0x8b69, 0xac2c, 0xddb1, 0xf695, 0xf6d6, 0xf718, 0xff5a, 0xff5a, 0xff5a, 0xff19, 0xf653, 0xedd0, 0xf5f0, 0xf5cf, 0xf58d, 0xfdce, 0xfdef, 0xfe30, 0xf652, 0xddb0, 0xb44c, 0x9369, 0x8328, 0x7ae7, 0x72c6, 0x7b27, 0x9bab, 0xa3eb, 0x93aa, 0x93ca, 0xbd51, 0xf719, 0xfffe, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbc, 0xe696, 0xbcef, 0xac6c, 0x93ca, 0x7ae7, 0x6224, 0x59e3, 0x51e3, 0x51c3, 0x51e3, 0x5204, 0x6286, 0x6a86, 0x6245, 0x51c3, 0x51a2, 0x59c2, 0x7285, 0x9baa, 0xd570, 0xf653, 0xfeb3, 0xfe50, 0xfdac, 0xf56b, 0xf56a, 0xed49, 0xdca8, 0xe4e9, 0xed09, 0xf52a, 0xf54a, 0xe50a, 0xe52b, 0xf5cf, 0xf633, 0xfeb6, 0xfef7, 0xfed6, 0xf695, 0xee12, 0xd52e, 0xbc4a, 0xbc6b, 0x8b28, 0x5184, 0x4184, 0x49c4, 0x3962, 0x3102, 0x20a1, 0x28e1, 0x3964, 0x49c5, 0x49c5, 0x49c5, 0x49c5, 0x49e5, 0x5206, 0x5a48, 0x49a5, 0x4185, 0x5226, 0x6ac9, 0x72a7, 0x8307, 0xbcae, 0xd590, 0xee53, 0xf6b6, 0xff39, 0xff7a, 0xff39, 0xff39, 0xf6d7, 0xf652, 0xedd0, 0xf60f, 0xf5ae, 0xed6c, 0xf5ad, 0xfdef, 0xfe30, 0xfe93, 0xcd2f, 0x9368, 0x7286, 0x7286, 0x72a6, 0x6a85, 0x72c6, 0x936a, 0xa3ec, 0x9baa, 0x9389, 0xac8d, 0xde76, 0xffbd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xfffe, 0xef3a, 0xcdd3, 0xb4ad, 0xa40b, 0x8b68, 0x72a6, 0x5a04, 0x5a04, 0x5a04, 0x51e3, 0x49c3, 0x49c3, 0x4162, 0x49c4, 0x51c4, 0x49a3, 0x4962, 0x4962, 0x6205, 0x8308, 0xac2b, 0xdd6f, 0xfe51, 0xfe0f, 0xf56b, 0xed28, 0xe4c7, 0xdc86, 0xcc46, 0xdcc8, 0xed29, 0xf52a, 0xed0a, 0xe4e9, 0xdceb, 0xed8d, 0xf633, 0xfeb5, 0xfed6, 0xf695, 0xe633, 0xe5d1, 0xdd4f, 0xcccc, 0xcccc, 0xa3cb, 0x6a47, 0x4164, 0x3122, 0x18a0, 0x0800, 0x0800, 0x1000, 0x3102, 0x41a4, 0x49c5, 0x5206, 0x5206, 0x5226, 0x6268, 0x3924, 0x1820, 0x1020, 0x20a1, 0x3943, 0x6225, 0x9369, 0xcd2f, 0xd54f, 0xe612, 0xee95, 0xff38, 0xff5a, 0xf739, 0xff39, 0xeeb7, 0xf651, 0xedef, 0xfe0f, 0xf58d, 0xe50b, 0xed6c, 0xf5ae, 0xfe30, 0xfed4, 0xcd4f, 0x9369, 0x7286, 0x6a86, 0x6a86, 0x6aa6, 0x7b07, 0x936b, 0x9bcb, 0x9b89, 0x9368, 0x9bea, 0xc572, 0xf73a, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffff, 0xffde, 0xffde, 0xffdd, 0xe6d8, 0xb510, 0xa42b, 0x9b88, 0x7ae7, 0x6a45, 0x5a04, 0x6245, 0x6245, 0x51c3, 0x3941, 0x3920, 0x3922, 0x4183, 0x49c4, 0x51c4, 0x51c4, 0x51a4, 0x6205, 0x7ac8, 0x9b68, 0xd4ed, 0xfe30, 0xfe0e, 0xfd6a, 0xece8, 0xe485, 0xcc23, 0xcc67, 0xe52a, 0xfd8b, 0xfd8b, 0xf56b, 0xe52a, 0xe52b, 0xed8d, 0xf633, 0xfe95, 0xfeb6, 0xe634, 0xddb1, 0xdd70, 0xd54e, 0xd50d, 0xccab, 0xb44c, 0x8b6c, 0x5a48, 0x3984, 0x20e0, 0x1860, 0x28e3, 0x28a1, 0x4184, 0x5206, 0x5206, 0x5206, 0x5206, 0x5a27, 0x62a8, 0x28a2, 0x1840, 0x2081, 0x28a1, 0x4163, 0x8329, 0xb48d, 0xd52f, 0xdd90, 0xe633, 0xee95, 0xf718, 0xf739, 0xf719, 0xff39, 0xf6d7, 0xf631, 0xf5ef, 0xfe0f, 0xed6c, 0xdcea, 0xed2b, 0xf58e, 0xfe10, 0xfeb4, 0xcd4f, 0x9baa, 0x7ac7, 0x7286, 0x6a66, 0x72c6, 0x7b48, 0x9bcc, 0x9bab, 0x9368, 0x9347, 0x9388, 0xacae, 0xe6d8, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffff, 0xf79d, 0xfffd, 0xff9a, 0xcdf3, 0xb4ee, 0x9beb, 0x8b49, 0x72e8, 0x6a86, 0x6266, 0x5a25, 0x49c3, 0x4182, 0x3961, 0x3100, 0x3942, 0x4162, 0x4183, 0x49a3, 0x49a3, 0x4183, 0x4183, 0x49c4, 0x7a85, 0xc48c, 0xfe51, 0xfe50, 0xed8c, 0xe509, 0xdcc8, 0xdca8, 0xdd0b, 0xe52b, 0xf56b, 0xf56b, 0xed4b, 0xe54b, 0xe56c, 0xedae, 0xf654, 0xf653, 0xfeb5, 0xfeb5, 0xe5f1, 0xd54e, 0xd52c, 0xd50b, 0xc46b, 0xb40a, 0x9b88, 0x7ae6, 0x5a24, 0x3962, 0x3983, 0x4a27, 0x6ae9, 0x5a67, 0x49e5, 0x5226, 0x5226, 0x49c5, 0x5a67, 0x7309, 0x730a, 0x5247, 0x3983, 0x3983, 0x6286, 0x9bca, 0xcccd, 0xe54e, 0xdd6f, 0xe5d2, 0xf695, 0xfef7, 0xf6f8, 0xeeb6, 0xf6d6, 0xff17, 0xf654, 0xf633, 0xf611, 0xf5ef, 0xf5ae, 0xed8d, 0xf5cf, 0xfe31, 0xfe73, 0xdd8f, 0x8327, 0x7b07, 0x7b49, 0x7b6a, 0x6ac7, 0x6ac7, 0x8b68, 0x93a9, 0x9beb, 0x8b69, 0x8349, 0x9c0c, 0xcd93, 0xffdc, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffff, 0xf79d, 0xfffd, 0xef18, 0xc592, 0xacae, 0x93ca, 0x8328, 0x6a86, 0x5a25, 0x51e4, 0x49a3, 0x3961, 0x3961, 0x4182, 0x3941, 0x3941, 0x3921, 0x3942, 0x4183, 0x49a3, 0x4183, 0x4183, 0x4183, 0x6a03, 0xac0b, 0xee11, 0xfe71, 0xfe0e, 0xf5cd, 0xf58c, 0xed4b, 0xd4a9, 0xd4c9, 0xe50a, 0xf56b, 0xf56b, 0xed4b, 0xe56c, 0xedce, 0xf633, 0xf654, 0xfeb6, 0xfef6, 0xee53, 0xddb0, 0xcd2d, 0xc4aa, 0xbc4a, 0xb40a, 0x9ba9, 0x8307, 0x6245, 0x4183, 0x3984, 0x41e5, 0x5a67, 0x5206, 0x49c4, 0x5205, 0x5205, 0x49c4, 0x5a46, 0x6ac8, 0x732a, 0x5a67, 0x41e5, 0x5205, 0x7b29, 0xac4c, 0xcced, 0xdd0d, 0xdd6f, 0xe5d1, 0xee75, 0xf6d7, 0xf6f7, 0xeed7, 0xf6d7, 0xff18, 0xfeb6, 0xf674, 0xf611, 0xf5ef, 0xf5ae, 0xf5ce, 0xfe31, 0xfeb3, 0xff36, 0xcced, 0x7ac6, 0x72c6, 0x5a66, 0x6ac8, 0x7b49, 0x838a, 0x8b48, 0x8b48, 0x8b69, 0x8b69, 0x8349, 0x8b8a, 0xbcf0, 0xff7a, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffdf, 0xffbd, 0xffdc, 0xdeb6, 0xb50f, 0xa44c, 0x8b89, 0x7ae7, 0x6266, 0x5a04, 0x51c3, 0x4982, 0x4161, 0x4162, 0x41a2, 0x4182, 0x3941, 0x3101, 0x3101, 0x3942, 0x4183, 0x4183, 0x4183, 0x4183, 0x59c3, 0xa3ea, 0xee12, 0xfed3, 0xfe71, 0xfe2f, 0xf5ce, 0xed4c, 0xd4a9, 0xd4a9, 0xdce9, 0xf56b, 0xf58c, 0xed6c, 0xed8d, 0xf5ef, 0xee54, 0xf675, 0xf6d6, 0xfef7, 0xf6b5, 0xe612, 0xd54e, 0xbc8a, 0xb40a, 0xabea, 0xa3c9, 0x8b48, 0x6a65, 0x51e4, 0x49c4, 0x49e5, 0x49c4, 0x49e5, 0x49c4, 0x51e5, 0x49e5, 0x49c4, 0x5226, 0x6267, 0x5a67, 0x5205, 0x49c4, 0x5a66, 0x8b8a, 0xb48d, 0xcced, 0xd4ed, 0xdd70, 0xe5d2, 0xee75, 0xf6d7, 0xf6f8, 0xf6d7, 0xfef8, 0xff38, 0xfed6, 0xfe74, 0xf611, 0xedcf, 0xedce, 0xf610, 0xfe93, 0xfef5, 0xfeb4, 0xe5d1, 0x8b48, 0x5204, 0x51e4, 0x5a45, 0x6266, 0x7b49, 0x9369, 0x8b89, 0x8b69, 0x8328, 0x7b08, 0x7b29, 0xa44d, 0xf6f8, 0xffbd, 0xffde, 0xffde, 0xffde, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffdd, 0xffbc, 0xd635, 0xacae, 0x9c2c, 0x8b48, 0x7285, 0x5a25, 0x5a04, 0x51c3, 0x49c3, 0x41a2, 0x4182, 0x3962, 0x3941, 0x3941, 0x3921, 0x3921, 0x4162, 0x4183, 0x4182, 0x4183, 0x49a3, 0x4963, 0x93aa, 0xe612, 0xfef4, 0xfe72, 0xf60f, 0xedce, 0xe54d, 0xe54c, 0xdcea, 0xdce9, 0xf54b, 0xf58c, 0xed4c, 0xed8d, 0xf610, 0xf674, 0xf6b6, 0xfed7, 0xf6d7, 0xee95, 0xe633, 0xdd90, 0xc4cd, 0xabe9, 0xabe9, 0xa3ea, 0x9369, 0x72a6, 0x6245, 0x5a25, 0x5225, 0x49a4, 0x5205, 0x5205, 0x49e5, 0x49c4, 0x49c4, 0x5205, 0x5a26, 0x4a05, 0x49e4, 0x5205, 0x72c7, 0x93ca, 0xbc8d, 0xcd0e, 0xd50e, 0xe5d2, 0xee34, 0xf6b6, 0xf6f8, 0xf6f8, 0xf6f8, 0xff18, 0xff39, 0xfeb6, 0xf654, 0xedf1, 0xedcf, 0xf60f, 0xfe51, 0xfeb4, 0xfed5, 0xfed5, 0xddb1, 0xac6d, 0x838a, 0x6266, 0x5a46, 0x6aa7, 0x6aa7, 0x9389, 0x9c0c, 0x9beb, 0x7b08, 0x72c7, 0x7ae8, 0x9c0c, 0xe655, 0xffdd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffff, 0xffdf, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffdd, 0xff9b, 0xcdf3, 0xa48d, 0x9c2b, 0x8328, 0x6a44, 0x51e4, 0x51c3, 0x49a3, 0x4982, 0x4182, 0x3961, 0x3120, 0x3100, 0x3942, 0x3942, 0x4162, 0x4183, 0x4162, 0x4162, 0x4183, 0x51e4, 0x59c4, 0x938a, 0xddd2, 0xfed4, 0xfe72, 0xfe51, 0xfe30, 0xf5ef, 0xed6d, 0xdcea, 0xdcc9, 0xed4b, 0xf58c, 0xed4c, 0xe56d, 0xedcf, 0xf674, 0xfed6, 0xfef7, 0xf6d6, 0xee95, 0xe633, 0xdd91, 0xd52f, 0xbc6c, 0xb42b, 0xabea, 0x9389, 0x7b07, 0x72a7, 0x6286, 0x5a25, 0x51e5, 0x5a26, 0x5a26, 0x49a4, 0x4163, 0x49a4, 0x51e5, 0x5205, 0x5a67, 0x6aa7, 0x7b08, 0x8b89, 0xa40b, 0xbcad, 0xd54f, 0xe5b1, 0xf654, 0xfeb6, 0xff18, 0xff39, 0xff19, 0xf719, 0xff39, 0xff39, 0xfeb6, 0xf654, 0xedf1, 0xedcf, 0xf631, 0xfeb3, 0xfed5, 0xfed6, 0xee33, 0xa3eb, 0x8b69, 0x93ec, 0x838b, 0x6aa7, 0x6aa6, 0x7ae7, 0x8308, 0x9bcb, 0x9c0c, 0x8349, 0x72e7, 0x72e7, 0x8baa, 0xd5f2, 0xffdd, 0xfffe, 0xffde, 0xffbe, 0xffbe, 0xffdf, 0xffdf, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbe, 0xffdd, 0xf75a, 0xc5b2, 0xa46c, 0x9c0b, 0x8327, 0x6a44, 0x51e4, 0x51e4, 0x49a3, 0x4182, 0x41a2, 0x4182, 0x3961, 0x3962, 0x4183, 0x4182, 0x4162, 0x3941, 0x3101, 0x3921, 0x49c4, 0x6266, 0x8b6a, 0xa42d, 0xddb1, 0xfeb4, 0xfe51, 0xf5f0, 0xf5cf, 0xed8e, 0xe52c, 0xd4aa, 0xdca9, 0xed2b, 0xf56c, 0xed4c, 0xe52c, 0xe56d, 0xee11, 0xfe94, 0xfef6, 0xfed6, 0xf695, 0xe613, 0xdd70, 0xdd2f, 0xcd0e, 0xbc8c, 0xabea, 0x9ba9, 0x8b48, 0x7ae7, 0x6a86, 0x5a25, 0x5a46, 0x5a46, 0x5a25, 0x4183, 0x3942, 0x49a3, 0x51e4, 0x5205, 0x62a7, 0x7308, 0x8b8a, 0x9bea, 0xac2b, 0xc4cd, 0xdd91, 0xee33, 0xfe95, 0xfef7, 0xff39, 0xff5a, 0xff3a, 0xff3a, 0xff39, 0xff19, 0xfef7, 0xfe74, 0xedf1, 0xedcf, 0xf651, 0xfed4, 0xff16, 0xfed6, 0xbcce, 0x7ac6, 0x51c3, 0x6246, 0x836a, 0x7b08, 0x72a7, 0x7ac7, 0x7286, 0x7ae8, 0x938a, 0x93aa, 0x8b69, 0x72e7, 0x8348, 0xbd50, 0xf79d, 0xffde, 0xfffe, 0xffbe, 0xffbe, 0xffde, 0xffdf, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffbd, 0xeef8, 0xbd50, 0x9c4b, 0x9c0a, 0x8307, 0x6a44, 0x5a04, 0x5a04, 0x51c3, 0x49a2, 0x49c3, 0x49c3, 0x41a2, 0x49c3, 0x4183, 0x3942, 0x3101, 0x30e0, 0x30e0, 0x3921, 0x51e4, 0x6287, 0x7aa7, 0x8308, 0xc4cd, 0xf652, 0xfe51, 0xf5ef, 0xf5cf, 0xf58e, 0xe54c, 0xdcca, 0xd489, 0xe4ca, 0xed2b, 0xed4c, 0xe54d, 0xdd4d, 0xe5b0, 0xf632, 0xfe74, 0xfe95, 0xfe75, 0xe5d2, 0xdd2f, 0xdd2e, 0xcd0e, 0xbc8c, 0xac0b, 0x9bca, 0x9369, 0x7ae7, 0x6a86, 0x6a86, 0x6a87, 0x6267, 0x5a46, 0x49a3, 0x4183, 0x51e5, 0x5a26, 0x6266, 0x6287, 0x7b08, 0x9389, 0xa3ea, 0xb42b, 0xc4cd, 0xd591, 0xe613, 0xf655, 0xfeb7, 0xff19, 0xff3a, 0xf73a, 0xff3a, 0xff3a, 0xff19, 0xfed7, 0xf674, 0xedf1, 0xedf0, 0xfe92, 0xfef5, 0xfef6, 0xee96, 0xb46d, 0x59e4, 0x51e4, 0x5a05, 0x6246, 0x7b08, 0x93cb, 0x7ac7, 0x7266, 0x7287, 0x8329, 0x938a, 0x8baa, 0x7b27, 0x7b27, 0xa48d, 0xe71b, 0xffbd, 0xfffe, 0xffde, 0xffbe, 0xffde, 0xffdf, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xff9c, 0xe6b7, 0xb50f, 0x9c2b, 0x9bea, 0x8307, 0x6a44, 0x51e4, 0x51e4, 0x49a3, 0x49a2, 0x49c3, 0x41a2, 0x3961, 0x4182, 0x3921, 0x30e0, 0x30e0, 0x3100, 0x3921, 0x4162, 0x49c4, 0x5a25, 0x40c0, 0x5161, 0xa3a9, 0xedf0, 0xfe51, 0xfdef, 0xfdef, 0xfdce, 0xf5cf, 0xe52c, 0xdca9, 0xdc89, 0xe4ea, 0xe54c, 0xe56d, 0xe56e, 0xedaf, 0xedf0, 0xee12, 0xf633, 0xf653, 0xedb1, 0xdd0e, 0xe50e, 0xbc8c, 0xbc6c, 0xac2b, 0xa3eb, 0x9369, 0x72a6, 0x6a85, 0x7b07, 0x72c8, 0x6aa7, 0x6266, 0x51e4, 0x51e4, 0x6266, 0x6aa7, 0x72e8, 0x6ae8, 0x7b29, 0x93a9, 0xabea, 0xb44b, 0xc4ad, 0xcd50, 0xd5b2, 0xe613, 0xf676, 0xf6f8, 0xf719, 0xf73a, 0xff3b, 0xff3a, 0xff19, 0xf675, 0xee33, 0xe5f1, 0xee10, 0xfeb3, 0xfef5, 0xf6b5, 0xde14, 0x9beb, 0x51a3, 0x49a3, 0x5a25, 0x6a87, 0x6225, 0x7b08, 0x9bcb, 0x7aa8, 0x7ac8, 0x8329, 0x8349, 0x8b89, 0x8b89, 0x8348, 0x93ea, 0xded9, 0xf77c, 0xfffe, 0xffff, 0xffde, 0xffff, 0xffdf, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbd, 0xffdd, 0xde96, 0xb4ce, 0xa44b, 0x9bea, 0x7b08, 0x6a66, 0x59e4, 0x51c3, 0x4983, 0x51c3, 0x51e4, 0x4162, 0x28e0, 0x3100, 0x3921, 0x28c0, 0x3901, 0x4162, 0x4182, 0x51e4, 0x49c3, 0x28c0, 0x3942, 0x4182, 0x72c6, 0xd56f, 0xfe92, 0xedcd, 0xf5cc, 0xf5ec, 0xf5ce, 0xdd0b, 0xd4aa, 0xcc8a, 0xc449, 0xd4aa, 0xe54d, 0xed8e, 0xf5af, 0xf5f0, 0xf5f0, 0xedd0, 0xedf1, 0xedf1, 0xd54f, 0xbc8c, 0xbc8d, 0xb44c, 0xac2b, 0xa40a, 0x9b89, 0x8b27, 0x8307, 0x8b28, 0x7ac6, 0x8b48, 0x8327, 0x7285, 0x6a64, 0x7285, 0x7ae6, 0x8307, 0x8b28, 0x9369, 0x9368, 0x9b89, 0xac4b, 0xc4ed, 0xd54e, 0xddb0, 0xe5d2, 0xee54, 0xf6b6, 0xf6f8, 0xff39, 0xff39, 0xff18, 0xfed6, 0xfe73, 0xdd4e, 0xe58f, 0xedaf, 0xfe52, 0xfe94, 0xf674, 0xb48d, 0x7b09, 0x72e8, 0x5a05, 0x4982, 0x6225, 0x72a6, 0x72a6, 0x72a7, 0x82e8, 0x8328, 0x7b07, 0x8348, 0x8368, 0x8369, 0x8b8b, 0x7b29, 0xbd10, 0xff5a, 0xfffd, 0xffde, 0xffdf, 0xf7be, 0xffdf, 0xf79e, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbd, 0xffdd, 0xe6b6, 0xb4ef, 0xa44b, 0x93a9, 0x72a7, 0x5a25, 0x5a04, 0x51c3, 0x4982, 0x49a3, 0x49c3, 0x3941, 0x30e0, 0x3100, 0x30c0, 0x3942, 0x4983, 0x4162, 0x4142, 0x49a3, 0x4182, 0x30e0, 0x28c0, 0x3101, 0x4961, 0x9ba9, 0xe5b0, 0xf5ef, 0xf5ee, 0xedac, 0xe54d, 0xdd0b, 0xcc8a, 0xc449, 0xc469, 0xccab, 0xd4cc, 0xdd0c, 0xed8f, 0xf5d0, 0xedd0, 0xedb0, 0xe5b0, 0xe5b1, 0xd54f, 0xc4cd, 0xbc8d, 0xbc8c, 0xb46c, 0xac4b, 0xa3ea, 0x93a9, 0x9389, 0x9389, 0x9baa, 0xa3eb, 0x9bca, 0x9369, 0x9389, 0x9389, 0x8b48, 0x8327, 0x9b89, 0xa3ca, 0x9bca, 0x9b88, 0xa3ea, 0xb46b, 0xc4cc, 0xcd4e, 0xdd91, 0xe613, 0xf696, 0xf6d7, 0xff18, 0xff18, 0xfed7, 0xf695, 0xedf1, 0xe5d0, 0xe5af, 0xdd2e, 0xfe52, 0xfe74, 0xc52f, 0x7285, 0x5a46, 0x72c8, 0x72e8, 0x6225, 0x51a3, 0x5a04, 0x72a6, 0x72c7, 0x7286, 0x7b08, 0x8348, 0x8b68, 0x7b07, 0x7b28, 0x8b8a, 0x7b09, 0xa46e, 0xeed8, 0xffdd, 0xffde, 0xffff, 0xffdf, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffdd, 0xffbc, 0xe6b6, 0xbd0f, 0xa44b, 0x8b68, 0x6a66, 0x5a25, 0x5a04, 0x51c3, 0x4962, 0x4982, 0x4182, 0x3921, 0x30e0, 0x3120, 0x28c0, 0x49a3, 0x49c4, 0x3942, 0x3942, 0x49a3, 0x4162, 0x30e0, 0x28e1, 0x3101, 0x28a0, 0x6223, 0xc4ad, 0xe5d0, 0xe5ae, 0xe56d, 0xd50c, 0xd50c, 0xcc8a, 0xc46a, 0xcccb, 0xcc8b, 0xc48a, 0xd4ec, 0xe56f, 0xe58f, 0xedb0, 0xedd1, 0xe5b0, 0xdd6f, 0xd52e, 0xccee, 0xccee, 0xcced, 0xc4ad, 0xbc6c, 0xb46c, 0xbc8d, 0xc4ce, 0xc4ef, 0xc50e, 0xb46c, 0x9368, 0x82e6, 0x8b27, 0x93a9, 0x9bea, 0xac2b, 0x9b89, 0xac0b, 0xac2b, 0xac0a, 0xac2a, 0xbc8c, 0xcd0e, 0xddb0, 0xd550, 0xe5f2, 0xee95, 0xf6d7, 0xf6f8, 0xfef8, 0xf6d6, 0xf695, 0xdd70, 0xe5b0, 0xe590, 0xdd6f, 0xfe73, 0xee32, 0x9beb, 0x4961, 0x4983, 0x5a05, 0x7b08, 0x7b09, 0x5a25, 0x5a04, 0x7286, 0x72a6, 0x6225, 0x7ac7, 0x9389, 0x93a9, 0x72c6, 0x72e7, 0x8b8a, 0x7b09, 0x93cb, 0xde55, 0xff9c, 0xffde, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffde, 0xff9c, 0xe696, 0xbd0f, 0x9c0a, 0x8327, 0x6a66, 0x6246, 0x5a04, 0x51c3, 0x4982, 0x4982, 0x4182, 0x3921, 0x3100, 0x3920, 0x3921, 0x3962, 0x3942, 0x3121, 0x3962, 0x49a3, 0x3962, 0x28a0, 0x28c1, 0x28c1, 0x2880, 0x51a3, 0x9389, 0xbc6c, 0xcced, 0xdd6f, 0xd4ec, 0xcccb, 0xccab, 0xccab, 0xccab, 0xc46b, 0xc4ab, 0xdd4e, 0xd50e, 0xdd4f, 0xe5b0, 0xedf1, 0xedd1, 0xd54f, 0xccee, 0xccee, 0xbc6b, 0xcccd, 0xd52e, 0xd52f, 0xd570, 0xdd90, 0xdd70, 0xcd2f, 0xbcad, 0xa40a, 0x8306, 0x7a84, 0x82c5, 0x8b27, 0xa3c9, 0xbc8d, 0xb44b, 0xc4ee, 0xcd0e, 0xc4ed, 0xcd0e, 0xcd2e, 0xd54f, 0xddb0, 0xddb1, 0xee33, 0xf6b6, 0xf6f7, 0xf6f8, 0xf6d7, 0xf6b6, 0xee75, 0xd570, 0xcd0f, 0xdd6f, 0xedd1, 0xe5d1, 0xbcae, 0x8328, 0x49a2, 0x49a3, 0x3942, 0x5205, 0x72e8, 0x72c8, 0x6aa7, 0x72a7, 0x6aa6, 0x6a45, 0x72a6, 0x93aa, 0xa42b, 0x7b07, 0x6aa6, 0x8b6a, 0x7b09, 0x8369, 0xcdd4, 0xff9c, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffde, 0xff9b, 0xe696, 0xbd30, 0x9bea, 0x7ae6, 0x6245, 0x6245, 0x59e4, 0x51c3, 0x49a3, 0x49a3, 0x4182, 0x3941, 0x3921, 0x3920, 0x49c3, 0x30e0, 0x28e0, 0x3942, 0x3942, 0x3942, 0x3122, 0x2060, 0x1860, 0x1860, 0x3101, 0x51c4, 0x6204, 0x6a24, 0x9348, 0xc4ce, 0xcccc, 0xc4ab, 0xc4ab, 0xbc4a, 0xac09, 0xbc4b, 0xcced, 0xcced, 0xccee, 0xd52e, 0xe590, 0xedf2, 0xedd1, 0xdd4f, 0xd52e, 0xdd4f, 0xe590, 0xedd1, 0xedd1, 0xe590, 0xd52f, 0xcced, 0xb44b, 0xa3c9, 0xa3ea, 0xa3e9, 0x9ba9, 0xa3a9, 0xa3e9, 0xa3a9, 0xa3e9, 0xb46b, 0xcd2e, 0xdd90, 0xdd90, 0xd54f, 0xdd70, 0xdd90, 0xd56f, 0xdd70, 0xee33, 0xf695, 0xf6d6, 0xf6d7, 0xeeb7, 0xee96, 0xee75, 0xe634, 0xddb2, 0xc4ee, 0xdd70, 0xdd90, 0xa3ca, 0x82e7, 0x72a7, 0x51e4, 0x49a4, 0x3922, 0x3921, 0x51c4, 0x6a86, 0x72c8, 0x72c7, 0x6a87, 0x7286, 0x6a65, 0x8b69, 0xa44c, 0x8327, 0x6a86, 0x7b29, 0x7ae9, 0x7b28, 0xc572, 0xff7b, 0xfffe, 0xffde, 0xffde, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbd, 0xff7b, 0xe6b6, 0xbd30, 0x93ca, 0x72c6, 0x5a04, 0x51c4, 0x59e4, 0x51a3, 0x51c3, 0x51c3, 0x4182, 0x4161, 0x3941, 0x3920, 0x49c3, 0x28e0, 0x2900, 0x3942, 0x28c0, 0x20a0, 0x28c1, 0x2080, 0x2080, 0x2080, 0x41a3, 0x5205, 0x4141, 0x38e0, 0x6203, 0x9beb, 0xbcab, 0xc4cc, 0xbc8b, 0x9ba8, 0x9347, 0xbc6b, 0xcd0e, 0xb44b, 0xd52f, 0xd550, 0xdd91, 0xedf2, 0xedf1, 0xe5b0, 0xe5b0, 0xedd1, 0xe58f, 0xe56f, 0xdd4f, 0xd52e, 0xd52e, 0xd52f, 0xd52e, 0xcd0e, 0xc4cd, 0xcced, 0xcced, 0xcd0e, 0xd52e, 0xcced, 0xc4cd, 0xcd0e, 0xd54e, 0xdd8f, 0xd54f, 0xd52e, 0xdd90, 0xe5d1, 0xe5d1, 0xe5d1, 0xee33, 0xf675, 0xee95, 0xee96, 0xee96, 0xeeb6, 0xee95, 0xee54, 0xe5f3, 0xd570, 0xcd50, 0xbc6c, 0x6a44, 0x6a44, 0x72c7, 0x6266, 0x3942, 0x4183, 0x3962, 0x3921, 0x49a3, 0x6266, 0x6a87, 0x6225, 0x7286, 0x6a65, 0x8328, 0x9beb, 0x7b27, 0x6265, 0x72c8, 0x72c8, 0x7b07, 0xb510, 0xff7a, 0xfffd, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbd, 0xf77b, 0xde76, 0xb4ce, 0x8b68, 0x6a85, 0x5a04, 0x51a3, 0x51e4, 0x51a3, 0x51a3, 0x49a3, 0x4162, 0x3941, 0x3941, 0x3120, 0x3941, 0x28e0, 0x28e0, 0x28e0, 0x2080, 0x1840, 0x2081, 0x20a1, 0x20a0, 0x28e0, 0x41a3, 0x49a3, 0x4162, 0x4161, 0x59e4, 0x8b6a, 0xbc8b, 0xc4cc, 0xb46b, 0x9ba8, 0xa3a9, 0xc4ad, 0xcd2f, 0xbcad, 0xe5d2, 0xe5f2, 0xedf2, 0xee13, 0xf612, 0xedf1, 0xedf1, 0xedd1, 0xdd0d, 0xd50d, 0xdd4e, 0xe58f, 0xedd1, 0xedd1, 0xedd1, 0xedd1, 0xe5b0, 0xedd1, 0xe5d1, 0xedd1, 0xedf1, 0xe5d1, 0xe590, 0xe5b0, 0xdd8f, 0xe5d0, 0xe58f, 0xdd8f, 0xedd1, 0xf612, 0xf613, 0xf613, 0xee33, 0xee54, 0xee75, 0xee96, 0xeeb7, 0xf6f7, 0xfed7, 0xf695, 0xee34, 0xd592, 0xac2b, 0x8b07, 0x6204, 0x6a45, 0x6266, 0x72e9, 0x3942, 0x4183, 0x49c4, 0x4183, 0x4162, 0x5a05, 0x6a86, 0x51e4, 0x6a46, 0x7ac7, 0x8348, 0x93a9, 0x7b07, 0x6265, 0x72a7, 0x6aa7, 0x7b07, 0xb4f0, 0xf75a, 0xffdd, 0xf7bd, 0xfffe, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbd, 0xf75a, 0xd614, 0xa44c, 0x7ae6, 0x6a64, 0x6225, 0x59e4, 0x51c4, 0x49a3, 0x49a3, 0x4982, 0x3941, 0x3921, 0x3941, 0x3120, 0x28e0, 0x28e0, 0x20a0, 0x1860, 0x1860, 0x2080, 0x20a1, 0x28c2, 0x28e0, 0x3161, 0x3982, 0x3100, 0x4182, 0x5a04, 0x51e3, 0x72c7, 0xbcac, 0xbcac, 0xb44b, 0xac2b, 0xbcad, 0xc4ee, 0xcd4f, 0xe5d2, 0xee74, 0xf674, 0xf674, 0xfe74, 0xfe74, 0xf632, 0xedd1, 0xe56f, 0xe56f, 0xdd2e, 0xdd2d, 0xe56f, 0xe590, 0xe5b0, 0xedb0, 0xedd1, 0xe590, 0xedf1, 0xf611, 0xf612, 0xf632, 0xf611, 0xe5b0, 0xe5b0, 0xe5af, 0xf611, 0xf631, 0xf632, 0xfe53, 0xfe74, 0xfe54, 0xfe74, 0xfeb5, 0xfeb6, 0xf6b6, 0xf6b7, 0xf6f8, 0xff18, 0xf6d6, 0xee75, 0xf696, 0xd571, 0x7ac6, 0x6a24, 0x6a65, 0x5a04, 0x4162, 0x6ae9, 0x5206, 0x3942, 0x41a4, 0x5205, 0x49a3, 0x5a05, 0x6aa7, 0x5a25, 0x6a45, 0x8329, 0x93aa, 0x8b89, 0x72e6, 0x6a86, 0x72c8, 0x6aa7, 0x7b28, 0xb4ef, 0xf75a, 0xffdd, 0xf7bd, 0xfffe, 0xffbd, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbc, 0xeed8, 0xc551, 0x93cb, 0x7ac7, 0x6a65, 0x6245, 0x5a25, 0x51c4, 0x51c4, 0x49a3, 0x4983, 0x4162, 0x3942, 0x3921, 0x3121, 0x28e0, 0x28c0, 0x28a0, 0x28a0, 0x28c0, 0x28c0, 0x28c0, 0x28c0, 0x28e1, 0x3101, 0x3963, 0x41a4, 0x49c4, 0x28e0, 0x4182, 0x7308, 0xa42c, 0x8328, 0x8b48, 0xac4c, 0xbcee, 0xd570, 0xee33, 0xf674, 0xf718, 0xff18, 0xff18, 0xf6f7, 0xf6d7, 0xfed7, 0xf6d6, 0xf696, 0xf612, 0xee12, 0xedf2, 0xedf2, 0xee32, 0xee53, 0xf673, 0xf674, 0xf695, 0xf6b6, 0xee54, 0xee75, 0xf695, 0xee75, 0xee54, 0xe614, 0xee55, 0xee96, 0xf6b6, 0xf6d7, 0xf6d7, 0xf6d7, 0xfef7, 0xff18, 0xfef6, 0xfeb6, 0xe634, 0xee75, 0xee75, 0xe655, 0xe655, 0xc551, 0x9c0d, 0x93ec, 0x5a25, 0x4162, 0x51c4, 0x6a87, 0x51e4, 0x51c4, 0x5a67, 0x49c4, 0x3963, 0x49c4, 0x5205, 0x51c4, 0x5a05, 0x6266, 0x6224, 0x8328, 0x9c0c, 0x9bec, 0x72e8, 0x5a25, 0x6287, 0x732a, 0x8348, 0xcdd3, 0xf75a, 0xffdd, 0xfffe, 0xf7bd, 0xffbd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xff5b, 0xe697, 0xbd31, 0x93aa, 0x7ac7, 0x6a66, 0x5a25, 0x5204, 0x51c4, 0x4983, 0x4162, 0x4162, 0x4162, 0x3962, 0x3941, 0x3121, 0x28c0, 0x28c0, 0x28c0, 0x28c0, 0x28e0, 0x3101, 0x3101, 0x30e0, 0x28a0, 0x28c0, 0x3942, 0x49e4, 0x3962, 0x20a0, 0x3101, 0x5225, 0x7285, 0x7ae7, 0x9389, 0xac4c, 0xbccd, 0xd570, 0xee54, 0xfeb5, 0xf6f8, 0xff18, 0xff18, 0xff18, 0xfef8, 0xff18, 0xfef7, 0xf6d7, 0xfed6, 0xfeb5, 0xfeb5, 0xfeb5, 0xfeb5, 0xfed5, 0xfed5, 0xfed5, 0xf6b6, 0xfef7, 0xf6b6, 0xfed6, 0xff17, 0xfed7, 0xfed6, 0xfed6, 0xfef7, 0xff18, 0xff18, 0xff18, 0xfef7, 0xfef7, 0xf6b6, 0xee75, 0xee75, 0xddd2, 0xbcef, 0xb4ce, 0xa42c, 0x8b69, 0x8349, 0x72c7, 0x4983, 0x6a67, 0x5a25, 0x4162, 0x3921, 0x49a3, 0x49a3, 0x51c4, 0x5206, 0x5205, 0x3942, 0x4984, 0x49a4, 0x4983, 0x6246, 0x5a25, 0x59c2, 0x72a6, 0x8b8a, 0x8b8a, 0x72c7, 0x5a25, 0x5a66, 0x6ae8, 0x8b89, 0xd614, 0xff7b, 0xffdd, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbc, 0xeed8, 0xbd31, 0x93aa, 0x7ae7, 0x6a86, 0x6245, 0x51e4, 0x51c4, 0x4983, 0x4142, 0x3921, 0x3942, 0x3942, 0x3121, 0x28e0, 0x28a0, 0x28c0, 0x28c0, 0x28e0, 0x3101, 0x3101, 0x3101, 0x30e0, 0x20a0, 0x20a0, 0x3122, 0x51e5, 0x3101, 0x20a0, 0x28e0, 0x49c4, 0x4961, 0x72c6, 0x93aa, 0x9bca, 0xa42b, 0xc50f, 0xddd2, 0xee53, 0xeeb6, 0xf6f7, 0xff18, 0xff38, 0xff39, 0xff59, 0xff59, 0xff18, 0xff38, 0xff18, 0xff17, 0xff17, 0xff17, 0xfef6, 0xf6d6, 0xf6b6, 0xf6b6, 0xfef7, 0xf695, 0xf695, 0xfeb6, 0xf6b6, 0xfed6, 0xff18, 0xfef7, 0xfed7, 0xf6b6, 0xf696, 0xee75, 0xe634, 0xcd92, 0xb4cf, 0xbccf, 0xac6d, 0x9c0c, 0x9beb, 0x7b08, 0x5a25, 0x5a25, 0x5a04, 0x30e0, 0x49a4, 0x5a25, 0x4983, 0x4983, 0x51e4, 0x5a05, 0x49a4, 0x4184, 0x5a26, 0x3942, 0x4143, 0x4142, 0x4142, 0x6266, 0x51e4, 0x59e3, 0x7286, 0x8349, 0x8b8a, 0x7b08, 0x6266, 0x6246, 0x6aa7, 0x93cb, 0xde55, 0xffbb, 0xffdd, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xfffd, 0xeed8, 0xbd10, 0x8b8a, 0x72a6, 0x6a86, 0x6245, 0x5204, 0x51c4, 0x49a3, 0x4142, 0x3921, 0x3101, 0x3101, 0x28e0, 0x28c0, 0x28e0, 0x28e0, 0x30e0, 0x3101, 0x3101, 0x3101, 0x28e0, 0x28c0, 0x2060, 0x2080, 0x28a0, 0x4184, 0x1860, 0x2080, 0x28c0, 0x49c4, 0x6244, 0x93aa, 0x9c0b, 0x93aa, 0xa40b, 0xbcee, 0xddb1, 0xee74, 0xe655, 0xeeb6, 0xf6f8, 0xff18, 0xff39, 0xff79, 0xff5a, 0xff59, 0xff39, 0xff39, 0xff18, 0xff18, 0xf6f7, 0xf6d6, 0xee95, 0xe674, 0xf695, 0xf6b6, 0xee54, 0xddf3, 0xe5f3, 0xddd2, 0xe613, 0xf6b6, 0xfef7, 0xee75, 0xde14, 0xd5b2, 0xcd92, 0xcd71, 0xbcef, 0xa42c, 0xac6d, 0x8b8a, 0x6a86, 0x6245, 0x5a25, 0x5a45, 0x6266, 0x5204, 0x4162, 0x4142, 0x49c4, 0x4162, 0x49a4, 0x51e5, 0x5a26, 0x3942, 0x3922, 0x51e5, 0x4183, 0x3922, 0x3901, 0x4142, 0x5a25, 0x51c4, 0x6224, 0x72a6, 0x8328, 0x93ab, 0x93ab, 0x7b28, 0x72c7, 0x7b08, 0x9c0c, 0xe696, 0xffbc, 0xffdd, 0xffde, 0xffde, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xff5b, 0xde56, 0xac8e, 0x8328, 0x7286, 0x6a66, 0x6245, 0x51e4, 0x49a3, 0x49a3, 0x4983, 0x3921, 0x30e0, 0x28c0, 0x28c0, 0x28e0, 0x3921, 0x3942, 0x3942, 0x3942, 0x3942, 0x3101, 0x28c0, 0x20a0, 0x1000, 0x1860, 0x2080, 0x3963, 0x20a0, 0x3101, 0x3962, 0x5a67, 0x6244, 0x8349, 0x8baa, 0x8348, 0x8b89, 0xa40b, 0xb4ad, 0xcd50, 0xddf4, 0xe655, 0xf6d7, 0xf6f8, 0xff19, 0xff59, 0xff5a, 0xf73a, 0xff5a, 0xff5a, 0xff39, 0xff39, 0xf718, 0xf6d6, 0xe675, 0xe654, 0xf695, 0xfeb6, 0xee54, 0xddd2, 0xd5b2, 0xc530, 0xc4ef, 0xddb2, 0xee75, 0xddf3, 0xcd71, 0xbd10, 0xac8e, 0xac6d, 0xac4d, 0x9c0c, 0x93ec, 0x8349, 0x72c7, 0x5a25, 0x3941, 0x3100, 0x3921, 0x4183, 0x4163, 0x3902, 0x49a4, 0x4163, 0x4163, 0x4143, 0x51e5, 0x4163, 0x3122, 0x4184, 0x49a4, 0x3942, 0x3921, 0x4163, 0x51c4, 0x51e4, 0x6225, 0x6a86, 0x7ae7, 0x93aa, 0xa42c, 0x93aa, 0x8b49, 0x8b89, 0xa46d, 0xeeb7, 0xffbc, 0xffdd, 0xffde, 0xffff, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xf75a, 0xde56, 0xb4cf, 0x8b69, 0x72c6, 0x6a66, 0x5a25, 0x49c3, 0x4162, 0x4983, 0x4983, 0x4142, 0x3101, 0x28e0, 0x3100, 0x3121, 0x4162, 0x4162, 0x4162, 0x4183, 0x3962, 0x3921, 0x28e0, 0x20a0, 0x1840, 0x28c1, 0x28c1, 0x3943, 0x28c0, 0x28c1, 0x3101, 0x49e5, 0x6a86, 0x8369, 0x93eb, 0x8b89, 0x8348, 0x8b89, 0xa42b, 0xbcce, 0xd5d3, 0xe634, 0xeeb6, 0xf6d7, 0xf6f8, 0xf739, 0xf73a, 0xf73a, 0xf75b, 0xf75a, 0xf73a, 0xff39, 0xf718, 0xf6d6, 0xee74, 0xe633, 0xee54, 0xf696, 0xee75, 0xddf3, 0xd5b2, 0xbcae, 0xa40b, 0xb4ae, 0xe655, 0xd592, 0xc530, 0xb4ae, 0x8b69, 0x7ae7, 0x8b69, 0x93aa, 0x6a86, 0x5204, 0x6266, 0x6266, 0x4183, 0x28e0, 0x28e1, 0x49c4, 0x3922, 0x3101, 0x4183, 0x41a4, 0x4183, 0x4183, 0x49e5, 0x49c4, 0x3943, 0x3942, 0x41a4, 0x4163, 0x4142, 0x4983, 0x4983, 0x51e4, 0x6245, 0x6265, 0x72a7, 0x8b69, 0xa42c, 0x9baa, 0x8b48, 0x9389, 0xbd30, 0xf718, 0xffbc, 0xffdd, 0xffff, 0xffdf, 0xffdf, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbc, 0xe6b7, 0xbd10, 0x8b8a, 0x72c6, 0x6a65, 0x5a04, 0x49c3, 0x4162, 0x4983, 0x4983, 0x4162, 0x3921, 0x3101, 0x3121, 0x3121, 0x3921, 0x3921, 0x3942, 0x3942, 0x3942, 0x3101, 0x28c0, 0x20a0, 0x1820, 0x2080, 0x20a1, 0x2080, 0x1860, 0x1860, 0x28e1, 0x41a4, 0x7b28, 0x93cb, 0x9c2c, 0x8b69, 0x7ae7, 0x93a9, 0xbcce, 0xcd70, 0xddf3, 0xe655, 0xf6b7, 0xf6f8, 0xeef8, 0xf719, 0xf73a, 0xf73a, 0xf73a, 0xf739, 0xf719, 0xf718, 0xf6f7, 0xf6b5, 0xee74, 0xe633, 0xe613, 0xee75, 0xee54, 0xddf3, 0xd5b2, 0xb48d, 0x9389, 0xa42c, 0xd5d3, 0xbd10, 0xbcef, 0xac8e, 0x8308, 0x6245, 0x72a6, 0x8328, 0x7b4a, 0x49c4, 0x3942, 0x3121, 0x3942, 0x4183, 0x3121, 0x2901, 0x3101, 0x3101, 0x3101, 0x3943, 0x3943, 0x4163, 0x4163, 0x4163, 0x4183, 0x3943, 0x3963, 0x4183, 0x4983, 0x4983, 0x49a3, 0x5a05, 0x6245, 0x6266, 0x6aa6, 0x8b69, 0xac2c, 0x9bea, 0x9389, 0xa40b, 0xde14, 0xff7a, 0xffbc, 0xffdd, 0xffff, 0xffbf, 0xffdf, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffde, 0xffde, 0xffde, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffbe, 0xffdc, 0xe6b7, 0xb4cf, 0x8349, 0x6a65, 0x6225, 0x5a25, 0x5204, 0x49a3, 0x49a3, 0x4983, 0x4162, 0x3942, 0x3941, 0x3101, 0x3100, 0x28c0, 0x28c0, 0x28e0, 0x30e0, 0x3101, 0x28e0, 0x28a0, 0x2080, 0x2080, 0x2080, 0x28c1, 0x2080, 0x20a0, 0x28e1, 0x49c5, 0x62a8, 0x6aa6, 0x8369, 0x93eb, 0x8349, 0x72c6, 0x9beb, 0xcd71, 0xd5d2, 0xde13, 0xee75, 0xf6d7, 0xf6f8, 0xf719, 0xf73a, 0xf75a, 0xf75b, 0xf75a, 0xf73a, 0xff39, 0xff38, 0xff17, 0xfed6, 0xf694, 0xf673, 0xe634, 0xf675, 0xee54, 0xddf3, 0xddb2, 0xb4ae, 0x9baa, 0xac6d, 0x9bcb, 0x8b69, 0x9c0c, 0xac8e, 0x8b69, 0x6224, 0x59e3, 0x5a04, 0x7309, 0x6ae8, 0x72e8, 0x41a4, 0x28c0, 0x3121, 0x3122, 0x3122, 0x3102, 0x3963, 0x3122, 0x3942, 0x28e1, 0x3942, 0x3102, 0x3963, 0x41a4, 0x4184, 0x3922, 0x4984, 0x49a4, 0x4163, 0x51e4, 0x5a05, 0x5a04, 0x6245, 0x6a86, 0x8b89, 0xb48d, 0xb46d, 0xac4c, 0xc4ee, 0xf6b7, 0xffdc, 0xffbd, 0xffbe, 0xffff, 0xf7be, 0xffdf, 0xffff, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdb, 0xeed7, 0xbd10, 0x8b69, 0x6a65, 0x5a24, 0x5a04, 0x51e4, 0x51e4, 0x49a3, 0x4162, 0x3942, 0x3942, 0x3121, 0x3101, 0x28e0, 0x20a0, 0x20a0, 0x3101, 0x41a3, 0x41a3, 0x3942, 0x3101, 0x3121, 0x1880, 0x1860, 0x1880, 0x1880, 0x1860, 0x28e1, 0x41c4, 0x5226, 0x72e8, 0x72e8, 0xa40c, 0x9bca, 0x9389, 0xcd71, 0xcdb2, 0xcdd3, 0xeeb7, 0xeeb7, 0xeed8, 0xf718, 0xf719, 0xf739, 0xf73a, 0xf73a, 0xff39, 0xf739, 0xf73a, 0xf73a, 0xf739, 0xf6f8, 0xf6b6, 0xee75, 0xe633, 0xee54, 0xf674, 0xee33, 0xd570, 0xac4c, 0xa42b, 0xc50f, 0x7b4a, 0x5a46, 0x5205, 0x8bcc, 0x93ec, 0x6287, 0x6266, 0x4183, 0x5206, 0x5206, 0x5a26, 0x5a46, 0x49c5, 0x3122, 0x3101, 0x3943, 0x3101, 0x3942, 0x3942, 0x3121, 0x28e0, 0x3101, 0x3122, 0x3942, 0x3963, 0x4183, 0x4183, 0x4162, 0x4162, 0x51c4, 0x51e4, 0x51e4, 0x6226, 0x6225, 0x7aa6, 0x9368, 0xb46c, 0xc54f, 0xcdb1, 0xde74, 0xf77d, 0xf79d, 0xffbe, 0xfffe, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdb, 0xeeb7, 0xbd0f, 0x8b69, 0x6a85, 0x6244, 0x5a25, 0x5205, 0x51c4, 0x49a3, 0x4183, 0x3962, 0x3942, 0x3121, 0x3101, 0x28e0, 0x3101, 0x28e0, 0x28e0, 0x3941, 0x3942, 0x28e0, 0x20a0, 0x20a0, 0x2080, 0x1880, 0x20a0, 0x28e1, 0x28c1, 0x3122, 0x3983, 0x41a4, 0x5a25, 0x836a, 0x93cb, 0x93a9, 0xb48d, 0xddf3, 0xd5d3, 0xde55, 0xeed7, 0xeed7, 0xf6f8, 0xf718, 0xf719, 0xf739, 0xf73a, 0xf75a, 0xff39, 0xf739, 0xf73a, 0xf73a, 0xf739, 0xf6f8, 0xf6b6, 0xf675, 0xee33, 0xee54, 0xee74, 0xee33, 0xd591, 0xb48d, 0xac4c, 0xc50f, 0x838b, 0x6266, 0x5205, 0x7b4a, 0x7b4a, 0x6287, 0x6267, 0x51e5, 0x41a4, 0x4163, 0x3963, 0x4184, 0x41a4, 0x4183, 0x3922, 0x3101, 0x28e0, 0x3121, 0x3942, 0x3121, 0x3101, 0x3121, 0x3942, 0x3942, 0x3942, 0x4163, 0x4183, 0x49a3, 0x49c4, 0x5a05, 0x5a25, 0x5a25, 0x5a05, 0x6225, 0x7ac7, 0x9389, 0xb4ad, 0xd5d1, 0xe674, 0xf737, 0xf79d, 0xffbd, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffbb, 0xe6b6, 0xb4ef, 0x8b69, 0x7285, 0x6265, 0x6245, 0x5a25, 0x49c4, 0x49a4, 0x49a3, 0x4183, 0x3942, 0x3121, 0x3101, 0x2900, 0x3121, 0x28e0, 0x20a0, 0x28c0, 0x28e0, 0x3101, 0x28e0, 0x28e0, 0x20a0, 0x1880, 0x20a0, 0x28e0, 0x20c0, 0x2901, 0x3142, 0x3121, 0x5205, 0x93cb, 0x8b69, 0x93a9, 0xcd50, 0xe633, 0xde34, 0xeed7, 0xf6f8, 0xf6f8, 0xf6f8, 0xf718, 0xf719, 0xf739, 0xff5a, 0xff5a, 0xff39, 0xf73a, 0xf73a, 0xf73a, 0xf739, 0xf718, 0xf6b6, 0xf675, 0xee54, 0xee54, 0xee54, 0xee54, 0xddb1, 0xbcce, 0xb48d, 0xbcee, 0x93ec, 0x6aa7, 0x5a25, 0x6aa7, 0x6aa7, 0x5a26, 0x5205, 0x49c4, 0x3943, 0x3122, 0x3101, 0x3102, 0x3963, 0x4184, 0x3943, 0x3101, 0x28e0, 0x3101, 0x3122, 0x3121, 0x3121, 0x3122, 0x3942, 0x3942, 0x3942, 0x4183, 0x41a3, 0x49c4, 0x51e4, 0x5a25, 0x5a25, 0x5a25, 0x6266, 0x6a66, 0x8308, 0x93a9, 0xb48d, 0xd5d2, 0xf6f6, 0xff99, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xff9a, 0xe676, 0xb4ef, 0x8b89, 0x72c6, 0x6a65, 0x6245, 0x5205, 0x49c4, 0x49a4, 0x49a3, 0x4183, 0x3962, 0x3941, 0x3121, 0x3101, 0x28e0, 0x28c0, 0x28c0, 0x28e0, 0x3121, 0x3962, 0x3942, 0x3101, 0x20a0, 0x20a0, 0x2901, 0x3101, 0x28e0, 0x28e1, 0x3142, 0x3122, 0x6266, 0x836a, 0x8b8a, 0xa40b, 0xcd50, 0xde13, 0xe675, 0xeed7, 0xf6f8, 0xf6f8, 0xf6f8, 0xf718, 0xf719, 0xf73a, 0xff5a, 0xff7a, 0xff39, 0xff5a, 0xf75a, 0xf75a, 0xf73a, 0xf718, 0xf6b6, 0xf695, 0xee54, 0xee54, 0xee54, 0xee54, 0xe5f2, 0xcd2f, 0xbcad, 0xb48d, 0x9bec, 0x72c7, 0x6a66, 0x6266, 0x5a26, 0x5205, 0x49a4, 0x3963, 0x3943, 0x3963, 0x3963, 0x3942, 0x3122, 0x3122, 0x3942, 0x3943, 0x28e0, 0x28e1, 0x3101, 0x3101, 0x3101, 0x3122, 0x3942, 0x3962, 0x3963, 0x4163, 0x4183, 0x49a3, 0x51e4, 0x5a05, 0x5a25, 0x5a25, 0x6266, 0x6a86, 0x8308, 0x9389, 0xa42c, 0xcd91, 0xf6f7, 0xffba, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xf77a, 0xde35, 0xacae, 0x8b89, 0x7ae7, 0x6a86, 0x5a25, 0x51e4, 0x49c4, 0x49a4, 0x49a3, 0x4183, 0x3962, 0x3941, 0x3121, 0x3121, 0x28e0, 0x28e0, 0x3101, 0x3941, 0x3962, 0x3962, 0x3101, 0x20a0, 0x28c0, 0x3121, 0x41a3, 0x49c4, 0x3942, 0x3942, 0x41a3, 0x49c4, 0x6aa7, 0x7b08, 0x9beb, 0xb4ae, 0xd591, 0xe634, 0xe675, 0xeeb6, 0xf6f8, 0xf6f8, 0xf6f8, 0xf718, 0xf719, 0xff5a, 0xff5a, 0xff7b, 0xff59, 0xff5a, 0xf75a, 0xf75a, 0xf73a, 0xf718, 0xf6d7, 0xf695, 0xee54, 0xee54, 0xee74, 0xf674, 0xee33, 0xd591, 0xbcce, 0xac4c, 0x9bcb, 0x7ae7, 0x6a66, 0x6225, 0x5a05, 0x5205, 0x49a4, 0x4183, 0x4163, 0x4184, 0x41a4, 0x3963, 0x3101, 0x28e1, 0x3122, 0x4183, 0x3101, 0x28e0, 0x28c0, 0x28c0, 0x28e1, 0x3121, 0x3942, 0x3963, 0x4183, 0x4183, 0x4183, 0x49a3, 0x51e4, 0x5a05, 0x6245, 0x6266, 0x6a86, 0x72c7, 0x8308, 0x9389, 0x9beb, 0xbd30, 0xeed7, 0xffbb, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xef18, 0xcdd3, 0xa46d, 0x8b69, 0x7ae7, 0x6a86, 0x5a25, 0x51e4, 0x51c4, 0x49a4, 0x4183, 0x4162, 0x3942, 0x3942, 0x3141, 0x3121, 0x3101, 0x3100, 0x28e0, 0x3101, 0x3101, 0x3100, 0x28e0, 0x28c0, 0x28e0, 0x3942, 0x49c4, 0x49c4, 0x3942, 0x3942, 0x51e4, 0x5a46, 0x72e8, 0x7b29, 0x9c0c, 0xbcce, 0xd5b1, 0xde13, 0xe675, 0xf718, 0xeed7, 0xf6d8, 0xf6f8, 0xf718, 0xf719, 0xff5a, 0xff5a, 0xff7a, 0xff59, 0xff5a, 0xf75a, 0xf75a, 0xf73a, 0xf718, 0xf6b6, 0xf695, 0xee54, 0xee54, 0xf674, 0xf695, 0xee54, 0xe5f2, 0xcd2f, 0xb46c, 0xac2c, 0x9369, 0x7286, 0x6245, 0x5a05, 0x49c4, 0x41c4, 0x3984, 0x4183, 0x4163, 0x3963, 0x3922, 0x3101, 0x28e1, 0x3102, 0x3943, 0x3942, 0x3101, 0x28c0, 0x28c0, 0x28e1, 0x3121, 0x3942, 0x3963, 0x5205, 0x49e5, 0x49c4, 0x51e4, 0x51e4, 0x5a05, 0x5a25, 0x6246, 0x6ac7, 0x72e7, 0x8328, 0x8b89, 0x9beb, 0xaccf, 0xde76, 0xff9b, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xe6d7, 0xc572, 0x940b, 0x8328, 0x7ac6, 0x6a86, 0x6245, 0x5a25, 0x51e4, 0x49a3, 0x4162, 0x3942, 0x3942, 0x3942, 0x3141, 0x3121, 0x3121, 0x28e0, 0x28c0, 0x28c0, 0x28c0, 0x20a0, 0x28e0, 0x3942, 0x3101, 0x3921, 0x4183, 0x4162, 0x3101, 0x3942, 0x5205, 0x6266, 0x6ac8, 0x836a, 0x9c0c, 0xb48d, 0xcd50, 0xcd91, 0xee96, 0xf6f7, 0xeeb7, 0xeeb7, 0xeed8, 0xf718, 0xf719, 0xff5a, 0xff5a, 0xff5a, 0xff39, 0xff5a, 0xf75a, 0xf75a, 0xf739, 0xf718, 0xf6b6, 0xf695, 0xee74, 0xee54, 0xf674, 0xf695, 0xf674, 0xee54, 0xddb1, 0xbcce, 0xbcad, 0xac0b, 0x7ae7, 0x72a7, 0x6246, 0x41a3, 0x41a4, 0x3963, 0x3963, 0x3963, 0x3942, 0x3101, 0x28e1, 0x3101, 0x3122, 0x3122, 0x4183, 0x3121, 0x28e0, 0x28e1, 0x3121, 0x3122, 0x3942, 0x3962, 0x5205, 0x49e5, 0x49e4, 0x5205, 0x5a05, 0x5a05, 0x5a25, 0x6245, 0x62a6, 0x72c7, 0x7b07, 0x8b89, 0x93cb, 0xa46e, 0xd615, 0xff9b, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xffdd, 0xde96, 0xbd31, 0x8baa, 0x7ae7, 0x72a6, 0x6a86, 0x6266, 0x6266, 0x51e4, 0x49a3, 0x4162, 0x3942, 0x3942, 0x3942, 0x3141, 0x3121, 0x3101, 0x28e0, 0x28e0, 0x3121, 0x28e0, 0x20a0, 0x28c0, 0x3942, 0x3101, 0x3921, 0x4183, 0x49a3, 0x4162, 0x4183, 0x5a25, 0x5a46, 0x6266, 0x836a, 0x9beb, 0xb4ad, 0xbcce, 0xbd0f, 0xeeb6, 0xde34, 0xe696, 0xeeb7, 0xeed8, 0xf6f8, 0xf719, 0xf73a, 0xff5a, 0xff5a, 0xff39, 0xf73a, 0xf73a, 0xf73a, 0xf739, 0xf718, 0xf6b6, 0xf695, 0xf674, 0xee54, 0xf674, 0xf695, 0xf674, 0xf695, 0xe633, 0xcd50, 0xbc8d, 0xb44c, 0x8307, 0x8308, 0x72c7, 0x49c4, 0x49e5, 0x3984, 0x3942, 0x4184, 0x4183, 0x3101, 0x28c0, 0x3101, 0x3122, 0x3122, 0x41a3, 0x3942, 0x3101, 0x3121, 0x3942, 0x3942, 0x3942, 0x3962, 0x3942, 0x3942, 0x4183, 0x51e4, 0x5a25, 0x5a25, 0x6266, 0x6a87, 0x6ac6, 0x72e7, 0x7ae7, 0x8b69, 0x93aa, 0x93ec, 0xbd73, 0xf71a, 0xffbd, 0xffbe, 0xffbe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffd, 0xf7bc, 0xf7dd, 0xfffe, 0xf7de, 0xffdd, 0xffdd, 0xff9c, 0xd613, 0xa4ad, 0x8368, 0x7307, 0x72e7, 0x72e7, 0x72a7, 0x6a66, 0x59e5, 0x51a4, 0x4162, 0x3942, 0x3942, 0x3942, 0x3121, 0x28e0, 0x28e0, 0x28e0, 0x28e0, 0x3101, 0x3101, 0x3101, 0x3101, 0x3101, 0x3121, 0x49e5, 0x49e4, 0x4183, 0x3963, 0x49e5, 0x49e4, 0x49e4, 0x6245, 0x8bab, 0x9c0c, 0x93cb, 0xac8e, 0xcd71, 0xd592, 0xd5b2, 0xddf2, 0xf6b6, 0xee95, 0xf6f7, 0xff39, 0xff5a, 0xf73a, 0xff7b, 0xff3a, 0xff3a, 0xff3a, 0xff39, 0xff19, 0xf6f8, 0xf6d7, 0xf6d6, 0xf696, 0xee34, 0xee54, 0xee95, 0xee96, 0xf6b6, 0xee95, 0xde13, 0xd5b2, 0xc550, 0xa44d, 0x8b8a, 0x72e8, 0x4183, 0x6287, 0x3963, 0x3102, 0x3922, 0x3922, 0x30e1, 0x28c1, 0x28e1, 0x3122, 0x3122, 0x4183, 0x49e4, 0x4163, 0x3101, 0x4163, 0x4183, 0x3942, 0x3922, 0x3942, 0x3942, 0x4183, 0x49c4, 0x51e4, 0x5a05, 0x5a25, 0x6a86, 0x6ae7, 0x72e7, 0x7308, 0x8349, 0x8369, 0x8b8a, 0xac8d, 0xde13, 0xf77a, 0xffdd, 0xffde, 0xffbe, 0xffdf, 0xffff, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdc, 0xf7bc, 0xf7dd, 0xf7de, 0xf7bd, 0xffbd, 0xff9c, 0xf73a, 0xd5f2, 0xacad, 0x8b89, 0x8327, 0x72e6, 0x72a6, 0x6a65, 0x6224, 0x5a26, 0x51e5, 0x41a4, 0x4163, 0x3983, 0x3983, 0x3163, 0x3143, 0x3101, 0x3100, 0x28e0, 0x28e0, 0x28c0, 0x28e1, 0x3101, 0x3102, 0x3942, 0x5205, 0x5205, 0x49c4, 0x3963, 0x41a3, 0x3942, 0x3942, 0x6ac7, 0x8349, 0x8b8a, 0x93ec, 0xac6d, 0xac6d, 0xac6d, 0xc530, 0xb4ad, 0xde13, 0xe675, 0xf6f8, 0xff39, 0xff5a, 0xf73a, 0xff7b, 0xf73a, 0xff3a, 0xff3a, 0xff39, 0xf718, 0xf6f7, 0xf6d7, 0xeed6, 0xf696, 0xee34, 0xee54, 0xee75, 0xee95, 0xf6b6, 0xeeb6, 0xe654, 0xde13, 0xd5b2, 0xc530, 0x93eb, 0x6266, 0x3101, 0x6287, 0x3122, 0x28c1, 0x30e1, 0x28e1, 0x28c0, 0x28c0, 0x30e1, 0x3122, 0x3122, 0x4163, 0x49c4, 0x41a3, 0x3962, 0x49a4, 0x49e4, 0x41a3, 0x4163, 0x4183, 0x4163, 0x4183, 0x49c4, 0x51e4, 0x5a05, 0x6266, 0x72c8, 0x72c7, 0x72e8, 0x7308, 0x7b28, 0x8349, 0x8349, 0x9c0c, 0xc530, 0xf75a, 0xffdd, 0xfffe, 0xffde, 0xffdf, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xffdc, 0xf7dc, 0xf7dd, 0xf7dd, 0xf7dd, 0xfffd, 0xff9c, 0xeed8, 0xd5f1, 0xb4cd, 0x9c0a, 0x9be9, 0x9388, 0x8b27, 0x7ac6, 0x7264, 0x5224, 0x51e3, 0x4183, 0x3962, 0x3142, 0x2922, 0x2902, 0x20e2, 0x28e0, 0x28c0, 0x20a0, 0x20a0, 0x20a0, 0x28c0, 0x28c1, 0x28e1, 0x4183, 0x49e4, 0x4183, 0x3942, 0x3101, 0x3121, 0x3121, 0x3963, 0x72c8, 0x7308, 0x7b29, 0x93cb, 0x9c0c, 0x8b6a, 0x8349, 0xa42c, 0x9beb, 0xd5d2, 0xe675, 0xf6f7, 0xf719, 0xff5a, 0xf73a, 0xff7b, 0xf73a, 0xff3a, 0xff3a, 0xff39, 0xf718, 0xf6f7, 0xf6d7, 0xeeb6, 0xf696, 0xee55, 0xee55, 0xee75, 0xee75, 0xf6b6, 0xf6b6, 0xee75, 0xee74, 0xe654, 0xde14, 0xa44d, 0x5a45, 0x3101, 0x6287, 0x3122, 0x28c1, 0x28e1, 0x28c1, 0x28c0, 0x28e1, 0x3942, 0x3963, 0x3943, 0x3922, 0x4183, 0x41a3, 0x4183, 0x49a4, 0x49c4, 0x4183, 0x3942, 0x4163, 0x3963, 0x4183, 0x49a3, 0x51c4, 0x51e4, 0x6245, 0x6aa7, 0x6ac7, 0x7308, 0x7b08, 0x7b28, 0x8369, 0x8b89, 0x9c0b, 0xbcef, 0xe6f8, 0xff9c, 0xffde, 0xffde, 0xffff, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffd, 0xffdd, 0xffdd, 0xf7bd, 0xf7bd, 0xffbc, 0xf719, 0xd615, 0xbced, 0xac2a, 0xa40a, 0xb46b, 0xbc8c, 0xb46b, 0xac09, 0x9ba8, 0x8b47, 0x7b06, 0x6a85, 0x5a03, 0x49a3, 0x4162, 0x3922, 0x3122, 0x3121, 0x3101, 0x3100, 0x28e0, 0x28e1, 0x28c0, 0x28c1, 0x28c1, 0x4183, 0x41a3, 0x3101, 0x28c0, 0x20a0, 0x3121, 0x4183, 0x5a46, 0x5a45, 0x6ac7, 0x72e8, 0x7b29, 0x7b08, 0x72c7, 0x6a66, 0x72c7, 0x9c0b, 0xd5f3, 0xe675, 0xf6d7, 0xf718, 0xff5a, 0xf73a, 0xf73a, 0xf73a, 0xf73a, 0xf739, 0xff39, 0xf718, 0xf6f7, 0xf6d7, 0xeeb6, 0xfeb6, 0xee55, 0xee55, 0xee75, 0xee75, 0xee95, 0xf6b6, 0xee95, 0xe633, 0xee75, 0xd5d3, 0x8b8a, 0x5204, 0x3101, 0x5226, 0x28e1, 0x28c0, 0x28c0, 0x28c0, 0x28c0, 0x3101, 0x3963, 0x4183, 0x3963, 0x3942, 0x4183, 0x49a4, 0x41a3, 0x41a3, 0x41a3, 0x4163, 0x3922, 0x3942, 0x3963, 0x41a3, 0x51e4, 0x5a25, 0x5a25, 0x6266, 0x6aa7, 0x72e7, 0x7b28, 0x8349, 0x8349, 0x8b8a, 0x93ca, 0xa40b, 0xac8d, 0xdeb7, 0xf77b, 0xffde, 0xffde, 0xffff, 0xffde, 0xffde, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xf79c, 0xf7bc, 0xffdd, 0xfffd, 0xffbd, 0xf79b, 0xe696, 0xbd51, 0xbced, 0xb46c, 0xbcac, 0xcd2e, 0xd54e, 0xcd0d, 0xc4ed, 0xc4cc, 0xbc8a, 0xac28, 0x9b86, 0x82c4, 0x6a23, 0x59a2, 0x4961, 0x4921, 0x3121, 0x3101, 0x28e0, 0x28c0, 0x28c0, 0x28c0, 0x28e1, 0x3101, 0x3122, 0x3942, 0x28e0, 0x28e0, 0x28e0, 0x3942, 0x41a3, 0x5a66, 0x41a3, 0x5205, 0x5205, 0x6266, 0x5a25, 0x6245, 0x6245, 0x6aa6, 0x9c0b, 0xd5f2, 0xe675, 0xeed7, 0xf718, 0xff5a, 0xf73a, 0xf73a, 0xf73a, 0xf73a, 0xf739, 0xff39, 0xf718, 0xf6f7, 0xf6d7, 0xeeb6, 0xfed7, 0xf675, 0xee75, 0xee75, 0xee55, 0xee75, 0xeeb6, 0xe675, 0xe654, 0xee95, 0xbd10, 0x6a66, 0x5a25, 0x3942, 0x49c4, 0x3102, 0x28c0, 0x28c1, 0x28c0, 0x28c0, 0x3101, 0x3963, 0x4184, 0x4183, 0x4183, 0x49c4, 0x49c4, 0x49a4, 0x49a4, 0x49a4, 0x41a3, 0x4183, 0x3963, 0x3963, 0x4183, 0x49c4, 0x51e4, 0x51e4, 0x5a05, 0x6246, 0x6aa6, 0x8348, 0x8baa, 0x93eb, 0xa44c, 0xac6c, 0xac6d, 0xb4ae, 0xded8, 0xf77b, 0xfffe, 0xffff, 0xffff, 0xffbe, 0xf7bd, 0xffdd, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xff9c, 0xffbd, 0xfffe, 0xfffe, 0xffbc, 0xef19, 0xcdd3, 0xa48d, 0x8307, 0x7ae6, 0x8b48, 0xa40a, 0xb46b, 0xb48b, 0xc4ec, 0xcd0d, 0xcccb, 0xbc8a, 0xb429, 0xa3a7, 0x8b26, 0x7284, 0x59c1, 0x5160, 0x41a3, 0x3962, 0x3121, 0x28e0, 0x28c0, 0x28e1, 0x3102, 0x3922, 0x28c0, 0x3121, 0x28e0, 0x28e0, 0x28c0, 0x28e0, 0x3101, 0x41a3, 0x41a3, 0x4183, 0x3942, 0x51e4, 0x49c3, 0x51e4, 0x5a25, 0x7b28, 0x9bea, 0xd5b2, 0xe655, 0xf6f7, 0xf718, 0xf739, 0xf73a, 0xf75a, 0xf73a, 0xff3a, 0xff3a, 0xff39, 0xf718, 0xf6f7, 0xf6d7, 0xeeb6, 0xfed7, 0xf675, 0xee75, 0xee75, 0xee75, 0xee95, 0xee95, 0xe654, 0xee74, 0xe634, 0xa44c, 0x51a3, 0x5204, 0x3942, 0x4163, 0x3122, 0x3102, 0x3942, 0x3942, 0x3122, 0x3942, 0x4183, 0x41a4, 0x49a4, 0x4183, 0x4183, 0x4183, 0x4163, 0x4183, 0x41a3, 0x4183, 0x41a3, 0x4183, 0x3963, 0x4163, 0x49a3, 0x49c4, 0x51e4, 0x6246, 0x6aa7, 0x8349, 0x9c0c, 0xac8d, 0xb4ce, 0xbcee, 0xb4ae, 0xb48d, 0xbcce, 0xdeb7, 0xf75b, 0xffbd, 0xffde, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde, 
0xfffe, 0xffdd, 0xffdd, 0xf77c, 0xd6b8, 0xbdb3, 0xa4ae, 0x8ba9, 0x8348, 0x72a6, 0x72c6, 0x9388, 0xa42a, 0xbccc, 0xcd4e, 0xd56e, 0xd58f, 0xd56f, 0xcd2e, 0xc50e, 0xb4cd, 0xa46b, 0x8bc9, 0x7b47, 0x5225, 0x49e4, 0x41a3, 0x3942, 0x3122, 0x3101, 0x3122, 0x3942, 0x28e0, 0x3942, 0x3101, 0x3101, 0x28c0, 0x3101, 0x3101, 0x3962, 0x4183, 0x41a3, 0x4162, 0x51e4, 0x49a3, 0x5a25, 0x6266, 0x7b08, 0xb4ad, 0xde13, 0xe675, 0xf6f7, 0xff39, 0xf739, 0xf739, 0xff7b, 0xf73a, 0xff3a, 0xff3a, 0xff39, 0xf718, 0xf6f7, 0xf6d7, 0xeed6, 0xfeb6, 0xee55, 0xee55, 0xee95, 0xee95, 0xf696, 0xee95, 0xde34, 0xd5d2, 0xc530, 0x93eb, 0x59e4, 0x51e4, 0x3121, 0x3942, 0x30e1, 0x3942, 0x4183, 0x4184, 0x3943, 0x3122, 0x3943, 0x4184, 0x49a4, 0x4163, 0x4183, 0x3922, 0x3121, 0x4163, 0x4163, 0x3942, 0x4163, 0x4183, 0x4163, 0x4183, 0x49c4, 0x5a25, 0x6a87, 0x7b08, 0x8b8a, 0x9c0b, 0xac8d, 0xb4ae, 0xb48d, 0xac4c, 0xa40b, 0xa40b, 0xb4ad, 0xe6d8, 0xf77b, 0xffbd, 0xffbe, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffde, 0xffde, 0xffde, 0xffde, 0xffde
};
const unsigned short  Rabbit[] PROGMEM = {
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffdf, 0x9cf3, 0x4208, 0x31c6, 0xc638, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xc618, 0x528a, 0x7bef, 0x39e7, 0xb5b6, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xe73c, 0x5aeb, 0x8c71, 0x8430, 0x4a49, 0xa534, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7be, 0x738e, 0x73ae, 0x8410, 0x8410, 0x5acb, 0x9cd3, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xad55, 0x528a, 0x7c10, 0x73af, 0x73af, 0x632d, 0x8410, 0xef9e, 0xffff, 0xf7be, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef5d, 0x528b, 0x8431, 0x6b4d, 0x5aec, 0x8431, 0x6b4d, 0x73af, 0xf7bf, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x8431, 0x632d, 0x8410, 0x630c, 0x52ab, 0x8451, 0x73af, 0x5aec, 0xef5d, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0x4a6a, 0x8431, 0x7bd0, 0x2945, 0x738e, 0x8c52, 0x630c, 0x4208, 0xd6ba, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x9cb3, 0x5aab, 0x9452, 0x62ec, 0x6b6d, 0x5aea, 0x8c90, 0x63af, 0x3208, 0xadd7, 0xffff, 0xf7de, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xb596, 0xc638, 0xe73c, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef5d, 0x5acb, 0x8c31, 0x6b2d, 0x8410, 0x9491, 0x630a, 0x8cb3, 0x73f0, 0x52eb, 0x8c71, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xad75, 0xc618, 0xbdf7, 0xb5b6, 0xdedb, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xa514, 0x4a29, 0x8411, 0x6b2d, 0xc5d6, 0x7b8d, 0x5aec, 0x8431, 0x8451, 0x630c, 0x5b0c, 0xef5d, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xce59, 0xffdf, 0xf79e, 0xef7d, 0xa534, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xf79e, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7ff, 0xf7ff, 0x52ab, 0x8c11, 0x734d, 0xacd3, 0xde58, 0x738e, 0x6b2d, 0x83d0, 0x9472, 0x5acb, 0x39c8, 0xe71d, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffdf, 0xf79e, 0x94b2, 0xef5d, 0xffff, 0xe73c, 0x8c51, 0x9cd3, 0xc638, 0xffff, 0xffdf, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xc619, 0x5aab, 0x8c10, 0x6acb, 0xde78, 0xe6b9, 0x734c, 0x62cb, 0x9471, 0x8431, 0x738f, 0x39e9, 0xb5f9, 0xffdf, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xdedb, 0xce59, 0xd6ba, 0xb596, 0x9cf3, 0xffff, 0xf79e, 0x8c71, 0xa514, 0xe73c, 0xef5d, 0xa534, 0xffff, 0xffdf, 0xffdf, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0x738e, 0x734d, 0x732c, 0x8c2f, 0xeed9, 0xe698, 0x9c4f, 0x62aa, 0x8c51, 0x7c10, 0x7c11, 0x428b, 0x8c71, 0xe73c, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xc638, 0xce79, 0xe73c, 0x6b6d, 0x8410, 0xf7be, 0xef7d, 0x8430, 0xce59, 0xffdf, 0xffff, 0xef7d, 0xad75, 0xffdf, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xd67a, 0x5aeb, 0x8c50, 0x6b4b, 0xddf4, 0xee97, 0xe677, 0x9c70, 0x5269, 0x7c10, 0x8451, 0x7411, 0x5aeb, 0x73ae, 0xe73c, 0xffff, 0xffff, 0xffff, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xc618, 0xef7d, 0xffff, 0xb5b6, 0x8c71, 0xffff, 0xe73c, 0x6b6d, 0xef7d, 0xf7be, 0xf79e, 0xffff, 0xb5b6, 0xf79e, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffdf, 0x7c0f, 0x630b, 0x6b8c, 0x9369, 0xee96, 0xeed7, 0xde77, 0xa512, 0x52eb, 0x73ef, 0x7c51, 0x94b2, 0x4a69, 0x5acb, 0xd6ba, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xb5b6, 0xffdf, 0xffff, 0xbdd7, 0x7bef, 0xf7be, 0xef7d, 0x8430, 0xdedb, 0xffdf, 0xf79e, 0xffdf, 0xc618, 0xce79, 0xef7d, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xe73c, 0x4a69, 0x8c51, 0x62eb, 0xb533, 0xf697, 0xfe55, 0xfe55, 0xbd11, 0x5aa9, 0x6bae, 0x73f1, 0x8473, 0x632d, 0x3a08, 0xad75, 0xffff, 0xfffd, 0xfffd, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xbdf7, 0xdedb, 0xf79e, 0xce38, 0x7bef, 0xffdf, 0xef7d, 0x7bef, 0xe6fb, 0xffdf, 0xef7e, 0xf79e, 0xef7d, 0xad75, 0xffff, 
0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xad75, 0x738e, 0x8410, 0x6b0b, 0xe616, 0xfe97, 0xee15, 0xe656, 0xc5d5, 0x6b4c, 0x6b4d, 0x8431, 0x9493, 0x7bf1, 0x528b, 0x8430, 0xf7bd, 0xfffe, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xc618, 0xd69a, 0xf7be, 0xce59, 0x7bef, 0xf7be, 0xf77e, 0x8410, 0xdefb, 0xffbf, 0xef7d, 0xef7e, 0xf79e, 0xa535, 0xf7be, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf79e, 0xffff, 0xf79e, 0x73ae, 0x638e, 0x630c, 0x93ee, 0xee36, 0xe5f5, 0xfef9, 0xe697, 0xbd73, 0x6b2b, 0x736d, 0x8410, 0x7bd0, 0x8c73, 0x6baf, 0x636d, 0xefde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xce59, 0xc638, 0xffbf, 0xd6ba, 0x7bef, 0xf77e, 0xf79e, 0x8410, 0xdedb, 0xf7be, 0xf79e, 0xef7e, 0xf7be, 0x94b2, 0xd6ba, 
0xffff, 0xf79e, 0xffff, 0xf79e, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xd6ba, 0x4aac, 0x94b3, 0x5a8a, 0xb4d2, 0xfed9, 0xddf4, 0xe655, 0xf6f8, 0xde56, 0x7b6c, 0x62cb, 0x8c52, 0x8432, 0x6bb0, 0x534e, 0x324a, 0xdedb, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xd6ba, 0xb5b6, 0xffdf, 0xdefb, 0x7bef, 0xef5d, 0xffbe, 0x8c31, 0xd6ba, 0xf79e, 0xf7bf, 0xef7e, 0xffdf, 0x8c51, 0xc618, 
0xffdf, 0xffff, 0xffff, 0x7bef, 0x8c51, 0xe73c, 0xf7be, 0xffff, 0xffff, 0xf7be, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0x9d36, 0x634e, 0x8c51, 0x732c, 0xd617, 0xee97, 0xee55, 0xee54, 0xe656, 0xeeb8, 0x9c70, 0x5aaa, 0x7bf0, 0x94d4, 0x7412, 0x6390, 0x4a69, 0xc618, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe71c, 0xa514, 0xffdf, 0xe73c, 0x83ef, 0xe73c, 0xffbf, 0x8c51, 0xd69a, 0xf79e, 0xf79e, 0xef7e, 0xffff, 0x8c51, 0xc639, 
0xffff, 0xffff, 0xf79e, 0x7bef, 0x5aeb, 0x94b2, 0x9cd3, 0xdedb, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0x6b6e, 0x6b6e, 0x6b4e, 0x736d, 0xe698, 0xee96, 0xe634, 0xf697, 0xddf5, 0xf6d9, 0xacd1, 0x62ca, 0x738e, 0x7bf1, 0x8c94, 0x7bcf, 0x4a69, 0x9cd3, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0x9492, 0xffdf, 0xef5d, 0x8410, 0xe71c, 0xffbe, 0x8c71, 0xd6ba, 0xf79e, 0xf79e, 0xf79e, 0xffdf, 0x8410, 0xd69a, 
0xf7be, 0xffff, 0xffff, 0xd69a, 0x8430, 0x8c51, 0x6b6d, 0x73ae, 0xad75, 0xdedb, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe73c, 0x422a, 0x7c12, 0x630d, 0x8c0f, 0xe676, 0xee75, 0xee56, 0xee56, 0xe655, 0xff18, 0xcdb4, 0x7b4c, 0x7b6e, 0x8bf2, 0x8430, 0x8430, 0x630c, 0x6b6d, 0xef5d, 0xffff, 0xe73c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8c51, 0xffbf, 0xef5d, 0x8410, 0xe71c, 0xf7be, 0x8c71, 0xdebb, 0xf7be, 0xf7be, 0xf7bf, 0xef7e, 0x7bcf, 0xe71c, 
0xffff, 0xffff, 0xffff, 0xffdf, 0xa514, 0x94b2, 0x9492, 0x8410, 0x6b4d, 0x7bef, 0xad75, 0xef5d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xffff, 0xce5a, 0x5b0e, 0x8c52, 0x6b2c, 0xa44e, 0xf6b6, 0xee36, 0xe615, 0xee55, 0xe654, 0xf6b7, 0xde16, 0x8b8f, 0x6aad, 0x8430, 0x8430, 0x94b2, 0x52aa, 0x5acb, 0xdedb, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x8410, 0xffbe, 0xef5d, 0x8430, 0xe71c, 0xf79e, 0x8c71, 0xdedb, 0xf7be, 0xef7e, 0xf7bf, 0xef5d, 0x7bcf, 0xf79e, 
0xffdf, 0xffff, 0xffff, 0xffff, 0xef7d, 0x8c51, 0x5acb, 0x8c71, 0x6b8f, 0x8452, 0x6b6e, 0x73cf, 0x8c72, 0xd6db, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0x9492, 0x8430, 0x8410, 0x632c, 0xad55, 0xee76, 0xee76, 0xf656, 0xf656, 0xee15, 0xee77, 0xe657, 0x9c90, 0x5a89, 0x8410, 0x8452, 0x8493, 0x5b2d, 0x3a08, 0xdeba, 0xfffe, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8410, 0xffde, 0xef5d, 0x8c71, 0xef3d, 0xf79e, 0x9493, 0xe71d, 0xf79f, 0xef7d, 0xf79e, 0xce79, 0x7bef, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe71c, 0x9492, 0x52aa, 0x6b8f, 0x4aab, 0x7c31, 0x8452, 0x6b6e, 0x8c72, 0x8410, 0xad55, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0x630c, 0x630c, 0x8c71, 0x52aa, 0xcdd5, 0xf6d8, 0xddd4, 0xf656, 0xfe97, 0xddf5, 0xf6d8, 0xe697, 0xb554, 0x6b0b, 0x738e, 0x7c31, 0x8452, 0x73cf, 0x4208, 0xdeba, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8410, 0xffde, 0xef5d, 0x94b2, 0xef3d, 0xf79e, 0x9cd4, 0xe71d, 0xf79f, 0xf79e, 0xffdf, 0xb596, 0x9492, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xdefb, 0x8430, 0x73af, 0x73af, 0x4209, 0x4a6a, 0x7c10, 0x8c51, 0x7bcf, 0x6b2c, 0x73f0, 0x9cf4, 0xce9b, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0x5aeb, 0x632c, 0x8c71, 0x5a89, 0xcdf6, 0xf6f9, 0xde15, 0xee55, 0xee76, 0xe615, 0xf697, 0xeeb8, 0xbd73, 0x6b2b, 0x6b4d, 0x8c72, 0x7c11, 0x7bf0, 0x4249, 0xd69a, 0xffff, 0xef7d, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8410, 0xffde, 0xef5d, 0xa514, 0xef5d, 0xf79e, 0xad35, 0xef3d, 0xf79f, 0xf79e, 0xffdf, 0x9492, 0xbdd7, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xe73c, 0x6b4e, 0x73d0, 0x6b8e, 0x528a, 0x52ab, 0x632d, 0x7bef, 0x8c51, 0x8473, 0x636f, 0x52ec, 0x73af, 0xad76, 0xdefb, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0x4208, 0x6b6d, 0x8411, 0x630c, 0xbd95, 0xf719, 0xde35, 0xee35, 0xee56, 0xf636, 0xee56, 0xee76, 0xc5b4, 0x6b2b, 0x738d, 0x8c72, 0x8cb3, 0x532e, 0x528a, 0xdefb, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8410, 0xffde, 0xef5d, 0xb5b6, 0xef5d, 0xf77e, 0xbdd8, 0xef5d, 0xf79e, 0xf79e, 0xf79e, 0x7bcf, 0xe71c, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7df, 0x634d, 0x7bf0, 0x738e, 0x630c, 0x9472, 0x7bae, 0x5acb, 0x6baf, 0x7c31, 0x8c93, 0x8431, 0x632d, 0x5acb, 0x7bef, 0xa535, 0xef5d, 0xf77e, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf79e, 0x4a69, 0x6b6f, 0x736e, 0x736d, 0xb574, 0xf719, 0xee76, 0xe615, 0xf656, 0xee55, 0xee35, 0xf6b8, 0xbd73, 0x6b2b, 0x8410, 0x73f1, 0x9515, 0x5acb, 0x5aeb, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8410, 0xffbe, 0xef5d, 0xce59, 0xef5d, 0xf77e, 0xd67a, 0xef7e, 0xf77e, 0xf7be, 0xe71c, 0x73ae, 0xffdf, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xe73d, 0x73ae, 0x7baf, 0x83ef, 0x7bae, 0xbdd6, 0xa513, 0x7b8d, 0x6b2c, 0x6b0c, 0x7bae, 0x8c51, 0x8c52, 0x73cf, 0x632d, 0x7bf0, 0x9492, 0xbdd8, 0xe73d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0x4a8a, 0x73af, 0x630c, 0x6b2c, 0xb554, 0xe698, 0xee56, 0xee15, 0xee55, 0xf697, 0xddd4, 0xff19, 0xacf2, 0x62eb, 0x8451, 0x7411, 0x9cd3, 0x52aa, 0x8410, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8410, 0xffbe, 0xef5d, 0xdedb, 0xef7e, 0xf77e, 0xe71c, 0xf79e, 0xf77e, 0xffdf, 0xc638, 0x8c51, 0xffdf, 0xffff, 
0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x7bae, 0x528a, 0x8c30, 0x6b0b, 0xce38, 0xeeb9, 0xcd94, 0x940e, 0x6aea, 0x5aca, 0x6b6e, 0x8431, 0x8cb3, 0x8c51, 0x73af, 0x736e, 0x7bf0, 0x8c72, 0xa535, 0xd6bb, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xef5d, 0x62eb, 0x5aec, 0x83f0, 0x630c, 0x9c91, 0xf6d9, 0xee76, 0xe636, 0xddf4, 0xf696, 0xee76, 0xeed8, 0x9c70, 0x632c, 0x8451, 0x8430, 0x8c71, 0x4a49, 0xd69a, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8410, 0xffbe, 0xef5d, 0xef5d, 0xf77e, 0xef7e, 0xf77e, 0xf79f, 0xf77e, 0xffdf, 0xad55, 0xad75, 0xffdf, 0xffff, 
0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0x83cf, 0x6b2c, 0x83cf, 0x62eb, 0xd593, 0xee77, 0xf6f9, 0xd637, 0xa4d2, 0x73af, 0x632d, 0x5b0d, 0x8410, 0x7baf, 0x7bf0, 0x8c52, 0x83f0, 0x630c, 0x5aec, 0x738e, 0xa514, 0xe71c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xfffe, 0xffde, 0x7c10, 0x634e, 0x8411, 0x62eb, 0x940e, 0xe635, 0xee97, 0xe656, 0xee56, 0xee55, 0xe636, 0xf6fa, 0x9471, 0x632c, 0x8430, 0x8410, 0x7bef, 0x528a, 0xf79e, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8410, 0xf7be, 0xef5d, 0xf77e, 0xf77e, 0xef7e, 0xffbf, 0xf7bf, 0xf77e, 0xf79e, 0x9492, 0xc638, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf79e, 0x8c71, 0x52aa, 0x8430, 0x6aea, 0xacf2, 0xe698, 0xe698, 0xde57, 0xe677, 0xd5f5, 0xa46f, 0x732b, 0x730b, 0x6b2c, 0x7bae, 0x7c10, 0x7c32, 0x7c52, 0x7c53, 0x6b8f, 0x73cf, 0x7bf0, 0xad55, 0xef5d, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffde, 0xa4f3, 0x630b, 0x73ae, 0x6b6d, 0x6b6e, 0xcd93, 0xf6b8, 0xee77, 0xde15, 0xe636, 0xeeb8, 0xd5d5, 0x836b, 0x6b8f, 0x8452, 0x8452, 0x6bb0, 0xb5b7, 0xffff, 0xffde, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8430, 0xf7bf, 0xe73d, 0xf79e, 0xf77e, 0xef5e, 0xf79f, 0xf77e, 0xf7bf, 0xef7d, 0x7bcf, 0xef5d, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xe71c, 0xa514, 0x8410, 0x8c30, 0x62ca, 0x9cb1, 0xde98, 0xe698, 0xe697, 0xe656, 0xee77, 0xeeb8, 0xcdb5, 0x9c50, 0x736c, 0x62eb, 0x630c, 0x6b8e, 0x7bf0, 0x8410, 0x8c72, 0x8431, 0x73af, 0x73af, 0x8c31, 0xbdb7, 0xf7bf, 0xf79e, 0xffff, 0xffdf, 0xffff, 0xd69a, 0x4a69, 0x4249, 0x8430, 0x62a8, 0xa490, 0xde57, 0xf71a, 0xe657, 0xe656, 0xf6d8, 0xd5b4, 0x5acb, 0x7bcf, 0x94d4, 0x632e, 0x5b0d, 0xf79e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8430, 0xf77e, 0xef5e, 0xef5d, 0xef7e, 0xef7e, 0xf79f, 0xef7e, 0xf79f, 0xe71c, 0x738e, 0xffff, 0xf7be, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xb5b6, 0x7c10, 0x8c71, 0x5aca, 0x83ad, 0xde77, 0xeed8, 0xe656, 0xe635, 0xee56, 0xee97, 0xee98, 0xde57, 0xc594, 0xa491, 0x7b8d, 0x62ca, 0x734c, 0x7bae, 0x7bae, 0x7bef, 0x8431, 0x73f0, 0x636e, 0x638f, 0x94d4, 0xbe39, 0xf7ff, 0xf7df, 0xffff, 0xf79e, 0x5aeb, 0x39c7, 0x83ee, 0x6b0b, 0x7b6c, 0xc594, 0xe698, 0xe656, 0xee76, 0xf697, 0xa4d2, 0x62eb, 0x83ef, 0x8431, 0x52ec, 0xe73d, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8430, 0xf79f, 0xf79e, 0xd6bb, 0xe73d, 0xef7e, 0xf77e, 0xf77e, 0xf7bf, 0xc638, 0x8c51, 0xffff, 0xffff, 0xef5d, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xbe59, 0x73cf, 0x8410, 0x6b2c, 0x5a89, 0xb512, 0xe656, 0xee97, 0xee35, 0xee56, 0xee56, 0xe656, 0xee77, 0xee77, 0xde15, 0xcd93, 0x942f, 0x83ae, 0x6b0b, 0x62eb, 0x73af, 0x7c11, 0x7c11, 0x7c32, 0x5b4e, 0x9515, 0x8493, 0xb5f8, 0xef9e, 0xffff, 0xf7be, 0x9492, 0x2125, 0x6b4d, 0x736d, 0x6b0b, 0xa4b1, 0xde36, 0xe676, 0xe635, 0xde36, 0x836c, 0x734c, 0x9cf4, 0x5b0d, 0x8cb4, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8430, 0xffff, 0xef5e, 0xbdb7, 0xe71c, 0xef7e, 0xef7e, 0xf77e, 0xffff, 0xb5b6, 0x9cf3, 0xf79e, 0xffff, 0x9cf4, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7ff, 0xce9a, 0x73af, 0x738e, 0x8c2f, 0x6b0a, 0x93ee, 0xe657, 0xee56, 0xee56, 0xe636, 0xe635, 0xee76, 0xfeb7, 0xf696, 0xee35, 0xf6d9, 0xe678, 0xc594, 0x9c70, 0x7bae, 0x6b4d, 0x632d, 0x6b6e, 0x8472, 0x73d0, 0x6b8f, 0x634d, 0x4a6a, 0x632d, 0xbdf8, 0xffff, 0xd6fc, 0x426a, 0x39e8, 0x738d, 0x6aea, 0x732b, 0xc573, 0xe697, 0xf6b8, 0xc574, 0x62ca, 0x8410, 0x6baf, 0x426b, 0xefdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8430, 0xffdf, 0xd6bb, 0xa515, 0xef5e, 0xf79e, 0xef5e, 0xef7e, 0xffff, 0x9cd3, 0xb596, 0xffff, 0xad55, 0x7bcf, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xe75d, 0x8c51, 0x8c30, 0x9cd2, 0x62ea, 0x734c, 0xc594, 0xde37, 0xeed9, 0xee97, 0xde15, 0xddd4, 0xe614, 0xf676, 0xde15, 0xe677, 0xeeb8, 0xeed9, 0xe698, 0xc5b5, 0x9c70, 0x7b8d, 0x5aaa, 0x6b4c, 0x840f, 0x8c51, 0x7c10, 0x6b6e, 0x5aeb, 0x5aec, 0xc67a, 0xf7ff, 0x9cf4, 0x3186, 0x5acb, 0x7bad, 0x62ca, 0x942f, 0xd5b4, 0xf6d9, 0x83ad, 0x6b4d, 0x94b3, 0x4a6a, 0xce9b, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8430, 0xe6fc, 0xbdd8, 0xa514, 0xffdf, 0xe73d, 0xef5d, 0xef5e, 0xf7bf, 0x9cf4, 0xb5b7, 0xef5d, 0x8430, 0xd6bb, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xad96, 0x73cf, 0x73cf, 0x7c10, 0x6b0b, 0x8c2f, 0xc5b5, 0xe698, 0xeeb8, 0xee76, 0xee56, 0xee56, 0xee56, 0xe656, 0xe615, 0xe615, 0xee56, 0xf697, 0xf6b8, 0xee77, 0xcdb5, 0xa4b0, 0x6ac9, 0x5aa9, 0x7bae, 0x8410, 0x7c10, 0x73d0, 0x4249, 0x6b8e, 0xe73d, 0xdf1c, 0x630c, 0x39e7, 0x632c, 0x7bcf, 0x7b2a, 0xc5b5, 0xb554, 0x630c, 0x7bf0, 0x5b0c, 0x8c72, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8430, 0xc5f8, 0xa535, 0xad56, 0xffdf, 0xc639, 0xe71c, 0xf79e, 0xf79e, 0xad76, 0x6b4d, 0x7bcf, 0xad75, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xf7be, 0xffff, 0xdf1d, 0x7c31, 0x8493, 0x8431, 0x6b4d, 0x630b, 0x8c0f, 0xc5b5, 0xee98, 0xee97, 0xe656, 0xe615, 0xee56, 0xee76, 0xee55, 0xee35, 0xee35, 0xf634, 0xee14, 0xf696, 0xe635, 0xeeb8, 0xbd94, 0x7bce, 0x5aec, 0x52cc, 0x7411, 0x8431, 0x5aec, 0x3a08, 0x39e8, 0x4229, 0x10e4, 0x0021, 0x4a8a, 0x836c, 0x6aea, 0x9cb2, 0x6b2d, 0x7bcf, 0x7bf0, 0x5aaa, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x8430, 0xad76, 0x9cf4, 0xb597, 0xf79f, 0xa535, 0xdedb, 0xf7bf, 0xf7bf, 0xef5d, 0xa514, 0xb5b6, 0xffff, 0xef7d, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xc638, 0x738e, 0x6b6d, 0x8430, 0x632c, 0x6b4d, 0x7bcf, 0xad55, 0xdedb, 0xee98, 0xee98, 0xee77, 0xe657, 0xee77, 0xee56, 0xe636, 0xee56, 0xde57, 0xde37, 0xde57, 0xeeb9, 0xe699, 0xcdd6, 0xa470, 0x6aa9, 0x6b4d, 0x7bcf, 0x8c72, 0x528b, 0x0021, 0x0862, 0x0042, 0x0883, 0x39e8, 0x738e, 0x73af, 0x31a7, 0x5acb, 0x8c72, 0x52ab, 0xe73d, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0x8430, 0xa514, 0x9492, 0xbdf8, 0xdedc, 0x94b3, 0xffdf, 0xef5e, 0xf79f, 0xef7e, 0xffff, 0xf79f, 0xe71d, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xf79e, 0x9cf3, 0x7bcf, 0x73ae, 0x8c51, 0x738e, 0x630c, 0x632c, 0xa470, 0xbd53, 0xde36, 0xee98, 0xeeb9, 0xe677, 0xe636, 0xe677, 0xee98, 0xee77, 0xe636, 0xde16, 0xe616, 0xee77, 0xf6b8, 0xde16, 0x7bcf, 0x39a7, 0x3187, 0x18a3, 0x2125, 0x2105, 0x10a3, 0x0863, 0x2104, 0x4229, 0x634d, 0x738f, 0x632d, 0x73af, 0x632d, 0x9cd3, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffde, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0x7bcf, 0x9cf3, 0x8c71, 0xbdb7, 0xb5b7, 0xb5b7, 0xf79f, 0xef3e, 0xef7f, 0xffff, 0xe71d, 0xf7bf, 0xffff, 0xb576, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe73c, 0x9492, 0x738e, 0x73ae, 0x8430, 0x7bcf, 0x62ca, 0x6aeb, 0x6b0b, 0x7b8d, 0xa491, 0xbd74, 0xd5f6, 0xe698, 0xf697, 0xf6b8, 0xf6b8, 0xf6b7, 0xf697, 0xee77, 0xd5b4, 0xac6f, 0x41e7, 0x18a2, 0x3165, 0x2904, 0x20e3, 0x18e4, 0x3186, 0x41e8, 0x4229, 0x52ab, 0x52ab, 0x73cf, 0x73af, 0x8c72, 0x73af, 0x2104, 0xdedb, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0x8410, 0x94b3, 0x8431, 0xc639, 0x8c72, 0xd69a, 0xffdf, 0xe73e, 0xef5e, 0xef5d, 0xef7e, 0xef7e, 0xef5e, 0x73af, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdefb, 0x9492, 0x73ae, 0x6b6d, 0x7bef, 0x8430, 0x840f, 0x738e, 0x6b4c, 0x62eb, 0x62eb, 0x734c, 0x940e, 0x9c2f, 0x9c6f, 0xacd1, 0xbd53, 0xc594, 0xb512, 0x9c4f, 0xb554, 0xc5b6, 0xce17, 0x9cb2, 0x2924, 0x18a2, 0x1061, 0x1082, 0x39e8, 0x7bf0, 0x7bf0, 0x8431, 0x7bf0, 0x8411, 0x7bf0, 0x4a6a, 0x39e8, 0x8410, 0xef5d, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xad55, 0x8431, 0x738e, 0xb596, 0x8c72, 0xdedc, 0xef7e, 0xf77f, 0xef5e, 0xef7e, 0xffbf, 0xf79e, 0xf79e, 0xd6bb, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf79e, 0xffff, 0xffff, 0xf79e, 0xbdf7, 0x8431, 0x73cf, 0x632c, 0x632d, 0x7c10, 0x8c51, 0x840f, 0x7bce, 0x6b6d, 0x6b4d, 0x632c, 0x5aeb, 0x5aeb, 0x5aeb, 0x630c, 0x632c, 0x6b2c, 0x5a89, 0x20e3, 0x18a2, 0x0000, 0x20e3, 0x18c3, 0x3166, 0x2966, 0x4209, 0x4a6a, 0x632d, 0x7bf0, 0x7bf0, 0x73cf, 0x8411, 0x83f0, 0x632d, 0x7baf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xdefb, 0x7bcf, 0x528a, 0x630c, 0x5aab, 0x5acb, 0xe73d, 0xffff, 0xef5e, 0xef7f, 0xf79e, 0xef7d, 0xef5d, 0xc618, 0xf7be, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef9e, 0xc639, 0x9cf3, 0x7c10, 0x6b6d, 0x5aeb, 0x5acb, 0x6baf, 0x6baf, 0x73f0, 0x7c11, 0x8472, 0x7c52, 0x73f0, 0x7411, 0x6b2c, 0x5269, 0x31a6, 0x5269, 0x6b6d, 0x4249, 0x2125, 0x39e7, 0x3186, 0x2125, 0x2966, 0x3186, 0x4229, 0x73af, 0x8451, 0x7bcf, 0x8432, 0x8411, 0x5acc, 0xb596, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xe71c, 0xc618, 0xf79e, 0xf7be, 0xdefc, 0x7bf0, 0x8c52, 0xf79f, 0xef5e, 0xf79f, 0xef7d, 0xffff, 0xe73c, 0xd6ba, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdefb, 0xce58, 0x9d35, 0x94d3, 0x8451, 0x73f0, 0x73f0, 0x6baf, 0x52cb, 0x4a8a, 0x4a49, 0x4208, 0x52ab, 0x5b0c, 0x29a7, 0x2986, 0x52cc, 0x6b8f, 0x4a49, 0x73af, 0x8c52, 0x5aec, 0x2104, 0x2945, 0x73af, 0x7bf0, 0x83f1, 0x7bf1, 0x7baf, 0x31a7, 0xe71d, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xa514, 0xad55, 0x52ab, 0x632d, 0xdefc, 0xef7e, 0x738e, 0xb597, 0xffff, 0xef3e, 0xf7be, 0xe71c, 0xc618, 0xf79e, 0xffdf, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xf7df, 0xffff, 0xe75d, 0x2186, 0x52ec, 0x8493, 0x426b, 0x6b6e, 0x7bf0, 0x6b6e, 0x8410, 0x6b4e, 0x2966, 0x5aec, 0x73af, 0x7bd1, 0x73b0, 0x8431, 0x6b6e, 0x39e8, 0xe73d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf79e, 0x39c7, 0x2965, 0x5aeb, 0x4a6a, 0x2104, 0xd69a, 0xc639, 0x73af, 0xe73e, 0xffdf, 0xef7d, 0xce59, 0xe71c, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xb5b7, 0x426a, 0x7c11, 0x73f0, 0x6baf, 0x73cf, 0x5acb, 0x8431, 0x5acb, 0x8431, 0x52ab, 0x528a, 0x73cf, 0x73d0, 0x73d0, 0x73af, 0x8452, 0x52cb, 0x5b0c, 0xe77d, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf79e, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7de, 0xffff, 0xffff, 0xffff, 0xa535, 0x39c7, 0x7bcf, 0x73b0, 0x8c72, 0x5aac, 0x41e8, 0xdedc, 0x8431, 0xce7a, 0xef7d, 0xc618, 0xe71c, 0xffdf, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7e, 0xef9e, 0x632c, 0x73cf, 0x7c31, 0x6baf, 0x6bcf, 0x5aec, 0xbdd8, 0xdefc, 0xa535, 0x632d, 0x6b4d, 0x6b6e, 0x7bf0, 0x73b0, 0x8431, 0x73b0, 0x73d0, 0x8431, 0x634d, 0x7c30, 0xf7bf, 0xf7be, 0xffff, 0xffff, 0xf7be, 0xffdf, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffdf, 0x94b3, 0x4a6a, 0x7bf0, 0x7bf0, 0x83f1, 0x6b6e, 0x8411, 0x3187, 0xc619, 0x94b3, 0xb5b6, 0xc618, 0xe73c, 0xffdf, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xa535, 0x4a69, 0x7bf0, 0x8472, 0x73f0, 0x7c11, 0x6b6e, 0xef7e, 0xffdf, 0xe73d, 0x7c10, 0x6b4d, 0x6b6e, 0x7bcf, 0x73d0, 0x7c11, 0x7c11, 0x6b6e, 0x8431, 0x8451, 0x5b0c, 0x7bf0, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7be, 0xf79e, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xf79e, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0x8410, 0x5acb, 0x8c72, 0x73af, 0x7bd0, 0x7bd0, 0x83f0, 0x8c52, 0x39c8, 0x8c72, 0xce79, 0xce79, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7e, 0x632d, 0x8431, 0x73cf, 0x8431, 0x8452, 0x6baf, 0x8c51, 0xe75d, 0xe73d, 0xf79e, 0xc639, 0x630c, 0x6b4d, 0x738f, 0x7c11, 0x73b0, 0x7bf0, 0x8431, 0x73f0, 0x7c10, 0x7c10, 0x634d, 0x94b2, 0xffdf, 0xffff, 0xef7d, 0xffff, 0xffdf, 0xffdf, 0xef5d, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xef7d, 0x6b6e, 0x632d, 0x8431, 0x7bd0, 0x8c52, 0x73af, 0x738f, 0x8431, 0x7bcf, 0x3166, 0x9492, 0xce7a, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x52ab, 0x39e8, 0x8431, 0x8431, 0x73cf, 0x8472, 0x5b4d, 0x8c72, 0xf7bf, 0xef5d, 0xef5d, 0xef7e, 0x7bd0, 0x738e, 0x7bf0, 0x7bf1, 0x8432, 0x6b8f, 0x73d0, 0x7c10, 0x7bf0, 0x8c72, 0x7bf0, 0x39c7, 0x630c, 0xef7d, 0xffff, 0xffff, 0xf7be, 0xef7d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xef5d, 0x52ab, 0x738e, 0x8c92, 0x738f, 0x7bd0, 0x6b6f, 0x7bf1, 0x8410, 0x8410, 0x7bcf, 0x8c51, 0xdedb, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x8c72, 0x31c7, 0x2966, 0x5b0c, 0x8451, 0x73cf, 0x8472, 0x5b4d, 0x9493, 0xffff, 0xe73d, 0xef7e, 0xf7bf, 0xad55, 0x6b4d, 0x8431, 0x73b0, 0x7bf1, 0x7c11, 0x8431, 0x8431, 0x7c10, 0x73af, 0x5b0c, 0x4228, 0x2945, 0x7bef, 0xef5d, 0xc638, 0xad75, 0xf7be, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xffff, 0xe71c, 0x4a49, 0x4a8a, 0x7c10, 0x8c52, 0x73af, 0x7bf1, 0x8411, 0x7bd0, 0x8411, 0x7baf, 0x9cf4, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x630c, 0x7bcf, 0x4a8a, 0x6b6e, 0x7c31, 0x7c31, 0x7c11, 0x634e, 0x94d3, 0xf7bf, 0xe71c, 0xef7e, 0xf79e, 0xd69a, 0x5aec, 0x8410, 0x8c93, 0x73b0, 0x8452, 0x8452, 0x632d, 0x3a08, 0x31a7, 0x52eb, 0x7bcf, 0x8430, 0x5aeb, 0x4a69, 0x738e, 0x94b2, 0xad75, 0xb596, 0xc638, 0xce59, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xdedb, 0x52aa, 0x52ab, 0x8431, 0x8431, 0x632d, 0x7bf1, 0x7bf1, 0x632e, 0x8c73, 0x8431, 0xa514, 0xef7e, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x73af, 0x3a08, 0x634d, 0x7bf0, 0x73cf, 0x8472, 0x73f0, 0x6b8f, 0x8c72, 0xef7e, 0xffdf, 0xe73d, 0xef5d, 0xef5d, 0x6b4d, 0x7bd0, 0x7c11, 0x8452, 0x634e, 0x3a09, 0x636e, 0x8c72, 0x94d3, 0xf7bf, 0xffff, 0xd69a, 0x9492, 0xdedb, 0xffff, 0xf79e, 0xd69a, 0x4208, 0x0861, 0x39e7, 0xce59, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xf7be, 0xffff, 0xd69a, 0x4a69, 0x5acb, 0x8c72, 0x7bcf, 0x7bf0, 0x8c52, 0x7bd0, 0x73b0, 0x8c53, 0x94b4, 0x8410, 0xf7bf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0x8c51, 0x528a, 0x738e, 0x7bcf, 0x8431, 0x7c11, 0x7c11, 0x73af, 0x8431, 0xe73d, 0xef7e, 0xef7e, 0xe73d, 0xf7bf, 0x94b3, 0x6b4d, 0x8c92, 0x52ec, 0x426a, 0xb5d7, 0xdefc, 0xa535, 0xf79e, 0xf7bf, 0x9cf4, 0xa514, 0xd69b, 0xffff, 0xdedc, 0xa514, 0x9492, 0x9cd4, 0x528b, 0x4a4a, 0xe71d, 0xffff, 0xf79e, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xce39, 0x4a49, 0x5acb, 0x9472, 0x7c11, 0x73d0, 0x8431, 0x6b6f, 0x7bf0, 0x7bd0, 0x5acc, 0x7bd0, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xce79, 0x9492, 0xa535, 0x6b6e, 0x8451, 0x7c10, 0x7c11, 0x73b0, 0x738e, 0xef9e, 0xe71c, 0xe71d, 0xffdf, 0xdf1c, 0x9cf4, 0x73af, 0x636e, 0x426a, 0xd6bb, 0xe73d, 0x8c72, 0xf7bf, 0xf7bf, 0x8c52, 0xad56, 0xef3d, 0xf7bf, 0xb597, 0x8c72, 0xc619, 0xffbf, 0xf7bf, 0xef7e, 0xb597, 0xb5b7, 0xf79e, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xef7d, 0xffff, 0xffff, 0xf7be, 0xffff, 0xf7be, 0xffff, 0xef7d, 0xbdf8, 0x4a6a, 0x6b4d, 0x8431, 0x7bcf, 0x7bf1, 0x73b0, 0x73b0, 0x8432, 0x7bf0, 0x630d, 0x630c, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xc638, 0xdedb, 0x632d, 0x7c10, 0x7c10, 0x7c11, 0x7bf1, 0x52ab, 0xd6bb, 0xf79e, 0xf79e, 0xd6bb, 0x4a4a, 0x4229, 0x5acc, 0x4229, 0xbdf8, 0xf7bf, 0x9d14, 0xef5e, 0xe6fc, 0x8c72, 0xc5f8, 0xffff, 0xd69a, 0x9cd4, 0xa535, 0xe71c, 0xf79f, 0xef5d, 0xf79f, 0xffdf, 0xef5d, 0x8c31, 0x9cd3, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xf7be, 0xffff, 0xf7be, 0xffff, 0xf79e, 0xad75, 0x4228, 0x7bcf, 0x7baf, 0x8410, 0x7bd0, 0x7bf0, 0x7bf1, 0x7bf0, 0x7c10, 0x738f, 0x630c, 0xe73d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xdedb, 0xf79f, 0x8431, 0x6b6e, 0x8431, 0x7c11, 0x8431, 0x6b6e, 0xa514, 0xf7bf, 0xf7bf, 0xbdd7, 0x0000, 0x0000, 0x2945, 0x9cf4, 0xffff, 0xa555, 0xd69b, 0xe71c, 0x9cb3, 0xd67a, 0xf75e, 0xbdd8, 0x9cb3, 0xbdd7, 0xf79e, 0xf79f, 0xf79e, 0xffbf, 0xef5d, 0xe71c, 0xf7bf, 0xa514, 0x2125, 0xa534, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xffff, 0xf7de, 0x94b3, 0x52aa, 0x73cf, 0x7bcf, 0x94b3, 0x738f, 0x7bf0, 0x7c11, 0x7bf1, 0x7c31, 0x6b8e, 0x5aec, 0xe73d, 0xffff, 0xffbf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe73d, 0xf79f, 0xbdf8, 0x5aec, 0x8c72, 0x7c11, 0x8431, 0x7bf0, 0x73af, 0xf7bf, 0xef9e, 0xbdf8, 0x0041, 0x0001, 0x52ab, 0xf7bf, 0xad76, 0xce7a, 0xd69b, 0x8c72, 0xd67a, 0xffbf, 0xb576, 0x9cd4, 0xdedc, 0xffff, 0xf7bf, 0xef5e, 0xef3d, 0xef5d, 0xf79e, 0xf79f, 0xf79e, 0xef7e, 0x4229, 0x738e, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf79e, 0x8c71, 0x632c, 0x7bef, 0x7bf0, 0x7c11, 0x73d0, 0x7bf0, 0x7c11, 0x7c11, 0x73d0, 0x73cf, 0x5b0c, 0xdedb, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe71c, 0xdedb, 0xe71c, 0x5aec, 0x8431, 0x7c11, 0x7c11, 0x7bf0, 0x630d, 0xd69a, 0xffdf, 0xd6db, 0x0862, 0x2125, 0xc659, 0xce9a, 0xad76, 0xd67a, 0x9cd4, 0xdebb, 0xef5d, 0x9452, 0x9c93, 0xbdd8, 0xbdd8, 0xce59, 0xe71c, 0xf79f, 0xffbf, 0xf79e, 0xef3d, 0xef5e, 0xef3d, 0xffdf, 0x9cd3, 0xc639, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xf79e, 0x8410, 0x5b0c, 0x8431, 0x8c72, 0x73d0, 0x7c31, 0x7bf1, 0x6b6f, 0x7c11, 0x73af, 0x7c10, 0x5b0c, 0xce9a, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe73d, 0xce7a, 0xf79e, 0x7bf0, 0x6baf, 0x7c11, 0x7c11, 0x8c72, 0x6b4e, 0x8431, 0xef7e, 0xf7df, 0x4229, 0x8431, 0xef5e, 0xad76, 0xdedc, 0x9cb3, 0xdedb, 0xd69b, 0x7baf, 0x6b0d, 0xa4d4, 0xd67a, 0xf79f, 0xf79e, 0xef5d, 0xffdf, 0xf77e, 0xdefc, 0xf77e, 0xef5e, 0xf79e, 0xce59, 0x738e, 0xdedb, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf79e, 0xffff, 0xe71c, 0x6b4d, 0x6b4d, 0x8cb2, 0x73cf, 0x7c10, 0x8c93, 0x73af, 0x7c11, 0x8432, 0x6b6f, 0x8451, 0x632d, 0xc679, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xdefc, 0xffff, 0xa535, 0x634d, 0x7c11, 0x8431, 0x7bf0, 0x8451, 0x630c, 0xd69a, 0xdf1c, 0x6b6e, 0xdedb, 0xb5b7, 0xc619, 0x9cb3, 0xef5e, 0xb597, 0x5acc, 0x3146, 0x18a3, 0xbdb7, 0xf7bf, 0xef5e, 0xef5d, 0xef7e, 0xef5e, 0xef5d, 0xef7e, 0xef7e, 0xf77e, 0xf79e, 0xb596, 0x2125, 0xad55, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xf7be, 0xffff, 0xe73c, 0x5aeb, 0x4a49, 0x8c71, 0x73cf, 0x8472, 0x7bf0, 0x6b8f, 0x7c11, 0x73d0, 0x73d0, 0x8432, 0x8451, 0x9d14, 0xf7bf, 0xffff, 0xf7df, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xdefb, 0xe75d, 0xce9a, 0x634d, 0x8c52, 0x7bf0, 0x7c12, 0x8432, 0x7bd0, 0x83d0, 0x7b8f, 0xb5b8, 0xd6bc, 0xa577, 0x9557, 0xd6bb, 0xac72, 0x5103, 0x5903, 0x48a1, 0x40a3, 0xb472, 0xff9f, 0xef3e, 0xf79f, 0xef3d, 0xef7d, 0xe73c, 0xe79e, 0xe7be, 0xef7d, 0xffff, 0xb5b6, 0x18e4, 0x9492, 0xffff, 0xffff, 0xffdf, 0xf7de, 0xffff, 0xffff, 0xd6fb, 0x4249, 0x4aaa, 0x8cb2, 0x6baf, 0x7c31, 0x6baf, 0x7c52, 0x7c31, 0x73af, 0x7bd0, 0x8c72, 0x4a6a, 0x9492, 0xe73c, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xa555, 0xb5d7, 0xb5d7, 0x4a8a, 0x8431, 0x6b6e, 0x52cc, 0x73b0, 0x73af, 0x52ab, 0x6b4e, 0xdedc, 0x9d15, 0xad97, 0xd6dc, 0x7b6e, 0x40e3, 0x4060, 0x60e2, 0x50a1, 0x48a2, 0x82cb, 0xf79f, 0xe71d, 0xef5e, 0xf77e, 0xf79e, 0xef7e, 0xef9e, 0xef9e, 0xf7be, 0xe73d, 0xa535, 0xad76, 0xdefb, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdefb, 0x31e7, 0x6b8e, 0x8c72, 0x7c10, 0x7c10, 0x73f1, 0x7c11, 0x6b8f, 0x7bf0, 0x7c11, 0x7c10, 0x4a6a, 0x7bcf, 0xe73c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xdefb, 0xad75, 0x7bf0, 0x4229, 0x10a3, 0x632d, 0x3a08, 0x31e8, 0x5b2d, 0x7c11, 0x4229, 0xad76, 0xc618, 0xa535, 0xbdb7, 0x72ec, 0x3062, 0x4061, 0x6903, 0x68a1, 0x5881, 0x58c2, 0x6124, 0xe71c, 0xef5d, 0xe73d, 0xf77e, 0xef7e, 0xf79e, 0xf79e, 0xef7e, 0xe73d, 0xffdf, 0xb5b6, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xce99, 0x31c7, 0x73cf, 0x73cf, 0x7c10, 0x73cf, 0x8431, 0x73f1, 0x7c31, 0x7c31, 0x7c10, 0x8431, 0x632d, 0x738e, 0xe73d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf79e, 0xb596, 0xef7d, 0x94b2, 0x0862, 0x0862, 0x5aec, 0x5acb, 0x7bf0, 0x73cf, 0x52ec, 0x7410, 0xe75d, 0x9492, 0xa4b2, 0x6289, 0x3020, 0x4040, 0x6903, 0x70c1, 0x6860, 0x70c2, 0x60a1, 0x5061, 0xad54, 0xffdf, 0xe73d, 0xef5e, 0xef5e, 0xef5e, 0xf75e, 0xf73d, 0xef7d, 0xce7a, 0xb5b6, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xadb6, 0x31e7, 0x73cf, 0x73ef, 0x8451, 0x73cf, 0x8431, 0x73d0, 0x7c11, 0x73d0, 0x7bf0, 0x7c11, 0x6b8e, 0x6b6e, 0xdedb, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xad75, 0xc638, 0xf79e, 0xdefc, 0x52ab, 0x0000, 0x5acc, 0x8c51, 0x9471, 0x738e, 0x4a8a, 0xbe59, 0x73cf, 0x41a6, 0x59c6, 0x3881, 0x60e2, 0x60a2, 0x68a1, 0x6040, 0x7081, 0x70e2, 0x6060, 0x5060, 0x6aea, 0xffbe, 0xef5d, 0xe71d, 0xef5e, 0xef3e, 0xf75e, 0xf71c, 0xffff, 0x9cf4, 0xdefc, 0xffff, 0xffff, 0xffff, 0xffdf, 0xa514, 0x4a69, 0x73cf, 0x73cf, 0x8451, 0x6b8f, 0x7c31, 0x8c72, 0x6b8f, 0x73af, 0x8452, 0x73af, 0x8c72, 0x6b8e, 0xbdf7, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xdedb, 0xce79, 0xffdf, 0xef3c, 0xef5d, 0xce7a, 0x31a7, 0x4a29, 0x83f0, 0x72eb, 0x4a08, 0xad76, 0xdf3d, 0x52ab, 0x28a2, 0x4040, 0x6923, 0x60c1, 0x6080, 0x70c2, 0x70c2, 0x68a1, 0x68c1, 0x60a1, 0x5880, 0x4964, 0xee99, 0xf75d, 0xe73e, 0xef9f, 0xef3e, 0xf75d, 0xf73c, 0xef7d, 0xad55, 0xffff, 0xffff, 0xffff, 0xe73d, 0x9cd3, 0x52aa, 0x73af, 0x8431, 0x7c10, 0x73f0, 0x7c10, 0x7bf1, 0x6b8f, 0x7c11, 0x73af, 0x8c92, 0x7bcf, 0x7bf0, 0xad75, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xbdf7, 0xffde, 0xe6fb, 0xf79e, 0xef3d, 0xffff, 0xbdb7, 0x4209, 0x41e8, 0x728a, 0x6acb, 0xf7bf, 0xef9e, 0xdebb, 0x728a, 0x58a1, 0x6880, 0x60c1, 0x60a1, 0x68c2, 0x68a2, 0x6081, 0x60c2, 0x6102, 0x58c1, 0x7206, 0xc513, 0xff3d, 0xef5e, 0xe77f, 0xe75e, 0xef5d, 0xf77d, 0xc618, 0xbdf8, 0xef7e, 0xffff, 0xef7e, 0x8c71, 0x5acb, 0x7bef, 0x8c72, 0x73af, 0x7c10, 0x73f0, 0x7c11, 0x7bf1, 0x8432, 0x7bf1, 0x8411, 0x738f, 0x630c, 0x8c72, 0xf79e, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xe71c, 0xad55, 0xf77d, 0xf79e, 0xdedb, 0xef5d, 0xb596, 0x5aab, 0xb596, 0x8c51, 0x6a08, 0xc576, 0xf77e, 0xf7df, 0xef3d, 0x61c7, 0x5000, 0x80a1, 0x60c1, 0x60a1, 0x5860, 0x60a2, 0x68e3, 0x58a1, 0x5081, 0x6964, 0xab6c, 0xabef, 0xff1d, 0xef5e, 0xdf1e, 0xe75e, 0xef5d, 0xf79d, 0xad55, 0xffdf, 0xffff, 0xffdf, 0x738e, 0x632c, 0x8c72, 0x8410, 0x73af, 0x7c31, 0x7bf0, 0x7bf0, 0x7bf0, 0x7c11, 0x7bf1, 0x7c11, 0x8410, 0x634d, 0x630c, 0xffdf, 0xffff, 0xffbe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffff, 0xffff, 0xfffe, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffff, 0xffde, 0x8c71, 0xbdb9, 0xb575, 0xad14, 0xb555, 0x8c30, 0x20c3, 0x28e3, 0xe6ba, 0xff9e, 0xd619, 0xbd97, 0xc639, 0x9d14, 0x9cd3, 0x9c50, 0x5144, 0x48c2, 0x68c2, 0x6881, 0x6820, 0x70c2, 0x58c1, 0x50c1, 0x4880, 0x8a27, 0xd30b, 0x8aea, 0xdefb, 0xffdf, 0xeefc, 0xf77e, 0xf7bf, 0xef1e, 0xc618, 0xffff, 0xef7d, 0x6b8e, 0x6b6e, 0x8cb3, 0x6b8e, 0x7c10, 0x7c12, 0x7c11, 0x73f1, 0x73f0, 0x7c31, 0x7c11, 0x73cf, 0x7c31, 0x738e, 0x738e, 0xe71c, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xe75c, 0xffff, 0xffff, 0xf7de, 0xffdf, 0xffdf, 0xffbf, 0xfffe, 0xf7bf, 0xef5e, 0xf7bf, 0xfffe, 0xc616, 0x8410, 0xc61a, 0xb575, 0xb555, 0x7bce, 0x39a6, 0x0800, 0x1882, 0xad14, 0xff7d, 0xad14, 0x62cc, 0x8c72, 0xbe18, 0xe6fc, 0xff7d, 0x9bef, 0x38a2, 0x5881, 0x70e3, 0x78c2, 0x68a2, 0x5060, 0x6984, 0x79c5, 0xa2a9, 0xe32b, 0x8a88, 0xd699, 0xef3d, 0xde7a, 0xdeba, 0xd6db, 0xa4f4, 0xffff, 0xef7d, 0x6b8e, 0x6b8e, 0x8472, 0x6b8e, 0x8472, 0x73f0, 0x7c32, 0x73f1, 0x73f1, 0x8452, 0x73f0, 0x73d0, 0x8cb3, 0x8451, 0x73ae, 0xc638, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xefff, 0xf7ff, 0xffff, 0xffff, 0xff9f, 0xf7fe, 0xf7ff, 0xf7ff, 0xffff, 0xd6b9, 0x738c, 0x7bce, 0xad55, 0xc618, 0x8c51, 0x5acb, 0x6b0c, 0x6b0c, 0x20c3, 0x28e4, 0x6aeb, 0xb575, 0xd69a, 0xa4f4, 0xdebc, 0xf77f, 0xef3e, 0xffbf, 0x6aec, 0x4880, 0x60a1, 0x70c2, 0x68a1, 0x58a1, 0x9268, 0xa2a9, 0xaa89, 0xe30a, 0x9288, 0xc5d6, 0xff7e, 0xbd76, 0xbdb5, 0x7c0f, 0xef7e, 0xffdf, 0x738e, 0x6b8e, 0x8431, 0x73cf, 0x7c31, 0x73f0, 0x7c11, 0x7c32, 0x7bf1, 0x7bf1, 0x7bf1, 0x73f0, 0x7c10, 0x7c11, 0x73cf, 0xb596, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7ff, 0xf7ff, 0xe75e, 0x7bf0, 0xc618, 0xfffe, 0xefbe, 0xbe5a, 0xadd7, 0xb5b5, 0x736b, 0xc5f6, 0xe71b, 0xa4f4, 0x9492, 0xbdd7, 0xf79e, 0xffdf, 0xc5d7, 0x62ec, 0x28e4, 0xce58, 0xffff, 0xc5f9, 0xbd98, 0xe6de, 0xe6fe, 0xef5e, 0xd6dc, 0x7206, 0x5060, 0x6081, 0x6081, 0x68e1, 0xb32a, 0xb2a9, 0xb228, 0xeb2b, 0x9288, 0xcdf6, 0xf73d, 0x8bef, 0x7bad, 0xa554, 0xffff, 0x738e, 0x6b6e, 0x8431, 0x8431, 0x7c31, 0x7c11, 0x6baf, 0x7c11, 0x7c11, 0x7c11, 0x8431, 0x73d0, 0x8472, 0x73cf, 0x52cb, 0x94d3, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xfffe, 0xde37, 0xd572, 0xa3aa, 0x71e2, 0x71a0, 0x940d, 0xd699, 0xe7bf, 0xefff, 0xfffe, 0x62c9, 0x738c, 0xad75, 0xd6ba, 0xe71c, 0xffdf, 0xffbe, 0xef3c, 0xffff, 0xf77d, 0xbdb6, 0x842f, 0xd69a, 0xf77f, 0xce1a, 0xd65b, 0xef5f, 0xef7f, 0xffff, 0x9b6b, 0x50c1, 0x60a1, 0x6080, 0x60c1, 0xc36b, 0xbaa9, 0xc288, 0xeb4b, 0x9288, 0xce38, 0xef1c, 0x3124, 0x5aa9, 0xe75c, 0x630c, 0x4229, 0x9492, 0x7bf0, 0x73d0, 0x8431, 0x73f0, 0x8472, 0x73f0, 0x7bf1, 0x7c11, 0x7c11, 0x8c72, 0x8451, 0x5aec, 0x73cf, 0xef9e, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xfffe, 0xff19, 0x79a1, 0xaa41, 0xc280, 0xd2c0, 0xe341, 0x5961, 0x9c6f, 0xefde, 0xefff, 0xd699, 0x20a2, 0x5289, 0xdf5c, 0xe73c, 0xf7be, 0xe73d, 0xef5d, 0xef3d, 0xef3d, 0xf75d, 0xff9e, 0xc618, 0x94b2, 0xd69b, 0xf79f, 0xef1e, 0xff9f, 0xef3d, 0xe6bb, 0x7226, 0x5081, 0x68e3, 0x68a1, 0x60a0, 0xbb4a, 0xc309, 0xd2c9, 0xd32a, 0x8ac9, 0xe75c, 0xc639, 0x20e4, 0x4228, 0x73ce, 0x39e8, 0x7bf0, 0x73af, 0x8c52, 0x7bd0, 0x73b0, 0x8472, 0x7c11, 0x7c11, 0x8411, 0x8431, 0x73cf, 0x8451, 0x6b6e, 0x6b8e, 0xd6db, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xffbd, 0xabeb, 0xa284, 0xd366, 0x99a0, 0x99e0, 0x9201, 0x9a85, 0x9b8b, 0xe73b, 0xdf3c, 0xc618, 0x5208, 0x52ab, 0xa597, 0xbdd7, 0xffff, 0xe71c, 0xef3d, 0xffbf, 0xf77e, 0xef3d, 0xf75e, 0xffdf, 0xd65a, 0x8431, 0xb5d8, 0xdedc, 0xde7a, 0xd5f7, 0x6207, 0x4081, 0x5060, 0x68c2, 0x70c2, 0x6080, 0xaaa7, 0xcb4a, 0xd30a, 0xb2c9, 0x9bee, 0xf7ff, 0x6bd0, 0x62ed, 0x18e4, 0x2946, 0x8412, 0x8411, 0x8431, 0x7bf0, 0x7bd0, 0x8452, 0x7c11, 0x6bb0, 0x7c32, 0x8431, 0x8431, 0x7bf0, 0x7bd0, 0x7bcf, 0xbdf8, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xff3b, 0x61c4, 0x79e4, 0x6962, 0xbcd1, 0xc5f7, 0x4b0d, 0x91c1, 0x9308, 0xf77b, 0xef7e, 0xffdf, 0xd5f8, 0x8c52, 0x7c93, 0x630c, 0xe75d, 0xe73d, 0xef7e, 0xf79e, 0xef5d, 0xf77e, 0xf75e, 0xeefd, 0xffbf, 0xef9f, 0x9d35, 0x9cd3, 0x7b6d, 0x2000, 0x48c2, 0x5103, 0x6903, 0x6061, 0x68a1, 0x5840, 0x91e4, 0xd38b, 0xe38b, 0x9226, 0xde78, 0xd77d, 0x4aed, 0x5acc, 0x18e4, 0x7bf1, 0x83d2, 0x7bf0, 0x7bd0, 0x73d0, 0x7bd0, 0x73d0, 0x7bf1, 0x8452, 0x73f1, 0x7bf0, 0x7bd0, 0x9493, 0x8431, 0xad55, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xe73d, 0xa535, 0xbdd7, 0xa535, 0xbdd8, 0xbdf7, 0x9cd3, 0x39c7, 0x62ec, 0xd69b, 0xffbf, 0xffdf, 0xa4f5, 0x6900, 0x8bac, 0xffff, 0xffdf, 0xffbe, 0xffff, 0xce99, 0x732c, 0x2104, 0x8c51, 0xad75, 0x8430, 0xd69a, 0xffff, 0xef7d, 0xffdf, 0xf77e, 0xf77d, 0xef5d, 0xf79e, 0xffdf, 0xef5d, 0xa4f3, 0x3186, 0x48a0, 0x5060, 0x70e1, 0x7080, 0x7080, 0x68a0, 0xab2a, 0x8a87, 0x8c72, 0xffff, 0xa535, 0x528b, 0x31c8, 0x632d, 0x8452, 0x7c11, 0x73d0, 0x7bf0, 0x7bf1, 0x7bf1, 0x7bf1, 0x7c11, 0x7c11, 0x7bf1, 0x7bef, 0x8430, 0x630c, 0x7bef, 0xf7be, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xc618, 0xce79, 0xdedb, 0xdedc, 0xf79e, 0xe6fc, 0xef7d, 0xef5d, 0xd6ba, 0xf79e, 0xffbf, 0xe6fc, 0xf77e, 0xb556, 0x6920, 0x836b, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x632c, 0xa534, 0xbdf7, 0x52aa, 0x39c7, 0x8430, 0xa534, 0xb5b6, 0xd679, 0xdedb, 0xdebb, 0xc5f7, 0xb575, 0xdedb, 0xffdf, 0xdedb, 0x7aea, 0x4923, 0x4861, 0x4000, 0x5082, 0x4020, 0x4903, 0x9bee, 0xffff, 0xce5a, 0x5acc, 0x52ab, 0x4a6a, 0x73d0, 0x8452, 0x7bf0, 0x7bf1, 0x7c11, 0x7bf1, 0x7bf1, 0x8431, 0x7c11, 0x7bf0, 0x7c11, 0x8410, 0x738e, 0x6b6d, 0xe73c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xbdf7, 0xf79e, 0xffdf, 0xdefc, 0xe73d, 0xef5e, 0xe73d, 0xf79e, 0xf7be, 0xf79e, 0xef5d, 0xef3d, 0xef3d, 0x8c31, 0x6941, 0x93cd, 0xef9e, 0xce59, 0x9471, 0x634c, 0x8430, 0xff9e, 0xffff, 0xf7be, 0xf79e, 0x9cd3, 0x738e, 0xd69a, 0xe73c, 0xd6ba, 0xce59, 0xbdd7, 0xc618, 0xbdb6, 0x7bae, 0x738e, 0xad35, 0xb5b6, 0xf77e, 0xce19, 0xa472, 0x830d, 0x72cc, 0x9c52, 0xbd76, 0xffdf, 0xd6bb, 0x7bd0, 0x31a7, 0x632d, 0x630d, 0x7c11, 0x73d0, 0x7bf1, 0x7c11, 0x8432, 0x7c11, 0x7bf1, 0x8431, 0x7bf1, 0x7bf0, 0x8452, 0x94b2, 0x738e, 0xc618, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xce59, 0xffdf, 0xef3d, 0xef5e, 0xef5d, 0xef7e, 0xef5d, 0xf79e, 0xf77e, 0xce39, 0x9492, 0x5acb, 0x630c, 0x526a, 0x9265, 0x72c9, 0x8c72, 0x7bf0, 0xbdb6, 0xdefb, 0xbdf7, 0xb535, 0xef5d, 0xffdf, 0xffff, 0xf7be, 0xe73c, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf79e, 0xd69a, 0xadb7, 0xdf1d, 0xce3a, 0xf79f, 0xef3e, 0xffdf, 0xef7f, 0xadb7, 0x738e, 0x8c51, 0x4a6a, 0x5aec, 0x6b6e, 0x8431, 0x73d0, 0x8c73, 0x73d0, 0x7bf1, 0x7bf1, 0x7bf1, 0x7bf1, 0x7c11, 0x8432, 0x8452, 0x8410, 0xad75, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xbdf7, 0xe73c, 0xffff, 0xef5e, 0xffff, 0xf77e, 0xffdf, 0xef5e, 0xb597, 0x736e, 0xa4f4, 0xf75d, 0xdeba, 0x41e7, 0x60e0, 0x4143, 0xa535, 0xe73d, 0xffdf, 0xef9e, 0xef7e, 0xff9e, 0xb5b6, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xf7df, 0xa555, 0x18c3, 0x5acc, 0x6b6e, 0x630c, 0x73af, 0x73cf, 0xbdd8, 0xf79e, 0x738f, 0x4a4a, 0x73af, 0x7c11, 0x7bf0, 0x7c11, 0x8431, 0x7bf1, 0x7c11, 0x7c11, 0x7bf1, 0x7c11, 0x7bf1, 0x634e, 0x8410, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xdefb, 0x8c71, 0xbdd8, 0x8431, 0x8411, 0x738f, 0x6b6f, 0x4a2a, 0x7bf0, 0xce59, 0xffbe, 0xffff, 0xffde, 0x7bce, 0x5880, 0xa44f, 0xffff, 0xf7bf, 0xf75d, 0xe75d, 0xf79f, 0xff7e, 0xbdd7, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xb5b6, 0x4228, 0x39e7, 0xc638, 0xef5d, 0xd6ba, 0xdefb, 0xf7be, 0xf7bf, 0xffff, 0x7baf, 0x4a6a, 0x8452, 0x7bf1, 0x8432, 0x7bf1, 0x8452, 0x7c11, 0x7c11, 0x8452, 0x8432, 0x7c11, 0x73d0, 0x6b8f, 0xd6ba, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdefb, 0x528a, 0x7bf0, 0xa535, 0xce59, 0xce7a, 0xb597, 0xad36, 0xdedc, 0xffdf, 0xf77d, 0xe6fb, 0xf77c, 0x736c, 0x6921, 0xcd95, 0xf7df, 0xe71d, 0xff9e, 0xe75d, 0xef9e, 0xff7f, 0xbdd7, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xd6ba, 0x6b8e, 0x8c51, 0x528a, 0xbdf7, 0xf7df, 0xef7d, 0xef9e, 0xf79e, 0xf79e, 0xef5d, 0xef7e, 0x9492, 0x5acc, 0x8c93, 0x73af, 0x7c11, 0x73d0, 0x7bf0, 0x7bf0, 0x73d0, 0x8431, 0x8452, 0x73b0, 0x8432, 0xbdf9, 0xffff, 0xffdf, 0xffff, 0xf79e, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xad75, 0xd6ba, 0xffdf, 0xf7bf, 0xf7bf, 0xf79e, 0xf77f, 0xf79f, 0xf79f, 0xef5d, 0xf77e, 0xef5c, 0xe71b, 0x5268, 0x7142, 0xbd13, 0xf7bf, 0xf7bf, 0xe71c, 0xad76, 0xbdf8, 0xc5b8, 0xffdf, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xf7df, 0xffff, 0xffff, 0xb5d7, 0x632c, 0x6b6d, 0x5aec, 0x73d0, 0xf7ff, 0xe79e, 0xe79e, 0xefbf, 0xef7e, 0xe73d, 0xf77e, 0xffff, 0xb5b7, 0x4a4a, 0x8431, 0x7bf0, 0x7c11, 0x7c11, 0x7c11, 0x8452, 0x7bf0, 0x7bf1, 0x7c11, 0x5aed, 0x8432, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xef3d, 0xd69a, 0xffff, 0xf77e, 0xef5d, 0xf79e, 0xef5d, 0xeefe, 0xf79f, 0xf7bf, 0xeefc, 0xf77f, 0xf79f, 0x9bac, 0x91e0, 0x79e4, 0xc533, 0xffff, 0xadf7, 0xa5b5, 0xdefa, 0xf79e, 0xffdf, 0xf7be, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xad56, 0x5acc, 0x8c52, 0x7bd0, 0x4a49, 0xef5d, 0xef5e, 0xf79e, 0xef5e, 0xf79e, 0xef5d, 0xf79f, 0xef5d, 0xf77e, 0xdedb, 0x4a4a, 0x8431, 0x7bf0, 0x7c11, 0x7bf0, 0x8432, 0x7c11, 0x7bf1, 0x8451, 0x73cf, 0x632c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xf7be, 0xf7be, 0xffdf, 0xf79e, 0xdedb, 0xf7be, 0xf77e, 0xf77e, 0xf79e, 0xf77e, 0xffdf, 0xd67b, 0xce79, 0xf77e, 0xffdf, 0xacb3, 0x7a25, 0xbb03, 0x7a05, 0xcd53, 0xe73c, 0xbe79, 0xe79c, 0xffde, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xa514, 0x73af, 0x8411, 0x8411, 0x4209, 0xa535, 0xef5e, 0xef5d, 0xf7bf, 0xef5e, 0xf77e, 0xf79e, 0xef7e, 0xef5e, 0xf77e, 0xe71c, 0x528b, 0x7bf0, 0x7c11, 0x7c11, 0x7bf1, 0x7c11, 0x7bf1, 0x7bf0, 0x8452, 0x3a08, 0xb5b6, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7e, 0xb5b7, 0xce59, 0xef3d, 0xef5d, 0xdedb, 0xd67a, 0x6b91, 0x6b4d, 0x7bce, 0x7bae, 0x834d, 0x79e5, 0xa242, 0xd363, 0x71e5, 0xb4d1, 0xce99, 0xd73c, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xf79e, 0xa514, 0x73af, 0x73cf, 0x8c72, 0x73af, 0x5acc, 0xf79f, 0xef7e, 0xef7e, 0xef7e, 0xe73d, 0xef5e, 0xffbf, 0xef5d, 0xf77e, 0xf77e, 0xef5e, 0x5aec, 0x738f, 0x8452, 0x7c11, 0x7c11, 0x8432, 0x7bf1, 0x7c11, 0x634e, 0x2966, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xf79e, 0xef5d, 0xc5f8, 0x7bef, 0x738e, 0x6b6e, 0x4a6a, 0x4a6a, 0x6b6d, 0xadba, 0xe6fc, 0xff7c, 0xa4f3, 0x59a5, 0xb284, 0xdb23, 0xb240, 0x6a05, 0x940f, 0xdf1c, 0xf7ff, 0xffff, 0xf7bd, 0xffff, 0xf7bf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xad55, 0x738e, 0x7bd0, 0x9493, 0x7bf0, 0x4a6a, 0xad77, 0xf7bf, 0xf79e, 0xf79e, 0xd69a, 0xdedc, 0xef5d, 0xf7bf, 0xef5d, 0xf77e, 0xef7e, 0xf79f, 0x738f, 0x632d, 0x8c73, 0x7bf1, 0x7c11, 0x8432, 0x7c11, 0x7c11, 0x31c8, 0x630c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xdedb, 0xb5b6, 0xd69a, 0xd6ba, 0xd6bb, 0xe71c, 0xdebb, 0xb596, 0xc618, 0xef3d, 0xef9f, 0xef5d, 0xfffe, 0xe6ba, 0x71a3, 0xd2e3, 0xe2a0, 0xb200, 0x7287, 0x8bef, 0xffff, 0xf7ff, 0xf7be, 0xffdd, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf79e, 0xffff, 0xffff, 0xad76, 0x6b6f, 0x7bd0, 0x7bf0, 0x8411, 0x73af, 0x528b, 0xe73d, 0xe73d, 0xffdf, 0xdefc, 0xb596, 0xdefc, 0xf79e, 0xef7e, 0xef5e, 0xf77e, 0xef5d, 0xf7bf, 0x8c72, 0x52cc, 0x8c72, 0x7bf1, 0x7c11, 0x8432, 0x7c11, 0x634e, 0x2986, 0xa535, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xbdd7, 0xce79, 0xffbf, 0xf77e, 0xf77e, 0xf77e, 0xf7be, 0xef3d, 0xf79e, 0xf79e, 0xffbf, 0xdf1c, 0xe77d, 0xde36, 0x7960, 0xdac2, 0xda80, 0xcaa0, 0x72a9, 0x9450, 0xffff, 0xffff, 0xf7be, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xc618, 0x632e, 0x73b0, 0x83f1, 0x8c52, 0x7bf0, 0x5acc, 0x9cd4, 0xf7bf, 0xef5d, 0xf79f, 0xbdb7, 0xad76, 0xef7e, 0xf7bf, 0xef5e, 0xf77e, 0xf77e, 0xef5d, 0xf7bf, 0xa535, 0x528b, 0x8452, 0x7bf1, 0x7c11, 0x7c11, 0x7bf0, 0x4a8b, 0x424a, 0xce7a, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xbdf7, 0xef7d, 0xef7d, 0xe71c, 0xef5d, 0xe73d, 0xef7e, 0xef3d, 0xf79e, 0xe71c, 0xf6fb, 0xefdf, 0xd75e, 0x93cc, 0x99c0, 0xe2e3, 0xdac2, 0xca80, 0x6aa9, 0x9c92, 0xef7f, 0xefbf, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xce59, 0x738e, 0x7370, 0x8c73, 0x7bf1, 0x9493, 0x8411, 0x4209, 0xd6bb, 0xef9e, 0xf79e, 0xdebb, 0x94b3, 0xd69a, 0xffbf, 0xf79e, 0xf77e, 0xef7e, 0xf77e, 0xef7e, 0xf79f, 0xc619, 0x528b, 0x8431, 0x7c11, 0x7c11, 0x7bf1, 0x73b0, 0x632d, 0x4a8b, 0xe71c, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xbdd7, 0xc638, 0xffdf, 0xe73c, 0xef5d, 0xef5d, 0xf79e, 0xe71c, 0xf79e, 0xef7e, 0xff5b, 0xe7df, 0x9df9, 0x51a3, 0xc2c4, 0xd2a2, 0xca81, 0xc260, 0x6ac9, 0xa4f3, 0xe75e, 0xffff, 0xffff, 0xffbd, 0xffff, 0xf7ff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xd69a, 0x632c, 0x632c, 0x8c53, 0x7bd1, 0x8c53, 0x7bd1, 0x738f, 0x5acc, 0xe73d, 0xf79e, 0xef7e, 0xbdd7, 0x8431, 0xffdf, 0xffdf, 0xe73d, 0xf7bf, 0xef7e, 0xf79e, 0xf79e, 0xf79f, 0xd69b, 0x52ab, 0x8431, 0x7c11, 0x8431, 0x7c11, 0x6b8f, 0x8452, 0x39e8, 0xf7bf, 0xffff, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xef7d, 0xb596, 0xff1b, 0xff7e, 0xe73f, 0xe77f, 0xf79e, 0xffff, 0xf7be, 0xe77e, 0xe71d, 0xa450, 0x79e4, 0xaa42, 0xd303, 0xd2e1, 0xd2a0, 0xca40, 0x630c, 0x9492, 0xb595, 0xf77d, 0xffff, 0xf79e, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xce59, 0x630d, 0x6b2e, 0x8c52, 0x8411, 0x8432, 0x8411, 0x8432, 0x4a4a, 0x9cf4, 0xf7df, 0xef5d, 0xffff, 0x6b6e, 0xd69a, 0xf79e, 0xf79f, 0xef7e, 0xef5e, 0xf79f, 0xef7e, 0xef5e, 0xf79f, 0xef5e, 0x5acc, 0x738f, 0x8c52, 0x8411, 0x8432, 0x8432, 0x73d0, 0x52ab, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xdedb, 0xcdd7, 0xe6fc, 0xf7df, 0xbdb7, 0x8bce, 0xa40d, 0xac4f, 0x8bcd, 0x69e5, 0x8a04, 0xaa43, 0xdb23, 0xdb22, 0xc280, 0xc280, 0xc281, 0x6b4d, 0x736d, 0x9471, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xbdf8, 0x5acc, 0x632d, 0x9cd4, 0x7bd0, 0x8411, 0x8411, 0x8411, 0x8432, 0x4a6a, 0xb5b7, 0xffdf, 0xef7e, 0xe73d, 0x6b6e, 0xd6bb, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7bf, 0xef7e, 0xef7e, 0xef7e, 0xf79f, 0x632d, 0x6b4e, 0x8c52, 0x8411, 0x7bf1, 0x8431, 0x7c11, 0x634d, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xd6db, 0xce7a, 0xd6bb, 0x7b4b, 0x71e3, 0x81c2, 0x9a43, 0x8a03, 0xb261, 0xd2e3, 0xdb02, 0xe2c0, 0xd260, 0xba00, 0xaa20, 0x99e1, 0x528a, 0x8410, 0xbdb7, 0x9cd3, 0xf79e, 0xffff, 0xef3c, 0xffff, 0xffff, 0xef7d, 0x9cf4, 0x630d, 0x7bcf, 0x8c72, 0x7bd0, 0x8431, 0x8411, 0x8411, 0x7bf0, 0x8411, 0x52ab, 0xd6bb, 0xf7bf, 0xef7e, 0xce59, 0x738e, 0xe73d, 0xf79f, 0xef7e, 0xf79f, 0xf7bf, 0xf79f, 0xef7e, 0xef7e, 0xef7e, 0xf7bf, 0x8411, 0x5aec, 0x8c52, 0x7bf0, 0x7bf1, 0x8432, 0x7c11, 0x73d0, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xd71c, 0xbd95, 0x61a3, 0xb2c4, 0xd2e3, 0xd2c2, 0xd2e4, 0xdac0, 0xe301, 0xd280, 0xda60, 0xe2c0, 0xd2e2, 0xa242, 0x60c0, 0x2945, 0xce79, 0x6b4d, 0x52ab, 0xa534, 0xf79e, 0xffff, 0xf79e, 0xdefc, 0x73af, 0x73cf, 0x8c92, 0x7bf0, 0x8411, 0x7bf1, 0x7bd0, 0x8411, 0x8411, 0x7bf1, 0x7bd0, 0x5acc, 0xef7e, 0xef9e, 0xf79e, 0xb5d7, 0x7bf0, 0xf79f, 0xf7bf, 0xef5e, 0xf79e, 0xf79f, 0xef7e, 0xef7e, 0xf79f, 0xef5e, 0xffdf, 0x9cf4, 0x528b, 0x8431, 0x8411, 0x7c11, 0x8432, 0x7bf0, 0x7c11, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xefff, 0xffff, 0xde36, 0x79c1, 0xd303, 0xf322, 0xeaa0, 0xe281, 0xd2a1, 0xd302, 0xcac2, 0xd2c1, 0xe301, 0xd2e2, 0x9a22, 0x4880, 0xad76, 0x94b3, 0x4a49, 0x8431, 0x7bf0, 0x9cf4, 0xe73d, 0xb596, 0x5aec, 0x6b4e, 0x8431, 0x7c10, 0x8431, 0x8432, 0x738f, 0x8c93, 0x7bf1, 0x8432, 0x8431, 0x738f, 0x5aec, 0xf79f, 0xe75d, 0xf7bf, 0xad76, 0x8431, 0xffdf, 0xf79f, 0xef5e, 0xf79f, 0xf79f, 0xef7e, 0xf79f, 0xf7bf, 0xef5e, 0xf7bf, 0xb5b7, 0x4a6a, 0x8431, 0x8411, 0x8432, 0x8432, 0x73af, 0x8c72, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xefdf, 0xffff, 0xbcd0, 0xa283, 0xdac1, 0xea80, 0xe260, 0xdaa1, 0xd2c2, 0xcb04, 0xc2e3, 0xcac2, 0xd280, 0xd2c2, 0xb2e5, 0x7205, 0xbdf8, 0x3a08, 0x73cf, 0x8411, 0x7bd0, 0x3a08, 0x2104, 0x4a4a, 0x73cf, 0x73d0, 0x8451, 0x7c11, 0x73d0, 0x8432, 0x7c11, 0x7bf1, 0x7bf1, 0x8411, 0x8c52, 0x632d, 0x6b6e, 0xf79e, 0xe73d, 0xf7df, 0xb596, 0x8c72, 0xffdf, 0xef9e, 0xef7e, 0xf7bf, 0xf7bf, 0xf79e, 0xf79f, 0xf79f, 0xef5e, 0xf79f, 0xce7a, 0x4a6a, 0x8431, 0x8411, 0x7c11, 0x7c11, 0x6b6f, 0x9cd4, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xff9d, 0x82a7, 0xbae4, 0xdac0, 0xda40, 0xd280, 0xd2e4, 0xdaa0, 0xcac2, 0xc2e3, 0xd302, 0xdaa0, 0xdaa1, 0xb2a4, 0x5962, 0x31c7, 0x73cf, 0x73cf, 0x8c72, 0x7bf0, 0x8451, 0x31c7, 0x4a6a, 0x8c93, 0x8431, 0x73d0, 0x8452, 0x8452, 0x7bf1, 0x8412, 0x8432, 0x8411, 0x8411, 0x8c52, 0x5aec, 0x8431, 0xf7bf, 0xef5d, 0xf7bf, 0xbe18, 0x94b3, 0xf7df, 0xef7e, 0xef9e, 0xf79f, 0xf79f, 0xf7bf, 0xf79f, 0xef7e, 0xf79f, 0xef7e, 0xe71d, 0x52ab, 0x8411, 0x8411, 0x8432, 0x7c11, 0x634e, 0xa535, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffbf, 0xffde, 0x7a04, 0xc324, 0xdaa0, 0xe2a0, 0xd2e2, 0xc2e4, 0xf2e0, 0xd2a0, 0xcac1, 0xdb01, 0xeaa0, 0xe2a0, 0xb283, 0x5101, 0x6b8e, 0x73af, 0x8431, 0x7bf0, 0x7c10, 0x8c52, 0x73af, 0x2986, 0x632d, 0x8431, 0x7bf0, 0x7c11, 0x7c11, 0x73d0, 0x8453, 0x7bf1, 0x8411, 0x7bf1, 0x8432, 0x5acc, 0x94b3, 0xf7bf, 0xef9e, 0xf7bf, 0xce9a, 0x9cf4, 0xf7df, 0xef7e, 0xf79e, 0xef7e, 0xef7e, 0xf79e, 0xef7e, 0xef5e, 0xf79f, 0xef7e, 0xef7e, 0x5acc, 0x8411, 0x7bf0, 0x8452, 0x8432, 0x632e, 0xa555, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbf, 0xffbd, 0x8180, 0xdb22, 0xe2a1, 0xd2a3, 0xb2a3, 0x9a82, 0x9245, 0xb264, 0xcac2, 0xdae0, 0xe240, 0xf283, 0xaa63, 0x3200, 0x8432, 0x8431, 0x7c11, 0x7c11, 0x8431, 0x7c11, 0x73d0, 0x73af, 0x424a, 0x6b8f, 0x8452, 0x7c11, 0x73b0, 0x7bf1, 0x8432, 0x7c11, 0x8411, 0x8c72, 0x8411, 0x4a6a, 0x9cd4, 0xef5e, 0xf79f, 0xf79f, 0xdefc, 0xb597, 0xef5e, 0xf7bf, 0xef5e, 0xf79f, 0xef5e, 0xef7e, 0xef7e, 0xef7e, 0xf7bf, 0xef7e, 0xf7bf, 0x6b6e, 0x6b6e, 0x8411, 0x7c11, 0x8431, 0x634e, 0x9d14, 0xffff, 0xffff, 0xfffe, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf71a, 0x8201, 0xca81, 0xeaa3, 0xb180, 0x79a0, 0x4980, 0x38e0, 0x81e2, 0xa1c0, 0xc280, 0xdaa1, 0xda64, 0x9a87, 0x3a46, 0x8431, 0x7c11, 0x7bf1, 0x7bf1, 0x7c11, 0x7c11, 0x7c11, 0x7bf1, 0x424a, 0x73b0, 0x8432, 0x73d0, 0x8431, 0x8452, 0x7bf1, 0x73b0, 0x8431, 0x8411, 0x528b, 0x10a3, 0xa535, 0xffff, 0xef7e, 0xe73d, 0xe73d, 0xc619, 0xef7e, 0xf7bf, 0xef5e, 0xf79f, 0xef7e, 0xef7e, 0xef7e, 0xef7e, 0xf7bf, 0xef7e, 0xf7bf, 0x6b6e, 0x6b4e, 0x8411, 0x7c11, 0x8432, 0x634e, 0x9d14, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7dd, 0x8b49, 0xbaa5, 0xda01, 0xe304, 0x7a82, 0x2200, 0x3a21, 0x8242, 0xd303, 0xcaa0, 0xcac0, 0xcae6, 0x6965, 0x632d, 0x8431, 0x7c11, 0x7bf1, 0x7bf1, 0x7bf1, 0x7c11, 0x7c11, 0x7c11, 0x6b6f, 0x6b6f, 0x7bf1, 0x8c72, 0x8432, 0x7bf0, 0x8431, 0x8c93, 0x7bd0, 0x4209, 0x8411, 0x7bf0, 0xb597, 0xf79f, 0xf7bf, 0xf79f, 0xf79f, 0xdedc, 0xf79f, 0xf79f, 0xef5e, 0xf79f, 0xf79f, 0xf79f, 0xef7e, 0xef7e, 0xf79f, 0xef7e, 0xf7bf, 0x73af, 0x6b4e, 0x8411, 0x7c11, 0x8452, 0x634d, 0xa534, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xefdd, 0xf7ff, 0xd677, 0x79e4, 0xd285, 0xba42, 0x6240, 0x1ae3, 0x31e0, 0xa2c1, 0xe2e1, 0xdac0, 0xcae0, 0x9a01, 0x6164, 0x8411, 0x8432, 0x8432, 0x7c11, 0x7c11, 0x7bf1, 0x7bf1, 0x7c11, 0x7c11, 0x7bf0, 0x7bf0, 0x8432, 0x7c11, 0x7bf1, 0x8c73, 0x8452, 0x5b0d, 0x2946, 0x528b, 0xef7e, 0xbdd8, 0xad56, 0xef7e, 0xef7e, 0xef5e, 0xf79f, 0xef5e, 0xf79f, 0xef7e, 0xef7e, 0xf79f, 0xf79f, 0xf79f, 0xef7e, 0xef7e, 0xf79f, 0xef7e, 0xffdf, 0x7bf0, 0x632d, 0x8411, 0x7c11, 0x8c72, 0x632d, 0xa555, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xfffe, 0xeffe, 0xf7ff, 0xe677, 0x9204, 0x9222, 0x4200, 0x12c2, 0x3a00, 0xab04, 0xdac3, 0xb260, 0x8a40, 0x6160, 0x4165, 0x84d4, 0x8432, 0x8432, 0x8432, 0x8431, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x8431, 0x7c11, 0x7c11, 0x8452, 0x7bf1, 0x4a8b, 0x2967, 0x4a4a, 0x5aec, 0xe73d, 0xad56, 0x94b3, 0xffdf, 0xef7e, 0xef5e, 0xef5e, 0xf79f, 0xef7e, 0xef7e, 0xf79f, 0xf79f, 0xf79f, 0xef7e, 0xf79f, 0xef7e, 0xf79f, 0xef7e, 0xffdf, 0x8431, 0x630d, 0x8431, 0x7c11, 0x8c72, 0x5b0c, 0xad96, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xefde, 0xefff, 0xf7bd, 0xff19, 0xc4ef, 0x3a21, 0x2b24, 0x3223, 0x61c4, 0x81a4, 0x9b6a, 0xe6b7, 0xf77c, 0x8472, 0x438f, 0x8431, 0x7c11, 0x7c11, 0x7c11, 0x8432, 0x8432, 0x8431, 0x8431, 0x8431, 0x7bf1, 0x8452, 0x8c73, 0x634e, 0x31c8, 0x3a09, 0x6b6f, 0x94b3, 0x52ab, 0x8411, 0x8411, 0x8c72, 0xffdf, 0xf79f, 0xf7bf, 0xef5e, 0xf79f, 0xef7e, 0xf79f, 0xf79f, 0xf79f, 0xef7e, 0xf79f, 0xf79f, 0xef7e, 0xf79f, 0xef7e, 0xffdf, 0x8c72, 0x5aec, 0x8431, 0x7c11, 0x8452, 0x52cc, 0xbdf7, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xef9d, 0xffff, 0xffff, 0xfffe, 0x3264, 0x2280, 0x6c0d, 0xf73c, 0xff3d, 0xffff, 0xf7ff, 0xf79f, 0xce7a, 0x640f, 0x8452, 0x8432, 0x7c11, 0x7c11, 0x8431, 0x8432, 0x8432, 0x8431, 0x73d0, 0x8452, 0x8452, 0x5b0d, 0x31a8, 0x424a, 0x73d0, 0x8c73, 0x7bd0, 0x8431, 0x39e8, 0x39e8, 0x8c72, 0xffdf, 0xe73d, 0xef7e, 0xef7e, 0xf79f, 0xef5e, 0xf79f, 0xf79f, 0xf79f, 0xef7e, 0xf7bf, 0xf79f, 0xef7e, 0xef7e, 0xef7e, 0xffdf, 0x9493, 0x5aec, 0x8431, 0x7c11, 0x8432, 0x52ab, 0xc639, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbe, 0xffff, 0xf79f, 0xe7df, 0x2a44, 0x2a80, 0x8caf, 0xfffe, 0xffff, 0xe7ff, 0xefdf, 0xffbf, 0xff9d, 0x94af, 0x94b3, 0x8c72, 0x7c11, 0x7bf1, 0x7c11, 0x7c11, 0x7c11, 0x7c11, 0x8452, 0x7c11, 0x4a6b, 0x2146, 0x52ac, 0x8c72, 0x8432, 0x5b0d, 0x8c52, 0x7bf0, 0x18c4, 0x630d, 0x94b3, 0xef7e, 0xffff, 0xef7e, 0xf79f, 0xf79f, 0xef5e, 0xf79f, 0xf79f, 0xf79f, 0xef7e, 0xf7bf, 0xf79f, 0xef7e, 0xef7e, 0xef7e, 0xffdf, 0x94b3, 0x5acc, 0x8c52, 0x8431, 0x8431, 0x4aab, 0xc659, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0xf7de, 0xfffe, 0xffdd, 0xf7bd, 0xefdc, 0x1a42, 0x2b02, 0x84b0, 0xffff, 0xffdf, 0xffdf, 0xffdf, 0xffff, 0xffff, 0xeffd, 0x636d, 0x5aec, 0x8c92, 0x73af, 0x8451, 0x8452, 0x73af, 0x8c73, 0x73af, 0x2946, 0x4209, 0x7bd0, 0x8431, 0x7bd0, 0x8c52, 0x528b, 0x528a, 0x0841, 0x4a49, 0x9492, 0x8410, 0xef7e, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xef7d, 0xf79e, 0xf79e, 0xef9e, 0xf7bf, 0x9cd4, 0x52ac, 0x8c52, 0x8451, 0x8451, 0x31a7, 0xef7e, 0xffff, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffbd, 0xffff, 0xffff, 0xd73a, 0x2263, 0x22c0, 0x7c6f, 0xf7de, 0xffff, 0xffdf, 0xffbf, 0xffff, 0xf7fe, 0xf7fe, 0xef9e, 0x6b6d, 0x5b0c, 0x94b3, 0x8452, 0x8c93, 0x8c72, 0x52ab, 0x18e4, 0x39c8, 0x8431, 0x7bf0, 0x8411, 0x94b3, 0x7bd0, 0x39c8, 0x10a3, 0x5acb, 0xb597, 0xbdf8, 0x7c10, 0xdefc, 0xf7df, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf7bf, 0x9cd4, 0x5acc, 0x8432, 0x7c10, 0x8431, 0x4249, 0xef9e, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xffff, 0xffff, 0xffdf, 0xffff, 0xd6f9, 0x3283, 0x2ae1, 0x740e, 0xf7fe, 0xffff, 0xffff, 0xffdf, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xefbe, 0x634d, 0x73cf, 0x5b0c, 0x3a29, 0x31a7, 0x4a8b, 0x4209, 0x630d, 0x8c52, 0x8c52, 0x8c72, 0x632d, 0x31a7, 0x2966, 0x3186, 0xbdf8, 0xffff, 0xdefc, 0x8c72, 0xce59, 0xffff, 0xef5e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xffdf, 0x94b3, 0x5aec, 0x8431, 0x7c10, 0x7c10, 0x634d, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xffbe, 0xff9f, 0xffff, 0xd6fa, 0x3283, 0x3b22, 0x73ec, 0xfffd, 0xefbc, 0xfffe, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7df, 0xce9a, 0x94b3, 0x4a6a, 0xb5b7, 0x4a6a, 0x4a4a, 0x73af, 0x8411, 0x8431, 0x5aec, 0x3187, 0x4a6a, 0x5acc, 0x9492, 0xef7e, 0xf7bf, 0xef7e, 0xad76, 0xb5b7, 0xffdf, 0xf7df, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7bf, 0xffff, 0x8c72, 0x630d, 0x8411, 0x8451, 0x73cf, 0x8451, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffde, 0xfffe, 0xffff, 0xf7ff, 0xb635, 0x3283, 0x3b42, 0x6c0b, 0xcf17, 0xadd3, 0xbe56, 0xf7dd, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffdf, 0xdefb, 0xad55, 0xe73d, 0x1904, 0x39e8, 0x94b3, 0x9493, 0x528b, 0x2946, 0x5acc, 0x8411, 0x52ab, 0xdedb, 0xf7bf, 0xe75d, 0xffff, 0xce7a, 0xa535, 0xef7e, 0xffff, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf7bf, 0xffff, 0x8431, 0x632e, 0x8411, 0x8451, 0x632d, 0x9d14, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7be, 0xfffe, 0xefdb, 0xc6b6, 0x9551, 0x5bca, 0x4345, 0x43a3, 0x21e0, 0x32a3, 0x2a62, 0x3ac5, 0x9551, 0xfffe, 0xf7df, 0xffff, 0xffff, 0xffff, 0xf79d, 0xffff, 0xc639, 0xdefc, 0xbdf8, 0x2925, 0x6b6e, 0x8c52, 0x52ab, 0x2946, 0x6b4e, 0x9493, 0x5acc, 0x8c52, 0xf7bf, 0xf79f, 0xef5d, 0xffff, 0xe71c, 0xb5b7, 0xef7e, 0xef7e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xef9e, 0xf7bf, 0xffdf, 0x7bd0, 0x6b4e, 0x8431, 0x7c31, 0x52ab, 0xb5d7, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xd719, 0x742b, 0x3ae4, 0x2262, 0x1a41, 0x3b64, 0x3b83, 0x3b43, 0x2280, 0x3323, 0x3303, 0x53e9, 0xdf9a, 0xf7fe, 0xffff, 0xffde, 0xffff, 0xffff, 0xbdf7, 0xc638, 0xef7e, 0xbdd7, 0x526a, 0x8c52, 0x52ab, 0x31a7, 0x5aec, 0x9cf4, 0x7bd0, 0x4209, 0xef7e, 0xf79f, 0xef7e, 0xef7e, 0xe75d, 0xf79e, 0xdefc, 0xf7bf, 0xef7e, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79e, 0xf7be, 0xef9e, 0xf7bf, 0xf7bf, 0x6b6e, 0x6b6e, 0x8432, 0x8431, 0x52cb, 0xdefc, 0xf7df, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xf7ff, 0x6bec, 0x2a62, 0x3b43, 0x4bc5, 0x1a81, 0x1220, 0x22e1, 0x3301, 0x1a80, 0x3ba3, 0x3ba4, 0x22a2, 0x9df2, 0xf7fe, 0xffff, 0xffff, 0xffff, 0xf79d, 0x3165, 0x8c31, 0xffff, 0xc618, 0x528a, 0x738f, 0x3187, 0x5aec, 0xa535, 0x7bd0, 0x630d, 0x8c52, 0xf7bf, 0xef7e, 0xef7e, 0xffdf, 0xe71c, 0xffdf, 0xef7e, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79f, 0xf79e, 0xf7be, 0xef9e, 0xf79e, 0xf7bf, 0x6b4e, 0x6b6e, 0x8c52, 0x8c72, 0x634d, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xae73, 0x3ae4, 0x3b03, 0x4ba5, 0x3b23, 0x1220, 0x3303, 0x1a20, 0x2aa4, 0x1a62, 0x3364, 0x3363, 0x3323, 0x640a, 0xfffe, 0xffff, 0xffff, 0xffff, 0xf7be, 0x2104, 0x94b3, 0xf7bf, 0xe73d, 0x4a6a, 0x2105, 0x5acc, 0x8c73, 0x8411, 0x8431, 0x4229, 0xce7a, 0xf79e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79e, 0xf77e, 0xf7bf, 0xf79f, 0xf79f, 0xef5e, 0x4a6a, 0x8431, 0x8431, 0x73ae, 0x8c51, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0x4366, 0x32e3, 0x3b23, 0x3302, 0x3322, 0x2ae1, 0x3b64, 0x3344, 0x1a21, 0x1220, 0x2b22, 0x3363, 0x3b85, 0x4b47, 0xfffe, 0xffbf, 0xffff, 0xffff, 0xffff, 0xa534, 0xc639, 0xe71c, 0xffdf, 0x52ab, 0x39c8, 0x8432, 0x8c52, 0x8c72, 0x7bd0, 0x5aec, 0xf7bf, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79e, 0xf79f, 0xef5d, 0xe73d, 0xf7bf, 0xc639, 0x4a6a, 0x7c10, 0x8c72, 0x630c, 0xad75, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xdedb, 0x2281, 0x4385, 0x43c4, 0x3321, 0x3341, 0x3342, 0x3363, 0x3b84, 0x1201, 0x1220, 0x2b02, 0x3363, 0x3b65, 0x4b27, 0xfffe, 0xffbf, 0xf7be, 0xffff, 0xf7be, 0xce59, 0xd69a, 0xffff, 0xce7a, 0x3187, 0x738f, 0x8c52, 0x7bf0, 0x8411, 0x5acc, 0x8c92, 0xf7bf, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79e, 0xf79f, 0xf79f, 0xef7e, 0xffff, 0x94b3, 0x52ec, 0x8472, 0x8451, 0x4208, 0xdedb, 0xffff, 0xffdf, 0xffff, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffff, 0xad75, 0x2b02, 0x3342, 0x3342, 0x3ba2, 0x3381, 0x2b62, 0x2b62, 0x3bc4, 0x2aa3, 0x22c2, 0x3343, 0x3363, 0x2ac2, 0x84ee, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xc638, 0xd6bb, 0xffff, 0x5aec, 0x5acb, 0x8c73, 0x7bf1, 0x8411, 0x8c52, 0x4229, 0xbdd8, 0xef5d, 0xf7bf, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79e, 0xffbf, 0xffdf, 0xef7e, 0xffdf, 0x632d, 0x5b0c, 0x8451, 0x7bf0, 0x6b6d, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffdf, 0xffff, 0xffdf, 0x9492, 0x3b84, 0x3b84, 0x3362, 0x3ba3, 0x3bc2, 0x33a3, 0x2b62, 0x33a3, 0x3b45, 0x3344, 0x3ba4, 0x3ba3, 0x1a61, 0xd799, 0xffff, 0xffdf, 0xf7be, 0xffff, 0xffff, 0xd69a, 0xdefc, 0xe71c, 0x41e8, 0x6b6e, 0x8411, 0x7bf1, 0x8432, 0x8c72, 0x4229, 0xce5a, 0xef9e, 0xef7e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79e, 0xf79f, 0xf79e, 0xffdf, 0xe71d, 0x5acc, 0x7bf0, 0x7c10, 0x6b6e, 0x9cf3, 0xffff, 0xf7be, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xf7be, 0xa514, 0x22c2, 0x4385, 0x3343, 0x22e0, 0x3b83, 0x3bc4, 0x3363, 0x3363, 0x4365, 0x3343, 0x3b83, 0x3ba3, 0x22a2, 0xf7fc, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffdf, 0xffff, 0xce7a, 0x62ec, 0x52ab, 0x8c31, 0x8c52, 0x7bf1, 0x8c52, 0x738f, 0x5acc, 0xf79f, 0xffdf, 0xe71c, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79e, 0xf77e, 0xf79e, 0xffff, 0x9cf4, 0x4a6a, 0x8c92, 0x8451, 0x6b6e, 0xe73c, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 
0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xd6ba, 0x2aa3, 0x2261, 0x2280, 0x1a60, 0x3322, 0x3322, 0x3b64, 0x3b64, 0x3303, 0x2b02, 0x3383, 0x3383, 0x3324, 0xbeb6, 0xffff, 0xffdf, 0xffff, 0xf79e, 0xffff, 0xffff, 0xe71c, 0x39c8, 0x6b2d, 0x8c51, 0x7bd0, 0x73b0, 0x9493, 0x738f, 0x73af, 0xdedc, 0xef7e, 0xf79e, 0xef7e, 0xef7e, 0xef9e, 0xef9e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79e, 0xf79f, 0xf79f, 0xf7bf, 0xf7bf, 0xf79f, 0xf79f, 0xf79e, 0xf79f, 0xf7bf, 0xef7e, 0x7c10, 0x6b6e, 0x6b8e, 0x8451, 0x7bf0, 0xffff, 0xf79e, 0xffff, 0xffff, 0xffdf, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff, 0xffff
};

const unsigned int  phvn [] PROGMEM = {
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xf8f8f8, 0xfefefe, 0xffffff, 0xf7f7f7, 0xfefefe, 0xffffff, 0xfdfdfd, 0xfafafa, 0xfefefe, 0xffffff, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xfafafa, 0xf8f8f8, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfafafa, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfcfcfc, 0xfbfbfb, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xf3f3f3, 0xfbfbfb, 0xffffff, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xfafafa, 0xfdfdfd, 0xfefefe, 0xfefefe, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfafafa, 0xfefefe, 0xffffff, 0xf7f7f7, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfbfbfb, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfafafa, 0xffffff, 0xfbfbfb, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf7f7f7, 0xfefefe, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xfafafa, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xfafafa, 0xf8f8f8, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xfcfcfc, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xc2c2c2, 0xcecece, 0xffffff, 0xffffff, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xbababa, 0xdddddd, 0xffffff, 0xfefefe, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xffffff, 0xf1f1f1, 0x888888, 0x252525, 0xababab, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xa3a3a3, 0x1d1d1d, 0x868686, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf3f3f3, 0xffffff, 0xf9f9f9, 0xfbfbfb, 0xffffff, 0xffffff, 0xfcfcfc, 0xf5fffb, 0xf8fffc, 0xfffeff, 0xfffbff, 0xfffaff, 0xfffbff, 0xfefbff, 0xfbfcff, 0xffffff, 0xfffdff, 0xfaf5ff, 0xfffbff, 0xfdf7f7, 0xfffcf3, 0xfffdff, 0x544c5b, 0x5d1700, 0x622f12, 0x735d5f, 0xced3e7, 0xeeffff, 0xeeffff, 0xf2fff3, 0xfaffe9, 0xf8fff6, 0xf8fff3, 0xfbfef3, 0xfffff6, 0xfffefb, 0xfffdff, 0xfffdff, 0xfffdff, 0xfffdfd, 0xfafbf5, 0xf7fff7, 0xf0fff8, 0xeffffe, 0xf5ffff, 0xbcbdd9, 0x4f4871, 0x6f3d00, 0x442200, 0x715f4b, 0xfffcf6, 0xfff2ed, 0xfff6f0, 0xfcfffd, 0xf1ffff, 0xfffffd, 0xfbfffa, 0xf2ffef, 0xf4fff3, 0xf2fff1, 0xfbfffa, 0xfffdff, 0xfff7ff, 0xffffff, 0xf7f7f7, 0xfdfdfd, 0xfefefe, 0xf9f9f9, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xf7f7f7, 0xfefefe, 0xffffff, 0xf2f2f2, 0xffffff, 0xfafafa, 0xf7f6f4, 0xfffeff, 0xfffcfe, 0xfffafd, 0xfff9fc, 0xfcf4f2, 0xfffdf9, 0xfffff8, 0xf7f6f2, 0xf5f5f5, 0xfdfeff, 0xfbfcfe, 0xfffffb, 0xfffff8, 0xc8c0be, 0x15080f, 0xab5a1b, 0xe6aa52, 0x816000, 0x2f2400, 0x6b6a66, 0xe1dfff, 0xfcfbff, 0xfefdff, 0xf6fafd, 0xfdfeff, 0xfefdfb, 0xfcf8f5, 0xfffbf8, 0xfffefb, 0xfffefd, 0xf9f5f4, 0xffffed, 0xf7fcf8, 0xf9fcff, 0xfbfcff, 0xd9d6eb, 0x635b50, 0x3a2c00, 0x79671d, 0xffaf5a, 0x8b4e17, 0x140c00, 0xcee6ea, 0xedffff, 0xf8ffff, 0xfffefa, 0xfffaf4, 0xfff7ff, 0xfffcff, 0xfcfdff, 0xeef6f8, 0xfbffff, 0xfcfcff, 0xfff8ff, 0xfff8ff, 0xfcfcfc, 0xf8f8f8, 0xffffff, 0xffffff, 0xfdfdfd, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfdfdfd, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfff7ff, 0xfffaff, 0xfef5f8, 0xfcf8f5, 0xfffff8, 0xfffff6, 0xfffff4, 0xf7f3e8, 0xfffdfa, 0xfffff8, 0xf3feee, 0xf5fff6, 0xf9fffd, 0xf7f5f8, 0x594d4f, 0x0f0000, 0xba5a0e, 0xe3921d, 0xffc52f, 0xdbae2d, 0x553100, 0x290f10, 0x8a7a97, 0xf7ecff, 0xfffcff, 0xfffbff, 0xfffdff, 0xfffdff, 0xfffeff, 0xfaf9f7, 0xfffbf8, 0xfffffa, 0xfbfffa, 0xfcffff, 0xf6f1ff, 0x8c7a92, 0x2b0e08, 0x603a00, 0xd5a92e, 0xffd22e, 0xff9133, 0xaf601e, 0x0f0400, 0x52726f, 0xe3ffff, 0xf0ffff, 0xfffdff, 0xfff9fb, 0xfff9ff, 0xf2e5ec, 0xfffcff, 0xfffdff, 0xfefeff, 0xfaf9ff, 0xfffeff, 0xfffdff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xf2f2f2, 0xffffff, 0xfafafa, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf4f4f4, 0xffffff, 0xffffff, 0xededed, 0xf7f7f7, 0xffffff, 0xfafafa, 0xfff5ff, 0xf3e9f1, 0xffffff, 0xfbfffd, 0xf3fef8, 0xf8ffff, 0xf2f7fa, 0xc4c4cc, 0x7e747f, 0xedeee9, 0xf9fff3, 0xf7fff8, 0xf5fcff, 0xb1aaba, 0x120009, 0x4e3133, 0xc25d0d, 0xff9b3d, 0xfc9d29, 0xfaa620, 0xfdbc3c, 0xa17417, 0x3b1f00, 0x39271b, 0xb8b3ba, 0xeeebf4, 0xfcfeff, 0xfafeff, 0xecf2fe, 0xfbffff, 0xfeffff, 0xf6f5fa, 0xfcf9ff, 0xa399a1, 0x382713, 0x402100, 0xb2832b, 0xffbe46, 0xffb524, 0xfda90b, 0xff9232, 0xac5f19, 0x432501, 0x030500, 0xb6c1bd, 0xf9ffff, 0xfaffff, 0xf5fcff, 0xfffef4, 0x65605a, 0xbcbbb7, 0xf1f3f2, 0xf8fefa, 0xeef8ef, 0xf9fff4, 0xf6ffec, 0xf7f7f7, 0xededed, 0xfcfcfc, 0xffffff, 0xf3f3f3, 0xe9e9e9, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xf8f8f8, 0xf8f8f8, 0xffffff, 0x989898, 0x636363, 0xd7d7d7, 0xffffff, 0xd6d7dc, 0x707475, 0xa5aea9, 0xecf9f2, 0xedfcf9, 0xf5ffff, 0xf7ffff, 0xd8dffb, 0x040013, 0x46434c, 0xc1c3be, 0xf4f6f5, 0xfffcff, 0x514053, 0x120004, 0x765455, 0xad520c, 0xeb8837, 0xffaa44, 0xff9c1f, 0xffab22, 0xffc847, 0xd7ab3e, 0x85670d, 0x180a00, 0x665e4b, 0xbfbfb5, 0xf4fafa, 0xf9ffff, 0xfcffff, 0xe8e5ee, 0xc8c1c8, 0x5b4641, 0x290e00, 0x7d590f, 0xf3c14e, 0xf8b62c, 0xf3a014, 0xffad2b, 0xffa129, 0xf49020, 0xa25a0e, 0x775438, 0x0a0000, 0x534d57, 0xfff9f9, 0xfcfcf2, 0xb2b9a9, 0x282e2e, 0x0f1515, 0xecf1f4, 0xfbffff, 0xf9ffff, 0xf8fffb, 0xe1f1e4, 0x96a898, 0x686868, 0xebebeb, 0xffffff, 0xeaeaea, 0x535353, 0xa7a7a7, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0x6b6b6b, 0x000000, 0x5e5e5e, 0xe0e0e0, 0xedfdfc, 0x16211b, 0x000200, 0x3f3d30, 0x5d594e, 0x9d999a, 0xd8d8e4, 0xf9fbff, 0x413c50, 0x030009, 0x3b3034, 0x816e70, 0x7e6467, 0x150000, 0x230200, 0x71503f, 0x9c5a2a, 0xd0872b, 0xffb22d, 0xffa21c, 0xff9c2f, 0xfa9d3d, 0xf1ab39, 0xf2bf32, 0xd4ad62, 0x7a5818, 0x463000, 0x736542, 0xa99d83, 0x9e8d79, 0x715842, 0x54361e, 0x8a5c0e, 0xdfac51, 0xfabb51, 0xeca229, 0xffaa2b, 0xffa82b, 0xfc9b26, 0xffad3c, 0xf39323, 0x93530b, 0x644936, 0x03000b, 0x0f0818, 0x75645d, 0x816c4d, 0x331c00, 0x050b25, 0x4d4f64, 0xfffdff, 0xdbd4db, 0xa1989b, 0x6c666a, 0x242128, 0x010109, 0x2f2f2f, 0xfdfdfd, 0xe3e3e3, 0x444444, 0x000000, 0x808080, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf1f1f1, 0xffffff, 0xfefefe, 0x717171, 0x000000, 0x020202, 0x363636, 0xbccccb, 0x41423a, 0x251201, 0x4e2b0f, 0x360d00, 0x1d0000, 0x291000, 0x211200, 0x0a0f09, 0x0f0705, 0x351b1c, 0x6d473e, 0x5d3116, 0x693f15, 0x4c2a00, 0x190000, 0x47230b, 0x94651d, 0xfbbe41, 0xffaf28, 0xfd9927, 0xff9935, 0xffa836, 0xf7a71e, 0xffad39, 0xfab045, 0xe3a649, 0xb48432, 0x865a0f, 0x835206, 0xb47929, 0xecaa56, 0xffc046, 0xf6a629, 0xfea62a, 0xffaa30, 0xfc9d25, 0xffa533, 0xffb448, 0xf7aa40, 0xa4692f, 0x401500, 0x260d00, 0x382008, 0x775637, 0x5c3514, 0x543113, 0x452b14, 0x000010, 0x1e141c, 0x39271b, 0x160000, 0x200000, 0x381501, 0x44211b, 0x2e0e13, 0x474747, 0x9c9c9c, 0x252525, 0x000000, 0x000000, 0x878787, 0xe8e8e8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfafafa, 0x595959, 0x000000, 0x262626, 0x000000, 0x00090a, 0x1f150c, 0x481f09, 0x985832, 0xac6633, 0x9d6029, 0xa2783e, 0x6b4e16, 0x414e32, 0x312a1a, 0x1a0000, 0x370300, 0x7c4411, 0xc29447, 0xc0a04d, 0xa0893b, 0x3e2d25, 0x301100, 0x976318, 0xeba32b, 0xffb621, 0xff9f0a, 0xff9f1d, 0xffa435, 0xff9b10, 0xffa01d, 0xffa92f, 0xfcaf3d, 0xfcb543, 0xffb43c, 0xffac2b, 0xffa31b, 0xfe9923, 0xff9f21, 0xffa31a, 0xff9e10, 0xffa51d, 0xffb43e, 0xe09a38, 0xa4640d, 0x1b131e, 0x403023, 0x926e3c, 0xeaac59, 0xcf8226, 0x8d4c0a, 0x290900, 0x000013, 0x3e3226, 0x554224, 0x6c4d17, 0xb1873f, 0xb07c33, 0x91591e, 0x985e38, 0x4a1000, 0x101010, 0x101010, 0x000000, 0x2c2c2c, 0x000000, 0x737373, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xfefefe, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbffff, 0xf8f8ff, 0xfffdff, 0xfffcfd, 0xfffcfb, 0xfffcfd, 0xfffcfd, 0xfff8fb, 0xfffffb, 0xfbfcf7, 0xf8faf7, 0xfafefd, 0xfbffff, 0xf9ffff, 0xf8ffff, 0xf8ffff, 0xfffcff, 0xfffcff, 0xfffdff, 0xfffcfd, 0xfcfcfc, 0xfcfdff, 0xfcffff, 0xfcffff, 0xfff9ff, 0xfffaff, 0xfef8ff, 0xf9f7fc, 0x7d7872, 0x170a00, 0x5c4523, 0x795e33, 0x000424, 0x001210, 0x08240e, 0x422f1e, 0x923e24, 0xdb6620, 0xff9e25, 0xffc530, 0xffaf2c, 0xe49f38, 0x98753f, 0x4a413a, 0x14101e, 0x120000, 0x683d06, 0xd89e3b, 0xfdca17, 0xae791d, 0x825007, 0xc69014, 0xffb92d, 0xffa321, 0xff9f1e, 0xffa22a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xffb12a, 0xef9525, 0xffaa46, 0xffa62e, 0xf39f09, 0xffb929, 0xde8c29, 0x893302, 0xd0822f, 0xffb94a, 0xd9a52b, 0x624000, 0x120000, 0x230f06, 0x6d4c29, 0xaa7e35, 0xf19e28, 0xffb841, 0xffc24e, 0xec9d36, 0xc77124, 0x884a1b, 0x342110, 0x051918, 0x050209, 0x180f08, 0x685743, 0x5e4735, 0x210804, 0x917c81, 0xfff9f7, 0xfffff0, 0xfffdff, 0xfffcff, 0xfbfaff, 0xfafbff, 0xfcffff, 0xfcffff, 0xfbfffd, 0xfbfffd, 0xfffdff, 0xfffcff, 0xfffdff, 0xfffcff, 0xfffbff, 0xfffaff, 0xfff8ff, 0xfff5ff, 0xfffff3, 0xfbfdf2, 0xfefffb, 0xfafcfb, 0xffffff, 0xfffdff, 0xfcf3f8, 0xfffbff, 0xfafafa, 0xfefefe, 0xfefefe, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xf6f6f6, 0xf8f8f8, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xfbfbfb, 0xfbfbfb, 0xfffeff, 0xfffeff, 0xf1eff2, 0xfffeff, 0xfffeff, 0xf2f2f4, 0xfeffff, 0xfcffff, 0xfffffa, 0xfffffa, 0xfffffb, 0xfffffb, 0xfcfefb, 0xf9fdfc, 0xfbfffe, 0xfcffff, 0xfaf9ff, 0xfefdff, 0xfffeff, 0xfffeff, 0xfefdff, 0xfdfcff, 0xfffeff, 0xfffeff, 0xfcfdf5, 0xfbfdf8, 0xfbffff, 0xfbffff, 0x797a75, 0x070000, 0x422f1e, 0x947a63, 0xc77d1e, 0x47290f, 0x000513, 0x00130f, 0x4a3b24, 0x7d3a20, 0xaf5521, 0xe99533, 0xffbc28, 0xffaf21, 0xffae22, 0xffbc2f, 0xe8ab2e, 0x94661b, 0x3b1719, 0x10002d, 0x845948, 0xf6d85e, 0xf3c943, 0xf1a148, 0xff9b2c, 0xff9c13, 0xffb840, 0xef9928, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xf59d21, 0xffb232, 0xf69b17, 0xffa427, 0xffb23e, 0xe69424, 0xe59e2a, 0xffc54d, 0xffd139, 0x815f17, 0x170711, 0x2d1f30, 0x906f44, 0xdea83e, 0xf9b435, 0xf6ae38, 0xeeb03f, 0xffb83b, 0xff981b, 0xbc5b00, 0x793b0c, 0x3c2422, 0x060419, 0x000017, 0x483200, 0x9d874e, 0x988253, 0x291300, 0x0b0000, 0x9a929f, 0xfbfeff, 0xf3fcff, 0xfbf9ff, 0xfcfaff, 0xfffeff, 0xfeffff, 0xfcffff, 0xfbffff, 0xfaffff, 0xf4fdfc, 0xf8fcfd, 0xfbffff, 0xfdfeff, 0xfbfcfe, 0xfcfcfe, 0xfffdff, 0xfffeff, 0xfffeff, 0xfffeff, 0xffffff, 0xfeffff, 0xfcffff, 0xf8fcff, 0xfcffff, 0xfeffff, 0xfefefc, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xf7f7f7, 0xf6f6f6, 0xffffff, 0xffffff, 0xfafafa, 0xf9f9f9, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfafafa, 0xffffff, 0xf9f9f9, 0xfcfcfc, 0xfdfdfd, 0xfcfcfc, 0xfbfbfb, 0xfcfcfc, 0xfefefe, 0xfefefe, 0xfffdff, 0xfffdff, 0xffffff, 0xfbffff, 0xf3fdff, 0xf5ffff, 0xf4ffff, 0xebfdfd, 0xfafbf6, 0xfdfdfb, 0xfcfcfa, 0xf8f8f6, 0xfafaf8, 0xfffffd, 0xfdfffc, 0xf8faf9, 0xf7ffff, 0xf7ffff, 0xf0f9fe, 0xdfe4ea, 0xc1c2c7, 0x9b9aa0, 0x7b767c, 0x676268, 0x65706a, 0x7a8682, 0x9aa9a6, 0xacb8b8, 0x5e6766, 0x090a05, 0x0a0300, 0x140a00, 0xbb8c30, 0xd8ac3f, 0x9e742c, 0x2a0914, 0x070023, 0x180e16, 0x4d3616, 0x7a4e2b, 0xe6822d, 0xffa741, 0xffb437, 0xfca115, 0xf8a41d, 0xffbf45, 0xdda337, 0x916000, 0x20070d, 0x664719, 0xe9b44e, 0xffc049, 0xff9a2f, 0xff9422, 0xf7941d, 0xffb147, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfd9d2c, 0xffa628, 0xfea01a, 0xffa41f, 0xf59f26, 0xf4ab38, 0xffc54d, 0xe1ae2e, 0x313325, 0x312100, 0x7f550d, 0xeaa941, 0xffbd43, 0xffa521, 0xffa119, 0xffb027, 0xffb153, 0xe08d23, 0x975600, 0x492409, 0x14032d, 0x030025, 0x381e07, 0x9a6f11, 0xdcb16d, 0x906a39, 0x3a2005, 0x150900, 0x0c0d07, 0x59665f, 0xaabdb9, 0x9aaead, 0x7f7f87, 0x767980, 0x70737a, 0x767b7f, 0x8e9699, 0xb9c1c4, 0xe5eff1, 0xf8ffff, 0xf8fffb, 0xf8fffd, 0xf8fffd, 0xf5fffc, 0xf4fffb, 0xf9ffff, 0xf9ffff, 0xf8ffff, 0xf9fcff, 0xfbfeff, 0xf3f5ff, 0xfaffff, 0xfbffff, 0xf3f9f5, 0xf3fdf5, 0xf9fffa, 0xf9f9f9, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xf2f2f2, 0xf5f5f5, 0xffffff, 0xf1f1f1, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfffcfb, 0xf7f1f1, 0xf2f3f5, 0xf2fcfe, 0xf1ffff, 0xf1ffff, 0xf1ffff, 0xf1fffe, 0xfbffff, 0xf9feff, 0xf5f9fc, 0xfafeff, 0xfeffff, 0xfeffff, 0xf5f7f6, 0xe1e1e1, 0x949e9d, 0x717a79, 0x404443, 0x171612, 0x060000, 0x080000, 0x0b0000, 0x120000, 0x050005, 0x060108, 0x030208, 0x000005, 0x00080a, 0x151e1d, 0x17221c, 0x07120c, 0x000100, 0x715734, 0xe4a94f, 0xf8b437, 0xa97915, 0x331f00, 0x00000e, 0x000a28, 0x55371f, 0x94672c, 0xe7a841, 0xffba3d, 0xffa425, 0xffa225, 0xffb32d, 0xffb625, 0xb89736, 0x582216, 0x732f18, 0xe69c31, 0xffab2a, 0xfc9d25, 0xffad36, 0xf49831, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xffac3a, 0xfa952b, 0xffac3f, 0xffa624, 0xeda10d, 0xfdbd35, 0xc38b2c, 0x632f00, 0x623901, 0xc38937, 0xffc54f, 0xffb929, 0xefa10b, 0xffb026, 0xffb841, 0xffa033, 0xa55a16, 0x5f321d, 0x090017, 0x000015, 0x42311d, 0xad863b, 0xe9b047, 0xf3b546, 0x62441e, 0x1a0300, 0x080006, 0x252736, 0x0a1819, 0x000800, 0x051200, 0x000400, 0x0a0300, 0x050000, 0x040000, 0x030000, 0x010000, 0x100f0b, 0x23241f, 0x31322d, 0x797e77, 0xaeb5ae, 0xe8eeea, 0xfbffff, 0xf9ffff, 0xf8ffff, 0xf6ffff, 0xf6ffff, 0xf4ffff, 0xeef7ff, 0xf7feff, 0xfcfdff, 0xfffffd, 0xfffffa, 0xfdfef8, 0xfefffa, 0xf5f5f5, 0xfcfcfc, 0xfafafa, 0xfbfbfb, 0xffffff, 0xffffff, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xfefefe, 0xf1f1f1, 0xffffff, 0xf9f9f9, 0xfbfbfb, 0xf4f4f4, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xf5f5f5, 0xb4b4b4, 0x707070, 0xd6d6d6, 0xffffff, 0xf9f9f9, 0xfcfcfc, 0xfcfcfc, 0xfafafa, 0xfefefe, 0xffffff, 0xffffff, 0xfafafa, 0xfff8f3, 0xf1edea, 0x85898a, 0x8c9698, 0xb9c5c5, 0xabb5ad, 0xc7cbbd, 0xcbccba, 0xc8c9cd, 0xbebfc1, 0xb8b8b8, 0xb5b4b2, 0xa7a3a0, 0x7e7975, 0x4a433d, 0x241b16, 0x140000, 0x1b0100, 0x290c00, 0x411e0a, 0x572e18, 0x663820, 0x69371e, 0x663318, 0x512a1b, 0x431d10, 0x34160b, 0x1c0800, 0x110705, 0x111216, 0x0c161f, 0x162731, 0x302219, 0x0d080f, 0x1d190e, 0x867120, 0xf6c841, 0xffc94f, 0x977838, 0x2c2918, 0x160305, 0x0f0000, 0x432d15, 0x9f8240, 0xdaaf3f, 0xf5b52f, 0xffaf31, 0xffa538, 0xffb625, 0xffb94a, 0x924c2a, 0x682d0f, 0xcb9b2c, 0xfbc330, 0xf19d23, 0xff9f2c, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xff9f2a, 0xfd9b2e, 0xffa039, 0xffac3d, 0xffb842, 0xbc7d16, 0x743900, 0x915732, 0xffb127, 0xffb330, 0xe9a826, 0xedab21, 0xffc339, 0xfdb64a, 0xa26932, 0x4a1f16, 0x0d030e, 0x070004, 0x39240f, 0xb38a3a, 0xffc945, 0xf4ba35, 0x8c681a, 0x1f1100, 0x070c00, 0x1e2422, 0x21293c, 0x0c1429, 0x11161c, 0x16110b, 0x190401, 0x351719, 0x492002, 0x52290d, 0x5d3619, 0x603b20, 0x59351d, 0x4c2812, 0x3e1b07, 0x371400, 0x0d0000, 0x140300, 0x281912, 0x50423f, 0x857979, 0xaea4a5, 0xb7aeb3, 0xaca5ac, 0xbccbce, 0xb3bcbb, 0xdeddd8, 0xd2c8be, 0xc5b7ae, 0xc5b6b1, 0x908685, 0x867d80, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xfefefe, 0xfefefe, 0xf9f9f9, 0xf8f8f8, 0xffffff, 0xf4f4f4, 0xffffff, 0xffffff, 0xe6e6e6, 0x6f6f6f, 0xbebebe, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfbfbfb, 0xffffff, 0xb9b9b9, 0x000000, 0x5c5c5c, 0xf0f0f0, 0xfbfbfb, 0xffffff, 0xffffff, 0xfdfdfd, 0xf8f8f8, 0xfdfdfd, 0xffffff, 0xffffff, 0xfffcf3, 0xfffffb, 0x676b6a, 0x000102, 0x1a1914, 0x342415, 0x290b00, 0x270000, 0x2b1508, 0x240e00, 0x250b00, 0x2d1200, 0x381904, 0x422007, 0x4d290f, 0x573217, 0x8f4a21, 0x924b21, 0x954c1f, 0x9a4e1c, 0xa0501b, 0xa5551a, 0xab5a1b, 0xb05c1c, 0xa8661c, 0x9d5d16, 0x925618, 0x754111, 0x582f0f, 0x371b0d, 0x120404, 0x0d0711, 0x171611, 0x2f3011, 0x312a18, 0x1d0a1d, 0x3f2320, 0xa58230, 0xf6c53a, 0xffc735, 0xb5783f, 0x673c19, 0x180700, 0x010101, 0x272510, 0x78611e, 0xd19c2c, 0xffbd30, 0xfda014, 0xffb01d, 0xfcbe51, 0x9c6d35, 0x6e4a0e, 0xc4982f, 0xffb633, 0xffa31b, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xffa028, 0xfca11f, 0xf6a426, 0xffb456, 0xcf834f, 0x8b441a, 0xb1712a, 0xf7be55, 0xeaa33b, 0xfbbb33, 0xfbc024, 0xd7a021, 0x8b5a18, 0x2a0900, 0x040000, 0x0c1c0f, 0x4c462e, 0xa48437, 0xffcc47, 0xffca41, 0x996d14, 0x301c00, 0x211811, 0x302b27, 0x2c3844, 0x0c1421, 0x07070f, 0x0a0000, 0x361c01, 0x63380e, 0x7e4416, 0xa15d30, 0xae5d1c, 0xaf5e1f, 0xae5e21, 0xaa5b22, 0xa3561e, 0x9c4f1b, 0x974b19, 0x944817, 0x865431, 0x7c4a29, 0x68391b, 0x53250d, 0x401600, 0x340d00, 0x320c00, 0x330f03, 0x291f06, 0x211000, 0x230a00, 0x200100, 0x43240f, 0x260f07, 0x0b0003, 0x8c8692, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xdbdbdb, 0x575757, 0x000000, 0xbcbcbc, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfefefe, 0xf5f5f5, 0xfcfcfc, 0xdfdfdf, 0x070707, 0x000000, 0x252525, 0xb7b7b7, 0xdfdfdf, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xfdfdfd, 0xf9faf2, 0xfcfffb, 0xd2d6d5, 0x292524, 0x200e04, 0x8b614b, 0x904f29, 0x974617, 0x854a1e, 0x8e5124, 0x98582a, 0xa05c2b, 0xa25924, 0xa0531b, 0x9f5015, 0xa05013, 0xab4f04, 0xb5590c, 0xc26716, 0xcf751d, 0xd98022, 0xe38b27, 0xed962c, 0xf49e31, 0xeb9e2a, 0xf6a633, 0xf7a537, 0xea9b36, 0xe39940, 0xc78940, 0x8b581f, 0x5f3304, 0x000017, 0x110008, 0x432200, 0x6a4a0f, 0x523219, 0x2e060f, 0x653109, 0xcc9111, 0xefce35, 0xeec430, 0xe2ac30, 0xbd7e31, 0x7a3a1f, 0x390803, 0x331a06, 0x575026, 0xefab46, 0xf7ad4c, 0xf6b326, 0xf9c138, 0xa77030, 0x93561f, 0xf8b041, 0xf8a11c, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xffad2f, 0xfba921, 0xf8b131, 0xdc9b3f, 0x96531e, 0xad682f, 0xffc057, 0xfcbd22, 0xf4bc33, 0xd39729, 0x7e4808, 0x250600, 0x1c1314, 0x665c41, 0xb89543, 0xe2a526, 0xe8c523, 0xffd152, 0xbf8434, 0x4f2200, 0x2a1800, 0x484438, 0x50413e, 0x2b0b10, 0x0c000b, 0x120000, 0x5f3c12, 0xa27029, 0xc17e25, 0xde8e2b, 0xf8a034, 0xe68b19, 0xfe9f33, 0xfa9d33, 0xf69932, 0xef9330, 0xe48a2a, 0xd87f23, 0xcd731b, 0xc66c16, 0xae5a11, 0xa3500a, 0x9c4d0a, 0x9f5315, 0x9f571d, 0x98521e, 0x945220, 0x955525, 0x834917, 0x90521f, 0x824310, 0x8b5123, 0x895e3c, 0x2a1406, 0x313236, 0xe4f4ff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xfafafa, 0xffffff, 0xffffff, 0xececec, 0xf5f5f5, 0x9b9b9b, 0x313131, 0x000000, 0x282828, 0xf7f7f7, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xffffff, 0xf6f6f6, 0x303030, 0x0f0f0f, 0x2b2b2b, 0x080808, 0x5c5c5c, 0xbebebe, 0xf2f2f2, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfbfff8, 0xfafffa, 0xfcffff, 0x847c79, 0x1f0000, 0x703317, 0xb85d31, 0xc55820, 0xbd611e, 0xb95c17, 0xb3520b, 0xb45005, 0xc65c0e, 0xe07321, 0xf48430, 0xfc8a34, 0xf39c35, 0xf69f36, 0xfba737, 0xfdac36, 0xfcb132, 0xfab22c, 0xf5b024, 0xf4b021, 0xf9a92e, 0xfea92a, 0xffa520, 0xffa71d, 0xffae26, 0xffb12e, 0xfdaf33, 0xf8b13b, 0xc6825b, 0x615034, 0x000808, 0x120010, 0x88333a, 0xaf4b34, 0x61311b, 0x121e1c, 0xad8100, 0xefb235, 0xffbe43, 0xffac31, 0xffb53f, 0xecb453, 0x9a7c3e, 0x4a3d1d, 0x4f2a0d, 0xb88323, 0xefa61c, 0xffb52b, 0xf9ac36, 0xb3691e, 0xb26723, 0xf9af42, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xf29a12, 0xffb035, 0xe8a53a, 0xa16a03, 0xab7709, 0xeeb437, 0xf8b42b, 0xf0a514, 0xa26932, 0x5d2f0d, 0x553318, 0xa37f4b, 0xeab452, 0xffba35, 0xffb125, 0xffa928, 0xe6c42d, 0x8a6e0d, 0x341600, 0x5e3227, 0x9f6551, 0x693214, 0x200100, 0x1b1112, 0x73481e, 0xb78338, 0xebaa36, 0xffb12b, 0xffb230, 0xff9f28, 0xffa936, 0xffa530, 0xfdaa1c, 0xfdaa1e, 0xfdab23, 0xffad2b, 0xffb032, 0xffb037, 0xfbac36, 0xf7a734, 0xffa138, 0xf8922d, 0xee8a28, 0xeb8c2e, 0xdb8129, 0xbe6815, 0xaa5709, 0xa75509, 0xb75516, 0xc05e1d, 0xc36728, 0xb56a31, 0x501f00, 0x130400, 0x819093, 0xe4ffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xefefef, 0xb6b6b6, 0x3a3a3a, 0x2e2e2e, 0x282828, 0x101010, 0x383838, 0xffffff, 0xf9f9f9, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xf5f5f5, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xffffff, 0xfffffd, 0xfffefb, 0xfffcf8, 0x645f5b, 0x060000, 0x544d47, 0xe8851d, 0xac590b, 0x571f00, 0x442a2b, 0x858198, 0xc5d1eb, 0xe2f5ff, 0xf0ffff, 0xfffcfb, 0xfeffff, 0xfbffff, 0xd2dadc, 0x30322d, 0x060000, 0x402f13, 0x5d4523, 0x874827, 0x8e4e2a, 0x945127, 0x99541d, 0xa96119, 0xc87f23, 0xe89f30, 0xfdb33a, 0xf9bd43, 0xf8b83a, 0xfab533, 0xffb52e, 0xffb52c, 0xfeb42d, 0xfcb833, 0xffbd3b, 0xffb32e, 0xffac28, 0xfaa524, 0xfaa224, 0xfca227, 0xffa42b, 0xffa52f, 0xffa731, 0xffbf07, 0xffbc27, 0xcb9a3e, 0x634219, 0x1b0000, 0x431b0f, 0x8c5537, 0x9e5b2e, 0x3b0a05, 0x8f5c27, 0xf2b84c, 0xf5b027, 0xf4a620, 0xffb93d, 0xfeac2c, 0xffb72d, 0xce9134, 0xa26000, 0xc47a0f, 0xf4a02e, 0xffab37, 0xf9a02a, 0xdf8815, 0xed9726, 0xffa92d, 0xffa126, 0xffa227, 0xffa32a, 0xffa52d, 0xfda029, 0xf39823, 0xffa631, 0xff9c30, 0xfc9c38, 0xf09e3b, 0xd9881f, 0xf49e27, 0xffaa2b, 0xeea72b, 0xba7f0b, 0xa06300, 0xda902d, 0xffbb54, 0xffaf37, 0xff9f14, 0xffab1a, 0xf6ad2c, 0xf0ae40, 0x764d2d, 0x4f1d04, 0x84542e, 0x947443, 0x291000, 0x190000, 0x8a501e, 0xe8a21e, 0xffc03d, 0xffb434, 0xffa629, 0xff9e24, 0xff9d21, 0xff9d20, 0xff9e1d, 0xff9e1c, 0xffae1a, 0xffae24, 0xffb033, 0xffb541, 0xffb748, 0xffb542, 0xfab239, 0xfab335, 0xffb61d, 0xffba29, 0xffb333, 0xf19c31, 0xd17922, 0xb75b1a, 0xac4e1b, 0xab4b21, 0x94572a, 0x76441f, 0x55351e, 0x3d2c24, 0x010002, 0x353841, 0xe2e6ef, 0xfcffff, 0xfbfff5, 0xf7ffff, 0xf2ffff, 0xecf8ff, 0xc1c6ec, 0x7e768b, 0x4b3730, 0x381a02, 0xb35500, 0xe79b4f, 0x5f3012, 0x200e0c, 0x676b6c, 0xf8fffd, 0xf9fef7, 0xfffef9, 0xfffffb, 0xfafbf6, 0xfffffb, 0xfdfef9, 0xfcfdf8, 0xfffffb, 0xfffffb, 0xfcfdf8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfafafa, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xfcfbf9, 0xfdfcfa, 0xfffefb, 0xa29d99, 0x060000, 0x231c16, 0xad5a0e, 0xf1a55a, 0xeeb26a, 0x916828, 0x3d2300, 0x231600, 0x433e2a, 0x717165, 0xc8c4c5, 0xe3e4e9, 0xf8ffff, 0xf5ffff, 0x7c879d, 0x03081c, 0x060515, 0x1a1422, 0x171200, 0x231c0a, 0x30261a, 0x382720, 0x35201b, 0x341b14, 0x3b1f13, 0x442717, 0x4e3123, 0x5e3e27, 0x6d4927, 0x724e1e, 0x714f12, 0x755a15, 0x816d24, 0x8e7e33, 0xcc9820, 0xe8b13a, 0xffc34b, 0xfdba45, 0xf8ad38, 0xfaa934, 0xffa834, 0xffa632, 0xfd9822, 0xfea831, 0xf5b740, 0xedc154, 0xb5913b, 0x451e00, 0x2a0000, 0x784033, 0x956654, 0x5a2600, 0x995d07, 0xfdb546, 0xfca92f, 0xed971c, 0xffaa2b, 0xfba826, 0xffbc54, 0xe79e35, 0xe8972c, 0xf9a133, 0xffa532, 0xfba02b, 0xf9a02a, 0xfea831, 0xff9f24, 0xfd9d22, 0xffa027, 0xfd9e26, 0xffa32a, 0xffa62f, 0xfa9f2a, 0xfda22d, 0xff9c28, 0xfd9e32, 0xfba840, 0xf2a034, 0xffac34, 0xfca325, 0xefa029, 0xd49222, 0xf8b449, 0xfcad46, 0xfca136, 0xffa72e, 0xf99d14, 0xfeac25, 0xfab243, 0xa46309, 0x56180d, 0x9e703f, 0x734f2d, 0x210000, 0x542805, 0xc49716, 0xf6ba35, 0xfaab69, 0xf2a61f, 0xfaa828, 0xffa82d, 0xffa432, 0xfba339, 0xf9a743, 0xf8b04c, 0xf7b554, 0xd2ad54, 0xba9443, 0x9c762f, 0x866224, 0x78581f, 0x6f5115, 0x6a4e0d, 0x68500a, 0x504434, 0x453929, 0x37291c, 0x2e2015, 0x2e1d15, 0x311e17, 0x311e18, 0x301d17, 0x280c01, 0x26120b, 0x1b1310, 0x000200, 0x0a1710, 0x94a499, 0xf7fff3, 0xf1ffe6, 0xf5eeff, 0xb8b4c5, 0x6f6c77, 0x393430, 0x221300, 0x3e2200, 0x956d0d, 0xedbb48, 0xf6aa4a, 0xa46728, 0x371300, 0x080000, 0xb2b7ba, 0xf8fffd, 0xf9fcf5, 0xfffffa, 0xfdfef9, 0xf8f9f4, 0xfffffb, 0xfffffb, 0xfbfcf7, 0xfffffb, 0xfdfef9, 0xfafbf6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xfefefe, 0xfcfdff, 0xfeffff, 0xffffff, 0xfffffd, 0xfffefb, 0xdfdbd8, 0x191410, 0x040000, 0x5d2600, 0xab6e2f, 0xebaa44, 0xffbf3d, 0xfcbd3a, 0xcb972a, 0x7b5107, 0x422000, 0x2e1e00, 0x392d13, 0x474337, 0x717576, 0x555d6a, 0x0e192f, 0x000a25, 0x0d1431, 0x0a1121, 0x0d1426, 0x15182b, 0x15162a, 0x0e0c1a, 0x09040a, 0x110c08, 0x1f180e, 0x220d0c, 0x2b1110, 0x33140f, 0x33120b, 0x32110c, 0x2f1111, 0x291016, 0x220d16, 0x340a00, 0x4a1d06, 0x6e3d15, 0x9c6427, 0xcb8d38, 0xeca83d, 0xf5ab30, 0xf0a31f, 0xff9d4b, 0xff9f37, 0xf4a01a, 0xf7b11b, 0xffcb40, 0xe3b34f, 0x875925, 0x350800, 0x6a3d14, 0x824d23, 0x92501c, 0xd3873b, 0xffb248, 0xfea42a, 0xfea225, 0xffa22c, 0xf6ab34, 0xffb03d, 0xf8a032, 0xfd9e32, 0xff9f32, 0xfd9e2a, 0xffa92f, 0xfba627, 0xffa52d, 0xffa52d, 0xffa82f, 0xfda027, 0xfda029, 0xffa831, 0xffa62f, 0xffa32c, 0xffa929, 0xfa9d26, 0xfba737, 0xfea837, 0xffa72e, 0xfe9c21, 0xfda632, 0xf4a73d, 0xf5a536, 0xfca637, 0xfb9d29, 0xffa527, 0xf9a020, 0xf6a635, 0xd6923d, 0x6f2f00, 0xa76028, 0x591f1e, 0x391018, 0x845e1d, 0xe6b02c, 0xffbb34, 0xfca933, 0xf2a730, 0xf19d17, 0xf9a626, 0xfdac37, 0xf8ad47, 0xe9a94f, 0xc69344, 0x8e6922, 0x5f4200, 0x3e1d0a, 0x341407, 0x280904, 0x25080a, 0x270c11, 0x281117, 0x281416, 0x271515, 0x230c14, 0x220f13, 0x201114, 0x181310, 0x10130c, 0x09130a, 0x061609, 0x051a0b, 0x1c2021, 0x141c1f, 0x19232d, 0x000515, 0x0d152a, 0x656a80, 0x757389, 0x474258, 0x331b11, 0x361c05, 0x4b2f00, 0x815d11, 0xc99a30, 0xfec23e, 0xffc32d, 0xffb011, 0xb3813a, 0x4f2800, 0x160200, 0x18171d, 0xe9f3f5, 0xf8fffd, 0xf7f8f2, 0xfffdfb, 0xfffffd, 0xfdfdfb, 0xfffffd, 0xfefefc, 0xfbfbf9, 0xfffffd, 0xfffffd, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfbfbfb, 0xfdfdfd, 0xfcffff, 0xfeffff, 0xfeffff, 0xf7f7f7, 0xfbfaf8, 0xfefaf7, 0x6c6865, 0x080401, 0x2e1308, 0x764b1e, 0xc78322, 0xfba417, 0xffb519, 0xffb527, 0xffb643, 0xffc064, 0xd5a044, 0xb4842f, 0x6f4800, 0x523400, 0x473203, 0x2f2200, 0x1f1800, 0x130f00, 0x110b15, 0x0b0511, 0x06000d, 0x09000c, 0x14090f, 0x2c1e1b, 0x493d2f, 0x605340, 0x996b2d, 0x9a6726, 0x9c5f1e, 0x9e5916, 0xa05514, 0xa25318, 0xa35620, 0xa45827, 0x8f5f3b, 0x7b4a21, 0x743f0d, 0x82470b, 0x93550c, 0xaa6613, 0xcf882c, 0xf5ab4c, 0xf9a133, 0xfa9d26, 0xffa829, 0xffa421, 0xf59c1e, 0xffb849, 0xf0b859, 0xb18431, 0x5a2a00, 0x753c0f, 0x843d1d, 0xb66633, 0xf19c42, 0xffa833, 0xffa52e, 0xff9f31, 0xec9716, 0xffa72b, 0xffa02c, 0xff9c30, 0xff9f33, 0xfc9c2b, 0xfaa227, 0xf6a323, 0xffa632, 0xffa630, 0xffa631, 0xfea32e, 0xfea12a, 0xffa42d, 0xffa42b, 0xffa32b, 0xffa71e, 0xf69d1f, 0xf9a833, 0xffa834, 0xff9d22, 0xff9c21, 0xffa938, 0xfca63f, 0xf29725, 0xffa52e, 0xffa82c, 0xf69a1b, 0xffac37, 0xf2a648, 0xa96423, 0x834418, 0x7a2e0c, 0x5d1e00, 0xa9782b, 0xffd156, 0xfdb934, 0xfa9f2c, 0xffad35, 0xfda215, 0xfea92a, 0xffaf35, 0xf1a432, 0xc7821b, 0x9f6408, 0x875705, 0x765005, 0x694700, 0x95500b, 0x9d5817, 0xa05b20, 0x9a5923, 0x975926, 0x9a5d2e, 0x945a2c, 0x8a5223, 0xa56b2b, 0x99652b, 0x7d5323, 0x513414, 0x221505, 0x050505, 0x000814, 0x011023, 0x01000d, 0x010009, 0x1b141b, 0x231512, 0x352214, 0x553921, 0x583613, 0x6c461f, 0xb58226, 0xd7a238, 0xf3b73b, 0xf9b52c, 0xffb528, 0xffb332, 0xf79c29, 0xdb7b14, 0x523a0e, 0x221100, 0x030002, 0x7d838f, 0xf5ffff, 0xf3fdf5, 0xfffffa, 0xfffbff, 0xf7f7f7, 0xf9f9f9, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xfefefe, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xfdfdfd, 0xf9f9f9, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xfafeff, 0xf1f5f8, 0xfbffff, 0xfcfdff, 0xffffff, 0xfffffd, 0xc2c1bf, 0x14100d, 0x040000, 0x3d220d, 0x864b11, 0xca6f14, 0xfd921e, 0xffa525, 0xffa626, 0xfaa528, 0xffa32b, 0xffb13a, 0xffb13e, 0xfcae41, 0xefac44, 0xd8a041, 0xc1923a, 0xa67c26, 0x796c26, 0x6c5e21, 0x574618, 0x442f12, 0x3a2313, 0x381d14, 0x331713, 0x2c100c, 0x561f0b, 0x733415, 0xa35a27, 0xd47e33, 0xed8c2b, 0xf38e1c, 0xfe9717, 0xffa620, 0xf3ac36, 0xf5ae38, 0xfeb942, 0xffbb44, 0xe9a42d, 0xca850e, 0xc27d06, 0xcd8b13, 0xfbb829, 0xf5a721, 0xfb9821, 0xff9e33, 0xffa53c, 0xff9d2e, 0xf3a529, 0xffc03e, 0xc68a32, 0x9c5a1d, 0x843a13, 0x8e3e0d, 0xca7524, 0xffac3e, 0xffa835, 0xff9a2f, 0xffab29, 0xffa426, 0xffa32b, 0xff9f2d, 0xffa231, 0xffa533, 0xf9a531, 0xffb53d, 0xf7a130, 0xf39d2c, 0xf19a27, 0xfaa12d, 0xffa631, 0xfea128, 0xfd9e26, 0xffa229, 0xf49914, 0xffac32, 0xfaaf3c, 0xf9a531, 0xff9e26, 0xffa026, 0xff9d2b, 0xf89c35, 0xffaa34, 0xffa428, 0xfb9f20, 0xf9a126, 0xffb149, 0xd08331, 0x823c00, 0x924f1b, 0x8e4826, 0xe7a52d, 0xffd02b, 0xfbae2c, 0xe69931, 0xf7a42a, 0xffa624, 0xff992f, 0xffae3a, 0xf1a02d, 0xd38614, 0xbf7607, 0xcd8519, 0xeca53d, 0xfbb34d, 0xf8b04c, 0xff9e27, 0xffa72f, 0xffa630, 0xf79c29, 0xf59b2b, 0xf39c32, 0xde8823, 0xc06c0a, 0x522925, 0x48211c, 0x3b1910, 0x331709, 0x331e0b, 0x3b2c15, 0x423b1f, 0x484325, 0x6f5216, 0x8b6a27, 0xaf8539, 0xc69338, 0xdfa13a, 0xeda737, 0xf2a82f, 0xffbe40, 0xffb32e, 0xffab1d, 0xfda40c, 0xffa60f, 0xffab27, 0xf49e3b, 0xc27331, 0x94491f, 0x342e18, 0x030000, 0x0c101c, 0xc5d1dd, 0xf5ffff, 0xfbfffa, 0xfffffd, 0xfff7ff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf1f1f1, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0xf8f8f8, 0xfbffff, 0xf8fdff, 0xfcffff, 0xfbffff, 0xfeffff, 0xfcfcfc, 0xfffffd, 0x71706e, 0x000304, 0x120904, 0x482313, 0x914c2b, 0xca7135, 0xea882d, 0xfc9d27, 0xffb12c, 0xffa231, 0xff9926, 0xff9d27, 0xffa22a, 0xffa32d, 0xffa431, 0xffb345, 0xffb84c, 0xfcc340, 0xfdc346, 0xf9bd4b, 0xf3b54e, 0xedae4d, 0xe0a142, 0xc68a28, 0xae730f, 0x5a401f, 0x644117, 0x8e5d23, 0xcc8f3f, 0xf9b14f, 0xffb142, 0xf9a62e, 0xf6a226, 0xffa82a, 0xffa628, 0xfca323, 0xf7a31f, 0xfbaa25, 0xffb32c, 0xfcb22b, 0xf3ab23, 0xe8a61c, 0xfdb02e, 0xffa52c, 0xff9929, 0xff9f31, 0xff9d29, 0xfb991e, 0xfda220, 0xffb94f, 0xf6a951, 0xdb8d45, 0x954601, 0x944300, 0xeb9532, 0xffb043, 0xff9f30, 0xffad35, 0xfb9b22, 0xffa124, 0xffa126, 0xfea128, 0xfaa636, 0xe59b32, 0xdb9631, 0xfead41, 0xffad3f, 0xf39f2f, 0xf59e2b, 0xffa732, 0xffa42b, 0xffa027, 0xffa429, 0xfaaa31, 0xf9b240, 0xdb962e, 0xe09225, 0xffa028, 0xffa62b, 0xfa9521, 0xffa339, 0xfca025, 0xf49b1b, 0xf7a225, 0xffb848, 0xdf8b31, 0x954600, 0x9d5105, 0xc57d2b, 0xfabd40, 0xffb13f, 0xf79518, 0xf59b09, 0xffb92d, 0xf6a839, 0xf18f2e, 0xff9e35, 0xee9628, 0xfba534, 0xffaf3a, 0xfaaa31, 0xf6a329, 0xfea429, 0xffa52a, 0xffa226, 0xffa633, 0xffab36, 0xffa933, 0xfba62f, 0xffae3b, 0xf9a83d, 0xcf7f1c, 0x9f5000, 0x5c3a1f, 0x6d4925, 0x8f6332, 0xb8833f, 0xdda045, 0xf7b142, 0xffb538, 0xffb42e, 0xffc652, 0xffc850, 0xfcb134, 0xf9a221, 0xffa725, 0xffaa2a, 0xffa929, 0xffa427, 0xfb9b2b, 0xffa12b, 0xffa72c, 0xffa62e, 0xf49b33, 0xc27e33, 0x7a4e1f, 0x432408, 0x0c0d05, 0x000104, 0x89919e, 0xf7ffff, 0xf8fffd, 0xfbfff8, 0xfffeff, 0xfffaff, 0xffffff, 0xffffff, 0xf8f8fa, 0xffffff, 0xffffff, 0xffffff, 0xfdfdff, 0xf7f7f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xf8f8f8, 0xf2f2f2, 0xffffff, 0xffffff, 0xffffff, 0xf9ffff, 0xe5ecf2, 0xcfd4d8, 0xbec2c5, 0xbabbbd, 0xd5d6d8, 0xffffff, 0xdfdfdf, 0x040f11, 0x02050a, 0x1b1016, 0x4f302d, 0x804d30, 0xaa6426, 0xdc8826, 0xffac35, 0xffad3d, 0xf69f2b, 0xffa228, 0xffa225, 0xffa82c, 0xf99a22, 0xe38c19, 0xd68212, 0xdc7b0a, 0xe38211, 0xee8c1d, 0xfa9a29, 0xffa82f, 0xffb02c, 0xffb221, 0xffb019, 0xefcf56, 0xd4ae33, 0xc69515, 0xd99e1c, 0xf6b331, 0xffba3b, 0xfbb53c, 0xf7b23b, 0xfda51d, 0xffad28, 0xffab2d, 0xfba22c, 0xfba133, 0xffa843, 0xffa747, 0xf89d40, 0xfda42c, 0xf19820, 0xfa9d26, 0xffa32e, 0xff9d28, 0xff9d26, 0xffa22b, 0xff9e26, 0xffa635, 0xf19824, 0xffb645, 0xea9f3a, 0x934700, 0xa35300, 0xf6a039, 0xffaa33, 0xff9f36, 0xfa9926, 0xffa020, 0xffa71f, 0xf4a11f, 0xf1a535, 0xd49136, 0x975809, 0xe09327, 0xffb549, 0xffad3f, 0xf59f2e, 0xffa731, 0xffa52d, 0xffa328, 0xffa328, 0xffbb51, 0xc48422, 0xa66a0a, 0xde9630, 0xfca32f, 0xffa428, 0xff9c25, 0xffaa38, 0xf7a223, 0xfba828, 0xffb33a, 0xee9c38, 0xa85505, 0xa14e00, 0xe89835, 0xffbf49, 0xf8a717, 0xf99f27, 0xffa53a, 0xffa52d, 0xf39b15, 0xfea628, 0xffae3e, 0xf99c32, 0xffa735, 0xffa32f, 0xf59f26, 0xf3a124, 0xfba92c, 0xffad30, 0xffa62a, 0xff9c22, 0xfca82c, 0xfca929, 0xf8aa24, 0xf9ad26, 0xfeb532, 0xfcb43b, 0xe59d2f, 0xc8801a, 0xf7bb25, 0xffbe2c, 0xffbf34, 0xffb635, 0xffa72f, 0xff9526, 0xff8a21, 0xfe841f, 0xc97b33, 0xcd7a2a, 0xd87d20, 0xf08e21, 0xff9f27, 0xffa425, 0xffa625, 0xfca321, 0xf7a63b, 0xffad43, 0xffa541, 0xe7882e, 0xb66722, 0x7a4a1a, 0x39290f, 0x0a0e00, 0x0d0e09, 0x1f2025, 0xd4d8e3, 0xeff7fa, 0xced8cd, 0xbdc3b9, 0xbdbcc2, 0xd1c9e0, 0xf6f5fa, 0xfdfcff, 0xfdfcff, 0xfffeff, 0xfffeff, 0xedecf1, 0xf4f3f8, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xf6f6f6, 0x7e7e7e, 0x262626, 0x333333, 0x444444, 0x484848, 0x2a3137, 0x161d23, 0x000307, 0x000105, 0x020609, 0x323335, 0x464646, 0x545454, 0x000406, 0x00080e, 0x020b12, 0x12110f, 0x3c2810, 0x794a16, 0xad620f, 0xc26903, 0xd6aa27, 0xecb831, 0xfcba30, 0xeea316, 0xfcaa22, 0xfead2a, 0xf2a32a, 0xe99e29, 0xbf6c20, 0xb5611b, 0xa85418, 0x9d4a18, 0x964216, 0x954218, 0x9f4e23, 0xac5b2e, 0xc06316, 0xca6918, 0xdb761c, 0xe6801e, 0xe47f17, 0xde7d12, 0xe3881d, 0xee982b, 0xec9f33, 0xf5a738, 0xffb13c, 0xffb539, 0xffb12e, 0xffab21, 0xffab1c, 0xffad1a, 0xff9c27, 0xffa330, 0xffa434, 0xfaa032, 0xf8a032, 0xfea432, 0xffa52c, 0xffa429, 0xff9c24, 0xffae28, 0xf09f12, 0xffbb40, 0xeca345, 0x994d00, 0xb36400, 0xffb035, 0xfb983a, 0xffa234, 0xfea11e, 0xffaa1c, 0xf5a71f, 0xfdb747, 0xebad5a, 0x874d0d, 0x9b5100, 0xea9d31, 0xffaf43, 0xf59f2e, 0xfea531, 0xffa62e, 0xffa227, 0xff9b1f, 0xeeac4c, 0x7c4300, 0x885200, 0xfbb958, 0xffab37, 0xff9f22, 0xffa42a, 0xf8a12d, 0xfaab2a, 0xfaad2d, 0xfeb13d, 0xb46509, 0x994500, 0xe69140, 0xffb240, 0xf7a515, 0xff9f2b, 0xffa52a, 0xfdaa34, 0xffa43b, 0xff9b30, 0xffa226, 0xffab25, 0xebab27, 0xff9c24, 0xff9f26, 0xffa52a, 0xfcae32, 0xfbb138, 0xfbb03b, 0xffae3e, 0xffaf42, 0xff9b39, 0xfc9933, 0xf49426, 0xe88d1b, 0xdf8419, 0xd9811f, 0xdb832c, 0xde873a, 0xc96d22, 0xbd651b, 0xae5a12, 0xa1520d, 0x9a510d, 0x985415, 0x98581a, 0x97591c, 0xaf6b00, 0xbc7304, 0xe8951f, 0xffa72f, 0xfaa129, 0xf19d2b, 0xefa236, 0xf8b04a, 0xf7bf38, 0xe4a023, 0xce7d14, 0xb25f13, 0x803c0d, 0x401908, 0x130e14, 0x041527, 0x0a0905, 0x000004, 0x3c3c46, 0x464a49, 0x242a1e, 0x020500, 0x000007, 0x0f0925, 0x19181d, 0x38373c, 0x4a494e, 0x4a494e, 0x2f2e33, 0x2c2b30, 0x8c8b90, 0xfdfcff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xfbfbfb, 0xffffff, 0xf6f6f6, 0xfdfaff, 0xfefcff, 0xbabcd5, 0x0b0a1c, 0x070000, 0x462b18, 0x562c00, 0x613000, 0x572a15, 0x6f4219, 0x95631e, 0xb8801f, 0xd3921e, 0xdd9117, 0xd48006, 0xc56a00, 0x9b6a2f, 0x603f20, 0x1d1017, 0x00001c, 0x00001c, 0x291612, 0x6a3e11, 0xa1631a, 0xb05506, 0xc66d1b, 0xea9538, 0xffaf39, 0xfdb120, 0xffaf1c, 0xffaa2f, 0xffa03a, 0xffaf37, 0xfea12a, 0xfaa12b, 0xf09c2c, 0xdc8a27, 0xc77424, 0xae5919, 0x9f4813, 0x923b1f, 0x8a3315, 0x923a16, 0x994217, 0x96400d, 0x984408, 0x9f4b0b, 0x9e4906, 0xc75b03, 0xc56417, 0xc67534, 0xc37e45, 0xb37538, 0xaf6f25, 0xcd862a, 0xf4a73f, 0xf7ad42, 0xfdb044, 0xfcab3f, 0xf59f2e, 0xf89f2b, 0xffa62e, 0xffa72c, 0xff9e22, 0xffa530, 0xffa42c, 0xffa42c, 0xfa9521, 0xffb64f, 0xd08834, 0x653200, 0xa77f4c, 0xfcca43, 0xffa400, 0xff9a28, 0xff9e53, 0xf9aa2b, 0xffa506, 0xffaa30, 0xf2aa44, 0x290b0b, 0x97793d, 0xffbc3c, 0xff9f09, 0xffb133, 0xf09a2b, 0xffa620, 0xffbb1b, 0x7e6f58, 0x410e00, 0xeab227, 0xf8bc28, 0xf2993f, 0xff982b, 0xff972f, 0xfc9634, 0xfaa018, 0xffc73b, 0xa97c43, 0x5e2907, 0xe8a32a, 0xffad2d, 0xfe923a, 0xffa123, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffb718, 0xfcab1e, 0xf3a131, 0xd78a32, 0xb66d20, 0xb97625, 0xc78c30, 0xbf8821, 0xc06c16, 0xb45f0f, 0xa4500a, 0x98460e, 0x944318, 0x924124, 0x8f3e2b, 0x8a3b2e, 0x8e2c2d, 0x882c15, 0x994312, 0xac5818, 0xc26e26, 0xd98731, 0xe49828, 0xf2ad24, 0xf9b44c, 0xf0ab34, 0xf7b024, 0xffb41b, 0xffb019, 0xffb632, 0xffb144, 0xed9438, 0xe06529, 0xb8591f, 0x885422, 0x5a4c27, 0x232814, 0x000100, 0x07000c, 0x260e28, 0x70460c, 0x95601a, 0xba791d, 0xcf8216, 0xdd8d1e, 0xdb8f2d, 0xbd7a29, 0x975c16, 0x694922, 0x492b00, 0x533900, 0x4d3600, 0x463200, 0x100400, 0x18130d, 0xd5d7d4, 0xfffcfa, 0xfefdff, 0xeffbff, 0xf4fff6, 0xfffff6, 0xfff7ff, 0xfffcff, 0xfbfffa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcff, 0x655b64, 0x1f0e04, 0x523b09, 0xcaa652, 0xf9c764, 0xf8b655, 0xfdb354, 0xf8ba35, 0xfec039, 0xffc036, 0xfcb92d, 0xf9b127, 0xfab02b, 0xfdb030, 0xfcac2f, 0xffc22c, 0xeeb436, 0xba953c, 0x76602f, 0x322012, 0x170007, 0x30041b, 0x561f3c, 0xa65d3d, 0x954917, 0xa35108, 0xcf7423, 0xeb8c38, 0xf29535, 0xf9a52b, 0xffb827, 0xf4a32e, 0xffb53c, 0xffb737, 0xffbe3b, 0xffbd37, 0xffaa29, 0xffa024, 0xff921b, 0xd97e23, 0xc56c12, 0xb66009, 0xad5b09, 0xa25507, 0xa35910, 0xa45e18, 0x9e5813, 0x745236, 0x523620, 0x2d1709, 0x1a0700, 0x190500, 0x290d00, 0x47210a, 0x613415, 0xad6000, 0xd4861a, 0xfaa83a, 0xffab3a, 0xfba22c, 0xfb9c24, 0xfe9e23, 0xff9e23, 0xf69b28, 0xffa12b, 0xffa32b, 0xf8931d, 0xfda335, 0xfbb254, 0xac7427, 0x4e2200, 0xc1953e, 0xffc234, 0xffa222, 0xf39636, 0xffb33a, 0xff9a16, 0xffa22a, 0xfabb3a, 0x744b2d, 0x533405, 0xecaf3c, 0xffad18, 0xf29f27, 0xffa62e, 0xffa21a, 0xf4b23a, 0x3c2517, 0x824c1d, 0xfab939, 0xeaa61f, 0xf9a137, 0xffa330, 0xff9825, 0xffa733, 0xffbe37, 0xbd8437, 0x613302, 0xb37f29, 0xffb639, 0xf99525, 0xffa540, 0xfea429, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xbf913c, 0x8d611a, 0x663a0b, 0x481e06, 0x280200, 0x210000, 0x2a0d09, 0x290e07, 0x6e2b18, 0x844127, 0x9d5733, 0xa85e2d, 0xa65818, 0xa25306, 0xab5903, 0xb56206, 0xca7405, 0xda8609, 0xef9c12, 0xf6a019, 0xffaf34, 0xffba41, 0xffac29, 0xffad1b, 0xfa9e21, 0xffb138, 0xffad39, 0xffa034, 0xf99b37, 0xde8326, 0xba6008, 0xab5500, 0x945603, 0x804c1a, 0x502b23, 0x180017, 0x0b000c, 0x372010, 0x896728, 0xc29a38, 0xe9b93b, 0xf9be46, 0xffb848, 0xffa73b, 0xfda132, 0xffad35, 0xffbc3a, 0xffc239, 0xffb94a, 0xfeb74b, 0xfab848, 0xedb23e, 0xf1c153, 0xc49e53, 0x4f2e1b, 0x14000b, 0x948679, 0xebe8f3, 0xf7ffff, 0xf8fffb, 0xfffff6, 0xfbeff9, 0xfffcff, 0xfbfffb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xf5f5f5, 0x443a43, 0x2c1900, 0x835d08, 0xecb139, 0xffbb32, 0xef9c10, 0xfca61f, 0xffae2f, 0xffa61f, 0xffa522, 0xffa125, 0xf99f27, 0xfaa42d, 0xfdaa32, 0xf9a92e, 0xf1a325, 0xff9a08, 0xffa816, 0xffb82d, 0xf8bc42, 0xcda045, 0x8a6531, 0x431f11, 0x160000, 0x2a071b, 0x693e35, 0x9b6036, 0x9c5012, 0x9c4502, 0xb85d17, 0xcd7722, 0xcc7c19, 0xe5942b, 0xf6a93f, 0xd38f24, 0xcf9026, 0xe8ae42, 0xf4b54b, 0xfcb94e, 0xf7b046, 0xffc74e, 0xefb746, 0xdaa643, 0xbd8c3f, 0x986931, 0x754926, 0x572e1a, 0x41190f, 0x270e14, 0x270d0e, 0x34160c, 0x523017, 0x7c5029, 0x9e6b34, 0xb27534, 0xb9762f, 0xbb6a00, 0xdc8a1c, 0xfba737, 0xffa936, 0xfa9f2a, 0xfa9d24, 0xffa027, 0xffa227, 0xfca12f, 0xffa22e, 0xff9e26, 0xffa328, 0xf09721, 0xffb548, 0xf3b755, 0x774600, 0x472809, 0xd8a23e, 0xffba36, 0xec981c, 0xffa42e, 0xff9f32, 0xffa42f, 0xf6bd25, 0xbc893a, 0x290a00, 0xbb9236, 0xfdb626, 0xef992a, 0xffad2a, 0xfba81a, 0xb38a4c, 0x220000, 0xce9337, 0xffb441, 0xf29f27, 0xffa324, 0xff9e28, 0xffa321, 0xffbb3a, 0xcda738, 0x49170c, 0x7e4b1c, 0xf4bc31, 0xffae2f, 0xffa23a, 0xfb9d23, 0xffac37, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xc98c31, 0xb27620, 0xb0762d, 0xb57c45, 0xa16b45, 0x814d37, 0x5b291e, 0x370601, 0x180c0e, 0x281612, 0x412414, 0x5f3414, 0x824818, 0xae6425, 0xd9853c, 0xf59c4a, 0xe9bc3d, 0xf9c53e, 0xfcc336, 0xeeaf2c, 0xf5b343, 0xf1ac45, 0xdd9026, 0xec9b26, 0xffa434, 0xf2851e, 0xda7219, 0xc96821, 0xb45920, 0xa85624, 0xa3562a, 0x964d22, 0x4f3d2f, 0x281507, 0x140000, 0x412205, 0x996e39, 0xe2aa55, 0xfeb944, 0xfdb128, 0xf5b031, 0xf7aa2a, 0xfaa11f, 0xfe9b19, 0xff9c18, 0xffa11b, 0xfba41f, 0xf4a620, 0xff9a15, 0xff9e21, 0xff9f25, 0xffa220, 0xffac25, 0xffbc40, 0xda9f41, 0x8e5714, 0x1b0400, 0x6f6564, 0xecf2ff, 0xf8fffd, 0xfffff4, 0xfff8fd, 0xfffcff, 0xfafffc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xfcfcfc, 0xfcfcfc, 0xfcfcfc, 0xaeaeae, 0x0e0000, 0x8e6f1d, 0xf8c22a, 0xffbc26, 0xff9726, 0xf18c22, 0xfdaa28, 0xf4b118, 0xff9a31, 0xff9c33, 0xff9b32, 0xfe992f, 0xff9d30, 0xffa335, 0xffa534, 0xffa130, 0xffa041, 0xff9b2d, 0xff9a1a, 0xffa817, 0xffbe2d, 0xfac13e, 0xcca435, 0xa08220, 0x191400, 0x100300, 0x281006, 0x5d3825, 0x83512c, 0x945424, 0xa1542a, 0xaa5536, 0xb6560a, 0xb2621d, 0x773b05, 0x3a1700, 0x3d2d14, 0x4a4434, 0x3f3f33, 0x3e4035, 0x453b17, 0x3f3212, 0x37290e, 0x2e1f0c, 0x201003, 0x1b0804, 0x230f11, 0x2e191e, 0x6c2c00, 0x914c13, 0xbf7325, 0xe5912e, 0xffa32f, 0xffac2b, 0xffaa24, 0xffa31c, 0xfea837, 0xffab3a, 0xffa835, 0xfaa12d, 0xf99e29, 0xffa32a, 0xffa42c, 0xffa128, 0xffa836, 0xffa733, 0xfc9c23, 0xffac2e, 0xf8a022, 0xeb9c23, 0xffc04b, 0xe9ad3b, 0x120000, 0x66450f, 0xedb850, 0xffb732, 0xfb9817, 0xffa539, 0xfca32d, 0xeeb619, 0xe3a737, 0x381b0b, 0x876b22, 0xefb428, 0xfba339, 0xffa91d, 0xffb825, 0x664c3b, 0x401b09, 0xf1b72f, 0xfba02d, 0xffa73b, 0xff9f15, 0xfe951f, 0xffb339, 0xe9b746, 0x53420c, 0x280000, 0xe4ad6a, 0xffbb27, 0xf6981a, 0xffb038, 0xf09a0f, 0xf8a73c, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa41d, 0xffa41d, 0xffb028, 0xffb631, 0xffb136, 0xffab42, 0xed953c, 0xcb7425, 0x884c32, 0x6c341b, 0x441600, 0x280500, 0x1f0800, 0x24180a, 0x2b271c, 0x2d2f24, 0x403927, 0x4b3a1e, 0x533914, 0x543813, 0x573f23, 0x422a0e, 0x3b1900, 0x6c4210, 0xc66224, 0xaf5314, 0xa75919, 0x995820, 0x7f4a20, 0x7e5039, 0x673b3a, 0x2c010b, 0x0a000b, 0x3e2717, 0x95732c, 0xe1ae38, 0xffbe2d, 0xffaf1d, 0xffa220, 0xffa32e, 0xfca43a, 0xffa032, 0xff9f2b, 0xffa129, 0xffa42c, 0xffa42e, 0xffa231, 0xfda134, 0xff9a1d, 0xffa424, 0xffb339, 0xffa538, 0xe98523, 0xeb9423, 0xffbf2c, 0xffd221, 0x6c4c0f, 0x1c0a00, 0xc1c0ce, 0xf8ffff, 0xf3f5e8, 0xfffdfd, 0xfefbff, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xffffff, 0xf4f4f4, 0xffffff, 0xffffff, 0x575757, 0x1e0000, 0xcda33d, 0xffc61f, 0xffa419, 0xfd933b, 0xca6d1d, 0xb06d12, 0xd1a041, 0xfdb431, 0xffb72c, 0xffb31f, 0xfcab14, 0xffa715, 0xffa925, 0xffa632, 0xffa237, 0xed9d24, 0xffa82c, 0xffaa2a, 0xff9f1a, 0xf5970f, 0xf7a31d, 0xfcb632, 0xfec23e, 0xe2c440, 0x7e6513, 0x211000, 0x040012, 0x150d24, 0x3c2a2a, 0x5a3a23, 0x643916, 0x944620, 0x925237, 0x7a4f46, 0x200d13, 0x01000c, 0x101221, 0x000009, 0x08070c, 0x0c0019, 0x0d0011, 0x1b060b, 0x381a0f, 0x573311, 0x744916, 0x976624, 0xb68038, 0xd99820, 0xf0ab2c, 0xffb52f, 0xffae26, 0xffa621, 0xffa42a, 0xffa435, 0xfea23d, 0xffaa36, 0xffaa34, 0xffa631, 0xfda22d, 0xffa22b, 0xffa52e, 0xffa32a, 0xfc9d25, 0xfda22f, 0xffa632, 0xffa228, 0xffa528, 0xffa828, 0xf4a121, 0xf3a829, 0xffbc3e, 0x604929, 0x200900, 0x96713c, 0xffc74a, 0xffa817, 0xff9c22, 0xf7a128, 0xf4b228, 0xf7be4d, 0x412519, 0x6d5112, 0xefb52f, 0xffa940, 0xffa012, 0xffbf2f, 0x452d23, 0x503218, 0xf7c228, 0xf79b1e, 0xffa63b, 0xff9f18, 0xff9e2a, 0xf7b046, 0x98732d, 0x080000, 0x826233, 0xffc760, 0xffa832, 0xfa951f, 0xffa413, 0xfeac1c, 0xef9d37, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa536, 0xffa32e, 0xfea11e, 0xf69c12, 0xf19b10, 0xfda827, 0xffb13d, 0xffa93f, 0xf59d43, 0xe2903c, 0xbf7b34, 0x96612b, 0x6c4824, 0x45301d, 0x231a15, 0x0f0d0e, 0x0c0015, 0x150008, 0x1d0000, 0x1f0207, 0x160a16, 0x07010d, 0x231419, 0x6c4f4b, 0x8e5738, 0x7b4c2e, 0x5e3c20, 0x4a361d, 0x342917, 0x0f0500, 0x080000, 0x211215, 0x997021, 0xd39d45, 0xffbb53, 0xffab35, 0xfa9917, 0xfe9e16, 0xffa61e, 0xf8a41d, 0xf6a317, 0xffa729, 0xffa93d, 0xffa244, 0xfc9b3c, 0xf79a30, 0xfaa528, 0xfeae25, 0xfcc14d, 0xeeaf3b, 0xdd942b, 0xb8640e, 0xcc7226, 0xf9a449, 0xf9ac2c, 0xfcb616, 0xdbb256, 0x160000, 0x827b8b, 0xf9ffff, 0xf8fef0, 0xfffff8, 0xfffeff, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfdfdfd, 0xffffff, 0xf7f7f7, 0xffffff, 0xf3f3f3, 0x1b1b1b, 0x481700, 0xe8b24e, 0xf6b126, 0xf19824, 0xffba58, 0xe79934, 0x7c3f00, 0x612a23, 0x925f06, 0xc18d27, 0xf2bc42, 0xffc63c, 0xf7b628, 0xeda31e, 0xf09d27, 0xf59f32, 0xe4b736, 0xf0ba40, 0xfab647, 0xfeac46, 0xffa640, 0xffa538, 0xfea12a, 0xf39a1c, 0xffad26, 0xffbe46, 0xc8a04b, 0x544725, 0x000007, 0x000112, 0x0a150f, 0x0e1700, 0x2a0c01, 0x2e1511, 0x48383b, 0x27181b, 0x2d170c, 0x7c5632, 0x9e6327, 0xaf681a, 0x9f6c2a, 0xa56c27, 0xb27022, 0xcc802a, 0xee9634, 0xff9d30, 0xff9c28, 0xffa229, 0xf9b339, 0xfdb235, 0xfcaa2a, 0xf9a221, 0xfaa226, 0xfca836, 0xf4a73f, 0xeba140, 0xf99a22, 0xfd9e26, 0xffa229, 0xffa32a, 0xffa32c, 0xffa32c, 0xffa32c, 0xffa32c, 0xfba129, 0xf89e26, 0xffab31, 0xffa52a, 0xfda328, 0xffaa2e, 0xfba327, 0xffac2f, 0xc09a4f, 0x210b0e, 0x2c1507, 0xdca330, 0xffb218, 0xfd9613, 0xffac33, 0xf9aa33, 0xe6b765, 0x2c1100, 0x825917, 0xfcb738, 0xf7a535, 0xfda118, 0xffb62d, 0x6f451d, 0x3a2b16, 0xe4b738, 0xffb228, 0xfd9b2e, 0xff9f28, 0xffad2f, 0xd09434, 0x2c1200, 0x200e1c, 0xd7b355, 0xf6ab2b, 0xff9b3f, 0xff9a2b, 0xffaa15, 0xf4a218, 0xfca838, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xff9e43, 0xfc9c38, 0xffa332, 0xffaf31, 0xffaf2c, 0xfda625, 0xf8a326, 0xf9a32c, 0xf6b02c, 0xf5ae2e, 0xf7ad34, 0xf9a83c, 0xf6a03d, 0xea9038, 0xd97c2c, 0xce6e22, 0xa16e2d, 0xad6928, 0xb16529, 0x9e6135, 0x5f4129, 0x291a13, 0x331e1d, 0x522c2b, 0x302207, 0x221b0b, 0x141215, 0x0a0c18, 0x010206, 0x0f0a00, 0x5c4e1d, 0xb9a661, 0xffb829, 0xffb52e, 0xffa92e, 0xff9a29, 0xff9b2f, 0xffad40, 0xfcb849, 0xf0b945, 0xffbd3c, 0xf2ae2f, 0xe4a023, 0xe3a126, 0xeeae33, 0xf5b73e, 0xf3b73d, 0xeeb439, 0xa68244, 0x885b24, 0x743b04, 0x7f3d00, 0xd48d25, 0xffbe45, 0xeda02c, 0xfaad43, 0xe2af39, 0x270400, 0x352a3a, 0xf1f8ff, 0xfbfff4, 0xfbfbef, 0xffffff, 0xf7fbfe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xc9c9c9, 0x030303, 0x885013, 0xfcc352, 0xf2ac33, 0xc76f18, 0xe48930, 0xffc049, 0xd58b34, 0x914337, 0x4b1606, 0x4b1800, 0x5b2a00, 0x86581d, 0xba8e47, 0xcea257, 0xb2863b, 0x8b5f16, 0x8a6224, 0x835a1c, 0x865918, 0xa56f27, 0xd59440, 0xfbae46, 0xffac31, 0xfb9f1a, 0xff8f29, 0xffa32b, 0xffb734, 0xe8b13d, 0x927229, 0x251a00, 0x000202, 0x091a24, 0x181911, 0x0b0f0e, 0x171c22, 0x171216, 0x220800, 0x814c18, 0xd6822a, 0xca6200, 0xffaf21, 0xffb82d, 0xffb22a, 0xffa521, 0xffa525, 0xffa629, 0xffa428, 0xffa62d, 0xfda43c, 0xfda036, 0xfe9c2d, 0xff9d27, 0xffa327, 0xffa728, 0xffa624, 0xf7a01d, 0xffa429, 0xffa328, 0xffa128, 0xffa028, 0xfea128, 0xffa32c, 0xffa530, 0xffa631, 0xffa52a, 0xf89e24, 0xffa72f, 0xffa933, 0xfa9f2a, 0xffa22e, 0xffa833, 0xffad35, 0xe8ac3c, 0x36191e, 0x120203, 0xc29021, 0xffaf1c, 0xfe9a22, 0xffb23e, 0xffa630, 0x8c6c45, 0x280d00, 0xbd8234, 0xffb137, 0xefa52c, 0xfdac29, 0xffa927, 0xbf7d26, 0x1a191f, 0x9e7533, 0xffbe31, 0xfd9f2e, 0xff9c3a, 0xffb01f, 0xc38f2c, 0x0d0000, 0x4a2f1c, 0xe9b64b, 0xffa41f, 0xff9731, 0xff9d34, 0xffaf34, 0xeb971a, 0xffaf2a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa233, 0xff9c2a, 0xff9c24, 0xffa122, 0xffa01d, 0xfb9a15, 0xfd9c19, 0xffa421, 0xffa52f, 0xff9f26, 0xff9b1f, 0xff9f1d, 0xffa822, 0xffb024, 0xffb022, 0xffad1c, 0xffbb41, 0xf69824, 0xe2811a, 0xc1792d, 0x5b4011, 0x100f00, 0x1e1913, 0x25100f, 0x0c0900, 0x1f1f1f, 0x1d1b26, 0x030005, 0x221100, 0x926e32, 0xebb64c, 0xfbbb35, 0xffa830, 0xfa9e21, 0xffa322, 0xffb335, 0xfbae3c, 0xc98c2f, 0x966c24, 0x7c5c23, 0x8a511c, 0x85500a, 0x916506, 0xb28c1f, 0xc2a034, 0xac8830, 0x80581b, 0x5f3409, 0x451300, 0x551c01, 0x834016, 0xd98f44, 0xffc355, 0xe89a1c, 0xcd7d0a, 0xf9a743, 0xf6bd30, 0x724915, 0x0e0011, 0xc9cfdb, 0xf7fff2, 0xf6f9e8, 0xfffffd, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfefefe, 0xfafafa, 0xffffff, 0xfbfbfb, 0x9e9e9e, 0x000000, 0xaf761f, 0xedb52e, 0xf3ae2f, 0xc2682a, 0x9d3a03, 0xdd8114, 0xf2981e, 0xcf701c, 0xa16b49, 0x895639, 0x61331c, 0x3c1504, 0x2e1005, 0x382215, 0x463629, 0x4d4133, 0x613029, 0x693e2d, 0x724e2c, 0x7a571f, 0x895e0f, 0xac730c, 0xdb931d, 0xffad2e, 0xffaa2e, 0xffa42c, 0xff9c23, 0xffae32, 0xffb949, 0xad792e, 0x3b2412, 0x0b051f, 0x1c1f0e, 0x111a15, 0x0c1a25, 0x152034, 0x040008, 0x4f2e1f, 0xc4875a, 0x9e4f0c, 0xc76409, 0xf79637, 0xffb34e, 0xffaf3f, 0xf6aa32, 0xefaa28, 0xe8a820, 0xe8ab1d, 0xf1a126, 0xf8a32c, 0xffa430, 0xffa232, 0xff9d2e, 0xff9b2a, 0xff9f2d, 0xffa432, 0xffa428, 0xffa429, 0xffa328, 0xffa229, 0xffa22a, 0xfea12a, 0xfba02b, 0xfca12c, 0xfea223, 0xffa92e, 0xf69d25, 0xfca32f, 0xffa533, 0xfe9e2e, 0xffa233, 0xff9928, 0xf4a929, 0x391718, 0x362b29, 0xddb241, 0xffb52e, 0xff9c34, 0xffa636, 0xffab30, 0x261209, 0x3d2400, 0xf1a750, 0xffa62e, 0xf1ac2d, 0xfdb336, 0xffa227, 0xfaa72d, 0x030c2b, 0x492211, 0xf7b227, 0xffad3b, 0xfe9a42, 0xfbac09, 0xd5a63a, 0x2c1d24, 0x452500, 0xe8a846, 0xffad2d, 0xff9d21, 0xffa43f, 0xf19a3b, 0xffad38, 0xfca20d, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xf5a12d, 0xffac38, 0xffad3c, 0xfba534, 0xf8a231, 0xfca635, 0xfea837, 0xfda834, 0xf79e2a, 0xfba52e, 0xffaa33, 0xfea932, 0xfaa52e, 0xf8a52b, 0xfaaa2f, 0xffaf34, 0xf4aa49, 0xc66b10, 0xaf5405, 0xa36b32, 0x3c381b, 0x000a04, 0x06252a, 0x0e1c27, 0x22162c, 0x241929, 0x0d0101, 0x301c01, 0xa77f41, 0xffbb56, 0xffaf27, 0xff9d01, 0xf09b31, 0xfda83d, 0xf9a73b, 0xd78e27, 0xac7115, 0x8a6014, 0x73591e, 0x665625, 0x72413c, 0x62362b, 0x573220, 0x4e2f1a, 0x3c200b, 0x2c1005, 0x391b1b, 0x54333c, 0x9a531b, 0xb76d26, 0xc3731e, 0xef9441, 0xde7d36, 0x9c3b00, 0xbd610e, 0xffa846, 0xfcbf28, 0x906328, 0x0a000b, 0xb1b7c5, 0xf3feee, 0xfefff1, 0xfbfbf9, 0xfafdff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfff4, 0xf9ffff, 0xfcfaff, 0xfff8f7, 0xfffff8, 0xf1ffff, 0x42474b, 0x140000, 0xeb9236, 0xffae1e, 0xffac15, 0xbe620b, 0x923315, 0xa44e35, 0x974b31, 0x661e10, 0x5a2600, 0x653713, 0x6a4528, 0x563d29, 0x2e2118, 0x0c0c0c, 0x000710, 0x000b16, 0x1e1818, 0x191816, 0x2a2a20, 0x534d33, 0x826b37, 0xab7d28, 0xd89021, 0xfba421, 0xf4a225, 0xfda520, 0xffac17, 0xfb9b22, 0xffa957, 0xe5a740, 0xb3902a, 0x1f0300, 0x08150c, 0x1e2424, 0x0b1023, 0x09173e, 0x001636, 0x020c03, 0x745819, 0xf9bb58, 0x96430f, 0xa85626, 0xce8139, 0xeca62d, 0xf1ad1e, 0xfaab28, 0xffb433, 0xffb92c, 0xffb738, 0xffb232, 0xffb432, 0xffb12c, 0xf7ad28, 0xfab52c, 0xffb627, 0xffaa17, 0xf7b12b, 0xfba826, 0xff9d21, 0xff9f28, 0xff9726, 0xffa131, 0xffa332, 0xfba12f, 0xffa22a, 0xf89b22, 0xffaa2e, 0xfeab2b, 0xf3a21f, 0xfaa727, 0xffa92e, 0xffab35, 0xe99c34, 0x1b1700, 0x867036, 0xffb73d, 0xf49521, 0xffae21, 0xffbf41, 0x6e5046, 0x160000, 0xb58b51, 0xf2b538, 0xfaa612, 0xffa728, 0xfd982e, 0xfda632, 0xffbb31, 0xa16a0f, 0x090013, 0x736c42, 0xffc834, 0xff8d1c, 0xffa730, 0xf3ca3a, 0x7d570e, 0x3e2700, 0xddad4b, 0xfaa922, 0xffa024, 0xffa033, 0xfba52e, 0xfca929, 0xfaa429, 0xff9a32, 0xff9c26, 0xfba423, 0xfeb034, 0xf9a739, 0xfb9e37, 0xffa134, 0xff9820, 0xff9b1b, 0xffa92e, 0xffb03c, 0xf9a334, 0xffae3c, 0xffa729, 0xffb92e, 0xffb21b, 0xffac19, 0xffb50b, 0xf8bf16, 0xf1c339, 0xe9bf46, 0xe2b234, 0xe0a32e, 0xe19839, 0xa0462c, 0xa03e00, 0xf59c28, 0x895100, 0x0b0004, 0x121e50, 0x011222, 0x161c10, 0x041e3f, 0x060011, 0x390a00, 0xc88326, 0xffc339, 0xffb027, 0xfd9c29, 0xff9b37, 0xff9a2d, 0xff962c, 0xfda541, 0xd5943a, 0x9d762b, 0x7e6b33, 0x53512a, 0x272e0f, 0x181818, 0x101519, 0x04111a, 0x000e19, 0x0d1216, 0x2f2219, 0x593b23, 0x784d2b, 0x54373b, 0x4d250c, 0x6b3100, 0x9e5119, 0xa44c1e, 0x923a08, 0xb26517, 0xecac40, 0xffae2e, 0xd2903a, 0x120000, 0x52677c, 0xedffff, 0xfffbff, 0xfff6ff, 0xfcfdeb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffff6, 0xf8ffff, 0xfffdff, 0xfffbfa, 0xfffff8, 0xd8eaec, 0x1e2223, 0x311309, 0xeca144, 0xffba34, 0xfdb82d, 0xc1751f, 0x8b4114, 0x975823, 0xa06e29, 0x885b18, 0x5d3617, 0x543115, 0x422610, 0x2c190a, 0x1a110a, 0x121212, 0x12191f, 0x17212a, 0x161118, 0x18171d, 0x121315, 0x080500, 0x1c0d00, 0x63400a, 0xc48c3f, 0xffc568, 0xfbb241, 0xf7a42c, 0xffae1f, 0xff991b, 0xff9e40, 0xffae39, 0xf3b840, 0x986226, 0x00001e, 0x130d00, 0x422c03, 0x2c1908, 0x120d21, 0x080518, 0x1e0b00, 0x8c6637, 0xf9c13a, 0x9f5e00, 0x833706, 0x97493d, 0x874829, 0x744f08, 0x79691e, 0x756d3f, 0xa17b28, 0xae8130, 0xbc8834, 0xbe872a, 0xc6922c, 0xc99a30, 0xc99c37, 0xe4b658, 0xeba246, 0xffb74f, 0xffb83e, 0xffb72e, 0xffac22, 0xfca323, 0xf39b2d, 0xffab49, 0xffa43a, 0xff9d30, 0xf99b2a, 0xfda430, 0xffac35, 0xf6a12a, 0xf19b22, 0xffae33, 0xf69e32, 0x4e3813, 0xa98642, 0xffb02e, 0xfba127, 0xfdb837, 0xc28d25, 0x290f0e, 0x4b2109, 0xcf9b50, 0xf7b233, 0xfba115, 0xffa52e, 0xff9b33, 0xfda730, 0xfdb427, 0xde9d35, 0x29120c, 0x251c00, 0xd6992e, 0xffb13f, 0xf7a223, 0xeab831, 0xaa7724, 0x533104, 0xe5af4b, 0xffad27, 0xffa128, 0xff9c30, 0xfa9f2a, 0xfaa526, 0xfaa129, 0xff9f31, 0xffa53a, 0xffa63b, 0xff9f2e, 0xf69a1d, 0xffa823, 0xffbb32, 0xffb32b, 0xf8bb3e, 0xeeb63d, 0xdda939, 0xd29c38, 0xd0973e, 0xc08835, 0xb98935, 0xa88029, 0xc2952e, 0xab7841, 0x945e44, 0x8c572f, 0x89501b, 0x874316, 0x8d3b16, 0x943d12, 0xc06a00, 0xffcb57, 0x78642f, 0x030708, 0x0a1413, 0x140e1c, 0x31182e, 0x41220d, 0x00031d, 0x25110a, 0x895617, 0xf1a93a, 0xffb02d, 0xf8a428, 0xffa331, 0xffa334, 0xf59d18, 0xffb83d, 0xfebb53, 0xba8738, 0x5e3c0c, 0x1b0900, 0x080206, 0x17182a, 0x201b17, 0x1b1b1b, 0x111a21, 0x09161f, 0x0c1115, 0x1b140e, 0x321b09, 0x452308, 0x442508, 0x5e3c0f, 0x875c25, 0x9b6332, 0x8c4821, 0x8f4613, 0xc07823, 0xf2af3a, 0xffac2a, 0xf1a849, 0x280700, 0x2a3748, 0xe0f6f3, 0xfffbff, 0xfff5ff, 0xfefff3, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffff6, 0xf6fdff, 0xfefeff, 0xfff9f7, 0xfffffa, 0xb4c6ca, 0x020200, 0x55321e, 0xe9a92d, 0xf4b824, 0xfabd31, 0xd59239, 0x8b4917, 0x622c00, 0x633907, 0x603b0e, 0x675445, 0x544234, 0x3a2c21, 0x261d16, 0x1d1916, 0x1b1b1b, 0x181c1f, 0x161b1f, 0x1d1a25, 0x12121e, 0x141824, 0x191d26, 0x0d0906, 0x0e0000, 0x4a2908, 0x92683e, 0xdeab52, 0xd28f34, 0xffaf31, 0xffa422, 0xff9327, 0xffa321, 0xffb62e, 0xec973d, 0x5e4833, 0x150000, 0x492a15, 0xa28134, 0x6e410a, 0x27000f, 0x1f052c, 0x060701, 0x9c6e10, 0xf3bd41, 0xeda833, 0x99440e, 0x752023, 0x63262b, 0x3c1d08, 0x221900, 0x0f0100, 0x10050d, 0x1c101e, 0x230f10, 0x2c1100, 0x2c1100, 0x271103, 0x3a2c2c, 0x633b17, 0x7b5622, 0x977128, 0xc19637, 0xebb644, 0xffc548, 0xffad2d, 0xf29514, 0xf69129, 0xffa034, 0xffa435, 0xffa234, 0xfc9f35, 0xf89e2e, 0xf8a32c, 0xfba828, 0xff9c2b, 0x7c4b11, 0xbf8835, 0xffa71c, 0xffb331, 0xdeab3e, 0x664500, 0x0d0000, 0xa26627, 0xf2ae4d, 0xffac2a, 0xff9c1a, 0xffa132, 0xff9e36, 0xfda72e, 0xf4ac1a, 0xffbb41, 0x7f5c22, 0x0b0000, 0x76491f, 0xffb547, 0xf4a81e, 0xefad35, 0xc78320, 0x794611, 0xedac46, 0xffa822, 0xff9f29, 0xff9b31, 0xffa02b, 0xffa82b, 0xfea32e, 0xfeae25, 0xee9422, 0xf99331, 0xffad3e, 0xffbe37, 0xf3b429, 0xc1952a, 0x9e7932, 0x655d36, 0x4f4017, 0x371e00, 0x3b1d00, 0x321503, 0x25140d, 0x161513, 0x0f1719, 0x070003, 0x18030c, 0x3b140f, 0x5c240d, 0x6a210e, 0x792711, 0xa75815, 0xd99214, 0xf0c63e, 0x665c1e, 0x04171b, 0x00101d, 0x170800, 0x69410e, 0x977047, 0x3d201a, 0x160100, 0x6a4211, 0xdfa039, 0xffbc3c, 0xf7a221, 0xf6a12a, 0xfca834, 0xf7a130, 0xd19d30, 0xe1b051, 0x986e24, 0x351500, 0x1a0300, 0x1d1115, 0x19142a, 0x161535, 0x21140b, 0x1f1a16, 0x1b1f22, 0x171e24, 0x171c20, 0x1c1b19, 0x291c13, 0x321f10, 0x634624, 0x664a23, 0x6b4924, 0x603417, 0x5e250a, 0x8e4a19, 0xd58933, 0xfdac36, 0xffa21f, 0xffb74a, 0x502200, 0x070a13, 0xcbdedc, 0xfffcff, 0xfff1ff, 0xfcfff6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdf9f0, 0xf7ffff, 0xfcffff, 0xfef7f1, 0xfefffd, 0x97a6ad, 0x040000, 0x724929, 0xffb83b, 0xec9e18, 0xf1a21f, 0xfcad44, 0xb36920, 0x571400, 0x460c00, 0x57221c, 0x141311, 0x131210, 0x111111, 0x151515, 0x1b1b1b, 0x1e1e1e, 0x1d1d1d, 0x1b1b1b, 0x151515, 0x181c1f, 0x1c252a, 0x1b252e, 0x131c23, 0x0e0f11, 0x110a04, 0x170a01, 0x63511f, 0x603a09, 0xc4892b, 0xffaf33, 0xff9d2c, 0xffa01e, 0xffa91a, 0xffa63a, 0xd28916, 0x623427, 0x0a0012, 0x7f6534, 0xf5b352, 0xa55019, 0x3a0a08, 0x12171d, 0x180006, 0x6d4c23, 0xddb440, 0xffce3b, 0xd88a25, 0xa54826, 0xa1452e, 0xaf5a24, 0x5a3e29, 0x261b1f, 0x00021e, 0x000821, 0x181818, 0x3a2a1a, 0x3d2618, 0x150000, 0x010602, 0x000202, 0x070b0e, 0x2d2920, 0x614923, 0xb48533, 0xfbb434, 0xffbb1d, 0xfba02b, 0xfca023, 0xffa424, 0xffa62d, 0xf89629, 0xf99c32, 0xffb039, 0xf5a421, 0xffa02a, 0xb56a19, 0xda9132, 0xffa617, 0xffba31, 0xac8c37, 0x221300, 0x271314, 0xe39a31, 0xffb73e, 0xffa724, 0xff9b22, 0xff9e35, 0xff9f37, 0xfda82b, 0xf4aa17, 0xffae26, 0xd4a438, 0x2b1710, 0x280918, 0xbe8d2e, 0xf6b324, 0xffae40, 0xe08c1c, 0xb36e2d, 0xfaad41, 0xfda11c, 0xff9d29, 0xff9d34, 0xffa12b, 0xffa72b, 0xfca230, 0xf9a51e, 0xfaa91c, 0xffb72e, 0xefac39, 0xb68334, 0x6b4923, 0x24160b, 0x040205, 0x000022, 0x070012, 0x1b0006, 0x48252c, 0x35212d, 0x1c1d2f, 0x011023, 0x001624, 0x291a2f, 0x644c34, 0x8c612c, 0x91501a, 0xa35815, 0xd48f2a, 0xf5bb3d, 0xf6c343, 0x41481e, 0x05000c, 0x270d16, 0x491800, 0xa15e10, 0xe4ad46, 0x6e580c, 0x020305, 0x653302, 0xbf812c, 0xffb43e, 0xffab29, 0xffa31c, 0xfeac22, 0xf4ac34, 0xc98429, 0x533b19, 0x554023, 0x221000, 0x0b0000, 0x1f1714, 0x22211f, 0x191b18, 0x191f1b, 0x201003, 0x1d130a, 0x181715, 0x13171a, 0x11161a, 0x141517, 0x1c1815, 0x221b15, 0x120608, 0x2b1814, 0x3c1c11, 0x380600, 0x581500, 0xb86521, 0xffa744, 0xffa830, 0xff9d1e, 0xffb136, 0x7d450c, 0x060000, 0xb6c1c3, 0xfffdff, 0xfff9ff, 0xf6fdf5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcf4, 0xfbffff, 0xfbffff, 0xfffef5, 0xfbffff, 0x75828b, 0x0e0400, 0x8c5c2e, 0xffa03d, 0xffa039, 0xffa62f, 0xffab23, 0xec9a1a, 0xd2892b, 0xb3713f, 0x7f4128, 0x0b141b, 0x10171d, 0x171c20, 0x1a1e21, 0x1b1c1e, 0x191919, 0x181715, 0x191512, 0x1d1f11, 0x181e12, 0x101a12, 0x0d1917, 0x122020, 0x1a2626, 0x131d1e, 0x07100f, 0x031104, 0x070000, 0x815f22, 0xf2b445, 0xffa739, 0xffa32b, 0xffa018, 0xffa635, 0xffaf24, 0xbd8027, 0x492819, 0x250311, 0xac7846, 0xfabf41, 0xa56b00, 0x77411d, 0x543e41, 0x180015, 0x3f261f, 0xb29e3d, 0xedd02e, 0xe6ae1b, 0xca6e1b, 0xa83611, 0xad631c, 0x7a4928, 0x251821, 0x041026, 0x111c20, 0x4e422c, 0x93633f, 0x7c340e, 0x302825, 0x19161d, 0x0a0d20, 0x050a20, 0x030208, 0x1d0d00, 0x78581b, 0xd9af5b, 0xffc147, 0xf9b025, 0xef9e07, 0xffa415, 0xffa62d, 0xfe9e30, 0xffa632, 0xfca929, 0xffa52c, 0xf69834, 0xfea642, 0xffaa1f, 0xf7af25, 0x776326, 0x040000, 0x674833, 0xffb029, 0xffb32c, 0xffa624, 0xff9e2b, 0xff9c34, 0xff9d31, 0xffa82c, 0xfaaa1d, 0xff9e15, 0xf3b628, 0x674931, 0x08001e, 0x7d601a, 0xf6b42a, 0xffae41, 0xfda230, 0xeb9548, 0xffb13d, 0xfda21d, 0xffa22f, 0xff9d34, 0xff9d24, 0xffa427, 0xf7a333, 0xf89e2c, 0xffbd39, 0xe3b337, 0x6d520f, 0x11010c, 0x00002c, 0x010427, 0x0c1818, 0x1b0907, 0x421c0f, 0x77402b, 0x8f5f4b, 0x4c342a, 0x1c1711, 0x090900, 0x1f1a04, 0x8d5717, 0x985b1c, 0x9d551a, 0xb16519, 0xe5a42c, 0xfcca43, 0xb28439, 0x49181e, 0x170418, 0x61311b, 0x923d18, 0xbf6324, 0xebac43, 0x987322, 0x2c0e00, 0x482d18, 0xbf7917, 0xf8ac3c, 0xffaa38, 0xfd9929, 0xffa618, 0xffb30d, 0xf2b237, 0x8d511d, 0x010009, 0x0f0c17, 0x12101d, 0x1d1b26, 0x232429, 0x141613, 0x101608, 0x19200e, 0x24160b, 0x21170e, 0x1c1815, 0x17181a, 0x13171a, 0x121619, 0x13171a, 0x17181a, 0x07112a, 0x201825, 0x694839, 0xb57943, 0xd7862b, 0xed9019, 0xffa21f, 0xffa922, 0xffa936, 0xffaa25, 0x9d5f16, 0x0e0000, 0x8f9aa0, 0xfbfbfd, 0xfffcff, 0xf8fff8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdf8, 0xfbffff, 0xf6fff8, 0xfffff6, 0xfbffff, 0x5b656f, 0x110100, 0xa36b32, 0xffb127, 0xffab37, 0xffad38, 0xffb625, 0xffc32f, 0xfbc05a, 0xb17c4a, 0x451500, 0x131a20, 0x141b21, 0x161b1f, 0x171b1e, 0x1a1a1a, 0x1a1917, 0x1d1916, 0x1e1a17, 0x232414, 0x181a0c, 0x16190e, 0x1c231b, 0x19241c, 0x0f1b17, 0x0d1917, 0x12211e, 0x031f23, 0x000012, 0x644b23, 0xe9b649, 0xf4a639, 0xf89e2e, 0xf89e23, 0xfda331, 0xffaf34, 0xf09b1e, 0xc97421, 0x5c1f0a, 0x250a00, 0x8a7526, 0xebb038, 0xe78009, 0xa9591e, 0x944f25, 0x582311, 0x3c1601, 0x86661d, 0xebc540, 0xf5bb35, 0xc2730e, 0xb24f00, 0xb35d22, 0x6e3927, 0x23161f, 0x00020b, 0x1e160b, 0x8f532f, 0xc9612e, 0x97553b, 0x7a4325, 0x451e00, 0x352001, 0x413b25, 0x0a0a02, 0x000007, 0x2b2c3e, 0xb78732, 0xf3bf49, 0xfcba26, 0xf1a009, 0xffa727, 0xffa435, 0xf79928, 0xfba327, 0xffa326, 0xffa12f, 0xf49334, 0xffae33, 0xeba521, 0x423008, 0x030005, 0xac783e, 0xffb31f, 0xfeab21, 0xffa529, 0xffa12f, 0xff9d2f, 0xff9f2e, 0xffa72c, 0xffa928, 0xffa223, 0xffb71d, 0xa0793e, 0x060017, 0x4b330d, 0xefaa31, 0xffa931, 0xf19832, 0xfc9d41, 0xffaa2d, 0xf7a31c, 0xffa733, 0xff9e31, 0xff9e22, 0xffac2d, 0xf9ad3f, 0xffc14d, 0xab722f, 0x4d221c, 0x0e000c, 0x140c19, 0x3c382d, 0x352d16, 0x392b11, 0x834d11, 0x9c581b, 0xb46836, 0x8a5239, 0x260e0e, 0x080004, 0x341512, 0x77402c, 0xc46221, 0x973c00, 0xb06700, 0xfcc642, 0xebbe4b, 0x784c0f, 0x3a1100, 0x522b0e, 0xad5a30, 0xaa4d07, 0xde8330, 0xedb16b, 0x7a6236, 0x260d00, 0x662813, 0xbb562c, 0xf6a329, 0xffb131, 0xffa636, 0xff9e3c, 0xffa219, 0xf9ad00, 0xf1b942, 0x5c2c15, 0x081213, 0x151f21, 0x192026, 0x141821, 0x12151e, 0x1b1b23, 0x232429, 0x1e1d22, 0x1b1612, 0x1e1915, 0x211d1a, 0x202020, 0x202123, 0x1d2124, 0x1b1f22, 0x1a1e21, 0x0a2129, 0x030706, 0x452c0e, 0xba863a, 0xffc147, 0xffc534, 0xffb92c, 0xf9ae2e, 0xf3a749, 0xfeb02a, 0xa76d1b, 0x0d0000, 0x6c7884, 0xeef2f3, 0xfffeff, 0xfcfffa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcf8, 0xfbfffd, 0xf6fff6, 0xeff3e5, 0xfbffff, 0x5f6774, 0x130000, 0xae712e, 0xffd42d, 0xa06a00, 0x8a510c, 0xbd8e3c, 0xbb9b46, 0x735d2e, 0x2c1d16, 0x0f090b, 0x17181a, 0x191919, 0x191919, 0x1a1a1a, 0x1b1a18, 0x1b1a18, 0x1e1a17, 0x1e1a17, 0x130f10, 0x221e1f, 0x24201f, 0x16120f, 0x10100e, 0x1c1e1d, 0x1f2525, 0x161f1e, 0x13242b, 0x08001a, 0x5a3a14, 0xedb641, 0xf8a731, 0xfb9f30, 0xffac32, 0xffaa36, 0xf09d25, 0xffb749, 0xf08616, 0xba6d05, 0x6f440d, 0x2d0b01, 0x744011, 0xd48c16, 0xd16e2d, 0xbf6b13, 0xb67229, 0x80432e, 0x360004, 0x572907, 0xbf9738, 0xf3ce4a, 0xc07309, 0xbf6407, 0xaa5610, 0x623810, 0x0d1601, 0x061400, 0x563407, 0xb05618, 0xb0521c, 0xc26829, 0xac5d12, 0x9e5b0c, 0xc99752, 0xab8b5a, 0x493920, 0x060000, 0x37190f, 0xa47d42, 0xf1bd47, 0xf5ac21, 0xfa9e21, 0xffa236, 0xff9d30, 0xf99c23, 0xeba428, 0xff9c22, 0xcf6d14, 0xffa93d, 0xe89e21, 0x281700, 0x0d0210, 0xe29837, 0xfab421, 0xf3a720, 0xfba52e, 0xffa331, 0xff9f2c, 0xffa32b, 0xffa32b, 0xffa32d, 0xf89e2c, 0xffb821, 0xcc9e3c, 0x160a0e, 0x311511, 0xe49933, 0xffa320, 0xc8771e, 0xff9a32, 0xf7a01d, 0xf2a51b, 0xfda833, 0xffa030, 0xffa625, 0xffb130, 0xecaa3c, 0x967d44, 0x2a0800, 0x1b0005, 0x623937, 0xbd9558, 0xc19735, 0x8d5905, 0x9a5b26, 0xba6b1e, 0xb25b16, 0xa5562b, 0x562b24, 0x070218, 0x0d0a1f, 0x653832, 0xb05834, 0xa13809, 0xe29046, 0xf6c859, 0xaa9427, 0x4b3600, 0x3a180e, 0x774b24, 0xb68924, 0xbe620f, 0xc27036, 0xb27c34, 0x5f3d00, 0x300c00, 0x6d3618, 0xc26e18, 0xf8892f, 0xffab38, 0xf9a71d, 0xfda72c, 0xffa043, 0xffa12c, 0xf9ab0d, 0xebb646, 0x4f2614, 0x09140e, 0x050e09, 0x121814, 0x1e2221, 0x1e1f21, 0x141319, 0x13101b, 0x1e1a28, 0x111518, 0x141517, 0x171717, 0x1a1917, 0x1b1a18, 0x181818, 0x161616, 0x131416, 0x152316, 0x1b1d18, 0x1d1007, 0x321a00, 0x78580f, 0xbd9941, 0xb08a3f, 0x714810, 0xb3782c, 0xfab939, 0xa8721c, 0x0a0002, 0x697689, 0xf2fbf8, 0xf1edea, 0xfffff8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfff7f3, 0xfbfffb, 0xf6fff4, 0xd6dacc, 0xf9ffff, 0x737b88, 0x180200, 0xb07028, 0xd3c54b, 0x533914, 0x15000a, 0x220d16, 0x1d190e, 0x000a0c, 0x000e18, 0x0d302c, 0x1c1713, 0x1e1a17, 0x201c19, 0x1f1b18, 0x1d1916, 0x1c1815, 0x1e1a17, 0x201c19, 0x22192e, 0x1c1122, 0x1c101e, 0x251a22, 0x241b20, 0x191418, 0x141318, 0x191a1f, 0x1b1d1c, 0x160015, 0x5d3006, 0xfab93b, 0xffa928, 0xfc9b2a, 0xffa82d, 0xf89b22, 0xffa333, 0xff9c30, 0xffb338, 0xfba826, 0xd6802b, 0x9c513e, 0x532728, 0x3b3118, 0x775321, 0x5e341b, 0x562b1a, 0x6a4228, 0x5b3825, 0x1e0000, 0x1d0900, 0x5d5330, 0xbb8d4f, 0xa5500d, 0xca6022, 0x955531, 0x222421, 0x001621, 0x291d1d, 0x874634, 0x934400, 0xe58e41, 0xfb9749, 0xaf4900, 0xb75500, 0xffb24d, 0xfabe50, 0x8d5e00, 0x0a0029, 0x311309, 0xb68833, 0xffc046, 0xfda22d, 0xfd9830, 0xffa43a, 0xffa22a, 0xebb134, 0xffb133, 0xc56511, 0xf69e3d, 0xe29720, 0x341f0c, 0x31212e, 0xf79d23, 0xf7b626, 0xeca624, 0xf6a530, 0xfba431, 0xffa229, 0xffa62b, 0xffa12c, 0xff9e2f, 0xe28f29, 0xffac1b, 0xdeaa30, 0x322212, 0x311120, 0xda8930, 0xffa113, 0xb5681a, 0xffa334, 0xf9a51e, 0xf3aa1f, 0xf8a732, 0xfa9f2d, 0xffa725, 0xf4ab28, 0xd09424, 0x00003b, 0x0c0400, 0x81660b, 0xeebb3e, 0xffb146, 0xc2620e, 0xaa4600, 0xff9f3c, 0xd77f28, 0xab5105, 0x7f3c08, 0x251201, 0x001616, 0x223724, 0x83621f, 0xbc6400, 0xb16400, 0xad7427, 0x694a38, 0x0e0216, 0x080401, 0x523f15, 0x7a4420, 0x651111, 0x6f3317, 0x734d26, 0x4d311b, 0x592a10, 0xa95914, 0xdc7816, 0xec961b, 0xfbc01e, 0xffa642, 0xf2a313, 0xf9a91e, 0xf9983a, 0xffa440, 0xffb027, 0xe1ae45, 0x553119, 0x040813, 0x1a1d24, 0x222625, 0x11140d, 0x15170c, 0x25251b, 0x1f1c15, 0x191611, 0x151f28, 0x151c22, 0x161a1d, 0x191816, 0x1c1815, 0x1d1916, 0x1c1b19, 0x1c1c1c, 0x1a1809, 0x1e1b24, 0x171232, 0x06041c, 0x09090b, 0x1c1910, 0x1c121a, 0x0c0017, 0x6f3f00, 0xf5be40, 0xa3731e, 0x090005, 0x7a89a0, 0xf8ffff, 0xdbd8d1, 0xf9f9ef, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xebf8ff, 0xfffffd, 0xfff8ef, 0xd8d9db, 0x6c7c89, 0x575b5e, 0x2a0100, 0xc47435, 0xb38c2d, 0x200f19, 0x071635, 0x001209, 0x1a1b15, 0x251714, 0x171812, 0x102133, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a18, 0x191b16, 0x1b1c16, 0x1e1e16, 0x201d18, 0x211917, 0x1e1415, 0x1d1930, 0x0f0002, 0x4e2b03, 0xe8b24e, 0xffc936, 0xfca70c, 0xffab29, 0xff9a37, 0xffa034, 0xfca12e, 0xffa52a, 0xffae2d, 0xffaf32, 0xef9928, 0xcc7410, 0xaf5600, 0x803110, 0x773622, 0x502a21, 0x281d17, 0x131f15, 0x031716, 0x000a1f, 0x000732, 0x291709, 0x2e1c0e, 0x3f2c1d, 0x503b2a, 0x422b19, 0x220900, 0x270c00, 0x4e331e, 0xbb442e, 0xc87108, 0xfcbc27, 0xc9811f, 0x90330a, 0xc5662c, 0xffbb3e, 0xf7c212, 0xc08d0d, 0x2d0416, 0x080000, 0xb9b03b, 0xffd355, 0xf7962b, 0xffa321, 0xffa725, 0xff9f2e, 0xffb42d, 0xcf6d22, 0xdc7e27, 0xdea441, 0x47220f, 0x5f2d12, 0xf4a540, 0xfca33f, 0xe58d23, 0xfca230, 0xffaa32, 0xfba126, 0xffa62b, 0xffa12b, 0xffa632, 0xe08528, 0xfa9e2f, 0xf5b436, 0x512309, 0x50210f, 0xdb972c, 0xe28329, 0xca6922, 0xf4ad39, 0xf5a915, 0xffa321, 0xff9c44, 0xff9e28, 0xfec31f, 0xc2aa50, 0x000025, 0x281500, 0xc09632, 0xfab728, 0xffc036, 0xbb6421, 0x7c2418, 0xd5824c, 0xffb72d, 0xd16206, 0x9f5413, 0x523317, 0x191410, 0x191516, 0x3c2d28, 0x4f362f, 0x472c23, 0x281f30, 0x0c0e1d, 0x000815, 0x000c13, 0x011919, 0x0e1a10, 0x1f1909, 0x4a3824, 0x802a2d, 0x8a361c, 0xa3530c, 0xca7c0d, 0xf1a01b, 0xffaf2b, 0xffa833, 0xfd9d36, 0xffa424, 0xf78e23, 0xff9b37, 0xffad2d, 0xf4af0c, 0xffd136, 0xdbab45, 0x471700, 0x190d19, 0x1d131b, 0x1c1714, 0x1d1a11, 0x1c1c12, 0x13160d, 0x111610, 0x1e2221, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x162017, 0x151b17, 0x19181d, 0x150f19, 0x261e29, 0x161014, 0x1b1714, 0x100d06, 0x142326, 0xe19525, 0xc57119, 0x0b0007, 0x5e6369, 0x897775, 0xf0e4f8, 0xf2fbff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7ffff, 0xfefdfb, 0xfffdf6, 0xf5f6f8, 0x3e4e5b, 0x010508, 0x3f1a00, 0xae6329, 0xa37716, 0x240c0a, 0x101c34, 0x0c221f, 0x101413, 0x211716, 0x202018, 0x0e1a26, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x161618, 0x141414, 0x151611, 0x191a14, 0x171813, 0x151316, 0x18151e, 0x1f1b29, 0x222328, 0x090600, 0x2c1c03, 0xa28357, 0xc29252, 0xc0822b, 0xe79f30, 0xf2a728, 0xffa032, 0xfea330, 0xfaa025, 0xf69e20, 0xfaa528, 0xffad36, 0xfea83b, 0xf29b34, 0xbd761e, 0xaa5f1b, 0xa15523, 0x9e5425, 0x934e15, 0x82460a, 0x663100, 0x471300, 0x0e1215, 0x0a0e11, 0x0d0e10, 0x161719, 0x18191b, 0x0f1012, 0x0e0f11, 0x191a1c, 0x954017, 0xa35a00, 0xf9b429, 0xfead44, 0xa44411, 0x9c3e0b, 0xeb9d39, 0xfabe28, 0xfdb553, 0xbc9344, 0x2e1b00, 0x4b3307, 0xdca934, 0xffb837, 0xfb9728, 0xfea11e, 0xffa22c, 0xffac28, 0xc96b21, 0xd67b22, 0xd89d39, 0x4e260d, 0x65300e, 0xfbac47, 0xeb922e, 0xe89026, 0xffa634, 0xffa62e, 0xfba126, 0xffa72c, 0xffa02a, 0xffa632, 0xe08827, 0xe98f1f, 0xfab53e, 0x643519, 0x53230c, 0xda932b, 0xdd7f27, 0xbd621c, 0xf8b22c, 0xffac2b, 0xff9e28, 0xff9e2c, 0xffac32, 0xdba634, 0x442400, 0x2f1514, 0xd1af58, 0xf1bd4d, 0xffb731, 0xee9925, 0x9c4502, 0xa34c21, 0xf5a04f, 0xffac20, 0xc26323, 0x773912, 0x29160f, 0x060e19, 0x06131c, 0x101518, 0x121210, 0x0a0b06, 0x091731, 0x060610, 0x331b0f, 0x673514, 0x894216, 0xa24d24, 0xac4f2e, 0xb6563d, 0xa5570c, 0xc97b26, 0xeb9c37, 0xf5a42f, 0xf7a327, 0xfea42a, 0xffa231, 0xfd9d2f, 0xffa52a, 0xfea52d, 0xffaf3f, 0xe89f39, 0xbd832f, 0xc39a5c, 0x9f8459, 0x281500, 0x101126, 0x17182a, 0x1d1d27, 0x1a1b20, 0x191a1f, 0x1d1c24, 0x1b1927, 0x141124, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x20251f, 0x111612, 0x1b1b1d, 0x19181d, 0x1d1a21, 0x100f14, 0x1e1f23, 0x161719, 0x0b100a, 0xd0861b, 0xbc6f1f, 0x1d121a, 0x000308, 0x645552, 0xeee5f6, 0xf9ffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8ffff, 0xfefdfb, 0xfbf4ee, 0xfcffff, 0x7e8c97, 0x000104, 0x361800, 0x8b4d1c, 0xae7615, 0x311200, 0x0a0e1a, 0x1b2f30, 0x12171d, 0x1e1818, 0x24211a, 0x101518, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x131418, 0x1a1a1a, 0x191a14, 0x161711, 0x1c1c1a, 0x25252f, 0x1e1f34, 0x0e0f2d, 0x101710, 0x181f18, 0x151b1b, 0x1c1a28, 0x0d0005, 0x2f0a00, 0xa77516, 0xf3bc24, 0xfc9e2c, 0xffa42f, 0xffa62c, 0xfda527, 0xf9a425, 0xfba72a, 0xffab31, 0xffab34, 0xffb825, 0xf7a22b, 0xe47e29, 0xc55611, 0xb54a04, 0xc06419, 0xba7029, 0x9c5c1c, 0x1e252b, 0x171e24, 0x0f181f, 0x0b151e, 0x0e1b24, 0x14222d, 0x0d1d2a, 0x000f1c, 0x663e0b, 0x9c6513, 0xeea32c, 0xffbb43, 0xdb7a2b, 0x913504, 0xb66621, 0xf3ac40, 0xff9e45, 0xffd53a, 0x8f6e1d, 0x290004, 0x97651e, 0xffc741, 0xfb9d29, 0xffa42b, 0xffa52b, 0xf4a62a, 0xb9631a, 0xd17a1b, 0xd1912f, 0x572606, 0x743e0f, 0xffaf4c, 0xd37a16, 0xee962c, 0xffab39, 0xfba129, 0xfba126, 0xffa72c, 0xfe9f29, 0xffa531, 0xe8952f, 0xd47a0a, 0xf7ad44, 0x7f4927, 0x5a2505, 0xd48b2c, 0xd67c26, 0xac5818, 0xf1ab17, 0xffa638, 0xff9a2a, 0xffac1d, 0xe6b23a, 0x8f6533, 0x250000, 0xab7434, 0xffc551, 0xeda72b, 0xf3a22f, 0xc76e1a, 0x923b00, 0xd4802a, 0xffb642, 0xfea21b, 0xb8663e, 0x582512, 0x110509, 0x0e1726, 0x14222b, 0x121c1b, 0x141e16, 0x15221b, 0x1e0d13, 0x422217, 0x935e36, 0xc57735, 0xbb5f0a, 0xb14e00, 0xbe5a02, 0xdf7c27, 0xf2ac18, 0xf6ad20, 0xfcad2a, 0xffac32, 0xffa835, 0xffa433, 0xff9f2d, 0xff9c28, 0xf6a32d, 0xfbae2a, 0xeca829, 0x9c6314, 0x320400, 0x11000e, 0x1b1728, 0x0c1711, 0x0e2020, 0x081913, 0x0e1b11, 0x152010, 0x131a0a, 0x16180b, 0x211e17, 0x27221e, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x232124, 0x121212, 0x1e201d, 0x1a1f1b, 0x131919, 0x11191c, 0x1b242d, 0x09111e, 0x201400, 0xc97f20, 0x8d4c0a, 0x1e171e, 0x000004, 0xa89a97, 0xfffcff, 0xf1f6f9, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7fcff, 0xfffffd, 0xfaf5f1, 0xfcffff, 0xdbe8f1, 0x1d2124, 0x110000, 0x6e401c, 0xd48f34, 0x5f3409, 0x060000, 0x182329, 0x19202a, 0x1e1c1d, 0x1e1b14, 0x161712, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1c1b20, 0x1e1e1e, 0x1e1f1a, 0x1a1b16, 0x181818, 0x181822, 0x17182d, 0x161632, 0x191919, 0x232a30, 0x081422, 0x000015, 0x160c14, 0x76542f, 0xdda340, 0xfcb424, 0xffa834, 0xfda32b, 0xfca228, 0xffa82c, 0xfea92a, 0xf7a424, 0xf3a020, 0xf4a121, 0xffb21b, 0xffab36, 0xdb8339, 0xac5b2c, 0x955531, 0x7e5333, 0x523c27, 0x34271f, 0x241b14, 0x221b15, 0x201b17, 0x191816, 0x141414, 0x181c1f, 0x181d21, 0x0a1117, 0x1e1800, 0x7b542b, 0xdb8e36, 0xffb22d, 0xf89a26, 0xa14a07, 0x944210, 0xde914b, 0xff9d22, 0xffb319, 0xecb944, 0x63331c, 0x491307, 0xd39530, 0xffb221, 0xffa034, 0xffaa2c, 0xeca235, 0x9a4f0c, 0xcc7c19, 0xd08a2b, 0x622802, 0x905416, 0xf1a142, 0xc16804, 0xf49c32, 0xffae3c, 0xf89e26, 0xfba126, 0xffa72c, 0xfd9e28, 0xffa531, 0xf7a93c, 0xc56b00, 0xea963e, 0x92542d, 0x642900, 0xce822c, 0xd07b28, 0x964e14, 0xf1a51c, 0xffa63c, 0xffa027, 0xffbd2a, 0xb59234, 0x37160d, 0x773b23, 0xfaa83c, 0xf3a117, 0xf8a523, 0xeb9234, 0xa64b14, 0x9a4300, 0xe6961d, 0xffb026, 0xf4971e, 0x834a2d, 0x371509, 0x0e070e, 0x181f29, 0x202123, 0x1d1910, 0x211d12, 0x202217, 0x21250c, 0x181a02, 0x2b2609, 0x53401f, 0x845b2f, 0x9d5b21, 0xb0550f, 0xd96f23, 0xfab126, 0xffb42b, 0xffae2b, 0xf8a324, 0xfea227, 0xffa830, 0xffa630, 0xff9f29, 0xf8a025, 0xfcac23, 0xfdb932, 0xd39a40, 0x6b4129, 0x130011, 0x060620, 0x1c2c39, 0x0a1e1f, 0x0e211d, 0x18281b, 0x1c2814, 0x191e07, 0x191803, 0x1e1906, 0x1d1606, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x20161e, 0x181317, 0x20221f, 0x151f17, 0x111e17, 0x182424, 0x0f1821, 0x000010, 0x654111, 0xe49948, 0x673405, 0x010006, 0x312c30, 0xf2e7e5, 0xfefeff, 0xfdfeff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfeffff, 0xf4f3f1, 0xfffefb, 0xfcffff, 0xf7ffff, 0x676c70, 0x0a0000, 0x492d17, 0xe29044, 0xaa7533, 0x231000, 0x090a0c, 0x151a20, 0x1f1f1f, 0x1e1a19, 0x1c1914, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a181b, 0x141414, 0x191919, 0x20201e, 0x161513, 0x050000, 0x090000, 0x1b0f11, 0x0c0000, 0x080005, 0x040000, 0x1a1300, 0x7f6825, 0xe7b14f, 0xffbb48, 0xff921e, 0xfa9d26, 0xffa72f, 0xffaa30, 0xfba328, 0xf39d22, 0xf7a327, 0xffb034, 0xffb93d, 0xef9e45, 0xb36827, 0x6b2d08, 0x4a2007, 0x422811, 0x291a05, 0x180b05, 0x1f121b, 0x221b15, 0x191410, 0x1c1713, 0x1e1a17, 0x171614, 0x171717, 0x1d1e20, 0x1f2022, 0x090b18, 0x482927, 0xc78249, 0xffbf3f, 0xffaf22, 0xbb6c10, 0x8c3c09, 0xb36233, 0xffb21f, 0xf99b21, 0xffba40, 0xa36d25, 0x360000, 0x8c5220, 0xffbd37, 0xf89c1d, 0xffaf30, 0xde9840, 0x773600, 0xc77d1c, 0xd2842f, 0x753009, 0xab6821, 0xd07e2a, 0xbf6602, 0xfaa238, 0xffad3b, 0xf79d25, 0xfda328, 0xffa62b, 0xffa02a, 0xffa32f, 0xfcb541, 0xc26800, 0xd57a34, 0xa25b2f, 0x7c3b05, 0xca7b2e, 0xc47725, 0x7e400d, 0xe18f29, 0xffa835, 0xffa61b, 0xf4b438, 0x7c5c21, 0x2a0701, 0xb87646, 0xfd9e1e, 0xffac1e, 0xffb137, 0xc46d20, 0x893004, 0xb76519, 0xffb535, 0xffbb3a, 0xda8b2f, 0x2d1f12, 0x101211, 0x0c1c29, 0x172736, 0x191c23, 0x1e1516, 0x1f191b, 0x14131b, 0x1e1d19, 0x21201e, 0x241e20, 0x1b0f13, 0x2a1212, 0x421d15, 0x582718, 0x7e4531, 0xa45008, 0xdd8933, 0xffb44a, 0xffae33, 0xf9a11c, 0xffa522, 0xffa82d, 0xffa02c, 0xffa423, 0xfa9c18, 0xfda925, 0xffbf45, 0xe2ad4d, 0x856228, 0x281600, 0x070000, 0x04001a, 0x0c071e, 0x060210, 0x030004, 0x0d0709, 0x231a1d, 0x271d25, 0x211720, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x21141b, 0x1b1519, 0x181d19, 0x111c14, 0x142118, 0x141d18, 0x030504, 0x110f10, 0xbb7f37, 0xde9453, 0x4b290d, 0x000105, 0x8a8184, 0xfffaf8, 0xf9ffff, 0xfffffd, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffffd, 0xf6f5f3, 0xffffff, 0xf5f9fc, 0xf9ffff, 0xafb4b8, 0x0b0704, 0x2a1d14, 0xc2692f, 0xe4a754, 0x65460f, 0x120701, 0x10100e, 0x1b1d18, 0x232126, 0x1c1817, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1c1817, 0x1e1c1f, 0x141519, 0x101113, 0x2e2923, 0x54452e, 0x553c14, 0x3d1b00, 0x572e12, 0x653e21, 0x876132, 0xb88e38, 0xedb635, 0xffb121, 0xff9e20, 0xff922b, 0xf2951e, 0xffa62c, 0xffaa2f, 0xfba328, 0xfba52e, 0xffad3c, 0xf9a238, 0xe28b24, 0x75310a, 0x602102, 0x652c11, 0x794722, 0x7d4e18, 0x824e12, 0x935627, 0xa05b3a, 0x2b353e, 0x19232c, 0x101920, 0x141b21, 0x151a1e, 0x0f1418, 0x101417, 0x151618, 0x150d25, 0x1d000b, 0x713a1c, 0xcf8c31, 0xffc044, 0xe9a238, 0x904502, 0x91431c, 0xe78d12, 0xffac3a, 0xf8a32f, 0xca892d, 0x63310e, 0x622e18, 0xf0ae57, 0xf7a907, 0xffa92e, 0xbd7c3a, 0x622b04, 0xc07b1e, 0xcd772e, 0x913f1a, 0xb56d21, 0xb15a13, 0xcf7612, 0xfea63c, 0xffa937, 0xfaa028, 0xffa52a, 0xffa429, 0xffa32d, 0xffa22e, 0xf6b439, 0xcf7507, 0xc25e2a, 0xab5d2c, 0x95500f, 0xc0702b, 0xb77020, 0x6c370d, 0xc06828, 0xfca62f, 0xffb222, 0xda9b3a, 0x5e300f, 0x67381e, 0xc38031, 0xffa921, 0xffad2c, 0xe48c2a, 0x933f01, 0x93420d, 0xe69846, 0xffbf54, 0xce953b, 0x6b3803, 0x010c0e, 0x001522, 0x062237, 0x071e30, 0x08101b, 0x191820, 0x212435, 0x111f39, 0x210d0f, 0x4d2b22, 0x8b553b, 0x93522a, 0x854718, 0x7d5124, 0x5a471f, 0x35320f, 0x7c2804, 0x93400a, 0xc57321, 0xf8a638, 0xffb639, 0xffa725, 0xf99d22, 0xffa02a, 0xffa225, 0xff9c23, 0xfc9a1d, 0xfca518, 0xffbc26, 0xecb332, 0xad7c2d, 0x80522e, 0x5f3926, 0x48250f, 0x3e220a, 0x513b24, 0x534431, 0x2f251c, 0x150f11, 0x1e1920, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x281c1c, 0x1a1414, 0x111516, 0x121c1b, 0x121c14, 0x141507, 0x150a00, 0x57462c, 0xffad4d, 0xa85f2c, 0x27150b, 0x020d0f, 0xd5c9c9, 0xfffefb, 0xf3fffd, 0xfffefb, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcf7f3, 0xfffffd, 0xfeffff, 0xfbffff, 0xfbffff, 0xbabfc3, 0x000002, 0x191919, 0x993c13, 0xe6a443, 0x996f23, 0x432e1b, 0x272317, 0x11140b, 0x201e2b, 0x18151c, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x17100a, 0x1f1d20, 0x12151e, 0x0e1118, 0x4f473a, 0xb69e70, 0xeec374, 0xebb44d, 0xedb151, 0xeaaa46, 0xf8b243, 0xffb239, 0xffb32e, 0xf99b15, 0xfc9616, 0xffa52d, 0xffaa33, 0xf79d23, 0xf0961b, 0xfca429, 0xffb441, 0xfea740, 0xcf751d, 0xa14600, 0x89550a, 0xb07332, 0xe2965a, 0xec9955, 0xd68335, 0xbe7227, 0x9a5722, 0x703110, 0x07111a, 0x000910, 0x000306, 0x080705, 0x150e08, 0x170a01, 0x140400, 0x160300, 0x2c130f, 0x1d0200, 0x230000, 0x5f2d0a, 0xc5873a, 0xeba641, 0xa55e0e, 0x8e451a, 0xa55d11, 0xfda83d, 0xffa831, 0xdb902b, 0x814e15, 0x572818, 0xca914e, 0xffc012, 0xef911d, 0x945428, 0x6d3b22, 0xbb7923, 0xb85b1e, 0xa14627, 0xad6012, 0xa44b13, 0xe58c28, 0xffa93f, 0xfda331, 0xfea42c, 0xffa82d, 0xffa328, 0xffa630, 0xffa12d, 0xf0b432, 0xe48c20, 0xb24820, 0xa95620, 0xa1570e, 0xaf5b1d, 0xaf6c1e, 0x6c4019, 0xa94e22, 0xe19229, 0xffc03d, 0xc78537, 0x662509, 0x965328, 0xc37f1a, 0xffbf31, 0xf09d33, 0xb3631c, 0x8e420e, 0xb26821, 0xe29841, 0xb7772f, 0x60340d, 0x120000, 0x1e0a00, 0x1a100e, 0x161213, 0x100805, 0x120000, 0x190800, 0x130f0e, 0x000a14, 0x00170a, 0x212107, 0x6b4619, 0x9e5918, 0xbc6516, 0xda8431, 0xe29a46, 0xe5a656, 0xb9732e, 0x985008, 0x964b00, 0xc77a1e, 0xf7a53f, 0xffab39, 0xf8a22b, 0xfaa227, 0xfc9c2b, 0xffa433, 0xffa631, 0xf89917, 0xf89f11, 0xffae27, 0xf9ad3d, 0xf8af51, 0xfdba47, 0xeaae40, 0xe9b754, 0xe9c473, 0xad975d, 0x483d1d, 0x0d0d01, 0x101417, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x271d14, 0x191411, 0x16191e, 0x151a20, 0x11120d, 0x322610, 0x4d3207, 0x9e7942, 0xffa432, 0x823910, 0x150f13, 0x00090c, 0xd7c9c8, 0xfaf6f3, 0xf4ffff, 0xfffcf8, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffef8, 0xf0efed, 0xbcbdbf, 0xeff4f8, 0xf5fafe, 0xb9bec2, 0x000105, 0x050c12, 0x862709, 0xcc8720, 0xa67822, 0x745840, 0x49432d, 0x070b00, 0x171626, 0x171522, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x281f16, 0x1f1d20, 0x161a26, 0x0e111a, 0x110800, 0x422200, 0xa67004, 0xffbe33, 0xffbb21, 0xffba1a, 0xffb71d, 0xff9e19, 0xffa136, 0xffa53e, 0xfea82f, 0xf8ab1d, 0xffaa33, 0xf89e23, 0xfea527, 0xffb438, 0xf49d2c, 0xc56c0e, 0xb5590e, 0xc6682a, 0xf4c738, 0xf6b537, 0xdb7f18, 0xba5000, 0xa94b01, 0x844718, 0x3b2319, 0x010014, 0x0f0600, 0x241a11, 0x3c2a1c, 0x543b27, 0x714f34, 0x825735, 0x865630, 0x8b572f, 0x7a5731, 0x694e30, 0x4f3631, 0x42191f, 0x5e2301, 0xb56f17, 0xbf7921, 0x8d4716, 0x824519, 0xc97a1d, 0xffb532, 0xe59325, 0x854d1c, 0x653b25, 0xb58135, 0xffc926, 0xd87a09, 0x753615, 0x815242, 0xbc7b2b, 0xa2420f, 0xa9472c, 0xa04e02, 0xa64b1c, 0xf59c38, 0xffaa40, 0xf99f2d, 0xffa62e, 0xffa92e, 0xfea227, 0xffa832, 0xffa02c, 0xf0b631, 0xf8a034, 0xa83b1a, 0xa04a11, 0xa05207, 0x9f4a11, 0xae6c20, 0x774f2c, 0x943813, 0xb86f13, 0xf8bd49, 0xbd7b31, 0x803110, 0x9c4b16, 0xd38f22, 0xfac32b, 0xcb7f27, 0x8e450e, 0x924c19, 0xb36d18, 0xb56e14, 0x6d2f00, 0x3a1912, 0x49444a, 0x944a25, 0x8a4b2c, 0x854f33, 0x89532f, 0x895325, 0x78491d, 0x523a18, 0x312a17, 0x1a1b37, 0x030013, 0x100006, 0x492119, 0x874c2a, 0x9d5614, 0xa65700, 0xd07c0c, 0xfcc14b, 0xf0b147, 0xc78227, 0xa15507, 0xba6918, 0xf7a444, 0xffb846, 0xf7a424, 0xfaa741, 0xf49e31, 0xffa332, 0xffa435, 0xffa036, 0xffa032, 0xfca228, 0xffb42e, 0xffab0f, 0xffc22f, 0xfbb73a, 0xa06f10, 0x3d1e00, 0x140400, 0x151321, 0x181c3f, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1e1506, 0x1a1712, 0x1f2229, 0x131521, 0x0f0909, 0x574328, 0x825d26, 0xc09044, 0xe57400, 0x732a07, 0x0f0f1b, 0x000607, 0xd2c2c2, 0xfffefd, 0xe1f5ec, 0xcec7c1, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xf2fcfe, 0xeff3f2, 0x2b2620, 0x120800, 0x5e544b, 0x38302d, 0x211d1c, 0x060407, 0x4d3217, 0xa6713b, 0xab661b, 0x844e12, 0x5e4c34, 0x262729, 0x120e0b, 0x2b1603, 0x151a13, 0x15180f, 0x1c1e19, 0x191c21, 0x101420, 0x12161f, 0x191c13, 0x191b03, 0x19160f, 0x1c1b16, 0x161616, 0x1d1c21, 0x232126, 0x100910, 0x0f040a, 0x2c1d22, 0x8b5819, 0xc08634, 0xeaa736, 0xffb32b, 0xffaf20, 0xffac27, 0xffb743, 0xffb14e, 0xe8c337, 0xecbb30, 0xf8b236, 0xe18a2b, 0xbb5d17, 0xc9732a, 0xeda843, 0xf4bb3a, 0xf68f33, 0xbc5f19, 0x964f25, 0x875942, 0x533729, 0x0c0000, 0x0d0400, 0x433937, 0xaf610e, 0xd48425, 0xf8a432, 0xffab2a, 0xffa923, 0xffac28, 0xfeab33, 0xf7a738, 0xff9f2c, 0xff9535, 0xe47c35, 0xbe5828, 0xa3411c, 0x9c4019, 0x9f4c18, 0xa35316, 0x96522d, 0xa2510f, 0xf39639, 0xffa54a, 0x9d4d06, 0x833800, 0xcf7f28, 0xfea434, 0xb95d06, 0x50281e, 0x624831, 0xc27a30, 0x9d3e08, 0x94562f, 0x894d11, 0xbc5415, 0xf8a71a, 0xffae33, 0xffa83a, 0xfaa030, 0xffa729, 0xffa622, 0xfca023, 0xffa432, 0xffaf36, 0xfea022, 0xad5a00, 0x884d25, 0x965633, 0xa14e0c, 0xae6a2b, 0x583d22, 0x6c2630, 0xba6127, 0xf69b30, 0xc9862b, 0x783b05, 0x984d16, 0xee9c46, 0xf0aa38, 0x924322, 0x9e532c, 0xa45a2d, 0x9b5019, 0x944606, 0xa24e05, 0xc16617, 0xd97a26, 0xf29c23, 0xf8a229, 0xffac32, 0xffb134, 0xffb131, 0xfdaf27, 0xf8ad1e, 0xf5ab18, 0xcd961f, 0x997021, 0x442f14, 0x040002, 0x0e0403, 0x4f331b, 0x8d5524, 0xa65a1c, 0xb26000, 0xe69627, 0xffbf49, 0xf7ab3b, 0xb86c0a, 0xb2650b, 0xe3993a, 0xf4ab44, 0xffb727, 0xffb328, 0xffb834, 0xffb73a, 0xf6ae36, 0xfcb340, 0xfdb141, 0xea9c2d, 0xb28860, 0x7c6458, 0x272331, 0x00000c, 0x101109, 0x1d1a07, 0x1c1d17, 0x121a27, 0x2c1410, 0x261c25, 0x131b1e, 0x192318, 0x1e1b22, 0x190d35, 0x1c1936, 0x0e1e14, 0x191a2f, 0x0f1428, 0x171e30, 0x0e1118, 0x352c1d, 0x6a4a23, 0x7f4c0b, 0xbe7d2d, 0xa65d26, 0x462400, 0x1a1c11, 0x050e17, 0x2c353c, 0x3d4844, 0x0c120e, 0x383637, 0xfcfcfc, 0xfafafa, 0xffffff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xfdfdfd, 0xffffff, 0xfefefe, 0xfcfcfc, 0xfcfcfc, 0xfcfcfc, 0xf9f9f9, 0xfcffff, 0xfcffff, 0x666865, 0x040301, 0x010000, 0x151316, 0x151419, 0x121318, 0x261304, 0x83562c, 0xad6a26, 0x713600, 0x412611, 0x2f3239, 0x17212b, 0x191d1e, 0x23262d, 0x141517, 0x030000, 0x140b0c, 0x2b2129, 0x1d1721, 0x18191e, 0x151b19, 0x20211c, 0x191917, 0x1a1c1b, 0x17181c, 0x141319, 0x1d1a21, 0x211a21, 0x170d15, 0x000811, 0x1c1f28, 0x332830, 0x493131, 0x503323, 0x583a14, 0x6f571b, 0x77631a, 0x7e5207, 0xa36c1c, 0xc57e26, 0xd27f17, 0xe48e17, 0xffb033, 0xffb53c, 0xde9b26, 0xa65000, 0xa6611e, 0x714322, 0x1e0005, 0x11000b, 0x5c382c, 0xb78a39, 0xe5b129, 0xfbb148, 0xffb748, 0xffb43d, 0xffa929, 0xffa221, 0xffa52a, 0xffa733, 0xfba337, 0xf9ac1e, 0xfcb026, 0xffb737, 0xf5aa37, 0xc67c1d, 0x964901, 0x8f420c, 0xa4552a, 0xa24712, 0xa84a02, 0xbd610a, 0xe59347, 0xae682d, 0x864108, 0xcf8031, 0xef942b, 0xa05106, 0x3c1e16, 0x503a25, 0xb66c25, 0xa34005, 0x97562c, 0x8c4f16, 0xbc5616, 0xffad26, 0xfaa52e, 0xf9a135, 0xfea434, 0xffa82a, 0xffa924, 0xffa429, 0xfd9f2e, 0xf7a734, 0xffa72c, 0xb55e00, 0x8e4f23, 0x9b5730, 0xa04b08, 0xa15f22, 0x462e16, 0x4f1a24, 0x9d4e16, 0xea942d, 0xd08d36, 0x8a4b15, 0xb5642d, 0xef9946, 0xbb6e04, 0x954a10, 0x984e1d, 0x924823, 0x893e1e, 0x944719, 0xbf6c26, 0xef9936, 0xffb43e, 0xffa32d, 0xffaa36, 0xffab36, 0xfda42e, 0xf9a32c, 0xfca82e, 0xfcaa2d, 0xf7a527, 0xffb143, 0xf9b844, 0xe1b94a, 0xaa9045, 0x52391a, 0x190000, 0x360600, 0x753d26, 0x9e5511, 0x9a500f, 0xc98033, 0xf5ae44, 0xffc23c, 0xeba31b, 0xb86900, 0xcc762b, 0x7c5921, 0x81622c, 0x7c6132, 0x675128, 0x544120, 0x4b3c1f, 0x43351b, 0x382a10, 0x351200, 0x0e0000, 0x0b0b15, 0x101721, 0x20201e, 0x252317, 0x1b1d1a, 0x0e1821, 0x241518, 0x18171c, 0x151f1e, 0x10170f, 0x22191c, 0x291926, 0x0f060b, 0x0a0e00, 0x0f1000, 0x1f291e, 0x011714, 0x0d2525, 0x343b33, 0x42280f, 0x7b3e11, 0xc16d31, 0x7c4c28, 0x1a0b00, 0x0d1919, 0x17232f, 0x10151b, 0x000200, 0x101109, 0x8b8380, 0xffffff, 0xfafafa, 0xf8f8f8, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffff8, 0xfcffff, 0xd7e2e6, 0x434d56, 0x020911, 0x0e1319, 0x191d26, 0x1f2630, 0x130d11, 0x4e2a10, 0xa8672d, 0x955017, 0x4f2107, 0x22161a, 0x000919, 0x0b212e, 0x00000c, 0x4c4849, 0x685a4f, 0x1e0500, 0x210400, 0x412e2a, 0x12101d, 0x142036, 0x191d1e, 0x131718, 0x1d1e20, 0x1c1d1f, 0x17181c, 0x1a1b20, 0x17171f, 0x13131d, 0x002714, 0x01211e, 0x00091b, 0x000022, 0x080024, 0x0f001a, 0x190913, 0x110400, 0x5c2600, 0x965721, 0xcf8637, 0xf6a730, 0xffbf28, 0xffb120, 0xc97c12, 0x9b4c09, 0x936332, 0x461a00, 0x1d0000, 0x573519, 0xb58f48, 0xf2b948, 0xffb62f, 0xffad24, 0xf8b131, 0xfaac2e, 0xfba629, 0xffa127, 0xffa12a, 0xffa530, 0xffa330, 0xff9f2e, 0xffa94a, 0xef9a2d, 0xefa021, 0xffb92c, 0xffbd35, 0xe09724, 0xaf6409, 0x934500, 0xaf4b0f, 0xb04f0a, 0x9e4600, 0xb5692b, 0xa56331, 0x8d4a16, 0xbf6f28, 0xd4791e, 0x82440b, 0x221212, 0x372718, 0xa75c18, 0xaf4907, 0x995528, 0x8e511b, 0xbd5a19, 0xffb032, 0xe48e1d, 0xe89128, 0xfda537, 0xfea628, 0xffa823, 0xffa52b, 0xf09125, 0xe29126, 0xffad35, 0xbe6404, 0x924e1d, 0xa1582d, 0xa64f0a, 0x97561c, 0x311e0f, 0x301117, 0x82450f, 0xca7b1c, 0xbe7a29, 0x934d19, 0xaf5822, 0xce7124, 0x974600, 0xa84f13, 0xa04b0a, 0x9f5005, 0xb86b13, 0xe5962f, 0xffb13d, 0xffab2b, 0xfe9714, 0xff9f28, 0xff9f29, 0xff9f2a, 0xff9e2b, 0xffa230, 0xffa637, 0xffa53a, 0xfaa236, 0xff9d29, 0xff9f26, 0xfeaf2e, 0xfdc242, 0xe8b94d, 0xab833e, 0x5c331f, 0x250005, 0x60211c, 0x8f5331, 0x975c0e, 0xbc7c0e, 0xeda72b, 0xffb138, 0xffad3e, 0xe78b24, 0x75552f, 0x492c0c, 0x190400, 0x0d0000, 0x0b0600, 0x06090e, 0x000713, 0x000a19, 0x240c02, 0x140a08, 0x192124, 0x121b20, 0x15161a, 0x201c1d, 0x131718, 0x101e1f, 0x12101e, 0x1e2724, 0x0f1d10, 0x181913, 0x372519, 0x240900, 0x251100, 0x695e40, 0x433c29, 0x181e10, 0x041b15, 0x001714, 0x020901, 0x4a2c14, 0xa15931, 0xb85420, 0x321f11, 0x121816, 0x041a25, 0x0e1c29, 0x19181d, 0x080800, 0x47443b, 0xede5e2, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xfbfbfb, 0xfefefe, 0xffffff, 0xf6f6f6, 0xf7efe4, 0xfcffff, 0xf2ffff, 0x80909d, 0x00070e, 0x1e1f23, 0x060910, 0x161e29, 0x141b2e, 0x220c01, 0x814719, 0xbc6b33, 0x9b5028, 0x5d2c1b, 0x211009, 0x030802, 0x080000, 0x201100, 0xaa8e67, 0xb1874d, 0x673400, 0x56300b, 0x241a18, 0x011027, 0x12171a, 0x1f2022, 0x191919, 0x0f0e0c, 0x191718, 0x1b1c20, 0x12161f, 0x141d26, 0x171516, 0x1f1812, 0x2d1c0c, 0x573a1c, 0x7a5123, 0x916121, 0xbb8638, 0xd79f4a, 0xf4b158, 0xf5ac4d, 0xf9ad3f, 0xffb233, 0xf1a424, 0xc37813, 0x9f521e, 0x984a3d, 0x2b1218, 0x523412, 0xa17820, 0xf2b938, 0xffc437, 0xfea821, 0xf89a1e, 0xffa42f, 0xf0a623, 0xf3a425, 0xfda32b, 0xffa431, 0xffa231, 0xffa02a, 0xffa023, 0xffa01e, 0xff932e, 0xff9f31, 0xffa62e, 0xffac2f, 0xfdb338, 0xf5b142, 0xd99a39, 0xbc7e27, 0xa25a32, 0xa45a2b, 0xaa5a25, 0x9f4e16, 0x994810, 0x9e4e13, 0xa85414, 0xb9621b, 0x714015, 0x120e0f, 0x211811, 0x995116, 0xbc5a13, 0x935023, 0x8a4d20, 0xbe5c1b, 0xffac3a, 0xcb750e, 0xd57f1a, 0xfca637, 0xf8a324, 0xfca522, 0xfea52f, 0xe0831c, 0xc27115, 0xffa93a, 0xc4670a, 0x904915, 0x9e5528, 0xaf5a17, 0x8e5220, 0x211610, 0x1c1213, 0x7d4b1a, 0xac620d, 0xa25a10, 0x944b18, 0x9c420e, 0xac500f, 0xa75911, 0xb55e29, 0xad5a16, 0xb66b0e, 0xda931f, 0xffb633, 0xffbe36, 0xffb22b, 0xffa521, 0xffa125, 0xff9e22, 0xffa122, 0xffa92b, 0xffa82f, 0xffa32f, 0xffa034, 0xffa33c, 0xff9938, 0xff9a35, 0xfd9524, 0xf59910, 0xffb61f, 0xffca45, 0xdcaa53, 0xa37746, 0x501f0e, 0x572600, 0x7e4905, 0x9c5d0d, 0xc27525, 0xfea64d, 0xffb240, 0xfa9e17, 0xffba44, 0xf6aa3a, 0xe09834, 0xc18330, 0x99672a, 0x724f27, 0x49331b, 0x271708, 0x22131a, 0x262628, 0x111d1b, 0x121c1d, 0x1e1c21, 0x191219, 0x0c0d0f, 0x17261f, 0x1c2135, 0x102016, 0x040f00, 0x382e22, 0x4a290a, 0x6c4100, 0xc29c51, 0xb39362, 0x0e0008, 0x0a0002, 0x120904, 0x211401, 0x472d0c, 0x915e31, 0xae6230, 0x983d06, 0x140c0a, 0x0b191c, 0x0e222b, 0x161a23, 0x0f0503, 0x231f14, 0x92948f, 0xfcffff, 0xfefefe, 0xffffff, 0xfafafa, 0xffffff, 0xf7f7f7, 0xffffff, 0xfbfbfb, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdf1, 0xfcffff, 0xdbecf4, 0x343d44, 0x060000, 0x25140a, 0x352b29, 0x15161b, 0x08132f, 0x1b1213, 0x552a08, 0xa55520, 0xbd5925, 0xb65a2b, 0xa36534, 0x65410d, 0x593d0b, 0x260700, 0x714800, 0xfbc05c, 0xeaa339, 0x8d5403, 0x553e1e, 0x0a1318, 0x18191d, 0x1e1c1d, 0x1c150f, 0x1b120b, 0x181109, 0x1b1b19, 0x222a2d, 0x0b1820, 0x28191c, 0x1b0802, 0x321702, 0x896739, 0xd3a359, 0xe8ad45, 0xfab735, 0xffbd30, 0xffae2d, 0xfda922, 0xffb02a, 0xfeac3c, 0xcf8033, 0x954b1c, 0x73310f, 0x692c0d, 0x835c11, 0xc8973a, 0xfdbf48, 0xfeaf2e, 0xf39a1a, 0xfc9f28, 0xffa633, 0xf8a12e, 0xf4a32d, 0xfca532, 0xffa837, 0xffa536, 0xff9e2c, 0xfc9c21, 0xfca41f, 0xffad21, 0xfcae0c, 0xffbd2d, 0xf1af3f, 0xb47c2f, 0x734a16, 0x523611, 0x4a391b, 0x493e22, 0x4b342c, 0x5c3725, 0x8b4f2d, 0xab561f, 0xb25009, 0xaf4d04, 0xa64e0e, 0xab5b26, 0x764622, 0x131512, 0x131112, 0x89491d, 0xbf6823, 0x80451b, 0x7f4422, 0xbe5f1b, 0xf9a542, 0xb96505, 0xce7718, 0xffaa3d, 0xf9a626, 0xfca824, 0xffa735, 0xda7d1d, 0xa8590a, 0xffa33f, 0xc56b15, 0x803e0e, 0x8b4a20, 0xb16325, 0x7c491e, 0x131017, 0x1a1710, 0x805123, 0xa95a0f, 0x9b4d0b, 0x9e5221, 0xa75422, 0xa65623, 0x955728, 0x512e18, 0x4f2c18, 0x57341e, 0x623d22, 0x623b10, 0x72490b, 0xaf8030, 0xefbe61, 0xffb33b, 0xffac30, 0xf7a31f, 0xf49e15, 0xfba31b, 0xffa827, 0xffa42b, 0xfc9b28, 0xf99b44, 0xffa335, 0xffab27, 0xffaa21, 0xff9d21, 0xf39921, 0xf8ab2b, 0xffc335, 0xc9a334, 0x815105, 0x6f300d, 0x7e321a, 0x954311, 0xd07a23, 0xfea432, 0xffaa2d, 0xffa701, 0xffa90a, 0xffb527, 0xffb13c, 0xe8a64f, 0xd2a169, 0x87684b, 0x1f0900, 0x1c1624, 0x171c22, 0x000d0d, 0x242a28, 0x241b1c, 0x1d0f0f, 0x23201b, 0x172319, 0x0a101e, 0x162017, 0x151400, 0x513720, 0x976329, 0xe4a73d, 0xf1b84f, 0x632f00, 0x361a0f, 0x59341a, 0x723c0d, 0xaa6524, 0xb66925, 0xa75d20, 0xa15d30, 0x571800, 0x0c0402, 0x232929, 0x141a1a, 0x261712, 0x31170a, 0x0a0000, 0x464e50, 0xdcebfe, 0xffffff, 0xffffff, 0xf4f4f4, 0xfbfbfb, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfcfcfc, 0xf9f9f9, 0xefefef, 0xffffff, 0xfffcf2, 0xbdc3c3, 0x414b4d, 0x080000, 0x270400, 0x7b4e2d, 0x664733, 0x221816, 0x0d152a, 0x15181d, 0x231202, 0x763c17, 0xb04e1d, 0xc65918, 0xf39646, 0xf1ac4d, 0xe2ab4e, 0xdca94d, 0xbf861d, 0xeda223, 0xffc23a, 0xe49725, 0x7f5519, 0x1d1606, 0x181415, 0x0f0601, 0x28180b, 0x675443, 0x463626, 0x0a0300, 0x1b211f, 0x0d1b1e, 0x051a13, 0x18272a, 0x151b29, 0x0f0714, 0x140000, 0x441f00, 0xaa791a, 0xf4bc41, 0xf59618, 0xffab2c, 0xffab38, 0xcc7724, 0x8e3c0a, 0x873e11, 0xa5661f, 0xb57f1b, 0xffc227, 0xffb32f, 0xf6a53a, 0xefa23a, 0xf1a62f, 0xfaa72d, 0xffa637, 0xffa446, 0xfda335, 0xffa536, 0xffa332, 0xfe9f2b, 0xf99e29, 0xf8a52d, 0xf9af34, 0xfab639, 0xe3c06c, 0x9f7f42, 0x4e3318, 0x18050b, 0x030012, 0x000017, 0x000614, 0x001015, 0x000100, 0x0f0402, 0x391404, 0x985329, 0xc0631d, 0xa84500, 0xa64c0d, 0x9c4f21, 0x894f27, 0x222216, 0x0b1016, 0x6c391c, 0xad6729, 0x613312, 0x703c26, 0xbc5f19, 0xed9941, 0xb05c06, 0xcc771c, 0xffb146, 0xfeac2c, 0xffad2b, 0xffad3c, 0xdb8023, 0xa0510f, 0xf2963f, 0xbe6c20, 0x68320c, 0x6d3816, 0xa1602a, 0x5c3313, 0x040a1a, 0x292011, 0x8a5223, 0xb55916, 0xa44e15, 0xa25527, 0xad6437, 0x8a502b, 0x3b1802, 0x000635, 0x00022c, 0x000527, 0x06061e, 0x00000b, 0x010004, 0x0d0c0a, 0x302f2b, 0xc68d33, 0xe8ad49, 0xfbbc48, 0xf1ac2a, 0xe99c12, 0xf6a019, 0xffa525, 0xffa328, 0xfdb026, 0xf4a01a, 0xf7991b, 0xff9e2a, 0xff9f31, 0xff9a24, 0xfe9b1a, 0xffa319, 0xfac430, 0xedaf3e, 0xc17834, 0xac5a35, 0x923d18, 0x963d01, 0xd78323, 0xfca834, 0xf1b32e, 0xebab2d, 0xeaaa3c, 0xb37a23, 0x471c00, 0x120000, 0x09060f, 0x0b122e, 0x191923, 0x151c26, 0x121b20, 0x23221e, 0x120000, 0x4d3628, 0x5c5044, 0x101109, 0x130f0c, 0x211a14, 0x2c190a, 0x6d3e14, 0xe0993f, 0xffc547, 0xf0a42c, 0xc38123, 0xd2ab4c, 0xe2a942, 0xfea93e, 0xfd982e, 0xc5630c, 0x994c16, 0x6f402e, 0x200609, 0x221819, 0x0d0c08, 0x271d11, 0x76503b, 0x714022, 0x190000, 0x060501, 0x323f52, 0xcbcbcb, 0xffffff, 0xffffff, 0xf4f4f4, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xf8f8f8, 0xf1f1f1, 0xc1c1c1, 0x797979, 0x8b8b8b, 0x666762, 0x161b1e, 0x010000, 0x1c0000, 0x8b4915, 0xaf642b, 0x925e39, 0x341d0f, 0x201f27, 0x0a171d, 0x000505, 0x3b251a, 0x934c2e, 0xb25013, 0xd5781b, 0xfeb544, 0xffaa33, 0xfab043, 0xfdb748, 0xfca524, 0xff9c0d, 0xffab30, 0xb87932, 0x311500, 0x1a0f0b, 0x38271d, 0x2d1400, 0x7d5f45, 0x876d54, 0x1b0e00, 0x0a0d04, 0x131f1d, 0x040b35, 0x070a33, 0x00001e, 0x070007, 0x482d10, 0xa87e2c, 0xf0b533, 0xf8b617, 0xfeab33, 0xffb24a, 0xdf8d3b, 0xa14d0f, 0x8d3d02, 0xb76a1c, 0xeba335, 0xffc43d, 0xff972d, 0xff9e21, 0xfea517, 0xf7a61f, 0xf8a636, 0xffa544, 0xffa138, 0xff9c24, 0xffa22d, 0xffa129, 0xfb9d21, 0xf89f21, 0xfbaa34, 0xf9b246, 0xe2a847, 0xca943c, 0x371e17, 0x240b04, 0x200700, 0x3d2519, 0x5f4836, 0x655033, 0x513e16, 0x3d2a00, 0x241600, 0x160c03, 0x0a0000, 0x4a2916, 0x975b27, 0xa7590f, 0xb05b1a, 0xa95624, 0x9d5421, 0x363018, 0x050d18, 0x482215, 0x8f5a26, 0x41210a, 0x653529, 0xb85d14, 0xd98636, 0xa95404, 0xcb771f, 0xffb145, 0xfdab2b, 0xfeab29, 0xffaa3d, 0xdb8027, 0x9b4e16, 0xdb8437, 0xac6523, 0x4f260a, 0x4c270d, 0x8b562a, 0x3b1b04, 0x000923, 0x422c15, 0x9e5827, 0xb95114, 0xa84815, 0xa55a30, 0x8b5026, 0x49270e, 0x050100, 0x000010, 0x151112, 0x362a14, 0x57411a, 0x654d1f, 0x5c4420, 0x3d2813, 0x210f05, 0x1b0000, 0x5e3a00, 0xb48a36, 0xebb549, 0xfbb73c, 0xf9a729, 0xfc9e24, 0xff9d27, 0xfca30b, 0xffaa28, 0xffa93f, 0xfda335, 0xfca325, 0xffa924, 0xffaa33, 0xffa440, 0xf49d29, 0xfaa629, 0xffb93c, 0xef9d37, 0xc36f29, 0x903d07, 0x883900, 0xd68c35, 0xefaf41, 0xeda93e, 0xf9b44f, 0xeeac56, 0xa26e32, 0x442604, 0x0f0600, 0x01050e, 0x030406, 0x060d17, 0x171925, 0x170c08, 0x2f1500, 0x917351, 0x624d38, 0x17100a, 0x4b3a26, 0x120000, 0x4c231d, 0xbe7e41, 0xf59e2a, 0xf99710, 0xf59b20, 0xffb94c, 0xf2b423, 0xffc037, 0xffb63c, 0xd37211, 0xb05f1d, 0x804b2b, 0x1f0d09, 0x111822, 0x1a1720, 0x161513, 0x37220f, 0x925833, 0xbe7443, 0x784214, 0x200700, 0x040002, 0x181818, 0x696969, 0x8a8a8a, 0x757575, 0xd0d0d0, 0xf4f4f4, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfefefe, 0xffffff, 0xa9a9a9, 0x101010, 0x000000, 0x000100, 0x030b0d, 0x463f35, 0x8e613a, 0xb7601d, 0xbc5e16, 0x8f4d1d, 0x371702, 0x130907, 0x1b2c33, 0x01212e, 0x00030d, 0x4f2318, 0x944413, 0xa55500, 0xd1901c, 0xffa625, 0xffa938, 0xf09f34, 0xffa52d, 0xff9912, 0xffa930, 0xe39650, 0x360c00, 0x25160f, 0x8c7668, 0x250500, 0x371300, 0xa08162, 0x56462d, 0x121305, 0x0b1610, 0x37150c, 0x512f14, 0x76531d, 0xb68833, 0xedad41, 0xffb038, 0xffa729, 0xff8f12, 0xfbbb37, 0xd89230, 0x984d0c, 0x8e3f06, 0xd38233, 0xffb44a, 0xffae36, 0xffa328, 0xfb9e37, 0xff9e3c, 0xff9e39, 0xff9e2d, 0xff9c1e, 0xff9e1a, 0xffa422, 0xfea82f, 0xffa526, 0xffa522, 0xffa31b, 0xfda923, 0xfaaf38, 0xd99a39, 0x8d5b12, 0x491c00, 0x715104, 0xa98628, 0xdeb541, 0xefbd36, 0xf7b529, 0xffb22f, 0xffab36, 0xff9e36, 0xaa834c, 0x74624c, 0x28272f, 0x070508, 0x573d1c, 0xa66c2d, 0xa35412, 0xa54b16, 0xa8531a, 0x43381a, 0x000c1a, 0x2d100c, 0x754c1e, 0x2c1505, 0x5e312b, 0xb65c10, 0xc8742b, 0x9f4c00, 0xc7731d, 0xfeac40, 0xf9a727, 0xf8a626, 0xfaa437, 0xd67c24, 0x984c1a, 0xc6722a, 0x9e5c20, 0x3f1f0a, 0x391c0a, 0x7d5029, 0x280d00, 0x000d2c, 0x533417, 0xb26231, 0xb5440a, 0xa74312, 0xb0673e, 0x66320b, 0x190600, 0x212f3a, 0x906b00, 0xc69425, 0xf3b143, 0xfcab3f, 0xfea839, 0xffb23f, 0xf7b239, 0xe0a428, 0x998881, 0x59432b, 0x442500, 0x875a05, 0xdc9f35, 0xffb140, 0xffa534, 0xff9b2d, 0xff9740, 0xff9b2e, 0xfba220, 0xf7ab22, 0xf9b030, 0xfcab36, 0xfea531, 0xfd9e26, 0xff9b2e, 0xffa836, 0xf99b1f, 0xfeab21, 0xffb730, 0xcb841a, 0x944c12, 0x853824, 0xf7900d, 0xffa61f, 0xffa01b, 0xff9919, 0xffab3a, 0xf3ac50, 0xaf7f37, 0x714e14, 0x363833, 0x1b1f2a, 0x131222, 0x1a0804, 0x6b4a27, 0xa58053, 0x200600, 0x2d1f1c, 0x78603e, 0x300c10, 0x501a1a, 0xd58b44, 0xffb12e, 0xffa61c, 0xffae33, 0xf29f27, 0xffb126, 0xffa52b, 0xda8125, 0xaf5f22, 0x7d4522, 0x391f0e, 0x081005, 0x0e2920, 0x171e30, 0x0e1215, 0x3e2813, 0x8f4a20, 0xba5d20, 0xb3682e, 0x845833, 0x4e3227, 0x060606, 0x0a0a0a, 0x000000, 0x0a0a0a, 0xc4c4c4, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7fffb, 0xfcfffd, 0xf8f7f5, 0xfffcfd, 0xfffbfb, 0xf1e6e2, 0x8b8178, 0x080000, 0x12251f, 0x0a1004, 0x3f331d, 0x62472a, 0x4f3117, 0x382612, 0x221f16, 0x121c1b, 0x171b0c, 0x151f17, 0x121f25, 0x0e1621, 0x0f0a10, 0x2d1306, 0x683716, 0x9b5d2e, 0xd68335, 0xf9a449, 0xffad3b, 0xffac29, 0xffa31e, 0xffa92e, 0xf7982c, 0xa44700, 0xdc7914, 0xd58b1e, 0x542200, 0x170000, 0x6d6747, 0x665c41, 0x200700, 0x7a5e1f, 0xfaa52e, 0xffae34, 0xffb337, 0xffb235, 0xfeab2b, 0xf5a21e, 0xf7a51e, 0xffb029, 0xf4a469, 0x914100, 0x994700, 0xf19e38, 0xffb03d, 0xffa52a, 0xffa726, 0xfa9b19, 0xfda22d, 0xfda22d, 0xfea32e, 0xffa42f, 0xffa42f, 0xfea32e, 0xfda22d, 0xfda22d, 0xffaa33, 0xf89d28, 0xfba430, 0xffaf3f, 0xe19327, 0xb36900, 0xb76f09, 0xdd9833, 0xf6b83f, 0xfeb93a, 0xffb02b, 0xfda220, 0xfe9e26, 0xffa531, 0xffaa2f, 0xfcaa2a, 0xffad06, 0xffd257, 0xac8447, 0x160800, 0x070005, 0x523827, 0x8e5c21, 0xb26d12, 0xa86014, 0x744018, 0x240f0c, 0x0b0d1a, 0x222625, 0x2b1500, 0x541a00, 0xac582c, 0xb0631d, 0x923e1a, 0xbc6726, 0xfdac39, 0xf9a528, 0xfeab1f, 0xffb035, 0xc86730, 0x9a3f2a, 0xa45e3a, 0x88602d, 0x362700, 0x161405, 0x262429, 0x1d161e, 0x170d0e, 0xb82f00, 0xce5d23, 0xb96c36, 0x805334, 0x49302c, 0x0d0004, 0x271511, 0x9f8d79, 0xffc823, 0xfdb721, 0xf3ab25, 0xf7ae2e, 0xfcaf2d, 0xf9a521, 0xfea321, 0xffad32, 0xffad2d, 0xffb943, 0xe69d34, 0xaf6b0a, 0xae6808, 0xe4972f, 0xffae3a, 0xfca023, 0xfea32e, 0xfea32e, 0xfea32e, 0xfea32e, 0xfea32e, 0xfea32e, 0xfea32e, 0xfea32e, 0xfda230, 0xfea331, 0xfea331, 0xfba02e, 0xffa533, 0xffaf3d, 0xed9220, 0xb85d00, 0x943c00, 0xf29b4e, 0xffb856, 0xee9b25, 0xf3a020, 0xffac2d, 0xffac33, 0xffb543, 0xfaaa31, 0xf0ab4c, 0x72400b, 0x200400, 0x6d5e59, 0x625b4b, 0x100800, 0x403603, 0xd67a4b, 0xcb6d30, 0x9b3b00, 0xfd9c33, 0xffb33c, 0xf39a22, 0xfda935, 0xffb445, 0xffa237, 0xe4842e, 0x9c5623, 0x572d1d, 0x2a171b, 0x18131a, 0x19191b, 0x1f1e1a, 0x151a1e, 0x181c1d, 0x1e1d18, 0x262014, 0x372a17, 0x4c381f, 0x573e20, 0x583e1d, 0x1c1a1d, 0x131112, 0x040001, 0x918f90, 0xfeffff, 0xf8ffff, 0xf2ffff, 0xf0ffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9fffb, 0xfcfffd, 0xfffffd, 0xfffbfa, 0xf6f0f0, 0xfffdfd, 0xefe9e9, 0x34302d, 0x010000, 0x23221d, 0x201d14, 0x0d0b00, 0x050400, 0x08090e, 0x171a2d, 0x141835, 0x011513, 0x03181b, 0x041b23, 0x041620, 0x01080e, 0x090200, 0x220b00, 0x3d1b00, 0x964d00, 0xc2771c, 0xe09128, 0xf1a02a, 0xf3a22c, 0xffb243, 0xffb754, 0xc88127, 0xf6c55f, 0xb69339, 0x3a240f, 0x060017, 0x251e30, 0x1e0e19, 0x190000, 0x926c3b, 0xffb43a, 0xffad31, 0xffab2f, 0xfba72b, 0xf7a327, 0xffaf33, 0xffb539, 0xfba72b, 0x9b4b02, 0xaf5e0c, 0xe39032, 0xffb043, 0xfca62f, 0xfba126, 0xffa92b, 0xffa426, 0xffa42f, 0xffa42f, 0xfea32e, 0xfea32e, 0xfea32e, 0xfea32e, 0xffa42f, 0xffa42f, 0xfe9e25, 0xffa22a, 0xffa732, 0xffa936, 0xfaa636, 0xf1a336, 0xf5a83e, 0xfab047, 0xffa80e, 0xfa9c16, 0xffa632, 0xffad37, 0xf2a11e, 0xf5a21e, 0xffa533, 0xf99639, 0xffce3f, 0xab891d, 0x433600, 0x10130a, 0x0f131f, 0x1c1318, 0x422515, 0x764b28, 0xba5f26, 0xa46635, 0x462e14, 0x02060f, 0x0c1a37, 0x0f1025, 0x261305, 0x725022, 0xad5e1b, 0x994312, 0xb15a17, 0xf8a138, 0xf9a423, 0xf4a019, 0xfca73a, 0xb85b20, 0xa84700, 0xa5591b, 0x673713, 0x271211, 0x181028, 0x100b21, 0x19120c, 0x392e0e, 0xaf5f24, 0xa1602a, 0x734722, 0x371f15, 0x1a101b, 0x0d0c14, 0x131706, 0x394016, 0xe7af26, 0xf9b836, 0xffb43e, 0xffa234, 0xfe9c31, 0xffa335, 0xfea935, 0xf7a832, 0xfca726, 0xffac34, 0xf7ab3d, 0xeda43e, 0xeda23d, 0xf7a539, 0xfda42e, 0xfb9d1f, 0xffa42f, 0xfea32e, 0xfda22d, 0xfda22d, 0xfea32e, 0xffa42f, 0xfea32e, 0xfda22d, 0xfda230, 0xfca12f, 0xfca12f, 0xf89d2b, 0xf89d2b, 0xffa937, 0xffa937, 0xf19624, 0xa74f08, 0xae5707, 0xe48e2b, 0xffb745, 0xfca82c, 0xf19c1f, 0xfea62b, 0xffa630, 0xffb026, 0xffbb4d, 0x996624, 0x1d0000, 0x1b0c13, 0x1d152a, 0x050014, 0x3b3446, 0xbf8e3f, 0xf1bc60, 0xd09223, 0xf4af2e, 0xffb32a, 0xfcaf25, 0xf3a421, 0xe29416, 0xb76b2f, 0x8c4d21, 0x4a240f, 0x180a0a, 0x030514, 0x010c20, 0x041020, 0x030d19, 0x111224, 0x121121, 0x100f1d, 0x0e0e16, 0x0a0b0f, 0x090909, 0x0b0c07, 0x0e0f09, 0x1f1d20, 0x030000, 0x4d4948, 0xfbf6f3, 0xfffefb, 0xf1f0ec, 0xfffffd, 0xfafcf9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafaf8, 0xfffffd, 0xfcfefb, 0xfeffff, 0xfcffff, 0xfcffff, 0xf8fbff, 0xc2c5ce, 0x291c23, 0x160f16, 0x060b0f, 0x0e1b21, 0x16232c, 0x0f1427, 0x0c0823, 0x120425, 0x2b1517, 0x311919, 0x3a211d, 0x472823, 0x502a21, 0x54281d, 0x5c2a1f, 0x642e22, 0x883e0d, 0x964a16, 0x9b4c11, 0xa95b1b, 0xb26827, 0xbb763b, 0xad6f3c, 0x71380b, 0x55432b, 0x281e03, 0x090504, 0x0a0614, 0x1d1604, 0x3a2400, 0x6f470a, 0xd3a13e, 0xffb033, 0xf8a427, 0xfaa62c, 0xfba62f, 0xf7a22e, 0xffac3d, 0xf49e31, 0xc77104, 0xa55500, 0xe2932c, 0xffb648, 0xfda831, 0xf29d20, 0xfca227, 0xffa72c, 0xffa42c, 0xffa631, 0xffa530, 0xfea32e, 0xfda22d, 0xfda22d, 0xfea32e, 0xffa530, 0xffa631, 0xff9b1f, 0xffa227, 0xffa027, 0xf69922, 0xf9a02a, 0xffac39, 0xffab39, 0xf19d2d, 0xff9a35, 0xffa22f, 0xffa226, 0xffa22e, 0xffa743, 0xf8a642, 0xf7b032, 0xffc731, 0x95895f, 0x322d10, 0x000100, 0x010415, 0x0a0b27, 0x06011f, 0x10021b, 0x1a071a, 0x5a0b10, 0x865245, 0x5d4f34, 0x13220d, 0x031d1a, 0x03151f, 0x13131d, 0x403436, 0xae5e23, 0xa85312, 0xa64a07, 0xec8e34, 0xffb42f, 0xfdaa2a, 0xed9943, 0x9f4b0d, 0xaa4500, 0xbb6c27, 0x68391b, 0x1b0b16, 0x0e0d2f, 0x0c0c28, 0x2f2724, 0x5e4f30, 0x725653, 0x3c251f, 0x160402, 0x090007, 0x060115, 0x060719, 0x00080b, 0x000800, 0x2e1612, 0xb59059, 0xfabf4b, 0xf9a415, 0xffa625, 0xffa238, 0xf79534, 0xfca33f, 0xffa823, 0xf9a427, 0xfba733, 0xffb246, 0xffb045, 0xfda331, 0xfc9e24, 0xffa220, 0xffa530, 0xfda22d, 0xfba02b, 0xfca12c, 0xffa42f, 0xffa530, 0xfea32e, 0xfca12c, 0xfea330, 0xfda22f, 0xffa633, 0xffa431, 0xf99e2b, 0xfca12e, 0xffaa37, 0xffae3b, 0xef9942, 0xb05800, 0xbe6803, 0xfba538, 0xffaa36, 0xf9a028, 0xffa72c, 0xf89e23, 0xfca114, 0xf8aa2e, 0xc58c32, 0x623f07, 0x2f1b03, 0x1f1313, 0x05000a, 0x080012, 0x2c1800, 0x5d4112, 0x70460c, 0xac732e, 0xbf7a2f, 0xbe6e27, 0xad5817, 0xa84f13, 0x954719, 0x833e15, 0x65300e, 0x4c290d, 0x482e17, 0x4d3420, 0x472c17, 0x3e1f0b, 0x321d24, 0x23121a, 0x170b15, 0x120e1c, 0x101624, 0x0c1929, 0x0c1f30, 0x0d2436, 0x0e0f14, 0x3c3d41, 0xd4d4d6, 0xfffffd, 0xfffbf7, 0xfffdf4, 0xf8eee2, 0xfffbed, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcfb, 0xfffffd, 0xf6faf9, 0xf3fcfb, 0xf8ffff, 0xf5feff, 0xfbffff, 0xfcfeff, 0xb4b1ba, 0x1b1821, 0x0a050b, 0x191011, 0x1a0b06, 0x351f11, 0x3e2008, 0x5f3d21, 0x8a4317, 0x954c19, 0xab5b20, 0xbd6825, 0xc66f2a, 0xc46c2c, 0xbd672e, 0xb8622f, 0xaf5e27, 0xa5521c, 0x933e08, 0x903d09, 0x8e400f, 0x874314, 0x72370b, 0x410c00, 0x190000, 0x3a2005, 0x806b32, 0xa7933a, 0xb89e27, 0xdeb134, 0xf5b43c, 0xffb53a, 0xfba627, 0xf5a023, 0xfaa42b, 0xffa835, 0xfca438, 0xf69d35, 0xdc8221, 0xb65c00, 0xf5a431, 0xffb038, 0xfda92c, 0xf39e1d, 0xfca524, 0xffa52a, 0xfc9f28, 0xffa230, 0xffa42f, 0xffa42f, 0xffa42f, 0xffa42f, 0xffa42f, 0xffa42f, 0xffa42f, 0xffa42f, 0xffa426, 0xffa123, 0xff9e22, 0xffa025, 0xffa329, 0xffa229, 0xfba129, 0xf99e29, 0xfea44e, 0xfa973c, 0xff9735, 0xff9320, 0xfb9d21, 0xffc34c, 0xd0a846, 0x624b00, 0x03000b, 0x070004, 0x23110d, 0x452e1e, 0x594127, 0x6d5539, 0x5c472c, 0x291800, 0x230005, 0x1b040c, 0x0c0a0d, 0x0d1e0e, 0x1a3114, 0x18260d, 0x151112, 0x1f0c28, 0x994f22, 0xad5f17, 0x9c4203, 0xcc6c1f, 0xffb635, 0xffad39, 0xcc7838, 0x8e4204, 0xbb6029, 0x904d20, 0x341600, 0x090c05, 0x15262e, 0x17212d, 0x161118, 0x210e10, 0x0e0113, 0x0b0000, 0x311d02, 0x61491d, 0x6c5126, 0x594021, 0x392617, 0x1e0f0a, 0x00001c, 0x060200, 0x775e28, 0xedba51, 0xffbc35, 0xffa61b, 0xffa026, 0xff9529, 0xffa722, 0xffa626, 0xfca22a, 0xf89d2a, 0xfa9c2a, 0xffa02a, 0xffa326, 0xffa422, 0xffa530, 0xfda22d, 0xfba02b, 0xfca12c, 0xffa42f, 0xffa530, 0xfea32e, 0xfba02b, 0xfea32e, 0xfda22d, 0xffa530, 0xffa833, 0xfea32e, 0xf99e29, 0xf99e29, 0xfca12c, 0xffbd53, 0xef9932, 0xca730a, 0xd27a10, 0xfba133, 0xffae3a, 0xfea429, 0xffa626, 0xffa72c, 0xfaa227, 0xfeb743, 0xedb94c, 0xd4ac4a, 0xc1a14c, 0xa08037, 0x856623, 0x3c2012, 0x260300, 0x3d0e00, 0x824121, 0x893d1b, 0x8a3614, 0x8d3318, 0x9e442a, 0xab4c08, 0xb86018, 0xbf7222, 0xbb7722, 0xba7822, 0xb97520, 0xb46918, 0xaa5b0e, 0x925826, 0x7c4819, 0x5e3310, 0x41230b, 0x27160c, 0x110d0e, 0x040813, 0x000918, 0x0c131d, 0xe0e9f2, 0xf8ffff, 0xf9ffff, 0xf2f6f9, 0xeeede9, 0xfffef4, 0xfff9eb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffefb, 0xf2f2f0, 0xfbffff, 0xf7ffff, 0xecf7fb, 0xf7feff, 0xfffeff, 0xcac5cc, 0x404c4c, 0x030000, 0x2c0e06, 0x55210b, 0x6b2800, 0x9e5b15, 0xa86c0c, 0xba8417, 0xde8e1b, 0xe6961b, 0xf19d19, 0xf9a217, 0xfda416, 0xfda51d, 0xffa825, 0xfea92c, 0xec9522, 0xf19a29, 0xed9227, 0xe38a24, 0xd07c19, 0xc87c1a, 0xce8d29, 0xc68b25, 0xd39332, 0xe6a73d, 0xffc540, 0xfbb924, 0xf8ad1c, 0xffb431, 0xffac3b, 0xff973b, 0xffa729, 0xffa72b, 0xfaa129, 0xfda331, 0xffa63b, 0xf49831, 0xe98c2c, 0xf09334, 0xffb437, 0xfaa526, 0xf6a21e, 0xffab26, 0xffae2b, 0xfda328, 0xfa9f2c, 0xffa435, 0xfda22d, 0xfea32e, 0xffa42f, 0xffa530, 0xffa530, 0xffa42f, 0xfea32e, 0xfda22d, 0xffa529, 0xff9d21, 0xff9e22, 0xffa82d, 0xffa82d, 0xff9f26, 0xffa027, 0xffaa31, 0xf2a943, 0xfaaa3b, 0xfca728, 0xffb329, 0xf7b032, 0xa66f1c, 0x421e04, 0x130009, 0x6b4d17, 0x96712a, 0xc79637, 0xe0a52f, 0xebaf2d, 0xf9c03d, 0xeab83d, 0xc49a24, 0x988026, 0x6a551c, 0x2e1d0d, 0x070005, 0x07040b, 0x1a1a1a, 0x1e1e20, 0x131017, 0x62290c, 0x9c5c1e, 0x9c4b13, 0xa44903, 0xe48d1a, 0xdf8b29, 0xa2511a, 0x985015, 0x9e6645, 0x431d06, 0x140a01, 0x142222, 0x0d2120, 0x000802, 0x0b0200, 0x372114, 0x725416, 0xa68133, 0xd8a740, 0xf1b638, 0xf7b932, 0xf2b439, 0xdba13d, 0xbc8532, 0x898521, 0x534715, 0x140000, 0x33150a, 0xa7803b, 0xefb93d, 0xfaaf20, 0xffaa1e, 0xf9a21f, 0xffa929, 0xffa82e, 0xffa028, 0xff9f28, 0xffa72f, 0xffa82b, 0xffa121, 0xffa42f, 0xfda22d, 0xfca12c, 0xfda22d, 0xffa42f, 0xffa530, 0xfea32e, 0xfca12c, 0xfba129, 0xfca22a, 0xfca22a, 0xfca22a, 0xffa52d, 0xfea42c, 0xfca22a, 0xfba129, 0xee9922, 0xffb33f, 0xf39b2f, 0xda7f16, 0xf2972c, 0xffa735, 0xfda027, 0xffa728, 0xffa334, 0xf59620, 0xfba625, 0xffb42a, 0xfbb428, 0xfbb62d, 0xfcb333, 0xfeb439, 0xdfad54, 0xc28b30, 0xc9882a, 0xd18726, 0xc47612, 0xd38320, 0xd98b29, 0xdc9030, 0xee9433, 0xf7a039, 0xfaa838, 0xf5a62f, 0xf1a229, 0xf3a22c, 0xf6a02f, 0xf69b30, 0xdc8712, 0xdc8a1c, 0xcf8526, 0xb27326, 0x8b571d, 0x643811, 0x421e06, 0x2c0d00, 0x09080d, 0x666970, 0xcad4de, 0xf2ffff, 0xf2ffff, 0xf7ffff, 0xf8fefe, 0xf9faf5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffef8, 0xfffffd, 0xf7ffff, 0xf3feff, 0xf9ffff, 0xfaf8f9, 0xa2938e, 0x180200, 0x0f0900, 0x432910, 0x7d4522, 0xb86531, 0xe7893f, 0xf89e3d, 0xfbb039, 0xffc642, 0xffb436, 0xffba37, 0xffba35, 0xffb52a, 0xffaf21, 0xffac1b, 0xffab17, 0xffa914, 0xffad2d, 0xffb134, 0xffad35, 0xffa732, 0xfea02c, 0xf9a32c, 0xffb239, 0xffb93d, 0xffb122, 0xffa22b, 0xffa128, 0xff9d26, 0xffa03d, 0xff9e2d, 0xffa01b, 0xffa82d, 0xfea429, 0xffaa2f, 0xfda32b, 0xfea32e, 0xffa937, 0xf4982b, 0xf3962c, 0xffb64c, 0xfaa026, 0xf49b1d, 0xfda422, 0xffac27, 0xfca323, 0xfda329, 0xffa634, 0xfaa032, 0xfda22d, 0xfda22d, 0xfea32e, 0xfea32e, 0xfea32e, 0xfea32e, 0xfda22d, 0xfda22d, 0xfe9f27, 0xfc9d25, 0xfc9e24, 0xfea026, 0xffa027, 0xff9f26, 0xff9f26, 0xff9f26, 0xf8a227, 0xf1a627, 0xefb43c, 0xc39236, 0x643700, 0x421200, 0x8a5823, 0xdfaa64, 0xf5b839, 0xffbd34, 0xffb724, 0xffab12, 0xffa60e, 0xffa817, 0xffab26, 0xffb033, 0xfcbc34, 0xffc442, 0xd3a037, 0x81571d, 0x3b1e16, 0x11051b, 0x000721, 0x051829, 0x2d0d00, 0x7a4e2b, 0x9f5f31, 0x974605, 0xb35e04, 0xb66111, 0x95460e, 0xad6733, 0x5b4925, 0x1e1206, 0x14101e, 0x0c0d1f, 0x050400, 0x392c09, 0x866a29, 0xc5a04f, 0xf1b32e, 0xffc044, 0xffb23b, 0xffa328, 0xffa720, 0xffaa1c, 0xffaf23, 0xffb42f, 0xffb62e, 0xfec045, 0xcfa445, 0x72581d, 0x3b2500, 0x654715, 0xba9638, 0xf3c744, 0xf7a527, 0xfaa528, 0xffa52a, 0xffa52e, 0xffa52f, 0xffa32b, 0xffa329, 0xfda328, 0xfda22d, 0xfea32e, 0xfea32e, 0xfea32e, 0xfea32e, 0xfda22d, 0xfea32e, 0xfea32e, 0xfca22a, 0xffa931, 0xffa72f, 0xfca22a, 0xffa52d, 0xffa62e, 0xfea42c, 0xfea42c, 0xee9918, 0xfba52a, 0xffad39, 0xfda335, 0xf3962c, 0xfd9e30, 0xffa630, 0xfc9e24, 0xffa939, 0xffa731, 0xffa527, 0xfa9c18, 0xf99815, 0xfe9a20, 0xff9a29, 0xffa237, 0xf7ad2a, 0xffb130, 0xffb837, 0xffaa27, 0xfda623, 0xffae2a, 0xfaae27, 0xfeb62e, 0xffa621, 0xffa51d, 0xffa51d, 0xffab22, 0xffb22d, 0xffb335, 0xffb038, 0xffad39, 0xffbd3b, 0xffbc3f, 0xffb645, 0xfdaf4b, 0xefa550, 0xd58d45, 0xa96327, 0x854009, 0x4a2a15, 0x130000, 0x070000, 0x9ea5ad, 0xf2ffff, 0xf2ffff, 0xf5ffff, 0xf8ffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffff4, 0xfbfdfa, 0xf3fcff, 0xf7ffff, 0xcccdd2, 0x4b3e38, 0x180000, 0x431a00, 0x874a1d, 0xba7743, 0xc77b3d, 0xd98940, 0xe79647, 0xc4782a, 0xad691e, 0xae6e27, 0xa45f12, 0xaf6c25, 0xb97c39, 0xc78c48, 0xdb9d52, 0xf4ad55, 0xffb24c, 0xffaf40, 0xf8a73e, 0xfca73d, 0xfca039, 0xffa13a, 0xffa63c, 0xffa83a, 0xf9a535, 0xed9d2a, 0xffb02f, 0xfa993a, 0xff9735, 0xff9933, 0xff9d4a, 0xff9827, 0xfaa105, 0xfcaa16, 0xf99f27, 0xffa52b, 0xffa52b, 0xffa62c, 0xffa92f, 0xf89e24, 0xf49a20, 0xffaa30, 0xff9f2e, 0xfe9f29, 0xffa429, 0xfda122, 0xf79e20, 0xfea62b, 0xffa836, 0xf79d2f, 0xffa42f, 0xfda22d, 0xfba02b, 0xf99e29, 0xf99e29, 0xfba02b, 0xfda22d, 0xffa42f, 0xfba22e, 0xfca32f, 0xfba22c, 0xfca12c, 0xffa42d, 0xffa82f, 0xffa62e, 0xffa22a, 0xffa712, 0xf8a73e, 0xa5642c, 0x5f2b03, 0x8c5f1e, 0xe3ae46, 0xffbb39, 0xf9a618, 0xfba327, 0xfca227, 0xff9f26, 0xff9e29, 0xff9e2c, 0xff9f30, 0xffa035, 0xffa239, 0xfba02b, 0xfaa21a, 0xffb722, 0xffc540, 0xcf9b45, 0x674927, 0x180f14, 0x000519, 0x0f0909, 0x442c28, 0x8c5c36, 0xa35e1d, 0xa04c0c, 0xa65110, 0xa25716, 0x9d562a, 0x2b2d20, 0x0a0809, 0x070002, 0x240e01, 0x6d4c16, 0xcd9c3f, 0xffc14a, 0xffb737, 0xffab1f, 0xffa22c, 0xfa9430, 0xff9e3e, 0xffa73a, 0xfe9a22, 0xfb9821, 0xffa130, 0xff9839, 0xffaa26, 0xfdb312, 0xf4bf33, 0xd5a751, 0x7c511c, 0x5e3500, 0x9c751a, 0xf6ac33, 0xf3a32a, 0xf99f27, 0xffa22a, 0xffa12a, 0xfb9c26, 0xf9a02a, 0xfca933, 0xfba02b, 0xfea32e, 0xffa631, 0xffa42f, 0xfca12c, 0xfba02b, 0xfda22d, 0xffa530, 0xfca228, 0xffac32, 0xffaa30, 0xfea42a, 0xffa62c, 0xfea42a, 0xfaa026, 0xfca228, 0xffb32c, 0xf8a120, 0xfea62b, 0xffab39, 0xfd9e30, 0xffa030, 0xffa736, 0xfd9e28, 0xf59723, 0xfb9e27, 0xffa127, 0xffa025, 0xffa830, 0xffa835, 0xff9f31, 0xffa037, 0xf7a42a, 0xf7a12a, 0xffa533, 0xffa133, 0xffa73b, 0xfda333, 0xf9a835, 0xffb53f, 0xffb92c, 0xffb42d, 0xffb338, 0xffb749, 0xfbaf4d, 0xe19b43, 0xca8c37, 0xc08634, 0xa67529, 0x9f6b1f, 0x9d6518, 0xac6e21, 0xc78235, 0xdb8f41, 0xdb8c3d, 0xd68335, 0xbb6b30, 0x8f4d1d, 0x4a2103, 0x0e0000, 0x444444, 0xd7dfe2, 0xf2fcfe, 0xf9ffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdf0, 0xfefffb, 0xeff8ff, 0x7c848f, 0x0d0a11, 0x1f0b00, 0x7a5133, 0xa16c40, 0xbb4d10, 0xbc5a13, 0xbf6e1d, 0x9a5907, 0x7a4400, 0x764213, 0x6a3120, 0x622626, 0x47391c, 0x332d17, 0x17190e, 0x0b1009, 0x212212, 0x52441f, 0x7e5e23, 0x956920, 0xc68413, 0xe09a28, 0xf8ab35, 0xffb33b, 0xffb338, 0xffb434, 0xffb835, 0xffba36, 0xf8bf28, 0xfeb63e, 0xffba32, 0xffa516, 0xfc9931, 0xfda335, 0xffb435, 0xeca344, 0xffa22e, 0xffa22b, 0xffa229, 0xfea227, 0xffa326, 0xffa927, 0xffa824, 0xfda21e, 0xff9e33, 0xffa132, 0xffa630, 0xffa92e, 0xffa72c, 0xfea52d, 0xfea531, 0xfda635, 0xffa732, 0xfea32e, 0xf99e29, 0xf59a25, 0xf59a25, 0xf99e29, 0xfea32e, 0xffa732, 0xfba737, 0xf8a231, 0xf8a32f, 0xfca532, 0xfda430, 0xfba02b, 0xfc9f28, 0xffa22b, 0xfca64f, 0xdf912d, 0xc57f0f, 0xd7941f, 0xfdb745, 0xffb542, 0xfda329, 0xffa220, 0xffa338, 0xfb9b34, 0xfea03e, 0xffa645, 0xfba23a, 0xfba12f, 0xffa628, 0xfba31d, 0xfcac39, 0xf49e2d, 0xf99e29, 0xfea527, 0xffb434, 0xfac156, 0xa68041, 0x2a0f00, 0x020c15, 0x100515, 0x654121, 0xab6b2b, 0xa04c1d, 0xa9541b, 0xaf651e, 0x712901, 0x020725, 0x080415, 0x341f0e, 0xa9833c, 0xffc84a, 0xffb922, 0xffa313, 0xff9919, 0xff9f16, 0xffa72a, 0xffa02f, 0xfc9f26, 0xfca41f, 0xfea724, 0xffa838, 0xf3983b, 0xff9d1b, 0xff9b32, 0xff9b43, 0xffa039, 0xffad29, 0xffba30, 0xe29f34, 0xb06d26, 0xf3ac36, 0xf6a933, 0xfda730, 0xffa52f, 0xffa32e, 0xffa32f, 0xfaa531, 0xf6a633, 0xfa9f2a, 0xffa42f, 0xffa732, 0xffa530, 0xfba02b, 0xf99e29, 0xfda22d, 0xffa732, 0xf89e24, 0xffa52b, 0xfba127, 0xf89e24, 0xffa52b, 0xfea42a, 0xfba127, 0xffa72d, 0xf9a31a, 0xfca520, 0xfaa025, 0xfba02b, 0xffa534, 0xff9f2f, 0xfd9d2d, 0xffa736, 0xffaa38, 0xffa530, 0xfea128, 0xfea525, 0xfeaa24, 0xf5a51c, 0xf0a71c, 0xfdb82c, 0xffc239, 0xfcb22d, 0xffb337, 0xffaf39, 0xffb13e, 0xffb23e, 0xffb53e, 0xef9f24, 0xc2992d, 0xae8626, 0x977025, 0x7b5723, 0x4f3512, 0x271700, 0x191401, 0x202111, 0x382819, 0x442f1a, 0x56391b, 0x663d11, 0x713a01, 0x854200, 0xa75c0b, 0xc5751e, 0xce5800, 0xb45005, 0xa25c28, 0x815a3b, 0x130300, 0x0f0c07, 0x979893, 0xfffffb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfafafa, 0xd4e5ff, 0x8995a3, 0x272622, 0x1a0200, 0x6a350b, 0xb05e26, 0xc65616, 0xcb4c09, 0xb05a1d, 0x9e4c10, 0x904108, 0x8e420e, 0x8d4618, 0x8a491f, 0x8d4f28, 0x915731, 0xb7590f, 0xb65810, 0xad5110, 0x893b0a, 0x4b1500, 0x110000, 0x000020, 0x000e40, 0x000328, 0x1a1c29, 0x393720, 0x574c14, 0x7e661c, 0xa47e33, 0xb27f40, 0xad713d, 0x978885, 0x6a5129, 0x734b00, 0xc68a1a, 0xfeb33e, 0xf6a530, 0xee9e23, 0xfeb12f, 0xff9318, 0xed9517, 0xffc247, 0xf5a431, 0xffa835, 0xf0a025, 0xf8aa2e, 0xfda22f, 0xffa22d, 0xfb9d2c, 0xf1a337, 0xf7a93c, 0xf9a22e, 0xfd9f25, 0xffa92e, 0xf1a126, 0xff9135, 0xffb912, 0xebc349, 0x6c3f1e, 0xa06022, 0xffbb3b, 0xffa428, 0xffa03d, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xfba02b, 0xfba02b, 0xffa22b, 0xffa22a, 0xffa32a, 0xffa328, 0xffa328, 0xffa226, 0xffa338, 0xffa434, 0xffa22a, 0xff9f20, 0xffa522, 0xffae2a, 0xf5af2d, 0xeaa929, 0x291d03, 0x03000b, 0x1d1338, 0x553334, 0x95591b, 0xa06515, 0x442a07, 0x0a1227, 0x000020, 0x4f3011, 0xeea536, 0xffb523, 0xfd9d13, 0xffa932, 0xf89f29, 0xfe9f1f, 0xf8a336, 0xf9a336, 0xf9a231, 0xfba22e, 0xfda32b, 0xffa32a, 0xffa327, 0xffa426, 0xfea128, 0xfea128, 0xffa229, 0xffa229, 0xffa32a, 0xffa42b, 0xffa42b, 0xffa52c, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xfda82b, 0xffa537, 0xff9e29, 0xffab21, 0xffb63a, 0x9a610a, 0x674700, 0xeae071, 0xffa230, 0xff9a25, 0xff9a19, 0xffa721, 0xefa22c, 0xf5ad49, 0xfda83d, 0xffa11d, 0xf0a315, 0xf8b31a, 0xf6ab2b, 0xfd9f47, 0xff9f40, 0xffa91e, 0xeea614, 0xf5be49, 0xff9d1f, 0xff9b2b, 0xff9b3b, 0xf29c39, 0xfaa028, 0xffab2f, 0xd58d39, 0x5c3f1d, 0x856733, 0x9f7938, 0xae7d2e, 0xb07a24, 0xa9782c, 0x836332, 0x4e412e, 0x2e2e30, 0x14140c, 0x081013, 0x000717, 0x000119, 0x0d0713, 0x452113, 0x833e14, 0xaa5011, 0xb55717, 0xaf5517, 0xa45216, 0x964e13, 0x894a14, 0x7f4a14, 0x7a4c18, 0x784e1c, 0xa94e21, 0xc56028, 0xc4530f, 0xc5560f, 0xb75e24, 0x5b2809, 0x100708, 0x223448, 0x9b9692, 0xdfdad6, 0xfffefa, 0xf6f2ef, 0xfffffd, 0xf4f4f4, 0xffffff, 0xfcfdff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xf7f7f7, 0x909090, 0x404040, 0x4e4e4e, 0x494949, 0x1e1a01, 0x180100, 0x451400, 0x934a15, 0xba6830, 0xb26632, 0x945728, 0x75441b, 0x3a4237, 0x2c3228, 0x1d1d13, 0x160f07, 0x190a03, 0x26120b, 0x3a1f18, 0x492c26, 0x8d3c1f, 0x9a4727, 0xa6542f, 0xa55b36, 0x8f583a, 0x614432, 0x26221f, 0x00060c, 0x17170f, 0x0e0a07, 0x0d0409, 0x12050e, 0x120005, 0x0f0000, 0x1a0400, 0x2e1707, 0x160000, 0x462000, 0xad7b1c, 0xf6b237, 0xfba92b, 0xf9a328, 0xffaf35, 0xf9a729, 0xffa715, 0xffc35c, 0xb07124, 0xd18122, 0xffad2d, 0xf4a21b, 0xfeac2f, 0xfba02b, 0xffa027, 0xfca228, 0xe89d28, 0xf9ad3d, 0xe89022, 0xffa834, 0xffa928, 0xf4a71d, 0xffaf2c, 0xefb144, 0x7a4f18, 0x5a2d06, 0xd5953b, 0xffac28, 0xffa226, 0xfd9e30, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xfea32e, 0xfda22d, 0xffa22b, 0xffa229, 0xffa129, 0xffa128, 0xffa227, 0xffa328, 0xfba339, 0xffa537, 0xffa432, 0xfda32b, 0xfda328, 0xfca728, 0xfca927, 0xf9a825, 0xa48c4c, 0x291e0c, 0x010012, 0x281823, 0x49270b, 0x512e04, 0x302217, 0x000121, 0x2f2009, 0xb48a42, 0xffbd40, 0xffa418, 0xf59d21, 0xf5a23a, 0xf7a037, 0xffa938, 0xffa432, 0xfea330, 0xffa42f, 0xffa430, 0xffa52e, 0xffa42b, 0xfea227, 0xfb9f22, 0xffa229, 0xffa229, 0xffa229, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xf7a424, 0xffa42f, 0xffa634, 0xfa9a21, 0xffb745, 0xc88a33, 0x593200, 0x846e34, 0xffbd38, 0xffaf2f, 0xfa9917, 0xffa620, 0xfaa62c, 0xeea137, 0xef9e33, 0xfea92c, 0xfca32d, 0xf5a41d, 0xf7a527, 0xfea13a, 0xff9c33, 0xf89b1a, 0xd8911d, 0xc58d42, 0xffc03f, 0xfb9d17, 0xff9b23, 0xffa642, 0xfe9f33, 0xffa726, 0xe8a32e, 0x9b7723, 0x130500, 0x120600, 0x1a0d04, 0x140b0e, 0x010007, 0x00010c, 0x050f18, 0x031217, 0x0c2136, 0x020f22, 0x0a0919, 0x321f25, 0x653f36, 0x8b5338, 0xa05c2f, 0xaa5d27, 0x945e42, 0x7e4a32, 0x5b2e1b, 0x3d170c, 0x290c08, 0x220c0f, 0x1f0f19, 0x20121f, 0x313133, 0x392719, 0x73461f, 0xaa652a, 0xb46425, 0xb26934, 0x884c27, 0x370800, 0x070200, 0x16110d, 0x403b37, 0x5d5956, 0x363533, 0x9c9c9c, 0xfefefe, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xfafafa, 0xffffff, 0xaeaeae, 0x141414, 0x000000, 0x101010, 0x452902, 0x81562b, 0x9b5f2b, 0x98521e, 0x8f5025, 0x60381e, 0x21170e, 0x0a1318, 0x09060f, 0x160d12, 0x2c1915, 0x49271b, 0x683822, 0x834425, 0x8e441f, 0x913f17, 0xa84e19, 0xa84b12, 0x9d3f00, 0x963a00, 0x9b4b0c, 0x995b22, 0x754618, 0x462300, 0x1e1913, 0x1e1a19, 0x16131c, 0x120f24, 0x191837, 0x1f1f43, 0x0b0d33, 0x000023, 0x5e2e00, 0xc48b44, 0xf5b048, 0xfba828, 0xffaa27, 0xffa224, 0xf69c21, 0xffa92e, 0xfbc028, 0xcf9953, 0x6a2f0f, 0xce842b, 0xffad1f, 0xffa61e, 0xfba52e, 0xffaa2f, 0xffa01a, 0xf8a324, 0xffbb49, 0xc87f16, 0xbd6a02, 0xffaa38, 0xf19e1c, 0xffbf31, 0xebc83a, 0x9b7252, 0x2e0406, 0x855815, 0xffc74c, 0xf8a324, 0xffa72b, 0xfea225, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa52e, 0xffa42d, 0xffa22b, 0xfea12a, 0xfda027, 0xfea128, 0xffa129, 0xffa22a, 0xf8a432, 0xf9a737, 0xfdad3e, 0xffaf40, 0xfeac3c, 0xfea733, 0xffa52b, 0xffa42a, 0xfac855, 0x806120, 0x120902, 0x040519, 0x171723, 0x120e0f, 0x120c16, 0x05011a, 0xa87816, 0xffc24e, 0xffb32d, 0xef9b1e, 0xfdae47, 0xfdb056, 0xffaf51, 0xffa940, 0xffa52d, 0xffa32b, 0xffa028, 0xffa128, 0xffa42a, 0xffa42b, 0xfca228, 0xf99f25, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa229, 0xffa229, 0xffa229, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xf4a620, 0xffa628, 0xffa536, 0xfe9730, 0xffaf44, 0xf3af4c, 0x7f5018, 0x250000, 0xb59644, 0xf0bf48, 0xffb818, 0xffae11, 0xfc9f35, 0xcb742d, 0xb86d10, 0xffc439, 0xffa53f, 0xfea42c, 0xfea92a, 0xf89923, 0xff9e28, 0xffa934, 0xc67e2a, 0x551e00, 0xd7ad3f, 0xffc030, 0xffa614, 0xffa235, 0xffa544, 0xfaa524, 0xffbd2a, 0xecb831, 0xb6914d, 0x482c05, 0x080000, 0x101032, 0x1d2651, 0x101c34, 0x0c1512, 0x161b04, 0x051931, 0x15151f, 0x472519, 0x8a4825, 0xb25c23, 0xaf520d, 0x9d4600, 0x964300, 0x91541b, 0x8b4f1b, 0x804a1c, 0x794724, 0x6f422b, 0x5f372b, 0x48251f, 0x391716, 0x07111b, 0x101519, 0x150e06, 0x271200, 0x5d3713, 0x8e582a, 0xa55f2c, 0xa85b25, 0x4a4541, 0x38332f, 0x100b07, 0x030000, 0x070604, 0xc3c3c3, 0xf4f4f4, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0x919191, 0x131313, 0x000000, 0x361a17, 0x331e19, 0x33261e, 0x242017, 0x0b0803, 0x050102, 0x180e17, 0x291b28, 0x703400, 0x8b4c09, 0xaa6719, 0xc4791e, 0xda871d, 0xef951b, 0xf99b17, 0xfb9a0f, 0xf79818, 0xfd9b1e, 0xf8941c, 0xeb861a, 0xe08127, 0xd17a33, 0xa85d26, 0x803c0f, 0x061415, 0x0c1a1d, 0x1a242d, 0x1e252f, 0x0d111c, 0x02020a, 0x151419, 0x353334, 0xf0af55, 0xffba57, 0xffac3d, 0xffa22b, 0xffa027, 0xff9e23, 0xffa628, 0xfdaa2a, 0xd2b446, 0x4f2a00, 0x7c4a25, 0xf8b445, 0xfca30b, 0xffa32b, 0xf49833, 0xf6ab2e, 0xfda714, 0xf9b13b, 0xd99b46, 0x713200, 0xc67e18, 0xffbb43, 0xfbb53b, 0xf3b442, 0x7e7d2d, 0x100005, 0x3d170a, 0xd0a12b, 0xffbc33, 0xf79d2b, 0xffa830, 0xffa523, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa42c, 0xffa42b, 0xffa32c, 0xffa22b, 0xfda22d, 0xfca12c, 0xfba22c, 0xfba22e, 0xfea527, 0xfca82e, 0xffaf3e, 0xffb94e, 0xffbc56, 0xffb450, 0xfeaa47, 0xfca63f, 0xfeac18, 0xe1a239, 0x66461f, 0x00000d, 0x112143, 0x08142c, 0x0e0403, 0x583d28, 0xffb424, 0xffaf24, 0xeea024, 0xfab047, 0xffbf65, 0xffbe66, 0xffb956, 0xfea839, 0xffa52a, 0xffa125, 0xff9b21, 0xfd9b20, 0xfea026, 0xfea42a, 0xfea52d, 0xfea52d, 0xffa52c, 0xffa42b, 0xffa42b, 0xffa32a, 0xffa229, 0xffa229, 0xfea128, 0xfea128, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xfaac26, 0xffaa27, 0xfe9829, 0xffa441, 0xffa129, 0xfdb731, 0xd49f51, 0x2e0000, 0x0f0700, 0x907639, 0xedba3d, 0xfeb421, 0xffaf3b, 0xbd6e23, 0x753700, 0xe7ba55, 0xffa332, 0xef9922, 0xfca82e, 0xffa229, 0xff9c24, 0xffa93a, 0xe29b49, 0x6f3c05, 0x4a3700, 0xecba3f, 0xffb117, 0xff961c, 0xffa541, 0xee9e21, 0xfab01d, 0xfbaf1e, 0xffc44b, 0xcb9437, 0x5f3e09, 0x0c0000, 0x010206, 0x121b1a, 0x1c2214, 0x1e2207, 0x0f1312, 0x302011, 0x6e3e1a, 0xb06224, 0xd57521, 0xdd7a15, 0xe48318, 0xee9424, 0xf89212, 0xf79317, 0xf8951d, 0xf69625, 0xee9328, 0xde8622, 0xca7614, 0xbc690b, 0x994718, 0x662505, 0x3a1407, 0x211517, 0x0d0a11, 0x0a0502, 0x291806, 0x493012, 0x3a3531, 0x1f1a16, 0x040000, 0x090502, 0xb1b0ae, 0xffffff, 0xffffff, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0x949494, 0x191919, 0x070b17, 0x040f21, 0x04162e, 0x001027, 0x11111b, 0x4b2f23, 0x834b26, 0x974b17, 0xca6d05, 0xe98e25, 0xffb043, 0xffb94a, 0xfcb541, 0xf4b33b, 0xf4b83e, 0xf3bc3e, 0xe8b043, 0xe7ae47, 0xe0a74d, 0xcd954a, 0xa8753e, 0x784d2a, 0x4d2a17, 0x32140c, 0x0a2b22, 0x092226, 0x0c1828, 0x0f0b1c, 0x160400, 0x3b2000, 0x896914, 0xd1b03f, 0xf7aa28, 0xfaa42b, 0xf79526, 0xff9b31, 0xff9e31, 0xfb9d2b, 0xffb239, 0xffbd44, 0x736038, 0x2d0d00, 0xc69843, 0xffca36, 0xfb9d09, 0xff9a37, 0xf8a24d, 0xc58d1e, 0xcb8b03, 0xe7af58, 0x63340a, 0x592d00, 0xfcca71, 0xedb846, 0xcf9a3c, 0x734305, 0x0c0f18, 0x0d0000, 0x967319, 0xffd02c, 0xefa220, 0xfca03d, 0xffa430, 0xffa42b, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa128, 0xffa22a, 0xffa42b, 0xffa530, 0xffa632, 0xfca532, 0xf9a332, 0xf8a231, 0xffa31e, 0xfea022, 0xf8a32e, 0xfcad44, 0xffbc5d, 0xffc26c, 0xfdbe6f, 0xf7b96e, 0xfc9603, 0xffb93e, 0xc5873e, 0x1f0d03, 0x061536, 0x0b182b, 0x331c00, 0xcc943d, 0xffad18, 0xef9a1b, 0xfeb654, 0xffc976, 0xffbf68, 0xfeb652, 0xf8ab37, 0xfbab30, 0xff9f28, 0xfe9e26, 0xfd9d25, 0xfd9e26, 0xffa22b, 0xffa62e, 0xffa72f, 0xffa62e, 0xffa52c, 0xffa42b, 0xffa42b, 0xffa32a, 0xffa229, 0xffa229, 0xfea128, 0xfea128, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xfba929, 0xffac2b, 0xfc9826, 0xffa93c, 0xfb9e12, 0xf9b00c, 0xffc54d, 0x8f5527, 0x000009, 0x200b1c, 0x82584a, 0xbf8730, 0xffd044, 0xf5c245, 0x582e00, 0x64413b, 0xffca4a, 0xcb8515, 0xce851e, 0xffb242, 0xffa42c, 0xf39825, 0xffb74b, 0xd9a63d, 0x120300, 0x8e681d, 0xfdb330, 0xffab28, 0xf89d2a, 0xf2a531, 0xf4a127, 0xfc9921, 0xeea228, 0xffc251, 0xddac4d, 0x7a5e15, 0x2b2200, 0x0a0e00, 0x010d19, 0x03132c, 0x121411, 0x1b1811, 0x2e2013, 0x4b3118, 0x754e25, 0xa47436, 0xcd9548, 0xe5a951, 0xfaac3f, 0xfeb043, 0xffb446, 0xffb545, 0xfeb542, 0xfeb743, 0xffbc45, 0xffc049, 0xff922e, 0xd9701d, 0x9c4a12, 0x70381d, 0x4a2e2a, 0x1c1920, 0x000e19, 0x001521, 0x110c08, 0x120d09, 0x211c18, 0xbbb7b4, 0xfffefc, 0xffffff, 0xfcfcfc, 0xf9fafc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xf8f8f8, 0xffffff, 0xfcfcfc, 0xfafafa, 0xffffff, 0xfdfdfd, 0xe6e6e6, 0x0c2c21, 0x000f0e, 0x0f040c, 0x4e272c, 0x884735, 0x93420b, 0xb45a00, 0xf3941c, 0xf4b66d, 0xd79e59, 0xa7753a, 0x734d1c, 0x4e340f, 0x3f2f15, 0x393220, 0x363427, 0x433f36, 0x2f2c25, 0x1d1c18, 0x131716, 0x060e11, 0x00030b, 0x000610, 0x001220, 0x020d13, 0x04080b, 0x110700, 0x3c1f01, 0x895b1f, 0xda9b3c, 0xffb73a, 0xffb525, 0xf2a010, 0xffb12f, 0xff9b29, 0xfc9628, 0xffa537, 0xfeac3e, 0xeeaa45, 0xd1963a, 0x110000, 0x805c20, 0xf4bd3c, 0xf8ae11, 0xffa118, 0xff9f37, 0xffbd6a, 0x846316, 0x936a12, 0xb19162, 0x250f02, 0x59452d, 0xbaa266, 0x83651c, 0x492a00, 0x140000, 0x06001e, 0x64471b, 0xe9b625, 0xffc41e, 0xf29f29, 0xffa745, 0xfc9e2d, 0xffa22c, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa025, 0xffa128, 0xffa32a, 0xffa530, 0xfea734, 0xfda939, 0xfba93b, 0xfaa93d, 0xffa62d, 0xfda027, 0xf39825, 0xf0992f, 0xf8ac4e, 0xffc575, 0xffd08e, 0xf8d095, 0xffab30, 0xffaa2c, 0xffad49, 0x5d3511, 0x000013, 0x030b18, 0x624003, 0xffb931, 0xf6981a, 0xfcb050, 0xffd48f, 0xffca88, 0xfdbd65, 0xfdb141, 0xe7971c, 0xf3a42b, 0xf3a036, 0xf9a439, 0xfda83b, 0xffab3a, 0xffaa36, 0xffa731, 0xfea42a, 0xfba127, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa229, 0xffa229, 0xffa229, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xf6a025, 0xffa830, 0xffa334, 0xff9f28, 0xffa614, 0xfbad0b, 0xf4ad21, 0xefaa43, 0x533e47, 0x0d0015, 0x140011, 0x4c330a, 0x957c17, 0xc1a74a, 0x493212, 0x0d000f, 0xc9a23b, 0x895e10, 0x946014, 0xfcb74f, 0xffab30, 0xf8981d, 0xffb335, 0xf4b728, 0x644845, 0x2d0a00, 0xc7903d, 0xffc749, 0xee9918, 0xffaf41, 0xfea53d, 0xff9c2f, 0xffa132, 0xfd9d25, 0xffb135, 0xffbf4a, 0xd3973f, 0x7f5427, 0x3b1f1c, 0x140019, 0x131315, 0x0d141e, 0x000e21, 0x00041c, 0x000416, 0x060e11, 0x1c190a, 0x271c00, 0x3e3524, 0x3d3522, 0x3b301a, 0x372e11, 0x3b330f, 0x4e451c, 0x696133, 0x7e7645, 0xcb9c42, 0xf7b85b, 0xee9b3f, 0xc36412, 0xa55113, 0x713c1c, 0x2d1b17, 0x0a101e, 0x0e0905, 0x28231f, 0xebe6e2, 0xfffefb, 0xfffffd, 0xeeeeee, 0xffffff, 0xfbfcfe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf2f2f2, 0xf3f3f3, 0xeeeeee, 0x001002, 0x160b00, 0x622c12, 0xa24823, 0xb44c17, 0xc66723, 0xc9812d, 0xab7419, 0x392f0b, 0x221a00, 0x0a0500, 0x050300, 0x0c0c00, 0x0f110e, 0x090d10, 0x03080e, 0x100718, 0x080010, 0x0a020f, 0x1a1116, 0x271d1b, 0x2f2219, 0x3d2d1d, 0x4b3b24, 0x5f3124, 0x683a16, 0x935e18, 0xd39530, 0xffb83f, 0xffb538, 0xffa32e, 0xff992c, 0xfea628, 0xf89b22, 0xffa32a, 0xffad2c, 0xf3a01e, 0xfcb849, 0xdaa45a, 0x552600, 0x150000, 0xd8a64d, 0xfab323, 0xf5991a, 0xffa12a, 0xffac26, 0xf1b754, 0x433616, 0x371b10, 0x362c22, 0x000500, 0x121909, 0x1d1707, 0x180b03, 0x070002, 0x131021, 0x371708, 0xcc9a37, 0xfaad1f, 0xfca023, 0xf59f30, 0xf8a638, 0xf8992b, 0xff9e27, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa126, 0xffa126, 0xffa028, 0xfca32d, 0xfca635, 0xfdab3d, 0xffb145, 0xffb448, 0xfdb455, 0xffb34e, 0xffa53a, 0xf6972b, 0xf8a23d, 0xffbf6a, 0xffd591, 0xf9d9a0, 0xffcc70, 0xf3a630, 0xffb33e, 0x89561d, 0x00000c, 0x000315, 0x7d5b1c, 0xffb31f, 0xefa43e, 0xffcf85, 0xffd7a9, 0xf6c990, 0xffbf64, 0xffab36, 0xf59e2a, 0xfaa842, 0xf5b456, 0xfbb657, 0xffb854, 0xffb44a, 0xfeac3c, 0xfba52e, 0xfda126, 0xfea024, 0xffa229, 0xffa229, 0xffa229, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xfc9f28, 0xffa13a, 0xffa43d, 0xfc9f28, 0xffaa28, 0xffa72b, 0xf09c1f, 0xffbc35, 0xad8255, 0x361d07, 0x060300, 0x0a1101, 0x010200, 0x1d160c, 0x17120e, 0x0c0f06, 0x332604, 0x33200f, 0x5e3e15, 0xe9b44e, 0xfba921, 0xffa120, 0xffab2d, 0xfcad1d, 0xbb9059, 0x180000, 0x613f1a, 0xe8af46, 0xf7a71e, 0xfba536, 0xfda038, 0xff9815, 0xff9d2a, 0xff991e, 0xff9d17, 0xffa41b, 0xffad2f, 0xffb24b, 0xe09345, 0xa65f21, 0x613208, 0x5a3113, 0x4e3121, 0x3e2c2a, 0x291e24, 0x171115, 0x130b08, 0x140d05, 0x010005, 0x080309, 0x100a0c, 0x150c0d, 0x140a08, 0x130600, 0x130500, 0x130500, 0x222300, 0x4d3600, 0xb0782d, 0xe18d35, 0xc2630f, 0xb05d1b, 0x9a592f, 0x5b2910, 0x050000, 0x221d19, 0xece7e3, 0xfffdfa, 0xf3f2f0, 0xffffff, 0xffffff, 0xf9fafc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xfafafa, 0xffffff, 0xd4d4d4, 0x101010, 0x0b0007, 0x593328, 0xa15931, 0xba5b1b, 0xbc5d19, 0xac6632, 0x704d31, 0x2a2016, 0x5c2e1e, 0x663524, 0x7c462e, 0x945438, 0x9b5533, 0x994a23, 0x994519, 0x9f4719, 0x733f18, 0x723d15, 0x763d12, 0x804012, 0x8d440f, 0x9f490c, 0xb45511, 0xc56018, 0xd98429, 0xf6a03d, 0xffb246, 0xffaa35, 0xfe9f27, 0xffa12a, 0xffa231, 0xff9f32, 0xfea63c, 0xffa533, 0xffa624, 0xffae18, 0xf0a913, 0xebb23f, 0xaf824b, 0x1f0000, 0x5e3c21, 0xf5bc4b, 0xf8a219, 0xffa348, 0xff9a2e, 0xffb510, 0xbe911e, 0x101012, 0x130030, 0x0a0d16, 0x132d14, 0x0e2712, 0x050c1e, 0x150f3b, 0x171942, 0x00041e, 0xa47a24, 0xffc13d, 0xffa231, 0xff9e4c, 0xffa739, 0xf8aa2e, 0xfd9e30, 0xff9f22, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa226, 0xffa126, 0xfd9e26, 0xf9a02c, 0xfaa433, 0xfdac40, 0xffb64a, 0xffbc51, 0xf7c37a, 0xffca76, 0xffbe5b, 0xffa437, 0xffa236, 0xffbb5e, 0xffd286, 0xf7d596, 0xf4e099, 0xf2ba49, 0xfaac2e, 0x885513, 0x050311, 0x00041e, 0x8b6c36, 0xffb021, 0xf4b95f, 0xffd79b, 0xeed0aa, 0xffd8a2, 0xffbf60, 0xf49924, 0xffb24a, 0xffbd6c, 0xffca77, 0xffc972, 0xffc366, 0xfdb551, 0xf5a73a, 0xf69f2b, 0xfda126, 0xffa527, 0xfea128, 0xfea128, 0xffa229, 0xffa229, 0xffa32a, 0xffa42b, 0xffa42b, 0xffa52c, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa32a, 0xffa432, 0xff9d3f, 0xfb9a3b, 0xffab37, 0xffa739, 0xfc9e46, 0xffab43, 0xffaa1c, 0xffcb43, 0x846a1f, 0x030900, 0x051b30, 0x0e1f39, 0x091126, 0x161d23, 0x121e12, 0x0b0f2a, 0x04001f, 0x241100, 0xd3a83f, 0xfcae1a, 0xffa322, 0xff9c29, 0xffa524, 0xefbb4d, 0x4d3119, 0x140000, 0xac7e28, 0xffbc33, 0xf79d2b, 0xffa733, 0xffa403, 0xf2a938, 0xf9ae3b, 0xf3a72f, 0xf1a325, 0xfaab28, 0xfbad25, 0xf9ac22, 0xffb529, 0xff9f34, 0xec801d, 0xcb6510, 0xb95e18, 0xa1541e, 0x824519, 0x6c3e1a, 0x694221, 0x743e10, 0x7b4215, 0x83481c, 0x8d4e23, 0x945127, 0x944c26, 0x8f4520, 0x8b3f1b, 0x54413d, 0x381e0d, 0x452200, 0x855219, 0xad6e29, 0xa95f18, 0xa75412, 0xb75f20, 0x3a3531, 0x040000, 0x332e2a, 0xeeeae7, 0xfffffd, 0xfefefe, 0xfbfbfb, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8ffff, 0xfefaf9, 0xfffded, 0xf9f4e1, 0xf9fffd, 0xe6f3fb, 0x2b2d39, 0x070004, 0x712b00, 0x98531c, 0xa05a1e, 0x9c5517, 0xa45a1d, 0x8f440b, 0x863807, 0xa45628, 0xad612d, 0xa55925, 0xa45721, 0xa85720, 0xa34e17, 0x9d440a, 0xa3490d, 0xb25518, 0xb0530d, 0xb95d12, 0xc56a1b, 0xce721b, 0xd87b1c, 0xe48720, 0xf5982e, 0xffa436, 0xffab2f, 0xffa22a, 0xfc9e2a, 0xfca031, 0xfca234, 0xf69e30, 0xf49e2d, 0xf7a32f, 0xf4a82e, 0xf9a02c, 0xff9f28, 0xffa120, 0xffba3a, 0xd7a84c, 0x2a1f00, 0x000513, 0xb58523, 0xffb832, 0xff9c13, 0xffa030, 0xf5a627, 0xe8c43a, 0x56470e, 0x0a0036, 0x1d1d25, 0x21201b, 0x15170c, 0x121b20, 0x101c34, 0x1f1c2f, 0x180000, 0x754312, 0xffbe3b, 0xfeb13b, 0xf9a83d, 0xfba737, 0xfda92d, 0xfea726, 0xfda22d, 0xffa039, 0xfcaa2a, 0xf6a12c, 0xffa238, 0xfe9c2d, 0xff9d23, 0xffa41f, 0xfb9f18, 0xfda623, 0xfda328, 0xfca228, 0xfba129, 0xfba02d, 0xfda132, 0xffa538, 0xffa840, 0xffaa42, 0xffa844, 0xffa642, 0xf7a13c, 0xf19e34, 0xf49e2f, 0xfaa026, 0xff9f1d, 0xff9d17, 0xffbf57, 0xffcc6d, 0xffd184, 0xffc98d, 0xf8c391, 0xf9c999, 0xffd5a3, 0xffdca8, 0xefeac4, 0xffb758, 0xffae2e, 0x8a5d24, 0x070020, 0x000315, 0x847323, 0xffa616, 0xf5c386, 0xfde4bc, 0xf6dfbf, 0xffcc9a, 0xffc585, 0xfcc88c, 0xfcd395, 0xfacb83, 0xffc87e, 0xffb255, 0xffa02a, 0xf99e1c, 0xf4a222, 0xf0a528, 0xf9a529, 0xffa827, 0xf9ae49, 0xfcae49, 0xffae45, 0xffaa3d, 0xffa535, 0xffa22e, 0xffa22b, 0xffa52d, 0xffa126, 0xffa42a, 0xfda027, 0xfda32b, 0xffa931, 0xffa32a, 0xfc9e24, 0xffa328, 0xfd9e26, 0xffa231, 0xfca32f, 0xffaa29, 0xf8a322, 0xfca32f, 0xffae3d, 0xffa22a, 0xffb045, 0xf4aa3d, 0x6f3900, 0x140000, 0x232742, 0x0f1f2e, 0x111518, 0x1c0c17, 0x1b222a, 0x0c1d15, 0x0b1517, 0x634a2b, 0xffc44b, 0xffa217, 0xff9930, 0xffa33c, 0xffbe2f, 0x916608, 0x0c0003, 0x3a2834, 0xdfb44b, 0xffbb12, 0xff9811, 0xff9b2e, 0xffa81f, 0xffa11c, 0xfda01f, 0xffa42b, 0xffa32f, 0xfe9e2d, 0xffa131, 0xffac3a, 0xffab36, 0xffaa35, 0xffa733, 0xf69f2b, 0xe99420, 0xda8413, 0xcb7707, 0xc36f00, 0xb36125, 0xab591d, 0xa14f15, 0x9b4911, 0x9a4711, 0x9e4b15, 0xa4521a, 0xa9571f, 0xab5a19, 0xb46228, 0xa25021, 0x8a3812, 0x93411c, 0xa4552c, 0xa55928, 0xa0551e, 0xbb5a23, 0x581f01, 0x070000, 0x404e51, 0xecf2ee, 0xfffef4, 0xfff7f5, 0xfef9ff, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xf9f9f9, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7feff, 0xfffeff, 0xfffdf2, 0xfffff6, 0xf7ffff, 0x494e51, 0x150706, 0x3b1d15, 0x95500f, 0xb06a2c, 0xaa6228, 0x944b14, 0x9f5321, 0xaa5c2b, 0xa75726, 0xa65625, 0x974712, 0x9a4911, 0xa35210, 0xb15f15, 0xbe6918, 0xc9731e, 0xd9812a, 0xe78d37, 0xf8a138, 0xf7a037, 0xf9a238, 0xffa83c, 0xffaf41, 0xffae3f, 0xffa836, 0xfd9f2e, 0xffa930, 0xffa42d, 0xffa22e, 0xffa531, 0xffa533, 0xfea32e, 0xffa52d, 0xffaa32, 0xf7a22d, 0xffaf47, 0xf99412, 0xffb410, 0xf4b83e, 0x765232, 0x0a0000, 0x21240f, 0xdfa736, 0xffb33d, 0xffa424, 0xff9f1b, 0xffc244, 0xb7943a, 0x1c1000, 0x160f2e, 0x12121c, 0x010000, 0x000200, 0x0b1316, 0x0d182a, 0x07040d, 0x381a00, 0xd4a160, 0xffba39, 0xfcaf3b, 0xfaa940, 0xfcaa3c, 0xffab2f, 0xfea628, 0xfca12c, 0xfda038, 0xf8aa2e, 0xf7a22e, 0xffa538, 0xff9d2e, 0xfe9e25, 0xffa625, 0xfca321, 0xffac2b, 0xfea42a, 0xfea42a, 0xfda32b, 0xfca12e, 0xfda230, 0xffa336, 0xffa53b, 0xffa63c, 0xffb653, 0xffb858, 0xffbb5c, 0xffba5d, 0xfcb857, 0xf9b04a, 0xf5a63d, 0xf3a133, 0xe8aa47, 0xf8bb62, 0xffc980, 0xffcf93, 0xffce9d, 0xfdd1a2, 0xfed6a5, 0xfcd8a6, 0xf5ebc7, 0xffc363, 0xf8ac34, 0x764e1b, 0x0c0322, 0x000a1a, 0x72641d, 0xffaa23, 0xf9c685, 0xfde4bc, 0xf4dfc0, 0xffd0a0, 0xffcc8f, 0xffce94, 0xfdd59a, 0xfccd89, 0xf9b562, 0xf5a542, 0xf59c28, 0xf8a32c, 0xfbb243, 0xfbb651, 0xffb24e, 0xffb049, 0xffb74f, 0xffb44b, 0xffae44, 0xfea839, 0xfba12f, 0xfd9e2a, 0xfe9e26, 0xff9e26, 0xfe9e23, 0xffa129, 0xfca12c, 0xfea531, 0xffaa36, 0xfea32e, 0xfe9f27, 0xffa92e, 0xffa32f, 0xffa334, 0xf99f2d, 0xfba625, 0xfaa524, 0xffa634, 0xffaf40, 0xfea02c, 0xfca73c, 0xffc857, 0xc28b3b, 0x341908, 0x090c1f, 0x05131e, 0x131716, 0x110209, 0x010302, 0x0c1818, 0x040d14, 0x2e1e05, 0xc89335, 0xffae31, 0xffa02b, 0xffa02f, 0xffb023, 0xe2b24c, 0x1a0c03, 0x060009, 0x85651c, 0xffbb39, 0xffa82d, 0xff9e22, 0xfc9c2b, 0xfea02e, 0xfda331, 0xfca532, 0xfda632, 0xfba52e, 0xf89f27, 0xf39b20, 0xfca22a, 0xfda22d, 0xffa630, 0xffa834, 0xffaa37, 0xffab3a, 0xffac3a, 0xffac3c, 0xefa039, 0xeb9c37, 0xe29231, 0xd6852a, 0xc97725, 0xba671b, 0xa8540c, 0x9b4701, 0x964300, 0x9d4c0d, 0xa14e1a, 0xa55226, 0xa9582d, 0xa05222, 0x9a4d17, 0xa2561a, 0xb65822, 0x91512b, 0x3d220f, 0x010100, 0x6f7571, 0xf4f6f3, 0xfffeff, 0xfffdff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfeff, 0xfeffff, 0xf7fdfb, 0xf8ffff, 0x7e8688, 0x070000, 0x371300, 0x9c613f, 0xaa651a, 0xa05917, 0x994d19, 0x9d4e23, 0xa2532a, 0x9e4e1d, 0x96460b, 0x954603, 0xb15c1b, 0xc36d22, 0xd88529, 0xeb982e, 0xf8a430, 0xffac37, 0xffaf3c, 0xffae40, 0xf8a521, 0xfaa723, 0xfdaa28, 0xffab2c, 0xffa82c, 0xfea42a, 0xfaa028, 0xfa9d26, 0xffa631, 0xfda22d, 0xfda029, 0xffa228, 0xffa126, 0xff9e21, 0xff9b1f, 0xff9c20, 0xffa33b, 0xff9926, 0xffab14, 0xffcc2e, 0x9d8034, 0x130117, 0x08000b, 0x6f622d, 0xffbb3a, 0xfba035, 0xff9e27, 0xffad1a, 0xf6be4d, 0x604527, 0x070008, 0x141b14, 0x00000b, 0x474644, 0x85857b, 0x3d4343, 0x0c141f, 0x080300, 0x6a4c18, 0xf8c56a, 0xffb538, 0xf9ad3d, 0xf9aa45, 0xffad43, 0xffae34, 0xfca728, 0xfaa12b, 0xfea139, 0xf6ab38, 0xf9a332, 0xffa635, 0xff9f2e, 0xfca12c, 0xffab32, 0xfca82e, 0xffad31, 0xffa52b, 0xffa52d, 0xfea42c, 0xfea32e, 0xfea330, 0xfea331, 0xffa334, 0xffa336, 0xf8b44f, 0xfaba59, 0xfdc46a, 0xffcc79, 0xffcd7e, 0xfbc67a, 0xf7be71, 0xf7b96c, 0xdfa64f, 0xefb665, 0xffc885, 0xffd39a, 0xffd8a7, 0xffdbae, 0xfddbae, 0xf9d8ad, 0xf8eac7, 0xffcf6e, 0xe39f32, 0x52300b, 0x0f071f, 0x01111e, 0x4f440c, 0xfba52e, 0xffcb87, 0xffe6bd, 0xf3e0c2, 0xffd6a9, 0xffd79e, 0xffd5a2, 0xfcd7a2, 0xfdd192, 0xeeb05b, 0xf7ae4f, 0xffb24b, 0xffbd5a, 0xffc670, 0xffc57b, 0xffc079, 0xffbe73, 0xffb348, 0xffae42, 0xfca73a, 0xfaa332, 0xfca12e, 0xffa22b, 0xffa22a, 0xffa32a, 0xffa027, 0xffa32c, 0xfaa330, 0xfda939, 0xffae3e, 0xfca532, 0xfc9f28, 0xffa82f, 0xffa938, 0xffa73d, 0xf59e2d, 0xf9a221, 0xfda625, 0xffab3a, 0xffb147, 0xf8a130, 0xf9a63c, 0xffbf47, 0xf1bb5b, 0x654828, 0x000007, 0x021013, 0x464b45, 0x887c7c, 0x383224, 0x00000e, 0x0b1521, 0x0c0900, 0x6a4614, 0xffb957, 0xffaa25, 0xff9f20, 0xffa018, 0xf5c04e, 0x5b4f27, 0x000007, 0x271900, 0xb38339, 0xffc057, 0xfca017, 0xfea23d, 0xfca039, 0xf79f33, 0xf7a02f, 0xf8a32e, 0xf9a52b, 0xfaa82b, 0xf9aa2b, 0xffa42d, 0xffa32c, 0xfca12c, 0xfaa12d, 0xf9a22e, 0xfba431, 0xfca635, 0xfea837, 0xffb121, 0xffb126, 0xffae27, 0xfdab2d, 0xffad39, 0xffad43, 0xf69f3e, 0xe79033, 0xc47220, 0xb36014, 0x984501, 0x8d3b00, 0x9c4b13, 0xa95821, 0xa3541b, 0x9b4c11, 0xad5822, 0xa55927, 0x955e37, 0x270f00, 0x070803, 0x929da3, 0xfcffff, 0xfffcfd, 0xffffff, 0xfdfdfd, 0xfafafa, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffffb, 0xf4f8f9, 0xf7ffff, 0xb0bdc5, 0x000000, 0x2b1000, 0x854a20, 0xb8662c, 0x9d5410, 0x994d13, 0xa15325, 0xab5933, 0x9f4c20, 0x934203, 0xaa5c07, 0xd28420, 0xf79e40, 0xfea73e, 0xffaf38, 0xffb02c, 0xffad23, 0xfba723, 0xfaa227, 0xf79e2a, 0xfda92c, 0xfdaa2a, 0xfba828, 0xf8a324, 0xf79f21, 0xfaa123, 0xffa628, 0xffab2e, 0xfea434, 0xfaa12b, 0xf99f24, 0xfea120, 0xffa422, 0xffa524, 0xffa525, 0xffa326, 0xfb9830, 0xfa9a12, 0xffc434, 0xb28931, 0x2c2421, 0x00001e, 0x1a0900, 0xb38d44, 0xffba38, 0xf99b2a, 0xffa129, 0xffbc38, 0xa0792c, 0x0f0007, 0x121429, 0x000700, 0x3b3b47, 0xcfcecc, 0xfffff6, 0x545857, 0x000105, 0x120b00, 0x9f7e37, 0xfbc652, 0xfdb53f, 0xf7ad42, 0xfaaa49, 0xffb047, 0xffae36, 0xf9a528, 0xf8a12d, 0xffa53c, 0xf9b049, 0xf9a437, 0xffa32d, 0xfd9e28, 0xfca836, 0xffb547, 0xf6aa3a, 0xf5a42f, 0xfda32b, 0xfea42c, 0xfea32e, 0xffa42f, 0xffa42f, 0xfea330, 0xfea330, 0xfea330, 0xf2ab37, 0xf2af44, 0xf4ba59, 0xf9c673, 0xfccd87, 0xfdcd8f, 0xffce94, 0xffd198, 0xf4c077, 0xfac883, 0xffd193, 0xffd7a2, 0xffdcaf, 0xffdfb6, 0xfee2bb, 0xfce2bf, 0xfce8c5, 0xffd46e, 0xc0882b, 0x2c1100, 0x0d0917, 0x05141b, 0x271f00, 0xd78e2f, 0xffd288, 0xffedbf, 0xf2e4c7, 0xfedbb3, 0xffdead, 0xffdaae, 0xfad9ac, 0xffd79c, 0xf8c27c, 0xffc578, 0xffcb7c, 0xffd087, 0xffcf91, 0xf5c88d, 0xf9bf7f, 0xffbb73, 0xffaa3b, 0xfca635, 0xf9a22f, 0xfba22e, 0xfea32e, 0xffa62f, 0xffa62e, 0xffa52d, 0xffa42c, 0xfea32e, 0xf5a033, 0xf8ab41, 0xffb44a, 0xfca73a, 0xf69b26, 0xff9e26, 0xfbaa3f, 0xffac47, 0xf9a133, 0xf9a123, 0xfba325, 0xffa83a, 0xffb24d, 0xf8a73c, 0xffb14b, 0xf5ae32, 0xfcc457, 0x8c6c3b, 0x090502, 0x000705, 0x676c65, 0xfffbf9, 0xd0c3b0, 0x302b42, 0x0a1121, 0x0f1511, 0x180600, 0xad7c39, 0xffb531, 0xffa01f, 0xffa825, 0xe9a92e, 0xa7954d, 0x060b05, 0x00000e, 0x3b200f, 0xd59c4b, 0xffbf3a, 0xf79f31, 0xf69c2a, 0xffa22e, 0xffac34, 0xffa92f, 0xfa9d24, 0xf9a028, 0xffae37, 0xffa42c, 0xffa42b, 0xffa32c, 0xfda22d, 0xfba22e, 0xf8a12d, 0xf8a12e, 0xf8a12e, 0xf09d11, 0xf9a61c, 0xfdaa20, 0xf8a41e, 0xf8a420, 0xffaa2b, 0xffab30, 0xfea82f, 0xfdad3e, 0xf4a33a, 0xd68627, 0xb15f0d, 0x9b4802, 0x98460c, 0xa04d19, 0xa55323, 0xa2521d, 0x974104, 0xb26227, 0x8e5a33, 0x0a0000, 0x111b24, 0xbbc2c8, 0xfffef8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefff7, 0xf6fffe, 0xdde7f0, 0x2a2f33, 0x0e0000, 0x71401f, 0xb66931, 0xa14400, 0xa35320, 0xa55425, 0x9f4c20, 0x984513, 0xa75313, 0xc8781f, 0xeb9e2c, 0xffb734, 0xffad2f, 0xffa825, 0xf8a41d, 0xf7a41a, 0xf9a51f, 0xfba72b, 0xffaa3b, 0xffad46, 0xfca442, 0xf59d39, 0xee972e, 0xf29a2c, 0xfda42e, 0xffa92e, 0xffa626, 0xfba01e, 0xfca234, 0xfea531, 0xffa729, 0xffa622, 0xffa41f, 0xffa11f, 0xfe9e25, 0xfe9b26, 0xf5aa2a, 0xffc44d, 0xd39645, 0x3a1f0c, 0x03072a, 0x070c29, 0x432a02, 0xe6ad42, 0xffa82b, 0xffa428, 0xffb33e, 0xd59c43, 0x3f2607, 0x00000b, 0x101a26, 0x000900, 0xcbcbd5, 0xfffffd, 0xfffff8, 0x474948, 0x000004, 0x1e1200, 0xbb9743, 0xffc947, 0xffb849, 0xfaae4c, 0xfbac50, 0xffb24d, 0xfead38, 0xf5a325, 0xf9a22e, 0xffab41, 0xfdb85d, 0xfba63b, 0xff9d25, 0xf99c23, 0xfdb044, 0xffc25e, 0xf2ad46, 0xe89a2d, 0xfba02b, 0xfba02b, 0xfca12c, 0xfea32e, 0xffa52d, 0xffa52d, 0xffa52d, 0xffa52b, 0xffa725, 0xfba82e, 0xfab148, 0xfec168, 0xfeca81, 0xfcca8f, 0xfecc97, 0xffd2a1, 0xffd69e, 0xffd7a0, 0xffd9a3, 0xffdcaa, 0xfcdfb3, 0xfbe3bd, 0xfce7c8, 0xffebd0, 0xffebc8, 0xffd26a, 0x95691e, 0x130100, 0x121015, 0x091718, 0x0b0700, 0xa76c26, 0xffd283, 0xfff4c4, 0xf5eccf, 0xfcdfbd, 0xffe3ba, 0xfcdeba, 0xf8dcb5, 0xffdba7, 0xffd3a7, 0xffd09e, 0xffce96, 0xfdce9a, 0xf4ce9d, 0xefc88f, 0xefb96f, 0xf1ac51, 0xffa731, 0xfea52f, 0xfda22d, 0xfea42c, 0xffa52e, 0xffa52c, 0xffa229, 0xfd9e26, 0xffa32b, 0xf99e2c, 0xeb9c33, 0xf5ad4b, 0xffbc5a, 0xfeaf46, 0xf79c2a, 0xfc9921, 0xf5a947, 0xffb554, 0xffaa40, 0xfba224, 0xfaa123, 0xfca53b, 0xffb453, 0xfcb04e, 0xfdac50, 0xf8b133, 0xffcb52, 0xa78345, 0x170f04, 0x000302, 0x585d56, 0xfffefa, 0xfffcef, 0xaba2b7, 0x020611, 0x131e20, 0x070512, 0x381a00, 0xe4a637, 0xffab34, 0xffa225, 0xf6ab2c, 0xd7b450, 0x252003, 0x070a2b, 0x06000d, 0x533400, 0xd19c36, 0xffc043, 0xfeac2e, 0xf69b19, 0xfd9816, 0xff9f20, 0xffa12b, 0xff9f30, 0xff9c32, 0xffa228, 0xffa32b, 0xffa62e, 0xffa831, 0xffa631, 0xfca32f, 0xf69d29, 0xf19a26, 0xf39b2f, 0xffa73b, 0xffae42, 0xffab3a, 0xfca62f, 0xfba629, 0xfaa620, 0xf8a51b, 0xf6a61d, 0xfbaa27, 0xffb239, 0xf9a83f, 0xd37f29, 0xa75211, 0x98420f, 0x9e471c, 0xa1541e, 0xac5311, 0xad4e0a, 0xb06836, 0x5e3e29, 0x030000, 0x47484a, 0xfefbf4, 0xf9f9f9, 0xfdfdfd, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfffa, 0xf9ffff, 0x616568, 0x0b0000, 0x592f16, 0x9e5a2b, 0xa75615, 0xa54e07, 0xa65226, 0x9d4a18, 0x984406, 0xaf5e0f, 0xdf8f2e, 0xfdad3c, 0xfeb131, 0xfaac24, 0xfaa419, 0xfaa620, 0xffac2c, 0xffb33d, 0xffb145, 0xf6a440, 0xe49133, 0xd68529, 0xc36815, 0xcb7119, 0xda8123, 0xec932d, 0xfaa032, 0xffa42f, 0xfca227, 0xf99d1e, 0xfda134, 0xffa631, 0xffa827, 0xf8a41e, 0xf6a41d, 0xfaa82b, 0xffab3b, 0xffac44, 0xe5bc3c, 0xb6874f, 0x431e18, 0x130a0f, 0x101729, 0x0a0116, 0x8a5e2d, 0xffc030, 0xfba01c, 0xffb02d, 0xfcb452, 0x7f522b, 0x0d0101, 0x172323, 0x000503, 0x4f5257, 0xfeffff, 0xfefdf9, 0xefeae4, 0x545358, 0x020109, 0x31210a, 0xcfa551, 0xffc03a, 0xffbb51, 0xfcb253, 0xfdb058, 0xffb654, 0xffaf3c, 0xf4a225, 0xf7a22d, 0xffae44, 0xffbf71, 0xfdaa42, 0xff9d1e, 0xf79b1e, 0xfab54e, 0xffcc72, 0xf4b558, 0xe89e35, 0xfba02d, 0xfba02d, 0xfba02b, 0xfca22a, 0xfda329, 0xfea429, 0xffa628, 0xffa729, 0xffa21a, 0xffa224, 0xffae40, 0xffc368, 0xffd187, 0xffd095, 0xfdcf9d, 0xffd3a4, 0xffd9af, 0xffdaad, 0xffddaf, 0xffe3b4, 0xfce7bc, 0xf7e7c5, 0xf8ead0, 0xfcefdc, 0xfff0ce, 0xf5c65c, 0x694910, 0x0b0312, 0x1a1b15, 0x0f1b19, 0x05040c, 0x764a1b, 0xffc770, 0xfff7c5, 0xfaf4da, 0xf9e4c5, 0xffe8c6, 0xfae2c6, 0xf7e0c1, 0xffdfb2, 0xfedbbb, 0xffd9b2, 0xffd4aa, 0xf8d2ab, 0xf3d3aa, 0xf6cf94, 0xfabe66, 0xfcae41, 0xfc9e24, 0xfd9f25, 0xfea227, 0xffa429, 0xffa52c, 0xffa52c, 0xffa32a, 0xfea128, 0xff9e26, 0xf49a2a, 0xea9e3c, 0xf6b559, 0xffc569, 0xffb452, 0xf99f2f, 0xff9d25, 0xf1ac4f, 0xffbc60, 0xffb046, 0xfca325, 0xf9a022, 0xfba63c, 0xffb65a, 0xfeb95c, 0xfcad5e, 0xfeb63d, 0xffc747, 0xbf9952, 0x281a0d, 0x000104, 0x5b5f5e, 0xf6f2f1, 0xfef5f8, 0xfff5fe, 0x383836, 0x00080a, 0x151c2c, 0x0b0000, 0x895712, 0xffaf4e, 0xffa429, 0xffab2e, 0xefb33b, 0x775a20, 0x070419, 0x13182e, 0x0b0200, 0x4e2f00, 0xc99933, 0xe8ae42, 0xffb540, 0xffa62b, 0xff9c21, 0xffa22a, 0xffa231, 0xfe982c, 0xff9f24, 0xffa128, 0xffa52b, 0xffa42c, 0xfea12a, 0xf59a25, 0xeb921c, 0xe68d19, 0xcc7518, 0xc87017, 0xce7521, 0xe58c38, 0xffaa4d, 0xffb84e, 0xffb13b, 0xf7a525, 0xfaa71d, 0xf4a21a, 0xfaa725, 0xffb038, 0xfdaa42, 0xe7933d, 0xc26b26, 0x9d470c, 0x9c5014, 0xad5515, 0xab4e0b, 0xa8531c, 0xa36944, 0x422611, 0x070000, 0x848780, 0xffffff, 0xffffff, 0xf4f4f4, 0xfbfbfb, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xeffaf2, 0xaeb7b4, 0x060100, 0x361300, 0x914e24, 0xad591d, 0x964504, 0xa25b1b, 0x9c4711, 0xac5915, 0xce7d21, 0xf5a836, 0xffba3c, 0xfeaf30, 0xf7a42c, 0xfeaa38, 0xfdaa2a, 0xffad39, 0xfba744, 0xe89340, 0xce7d2e, 0xb96a1b, 0xaa5e06, 0xa05700, 0xdd8521, 0xeb942d, 0xfaa339, 0xffa83a, 0xfea432, 0xf99e29, 0xf89e26, 0xfda027, 0xffa234, 0xffa22b, 0xf8a322, 0xf5a71f, 0xfab130, 0xfdb843, 0xf3af4c, 0xe5a34c, 0x7a6c2f, 0x291713, 0x030010, 0x181e1c, 0x101109, 0x1b0000, 0xcc8c4e, 0xffb422, 0xffae19, 0xffaf39, 0xc38145, 0x371410, 0x0a0b10, 0x11251a, 0x000400, 0xb1a9b8, 0xfdfffe, 0xfffff8, 0xfffefa, 0x737079, 0x03000c, 0x3c2716, 0xe6b769, 0xffc03f, 0xffbb57, 0xfdb35a, 0xffb561, 0xffbb5e, 0xffb241, 0xf1a124, 0xf4a12b, 0xffae44, 0xffc47f, 0xffaf49, 0xffa11f, 0xf59c1c, 0xf4b450, 0xffcf80, 0xf9c16c, 0xf8ae4b, 0xffa432, 0xfda22f, 0xfca12c, 0xfba129, 0xfba126, 0xfca325, 0xfea525, 0xffa624, 0xff9d1d, 0xfa9b23, 0xf8a942, 0xffc570, 0xffd995, 0xffdba6, 0xfbdaad, 0xfcdcb3, 0xffdabb, 0xfedcb9, 0xffe2ba, 0xffeabe, 0xfeecc4, 0xf6ebcb, 0xf7efda, 0xfdf5e8, 0xffedcb, 0xdab044, 0x3f2700, 0x0c0924, 0x1e2214, 0x101b15, 0x080a23, 0x4b290d, 0xeeb359, 0xfff4be, 0xfffee2, 0xfbebd1, 0xffecce, 0xfae8d2, 0xf8e4cb, 0xffe0ba, 0xf8e5ba, 0xfde2b5, 0xffdeb5, 0xfcdcb6, 0xfaddb5, 0xffd69b, 0xffc165, 0xffab37, 0xfc9a1b, 0xfc9d1f, 0xffa022, 0xffa125, 0xffa328, 0xffa429, 0xffa52b, 0xffa62c, 0xff9c26, 0xf9a133, 0xf7ae4f, 0xffc46e, 0xffca74, 0xfab152, 0xf49c2e, 0xff9f29, 0xf3b35c, 0xffc26b, 0xffaf48, 0xfaa025, 0xfca227, 0xffaa43, 0xffba63, 0xfbbb64, 0xffba77, 0xffba44, 0xfec240, 0xd5ab5f, 0x2c1a0e, 0x000007, 0x82858a, 0xfdfbff, 0xf6f4ff, 0xfffff6, 0x9f9989, 0x000200, 0x0a181b, 0x100b0f, 0x350d00, 0xc6803a, 0xffb237, 0xffa22d, 0xffa827, 0xc28c34, 0x0e0000, 0x0a1720, 0x121c13, 0x0f030d, 0x291d00, 0x7d642e, 0xd8a85e, 0xffba58, 0xffac38, 0xfca325, 0xfaa322, 0xf8a322, 0xfd9b20, 0xff9e23, 0xffa128, 0xffa42c, 0xffa62d, 0xffa52e, 0xfea32e, 0xfda22d, 0xeea12b, 0xcf8017, 0xaf5d07, 0xa6520a, 0xb15c19, 0xc87529, 0xe7963d, 0xffb04d, 0xffa935, 0xffac33, 0xffad30, 0xf9a626, 0xf8a629, 0xffb23f, 0xf7a43c, 0xd48020, 0xa85a1a, 0x954508, 0xa14c13, 0xa34811, 0xa95622, 0x8a5028, 0x1a0500, 0x030c07, 0xc8c8c8, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xc2d1cc, 0x0d1613, 0x0a0000, 0x713f24, 0xb3612f, 0xa64a09, 0xac5c1d, 0x874a11, 0xae5b17, 0xd8872e, 0xfbae3a, 0xfeb228, 0xf4a817, 0xf4a222, 0xf09b30, 0xe78e32, 0xe18c1f, 0xdb8727, 0xbe681d, 0x913d01, 0x7d2c00, 0x9a5009, 0xd18b33, 0xf8b44f, 0xffae31, 0xfeaa2e, 0xfba72b, 0xfaa42b, 0xfca32b, 0xffa42f, 0xffa530, 0xffa531, 0xff9d2e, 0xffa22b, 0xffaa29, 0xffb831, 0xffbb3c, 0xdb9f2f, 0x985f05, 0x5e2600, 0x000012, 0x050b17, 0x1a2a2a, 0x14201c, 0x140c00, 0x61370f, 0xf5ad58, 0xffac31, 0xffb50b, 0xe89930, 0x7b3b20, 0x150003, 0x141e1f, 0x001000, 0x1c231c, 0xf8e7f7, 0xfefffd, 0xfffef7, 0xfffefa, 0x9993a1, 0x090015, 0x3e261c, 0xe8b46b, 0xffbe43, 0xffbb59, 0xfeb45d, 0xffb765, 0xffc063, 0xffb745, 0xf2a227, 0xf3a02a, 0xffac42, 0xffc584, 0xffb350, 0xffa622, 0xf69d1d, 0xefb351, 0xfdd284, 0xffcb79, 0xffbf5d, 0xffa735, 0xffa533, 0xfda22d, 0xfaa028, 0xf99f24, 0xfaa121, 0xfba220, 0xfda520, 0xffa32d, 0xf89e30, 0xf0a749, 0xf8c377, 0xffd89d, 0xf8ddae, 0xf1deb6, 0xf2e2be, 0xffe1c9, 0xffe1c5, 0xffe7c2, 0xffefc5, 0xfdefc8, 0xf7eecf, 0xfaf3e0, 0xfffdf2, 0xffe6c5, 0xc49b2f, 0x220f00, 0x0b0b2d, 0x1e2211, 0x0d1810, 0x0b0e2f, 0x2e1300, 0xdea146, 0xfff0ba, 0xffffe8, 0xfbefd7, 0xfff0d8, 0xfcedda, 0xf8e8d1, 0xffe2bc, 0xf8edb5, 0xf8e5ad, 0xf5dbaa, 0xf6dab3, 0xffe0ba, 0xffd8a0, 0xffb65d, 0xfc9421, 0xffa322, 0xffa523, 0xffa525, 0xffa123, 0xfb9d21, 0xf89c21, 0xf89e24, 0xfaa026, 0xffa02a, 0xffad41, 0xffbf60, 0xffd17d, 0xffcb77, 0xf1ab4c, 0xee962a, 0xff9f29, 0xf7b964, 0xffc46f, 0xffae48, 0xfa9e23, 0xffa52a, 0xffb14b, 0xffbc67, 0xf7b964, 0xffb075, 0xffb847, 0xffc23f, 0xe0b265, 0x230f04, 0x070512, 0xabadb9, 0xfefbff, 0xf9fbff, 0xfefbe8, 0xddd6bc, 0x191a15, 0x04130c, 0x1d1f2b, 0x280408, 0x7c3d07, 0xe9991e, 0xffa331, 0xffab25, 0xf1aa42, 0x503820, 0x000504, 0x152928, 0x161443, 0x000716, 0x0b0c07, 0x422a04, 0x956418, 0xdf9c31, 0xffba38, 0xffbd2d, 0xfcb924, 0xffa328, 0xffa227, 0xffa126, 0xffa128, 0xffa129, 0xffa32c, 0xffa62e, 0xffa631, 0xf0ad16, 0xfbb533, 0xfcb04e, 0xda8a45, 0x9d4a14, 0x782500, 0x8f3e00, 0xbd6d24, 0xda7c22, 0xe0841f, 0xed9622, 0xf39e1d, 0xef9d15, 0xf8a81f, 0xffb12c, 0xfaab2a, 0xda8b48, 0xaa5f26, 0x9e501f, 0xab5019, 0xaa4809, 0xac612a, 0x5d4225, 0x000400, 0x202020, 0xc8c8c8, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfcfcfc, 0xf9f9f9, 0xffffff, 0xf8f8f8, 0xc3c3c3, 0x040311, 0x130101, 0x633420, 0xa0562f, 0xa94f1d, 0xb1511e, 0xad5223, 0x9c441c, 0xa25c07, 0xb16319, 0xba6125, 0xb75524, 0xb54e21, 0xb7541d, 0xb15512, 0xa64f02, 0x8e4b42, 0x6b2913, 0x5f1b00, 0x8a4406, 0xcc822d, 0xf6a740, 0xffae3a, 0xffab32, 0xfea33a, 0xfba337, 0xfba337, 0xfba536, 0xfba737, 0xfbaa37, 0xfcac39, 0xfdad3a, 0xffb137, 0xffbc50, 0xde9b4a, 0x9d6937, 0x6b4633, 0x321e20, 0x06000f, 0x04041c, 0x22151f, 0x1e2416, 0x102119, 0x060c1a, 0x170200, 0xbb8a2b, 0xffbd2b, 0xffaf1d, 0xfd9d46, 0xa8682b, 0x432d15, 0x060a0b, 0x151c22, 0x010005, 0x544f53, 0xfdf8fe, 0xfffef4, 0xf6f6ec, 0xfbffff, 0xd7dae9, 0x150c1f, 0x1b0300, 0xd3ab6e, 0xfaca64, 0xffbd57, 0xfcb259, 0xffbf75, 0xffb978, 0xfcb269, 0xfcaf53, 0xf4a32e, 0xffad26, 0xfdca9f, 0xffc86a, 0xf7b024, 0xf19d16, 0xffab51, 0xffbe87, 0xf7ca91, 0xeed789, 0xfdcd8d, 0xfcc988, 0xfcc37e, 0xfbbd70, 0xfab75c, 0xf6ae40, 0xeda225, 0xe69a13, 0xe59e1e, 0xffaf3a, 0xff9e1a, 0xe69706, 0xfedb75, 0xf8e9c8, 0xfbe9d5, 0xffe5b0, 0xf2e8e9, 0xe9edde, 0xf7e6c8, 0xffeac3, 0xfff2d8, 0xf0f3f8, 0xfdfbfc, 0xffffd5, 0xc4c770, 0x423f14, 0x06000b, 0x080030, 0x070033, 0x000022, 0x00061c, 0x000111, 0x413713, 0xf3c884, 0xfff9d2, 0xfbfaff, 0xfff8f2, 0xfdedde, 0xfaf6ed, 0xeee6d1, 0xffe9d5, 0xf7e4a9, 0xfef3b1, 0xebe2c3, 0xf8e9cc, 0xffd68a, 0xffa431, 0xff901b, 0xffb44b, 0xe8952d, 0xec9931, 0xf4a23c, 0xf3a747, 0xf5b25b, 0xf3b86a, 0xfcc67c, 0xffca8a, 0xfed597, 0xf9d696, 0xffd08a, 0xffc16b, 0xf7a238, 0xec981e, 0xf9af2c, 0xfbce7b, 0xffca6a, 0xf3af44, 0xf2a03c, 0xffae59, 0xffb667, 0xfab861, 0xfcc662, 0xffb73f, 0xfbb44c, 0xf8ca7d, 0xb8a376, 0x040200, 0x1e231d, 0xf4f8f9, 0xfeffff, 0xfafafa, 0xffffff, 0xfdfdfd, 0x454545, 0x000000, 0x232323, 0x0b0b0b, 0x363636, 0xac5714, 0xf69f40, 0xffb22c, 0xfeae21, 0xb6842f, 0x0b0000, 0x141a26, 0x17201b, 0x181900, 0x171b0c, 0x00050a, 0x000714, 0x211c22, 0x5d452d, 0x9b6c34, 0xdca151, 0xf0ae24, 0xffbb34, 0xffb734, 0xf9aa2b, 0xfba52a, 0xffa32c, 0xffa02d, 0xffa232, 0xfe9e26, 0xffa325, 0xffa723, 0xffa928, 0xeda22f, 0xc0842c, 0x7d4f13, 0x472200, 0x7a2c16, 0x964625, 0xab5524, 0xaa5011, 0xab5009, 0xb55916, 0xb85e22, 0xb05622, 0xb1633c, 0xa55425, 0xa14f15, 0xa24f0d, 0xa25412, 0xa5642a, 0x905a2b, 0x61340b, 0x000400, 0x1e241a, 0xc1c3c0, 0xfbf9fc, 0xfffdff, 0xfffbfb, 0xfff5f2, 0xfffbf3, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xfefefe, 0x989898, 0x050505, 0x0d0000, 0x50311f, 0x955f3b, 0xaa612c, 0xa65111, 0xa24d0a, 0xa25112, 0xa5591d, 0xae5013, 0xa44807, 0x9c4500, 0x9f4f06, 0xa85f1b, 0xa16028, 0x864b21, 0x6c3413, 0x4b1e09, 0x79491b, 0xba8633, 0xedb23e, 0xffbc35, 0xfbb12a, 0xf3a326, 0xf09c2a, 0xffa306, 0xffa70e, 0xffae1b, 0xffb428, 0xf8b331, 0xeaac31, 0xd9a22d, 0xce9a2a, 0x896032, 0x6b451e, 0x3a1c02, 0x150200, 0x0a0300, 0x080e0c, 0x0d1b1b, 0x152928, 0x1b141b, 0x131e18, 0x081a1c, 0x121015, 0x522f05, 0xedaf3e, 0xfaad21, 0xfca92f, 0xc56a19, 0x90551d, 0x311c07, 0x121617, 0x1b2026, 0x000004, 0x787377, 0xfffdff, 0xfffbf8, 0xfffffa, 0xedf3f1, 0xf9ffff, 0x8a8895, 0x0d0000, 0x7f6334, 0xffe090, 0xffc35e, 0xffc568, 0xffbe6c, 0xfeba6f, 0xffc87a, 0xffbe67, 0xf2a440, 0xf8aa3d, 0xf6c985, 0xffcd78, 0xffbd56, 0xf59f30, 0xf29c35, 0xffbc67, 0xffd58c, 0xf9d394, 0xfbd692, 0xfdd695, 0xffd596, 0xffd696, 0xffd691, 0xffd083, 0xffc96f, 0xfac263, 0x8b5205, 0xce822a, 0xffb33a, 0xeea117, 0xf8c063, 0xffe0c8, 0xf2d9d2, 0xfff4cd, 0xebf6ce, 0xfff1cd, 0xffeec7, 0xeefbe9, 0xfbf6fd, 0xfffdf1, 0xfaf4ba, 0xbb9b50, 0x22000c, 0x200000, 0x48260a, 0x745713, 0x7b6303, 0x795e03, 0x694910, 0x472207, 0x300001, 0x0e0800, 0xc1a367, 0xfff0c4, 0xf3edf9, 0xf9ffec, 0xfffaba, 0xffecdb, 0xffeedb, 0xfef1cf, 0xe8dec3, 0xffece5, 0xffebc7, 0xe6ac49, 0xf19c1b, 0xffa930, 0xac7825, 0xa7701d, 0xedb35f, 0xffd380, 0xffcb7c, 0xffdb92, 0xffdb9a, 0xfcd497, 0xffd98c, 0xf5cd90, 0xfad19d, 0xffd692, 0xffbb56, 0xe99823, 0xefa132, 0xffc260, 0xffcf82, 0xfac167, 0xf1ac45, 0xf9a946, 0xffb966, 0xffc476, 0xffc46d, 0xf9c560, 0xfdb64e, 0xffc86f, 0xf9d696, 0x6a5c35, 0x060500, 0x8d928c, 0xfcffff, 0xfafafc, 0xffffff, 0xfafafa, 0xffffff, 0x686868, 0x000000, 0x191919, 0x141414, 0x3b3b3b, 0x9c5012, 0xbf6818, 0xff9f2e, 0xffbc39, 0xe0a942, 0x554015, 0x020001, 0x1b1d2a, 0x242422, 0x1d1d25, 0x121429, 0x131430, 0x090418, 0x140105, 0x250600, 0x3c1500, 0x794c13, 0x9d6d2f, 0xc38d43, 0xe4a74e, 0xffba52, 0xffbb43, 0xffb22d, 0xffb024, 0xffa62b, 0xfd9f21, 0xf99c19, 0xfca321, 0xffb237, 0xf9b548, 0xd8a041, 0xb78733, 0x5a3f24, 0x532f0f, 0x65310a, 0x8f4d1d, 0xaa5d29, 0xa6551d, 0x9c4b13, 0x9c4b13, 0x9f4f0a, 0xa85215, 0xb35522, 0xae4d23, 0xa6461e, 0xa75023, 0xa75a24, 0x9d5719, 0x41290f, 0x0f0000, 0x281c10, 0xafa7a4, 0xfffeff, 0xf2f1f6, 0xfffeff, 0xf7f7f9, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf2f2f2, 0xffffff, 0xffffff, 0xffffff, 0xf3f3f3, 0x7a7a7a, 0x090909, 0x030303, 0x5d2800, 0x9b5e2f, 0xb1692e, 0xa7550c, 0xa75001, 0xa85505, 0xa95c0e, 0xa45c10, 0xa54c22, 0xab5a2d, 0xab6738, 0x945e2f, 0x683f11, 0x482800, 0x4b2f0a, 0x5c4422, 0xc19826, 0xddac36, 0xf5b740, 0xfbb033, 0xfaa725, 0xfdab23, 0xffb527, 0xffba27, 0xffb845, 0xffad41, 0xe19839, 0xbb7e2e, 0x915f20, 0x643e0f, 0x3d1f00, 0x260c00, 0x0e0e0c, 0x010204, 0x04070c, 0x10141d, 0x10171d, 0x111d1d, 0x122218, 0x0d1d10, 0x1b1c20, 0x0b1a21, 0x06171f, 0x1a0d00, 0xbe8735, 0xffba33, 0xffaf31, 0xcf8431, 0xa5550e, 0x814d1e, 0x201001, 0x14191c, 0x10151b, 0x010002, 0xa29e9f, 0xfffeff, 0xfbf2f5, 0xfffefc, 0xf3f9f5, 0xf1fbfc, 0xaaafb3, 0x16130e, 0x0d0000, 0x8c794f, 0xffdc84, 0xfdce76, 0xf5bf69, 0xf9bd67, 0xffbe6a, 0xffc470, 0xffc06d, 0xe8a451, 0xf3cd6c, 0xffca7e, 0xffc788, 0xffb260, 0xeb9b2a, 0xf3ae37, 0xffcf75, 0xffd69e, 0xfadb98, 0xf8d89b, 0xf8d7a2, 0xfad8aa, 0xfedbb1, 0xffdfb2, 0xffe2b2, 0xffe3b0, 0xb08e73, 0x5d3301, 0xce9639, 0xffbd44, 0xec9c3d, 0xffd6b1, 0xffe8e0, 0xe8ecdd, 0xffedb2, 0xf3f4d5, 0xfcffff, 0xf2efff, 0xf8f4d9, 0xfdd26c, 0x894e00, 0x0b0000, 0x723506, 0xa86b34, 0xe2a759, 0xfabe4e, 0xfec037, 0xffc73d, 0xffba49, 0xea9a43, 0xa87824, 0x4e2521, 0x150000, 0x856b0e, 0xfad76f, 0xffeae4, 0xfff7ff, 0xfff8cf, 0xfff3ce, 0xf6f4dd, 0xe5e1de, 0xfff8e8, 0xffd586, 0xf4a515, 0xffbe2b, 0xd99e2a, 0x443000, 0xbca56f, 0xffe5ac, 0xfcda9d, 0xffdfa3, 0xffe8b0, 0xfadca8, 0xf2d8a7, 0xffdf8e, 0xf6cf94, 0xffd2a1, 0xffcc83, 0xf3ab3d, 0xea9f28, 0xfbb95b, 0xffd094, 0xffd08d, 0xf1b463, 0xf1ac4d, 0xffc061, 0xffc573, 0xffbd6f, 0xf6be69, 0xf9cb6b, 0xffd88b, 0xf2cf8f, 0x958051, 0x070100, 0x222419, 0xc0c5c1, 0xf2f2f2, 0xfffeff, 0xffffff, 0xf2f2f2, 0xffffff, 0x858585, 0x0b0b0b, 0x161616, 0x111111, 0x0e0e0e, 0x8e521c, 0x9c460b, 0xdb701e, 0xffac3b, 0xffc347, 0xa98730, 0x120100, 0x181133, 0x161922, 0x11111d, 0x1a1927, 0x292735, 0x1b1926, 0x181520, 0x19141b, 0x140f13, 0x060013, 0x120415, 0x220c0e, 0x3d1e0a, 0x643d12, 0x8e5e20, 0xb98134, 0xdda44d, 0xffb042, 0xffb342, 0xffb33f, 0xffaa31, 0xffa526, 0xffa922, 0xffaf25, 0xffb426, 0xefb547, 0xb38631, 0x5f4717, 0x2c2010, 0x36251e, 0x66412e, 0x96572b, 0xae5d1e, 0x9f5808, 0xa65913, 0xae581f, 0xb15222, 0xad4d1d, 0xad4e18, 0xae5513, 0xb15b10, 0x98603b, 0x532406, 0x170000, 0x100600, 0x909493, 0xf5ffff, 0xf4ffff, 0xf2ffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xebebeb, 0x747474, 0x000000, 0x000000, 0x454545, 0xb56b2c, 0xad6221, 0xa45614, 0xaf601e, 0xaf611f, 0xa3591c, 0xa25c21, 0x9a581e, 0x885d3d, 0x6f4632, 0x4c2721, 0x2d0b0a, 0x290900, 0x523104, 0xa07f30, 0xe2c15a, 0xfdb225, 0xffb424, 0xffb41e, 0xffb11c, 0xffb52e, 0xffb343, 0xdf9f48, 0xbc8640, 0x896040, 0x6e492f, 0x462715, 0x220a06, 0x0f000a, 0x0b0119, 0x0f0b2c, 0x13123a, 0x102013, 0x101d14, 0x19221f, 0x202328, 0x1c1b21, 0x1a1519, 0x1c1412, 0x1a110c, 0x192322, 0x0d1b26, 0x060b0f, 0x53360a, 0xffbf4d, 0xffaf20, 0xf7a238, 0x9e5824, 0x9a551c, 0x643916, 0x190f06, 0x141b21, 0x161b1f, 0x141311, 0x989493, 0xcacacc, 0x9d939e, 0x747277, 0x222824, 0x07140d, 0x101d16, 0x0b110d, 0x1d1e19, 0x110c06, 0x896e37, 0xe9c98c, 0xffdb93, 0xfccd7b, 0xffcf7b, 0xfdc673, 0xfbc376, 0xf8c278, 0xf7d170, 0xf4c27d, 0xffc898, 0xffcd8c, 0xfcb34c, 0xe2a028, 0xf6b654, 0xffd896, 0xfad496, 0xf8d39c, 0xf8d3a6, 0xf7d5b0, 0xf7d8b9, 0xf8dbbb, 0xf6debc, 0xf7dfbb, 0xfffce9, 0x443a21, 0x4b3000, 0xecad4c, 0xffa12d, 0xffb157, 0xfff8d4, 0xedf8fc, 0xfff5ef, 0xf4f5ef, 0xf0fbff, 0xfbe3c9, 0xffc850, 0x9c6300, 0x2e0a00, 0x775353, 0xedb61e, 0xffc245, 0xffbf60, 0xf9b15d, 0xfbb053, 0xffbb52, 0xffbd51, 0xffbb52, 0xf4ca54, 0xf7b65a, 0x604323, 0x191200, 0xaf7605, 0xffc96b, 0xfce0cb, 0xfffbfa, 0xfff8e1, 0xf3f1f6, 0xfffcff, 0xfff5d5, 0xffab3e, 0xffac1c, 0xdda036, 0x3a2400, 0x5a5734, 0xfef6d1, 0xfff3c7, 0xe6ce9e, 0xffe3b1, 0xf3d5a3, 0xedd1a2, 0xf0d5a8, 0xf4d897, 0xffdc9e, 0xffd28e, 0xf6b45e, 0xeba33d, 0xfbb958, 0xffd089, 0xfdcca1, 0xfec389, 0xffc980, 0xffcc74, 0xffc56f, 0xffbf77, 0xfec582, 0xffd186, 0xfbd781, 0xe3cea1, 0x5f512a, 0x0e0800, 0x141608, 0x1d221c, 0x0c0e0d, 0x0f0d0e, 0x393333, 0x737373, 0x949494, 0xd0d0d0, 0x7d7d7d, 0x090909, 0x0d0d0d, 0x1c1c1c, 0x121212, 0x6c451c, 0xa14e26, 0xb64710, 0xe88729, 0xffc843, 0xd8a72e, 0x563407, 0x0d001d, 0x1c211d, 0x1b1e15, 0x191a0c, 0x171808, 0x131709, 0x141d18, 0x0f1e21, 0x051922, 0x061c2a, 0x081a28, 0x04111a, 0x02090f, 0x08080a, 0x0b0301, 0x180d07, 0x33241d, 0x774a09, 0x946120, 0xbe823c, 0xe59c4d, 0xfcaa47, 0xffad32, 0xffa918, 0xffa507, 0xfbab16, 0xffb42d, 0xf2ae43, 0xb98134, 0x603606, 0x210300, 0x231105, 0x453a34, 0x7f5024, 0x82501f, 0x8e5a20, 0x9e6424, 0xa1621f, 0xa05c1b, 0xa35d1f, 0xa66024, 0xa2603e, 0x9d674b, 0x5b3b26, 0x090000, 0x000602, 0x6f7d7e, 0xeffeff, 0xf4ffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xb2b2b2, 0x3e3e3e, 0x000000, 0x000000, 0x1f1f1f, 0x2c2c2c, 0x5b2c02, 0x5e320d, 0x5b3415, 0x4f2b15, 0x492517, 0x573229, 0x59342c, 0x431c15, 0x120d00, 0x0e0300, 0x220c00, 0x613d1b, 0xb88448, 0xf9b854, 0xffbf35, 0xffb10f, 0xffb83b, 0xffb036, 0xed9d2e, 0xc78024, 0x996222, 0x664222, 0x352120, 0x150a1a, 0x00040b, 0x00040b, 0x000b13, 0x06141f, 0x0e1c29, 0x111e2e, 0x0e1b2b, 0x0b1829, 0x111f12, 0x141f17, 0x101614, 0x101116, 0x1b181f, 0x251f23, 0x281e1d, 0x2b201c, 0x142222, 0x070c10, 0x251400, 0xc19242, 0xffbb3d, 0xfea227, 0xb86313, 0x985028, 0x905930, 0x3c1e06, 0x1a1615, 0x0f181f, 0x14181b, 0x100c09, 0x282421, 0x1c1e1d, 0x030007, 0x000005, 0x161c1c, 0x313c34, 0x1a271d, 0x000400, 0x030a10, 0x030617, 0x0e0100, 0x432f16, 0x9c8156, 0xf7d598, 0xffdf96, 0xf4cb7c, 0xfcd383, 0xf2c97a, 0xf8cc81, 0xf8c785, 0xffc990, 0xffd697, 0xffcf7e, 0xebae51, 0xe9aa4d, 0xffc871, 0xffd69f, 0xffd7a6, 0xffd7ad, 0xffd7b2, 0xffd9b4, 0xfcdab4, 0xfaddb1, 0xfae0af, 0xfdffd5, 0xb4bba9, 0x060000, 0x835615, 0xffbc37, 0xe99300, 0xffd685, 0xfffeff, 0xebfafd, 0xfff8ff, 0xffe59c, 0xffd74a, 0xa67823, 0x1b0000, 0x644119, 0xffbe52, 0xffca5f, 0xffca70, 0xfdc178, 0xfac076, 0xfeca76, 0xfbc970, 0xf4c472, 0xf8c782, 0xf4bf71, 0xf8d561, 0xffc94e, 0x773503, 0x240000, 0xa77b02, 0xfecf39, 0xf4ecc5, 0xfff8f8, 0xfcefff, 0xfff7f8, 0xfac68a, 0xffa22e, 0xffa841, 0x744124, 0x000022, 0xd4cfaf, 0xfef4d0, 0xecd9af, 0xfde1b1, 0xffe7b5, 0xf4cf9b, 0xffdeac, 0xfbd9ab, 0xf3d6ae, 0xffdd9c, 0xfcc76b, 0xebaa4c, 0xf6b466, 0xffcd91, 0xffd39d, 0xf4cd96, 0xf9c08b, 0xffd38d, 0xffce7b, 0xf3bf73, 0xffd498, 0xffebb8, 0xe4c58f, 0x9e8648, 0x2b2914, 0x181705, 0x060800, 0x010600, 0x000100, 0x1b1c1e, 0x353334, 0x130d0f, 0x060606, 0x000000, 0x272727, 0x242424, 0x0c0c0c, 0x1f1f1f, 0x1c1c1c, 0x070707, 0x3b220c, 0xa15436, 0xb1461c, 0xb55e17, 0xf3b53c, 0xf9be34, 0xb37f33, 0x220108, 0x11100c, 0x26261c, 0x212214, 0x101300, 0x161d0d, 0x18231b, 0x111f20, 0x101e27, 0x0e260e, 0x0e2712, 0x0b2313, 0x0c261d, 0x0e2626, 0x021b22, 0x001321, 0x051c2e, 0x00090c, 0x040c0f, 0x181413, 0x342216, 0x5c3b1a, 0x936325, 0xcb9239, 0xf2b34a, 0xffb237, 0xffa826, 0xffa31c, 0xffae2c, 0xffae40, 0xbd893e, 0x59431c, 0x0b0900, 0x170000, 0x190300, 0x362110, 0x503c24, 0x4f3a1f, 0x4c3315, 0x4e3316, 0x4c2d11, 0x562612, 0x5b3626, 0x362013, 0x19150c, 0x010600, 0x000300, 0x464942, 0xd0d0c8, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0xf0f0f0, 0x7f7f7f, 0x181818, 0x202020, 0x212121, 0x020202, 0x0b0b0b, 0x0b0706, 0x000007, 0x081120, 0x031229, 0x010f29, 0x0e122b, 0x070216, 0x07000b, 0x1b1000, 0x6a5520, 0xc49f46, 0xfac043, 0xffbc2b, 0xffb01d, 0xffa617, 0xff9d17, 0xb98633, 0x956429, 0x5f371e, 0x2b1019, 0x09001a, 0x000020, 0x000928, 0x011631, 0x000b29, 0x000c26, 0x000b21, 0x020919, 0x040811, 0x07060b, 0x080705, 0x0b0803, 0x030000, 0x151014, 0x1b181f, 0x171721, 0x181b22, 0x151a1d, 0x101a12, 0x131f13, 0x111c20, 0x0b0000, 0x865a1b, 0xffc553, 0xfab33d, 0xc17424, 0x803000, 0xaf5f2c, 0x70462d, 0x190500, 0x1c1d22, 0x0e1821, 0x1d2122, 0x26231c, 0x14140c, 0x020703, 0x07080d, 0x51545b, 0xe2e5ea, 0xfbfffd, 0xe5ede0, 0x8e958d, 0x272b34, 0x000016, 0x010005, 0x040000, 0x0a0000, 0x523e23, 0xbea678, 0xf9db9d, 0xffe097, 0xf8d786, 0xfbc893, 0xffd496, 0xfcd18d, 0xfbcf8e, 0xffda9f, 0xffd091, 0xf0bb6b, 0xedb757, 0xffd7a1, 0xffd8a6, 0xffdaac, 0xffd8b0, 0xffdab0, 0xffddae, 0xffe1ad, 0xffe6ad, 0xebe4ae, 0xfeffea, 0x464c4a, 0x1f0600, 0xde9e32, 0xffb81c, 0xe7ae3d, 0xfcdab7, 0xfff9ca, 0xfff59f, 0xefbb41, 0x9c7122, 0x292317, 0x543300, 0xeb9d15, 0xfcb71e, 0xffce7a, 0xffd591, 0xffd5a0, 0xfdcf9b, 0xf7cf91, 0xf3d28f, 0xf2d39a, 0xf4d5a9, 0xfee591, 0xf2c858, 0xffbb29, 0xf29619, 0x5d2e02, 0x251c17, 0xa0884a, 0xffcc40, 0xffeec2, 0xfff6ca, 0xf7d888, 0xe1ab25, 0xffc534, 0xd8923a, 0x200300, 0x5a667c, 0xfffedb, 0xf5e3bd, 0xf7dcb1, 0xffe1b1, 0xffddaa, 0xffdba9, 0xffdcab, 0xffdaad, 0xffdcc0, 0xfbcf90, 0xf0b95c, 0xf5bc63, 0xffd098, 0xffd1ad, 0xf4cc9b, 0xfbd68f, 0xffd19d, 0xf2c280, 0xf2cb7e, 0xffe6a3, 0xf7daae, 0xa69176, 0x46361d, 0x0d0200, 0x000500, 0x000200, 0x040905, 0x383a39, 0x9c9d9f, 0xf5f5f7, 0xfefcff, 0xe7e5ea, 0x434343, 0x000000, 0x030303, 0x181818, 0x181818, 0x171717, 0x121212, 0x232323, 0x1d1210, 0x8e4928, 0xb7582a, 0x7f3d0b, 0xaf7b27, 0xffc344, 0xfab74c, 0x7b521e, 0x0a0004, 0x1c121b, 0x212129, 0x141b23, 0x181d23, 0x17151a, 0x1e0f14, 0x220d12, 0x110604, 0x0f0504, 0x060000, 0x040406, 0x090e12, 0x020d13, 0x00070e, 0x000a12, 0x000d26, 0x00112a, 0x00132f, 0x000b23, 0x000312, 0x010506, 0x241c0f, 0x44351e, 0xa05e2a, 0xd58c47, 0xffad4d, 0xffac34, 0xffab2b, 0xffb73e, 0xf9b248, 0xdc9d3e, 0x5c442c, 0x2b170e, 0x0b000c, 0x05001d, 0x040025, 0x0e0e28, 0x171721, 0x0c0c0a, 0x180500, 0x0b0000, 0x110c09, 0x11110f, 0x1c1e1b, 0x292621, 0x281f16, 0x8f8174, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf2f2f2, 0xf1f1f1, 0xfefefe, 0xf1f1f1, 0xd7d7d7, 0xcecece, 0xd3d3d3, 0xc7c6d8, 0x282e44, 0x000c25, 0x0c2136, 0x04151f, 0x070802, 0x241400, 0x6f532e, 0xc99c49, 0xe6af48, 0xffba34, 0xffb41d, 0xffa718, 0xea9224, 0xbb6c29, 0x90461f, 0x331f28, 0x1b0f19, 0x03030d, 0x00040d, 0x030c11, 0x101211, 0x1c130c, 0x241309, 0x4d2315, 0x542a1a, 0x5c331f, 0x60381f, 0x5f381b, 0x5e3814, 0x5d3a12, 0x5f3c12, 0x8c5b30, 0x835732, 0x704c34, 0x4c3126, 0x221411, 0x0f0d0e, 0x141c1e, 0x1c2729, 0x0a121d, 0x462502, 0xeba438, 0xffbc2b, 0xe0a541, 0x6a3114, 0x82381d, 0xbb6019, 0x573728, 0x180a07, 0x19202a, 0x0b151f, 0x171b1c, 0x1f1c13, 0x1d1d15, 0x1c211d, 0x000401, 0x93989e, 0xfcfeff, 0xfcfcfe, 0xfffff4, 0xfffff4, 0xf1eff2, 0x938ea2, 0x424a4d, 0x4b5056, 0x3a3941, 0x040000, 0x0d0000, 0x9a8361, 0xfae0a7, 0xf7d993, 0xffcd9f, 0xffd79f, 0xfbd898, 0xf0d399, 0xf5d9a9, 0xffe0ad, 0xfcd592, 0xefc56f, 0xf5cf91, 0xf9d59b, 0xffdcad, 0xffe1b7, 0xffe1bc, 0xffe0b8, 0xffdeb4, 0xffdfb0, 0xfddebf, 0xfff9d7, 0xa3ae9e, 0x060000, 0x6d4416, 0xf4b448, 0xeea62e, 0xe8a147, 0xe9c881, 0xb78700, 0x725722, 0x281439, 0x551b00, 0xde9620, 0xffd05f, 0xedaf3e, 0xface65, 0xffd484, 0xffd9a2, 0xffd3a4, 0xfecd95, 0xffd492, 0xffda99, 0xffd398, 0xfae393, 0xffbe4a, 0xf2b342, 0xffc45c, 0xdc8f37, 0x401d17, 0x140919, 0x874801, 0xb89e4a, 0xecc665, 0xebb72f, 0xecb30e, 0xe2ab2c, 0x6b4611, 0x070100, 0xb2c8a1, 0xfff1ce, 0xfeeac5, 0xffeec6, 0xf7d6a9, 0xf9d7aa, 0xffe4ba, 0xf5d5ae, 0xf9ddb8, 0xffd9b3, 0xfac78e, 0xfac17a, 0xffd190, 0xffddb0, 0xf4d4ad, 0xf3d098, 0xffdb8f, 0xffd29b, 0xf5cf8e, 0xffe79d, 0xf0dda3, 0x807559, 0x0b0400, 0x010002, 0x373938, 0x505455, 0x494a4c, 0xa1a1a1, 0xf9f7f8, 0xfffeff, 0xfcfaff, 0xfffeff, 0xfffeff, 0x7c7c7c, 0x1a1a1a, 0x0b0b0b, 0x1b1b1b, 0x212121, 0x232323, 0x111111, 0x181818, 0x130f1e, 0x733810, 0xb06126, 0x6a3d1c, 0x603b0e, 0xeea73d, 0xffc23c, 0xd5a632, 0x351b1a, 0x0e0108, 0x0f1521, 0x142433, 0x141b25, 0x2b1915, 0x60331e, 0x733214, 0x89523e, 0x87533d, 0x78462f, 0x65381b, 0x613818, 0x5e3a16, 0x5f3d17, 0x66461f, 0x53370f, 0x3d2906, 0x211a00, 0x0f1104, 0x030c0b, 0x00060f, 0x000417, 0x06081d, 0x071329, 0x2a1f19, 0x754515, 0xca761c, 0xfa9720, 0xffa01e, 0xf9a528, 0xf8b037, 0xf9c562, 0xb2863b, 0x63431c, 0x2a1713, 0x0b0416, 0x0b0c21, 0x121524, 0x0d111a, 0x3e3f39, 0xd7d9d6, 0xc1c5c6, 0xb5b8bd, 0xdcdde1, 0xf4f0f1, 0xfff8f6, 0xfffcf4, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfafafa, 0xf9f9f9, 0xfefefe, 0xffffff, 0xffffff, 0xc8aeb7, 0x1f0e16, 0x050003, 0x0e0b02, 0x1b1000, 0x7d5f21, 0xcb983d, 0xfab74c, 0xf7b226, 0xffb72d, 0xffac28, 0xee8a1a, 0xbe671a, 0x854627, 0x401e2c, 0x0c0024, 0x0d0d17, 0x02071b, 0x000522, 0x0b1129, 0x362e2b, 0x775728, 0xba8223, 0xe69f21, 0xffa228, 0xffa92e, 0xffb135, 0xffb437, 0xf6b235, 0xeeb335, 0xefb83a, 0xf1be41, 0xffab34, 0xda831a, 0xb5691b, 0x8a4d1e, 0x4e2010, 0x301318, 0x26172a, 0x140b26, 0x010715, 0xa47645, 0xffb931, 0xffb00f, 0xb88532, 0x370d0f, 0x995548, 0xb95700, 0x3e231a, 0x170e11, 0x141c29, 0x101c28, 0x202425, 0x17130a, 0x1c1c12, 0x141b14, 0x000900, 0x2d343a, 0xdbdaea, 0xfffdff, 0xfffaf0, 0xfaf4e4, 0xfffdfa, 0xfffaff, 0xf7fffb, 0xf7ffff, 0xedf4ff, 0x7f8094, 0x070008, 0x0e0000, 0x826941, 0xffe5ac, 0xffd7a8, 0xffd09d, 0xfad9a3, 0xf6e0ae, 0xe9d7a7, 0xefdaa5, 0xffe2a6, 0xffe19d, 0xe9d58e, 0xefda9b, 0xf7e0ac, 0xfee2bb, 0xffe2c2, 0xfee0c4, 0xffe0c4, 0xffe1c4, 0xffdcdb, 0xfff9d5, 0xcad5b3, 0x10171f, 0x150004, 0x8f531d, 0xed9927, 0xde7f00, 0x805500, 0x2a0c14, 0x240007, 0x7a3003, 0xbd6f3e, 0xb9734f, 0x92551c, 0x85500a, 0x7c480f, 0x905921, 0xbc8340, 0xe2a950, 0xefb645, 0xf3b544, 0xe5a041, 0xc87e33, 0x9c5507, 0x7d4f2e, 0x704326, 0x8f5c1d, 0xc18525, 0xcb7504, 0x733401, 0x00003b, 0x401b00, 0x92580e, 0xca7e10, 0xe7a02e, 0x7d4b1a, 0x0e0010, 0x1d1f2e, 0xd3e6b8, 0xfffcdc, 0xf4e4c2, 0xfde7c2, 0xffe5be, 0xfde1ba, 0xffe6c5, 0xf8e3c6, 0xf8e7cd, 0xfdcf9b, 0xffca99, 0xffd3a6, 0xffdbb2, 0xf3d6aa, 0xefdaa5, 0xfedf9f, 0xffd78f, 0xf2c991, 0xffe6a3, 0xefdd95, 0x7a733d, 0x030200, 0x070a11, 0x858c9e, 0xedf6ff, 0xfeffff, 0xffffff, 0xfdfbfc, 0xfffdfd, 0xfffdff, 0xfcfaff, 0xfcfbff, 0xd0d0da, 0x2b2b2b, 0x000000, 0x202020, 0x222222, 0x0e0e0e, 0x1d1d1d, 0x181818, 0x1a1a1a, 0x09071f, 0x622c00, 0xa36019, 0x7a5c44, 0x3b1e0c, 0xcd832c, 0xffb01c, 0xf7c526, 0x886b4d, 0x1b1000, 0x05100a, 0x0f2727, 0x061208, 0x372000, 0x9d5f24, 0xbd6315, 0xcd8717, 0xeba535, 0xfcb644, 0xfbb442, 0xf8b13d, 0xf5ae3a, 0xf6af3b, 0xfeb741, 0xffa82a, 0xffa02c, 0xdc9430, 0xae7e32, 0x745829, 0x3c2b1b, 0x190913, 0x0a0013, 0x031114, 0x050d0f, 0x19120c, 0x41270e, 0x784913, 0xb46e16, 0xe58f16, 0xffa419, 0xffb10a, 0xffbf29, 0xf1bf42, 0xb6983e, 0x64551e, 0x231d05, 0x070302, 0x010007, 0x061005, 0xb4beb6, 0xf8ffff, 0xfbffff, 0xfbfbff, 0xfffeff, 0xfffaff, 0xfffdff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfbf3f1, 0xfcffff, 0xf1fbff, 0xfbffff, 0xfdf8e5, 0xfaf7e4, 0xf5ffff, 0x7d9bb7, 0x000013, 0x030000, 0x351e00, 0x916715, 0xd9a02f, 0xf9b836, 0xffc139, 0xf2b028, 0xffab2f, 0xe8902f, 0xbf7538, 0x7d4723, 0x40210c, 0x211916, 0x080e26, 0x00022e, 0x080000, 0x351a07, 0x7c4c1c, 0xc47f31, 0xf5a43b, 0xffb33c, 0xffb436, 0xfeb131, 0xffa62b, 0xfca822, 0xf6ac19, 0xf0af15, 0xeeb11b, 0xf2af2a, 0xf6ad3a, 0xfaab46, 0xb5581d, 0xbb4d00, 0xa85313, 0x442e20, 0x000e18, 0x121a1d, 0x181623, 0x020633, 0x563800, 0xf3b64c, 0xff9e21, 0xfcb83b, 0x694c2c, 0x400800, 0xbc7012, 0x8b5237, 0x111111, 0x1d1d1d, 0x0e0e0e, 0x151515, 0x282828, 0x191919, 0x101010, 0x1d1d1d, 0x191919, 0x000000, 0x1c1c1c, 0xa8a8a8, 0xf1f1f1, 0xffffff, 0xfafafa, 0xffffff, 0xf3ffff, 0xf1faff, 0xfbffff, 0xfefffb, 0xc5c6be, 0x272820, 0x000200, 0x70756e, 0xfffdcc, 0xf2e1ad, 0xf4daa1, 0xffdda3, 0xffdaa1, 0xffe2b0, 0xf2d5ab, 0xffe6c1, 0xfedeb5, 0xfcdfb5, 0xfcdfb7, 0xfce0b8, 0xfce3bb, 0xfee6c0, 0xffe8c4, 0xffeac5, 0xffeccb, 0xfeefd2, 0xf9f1de, 0x3e3b32, 0x030200, 0x0f0d10, 0x1a131a, 0x170e13, 0x0d0a1f, 0x120109, 0x3f2727, 0x473646, 0x0a082d, 0x00001b, 0x271910, 0x4d2d00, 0x5d3e00, 0x714500, 0x9e5e06, 0xd68722, 0xfea73d, 0xf7a43c, 0xc97f1e, 0x9d5a00, 0x694805, 0x5a3b0c, 0x462d17, 0x1e0c08, 0x080000, 0x261d1e, 0x403a3c, 0x292229, 0x080b12, 0x00030c, 0x0a131c, 0x101920, 0x101519, 0x000100, 0x5b5249, 0xfff5e7, 0xffeacf, 0xfee9cc, 0xffe8c9, 0xffe7c5, 0xfee4c1, 0xfde4bc, 0xfee2ba, 0xfee3b8, 0xf5e4ae, 0xf5e0ab, 0xffe5b2, 0xf7d7a6, 0xfed8a9, 0xffd8a9, 0xffd6a8, 0xffcea1, 0xfdd485, 0xffface, 0x55564e, 0x00090e, 0x2b2e27, 0xdddbc6, 0xfafce7, 0xfbfff6, 0xffffff, 0xffffff, 0xfdfdfd, 0xf9f9f9, 0xffffff, 0xeaeaea, 0xa4a4a4, 0x121212, 0x000000, 0x1b1b1b, 0x181818, 0x1f1f1f, 0x181818, 0x141414, 0x2a2a2a, 0x121212, 0x301703, 0x112327, 0x9c5a3a, 0xaf5f16, 0x391700, 0x8a5728, 0xf7bb3f, 0xffab2c, 0xdeaa34, 0x572d03, 0x0c000e, 0x1a213b, 0x131e30, 0x100513, 0x512e1a, 0xa07028, 0xa34414, 0xb35a16, 0xf2a03c, 0xffbf42, 0xfca821, 0xfb9e1d, 0xffa332, 0xffa743, 0xffa336, 0xffa42f, 0xffa82b, 0xffb234, 0xffbb42, 0xe9aa40, 0xa77c20, 0x704f00, 0x261012, 0x0b080f, 0x000d19, 0x001b26, 0x0b2323, 0x3b2c19, 0x834820, 0xc36833, 0xe48f35, 0xffae43, 0xf9a624, 0xfeb326, 0xffc240, 0xdaa33f, 0x8e5e1c, 0x380d00, 0x00001c, 0x08111a, 0x979c96, 0xffffff, 0xfffcff, 0xfcf9ff, 0xfcffff, 0xf2fce4, 0xfafafa, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfdfdfd, 0xfdfdfd, 0xfafafa, 0xfffdfd, 0xfef9f5, 0xfffff6, 0xfcfbf6, 0xfcffff, 0xf9ffff, 0x95989d, 0x000002, 0x170000, 0x603e18, 0xbc8a41, 0xf2b149, 0xf5aa2d, 0xfcad2c, 0xffb438, 0xe0931f, 0xc7782d, 0x874a07, 0x553305, 0x302215, 0x0b0715, 0x01000c, 0x0e0500, 0x332502, 0x907b2c, 0xb9953f, 0xe9b24e, 0xffbc4d, 0xffb138, 0xfca426, 0xf5a222, 0xf3a626, 0xfca73d, 0xf4a232, 0xf2a225, 0xfdac29, 0xffb538, 0xffa83b, 0xe78427, 0xc96213, 0xa5570c, 0x995526, 0x663121, 0x1f0300, 0x121615, 0x182b31, 0x070d19, 0x160412, 0xae812c, 0xfbb442, 0xffa422, 0xfeb940, 0x503518, 0x511e0d, 0xba741f, 0x67351e, 0x141414, 0x101010, 0x282828, 0x202020, 0x020202, 0x0c0c0c, 0x1e1e1e, 0x181818, 0x232323, 0x141414, 0x060606, 0x040404, 0x323232, 0x5d5d5d, 0x868686, 0xbfbfbf, 0xd1d6dc, 0xf2f5fa, 0xf5f6f8, 0xf5f5f5, 0xfffffb, 0xf4f5f0, 0x757772, 0x020701, 0x9a956d, 0xfef1c5, 0xf9e3b2, 0xf9daa4, 0xfdd9a5, 0xfad6a6, 0xffe5ba, 0xf4d7af, 0xffe2ba, 0xffe2ba, 0xffe3bc, 0xfee5bd, 0xfee6c0, 0xffe7c3, 0xffe8c6, 0xffe9c7, 0xfeebcb, 0xfaecd1, 0xfffeec, 0x69665f, 0x000000, 0x181619, 0x201b1f, 0x1a1116, 0x101b00, 0x1b2618, 0x0c1013, 0x060000, 0x3a210b, 0x9b7439, 0xd2a749, 0xd9ae3e, 0xebbb57, 0xecb64a, 0xf3b03d, 0xfbad31, 0xffaf2f, 0xffb334, 0xffb53c, 0xfbb43e, 0xe6b358, 0xe9b456, 0xeab555, 0xd5a34c, 0x896322, 0x261000, 0x060000, 0x11161a, 0x202126, 0x11141b, 0x0f161e, 0x111a21, 0x0e1317, 0x000100, 0x80796f, 0xfff9eb, 0xffebd2, 0xffeacf, 0xfee9cc, 0xffe8c8, 0xfee6c4, 0xfee4bf, 0xfde4bc, 0xfee2ba, 0xf3dcaa, 0xfff5c3, 0xf8dcac, 0xf8d9aa, 0xffebbe, 0xf6d1a5, 0xfbd4a9, 0xffe4ba, 0xfffbc8, 0x7a6a51, 0x0a0b10, 0x6c7282, 0xeeedf2, 0xfffef8, 0xfbf8f1, 0xe8eceb, 0xebebeb, 0xd7d7d7, 0xa7a7a7, 0x929292, 0x4d4d4d, 0x262626, 0x000000, 0x060606, 0x1a1a1a, 0x222222, 0x202020, 0x101010, 0x141414, 0x151515, 0x101010, 0x282828, 0x1b0f01, 0x050f18, 0x653215, 0xba6e30, 0x462200, 0x643c0b, 0xf3b03d, 0xffa623, 0xfebd49, 0x97671d, 0x230b01, 0x070423, 0x1d2440, 0x161511, 0x220e00, 0x5c391d, 0xc6562e, 0xac440d, 0xb65c0e, 0xdc8d26, 0xfcb038, 0xffb636, 0xffa722, 0xff9f1d, 0xfda237, 0xffa432, 0xffa129, 0xfda124, 0xfba629, 0xfab037, 0xf7b847, 0xf3ba4f, 0xd09a44, 0x845e20, 0x2c1e04, 0x000207, 0x010715, 0x1e1518, 0x412412, 0x5c300d, 0xa05c1d, 0xbd7221, 0xef9a2f, 0xffb939, 0xffa722, 0xf0a12b, 0xf3b153, 0xcf9647, 0x5e430e, 0x120000, 0x1b0f1b, 0x9795ab, 0xf5feff, 0xf9fffa, 0xf9faf2, 0xfffefd, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xfffeff, 0xfff7ee, 0xfffcec, 0xfffefa, 0xe1e9f6, 0x5d616d, 0x0f0000, 0x502400, 0xac6c25, 0xe69e49, 0xffaf41, 0xffaf2d, 0xffae29, 0xfa9f2a, 0xdd8627, 0xb76414, 0x693b23, 0x3a1f0c, 0x12130d, 0x000c19, 0x000b19, 0x31271b, 0x896624, 0xd9a43a, 0xefc034, 0xf5bb33, 0xfbb22f, 0xffa92d, 0xffa22a, 0xffa12d, 0xfba431, 0xf9a835, 0xeb9a2e, 0xf7a331, 0xffab35, 0xffab34, 0xff9e33, 0xe78228, 0xc15b13, 0xa23900, 0x935f25, 0x4b3527, 0x150c11, 0x1f0a07, 0x2d232b, 0x041531, 0x090d0e, 0x6a430a, 0xf7b851, 0xffab2f, 0xffa41f, 0xf2ae41, 0x3b230b, 0x683a2b, 0x9f6221, 0x361502, 0x202020, 0x191919, 0x000000, 0x000000, 0x363636, 0x464646, 0x171717, 0x1a1a1a, 0x0f0f0f, 0x1d1d1d, 0x252525, 0x181818, 0x050505, 0x000000, 0x0f0f0f, 0x000000, 0x080307, 0x171216, 0x2d2b2e, 0x28282a, 0x29292b, 0x6a6a6a, 0x616161, 0x0f0f0d, 0x030300, 0x888363, 0xfff9d5, 0xffe7be, 0xfbdcae, 0xffecbf, 0xedcb9e, 0xffe8bd, 0xffe4bf, 0xffe5c0, 0xffe6c1, 0xffe8c4, 0xffe9c7, 0xffe9c9, 0xfeeac9, 0xfee9ca, 0xfeebcd, 0xfcedd6, 0xffffef, 0x9d9d95, 0x000000, 0x1d1d1f, 0x1f1a1e, 0x1d1719, 0x131e16, 0x061a1b, 0x000e04, 0x3a3100, 0xb28213, 0xffb72a, 0xffb837, 0xfbb44a, 0xfcb269, 0xffb66b, 0xffb86a, 0xffb364, 0xfdac5b, 0xfbaa59, 0xffb05f, 0xffb667, 0xffc13f, 0xffb347, 0xffab49, 0xffb842, 0xf9bb34, 0xa9841a, 0x3f3013, 0x000022, 0x1e1c1f, 0x1e1f23, 0x14191f, 0x10171d, 0x111619, 0x0a0a08, 0xb2aba1, 0xfff9ed, 0xfeecd6, 0xffecd4, 0xffebd2, 0xffeacd, 0xffe8c9, 0xffe7c5, 0xfee6c2, 0xfde5bf, 0xffe5bc, 0xf6d9af, 0xffeec4, 0xffeac2, 0xf3d7af, 0xfbe2ba, 0xffecc3, 0xfee6c0, 0x857460, 0x130b08, 0x191b28, 0x696c7f, 0x6e6b76, 0x221c1e, 0x2b262a, 0x34343c, 0x141414, 0x000000, 0x121212, 0x000000, 0x070707, 0x000000, 0x232323, 0x181818, 0x1d1d1d, 0x171717, 0x141414, 0x1e1e1e, 0x414141, 0x373737, 0x000000, 0x000000, 0x1a1f18, 0x1d1f2c, 0x351b04, 0xa46232, 0x5a3316, 0x4d3706, 0xffb550, 0xfea21d, 0xfcab36, 0xe9ad3d, 0x664309, 0x0a000b, 0x1c1b3b, 0x222921, 0x0a0900, 0x221421, 0x72391e, 0x90502c, 0xa1561f, 0xa75106, 0xd27817, 0xffa835, 0xffae2d, 0xf5a31b, 0xfaa634, 0xfaa330, 0xfda32b, 0xffa42a, 0xffa726, 0xffa824, 0xffa822, 0xffa922, 0xffab19, 0xffb83d, 0xdfa44a, 0x85602c, 0x2f1d07, 0x0b0301, 0x09060d, 0x0f0d18, 0x441e0b, 0x75411c, 0xb76c29, 0xd77311, 0xff9d20, 0xffb631, 0xf49d1c, 0xffbb41, 0xfaaf3c, 0xac6d26, 0x3a1502, 0x090004, 0x696e71, 0xedf7ef, 0xfffff8, 0xfff5f4, 0xf5f5f5, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfafafa, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xf9f6fd, 0xfffdff, 0xfdf4f5, 0xaba5a9, 0x352b2c, 0x1e0300, 0x895019, 0xd58432, 0xffb547, 0xffb43b, 0xffa11e, 0xffa21d, 0xffa12b, 0xd78228, 0xa0551c, 0x6f2d0a, 0x1c1a1f, 0x131023, 0x030117, 0x0e0a09, 0x5f4e22, 0xcda84d, 0xffc54e, 0xffb031, 0xfbab20, 0xf8a11c, 0xf89921, 0xff9a2c, 0xffa33b, 0xffa740, 0xfea63c, 0xf4a236, 0xffa71f, 0xffae29, 0xffaa2d, 0xe7901f, 0xbe6d11, 0x9b550f, 0x864a18, 0x7b451f, 0x3b2621, 0x101308, 0x000f00, 0x22231e, 0x261c3f, 0x030022, 0x3d2604, 0xdbae31, 0xffb13b, 0xfda11c, 0xffa51e, 0xd4943c, 0x2e1d0d, 0x6c483c, 0x6a3910, 0x160800, 0x030303, 0x000000, 0x3e3e3e, 0x919191, 0x7c7c7c, 0x272727, 0x020202, 0x161616, 0x1d1d1d, 0x181818, 0x161616, 0x141414, 0x141414, 0x373737, 0x616161, 0x6a6a6a, 0x867a7a, 0x281d21, 0x030002, 0x08060b, 0x000004, 0x010000, 0x130e0b, 0x110a04, 0x0b0d00, 0x0c0b00, 0x736b54, 0xfeefd2, 0xffedcb, 0xeed0aa, 0xffebc2, 0xffe7bd, 0xfce4c2, 0xfde5c3, 0xfee7c7, 0xffe9c9, 0xffeacb, 0xffecce, 0xfdecd0, 0xfdecd0, 0xfeecd4, 0xfff2df, 0xfffbef, 0xcfcec9, 0x0f1110, 0x141517, 0x151314, 0x1f1b1a, 0x1b1b41, 0x03000b, 0x3a2706, 0xba953d, 0xffce54, 0xffc147, 0xffb253, 0xffb672, 0xffbf5d, 0xffbe5f, 0xffbf65, 0xfdbf68, 0xfcc068, 0xfdc067, 0xfdbc60, 0xfcba5c, 0xffc259, 0xffbd6e, 0xffbd7a, 0xffb85c, 0xffc143, 0xffce5b, 0xb68d59, 0x401620, 0x0b0505, 0x1d191a, 0x17181c, 0x12171b, 0x13171a, 0x1d1d1b, 0xe1ddd4, 0xfff7ec, 0xffefdd, 0xffeeda, 0xffedd7, 0xfeedd3, 0xfeeacf, 0xfee9ca, 0xffe8c8, 0xfee7c5, 0xfcdab5, 0xffedca, 0xf8dbb9, 0xfae3c1, 0xf4e1c0, 0xfff8d6, 0xede4c3, 0x676141, 0x0d0e08, 0x000100, 0x050507, 0x0e0a0b, 0x060000, 0x060000, 0x110d0e, 0x000004, 0x2c2c2c, 0x7a7a7a, 0x6e6e6e, 0x4f4f4f, 0x313131, 0x202020, 0x151515, 0x151515, 0x0d0d0d, 0x212121, 0x0d0d0d, 0x0a0a0a, 0x393939, 0x808080, 0x888888, 0x303030, 0x000607, 0x080412, 0x120f00, 0x774427, 0x653f28, 0x2c2500, 0xeda251, 0xffab26, 0xfc9d27, 0xffc643, 0xca972e, 0x442602, 0x070007, 0x141527, 0x18222b, 0x031019, 0x001a0b, 0x313622, 0x6c472a, 0x92481b, 0xb14f10, 0xcc6916, 0xe68c2b, 0xffaf44, 0xffaf33, 0xffa72b, 0xfda027, 0xffa129, 0xffa429, 0xffa422, 0xffa118, 0xffa013, 0xffa225, 0xff9f1a, 0xffae23, 0xffbc39, 0xc59735, 0x634918, 0x170d0e, 0x00001e, 0x150e1e, 0x2b161b, 0x723f2c, 0xa34e17, 0xd86a09, 0xffa123, 0xffae22, 0xf5ad1d, 0xff9f2a, 0xffb13d, 0xe0a23f, 0x6b4409, 0x170100, 0x3e343f, 0xacaaad, 0xfffff3, 0xffffff, 0xffffff, 0xf5f5f5, 0xf9f9f9, 0xffffff, 0xfefefe, 0xf8f8f8, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xfefefe, 0xf9f9f9, 0xfafafa, 0xfdfdfd, 0xfffcff, 0xeef1ff, 0x63687e, 0x070000, 0x3e1700, 0xad6618, 0xfea53d, 0xffaf3e, 0xfca021, 0xfda01f, 0xffa82c, 0xfba131, 0xbd6f1a, 0x8e501d, 0x704330, 0x381617, 0x000f27, 0x00000c, 0x3a1d0d, 0xb67c3c, 0xffb946, 0xffaf22, 0xf29f13, 0xfda829, 0xff9a23, 0xffa02d, 0xffa638, 0xffa437, 0xff9e2f, 0xf99e29, 0xf8a629, 0xfbae2c, 0xffa525, 0xf89722, 0xd5811e, 0xa9651a, 0x794b19, 0x4d3519, 0x2e271f, 0x1d2122, 0x000010, 0x0c0b00, 0x272e0f, 0x10212b, 0x01001c, 0x46170d, 0xc78934, 0xf4c23b, 0xfa9e1f, 0xfea01a, 0xffad2b, 0xac7636, 0x1c1411, 0x563b32, 0x3a1302, 0x040a00, 0x1d1d1d, 0x999999, 0xf3f3f3, 0xefefef, 0x979797, 0x545454, 0x404040, 0x0c0c0c, 0x070707, 0x111111, 0x141414, 0x131313, 0x707070, 0xffffff, 0xececec, 0xffffff, 0xfff8f7, 0xa09695, 0x060105, 0x0b0a0f, 0x333132, 0x746b64, 0x4c3c2d, 0x47301e, 0x21221a, 0x0c0c02, 0x040000, 0x4f4838, 0xefe0cb, 0xfff9de, 0xf8debd, 0xfddfbb, 0xfae3c4, 0xf9e4c7, 0xfbe6c9, 0xfce8cd, 0xfcebd1, 0xfdedd4, 0xfeeed5, 0xfef0d6, 0xffefdd, 0xfcf0e0, 0xfffff6, 0xf3f3f1, 0x202425, 0x07080a, 0x171715, 0x1c1815, 0x110d26, 0x380f00, 0xa45a11, 0xffaf56, 0xffc37b, 0xf4c38b, 0xffc78a, 0xffc172, 0xffc972, 0xfdc572, 0xf7c473, 0xf7c87a, 0xfdcd81, 0xffce81, 0xfcc777, 0xf8c16f, 0xfdb988, 0xf8be7e, 0xffd082, 0xf8cd7f, 0xedbc77, 0xfcc279, 0xf3ae53, 0xbf7607, 0x201511, 0x19110f, 0x1c1a1b, 0x191a1e, 0x090d0e, 0x30302e, 0xfffff8, 0xfffbf1, 0xfff2e2, 0xfff2e2, 0xfff1de, 0xffeeda, 0xffedd5, 0xfdecd2, 0xfeeacf, 0xfeebcd, 0xffefd1, 0xfde2c4, 0xf1d9bd, 0xfae9cf, 0xffffe6, 0xd3cfb6, 0x373621, 0x010300, 0x000400, 0x1e2012, 0x413a20, 0x524427, 0x655941, 0x3b3424, 0x080800, 0x000100, 0xa3a3a3, 0xffffff, 0xf4f4f4, 0xffffff, 0xf7f7f7, 0x676767, 0x050505, 0x1a1a1a, 0x1a1a1a, 0x020202, 0x1d1d1d, 0x4c4c4c, 0x565656, 0xa0a0a0, 0xfcfcfc, 0xe6e6e6, 0x789498, 0x241a22, 0x030801, 0x401e14, 0x62412e, 0x0c1000, 0xb77c40, 0xffb032, 0xffa127, 0xfea628, 0xffbd3a, 0xb48720, 0x301200, 0x06001e, 0x1a213e, 0x0d2613, 0x001303, 0x000b01, 0x181411, 0x432b29, 0x643627, 0x80451d, 0xac6523, 0xcd802e, 0xf59d21, 0xfea42a, 0xffa934, 0xffa533, 0xf99b29, 0xf69922, 0xffa328, 0xffae2f, 0xf59c38, 0xffa830, 0xfea316, 0xf39e07, 0xffb62c, 0xfabe5c, 0xa97b47, 0x43200a, 0x000010, 0x0d0e22, 0x2f1d2d, 0x7b473a, 0xa65118, 0xc05e00, 0xf19d21, 0xf8b530, 0xffaa3a, 0xf89917, 0xffb32b, 0xffb444, 0x9d6122, 0x270300, 0x120703, 0x565c5a, 0xededed, 0xffffff, 0xffffff, 0xf2f2f2, 0xfdfdfd, 0xffffff, 0xfafafa, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xfefefe, 0xffffff, 0xfdfdfd, 0xc2b8c1, 0x1b1829, 0x030009, 0x573921, 0xb36e20, 0xffa933, 0xffb432, 0xf99d20, 0xf3a01e, 0xffb63f, 0xee9833, 0xb96b20, 0x8f5122, 0x623c27, 0x332324, 0x060411, 0x00000b, 0x6c5533, 0xdea345, 0xffba36, 0xffa91c, 0xff9812, 0xfe9f1f, 0xfdab2b, 0xffa12d, 0xffa02a, 0xff9f23, 0xffa11f, 0xfda51f, 0xfba921, 0xf9ad23, 0xf7ae23, 0xde8036, 0xb16021, 0x7b3c11, 0x4e2813, 0x2d1918, 0x0e0b16, 0x000417, 0x00051a, 0x323023, 0x564229, 0x32251d, 0x000010, 0x2a1b06, 0xc78322, 0xffc040, 0xe6a031, 0xfda220, 0xffac2b, 0xffaf36, 0x7b512b, 0x050912, 0x31221d, 0x26070c, 0x001209, 0x303030, 0xf0f0f0, 0xffffff, 0xf8f8f8, 0xf8f8f8, 0xffffff, 0xfdfdfd, 0xa3a3a3, 0x080808, 0x252525, 0x101010, 0x000000, 0x383838, 0xdedede, 0xffffff, 0xf7f7f7, 0xfffaf5, 0xf7f2ef, 0x242424, 0x000100, 0x454138, 0xfff2e0, 0xeecfb0, 0xf8d1aa, 0x453e38, 0x1a1511, 0x191814, 0x010000, 0x2b271e, 0xccc3b4, 0xfffce5, 0xffecd3, 0xfce8cf, 0xfce8cf, 0xfae9cf, 0xfaead1, 0xfbebd4, 0xfdeed9, 0xfdf1db, 0xfff2df, 0xfff2e3, 0xf9ece3, 0xfffff8, 0xe0e2e1, 0x212727, 0x030708, 0x222421, 0x161510, 0x100d1e, 0x764210, 0xef8e19, 0xffc044, 0xffd07d, 0xf7dcaf, 0xffdca7, 0xffc77a, 0xffd39e, 0xffd199, 0xffcd94, 0xffcb8f, 0xffca8f, 0xffcc8f, 0xffce93, 0xffd094, 0xffd891, 0xffd991, 0xefd58b, 0xf0d993, 0xffe49b, 0xffd577, 0xfcaf2f, 0xee9400, 0x503f37, 0x1e130f, 0x211b1b, 0x1f1f21, 0x030406, 0x2e2e2c, 0xf6f3ec, 0xfffff6, 0xfff3ea, 0xfff4e8, 0xfff3e5, 0xfef1e0, 0xfff0dd, 0xffefd8, 0xfeeed5, 0xfeedd3, 0xffefd1, 0xfdecd0, 0xfff2d8, 0xffffea, 0xb0aa9a, 0x27281a, 0x000200, 0x1d2319, 0x050f07, 0x5d573d, 0xe1cb9a, 0xffecb6, 0xf9e6bc, 0x433b26, 0x000200, 0x2c312a, 0xffffff, 0xfdfdfd, 0xf7f7f7, 0xffffff, 0xd8d8d8, 0x2b2b2b, 0x060606, 0x0f0f0f, 0x292929, 0x111111, 0x9d9d9d, 0xffffff, 0xfafafa, 0xf5f5f5, 0xffffff, 0xffffff, 0xc1d8de, 0x38312b, 0x111312, 0x1b0c11, 0x3f291c, 0x000700, 0x7e623b, 0xffb746, 0xfe9f21, 0xf99a24, 0xfba922, 0xfcba30, 0xb58438, 0x34131a, 0x03000c, 0x213416, 0x693013, 0x3e1a0e, 0x0d0711, 0x00081c, 0x000d1c, 0x262217, 0x5d3c11, 0x743f00, 0xae6308, 0xcd8123, 0xf2a03d, 0xffab47, 0xffab41, 0xffa739, 0xfba534, 0xf6a230, 0xfab13e, 0xf7a631, 0xfda22d, 0xffaa32, 0xffab35, 0xfba430, 0xf0a532, 0xefac3b, 0x463718, 0x0a0904, 0x000012, 0x2d1d2a, 0x84513c, 0xa15517, 0xa55800, 0xeaa641, 0xf9aa29, 0xfda32b, 0xff9f2a, 0xffaa2f, 0xffb940, 0xbc852a, 0x412300, 0x0c0003, 0x3e3e3e, 0xb1b1b1, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xf9f9f9, 0xfefefe, 0xfbfbfb, 0xfdfdfd, 0xffffff, 0xededed, 0xa7a7a7, 0x0b0005, 0x130000, 0x592e0b, 0xbd7d35, 0xfcaa44, 0xfaa129, 0xe89417, 0xf8aa2e, 0xffae30, 0xfba93d, 0xba6719, 0x92481b, 0x88513d, 0x462a26, 0x030303, 0x000508, 0x845b1d, 0xd7a244, 0xffbd3d, 0xffaa1a, 0xff9811, 0xff9923, 0xffa337, 0xf5a035, 0xffa42e, 0xffa025, 0xfea321, 0xffaf28, 0xffb737, 0xf6ab36, 0xd68b26, 0xbc6f13, 0x885334, 0x552c18, 0x240b04, 0x100406, 0x0f0609, 0x1e0b07, 0x422213, 0x683e26, 0x815c28, 0x7a5948, 0x180109, 0x291200, 0xc59b45, 0xffbe33, 0xfc9c12, 0xff9f33, 0xfca72a, 0xffb53d, 0xd9992b, 0x3c2012, 0x000b1e, 0x1f1714, 0x250c21, 0x001e16, 0x020202, 0x222222, 0x858585, 0xffffff, 0xffffff, 0xf4f4f4, 0xffffff, 0xf1f1f1, 0x737373, 0x6e6e6e, 0x595959, 0x090909, 0x000000, 0x3d3d3d, 0xececec, 0xffffff, 0xfffff7, 0xf7f9f4, 0x535957, 0x000200, 0x2a2311, 0xd9c19f, 0xffd3a1, 0xf1b67a, 0xc5b3af, 0xddd2d0, 0x787475, 0x0f1316, 0x000102, 0x1a1b16, 0xaca89d, 0xfffeee, 0xfff2da, 0xfff0da, 0xfeeed7, 0xfcedd8, 0xfaedda, 0xfcefde, 0xfef3e1, 0xfff5e3, 0xfff3e9, 0xfef4eb, 0xfffefb, 0x808485, 0x0e1316, 0x0e1412, 0x22241f, 0x161711, 0x1a1e37, 0x684424, 0xc8791a, 0xfeaa2e, 0xffcb60, 0xffdd8d, 0xffdc9e, 0xffd599, 0xffda7f, 0xface6b, 0xf4bb50, 0xefac39, 0xefa72f, 0xf2ad36, 0xf8b947, 0xfdc153, 0xf4ca5c, 0xffd788, 0xffd7a1, 0xfdd693, 0xffdf79, 0xffd45c, 0xefa83c, 0xd7832d, 0x513f35, 0x24150e, 0x1f1714, 0x1e1e1e, 0x101113, 0x121210, 0x999893, 0xfffff6, 0xfff6ed, 0xfff5ec, 0xfef4ea, 0xfff3e5, 0xfff2e1, 0xfff0dd, 0xfeefda, 0xffefd8, 0xf2ebcf, 0xf9f3d9, 0xfffee8, 0x9e9b8a, 0x101004, 0x000100, 0x070908, 0x818284, 0xdcdde1, 0xc3af96, 0xf1c890, 0xffd397, 0xcbab84, 0x271d11, 0x05060a, 0x5c6369, 0xfafafa, 0xf6f6f6, 0xffffff, 0xe7e7e7, 0x2b2b2b, 0x000000, 0x000000, 0x525252, 0x6b6b6b, 0x9b9b9b, 0xf6f6f6, 0xfefefe, 0xf9f9f9, 0xffffff, 0xeaeaea, 0x969696, 0x101f22, 0x040300, 0x1f181f, 0x161a26, 0x1c1208, 0x000304, 0x343821, 0xfeaf4a, 0xffa92b, 0xffaa33, 0xf89820, 0xffb032, 0xffc555, 0x9c7027, 0x271400, 0x1c1914, 0xa0522e, 0x8f5235, 0x643f2d, 0x3b2c25, 0x181411, 0x040000, 0x0f0300, 0x231200, 0x663817, 0x8b5529, 0xb57434, 0xd48834, 0xef9c36, 0xffae3f, 0xffae3a, 0xf6a22e, 0xf6a323, 0xfea62b, 0xffa32f, 0xfb9b2a, 0xf99825, 0xfd9f25, 0xffaa28, 0xffb028, 0xf7bc56, 0x573e06, 0x0b1411, 0x01081b, 0x371d1e, 0x905130, 0xa4551c, 0xaf601d, 0xf9af32, 0xffb441, 0xfca436, 0xe38a14, 0xf5a323, 0xffbb49, 0xbd7f34, 0x743a12, 0x000000, 0x2d2d2d, 0x9e9e9e, 0xf4f4f4, 0xffffff, 0xfafafa, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfafafa, 0xfefefe, 0xffffff, 0x9e9e9e, 0x090909, 0x100408, 0x6a3f1c, 0xba6e1a, 0xffb548, 0xeb9727, 0xa25b00, 0xd8982a, 0xf8b741, 0xfeac2c, 0xbb6500, 0x994403, 0xa15436, 0x682f28, 0x120000, 0x0d1009, 0x2c4034, 0xf9b121, 0xffb936, 0xf6a731, 0xf2a12b, 0xfda92c, 0xfca730, 0xfda342, 0xf79a4c, 0xfe9d32, 0xffa532, 0xffac35, 0xf5a834, 0xde932e, 0xbe7028, 0x9d4c21, 0x8a341d, 0x271c0a, 0x0a0800, 0x050c05, 0x293028, 0x544933, 0x774f1e, 0xa2580f, 0xcd6b12, 0xa05617, 0x1c0000, 0x150200, 0xb88848, 0xffc349, 0xeca41e, 0xfca021, 0xffa019, 0xef9f24, 0xfcb644, 0xb47d18, 0x0e0000, 0x021830, 0x1e1a19, 0x29122e, 0x062922, 0x202020, 0x000000, 0x090909, 0x909090, 0xfbfbfb, 0xffffff, 0xfcfcfc, 0xffffff, 0xdddddd, 0x8b8b8b, 0x9a9a9a, 0x060606, 0x181818, 0x000000, 0x606060, 0xfcfcfc, 0xf8fdf6, 0xc9d3cb, 0x89948e, 0x000600, 0x0c0400, 0x7e6135, 0xffdc9e, 0xf3af64, 0xd2b9b4, 0xfffaf8, 0x9e999d, 0x030710, 0x141d24, 0x000204, 0x000100, 0x939389, 0xfffbe4, 0xfff7e3, 0xfff3de, 0xfeefdc, 0xfbeedd, 0xfcf0e0, 0xfdf4e3, 0xfff6e5, 0xfff6ed, 0xfffcf6, 0xf3efec, 0x1c2021, 0x000204, 0x1c2220, 0x181a15, 0x1c1d15, 0x07191d, 0x271a14, 0x622f14, 0x9f521c, 0xc07122, 0xc7862a, 0xbe8a34, 0xac8133, 0x9c7228, 0xab7421, 0xc57b1a, 0xe18719, 0xf1901d, 0xec8e1d, 0xd48117, 0xc07510, 0xa37014, 0xa36a1b, 0xbc7e35, 0xca8937, 0xbe7d21, 0xb67825, 0x9a5b28, 0x662310, 0x2f1b10, 0x25140c, 0x190f0d, 0x1b1a18, 0x262827, 0x000100, 0x383732, 0xf9f6ef, 0xfff7f0, 0xfff6ef, 0xfff5eb, 0xfef4e8, 0xfff3e3, 0xfef1e0, 0xfff0dd, 0xfff0db, 0xffffe6, 0xffffe5, 0x7e806b, 0x030400, 0x050600, 0x1b1b1b, 0x09080d, 0xb2b3b8, 0xfffbff, 0xccad99, 0xe8b37d, 0xffd99e, 0x805938, 0x0a0000, 0x08091b, 0x9aa0b6, 0xcacaca, 0xf6f6f6, 0xffffff, 0x4b4b4b, 0x000000, 0x0b0b0b, 0x0d0d0d, 0xa7a7a7, 0x878787, 0xe7e7e7, 0xffffff, 0xf9f9f9, 0xffffff, 0xf7f7f7, 0x858585, 0x000000, 0x000204, 0x292a0b, 0x21101a, 0x0c192a, 0x1d1a11, 0x191b27, 0x000900, 0xc97c20, 0xffbc3f, 0xfaa123, 0xff9b2f, 0xff9b36, 0xf9a823, 0xf8c836, 0xa3893f, 0x110016, 0x1c0200, 0x8b6033, 0xb6753f, 0x9c4c17, 0x863e16, 0x6b3c32, 0x372a3e, 0x040d34, 0x110007, 0x3e1b17, 0x703c15, 0x954f07, 0xbf6d09, 0xec961f, 0xffab2f, 0xffab2d, 0xff9e28, 0xffa123, 0xffa51d, 0xffa81a, 0xffa81d, 0xfea527, 0xfda132, 0xfb9d39, 0xffb215, 0xdbaa4b, 0x33371e, 0x000412, 0x1f0f19, 0x672c1a, 0xb05b34, 0x943807, 0xbf6d09, 0xe79c25, 0xffc13d, 0xce880e, 0xa75d00, 0xe89640, 0xfda947, 0xc67000, 0x525252, 0x000000, 0x0b0b0b, 0xa2a2a2, 0xf8f8f8, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xeeffff, 0xfcffff, 0xfffbff, 0xfafafa, 0xf1ffff, 0xa7beb8, 0x010004, 0x1b000a, 0x933f11, 0xb55336, 0xffb629, 0xf5b432, 0x672d05, 0xbb8b39, 0xfebb39, 0xffb028, 0xba793f, 0xa83c20, 0xbb5b1e, 0x614e09, 0x001c30, 0x000032, 0x3d1a00, 0xe9a425, 0xffae20, 0xfca023, 0xfd9e30, 0xffa634, 0xffa523, 0xfca01b, 0xffa42a, 0xffa73c, 0xf8aa24, 0xffa932, 0xffa23b, 0xdc8526, 0xa86514, 0x66410c, 0x1e130d, 0x000320, 0x2d3001, 0x8b5926, 0xdf8632, 0xe57c0f, 0xc05300, 0xaa5127, 0xa5613c, 0x9f561f, 0x00001e, 0x311100, 0xc17d1c, 0xffb732, 0xffab26, 0xf7a22b, 0xf3a32a, 0xfbaa27, 0xffa61a, 0xfbb74c, 0x413310, 0x061323, 0x070000, 0x744e07, 0x7e6232, 0x00041a, 0x0c1d39, 0x020e26, 0x030919, 0x0c0b13, 0x8a858b, 0xfffdff, 0xfefcff, 0xfbfcff, 0xfbfff4, 0x828a7b, 0xacb2a4, 0x575b4d, 0x000100, 0x171614, 0x040207, 0xa29ca6, 0xfafff7, 0xacb0af, 0x9b9aa2, 0x6a646e, 0x070000, 0x140800, 0xb4a882, 0xfff8c4, 0x8e7c66, 0x34281c, 0x181619, 0x111926, 0x111d2d, 0x1b232e, 0x050b0b, 0x000100, 0x585752, 0xd7d6d1, 0xfffffa, 0xfffffa, 0xfdfcf7, 0xefeee9, 0xf5f4ef, 0xfffffa, 0xf7fffa, 0xd2d4c9, 0x473930, 0x160000, 0x321819, 0x20141e, 0x0f1628, 0x0f233b, 0x0e1831, 0x070f26, 0x01061a, 0x000110, 0x010009, 0x060005, 0x080002, 0x0c0002, 0x130800, 0x2a1900, 0x4f3212, 0x6b4820, 0x775025, 0x704b21, 0x5b3d19, 0x4d3312, 0x3d1024, 0x1e000a, 0x0d0000, 0x030000, 0x010302, 0x00030a, 0x000010, 0x050017, 0x001419, 0x0a1d24, 0x0a1624, 0x141726, 0x201d26, 0x170c08, 0x201100, 0x463519, 0xeef5ee, 0xfbfef7, 0xfffff6, 0xfff9f0, 0xfff2ea, 0xfff4ef, 0xfff9f6, 0xfffbfb, 0xd0d9d6, 0x444d4a, 0x000300, 0x000906, 0x151e1b, 0x19221f, 0x0c1512, 0x1c2522, 0x3c2b00, 0x9f9069, 0xfcefcf, 0xa29781, 0x060000, 0x100c09, 0x68676c, 0x9e9ea6, 0xadadad, 0xffffff, 0x7e7e7e, 0x0a0a0a, 0x0e0e0e, 0x040404, 0x636363, 0xaeaeae, 0x9a8991, 0xfff8ff, 0xfffdff, 0xfcffff, 0xf6ffff, 0x6e7b81, 0x000811, 0x05121b, 0x121b24, 0x001031, 0x0e0c0d, 0x825a1c, 0x704705, 0x0c0500, 0x000a1c, 0x444540, 0xffbe24, 0xf5a22a, 0xffa73e, 0xffa72c, 0xf79f21, 0xfaa93e, 0xeaa73c, 0xd19a1b, 0x00093a, 0x1b1000, 0x984a0c, 0xc36036, 0xab4d27, 0xb35821, 0xd07620, 0xe48f1a, 0x75532e, 0x361607, 0x150000, 0x371816, 0x6d4222, 0x9e5a1b, 0xd77625, 0xff9640, 0xffaa1a, 0xffaa2f, 0xff9c32, 0xff9624, 0xff9f1c, 0xffa41f, 0xf7a237, 0xf7a655, 0xf3a32a, 0xffb926, 0xd59e37, 0x361e1e, 0x000027, 0x1a1c11, 0x7d4b16, 0xc3582a, 0x875000, 0xbf7520, 0xfea93c, 0xffbc33, 0xab7a14, 0x69400c, 0xe0b25d, 0xecbb16, 0xd95c2e, 0x7a3518, 0x100700, 0x000305, 0xc6c0c4, 0xfff7fd, 0xfff7ff, 0xf3fdff, 0xffffff, 0xfefefe, 0xffffff, 0xfcfcfc, 0xffffff, 0xfefefe, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7ffff, 0xfcfbff, 0xfffcfc, 0xfbffff, 0xc1d3d3, 0x15201c, 0x1f0b02, 0x693829, 0x994b1b, 0xd9941b, 0xfbb35f, 0x6e2600, 0xb37c22, 0xe9b234, 0xf1a931, 0xef9523, 0x9c4a22, 0xa24208, 0xaa5f1c, 0x35250c, 0x00091d, 0x15150d, 0xb9883c, 0xffae43, 0xffa921, 0xffa12d, 0xfb9b37, 0xfb9b37, 0xfea02c, 0xffa622, 0xffa520, 0xfca321, 0xffa536, 0xf19f33, 0xc17d2a, 0x7e441e, 0x4a1716, 0x2e0100, 0x4f2c00, 0xa38723, 0xefa64a, 0xf1c957, 0xe8a44f, 0xb24820, 0x943a05, 0xc16b20, 0x964d22, 0x0e0000, 0x2d1e09, 0xa17a39, 0xffbc4b, 0xffaa23, 0xf19317, 0xf99f31, 0xfda537, 0xffa630, 0xffbb3a, 0xb77f2c, 0x20150f, 0x000621, 0x211800, 0xc0952f, 0xa07832, 0x070009, 0x0f0e00, 0x171405, 0x080000, 0x0a0000, 0x1b0e15, 0x8b848b, 0xffffff, 0xf2f8f8, 0xfcfffb, 0xd4d9d2, 0xe3e6df, 0xdcdfd8, 0x090a05, 0x0e0c0d, 0x060409, 0x131017, 0xf1f9ee, 0xf2f7f3, 0x838288, 0xa39da9, 0x51474f, 0x080000, 0x2f2309, 0xb9ad87, 0xecd4b8, 0x584632, 0x0e0100, 0x0b0507, 0x050004, 0x060000, 0x221608, 0x564531, 0x010000, 0x1b1a15, 0x85847f, 0xdfded9, 0xf8f7f2, 0xfffffa, 0xfffffa, 0xf0efea, 0x7d8c79, 0x324339, 0x000509, 0x000f1a, 0x091a24, 0x000807, 0x080900, 0x0c0800, 0x120900, 0x281b00, 0x402f03, 0x533d0b, 0x684d16, 0x826225, 0x9a7435, 0xa57e3b, 0xc1933b, 0xcd9a3e, 0xdea33f, 0xedaa41, 0xf4ad41, 0xefaa42, 0xe5a63f, 0xdda23e, 0xc89931, 0xba932e, 0xa98a2f, 0x8a7325, 0x725e21, 0x644d24, 0x50321a, 0x472317, 0x2e1916, 0x240e10, 0x130008, 0x0d010f, 0x13111f, 0x0d1723, 0x001118, 0x000e12, 0x262b25, 0xa4a6a1, 0xfefdf8, 0xfffaf4, 0xfffaf4, 0xfffcfa, 0xddd3d2, 0x817778, 0x070100, 0x181206, 0x373125, 0x221c10, 0x0a0400, 0x0d0700, 0x060000, 0x060000, 0x645335, 0xe9d9bf, 0xb8ac94, 0x221908, 0x0a0300, 0x524e4b, 0xb0b0b2, 0x737479, 0xffffff, 0xd3d3d3, 0x040404, 0x131313, 0x0e0e0e, 0x090909, 0xe6e6e6, 0xdfdfdf, 0xefe7e5, 0xf4f0ef, 0xfeffff, 0xeef2f5, 0x828689, 0x101010, 0x040000, 0x070000, 0x160e00, 0x15161a, 0x0e0000, 0xb78433, 0xbd8c3f, 0x190d01, 0x00081b, 0x161511, 0xd59730, 0xffba43, 0xf8a525, 0xfd9d22, 0xff9f2a, 0xf59f28, 0xfab23a, 0xeaac35, 0xb99936, 0x0d0000, 0x15000b, 0x8e4e2a, 0xb9582e, 0xa04612, 0xa25600, 0xef973d, 0xffc038, 0xebbc48, 0x987c33, 0x34240b, 0x1b040a, 0x4c1e1e, 0x904b21, 0xc06b1b, 0xea9f20, 0xfba92c, 0xffa92f, 0xffa333, 0xffa236, 0xfe9e2d, 0xfaa224, 0xffb026, 0xfda92f, 0xf6a522, 0xf0ae3d, 0x94733d, 0x1c161a, 0x04000c, 0x562b18, 0xa75b21, 0x9a5011, 0xa35119, 0xd58129, 0xfcb632, 0xe7af36, 0x98621c, 0x6f3900, 0xf2be58, 0xef912d, 0x96570a, 0x6a492a, 0x0a0004, 0x3d313b, 0xe5ded4, 0xfffff6, 0xf8ffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdff, 0xfffffd, 0xfcfff4, 0xeaf6f2, 0x535e64, 0x070000, 0x643615, 0xa2571d, 0xbe8220, 0xf2c73d, 0x844a3c, 0x70321b, 0xf0b529, 0xffb92f, 0xf5a439, 0xae5e05, 0x9b361a, 0xb1610a, 0x714308, 0x11031a, 0x0a080b, 0x846a16, 0xffc34f, 0xffa145, 0xffa427, 0xf8992b, 0xffa13f, 0xffa644, 0xf79d2d, 0xf69e20, 0xffac26, 0xffb02a, 0xe98e31, 0xb06629, 0x63301d, 0x240405, 0x391c0c, 0xa1773b, 0xf5b547, 0xffba2d, 0xffb40c, 0xffa738, 0x9e5918, 0x7c4316, 0xc56c4e, 0x7d381b, 0x120000, 0x3d2616, 0xb99139, 0xf7bd4f, 0xffb330, 0xf89c17, 0xffa32d, 0xffa63e, 0xfda038, 0xfea02f, 0xecb654, 0x583606, 0x040017, 0x000a30, 0x423407, 0xf4be3a, 0xc28721, 0x4e281b, 0x9b7f2c, 0xac8d4a, 0x826134, 0x472613, 0x120000, 0x1a0e10, 0xc0c0c2, 0xf9ffff, 0xfffeff, 0xf7f6fb, 0xfffeff, 0xfffeff, 0x9a9a9c, 0x060608, 0x181617, 0x010000, 0x42483c, 0xf8faf5, 0xe0dfe5, 0x6b6573, 0xbfb7c4, 0x584d51, 0x0a0000, 0x0e0200, 0x82684d, 0xbea891, 0xa49183, 0x624f48, 0x634f46, 0x8c7263, 0xc8aa90, 0xffeecb, 0xa6a5a0, 0x0c0b06, 0x010000, 0x2c2b26, 0x686762, 0xa8a7a2, 0x969590, 0x474641, 0x111a29, 0x000013, 0x000518, 0x252736, 0x261b1f, 0x351e10, 0x664220, 0x885c2d, 0xb58729, 0xcd9c3d, 0xe2b04d, 0xecb550, 0xf4ba4f, 0xffc356, 0xffc555, 0xffc150, 0xffbf59, 0xffbc54, 0xffb94b, 0xffb645, 0xffb442, 0xffb542, 0xffb646, 0xffb64a, 0xffc547, 0xffc348, 0xffc753, 0xf9c555, 0xfac55b, 0xfac35c, 0xefb44e, 0xe7a944, 0xcd9f49, 0xb78639, 0x915f20, 0x603407, 0x3b1b04, 0x2c1d1a, 0x191b28, 0x000b21, 0x000100, 0x0b0d08, 0x494b48, 0x959595, 0x9d9d9f, 0x5c5a5d, 0x1c1a1d, 0x080307, 0x2f1d07, 0xaa9882, 0xfff0da, 0xc5b39d, 0x6e5c46, 0x5d4b35, 0x715f49, 0x97856f, 0xc0b2a7, 0x5c4e43, 0x080000, 0x080000, 0x5e5955, 0xa7a6a4, 0x7b7b7b, 0xe4e5e7, 0xffffff, 0x3e3e3e, 0x101010, 0x000000, 0x0c0c0c, 0xb0b0b0, 0xfefefe, 0xffffff, 0xf2f7f1, 0xf4faf6, 0xfbffff, 0xb8bab9, 0x160f07, 0x0f0000, 0x492c0e, 0x8e6843, 0xad8746, 0x8f7751, 0x482100, 0xd9952a, 0xebae51, 0x35230f, 0x0a0d1e, 0x070302, 0x6a3e1b, 0xecb852, 0xfcb623, 0xf79613, 0xffa836, 0xff9f23, 0xf4a11f, 0xffb641, 0xffb72e, 0xca9932, 0x321e17, 0x10001a, 0x7e4c2b, 0xaf5c18, 0xa0470d, 0x9f5a15, 0xf49d02, 0xffbb21, 0xf8c93d, 0xd0b34b, 0x877137, 0x361a02, 0x2f0b00, 0x6a412d, 0xa2641b, 0xd4952e, 0xf7b030, 0xf8a628, 0xfd9e34, 0xffa63b, 0xffa822, 0xfda400, 0xffa82e, 0xf89a29, 0xffae34, 0xf0bc46, 0x795d2b, 0x100012, 0x1f000f, 0x73521d, 0xb75a2f, 0x903717, 0xb46429, 0xe49c26, 0xffbf35, 0xeaa240, 0x703300, 0x85542c, 0xffcd46, 0xc08306, 0x9c5913, 0x5d292b, 0x0b0009, 0x687460, 0xedfde0, 0xf9ffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfff5ff, 0xfefbf4, 0xf9fff4, 0x88958e, 0x000005, 0x513027, 0x955019, 0xba5c00, 0xf3cc33, 0x9b713f, 0x431811, 0xdfb443, 0xfab617, 0xffa336, 0xde892f, 0x874000, 0xb54827, 0xa96b16, 0x351e00, 0x080019, 0x664d24, 0xefb633, 0xffac28, 0xff922b, 0xffa32f, 0xf99b27, 0xffa732, 0xffa933, 0xf49f28, 0xffae3e, 0xffad4a, 0xda852b, 0x88421e, 0x5e2508, 0x401700, 0x725615, 0xd2b446, 0xfac541, 0xf9a528, 0xffa235, 0xffb624, 0xba6100, 0xa24301, 0xae6538, 0x6b4a39, 0x23050d, 0x613415, 0xdeb34b, 0xffbb3c, 0xfdb02e, 0xf09914, 0xffa527, 0xffaa34, 0xf69a2b, 0xffaa39, 0xffb844, 0x796230, 0x1a0b00, 0x030825, 0x031032, 0x523d0e, 0xffbc30, 0xeda020, 0xca8d54, 0xfcc44b, 0xfdc558, 0xf9c36d, 0xd09f64, 0x724e2a, 0x0f0000, 0x231e1b, 0xc9ced2, 0xfffdff, 0xfffdff, 0xf6f0fc, 0xfffdff, 0xfffdff, 0x717075, 0x0f0f0f, 0x000100, 0x090c01, 0x666863, 0xf4f3f8, 0xe6e2f0, 0x5a5363, 0x9d95a2, 0x8f858d, 0x504549, 0x0a0000, 0x241609, 0x53453c, 0x76635d, 0x786159, 0x896f5e, 0x9d7f65, 0x7a5c3a, 0x4e4d49, 0x252420, 0x1e1d19, 0x11100c, 0x010000, 0x010000, 0x040300, 0x010000, 0x040814, 0x190b08, 0x52290d, 0x83400b, 0xb6641a, 0xe5933f, 0xf9ad57, 0xffc771, 0xffbc50, 0xffbe54, 0xffbd55, 0xffba54, 0xffb956, 0xffbb5a, 0xffbb5d, 0xffb95b, 0xffbd6c, 0xffbc6b, 0xffbb66, 0xffb863, 0xffb762, 0xfeb661, 0xfeb662, 0xfdb762, 0xffb969, 0xfdb163, 0xfdb163, 0xffb764, 0xffba5e, 0xffb750, 0xffb845, 0xffc146, 0xf3c532, 0xffcd3f, 0xffcc46, 0xfeb640, 0xde9435, 0xb06b26, 0x763c0c, 0x4c1700, 0x181109, 0x0f0c07, 0x030504, 0x000105, 0x000208, 0x03080e, 0x0d1015, 0x15161a, 0x31200e, 0x544331, 0x796856, 0x847361, 0x8d7c6a, 0x847361, 0x635240, 0x62513f, 0x070000, 0x12070b, 0x574e51, 0x999395, 0x8c8889, 0x656565, 0xededed, 0xfefffd, 0x4c4c4c, 0x000000, 0x000000, 0x202020, 0x8d8d8d, 0xffffff, 0xfefefe, 0xfafafa, 0xf7ffff, 0xf8ffff, 0xb8bcbb, 0x181409, 0x110000, 0x805c2a, 0xdea963, 0xfec16e, 0xffc258, 0xf2c175, 0xce923a, 0xffab2a, 0xf4ac3e, 0x52381d, 0x060817, 0x1d191a, 0x130006, 0x8e6b2b, 0xf7bd38, 0xffac1e, 0xffa125, 0xffa52f, 0xf5971b, 0xfdaa2a, 0xfaa622, 0xffb02f, 0xe7ac48, 0x4e3717, 0x110003, 0x835234, 0xb0692b, 0x84390f, 0xc97714, 0xee972d, 0xffa82a, 0xffb11e, 0xfec12b, 0xd2a935, 0x6c561c, 0x160a00, 0x501905, 0x875017, 0xc98e28, 0xf1ac2d, 0xfdab2d, 0xffa129, 0xff9f28, 0xffa228, 0xffa022, 0xffa135, 0xfe9e23, 0xffbe2c, 0xdca642, 0x654133, 0x0b0007, 0x35321f, 0xbc5b26, 0x994322, 0x9a4f25, 0xbf7216, 0xffae26, 0xffbd3e, 0xd9974d, 0x3e1100, 0xa48827, 0xfbbe3f, 0xb85c00, 0xa15033, 0x371820, 0x000700, 0x91aa8d, 0xfbfffd, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xfcfcfc, 0xfafafa, 0xfbfbfb, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfff7fd, 0xfffcf7, 0xe0ece0, 0x1b221b, 0x0d0000, 0x713e23, 0xa1510a, 0xed8d1f, 0xccab37, 0x2d0500, 0xa28331, 0xf9cf21, 0xfdac1d, 0xfc9836, 0xa64c0e, 0x964f21, 0xba5a28, 0x764413, 0x170803, 0x311f15, 0xd9ab4b, 0xffb72d, 0xff9a1d, 0xff9e1e, 0xffa332, 0xffa728, 0xfda819, 0xf5a414, 0xfcac2f, 0xffb054, 0xcf7a41, 0x7e2904, 0x431714, 0x613800, 0xb88b14, 0xffc931, 0xfcb92a, 0xf0a023, 0xfca62f, 0xffa72c, 0xd68543, 0xa35d00, 0xa35912, 0x773527, 0x200000, 0x66460b, 0xedaf42, 0xffb233, 0xffa624, 0xfaa025, 0xffa32c, 0xffa931, 0xf79b20, 0xfba82e, 0xfeb743, 0xc28415, 0x120e0b, 0x17170f, 0x121e2a, 0x00091d, 0x5d411a, 0xfeb336, 0xffaf25, 0xffbb5a, 0xffb53d, 0xfdb23b, 0xffc452, 0xffc662, 0xf4c679, 0x95784c, 0x100000, 0x0e0508, 0xb7adac, 0xfff7fa, 0xfffbff, 0xfbf5ff, 0xfdf9ff, 0xfffeff, 0x858786, 0x090c05, 0x000100, 0x080904, 0x333335, 0xc4c1ca, 0xe1ddeb, 0x635d6b, 0x76707c, 0x98929c, 0x919795, 0x505453, 0x100e11, 0x090305, 0x080000, 0x0c0000, 0x1f1104, 0x0b0000, 0x060503, 0x1c1b19, 0x141311, 0x131210, 0x1e1d1b, 0x1e1d1b, 0x1c1b19, 0x161513, 0x2f2a0d, 0x584213, 0x85570c, 0xa96400, 0xef9f24, 0xffca49, 0xffbe3e, 0xffca4c, 0xffc863, 0xffc462, 0xffc467, 0xffc570, 0xffbf71, 0xf4b872, 0xf6bc7c, 0xffc78a, 0xfac06c, 0xfac26d, 0xfbc472, 0xfac673, 0xfac575, 0xf9c474, 0xfac371, 0xf9c26f, 0xffc26f, 0xffc272, 0xffc075, 0xffbe76, 0xfdb771, 0xf9b36b, 0xffbb73, 0xffc77c, 0xffd767, 0xffd260, 0xffc24d, 0xffbf4c, 0xffc459, 0xe9a042, 0xb06d1c, 0x985a11, 0x443226, 0x2b1e16, 0x171614, 0x151c22, 0x141e27, 0x0b161c, 0x11161a, 0x1d2122, 0x1e1b16, 0x0d0a05, 0x050200, 0x080500, 0x0d0a05, 0x030000, 0x030000, 0x23201b, 0x6c6670, 0x847f86, 0x949198, 0x716f74, 0x626264, 0xebebeb, 0xb0b0b0, 0x252724, 0x000000, 0x090909, 0x080808, 0x989898, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xf8ffff, 0x868a8d, 0x130f06, 0x1a0600, 0x9f7b47, 0xfdca79, 0xfab951, 0xffbd45, 0xfba929, 0xfab858, 0xffbc53, 0xffad1d, 0xfaab35, 0x65482a, 0x00000f, 0x1d181c, 0x0b061c, 0x220d00, 0xb0822c, 0xffc139, 0xfea01a, 0xff9d30, 0xffa535, 0xf99d14, 0xf79e1e, 0xf7a539, 0xffb436, 0xf8b131, 0x77490b, 0x1b0603, 0x684130, 0xaf5e27, 0x8d4400, 0xdb853c, 0xffae52, 0xff9b22, 0xf69301, 0xffb827, 0xf0bc46, 0xb79035, 0x743f20, 0x592100, 0x713300, 0xc27e2b, 0xfeb13d, 0xffac31, 0xff9e32, 0xff9d44, 0xffa01f, 0xffa432, 0xff9b27, 0xffa720, 0xffba37, 0xca9744, 0x32200c, 0x01061a, 0x964800, 0xa8612b, 0x884117, 0xa45010, 0xfa9829, 0xffae21, 0xffbc49, 0x9c7029, 0x210600, 0xecb05a, 0xfc9d29, 0xa84d07, 0x7b4c3c, 0x000100, 0x25352b, 0xe9efef, 0xfbfbfb, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcf8, 0xfeffff, 0x6c7574, 0x060000, 0x462107, 0x8b4915, 0xbc6d1e, 0xffba59, 0x452206, 0x694302, 0xf3cd2c, 0xecaa18, 0xffac34, 0xe28617, 0x8f360e, 0xa15732, 0xa25c2b, 0x451f16, 0x120000, 0x997634, 0xffc13c, 0xffa221, 0xff9f2b, 0xffaa1b, 0xfd9d2c, 0xffa521, 0xffab17, 0xffb626, 0xf9a938, 0xb7681d, 0x7e2d00, 0x762508, 0x90701b, 0xe7b751, 0xffc84c, 0xffa41d, 0xfb970e, 0xffa726, 0xffb138, 0xedac34, 0x9a511e, 0xa15436, 0x523017, 0x3c2200, 0xb36622, 0xffaa35, 0xf6b223, 0xffa222, 0xffa82d, 0xffa533, 0xffa536, 0xfb9e27, 0xf9a123, 0xffc34b, 0xc8973a, 0x351700, 0x000614, 0x22251e, 0x111b1a, 0x000610, 0x735531, 0xfaaf3c, 0xffa81e, 0xfcaf43, 0xfdab48, 0xfdac41, 0xfaaf3a, 0xf7b640, 0xfec963, 0xffe399, 0xc6a77b, 0x392109, 0x140900, 0x706458, 0xf3e9ea, 0xfffbff, 0xfffcff, 0xfaf9ff, 0xfeffff, 0xcacfc8, 0x504f4b, 0x010000, 0x000000, 0x000002, 0x5d5c61, 0x807f85, 0x1f1e24, 0x000007, 0x324146, 0x677276, 0x3a3f45, 0x0c0b13, 0x1f1c23, 0x1c1b20, 0x0f1314, 0x1a2320, 0x110f10, 0x1f1d1e, 0x141213, 0x1a1819, 0x1e1c1d, 0x161415, 0x1e1c1d, 0x181617, 0x53342f, 0x54382d, 0x4e3725, 0x463217, 0x5e4620, 0x715223, 0x775017, 0x95672b, 0xb88534, 0xd3a051, 0xf8c77a, 0xffe094, 0xffe095, 0xfdd18a, 0xf7ca86, 0xf9ce89, 0xffc77c, 0xffc980, 0xffc986, 0xfdca89, 0xfcca8b, 0xfdca89, 0xffca89, 0xffca85, 0xf4c380, 0xfac87f, 0xfbc676, 0xffcd75, 0xffd87e, 0xffdf87, 0xffd983, 0xedc774, 0xd49e58, 0xbb8944, 0x8d601f, 0x79501a, 0x765329, 0x58391d, 0x3f2214, 0x4e312b, 0x654530, 0x4b3426, 0x261d18, 0x0c0f14, 0x0d181e, 0x1a2328, 0x1a2020, 0x11120d, 0x11161a, 0x161b1f, 0x1d2226, 0x1a1f23, 0x161b1f, 0x12171b, 0x161b1f, 0x2b3034, 0x68696d, 0x3f4044, 0x030406, 0x1e1f21, 0x8f9092, 0x48494b, 0x000201, 0x000000, 0x000000, 0x5c5c5c, 0xdfdfdf, 0xffffff, 0xf9f9f9, 0xffffff, 0xf9f9f9, 0xf2f2f2, 0x51504b, 0x110900, 0x463112, 0xd0ac78, 0xffe296, 0xfec260, 0xeca938, 0xffb93f, 0xffb537, 0xf9b354, 0xf6a941, 0xffa314, 0xffb13b, 0x614628, 0x050817, 0x121214, 0x191d29, 0x070009, 0x462408, 0xcc9835, 0xffbc3b, 0xf99e2c, 0xff9f30, 0xffa422, 0xf9a03a, 0xffb22c, 0xffa52a, 0xffa932, 0xfeb937, 0x986313, 0x3f0d00, 0x6d3d19, 0xa55731, 0xab5c19, 0xe28f27, 0xffba3f, 0xffa830, 0xfa9722, 0xffa42d, 0xffb232, 0xdfa343, 0xa76529, 0x732c10, 0x792d0b, 0xb66820, 0xfba53e, 0xffb042, 0xfd9631, 0xffa525, 0xfb9d23, 0xffa93a, 0xffa22f, 0xfda215, 0xfebc34, 0x8d6d30, 0x030012, 0x5a2c00, 0xa06d2b, 0x98531c, 0x9b4013, 0xce6a1c, 0xffb22d, 0xefab1c, 0xf8c248, 0x482927, 0x683204, 0xffbf62, 0xc67210, 0x85470e, 0x40221a, 0x030009, 0x838c91, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffff4, 0xd7dce2, 0x0a0c1b, 0x1e0701, 0x753f10, 0xb76e21, 0xe19d4c, 0xb37930, 0x200000, 0xe0b743, 0xf2b10f, 0xffa32f, 0xffa13f, 0xb45f05, 0x9b4917, 0xa4552a, 0x734931, 0x250918, 0x3d210b, 0xefb547, 0xfca51a, 0xfda32b, 0xfaa62c, 0xfda71e, 0xfc9d29, 0xfca025, 0xffab30, 0xfba840, 0xc67526, 0x863800, 0x8d4500, 0xc5812e, 0xffca37, 0xf2a52f, 0xf49334, 0xffa13b, 0xffa82a, 0xffad27, 0xeea232, 0xb97520, 0xa24c29, 0x5c3025, 0x572713, 0xad7218, 0xf7c236, 0xffae33, 0xff8b21, 0xfbaa23, 0xfea726, 0xfca531, 0xfaa332, 0xfda328, 0xffb132, 0xda9a36, 0x624617, 0x030000, 0x11191b, 0x17190e, 0x101115, 0x060612, 0x765931, 0xf4ae35, 0xffae2a, 0xf9b054, 0xffb469, 0xfdb15b, 0xffb855, 0xffc559, 0xeaab42, 0xeab557, 0xffe698, 0xfed794, 0x7c7046, 0x180d00, 0x080000, 0x9e959a, 0xfffcff, 0xfffdff, 0xfafeff, 0xf7fef7, 0xfffdff, 0xaaa8a9, 0x3f3e3c, 0x080904, 0x000100, 0x010300, 0x080d09, 0x1f2322, 0x081110, 0x000405, 0x0d0b0c, 0x251f21, 0x252024, 0x18191e, 0x0f1a1e, 0x0a1c20, 0x1a1819, 0x171516, 0x191718, 0x211f20, 0x1d1b1c, 0x161415, 0x1b191a, 0x1e1c1d, 0x4c151b, 0x3e0f15, 0x240407, 0x130001, 0x0e0204, 0x090005, 0x070005, 0x080007, 0x0d0200, 0x362706, 0x6b562b, 0x997b45, 0xc6a15b, 0xeec170, 0xffd075, 0xffcf6f, 0xffcc8c, 0xffcc90, 0xffce99, 0xfad0a0, 0xf9d0a4, 0xfbd1a1, 0xffcf9e, 0xffcf9a, 0xffddaf, 0xffd69c, 0xfccb7f, 0xfccd73, 0xedc264, 0xc09e47, 0x8f772d, 0x695516, 0x351a00, 0x200c00, 0x0a0000, 0x040000, 0x120806, 0x140002, 0x1e0004, 0x3b101a, 0x421300, 0x371400, 0x25140c, 0x151517, 0x10171d, 0x121a1c, 0x181a15, 0x1a180c, 0x171b1e, 0x171b1e, 0x181c1f, 0x0f1316, 0x0f1316, 0x1e2225, 0x1f2326, 0x121619, 0x000800, 0x1a241b, 0x0f160f, 0x131915, 0x060a09, 0x000002, 0x000105, 0x403f44, 0xbdbdbd, 0xf3f3f3, 0xffffff, 0xffffff, 0xfbfbfb, 0xf7f7f7, 0x949494, 0x000000, 0x120800, 0x867444, 0xf9d696, 0xffdd8a, 0xf0b356, 0xf8b655, 0xffcd6c, 0xf8b95a, 0xffb644, 0xf9b665, 0xfeb557, 0xffb22c, 0xfeb242, 0x4e3419, 0x070d1d, 0x1b1c1e, 0x151d20, 0x1b162c, 0x13000a, 0x613e14, 0xdaa73e, 0xf7b12b, 0xf49a1f, 0xffa33a, 0xf4a236, 0xffa435, 0xff9e19, 0xf9aa31, 0xf9a743, 0xffb12c, 0xd9971f, 0x371300, 0x71331e, 0x86480f, 0xba7b14, 0xe9a222, 0xf8a427, 0xff9f2e, 0xffa134, 0xff9f2f, 0xffb92f, 0xffb347, 0xd88946, 0x95481c, 0x7f3200, 0xb66718, 0xf5a131, 0xffae29, 0xffa325, 0xf49e27, 0xfaac40, 0xffa939, 0xfd990f, 0xffb022, 0xd7a44b, 0x36200b, 0x1f0d09, 0x7c5923, 0xac6821, 0x9d4014, 0xa54512, 0xfcaa3e, 0xf4ac1a, 0xfcb326, 0xc4a265, 0x270000, 0xad7542, 0xeeab43, 0xa25600, 0x78371b, 0x110007, 0x1b2831, 0xdddddd, 0xffffff, 0xffffff, 0xf9f9f9, 0xfefefe, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfff1, 0x808893, 0x000015, 0x3d1c17, 0x8e4e10, 0xbc7213, 0xf0b362, 0x2f0400, 0x776034, 0xf6c356, 0xf99c25, 0xffa323, 0xef8f38, 0x954314, 0x9d5308, 0xb26028, 0x462c2d, 0x0d000c, 0x836131, 0xffb734, 0xfe9b19, 0xfca62f, 0xf4ae2a, 0xf2a62c, 0xffa32d, 0xffa937, 0xffa649, 0xc56c2a, 0x863301, 0xa85d1c, 0xeead45, 0xfbc436, 0xff9230, 0xffa42e, 0xffa51c, 0xffa220, 0xffa53a, 0xfea853, 0xdf8e3f, 0xa25503, 0x5b2137, 0x732600, 0xc77c16, 0xffc34e, 0xf4ae3e, 0xe3a126, 0xfeab33, 0xff9635, 0xf6a61b, 0xf9aa2b, 0xf6a329, 0xffac2b, 0xffb538, 0x955b09, 0x0e0000, 0x0b164e, 0x1c2512, 0x191509, 0x26202e, 0x070314, 0x5c400e, 0xeaac27, 0xffbd3e, 0xf9b36e, 0xf8b370, 0xffbc74, 0xffbb69, 0xffb85c, 0xffcb68, 0xffc963, 0xeebb52, 0xffd66e, 0xf0e5ad, 0xc4b88e, 0x483d2b, 0x080000, 0x26202c, 0xb3b1bc, 0xfcffff, 0xfbfffb, 0xfffcff, 0xfaf8fb, 0xfffffb, 0xabaca4, 0x4b4e43, 0x0f1509, 0x000400, 0x030b00, 0x030000, 0x060000, 0x1e110b, 0x281914, 0x221616, 0x171518, 0x0e171c, 0x14252c, 0x1b191c, 0x1a181b, 0x232124, 0x1b191c, 0x181619, 0x19171a, 0x161417, 0x2e2c2f, 0x773f06, 0xaa6e28, 0xc6862f, 0xc88b2e, 0xb58732, 0x826e33, 0x3d4224, 0x00160a, 0x000623, 0x000618, 0x040000, 0x120000, 0x542d00, 0xb98230, 0xf5b44e, 0xffb748, 0xfbcf78, 0xf7d281, 0xf3d98e, 0xeedd98, 0xeddf9e, 0xefdd9b, 0xf2dc93, 0xf4da8f, 0xf5c980, 0xf2c373, 0xf1bf68, 0xefbc69, 0xaf8145, 0x4a250b, 0x180008, 0x0e001c, 0x02072f, 0x000022, 0x000d21, 0x394344, 0x80795f, 0xb8905d, 0xd28a42, 0xd47825, 0x996341, 0x71472f, 0x3c2619, 0x171312, 0x0d1215, 0x141a18, 0x1e1e14, 0x241e10, 0x211d1a, 0x1b1714, 0x211d1a, 0x201c19, 0x181411, 0x201c19, 0x221e1b, 0x110d0a, 0x000800, 0x000600, 0x000800, 0x000300, 0x070c08, 0x535456, 0xc4c5c9, 0xfdfcff, 0xfcfcfc, 0xffffff, 0xfafafa, 0xfbfbfb, 0xa4a4a4, 0x1a1a1a, 0x000000, 0x474747, 0xd3c483, 0xffea9d, 0xf9ce72, 0xf5ba54, 0xffc75f, 0xffbd62, 0xf6b86b, 0xf6bd7a, 0xffb853, 0xecad66, 0xfcb863, 0xffa828, 0xeda539, 0x483318, 0x020919, 0x161a1b, 0x161c1c, 0x1c1b2b, 0x1d0f30, 0x1b0104, 0x815b08, 0xfac328, 0xffb226, 0xff9444, 0xff9e2a, 0xf69e30, 0xfba339, 0xffa72b, 0xf79913, 0xeea139, 0xf2b251, 0xd69517, 0x492e01, 0x5f3407, 0x955319, 0xdb852e, 0xffab31, 0xffad24, 0xf4a524, 0xeda632, 0xffa51b, 0xfca51a, 0xffb63a, 0xf4ab4f, 0xb06627, 0x8b3e00, 0xbe7105, 0xffbd2b, 0xff9a21, 0xf9a737, 0xe4a033, 0xfaa933, 0xffa822, 0xff9e1e, 0xf8b453, 0x725010, 0x00002c, 0x5a3e19, 0xa56211, 0xa44515, 0xa84c27, 0xc97d25, 0xffb32c, 0xfda61b, 0xe6c63f, 0x6c4a24, 0x3e1907, 0xe9b150, 0xda860a, 0x90380a, 0x3a1121, 0x00040f, 0x9d9d9d, 0xededed, 0xffffff, 0xfefefe, 0xffffff, 0xfefefe, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xf5f5f5, 0xeef7ff, 0x192517, 0x090000, 0x7c3b27, 0xb64908, 0xffa515, 0x895641, 0x000b00, 0xf1af23, 0xff9e36, 0xffa52a, 0xfbad31, 0xba6f2e, 0x9a390c, 0xb2581c, 0x88471d, 0x00132b, 0x140f00, 0xc18f2c, 0xffb134, 0xf89827, 0xffaf48, 0xf7a02d, 0xfda922, 0xf3a624, 0xffb853, 0xd08438, 0x873d00, 0xb66911, 0xfea73d, 0xffa130, 0xffa436, 0xfba629, 0xffaa2c, 0xffa22e, 0xffa135, 0xffb139, 0xe7a22d, 0x95591b, 0x4d1018, 0x904100, 0xde8d21, 0xffae38, 0xf5a124, 0xfca426, 0xffa62c, 0xfe9e2e, 0xffa33a, 0xf1b03a, 0xfaa129, 0xffa32e, 0xffb756, 0x986f2f, 0x140d00, 0x100b0f, 0x271a2c, 0x211a21, 0x091515, 0x081f19, 0x00040e, 0x4a2f1e, 0xe8b53f, 0xf8b425, 0xffb377, 0xf1bb71, 0xf3be70, 0xf7c16b, 0xf8c069, 0xf7bf6c, 0xffc37d, 0xffc78f, 0xffc093, 0xf3c68b, 0xffe4a6, 0xffe7a7, 0xada368, 0x333204, 0x000500, 0x303634, 0x9ba1ad, 0xe4d2ba, 0xfffde8, 0xfffeed, 0xfffff6, 0xfffffd, 0xe7e6ec, 0xc4c0cf, 0xada9ba, 0x94ae91, 0x687c60, 0x252f16, 0x0b0c00, 0x201c11, 0x241e20, 0x14101e, 0x161326, 0x19190f, 0x1d1f1c, 0x15181f, 0x18171d, 0x1d1008, 0x321600, 0x734706, 0xae7822, 0xefa427, 0xffb025, 0xffb215, 0xffb317, 0xffae24, 0xffc555, 0xffd778, 0xbfa54e, 0x5c5b3c, 0x231700, 0x453939, 0x170c10, 0x774b0a, 0xffb61e, 0xffa406, 0xfc9224, 0xf99f2f, 0xfba131, 0xfea434, 0xffa737, 0xffa939, 0xffa838, 0xffa737, 0xffa535, 0xeba207, 0xff9d2e, 0xffa133, 0xf19400, 0xffc435, 0x6a4808, 0x1e0d05, 0x2e271f, 0x21140b, 0x726320, 0xc8a843, 0xffdf88, 0xffce7b, 0xffb643, 0xf6a716, 0xffb822, 0xffa528, 0xff8e27, 0xca6c26, 0x743e18, 0x21170b, 0x040f13, 0x0e1525, 0x1c1429, 0x161b15, 0x171d13, 0x151b0d, 0x121a0b, 0x192114, 0x0e1810, 0x081012, 0x293036, 0x7c7b5d, 0xaaa893, 0xafaca3, 0xbdbbbe, 0xeceaf5, 0xfefeff, 0xfbfdff, 0xfcffff, 0xf0f6f4, 0xdfe3e4, 0x8d8b90, 0x332a2d, 0x160702, 0x3e2b1a, 0xb7a380, 0xffeabe, 0xfcdda6, 0xf8ca96, 0xfbbb7e, 0xffbb6a, 0xffc260, 0xffc463, 0xf5bf75, 0xe9ba86, 0xf2c186, 0xf8c859, 0xffbb43, 0xffb235, 0xe4a62d, 0x37270e, 0x00052b, 0x111b10, 0x1a112e, 0x171520, 0x1e231f, 0x0d0e09, 0x190800, 0x9f7346, 0xffb84a, 0xffaa06, 0xffac27, 0xf79b1c, 0xffa52e, 0xff9f2d, 0xfd9929, 0xffa432, 0xfca730, 0xffb53a, 0xe7a433, 0x823807, 0x5e1202, 0x97551b, 0xd69723, 0xf8ad2d, 0xffa836, 0xfd9733, 0xffa143, 0xffa034, 0xffa52b, 0xffab2a, 0xfca933, 0xbf6a0d, 0x903b00, 0xc56c40, 0xfcb946, 0xeda127, 0xf8a01b, 0xffa61d, 0xfa980f, 0xffa626, 0xfdb03a, 0xc98518, 0x000022, 0x2a1b16, 0x845b1d, 0xa15615, 0x9b3f18, 0xc97131, 0xf7a331, 0xffa526, 0xffa63b, 0xeeb021, 0x130006, 0x8f763e, 0xffa93d, 0xa95914, 0x503b28, 0x090200, 0x2a2e37, 0xf9fcff, 0xfefeff, 0xfcfbf9, 0xfffffb, 0xfafbf6, 0xfcfefb, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0x9ca5ae, 0x030e0a, 0x2d1805, 0x974b2b, 0xc86315, 0xe6992d, 0x4b210b, 0x5c542f, 0xfcb22b, 0xff9f38, 0xff9d27, 0xf4a82e, 0xb6661f, 0x9e3e0e, 0xa85a29, 0x663a21, 0x000309, 0x614c1f, 0xe5ab40, 0xffb231, 0xfe9f2b, 0xffa43b, 0xf39e2a, 0xfda925, 0xffb845, 0xd28422, 0x914400, 0xb86b1b, 0xf0a240, 0xfda736, 0xffaa36, 0xff9728, 0xf9a020, 0xfca12e, 0xf69d25, 0xffad2d, 0xed9e35, 0x954a09, 0x672300, 0x935719, 0xe29128, 0xffb446, 0xffb53f, 0xf6a225, 0xfca426, 0xffa52b, 0xfb9b2b, 0xff9e33, 0xe4a227, 0xffb038, 0xffa73b, 0xd38230, 0x563404, 0x0b0a00, 0x181b20, 0x181121, 0x201b1f, 0x121c1d, 0x132823, 0x0a0d16, 0x3e2113, 0xdca735, 0xfcb421, 0xffb167, 0xfdbe5f, 0xffc069, 0xffc278, 0xffc989, 0xffca8c, 0xffc986, 0xffcc82, 0xffcf7e, 0xffd982, 0xefcc7a, 0xefd78d, 0xfffbc0, 0xfffbd4, 0xc1b8a9, 0x453841, 0x0a000c, 0x00000e, 0x20222f, 0x41444b, 0x6f7072, 0xadaca7, 0xdbd4ca, 0xe4dbcc, 0xd6c9b9, 0xced2ed, 0x9593a9, 0x3d3646, 0x10040e, 0x190c13, 0x20151b, 0x1c151c, 0x242128, 0x2a1a0b, 0x1e1e1c, 0x0c1f2e, 0x06243e, 0x071c31, 0x251c1d, 0x653b22, 0x945428, 0xcca025, 0xf0b557, 0xf1a75c, 0xf8a847, 0xffb430, 0xeea920, 0xf5b554, 0xffd6a3, 0xf0dca7, 0xbeae8a, 0x7c7266, 0x9e9085, 0xc69f66, 0xf0a736, 0xffa725, 0xfaa02e, 0xfda22f, 0xfda22f, 0xfea330, 0xffa431, 0xffa431, 0xffa431, 0xffa431, 0xfea330, 0xffb023, 0xfa9b25, 0xff9726, 0xffb735, 0xe3a629, 0xba8d38, 0x926838, 0x8e623d, 0xc4b16d, 0xfbd9b4, 0xffe0b5, 0xffcb65, 0xdfa619, 0xf3b136, 0xf6b04e, 0xf7b253, 0xe5bc40, 0xd19f3e, 0x9d6a35, 0x512c24, 0x1a0c23, 0x141a30, 0x1e2628, 0x151908, 0x151422, 0x1f1f29, 0x222127, 0x171719, 0x151316, 0x120d14, 0x1b1523, 0x453c4f, 0xb0abb1, 0xc5c3c8, 0xccc9d0, 0xdbdae0, 0xdedde2, 0xaaacab, 0x676c66, 0x41463f, 0x1a1720, 0x030005, 0x060000, 0x54473f, 0xcfbfa5, 0xffffcd, 0xffffba, 0xe3ce7b, 0xffd192, 0xffcf89, 0xface85, 0xf7cb8c, 0xf7c894, 0xfcc489, 0xffc36f, 0xffc55a, 0xf3b383, 0xffc668, 0xffb34a, 0xffac3a, 0xd5962c, 0x2e1f0a, 0x060f30, 0x152010, 0x191724, 0x131514, 0x171d13, 0x131716, 0x0b0004, 0x562d17, 0xc77e2f, 0xffb030, 0xffaa2c, 0xfaa025, 0xffa12c, 0xffa02e, 0xff9f2c, 0xffa12d, 0xf5a029, 0xf7a72c, 0xfeaf50, 0xe49c3a, 0x995105, 0x6b2100, 0x9f541b, 0xe79b39, 0xffae34, 0xfea32e, 0xffa034, 0xfc9e2c, 0xfca426, 0xfda827, 0xffb33b, 0xf9a640, 0xc46f1f, 0x964101, 0xca831b, 0xffb445, 0xffb338, 0xfb9816, 0xff9f1a, 0xffaa2a, 0xfbac35, 0xf9b343, 0x473529, 0x0f0008, 0x624219, 0xad6922, 0x9f3c1c, 0xba6022, 0xf2a225, 0xffa934, 0xffa536, 0xfeb131, 0x6a4a23, 0x3c260e, 0xeea642, 0xbd671c, 0x744a22, 0x2c1608, 0x08090e, 0xbcbdc1, 0xffffff, 0xfffeff, 0xfffffd, 0xfffffd, 0xfefffd, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xfdfdfd, 0xf9f9f9, 0xffffff, 0x3f4a46, 0x00000c, 0x653e1f, 0xa64815, 0xe0892c, 0xa3743e, 0x230100, 0xc69a4f, 0xffb02f, 0xfe9f35, 0xf8a130, 0xe89d2a, 0xa54e01, 0xaa4e1b, 0x965b39, 0x271813, 0x190800, 0xb88d49, 0xffb845, 0xffa622, 0xffa52c, 0xf9a133, 0xfda736, 0xffae31, 0xe99638, 0xa35200, 0xb1610a, 0xf2a442, 0xffb342, 0xf9a52b, 0xfda029, 0xffa232, 0xffa62e, 0xfba127, 0xffb737, 0xfcb13a, 0xb3661e, 0x83330e, 0xaa5f1e, 0xe8a32e, 0xffab40, 0xffaf40, 0xfba631, 0xf59f24, 0xffa92d, 0xffa92f, 0xfea02c, 0xffa231, 0xeba424, 0xffb33f, 0xef8d32, 0x894308, 0x220a00, 0x020e0c, 0x16252c, 0x141720, 0x191917, 0x101a1b, 0x142421, 0x14131b, 0x34130c, 0xd19733, 0xffb723, 0xffa644, 0xffba57, 0xffc56c, 0xffca7c, 0xffcc87, 0xffc785, 0xf6c47d, 0xf8cd7e, 0xf4cf77, 0xf0c382, 0xffdfa1, 0xffecb8, 0xd1bc91, 0x7e6e4c, 0x6c5b3f, 0x624c34, 0x604731, 0x7b7172, 0x685f60, 0x524c4e, 0x3d3b3c, 0x1b1f20, 0x020b0a, 0x000b0b, 0x000404, 0x06000c, 0x0d000c, 0x17070a, 0x281710, 0x392b20, 0x302718, 0x1b190a, 0x191b0d, 0x291e0a, 0x131200, 0x071106, 0x131e1a, 0x21201e, 0x371e19, 0x4d1810, 0x490300, 0x2e0c00, 0x3e160c, 0x653529, 0x96632e, 0xcb9528, 0xf7ba2e, 0xffbf41, 0xffb352, 0xffe590, 0xf4dfaa, 0xdcd6b6, 0xe5d6b5, 0xfff6cd, 0xc79c67, 0xc9933d, 0xf8b63e, 0xffa42b, 0xffa32a, 0xffa229, 0xfea128, 0xfda027, 0xfea128, 0xfea128, 0xffa229, 0xfca32d, 0xffa627, 0xfda430, 0xe2973c, 0xcc943f, 0xf9c967, 0xf1b459, 0xffb26d, 0xffde96, 0xffd7ac, 0xefb882, 0xecb94e, 0xefc13a, 0xcd9c35, 0x804e11, 0x683506, 0x221d09, 0x230d00, 0x3b1400, 0x4e2300, 0x391900, 0x1c0a00, 0x1b0f19, 0x261a3e, 0x161a1b, 0x181a17, 0x17190c, 0x201d0c, 0x38311e, 0x362919, 0x1a0a00, 0x110000, 0x010013, 0x030012, 0x06030e, 0x09070a, 0x0c0b07, 0x1b1c16, 0x3c3d37, 0x52534d, 0x77725c, 0x67614b, 0x5a523b, 0x5e5036, 0x655231, 0x7e693c, 0xd4be85, 0xffeaaa, 0xfdcf9e, 0xfacd8c, 0xf9cb7d, 0xf7c87a, 0xfac581, 0xffc684, 0xffcb7b, 0xffd071, 0xffb37c, 0xffc26d, 0xfda742, 0xffae42, 0xc68b2f, 0x1e1506, 0x0b172f, 0x16220e, 0x1b2121, 0x16190e, 0x101406, 0x171c1f, 0x0c091a, 0x220507, 0x8b481d, 0xe88834, 0xfca733, 0xffaa36, 0xffa02f, 0xffa12e, 0xffa22f, 0xfc9f28, 0xf7a128, 0xf29f25, 0xf9a13d, 0xffba39, 0xeca227, 0xa35513, 0x863218, 0xb2602e, 0xeb9e34, 0xffb828, 0xfda329, 0xfaa224, 0xfea726, 0xfba625, 0xf39f23, 0xffae3e, 0xfba842, 0xc67114, 0x9a4d00, 0xea9634, 0xffae3f, 0xff9d25, 0xffa629, 0xffa628, 0xf0a027, 0xffbb45, 0xb18637, 0x110008, 0x2f1f10, 0xa76b2c, 0xa94221, 0xa94b0e, 0xe19619, 0xffac3b, 0xfea432, 0xffae3a, 0xc79b32, 0x0d0000, 0xb7873b, 0xe18629, 0x9a5013, 0x603417, 0x030000, 0x6c6869, 0xfdfbfc, 0xffffff, 0xfafafa, 0xfeffff, 0xfefffd, 0xfcfefb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xd8d8d8, 0x0a1507, 0x100317, 0x93582c, 0xaa4300, 0xe19f3e, 0x4f3733, 0x402200, 0xffb142, 0xffa72e, 0xf69e30, 0xffb246, 0xd68921, 0x953b00, 0xb3612f, 0x6d4732, 0x000005, 0x724406, 0xf2af56, 0xffaf35, 0xfd9812, 0xffa426, 0xfba632, 0xffaf3e, 0xfba22c, 0xb55e0e, 0xbe6811, 0xfca845, 0xffb744, 0xf3a123, 0xf8a324, 0xfaa026, 0xffa634, 0xff9c2c, 0xffb02b, 0xfdae37, 0xb76a22, 0x813504, 0xb96c24, 0xffb148, 0xffac34, 0xfba131, 0xf99f2d, 0xf79e2a, 0xfba22c, 0xffa830, 0xffa62e, 0xfca22a, 0xffa22b, 0xffb639, 0xef9429, 0xba5e15, 0x622604, 0x1a0f0d, 0x021823, 0x0b1f28, 0x1c2124, 0x1b1e17, 0x10181b, 0x131c19, 0x19141b, 0x270708, 0xb8802d, 0xffb626, 0xff9923, 0xffa244, 0xffaf4f, 0xffb24c, 0xf5b049, 0xe7ac4e, 0xe9b967, 0xf8cf8d, 0xf3cc95, 0xffd9a1, 0xffddad, 0xf5d5ae, 0xb49f80, 0x7f6f55, 0xada282, 0xd9cda7, 0xe1d4aa, 0xa7a08e, 0xa09788, 0xa49a90, 0x887f7a, 0x3b3535, 0x090a0e, 0x050c12, 0x051016, 0x241706, 0x3d2e1b, 0x4d3c28, 0x52412d, 0x4a3d2c, 0x2e271d, 0x141510, 0x101616, 0x0f144c, 0x160c2f, 0x3c1c1d, 0x713c14, 0x9d590e, 0xca8520, 0xe7a534, 0xdfa329, 0x967331, 0x9e7f3c, 0x9e8147, 0x644320, 0x390e00, 0x703c17, 0xc88e3a, 0xfbbe3f, 0xffc861, 0xf4db9b, 0xfffdd0, 0xfbedbe, 0xfff3da, 0x9f9089, 0x3c2200, 0xe4b237, 0xfea42a, 0xfea42a, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xf99933, 0xffb22f, 0xeca533, 0x521a00, 0xa48159, 0xffe791, 0xfecd67, 0xffda90, 0xffd4b3, 0xffd57c, 0xedc04d, 0xb98b36, 0x603300, 0x3d1600, 0x6e4b11, 0x9f7e51, 0x947a41, 0xab7e45, 0xd69247, 0xeda133, 0xd5950d, 0x9e7300, 0x594008, 0x201010, 0x18202d, 0x161d25, 0x0e100f, 0x120d07, 0x30261c, 0x4c3a30, 0x523934, 0x573b37, 0x2e242c, 0x20171a, 0x100805, 0x070000, 0x0e0500, 0x493e3a, 0x897d7f, 0x9e9198, 0x969577, 0xb3af92, 0xd4cdb1, 0xd7cbb1, 0xac9c82, 0x7d6c4e, 0xb8a483, 0xfae3c1, 0xffe1a0, 0xffd99f, 0xffcf97, 0xf9c57c, 0xefb85d, 0xe8ae4a, 0xeeb158, 0xfbb96f, 0xffad51, 0xffb04c, 0xef9a26, 0xffb13a, 0xad7828, 0x0f0b00, 0x0b1828, 0x171e0c, 0x131e20, 0x1d1e18, 0x1b1811, 0x1a1e27, 0x10182d, 0x1b0e18, 0x723a21, 0xb15218, 0xe7962d, 0xffae44, 0xffa435, 0xffa12d, 0xffa129, 0xfc9f26, 0xffaa32, 0xf8a32c, 0xfb9f22, 0xf99f24, 0xffb538, 0xfdac40, 0xb66526, 0x893415, 0xb2651d, 0xf2b22a, 0xffaa29, 0xfaa524, 0xf8a322, 0xffb333, 0xfaa629, 0xf19d21, 0xffb139, 0xfdaa34, 0xb86312, 0xbe660d, 0xec8e2a, 0xffaa3b, 0xffa52d, 0xf99f24, 0xf3a124, 0xf7a92d, 0xfdb837, 0x543a23, 0x0d0407, 0x7c4821, 0xb55525, 0xa04204, 0xc97b16, 0xfdac37, 0xf4a431, 0xffa32f, 0xfab927, 0x321e1d, 0x624527, 0xf6a230, 0xb75109, 0x8d491a, 0x100300, 0x2c2220, 0xe2dedd, 0xfeffff, 0xf5f9fc, 0xfcffff, 0xfdfffc, 0xfefffa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0x909090, 0x000500, 0x401f2a, 0xa45220, 0xc5650f, 0xb98b36, 0x120516, 0x836028, 0xffaf27, 0xff9c29, 0xf7a42a, 0xffba4c, 0xc27118, 0x9a4600, 0xa16036, 0x341707, 0x16130a, 0xd99739, 0xffb147, 0xffa42a, 0xff9c18, 0xfba222, 0xfaa72f, 0xfda834, 0xe68719, 0xbe6717, 0xfba447, 0xffac3b, 0xfca72a, 0xfaa322, 0xfaa224, 0xffae33, 0xf09a23, 0xffa627, 0xffaf3e, 0xbf6c20, 0x823200, 0xaf621a, 0xf1a62f, 0xffad2d, 0xffa034, 0xffa430, 0xffa230, 0xffa230, 0xffa331, 0xfea32e, 0xffa52d, 0xffa72c, 0xffaa2c, 0xfbae3c, 0xbf6608, 0xa14b12, 0x683522, 0x1c1b23, 0x031d2c, 0x07191d, 0x181810, 0x1e2418, 0x181b20, 0x1b1d1a, 0x1c161a, 0x170006, 0x885a1f, 0xfdb636, 0xffa527, 0xffa534, 0xfba22e, 0xec9824, 0xefa738, 0xf5b553, 0xfdc674, 0xffda9e, 0xffd5a4, 0xfed078, 0xf0c67a, 0xefcc94, 0xffebc5, 0xfffde6, 0xefe6d5, 0x837d6d, 0x322f1e, 0x01170b, 0x1d291d, 0x474337, 0x4d3729, 0x411e0b, 0x582f19, 0x6f462a, 0x633a1a, 0x55403d, 0x4e3632, 0x3a1f18, 0x280d06, 0x200903, 0x150505, 0x080206, 0x04030b, 0x000f10, 0x040402, 0x3a180e, 0x864529, 0xcd783f, 0xffac4f, 0xffbf42, 0xfdb523, 0xffcc6d, 0xfdcb5c, 0xfad664, 0xfce28d, 0xc1a87f, 0x422714, 0x230600, 0x7c6229, 0xffcd6d, 0xffe8a9, 0xe9e2b6, 0xfaf1c8, 0xfffbf1, 0x67646d, 0x1d0700, 0xdfad32, 0xf8a430, 0xfaa632, 0xfca834, 0xffab37, 0xffac38, 0xffab37, 0xfeaa36, 0xfda935, 0xffa347, 0xfcaa2a, 0xe4a639, 0x210000, 0x64564d, 0xfefccb, 0xebda92, 0xf7d099, 0xffe1ab, 0xf9ce70, 0x7b5400, 0x270000, 0x613826, 0xc5a27a, 0xfdde9b, 0xe8ca82, 0xffc664, 0xffba48, 0xffb831, 0xffbb2a, 0xf9ae2e, 0xc08c36, 0x6b512e, 0x1f1919, 0x000020, 0x0a0525, 0x0c041b, 0x0b000c, 0x17010d, 0x290d19, 0x3b1929, 0x462133, 0x493627, 0x4f3a29, 0x5f4a37, 0x604733, 0x472c17, 0x432614, 0x533324, 0x5b3b2e, 0x23161d, 0x27181b, 0x40312a, 0x978875, 0xfff2d5, 0xffffd8, 0xfae9bd, 0xdcca9c, 0xfdbf5c, 0xf8c479, 0xfad29f, 0xfcdcab, 0xf5d08a, 0xeab454, 0xeb9d30, 0xf69626, 0xf69f14, 0xf3a529, 0xf3a622, 0xf8af2e, 0x7d520e, 0x050503, 0x0d1c23, 0x181a0d, 0x0e1726, 0x1b141b, 0x271919, 0x1b1b25, 0x0a1b2b, 0x18191e, 0x744529, 0xa74a11, 0xbc6c13, 0xf19e3e, 0xffa83e, 0xffa22e, 0xfc9e24, 0xfda126, 0xffae33, 0xfaa42d, 0xffa725, 0xffa02a, 0xfb9e25, 0xffb632, 0xffae3e, 0xb5661b, 0x8d4201, 0xae6a19, 0xffaf39, 0xffb53d, 0xf19d21, 0xf7a326, 0xffb030, 0xf8a322, 0xfaa524, 0xfea928, 0xfca14e, 0xca6f16, 0xde801e, 0xffa539, 0xffa22e, 0xfba127, 0xfea92c, 0xffab2e, 0xffb92e, 0xb7913e, 0x190a03, 0x3e160e, 0xae6226, 0xa3490b, 0xba6320, 0xfbad2f, 0xf4a936, 0xff9b1b, 0xffba23, 0x7f6439, 0x16050f, 0xdb9928, 0xd4651e, 0xa24e10, 0x39251a, 0x0b0000, 0xaba6a3, 0xfafeff, 0xf9ffff, 0xfbffff, 0xfafcf9, 0xfffffa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfafafa, 0xffffff, 0xfdfdfd, 0xffffff, 0xf5f5f5, 0x464646, 0x000400, 0x753b30, 0xa7420e, 0xde9336, 0x6e551d, 0x110005, 0xc08b3b, 0xffb124, 0xff992c, 0xffad26, 0xfaad39, 0xb65e16, 0xa75b29, 0x704427, 0x160000, 0x745529, 0xffb945, 0xfba02d, 0xff9e26, 0xffa92b, 0xf9a624, 0xf8aa2c, 0xfba430, 0xe88317, 0xf39c3f, 0xffaf43, 0xfba224, 0xf69916, 0xffa629, 0xfba22c, 0xf39e27, 0xf9a92e, 0xffb93a, 0xc77029, 0x973e12, 0xbb681c, 0xfbac35, 0xffb131, 0xf79e26, 0xffa632, 0xffa12a, 0xffa12c, 0xffa02f, 0xff9f2f, 0xfea02e, 0xffa62e, 0xffaa2c, 0xffac27, 0xd88829, 0x9c4500, 0xa95829, 0x714739, 0x0e111a, 0x031924, 0x141a18, 0x1f0e00, 0x1a1d12, 0x18151c, 0x1f1e1a, 0x1c1817, 0x0d0010, 0x523112, 0xedb74b, 0xffbc41, 0xffb126, 0xfaab2c, 0xeb9d30, 0xffb95d, 0xffcf7e, 0xffc173, 0xffbc6b, 0xf5b460, 0xce9e52, 0xfccd87, 0xffe1a3, 0xffe8b2, 0xffedba, 0xf1d7a6, 0xbaaa77, 0xc6bb85, 0xfcf6bc, 0xecdba5, 0xddb88b, 0xbf8963, 0xa96a49, 0xa06142, 0x814626, 0x592402, 0x2a0300, 0x401703, 0x5c2f0e, 0x74481b, 0x875e26, 0x8b692a, 0x836825, 0x796520, 0x5b5324, 0x372d14, 0x18080b, 0x17000b, 0x451e19, 0x936029, 0xdea031, 0xffcd39, 0xf7ac35, 0xffc95c, 0xfbc160, 0xedc565, 0xffeb8d, 0xf1e79f, 0x85815c, 0x040100, 0x926929, 0xfff6c7, 0xfffcdd, 0xffffef, 0xd8d8d6, 0x180f06, 0x845d22, 0xfbb843, 0xf5aa44, 0xf8ad47, 0xfbb04a, 0xffb44e, 0xffb54f, 0xffb54f, 0xfeb34d, 0xfcb14b, 0xffb153, 0xefa22e, 0xf5b54b, 0x7e551f, 0x1b0f03, 0xced6c9, 0xfcffe8, 0xffffdd, 0xffff92, 0x654a1d, 0x260500, 0x987a60, 0xffefb8, 0xffdd9e, 0xf0c479, 0xf8ca6a, 0xffb85e, 0xfeb63d, 0xf7c032, 0xe0ab41, 0x98623e, 0x461729, 0x180019, 0x0d0713, 0x463106, 0x5c4615, 0x70571f, 0x826627, 0x8d6b2c, 0x855f21, 0x71460f, 0x5b2d00, 0x391300, 0x320a00, 0x4e2303, 0x794a2c, 0x92603d, 0x9b683b, 0xb9854c, 0xe7b475, 0xfedec5, 0xf1d2b5, 0xcbab85, 0xbd9e70, 0xf1d1a0, 0xffeaba, 0xffedc0, 0xffdfb5, 0xf2bd79, 0xe3b05f, 0xdcad51, 0xf2bf66, 0xffd180, 0xffcc75, 0xffb64a, 0xf9a21f, 0xf6a70e, 0xeba430, 0xffc342, 0xe4aa2f, 0x482700, 0x070b17, 0x122023, 0x1c150d, 0x1b2234, 0x17080f, 0x290d0c, 0x140e10, 0x081c23, 0x132019, 0x714926, 0xb6571d, 0x914500, 0xd2822b, 0xfda742, 0xffa633, 0xfb9d21, 0xfea024, 0xffa72d, 0xf59c26, 0xfc9e2c, 0xffa829, 0xfd9f21, 0xfb9e25, 0xffb433, 0xffb22e, 0xbd7215, 0x7c2e08, 0xca7518, 0xffb04a, 0xffb343, 0xef9b1f, 0xf49f1e, 0xfda625, 0xfda527, 0xffa52b, 0xffae4b, 0xf69834, 0xeb8e26, 0xf69a2b, 0xffaa37, 0xffa62e, 0xf89e23, 0xffa92b, 0xffa427, 0xfec33b, 0x5f3d0f, 0x200307, 0x835521, 0xa6541c, 0xb85625, 0xf9aa31, 0xf9ae37, 0xfb9912, 0xffb62a, 0xbb8c30, 0x07000b, 0x8e671c, 0xe2813a, 0xab4d0d, 0x5a3d2b, 0x0f0000, 0x675f5c, 0xeff4f8, 0xf8ffff, 0xf9ffff, 0xfbfbf9, 0xfffff8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xd1d1d1, 0x141414, 0x0b0e05, 0x9d4e27, 0xb94512, 0xbd8b2c, 0x291e08, 0x401c0e, 0xe8a139, 0xffb02a, 0xff9c35, 0xffb31f, 0xf19b20, 0xb7581e, 0x98593a, 0x351e10, 0x381900, 0xda9841, 0xffb132, 0xf69b26, 0xfd9c2b, 0xffaa35, 0xf7ac2c, 0xf4ab2a, 0xffa731, 0xff962c, 0xffb141, 0xf59d21, 0xffaa23, 0xffa220, 0xff9e2b, 0xfea137, 0xec9824, 0xffb435, 0xcd833c, 0x95450a, 0xb45d16, 0xfea736, 0xffb02b, 0xfaa026, 0xffa532, 0xfda527, 0xffa024, 0xffa02a, 0xff9f2f, 0xff9e31, 0xfea02f, 0xfaa028, 0xf7a31f, 0xfba81e, 0xbb6920, 0x984205, 0xa65b33, 0x5d3828, 0x050b0b, 0x07191b, 0x231a11, 0x542e19, 0x1f1f13, 0x160e19, 0x1f1a14, 0x1a1b15, 0x120e25, 0x200f07, 0xbf9944, 0xdc9f2c, 0xba7903, 0xeeaa3b, 0xf2aa46, 0xfeb155, 0xffbd61, 0xf2a03d, 0xe59327, 0xeb9723, 0xffd09c, 0xffdfa6, 0xffd28d, 0xfab663, 0xf0ab4c, 0xfabb51, 0xecb745, 0xfacc54, 0xcd8a1f, 0xc37916, 0xbd6815, 0xb25917, 0xa4511f, 0x813c15, 0x592404, 0x532a0e, 0xb07525, 0xce8e37, 0xeca847, 0xfcb446, 0xfeb63e, 0xfdb839, 0xf9b836, 0xf3b733, 0xefb93b, 0xddb148, 0xa98b42, 0x5e491e, 0x271500, 0x1a0100, 0x3d1a00, 0x825631, 0xeab70e, 0xfac038, 0xfcba5c, 0xffc181, 0xfec997, 0xffe9bc, 0xf1e7c3, 0x818465, 0x150500, 0xc5b093, 0xfff6ea, 0xf3f9ff, 0x444c4f, 0x1c0400, 0xd19036, 0xffb144, 0xfab75e, 0xfbb85f, 0xfdba61, 0xfebb62, 0xffbc63, 0xfebb62, 0xfebb62, 0xfdba61, 0xffc05a, 0xfaaf49, 0xfdb046, 0xd69b3f, 0x1e0000, 0x655d68, 0xeaf1f7, 0xf8ffe8, 0xa2a862, 0x0d0a00, 0x8b8086, 0xfffbda, 0xfae096, 0xf9cd76, 0xffd271, 0xf4ad37, 0xffc345, 0xcba230, 0x7b6a18, 0x312201, 0x150000, 0x330800, 0x7b5315, 0xac8c1d, 0xe8af2c, 0xf1b932, 0xf3ba2f, 0xf8bf30, 0xf9bf30, 0xf5b72e, 0xf5b633, 0xeead2f, 0xd29f46, 0xa0681d, 0x6c2f00, 0x6a2600, 0x92491c, 0xa55a20, 0xa35709, 0xb76c11, 0xaf7215, 0xd69a3a, 0xfdc25e, 0xfdc25e, 0xf3b65b, 0xe7a858, 0xfebd79, 0xffca8f, 0xffe9b9, 0xf8ca7d, 0xe1a133, 0xe38f12, 0xfe9f29, 0xffb74a, 0xffbc50, 0xf9b240, 0xfbb232, 0xb77829, 0xdaa547, 0xb98b2b, 0x210600, 0x0f1535, 0x121d21, 0x221411, 0x1d2124, 0x2d1610, 0x4c241a, 0x1c0e05, 0x091f1c, 0x0c1e12, 0x603815, 0xb9561f, 0x883d00, 0xbc6f1f, 0xf7a341, 0xffa834, 0xfb9f20, 0xffa426, 0xfda328, 0xf69d27, 0xf49f2b, 0xfba325, 0xffa92f, 0xfc9b2a, 0xf6981e, 0xffb933, 0xf9ab3e, 0xb1621f, 0x933e00, 0xcd7828, 0xffb24c, 0xffb43c, 0xf7a221, 0xfba325, 0xffa230, 0xffa135, 0xfc9d29, 0xffaa38, 0xfa9f2c, 0xf69d29, 0xffab37, 0xffa52d, 0xf79a21, 0xfd9f25, 0xf49d33, 0xffbc1b, 0xc58e2a, 0x2e2017, 0x3c2a14, 0x9e5425, 0xbb5316, 0xef9c32, 0xfdaf31, 0xf4a01c, 0xffac26, 0xe79f26, 0x261a0e, 0x3d2a24, 0xcb8432, 0xb6561c, 0x6e4b35, 0x200900, 0x28201d, 0xdadfe5, 0xf5ffff, 0xf8ffff, 0xfffffd, 0xfffff6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xb2b2b2, 0x000000, 0x22231e, 0xb4571e, 0xd35626, 0x805f00, 0x020100, 0x6f3e1d, 0xffaa33, 0xf8a92a, 0xff9f3b, 0xffb318, 0xf09214, 0xbe5a28, 0x7c4433, 0x100500, 0x704d27, 0xffbb48, 0xf8a926, 0xffa933, 0xfe9f33, 0xfba534, 0xf3ac2c, 0xeea522, 0xffa52d, 0xffa33a, 0xf9a729, 0xf39d14, 0xfea115, 0xffaf2e, 0xff9f33, 0xffa33f, 0xffb747, 0xe19b19, 0x81332f, 0xb96f28, 0xf7a72a, 0xffad2e, 0xff9d2d, 0xffa22a, 0xffac2c, 0xfca72a, 0xffa124, 0xffa32c, 0xffa132, 0xffa136, 0xffa133, 0xfaa028, 0xfaa622, 0xffb327, 0xb46226, 0xa24c19, 0x944c26, 0x3f1c09, 0x0c110b, 0x101d16, 0x291709, 0x946048, 0x343226, 0x1d131e, 0x1f1810, 0x1a1d14, 0x1a1e39, 0x030002, 0x876c25, 0x905d00, 0x6e3200, 0xe7a956, 0xfdbc58, 0xeaa32f, 0xf3a326, 0xf1991b, 0xffa42a, 0xffbd46, 0xffde8f, 0xdeaa54, 0xe39b37, 0xf89e2e, 0xf79319, 0xffaa2b, 0xf89b1a, 0xd17a00, 0xc27314, 0xdb8329, 0xde7929, 0xc3570e, 0xaf4803, 0xa34a06, 0xae6822, 0xe3a862, 0xffb037, 0xffb034, 0xffac2d, 0xffa322, 0xff9e21, 0xffa32b, 0xffa633, 0xffa334, 0xffa234, 0xffb538, 0xffc137, 0xfec339, 0xe0b846, 0x8a732d, 0x271f0a, 0x0d0d17, 0x400b07, 0xbf8847, 0xf4b73a, 0xffbe39, 0xffc065, 0xffd5a0, 0xfffccd, 0xede7a9, 0x1d1e22, 0x0f0000, 0x968687, 0x5b6888, 0x020d13, 0x85601a, 0xffbe4d, 0xff9e35, 0xffc071, 0xffc071, 0xfebf70, 0xfdbe6f, 0xfdbe6f, 0xfdbe6f, 0xfdbe6f, 0xfebf70, 0xfac45a, 0xffc366, 0xffa93b, 0xffb63c, 0x7d4a08, 0x110007, 0x807d92, 0x768460, 0x000725, 0x26361c, 0xe9f7ba, 0xffffd0, 0xf5d6a7, 0xffcf76, 0xf3a92c, 0xffb22c, 0xa76737, 0x3a1606, 0x030007, 0x282d26, 0x908245, 0xe4b446, 0xffc13c, 0xffbb36, 0xffac37, 0xffab32, 0xffa325, 0xffa524, 0xffa326, 0xfc9f28, 0xffa537, 0xffa238, 0xebb225, 0xffc851, 0xeaa44e, 0xa95820, 0x9c4416, 0xa84d16, 0xb75b10, 0xdd8229, 0xea8f26, 0xc46a00, 0xd07b00, 0xf29e17, 0xfdaa1e, 0xee9a13, 0xf29d1c, 0xe99318, 0xf0be5d, 0xffcb76, 0xffc576, 0xf5a84c, 0xed9925, 0xf9a11c, 0xffa625, 0xffa129, 0xeba546, 0x682d05, 0x8c5c1e, 0x865e18, 0x0f0005, 0x131b49, 0x0d181c, 0x2b1716, 0x050900, 0x50341f, 0x8b5f46, 0x31200e, 0x061b12, 0x001204, 0x4b2204, 0xb64d20, 0x924b0d, 0xb66a1e, 0xf3a040, 0xffa834, 0xfca021, 0xffa928, 0xffa429, 0xffa530, 0xf7ab24, 0xfba534, 0xffa136, 0xffa62e, 0xffa52e, 0xf99c35, 0xf4a137, 0xffb737, 0xba6135, 0x994404, 0xd17c1f, 0xffb03a, 0xfda827, 0xfea42a, 0xffa135, 0xff9f41, 0xffa626, 0xffa62a, 0xffa52b, 0xffa62e, 0xf79e28, 0xfaa028, 0xffac34, 0xffa42b, 0xf5a745, 0xffa400, 0xffcc42, 0x4c462c, 0x06030a, 0x944c26, 0xbc5103, 0xe48c33, 0xfcae28, 0xf2a72a, 0xff9f19, 0xffae2a, 0x50441a, 0x0b0535, 0xa57216, 0xc3622f, 0x7a553b, 0x3b200f, 0x070000, 0xc4cbd1, 0xedfaff, 0xf8ffff, 0xfffffb, 0xfffdf3, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0x7c7c7c, 0x010101, 0x783a11, 0xb45400, 0xb76d2e, 0x3d363e, 0x0e070f, 0xb06017, 0xffa32a, 0xf4a338, 0xffa017, 0xff9e49, 0xdc9320, 0x815f08, 0x140316, 0x33210d, 0xeebb45, 0xffa23d, 0xff9f2a, 0xff9f27, 0xffb220, 0xf8b542, 0xa96d37, 0xd59d46, 0xf5ae20, 0xffa62e, 0xffac23, 0xf9ab2d, 0xeeaa2d, 0xf9a938, 0xffa632, 0xffb218, 0xd79b29, 0x592927, 0xd77c07, 0xf89d28, 0xffac37, 0xffa530, 0xffa42f, 0xffa631, 0xffa530, 0xffa833, 0xff9b2e, 0xffa130, 0xffa42c, 0xfda329, 0xfba52c, 0xf9a42f, 0xf9a22f, 0xffab3a, 0xd27b2e, 0xaf5b05, 0x7b3d0a, 0x1f111e, 0x001428, 0x1d2e0a, 0x874900, 0xe65713, 0x5a351a, 0x13060f, 0x041618, 0x0b2114, 0x1a1b16, 0x2c2014, 0x1a1309, 0x0c0c30, 0x945f11, 0xf2ad38, 0xffa924, 0xff9c28, 0xfb9c2e, 0xfba92b, 0xffb030, 0xffa93a, 0xf79b16, 0xfa9b1b, 0xfd9822, 0xffa234, 0xffa63b, 0xec8f25, 0xd88316, 0xe19422, 0xffbb47, 0xd58526, 0x8f4403, 0x9e5a2d, 0x9c5925, 0xa35e10, 0xf6af3b, 0xffbc2d, 0xffa711, 0xfe9c31, 0xffa325, 0xfdaa1c, 0xf6a549, 0xf4a44f, 0xffb030, 0xffa216, 0xf7b151, 0xfdb958, 0xfebc5b, 0xf8b856, 0xfec05d, 0xffcf6a, 0xeeb34b, 0xb3790e, 0x1e1319, 0x0a000b, 0x6b4e12, 0xf2bb2b, 0xf8a32e, 0xffbf83, 0xdac6a5, 0xebfffd, 0x606d42, 0x000908, 0x070311, 0x000010, 0x171006, 0xcd8f28, 0xfca41f, 0xf3c081, 0xffcc81, 0xfdc97e, 0xfbc77c, 0xfac67b, 0xfcc87d, 0xfdc97e, 0xfcc87d, 0xfbc77c, 0xffbe78, 0xffc78c, 0xf7b65c, 0xf6ab11, 0xbb832c, 0x050008, 0x00090a, 0x070004, 0x000600, 0x8b957c, 0xf1e3fc, 0xf2d0ad, 0xf9c35f, 0xe0a138, 0xd5a63c, 0x714633, 0x00001e, 0x44290b, 0xb07a10, 0xf6b833, 0xffca5a, 0xf0c26c, 0xefbb67, 0xfcbe5b, 0xf9b85a, 0xfdb44b, 0xfea845, 0xf69640, 0xffa43d, 0xffac2b, 0xf39d24, 0xffa54d, 0xff9f10, 0xffab23, 0xffb53c, 0xf0af47, 0xac6e19, 0x944d0b, 0xb3602a, 0x9d3e12, 0xd08a1b, 0xffb548, 0xdf9325, 0xd38113, 0xf5a02c, 0xfea62a, 0xfca41f, 0xf8a116, 0xfb9c28, 0xffa02c, 0xffa430, 0xffa531, 0xffa22e, 0xfe9f2b, 0xfe9f2b, 0xffa02c, 0xecb234, 0x785118, 0x080004, 0x151b2b, 0x171e17, 0x181909, 0x1f1c15, 0x1b1b1d, 0x000913, 0x653426, 0xc8632b, 0x944c04, 0x1b1b00, 0x001830, 0x111a21, 0x684618, 0xb3472a, 0xd8741e, 0xffa32b, 0xffa93e, 0xfa9b2f, 0xfca11d, 0xffa829, 0xff9d3f, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xf8bd31, 0xae692e, 0x7f391f, 0xc18429, 0xfdc220, 0xf6aa07, 0xfb991a, 0xff9d33, 0xf9a72a, 0xffa640, 0xffa02f, 0xffb121, 0xcd8a07, 0xbc7920, 0xffaf58, 0xffa72b, 0xf59b20, 0xffa12e, 0xffac15, 0xe1b04a, 0x211322, 0x161000, 0x986900, 0xea7c23, 0xffb41f, 0xe6a23f, 0xfbb033, 0xffac1b, 0x9c561b, 0x090005, 0x655436, 0xb9671b, 0xaf5a19, 0x6d360d, 0x100000, 0x898c93, 0xfbffff, 0xfffeff, 0xfffefd, 0xfffdfe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0x6c6c6c, 0x000000, 0x89491d, 0xb85d0e, 0x9e5920, 0x281e26, 0x1a0c0c, 0xbf6d21, 0xffa62d, 0xf5a73a, 0xffa734, 0xffa52b, 0xde9431, 0x592c03, 0x1b0100, 0xb2954f, 0xeead35, 0xff9f2c, 0xfdaa2a, 0xfdb11d, 0xf0a937, 0x8f4b0c, 0x9c5f0f, 0xe1a123, 0xfda92c, 0xff9736, 0xfe9e2d, 0xfba01b, 0xfaa42b, 0xf0ac1d, 0xf5c120, 0xc28a3f, 0x692812, 0xbe852e, 0xf89d28, 0xffab36, 0xffaa35, 0xfa9f2a, 0xfa9f2a, 0xfba02b, 0xf99e29, 0xfca12c, 0xff9b2c, 0xff9f2d, 0xffa936, 0xffa32a, 0xfaa025, 0xffa82a, 0xfca325, 0xffa727, 0xf1a02b, 0x8a4e06, 0x3e1f1c, 0x080224, 0x100e19, 0x5d4217, 0xac631e, 0xc35313, 0x603b1e, 0x190913, 0x0e1d20, 0x122923, 0x111520, 0x1e1614, 0x15120b, 0x000019, 0xa26d1f, 0xf9b43f, 0xffab26, 0xff9e2a, 0xfb9c2e, 0xf6a426, 0xfba828, 0xfda132, 0xffb030, 0xfca728, 0xffa52a, 0xffa62e, 0xfba02b, 0xf19c28, 0xf7a738, 0xffb849, 0xc56d09, 0x9d5000, 0xa66a38, 0x73452b, 0x442008, 0x553208, 0x754e09, 0xbf933a, 0xfbb756, 0xffb856, 0xf9a521, 0xffa622, 0xffa03c, 0xf99d22, 0xffa910, 0xff9f1f, 0xffa429, 0xffa632, 0xffb54e, 0xffc46c, 0xffc574, 0xfec777, 0xffcb7b, 0xffc876, 0xc7a05b, 0x48260b, 0x230100, 0x865314, 0xf7b12f, 0xf6ad2d, 0xc3914a, 0x917c5d, 0x606561, 0x000207, 0x181b12, 0x131b1d, 0x161211, 0xd49140, 0xffba38, 0xf7bd69, 0xffd08b, 0xffce89, 0xfccb86, 0xfccb86, 0xfdcc87, 0xfecd88, 0xfdcc87, 0xfccb86, 0xffd38f, 0xffcf95, 0xf7be67, 0xffba24, 0xc5913e, 0x150e1e, 0x0b191c, 0x1e121c, 0x000d08, 0x5d5e58, 0xa58e65, 0xc0883d, 0xf1a835, 0xffc64c, 0x744b0b, 0x0f0000, 0x613b14, 0xc89d59, 0xffd777, 0xffd06e, 0xfdcd7b, 0xffcd83, 0xffc067, 0xffb84a, 0xffa735, 0xffac24, 0xffaf25, 0xffa736, 0xfe9e2e, 0xfea31f, 0xffa823, 0xfca532, 0xfdb839, 0xe5a63c, 0xbe8d41, 0x835929, 0x4d2605, 0x502302, 0x79441a, 0x975d2b, 0x924a00, 0xbd711b, 0xffac4e, 0xffab45, 0xf09123, 0xfe9f29, 0xffa72b, 0xfa9d1c, 0xfd9e2a, 0xffa02c, 0xffa22e, 0xffa32f, 0xffa22e, 0xffa12d, 0xffa02c, 0xffa02c, 0xf5b935, 0x865e23, 0x140812, 0x11172d, 0x0b1516, 0x1f2018, 0x22211f, 0x16151d, 0x0c1816, 0x6f4022, 0xc0611f, 0xae5b15, 0x4f3618, 0x010f1a, 0x00010c, 0x462f21, 0x9d5117, 0xeb9929, 0xffb226, 0xfe9923, 0xff9e36, 0xffac35, 0xffa629, 0xfe9e30, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xffa83f, 0xffbd45, 0xae7814, 0x623400, 0xb68540, 0xffc84e, 0xf4a115, 0xffa12c, 0xf5a02b, 0xf89921, 0xffa223, 0xffab36, 0xdb9540, 0x905919, 0x8d5e04, 0xe5b932, 0xffb037, 0xf7970f, 0xffa513, 0xfbba46, 0x967b4c, 0x250f01, 0x572000, 0xe78a3d, 0xffa617, 0xeca436, 0xfcac31, 0xffab22, 0xb6702a, 0x150909, 0x392919, 0xb26d28, 0xb25d1c, 0x743d14, 0x0f0000, 0x787b82, 0xfbffff, 0xfffeff, 0xfffefd, 0xfefcfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xfdfdfd, 0x545454, 0x000000, 0x995322, 0xb8651f, 0x7a4114, 0x13070b, 0x391e13, 0xd9852f, 0xffa82b, 0xf4a639, 0xffa844, 0xfaae1a, 0xc47c32, 0x3c0000, 0x79520d, 0xfed24f, 0xf8a42a, 0xff9c18, 0xf0b422, 0xfdc844, 0x7d460e, 0x5d1f00, 0xe9ac2d, 0xffb528, 0xff9f3d, 0xff9d33, 0xffa62c, 0xff9e2f, 0xffad25, 0xf5c330, 0x927927, 0x331400, 0xb47c43, 0xffbd3d, 0xffaa35, 0xffa934, 0xfca12c, 0xf99e29, 0xfea32e, 0xffa42f, 0xfda22d, 0xffa42f, 0xffa830, 0xff9e2b, 0xff9d2e, 0xfe9d28, 0xffa726, 0xffaa21, 0xfba214, 0xffad21, 0xde9f1c, 0x63461e, 0x03052c, 0x000020, 0x542a1c, 0xa15420, 0xb65e1f, 0xae5e21, 0x603d21, 0x1b0a10, 0x0c1617, 0x051918, 0x111731, 0x1e1c2a, 0x151611, 0x000011, 0xaf7a2c, 0xfdb843, 0xffaa25, 0xffa02c, 0xfe9f31, 0xf4a224, 0xf7a424, 0xfa9e2f, 0xf4a433, 0xfca834, 0xffad32, 0xfaa123, 0xf29a1f, 0xffac3b, 0xfcaa44, 0xd6872a, 0x9e4b00, 0x97551b, 0x5c3518, 0x1f110e, 0x0f0f17, 0x0d0e12, 0x0f0800, 0x130700, 0x593213, 0xb98941, 0xf0ae36, 0xffaa2f, 0xfc931e, 0xffa610, 0xf59800, 0xf49332, 0xff9c0f, 0xff9e1c, 0xffa433, 0xfeab4d, 0xfbb668, 0xffcc89, 0xffd79c, 0xffd39c, 0xffde6e, 0xb98e3f, 0x200003, 0x320607, 0xf8bd49, 0xf4a900, 0xf2a22f, 0xa75f13, 0x130806, 0x0b0a0f, 0x26261e, 0x020c0e, 0x1b1d1c, 0xce8f40, 0xffb031, 0xffcf7f, 0xffd99b, 0xffd698, 0xfdd496, 0xfcd395, 0xfed597, 0xffd698, 0xfed597, 0xfdd496, 0xfbcf8e, 0xfdd9a5, 0xffd283, 0xffc637, 0xb58539, 0x100b21, 0x0a1920, 0x241822, 0x020a0c, 0x1a0804, 0x966e00, 0xf8aa2e, 0xf59c1e, 0xeeac32, 0x2e0a00, 0x0d1000, 0xe6a237, 0xffd475, 0xffe193, 0xf1cd8f, 0xfdc78b, 0xffbf73, 0xffad45, 0xffa426, 0xffa226, 0xf99a02, 0xf19e02, 0xeb9818, 0xfda22d, 0xffac24, 0xf29f11, 0xfcaf2d, 0xa48542, 0x4f3502, 0x0e0000, 0x060000, 0x100a0c, 0x1f1513, 0x221203, 0x4f3b22, 0xa45c2c, 0x9c4d12, 0xd57e31, 0xffab4d, 0xffa133, 0xff9e28, 0xffa931, 0xffa129, 0xffa12d, 0xffa12d, 0xfea02c, 0xffa12d, 0xffa22e, 0xffa22e, 0xffa12d, 0xfea02c, 0xfbbc2f, 0x986f2f, 0x160a16, 0x0e1532, 0x151f29, 0x1c1e1d, 0x151316, 0x100d18, 0x13120d, 0x73471a, 0xb1560d, 0xbd5b1c, 0x935530, 0x3d2719, 0x0c060a, 0x0e0518, 0x674102, 0xd39b24, 0xffb219, 0xff9811, 0xffa337, 0xffa639, 0xf59b23, 0xffa52a, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xfda329, 0xff9932, 0xf7a60e, 0xfbcd39, 0x9a7c36, 0x3c1b0c, 0x9a6b3d, 0xffc356, 0xf3a618, 0xf9a042, 0xffa931, 0xffa11e, 0xf4911a, 0xffc458, 0xc49a34, 0x443200, 0x706428, 0xfcbc5b, 0xffae1e, 0xff9f14, 0xffa924, 0xf6c44b, 0x754c2e, 0x3b000d, 0xbe773f, 0xffa523, 0xf9ab2f, 0xf9a529, 0xffa92b, 0xd58e36, 0x332115, 0x130505, 0x93662b, 0xb66120, 0x7f481f, 0x0f0000, 0x61646b, 0xf7fcff, 0xfffeff, 0xfffefd, 0xfefcfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0x3d3d3d, 0x070707, 0x9e5119, 0xad672c, 0x582f11, 0x120203, 0x623a20, 0xef9736, 0xffa627, 0xefa335, 0xf4a83a, 0xf4b12e, 0x80370c, 0x662018, 0xeab13e, 0xf6b417, 0xffa229, 0xffa81e, 0xedc843, 0x845d24, 0x330900, 0xb88738, 0xffbe25, 0xffab38, 0xffa143, 0xfda005, 0xf49b1b, 0xffb738, 0xf6bc3f, 0x835f25, 0x1d0007, 0x9d7b3e, 0xfcc02e, 0xffa223, 0xfda22d, 0xf99e29, 0xf89d28, 0xffa42f, 0xffaa35, 0xffa732, 0xffa42f, 0xffa732, 0xffaa2c, 0xffa331, 0xf8962b, 0xff9f2d, 0xffab27, 0xfba212, 0xfda819, 0xffb82e, 0x97752d, 0x211313, 0x000020, 0x423429, 0xa0632c, 0xb8551e, 0xa64814, 0xaa6321, 0x61432b, 0x1c0807, 0x222013, 0x071108, 0x0f1330, 0x1f2138, 0x121713, 0x0c0f18, 0xb17c2e, 0xfab540, 0xffa621, 0xff9f2b, 0xffa234, 0xf7a527, 0xfaa727, 0xffa334, 0xf79f3d, 0xffa53a, 0xffa630, 0xffa025, 0xffa631, 0xffb049, 0xe18731, 0x9c4400, 0xa05826, 0x7d4826, 0x1b0500, 0x000009, 0x00051c, 0x00011b, 0x000013, 0x05000d, 0x050000, 0x150200, 0xbb8e3b, 0xffb73c, 0xffaa24, 0xf99d1e, 0xffbb5c, 0xe8b178, 0xeb9622, 0xf99c25, 0xff9d21, 0xfd991f, 0xfaa032, 0xffb961, 0xffd08e, 0xfbd7a3, 0xffd081, 0xffe68d, 0x8a794e, 0x210100, 0xc78c3e, 0xffba2a, 0xffb82f, 0xf9a73b, 0x6c4e12, 0x190300, 0x15040e, 0x0b0d24, 0x0f1515, 0xa7751c, 0xffb53d, 0xffd6a6, 0xffdfad, 0xffdcaa, 0xfedaa8, 0xfdd9a7, 0xffdba9, 0xffdcaa, 0xffdba9, 0xfedaa8, 0xfcdfa5, 0xf9e2b6, 0xfbd48f, 0xf3b934, 0x9a6d29, 0x0f0a21, 0x040f11, 0x130407, 0x1a0900, 0x8a673f, 0xe4ad2c, 0xffb726, 0xffb941, 0xb17223, 0x190000, 0x888d57, 0xffdc78, 0xffd987, 0xfade9d, 0xffd396, 0xffb565, 0xffa039, 0xff9c23, 0xff9d1b, 0xf08e21, 0xeda52f, 0xf0ba4d, 0xf1b756, 0xe99b2c, 0xfeab1f, 0xffb834, 0xc3821e, 0x070000, 0x070302, 0x060c08, 0x000c08, 0x000a07, 0x000305, 0x000009, 0x161523, 0x814428, 0x964f23, 0x954100, 0xe38223, 0xffae3b, 0xff971c, 0xffa226, 0xffa028, 0xffa530, 0xfda22d, 0xfba02b, 0xfca12c, 0xfea32e, 0xffa530, 0xfea32e, 0xfca12c, 0xfcba26, 0xa37834, 0x070007, 0x10193a, 0x212b37, 0x0d0c08, 0x1b120d, 0x261b17, 0x0d0105, 0x764b21, 0xa9550f, 0xb74a12, 0xb8592b, 0x8c5627, 0x4b3923, 0x000010, 0x221504, 0x9d7327, 0xfcaf2b, 0xffa71b, 0xff9d25, 0xfb9e34, 0xfca12f, 0xffa52a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xffa01d, 0xffaa2b, 0xe8aa25, 0xf0c952, 0x8b6830, 0x2d0200, 0x976b3a, 0xf1cb44, 0xfcaf45, 0xee941a, 0xffa32d, 0xff982a, 0xffaa1d, 0xffd033, 0x9a8125, 0x1c090b, 0x9d6d3f, 0xfab442, 0xffa928, 0xff9b12, 0xffb61c, 0xd89c53, 0x672a29, 0x723b14, 0xffa431, 0xffb32e, 0xf8a229, 0xffa933, 0xe89e35, 0x5c3c23, 0x0d000c, 0x5d4a20, 0xb86322, 0x885128, 0x110000, 0x4d5057, 0xf7fcff, 0xfffeff, 0xfefaf9, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xf1f1f1, 0x2a2a2a, 0x131313, 0xa65013, 0x9a6032, 0x3b2114, 0x1e0908, 0x884f24, 0xfc9d31, 0xffa523, 0xf1a837, 0xf9b631, 0xcf8b38, 0x5f1500, 0xbf783a, 0xffbf33, 0xf8a616, 0xffaa3a, 0xffa32c, 0x937a38, 0x180000, 0x765230, 0xfccc4c, 0xee9f20, 0xff9d3e, 0xea8c0e, 0xfeb407, 0xffbb4f, 0xe6ba37, 0x735a24, 0x140000, 0xa1773b, 0xffc13f, 0xffa420, 0xff9a14, 0xfda22d, 0xf99e29, 0xfda22d, 0xffaa35, 0xffa631, 0xf99e29, 0xf99e29, 0xfda22d, 0xf29d1c, 0xffa835, 0xff9f34, 0xffa835, 0xfda21d, 0xf6a41a, 0xffb73c, 0xd79328, 0x3b303e, 0x0a000b, 0x3a210d, 0xb8923f, 0xbe7f22, 0xa24b16, 0xa54a1d, 0xaf5b13, 0x5e483b, 0x180000, 0x705d33, 0x51451d, 0x0c0411, 0x0c0d21, 0x131917, 0x0a0f15, 0xb17c2e, 0xf9b43f, 0xffa41f, 0xff9f2b, 0xffa335, 0xfaa82a, 0xfca929, 0xffa435, 0xffa438, 0xff9d2c, 0xff981d, 0xffa326, 0xffad3a, 0xf59332, 0xc06316, 0xa14708, 0x8b5940, 0x2a0600, 0x0a0000, 0x454952, 0x6a7686, 0x7a7d90, 0xaea3b4, 0xcdb8c7, 0x94a49a, 0x000007, 0x351e00, 0xeebd44, 0xf9b31f, 0xf6b166, 0xffefe1, 0xf7fae5, 0xf1d196, 0xe9b25f, 0xf09d27, 0xff9e0e, 0xff9f0d, 0xf49f20, 0xf2b857, 0xffdd94, 0xffdab7, 0xffedb8, 0xe8e59e, 0x4a3400, 0x773802, 0xffbf4e, 0xf0a81e, 0xffc565, 0xffd165, 0x825a27, 0x300e05, 0x060014, 0x0e101c, 0x9d7128, 0xffbf57, 0xf7ddb8, 0xffe5be, 0xffe3bc, 0xfce0b9, 0xfbdfb8, 0xfde1ba, 0xfee2bb, 0xfde1ba, 0xfce0b9, 0xffeec0, 0xeedfc0, 0xf6d69d, 0xfdc54a, 0x9b6b29, 0x130a1b, 0x020800, 0x200b00, 0x986d3a, 0xffd27c, 0xffc460, 0xeaa71a, 0xffc15d, 0x6b351d, 0x583c0a, 0xfcf0a4, 0xffeac2, 0xfbe3b3, 0xfddb9b, 0xffc065, 0xff9e28, 0xff9616, 0xff9b21, 0xea9423, 0xeab16c, 0xfbdbaa, 0xfff3d9, 0xfff7d3, 0xecb04e, 0xf7af1f, 0xf4b44a, 0x340200, 0x1e1b30, 0x9291a1, 0xbbbfc8, 0x9ea8a9, 0x717d7b, 0x5b6566, 0x42464f, 0x00000c, 0x431601, 0x945e38, 0x934e0b, 0xb25d00, 0xf99b29, 0xffa82b, 0xffa828, 0xf99b1d, 0xffa530, 0xfea32e, 0xfca12c, 0xfca12c, 0xffa42f, 0xffa530, 0xffa42f, 0xfda22d, 0xfdba23, 0xa27531, 0x070009, 0x191f3f, 0x0e1319, 0x0d0200, 0x695031, 0x70522c, 0x09000d, 0x70482f, 0xb2632b, 0xb14310, 0xb3460d, 0xb76a22, 0x9f7c44, 0x2d220e, 0x06001b, 0x543024, 0xd19040, 0xffb939, 0xfba51e, 0xfda42e, 0xffaf3f, 0xfb9d29, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xffac27, 0xfda333, 0xfda831, 0xe5a014, 0xf4bb4a, 0x9e6f39, 0x200300, 0x6c5d1a, 0xfcc050, 0xfab52c, 0xffae2a, 0xff9f3b, 0xf18219, 0xffaf2b, 0xf8c04f, 0x6f4608, 0x1d0000, 0x9e672e, 0xf9a63e, 0xffaa2e, 0xfda213, 0xffb73a, 0xb4782f, 0x562100, 0xe17e18, 0xffb336, 0xfba631, 0xffa631, 0xf7a331, 0x7f4e23, 0x190812, 0x2c2e18, 0xb35e1d, 0x8e572e, 0x170500, 0x3b3e45, 0xf5faff, 0xfffeff, 0xfcf8f7, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xe3e3e3, 0x191919, 0x1c1c1c, 0xb45714, 0x805230, 0x1e1415, 0x2f1611, 0xa35b20, 0xfe9b24, 0xffaa26, 0xf9b240, 0xfcb42e, 0x964a18, 0x9f5727, 0xf4ad37, 0xfeab21, 0xffac3f, 0xfaa650, 0xb26a1e, 0x15030f, 0x2a0d09, 0xcfa948, 0xf0b325, 0xfda446, 0xffa940, 0xf8b423, 0xfbc144, 0xcb9732, 0x694523, 0x150000, 0xa5883a, 0xffc630, 0xff9f14, 0xff9b2d, 0xffab35, 0xffa42f, 0xfa9f2a, 0xffa42f, 0xffa732, 0xfa9f2a, 0xf59a25, 0xfba02b, 0xffa631, 0xf4a11f, 0xfea531, 0xff9f34, 0xffa62f, 0xf7a420, 0xffbc41, 0xe3ab54, 0x693503, 0x000022, 0x34180c, 0xbb8431, 0xecac31, 0xa96707, 0x924916, 0xa75325, 0xb95c16, 0x3d3133, 0x160000, 0xcba554, 0xc09b43, 0x301600, 0x050006, 0x1a231e, 0x020c15, 0xb07b2d, 0xfcb742, 0xffa722, 0xff9f2b, 0xffa234, 0xfaa82a, 0xfba828, 0xfca031, 0xff9d1f, 0xffa727, 0xffa628, 0xffa42d, 0xfc9f37, 0xd27e28, 0xaa5f1b, 0xa56027, 0x4d322b, 0x100000, 0x685f60, 0xe6e6e8, 0xf8f7fc, 0xfffdff, 0xfffafa, 0xfff9f6, 0xf4fff3, 0x9ba2bc, 0x160d12, 0x8a6b01, 0xe9b523, 0xffcfa4, 0xfff7ff, 0xe3ffff, 0xfefff6, 0xfde9c4, 0xf4bf6f, 0xfaa731, 0xfb9e13, 0xef970f, 0xeaa229, 0xf4ba4e, 0xffe3b7, 0xf3e4d1, 0xfffdd4, 0xb7a263, 0x6b3000, 0xe1992b, 0xf5bb40, 0xf7c789, 0xffd16b, 0xffd68c, 0xa8814a, 0x1f0b02, 0x060009, 0x84521f, 0xf7bf60, 0xfef8c6, 0xffecd1, 0xfeeacf, 0xfbe7cc, 0xfae6cb, 0xfce8cd, 0xfde9ce, 0xfce8cd, 0xfbe7cc, 0xf3e6c6, 0xf0e4d4, 0xffebbe, 0xffcb57, 0x754200, 0x0a0000, 0x2d2d0b, 0x987b4f, 0xffd68b, 0xfec669, 0xffb470, 0xfabb38, 0xc79532, 0x53231f, 0xcdb47e, 0xfffcb7, 0xfff3ed, 0xf4dbb2, 0xebb55d, 0xef991e, 0xfd9210, 0xfc9725, 0xf5ac50, 0xf6c47b, 0xfff6db, 0xfdfeff, 0xf1ffff, 0xfff7f7, 0xffdc83, 0xedab21, 0x805204, 0x1c071a, 0xbbbbb9, 0xfffeff, 0xfffdff, 0xfffcff, 0xfefcff, 0xfffeff, 0xdfdfd7, 0x515242, 0x140000, 0x563418, 0x956534, 0xa06016, 0xcc8022, 0xffb145, 0xffa938, 0xffaa36, 0xfea52f, 0xfda42e, 0xfda42e, 0xfda42e, 0xfea52f, 0xffa630, 0xfda42e, 0xfca32d, 0xffbe29, 0x996e2a, 0x120411, 0x191d38, 0x040000, 0x402600, 0xd7a95e, 0xca943c, 0x090116, 0x502e22, 0xaf663b, 0xb5501a, 0xa13b00, 0xaf5d11, 0xdca553, 0xb28b3e, 0x23081b, 0x160004, 0x65371f, 0xe7af52, 0xffc23e, 0xf7a326, 0xfaa12d, 0xfea531, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xfea42a, 0xea9930, 0xffa928, 0xffa623, 0xff9f2d, 0xf9a529, 0xefb932, 0xa3832c, 0x140000, 0x713e11, 0xd7a93a, 0xf5bd22, 0xffb731, 0xffa045, 0xfc8f3a, 0xffb041, 0xdf9f19, 0x0e000b, 0x2a0600, 0xa9732d, 0xf3a340, 0xffad3c, 0xffae1d, 0xfbb835, 0x95571c, 0xaa5100, 0xf09f36, 0xffae3b, 0xffa528, 0xffa430, 0x9b561b, 0x270e07, 0x101f1a, 0xa75211, 0x925b32, 0x1f0d01, 0x282b32, 0xecf1f7, 0xfffeff, 0xfcf8f7, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xd2d2d2, 0x0a0a0a, 0x1f1f1f, 0xc15f18, 0x654026, 0x090915, 0x442721, 0xba681f, 0xff991b, 0xffae29, 0xf9b43f, 0xdf8a1f, 0x98470f, 0xe8a24d, 0xffb727, 0xfea527, 0xf09544, 0xb3703c, 0x4f250c, 0x03001c, 0x695018, 0xf2bc36, 0xffae27, 0xfaa435, 0xeeab38, 0xf3c15e, 0x986c3b, 0x351f00, 0x1c0000, 0xb78548, 0xffca2c, 0xf7a213, 0xffa42c, 0xffae31, 0xf39a36, 0xffa42f, 0xf99e29, 0xfea32e, 0xffa631, 0xfa9f2a, 0xfca12c, 0xffa833, 0xffa833, 0xffac2d, 0xfba02e, 0xfc9d2f, 0xfda52a, 0xfeb532, 0xe3ae44, 0x875e32, 0x1e0004, 0x2a1504, 0xb38c3d, 0xffc84c, 0xd8871b, 0x964601, 0x9d4f1e, 0xa1541e, 0xab591d, 0x141021, 0x371500, 0xf5ba46, 0xffc43b, 0x94662a, 0x281a0d, 0x101b13, 0x000e1d, 0xaa7527, 0xfcb742, 0xffaa25, 0xff9e2a, 0xffa032, 0xfba92b, 0xfca929, 0xf99d2e, 0xffa425, 0xffaf37, 0xfba339, 0xd5842b, 0xb36d27, 0x98612b, 0x7a5028, 0x603f1e, 0x050001, 0x494345, 0xf5f1f2, 0xfffefd, 0xfcf8f5, 0xfffff8, 0xf1f1e5, 0xfcfdef, 0xf6fff5, 0xf7ffff, 0x9d99a8, 0x5f4100, 0xe7ae29, 0xfdc089, 0xfff7ff, 0xdafffe, 0xfbfbff, 0xfffdfa, 0xfff8e0, 0xf6d09f, 0xebb265, 0xeaa138, 0xf19c1d, 0xfea018, 0xf4c772, 0xffecd4, 0xfff5f7, 0xfff8d7, 0xb28331, 0xc47f17, 0xffbf5e, 0xffcd7f, 0xf3d388, 0xffe6a6, 0xffde9b, 0xac8f65, 0x301a03, 0x682d00, 0xf4b54c, 0xfff8c9, 0xfff4e1, 0xfff1de, 0xfdeedb, 0xfdeedb, 0xfeefdc, 0xfff0dd, 0xfff0dd, 0xfdeedb, 0xf9ecdb, 0xfff7f3, 0xffecc7, 0xe0a432, 0x5c2300, 0x412a22, 0xa39a63, 0xfff2ac, 0xf6e097, 0xffd5a1, 0xffbf7d, 0xffb230, 0xb88009, 0xa57a57, 0xfff2e4, 0xf5ebc7, 0xffe7c6, 0xfac275, 0xf3a124, 0xfa9c16, 0xf7a53f, 0xedb77b, 0xf7dfbb, 0xffffe4, 0xfffaf4, 0xf0f9ff, 0xebffff, 0xf6ebe5, 0xffd47b, 0xca8909, 0x63460a, 0xa0aed3, 0xfdfffa, 0xffffff, 0xfdfaff, 0xfffbff, 0xfdf3fc, 0xfffbfb, 0xfffff6, 0xf0eddc, 0x37322f, 0x160800, 0x583c27, 0x80542f, 0x91561e, 0xb46e26, 0xc37723, 0xee9d42, 0xf9a32c, 0xfba52e, 0xfda730, 0xfea831, 0xfda730, 0xfca62f, 0xfba52e, 0xfba52e, 0xffbe2c, 0x926627, 0x190b18, 0x0d0b20, 0x211500, 0xa07727, 0xffc854, 0xfeb028, 0x182023, 0x2a1003, 0x95542c, 0xb25d1d, 0x9d4808, 0x98480b, 0xe29640, 0xffc249, 0x906a21, 0x2d0d02, 0x120001, 0x816132, 0xf1b94a, 0xfeac2e, 0xef971b, 0xffae2e, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa636, 0xffa522, 0xff9f23, 0xffa63d, 0xfda029, 0xfcb623, 0xfbc44d, 0xbd894f, 0x1c0000, 0x422500, 0x9a7c22, 0xe9bc3d, 0xfcb237, 0xfc9f37, 0xffae3b, 0xf9b121, 0x554d42, 0x0a0000, 0x4d2f13, 0xa6702a, 0xef9b39, 0xffa623, 0xffbe3a, 0xea9a43, 0xa55704, 0xca7d2d, 0xfdb141, 0xfda71e, 0xffa132, 0xb8611a, 0x3d1e01, 0x01131f, 0x964100, 0x945d34, 0x261408, 0x13161d, 0xdbe0e6, 0xfffeff, 0xfffcfb, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfafafa, 0xfdfdfd, 0xfefefe, 0xc6c6c6, 0x000000, 0x1f1f1f, 0xc76117, 0x52321d, 0x000316, 0x55372f, 0xcd7325, 0xff9b18, 0xffaf28, 0xf4af3a, 0xba580d, 0xd48133, 0xf0ab36, 0xffbd2c, 0xf79c29, 0xc9722d, 0x5e260b, 0x1f0510, 0x080715, 0xa1882c, 0xfdb934, 0xffb32e, 0xffba21, 0xdfa738, 0x5e3215, 0x1d0000, 0x0d052e, 0xb99944, 0xffb52b, 0xffa330, 0xffae3a, 0xf6a82c, 0xeea12d, 0xffb139, 0xffa833, 0xfda22d, 0xffa631, 0xffa934, 0xffa530, 0xffa732, 0xffa934, 0xfa9f2a, 0xffaa2d, 0xfea331, 0xffa93b, 0xffaf32, 0xffbf3d, 0xa87b1e, 0x230600, 0x1d0735, 0xb38e36, 0xedc33b, 0xfdc238, 0xc57020, 0x993712, 0xb15725, 0xa4581a, 0x884511, 0x01031c, 0x6a4624, 0xf3ac20, 0xffbd15, 0xf4bb64, 0x533f24, 0x000500, 0x000c20, 0xa26d1f, 0xfab540, 0xffab26, 0xff9d29, 0xfe9f31, 0xfeac2e, 0xffad2d, 0xfb9f30, 0xffb13e, 0xde902b, 0xb26618, 0x7f3e06, 0x532100, 0x3f1e0d, 0x23150c, 0x040000, 0x575f62, 0xedf1f4, 0xfffeff, 0xfbf7f6, 0xfffffb, 0xf2fcf3, 0xf4fff8, 0xeefff8, 0xfffeff, 0xf9ffff, 0xfdfaff, 0xddb88c, 0xb06d00, 0xffbf6d, 0xfff5eb, 0xf1fffd, 0xfff3f9, 0xfffbff, 0xfcfdff, 0xfffdff, 0xfff2e0, 0xfabf7b, 0xf79820, 0xff9500, 0xe6a031, 0xffe2b2, 0xfff1ff, 0xfffbf4, 0xf9d37e, 0xdf9941, 0xe7984b, 0xffcd55, 0xf0e6a8, 0xf8e5bb, 0xffe4b5, 0xfff4be, 0xd2b66d, 0xa36200, 0xd89017, 0xf8e4cb, 0xfff8ea, 0xfff6e8, 0xfff3e5, 0xfff3e5, 0xfff4e6, 0xfff5e7, 0xfff4e6, 0xfff3e5, 0xfdf0e7, 0xfffafe, 0xfcd9bb, 0xd19123, 0x9a5e15, 0xd7bcab, 0xfffeba, 0xffec94, 0xeaecad, 0xffded9, 0xffb565, 0xffb028, 0xe29b0f, 0xfcd588, 0xfff6ff, 0xfefffd, 0xffcd80, 0xfaa52e, 0xf99400, 0xfea31f, 0xfcc582, 0xfffaf1, 0xf5ffff, 0xe1f6f9, 0xfff4f4, 0xf5fafd, 0xf1ffff, 0xfffddf, 0xeeac4e, 0xb87300, 0xcbbc83, 0xe0ffff, 0xfbfeff, 0xf6f9ff, 0xfffffa, 0xfffff1, 0xffffee, 0xfffbf2, 0xfffbff, 0xfefbff, 0xf0f4ff, 0x48454e, 0x0b0000, 0x321108, 0x4f1f08, 0x642500, 0x843c02, 0xaf621e, 0xf7a12a, 0xfba52e, 0xffa932, 0xffaa33, 0xfea831, 0xfba52e, 0xfaa42d, 0xfba52e, 0xfcbb2b, 0x8e6527, 0x120411, 0x00000c, 0x64522c, 0xf0be5b, 0xfeb221, 0xffac05, 0x314635, 0x170500, 0x7e4115, 0xad601a, 0xa25b1d, 0x863c0d, 0xc76e1c, 0xffb022, 0xffd433, 0xa08550, 0x10041a, 0x0f0000, 0xb5832a, 0xffc64b, 0xffac27, 0xf4a71b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa52b, 0xffa814, 0xff992c, 0xffa341, 0xffa52a, 0xf7a225, 0xfaa43f, 0xf8a636, 0xffbe27, 0xb4a550, 0x120000, 0x0c0016, 0x76592f, 0xd9aa28, 0xffc62d, 0xfab222, 0xffc034, 0x7a7c4d, 0x030200, 0x1d1111, 0x67420e, 0xb46c0a, 0xffa035, 0xff9a30, 0xffaf45, 0xc78032, 0xad6324, 0xf8b042, 0xfdab1b, 0xff9c2f, 0xce6e21, 0x553004, 0x000a1d, 0x8b3600, 0x955e35, 0x29170b, 0x04070e, 0xced3d9, 0xfffdff, 0xfffefd, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfcfe, 0xfafeff, 0xfcfdff, 0xfffffd, 0xb2a89f, 0x0f0000, 0x482f1b, 0x9d5c32, 0x2a1b00, 0x170f02, 0x783c22, 0xc86a20, 0xffb03a, 0xf3b23c, 0xc57f1f, 0xd28115, 0xf29f25, 0xffba3b, 0xf09a33, 0xb56e30, 0x744732, 0x211517, 0x000711, 0x2d1f02, 0xe7ad42, 0xffc521, 0xfcae26, 0x826b3f, 0x000617, 0x0c0608, 0x482300, 0xf49f28, 0xf9a42d, 0xffaa33, 0xffad36, 0xffab34, 0xfda831, 0xfca730, 0xfca730, 0xfca836, 0xffa535, 0xffa136, 0xff9f37, 0xffa035, 0xffa331, 0xffa229, 0xffa01f, 0xff9c32, 0xfea026, 0xf9c83d, 0xdbc850, 0x6d5d22, 0x210000, 0x652c0e, 0xe19c4e, 0xffc026, 0xfeac3e, 0xf1ab4c, 0xb07028, 0x9f4415, 0xb64c00, 0xa46113, 0x3b2d20, 0x0f0000, 0xb3843e, 0xfeb640, 0xffaa39, 0xffb538, 0xd7a922, 0x1e1300, 0x000832, 0x986f20, 0xffb639, 0xffad1f, 0xf6a230, 0xf3a946, 0xfea932, 0xfea621, 0xffb033, 0xd89b42, 0x8c5828, 0x310f0e, 0x22142d, 0x17182c, 0x000204, 0x080e04, 0x7c7e71, 0xfefefe, 0xfdfdfd, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfffff8, 0xfbf8ff, 0xfffaff, 0xfffdf4, 0xe2daab, 0xc6ba7e, 0xfff4d0, 0xfff7f4, 0xfffbf1, 0xfdfdfb, 0xf2f9ff, 0xf9ffff, 0xffffff, 0xfff9e0, 0xf7d6a1, 0xd1a55c, 0xff9500, 0xfeb43b, 0xf1e8ad, 0xf7fff8, 0xffe8c4, 0xf1912d, 0xff991c, 0xffa638, 0xffe3cd, 0xeaebe3, 0xe7ffff, 0xf9ffed, 0xfae39d, 0xe5b144, 0xdea62d, 0xe9bb43, 0xf9f1ef, 0xfffbf9, 0xfffcfd, 0xfffafc, 0xfbf7f8, 0xfcfafd, 0xfffdff, 0xfefdff, 0xfcffff, 0xfceac4, 0xefc360, 0xe3a417, 0xf3b52c, 0xfff095, 0xffffe6, 0xe0edff, 0xffe8e4, 0xffe4aa, 0xfbb241, 0xe49512, 0xe6a93f, 0xffedad, 0xffffd8, 0xededcb, 0xff9c01, 0xf9a217, 0xdbac5a, 0xe6d0c2, 0xfff6fa, 0xffffed, 0xf7ffeb, 0xf3ffff, 0xf1f4fb, 0xfffef8, 0xfffde3, 0xffe6bd, 0xc1a87f, 0xeddcc2, 0xfffef8, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xf7f7f7, 0xfcfcfc, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0x707070, 0x000000, 0x020202, 0x101010, 0x1f1f1f, 0x282828, 0x8e3e1b, 0xdf942f, 0xffb22a, 0xffaa39, 0xffa242, 0xf9a42d, 0xfdb02c, 0xf4ac34, 0xffb732, 0x81671d, 0x00000e, 0x371718, 0xf0a63d, 0xffb023, 0xf3a536, 0xffc34f, 0x84712c, 0x12000c, 0x5b3331, 0xa96416, 0xa24d0d, 0x964a28, 0xa05c13, 0xfbae3c, 0xffab26, 0xffc249, 0xcd9e4c, 0x4d2e12, 0x1a0002, 0x846050, 0xeec56b, 0xf3c62b, 0xffa21c, 0xffa22b, 0xffa032, 0xffa330, 0xffa929, 0xfda925, 0xfba832, 0xffab44, 0xffa630, 0xffa630, 0xffa630, 0xffa630, 0xffa630, 0xffa630, 0xffa630, 0xffa630, 0xffbd3a, 0xcb912e, 0x502b00, 0x0f0000, 0x261025, 0x8e6e57, 0xf3c45a, 0xffc81f, 0xeba21f, 0x211e00, 0x000110, 0x39201c, 0x784c31, 0xab6621, 0xfa961e, 0xffb624, 0xffa834, 0xd28118, 0xcb831f, 0xf29d33, 0xffad44, 0xcb7021, 0x693619, 0x140816, 0x46230d, 0x80614d, 0x4a3021, 0x0e0000, 0xb7aca8, 0xfffeff, 0xfafbff, 0xf9fdff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffefc, 0xfefefe, 0xfcffff, 0xfcfdff, 0xfffffd, 0xaba29b, 0x0e0000, 0x4f3a29, 0x875230, 0x211200, 0x281c0e, 0x804525, 0xcb6e21, 0xffad37, 0xeca62d, 0xd38521, 0xf1a336, 0xffba44, 0xfaa42d, 0xc67212, 0x9c5720, 0x572e1c, 0x0d0304, 0x020d11, 0xb06e18, 0xffc867, 0xba953d, 0x483a0b, 0x11100e, 0x0c0000, 0x6b3f10, 0xd58c2d, 0xfda833, 0xfea934, 0xfea934, 0xfca732, 0xfaa530, 0xfaa530, 0xfda833, 0xffab36, 0xffac31, 0xfca228, 0xfd9e26, 0xffa52d, 0xffa72f, 0xfea32e, 0xf9a42f, 0xfaab35, 0xffbe29, 0xfcc755, 0xb1875f, 0x391727, 0x230500, 0x926c17, 0xf8be41, 0xffbc4a, 0xf7a825, 0xf8af2c, 0xe4a035, 0xab5a23, 0x9f3c13, 0xb5590c, 0x8d5a18, 0x23171b, 0x2a0d00, 0xd29e4a, 0xffb53c, 0xf9a231, 0xffb138, 0xf1bc3a, 0x624f0d, 0x00001c, 0x8c681c, 0xfcb53f, 0xffa91f, 0xf6a532, 0xf5aa44, 0xfea82f, 0xffad2b, 0xfeaf38, 0xa2712e, 0x3b1300, 0x2a1212, 0x110a1c, 0x00000c, 0x212a29, 0x979a93, 0xfffff8, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xf7f7f7, 0xfcfcfc, 0xfefefe, 0xffffff, 0xf6f9ee, 0xfefdff, 0xfffcff, 0xfffcf6, 0xfcf7cf, 0xe7dfae, 0xfbebd2, 0xffeaf0, 0xfffef8, 0xfffeff, 0xfbffff, 0xdfe8f1, 0xbbbfbe, 0xfff7e4, 0xfffdd4, 0xedcc97, 0xfd9421, 0xea9721, 0xe8bb5e, 0xead199, 0xf9c684, 0xffad3c, 0xffa921, 0xee9a1e, 0xedc486, 0xfbe6b9, 0xffffdb, 0xfff0bc, 0xffc76e, 0xffa62f, 0xff9a1a, 0xff9b1e, 0xefbe72, 0xf7c67a, 0xfaca80, 0xf4c57d, 0xf0c17b, 0xf2c67f, 0xf7cc87, 0xf9ce89, 0xfcc97a, 0xf3b352, 0xf09f29, 0xf29a1c, 0xf4a73b, 0xfdcd8b, 0xfff1de, 0xf2faff, 0xffdcbd, 0xf6a963, 0xf8982a, 0xffae39, 0xfaa94e, 0xffce91, 0xffdaaa, 0xcfa471, 0xff9c12, 0xde9526, 0xfcd59a, 0xfffcef, 0xfffdff, 0xbebeb4, 0xe3ebde, 0xf5ffff, 0xfbffff, 0xfdfcf7, 0xfffae7, 0xfbe6c9, 0xfae5c8, 0xfffdea, 0xf1f0eb, 0xfbffff, 0xfefefe, 0xf7f7f7, 0xffffff, 0xffffff, 0xf9f9f9, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xf8f8f8, 0x999999, 0x0f0f0f, 0x000000, 0x1a1a1a, 0x040404, 0x5e200b, 0xad6e1e, 0xf6ab34, 0xffab40, 0xffa03a, 0xfda42c, 0xf7a829, 0xf4ab38, 0xffb531, 0x775c27, 0x00000b, 0x725034, 0xffb646, 0xffa924, 0xfbaa37, 0xf7ae3b, 0xc6a643, 0x1d0407, 0x280c1a, 0x976121, 0xa85a0f, 0x94401e, 0xaa5b23, 0xe79a24, 0xffa625, 0xf5a81e, 0xf5bc37, 0xe0b952, 0x815f22, 0x200000, 0x471d00, 0xc19361, 0xffc663, 0xf3b047, 0xf8a839, 0xffa43d, 0xfd9a3c, 0xfe9e38, 0xffab2e, 0xf8aa16, 0xffa733, 0xffa733, 0xffa733, 0xffa733, 0xffa733, 0xffa733, 0xffa733, 0xffa733, 0xffa82a, 0xfaad43, 0xcd944d, 0x61371e, 0x1b0000, 0x210300, 0x5d3d0e, 0xb79645, 0xf9c24e, 0x7b652b, 0x030909, 0x0e070f, 0x6a3b21, 0x8d470c, 0xbb6d1a, 0xfda43c, 0xffb03f, 0xec9d34, 0xd38a23, 0xee992c, 0xffaf40, 0xcf751f, 0x794520, 0x221215, 0x331300, 0x705341, 0x483121, 0x0e0000, 0xb6aba7, 0xfffeff, 0xfeffff, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefdfb, 0xffffff, 0xfcffff, 0xfbffff, 0xfafafa, 0xa59e98, 0x0f0100, 0x554233, 0x5f3f2a, 0x0f0200, 0x3b2819, 0x8a4c25, 0xd37a26, 0xffb239, 0xf0a025, 0xf09b30, 0xffb54c, 0xffaf41, 0xca7109, 0xa35000, 0x8a4d21, 0x3d1b0f, 0x0f0607, 0x2a3332, 0xf3a13e, 0x9b7537, 0x151d12, 0x000415, 0x231a1f, 0x7d4921, 0xd07f23, 0xffb331, 0xffad38, 0xffac37, 0xffaa35, 0xfba631, 0xf9a42f, 0xf9a42f, 0xfca732, 0xffaa35, 0xf2991b, 0xffb030, 0xffb42f, 0xf5a11b, 0xeda020, 0xf8b542, 0xf9c059, 0xebb95a, 0xb7a245, 0x4e340f, 0x160000, 0x53301a, 0xb79239, 0xf3be3a, 0xfeb431, 0xf79c2a, 0xf29c2d, 0xffc230, 0xd0891d, 0xa23c14, 0xaf451d, 0xac6724, 0x55350f, 0x07000b, 0x744f1a, 0xf6b851, 0xffae31, 0xfa9b2d, 0xffad39, 0xffc244, 0xb6914a, 0x080005, 0x7a5c16, 0xf9ba49, 0xfda925, 0xf8a837, 0xf8a940, 0xffa62b, 0xffb235, 0xe89b31, 0x593c1c, 0x240f00, 0x0f0506, 0x03030b, 0x3c4447, 0xc0c6c2, 0xfffffd, 0xfffdff, 0xfbfbfb, 0xfcfcfc, 0xfefefe, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xfdfdfd, 0xffffff, 0xf6fff1, 0xfbffff, 0xfcfeff, 0xf1f1ef, 0xffffe8, 0xffffe3, 0xfff9f0, 0xfff9ff, 0xfffcfd, 0xf5f0f4, 0xf5fafd, 0xf7ffff, 0x97a29c, 0x8b8d80, 0xf7efdc, 0xfffde4, 0xffbb7d, 0xf39d2e, 0xffaa22, 0xf5ae3c, 0xf1a945, 0xfca62f, 0xffa924, 0xfeb83c, 0xff9a0d, 0xffb63e, 0xffc35e, 0xf3b24e, 0xf89e2c, 0xff9e20, 0xffa42c, 0xffa333, 0xf09709, 0xf69d0f, 0xf7a013, 0xf5a012, 0xf19e12, 0xf29f15, 0xf19f17, 0xee9c14, 0xef9c24, 0xfa9d24, 0xffa62d, 0xffa631, 0xfe9829, 0xeb9832, 0xf0b154, 0xf9c974, 0xf2a644, 0xfea831, 0xffa721, 0xffb534, 0xfea638, 0xf19f3c, 0xf29d32, 0xfc9f26, 0xe5992b, 0xffcf8b, 0xfffce1, 0xf8f5ee, 0x848283, 0xaba9ae, 0xfeffff, 0xf4fef5, 0xf5fffc, 0xfcfffb, 0xfbf4ec, 0xfff5ea, 0xfffcf1, 0xfef7ef, 0xf6fbf5, 0xf8ffff, 0xfcfcfc, 0xf7f7f7, 0xfefefe, 0xfbfbfb, 0xf9f9f9, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xb9b9b9, 0x3d3d3d, 0x000000, 0x111111, 0x2d0e0c, 0x6e4310, 0xd79535, 0xffa841, 0xffa037, 0xffa931, 0xf8a42a, 0xf4a73b, 0xffb938, 0x674931, 0x0d0709, 0xb7954b, 0xffc041, 0xffa226, 0xffac3a, 0xf49e2d, 0xfac545, 0x583e1b, 0x07000c, 0x614021, 0xad691e, 0x993c11, 0xa3461b, 0xd6881b, 0xffb43e, 0xffa71f, 0xf2a70e, 0xffc32e, 0xffcc57, 0xbd8e46, 0x5a2f0d, 0x1e0000, 0x503e26, 0xb4965a, 0xf6c55c, 0xf9b331, 0xfaa322, 0xfb9d29, 0xf99f31, 0xfea839, 0xfea733, 0xfea733, 0xfea733, 0xfea733, 0xfea733, 0xfea733, 0xfea733, 0xfea733, 0xffa52d, 0xffa833, 0xffb44b, 0xc88439, 0x703c17, 0x2a0701, 0x0d0004, 0x201825, 0xa28738, 0xbf9a54, 0x323226, 0x000315, 0x5d301b, 0x924a18, 0x965626, 0xbd7137, 0xffa83f, 0xffb851, 0xe49c30, 0xef9b27, 0xffaf39, 0xd67d21, 0x8b5322, 0x3d2116, 0x1e0300, 0x5d4332, 0x483527, 0x0d0000, 0xb3aaa5, 0xfffeff, 0xfeffff, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcf9, 0xfffffd, 0xfeffff, 0xfbffff, 0xf9fafc, 0xa39f9c, 0x100600, 0x4e4035, 0x3e3128, 0x0e0000, 0x593622, 0x925320, 0xd88529, 0xffb63e, 0xf79f24, 0xffae3f, 0xffba58, 0xdb8926, 0xa74d00, 0xa65617, 0x844f30, 0x260f07, 0x120e0d, 0x3d423e, 0x6c522d, 0x0d0300, 0x030009, 0x3d2825, 0x84491f, 0xd07c26, 0xf9a336, 0xffaf3c, 0xfea935, 0xffaa36, 0xffab37, 0xffab37, 0xffaa36, 0xfda834, 0xfda834, 0xfca733, 0xffa332, 0xffa830, 0xf9a425, 0xf3a626, 0xfcbb43, 0xf7c35e, 0xba9344, 0x755313, 0x1e0000, 0x462514, 0x9e7932, 0xf4ca40, 0xffd33a, 0xf5a931, 0xf69c3b, 0xffb14a, 0xfba335, 0xffc641, 0xb46810, 0xa13409, 0xc05f28, 0x8a5835, 0x190506, 0x190a03, 0xcb9c42, 0xffbe45, 0xffa324, 0xff9e33, 0xffa839, 0xfeb238, 0xe6b360, 0x311102, 0x6b4e0c, 0xf9bf54, 0xfeae31, 0xf8aa3b, 0xfaa83a, 0xffa82a, 0xffae3c, 0xb4701b, 0x251b1c, 0x0a0607, 0x030406, 0x6e7774, 0xf1faf5, 0xfcfffd, 0xfdf9fa, 0xfcf2fa, 0xfcfcfc, 0xfcfcfc, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xfcfcfc, 0xfbfbfb, 0xf8fff1, 0xf9ffff, 0xfbffff, 0xf8fcff, 0xfefff6, 0xfffff4, 0xf8f6f9, 0xfcf7ff, 0xfffbff, 0xfcf7fb, 0xfcffff, 0xf7fffb, 0xe4f4ea, 0x828d87, 0x484c4b, 0xdddddf, 0xfffae6, 0xf4af4a, 0xfa9200, 0xffac1c, 0xf8ae43, 0xe09c39, 0xdea33d, 0xd9ad4e, 0xffa52b, 0xfca637, 0xedac48, 0xf4b54c, 0xffbb42, 0xffb933, 0xfeb532, 0xf0b334, 0xffbb34, 0xffba33, 0xffb832, 0xffb733, 0xffb936, 0xffba37, 0xffb938, 0xffb635, 0xffb130, 0xffaf31, 0xffab31, 0xffaa30, 0xffad32, 0xffb335, 0xffb02e, 0xf5a824, 0xe0aa3e, 0xf5b645, 0xe49b2a, 0xde952c, 0xeca742, 0xffb344, 0xffa217, 0xffa100, 0xeabc6f, 0xfff9df, 0xd1ccd0, 0x313a37, 0x8a8c89, 0xfffaff, 0xece8f6, 0xfcfff6, 0xf0fdf4, 0xf9fffd, 0xf3f3f3, 0xfffdff, 0xfffdff, 0xefefef, 0xf9fffd, 0xf3fff7, 0xfdfdfd, 0xffffff, 0xf9f9f9, 0xf5f5f5, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfafafa, 0xf7f7f7, 0xffffff, 0xffffff, 0xe1e1e1, 0x727272, 0x000000, 0x100c1b, 0x3c230d, 0xaa7030, 0xfba342, 0xffa837, 0xffac35, 0xffaa38, 0xf3a43f, 0xffc042, 0x56342a, 0x2c1c0d, 0xe6be4c, 0xffb52b, 0xff9f2e, 0xffac3b, 0xffa030, 0xffba33, 0xb39137, 0x1b170e, 0x1c090f, 0x9b6632, 0xb45b1f, 0x973705, 0xb86614, 0xf8a73b, 0xffab3a, 0xffad35, 0xfa9e23, 0xf3a028, 0xffc052, 0xe7b755, 0xa37e26, 0x291e00, 0x2d1800, 0x7e5913, 0xe4b144, 0xffc53d, 0xfeb42d, 0xffaa3f, 0xfea555, 0xffa835, 0xffa835, 0xffa835, 0xffa835, 0xffa835, 0xffa835, 0xffa835, 0xffa835, 0xffab37, 0xfca429, 0xffa526, 0xffb03d, 0xc87f30, 0x774524, 0x3f2530, 0x03001e, 0x140b00, 0x7c6438, 0x39392d, 0x00091d, 0x361911, 0x944e1d, 0x984f1c, 0x843f18, 0xda8326, 0xffb654, 0xfbb146, 0xf6a62d, 0xffaf34, 0xe08a25, 0x95571a, 0x5d3418, 0x150000, 0x483526, 0x48382b, 0x0e0400, 0xb0a8a5, 0xfefcfd, 0xfafbff, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffefa, 0xfffffd, 0xfeffff, 0xfaffff, 0xfafeff, 0xa5a5a5, 0x0c0703, 0x3c3229, 0x232726, 0x230a05, 0x7d472d, 0x9f5b1a, 0xda8f2a, 0xffb23b, 0xfc9e2a, 0xffb546, 0xe3a049, 0xb05e0a, 0xa14600, 0xb36736, 0x704630, 0x170c08, 0x151716, 0x262722, 0x00061c, 0x010009, 0x623123, 0x9c4a1a, 0xb35702, 0xec952b, 0xffb546, 0xf2a83d, 0xfda736, 0xfea837, 0xfea837, 0xffaa39, 0xffab3a, 0xffab3a, 0xffaa39, 0xffa938, 0xffb353, 0xffa63f, 0xffad3e, 0xffbe4e, 0xe9aa43, 0xa06e19, 0x633b00, 0x4c2c00, 0xb67a56, 0xf0b652, 0xffcf40, 0xfbac33, 0xf2973a, 0xffa946, 0xffb03c, 0xf5a228, 0xffb437, 0xe79f3d, 0x9f4e16, 0xb05215, 0xa8611f, 0x43211f, 0x12000e, 0x836a31, 0xf9c04f, 0xffb232, 0xffa228, 0xffa63f, 0xffa63c, 0xfaa72f, 0xfab95b, 0x6c3d0f, 0x684704, 0xf6bb53, 0xfeb23a, 0xf7a93a, 0xfda937, 0xffb135, 0xf5a340, 0x764209, 0x0b0c20, 0x00000b, 0x4d5653, 0xe1ebe2, 0xfbfffa, 0xf5f7f4, 0xfffdff, 0xfffbff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xf9fff1, 0xf3faf3, 0xfbffff, 0xfaffff, 0xfcffff, 0xfcffff, 0xfefeff, 0xfefdff, 0xfff9ff, 0xfffeff, 0xfefffb, 0xe9f3ea, 0xf7fffb, 0xd4e0e0, 0x374049, 0x050b19, 0xc8dbdf, 0xffdf8a, 0xffad1a, 0xf8a626, 0xbd8331, 0x744404, 0x623b00, 0x402600, 0x2d1606, 0x271606, 0x3e2f18, 0x796133, 0xb88c41, 0xdaa03c, 0xe9ab3a, 0xf1b43f, 0xd0a060, 0xc79a59, 0xbb8d4f, 0xb08445, 0xa77e40, 0xa67e41, 0xad854a, 0xb48c51, 0xe3942b, 0xeca33a, 0xeeaf46, 0xe5b14e, 0xd2a852, 0xad8b44, 0x775821, 0x4c3001, 0x2b1900, 0x351800, 0x4c2400, 0x623715, 0x764b20, 0xc48b48, 0xfba842, 0xff9a1a, 0xffe9bb, 0xc7bcba, 0x030a1c, 0x4a5859, 0xfbfffc, 0xfbf3ff, 0xfffcff, 0xf7faf1, 0xf5fff8, 0xfbffff, 0xfcfdff, 0xfffdff, 0xfffdff, 0xfeffff, 0xfbffff, 0xf3fef6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xf6f6f6, 0xfcfcfc, 0xffffff, 0xffffff, 0xf0f0f0, 0xffffff, 0xf4f4f4, 0x313131, 0x000515, 0x160c0b, 0x7a4a24, 0xee9e47, 0xffb03b, 0xffa630, 0xffaf44, 0xf7a541, 0xfcbe45, 0x572e1a, 0x5d411a, 0xfac940, 0xfda819, 0xffa539, 0xffa53b, 0xffa838, 0xffad32, 0xefc036, 0x6f5e26, 0x0a000e, 0x5a3522, 0xb8732e, 0xa64e0f, 0x963f0a, 0xecad46, 0xefa341, 0xffa849, 0xffa645, 0xff9a2e, 0xfba52a, 0xffbf36, 0xffca39, 0xeac85a, 0xa27d2d, 0x4d2500, 0x532600, 0xad7a38, 0xe7ac48, 0xf2aa31, 0xfbac29, 0xffa938, 0xffa938, 0xffa938, 0xffa938, 0xffa938, 0xffa938, 0xffa938, 0xffa938, 0xf2b341, 0xfbb138, 0xffa926, 0xffb331, 0xf29b2a, 0xb06b1e, 0x804f2e, 0x4d2a24, 0x060002, 0x131313, 0x191b18, 0x0e1822, 0x0f0d10, 0x814513, 0xba5a10, 0x924819, 0xa65307, 0xe0923d, 0xffba51, 0xffb138, 0xffb033, 0xea972f, 0x9c5610, 0x7d4419, 0x170700, 0x33251a, 0x3d3329, 0x0c0500, 0xadaaa5, 0xfefefc, 0xf9fafc, 0xfbffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffef8, 0xfffdfa, 0xfcfdff, 0xfbffff, 0xfbffff, 0xa2a6a9, 0x040301, 0x27221e, 0x051314, 0x3d1810, 0x974d2a, 0xa96214, 0xe19d32, 0xffb13f, 0xffa93c, 0xffae44, 0xae6b24, 0x954200, 0xab4e13, 0xa75f39, 0x4d2d1e, 0x151412, 0x1d2122, 0x0e0d0b, 0x000b1a, 0x50312c, 0x99441d, 0xb24905, 0xd77e24, 0xffb851, 0xffb844, 0xfea227, 0xffac3d, 0xffa93a, 0xfca637, 0xfca637, 0xfea839, 0xffab3c, 0xffae3f, 0xffaf40, 0xf9a447, 0xfca544, 0xfeab45, 0xf09e3a, 0xbf7617, 0x9d5f0a, 0xba863d, 0xf1c181, 0xffc13a, 0xffb42d, 0xffa72a, 0xffa540, 0xffa84e, 0xffa242, 0xf4a232, 0xf6ae35, 0xffbf3f, 0xc36f29, 0xa04c27, 0xab6b2d, 0x5f3e09, 0x0e0002, 0x4a2c22, 0xebc058, 0xf7b73c, 0xf8a629, 0xffa938, 0xffab48, 0xffa93f, 0xffab31, 0xffb950, 0xa36920, 0x82580e, 0xf3b24a, 0xffb039, 0xf7a93a, 0xffac37, 0xffb83f, 0xd4903d, 0x432106, 0x01051e, 0x010810, 0xb2b9b1, 0xfcfff4, 0xf3f6ef, 0xfffeff, 0xfffdff, 0xfdf7f9, 0xffffff, 0xf8f8f8, 0xffffff, 0xfbfbfb, 0xf7f7f7, 0xeaeaea, 0xffffff, 0xffffff, 0xfefff3, 0xfdfffa, 0xfafbff, 0xf7f7ff, 0xfeffff, 0xfcffff, 0xeaeef1, 0xbdc0c5, 0xfffeff, 0xfdfcfa, 0xecede8, 0xfefffb, 0xfafefd, 0xfbffff, 0xeff3fc, 0x00010b, 0x1e3a45, 0xf8e7af, 0xfcc865, 0xcf9f55, 0xd0aa83, 0xae8662, 0x9f7b57, 0x8f7a5f, 0x696061, 0x4c4648, 0x262024, 0x0d0101, 0x110000, 0x210500, 0x37190f, 0x44271f, 0x2a1f1b, 0x251a18, 0x1e1311, 0x140a09, 0x0a0102, 0x060000, 0x0f090b, 0x191516, 0x2f1d19, 0x35271c, 0x322b11, 0x252503, 0x161700, 0x080800, 0x0c0800, 0x1c1714, 0x4b4930, 0x6e5f4a, 0x8e7264, 0xa18675, 0xa38b6f, 0xbc9d6e, 0xdcac64, 0xffc872, 0xfff3dd, 0x0b0b0d, 0x02101d, 0xdfeef3, 0xfefffd, 0xfffafb, 0xfffdff, 0xfafefd, 0xfcfffd, 0xfeffff, 0xb7b8bc, 0xe3e4e9, 0xfeffff, 0xfeffff, 0xf4f6f5, 0xfcfffd, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xe9e9e9, 0xf7f7f7, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfefefe, 0xf2f2f2, 0xb2b2b2, 0x00060b, 0x010009, 0x512c19, 0xd49343, 0xffb33c, 0xfda22d, 0xffad43, 0xffaa40, 0xf7b443, 0x794a16, 0x9b6f30, 0xffc03d, 0xfda618, 0xffac42, 0xf9a340, 0xffab37, 0xffac3a, 0xffbe28, 0xddac46, 0x483026, 0x0d0000, 0x704a1b, 0xb06a2e, 0x9c4518, 0xbd7e21, 0xf6ae48, 0xffb747, 0xffa02f, 0xffa132, 0xffa537, 0xfca531, 0xffb134, 0xf9ac40, 0xffc75d, 0xf7c266, 0xaf803a, 0x845319, 0xb97f36, 0xf7b142, 0xf8ad1c, 0xffab3b, 0xffab3b, 0xffab3b, 0xffab3b, 0xffab3b, 0xffab3b, 0xffab3b, 0xffab3b, 0xefaf41, 0xf5ad3e, 0xfdaa34, 0xffa626, 0xffb638, 0xe59428, 0x985103, 0x94521e, 0x4c2e2e, 0x010511, 0x0b1111, 0x1e2422, 0x061117, 0x663b18, 0xc56519, 0xab5717, 0x8d3a04, 0xb76921, 0xf3a445, 0xffb43e, 0xffb036, 0xf7a43c, 0xa85c11, 0x924a18, 0x20180d, 0x1d140b, 0x2d261e, 0x050000, 0xadaca8, 0xfffffd, 0xfcfefd, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffbf4, 0xfffdf9, 0xfdfeff, 0xfbffff, 0xf5fcff, 0x9ba0a4, 0x000000, 0x1a1917, 0x000c0f, 0x5b2b21, 0xa54a1d, 0xb2650d, 0xeeb041, 0xffb549, 0xffaa46, 0xd78724, 0x925117, 0x9b460f, 0xb55928, 0x8a4826, 0x2f180a, 0x0d1615, 0x151d20, 0x110b0f, 0x482a10, 0x91512d, 0xad4c15, 0xce6a1e, 0xfaab4e, 0xf8b54a, 0xfbaa34, 0xffb031, 0xffae3f, 0xffab3c, 0xfea839, 0xfea839, 0xffaa3b, 0xffac3d, 0xffac3d, 0xffab3c, 0xf1a73c, 0xf9ac40, 0xfeab41, 0xfea93f, 0xffac45, 0xffb64f, 0xffb750, 0xf4b149, 0xffb423, 0xffae45, 0xffa344, 0xfba224, 0xffac23, 0xffac3f, 0xfcab50, 0xffb44f, 0xf7a93a, 0xb45515, 0xa35223, 0x715226, 0x18160a, 0x261910, 0xb08540, 0xffca4a, 0xf0ab32, 0xfda935, 0xffab44, 0xffab4c, 0xfeac40, 0xffad31, 0xffb742, 0xd39435, 0xb88333, 0xf7af43, 0xfeae35, 0xfbab3a, 0xffb03b, 0xffb541, 0xad7333, 0x1d0d0d, 0x000010, 0x2f3032, 0xe8eadc, 0xfffff3, 0xfffefd, 0xfffbff, 0xf3f1f4, 0xfffff8, 0xfcfcfc, 0xf8f8f8, 0xffffff, 0xfefefe, 0xf8f8f8, 0x9c9c9c, 0xa8a8a8, 0xffffff, 0xfffdf4, 0xfffefb, 0xfffdff, 0xfffdff, 0xfffdff, 0xf6f6f8, 0xc4c5bf, 0x303426, 0xd9dcd5, 0xfffffb, 0xfffffd, 0xfffeff, 0xf2edf1, 0xfffafe, 0xfffeff, 0x555553, 0x00020b, 0xa4967c, 0x826c47, 0x59483e, 0xa98d89, 0xe0af8f, 0xdeaa7b, 0xc8a480, 0xdda977, 0xdbab7d, 0xc99c7b, 0xa37e6b, 0x795d5a, 0x4e3e49, 0x1f172f, 0x00001c, 0x080206, 0x040002, 0x030004, 0x040108, 0x07060e, 0x06050d, 0x05050f, 0x080812, 0x000027, 0x00001f, 0x030214, 0x1f1516, 0x4d3c2c, 0x7c6144, 0xa88661, 0xcda780, 0xc9ae7f, 0xdfb58b, 0xd6a27b, 0xd9ac85, 0xd4b890, 0x998a5f, 0x625028, 0x8e744f, 0x8c817b, 0x000200, 0x5c6c6c, 0xf0fbff, 0xfffffd, 0xfffae8, 0xfffef2, 0xf9feff, 0xfffdff, 0xbbb7b8, 0x3c3b39, 0xdbdcd7, 0xfffffb, 0xfdfcfa, 0xfffeff, 0xfffbff, 0xffffff, 0xfdfdfd, 0xffffff, 0xa1a1a1, 0xa0a0a0, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xffffff, 0xf9f9f9, 0xf6f6f6, 0xffffff, 0xffffff, 0xfdfdfd, 0xeaeaea, 0x1d2f23, 0x010009, 0x31130b, 0xac7b2f, 0xf8b63c, 0xfead38, 0xfca53c, 0xffab3c, 0xf9ac40, 0xb88124, 0xd29a43, 0xffb13e, 0xffab23, 0xfbaa3f, 0xf7a74e, 0xffa933, 0xf5af33, 0xffaa2f, 0xffc54a, 0xad893d, 0x0e0f09, 0x190c13, 0x85512c, 0xac5b1a, 0x9f4a0a, 0xeb983a, 0xffbc3f, 0xffaf2d, 0xffad3c, 0xffa747, 0xf99f3e, 0xffa83e, 0xffa552, 0xfba43b, 0xf1aa2e, 0xfabd40, 0xffc152, 0xeaa645, 0xe89c3a, 0xffb54c, 0xffac3c, 0xffac3c, 0xffac3c, 0xffac3c, 0xffac3c, 0xffac3c, 0xffac3c, 0xffac3c, 0xfea13a, 0xffa43f, 0xffaa42, 0xf9a531, 0xffb83a, 0xf9ac3a, 0xbd6c1a, 0xaa5820, 0x8b5028, 0x3d2614, 0x11170d, 0x0e1b12, 0x0a1310, 0x342017, 0x94532b, 0xae4d08, 0x974520, 0x9c4b13, 0xc97920, 0xfbab3a, 0xffb13c, 0xffae4a, 0xc06c23, 0x9c4913, 0x353128, 0x120d07, 0x1e1b14, 0x010000, 0xaeafaa, 0xfefffd, 0xfbfdfc, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffaf3, 0xfffefa, 0xfeffff, 0xf9ffff, 0xf0f9ff, 0x939aa0, 0x000002, 0x151515, 0x0a1c1c, 0x7b4135, 0xaf4918, 0xb66708, 0xf8bf4c, 0xffb64d, 0xf29e3e, 0x9e5400, 0x8d4e1b, 0xa65321, 0xb85b2f, 0x763515, 0x241303, 0x081412, 0x0b1419, 0x261f26, 0x975420, 0xa95620, 0xa64403, 0xe2822c, 0xffc054, 0xf8b038, 0xf8a933, 0xffab3d, 0xffab3e, 0xffab3e, 0xffac3f, 0xffaf42, 0xffb043, 0xffae41, 0xfea83b, 0xf9a336, 0xf5b338, 0xf6b037, 0xfcab38, 0xffab38, 0xffab38, 0xffac31, 0xffb02c, 0xffb129, 0xf4ae4e, 0xf6b041, 0xf3aa3b, 0xfaab46, 0xffb249, 0xfbaf35, 0xfaad39, 0xffbb59, 0xcf8024, 0xb14c06, 0x9c4e10, 0x2c1f0c, 0x00051d, 0x6a6442, 0xffd55c, 0xffb02b, 0xf6af3b, 0xffb245, 0xffa747, 0xfdaa4e, 0xfbad40, 0xfaa82a, 0xfeb238, 0xf2b248, 0xe8ac56, 0xffb144, 0xffac32, 0xfeae3b, 0xffb23b, 0xffae3c, 0x8d5c24, 0x080413, 0x010009, 0x7c7974, 0xffffed, 0xfcf6ea, 0xfffcff, 0xfffbff, 0xfffdfe, 0xfefff3, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0x494949, 0x363636, 0xf7f7f7, 0xfffdf8, 0xfffcfb, 0xfffaff, 0xfffbff, 0xf9f4fb, 0xfffffd, 0xf2f3e5, 0x191d06, 0x63695b, 0xf9fcf5, 0xfffcfd, 0xfff8ff, 0xfffbff, 0xfff8f9, 0xfffef8, 0x8b847a, 0x0a0004, 0x271410, 0x060006, 0x00001b, 0x2f1725, 0xa56742, 0xe39f5e, 0xcd9a63, 0xc68c5c, 0xcc905c, 0xd0955d, 0xd49e62, 0xd9a86e, 0xd1a870, 0xb6935b, 0x9a7a41, 0x665647, 0x544435, 0x4a3a2b, 0x504235, 0x5c5044, 0x574d43, 0x4a4036, 0x3e352c, 0x603c1a, 0x855c40, 0xa57561, 0xc08877, 0xdda38d, 0xe5aa8a, 0xd69d70, 0xcb945e, 0xc8875d, 0xd1815c, 0xe88f6f, 0xe19677, 0x8c5e46, 0x2a1710, 0x04000b, 0x180e30, 0x1e1214, 0x030700, 0x93a398, 0xf8ffff, 0xf0eceb, 0xffffe3, 0xffffea, 0xfbffff, 0xfff4fc, 0x534a4d, 0x16130c, 0xfffff4, 0xfffff4, 0xfffff8, 0xfffcff, 0xfffbff, 0xfbfbfb, 0xffffff, 0xefefef, 0x313131, 0x585858, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfefefe, 0x58664d, 0x0c0610, 0x1b0100, 0x8c621a, 0xf0b83f, 0xffc04d, 0xf7a238, 0xffa936, 0xffaf46, 0xecb237, 0xf1b14d, 0xfda43e, 0xffae2c, 0xefa53a, 0xfbb15c, 0xfda831, 0xebb028, 0xff9a3d, 0xffab2f, 0xf0c542, 0x576651, 0x00002c, 0x461c10, 0xa55800, 0xb34625, 0xd67429, 0xfba733, 0xffb83b, 0xf7aa42, 0xf7a64a, 0xffac42, 0xffac2c, 0xffab2c, 0xffa836, 0xffa843, 0xffa941, 0xfba830, 0xfaab2c, 0xfcad37, 0xfaa940, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xff9c3f, 0xffa448, 0xffa546, 0xfdaf42, 0xf3ae37, 0xfcb84d, 0xef9f5a, 0x983e19, 0xaf6011, 0x825015, 0x1f240e, 0x021a0d, 0x1c1c10, 0x0a0614, 0x664443, 0xc45b19, 0xab5b42, 0x934111, 0xa75604, 0xf1a034, 0xffb241, 0xffb353, 0xd27c33, 0xa1460f, 0x49463f, 0x0f0e09, 0x161510, 0x000100, 0xaeafaa, 0xfefffd, 0xf7f9f6, 0xf7fbfa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf4ffff, 0xfdfdf5, 0xfffced, 0xfffaf2, 0xfffdff, 0x5f636c, 0x06070c, 0x0b0706, 0x3b100a, 0x936041, 0x94540d, 0xd18621, 0xffc358, 0xf7ac4f, 0xa7621f, 0x8c4e1f, 0xba3b10, 0xc1582b, 0x965a36, 0x242215, 0x001c23, 0x081b1f, 0x2f0b00, 0xa04c1d, 0xb46628, 0x8f4000, 0xbd6e1f, 0xfcab50, 0xffb24a, 0xffaf3b, 0xffad32, 0xffa92b, 0xf2a942, 0xfbb24b, 0xffb853, 0xfbaf4d, 0xe7983b, 0xd8872c, 0xe38f37, 0xf7a34b, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffb22b, 0xffab52, 0xf69e54, 0xfbaa3f, 0xffb43a, 0xfdab48, 0xfeaa50, 0xfdaa40, 0xad5b0f, 0x81524c, 0x232524, 0x000f0a, 0x140210, 0xddac81, 0xfcbd4c, 0xfab250, 0xfeac3e, 0xfeac3e, 0xfdab3d, 0xfdab3d, 0xfeac3e, 0xffad3f, 0xffad3f, 0xffae40, 0xfeae35, 0xfba84a, 0xffb03a, 0xfda738, 0xffb743, 0xf5ba52, 0x50341c, 0x02050c, 0x050505, 0xd5d5d5, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfcfcfc, 0xf8f8f8, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xadadad, 0x909090, 0xf3f3f3, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0x8d8d8d, 0x262626, 0xffffff, 0xffffff, 0xfdfdfd, 0xfbfbfb, 0xffffff, 0xffffff, 0xe0e0e0, 0x0b121a, 0x010609, 0x1f201a, 0x110b00, 0x0d0100, 0x0e0000, 0x574136, 0xa88f88, 0xdb9b75, 0xd19769, 0xc08d54, 0xb98b4d, 0xbf9356, 0xc1935f, 0xc9956d, 0xd7a081, 0xdc9c6c, 0xd69666, 0xd59565, 0xdb9b6b, 0xdd9d6d, 0xda9a6a, 0xd79767, 0xd99969, 0xd99558, 0xdda069, 0xd7a374, 0xc69670, 0xbb8a69, 0xc08865, 0xc8875f, 0xcc8358, 0xd1906a, 0xd3a37d, 0xad906e, 0x533d26, 0x160000, 0x0d0000, 0x18191e, 0x03161c, 0x060606, 0x1b1b1b, 0xf1f1f1, 0xffffff, 0xfefefe, 0xf5f5f5, 0xf8f8f8, 0xfefefe, 0xfbfbfb, 0x242424, 0xa8a8a8, 0xfefefe, 0xffffff, 0xf8f8f8, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf9f9f9, 0x7c7c7c, 0xbdbdbd, 0xffffff, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xffffff, 0xfefefe, 0xf5f5f5, 0xffffff, 0xf4f4f4, 0xffffff, 0xfefefe, 0xc9c3c3, 0x030300, 0x080002, 0x61412c, 0xebb354, 0xffb33c, 0xffa73f, 0xffac38, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xf9ac42, 0xffab4e, 0xfdac25, 0xffd25b, 0xaca392, 0x000a19, 0x010e05, 0x281f30, 0x98551e, 0xac5b09, 0xe98e31, 0xffb65e, 0xf1af4e, 0xefb13a, 0xffb248, 0xff9850, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffab3e, 0xffaa3d, 0xffaa3d, 0xffae3b, 0xffad3d, 0xf7a63a, 0xe8972e, 0xda8a27, 0xdf9031, 0xf5a84c, 0xffbe64, 0xffb845, 0xf8a428, 0xffb32c, 0xffb82b, 0xefa71f, 0xffba44, 0xfbb351, 0xb8701c, 0x8b3f03, 0xa76214, 0x7f4d10, 0x1f0c06, 0x030b22, 0x0b1411, 0x351a00, 0xa05f41, 0xb54b0d, 0xb2521f, 0x964615, 0xa2631c, 0xe5ae49, 0xffc455, 0xda8d33, 0xac500f, 0x8f5629, 0x2b0f00, 0x121315, 0x000107, 0x88837f, 0xfff9f0, 0xffffff, 0xedfbff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf5ffff, 0xfefdf9, 0xfffcf3, 0xfffbf5, 0xf7f8fc, 0x464f58, 0x000509, 0x100d08, 0x6e3a25, 0x84491f, 0xa15f15, 0xf6ac4b, 0xffb44d, 0xcb7b22, 0x984a08, 0x974b19, 0xbb501c, 0xa6542c, 0x56321a, 0x151a14, 0x001216, 0x1f1c13, 0x734524, 0xa95622, 0x9b4919, 0xa04f10, 0xdf923a, 0xffbb4f, 0xf9ac38, 0xf5a536, 0xffab48, 0xffb257, 0xffc15e, 0xfab04d, 0xd78b29, 0xbb6f0d, 0xc67718, 0xeb9b3c, 0xffb052, 0xffb052, 0xffab3e, 0xffab3e, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffab3e, 0xffab3e, 0xf7b141, 0xf8ac3c, 0xffb141, 0xffaf40, 0xfba62f, 0xffbd46, 0xffb852, 0xb97023, 0x773e23, 0x2e0c1a, 0x070b0a, 0x0a1e13, 0x1e1e28, 0xdabc96, 0xf7c155, 0xf0a63d, 0xffad3f, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xfeac3e, 0xffad3f, 0xffad3f, 0xffaf39, 0xf9a94a, 0xffaf3c, 0xffa93a, 0xffb843, 0xedb44b, 0x482e17, 0x00030c, 0x515151, 0xf2f2f2, 0xfbfbfb, 0xf5f5f5, 0xffffff, 0xf4f4f4, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xe6e6e6, 0xffffff, 0xffffff, 0xffffff, 0xe9e9e9, 0xfefefe, 0xffffff, 0xffffff, 0xf5f5f5, 0xfafafa, 0xe5e5e5, 0xaaaaaa, 0xbdbdbd, 0xffffff, 0xf7f7f7, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0x4e5659, 0x000201, 0x15100a, 0x75695d, 0x695848, 0x351f11, 0x110000, 0x311b10, 0x957453, 0xc29a76, 0xd8a379, 0xc48657, 0xbb7c49, 0xc88c5a, 0xc59162, 0xb38458, 0xc89168, 0xc18a61, 0xbd865d, 0xc18a61, 0xc28b62, 0xc08960, 0xbf885f, 0xc28b62, 0xc9915e, 0xbb8556, 0xb98458, 0xc48f67, 0xc68f68, 0xc4865f, 0xcc895f, 0xda956b, 0xcea18c, 0x7e6048, 0x2d1d04, 0x0e0000, 0x341910, 0x795d59, 0x5d4e49, 0x12130b, 0x000000, 0x777777, 0xfbfbfb, 0xfdfdfd, 0xf7f7f7, 0xffffff, 0xffffff, 0xb8b8b8, 0xaaaaaa, 0xd7d7d7, 0xffffff, 0xf6f6f6, 0xffffff, 0xf7f7f7, 0xfdfdfd, 0xfdfdfd, 0xfbfbfb, 0xededed, 0xffffff, 0xf3f3f3, 0xffffff, 0xf6f6f6, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xf8f8f8, 0xffffff, 0xffffff, 0xececec, 0xffffff, 0xffffff, 0xfcfcfc, 0xefebea, 0x38382e, 0x0a0106, 0x52331f, 0xe3ab4c, 0xffb53e, 0xffac43, 0xffaf3b, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffae43, 0xffaa47, 0xfead28, 0xffd263, 0xc1b8a7, 0x06121e, 0x0b1306, 0x130208, 0x3e1a1c, 0x743f1d, 0xc37b26, 0xfdaa34, 0xffb440, 0xffac49, 0xffab48, 0xffae41, 0xffab3e, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffab3e, 0xffab3e, 0xffab3e, 0xfbaa37, 0xffb040, 0xffb448, 0xfcab42, 0xe69633, 0xd28324, 0xc5791b, 0xc27519, 0xffae57, 0xffb252, 0xffb84c, 0xffb33b, 0xf6ac31, 0xffb840, 0xffb748, 0xe89f36, 0x984d09, 0xa65c11, 0xa96b30, 0x684330, 0x201920, 0x0d0e12, 0x231304, 0x5f3620, 0xb9601c, 0xae581d, 0x90400d, 0x954a10, 0xbc772a, 0xfbb45a, 0xffb759, 0xaa5900, 0x975825, 0x4e2b0f, 0x120e0b, 0x000209, 0x606060, 0xfffef8, 0xf9f8f6, 0xf7ffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8fcff, 0xfffdfe, 0xfffcf8, 0xfffefb, 0xdfe8ed, 0x223138, 0x000404, 0x1e1a0f, 0x945023, 0x874207, 0xc78032, 0xffc265, 0xd98a2d, 0xa24d00, 0x994000, 0xa94e19, 0xb3692a, 0x6f4421, 0x1e1b16, 0x061117, 0x110c08, 0x542f14, 0xa76535, 0xa5561d, 0x9d451d, 0xb96527, 0xf3a448, 0xffbf4c, 0xffbc46, 0xffbb56, 0xfbac61, 0xef9e66, 0xbd7217, 0xa85d02, 0xab5f01, 0xd08424, 0xf7a945, 0xffb24b, 0xfead44, 0xfcab42, 0xffaa3d, 0xffab3e, 0xffad40, 0xffae41, 0xffae41, 0xffad40, 0xffab3e, 0xffaa3d, 0xeaad43, 0xf7b432, 0xffb235, 0xffa438, 0xffa72b, 0xffc233, 0xd49e3e, 0x6c3928, 0x280d1c, 0x0d0009, 0x18190b, 0x071a06, 0x05161e, 0xbbb49a, 0xfdcc6d, 0xffaf38, 0xffad3f, 0xffad3f, 0xffad3f, 0xffad3f, 0xffad3f, 0xffad3f, 0xfeac3e, 0xfeac3e, 0xffb23b, 0xf9a84c, 0xffaf3c, 0xffab3e, 0xffb744, 0xe4ab44, 0x3d230c, 0x00020b, 0x888888, 0xffffff, 0xffffff, 0xf7f7f7, 0xf6f6f6, 0xffffff, 0xfcfcfc, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xb6b6b6, 0xffffff, 0xffffff, 0xfdfdfd, 0xf2f2f2, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0x686868, 0x222222, 0xc7c7c7, 0xffffff, 0xfcfcfc, 0xffffff, 0xf8f8f8, 0xb1bab7, 0x070802, 0x0c0200, 0x978476, 0xd0b6a7, 0x7f6556, 0x351f12, 0x0e0000, 0x0a0900, 0x594731, 0xb78971, 0xe09b7e, 0xd3855f, 0xc0774c, 0xbc834e, 0xc09159, 0xbe8c67, 0xb98762, 0xb78560, 0xb98762, 0xbb8964, 0xb98762, 0xb98762, 0xba8863, 0xb6855c, 0xc08d62, 0xc2895c, 0xbc7f52, 0xbb7e51, 0xc3885e, 0xc98f6a, 0xc58d6a, 0x5b4643, 0x0a0000, 0x030100, 0x33291d, 0x81655a, 0xe0bbb2, 0x8d7261, 0x140300, 0x080808, 0xcbcbcb, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xffffff, 0xc1c1c1, 0x090909, 0x8b8b8b, 0xffffff, 0xffffff, 0xfafafa, 0xf8f8f8, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xb2b2b2, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xfefefe, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xfcfcfc, 0xf3f3f3, 0xffffff, 0xfffeff, 0x74766b, 0x070003, 0x40210d, 0xdaa346, 0xffb943, 0xffae47, 0xffae3b, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffab3e, 0xffac3f, 0xffa63c, 0xf9a72a, 0xfacc6e, 0xb7ae9f, 0x00050e, 0x1b1807, 0x240900, 0x00000e, 0x200e1c, 0x693e1e, 0xcf8820, 0xffbd36, 0xffb23f, 0xf5a43b, 0xf4ba3f, 0xffab3e, 0xffab3e, 0xffab3e, 0xffac3f, 0xffac3f, 0xffac3f, 0xffac3f, 0xffad40, 0xffb042, 0xfba93b, 0xf8a73c, 0xffae45, 0xffb24d, 0xf3a543, 0xd38727, 0xb86c0e, 0xa45312, 0xc67631, 0xea9b4c, 0xfeb157, 0xffb752, 0xffb547, 0xffb641, 0xffba43, 0xb56a19, 0x903d00, 0xa6551d, 0x9a5d31, 0x4c2d1b, 0x1a1018, 0x110f14, 0x18160a, 0x905217, 0xa56124, 0x9c5016, 0x98430d, 0x993f0b, 0xd5803f, 0xffc264, 0xca830f, 0x9c5117, 0x724420, 0x1d1007, 0x000107, 0x303539, 0xfffffd, 0xfbf7f4, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefdff, 0xfef9ff, 0xfffcf9, 0xfcffff, 0xbdcfd3, 0x041318, 0x060701, 0x3f2f1f, 0xa25110, 0xa95b13, 0xe59a49, 0xe29843, 0x9b4e00, 0x984600, 0xb0551c, 0xb95927, 0x845d1c, 0x292407, 0x041a25, 0x020e1c, 0x3d1d0e, 0x9a5423, 0xab5a1b, 0x9f5317, 0x913f07, 0xd1803e, 0xffbc68, 0xfdb455, 0xe29c3c, 0xca8230, 0xa45a19, 0x934713, 0x9c5000, 0xcb7f29, 0xfbae52, 0xffbb5b, 0xfdaf4a, 0xf6a83c, 0xfbab3c, 0xffb241, 0xfdab3f, 0xfeac40, 0xffae42, 0xffaf43, 0xffaf43, 0xffae42, 0xfeac40, 0xfdab3f, 0xf2b13b, 0xffb23c, 0xfb9f32, 0xffa83f, 0xffc950, 0xd7a22e, 0x5f3f0e, 0x15001d, 0x080000, 0x503927, 0x87744a, 0x272911, 0x000b18, 0x979691, 0xffd384, 0xffa61e, 0xffad41, 0xffae42, 0xffae42, 0xffae42, 0xffae42, 0xffad41, 0xfeac40, 0xfdab3f, 0xffb33d, 0xf9aa4d, 0xfeb13f, 0xffad40, 0xffb746, 0xd9a23b, 0x321903, 0x00000b, 0xaeaeae, 0xffffff, 0xfcfcfc, 0xe7e7e7, 0x9c9c9c, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xf8f8f8, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0x484848, 0x545454, 0xfafafa, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xdddddd, 0x4b4b4b, 0x898989, 0xffffff, 0xfdfdfd, 0xf6f6f6, 0xffffff, 0xf4fbf4, 0x494941, 0x0e0000, 0x664c3f, 0x9e8173, 0x4b3124, 0x554337, 0x584c40, 0x050908, 0x0c0401, 0x4b2e26, 0xa57463, 0xd39377, 0xce8a63, 0xc17f4d, 0xbd7e48, 0xb78057, 0xb78057, 0xb78057, 0xba835a, 0xba835a, 0xb98259, 0xb88158, 0xb88158, 0xbe875e, 0xbd8256, 0xb77948, 0xbb7b4b, 0xd1966c, 0xcea07f, 0x916e58, 0x482e1f, 0x0a0000, 0x130f0e, 0x51544d, 0x554e44, 0x482f28, 0x9f7d74, 0x604436, 0x0d0000, 0x555555, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xf4f4f4, 0x8c8c8c, 0x4e4e4e, 0xfafafa, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xfcfcfc, 0x484848, 0x616161, 0xfafafa, 0xfefefe, 0xf5f5f5, 0xffffff, 0xfcfcfc, 0xfefefe, 0xfcfcfc, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0x999999, 0xeeeeee, 0xfefefe, 0xfffeff, 0x95988f, 0x040004, 0x351806, 0xd8a345, 0xffba44, 0xffae49, 0xfcac3b, 0xfeac40, 0xfeac40, 0xfeac40, 0xfeac40, 0xfeac40, 0xfeac40, 0xfeac40, 0xfeac40, 0xffab3d, 0xffab38, 0xf3a536, 0xffdc94, 0x968f85, 0x000009, 0x493a25, 0x976e40, 0x303107, 0x060411, 0x080018, 0x6c4325, 0xe69e2f, 0xffb928, 0xfdae2f, 0xf2b149, 0xffad41, 0xffad41, 0xfeac40, 0xfeac40, 0xffad41, 0xffad41, 0xffae42, 0xffaf43, 0xfba93d, 0xfca93f, 0xfdac43, 0xffaf49, 0xffb44f, 0xffb450, 0xfcb04e, 0xf8ac4a, 0xbe732f, 0x9e530f, 0x964905, 0xac5f17, 0xca7d2d, 0xe69941, 0xffb14f, 0xffbe56, 0xe09941, 0x9a4407, 0xa3440e, 0xba6626, 0x894e24, 0x391f22, 0x040a1a, 0x001816, 0x452006, 0x865626, 0xa66523, 0xac5818, 0x9a3a08, 0xa44612, 0xdc8d3e, 0xf1ad42, 0xaa5715, 0x925526, 0x422712, 0x080705, 0x0e151b, 0xdee2e5, 0xfffbf8, 0xfffcf5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdff, 0xfdf8fe, 0xfffffd, 0xf8ffff, 0x8fa1a3, 0x000302, 0x231306, 0x714930, 0xb1560f, 0xc67025, 0xd98a3d, 0xa1590d, 0x843e00, 0xa55c25, 0xab6134, 0x9b4d27, 0x392d00, 0x051302, 0x001321, 0x181820, 0x773f24, 0xbe6023, 0xac4f0c, 0x9f5518, 0x985004, 0xce863e, 0xdd9450, 0xa45d1d, 0x823b00, 0x874100, 0x9d580d, 0xc98436, 0xfeb25c, 0xffb65e, 0xffb458, 0xfbaf4d, 0xfdb048, 0xffb447, 0xffb241, 0xfbab38, 0xfdac41, 0xfead42, 0xffae43, 0xffaf44, 0xffaf44, 0xffae43, 0xfead42, 0xfdac41, 0xffb348, 0xffa746, 0xffa93f, 0xffc653, 0xf7b662, 0x71452c, 0x0d0002, 0x000005, 0x69531a, 0xd0ab5a, 0xe5bb73, 0x442e17, 0x000010, 0x746e7a, 0xffe2a9, 0xffa018, 0xfeab41, 0xffac42, 0xffad43, 0xffae44, 0xffae44, 0xffad43, 0xffac42, 0xfeab41, 0xffb43f, 0xf9ac50, 0xfeb242, 0xffaf43, 0xffba48, 0xd5a03a, 0x2b1500, 0x00000c, 0xb1b1b1, 0xfdfdfd, 0xffffff, 0xdddddd, 0x2c2c2c, 0x8e8e8e, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xfdfdfd, 0xffffff, 0x8e8e8e, 0x141414, 0xdadada, 0xffffff, 0xffffff, 0xfefefe, 0xf9f9f9, 0xffffff, 0xfefefe, 0xffffff, 0xfafafa, 0xdcdcdc, 0xf4f4f4, 0xffffff, 0xfafafa, 0xffffff, 0xfbfffb, 0xaeaea6, 0x120400, 0x382215, 0x5c4136, 0x1a0600, 0x23160e, 0x5d5650, 0x463b49, 0x19121a, 0x050000, 0x2b2115, 0x765e46, 0xb98c6b, 0xd2916b, 0xca7c55, 0xc28252, 0xc28252, 0xc08050, 0xbe7e4e, 0xbc7c4c, 0xbd7d4d, 0xbe7e4e, 0xbe7e4e, 0xb27244, 0xb77749, 0xc78759, 0xd1986d, 0xb78a6b, 0x745a49, 0x2a221f, 0x000105, 0x210d0c, 0x4e4741, 0x565950, 0x1c1912, 0x150301, 0x614949, 0x231610, 0x050500, 0xc5c5c5, 0xffffff, 0xffffff, 0xfcfcfc, 0xfefefe, 0xffffff, 0xcccccc, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xededed, 0xcfcfcf, 0x121212, 0x9f9f9f, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xf5f5f5, 0xffffff, 0xf7f7f7, 0xffffff, 0xfdfdfd, 0x767676, 0x2b2b2b, 0xf7f7f7, 0xfcfcfc, 0xf9f8fd, 0x9ea39c, 0x030005, 0x341908, 0xd8a549, 0xffba45, 0xffaf49, 0xfeb13f, 0xfead42, 0xfead42, 0xfead42, 0xfead42, 0xfead42, 0xfead42, 0xfead42, 0xfead42, 0xffac40, 0xffad36, 0xefa647, 0xffeec1, 0x616161, 0x00000c, 0x523c25, 0xebb970, 0xc8aa48, 0x574c1e, 0x00000e, 0x030013, 0x6d4a24, 0xeaab3a, 0xffc544, 0xfaa53b, 0xffaf44, 0xffae43, 0xfead42, 0xfdac41, 0xfdac41, 0xfead42, 0xffaf44, 0xffaf44, 0xffac44, 0xffad45, 0xffae48, 0xffad47, 0xfbac47, 0xfbad48, 0xfdb24c, 0xffb550, 0xffca6a, 0xeca54b, 0xc77f2b, 0xa95f14, 0x8b4000, 0x833800, 0xa65b17, 0xd38642, 0xc98234, 0xa8531d, 0xa44310, 0xbb5a13, 0xb26227, 0x623427, 0x0f0f1b, 0x02282b, 0x170610, 0x4d3119, 0x825416, 0xa86419, 0xb35f21, 0x9b410d, 0xa65214, 0xe2964a, 0xbd6825, 0xa35c24, 0x734724, 0x251508, 0x000306, 0x9da4aa, 0xfffffd, 0xfef4eb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffeff, 0xfcfafb, 0xfefffa, 0xf0fdf6, 0x546360, 0x040000, 0x522915, 0xa05a38, 0xae520f, 0xbb621e, 0xb86823, 0x954b0a, 0xa0612b, 0x9d6840, 0x704228, 0x481d0d, 0x0f1200, 0x0f2018, 0x000910, 0x443029, 0xa15931, 0xb24c0a, 0xaf520f, 0x995019, 0xa0671a, 0x915612, 0x7d3c04, 0x732f00, 0x9e571f, 0xd38b43, 0xeea74b, 0xffc55b, 0xfdb354, 0xf3a948, 0xf4a846, 0xfcb14b, 0xfaad45, 0xf1a337, 0xfbaa3e, 0xffbe4f, 0xfeaf46, 0xfdae45, 0xfdae45, 0xfdae45, 0xfdae45, 0xfdae45, 0xfdae45, 0xfeaf46, 0xffab54, 0xffa94a, 0xffc853, 0xe8b548, 0x6d4222, 0x160019, 0x28121f, 0x7a7734, 0xe9ba4e, 0xffd353, 0xe1a954, 0x3b1707, 0x01000b, 0x4a4657, 0xfff0d3, 0xfbb545, 0xfca941, 0xfeab43, 0xffad45, 0xffaf47, 0xffb048, 0xffaf47, 0xffae46, 0xffad45, 0xffb43f, 0xfbb055, 0xfdb445, 0xffaf44, 0xffbc4c, 0xd7a33e, 0x2a1502, 0x00010e, 0xa6a6a6, 0xffffff, 0xffffff, 0xfdfdfd, 0x575757, 0x464646, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xfefefe, 0xffffff, 0xbdbdbd, 0xfcfcfc, 0xffffff, 0xf7f7f7, 0xfefefe, 0xffffff, 0xf8f8f8, 0xf2f2f2, 0xfbfbfb, 0xffffff, 0xffffff, 0xf5f5f5, 0xfafafa, 0xffffff, 0xfcfcfc, 0xfbffff, 0xfefffa, 0x575048, 0x0b0000, 0x43352c, 0x2b201c, 0x100a0a, 0x1a1a1c, 0x362430, 0x282129, 0x101918, 0x02110a, 0x141b0b, 0x513f2b, 0x9a6c55, 0xc7876e, 0xbe8051, 0xbf8152, 0xbc7e4f, 0xb67849, 0xb37546, 0xb67849, 0xb97b4c, 0xb97b4c, 0xbe7f56, 0xc98e66, 0xc38e6c, 0x926a50, 0x462f1f, 0x0b0600, 0x00080d, 0x0b1d29, 0x311915, 0x3e332d, 0x171810, 0x070601, 0x382c2e, 0x392a2f, 0x030104, 0x5b6767, 0xffffff, 0xffffff, 0xf5f5f5, 0xffffff, 0xf9f9f9, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xfafafa, 0xffffff, 0xffffff, 0xe7e7e7, 0xc2c2c2, 0xffffff, 0xffffff, 0xf4f4f4, 0xffffff, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xffffff, 0xf6f6f6, 0xffffff, 0xececec, 0x3c3c3c, 0x686868, 0xffffff, 0xfcfcfc, 0xfdfeff, 0x989d96, 0x04010a, 0x391f10, 0xdba84d, 0xffb643, 0xffb14d, 0xffb748, 0xfdae45, 0xfdae45, 0xfdae45, 0xfdae45, 0xfdae45, 0xfdae45, 0xfdae45, 0xfdae45, 0xffae47, 0xfaab32, 0xf1b464, 0xffeedf, 0x2e3842, 0x000112, 0x381f0b, 0xf1b95a, 0xffd16d, 0xdcb54c, 0x716c28, 0x0a0c0b, 0x0a0009, 0x794f29, 0xf0ac4b, 0xffbf45, 0xffb249, 0xffb047, 0xfdae45, 0xfbac43, 0xfbac43, 0xfbac43, 0xfdae45, 0xfeaf46, 0xffb14e, 0xfeaa47, 0xf7a541, 0xfaa842, 0xffb049, 0xffb34b, 0xf9af46, 0xf2a83f, 0xeda433, 0xffbd4f, 0xffc45e, 0xf7b056, 0xc98437, 0x8e4a0b, 0x722f00, 0x803e0e, 0x9d581d, 0xa85b2d, 0x9f4717, 0xa24000, 0xbb5c1c, 0x91502a, 0x322117, 0x01191b, 0x151329, 0x1a110c, 0x3d2500, 0x754b11, 0xa96b2e, 0xab5e28, 0x984211, 0xb15725, 0xb86726, 0xa15315, 0x945522, 0x4a2508, 0x060000, 0x5b646b, 0xfcffff, 0xfffef8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefff9, 0xfcfff6, 0xd5e2d8, 0x1e2820, 0x200d00, 0x864529, 0xba552b, 0xa24b15, 0xa24c13, 0xa9571b, 0xa1591f, 0x9e6538, 0x613f24, 0x2b1c15, 0x09080d, 0x101a19, 0x161b1e, 0x1f1410, 0x75472f, 0xad5b29, 0xa64405, 0xae5418, 0x9a501f, 0x976937, 0x673502, 0x673000, 0x9b5f20, 0xdf9d51, 0xffc266, 0xffb94e, 0xfaad3b, 0xf5ac43, 0xfcb34a, 0xfab047, 0xf1a73e, 0xf9ac44, 0xffba53, 0xffb650, 0xf8a640, 0xffb148, 0xfeaf46, 0xfdae45, 0xfbac43, 0xfbac43, 0xfdae45, 0xfeaf46, 0xffb148, 0xffaa48, 0xfcb951, 0xd6b04f, 0x6a561b, 0x120000, 0x391c1e, 0xa88251, 0xfbd163, 0xffbf49, 0xffc035, 0xca9547, 0x33170c, 0x030804, 0x202833, 0xf0e5e3, 0xeed68c, 0xfaa73f, 0xfca941, 0xffad45, 0xffb048, 0xffb149, 0xffb149, 0xffaf47, 0xffae46, 0xfbb23f, 0xfdb159, 0xfeb546, 0xfead42, 0xffbf51, 0xdca845, 0x2d1805, 0x00020e, 0xa2a2a2, 0xffffff, 0xf4f4f4, 0xffffff, 0xeaeaea, 0xbdbdbd, 0xffffff, 0xf9f9f9, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xdfdfdf, 0xd1d1d1, 0xffffff, 0xfdfdfd, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xececec, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xfcfcfc, 0xf2f7fa, 0xfcffff, 0xcecfca, 0x11100b, 0x050400, 0x141414, 0x17171f, 0x121621, 0x1f1714, 0x1e1e1c, 0x1c2426, 0x162123, 0x091312, 0x0a0b05, 0x2d2115, 0x564334, 0xa47654, 0xae805e, 0xb68866, 0xb78967, 0xb78967, 0xb98b69, 0xb88a68, 0xb48664, 0xb5866c, 0x8f6652, 0x523527, 0x200f07, 0x0e0906, 0x151618, 0x171f21, 0x121a1c, 0x1f0f10, 0x1f1b18, 0x0c120e, 0x171916, 0x24191d, 0x080002, 0x222023, 0xdee8e9, 0xfefefe, 0xfbfbfb, 0xffffff, 0xffffff, 0xf7f7f7, 0xfbfbfb, 0xffffff, 0xf8f8f8, 0xfcfcfc, 0xf2f2f2, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xd3d3d3, 0xeaeaea, 0xffffff, 0xf9f9f9, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xf0f0f0, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xb8b8b8, 0xf6f6f6, 0xffffff, 0xfbfbfb, 0xfeffff, 0x808780, 0x030009, 0x3d2314, 0xe1af56, 0xfdb644, 0xffb04d, 0xffb84a, 0xfeaf46, 0xfeaf46, 0xfeaf46, 0xfeaf46, 0xfeaf46, 0xfeaf46, 0xfeaf46, 0xfeaf46, 0xffb14e, 0xf5af35, 0xffd697, 0xeddde7, 0x0b2033, 0x000e25, 0x391e0d, 0xefb547, 0xffac53, 0xffd15c, 0xfed15a, 0x9b833d, 0x29190c, 0x120000, 0x784d1a, 0xf4ba57, 0xffb54c, 0xffb34a, 0xfeaf46, 0xfcad44, 0xfaab42, 0xfaab42, 0xfcad44, 0xfdae45, 0xfba745, 0xffab49, 0xffb04c, 0xffb04c, 0xfdae47, 0xfbae44, 0xfeb449, 0xffb94e, 0xffb248, 0xffb347, 0xf9b041, 0xfcb84b, 0xffc765, 0xe8af5e, 0x9b6525, 0x552200, 0x8a4623, 0x9c5c30, 0xa55d2d, 0xa54a15, 0xb75111, 0xb05f1e, 0x633d18, 0x0a0905, 0x131f1f, 0x0e1317, 0x120e0f, 0x311e0f, 0x69411d, 0x975825, 0xa74f1d, 0xa43f11, 0xa1561c, 0xa04d0b, 0xa85716, 0x7b4215, 0x1a0800, 0x282f35, 0xeaf3fa, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefffb, 0xfefff4, 0xf7ffef, 0xbccabb, 0x000400, 0x402313, 0xaa593b, 0xc0471a, 0xa24e22, 0x9d4716, 0xaa5721, 0x9c5320, 0x6c3810, 0x190400, 0x0b1316, 0x082233, 0x1b2336, 0x010005, 0x44281a, 0x90542f, 0xaa551c, 0xb25416, 0xaa551f, 0xa75d30, 0x461d07, 0x4e2300, 0xa97b40, 0xfcc573, 0xffc45f, 0xf6b041, 0xf9ab3c, 0xffb447, 0xf9b240, 0xfab243, 0xffb649, 0xffb94e, 0xffb24a, 0xf8a845, 0xfba946, 0xffb151, 0xffb34b, 0xfeb149, 0xfbae46, 0xf9ac44, 0xf9ac44, 0xfbae46, 0xfeb149, 0xffb34b, 0xfeb836, 0xf5c654, 0x816e33, 0x030000, 0x292718, 0xc0ae5a, 0xffd259, 0xffb344, 0xffae44, 0xffc343, 0xd0a360, 0x291810, 0x000d00, 0x001216, 0xcbd9e6, 0xfbffdb, 0xf9a640, 0xfba842, 0xffac46, 0xffb04a, 0xffb24c, 0xffb24c, 0xffb14b, 0xffb04a, 0xfab13e, 0xfeb45b, 0xfeb647, 0xfbac43, 0xffc052, 0xdfad4a, 0x301b0a, 0x000110, 0x797979, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xededed, 0xffffff, 0xfafafa, 0xfcfcfc, 0xffffff, 0xffffff, 0xfafafa, 0xf7f7f7, 0xffffff, 0xfcfcfc, 0xffffff, 0xfafafa, 0xb3b3b3, 0x373737, 0xefefef, 0xffffff, 0xf0f0f0, 0xfbfbfb, 0xffffff, 0xf8f8f8, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xf9ffff, 0xf1f6fa, 0xfbffff, 0x747a78, 0x000303, 0x1d2528, 0x0c121e, 0x161c2c, 0x101c08, 0x161c12, 0x151618, 0x171520, 0x1f1f2b, 0x151c22, 0x000f0a, 0x000700, 0x311100, 0x472712, 0x5e3e29, 0x6b4b36, 0x70503b, 0x70503b, 0x674732, 0x5d3d28, 0x482a20, 0x1d0600, 0x070000, 0x0a0b10, 0x1a1f25, 0x181c1d, 0x191911, 0x251f13, 0x1d1520, 0x11161a, 0x122020, 0x191f1f, 0x180d11, 0x1f0f12, 0x8a8280, 0xfcfffb, 0xffffff, 0xfdfdfd, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xfefefe, 0xfafafa, 0xffffff, 0xfafafa, 0xffffff, 0xe3e3e3, 0x313131, 0xc8c8c8, 0xffffff, 0xfafafa, 0xf9f9f9, 0xffffff, 0xf9f9f9, 0xf8f8f8, 0xffffff, 0xfafafa, 0xffffff, 0xf7f7f7, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xfeffff, 0x676e67, 0x000007, 0x402619, 0xe7b55c, 0xfeb745, 0xffad4a, 0xfeb244, 0xfeb149, 0xfeb149, 0xfeb149, 0xfeb149, 0xfeb149, 0xfeb149, 0xfeb149, 0xfeb149, 0xfbaf51, 0xf2b139, 0xffefb8, 0xc9bfd7, 0x00061e, 0x000b24, 0x361c0d, 0xe6ab37, 0xffb357, 0xfaa03f, 0xffae3a, 0xffd55c, 0xb8a153, 0x201400, 0x120000, 0x85642f, 0xffb850, 0xffb54d, 0xfeb149, 0xfbae46, 0xf9ac44, 0xf9ac44, 0xfaad45, 0xfbae46, 0xffb252, 0xffb04e, 0xffaf4c, 0xffaf4b, 0xffb14a, 0xffb248, 0xfbb144, 0xf9af42, 0xffa74d, 0xffab49, 0xffb647, 0xf7b53d, 0xebb440, 0xfccc68, 0xe7bc6d, 0xa77e3c, 0x480500, 0x622900, 0x9a5c2d, 0xaf5b2f, 0xa94305, 0xb55c0a, 0x905c23, 0x36221b, 0x021600, 0x1c2b2e, 0x0d1431, 0x050017, 0x260b00, 0x6a3406, 0xb25c23, 0xbe531d, 0x955019, 0xa85310, 0xb75c15, 0xa25f2a, 0x2c1100, 0x0a0f13, 0xc5d2db, 0xf0f7fd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfffcf3, 0xf4ffff, 0xe9ffff, 0x637984, 0x080000, 0x895929, 0xa25713, 0xad5808, 0xc85000, 0xa5632f, 0x695647, 0x21170e, 0x191410, 0x121c25, 0x071017, 0x261910, 0x052b20, 0x100700, 0x764122, 0xa75526, 0xae4611, 0xc86e18, 0x7c581c, 0x000b27, 0x5b2d00, 0xd19b41, 0xffc766, 0xf7ac46, 0xfdac43, 0xffb54e, 0xf8ae4d, 0xf5af50, 0xffb54c, 0xffb14b, 0xffb049, 0xfeb04b, 0xfdb24d, 0xfcb24f, 0xfbb150, 0xf9b14f, 0xffb14d, 0xffb13e, 0xf9a729, 0xf8a432, 0xffaf55, 0xfeb05d, 0xf4b148, 0xf8bf3c, 0xe8d65a, 0x876c35, 0x1c0000, 0x502922, 0xdab364, 0xffd251, 0xf9b43d, 0xffb25d, 0xfab34b, 0xffcb51, 0xad8641, 0x1f0900, 0x0c0703, 0x030418, 0x9ba0b6, 0xf8ffe9, 0xfec16e, 0xea9f3a, 0xffb543, 0xffb84e, 0xfdb159, 0xf5b35f, 0xfbb754, 0xfeb33e, 0xfdae49, 0xffb658, 0xfbaf51, 0xffb145, 0xffb740, 0xf1b85e, 0x442b0c, 0x030214, 0x5a5a5a, 0xffffff, 0xfefefe, 0xffffff, 0xf9f9f9, 0xf7f7f7, 0xffffff, 0xdbdbdb, 0xfefefe, 0xfefefe, 0xffffff, 0xfafafa, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xf7f7f7, 0x222222, 0x252525, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xf6f6f6, 0xffffff, 0xffffff, 0xfafafa, 0xfefefe, 0xfcfcfc, 0xffffff, 0xf5f5f5, 0xffffff, 0xededed, 0x2c2c2c, 0x010101, 0x212121, 0x0e0e0e, 0x17181a, 0x181d21, 0x131c23, 0x0a141d, 0x0d1114, 0x312821, 0x3c2716, 0x482a12, 0x050819, 0x000011, 0x00000e, 0x000713, 0x020f18, 0x000e15, 0x00090d, 0x00060a, 0x0e0a01, 0x070000, 0x3f322a, 0x3b2c25, 0x231411, 0x211519, 0x201621, 0x1b1523, 0x29251a, 0x18140b, 0x0d0900, 0x28251e, 0x010000, 0x3a3b36, 0xfffffb, 0xfcfefb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xfefefe, 0xf2f2f2, 0x1a1a1a, 0x292929, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xf0f0f0, 0xeaeaea, 0xf7f7f7, 0xffffff, 0xf9f9f9, 0xffffff, 0xf9f9f9, 0xfefeff, 0x494b58, 0x060201, 0x533b0d, 0xfbc460, 0xffb638, 0xffb242, 0xffaf56, 0xffb644, 0xfbad4b, 0xfaad5b, 0xffb55e, 0xfcb44e, 0xfdb644, 0xffb547, 0xfcad46, 0xf6ab1c, 0xffcb8c, 0xfff1e8, 0x909692, 0x00020e, 0x181133, 0x220301, 0xbe934f, 0xffcc45, 0xf9b749, 0xfead51, 0xfeaa47, 0xffca59, 0xdaae4b, 0x4a3405, 0x070000, 0x9b824a, 0xf1c946, 0xffc238, 0xffa83f, 0xffb642, 0xffb741, 0xfdaa42, 0xfaa02e, 0xffad46, 0xffb350, 0xffb355, 0xf4af50, 0xf3b150, 0xfbb64e, 0xffb643, 0xffaf39, 0xfab04d, 0xfbb14e, 0xfbb24c, 0xf9b049, 0xf9b049, 0xfdb44b, 0xffbc50, 0xffc256, 0xcbaf42, 0x2c0c00, 0x240413, 0x865834, 0xa95f14, 0xb35903, 0xa8560d, 0x7e360e, 0x001938, 0x291713, 0x2a1911, 0x061210, 0x1f160d, 0x1d100a, 0x191814, 0x735d46, 0xc35d2d, 0xb14c18, 0xaa470e, 0xad5822, 0x7f4418, 0x1c0200, 0x737a73, 0xedffff, 0xfefefe, 0xfafafa, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfbfae8, 0xf8fffd, 0xe1f1f1, 0x1d1c17, 0x3d1b00, 0xa05e2c, 0xa95316, 0xb25617, 0xac5c1d, 0x714624, 0x241b14, 0x171717, 0x140f0b, 0x1b140e, 0x403227, 0x432c1a, 0x00040b, 0x322c0a, 0x844826, 0xc35f2e, 0xbd6c1d, 0x562c13, 0x1c0000, 0x583d00, 0xe2b059, 0xffca6f, 0xffc665, 0xffb44e, 0xffb64d, 0xffb44f, 0xf9af4e, 0xffb85a, 0xffb14b, 0xffb44d, 0xffb550, 0xffb14c, 0xfbb04b, 0xfdb14f, 0xffb552, 0xffb655, 0xffb74d, 0xf5a536, 0xf8a432, 0xffb54a, 0xffb754, 0xf9ad4d, 0xf8b54c, 0xffc650, 0x9e8430, 0x210000, 0x643b1d, 0xe6b982, 0xfacb61, 0xf5bc3b, 0xf6ad44, 0xffab63, 0xfeb942, 0xffd060, 0x896535, 0x180507, 0x1e1e1c, 0x00040d, 0x6b6d7c, 0xffffef, 0xffe0a2, 0xeaad5a, 0xffac42, 0xffaf44, 0xffb04d, 0xf6ad51, 0xf7b14f, 0xfeb447, 0xffb04b, 0xffb355, 0xf7ad4e, 0xffb347, 0xffb945, 0xf8bd61, 0x684c25, 0x030007, 0x393939, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xf4f4f4, 0x8d8d8d, 0x292929, 0xb3b3b3, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xaeaeae, 0x262626, 0xa8a8a8, 0xfafafa, 0xf8f8f8, 0xfdfdfd, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xfefefe, 0x989898, 0x000000, 0x191919, 0x515151, 0x1b0e05, 0x1c1209, 0x211a14, 0x24201d, 0x151412, 0x18130f, 0x2f2822, 0x675d54, 0x725653, 0x604440, 0x442824, 0x2c110a, 0x220700, 0x290e03, 0x361b10, 0x3f2518, 0x593125, 0x84665e, 0x614f4f, 0x2b262c, 0x1d1e23, 0x0d0b0c, 0x1e170f, 0x1f1307, 0x100c03, 0x0e0a01, 0x5d5852, 0x19160f, 0x010000, 0xa9aaa5, 0xfffffd, 0xf8faf7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfdfdfd, 0xa0a0a0, 0x161616, 0xdedede, 0xffffff, 0xfdfdfd, 0xf7f7f7, 0xfefefe, 0xffffff, 0xf9f9f9, 0xf6f6f6, 0xfdfdfd, 0xffffff, 0xa8a8a8, 0x282828, 0x9b9b9b, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xf1f1fb, 0x2f2f39, 0x060000, 0x765826, 0xfdc35f, 0xffb339, 0xffb042, 0xffb35a, 0xffb446, 0xffb353, 0xffb15e, 0xf9ae53, 0xf8ae45, 0xffb441, 0xffb346, 0xfeac48, 0xe6ad46, 0xffe5c1, 0xfff8fa, 0x565853, 0x030d0f, 0x161229, 0x0e0000, 0x998141, 0xffc146, 0xfeb54f, 0xffad57, 0xf6a343, 0xffb949, 0xffd166, 0xbb9a53, 0x664e2c, 0x180000, 0xb8893b, 0xffbc50, 0xffac41, 0xffaa4d, 0xfeb04b, 0xffb543, 0xfba63b, 0xffa83c, 0xffaf47, 0xffb550, 0xfbb555, 0xf8b453, 0xfbb34d, 0xffb246, 0xffb142, 0xfab04d, 0xfdb350, 0xffb552, 0xffb650, 0xfdb44d, 0xfbb249, 0xfcb34a, 0xfeb64a, 0xf8b775, 0xdeb450, 0x533501, 0x180000, 0x66391c, 0xa5672e, 0xb3642c, 0x9f4d04, 0x0f1a1c, 0x151517, 0x422e23, 0x45301b, 0x131105, 0x0f0b0c, 0x251714, 0x251c0d, 0x7f4329, 0xa25833, 0xaf5823, 0xb95f21, 0x9f5621, 0x360d00, 0x32312c, 0xedffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffec, 0xfffff4, 0x9f9b8f, 0x150000, 0x915731, 0xb76939, 0xad5a2e, 0x9f512b, 0x482d18, 0x241407, 0x040507, 0x1b2831, 0x15110e, 0x4c2e16, 0x734c2d, 0x3e2008, 0x100c09, 0x5e3b28, 0xb06627, 0xb9671b, 0x54240d, 0x090006, 0x674c1d, 0xf6b138, 0xffcb70, 0xf6b95c, 0xf0ae4d, 0xfcb34d, 0xffb752, 0xffb14d, 0xfbaf4d, 0xffba5b, 0xfdaf4a, 0xffb651, 0xffb853, 0xffb24e, 0xfcae4a, 0xffb44f, 0xffb853, 0xffb853, 0xefa42f, 0xf2a136, 0xffac4b, 0xffb451, 0xffb347, 0xffbc4b, 0xf8b54a, 0xd59734, 0x310c00, 0x7b5019, 0xeebd70, 0xffca5f, 0xebae31, 0xfab53e, 0xfaaf52, 0xfaab66, 0xfab830, 0xfac565, 0x553423, 0x070013, 0x212a29, 0x000900, 0x2f2f2f, 0xfef5ee, 0xfffedf, 0xedc68d, 0xeea94e, 0xffa83a, 0xffb143, 0xfeac46, 0xf8ae4b, 0xfbb651, 0xffb14e, 0xfcb253, 0xf5ab4c, 0xffb44a, 0xffba4b, 0xffc063, 0xa17f51, 0x0d0000, 0x141414, 0xd7d7d7, 0xf8f8f8, 0xf5f5f5, 0xffffff, 0xf9f9f9, 0xffffff, 0xcfcfcf, 0x373737, 0xa2a2a2, 0xf8f8f8, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xf8f8f8, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xebebeb, 0xe6e6e6, 0xffffff, 0xfcfcfc, 0xfefefe, 0xf5f5f5, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xf3f3f3, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xf3f3f3, 0xffffff, 0xf9f9f9, 0x3d3d3d, 0x050505, 0x525252, 0x624935, 0x311804, 0x513a28, 0x655243, 0x201207, 0x100b07, 0x23272a, 0x131c23, 0x7f553c, 0x976b50, 0xa87a60, 0xa67459, 0x9b684b, 0x9e6749, 0xaa7154, 0xb67b5d, 0xa77866, 0x68473e, 0x22161a, 0x191d28, 0x0b121a, 0x231e1a, 0x715c47, 0x5a3918, 0x211d14, 0x625d57, 0x544f49, 0x030000, 0x51504c, 0xfffffd, 0xfffffd, 0xf7f9f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xf3f3f3, 0xffffff, 0xe5e5e5, 0xe7e7e7, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0x939393, 0x494949, 0xcbcbcb, 0xffffff, 0xf5f5f5, 0xfdfdfd, 0xffffff, 0xffffff, 0xcacdd6, 0x100e11, 0x170800, 0xae8a4e, 0xffc460, 0xfdb03a, 0xffb045, 0xffb65a, 0xfab246, 0xffb658, 0xffb25b, 0xfaab4c, 0xfcae41, 0xffb440, 0xffaf46, 0xfaa74b, 0xf5d7a5, 0xfff5f1, 0xefdfea, 0x1c1d15, 0x0a1109, 0x191b28, 0x080703, 0x4d4c1c, 0xffc255, 0xffb657, 0xffaf5c, 0xffb256, 0xf6ae40, 0xfdbf4e, 0xffd070, 0xe0b064, 0x5f410f, 0x552001, 0xd18e40, 0xffbd4f, 0xfbaa59, 0xffbb67, 0xf7ae3d, 0xffb34a, 0xf9a430, 0xfba939, 0xffb349, 0xffb955, 0xfdb755, 0xfab250, 0xfbaf4d, 0xffb14e, 0xfcb251, 0xfeb453, 0xffb552, 0xffb650, 0xfdb44e, 0xfbb24b, 0xfab148, 0xfab148, 0xffb566, 0xffcc5b, 0xdbb246, 0x4e3612, 0x17001a, 0x5e3c3d, 0x9c5f26, 0xc46e1b, 0x613916, 0x050c12, 0x3a2419, 0x814c22, 0x2e2613, 0x090d16, 0x2f2121, 0x0a0b05, 0x140907, 0x53321f, 0x8d4e22, 0xb05c20, 0xbc6b33, 0x76401c, 0x140300, 0xb4bcc7, 0xf8f8f8, 0xf8f8f8, 0xffffff, 0xffffff, 0xfbfbfb, 0xf5f5f5, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfef9f3, 0xf3ece6, 0x4f3e34, 0x5e3821, 0xac724d, 0x81411d, 0x511e09, 0x1e0000, 0x000107, 0x100c09, 0x161a1d, 0x0a1823, 0x130e0a, 0x855a38, 0x754723, 0x1d0800, 0x2a0e02, 0x985636, 0xac6219, 0x572d00, 0x140008, 0x5f431c, 0xeebe4f, 0xffd06b, 0xf1b150, 0xf2b04f, 0xf9b552, 0xffb955, 0xffb650, 0xfcb04e, 0xfeb250, 0xffb656, 0xfcb04e, 0xffb654, 0xffb853, 0xffb14d, 0xfeb04c, 0xffb550, 0xffb44f, 0xfcad48, 0xeba128, 0xffb04c, 0xffb760, 0xffad4e, 0xffb03a, 0xffba3e, 0xd6932a, 0x915000, 0x895a2e, 0xfdcb82, 0xffce64, 0xf3ad34, 0xffba48, 0xffb752, 0xfdb354, 0xffbc5c, 0xffc637, 0xd2a258, 0x2e1018, 0x090325, 0x152324, 0x091700, 0x0c0a00, 0xb9a8ae, 0xf9ffff, 0xf8e7c9, 0xebb670, 0xf7a541, 0xffb13f, 0xffb143, 0xfeb34e, 0xf7b459, 0xffb24f, 0xfcb253, 0xf4ae4e, 0xffb64d, 0xffb64a, 0xfebc5e, 0xdbae73, 0x321b00, 0x000000, 0xa1a1a1, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xf7f7f7, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xf9f9f9, 0xf4f4f4, 0xffffff, 0xffffff, 0xe2e2e2, 0xffffff, 0xffffff, 0xeeeeee, 0xf3f3f3, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xbbbbbb, 0x0d0d0d, 0x010101, 0x6e5b4c, 0x442d1b, 0x785c46, 0xaa8c74, 0x5a4331, 0x0b0000, 0x070707, 0x151e25, 0x190600, 0x311c00, 0x563d1f, 0x7a5b3f, 0x916c51, 0x936a4e, 0x845539, 0x734126, 0x2a1e0e, 0x120a00, 0x16130e, 0x0e0a09, 0x080000, 0x62473e, 0xac8371, 0x76442b, 0x423d37, 0x625d57, 0x040000, 0x15110e, 0xc4c3c1, 0xfffffd, 0xffffff, 0xfcfefd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xeeeeee, 0xf8f8f8, 0xffffff, 0xfdfdfd, 0xf8f8f8, 0xefefef, 0xf9f9f9, 0xffffff, 0xfdfdfd, 0xefefef, 0xffffff, 0xfbfbfb, 0xfefefe, 0xf8f8f8, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xf8f8f8, 0x8b8e97, 0x040000, 0x432d06, 0xe7bb72, 0xffc05c, 0xfbb243, 0xffb24b, 0xffb356, 0xf8b149, 0xffb355, 0xffb155, 0xffb14e, 0xffb746, 0xffb343, 0xf7ad4e, 0xf9ad61, 0xfbfae8, 0xfffcff, 0x9e98a2, 0x010200, 0x101204, 0x1f222b, 0x111820, 0x172412, 0xf5aa45, 0xffbc5d, 0xffb256, 0xffb95a, 0xfbb148, 0xeaa236, 0xffbf57, 0xffc762, 0xf6d288, 0x7b481d, 0x8f500b, 0xf2b042, 0xffb856, 0xf9ac5a, 0xffbb59, 0xfab244, 0xfaa933, 0xf6a633, 0xf8ac3e, 0xffb64d, 0xffb956, 0xfeb455, 0xfbb053, 0xfeb157, 0xfeb455, 0xfdb352, 0xfbb150, 0xf9af4c, 0xf9b04a, 0xfbb24c, 0xfeb54e, 0xffb750, 0xfeb13f, 0xffab53, 0xffcf60, 0xe7c25a, 0x513e2d, 0x0d000c, 0x5f361a, 0xab6b24, 0x98531a, 0x140a08, 0x100000, 0x884e20, 0x795531, 0x14141c, 0x0c0e1b, 0x22211c, 0x000609, 0x040000, 0x280800, 0x572200, 0x90552b, 0x9f6c4d, 0x421e10, 0x4e3632, 0xffffff, 0xffffff, 0xfefefe, 0xf8f8f8, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfffaff, 0xa59ba4, 0x17080b, 0x4a2e23, 0x2c0600, 0x160000, 0x0f0a06, 0x132531, 0x5d6a73, 0x94908d, 0x403c39, 0x000104, 0x34261b, 0x936846, 0x4b290e, 0x050402, 0x68280d, 0xb47937, 0x55260a, 0x120000, 0x7e6626, 0xf2bd55, 0xffc266, 0xedb24e, 0xffba52, 0xffbd57, 0xffba55, 0xf6b04e, 0xf5ad4b, 0xf7ad4c, 0xfcb04e, 0xffb654, 0xfdb455, 0xfeb654, 0xfeb451, 0xfdb24d, 0xffb44f, 0xffb64f, 0xfdac43, 0xf29f37, 0xf8ad3a, 0xffb252, 0xffb059, 0xffb04d, 0xffb63d, 0xeda62a, 0xc4801b, 0xa96719, 0xffcc7c, 0xfbc160, 0xf0ac41, 0xffb651, 0xffb35e, 0xffad59, 0xffc256, 0xf8b936, 0xfacd50, 0x835b28, 0x0f0005, 0x191530, 0x101a1c, 0x1b250d, 0x040100, 0x554351, 0xe5f7ff, 0xfffff6, 0xf6d5a8, 0xecab59, 0xffad42, 0xffb241, 0xffb752, 0xf9b459, 0xffb150, 0xfdb455, 0xf8b451, 0xffb750, 0xffb049, 0xfcb355, 0xffcb80, 0x6b4b10, 0x000000, 0x595959, 0xfbfbfb, 0xffffff, 0xf8f8f8, 0xffffff, 0xfcfcfc, 0xf8f8f8, 0xffffff, 0xf8f8f8, 0xfcfcfc, 0xe2e2e2, 0xf4f4f4, 0xffffff, 0xf9f9f9, 0xffffff, 0xfbfbfb, 0xf9f9f9, 0xffffff, 0xffffff, 0xf4f4f4, 0xfbfbfb, 0xc2c2c2, 0x4c4c4c, 0xe2e2e2, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xf8f8f8, 0xfdfdfd, 0xffffff, 0xffffff, 0xfafafa, 0xfbfbfb, 0xffffff, 0x767676, 0x151515, 0x030000, 0x231a13, 0x311e0f, 0x573c27, 0x8e735e, 0x6b5645, 0x25170c, 0x17100a, 0x111b12, 0x0a1109, 0x0a0d04, 0x17140d, 0x251c15, 0x271811, 0x1e0b04, 0x150100, 0x091718, 0x1e201b, 0x100400, 0x280f00, 0x765641, 0x8f6e5b, 0x593b30, 0x290e07, 0x231e1a, 0x040000, 0x0e0906, 0xa39f9e, 0xfffffd, 0xfafafa, 0xffffff, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xe2e2e2, 0x646464, 0xbdbdbd, 0xffffff, 0xededed, 0xf9f9f9, 0xffffff, 0xffffff, 0xfbfbfb, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xdddddd, 0xf6f6f6, 0xffffff, 0xffffff, 0xfcfcfc, 0xf3f3f3, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0x3a3e49, 0x080000, 0x7d5c26, 0xffd179, 0xfcb853, 0xfbb24b, 0xffb551, 0xfeaf50, 0xfbb34f, 0xfdb153, 0xffb054, 0xffb54f, 0xffb849, 0xf2af47, 0xf1b66a, 0xffcc9a, 0xf0fbf3, 0xf7fcff, 0x3c3d41, 0x010200, 0x1e1e12, 0x1e1e28, 0x060b1e, 0x051014, 0x985a03, 0xfcbb5d, 0xffbf57, 0xf6ad46, 0xffb856, 0xffb052, 0xffb050, 0xffab48, 0xfbcf66, 0xebba5d, 0xb17926, 0xc18219, 0xf1ad2e, 0xf8ac4c, 0xffb262, 0xf9b643, 0xffb33f, 0xf5a834, 0xf1a334, 0xfbad41, 0xffb752, 0xffb757, 0xfeb358, 0xfcb25b, 0xffb457, 0xfdb354, 0xfbb152, 0xfab04f, 0xfbb14e, 0xfcb34d, 0xfeb54f, 0xfeb54e, 0xf6bb55, 0xffbc50, 0xffa749, 0xffc65e, 0xecc256, 0x62471c, 0x1d0001, 0x4e2b0b, 0xaa652a, 0x5f3a2a, 0x070001, 0x542e0a, 0xab6935, 0x392723, 0x00051d, 0x564c43, 0x9aa49c, 0x50554e, 0x1e1b14, 0x0a0000, 0x120000, 0x3a1606, 0x552a17, 0x300000, 0xababab, 0xf8f8f8, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xf6f6f6, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xb8aab7, 0x170f1e, 0x0d0a15, 0x443b3c, 0x64564b, 0xa6a296, 0xbdd1d0, 0xd0f7ff, 0xf7fcff, 0xf9f5f2, 0x392f26, 0x0e0000, 0x7a5a41, 0x7c573a, 0x221205, 0x0b1821, 0x9b5318, 0x522c19, 0x210907, 0x784f19, 0xf1b847, 0xffce60, 0xfaba62, 0xfbb254, 0xffbc4d, 0xffb246, 0xeda53f, 0xeba744, 0xf8b354, 0xfeb556, 0xfdb14f, 0xffb651, 0xfeb95a, 0xfab455, 0xfab250, 0xffb351, 0xffb651, 0xffb148, 0xfba63c, 0xf19c31, 0xfeb04e, 0xffb353, 0xffac4b, 0xffac41, 0xffb13b, 0xeca332, 0xe4a03f, 0xf7b664, 0xfabc4b, 0xf0ad42, 0xffbb5c, 0xffb061, 0xf1a257, 0xffb35b, 0xffc04d, 0xffc43b, 0xb0903b, 0x250600, 0x0e0000, 0x292327, 0x101116, 0x222618, 0x0b0900, 0x0e0314, 0xa9b6be, 0xfcffff, 0xfff4df, 0xe9be89, 0xf2af58, 0xfead42, 0xffb54e, 0xffb657, 0xffb052, 0xffb657, 0xfab955, 0xffb753, 0xffaf4c, 0xfdae51, 0xffce78, 0xae8432, 0x000000, 0x040404, 0xb9b9b9, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xc6c6c6, 0x606060, 0x9a9a9a, 0xf5f5f5, 0xfdfdfd, 0xffffff, 0xffffff, 0xfafafa, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0x171717, 0x262626, 0xe2e2e2, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xf4f4f4, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfbfbfb, 0xa1a1a1, 0x101920, 0x090d10, 0x070200, 0x140600, 0x463324, 0x7f6856, 0x79604c, 0x2e1501, 0x131f2b, 0x101c28, 0x0f1923, 0x0e151f, 0x0a0d16, 0x090913, 0x15121b, 0x221f28, 0x0f1221, 0x191013, 0x361c0f, 0x825e44, 0x846246, 0x35230f, 0x090a02, 0x061616, 0x040000, 0x332e2b, 0xa8a2a2, 0xfbf7f6, 0xfffeff, 0xffffff, 0xfcfbff, 0xfdfeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xe4e4e4, 0x0f0f0f, 0x1a1a1a, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xffffff, 0xf1f1f1, 0xf2f2f2, 0xffffff, 0xf6f6f6, 0xffffff, 0xf3f3f3, 0x8b8b8b, 0x636363, 0xe4e4e4, 0xfdfdfd, 0xfefefe, 0xfefefe, 0xffffff, 0xf9f9f9, 0xf6f6f6, 0xffffff, 0xadadad, 0x00010d, 0x120400, 0xb38b43, 0xffca67, 0xf8b34c, 0xfab152, 0xffb859, 0xfeb04c, 0xffb653, 0xffb253, 0xffb352, 0xffb54d, 0xf4b146, 0xe6b35a, 0xf6ce9b, 0xfff2df, 0xfbfffa, 0xadb1b2, 0x000002, 0x13140c, 0x1e1d18, 0x1c171d, 0x1b141c, 0x040000, 0x300a00, 0xc19648, 0xffca60, 0xf8b645, 0xffb856, 0xffb862, 0xffaf59, 0xfdad4e, 0xe9ac37, 0xffce50, 0xeeb858, 0xd59635, 0xeaa41e, 0xfcab38, 0xfaa856, 0xffb94a, 0xffbb50, 0xfaad41, 0xf3a236, 0xf8a638, 0xffb146, 0xffb753, 0xffb758, 0xfab55a, 0xffb457, 0xffb457, 0xffb657, 0xffb758, 0xffb756, 0xfeb451, 0xf9af4c, 0xf5ac46, 0xf5bc63, 0xffb748, 0xffb147, 0xffaa48, 0xffd15d, 0xeec44e, 0x694b0f, 0x1e0007, 0x703b0f, 0x7c5141, 0x1e1c27, 0x1d0d00, 0xa25924, 0x724530, 0x020c18, 0x4e413b, 0xfffff3, 0xfefffa, 0xdee8ea, 0xb5c2ca, 0x95989f, 0x574946, 0x644437, 0x2d0300, 0x212121, 0xb5b5b5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xaca19f, 0x89888e, 0xe5eef7, 0xfbffff, 0xfcf9f2, 0xfffff4, 0xf3fef8, 0xeeffff, 0xfffffd, 0xa8acaf, 0x080000, 0x350e00, 0xa16d45, 0x5d3a1e, 0x130c06, 0x222b32, 0x4e2f10, 0x160000, 0x7d521b, 0xffc445, 0xffb955, 0xe6ad53, 0xf9bb4e, 0xffae56, 0xffb33f, 0xfdad3e, 0xf3aa43, 0xf7b554, 0xffc264, 0xffc060, 0xffb654, 0xffb34f, 0xfdba5f, 0xf9b457, 0xfab454, 0xffb755, 0xffb44f, 0xfca93f, 0xfba43a, 0xffa73b, 0xffb362, 0xffba5a, 0xffb442, 0xf9a62e, 0xf3a236, 0xfaae4e, 0xffbd62, 0xffc66c, 0xffb943, 0xfdb350, 0xfdb762, 0xfab862, 0xffc462, 0xffc354, 0xefad3f, 0xf4af48, 0x46330b, 0x110000, 0x53432c, 0x493d25, 0x150a12, 0x1f1a1e, 0x17190e, 0x000010, 0x504f4a, 0xedf1f4, 0xffffff, 0xf6e2c9, 0xf5c482, 0xf2ac4c, 0xffb047, 0xffb850, 0xffb256, 0xfeb654, 0xf8b854, 0xfcb654, 0xffb556, 0xffb054, 0xffc161, 0xe5b14e, 0x232323, 0x000000, 0x565656, 0xf3f3f3, 0xffffff, 0xf7f7f7, 0xfafafa, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0x959595, 0x000000, 0x4c4c4c, 0xfdfdfd, 0xffffff, 0xeeeeee, 0xffffff, 0xfdfdfd, 0xfefefe, 0xf0f0f0, 0xffffff, 0xffffff, 0xc2c2c2, 0x2f2f2f, 0xd6d6d6, 0xffffff, 0xfafafa, 0xffffff, 0xfbfbfb, 0xfafafa, 0xfafafa, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0xffffff, 0xfdfdfd, 0xdadfe3, 0x4a4f53, 0x0b0f12, 0x080808, 0x040000, 0x302217, 0x705947, 0x442812, 0x0e0e18, 0x0f0f19, 0x15151d, 0x1d1d25, 0x222328, 0x202125, 0x1a1b1d, 0x161719, 0x292023, 0x0f0100, 0x49372d, 0x725c4e, 0x2b1b0c, 0x070500, 0x030d0c, 0x000509, 0x645f5c, 0xdad4d4, 0xfffdfd, 0xfdf9fa, 0xfffeff, 0xfffeff, 0xf9f8fd, 0xfdfeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xc4c4c4, 0x414141, 0xd9d9d9, 0xffffff, 0xfbfbfb, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xe4e4e4, 0xffffff, 0xefefef, 0x252525, 0x070707, 0xa4a4a4, 0xffffff, 0xfefefe, 0xffffff, 0xfafafa, 0xfefefe, 0xffffff, 0xffffff, 0xf2f2f2, 0x313131, 0x00010c, 0x3c2c0a, 0xe6b661, 0xffbc4f, 0xffb650, 0xf9b258, 0xffb75b, 0xffb551, 0xffb450, 0xffb453, 0xffb451, 0xfab14a, 0xebb44f, 0xeeca80, 0xfdecd0, 0xfffcff, 0xfef4f2, 0x413c40, 0x000007, 0x212528, 0x131311, 0x190f06, 0x5a4532, 0x4f3416, 0x0a0000, 0x5b4418, 0xd0a846, 0xffc74f, 0xffb34b, 0xffad59, 0xffb35d, 0xffbe5d, 0xffb347, 0xfbbb4f, 0xefb458, 0xffc56f, 0xffaf43, 0xf1991d, 0xffb545, 0xfaab4e, 0xffba5b, 0xffb34f, 0xfca941, 0xfaa437, 0xfea93c, 0xffb448, 0xfeb952, 0xf9b957, 0xffb55a, 0xffb55a, 0xffb558, 0xffb95a, 0xffba59, 0xffb756, 0xfbb14e, 0xf6ac49, 0xfeab43, 0xf8ab4f, 0xffba4a, 0xffc052, 0xf5a54c, 0xffc64d, 0xfcc954, 0x76441f, 0x2f0800, 0x3a2522, 0x232534, 0x100700, 0x764119, 0x9d5c36, 0x2f0f02, 0x020204, 0xbdb9b0, 0xfffffa, 0xf7fdfd, 0xf6ffff, 0xf9ffff, 0xeef2f5, 0xfaf6f5, 0xebe1df, 0x848484, 0xcbcbcb, 0xf7f7f7, 0xf8f8f8, 0xfcfcfc, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfef6e3, 0xfcfffa, 0xf1ffff, 0xf5ffff, 0xfffff7, 0xfffded, 0xfffeef, 0xfbf7ee, 0xfffbf8, 0x4f5962, 0x0b0400, 0x6b370f, 0xa3612d, 0x462307, 0x0a0501, 0x262626, 0x00003e, 0x7c581e, 0xffbb3f, 0xffbe4f, 0xedb84e, 0xfdc568, 0xffb05b, 0xffb149, 0xfca32d, 0xffae3e, 0xffb851, 0xf9b757, 0xf5b456, 0xfab556, 0xffb351, 0xffae48, 0xfbba5e, 0xf8b658, 0xfdb758, 0xffbb58, 0xffb14a, 0xf7a238, 0xfca639, 0xffb547, 0xffb26e, 0xffaf4c, 0xffae30, 0xf7a527, 0xf5a43b, 0xffb863, 0xffc36d, 0xefb14e, 0xffb54b, 0xf9ac52, 0xf4b160, 0xfbc45f, 0xe2b130, 0xf1bc38, 0xf9b854, 0x964806, 0x080000, 0x352525, 0xbeb089, 0x706235, 0x1e0a13, 0x1b1020, 0x21231e, 0x070d1d, 0x0a0000, 0xcacbcd, 0xf8ffff, 0xfffef6, 0xffdcaa, 0xf0b056, 0xfbad41, 0xffb94d, 0xffb458, 0xfbb553, 0xf5b752, 0xfbb754, 0xffba5e, 0xffb558, 0xfdb551, 0xffca5d, 0x494949, 0x090909, 0x000000, 0x9f9f9f, 0xfdfdfd, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xfcfcfc, 0xffffff, 0xf7f7f7, 0xbababa, 0xa6a6a6, 0xf6f6f6, 0xfbfbfb, 0xffffff, 0xf2f2f2, 0xffffff, 0xf4f4f4, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xfafafa, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xfbfbfb, 0xffffff, 0xfbfbfb, 0xffffff, 0xfdfdfd, 0xffffff, 0xebebeb, 0xffffff, 0xfffdfa, 0xfdfeff, 0x9aa1a7, 0x1b242b, 0x000105, 0x0a0501, 0x3b291b, 0x553c28, 0x150b0a, 0x1b1310, 0x1d1814, 0x1a1710, 0x18180e, 0x191d0f, 0x191f11, 0x171e0e, 0x221b09, 0x050200, 0x3e3e36, 0x333532, 0x000105, 0x040308, 0x282327, 0xb6b0b4, 0xfffbfb, 0xfffdfd, 0xfffdff, 0xfefafb, 0xfbf9fc, 0xfffeff, 0xfdfcff, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xf9f9f9, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfbfbfb, 0xa8a8a8, 0xbcbcbc, 0xffffff, 0xfefefe, 0xfefefe, 0xf6f6f6, 0xffffff, 0xf5f5f5, 0xffffff, 0xfbfbfb, 0x828282, 0x060606, 0x000813, 0x64522c, 0xffd478, 0xfcb543, 0xffbe58, 0xfbb45c, 0xfeb45b, 0xffba55, 0xffb14c, 0xffb350, 0xffb350, 0xf6af47, 0xefbd5c, 0xfee5a5, 0xfffff3, 0xf4feff, 0xc8b2b5, 0x080005, 0x181624, 0x181e2a, 0x131514, 0x130600, 0x8a6d41, 0xd5ab71, 0x0e0f3d, 0x0a0000, 0x8c6d13, 0xf6be45, 0xf8ae41, 0xffb65c, 0xffc166, 0xf4bb54, 0xffac52, 0xfaae63, 0xffc673, 0xf5ae5e, 0xffa959, 0xffb432, 0xf09d0f, 0xffae5e, 0xfeb75f, 0xffb95b, 0xffb24c, 0xfea63a, 0xfaa433, 0xfdaf40, 0xfeba4f, 0xfabd53, 0xffb65b, 0xfeb358, 0xfcb154, 0xfdb255, 0xffb758, 0xffb958, 0xffb855, 0xffb754, 0xffa02d, 0xf4a33a, 0xf0ba62, 0xefbf5d, 0xf9b749, 0xffb964, 0xffb85e, 0xffbf2f, 0x583823, 0x101420, 0x1e202f, 0x100200, 0x42260e, 0xb56736, 0x742b08, 0x00030e, 0x6d6d6d, 0xf7f6f4, 0xfffefa, 0xfdfaf5, 0xf9f9f7, 0xf8ffff, 0xf0ffff, 0xebffff, 0xffffff, 0xf3f3f3, 0xf5f5f5, 0xffffff, 0xffffff, 0xf8f8f8, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xfdfdfd, 0xf9f9f9, 0xe9f2ed, 0x0c1a1b, 0x140000, 0x9a5421, 0x7f4a14, 0x0f1807, 0x0a2634, 0x000015, 0x652a00, 0xe3a745, 0xffc655, 0xfab347, 0xffb859, 0xffb45a, 0xffae44, 0xf99f24, 0xf19d3d, 0xffbe5d, 0xffbd5c, 0xf2ae4d, 0xfab95b, 0xffbf67, 0xf7b662, 0xf9b665, 0xffae5b, 0xffb743, 0xfbc03e, 0xf2b244, 0xffae48, 0xe68f1e, 0xfba840, 0xffb466, 0xffb96a, 0xf9b04a, 0xf7a92d, 0xfca92f, 0xfead44, 0xfeb45d, 0xf6b863, 0xecb95e, 0xffb76c, 0xfdbe55, 0xf9c357, 0xffbc59, 0xffa61d, 0xffaf0b, 0xa68734, 0x000027, 0x3a1400, 0xf8c045, 0xe6b652, 0x1d1b26, 0x00162c, 0x0b230d, 0x1a1d0a, 0x1b2026, 0x000100, 0x616566, 0xf7feff, 0xfcffff, 0xfff9e6, 0xffe8b2, 0xd7a951, 0xf6bc4e, 0xffb454, 0xffb352, 0xfdb151, 0xffb856, 0xffbb58, 0xf2b44f, 0xf5ba54, 0xffcf68, 0x988739, 0x090006, 0x0a0b1d, 0x000500, 0xd8d1c1, 0xfffbf8, 0xf6ede8, 0xfefdff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xf6f6f6, 0xffffff, 0xd2d2d2, 0xe8e8e8, 0xffffff, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xe3e3e3, 0x767676, 0x000000, 0x000000, 0x595959, 0x554b41, 0x21170d, 0x060000, 0x1d190d, 0x17180a, 0x15190a, 0x131a0a, 0x0c1504, 0x251305, 0x57473a, 0x60534a, 0x080000, 0x030000, 0x727272, 0xf6fafd, 0xf8fdff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfcfcfc, 0xd1d1d1, 0xe4e4e4, 0xf6f6f6, 0xffffff, 0xfefefe, 0xf9f9f9, 0xffffff, 0xffffff, 0xfffbff, 0xfffcfd, 0xfffcfa, 0xfffdf6, 0xfffff6, 0xc4c5bf, 0x000306, 0x060f16, 0x090500, 0xac8f65, 0xfac06c, 0xffc057, 0xffb650, 0xf8b25a, 0xfbb560, 0xfcb25d, 0xffb741, 0xffb646, 0xe8b04f, 0xd5b467, 0xfaecbb, 0xfffeeb, 0xfbffff, 0xf8feff, 0x3f5843, 0x01050e, 0x171218, 0x1e2416, 0x071927, 0x0a1044, 0x261617, 0xeacb70, 0xd8be2b, 0x230a0d, 0x0d0018, 0xb4973b, 0xfbb515, 0xffa824, 0xffb34f, 0xf5b959, 0xfcbc62, 0xf9be64, 0xf5bc65, 0xf1b85f, 0xf9b757, 0xffb54c, 0xffaa37, 0xff9c22, 0xfebd5f, 0xffbd5d, 0xffba57, 0xfda541, 0xef9831, 0xfcaa46, 0xffc05e, 0xf8b656, 0xffc04c, 0xfbb84d, 0xfcb857, 0xfdb560, 0xf6ae5a, 0xfdb35c, 0xffbc5b, 0xfcb14b, 0xffb851, 0xf8ab3f, 0xf6a232, 0xffa837, 0xffb54b, 0xffbc59, 0xffb95f, 0xf4b25e, 0xfeba31, 0x592500, 0x00001b, 0x001d34, 0x22240e, 0x975024, 0x8d4e2d, 0x000300, 0x252e35, 0xf1f8fe, 0xfeffff, 0xfffffd, 0xfffefb, 0xfffdfa, 0xfffffd, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xb8c1c0, 0x000000, 0x4b2711, 0xa46033, 0x613613, 0x06130c, 0x06131b, 0x321517, 0xc18523, 0xf6b758, 0xffbf61, 0xffbf5d, 0xffb850, 0xf4a236, 0xfaa339, 0xfda43c, 0xffbd5e, 0xffb656, 0xffb657, 0xffbb5c, 0xffbb5e, 0xfdb85d, 0xffba5f, 0xffbb63, 0xffb256, 0xf6b050, 0xffc257, 0xffbf4e, 0xe39226, 0xc16a0b, 0xffba60, 0xfcbd60, 0xffb85e, 0xf6a941, 0xf2a52f, 0xfcaf3d, 0xffb553, 0xffba62, 0xfdbc60, 0xf6bb57, 0xfdb748, 0xffbd69, 0xffb054, 0xd78a0a, 0xffc248, 0xcf9452, 0x250000, 0x3a260d, 0xd4ae67, 0xffe16c, 0x9a7838, 0x06000e, 0x010d1d, 0x0e190b, 0x1b1c17, 0x15161a, 0x130f0c, 0x060709, 0xc5cdd0, 0xfaffff, 0xfffff1, 0xfffcd6, 0xffe5a7, 0xd8a95b, 0xf1b240, 0xfeba4f, 0xffba5a, 0xffb057, 0xfdaf5a, 0xffbf67, 0xffc565, 0xf1bc56, 0xd1b464, 0x331f14, 0x0a0815, 0x060e03, 0x38392b, 0xeae0e1, 0xfffdff, 0xfbfcff, 0xffffff, 0xf4f4f4, 0xfefefe, 0xffffff, 0xfcfcfc, 0xfafafa, 0xffffff, 0xf9f9f9, 0x979797, 0x0f0f0f, 0x222222, 0xb3b3b3, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xfefefe, 0xf8f8f8, 0xadadad, 0x383838, 0x000000, 0x5c4742, 0x59443f, 0x422f29, 0x32231c, 0x2a1d15, 0x292017, 0x292218, 0x342d23, 0x544437, 0x584a3f, 0x0a0000, 0x352e28, 0xb6b2af, 0xffffff, 0xfbffff, 0xfbffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0x9c9c9c, 0x272727, 0x131313, 0xaaaaaa, 0xf5f5f5, 0xf9f9f9, 0xffffff, 0xfcfcfc, 0xf7f7f7, 0xffffff, 0xfffdfd, 0xfef9f6, 0xfdf8f4, 0xfdf8f4, 0xe5e4e0, 0x2c2d2f, 0x000105, 0x0e151d, 0x3c2b17, 0xddb97f, 0xffc766, 0xffb849, 0xffbc5b, 0xfeb863, 0xffb85f, 0xffb752, 0xffbb45, 0xffc25d, 0xdcad67, 0xfff5ce, 0xfff2e2, 0xfffefb, 0xf8fcfd, 0xbbc4c3, 0x000c01, 0x0e121b, 0x16151d, 0x14150d, 0x111518, 0x0c081f, 0x110400, 0x8a773d, 0xffe783, 0xd3b95c, 0x241100, 0x150000, 0xd5aa4e, 0xf5b230, 0xf49e2f, 0xffaf3d, 0xffb650, 0xffb957, 0xfdbc5e, 0xfbbc5f, 0xffbd5d, 0xffba54, 0xffad41, 0xf79d2b, 0xf2aa44, 0xffb855, 0xffb859, 0xffb256, 0xbf6e12, 0xd78829, 0xf9b14f, 0xffbb56, 0xf6bc51, 0xfbbc55, 0xffc061, 0xfbb158, 0xffb65e, 0xffb75f, 0xf2a94b, 0xffc565, 0xfeb654, 0xffb551, 0xffae44, 0xfca639, 0xffaa3f, 0xffb651, 0xffbc5d, 0xfcb95e, 0xfaba36, 0xb87b3c, 0x281616, 0x001019, 0x081003, 0x622f12, 0xa46949, 0x2d1800, 0x03080c, 0xcbcfd2, 0xfeffff, 0xfafafa, 0xfffffd, 0xfffffd, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0x70777d, 0x0d0000, 0x864f30, 0x975734, 0x2b1508, 0x000f17, 0x190e08, 0x8f4b28, 0xfcbf4c, 0xfebc5c, 0xfbb462, 0xffbd61, 0xfab140, 0xeb9f25, 0xffaf43, 0xffb259, 0xffbe5f, 0xffb859, 0xffb659, 0xffb85b, 0xffb75a, 0xffba5b, 0xffba59, 0xfeb451, 0xf4ba57, 0xffc97d, 0xf6b565, 0xe7a034, 0xb66500, 0xc97628, 0xfdba6c, 0xf9c85f, 0xffb349, 0xf4a337, 0xf1a73a, 0xffb751, 0xffbc62, 0xffbd63, 0xffbb58, 0xffb647, 0xfebd3f, 0xef9535, 0xffa239, 0xffcd51, 0xaf893e, 0x210207, 0x4c2017, 0xfbc36c, 0xffef7d, 0xcab95f, 0x2d200f, 0x0f0009, 0x544035, 0x312b1f, 0x171522, 0x201b1f, 0x211b1b, 0x000000, 0x353b3b, 0xeff8f5, 0xfbfef5, 0xf7f0de, 0xfff0d7, 0xfffadc, 0xdcb347, 0xf5c05a, 0xf9b054, 0xffb561, 0xffbe6f, 0xffb15f, 0xf9b961, 0xf2bf63, 0xfed07b, 0x7e5f31, 0x070000, 0x181d23, 0x000300, 0x505156, 0xf9f7ff, 0xfffff8, 0xf4f4f4, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0x737373, 0x070707, 0x535353, 0xf5f5f5, 0xffffff, 0xededed, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xfdfdfd, 0xfbfbfb, 0xfbfbfb, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xc8c8c8, 0x404040, 0x140000, 0x3c2221, 0x523a38, 0x4c3432, 0x523f3b, 0x55423e, 0x473531, 0x4e3f3a, 0x3f3229, 0x0a0000, 0x4a413a, 0xe4dfdb, 0xfdf9f6, 0xffffff, 0xfeffff, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf2f2f2, 0xffffff, 0xffffff, 0xf3f3f3, 0xffffff, 0xeaeaea, 0x535353, 0x000000, 0x8f8f8f, 0xf4f4f4, 0xffffff, 0xfcfcfc, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xfffffb, 0xfffffa, 0xfefffa, 0xfeffff, 0x393c41, 0x000009, 0x191c23, 0x000104, 0x805f2c, 0xf9c87b, 0xffc75c, 0xffb749, 0xffb95a, 0xfbb55f, 0xffb757, 0xffad40, 0xe8bb54, 0xddb669, 0xfff1ce, 0xfff9f8, 0xfff7ff, 0xfffdff, 0xf1f3ee, 0x252918, 0x000002, 0x171b24, 0x161824, 0x130d0d, 0x423222, 0x43311b, 0x0b0000, 0x2b271c, 0xffca7c, 0xfad15b, 0xdec05e, 0x392115, 0x140001, 0xc3a04c, 0xffbf32, 0xff951e, 0xffab3a, 0xffb043, 0xffb850, 0xffbd5b, 0xffc160, 0xffbe5d, 0xf8b250, 0xeea642, 0xed9d2c, 0xffb84f, 0xffbb5e, 0xffc470, 0xbe7725, 0xae6611, 0xf7ad4e, 0xffb650, 0xfbcc72, 0xeeb75c, 0xf5b257, 0xffb457, 0xfcad50, 0xffb95c, 0xffc267, 0xf1b157, 0xffb65f, 0xffbb5f, 0xffb958, 0xfeab45, 0xf5a238, 0xf8a940, 0xffb84f, 0xffc159, 0xf2b63a, 0xffbb66, 0x7d4820, 0x191509, 0x000907, 0x2f1a15, 0x946345, 0x703b05, 0x000000, 0x939393, 0xffffff, 0xf9f9f9, 0xffffff, 0xfbfbfb, 0xfffffd, 0xfffefc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xfefefe, 0xffffff, 0xfbfbfb, 0xffffff, 0xf9f9f9, 0x2a2e37, 0x270600, 0x9c5a37, 0x6b3721, 0x04010a, 0x0b1727, 0x4b260b, 0xe27e33, 0xfcb646, 0xffba56, 0xf9b054, 0xf5ab4a, 0xefa53a, 0xf5ac3d, 0xffbf5a, 0xffba5e, 0xf4b355, 0xffc063, 0xffbc60, 0xffb458, 0xffb95d, 0xffb455, 0xf8ae4b, 0xfdb551, 0xf6d179, 0xe3b36b, 0xc3833c, 0xd58933, 0x9b4900, 0xe3974b, 0xffc773, 0xebc058, 0xffa832, 0xf8a434, 0xfab14b, 0xffbe63, 0xfebb64, 0xffb758, 0xffb347, 0xffaa33, 0xf6a637, 0xfea418, 0xfda71e, 0xc18735, 0x3c240a, 0x4f4029, 0xefc887, 0xffcb64, 0xffd26d, 0x686435, 0x00000b, 0x3e180b, 0xc69956, 0x624f2f, 0x050217, 0x211a21, 0x251c21, 0x1b1718, 0x000200, 0x69726d, 0xf9ffff, 0xe5e6ea, 0xbcb7be, 0xf9edf9, 0xffffc5, 0xdcb572, 0xefae5e, 0xffb75c, 0xffaf4f, 0xffb85c, 0xfbb963, 0xf3bf6c, 0xffce7e, 0xb58e43, 0x200d00, 0x0e0b1c, 0x1c2826, 0x00020b, 0x5d5e73, 0xf3f6e3, 0xffffff, 0xf8f8f8, 0xfafafa, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xf9f9f9, 0xfefefe, 0xffffff, 0xf8f8f8, 0xe1e1e1, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xfdfdfd, 0xf6f6f6, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xf6f6f6, 0xf6f6f6, 0xffffff, 0xffffff, 0xe5e5e5, 0x261714, 0x0f0000, 0x1d0f0c, 0x221411, 0x2a1c19, 0x291e1a, 0x1d120e, 0x1b100c, 0x070000, 0x413a34, 0xe8e3df, 0xfffefb, 0xfffffd, 0xf5f5f5, 0xfeffff, 0xfbfcfe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xd8d8d8, 0xfafafa, 0xffffff, 0xffffff, 0xfbfbfb, 0xfafafa, 0xfefefe, 0xffffff, 0xffffff, 0xf8f8f8, 0xfbfdf8, 0xfbfff8, 0xf3fdf4, 0x3d4547, 0x020514, 0x191828, 0x1b191c, 0x120e03, 0xd7ae56, 0xfec369, 0xffb85a, 0xffb753, 0xfebb53, 0xfbbb57, 0xffbf5f, 0xffb155, 0xdac188, 0xfffed6, 0xfffcf1, 0xbab0bb, 0xece7fd, 0xfffdff, 0x494949, 0x020200, 0x221a25, 0x171a21, 0x1a1e2a, 0x11040b, 0x7a5936, 0xb08f4c, 0x261800, 0x00000e, 0x836531, 0xffd277, 0xffdb5c, 0xe7c178, 0x4e383b, 0x3e2707, 0xd4982a, 0xffa72e, 0xffa028, 0xffa52f, 0xffac3b, 0xffb44b, 0xffbb57, 0xffbd5d, 0xf9b95f, 0xf0b55b, 0xfba22a, 0xffb549, 0xffb95d, 0xffc072, 0xe5a55d, 0x874400, 0xc87e25, 0xd18321, 0xe5be73, 0xffd182, 0xefb15a, 0xffbe60, 0xffc363, 0xfab153, 0xffc56e, 0xf0b360, 0xffb867, 0xffb865, 0xffb85e, 0xffb654, 0xf7aa42, 0xeea234, 0xf7ae3d, 0xffbf4c, 0xf7bb49, 0xffb84d, 0xd6812e, 0x552f08, 0x060f16, 0x131b28, 0x5a361e, 0xa45916, 0x0f0600, 0x544f4b, 0xfffffd, 0xfcfdff, 0xfcffff, 0xfbfcfe, 0xfefdfb, 0xfffbf8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xd7d7d7, 0x010207, 0x5a311b, 0x884926, 0x37160d, 0x000418, 0x2c272e, 0x874918, 0xff942c, 0xfdaf4b, 0xffbc4e, 0xf5ac39, 0xeaa033, 0xf1a748, 0xfcb25b, 0xffbc5e, 0xffb951, 0xf9be64, 0xffbe64, 0xffbb5f, 0xffbb5f, 0xffba5e, 0xfab155, 0xf7b65a, 0xffcd72, 0xd7ba78, 0x744900, 0xc5853d, 0xb96830, 0xa65715, 0xffc36a, 0xf8c15d, 0xecbb5f, 0xf8a025, 0xffab3e, 0xffbc5c, 0xffbd63, 0xf8b253, 0xf8ab43, 0xfca733, 0xfb9e25, 0xfd992a, 0xffae1a, 0xeaaa26, 0x734509, 0x80643f, 0xf1dc8b, 0xf9d662, 0xffca5e, 0xbb9065, 0x1b1209, 0x060000, 0x956827, 0xffcc55, 0x7e602a, 0x010012, 0x1c1922, 0x1c1318, 0x282425, 0x141613, 0x000200, 0x868e90, 0xf9ffff, 0xa2a4bb, 0x525170, 0xeee2ec, 0xfff9e8, 0xebbd81, 0xe0a03f, 0xffb949, 0xffb74c, 0xffbd64, 0xf8ba6f, 0xffc781, 0xf6ca73, 0x5f411b, 0x070005, 0x21292b, 0x07111a, 0x000010, 0x646754, 0xf9f9f9, 0xffffff, 0xffffff, 0xf3f3f3, 0xf7f7f7, 0xfefefe, 0xfdfdfd, 0xfbfbfb, 0xffffff, 0xf4f4f4, 0xffffff, 0xfcfcfc, 0xf7f7f7, 0xffffff, 0xffffff, 0xd3d3d3, 0x9f9f9f, 0xefefef, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xb5bab4, 0x1a1f19, 0x030802, 0x131812, 0x141611, 0x151712, 0x171914, 0x090a05, 0x171310, 0xcac6c3, 0xfffefb, 0xedecea, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf3f3f3, 0xa3a3a3, 0xe0e0e0, 0xffffff, 0xf5f5f5, 0xffffff, 0xf9f9f9, 0xffffff, 0xf3f3f3, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf3f3f3, 0xf1f1f1, 0xffffff, 0xfefffd, 0xf9fff6, 0x374339, 0x00070b, 0x111427, 0x201929, 0x0d0000, 0x5c4c28, 0xfbd56a, 0xfabc65, 0xffb268, 0xffb962, 0xffc457, 0xebb94a, 0xe5ae5b, 0xfcbb85, 0xfffbf8, 0xe6dcda, 0x565551, 0xbabebd, 0xfbffff, 0x6a6b70, 0x04010a, 0x1c1421, 0x241c27, 0x161920, 0x1c1e2d, 0x0d0002, 0x8a6435, 0xfdd776, 0x7d6623, 0x070002, 0x19161d, 0xceb25f, 0xffc148, 0xffc965, 0xffd78f, 0x704f30, 0x8d572b, 0xf1a837, 0xff9f27, 0xfe9e26, 0xfd9f2d, 0xfca637, 0xfdae45, 0xfcb654, 0xfdbe61, 0xfdc268, 0xffa52d, 0xf3a133, 0xfeb557, 0xfbba6a, 0xffcb82, 0xa6661c, 0x9b5404, 0xc57b26, 0x724c0e, 0xf1c481, 0xffd184, 0xedad55, 0xffbd60, 0xffbd60, 0xf5b35c, 0xfec06b, 0xffb768, 0xfab260, 0xfdb560, 0xffbd61, 0xffb552, 0xefa538, 0xf1a430, 0xffb13a, 0xffc45a, 0xffad32, 0xff9f2d, 0x914c11, 0x1e151a, 0x00152a, 0x291808, 0xa0551b, 0x39291c, 0x1f150c, 0xeae6e3, 0xfcffff, 0xf8fdff, 0xfcffff, 0xfefdfb, 0xfffefa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xa3a3a3, 0x040000, 0x734f37, 0x582c13, 0x0f0506, 0x0a0d20, 0x533125, 0xb7671e, 0xffa12b, 0xffb857, 0xffb340, 0xeba021, 0xeea532, 0xffb75e, 0xfbb367, 0xf7b45d, 0xffc158, 0xf8be6a, 0xf7b75f, 0xffbb5f, 0xffba5d, 0xfbb45a, 0xffc671, 0xffd386, 0xefc57d, 0x5a3b04, 0x805207, 0xd5924c, 0x803204, 0xe29962, 0xffce6d, 0xf7bb4d, 0xf4b359, 0xf1a02a, 0xffb449, 0xffbc5b, 0xffb351, 0xf6a83c, 0xf6a22e, 0xf89f2b, 0xfb9c2e, 0xffa027, 0xf3a237, 0xe3ac52, 0xd5ac5a, 0xefca71, 0xffd876, 0xe5c25c, 0xefcf6c, 0x3b2027, 0x0f0000, 0x66451a, 0xedb84e, 0xffd24b, 0x77571c, 0x090011, 0x161e21, 0x181214, 0x24201f, 0x11100e, 0x111312, 0x000005, 0xadb1bc, 0xf5fbff, 0x6e7389, 0x211e49, 0xebe0ee, 0xfffcdc, 0xf1cd81, 0xf2c15b, 0xecae47, 0xf9b459, 0xffbc6e, 0xf8c995, 0xffda88, 0xab8749, 0x160000, 0x100b11, 0x1d2528, 0x161e20, 0x000200, 0x4d4d4d, 0xcecece, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfbfbfb, 0xf6f6f6, 0xf3f3f3, 0xffffff, 0xffffff, 0xf2f2f2, 0xdbdbdb, 0x9e9e9e, 0xefefef, 0xffffff, 0xf8f8f8, 0xffffff, 0xfbfbfb, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xf4ffff, 0x1b2c26, 0x000f0a, 0x1b2723, 0x17221e, 0x141d1a, 0x181e1c, 0x000604, 0x414141, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xf3f3f3, 0xfffffd, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xe5e5e5, 0xa2a2a2, 0xd9d9d9, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xcecccf, 0x31372d, 0x000400, 0x151e23, 0x1a182d, 0x170a13, 0x160000, 0xbfa45f, 0xecd17a, 0xffcd81, 0xffbe74, 0xffb15c, 0xf7bc58, 0xdcb45c, 0xe8c792, 0xfff6e3, 0xddd3ec, 0x070311, 0x7f8382, 0xf9fff6, 0x97a294, 0x030804, 0x0f0c17, 0x20162e, 0x131718, 0x191c21, 0x151120, 0x0e0000, 0x896833, 0xffdd72, 0xd3af51, 0x5f390c, 0x000017, 0x3b2a00, 0xf1c361, 0xffca60, 0xffc269, 0xffd08c, 0xc69256, 0xd5a158, 0xffa93a, 0xfaa332, 0xf79d2b, 0xf89e2c, 0xfba433, 0xfdac41, 0xffb852, 0xffc15f, 0xffaa3d, 0xeb982e, 0xffb44f, 0xffbe63, 0xffc876, 0xeaaa60, 0x8c4b09, 0xc17d3e, 0x663d07, 0x72480c, 0xeec17d, 0xffd384, 0xe5ad58, 0xffc269, 0xfab75e, 0xffb961, 0xfcb45f, 0xf8b45f, 0xfab862, 0xffbe64, 0xffbc5d, 0xfbb148, 0xf6a635, 0xf6a12c, 0xffbb53, 0xffb834, 0xffa725, 0xc46920, 0x47221c, 0x000919, 0x181914, 0x602e0d, 0x5e4531, 0x110100, 0xbfbab6, 0xfbffff, 0xf3fcff, 0xfbffff, 0xf9f8f6, 0xfffef8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xfefefe, 0x6e6e6e, 0x150f03, 0x5c4028, 0x291607, 0x010e17, 0x1a1720, 0x783a13, 0xd4791c, 0xffaf36, 0xffb542, 0xf9a430, 0xeb9a27, 0xfaad43, 0xffbf60, 0xfdba61, 0xf8b860, 0xfec168, 0xf0b768, 0xfab965, 0xffbe61, 0xfdb757, 0xfcbc62, 0xffd387, 0xd3b376, 0x7b6533, 0x3b1500, 0xcb9559, 0x8b460f, 0x9b541e, 0xffd48f, 0xefb45a, 0xffc861, 0xf19e38, 0xf1a93b, 0xffb651, 0xffb04f, 0xfba337, 0xfca227, 0xfba222, 0xf99f2d, 0xffa743, 0xffa640, 0xffb96f, 0xf7b871, 0xffcc66, 0xf4c050, 0xf9c772, 0xe0bb84, 0x4c3805, 0x010010, 0x512e00, 0xd89932, 0xffd056, 0xffd364, 0x79532c, 0x080006, 0x091f13, 0x201f1b, 0x12110f, 0x1b1718, 0x221d21, 0x030004, 0x09090b, 0xe3e5e4, 0xf7fbfa, 0x323850, 0x1e2430, 0xeff0e8, 0xffffdf, 0xd5b880, 0xf8c479, 0xfab059, 0xffb253, 0xffe9c4, 0xfad795, 0xffd987, 0x704d25, 0x110004, 0x1c1c1a, 0x131c0b, 0x111217, 0x000000, 0x353535, 0xababab, 0xfafafa, 0xfefefe, 0xf8f8f8, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xf4f4f4, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf1f1f1, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xc5d1cf, 0x0c1615, 0x081110, 0x141a1a, 0x151618, 0x161618, 0x1c1a1d, 0x130e12, 0x1e2225, 0xe8ecef, 0xfeffff, 0xfeffff, 0xffffff, 0xfffffd, 0xfffffd, 0xfaf9f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xf8f8f8, 0xffffff, 0xffffff, 0xf8f8f8, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xaeaeae, 0x322831, 0x010000, 0x181e14, 0x11161a, 0x1c1527, 0x1a0504, 0x6f4e19, 0xfed772, 0xf6e8c5, 0xffe1a0, 0xffbe5d, 0xf7ac47, 0xf1b86b, 0xf5d5ac, 0xfffded, 0xedece7, 0x0c0016, 0x5f5967, 0xf4f5f7, 0xc9d3cb, 0x000400, 0x020902, 0x202022, 0x1c171e, 0x102216, 0x181c1f, 0x180c1a, 0x160100, 0x8a7540, 0xf0d36b, 0xf9c651, 0xdb942a, 0x342311, 0x0b0000, 0x52431c, 0xf0d181, 0xf8bd71, 0xffbf60, 0xffcb60, 0xfbc483, 0xffb959, 0xfaaf49, 0xfaa538, 0xfca12e, 0xfe9f29, 0xfea02c, 0xffa939, 0xffb346, 0xffb857, 0xf8a944, 0xf6a83c, 0xffb94e, 0xfab455, 0xfebc70, 0xa26630, 0x753b13, 0xbf8d5a, 0x3c1100, 0x856125, 0xfad793, 0xf8ce82, 0xf4bc67, 0xffb95d, 0xffba5a, 0xfbb657, 0xfdba5f, 0xfabd64, 0xfabc65, 0xfebd61, 0xffba59, 0xffac42, 0xf89e2e, 0xf8ab43, 0xfcbc38, 0xfdac27, 0xe57f2d, 0x76341e, 0x090c11, 0x0a1d21, 0x21120f, 0x5f4129, 0x1c0900, 0x8e8985, 0xf8ffff, 0xf5ffff, 0xf9ffff, 0xf8f7f5, 0xfffbf4, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xfafafa, 0xffffff, 0xfcfcfc, 0x4d4d4d, 0x1a1100, 0x351f08, 0x100d06, 0x0d2434, 0x2e2423, 0x93420b, 0xdf7e17, 0xf4b63f, 0xffa722, 0xf59e2d, 0xf9a243, 0xffb253, 0xffba50, 0xfdbe54, 0xfabd64, 0xeeb26a, 0xf9be72, 0xffc16f, 0xffbd60, 0xffc160, 0xffd47b, 0xeac27c, 0x76602f, 0x0a0200, 0xbd9349, 0x905326, 0x4a0000, 0xf9b670, 0xffc974, 0xfdc272, 0xf8ab4f, 0xfa9d26, 0xf6b24d, 0xffb656, 0xfca440, 0xf79824, 0xffa31b, 0xffa51e, 0xfda331, 0xffb157, 0xffc080, 0xfdb36c, 0xffc26d, 0xfcb857, 0xffd470, 0xf3c377, 0x614021, 0x0f0002, 0x0d1b24, 0xca9d40, 0xffbe30, 0xf1af37, 0xffda8c, 0x926858, 0x0e0008, 0x07270f, 0x1f201a, 0x1b1a18, 0x241e22, 0x170d15, 0x2a2126, 0x040000, 0x1e1c0f, 0xffffed, 0xf7fffa, 0x000504, 0x324148, 0xf6fbff, 0xfffced, 0xffd1a0, 0xf6ac57, 0xffa73a, 0xe6d6bd, 0xfff9c3, 0xfacf71, 0xdeb478, 0x2f1119, 0x0f0c05, 0x0f1800, 0x7b7a88, 0x484848, 0x020202, 0x000000, 0x565656, 0xbebebe, 0xf8f8f8, 0xffffff, 0xfafafa, 0xffffff, 0xfcfcfc, 0xfefefe, 0xfafafa, 0xffffff, 0xf9f9f9, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xfcfcfc, 0xfafafa, 0xffffff, 0xf9f9f9, 0x747577, 0x010103, 0x201e21, 0x1f191d, 0x231a1f, 0x271a21, 0x27181f, 0x28171f, 0x000509, 0x7a7f83, 0xfcffff, 0xfcfdff, 0xfafafa, 0xfffffd, 0xfffffd, 0xfffcf9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xb3b3b3, 0x454545, 0x000000, 0x080009, 0x524d4a, 0x6b6e63, 0x0f1014, 0x0a000f, 0x40251e, 0xecc582, 0xffd159, 0xfff8ff, 0xf2d39a, 0xecb237, 0xffc34d, 0xffd098, 0xfff7f6, 0xf4f6ff, 0x213631, 0x160b0f, 0xfffbff, 0xf1f0f6, 0x161b21, 0x000205, 0x191f1d, 0x1b1c14, 0x1f1f13, 0x0b2812, 0x121617, 0x271523, 0x100000, 0x8a7d49, 0xf5dd7b, 0xf6bb39, 0xffba25, 0xb88b54, 0x150600, 0x00001c, 0x575540, 0xf4ca66, 0xffcf66, 0xfead52, 0xffc24f, 0xffc66d, 0xfcba5a, 0xfdae45, 0xffa735, 0xffa026, 0xff9a1e, 0xff9d25, 0xffa52d, 0xffb35b, 0xffb351, 0xe69627, 0xffb643, 0xffc35a, 0xffc87a, 0xeeb687, 0x471500, 0x95602c, 0x966b38, 0x2f1000, 0x634b0d, 0xf7d68f, 0xffd986, 0xffbb5e, 0xffaf4b, 0xfeba55, 0xffbf5e, 0xfbc064, 0xf8bc64, 0xfcbc64, 0xffbb5e, 0xffb14c, 0xffa238, 0xf7a63b, 0xe8b22e, 0xf8b331, 0xf08330, 0x913c1d, 0x221a17, 0x00171f, 0x0b1326, 0x48260b, 0x260f00, 0x69625c, 0xf0f7fd, 0xf5ffff, 0xf9ffff, 0xfffefb, 0xfffdf4, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xf8f8f8, 0xfefefe, 0xececec, 0x292929, 0x000901, 0x151318, 0x1f1f29, 0x121413, 0x442310, 0x9d4a16, 0xea8928, 0xffb32a, 0xff9f16, 0xffa725, 0xf7ac37, 0xf7bc56, 0xffcb71, 0xfcbf6f, 0xf9b165, 0xffb86f, 0xf7c360, 0xf7bf6c, 0xf7c967, 0xffdc70, 0xc69b64, 0x181713, 0x170c00, 0xcf7423, 0x988662, 0x1b0000, 0xb28a57, 0xffe171, 0xfbba6a, 0xffba6f, 0xfbb539, 0xeca81f, 0xffaf3b, 0xf9a328, 0xfaa725, 0xf7aa26, 0xeaa027, 0xf1a744, 0xffb76c, 0xffb77d, 0xffbd76, 0xf5ad58, 0xffbd5c, 0xffda7a, 0xdbb36b, 0x4e3b13, 0x010100, 0x0b151e, 0xd5933d, 0xffb316, 0xffaf20, 0xfbc362, 0xfbe689, 0x775d38, 0x130013, 0x131521, 0x0b0f0e, 0x0f2822, 0x241a1b, 0x381712, 0x111b10, 0x091f2c, 0x0b0012, 0x482e21, 0xf2fff8, 0xb4c3be, 0x060b11, 0x726f78, 0xfffbff, 0xfeecde, 0xffeecc, 0xcbb383, 0xf5b329, 0xfff1ef, 0xf9eacd, 0xefd25d, 0xbe884c, 0x160000, 0x000301, 0xa6b7cb, 0xf4f4f4, 0x212121, 0x282828, 0x5a5a5a, 0x030303, 0x545454, 0xfefefe, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xf6f6f6, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xf7fffd, 0xf9ffff, 0xfbfffd, 0xfbfffb, 0xfcfffa, 0xfefff8, 0xfbfdf2, 0xfffff4, 0xfffefd, 0xfffefd, 0xfffbfa, 0xfffdfd, 0xfffcfd, 0xfff9fa, 0xfffbfc, 0xfff5f7, 0x191418, 0x140f13, 0x171216, 0x1b161a, 0x191418, 0x1c171b, 0x1f1a1e, 0x191418, 0x070604, 0x333132, 0xefedee, 0xfffeff, 0xf1ecf2, 0xfffdff, 0xfbf6fd, 0xfffbff, 0xf8faf9, 0xfefffd, 0xfefffd, 0xfefffb, 0xfbfef7, 0xfefff8, 0xfdfff5, 0xfefff6, 0xfbfaff, 0xfffeff, 0xfffeff, 0xfffeff, 0xfffeff, 0xfcfbff, 0xfffeff, 0xfffeff, 0xfcfcfc, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfafafa, 0xf2f2f2, 0xfefefe, 0xffffff, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0x444444, 0x000000, 0x646464, 0x1e1e1e, 0x32291a, 0xfffdff, 0x8a8e8d, 0x100702, 0x1a0000, 0xb59848, 0xf4df86, 0xffe8ec, 0xfff6ad, 0xdaa76e, 0xe2bc98, 0xfff1e3, 0xfff6f4, 0xffffff, 0x525751, 0x030b00, 0xe7e7e7, 0xf2f0f1, 0x383236, 0x060002, 0x22191e, 0x1e181a, 0x191514, 0x1c1b19, 0x15241d, 0x02172c, 0x06112d, 0x120500, 0x9f814d, 0xffda8f, 0xf5bd6a, 0xf2a64e, 0xffbb1d, 0xb88534, 0x201617, 0x000013, 0x504e35, 0xe3c678, 0xffd774, 0xfcb253, 0xffba6b, 0xffbd6a, 0xffc66c, 0xffc25d, 0xf2aa3c, 0xf39d24, 0xff9e1f, 0xff9e1b, 0xf6a31f, 0xffaf38, 0xf29d1e, 0xffae44, 0xffb775, 0xf1b85e, 0xffde73, 0x9e7e43, 0x080000, 0xb97b24, 0x9c7625, 0x000703, 0x26202a, 0xc7a776, 0xffdf78, 0xffc74b, 0xf2b45f, 0xffc26a, 0xffbd61, 0xf8bb60, 0xfcc872, 0xfec16e, 0xffab55, 0xffa149, 0xfe9925, 0xf9a52b, 0xfeac2f, 0xef9026, 0x9e5312, 0x391d08, 0x0e0f11, 0x1a1e21, 0x121212, 0x090909, 0x303030, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xc4c4c4, 0x000000, 0x0e1810, 0x141217, 0x11111b, 0x0e100f, 0x502f1c, 0xa14e1a, 0xe98827, 0xfbaf26, 0xffa323, 0xf69c22, 0xfeb242, 0xffc35e, 0xf1b85e, 0xf9bb66, 0xffc16f, 0xffb05f, 0xe5b94c, 0xffe175, 0xffc882, 0x8a6048, 0x000200, 0x271b03, 0xb27640, 0xc78632, 0x240e00, 0x4d2f0d, 0xecc47c, 0xf8c26c, 0xffc378, 0xfcb050, 0xeea324, 0xf7a82f, 0xf89d2a, 0xfba22a, 0xfba72b, 0xf8aa2e, 0xfaaf3c, 0xffbc5a, 0xffc472, 0xffc17c, 0xf7ac59, 0xffd06c, 0xfdda76, 0xc6ae70, 0x493125, 0x140000, 0x432200, 0xb69548, 0xf0ac41, 0xfdaa26, 0xffae44, 0xffc66c, 0xf1d874, 0x6e5b31, 0x0f000e, 0x180d13, 0x291500, 0x06160c, 0x232027, 0x291315, 0x152018, 0x15282f, 0x1d1021, 0x190400, 0x4c584c, 0xe4ede8, 0x36393e, 0x100d18, 0xc6bbc3, 0xfffbf4, 0xfff5dc, 0xfff7d3, 0xf3ba6d, 0xf3d5a1, 0xfff3df, 0xfff1bc, 0xe3bb63, 0x5c381e, 0x040015, 0x394d42, 0xfcfcfc, 0xe3e3e3, 0xb8b8b8, 0xf4f4f4, 0x6a6a6a, 0x000000, 0xb7b7b7, 0xf9f9f9, 0xb0b0b0, 0x9d9d9d, 0xf8f8f8, 0xffffff, 0xf4f4f4, 0xf9f9f9, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xf7fffb, 0xf9fffd, 0xfbfffd, 0xfafffb, 0xfdfffc, 0xfefffd, 0xfffffd, 0xfffffb, 0xf9fffd, 0xebf4ef, 0xfbfffd, 0xfcfffd, 0xeaefeb, 0xfefffd, 0xf6f6f4, 0x797977, 0x070506, 0x100e0f, 0x1d1b1c, 0x232122, 0x1f1d1e, 0x1c1a1b, 0x1c1a1b, 0x1b191a, 0x1b201c, 0x000200, 0x838786, 0xfcffff, 0xfcffff, 0xf9fdff, 0xf6f9fe, 0xfcffff, 0xffffff, 0xffffff, 0xfafafa, 0xfdfdfb, 0xfffffd, 0xfffffb, 0xfffffa, 0xf9faf4, 0xf7f6fb, 0xfffeff, 0xfffeff, 0xfefdff, 0xfcfbff, 0xfdfcff, 0xfffeff, 0xfcfbff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xfbfbfb, 0x989898, 0xbcbcbc, 0xfefefe, 0x989898, 0x101010, 0x7e7e7e, 0xf6f6f6, 0xb2b2b2, 0xf3ebe8, 0xfffffa, 0x48474f, 0x080000, 0x695121, 0xe1c57c, 0xf9e1b3, 0xfffbef, 0xf7ca8f, 0xebc596, 0xffeacf, 0xfff9ef, 0xfffdfd, 0xababab, 0x1f211c, 0x43463d, 0xe6e4e5, 0x4a4849, 0x030000, 0x272226, 0x1e191d, 0x111015, 0x191a1e, 0x13171a, 0x121912, 0x1d1d13, 0x161010, 0x060000, 0x725d3e, 0xf7ce7f, 0xffc868, 0xffb964, 0xf3a716, 0xedb033, 0xa87f2f, 0x331e03, 0x0a0004, 0x503b36, 0xcaa76d, 0xffe478, 0xfabd52, 0xfec05d, 0xf4b45a, 0xfab663, 0xffc26d, 0xffac4c, 0xee9628, 0xfda029, 0xf9a32c, 0xf9a427, 0xfba627, 0xf9a33c, 0xfeb15f, 0xffc966, 0xf5c966, 0xecc486, 0x352213, 0x2b1800, 0xc1833a, 0xb56c27, 0x100000, 0x0c0610, 0x82603a, 0xf3d178, 0xffdc7d, 0xf6b454, 0xffb85a, 0xffc875, 0xf0b46c, 0xf4b86f, 0xffc870, 0xffaa45, 0xff9a26, 0xf9a52b, 0xffad30, 0xf09127, 0xa25716, 0x3e220d, 0x0f1012, 0x171b1e, 0x242424, 0x070707, 0x141414, 0xd0d0d0, 0xffffff, 0xfbfbfb, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xf9f9f9, 0xffffff, 0x909090, 0x040404, 0x1c261e, 0x252328, 0x191923, 0x0a0c0b, 0x51301d, 0xa6531f, 0xf49332, 0xffb42b, 0xffa12f, 0xfda333, 0xfcaf45, 0xffc15d, 0xffc265, 0xfaba60, 0xfeb75f, 0xffb961, 0xffe682, 0xdfb85d, 0x5f3a1f, 0x030017, 0x151811, 0xb17831, 0xd4843b, 0x472f0d, 0x150000, 0xb99f4b, 0xffda7b, 0xf9b979, 0xffbf6e, 0xf8a837, 0xffb43e, 0xf7a130, 0xfda22f, 0xf7a02d, 0xf5a131, 0xffb145, 0xffc35d, 0xffc263, 0xfbba60, 0xfbbb64, 0xffd361, 0xf7d47a, 0xafa275, 0x201f1a, 0x070004, 0x4c270d, 0xda943f, 0xffbe3a, 0xf9af34, 0xfeb451, 0xffb670, 0xffc972, 0xe6c965, 0x4b3e1c, 0x0b0009, 0x553526, 0x976028, 0x16180a, 0x101727, 0x140d15, 0x15241f, 0x122021, 0x251a22, 0x11060a, 0x000200, 0x585753, 0x3e3b42, 0x03000b, 0x3f3744, 0xfef5f8, 0xfffdf4, 0xfef7e5, 0xffe1cc, 0xe2cd8a, 0xfff4e2, 0xfffbf4, 0xfce693, 0xad8552, 0x19000f, 0x000800, 0xb0b0b0, 0xffffff, 0xfafafa, 0xffffff, 0xf1f1f1, 0x828282, 0x9c9c9c, 0xfafafa, 0x757575, 0x0a0a0a, 0x8b8b8b, 0xfdfdfd, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xfdfdfd, 0xfafafa, 0xfdfdfd, 0xffffff, 0xffffff, 0xfafafa, 0xfbfbfb, 0xffffff, 0xfbfffb, 0xfafffc, 0xfcffff, 0xf7fbfc, 0xf4f5f9, 0xfcfbff, 0xfffdff, 0xfdfaff, 0xf4fffb, 0xf5fffb, 0xf0fff6, 0xf3fff7, 0xf8fffb, 0xf5fff7, 0x919b93, 0x020902, 0x0a1a10, 0x0b1b11, 0x08180e, 0x06160c, 0x08180e, 0x08180e, 0x09190f, 0x0c1c12, 0x141611, 0x030500, 0x1c211b, 0x999e9a, 0xfbffff, 0xf9ffff, 0xf7ffff, 0xf7ffff, 0xfffeff, 0xfffeff, 0xfffeff, 0xffffff, 0xfcfcfe, 0xf6f6f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfd, 0xffffff, 0xffffff, 0xfefeff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf4f4f4, 0xfefefe, 0xffffff, 0xe6e6e6, 0x808080, 0x010101, 0x999999, 0xfbfbfb, 0x8f8f8f, 0x7d7d7d, 0xfbfbfb, 0xffffff, 0xf6f6f6, 0xfffeff, 0x8c8f86, 0x050010, 0x0f0000, 0xb29f50, 0xffe7ae, 0xfff4f2, 0xfffbe2, 0xe5cda7, 0xfeebcd, 0xfffded, 0xfffefa, 0xefeff1, 0x3a3c3b, 0x000100, 0x4b4b41, 0x474143, 0x030000, 0x1e1c1d, 0x242527, 0x080c0f, 0x1c2127, 0x161d25, 0x121923, 0x25201c, 0x82612b, 0x593709, 0x030005, 0x494441, 0xf3c977, 0xffc657, 0xffc376, 0xf5b039, 0xfeb322, 0xffb927, 0xcb8e33, 0x472313, 0x0a0009, 0x3a2d1d, 0xb1a163, 0xffe271, 0xf4c45e, 0xfac16a, 0xffc37b, 0xffb66f, 0xffb567, 0xffba60, 0xeeaa47, 0xf49a39, 0xf9a521, 0xffaf32, 0xf4a03d, 0xf9af46, 0xffcc5f, 0xf2bc64, 0xffd58e, 0xae895d, 0x020204, 0x5c2d11, 0xeb8129, 0xab622d, 0x22091c, 0x07000b, 0x555637, 0xebc36e, 0xffd377, 0xffc464, 0xfcb563, 0xfdb978, 0xffc07d, 0xfcbf64, 0xefb03e, 0xff9c28, 0xf9a52b, 0xffaf32, 0xf29329, 0xa85d1c, 0x462a15, 0x101113, 0x13171a, 0x171717, 0x191919, 0x141414, 0x939393, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfefefe, 0xffffff, 0xf9f9f9, 0x4b4b4b, 0x000000, 0x000400, 0x141217, 0x20202a, 0x0d0f0e, 0x563522, 0xab5824, 0xf29130, 0xefa31a, 0xfe9d36, 0xfba23c, 0xfdaf4b, 0xffbf5e, 0xfec164, 0xf8bd63, 0xffc26b, 0xffd07c, 0xd2b37c, 0x553216, 0x000100, 0x2a3223, 0xb7793c, 0xe08323, 0x653a03, 0x00001b, 0x876549, 0xffdf78, 0xf3c565, 0xffc581, 0xfaaf4a, 0xffae44, 0xfaa147, 0xe9941d, 0xf8a130, 0xf7a237, 0xffb34f, 0xffc86b, 0xffc66e, 0xf7ba61, 0xf6bf65, 0xffd175, 0xefe46e, 0x8d8053, 0x14061d, 0x0c000f, 0x503903, 0xe4b13c, 0xffbb3b, 0xff9123, 0xfaa933, 0xffc780, 0xf3b57a, 0xffd275, 0xdfbc6b, 0x21140c, 0x0f0000, 0xb48446, 0xed9f4d, 0x28200d, 0x000919, 0x111217, 0x131f1f, 0x101916, 0x201615, 0x22202d, 0x241d15, 0x060000, 0x1d161d, 0x17111f, 0x01000c, 0xa4a2ad, 0xfffeff, 0xfeffff, 0xfffafb, 0xfae4cd, 0xfff3db, 0xf5f5eb, 0xfff9dc, 0xe5be83, 0x513506, 0x000200, 0x2c2c2c, 0xdedede, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xefefef, 0xffffff, 0xc7c7c7, 0x040404, 0x000000, 0x505050, 0xc6c6c6, 0xffffff, 0xf2f2f2, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xf8f8f8, 0xf7f7f7, 0xffffff, 0xffffff, 0xfafafa, 0xfcfffb, 0xfcfffd, 0xfcffff, 0xfeffff, 0xfffeff, 0xfffdff, 0xfffcff, 0xfffbff, 0xf2f9f2, 0xfbfffb, 0xfbfffb, 0xfbfffa, 0xebede8, 0x868782, 0x1b1c17, 0x020100, 0x4d2f2f, 0x442626, 0x351717, 0x341616, 0x422424, 0x432525, 0x381a1a, 0x311313, 0x423431, 0x493e3a, 0x0e0402, 0x261e1c, 0x97928f, 0xe6e2e1, 0xfffeff, 0xffffff, 0xfffeff, 0xfbf9fc, 0xfcfaff, 0xfffeff, 0xfffdff, 0xfffdff, 0xfffdff, 0xf4f1fa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfafafa, 0xfcfcfc, 0xfefefe, 0xfefefe, 0xffffff, 0xf6f6f6, 0xfefefe, 0xffffff, 0xb7b7b7, 0x383838, 0x000000, 0x080808, 0xcfcfcf, 0xffffff, 0xeaeaea, 0xffffff, 0xffffff, 0xececec, 0xffffff, 0xd1dad9, 0x2c2c38, 0x07000c, 0x574726, 0xdfcf81, 0xfffad7, 0xfff9ff, 0xe6e1ce, 0xfef7e7, 0xfffdf1, 0xf8faf5, 0xfbffff, 0x8c9195, 0x000002, 0x130f0c, 0x201b15, 0x060000, 0x151112, 0x2c2e2d, 0x0c1212, 0x182022, 0x192124, 0x02060f, 0x11131f, 0x2d1d1d, 0xedb254, 0xb4771a, 0x090003, 0x272c3f, 0xe6bf72, 0xffc550, 0xf9c079, 0xffc767, 0xf4a936, 0xfea620, 0xffc23b, 0xdea33b, 0x593a01, 0x0a0000, 0x100c1d, 0xb09c5f, 0xeccf8d, 0xffdc91, 0xfbbe6d, 0xfcb962, 0xffc772, 0xffc573, 0xf0b565, 0xf99c4f, 0xf7a420, 0xee9b23, 0xe08f33, 0xf9b23c, 0xf9ba46, 0xfec06d, 0xf7bc6e, 0xffda8a, 0x6e4f3a, 0x00000e, 0x673e22, 0xf28131, 0xb25f2d, 0x2b2225, 0x00020b, 0x5d481d, 0xd7b877, 0xffda82, 0xfcbf64, 0xffbe6d, 0xffc274, 0xffc063, 0xf6bd4c, 0xff9d29, 0xf9a52b, 0xffb033, 0xf3942a, 0xac6120, 0x4d311c, 0x111214, 0x101417, 0x1a1a1a, 0x141414, 0x000000, 0x545454, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xf8f8f8, 0xf8f8f8, 0xaeaeae, 0x060606, 0x121212, 0x3b453d, 0x161419, 0x171721, 0x0c0e0d, 0x5d3c29, 0xab5824, 0xf1902f, 0xf8ac23, 0xfe9e3a, 0xef9632, 0xffb755, 0xffc567, 0xebb35c, 0xfecd7e, 0xffd791, 0xcfa25f, 0x272624, 0x060005, 0x4b3d22, 0xba8330, 0xe1812a, 0x6f3706, 0x060000, 0x44353a, 0xf3cb8e, 0xf4cc6c, 0xf7c16b, 0xffc266, 0xf9b33a, 0xee9d4c, 0xa04c0e, 0xe29918, 0xfead44, 0xffba56, 0xffc86c, 0xffbf6b, 0xedb465, 0xf9c87b, 0xffdd8f, 0xfdd687, 0x637140, 0x060000, 0x150000, 0x87562d, 0xfbbf45, 0xf6ae0a, 0xfda71e, 0xff9d40, 0xffb656, 0xffc78c, 0xe6b569, 0xffe17c, 0xb29164, 0x0b0009, 0x4d2f13, 0xf8bd47, 0xdf8f3a, 0x190c00, 0x0e1618, 0x403c31, 0x101518, 0x1c2021, 0x1b140c, 0x1b1d2a, 0x221914, 0x2a201f, 0x140e12, 0x251f29, 0x050310, 0x363642, 0xf4f8ff, 0xfbffff, 0xfcfbff, 0xfff8ff, 0xfffbe1, 0xf3feed, 0xfffbff, 0xffecb9, 0x9f8838, 0x070008, 0x000000, 0x6a6a6a, 0xf3f3f3, 0xffffff, 0xececec, 0xfefefe, 0xffffff, 0xffffff, 0xfafafa, 0x979797, 0x545454, 0x424242, 0xa5a5a5, 0xf9f9f9, 0xf6f6f6, 0xf9f9f9, 0xffffff, 0xf7f7f7, 0xf6f6f6, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xf8fdf9, 0xf9fbfa, 0xf6f8f7, 0xffffff, 0xfffeff, 0xd8d3da, 0x9c96a0, 0x7c7680, 0x615755, 0x504644, 0x4c413f, 0x4d4240, 0x372928, 0x0d0000, 0x0d0000, 0x2d1b1b, 0x441f19, 0x46211b, 0x47221c, 0x56312b, 0x6b4640, 0x6b4640, 0x59342e, 0x4e2923, 0x442221, 0x381819, 0x240606, 0x120000, 0x130000, 0x3e2b2d, 0x5c4e4e, 0x544548, 0x4f4b4a, 0x555150, 0x837f80, 0xaca7ab, 0xd5d0d6, 0xfef9ff, 0xfffcff, 0xfffcff, 0xf4f4f4, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0x8f8f8f, 0x434343, 0x555555, 0xa0a0a0, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xededed, 0xffffff, 0xf4f4f4, 0x3f4d3e, 0x00001e, 0x0c0004, 0xa79a63, 0xfff6c9, 0xfffded, 0xfff8f1, 0xfffafe, 0xfcffff, 0xf7fdfd, 0xf7ffff, 0xe1ecf0, 0x1f292b, 0x000102, 0x292524, 0x130908, 0x2a2220, 0x1d1918, 0x141817, 0x101918, 0x1e2726, 0x151716, 0x35312e, 0x100604, 0x16050b, 0xfbb448, 0xf7aa2a, 0x37230b, 0x000316, 0xb6985c, 0xffd96e, 0xf3bd73, 0xfcc471, 0xfabb6e, 0xeca048, 0xf09b1e, 0xffba24, 0xf3b335, 0x7a5923, 0x060005, 0x080000, 0x86745c, 0xf5d799, 0xffdb7b, 0xf4c052, 0xf4b951, 0xfebe67, 0xffc379, 0xffb471, 0xf2a62c, 0xd38a1b, 0xa35904, 0xe7a534, 0xf6b743, 0xffc16a, 0xffc16a, 0xffcc7a, 0xe9b56c, 0x363729, 0x000113, 0x793812, 0xde7b20, 0x9f6c2a, 0x3b2a18, 0x060000, 0x4b4024, 0xc8b16e, 0xffe689, 0xfec463, 0xfeb859, 0xffcb6d, 0xffbb5b, 0xff9e2a, 0xf8a42a, 0xffb033, 0xf09127, 0xab601f, 0x513520, 0x111214, 0x0e1215, 0x121212, 0x373737, 0x000000, 0x070707, 0xbdbdbd, 0xf2f2f2, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfdfdfd, 0xf6f6f6, 0xbbbbbb, 0x7b7b7b, 0xd0d0d0, 0xcbd5cd, 0x323035, 0x10101a, 0x090b0a, 0x5d3c29, 0x9f4c18, 0xe1801f, 0xffb62d, 0xfe9d34, 0xfca33b, 0xffb853, 0xffc469, 0xfdcf82, 0xfbdb9e, 0xb0996d, 0x372501, 0x000315, 0x20281b, 0xb76d2e, 0xe4690c, 0x763e0d, 0x000113, 0x19110f, 0xddb45c, 0xffcf7b, 0xf3be6e, 0xffc26f, 0xf7b94a, 0xffc251, 0xa35e1d, 0x7a3800, 0xf1ba43, 0xffc161, 0xffc668, 0xfec069, 0xebb764, 0xf7cb82, 0xffe4a4, 0xccaf77, 0x654b18, 0x000010, 0x311d02, 0x94650d, 0xffbb3b, 0xffae25, 0xf8a022, 0xeea232, 0xffcd64, 0xffc372, 0xfaba7d, 0xfacd72, 0xffe282, 0x5c4233, 0x110005, 0xa67b36, 0xffd137, 0xb47937, 0x080000, 0x504a32, 0x988158, 0x161014, 0x161a25, 0x1b170c, 0x191921, 0x120d0a, 0x292323, 0x1b1718, 0x29272a, 0x100f14, 0x000005, 0xa8abb0, 0xf6fbff, 0xf6f1ff, 0xfffdff, 0xfefff2, 0xf9ffff, 0xfbfaff, 0xffffdc, 0xe7d7a4, 0x322223, 0x030303, 0x000000, 0x777777, 0xf5f5f5, 0xffffff, 0xffffff, 0xf5f5f5, 0xf8f8f8, 0xfbfbfb, 0xffffff, 0xffffff, 0xeeeeee, 0xfbfbfb, 0xffffff, 0xffffff, 0xfafafa, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xd8d8d8, 0xa8a8a8, 0x8b8b8b, 0x858585, 0xa5a6a8, 0xb3b4b6, 0xababab, 0x7a7977, 0x393532, 0x0b0803, 0x040000, 0x070200, 0x110000, 0x0d0000, 0x1f0b0a, 0x2b1615, 0x2c1716, 0x402828, 0x482e2f, 0x3c2223, 0x201a04, 0x221c06, 0x221c06, 0x211b05, 0x221c06, 0x201a04, 0x1e1802, 0x1f1903, 0x350b0c, 0x370f0f, 0x522e2e, 0x4e302e, 0x3f2725, 0x372322, 0x1f0f0f, 0x190b0a, 0x0e0a00, 0x040000, 0x040000, 0x040000, 0x0b0507, 0x3d363d, 0x807981, 0xaaa2ad, 0xbabab8, 0x979795, 0x828280, 0x8f8f8d, 0xb9b9b7, 0xe3e3e1, 0xf8f8f6, 0xfffffd, 0xffffff, 0xfdfdfd, 0xfafafa, 0xfafafa, 0xf6f6f6, 0xf7f7f7, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfafafa, 0xf9f9f9, 0xeeeeee, 0xffffff, 0xffffff, 0x696969, 0x000700, 0x01001b, 0x4f4138, 0xf3e7b5, 0xfffdf1, 0xfdfaf3, 0xf5f4e0, 0xfff9ff, 0xf7faff, 0xf9ffff, 0xf8ffff, 0x939ea0, 0x000304, 0x1e2223, 0x1c171b, 0x20171a, 0x17120e, 0x181816, 0x171d1d, 0x151d1f, 0x0e100d, 0x20180d, 0xa08b78, 0x43250d, 0x0a000d, 0xc2841f, 0xffc737, 0x906926, 0x030000, 0x665634, 0xffdf91, 0xfbc471, 0xf6bf6f, 0xf7c27c, 0xf7bb73, 0xf0a144, 0xfa9a22, 0xffb638, 0xe8ae43, 0x967724, 0x160004, 0x120000, 0x66501e, 0xdac16d, 0xffdd79, 0xf5c561, 0xfbbe63, 0xffc474, 0xffc27e, 0xffbe56, 0xeaaa49, 0x753700, 0xaf741a, 0xfdc357, 0xf8b751, 0xffc568, 0xf3c184, 0xffe07d, 0xc89f47, 0x110d04, 0x000519, 0x8c5a25, 0xca6902, 0xa96a23, 0x21111b, 0x070000, 0x363010, 0xbba969, 0xffdf87, 0xffce6c, 0xffb85c, 0xffb35f, 0xff9f2b, 0xf7a329, 0xffaf32, 0xeb8c22, 0xa75c1b, 0x513520, 0x101113, 0x0d1114, 0x373737, 0xdadada, 0xc5c5c5, 0x737373, 0xc2c2c2, 0xffffff, 0xffffff, 0xf2f2f2, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xf2f2f2, 0xffffff, 0xc8d2ca, 0x0c0a0f, 0x070711, 0x0b0d0c, 0x5f3e2b, 0xa5521e, 0xdd7c1b, 0xffb32a, 0xfd9c29, 0xffad3d, 0xffb751, 0xffcb72, 0xf7d492, 0xa3946b, 0x2d2b1c, 0x000200, 0x201911, 0x70501d, 0xcc742a, 0x9b4514, 0x070000, 0x000b19, 0xa2845e, 0xffe470, 0xf5bb69, 0xffc87b, 0xfabc57, 0xf2b648, 0xd89b4b, 0x683200, 0xb68c36, 0xf5d179, 0xf9bb66, 0xf6be67, 0xf3c46c, 0xfbd582, 0xf6d892, 0xb39d6b, 0x4a391b, 0x0d0000, 0x5e3322, 0xc28e42, 0xffcc40, 0xfca70e, 0xf79820, 0xfba34a, 0xffc36c, 0xf6c55f, 0xffc26f, 0xfcb776, 0xffdd7f, 0xbeae61, 0x160808, 0x4d2c1b, 0xe6b13f, 0xffc625, 0x7b5d39, 0x040000, 0xa7905c, 0xd1a25c, 0x1c090d, 0x060b1f, 0x211f12, 0x1f1e1c, 0x222325, 0x1d1f1e, 0x181a17, 0x10110c, 0x1f201b, 0x030400, 0x3a3a38, 0xffffff, 0xfff8ff, 0xfcfff8, 0xf3fefa, 0xfcfeff, 0xf5f6f0, 0xfefff3, 0xfffef6, 0xa08981, 0x070707, 0x080808, 0x090909, 0x969696, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfbfbfb, 0xffffff, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xf3f3f3, 0xaaaaaa, 0x484848, 0x0b0b0b, 0x010101, 0x040404, 0x000000, 0x03020a, 0x000004, 0x020001, 0x010000, 0x030100, 0x312e1d, 0x4b4630, 0x28240b, 0x0d0400, 0x100501, 0x1b100c, 0x20120f, 0x2d1e1b, 0x3e2c2a, 0x402e2c, 0x463231, 0x5d3929, 0x5a3626, 0x573323, 0x4f2b1b, 0x462212, 0x482414, 0x522e1e, 0x593525, 0x593c36, 0x593e37, 0x48312b, 0x301f17, 0x372d24, 0x322e25, 0x121208, 0x10130a, 0x040200, 0x141100, 0x2f2c1d, 0x4e4a3f, 0x25201c, 0x040000, 0x090305, 0x080206, 0x000100, 0x000100, 0x070803, 0x000100, 0x000100, 0x13140f, 0x5a5b56, 0xa2a39e, 0xffffff, 0xf8f8f8, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0x818181, 0x000000, 0x0a1318, 0x0d0a03, 0xa99c89, 0xfff9ed, 0xfffeff, 0xfbfff8, 0xfffff6, 0xfffaff, 0xfefcff, 0xfeffff, 0xebf1f1, 0x333e3a, 0x000300, 0x25292a, 0x131017, 0x221821, 0x1b180f, 0x161815, 0x0d1517, 0x13181c, 0x17140f, 0x230e00, 0xd0a884, 0xa57141, 0x050318, 0x865b0d, 0xffc634, 0xe6ad3c, 0x3b2b0a, 0x1d1a11, 0xcab07f, 0xffd071, 0xfbc376, 0xf2b968, 0xffc672, 0xffc572, 0xf6a24a, 0xea972f, 0xfbae2e, 0xffbd28, 0xc18a51, 0x582d00, 0x180000, 0x4a3b12, 0xcab886, 0xf9da99, 0xf3c16c, 0xfdbf5c, 0xffc074, 0xffc978, 0xffd07d, 0xa4712f, 0x723c00, 0xdba543, 0xf1b53d, 0xf9b554, 0xffd192, 0xf8cb70, 0xffdf72, 0xa68649, 0x000810, 0x150a10, 0x984a19, 0xce721f, 0x744b2d, 0x1b0400, 0x030005, 0x302d24, 0xbba677, 0xffd785, 0xf8bd63, 0xfdbb65, 0xff9f2b, 0xf7a329, 0xffae31, 0xe6871d, 0xa15615, 0x4f331e, 0x101113, 0x0f1316, 0x0b0b0b, 0xdbdbdb, 0xffffff, 0xf7f7f7, 0xf9f9f9, 0xfbfbfb, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0xffffff, 0xf4f4f4, 0xa8b2aa, 0x010004, 0x1e1e28, 0x101211, 0x502f1c, 0xa5521e, 0xdf7e1d, 0xf6aa21, 0xff9f24, 0xf29923, 0xffbf54, 0xffe08a, 0xb99a61, 0x251f05, 0x000405, 0x051c2e, 0x5d2c01, 0xcf722f, 0x83480c, 0x070e06, 0x090d18, 0x856c44, 0xffde8c, 0xfcc173, 0xffbf78, 0xffbe6d, 0xf5b93f, 0xeeb34d, 0x8d5021, 0x673d00, 0xf4da69, 0xe7cd94, 0xf8c171, 0xf6c46f, 0xfbd27a, 0xf8da84, 0xa4904b, 0x170800, 0x080000, 0x6e6568, 0xf6ac41, 0xffb640, 0xfaa727, 0xf39e1f, 0xfeac3c, 0xffbf61, 0xfcbd70, 0xf9c37d, 0xf9c267, 0xffbe79, 0xffcd77, 0x6a6428, 0x030002, 0x9e7a4a, 0xffc432, 0xf2ad12, 0x2e2717, 0x000000, 0xe4c27b, 0xd5983f, 0x1b0104, 0x050a27, 0x292a1c, 0x18150c, 0x11191b, 0x161c1c, 0x1a1f19, 0x11140b, 0x1d1f14, 0x16160c, 0x070400, 0xd6d3cc, 0xfff9fd, 0xf8fffd, 0xebfafd, 0xfffeff, 0xfffffa, 0xecfcfc, 0xfcffff, 0xffefe8, 0x323232, 0x0e0e0e, 0x090909, 0x060606, 0x747474, 0xfefefe, 0xffffff, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xffffff, 0xfdfdfd, 0x898989, 0x262626, 0x0a0a0a, 0x505050, 0x676767, 0x262626, 0x030303, 0x1e1e1e, 0x1b1924, 0x100f15, 0x1d1b1c, 0x120f08, 0x1e1b0a, 0x99987c, 0xfbf8d7, 0xdfddb7, 0xa2a499, 0x3a3c31, 0x010100, 0x0d0d03, 0x201d14, 0x1b170e, 0x100901, 0x19120a, 0x401505, 0x421707, 0x4f2414, 0x5a2f1f, 0x5b3020, 0x5c3121, 0x592e1e, 0x502515, 0x322215, 0x25190b, 0x1c1407, 0x1a180b, 0x12180a, 0x0f1c0b, 0x081a0a, 0x000800, 0x504f33, 0xa2a089, 0xd6d4bf, 0xfefbec, 0x959186, 0x0f0a06, 0x1f1919, 0x191315, 0x1b1c17, 0x1b1c17, 0x13140f, 0x0d0e09, 0x383934, 0x696a65, 0x4c4d48, 0x141510, 0x202020, 0xa7a7a7, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfcfcfc, 0xe8e8e8, 0x727272, 0x010101, 0x141414, 0x000019, 0x4b4d1e, 0xfffee6, 0xfff5ff, 0xfcffff, 0xecf9e8, 0xf8f8ff, 0xfff3fa, 0xfffcff, 0xfffefd, 0xc0c2bf, 0x000300, 0x111a15, 0x131718, 0x27242d, 0x1b1320, 0x202215, 0x161b17, 0x182023, 0x191c21, 0x1f1611, 0x210300, 0xdeaa7a, 0xe6a565, 0x000019, 0x634509, 0xf6af1f, 0xffc73b, 0x8a6f3a, 0x000009, 0x7c6d50, 0xffd973, 0xfac077, 0xffc26b, 0xffbf5f, 0xffba5a, 0xf2b55a, 0xefaf4b, 0xf9a529, 0xff9e0b, 0xffbf3d, 0xe7aa4d, 0x7a572f, 0x0b0000, 0x170d0e, 0xa49171, 0xffde8e, 0xfdcb5a, 0xf8be6c, 0xf0b976, 0xfece82, 0xfed094, 0x531f00, 0x9d6a0f, 0xf2bc38, 0xf4b04d, 0xffb965, 0xffbf75, 0xefce81, 0xf5d77d, 0x8f6533, 0x060017, 0x2a132d, 0xaa480b, 0xb17127, 0x57311c, 0x1a1033, 0x000022, 0x241b12, 0xc6aa69, 0xffe68e, 0xefba5e, 0xff9f2b, 0xf6a228, 0xffad30, 0xe28319, 0x9d5211, 0x4d311c, 0x0f1012, 0x101417, 0x0b0b0b, 0xc0c0c0, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xa3afab, 0x040005, 0x201921, 0x080b04, 0x564325, 0x98531a, 0xca670c, 0xffac34, 0xfba82e, 0xe7991d, 0xffe77f, 0xc8ad76, 0x191919, 0x00000e, 0x240a00, 0x5d2900, 0xcd6e2e, 0x77402b, 0x160f17, 0x000200, 0x705937, 0xffcc90, 0xffcd7f, 0xfbc064, 0xffcd82, 0xeda14d, 0xffbd3d, 0xb27910, 0x2b1100, 0xc1b58d, 0xffdc8a, 0xffb37d, 0xf2bc64, 0xffe783, 0xe2d680, 0x6d6743, 0x0b0000, 0x3d1901, 0xca923b, 0xffbc30, 0xffaa19, 0xffa521, 0xea9d2b, 0xf3b153, 0xffc674, 0xfcc374, 0xfcc171, 0xfbbd6a, 0xf1c365, 0xffde75, 0xcfac72, 0x070000, 0x3e2b03, 0xffd04d, 0xeaa81c, 0xcfa455, 0x00011c, 0x685836, 0xffe55d, 0xb29426, 0x0c010f, 0x0d1c31, 0x141d08, 0x1e0b1f, 0x090d0e, 0x222631, 0x050f07, 0x181e1a, 0x24253a, 0x161616, 0x0c0900, 0x332637, 0xc4c4c4, 0xfefefe, 0xfcfcfc, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xfefefe, 0xe5e5e5, 0x0b0b0b, 0x181818, 0x080808, 0x070707, 0x242424, 0x888888, 0xffffff, 0xfffff6, 0xfefffa, 0xf2f8f8, 0xf8ffff, 0xf9ffff, 0xfefeff, 0xc3bec2, 0x4a3f43, 0x110000, 0x856c44, 0xe0c389, 0xffe7a6, 0xf9dca4, 0x5f4c2c, 0x463c3a, 0x090617, 0x151b0d, 0x1c211a, 0x171c1f, 0x0f1217, 0x130f0c, 0xd7ccba, 0xffedc9, 0xffe8b8, 0xfff4ce, 0xfff4d3, 0xa8a187, 0x101101, 0x0d120b, 0x000904, 0x000501, 0x101710, 0x131a24, 0x0c131d, 0x0f1620, 0x0a111b, 0x101721, 0x0f1620, 0x000610, 0x0f1620, 0x15121b, 0x1f1c23, 0x181619, 0x010000, 0x030300, 0x111204, 0x181909, 0xa4a593, 0xffeec8, 0xffeec6, 0xffecc1, 0xfff5cb, 0xbeb898, 0x080600, 0x171918, 0x1a1e29, 0x142020, 0x151a20, 0x0c0910, 0x453c2d, 0x6f5e33, 0xffedad, 0xffe2a2, 0xf7d097, 0x684d3a, 0x1b0500, 0x554747, 0xdfdae1, 0xf6f9ff, 0xfbffff, 0xf9fef8, 0xfdfff5, 0xffffff, 0xffffff, 0xf4f4f4, 0x888888, 0x161616, 0x060606, 0x202020, 0x000000, 0x202020, 0xf7f7f7, 0xfdfdfd, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xf8fde7, 0xbbbac8, 0x222036, 0x070a00, 0x192207, 0x131812, 0x212429, 0x131812, 0x1e1c29, 0x030c1d, 0x181100, 0x23210a, 0x001b2e, 0x0d1506, 0xbe8d2e, 0xffde63, 0x2a4944, 0x110000, 0xe39a67, 0xf7b217, 0xedc52f, 0x341618, 0x1f042d, 0xcdc16f, 0xffd374, 0xffbf7d, 0xffb87d, 0xffc76f, 0xffcd6c, 0xf6b966, 0xfda94f, 0xff9822, 0xff9912, 0xffaf19, 0xffc636, 0xb88c2b, 0x341300, 0x120000, 0x7d6f55, 0xeee8ae, 0xffd964, 0xffc261, 0xfbba54, 0xffd898, 0xbaa89c, 0x1e1500, 0xbe9b1d, 0xfcac4b, 0xffa044, 0xffca7a, 0xe9ba5e, 0xfbda69, 0xffd982, 0x6c4130, 0x0d0013, 0x13173c, 0x8f4916, 0xa3703b, 0x3e2600, 0x191814, 0x000019, 0x20151b, 0xd9b67e, 0xffe272, 0xf6a113, 0xff9d2d, 0xffa82e, 0xc06d03, 0x8e5730, 0x453221, 0x0d1100, 0x0e1726, 0x000000, 0xc0c0c0, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xc1cdc9, 0x110a11, 0x181119, 0x060803, 0x49381c, 0x9b5823, 0xc06009, 0xffa12d, 0xf7a41a, 0xffb943, 0xe1b165, 0x4f3a1f, 0x000007, 0x16141f, 0x352414, 0x7c5b30, 0x613705, 0x2f0b19, 0x0f000e, 0x635026, 0xe8ca74, 0xffd088, 0xf3bd7f, 0xfbcd78, 0xf9a94a, 0xffcd3e, 0xc99b46, 0x200000, 0x7a6933, 0xfff294, 0xf7c677, 0xfdba6b, 0xfde38c, 0xddc683, 0x604b30, 0x140000, 0x745419, 0xebbf44, 0xffbd3b, 0xfba140, 0xfa9f1a, 0xfaa62c, 0xfdb24c, 0xffc06a, 0xffc477, 0xffc478, 0xffc374, 0xffc06c, 0xfcc956, 0xffe39f, 0x594b3e, 0x130200, 0xb48533, 0xfab323, 0xffd763, 0x735c30, 0x121015, 0xcbb373, 0xffe061, 0x82620d, 0x0d060d, 0x0e1a30, 0x191e18, 0x352025, 0x312f20, 0x0e0a19, 0x1d1e19, 0x040700, 0x151419, 0x1d1c22, 0x15150d, 0x100a14, 0x000000, 0x565656, 0xa7a7a7, 0xe2e2e2, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xb3b3b3, 0x000000, 0x262626, 0x101010, 0x050505, 0x0a0a0a, 0x323232, 0x98988e, 0xd4d7d0, 0xfbffff, 0xf9ffff, 0xbdc2c8, 0x7c7d82, 0x241e20, 0x070000, 0xb09979, 0xf0d3a9, 0xffe0a5, 0xfcd997, 0xf1d198, 0x8a7351, 0x574a44, 0x0c0612, 0x191d0f, 0x10150f, 0x131919, 0x101417, 0x0e0d09, 0x9f9685, 0xfffedc, 0xf2dbaf, 0xead1a9, 0xfff0cf, 0xf5e9cf, 0x6f6c5b, 0x000200, 0x3a3d36, 0x42453e, 0x000100, 0x15191c, 0x000407, 0x070b0e, 0x101417, 0x0e1215, 0x171b1e, 0x14181b, 0x000205, 0x150f13, 0x130d11, 0x060000, 0x524d49, 0x474338, 0x040100, 0x7f7c69, 0xffffed, 0xf8dab6, 0xfce3bb, 0xeedbb1, 0xfffbd6, 0x989175, 0x070500, 0x181a19, 0x13161f, 0x131c1b, 0x13131b, 0x1d161d, 0x56483b, 0x887249, 0xf1d498, 0xefcb8d, 0xf5ca95, 0xffebcd, 0x7e6a52, 0x0a0000, 0x272324, 0x87888d, 0xdadde2, 0xf7fcf8, 0xeff2eb, 0xd0d0d0, 0x929292, 0x262626, 0x0a0a0a, 0x0e0e0e, 0x141414, 0x090909, 0x010101, 0xc4c4c4, 0xfefefe, 0xf8f8f8, 0xf9f9f9, 0xfdfdfd, 0xffffff, 0xdadada, 0x9f9f9f, 0x3c4032, 0x12121c, 0x0b0a1c, 0x111111, 0x202312, 0x1b1d0f, 0x090a04, 0x1e1f1a, 0x0c0d11, 0x34332f, 0x352913, 0x151106, 0x071a2b, 0x0c0f08, 0x916a1f, 0xffce59, 0xb5b18b, 0x150000, 0x946b4d, 0xffd64f, 0xdcac0a, 0xb58346, 0x160000, 0x686345, 0xffe18f, 0xf3be70, 0xffc976, 0xffc66a, 0xfbc56f, 0xffc37a, 0xffc378, 0xffa94c, 0xffa931, 0xfaa12b, 0xeba02b, 0xfabe4c, 0xdeb34d, 0x684800, 0x291000, 0x5c4535, 0xfdd798, 0xfbcd82, 0xf9c27f, 0xfed176, 0xf7da72, 0x805d41, 0x200000, 0xd3ac4d, 0xffbc43, 0xfdb94a, 0xffd481, 0xf5c482, 0xfcd280, 0xe5c669, 0x5c4519, 0x0b0012, 0x2b1100, 0x6e4a2a, 0x7b5236, 0x40251a, 0x080609, 0x020400, 0x5d4b25, 0xe6be79, 0xffae2b, 0xfd9f25, 0xffa22b, 0xc06807, 0x8c5326, 0x3c2618, 0x0f100a, 0x0e1420, 0x131313, 0xd8d8d8, 0xfefefe, 0xfbfbfb, 0xfbfbfb, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xdeebe4, 0x241d24, 0x0e0611, 0x0b100c, 0x3b2d13, 0x995929, 0xb05303, 0xf0952a, 0xffb01e, 0xfabf5b, 0x6c4e28, 0x080002, 0x0d0b18, 0x24201f, 0x423c2e, 0x453f29, 0x030905, 0x0d0013, 0x562721, 0xe2b250, 0xffea72, 0xf9cb8d, 0xf6c791, 0xecc158, 0xffb71f, 0xd6a441, 0x0f0000, 0x1f1714, 0xf2e187, 0xf2c864, 0xfbca85, 0xffe27e, 0xd0d38e, 0x2f1f12, 0x250200, 0x9c7029, 0xf1b837, 0xffb937, 0xfaa026, 0xfc9b19, 0xf0a331, 0xf9b047, 0xffc66d, 0xffc77d, 0xffc17c, 0xffc47d, 0xffc273, 0xffbe6a, 0xffde67, 0xb2a48a, 0x000015, 0x5d3710, 0xffbd3c, 0xffb228, 0xe8c277, 0x1b1809, 0x917454, 0xffec84, 0xe7bb4e, 0x4a2a00, 0x120e0b, 0x091428, 0x050311, 0x6a5540, 0x7c724e, 0x0a000b, 0x362b27, 0x696736, 0x0d0b00, 0x181422, 0x29282e, 0x0a0b0d, 0x151515, 0x040404, 0x000000, 0x272727, 0x6e6e6e, 0xb3b3b3, 0xeaeaea, 0xffffff, 0xf9f9f9, 0xffffff, 0x6c6c6c, 0x000000, 0x1f1f1f, 0x1c1c1c, 0x171717, 0x000000, 0x040100, 0x1e1f1a, 0x2f3334, 0x272f32, 0x0f1418, 0x030207, 0x040000, 0x5f5452, 0xfce0b9, 0xfcdcab, 0xf0ca8c, 0xf5cd88, 0xe8c186, 0x987c57, 0x554337, 0x382d33, 0x272a21, 0x10150f, 0x151b1b, 0x121619, 0x0a0b06, 0x524b3b, 0xfff4d7, 0xf1ddb8, 0xf8dcb5, 0xf1dab8, 0xfffee3, 0xaba492, 0x262417, 0xdfdfd3, 0xe9e7db, 0x8f8b7f, 0x0f0c05, 0x36332c, 0x2c2922, 0x1b1811, 0x1b1811, 0x17140d, 0x232019, 0x2f2c25, 0x241a19, 0x281e1c, 0x857c77, 0xeee5dc, 0xdbd3c6, 0x292212, 0xbab3a0, 0xf3ecd9, 0xf6deba, 0xecd6b1, 0xf7e7c5, 0xf4e9cb, 0x4c4630, 0x080800, 0x191a1c, 0x191c23, 0x151716, 0x28252c, 0x44373e, 0x503c31, 0x967a53, 0xecc991, 0xf7cd93, 0xf6c695, 0xfbe4b0, 0xeedbb3, 0x5f533b, 0x040000, 0x060709, 0x14181b, 0x313234, 0x393b38, 0x151515, 0x080808, 0x000000, 0x161616, 0x161616, 0x1e1e1e, 0x000000, 0x8d8d8d, 0xffffff, 0xf8f8f8, 0xffffff, 0xf5f5f5, 0xa1a1a1, 0x606060, 0x222222, 0x000000, 0x090a0c, 0x040507, 0x181621, 0x28222e, 0x110c06, 0x1a1600, 0x615b45, 0x2c2220, 0x010400, 0x826f4e, 0x634f34, 0x080204, 0x1e1d2b, 0x0a080d, 0x50340c, 0xf9b64d, 0xffeb93, 0x765c4f, 0x271f12, 0xe9d670, 0xf7bc22, 0xffb635, 0x5b3000, 0x01000b, 0xd3b380, 0xffdc84, 0xffcc5f, 0xffc665, 0xfabe75, 0xffc685, 0xffd08f, 0xffbc7b, 0xf8a94d, 0xf9a646, 0xfca637, 0xffad2f, 0xffbd3b, 0xedb347, 0x8e611d, 0x230000, 0x4b2e40, 0xe8d696, 0xfbe18c, 0xe8bb6a, 0xffda74, 0xfdc98d, 0x1c0000, 0x281f16, 0xdca63c, 0xf7bf36, 0xffc65c, 0xfcbc90, 0xfccf8e, 0xfff06a, 0xccaf3a, 0x59280a, 0x000307, 0x200b06, 0x6e3d2e, 0x542b19, 0x292315, 0x09160c, 0x020300, 0x755e4c, 0xfcb948, 0xffb534, 0xfb9622, 0xaf5300, 0x905923, 0x392316, 0x110b19, 0x05060b, 0x282828, 0xf0f0f0, 0xffffff, 0xf9f9f9, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xedf8f0, 0x393337, 0x040008, 0x131c1b, 0x322512, 0x905229, 0xa34b03, 0xe7912e, 0xffc548, 0xa17430, 0x110700, 0x101322, 0x222224, 0x1f190b, 0x34352d, 0x000710, 0x00062a, 0x41231b, 0xd39542, 0xffd553, 0xf5bf5b, 0xf2c38d, 0xffcd80, 0xfabc2d, 0xe0a919, 0x3e1213, 0x140315, 0xbbb16a, 0xffe289, 0xffca7c, 0xfad88e, 0xcdc38e, 0x1b170c, 0x1e0a00, 0xa77d27, 0xffd547, 0xffaa2c, 0xf38e3e, 0xffa03f, 0xf4a201, 0xfbbc5d, 0xffbf68, 0xffc87b, 0xffc37e, 0xfec180, 0xffc37e, 0xfcbe73, 0xffc576, 0xffe68d, 0x3b3734, 0x11040d, 0xd18f39, 0xffad1e, 0xffcf71, 0x87704e, 0x3c361e, 0xffd58c, 0xffd755, 0xb08330, 0x1e0200, 0x13150a, 0x171e31, 0x060013, 0xa69260, 0xb7a670, 0x150008, 0x533b31, 0xeae192, 0x5b5324, 0x070008, 0x191724, 0x222720, 0x1c1c1c, 0x161616, 0x131313, 0x070707, 0x000000, 0x000000, 0x454545, 0xadadad, 0xffffff, 0xffffff, 0xf6f6f6, 0x272727, 0x0a0a0a, 0x161616, 0x252525, 0x202020, 0x181510, 0x0f0e0c, 0x040809, 0x01060a, 0x101417, 0x121011, 0x0b0300, 0x998f86, 0xfddeb0, 0xebc892, 0xebc282, 0xffd491, 0xf0c68c, 0xb69670, 0x5f4a39, 0x5f5150, 0x272823, 0x181a17, 0x161c1c, 0x131919, 0x0d0f0a, 0x1a160a, 0xc3b7a1, 0xfffcdf, 0xf8deb9, 0xf1daba, 0xfff7dd, 0x89806f, 0x272113, 0xf8f2e6, 0xfff7ea, 0xfcf3e4, 0x666050, 0xaca696, 0xf7f1e1, 0xe9e3d3, 0x807a6a, 0x837d6d, 0xeae4d4, 0xeee8d8, 0xab9e98, 0x665953, 0xfffcf4, 0xfffcf3, 0xdfd3c5, 0x261a0a, 0xa19684, 0xfffeec, 0xfdeac9, 0xe2d2b1, 0xfffee3, 0xb3ab94, 0x0d0700, 0x111109, 0x121315, 0x191c21, 0x1a1915, 0x302a2e, 0x5c4b53, 0x5c443a, 0xbb9b75, 0xf4cd96, 0xffd19d, 0xfec99d, 0xdec784, 0xfff4bf, 0x857b58, 0x040100, 0x171715, 0x101115, 0x030408, 0x000002, 0x0a0a0a, 0x0c0c0c, 0x2b2b2b, 0x212121, 0x131313, 0x000000, 0x464646, 0xfafafa, 0xffffff, 0xffffff, 0x9f9f9f, 0x313131, 0x0b0b0b, 0x000000, 0x000000, 0x1f1f1f, 0x161622, 0x1f1f1d, 0x272226, 0x180d1d, 0x0b0000, 0x6a5f32, 0xe9dab1, 0x452e26, 0x010800, 0xcaaa71, 0x9a7d5b, 0x070002, 0x2c1b25, 0x0f0818, 0x1a0c03, 0xcc903a, 0xffd354, 0xedcca1, 0x232510, 0x9b8d50, 0xffde70, 0xf6aa16, 0xc5962a, 0x0b0000, 0x5d4334, 0xffeb9e, 0xf5cd5b, 0xfec76c, 0xfbbe7b, 0xfdc27c, 0xfec57e, 0xfec68d, 0xffc486, 0xf7ae50, 0xffa72c, 0xfc991a, 0xf79228, 0xffb659, 0xfbbb57, 0xb58614, 0x160000, 0x392c19, 0xc2c180, 0xfff0a4, 0xf1b97c, 0xffe17c, 0xb5a04f, 0x00001b, 0x5f3414, 0xddac36, 0xfbbf2d, 0xffc270, 0xf8c695, 0xe9c66a, 0xffd258, 0xd89125, 0x292830, 0x0b0000, 0x220602, 0x3e2a1f, 0x302d24, 0x18211c, 0x090d10, 0x11070f, 0xb3832e, 0xffc74b, 0xf5922a, 0x9f4100, 0x8b571e, 0x311d14, 0x160d2a, 0x050102, 0x3d3d3d, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf5fff7, 0x5c565a, 0x030009, 0x101a1c, 0x281e12, 0x7f4726, 0xa24e10, 0xdb8b32, 0xdfa35a, 0x391800, 0x060608, 0x182329, 0x131709, 0x201b07, 0x191919, 0x070e2a, 0x411a2c, 0x99631b, 0xffb736, 0xffc85f, 0xfac17c, 0xfccc78, 0xffbe4a, 0xfea621, 0x4d3e1f, 0x130003, 0x9b7755, 0xffe386, 0xffc877, 0xffe79c, 0xb6a56d, 0x09080e, 0x150000, 0xc7a343, 0xffcc31, 0xed9414, 0xfe9633, 0xffa236, 0xf3a63a, 0xfdb966, 0xffcd7d, 0xfec679, 0xfcc278, 0xffc57f, 0xffc680, 0xf8bf7a, 0xfcc680, 0xffe299, 0x9d986e, 0x0e0500, 0x875b2a, 0xffbf42, 0xfda831, 0xf6cba0, 0x614c39, 0xbea167, 0xffdc76, 0xe5b338, 0x724a17, 0x0e0002, 0x181b14, 0x1a1c29, 0x1e0e1b, 0xd7c37a, 0xc2ad74, 0x190000, 0x76563d, 0xffee8d, 0xdbc886, 0x33211f, 0x040002, 0x222419, 0x191919, 0x1b1b1b, 0x1d1d1d, 0x242424, 0x2a2a2a, 0x0e0e0e, 0x000000, 0x050505, 0xa6a6a6, 0xffffff, 0xffffff, 0xb9b9b9, 0x030303, 0x121212, 0x1b1b1b, 0x171717, 0x1b1613, 0x191816, 0x191a1c, 0x14181b, 0x1f2022, 0x181411, 0x070000, 0x9a8e82, 0xffe7b5, 0xf9d69e, 0xf8cf91, 0xfbcd8f, 0xfacf9a, 0xe3c39d, 0x745f4e, 0x51443e, 0x100e0f, 0x191919, 0x15191a, 0x171d1b, 0x151a14, 0x070700, 0x605949, 0xfffdec, 0xf2dbbb, 0xfffde1, 0xcabdaa, 0x1d1709, 0x060200, 0xcac3b9, 0xfffcf0, 0xfff5e7, 0x2e2715, 0x958e7c, 0xffffed, 0xffffed, 0x918a78, 0x928b79, 0xfffdeb, 0xfffdeb, 0x877d74, 0x3c3229, 0xfbf1e8, 0xfffdf3, 0xbab0a6, 0x0c0200, 0x2a2014, 0xd5cbbf, 0xfbeece, 0xf5e9cf, 0xf2ead5, 0x524c3e, 0x070400, 0x1d1d1b, 0x17181a, 0x171b1c, 0x1c1c14, 0x150f11, 0x514144, 0x7e665a, 0xf0cfac, 0xf6ce9b, 0xf2c291, 0xffcea6, 0xe8d088, 0xfff1b6, 0x8c805a, 0x060000, 0x151412, 0x19181e, 0x19181e, 0x222025, 0x222222, 0x222222, 0x181818, 0x0d0d0d, 0x181818, 0x0a0a0a, 0xcdcdcd, 0xffffff, 0xfbfbfb, 0x8e8e8e, 0x171717, 0x000000, 0x101010, 0x252525, 0x1f1f1f, 0x121212, 0x1d1f2e, 0x121210, 0x26211d, 0x0a0000, 0x46341e, 0xe0ce90, 0xffeab1, 0x593620, 0x000500, 0xeac787, 0xd0ae80, 0x160300, 0x1f0a0f, 0x17132a, 0x030009, 0x81541b, 0xfdbe31, 0xffe192, 0xa49365, 0x674e26, 0xffca95, 0xfdbc46, 0xeebc37, 0x7f591a, 0x140000, 0xbba26a, 0xffe689, 0xf9c977, 0xfac077, 0xfcc46f, 0xf3c16c, 0xf5c884, 0xffca94, 0xffcd7e, 0xffb046, 0xff9d29, 0xffa538, 0xf8972c, 0xe99c26, 0xffcb46, 0xc79d27, 0x150000, 0x140e1a, 0xc1c181, 0xffec97, 0xf6cd71, 0xf9df80, 0x8b8048, 0x180004, 0x77490d, 0xeab332, 0xffca4c, 0xf2c17e, 0xf9c59d, 0xffbe6a, 0xffbd2d, 0x9b614b, 0x3b1e10, 0x010602, 0x15262d, 0x111a23, 0x120f16, 0x252024, 0x010204, 0x392200, 0xe0a945, 0xf0923a, 0xa54b0f, 0x724212, 0x1d0f0e, 0x1c1735, 0x060100, 0x686868, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8fff8, 0x999395, 0x0c0914, 0x020d11, 0x1e170f, 0x6f391f, 0xa85823, 0xc07426, 0x68452f, 0x1b0900, 0x191917, 0x18231d, 0x13190b, 0x1e1c0f, 0x130d0d, 0x241c2b, 0x8b3a0d, 0xd28519, 0xf7ac37, 0xffc17f, 0xffd18c, 0xffd85b, 0xe8ad35, 0x96440a, 0x00001b, 0x635129, 0xffd593, 0xffc473, 0xffe680, 0xb08e5e, 0x180204, 0x1e1500, 0xdca94d, 0xedae44, 0xda851b, 0xea8722, 0xffa825, 0xf1a80e, 0xecb24f, 0xfdc5b6, 0xffca86, 0xfac47a, 0xfac172, 0xffd07f, 0xfec979, 0xf0c076, 0xfed593, 0xffd89d, 0x1d1a07, 0x482c00, 0xe5a541, 0xffba3a, 0xffcd74, 0xc19a79, 0x95734e, 0xffe194, 0xffcc54, 0xca9843, 0x2d1000, 0x140c1b, 0x202328, 0x030004, 0x503f2b, 0xfff09a, 0xb19f6f, 0x180000, 0x9c7a4d, 0xfadd77, 0xffe69d, 0xb3987d, 0x190900, 0x0a0100, 0x1b1b1b, 0x292929, 0x1d1d1d, 0x111111, 0x171717, 0x1e1e1e, 0x1a1a1a, 0x111111, 0x060606, 0xb8b8b8, 0xffffff, 0xffffff, 0x696969, 0x020202, 0x1c1c1c, 0x1c1c1c, 0x1a1112, 0x1f1b1c, 0x1f1e23, 0x191a1e, 0x181818, 0x1b1811, 0x180e02, 0x8e8170, 0xffe9b6, 0xeccd97, 0xf0c990, 0xf4c994, 0xffd7a9, 0xdabd9d, 0x695848, 0x403730, 0x080307, 0x1d1d1f, 0x171b1a, 0x1a231e, 0x192019, 0x080901, 0x0c0800, 0xbab1a8, 0xfffde6, 0xfffeea, 0x514b3d, 0x010100, 0x0c0b06, 0x54514a, 0x8d867c, 0x40362c, 0x060000, 0x2c261a, 0xd3cdc1, 0xf4eee2, 0x3d372b, 0x565044, 0xf7f1e5, 0xccc6ba, 0x252118, 0x0f0b02, 0x524e45, 0x85807a, 0x4a453f, 0x0d0802, 0x040000, 0x66615b, 0xfffddf, 0xffffe8, 0xa6a092, 0x080300, 0x191718, 0x19191b, 0x222325, 0x181c1b, 0x171a0f, 0x0a0905, 0x3f3335, 0x756254, 0xe8cca7, 0xfdd9a5, 0xf4c899, 0xfccba3, 0xf3da98, 0xf4dfaa, 0x837453, 0x1a1205, 0x201c1d, 0x1f1c23, 0x1a171e, 0x211c22, 0x111111, 0x1b1b1b, 0x212121, 0x1d1d1d, 0x000000, 0x767676, 0xf5f5f5, 0xffffff, 0xbbbbbb, 0x101010, 0x000000, 0x202020, 0x252525, 0x141414, 0x101010, 0x1d1d1d, 0x191b27, 0x1c1c1e, 0x060000, 0x2c1d06, 0xb6a26d, 0xffeea3, 0xfedb97, 0x8f6439, 0x000300, 0xd1b67f, 0xfdd799, 0x472d0c, 0x080000, 0x171d33, 0x060a16, 0x301c01, 0xe5af31, 0xf8c866, 0xffe29d, 0x966a43, 0xd5a17a, 0xffd57d, 0xf8c248, 0xe5ac41, 0x320f00, 0x4f320a, 0xffe3a9, 0xf5ce89, 0xf8c471, 0xffc968, 0xffcc70, 0xf6c87a, 0xf0be79, 0xffce93, 0xffc386, 0xffac4b, 0xffa820, 0xfeaa14, 0xe7941a, 0xce7d24, 0xffc247, 0xcda148, 0x1b0300, 0x0d0208, 0xb1ac5b, 0xffed87, 0xfede8b, 0xf8d869, 0x55372c, 0x1f0000, 0x825418, 0xe8be48, 0xfdcd67, 0xffcc9b, 0xffb578, 0xffbb41, 0xe77c34, 0x784518, 0x162018, 0x001a2c, 0x0a162c, 0x1f1520, 0x231b18, 0x191f13, 0x010200, 0x8a6129, 0xc9752f, 0xae5b25, 0x582f11, 0x120d13, 0x131627, 0x010000, 0xacacac, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xfefefe, 0xfefefe, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8fff6, 0xe2dcde, 0x35323d, 0x00080e, 0x16130e, 0x5e2b16, 0xac5f31, 0x924c04, 0x0f0915, 0x231a1b, 0x201c13, 0x171914, 0x171e24, 0x15161b, 0x23150c, 0x452913, 0xb65302, 0xde8f26, 0xf8b958, 0xffcc86, 0xffcc72, 0xe0b63e, 0x8d6b24, 0x150005, 0x2c1600, 0xead17d, 0xffe38c, 0xf7d691, 0xc4ad6a, 0x170000, 0x4b2711, 0xdebc51, 0xfeb937, 0xbd6913, 0xd2742c, 0xffa533, 0xf09f10, 0xffbd43, 0xffe191, 0xeac086, 0xfac382, 0xfcc479, 0xfdc56e, 0xffd373, 0xf0bf63, 0xf2cb7c, 0xf7d99d, 0x947c4c, 0x160000, 0xb0822c, 0xffc352, 0xf7ba5f, 0xffd790, 0xc58a3c, 0xe7ac60, 0xffd99d, 0xffc948, 0x926641, 0x0d0002, 0x1f222b, 0x15162a, 0x070000, 0x97884d, 0xfffca0, 0x86775a, 0x170000, 0xc9a767, 0xffe17b, 0xf3c97f, 0xffe5af, 0x8c754b, 0x160100, 0x1d1d1d, 0x181818, 0x131313, 0x1d1d1d, 0x111111, 0x121212, 0x252525, 0x0f0f0f, 0x000000, 0x323232, 0xdddddd, 0xffffff, 0xe1e1e1, 0x121212, 0x000000, 0x1d1d1d, 0x231a1b, 0x221c1e, 0x18161b, 0x17181a, 0x161614, 0x332f26, 0x453c2b, 0x90816e, 0xffeebb, 0xe6ca98, 0xf1d09d, 0xfdd7a8, 0xffe6c0, 0xbda58b, 0x574b3d, 0x36332c, 0x150e16, 0x211f24, 0x161a19, 0x19221d, 0x131d15, 0x131812, 0x010000, 0x484340, 0xfffeee, 0xaca89c, 0x080903, 0x101413, 0x1c2222, 0x000100, 0x13100b, 0x060000, 0x1f1b18, 0x090502, 0x221e1b, 0x35312e, 0x0b0704, 0x15110e, 0x393532, 0x120e0b, 0x050600, 0x161712, 0x000100, 0x11110f, 0x050503, 0x1f1f1f, 0x131315, 0x0c0c0e, 0xc7c6aa, 0xe9e6d3, 0x4a473e, 0x010000, 0x1c1b21, 0x0e0f14, 0x1b1c1e, 0x101511, 0x121d0c, 0x13160f, 0x35302d, 0x5c4f3f, 0xc0aa83, 0xffe6b2, 0xfed8a9, 0xf6c8a4, 0xf9dba5, 0xfbe2b9, 0x87755d, 0x3b322b, 0x282327, 0x18151c, 0x1f1a20, 0x1f1a1e, 0x202020, 0x141414, 0x131313, 0x030303, 0x1b1b1b, 0xf1f1f1, 0xffffff, 0xe5e5e5, 0x060606, 0x030303, 0x212121, 0x1a1a1a, 0x171717, 0x090909, 0x0f0f0f, 0x1f1f1f, 0x0f1316, 0x1a191f, 0x070000, 0x90834e, 0xf8e48e, 0xedcd78, 0xffda93, 0xc89755, 0x010100, 0x918360, 0xffeea5, 0x9d7b3b, 0x070a00, 0x0a1b2b, 0x0f161c, 0x020605, 0xae7818, 0xf3be60, 0xffdc94, 0xe2ae72, 0xcc9b4e, 0xffcd79, 0xffca72, 0xffc25a, 0xa17632, 0x2d0a00, 0xa4896c, 0xf8d9a0, 0xfacd72, 0xfcc25f, 0xffcc76, 0xfec67b, 0xffce78, 0xeaaf73, 0xffbc91, 0xffca87, 0xf5b241, 0xf3ab23, 0xf4a42b, 0xd27b1c, 0xb06512, 0xffc634, 0xdfae52, 0x2a0403, 0x140500, 0xb5ac6b, 0xfad992, 0xffe087, 0xceb469, 0x341405, 0x180000, 0x957029, 0xecb94c, 0xffc16b, 0xffc67b, 0xfbbd5a, 0xfe8a11, 0x9f570d, 0x412e1f, 0x0a1322, 0x121a27, 0x21201c, 0x120f06, 0x20261c, 0x001723, 0x361a0e, 0x934713, 0xad642f, 0x48261c, 0x0e151f, 0x000e0e, 0x232522, 0xe9e9e9, 0xffffff, 0xfbfbfb, 0xffffff, 0xf8f8f8, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf5fff3, 0xfffdff, 0x5d5b66, 0x000d15, 0x16120f, 0x522110, 0xaa5f35, 0x6d2800, 0x06122c, 0x141215, 0x261a0e, 0x080204, 0x01051e, 0x121429, 0x301b0a, 0x7e531c, 0xc05c0e, 0xdb943a, 0xfecd6e, 0xffd46e, 0xffcb65, 0xa97a2c, 0x120600, 0x000130, 0xb98329, 0xffe16e, 0xefe864, 0xb7b686, 0x03001c, 0x3c2a06, 0xeac342, 0xf9b643, 0xa44d08, 0xce7716, 0xfca929, 0xfaa629, 0xf8a94c, 0xffc47f, 0xfecb72, 0xf6d257, 0xfcc283, 0xffc97c, 0xffc869, 0xffcb61, 0xdeb14c, 0xf8d786, 0xe8d39a, 0x211400, 0x714401, 0xffc658, 0xffcd67, 0xfad39c, 0xf2bd77, 0xf8a628, 0xffcf61, 0xf2c4a2, 0xeabb39, 0x5a312f, 0x060012, 0x172122, 0x000019, 0x483d37, 0xe6d782, 0xfbe88a, 0x504333, 0x2c1400, 0xeece81, 0xfed674, 0xf8c880, 0xfdd58d, 0xe8cb91, 0x3f2121, 0x0f0f0f, 0x060606, 0x2f2f2f, 0x676767, 0x323232, 0x010101, 0x242424, 0x1e1e1e, 0x1b1b1b, 0x000000, 0x5b5b5b, 0xffffff, 0xfefefe, 0xa0a0a0, 0x0b0b0b, 0x161616, 0x1e1317, 0x211b1f, 0x1a181d, 0x1c1c1e, 0x0d0d0b, 0x343025, 0x5d5240, 0x8e7f68, 0xfbebb8, 0xf0d9a7, 0xfadbac, 0xf0cda3, 0xffe5c4, 0xbba78f, 0x5c5449, 0x1d1e18, 0x1f1722, 0x1c1a1f, 0x0f1312, 0x121c14, 0x0e1810, 0x252a24, 0x1f1f1d, 0x060203, 0x59574b, 0x2f3028, 0x020806, 0x131d1e, 0x151f21, 0x161b1e, 0x121210, 0x25211e, 0x1d1c21, 0x1a191e, 0x030207, 0x09080d, 0x201f24, 0x0f0e13, 0x000004, 0x121116, 0x161c18, 0x212723, 0x1d2321, 0x111717, 0x161b1e, 0x14191d, 0x1a1f23, 0x00040a, 0x3f3f25, 0x616250, 0x010000, 0x17161b, 0x1b1924, 0x181820, 0x191a1c, 0x131812, 0x152411, 0x0c130b, 0x2a2924, 0x675e4d, 0xbba981, 0xffe5b2, 0xf4d2a2, 0xf6cca6, 0xf2d3a7, 0xffeccb, 0x8d7a69, 0x554a48, 0x2f2830, 0x110e17, 0x1f1a20, 0x1b1517, 0x131313, 0x232323, 0x131313, 0x0b0b0b, 0xb1b1b1, 0xffffff, 0xffffff, 0x424242, 0x040404, 0x161616, 0x242424, 0x161616, 0x0a0a0a, 0x373737, 0x797979, 0x1b1b1b, 0x1e231f, 0x00000b, 0x4b4338, 0xe2d68c, 0xf7e277, 0xf0cd73, 0xffd68c, 0xf5c072, 0x0d0a05, 0x5b5642, 0xfff7a6, 0xe8c26d, 0x162415, 0x001520, 0x131c19, 0x000c1a, 0x763a00, 0xefb764, 0xffc887, 0xffcf7f, 0xdeac33, 0xfcc261, 0xffc88e, 0xffbf6f, 0xf8ca5b, 0x4e2800, 0x371b0f, 0xfee4b1, 0xffd777, 0xf0b454, 0xffbd72, 0xffc380, 0xfdc767, 0xffd080, 0xfcc88e, 0xfcc69a, 0xffc493, 0xf0ab5d, 0xeca028, 0xffba23, 0xbb7c13, 0xa85604, 0xfeb334, 0xe9ba46, 0x29100c, 0x0f0020, 0xceb08e, 0xffd785, 0xf8df6b, 0x8c764f, 0x0e0000, 0x2e0d00, 0xbc8528, 0xffcb61, 0xffd472, 0xebbb59, 0xff9604, 0xbb650e, 0x6e3b26, 0x2c1821, 0x090b0a, 0x020b00, 0x040c00, 0x1b211f, 0x052846, 0x0d0009, 0x732e05, 0xab662f, 0x402224, 0x081422, 0x000b00, 0x727876, 0xffffff, 0xfefefe, 0xfafafa, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdfe, 0xfdf9fa, 0xe0dcdd, 0x030000, 0x110d0e, 0x282425, 0x504c4d, 0x1e1a1b, 0x0e1414, 0x2b2223, 0x0a0000, 0x303135, 0x778585, 0x070500, 0x582707, 0xad5024, 0xb66031, 0xed9b1d, 0xffc261, 0xffd56f, 0xca9e3b, 0x0f0917, 0x08051a, 0x823f00, 0xfdc065, 0xfff691, 0xc0bf87, 0x0d010b, 0x350e00, 0xfbc139, 0xffb636, 0x963a2b, 0xd28014, 0xf0a42c, 0xf3af32, 0xefaf41, 0xffc16e, 0xffc98a, 0xffc687, 0xffcf85, 0xf7ce7f, 0xfcbc7e, 0xffc479, 0xebb032, 0xfad57c, 0xffe9c1, 0x8d7130, 0x360c00, 0xfaaa39, 0xf5c873, 0xf2cf97, 0xffce74, 0xfaa31e, 0xffab55, 0xffd69c, 0xf7cf56, 0xc49638, 0x1f0d00, 0x0f172c, 0x0f1431, 0x0f0000, 0xc09a5b, 0xffe898, 0xf9e296, 0x3f291b, 0x816243, 0xf6ce93, 0xffd284, 0xf9cb75, 0xf7d282, 0xfae19f, 0x796a33, 0x000109, 0x131925, 0x0d0e00, 0xddd290, 0xd4ba6d, 0x2d1100, 0x090000, 0x17232f, 0x1a1a1a, 0x0d0d0d, 0x050505, 0xa8a8a8, 0xffffff, 0xf4f4f4, 0x5f5f5f, 0x000000, 0x261f26, 0x1d1b20, 0x16171c, 0x15191c, 0x151a14, 0x1e1f11, 0x66604a, 0x887f62, 0xffe8c2, 0xf3d4a8, 0xf7d7a8, 0xf7d7a6, 0xfbdfb7, 0xe2cdb0, 0x716356, 0x0d0301, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x040404, 0x0e0e0e, 0x191919, 0x1e1e1e, 0x1b1b1b, 0x181818, 0x181818, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x080808, 0x0d0d0d, 0x151515, 0x1c1c1c, 0x202020, 0x1f1f1f, 0x1c1c1c, 0x1a1a1a, 0x19251b, 0x181c1b, 0x0b0708, 0x796d61, 0xead6b1, 0xf8daa6, 0xffddac, 0xffd6af, 0xffdaae, 0xf6d4ae, 0x937e63, 0x695d4f, 0x0b0704, 0x232428, 0x11141b, 0x1b1e27, 0x1f1f1f, 0x1a1a1a, 0x000000, 0x6c6c6c, 0xffffff, 0xfbfbfb, 0x9a9a9a, 0x010101, 0x171b02, 0x141b21, 0x1d233d, 0x010000, 0x251700, 0xe8d390, 0xc6b58a, 0x130600, 0x0f181f, 0x010100, 0x897a51, 0xffe29d, 0xfccc78, 0xfec774, 0xfdc77f, 0xffd99a, 0x4d472f, 0x4b3c11, 0xfee0a0, 0xffde92, 0xad8e4b, 0x0f0000, 0x1e201f, 0x000d27, 0x1e1c00, 0xe59f30, 0xffc671, 0xf3cf9f, 0xfcb74f, 0xff9c1d, 0xffc683, 0xf0cdb1, 0xffcd6e, 0xe6b238, 0x2d0700, 0x898254, 0xfef2c0, 0xfbc07c, 0xffb539, 0xffb660, 0xffc6a1, 0xffca86, 0xffc87b, 0xf9cb8f, 0xf9d090, 0xf8c761, 0xfbab2e, 0xff951c, 0xffb240, 0xb87109, 0x995419, 0xf1bc30, 0xefbe23, 0x380100, 0x18001c, 0xccdbb0, 0xffe58b, 0xfbbd38, 0x753f00, 0x05001a, 0x231627, 0xd99e50, 0xffd162, 0xefcb6b, 0xeea532, 0xc05f0e, 0xa74e24, 0x4c2514, 0x0f0e0c, 0x6f7277, 0x262e30, 0x000800, 0x282828, 0x0f0f0f, 0x282828, 0x4b4b4b, 0x1f1f1f, 0x0f0f0f, 0x121212, 0xe8e8e8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdfe, 0xfffeff, 0xf6f2f3, 0x5a5657, 0x050102, 0x201c1d, 0x272324, 0x171314, 0x191f1f, 0x080000, 0x0c0000, 0xecedf1, 0xcddbdb, 0x030100, 0x784727, 0xa94c20, 0xb15b1e, 0xf7a42a, 0xffd365, 0xebc15d, 0x5c3804, 0x060316, 0x26210d, 0xdb913c, 0xffe181, 0xefdb82, 0x3a2c21, 0x1e0500, 0xdeb647, 0xffbb49, 0xa44e15, 0xb25f19, 0xfba631, 0xf6a82c, 0xf0aa31, 0xf8b854, 0xffc87f, 0xffc589, 0xf6bf7e, 0xfac577, 0xffc783, 0xffc174, 0xedb441, 0xf8c373, 0xffde95, 0xcaaa6d, 0x4e240e, 0xb4902f, 0xffc055, 0xfad58e, 0xf7d492, 0xffb748, 0xfca228, 0xfebd7d, 0xfdc789, 0xffbc37, 0x8f6729, 0x150600, 0x151d32, 0x00000f, 0x655033, 0xf5ca85, 0xfed384, 0xf8d790, 0x9b8063, 0xba976d, 0xffd495, 0xffcc7b, 0xfac871, 0xf6cd7d, 0xffe1a0, 0x8e7741, 0x000107, 0x151925, 0x0d0b00, 0xbfb170, 0xffe598, 0x8f724a, 0x160b09, 0x040d14, 0x222222, 0x1f1f1f, 0x000000, 0x383838, 0xfbfbfb, 0xffffff, 0xcecece, 0x2a2a2a, 0x070105, 0x201e23, 0x1d1e23, 0x171b1e, 0x141915, 0x0b0b00, 0x5f5845, 0x988e73, 0xf7dbb4, 0xf0d3a9, 0xf8d9aa, 0xf4d5a6, 0xfbdfb7, 0xf5e1c6, 0x73655a, 0x0c0200, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x101010, 0x151515, 0x1b1b1b, 0x1c1c1c, 0x1a1a1a, 0x181818, 0x191919, 0x1b1b1b, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x101010, 0x131313, 0x171717, 0x1a1a1a, 0x1c1c1c, 0x1c1c1c, 0x1b1b1b, 0x1a1a1a, 0x131d14, 0x141817, 0x080307, 0x7f7367, 0xfce8c5, 0xf9ddab, 0xfbd7a7, 0xfdd3ad, 0xffd9ae, 0xeacaa4, 0xa79179, 0x5f5549, 0x060501, 0x1a1b1f, 0x13161d, 0x171a21, 0x1b1b1b, 0x000000, 0x3c3c3c, 0xececec, 0xfafafa, 0xeeeeee, 0x2c2c2c, 0x000000, 0x171a09, 0x1f232c, 0x050a1d, 0x130f04, 0x96854d, 0xfff0a7, 0xae9b73, 0x0f0100, 0x0e171e, 0x060400, 0x948157, 0xffe09a, 0xfccc7a, 0xfcc875, 0xfcc67e, 0xffd193, 0xaa9874, 0xa48a57, 0xfbd690, 0xfed585, 0xe9c682, 0x55421a, 0x000100, 0x0e1b2c, 0x060a00, 0xa8720e, 0xffc157, 0xffd39a, 0xfebf6f, 0xfaa526, 0xfab04d, 0xfecea6, 0xf8cf80, 0xffc77c, 0xbd8e22, 0x492a00, 0xcfbb98, 0xf8d790, 0xfbba76, 0xfbad3e, 0xf8bb7a, 0xffc582, 0xffca82, 0xf9c97f, 0xf4cd82, 0xffce7f, 0xffbc56, 0xfc9c21, 0xffa930, 0xffb448, 0xb16a0e, 0x8a4300, 0xffc052, 0xcf9c49, 0x1b0000, 0x494635, 0xf8e5ab, 0xffdb66, 0xc18a2f, 0x27171a, 0x060011, 0x6b3f0e, 0xffc867, 0xedbd57, 0xf3a92e, 0xd16d15, 0xaf5425, 0x542b17, 0x17120e, 0xe6e5eb, 0xc9cdd0, 0x000802, 0x080808, 0x262626, 0x181818, 0x1e1e1e, 0x232323, 0x000000, 0x616161, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdfe, 0xfffeff, 0xfffeff, 0xbfbdbe, 0x040203, 0x141213, 0x0e0c0d, 0x1c1a1b, 0x0e1414, 0x060000, 0xa59999, 0xfdfeff, 0x95a3a3, 0x121004, 0x794828, 0xa84b1f, 0xbf671d, 0xfbac2d, 0xffd558, 0x9e8133, 0x0f0002, 0x08061c, 0x544800, 0xffbd57, 0xf9ed8b, 0x816f49, 0x1a0006, 0x9f7a33, 0xffdc42, 0xb35d10, 0x98391d, 0xf0a832, 0xffb42f, 0xf4a225, 0xf2aa3e, 0xffc572, 0xffcc90, 0xfcc58c, 0xf8c67f, 0xfecc77, 0xffb97b, 0xf3ba46, 0xe1ba55, 0xffdfa1, 0xeec492, 0x6b3a11, 0x926426, 0xfad56d, 0xffd173, 0xf6d399, 0xf5c76f, 0xfa9f1a, 0xffa847, 0xffd5ab, 0xefc174, 0xffac1d, 0x4c2f1f, 0x150c11, 0x000515, 0x21201b, 0xccb081, 0xffe598, 0xf6c374, 0xfacd8a, 0xefcd9d, 0xf0c88d, 0xffd289, 0xfec774, 0xffc973, 0xfac97c, 0xffe2a1, 0xaa8a51, 0x000306, 0x0c101b, 0x161304, 0xad9e5d, 0xfff8a8, 0xf3d1a4, 0x504033, 0x000200, 0x0f0f0f, 0x2a2a2a, 0x191919, 0x000000, 0x9f9f9f, 0xffffff, 0xffffff, 0xa3a3a3, 0x040002, 0x131116, 0x1e1f24, 0x161a1d, 0x151918, 0x020200, 0x5b5442, 0xc7bca6, 0xefd5b2, 0xf3d7af, 0xfadeaf, 0xf1d5a6, 0xf9e0b8, 0xfff3d9, 0x685b52, 0x070000, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1c1c1c, 0x1c1c1c, 0x1c1c1c, 0x1b1b1b, 0x1a1a1a, 0x1a1a1a, 0x1b1b1b, 0x1b1b1b, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x191919, 0x191919, 0x181818, 0x191919, 0x191919, 0x1a1a1a, 0x1a1a1a, 0x0f1910, 0x141819, 0x030002, 0x7a6d64, 0xfff4d3, 0xfbe0b1, 0xf4d3a8, 0xfcd5b4, 0xffdcb2, 0xe7caa8, 0xc5b39b, 0x4e4639, 0x080703, 0x15161a, 0x1b1c21, 0x17171f, 0x1a1a1a, 0x000000, 0xacacac, 0xffffff, 0xffffff, 0x8b8b8b, 0x000000, 0x151515, 0x191a15, 0x1c1f28, 0x000308, 0x544d30, 0xfae69f, 0xfff7aa, 0xa69069, 0x140508, 0x0a131a, 0x120c00, 0xa48c5e, 0xffdf98, 0xfacb79, 0xfac97c, 0xfbc680, 0xffc888, 0xf3cf9d, 0xeec587, 0xfbcc7e, 0xf7c773, 0xffe79f, 0xc2ac7d, 0x0b0800, 0x0f161c, 0x000a1a, 0x624500, 0xf8b236, 0xffce7b, 0xfac68d, 0xf9b844, 0xec9e16, 0xffc682, 0xf6cd99, 0xffd4a0, 0xffc759, 0x975f0c, 0x624213, 0xebddae, 0xfbd4a9, 0xfdbb4a, 0xedb14f, 0xffbc73, 0xffcb84, 0xffcc74, 0xf3c87a, 0xffd29a, 0xffca83, 0xfbae3c, 0xfda124, 0xffab3a, 0xf9a727, 0x973b08, 0xb15c23, 0xffd740, 0x9b781a, 0x140000, 0x7f8174, 0xffe387, 0xfec34d, 0x5b4317, 0x000012, 0x150200, 0xc5934c, 0xffc85e, 0xf5ab24, 0xc66200, 0xa74913, 0x7a4e35, 0x070000, 0xbab3bb, 0xfffdff, 0x858f8e, 0x000000, 0x171717, 0x191919, 0x070707, 0x181818, 0x050505, 0xcccccc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xf5f5f5, 0x2e2e2e, 0x060606, 0x1b1b1b, 0x1b1b1b, 0x000202, 0x82797a, 0xfffbfb, 0xf4f5f9, 0x7b8989, 0x030100, 0x885737, 0xa04317, 0xc3691d, 0xfab325, 0xe3b940, 0x45330d, 0x030026, 0x14101f, 0x8e720e, 0xffc54e, 0xc4ca84, 0x15010d, 0x684714, 0xffe14e, 0xc97a1b, 0x8f2e01, 0xe18930, 0xffb93f, 0xfea418, 0xf5a228, 0xffba5b, 0xffce8c, 0xfdc894, 0xfbc88f, 0xffcf84, 0xffcc71, 0xffa747, 0xf5bb50, 0xeed289, 0xffe8af, 0x936448, 0x854915, 0xf6c850, 0xf7cb82, 0xffdb90, 0xf7c586, 0xf3ad3d, 0xf8a11e, 0xffb977, 0xffdaaf, 0xf3c160, 0xed920e, 0x1d0e25, 0x120f22, 0x000005, 0x8b8265, 0xffe3a3, 0xffd17f, 0xfec377, 0xffc98b, 0xffda96, 0xffd189, 0xffca7c, 0xffc573, 0xffce7c, 0xffcc80, 0xffdf9c, 0xbf9356, 0x050b0b, 0x01040d, 0x231d0f, 0xc0ac6d, 0xffe191, 0xffe9b6, 0xaa947d, 0x0e0d00, 0x0f0f0f, 0x1a1a1a, 0x222222, 0x040404, 0x2b2b2b, 0xf8f8f8, 0xfcfcfc, 0xf7f7f7, 0x4c4648, 0x010002, 0x191a1f, 0x171a1f, 0x15191a, 0x090803, 0x484033, 0xede1d1, 0xf9e1bf, 0xf8deb9, 0xfbe0b5, 0xf2daae, 0xfae4bf, 0xfff0d9, 0x4b4239, 0x030000, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x202020, 0x1d1d1d, 0x1a1a1a, 0x191919, 0x1b1b1b, 0x1c1c1c, 0x1b1b1b, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1d1d1d, 0x1c1c1c, 0x1a1a1a, 0x191919, 0x191919, 0x191919, 0x1a1a1a, 0x1b1b1b, 0x151c14, 0x1b1c1e, 0x030004, 0x60564d, 0xfeedcf, 0xfce5bb, 0xf5d7b1, 0xffddc1, 0xfedeb8, 0xf6ddbe, 0xdecdb9, 0x352f23, 0x0e0d0b, 0x191a1e, 0x1e1f24, 0x16151b, 0x000000, 0x505050, 0xffffff, 0xf6f6f6, 0xfbfbfb, 0x1d1d1d, 0x111111, 0x1c1c1c, 0x1e1c21, 0x0b0c11, 0x1d1a11, 0xb5a778, 0xffee9b, 0xffdf8e, 0xbda37e, 0x1f1015, 0x030c13, 0x1d1200, 0xb79862, 0xffda8f, 0xf9cc7b, 0xfacc81, 0xfcca85, 0xfdc383, 0xffcf8e, 0xffcb81, 0xffce7b, 0xfac26d, 0xffd186, 0xffebb7, 0x756a4e, 0x030300, 0x011329, 0x312a0e, 0xdc9928, 0xffbf4a, 0xf6c78f, 0xffcc73, 0xf09f12, 0xffb246, 0xffca9e, 0xf4c784, 0xffcb94, 0xf8b751, 0x744400, 0x927c64, 0xffecad, 0xffcf82, 0xefb54a, 0xf7b257, 0xffc46f, 0xffd07b, 0xfac984, 0xfacc9a, 0xffd092, 0xffc26a, 0xf49624, 0xfea02c, 0xffbb2c, 0xe6813b, 0x8d2a0a, 0xcb8a08, 0xfbcf48, 0x6a3f15, 0x000d1b, 0xdfc183, 0xffd853, 0x906d13, 0x0b0a1a, 0x00001e, 0x4e2f03, 0xffbe5d, 0xffb72a, 0xd4710b, 0xa04308, 0x784b2e, 0x0a0000, 0x9b9098, 0xfffbff, 0xf7fbfc, 0x575757, 0x000000, 0x191919, 0x1f1f1f, 0x000000, 0x4e4e4e, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xfafafa, 0xffffff, 0x7e7e7e, 0x000000, 0x202020, 0x000000, 0x222828, 0xfbf2f3, 0xfff5f5, 0xfeffff, 0x8b9999, 0x030100, 0x8a5939, 0x9c3f13, 0xbe5f1b, 0xfec52e, 0x9d7c1d, 0x10070a, 0x090c35, 0x2f1c16, 0xc69632, 0xffd55d, 0x585a4d, 0x200b08, 0xcca927, 0xf8bd23, 0x8e2e1e, 0xc06133, 0xffb318, 0xf8a432, 0xf39d16, 0xffb445, 0xffce7e, 0xffcd95, 0xf6c491, 0xffce8c, 0xffcb78, 0xeeb252, 0xfead28, 0xfabe78, 0xfff0aa, 0xbb9a7b, 0x824e27, 0xdeaa34, 0xffd06b, 0xfdcc94, 0xf6de9e, 0xffb661, 0xf7991b, 0xfeb951, 0xfec99d, 0xffc883, 0xf8b947, 0xab6607, 0x070326, 0x000010, 0x373425, 0xead6a4, 0xffe198, 0xf7bc6c, 0xffcb83, 0xffc98a, 0xfac97c, 0xffcc80, 0xfec679, 0xffc97c, 0xffd184, 0xffcd82, 0xffda91, 0xc6944d, 0x090e0a, 0x04040c, 0x292212, 0xdec686, 0xf8ce7c, 0xffd499, 0xefd3ae, 0x3a3410, 0x0d0d0d, 0x0f0f0f, 0x1c1c1c, 0x161616, 0x000000, 0xa6a6a6, 0xfcfcfc, 0xffffff, 0xbdb7b7, 0x020001, 0x111216, 0x1b1e23, 0x161a1d, 0x151412, 0x1e150e, 0xded2c6, 0xfff0d1, 0xf9e3be, 0xf4ddb4, 0xf7e0b6, 0xfdeac9, 0xe7dbc5, 0x2b2620, 0x0a080d, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1b1b1b, 0x191919, 0x171717, 0x191919, 0x1c1c1c, 0x1d1d1d, 0x1b1b1b, 0x181818, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1b1b1b, 0x1b1b1b, 0x1b1b1b, 0x1b1b1b, 0x1b1b1b, 0x1b1b1b, 0x1b1b1b, 0x1b1b1b, 0x171d13, 0x1f1f21, 0x040005, 0x433832, 0xeadac0, 0xffedc5, 0xf8debd, 0xfee0c8, 0xf6dcbb, 0xfff1d4, 0xd1c4b1, 0x151108, 0x121210, 0x1d1e22, 0x1b1a1f, 0x0f0d12, 0x000000, 0xcdcdcd, 0xffffff, 0xfefefe, 0x8a8a8a, 0x000000, 0x1b1b1b, 0x181818, 0x1d1a23, 0x020001, 0x46402a, 0xfae6ab, 0xf4d078, 0xf7d180, 0xd6ba92, 0x261714, 0x000309, 0x251600, 0xc79f64, 0xffd687, 0xf9ce7f, 0xf7cf89, 0xffcf8d, 0xfec37f, 0xffc87e, 0xffc67a, 0xffd180, 0xffc875, 0xefbf75, 0xffe6ac, 0xdcc79c, 0x302505, 0x00050b, 0x0e101c, 0xb2792c, 0xffb52b, 0xfac97a, 0xffd69b, 0xfcb040, 0xf4a019, 0xffb767, 0xffd18f, 0xfed2b9, 0xffce76, 0xde9e34, 0x6d4005, 0xd1b971, 0xfbd9a9, 0xffc86e, 0xefaf43, 0xfeb44b, 0xffcd7f, 0xffd095, 0xf6ca8b, 0xfacd8a, 0xffce92, 0xffac4b, 0xffa732, 0xfc9c11, 0xffb132, 0xbc5a2b, 0x8d3d0a, 0xe6b131, 0xdaa845, 0x000407, 0x806846, 0xffda63, 0xbd8e18, 0x211515, 0x000c38, 0x0b0000, 0xc07f3b, 0xfeba31, 0xd57713, 0xa84f17, 0x693d22, 0x0b0000, 0xb7acb4, 0xfff8ff, 0xfeffff, 0xdbdbdb, 0x242424, 0x000000, 0x282828, 0x000000, 0x959595, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfefd, 0xfdfffe, 0xfdfffe, 0xfeffff, 0xcccecd, 0x090b0a, 0x0a0c0b, 0x000100, 0xa5abab, 0xfffcfd, 0xfffbfb, 0xeff0f4, 0x9ba9a9, 0x060400, 0x633212, 0xad5024, 0xd57334, 0xf1c145, 0x453200, 0x040519, 0x03081e, 0x5d3418, 0xeaa848, 0xebbc64, 0x070013, 0x7c6519, 0xffd93e, 0xa75d08, 0x741819, 0xe39240, 0xfbae06, 0xffa02a, 0xf0a42c, 0xffc364, 0xffd08d, 0xf6c793, 0xf9cc91, 0xffd286, 0xffbe64, 0xeca040, 0xffc65a, 0xffd177, 0xffcfa2, 0x9b6543, 0xc38f2c, 0xfcc84e, 0xffcb81, 0xffd39e, 0xedc97f, 0xfea434, 0xfd9824, 0xffcf8c, 0xfdd29f, 0xffba52, 0xf2ac3c, 0x643f0a, 0x000216, 0x010000, 0xb5a782, 0xffe9a9, 0xffcf86, 0xffc57d, 0xffca86, 0xffcc8a, 0xfbc77b, 0xffcf85, 0xffcb85, 0xffcb88, 0xffcd87, 0xffcb81, 0xffd282, 0xca9843, 0x090e08, 0x0e0d13, 0x332719, 0xf1d596, 0xffd47f, 0xf7c483, 0xffe4b6, 0x726632, 0x000000, 0x181818, 0x222222, 0x141414, 0x080808, 0x2a2a2a, 0xffffff, 0xfefefe, 0xfdf8f5, 0x2b292a, 0x05060a, 0x1a1d24, 0x181b20, 0x1f1d1e, 0x070000, 0xaa9d97, 0xfff6d8, 0xf6e2c1, 0xf0dab3, 0xf7e4bc, 0xfff3d2, 0xc7bcaa, 0x16120f, 0x15161b, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x171717, 0x161616, 0x161616, 0x191919, 0x1c1c1c, 0x1d1d1d, 0x1a1a1a, 0x171717, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x181818, 0x191919, 0x1b1b1b, 0x1c1c1c, 0x1c1c1c, 0x1c1c1c, 0x1b1b1b, 0x1a1a1a, 0x171a11, 0x1c1c1e, 0x120b13, 0x2a1f1d, 0xd1c2ab, 0xfff7d5, 0xfae2c6, 0xf6dbc8, 0xf2ddbe, 0xfff5dd, 0x9d9483, 0x030000, 0x121212, 0x1c1c1e, 0x141215, 0x090408, 0x3b3b3b, 0xffffff, 0xffffff, 0xe9e9e9, 0x1b1b1b, 0x0b0b0b, 0x1b1b1b, 0x171717, 0x19171a, 0x0a0700, 0x74694b, 0xfff2b3, 0xf3c671, 0xffd88a, 0xe3c496, 0x2c1f0f, 0x000107, 0x2c1800, 0xd4a464, 0xffd481, 0xfad182, 0xf3d08e, 0xffd292, 0xffc580, 0xfeca81, 0xffca80, 0xffca7d, 0xffcb80, 0xffd088, 0xf3cc8b, 0xffe7ae, 0xa18a56, 0x000400, 0x000017, 0x7b502e, 0xf8aa2c, 0xffc65a, 0xffd2a4, 0xffc47e, 0xf4a21b, 0xfa9b1d, 0xffd59f, 0xf5d197, 0xffd49c, 0xfbba5e, 0xc1850d, 0xac783c, 0xf5d197, 0xffd995, 0xf3ba51, 0xf3aa3b, 0xffbc6e, 0xffcf90, 0xface83, 0xf6cc84, 0xffce9f, 0xffc479, 0xf4a02e, 0xf59815, 0xffc121, 0xda8334, 0x772623, 0xa36711, 0xfecd4d, 0x564f23, 0x1f0400, 0xf4c46f, 0xe5ab2d, 0x482811, 0x010e2e, 0x060c02, 0x5d2e12, 0xf6b83d, 0xc87017, 0xac5a2a, 0x57311c, 0x090100, 0xc1b7bf, 0xfff9fc, 0xfbfffa, 0xffffff, 0x959595, 0x000000, 0x080808, 0x131313, 0xd2d2d2, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfffe, 0xfbfffe, 0xfcffff, 0xfcffff, 0xf5f9f8, 0x373b3a, 0x000100, 0x494d4c, 0xfbffff, 0xfffafb, 0xfffbfb, 0xfeffff, 0xe4f2f2, 0x131105, 0x461500, 0xb4572b, 0xe5833a, 0xa87d38, 0x120900, 0x0b151e, 0x0e0d15, 0x844414, 0xfdb048, 0x866a45, 0x1b0001, 0xceac30, 0xdca032, 0x66130d, 0x8b431b, 0xeeb22e, 0xfbaa1a, 0xff9a20, 0xf4b04b, 0xffc87b, 0xfbca92, 0xf1c995, 0xffd791, 0xfcc56b, 0xf6aa4a, 0xffad4e, 0xf5d394, 0xffe486, 0xe19766, 0xd78e32, 0xe5ab2d, 0xffce80, 0xffd48c, 0xfcce93, 0xefab46, 0xf99d1e, 0xffb057, 0xffd2ad, 0xffcd81, 0xffb934, 0xcf9532, 0x2c1d08, 0x000800, 0x524f30, 0xfde7ad, 0xffda92, 0xfdc481, 0xffd092, 0xf9c685, 0xf9cd84, 0xffcd87, 0xffd18f, 0xfecc8f, 0xffcd92, 0xfac889, 0xfdcd81, 0xffd278, 0xd1a13f, 0x11140b, 0x0b090e, 0x4d3f32, 0xfedea1, 0xffd782, 0xfdc781, 0xffe0a9, 0xaa9a5c, 0x030303, 0x1a1a1a, 0x151515, 0x131313, 0x1c1c1c, 0x000000, 0xa9a9a9, 0xf5f5f5, 0xfffefa, 0x848381, 0x010206, 0x14171e, 0x181b22, 0x1d1b20, 0x070000, 0x736564, 0xfff6d9, 0xf8e8c7, 0xf0deb8, 0xf7e5bf, 0xfff7d8, 0xa8a18f, 0x060503, 0x181b22, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x191919, 0x181818, 0x181818, 0x1a1a1a, 0x1b1b1b, 0x1c1c1c, 0x1a1a1a, 0x191919, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1b1b1b, 0x1b1b1b, 0x1b1b1b, 0x1a1a1a, 0x191919, 0x181818, 0x1c1d15, 0x181619, 0x1c151d, 0x130908, 0xb6aa94, 0xfffbdc, 0xfae6cd, 0xf2dbcd, 0xfbe7cc, 0xfbecd5, 0x5f5848, 0x010000, 0x151716, 0x19191b, 0x141215, 0x0c0608, 0x919191, 0xf5f5f5, 0xffffff, 0x8d8d8d, 0x070707, 0x1a1a1a, 0x191919, 0x101010, 0x14130e, 0x141102, 0xad9f7c, 0xffe3a7, 0xffca7c, 0xffdb90, 0xeccd97, 0x423717, 0x000107, 0x321b00, 0xdda862, 0xffd27d, 0xf9d285, 0xedce8e, 0xffd193, 0xffc67f, 0xfacd8a, 0xfdce8a, 0xf9c885, 0xf9c883, 0xffda94, 0xf1c681, 0xffdd98, 0xfdda96, 0x48412e, 0x000007, 0x3a231d, 0xd79139, 0xffbb40, 0xfdcb90, 0xfbd1ab, 0xffb34d, 0xf79911, 0xffb257, 0xffd276, 0xf5d09b, 0xfbca85, 0xf7b53d, 0xcf8230, 0xf8ba67, 0xf9d9a0, 0xffcf7f, 0xfbb150, 0xf5a647, 0xffc06c, 0xffd387, 0xfccf8c, 0xfdcf93, 0xffc587, 0xf7b142, 0xfaa61f, 0xfba919, 0xf3aa44, 0x8d4a2d, 0x581a00, 0xdfaa40, 0xc6a53c, 0x150000, 0xa77e52, 0xfab83e, 0x764011, 0x0a0e17, 0x0d201c, 0x16000a, 0xcb9529, 0xd5863b, 0x9e522e, 0x2a0a00, 0x302f2d, 0xf3f1f6, 0xfffffd, 0xeef9eb, 0xf9f9f9, 0xeeeeee, 0x424242, 0x000000, 0x505050, 0xfafafa, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcffff, 0xf8fcfb, 0xf9fdfc, 0xfcffff, 0xfcffff, 0x676b6a, 0x000100, 0xaeb2b1, 0xf7fdfd, 0xfffcfd, 0xfff5f5, 0xfdfeff, 0xf5ffff, 0x5d5b4f, 0x310000, 0xa3461a, 0xcf6e1d, 0x4e260d, 0x0e0d12, 0x14251b, 0x271e23, 0x8f4005, 0xffb944, 0x352528, 0x542f02, 0xffd552, 0x994d19, 0x490013, 0xbe863b, 0xf0c01e, 0xf4a31e, 0xff9a22, 0xfbbd66, 0xffd18e, 0xf7ce9a, 0xf6d39b, 0xffda8b, 0xe6ac4b, 0xe79330, 0xffc063, 0xe8dba6, 0xfcc7a5, 0xffb746, 0xe69404, 0xffbc5a, 0xffd794, 0xffd5a0, 0xefc37a, 0xffa025, 0xfaa620, 0xffce90, 0xffceba, 0xffc25e, 0xffb825, 0xa87929, 0x050000, 0x030d00, 0xb5b27f, 0xffe39a, 0xffcf86, 0xfdc183, 0xffce97, 0xf3c383, 0xf5ce81, 0xffcd8d, 0xfcca8f, 0xf8c691, 0xfbcc98, 0xf7c98d, 0xffd184, 0xffd576, 0xd7a840, 0x1c1f16, 0x010004, 0x6a5c4f, 0xffe6a7, 0xffcc76, 0xffcc83, 0xffdea1, 0xd0bd79, 0x111111, 0x121212, 0x0e0e0e, 0x292929, 0x0e0e0e, 0x0d0d0d, 0x292929, 0xffffff, 0xfffcf8, 0xdad9d7, 0x090a0e, 0x0e1118, 0x14171e, 0x131116, 0x0e0307, 0x4c3e3e, 0xfff4da, 0xffeed0, 0xf6e4c0, 0xf7e5c1, 0xfff8db, 0x968f7f, 0x000000, 0x131720, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1d1d1d, 0x1c1c1c, 0x1b1b1b, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1b1b1b, 0x1b1b1b, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1a1a1a, 0x1d1d1d, 0x1c1c1c, 0x1b1b1b, 0x191919, 0x181818, 0x181818, 0x181818, 0x181818, 0x23241c, 0x161417, 0x201823, 0x070000, 0xa19682, 0xfffbde, 0xfae8d0, 0xf6e0d3, 0xfff6dc, 0xf0e4ce, 0x363022, 0x0b0a05, 0x1a1c1b, 0x19191b, 0x1b161a, 0x130d0f, 0xededed, 0xfefefe, 0xf7f7f7, 0x202020, 0x000000, 0x1b1b1b, 0x181818, 0x202020, 0x151307, 0x181300, 0xdecca8, 0xffdaa2, 0xffc980, 0xffd28a, 0xf8d9a0, 0x5b5227, 0x000206, 0x361d00, 0xe3aa63, 0xffd27b, 0xfad388, 0xe9cb8d, 0xfdd192, 0xffc67f, 0xf7d192, 0xf8d092, 0xfed293, 0xf2c584, 0xfbcc88, 0xf9cd86, 0xf7cb80, 0xffea9b, 0xad9b87, 0x0f0900, 0x0b0207, 0xb4753f, 0xffaf31, 0xfbc77c, 0xf3d7c1, 0xffc47a, 0xfca62f, 0xfea60e, 0xffbd5e, 0xf6d590, 0xffe1a5, 0xf6b068, 0xf09918, 0xffac4a, 0xe6cd95, 0xffe1aa, 0xffc06f, 0xe59826, 0xf0b046, 0xffd28f, 0xffd59b, 0xffd184, 0xffd99e, 0xf6b74d, 0xf2a517, 0xec9a2e, 0xffc958, 0xb37e30, 0x3c0000, 0x91590f, 0xfbc837, 0x37161f, 0x512d1d, 0xf8b240, 0x945011, 0x1a170e, 0x041d1a, 0x0a0029, 0x724000, 0xd18343, 0x8a4023, 0x200300, 0x75797a, 0xfeffff, 0xf5f6f1, 0xf7fff4, 0xfefefe, 0xffffff, 0x909090, 0x010101, 0x838383, 0xfdfdfd, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xf5f5f5, 0xffffff, 0x8e8e8e, 0x1e1e1e, 0xf9f9f9, 0xfbfbfb, 0xfbffff, 0xf3ffff, 0xf1ffff, 0xfbffff, 0xdacdc4, 0x1e0000, 0x865b39, 0x4d4538, 0x040a00, 0x282230, 0x050e1d, 0x3a1600, 0xc26023, 0xc38f55, 0x080000, 0xd8861a, 0xe3b14e, 0x2f0d04, 0x5f322f, 0xeaa629, 0xffab0f, 0xffa02d, 0xffa618, 0xeac787, 0xfed0b6, 0xffd39d, 0xffc769, 0xffa03d, 0xf09119, 0xfeb743, 0xffd196, 0xfcdb94, 0xffc47f, 0xf7991d, 0xffb733, 0xefbd88, 0xffd8b7, 0xffc864, 0xffa716, 0xb17f42, 0xeac97c, 0xf5d59c, 0xffd78a, 0xffb931, 0xf2af46, 0x654433, 0x000313, 0x5e3e2f, 0xffe9ae, 0xf9cd86, 0xffcb95, 0xffc87f, 0xffd969, 0xf5c36a, 0xfcc6ac, 0xf2cb92, 0xffd092, 0xffcb8b, 0xfcca8f, 0xf4ca90, 0xffd491, 0xffcf77, 0xeba136, 0x212429, 0x070100, 0xad9360, 0xffdd99, 0xffcf8d, 0xfbcb8b, 0xf7d58d, 0xf7de8c, 0x4e352e, 0x060004, 0x182022, 0x0e1b09, 0x17190e, 0x1f1726, 0x080611, 0x97a493, 0xfefefe, 0xf4f4f4, 0x818181, 0x000000, 0x1d1d1d, 0x1c1c1c, 0x151515, 0x0a0a0a, 0xc8c6b1, 0xfffbe5, 0xf6ebd5, 0xf4e5d0, 0xfffcec, 0x776e65, 0x060201, 0x1a1b1f, 0x1a1b2d, 0x0a0911, 0x281d19, 0x4c3025, 0x462017, 0x240b07, 0x06100f, 0x042c2b, 0x1d1e19, 0x1a1b16, 0x191a15, 0x1a1b16, 0x1e1f1a, 0x1f201b, 0x1d1e19, 0x1a1b16, 0x1a1d16, 0x191c15, 0x171a13, 0x161912, 0x161912, 0x171a13, 0x181b14, 0x191c15, 0x231f1e, 0x211d1c, 0x1f1b1a, 0x1f1b1a, 0x201c1b, 0x211d1c, 0x201c1b, 0x201c1b, 0x2e1731, 0x1c1924, 0x16231c, 0x131e0e, 0x120b00, 0x3a2315, 0x573c31, 0x301c11, 0x161b1e, 0x141819, 0x161614, 0x0e0b04, 0x7e7669, 0xfffeec, 0xf5e6cf, 0xf5e5cc, 0xfeffec, 0xb6b9a6, 0x080a00, 0x121409, 0x1a1b16, 0x191919, 0x000004, 0x96959b, 0xfdfeff, 0xfefffd, 0x7e8178, 0x000400, 0x161a0c, 0x181b12, 0x1a1c19, 0x1a1b1d, 0x0c0009, 0x5d4930, 0xffe4ae, 0xfacf98, 0xf8cb8a, 0xfdd68b, 0xffe6ae, 0x9b7864, 0x030007, 0x412c0f, 0xf1a947, 0xffcb8a, 0xfecb9c, 0xf6cd75, 0xf6db96, 0xffca90, 0xf6cd7d, 0xffd29f, 0xf9c192, 0xffcc7f, 0xfac366, 0xffd285, 0xfcc987, 0xffd58d, 0xffcf9b, 0x514628, 0x000009, 0x6a4727, 0xf8b331, 0xffc03c, 0xffcd84, 0xffdfa1, 0xd6b197, 0xce8119, 0xffae29, 0xffcd7a, 0xf4d295, 0xffca66, 0xf8a724, 0xf19b20, 0xfec665, 0xf9d8a2, 0xf4d09c, 0xf9ac42, 0xff9a0a, 0xffa72b, 0xffc36d, 0xffdd9b, 0xf4d69a, 0xf3c883, 0xe9a445, 0xfd9c1a, 0xffb626, 0xf49a2c, 0x753f1b, 0x100010, 0xf9a84c, 0xae7b08, 0x160000, 0xeb9c5a, 0xb1681b, 0x110a1c, 0x151014, 0x151827, 0x2a0d00, 0x774f36, 0x704232, 0x280800, 0xeee8dc, 0xfbfffb, 0xfeffff, 0xfff6ff, 0xfdfdfd, 0xffffff, 0xe7e7e7, 0x121212, 0x9a9a9a, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfcfcfc, 0xffffff, 0xb9b9b9, 0x7a7a7a, 0xffffff, 0xfffefa, 0xfefefe, 0xf7ffff, 0xf4ffff, 0xfbffff, 0xf4ede7, 0x5c4533, 0x553318, 0x494134, 0x000300, 0x110b19, 0x06101c, 0x421e08, 0xc6662a, 0x9c6b31, 0x110a00, 0xe5a645, 0x805119, 0x310c00, 0x935f38, 0xf4a53c, 0xffa314, 0xfda01d, 0xf9a83c, 0xfdd68b, 0xffd4a7, 0xfebf78, 0xffad41, 0xfd9b2c, 0xf99f27, 0xffc056, 0xffd0a0, 0xf5d29c, 0xffb44a, 0xff9a14, 0xe3a246, 0xffe0ac, 0xffd17c, 0xf8b646, 0xb87f26, 0x936220, 0xf2d289, 0xfcd89e, 0xffc575, 0xffbc3a, 0xd49838, 0x2d1000, 0x000009, 0xb79977, 0xffe7a5, 0xf9d48e, 0xffd09f, 0xffd693, 0xd5a940, 0xffd984, 0xfdc6a7, 0xf2cb92, 0xffd092, 0xffca8a, 0xfdcb90, 0xf6cc92, 0xffd28f, 0xffca72, 0xeaa035, 0x1e2225, 0x191100, 0xccb37d, 0xffe19d, 0xffcf8d, 0xfbcb8b, 0xfad891, 0xffeb9b, 0x775d4e, 0x0f0408, 0x141c1f, 0x152113, 0x181911, 0x1f1724, 0x000007, 0x3b4836, 0xfdfdfd, 0xffffff, 0xcacaca, 0x232323, 0x0b0b0b, 0x1d1d1d, 0x161616, 0x000000, 0x898673, 0xffffec, 0xf7ecd8, 0xfaedda, 0xfff9e9, 0x60574e, 0x010000, 0x1a1b1f, 0x1b1d2a, 0x15161a, 0x342b22, 0x664a3e, 0x70453c, 0x4e2d28, 0x211d1a, 0x021815, 0x171715, 0x181816, 0x191917, 0x191917, 0x181816, 0x191917, 0x1b1b19, 0x1d1d1b, 0x211f20, 0x201e1f, 0x1d1b1c, 0x1b191a, 0x1b191a, 0x1c1a1b, 0x1e1c1d, 0x1f1d1e, 0x151515, 0x171717, 0x181818, 0x191919, 0x191919, 0x171717, 0x161616, 0x151515, 0x1d0f26, 0x16161e, 0x0d140c, 0x1a1907, 0x43301f, 0x6e4e43, 0x62473e, 0x2f1e16, 0x171c1f, 0x141819, 0x161614, 0x030000, 0x6e685c, 0xfffeed, 0xf9edd7, 0xfaebd4, 0xfcffec, 0x6d705f, 0x010300, 0x1d1e16, 0x1c1d18, 0x070707, 0x2d2c31, 0xe1e0e6, 0xfdfcff, 0xededed, 0x41423d, 0x010200, 0x1c1d15, 0x1d1e19, 0x181818, 0x1b1a1f, 0x0a0002, 0x816e4e, 0xffe7ab, 0xf9cf93, 0xf9cc89, 0xf8cf7f, 0xffe2a4, 0xc4a185, 0x0a050b, 0x3d270f, 0xf4ac4a, 0xffc681, 0xffce9d, 0xf7cd77, 0xf3d893, 0xffc58b, 0xfcd182, 0xfbc893, 0xffd6a7, 0xf8c278, 0xe9b75e, 0xfccc82, 0xffda9e, 0xf2cc8d, 0xffe8a9, 0x968a62, 0x040507, 0x351700, 0xd49224, 0xffb83f, 0xffcb80, 0xf8d595, 0xffd592, 0x7e471e, 0xc8932b, 0xebb829, 0xffd68f, 0xffd5a3, 0xf7b545, 0xea940b, 0xffbd55, 0xface91, 0xfad29f, 0xffba5b, 0xffa21d, 0xfb9f22, 0xf8ae4b, 0xffc26c, 0xffd795, 0xffd28b, 0xf1ae53, 0xf0961c, 0xffa81f, 0xfca534, 0x935929, 0x29090e, 0x995612, 0xcaa147, 0x1c0c00, 0xbb6f31, 0xc2792a, 0x231b28, 0x161213, 0x020611, 0x0f0000, 0x533626, 0x624036, 0x5e453e, 0xfdf9f0, 0xfbfffb, 0xfcfcfe, 0xfffbff, 0xffffff, 0xffffff, 0xfdfdfd, 0x707070, 0xc8c8c8, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xffffff, 0xfefefe, 0xe7e7e7, 0xdfdfdf, 0xffffff, 0xfffcf3, 0xfef9f5, 0xfcffff, 0xf8ffff, 0xf6fbff, 0xfffffd, 0xaea198, 0x220f00, 0x0d0400, 0x23291d, 0x26232e, 0x020e1a, 0x41210a, 0xc96c31, 0x784a16, 0x3b3a36, 0xb59751, 0x240000, 0x4d2001, 0xc28131, 0xffa44c, 0xfe9f1d, 0xf1a418, 0xfdb873, 0xffdd83, 0xffc37b, 0xeea445, 0xf9a022, 0xffa023, 0xfba832, 0xffc86e, 0xfdd7b3, 0xfdcc94, 0xfba117, 0xffa220, 0xffc691, 0xffd490, 0xffb835, 0xeeaf45, 0x3f2e14, 0xbc8c44, 0xfddc97, 0xffd799, 0xffbf68, 0xfab23c, 0xa47024, 0x110000, 0x2e2a27, 0xfce0a1, 0xf1d78d, 0xffe9a8, 0xf0d1a2, 0xa9874a, 0xd6b158, 0xffe698, 0xfec49c, 0xf4cd94, 0xffd092, 0xffca8a, 0xffcd92, 0xf9cf95, 0xfed18e, 0xffc76f, 0xeaa035, 0x161719, 0x332c12, 0xecd19a, 0xffdc98, 0xffcd8b, 0xfdcb8c, 0xfbd690, 0xffefa0, 0xa89074, 0x140a08, 0x0b1016, 0x1a241b, 0x191911, 0x281e29, 0x0a070e, 0x000500, 0xc4c4c4, 0xffffff, 0xffffff, 0x626262, 0x000000, 0x1b1b1b, 0x181818, 0x030303, 0x383526, 0xf7f1e1, 0xfdf2e0, 0xfff3e2, 0xfff6e8, 0x4b443c, 0x010000, 0x1a1e21, 0x14171c, 0x151714, 0x292315, 0x644938, 0x86584b, 0x74453d, 0x482d26, 0x110c06, 0x1b1a18, 0x1e1d1b, 0x1f1e1c, 0x1b1a18, 0x151412, 0x131210, 0x171614, 0x1b1a18, 0x1e1920, 0x1d181f, 0x1d181f, 0x1c171e, 0x1a151c, 0x18131a, 0x161118, 0x151017, 0x191a1c, 0x1c1d1f, 0x1c1d1f, 0x18191b, 0x131416, 0x131416, 0x191a1c, 0x1f2022, 0x201e2c, 0x0d0e12, 0x131307, 0x42311d, 0x795442, 0x845950, 0x543834, 0x241917, 0x171b1c, 0x171918, 0x1b1b19, 0x030000, 0x5c584c, 0xfffeee, 0xfcf1df, 0xfef3df, 0xe7e9db, 0x252719, 0x090b00, 0x22231d, 0x1a1b16, 0x000000, 0x757577, 0xfffeff, 0xfefcff, 0xb1b0b6, 0x040404, 0x0f100b, 0x20211c, 0x1b1b1b, 0x18171d, 0x16141f, 0x160702, 0xb6a379, 0xffe7a5, 0xf6cd8b, 0xfccd85, 0xf2ca73, 0xfedc94, 0xedcba5, 0x1d1a13, 0x311b06, 0xf6ae4c, 0xffc172, 0xffd1a0, 0xfbd081, 0xf3d895, 0xffc68c, 0xffd284, 0xfdca91, 0xffc99a, 0xffd896, 0xdeb364, 0xa8833f, 0xffe2ac, 0xefd7a7, 0xffe596, 0xd8cb94, 0x2c2920, 0x120000, 0xa3681c, 0xf5aa44, 0xffc777, 0xf5d08c, 0xffdf83, 0x8a6f5c, 0x4a3e04, 0xebc22c, 0xfcb948, 0xffcaae, 0xffd198, 0xea9e0a, 0xfea531, 0xffc178, 0xffd7a3, 0xffc272, 0xf9a531, 0xfca325, 0xf7a22d, 0xf6a232, 0xffc77b, 0xffd58c, 0xffc06a, 0xeb9b2c, 0xfba01c, 0xffaf3a, 0xba7733, 0x51210a, 0x310400, 0xad9660, 0x2f2b2c, 0x904b14, 0xc07927, 0x241e1e, 0x120c0e, 0x2a2f33, 0x27231a, 0x0c0000, 0x261412, 0xa59a98, 0xfffffb, 0xfafffb, 0xf8f6f7, 0xfffcff, 0xffffff, 0xf9f9f9, 0xffffff, 0xd8d8d8, 0xf4f4f4, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xf7f7f7, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xfffaed, 0xfff9f0, 0xfffffd, 0xfcffff, 0xf4f9fd, 0xfeffff, 0xdfdbd8, 0x060000, 0x140b06, 0xb6bcb2, 0x6d6a75, 0x000c15, 0x40250a, 0xc16830, 0x512800, 0x383b40, 0x4b4829, 0x140000, 0x7a4418, 0xd0811a, 0xffa548, 0xfea12a, 0xf0ab2c, 0xffc993, 0xffc960, 0xeda843, 0xec9723, 0xffa61e, 0xffa41b, 0xf2aa34, 0xffce82, 0xfeddbe, 0xffbe63, 0xe4910d, 0xffb65a, 0xffd9a1, 0xf6bc50, 0xfdbd39, 0x8d601d, 0x2d2d23, 0xffdb8b, 0xf6d495, 0xfacd8a, 0xffc565, 0xe29634, 0x67420e, 0x0a0000, 0x7e735f, 0xfce28d, 0xf0d98d, 0xfff5bb, 0x928050, 0x634d13, 0xffe198, 0xffd793, 0xffc896, 0xf8d198, 0xffd193, 0xffc989, 0xffcd92, 0xfcd298, 0xffd28f, 0xffc66e, 0xeaa035, 0x090a05, 0x51482b, 0xfde0a6, 0xfcd089, 0xfec784, 0xfecc8d, 0xf6cf8c, 0xffe79a, 0xd5be94, 0x231910, 0x050a10, 0x162018, 0x131309, 0x231a1f, 0x272528, 0x000500, 0x6d6d6d, 0xf7f7f7, 0xffffff, 0xb3b3b3, 0x030303, 0x161616, 0x1a1a1a, 0x161616, 0x050200, 0xb1ada2, 0xfffdf1, 0xfff6e8, 0xf9efe3, 0x403c33, 0x000000, 0x1a1e1f, 0x161817, 0x10160c, 0x100f00, 0x48311f, 0x7d4d3f, 0x864c41, 0x724339, 0x432318, 0x1b1110, 0x231918, 0x2c2221, 0x322827, 0x2f2524, 0x281e1d, 0x1f1514, 0x1a100f, 0x171a21, 0x191c23, 0x1c1f26, 0x1e2128, 0x1e2128, 0x1c1f26, 0x1a1d24, 0x181b22, 0x1c1c1c, 0x161616, 0x141414, 0x1b1b1b, 0x272727, 0x2d2d2d, 0x292929, 0x222222, 0x24242c, 0x151410, 0x3c2f1f, 0x73503a, 0x8a5543, 0x7a483f, 0x452928, 0x121013, 0x18191b, 0x181a19, 0x21221d, 0x010100, 0x525044, 0xfbf7eb, 0xfaf4e4, 0xfffcea, 0xa3a59a, 0x050600, 0x191a14, 0x191a15, 0x141412, 0x101010, 0xc0c0c2, 0xffffff, 0xfffbff, 0x625f68, 0x010002, 0x232220, 0x1a1917, 0x110f12, 0x1c1922, 0x0c0816, 0x332616, 0xe2d09e, 0xfcde96, 0xf9ce8a, 0xffcf85, 0xf2c96d, 0xf9d685, 0xfeddaa, 0x35341f, 0x250d01, 0xf4ab4c, 0xffc062, 0xffd4a3, 0xfed289, 0xf5da97, 0xffcd93, 0xfed083, 0xffd297, 0xf1bd8b, 0xffe0a4, 0xf1cb84, 0x6d520f, 0x9b8755, 0xfff2cd, 0xf2d682, 0xf4e39e, 0x625c42, 0x0b0000, 0x78441d, 0xe89745, 0xffc26c, 0xfdd590, 0xffc876, 0xe8dd9d, 0x252410, 0x967a30, 0xebb31e, 0xffbe79, 0xffcebd, 0xf1bb3f, 0xf58d10, 0xffb55d, 0xffd9a0, 0xfac382, 0xeba641, 0xfda82b, 0xffa31f, 0xfb9817, 0xf8a94d, 0xffc674, 0xffcc78, 0xf5ac45, 0xf3a123, 0xffb036, 0xd48830, 0x793802, 0x160000, 0x4c4630, 0x28323e, 0x77390a, 0xaf6b1a, 0x252116, 0x080204, 0x6b716d, 0xc2c7cd, 0x0a0d12, 0x0c0b11, 0xf4f3f8, 0xffffff, 0xfefefe, 0xfffefd, 0xfffcfd, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfbfbfb, 0xfffcf1, 0xfffdf4, 0xfffefb, 0xfeffff, 0xfcffff, 0xfcffff, 0xf3f7fa, 0x222325, 0x665a5a, 0xfcfffa, 0x65636e, 0x00040b, 0x382004, 0xab5822, 0x3d1a00, 0x0a1121, 0x000b11, 0x2c180f, 0x995820, 0xdd8019, 0xffa935, 0xf79e2a, 0xfbb34f, 0xffc481, 0xeda737, 0xf2a12b, 0xffa127, 0xfea01c, 0xe49208, 0xedae3c, 0xffd994, 0xf7cda3, 0xffa115, 0xdd9936, 0xffc992, 0xffbd61, 0xffc034, 0xb8923f, 0x160400, 0xafa077, 0xffe28a, 0xeac78f, 0xfec983, 0xffc058, 0xca7d2d, 0x381f09, 0x030300, 0xaa9872, 0xfae386, 0xfff6b3, 0xbfaa7b, 0x2a1b00, 0xaa9755, 0xffe8a7, 0xf6c98e, 0xffd198, 0xfbd49b, 0xffd193, 0xffc989, 0xffcf94, 0xfcd298, 0xffd592, 0xffc66e, 0xe2982d, 0x030400, 0x7a704d, 0xffe9aa, 0xf6c77f, 0xfac380, 0xffcd8e, 0xf5cc8a, 0xfcde95, 0xf3dca6, 0x3e3224, 0x080b14, 0x131a13, 0x191708, 0x100605, 0x252024, 0x091106, 0x2e2e2e, 0xfafafa, 0xffffff, 0xf2f2f2, 0x1a1a1a, 0x0f0f0f, 0x1c1c1c, 0x1f1f1f, 0x010000, 0x5b5652, 0xfffdf6, 0xfff9ef, 0xebe3d8, 0x37322c, 0x080a07, 0x181e1e, 0x1e1d1b, 0x171a11, 0x0c0f00, 0x382715, 0x724737, 0x915348, 0x92564b, 0x774335, 0x372420, 0x35221e, 0x372420, 0x3d2a26, 0x44312d, 0x44312d, 0x3e2b27, 0x36231f, 0x0e1213, 0x0d1112, 0x0c1011, 0x0c1011, 0x0e1213, 0x101415, 0x141819, 0x161a1b, 0x100501, 0x1d120e, 0x2e231f, 0x3b302c, 0x3e332f, 0x3b302c, 0x372c28, 0x342925, 0x291d1f, 0x3f3128, 0x6c513e, 0x84543e, 0x894a39, 0x7a453f, 0x402a2c, 0x0c1115, 0x191919, 0x181816, 0x1f201b, 0x040300, 0x45453d, 0xf2f0e4, 0xfffef2, 0xfefcef, 0x454641, 0x000100, 0x1f201b, 0x11110f, 0x0e0e0c, 0x2b2b2b, 0xf5f5f5, 0xfcfcfc, 0xf2ecf8, 0x1a151c, 0x0d090a, 0x282421, 0x100c09, 0x100c0d, 0x1e1920, 0x05000b, 0x4f4029, 0xf7e4ac, 0xf6d68d, 0xfed18e, 0xffcd84, 0xf5ca6e, 0xf9d57f, 0xffe0a6, 0x5d5f3a, 0x230a06, 0xeba243, 0xffc457, 0xffd4a1, 0xfccf8e, 0xf2d794, 0xffcf95, 0xface87, 0xffd193, 0xffd09b, 0xf6c791, 0xffe4a3, 0xa58d47, 0x211000, 0xd0c3a3, 0xfdeda0, 0xffeaa1, 0x93875d, 0x060002, 0x4b221c, 0xd8853f, 0xffba58, 0xffda92, 0xe8c07a, 0xfff38f, 0x9e9076, 0x0c0000, 0xb89827, 0xffc141, 0xffba81, 0xf5cb8f, 0xf99211, 0xfda541, 0xffd18a, 0xffcf91, 0xeaad54, 0xe9961c, 0xf69510, 0xffa92b, 0xf5992a, 0xfeae4f, 0xffc16b, 0xfcb450, 0xf5a52a, 0xffac2e, 0xe38f2c, 0x9a4c04, 0x2c1e2d, 0x030305, 0x07182a, 0x662b09, 0xa6641a, 0x2f2c1b, 0x060005, 0x777c75, 0xf8ffff, 0x3d464f, 0x212a31, 0xfbffff, 0xfdfcff, 0xfffbfc, 0xfffdfc, 0xfffefd, 0xfcfcfc, 0xffffff, 0xf8f8f8, 0xffffff, 0xfbfbfb, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xfef9f5, 0xfffefa, 0xfefaf7, 0xf9f9f9, 0xfeffff, 0xfafeff, 0xfcffff, 0x919598, 0xdfd3d7, 0xfcfffb, 0x66646f, 0x000609, 0x3a2709, 0x9e4e19, 0x503210, 0x011027, 0x00091c, 0x452e0c, 0xa25914, 0xf8922e, 0xffab29, 0xef9b27, 0xffb45b, 0xf7ab49, 0xe89424, 0xffb134, 0xffa635, 0xda8010, 0xc47f00, 0xf5bd50, 0xffde94, 0xecb16b, 0xfa8f00, 0xf5b666, 0xfec68d, 0xffc44e, 0xd89b1e, 0x180b00, 0x4f4842, 0xffee9f, 0xe8ba5a, 0xf4d3a0, 0xffd187, 0xffa837, 0xb9692a, 0x1e1317, 0x040e03, 0xc8af77, 0xfffeab, 0xfbe0b1, 0x3a2000, 0x574000, 0xfbe08f, 0xfbd799, 0xffd3a1, 0xffcf92, 0xfcd59c, 0xffd193, 0xffcc8c, 0xffd196, 0xfbd197, 0xffd693, 0xfdc169, 0xca8015, 0x111204, 0xb4a882, 0xffecaa, 0xf8c87e, 0xfbc27d, 0xffcf93, 0xfad191, 0xfedd96, 0xf7dfa1, 0x524535, 0x05050d, 0x11170d, 0x494730, 0x1b1108, 0x0f090d, 0x121615, 0x060606, 0xdcdcdc, 0xfafafa, 0xffffff, 0x3d3d3d, 0x030303, 0x1e1e1e, 0x191919, 0x100f14, 0x1b1718, 0xe9e1de, 0xfffdf6, 0xddd4cd, 0x27241f, 0x090e0a, 0x141d1c, 0x201519, 0x1a1b16, 0x13190d, 0x2b2316, 0x644034, 0x8f554a, 0x935548, 0x864d3c, 0x735148, 0x634138, 0x523027, 0x4c2a21, 0x533128, 0x5c3a31, 0x603e35, 0x5f3d34, 0x3e342b, 0x362c23, 0x2b2118, 0x21170e, 0x1d130a, 0x20160d, 0x261c13, 0x2a2017, 0x4a2d25, 0x53362e, 0x5b3e36, 0x5a3d35, 0x53362e, 0x4f322a, 0x52352d, 0x573a32, 0x57312e, 0x734f43, 0x805743, 0x8a533e, 0x955647, 0x6f3e39, 0x2b1b1b, 0x0e1c1d, 0x1b1a18, 0x171612, 0x181914, 0x040500, 0x32332d, 0xe9eae2, 0xfffff8, 0xd4d5cd, 0x0e0e0e, 0x070707, 0x1e1e1e, 0x161616, 0x070707, 0x4b4b4b, 0xfffffd, 0xfffffd, 0xc5bec5, 0x040000, 0x1f1a16, 0x19150c, 0x201c13, 0x3c3733, 0x1a1416, 0x040004, 0x5e4e34, 0xfae5ae, 0xf5d48f, 0xffd398, 0xffcc8a, 0xf5c76f, 0xfbd580, 0xffe3a7, 0x979b68, 0x2e1318, 0xd58c2d, 0xffc349, 0xffd19e, 0xfacc91, 0xeed390, 0xffcb91, 0xfed293, 0xfccf8e, 0xffd69c, 0xfbcc98, 0xffe0a0, 0xf0d385, 0x472f00, 0x513a1a, 0xf7f0b9, 0xfff2af, 0xb7a871, 0x040a0a, 0x250917, 0xc46f2e, 0xffa93a, 0xffd58d, 0xf4cf88, 0xedbd68, 0xffefae, 0x322b21, 0x301c01, 0xd79d20, 0xffc543, 0xf9c8aa, 0xffac31, 0xf09928, 0xffbf6a, 0xffdc97, 0xf8bc64, 0xd1820b, 0xd57600, 0xffac48, 0xffa11f, 0xf5a033, 0xf6ac4d, 0xf6ac43, 0xf8a326, 0xffaa2c, 0xee952d, 0xb05d0f, 0x37262e, 0x040309, 0x000d1c, 0x622a13, 0x9a5a1d, 0x232112, 0x08000f, 0x77796e, 0xfdfdff, 0xb7bec6, 0x939ea2, 0xf8ffff, 0xfffdff, 0xfffcff, 0xfaf6f7, 0xfeffff, 0xf9f9f9, 0xffffff, 0xf8f8f8, 0xfefefe, 0xfbfbfb, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xf3f7fa, 0xfeffff, 0xfefefe, 0xf8f7f5, 0xfffefc, 0xfbfbfb, 0xffffff, 0xf4f5f7, 0xfffaff, 0xf9fefa, 0x9898a0, 0x001315, 0x281700, 0x8f4311, 0x563b1e, 0x061735, 0x0d1a23, 0x583c0d, 0xad5f0a, 0xffa036, 0xffa729, 0xf1a130, 0xffab44, 0xfd9e20, 0xf8972c, 0xffb639, 0xeb8926, 0xb3610b, 0xc78e1b, 0xffcc63, 0xffcc7b, 0xefa03b, 0xf69b16, 0xffbf5e, 0xffbd56, 0xf4b140, 0x5e3a00, 0x050600, 0xddcfaa, 0xffd379, 0xe2b54e, 0xffe1b3, 0xffce81, 0xf88e16, 0xa35322, 0x0d0b21, 0x192a20, 0xf3d491, 0xfff1b1, 0x8c6e54, 0x1d0000, 0xcaa756, 0xffdb7a, 0xffd392, 0xffd8aa, 0xface91, 0xf9d299, 0xffcf91, 0xffcf8f, 0xffd499, 0xf9cf95, 0xffd491, 0xf2b65e, 0xa95f00, 0x2e2d1b, 0xe8dcb2, 0xffe3a0, 0xf7c67a, 0xfbc07c, 0xffd297, 0xffd699, 0xfad994, 0xf4dc9c, 0x625544, 0x000005, 0x171b0c, 0xa19e7f, 0x574b3d, 0x090005, 0x191921, 0x000000, 0x939393, 0xfafafa, 0xf9f9f9, 0x797979, 0x000000, 0x1e1e1e, 0x151515, 0x1c1a25, 0x010004, 0x92898a, 0xfffdf8, 0xd9d2cc, 0x191813, 0x0a0f0b, 0x141e1d, 0x21101a, 0x1a181b, 0x141d18, 0x15150d, 0x4b3029, 0x87554e, 0x8a5044, 0x864d3a, 0x8f5f51, 0x855547, 0x7a4a3c, 0x764638, 0x774739, 0x7a4a3c, 0x78483a, 0x754537, 0x926457, 0x8c5e51, 0x825447, 0x794b3e, 0x744639, 0x744639, 0x76483b, 0x784a3d, 0x97675b, 0x855549, 0x734337, 0x714135, 0x7a4a3e, 0x815145, 0x7c4c40, 0x734337, 0x8f4e48, 0x8f574a, 0x84503b, 0x935a47, 0x965c50, 0x532a24, 0x140a08, 0x0e211f, 0x1c1b17, 0x181713, 0x1a1915, 0x0a0b06, 0x22241f, 0xe7eae3, 0xfcfffa, 0x7b8079, 0x040308, 0x16151a, 0x1c1c1e, 0x19191b, 0x030303, 0x898987, 0xf8f8f6, 0xfffffd, 0x827c7c, 0x040000, 0x201c11, 0x0d0a00, 0x5d5a4b, 0x989489, 0x130e0a, 0x060000, 0x6c5a42, 0xffe8b4, 0xf9d696, 0xffd19c, 0xffce92, 0xf4c671, 0xf4ce7b, 0xffe2a6, 0xcfd597, 0x381d26, 0xb56c0e, 0xf7bd38, 0xffcd98, 0xfecf9b, 0xf0d592, 0xffc88e, 0xfed79e, 0xfad18f, 0xf9cb8f, 0xffdaa8, 0xffd391, 0xffdd85, 0xbd9b53, 0x1c0000, 0x8a896b, 0xffe6ab, 0xdcc987, 0x0e1d18, 0x16041a, 0xa95413, 0xeb9116, 0xffcf85, 0xffd89d, 0xe5ad60, 0xffe37c, 0xd5bf90, 0x130011, 0x61470e, 0xdfb52f, 0xffbd65, 0xffbc49, 0xeb9822, 0xfcad48, 0xffd180, 0xffc86e, 0xd98c1a, 0xbd6600, 0xd98944, 0xffaf1d, 0xf6a025, 0xf1a239, 0xf6a232, 0xfc9f1e, 0xffab2c, 0xf79a33, 0xbc661b, 0x442c20, 0x1d1415, 0x00121c, 0x693124, 0x8a4a1c, 0x0e0e04, 0x10011e, 0xb0aea2, 0xfff7fb, 0xffffff, 0xf2fdf9, 0xfcffff, 0xfffcff, 0xfffaff, 0xfdfbfe, 0xf8ffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xfafafa, 0xf4feff, 0xf9ffff, 0xfcffff, 0xfffffd, 0xfffefb, 0xfffbf8, 0xf8f7f5, 0xffffff, 0xfff7ff, 0xfcfffd, 0xdbdbe3, 0x001010, 0x170800, 0x924916, 0x4d3519, 0x000b2c, 0x101916, 0x6a4818, 0xbf6c0e, 0xffa12c, 0xf59e2a, 0xfaac3d, 0xfaa026, 0xff9f12, 0xffa53c, 0xffaa30, 0xc3630c, 0xa35612, 0xe0af48, 0xffd46e, 0xffb65f, 0xfc9f26, 0xf7af4b, 0xffaa31, 0xffc12b, 0x8f5a00, 0x0a0000, 0xa1a49b, 0xfff6ab, 0xf1a955, 0xf9cd62, 0xfedbb1, 0xfebc6e, 0xf08205, 0x8e3d12, 0x00001e, 0x2c4138, 0xfff1a7, 0xcdbb89, 0x180000, 0x5f321b, 0xeec269, 0xfdce62, 0xffd290, 0xfccba2, 0xffd79a, 0xf7d097, 0xfdcd8f, 0xffd292, 0xffd79c, 0xf8ce94, 0xffd28f, 0xe8ac54, 0x914700, 0x454430, 0xfff9cd, 0xf5d791, 0xf1c073, 0xfabf7b, 0xffd69b, 0xffd99c, 0xf3d08c, 0xffe9a6, 0x786858, 0x000004, 0x202511, 0xe8e6c0, 0x8f8472, 0x0c020a, 0x1c1c28, 0x050505, 0x595959, 0xffffff, 0xffffff, 0xb6b6b6, 0x000000, 0x1d1d1d, 0x181818, 0x1c1c28, 0x010007, 0x423c3e, 0xfffaf7, 0xddd6d0, 0x171611, 0x0c120e, 0x172120, 0x2a1421, 0x201b22, 0x151f1e, 0x010602, 0x37241e, 0x875a54, 0x8d584a, 0x8d5846, 0x8b5440, 0x8d5642, 0x915a46, 0x945d49, 0x955e4a, 0x935c48, 0x8f5844, 0x8c5541, 0x964c3f, 0x984e41, 0x9b5144, 0x9e5447, 0xa05649, 0xa05649, 0xa05649, 0x9f5548, 0x874c3e, 0x8e5345, 0x955a4c, 0x94594b, 0x905547, 0x8e5345, 0x925749, 0x975c4e, 0xa14e46, 0x975243, 0x8a4f3d, 0x925a49, 0x824c42, 0x45201a, 0x17120e, 0x071e18, 0x1e1a17, 0x1a1915, 0x21201c, 0x13140f, 0x1b1d18, 0xe5eae4, 0xf6fdf6, 0x2a312a, 0x040309, 0x1c1b21, 0x18171c, 0x151517, 0x040404, 0xcbcbc9, 0xfcfcfa, 0xfcfdf8, 0x4e4945, 0x0a0600, 0x1a1708, 0x0d0a00, 0x9a9784, 0xeae7d8, 0x0f0b02, 0x080300, 0x7a6850, 0xffefbd, 0xfcd89c, 0xffcc9c, 0xffd199, 0xf4c575, 0xeec575, 0xffdca0, 0xf0f7b3, 0x3b1f2d, 0x9b5200, 0xeeb52a, 0xfecc97, 0xffd6a5, 0xf6db98, 0xffca90, 0xfcd7a2, 0xf9d291, 0xfdcf93, 0xfec997, 0xffd492, 0xffd578, 0xe6bd6d, 0x4b2000, 0x020200, 0xf3cf9b, 0xf7e39c, 0x203429, 0x180b25, 0x933e00, 0xdb7e00, 0xfdcd83, 0xffd6b3, 0xf6c568, 0xe4bd44, 0xfff6b5, 0x907885, 0x01010b, 0x907421, 0xffb90a, 0xf9bd4f, 0xec9d24, 0xf6a434, 0xfab95f, 0xffc86b, 0xf7a93c, 0xb9680d, 0xa25b2d, 0xffb519, 0xfca824, 0xf7a633, 0xf9a02c, 0xff9c1a, 0xffab2b, 0xfa9c3a, 0xbd6923, 0x65462a, 0x1f120a, 0x000e15, 0x6d342d, 0x83431f, 0x0c0d07, 0x1a0a2e, 0xf5f1e6, 0xfff9f8, 0xfef9f5, 0xfbfffb, 0xfefffd, 0xfff9fd, 0xfff1f8, 0xfffeff, 0xf3ffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfefefe, 0xfbfbfb, 0xfafafa, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffefb, 0xfffefb, 0xfaf6f3, 0x423e3b, 0x040000, 0x44403d, 0x484441, 0x0b0704, 0x3a231b, 0x874721, 0xc67019, 0xffb63c, 0xec9e20, 0xffa32b, 0xffa927, 0xffa30d, 0xecc989, 0x824d01, 0x852f18, 0xdb8635, 0xffb633, 0xffbf67, 0xf9a739, 0xf7a012, 0xf6a60f, 0xf8b741, 0xb8914c, 0x0b0000, 0x565340, 0xfff0b5, 0xffce97, 0xf9a71f, 0xece5b9, 0xffe08d, 0xffb241, 0xcc781e, 0x613915, 0x030000, 0x7c7f60, 0xf3ebaa, 0x182943, 0x190000, 0xb1730c, 0xecc137, 0xfbd79b, 0xfdd1ae, 0xfed28b, 0xfdd496, 0xfede89, 0xffdaad, 0xffc396, 0xffd7a4, 0xf8daa6, 0xffb85a, 0xf1a744, 0x1e1e00, 0x737a59, 0xffedb7, 0xffd088, 0xf1b06c, 0xffd195, 0xffd092, 0xffd195, 0xf6d298, 0xffecb3, 0x73674d, 0x030000, 0x302e17, 0xe8dea3, 0xe9d99b, 0x1f0f00, 0x190b22, 0x0c0c0c, 0x2d2d2d, 0xf7f7f7, 0xffffff, 0xeeeeee, 0x202020, 0x080808, 0x1a1a1a, 0x1d1d1d, 0x101211, 0x000301, 0xbfc8c3, 0xf8fefa, 0x000000, 0x1a1112, 0x24181a, 0x1e1b16, 0x121315, 0x161a23, 0x141622, 0x150811, 0x5e3b39, 0xa66d5c, 0x934b33, 0x8e5448, 0x935b4e, 0x925d4f, 0x8b5648, 0x945c4f, 0x995b50, 0x914e45, 0x9e5850, 0x91574b, 0x91574b, 0x91574b, 0x91574b, 0x91574b, 0x91574b, 0x91574b, 0x91574b, 0x91574b, 0x91574b, 0x90564a, 0x90564a, 0x90564a, 0x91574b, 0x93594d, 0x93594d, 0x846040, 0x8f5541, 0x974e47, 0xa7706b, 0x53403a, 0x080a05, 0x17161b, 0x281825, 0x1a1f19, 0x161815, 0x282423, 0x1a1114, 0x190e14, 0xfffbff, 0xb0a6af, 0x060005, 0x171a1f, 0x202125, 0x1b191a, 0x050000, 0x2d2727, 0xfffbfc, 0xffffff, 0xe5e6ea, 0x20151d, 0x0a0710, 0x050704, 0x292404, 0xf3e5a8, 0xdbca92, 0x221908, 0x000012, 0x86765f, 0xffe6b7, 0xffd694, 0xfcce92, 0xffd9af, 0xffcca5, 0xf5b47a, 0xffce7c, 0xf4fa98, 0x645f65, 0x301300, 0xeaaf2d, 0xffc272, 0xfddfa1, 0xf4de8b, 0xffcda8, 0xffd7a1, 0xffd098, 0xffd197, 0xfdd29f, 0xfddaa4, 0xffe39f, 0xf6b655, 0xb86500, 0x030303, 0x333f3d, 0xe6dfc5, 0x7a6a51, 0x030000, 0x6b472d, 0xc66c14, 0xffb843, 0xfad9ae, 0xffd599, 0xe3a923, 0xffcc65, 0xffebc2, 0x413a32, 0x0a0004, 0xc49b5d, 0xffc327, 0xf3a626, 0xff9a10, 0xffab2e, 0xfbbb64, 0xf4ad37, 0xf19d23, 0x5f2a02, 0xa46822, 0xf8ba4b, 0xf6af31, 0xf59f38, 0xf0992f, 0xffb42f, 0xf6a629, 0xc06c12, 0x83432a, 0x2c1913, 0x0a1010, 0x55473a, 0x51301f, 0x0f0000, 0x464847, 0xf3fff3, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffefb, 0xfdf9f6, 0xfffefb, 0x6f6b68, 0x030000, 0x2b2724, 0x2f2b28, 0x0b0704, 0x472813, 0xa15637, 0xbd5b1a, 0xf6a230, 0xf8b020, 0xfba618, 0xfca429, 0xffb94c, 0x6b561f, 0x491800, 0x8c3e10, 0xf7a13a, 0xfeab35, 0xfcaa46, 0xf7a329, 0xffa925, 0xffb72d, 0xdfa73a, 0x3e2000, 0x1b100a, 0xc6bb9d, 0xfff1ba, 0xf5be64, 0xf3ac3a, 0xe2daab, 0xffd986, 0xffa439, 0xbb6613, 0x5e3517, 0x0d0908, 0x5f624f, 0x8c8551, 0x01112a, 0x290400, 0xcd8e25, 0xface49, 0xfdd99f, 0xfdd1ac, 0xfed18d, 0xfdd397, 0xffd89a, 0xffd597, 0xffd19b, 0xffdcb5, 0xfcce90, 0xffbb49, 0xc48526, 0x080600, 0x9a9e79, 0xfff0b7, 0xffc77f, 0xecad68, 0xffcf92, 0xffce92, 0xffd296, 0xfcd89e, 0xffeeb9, 0x695d45, 0x060300, 0x3a361d, 0xf0e6ab, 0xf2e0a2, 0x4d3d26, 0x090011, 0x060606, 0x090909, 0xd5d5d5, 0xfafafa, 0xfbfbfb, 0x4a4a4a, 0x070707, 0x171717, 0x191313, 0x1f1e1c, 0x000501, 0x5e6460, 0xb5bbb7, 0x1f1f1d, 0x161010, 0x261a1c, 0x1d1916, 0x161618, 0x191d26, 0x1b1d29, 0x180e16, 0x472b27, 0x8d5f4f, 0x9c6348, 0x96584d, 0x965a4f, 0x985e52, 0x91574b, 0x93594d, 0x965a4f, 0x93554a, 0x9b5b51, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x965a4f, 0x975b50, 0x97634b, 0x925342, 0xa15e55, 0x8a5d57, 0x32281f, 0x111811, 0x1c1d21, 0x241623, 0x151714, 0x1f1f1d, 0x191816, 0x151112, 0x302b2f, 0xbbb6ba, 0x525055, 0x0c0b10, 0x171719, 0x1d1b1e, 0x1e1a1b, 0x030000, 0x605c5b, 0xfffeff, 0xf7f7f9, 0xbfbec3, 0x160d12, 0x06030c, 0x020401, 0x4e4929, 0xfdefb2, 0xf0dda3, 0x302511, 0x050414, 0x7b6c55, 0xffecbd, 0xffd893, 0xfed190, 0xffd8a9, 0xfbcaa1, 0xf1b475, 0xffc46d, 0xfffcb2, 0x8b8a78, 0x170100, 0xba7e28, 0xffbe51, 0xffd685, 0xfad9a3, 0xfdd1a2, 0xfdd69f, 0xfecf97, 0xffd39b, 0xfdd4a0, 0xf9d5a1, 0xffde9a, 0xfbbc5d, 0xce7b05, 0x0d0805, 0x091314, 0x8e8774, 0x675747, 0x120d13, 0x633d28, 0xb65b0a, 0xffa134, 0xffe6b6, 0xffd998, 0xeeb244, 0xffb751, 0xffeab1, 0xbeb5a4, 0x150a06, 0x472400, 0xe4b235, 0xfcad2e, 0xffaa23, 0xffa42c, 0xf4ad43, 0xffb335, 0xfba534, 0x87440f, 0x1c0000, 0xa27c2b, 0xf4ba3c, 0xffb43f, 0xfb9a2f, 0xfea42c, 0xf8ab35, 0xba7412, 0x904623, 0x3c2418, 0x030909, 0x2f261d, 0x40251a, 0x0a0000, 0x7c8083, 0xf9fffa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffffd, 0xf4f3f1, 0xfffffd, 0xabaaa8, 0x010000, 0x131210, 0x1e1d1b, 0x0c0b09, 0x59330c, 0xa14c2d, 0xcd5e29, 0xffaa3e, 0xf2b119, 0xffc535, 0xeaad52, 0x7d5120, 0x120f00, 0x350c08, 0xb26a1e, 0xffb63a, 0xf7982c, 0xfca531, 0xf8a326, 0xffa62b, 0xfdae35, 0x9b6e1d, 0x0b0000, 0x6b6855, 0xfff4c8, 0xffd292, 0xd5a328, 0xf5be6b, 0xece2ad, 0xffd582, 0xf0932c, 0xaf590e, 0x5b321c, 0x0f0c15, 0x353736, 0x251b00, 0x00011b, 0x492409, 0xe8a83a, 0xffd15a, 0xfdd69f, 0xffd3ac, 0xffd395, 0xfcd497, 0xffd1a8, 0xffcf84, 0xfddda2, 0xfbddb9, 0xffbf66, 0xffb42f, 0x7b4f04, 0x070010, 0xcfcaa0, 0xffecae, 0xfabc71, 0xedb06d, 0xffd49a, 0xffd096, 0xfcd296, 0xffdda5, 0xf6e3b8, 0x4e432d, 0x0c0800, 0x575235, 0xfbecb1, 0xfbe9ab, 0x897a63, 0x04000c, 0x171717, 0x000000, 0x9c9c9c, 0xf8f8f8, 0xffffff, 0x808080, 0x020202, 0x191919, 0x231816, 0x211916, 0x100f0b, 0x11130e, 0x575c58, 0x2c2c2a, 0x181415, 0x22191c, 0x1a1512, 0x1a181b, 0x1b1e25, 0x1c2127, 0x131315, 0x23160e, 0x664b38, 0xa48066, 0x9f5c53, 0x9b584f, 0xa15e55, 0x9e5e54, 0x9a5c51, 0x9a6054, 0x986053, 0x996154, 0x9d5f54, 0x9d5f54, 0x9d5f54, 0x9d5f54, 0x9d5f54, 0x9d5f54, 0x9d5f54, 0x9d5f54, 0x9d5f54, 0x9d5f54, 0x9e6055, 0x9e6055, 0x9e6055, 0x9d5f54, 0x9c5e53, 0x9c5e53, 0xa55d4f, 0xa1584f, 0xab7068, 0x63453b, 0x0e0e02, 0x152219, 0x1b1f20, 0x221821, 0x181413, 0x232220, 0x141414, 0x121413, 0x313534, 0x535957, 0x090f0d, 0x141d1a, 0x191411, 0x201b18, 0x201c1b, 0x030000, 0x9b999a, 0xfffeff, 0xf8f8fa, 0x88888a, 0x060000, 0x16151b, 0x010300, 0x858060, 0xfff5b9, 0xffedb2, 0x4e4026, 0x08050e, 0x5d5137, 0xffeebc, 0xffd992, 0xfed38f, 0xffd6a4, 0xfbcd9c, 0xf4b973, 0xfeb859, 0xfff1bf, 0xc4c299, 0x0a0000, 0x763e1d, 0xfbb12c, 0xffc85d, 0xffd2b0, 0xeed7a1, 0xfcd4a0, 0xfdd097, 0xffd49c, 0xfed5a1, 0xf7d39f, 0xffda95, 0xffc364, 0xe79621, 0x30231a, 0x000204, 0x2f2b22, 0x3c2f29, 0x1c1924, 0x5b3522, 0xad5307, 0xec892b, 0xeed49b, 0xffe49f, 0xfabe75, 0xf3a541, 0xffd07f, 0xfff2d1, 0x534e38, 0x140000, 0x967528, 0xffb739, 0xffa525, 0xffad3f, 0xf4a320, 0xffa820, 0xffad46, 0xc66c20, 0x0a0b1d, 0x1c1100, 0x876212, 0xf5ad49, 0xffb03e, 0xf9a020, 0xffb43f, 0xb7761c, 0xa04818, 0x53321f, 0x050e0d, 0x151611, 0x251716, 0x030005, 0xb8bfc5, 0xfbfffa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xf8f8f8, 0xffffff, 0xdddddd, 0x121212, 0x090909, 0x212121, 0x0d0d0d, 0x63370a, 0xaa5224, 0xc75a15, 0xfda939, 0xf9c241, 0xce9e3a, 0x68451b, 0x0c0000, 0x050a06, 0x4b2826, 0xd7932e, 0xffac30, 0xfa9627, 0xffb636, 0xef982e, 0xf7a327, 0xe6a541, 0x391600, 0x050310, 0xb6b49d, 0xfff0be, 0xffca70, 0xb48708, 0xd8b274, 0xfdf1b7, 0xffcf7c, 0xdb7c1e, 0xac5512, 0x603626, 0x0a0718, 0x1c1e2b, 0x0d0400, 0x000019, 0x6c4615, 0xf2af3a, 0xfcc75d, 0xfbd39f, 0xffd7ad, 0xffd59a, 0xfdd69b, 0xffcca8, 0xffd189, 0xf7e0ac, 0xf4d6a0, 0xffb43c, 0xe7971c, 0x331500, 0x302738, 0xf6e9b5, 0xffdf9a, 0xf3b465, 0xf7bc78, 0xffdda5, 0xffd59e, 0xfbd499, 0xffe1a8, 0xddcdac, 0x251d0a, 0x0a0700, 0x8c8362, 0xffeeb3, 0xffeeb3, 0xa69a80, 0x02000a, 0x5b5b5b, 0x010101, 0x585858, 0xffffff, 0xffffff, 0xaeaeae, 0x000000, 0x1a1a1a, 0x3f2a25, 0x1c0d08, 0x231c16, 0x0d0c07, 0x1a1c17, 0x161815, 0x1f1d1e, 0x1a1519, 0x171113, 0x1c1a1d, 0x181b20, 0x181d21, 0x131514, 0x0c0800, 0x3f3221, 0x917f67, 0xab685f, 0xa05c53, 0xa45e56, 0xaa645c, 0xa7645b, 0xa2665b, 0x9e695b, 0x966556, 0xa46158, 0xa46158, 0xa46158, 0xa46158, 0xa46158, 0xa46158, 0xa46158, 0xa46158, 0xa46158, 0xa56259, 0xa56259, 0xa56259, 0xa56259, 0xa46158, 0xa36057, 0xa25f56, 0xae5652, 0xb26963, 0x9c6d63, 0x3e2e21, 0x030900, 0x132017, 0x161c1c, 0x1c1a1f, 0x20171a, 0x1e1a1b, 0x1c1e1d, 0x101914, 0x17241d, 0x19261d, 0x09140c, 0x111b13, 0x281a11, 0x2f241e, 0x1e1916, 0x040205, 0xc3c4c8, 0xfffeff, 0xfffeff, 0x4b494a, 0x0c0704, 0x535458, 0x040605, 0xaba688, 0xfff1b6, 0xffeeb0, 0x80704f, 0x040000, 0x352b12, 0xf5dfae, 0xffdd96, 0xfcd590, 0xfdd8a3, 0xffd7a3, 0xfec67c, 0xf1ad4a, 0xffdaac, 0xf2ebbd, 0x20182d, 0x3a0d0a, 0xe19315, 0xffbb40, 0xffc89c, 0xecdfab, 0xfdd8a4, 0xfdd29b, 0xffd49e, 0xffd7a4, 0xf8d7a4, 0xffda97, 0xffc76a, 0xf6a731, 0x59432e, 0x000104, 0x0a0a0c, 0x180f14, 0x151321, 0x623927, 0xae520f, 0xd67526, 0xf3d595, 0xffeca5, 0xdea77e, 0xc77c1f, 0xffc862, 0xfff2c4, 0xa2a079, 0x110207, 0x35250b, 0xf2aa3b, 0xe5941e, 0xeeaa45, 0xffaa1c, 0xfe9f11, 0xffad4b, 0xf38b28, 0x2a342b, 0x030408, 0x100202, 0x664019, 0xe7ac46, 0xffb82e, 0xf5aa35, 0xb46b1c, 0xa5460c, 0x55331a, 0x0b1514, 0x171f21, 0x0e070e, 0x100f1d, 0xe3eaf4, 0xf8fdf6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfafafa, 0x3f3f3f, 0x010101, 0x202020, 0x0f0f0f, 0x592f07, 0xa25215, 0xda7f22, 0xfcbd53, 0xb28b3c, 0x452405, 0x0d0000, 0x0f1629, 0x1c1328, 0x6d4925, 0xe9a42b, 0xfe9e2e, 0xffac36, 0xfca92f, 0xbe6d1c, 0xf2ab2f, 0xa57930, 0x0f0002, 0x262a29, 0xdfd9c1, 0xffe9b4, 0xe8b03f, 0x8a5e00, 0xd5ba85, 0xfeeeb0, 0xfcc171, 0xc8660f, 0xaa5012, 0x663c2c, 0x0c0b1b, 0x1a2030, 0x231a1f, 0x02041d, 0x876118, 0xf4b033, 0xfbc269, 0xfdd5a2, 0xffd8aa, 0xffd4a1, 0xf9d59b, 0xffcb9b, 0xffd8a2, 0xf8dcad, 0xf5cd75, 0xffab24, 0xad6614, 0x0f0000, 0x70655f, 0xfff8ba, 0xffce81, 0xf0af5d, 0xffc784, 0xffe0aa, 0xfdd8a3, 0xfcd9a1, 0xffeab2, 0xc1b29d, 0x070000, 0x171200, 0xc7bb93, 0xffecb0, 0xfff0b7, 0x998d73, 0x020308, 0xbebebe, 0x464646, 0x1a1a1a, 0xffffff, 0xfdfdfd, 0xd7d7d7, 0x0d0d0d, 0x0e0e0e, 0x50312c, 0x361d18, 0x271811, 0x1b1610, 0x141510, 0x090b0a, 0x222224, 0x1b1a1f, 0x191418, 0x1d1b1e, 0x16151a, 0x18191b, 0x1f1f1d, 0x100d06, 0x1e180a, 0x584f3e, 0xb3776c, 0xac6960, 0xaa615a, 0xae635d, 0xad645d, 0xa9665d, 0xa36b5e, 0x9b6a5b, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa9655c, 0xa8645b, 0xa8645b, 0xbc6365, 0xb3726e, 0x68463c, 0x191104, 0x13160b, 0x191e18, 0x141817, 0x171b1c, 0x21161c, 0x191418, 0x202423, 0x0f1c15, 0x09190f, 0x0b170d, 0x1f251b, 0x0e1005, 0x493224, 0x3f2e24, 0x130b08, 0x1c1b20, 0xdfe2e9, 0xfbfeff, 0xfaf8fb, 0x100a0a, 0x59564f, 0xafb0b2, 0x020403, 0xa8a185, 0xffecb1, 0xffebaa, 0xc0ad85, 0x080000, 0x140d00, 0xd7c499, 0xffe6a3, 0xf9d694, 0xfcd8a4, 0xffdba7, 0xffd085, 0xe6a642, 0xffc98b, 0xfff7ce, 0x54515c, 0x120000, 0xad6510, 0xffaa32, 0xffbf71, 0xf7e2b3, 0xffdca8, 0xfed59f, 0xffd29e, 0xfdd7a6, 0xfdddac, 0xffde9d, 0xffc96d, 0xf9a936, 0x71512a, 0x0a0a08, 0x141720, 0x13111c, 0x13131f, 0x6b4129, 0xaa4e0d, 0xc2631f, 0xffda91, 0xffe9a6, 0xdab193, 0x8c4e00, 0xf4ba4f, 0xffeeb4, 0xd2d0a0, 0x1f161b, 0x010007, 0xb47820, 0xe9a53a, 0xb77c20, 0xffb029, 0xffa923, 0xffa840, 0xff9a24, 0x5e491e, 0x261f27, 0x070f36, 0x00000b, 0x493500, 0xb98829, 0xffbe59, 0xc57a1f, 0xa74e14, 0x482a10, 0x051313, 0x1b2527, 0x030005, 0x4d4a5b, 0xf8feff, 0xfefffb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfeff, 0xfeffff, 0xfafbfd, 0xfeffff, 0x838486, 0x020305, 0x0f1012, 0x0f1012, 0x492b09, 0x9a5d26, 0xb26f21, 0x7d5811, 0x170800, 0x0e0009, 0x221934, 0x061626, 0x401a33, 0x976318, 0xf1a722, 0xfea137, 0xffbc51, 0xbe7a17, 0x9e5e16, 0xefb844, 0x3d2f0c, 0x04000e, 0x4c4d3d, 0xf7e8cb, 0xffecac, 0x996900, 0x744807, 0xffe6b7, 0xfeeaab, 0xfbbc6f, 0xbe5909, 0xa74c13, 0x643e29, 0x0e1118, 0x161e29, 0x1d181c, 0x07051b, 0x9d7515, 0xf9b331, 0xffc67e, 0xffd9a9, 0xffd7a4, 0xfbcfa0, 0xf6d39b, 0xfed095, 0xffdeb3, 0xfdd095, 0xfdbb4a, 0xe59421, 0x643211, 0x0b0000, 0xb3a381, 0xfff6af, 0xf3bc69, 0xf3b15b, 0xffcf8b, 0xffdaa6, 0xf6d6a3, 0xfedfa8, 0xfff3bc, 0x9e9188, 0x060000, 0x4a442c, 0xeee0b3, 0xffe7aa, 0xffeeb8, 0x72684d, 0x000202, 0xffffff, 0x9e9e9e, 0x070707, 0xd4d4d4, 0xfefefe, 0xf7f7f7, 0x313131, 0x000000, 0x4b231b, 0x624037, 0x2c150d, 0x140b04, 0x25241f, 0x161817, 0x1b1f22, 0x1e2126, 0x1c1b20, 0x1b1b1d, 0x161417, 0x1d191a, 0x302b28, 0x271d1b, 0x130802, 0x251810, 0x9d6e5e, 0xb1796c, 0xb26c64, 0xad5e59, 0xb05f5b, 0xae635d, 0xac6960, 0xa66c60, 0xb06760, 0xb06760, 0xb06760, 0xb06760, 0xb06760, 0xb06760, 0xb06760, 0xb06760, 0xb06760, 0xaf665f, 0xae655e, 0xae655e, 0xaf665f, 0xb06760, 0xb26962, 0xb36a63, 0xc2777b, 0x8e5d58, 0x301c11, 0x090300, 0x2b241c, 0x2a2220, 0x181816, 0x121d19, 0x1d121a, 0x1c171b, 0x181e1c, 0x0e1b12, 0x172319, 0x111308, 0x22180e, 0x27140d, 0x664732, 0x412b1d, 0x070000, 0x45464b, 0xf5fcff, 0xfbffff, 0xc6c4c5, 0x060000, 0xc2c2b6, 0xe9edec, 0x000100, 0x878066, 0xffeab1, 0xffeaa8, 0xf2dbaf, 0x3b2e1b, 0x070000, 0xb19e7d, 0xffeeb5, 0xf9d69c, 0xf9d9aa, 0xfedaaa, 0xffd68e, 0xe6a746, 0xfdc06d, 0xffeebf, 0x999383, 0x070000, 0x6c350e, 0xe78a22, 0xfdaf40, 0xffd8a2, 0xfeddaa, 0xffd8a4, 0xffd4a1, 0xfcd6a7, 0xfedfb0, 0xffe0a1, 0xffc96f, 0xf7aa38, 0x886025, 0x090900, 0x181e2a, 0x191d29, 0x11141b, 0x6a4121, 0xa54906, 0xb85c1d, 0xf7c06e, 0xfee1a7, 0xfce4c0, 0x704200, 0xb67f22, 0xffefae, 0xece3b8, 0x473f34, 0x000017, 0x603900, 0xfcc163, 0x8e5600, 0xd48f2a, 0xffb03b, 0xfca62f, 0xffa82c, 0x9e5f29, 0x250a01, 0x021229, 0x092638, 0x000102, 0x270800, 0x936124, 0xb5811b, 0xa35b2b, 0x3f2d19, 0x001111, 0x111717, 0x0d0103, 0x9a92a1, 0xfafcff, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcffff, 0xfcffff, 0xfbffff, 0xfcffff, 0xd1d5d8, 0x212528, 0x010508, 0x121619, 0x382908, 0x82553e, 0x390a00, 0x100400, 0x162119, 0x20232a, 0x242430, 0x00060c, 0x682129, 0xb8700e, 0xfaa71b, 0xffae37, 0xe9a252, 0x824c0c, 0xbc9339, 0xb98e30, 0x030d16, 0x050a06, 0x6c614f, 0xffeec7, 0xfeda8c, 0x5f3900, 0x987243, 0xffefc6, 0xffecad, 0xf5b26b, 0xb64f04, 0xaa4f16, 0x654025, 0x0e1410, 0x101c1c, 0x12110d, 0x100b22, 0xaf8715, 0xfdb52d, 0xffc88b, 0xffdbab, 0xfed6a2, 0xfbd0a6, 0xf7d49e, 0xffd8a0, 0xf7dbac, 0xf9be64, 0xfd9a22, 0xb16824, 0x260a09, 0x3d2f26, 0xf2dba7, 0xffe596, 0xe9ae54, 0xfdba63, 0xffdb99, 0xf8d7a4, 0xf0d4a2, 0xfbe0a9, 0xfff4bc, 0x6b615f, 0x060000, 0xa0997f, 0xffeebe, 0xffe1a3, 0xffeab4, 0x534c30, 0x000400, 0xf8f8f8, 0xe7e7e7, 0x2b2b2b, 0x878787, 0xffffff, 0xffffff, 0x5e5e5e, 0x000000, 0x3f0f05, 0x6f473f, 0x43281f, 0x1a0d05, 0x201f1a, 0x1d2120, 0x14191c, 0x191e24, 0x191e22, 0x17181c, 0x1a1617, 0x221817, 0x372727, 0x3b2929, 0x271314, 0x220c0f, 0x5c3925, 0xa57767, 0xbc7c72, 0xb3625e, 0xb9615f, 0xbc6764, 0xb66b65, 0xb26e65, 0xb66b65, 0xb66b65, 0xb66b65, 0xb66b65, 0xb66b65, 0xb66b65, 0xb66b65, 0xb66b65, 0xb66b65, 0xb46963, 0xb36862, 0xb26761, 0xb36862, 0xb76c66, 0xba6f69, 0xbd726c, 0xad7574, 0x4b2d25, 0x1f1509, 0x1e150c, 0x3c2726, 0x382224, 0x191514, 0x12231b, 0x1e141d, 0x1f1d22, 0x121816, 0x121d15, 0x1f251b, 0x190f06, 0x2b0e08, 0x572e2a, 0x6a452b, 0x311605, 0x080000, 0x6d7075, 0xf8ffff, 0xfbffff, 0x787677, 0x342a28, 0xfdfff1, 0xdee4e2, 0x000100, 0x695e48, 0xffeeb6, 0xffdf9c, 0xffecbb, 0x98886e, 0x030000, 0x84745b, 0xfff0c1, 0xf6d5a2, 0xfadab3, 0xf7d4aa, 0xffda98, 0xf4b95d, 0xf3b150, 0xffde95, 0xe0d3a6, 0x222922, 0x37160f, 0xb15c09, 0xee961b, 0xffbf75, 0xf8d6a6, 0xffdba7, 0xffd9a5, 0xf9d5a5, 0xfadbac, 0xffdf9f, 0xffca70, 0xfaae3e, 0xa5772a, 0x0f0d00, 0x0e1822, 0x151d2a, 0x0e1414, 0x6d4319, 0xac510a, 0xab5115, 0xf2aa55, 0xffe1b0, 0xf8f1bb, 0x856727, 0x6f3f00, 0xffe4a1, 0xfff3d1, 0x746c47, 0x00001c, 0x220e00, 0xcd9943, 0xb07823, 0x845112, 0xeaa03f, 0xffa920, 0xf7b334, 0xc9722b, 0x52260d, 0x000309, 0x173035, 0x1d232f, 0x180518, 0x140000, 0x3c3200, 0x723d1b, 0x312d22, 0x04191a, 0x050600, 0x422a26, 0xe8d7e1, 0xfaf7ff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcffff, 0xf7fbfe, 0xfcffff, 0xfafeff, 0xfcffff, 0x494d50, 0x020609, 0x181c1f, 0x272300, 0x240108, 0x240026, 0xb9bad8, 0xa2bcbb, 0x051606, 0x050800, 0x1a201e, 0x892f24, 0xd07912, 0xffad1d, 0xffb72f, 0xb5733f, 0x5a2d06, 0xddc352, 0x573300, 0x000a2f, 0x000700, 0x937f74, 0xfffaca, 0xceaf55, 0x412000, 0xd0ae81, 0xffe1bb, 0xffe9ab, 0xe5a15a, 0xab4000, 0xb0561a, 0x694523, 0x0f170a, 0x12211a, 0x1b1d12, 0x1d152c, 0xba9218, 0xfdb429, 0xffc58e, 0xffd9ac, 0xffd8a4, 0xffd4ad, 0xf8d7a1, 0xffdeaf, 0xe5d49c, 0xf2ab37, 0xf47d05, 0x853f25, 0x060009, 0x74664b, 0xfffcc5, 0xfed482, 0xe2a248, 0xffc46b, 0xffe7a5, 0xf8daa8, 0xeed4a3, 0xf7dea8, 0xffedb4, 0x413839, 0x0c0800, 0xe5dec2, 0xffefbd, 0xfadc9e, 0xffe4af, 0x494226, 0x000902, 0xd1d1d1, 0xffffff, 0x5b5b5b, 0x4e4e4e, 0xffffff, 0xfefefe, 0x7c7c7c, 0x020202, 0x380400, 0x60342b, 0x614339, 0x302219, 0x0d0a05, 0x181c1b, 0x11161a, 0x0d141a, 0x131b1e, 0x121619, 0x1d1918, 0x221414, 0x311b1d, 0x43282d, 0x41232b, 0x3e202a, 0x1a0200, 0x916b58, 0xc5877c, 0xbe6b67, 0xc56a69, 0xca6f6e, 0xc26f6b, 0xb86d67, 0xbc6f69, 0xbc6f69, 0xbc6f69, 0xbc6f69, 0xbc6f69, 0xbc6f69, 0xbc6f69, 0xbc6f69, 0xbc6f69, 0xba6d67, 0xb76a64, 0xb66963, 0xb86b65, 0xbd706a, 0xc2756f, 0xc57872, 0x8d6460, 0x170300, 0x2c281c, 0x3e342b, 0x422426, 0x3d1d22, 0x170f0d, 0x142920, 0x251b24, 0x1e1d22, 0x101916, 0x172119, 0x181a0f, 0x200d06, 0x401713, 0x814948, 0x5e371a, 0x200400, 0x0d0200, 0x878a91, 0xf7ffff, 0xf3faff, 0x413f40, 0x7b726d, 0xfffff1, 0xb8beba, 0x010504, 0x5b503a, 0xfff0b9, 0xf3d28d, 0xffe8b3, 0xe3d2b4, 0x030007, 0x655442, 0xffedc3, 0xf4d3a6, 0xfadcb8, 0xf4d2ad, 0xffe0a2, 0xffcc72, 0xe49f38, 0xffd470, 0xffffbf, 0x465250, 0x1b0a10, 0x833900, 0xde7f07, 0xfaa94d, 0xf2d2a1, 0xffdca9, 0xffdda9, 0xf8d3a6, 0xf3d7a8, 0xffdb9d, 0xffcb71, 0xffb343, 0xbb8932, 0x181700, 0x05121b, 0x111b25, 0x0e1410, 0x724a19, 0xb75d11, 0x994004, 0xf19d45, 0xfff0c6, 0xe9eca7, 0xbba86d, 0x401700, 0xdab976, 0xfff7dc, 0x998e56, 0x000017, 0x070000, 0x764500, 0xeeb663, 0x4a2200, 0xd08f3d, 0xffb11d, 0xe9b335, 0xdf8225, 0x6e361b, 0x1d1220, 0x071110, 0x090901, 0xb5a9b5, 0xaaacbb, 0x000f09, 0x2b0600, 0x1a1f19, 0x082022, 0x030000, 0x775b50, 0xfff7fd, 0xfffcff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xf3f3f3, 0xb3b3b3, 0x030303, 0x151515, 0x000200, 0x6a6569, 0xe5dbe4, 0xfefeff, 0xb6c5c8, 0x000704, 0x0e100b, 0x2e211b, 0x81431c, 0xd17f19, 0xffbd19, 0xebc04f, 0x380d00, 0xb88744, 0xa17f38, 0x0b001e, 0x071b24, 0x170005, 0xb68d57, 0xffffc5, 0x554747, 0x411f00, 0xf4d169, 0xffebba, 0xffe389, 0xd59d53, 0x984706, 0xb45b21, 0x703f1e, 0x091113, 0x0a1d2c, 0x0f0d12, 0x1d190d, 0xe59e36, 0xffa83c, 0xffcd94, 0xeeeaa1, 0xefe188, 0xfad9a6, 0xf3d7cb, 0xffc992, 0xf4c22f, 0xf38e00, 0xc25d25, 0x100026, 0x28140b, 0xf1cb5c, 0xf0fae2, 0xffa749, 0xeda72e, 0xffdf98, 0xfedac4, 0xf3d3a2, 0xffe5a5, 0xfdddb4, 0xe4cda1, 0x060100, 0xa49574, 0xfedead, 0xffdb9e, 0xffe0ac, 0xfee6c4, 0x4a4339, 0x000107, 0x9d9d9d, 0xfafafa, 0xb7b7b7, 0x313131, 0xffffff, 0xf9f9f9, 0xbcbcbc, 0x010101, 0x061323, 0x3a1b18, 0x923023, 0x863522, 0x100f00, 0x141817, 0x20131a, 0x001809, 0x1a1f23, 0x14181b, 0x1f1f21, 0x1c1819, 0x1d1312, 0x3f312e, 0x392723, 0x3c2923, 0x1e2211, 0x4e1818, 0xcc707b, 0xca787c, 0xb66c6b, 0xd57d7c, 0xb75f5d, 0xbe7c70, 0xc0716a, 0xbe6f68, 0xc1746c, 0xc47a71, 0xc1786f, 0xb87268, 0xb77167, 0xba766b, 0xb17e69, 0xbd7567, 0xc96a66, 0xc86466, 0xc2686a, 0xc37173, 0xcb747a, 0xd1717c, 0x37190e, 0x30150a, 0x341e13, 0x43322b, 0x322924, 0x171312, 0x171719, 0x161a1d, 0x2e1c10, 0x09142a, 0x131627, 0x141a18, 0x02211b, 0x201700, 0x752700, 0x9e4139, 0x1d1d1d, 0x0c0c0c, 0x0b0b0b, 0xcccccc, 0xffffff, 0xf1f1f1, 0x383838, 0xd0d0d0, 0xfffeff, 0x88838a, 0x0f0705, 0x4a3e26, 0xfff1be, 0xfce7a8, 0xf3d5a1, 0xffeeca, 0x717169, 0x0f0000, 0xffdda0, 0xffe8ad, 0xe6c79b, 0xffe8c6, 0xf8d5af, 0xffd6a6, 0xf9a624, 0xf9b578, 0xfff6ba, 0xe1b67f, 0x280800, 0x231b04, 0xb86032, 0xfd841c, 0xf8bf27, 0xffcda3, 0xfddfc7, 0xebe49e, 0xf0dda5, 0xffd7b3, 0xffc77d, 0xffb13f, 0xdc8a24, 0x261607, 0x0b1320, 0x161920, 0x0e1118, 0x7a4718, 0xbc5c05, 0x924414, 0xe89839, 0xece9b6, 0xfae3ba, 0xfec35d, 0x3a2200, 0x635c64, 0xffffbc, 0xb69757, 0x0e000c, 0x13140f, 0x100404, 0xb49052, 0xad7b36, 0x491800, 0xf5c15b, 0xfdb433, 0xed8127, 0x873e13, 0x301420, 0x060928, 0x000b19, 0xcbcdc8, 0xfffff4, 0xe7dddb, 0x3e3e3e, 0x000000, 0x131313, 0x000000, 0xb7b7b7, 0xf5f5f5, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xc2c2c2, 0x000000, 0x030303, 0x868b87, 0xcec9cd, 0xfffbff, 0xfefeff, 0xb1bfc0, 0x000502, 0x0b0c06, 0x362722, 0x995226, 0xd38312, 0xffc736, 0x8e6412, 0x5c371c, 0xa67d45, 0x402400, 0x0c071b, 0x051922, 0x28070e, 0xd7ac77, 0xfbeeb7, 0x352724, 0x5a3200, 0xf9d269, 0xffe9b8, 0xffe590, 0xc38e48, 0x934203, 0xb55a21, 0x703f1e, 0x0b1013, 0x0b1e2c, 0x0d0b10, 0x2f2919, 0xe9a334, 0xffa834, 0xffcc96, 0xeee5ac, 0xf5e296, 0xffe1a8, 0xfcdcb6, 0xffbb69, 0xf8a628, 0xd27607, 0x6e3710, 0x10000f, 0x754b32, 0xffda85, 0xeaecbb, 0xfb9f30, 0xfcb95e, 0xffe0ac, 0xffe3be, 0xedcf9d, 0xffdaa9, 0xffe6b9, 0xb8985b, 0x6a644c, 0xd8c8a6, 0xffeab9, 0xffd79c, 0xffdda9, 0xe8d0ae, 0x352e24, 0x00040a, 0x5e5e5e, 0xffffff, 0xf1f1f1, 0x545454, 0xd3d3d3, 0xffffff, 0xebebeb, 0x1d1d1d, 0x000414, 0x261710, 0x702716, 0x8a3d2b, 0x3e2918, 0x221a18, 0x1a0f15, 0x10281b, 0x000104, 0x1d2124, 0x0e0e10, 0x1f1b1a, 0x241c1a, 0x231814, 0x32231e, 0x2b1915, 0x5e3732, 0x1a0400, 0x603830, 0xe28c8f, 0xde797f, 0xaf605b, 0xc27970, 0xd47b75, 0xce716a, 0xc96f67, 0xca7068, 0xcd746c, 0xcc756c, 0xc97269, 0xc9756b, 0xce7a70, 0xc5776a, 0xb46f5f, 0xc58373, 0xcc7f77, 0xc26868, 0xda8082, 0xc27c7a, 0x6a3831, 0x1a0000, 0x573f33, 0x453128, 0x1e0f08, 0x271d1b, 0x211d1c, 0x131416, 0x1e2223, 0x1e0c02, 0x061324, 0x0f1b27, 0x212622, 0x05100a, 0x4d331a, 0x954f2b, 0x621e11, 0x151515, 0x000000, 0x323232, 0xf1f1f1, 0xffffff, 0xbdbdbd, 0x545454, 0xfdfdfd, 0xfffeff, 0x545158, 0x060000, 0x4c402a, 0xfbebba, 0xf5dfa3, 0xf5d7a3, 0xffe2bc, 0xdfd5c9, 0x6c5625, 0xcba961, 0xffe1a6, 0xffe1b6, 0xf1d6a9, 0xffe3b4, 0xffd7af, 0xfeb149, 0xeca748, 0xffe7b5, 0xf4d092, 0x6b4611, 0x150400, 0x703c17, 0xd66f22, 0xf0a526, 0xffc070, 0xffd8a7, 0xefdea6, 0xf0dfa9, 0xffd9b7, 0xffc689, 0xffb033, 0xe29128, 0x291909, 0x09111c, 0x15181f, 0x0f1219, 0x7b481b, 0xbb5b05, 0x8e4012, 0xd18730, 0xf2ecba, 0xffebc2, 0xffcc66, 0x492b00, 0x382e36, 0xffefb0, 0xd9b77a, 0x1f0e14, 0x131418, 0x0a0605, 0x462a00, 0xaf8650, 0x573009, 0xa57722, 0xffbf44, 0xed8522, 0x8e4713, 0x3e2423, 0x0b0d22, 0x00020c, 0xbfc1bc, 0xfffef8, 0xfef6f4, 0xfdfdfd, 0x626262, 0x010101, 0x000000, 0xe2e2e2, 0xfbfbfb, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfafafa, 0xffffff, 0xd7d7d7, 0x272727, 0x6b6b6b, 0xf4fbf4, 0xfffeff, 0xfffbff, 0xf9f8ff, 0xb3bec0, 0x000501, 0x0d0a05, 0x43302a, 0xa5531b, 0xe09516, 0xffc253, 0x441800, 0x715144, 0x775937, 0x110100, 0x14191d, 0x01131f, 0x391310, 0xfacd96, 0xd6cb9d, 0x110200, 0x895919, 0xffd76c, 0xfae7bc, 0xffe89b, 0xa67435, 0x8b3b00, 0xb65b22, 0x743f1d, 0x0b1111, 0x0b1e2c, 0x0a090e, 0x3e3724, 0xeea82e, 0xffa829, 0xffcc9b, 0xf1e2c1, 0xfcdfa5, 0xffdf9b, 0xf6d183, 0xeeaa3b, 0xf68624, 0x9c5819, 0x101004, 0x291500, 0xd39660, 0xffe9b4, 0xe9d37e, 0xe89a1e, 0xffc589, 0xffdfb9, 0xf4e3af, 0xf5d8ac, 0xffdab3, 0xffdba1, 0xc39547, 0xded3b7, 0xfde9c4, 0xffe4b3, 0xf7d399, 0xffeab7, 0xdbc6a7, 0x1e1a11, 0x00050b, 0x1d1d1d, 0xe3e3e3, 0xffffff, 0x797979, 0x999999, 0xfbfbfb, 0xffffff, 0x505050, 0x00000e, 0x121a0f, 0x3d1d06, 0x813d2a, 0x713f34, 0x311716, 0x120809, 0x23342c, 0x464a4b, 0x090a0c, 0x171717, 0x231f1e, 0x100b08, 0x291f1d, 0x271916, 0x322421, 0x5d2725, 0x403020, 0x1b1000, 0x834840, 0xe98d8e, 0xd8807c, 0xc7746c, 0xc96c65, 0xcf786e, 0xcb746a, 0xca7369, 0xcc756b, 0xcc756b, 0xc97268, 0xc87167, 0xc87469, 0xcc6e62, 0xd88678, 0xc07b6b, 0xb36d61, 0xd68c83, 0xd49189, 0x784c3f, 0x190200, 0x513b30, 0x3e2a21, 0x33221a, 0x312620, 0x251d1a, 0x151412, 0x1a1c1b, 0x1c2021, 0x1b0802, 0x485963, 0x082024, 0x12110c, 0x2c1410, 0x7b4636, 0x7b4225, 0x290c00, 0x1d1d1d, 0x000000, 0x6a6a6a, 0xffffff, 0xf9f9f9, 0x969696, 0x7e7e7e, 0xffffff, 0xd6d7db, 0x1b181f, 0x060000, 0x3f3422, 0xebdaae, 0xf7e3a8, 0xfadfaa, 0xf5d4ab, 0xfff8dd, 0xe0c387, 0xd2ad5f, 0xf7cf91, 0xffebb6, 0xefd69d, 0xfee5af, 0xfbdbb2, 0xffc67f, 0xe59b20, 0xffcb95, 0xffeaa8, 0xc69842, 0x200200, 0x1a180c, 0xa45729, 0xe07d20, 0xfaab32, 0xffcf75, 0xf8d8a7, 0xf2e1b3, 0xffdebf, 0xffc690, 0xfcae28, 0xeb9a2f, 0x2d1e0b, 0x070f1a, 0x14171e, 0x12151c, 0x7d4a1d, 0xba5a06, 0x87380d, 0xaf6f27, 0xf4edb9, 0xffebc2, 0xffd46e, 0x724a0c, 0x0f0003, 0xe3d29e, 0xf6d39b, 0x221407, 0x0b0d1c, 0x1b1f1e, 0x130200, 0x7f6447, 0x5a441f, 0x512e00, 0xfcc755, 0xf69427, 0x95520e, 0x492f20, 0x0c0f18, 0x00060e, 0xc5c5c3, 0xfffcf9, 0xfffdff, 0xffffff, 0xf2f2f2, 0x6a6a6a, 0x151515, 0xf0f0f0, 0xffffff, 0xf5f5f5, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfbfbfb, 0xfefefe, 0xefefef, 0xa1a1a1, 0xf2f2f2, 0xf9fffb, 0xfffffd, 0xfffaff, 0xf6f5fb, 0xc8d2d3, 0x0b1610, 0x0f0802, 0x4d3430, 0xb4530f, 0xf6b130, 0xbf8f45, 0x21000b, 0x41282b, 0x271507, 0x1c1819, 0x0c190f, 0x000f1c, 0x411707, 0xffd6a1, 0xa8a280, 0x0b0000, 0xbb8233, 0xffd76a, 0xf9ebc4, 0xffe6a4, 0x83561f, 0x853500, 0xb95c23, 0x76401c, 0x0c100f, 0x0b1e2c, 0x06070b, 0x433822, 0xf1ab29, 0xffa51e, 0xffcb9f, 0xfae5d4, 0xffdaab, 0xffcf81, 0xe8b84a, 0xe69c21, 0xdb6a26, 0x56361f, 0x00060c, 0x684204, 0xffce7b, 0xffe8c3, 0xf0b241, 0xeba939, 0xffce9f, 0xfbe4bb, 0xeadda8, 0xffe5c4, 0xffd5a7, 0xf1ba6a, 0xffca80, 0xffeece, 0xfae3ba, 0xfbdba8, 0xf5d29c, 0xfff4c6, 0xc9b89c, 0x161209, 0x0c1117, 0x010101, 0x828282, 0xffffff, 0xd4d4d4, 0xc6c6c6, 0xffffff, 0xffffff, 0x8f8f8f, 0x01000b, 0x072114, 0x141800, 0x642c1b, 0x8d423c, 0x461914, 0x0d0301, 0x252f2e, 0xe9ebea, 0x686a67, 0x000000, 0x1b1a18, 0x292522, 0x110c09, 0x19110f, 0x2c2221, 0x261003, 0x69473d, 0x402315, 0x140300, 0x835848, 0xed8f8d, 0xe47c7b, 0xcd7d74, 0xc7806e, 0xc7806e, 0xc87f6e, 0xcb8271, 0xcd8473, 0xce8272, 0xcc8070, 0xcb7f6f, 0xd97b71, 0xd77069, 0xd26966, 0xe38e87, 0xce998b, 0x61422e, 0x210600, 0x4b2a1b, 0x4a3932, 0x24150e, 0x1f140e, 0x2a211c, 0x1b1612, 0x171614, 0x131512, 0x000100, 0x8e7c7a, 0xc5d7d7, 0x0f2c28, 0x080100, 0x5a231e, 0x91443a, 0x4f2413, 0x131a08, 0x1a1a1a, 0x000000, 0xababab, 0xffffff, 0xffffff, 0xc5c5c5, 0xd9d9d9, 0xffffff, 0x6c7071, 0x000005, 0x140d14, 0x261a0e, 0xd1c29b, 0xffefb8, 0xffe9b3, 0xf9daae, 0xf6d7a1, 0xffefba, 0xfbd292, 0xe3bc6d, 0xfedc92, 0xffebb3, 0xf0d5a6, 0xfce5af, 0xffdaa9, 0xeda02c, 0xf9a954, 0xffedac, 0xffd26e, 0x59330e, 0x000a21, 0x6b3b24, 0xc45b1a, 0xed9114, 0xffc043, 0xffd490, 0xf8e1c2, 0xfde3ca, 0xffca88, 0xf9ac28, 0xf2a233, 0x32230e, 0x050e17, 0x13161b, 0x13161f, 0x7e4b20, 0xba590a, 0x81320b, 0x8b5821, 0xf2e8b3, 0xfae2bc, 0xffd46c, 0xab7628, 0x0e0000, 0xbcb38a, 0xffdba7, 0x342609, 0x01031a, 0x121e1e, 0x191011, 0x21140c, 0x3e3a1d, 0x1e0a00, 0xc39c3d, 0xffa938, 0x9c5d10, 0x442b0c, 0x080806, 0x191c21, 0xe2e0e1, 0xfdf9fa, 0xfdfbfe, 0xf3f3f3, 0xffffff, 0xf3f3f3, 0xa5a5a5, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfbfbfb, 0xffffff, 0xfcfcfc, 0xffffff, 0xf4f4f4, 0xffffff, 0xf3fff5, 0xf9f9f7, 0xfffbff, 0xfffeff, 0xe4edec, 0x1e251e, 0x0b0000, 0x50332f, 0xc15a0f, 0xe8af3e, 0x624519, 0x16001e, 0x1d0d1a, 0x100b08, 0x242831, 0x1b291a, 0x000c1c, 0x4d1e00, 0xffce97, 0x7e7b68, 0x0b0000, 0xdd9738, 0xffcb5d, 0xf8f2d0, 0xf0dfa9, 0x62390d, 0x843606, 0xbb5c24, 0x7a401a, 0x10110c, 0x0b1f2a, 0x03060b, 0x44361c, 0xf6ad2a, 0xffa01a, 0xffc99b, 0xffe9d5, 0xffd7a3, 0xffc167, 0xe7a52b, 0xd3811b, 0x984920, 0x15120d, 0x0d1313, 0xb87b2a, 0xffe783, 0xfbd7a7, 0xf99519, 0xf9c474, 0xffdfab, 0xfeeab5, 0xf8e3b4, 0xffdabe, 0xefba78, 0xe4af51, 0xffe6b1, 0xf7ddb8, 0xf4d7ab, 0xfedeab, 0xfadaa7, 0xfff4c8, 0xa5957c, 0x0f0c05, 0x151a1e, 0x080808, 0x292929, 0xe7e7e7, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xd3d3d3, 0x0f0915, 0x021c13, 0x001802, 0x401d0a, 0x903c32, 0x61251b, 0x110700, 0x14191c, 0xfffffb, 0xf0f1ec, 0x484944, 0x010000, 0x1a1917, 0x282423, 0x181413, 0x1e1a1b, 0x171808, 0x32130e, 0x5d3832, 0x2b200e, 0x150900, 0x824940, 0xdd8786, 0xf5a09d, 0xd18578, 0xd28478, 0xd18176, 0xd17f74, 0xd17d73, 0xd37c73, 0xd47b73, 0xd37a72, 0xe67e7b, 0xe07273, 0xff9698, 0xe59491, 0x69392d, 0x1f0300, 0x3c2014, 0x623d35, 0x180f0a, 0x271d1b, 0x1c1411, 0x1f1a16, 0x2a2925, 0x060702, 0x060805, 0x50524f, 0xfdeef1, 0xe0ede6, 0x001a11, 0x190f05, 0x72281d, 0x8c3730, 0x3d221b, 0x001a0c, 0x0b0b0b, 0x101010, 0xe4e4e4, 0xffffff, 0xffffff, 0xf3f3f3, 0xffffff, 0xe5e5e5, 0x161c18, 0x000005, 0x251f29, 0x0d0200, 0xb7a887, 0xfff6c3, 0xf6dda7, 0xf8dcad, 0xfdd891, 0xffdcb9, 0xffd9ae, 0xe4bf64, 0xe8c463, 0xffe8b5, 0xf7d7b0, 0xfce9a4, 0xffe1b6, 0xfeb362, 0xea9419, 0xffd993, 0xffe68a, 0xa67f30, 0x031134, 0x2e1405, 0x964214, 0xd07218, 0xffaa21, 0xffc863, 0xfbdbc4, 0xfee6ce, 0xffd078, 0xf9a930, 0xf6a635, 0x35270d, 0x050e15, 0x14171c, 0x141720, 0x7e4a22, 0xbb5a0d, 0x80300d, 0x674321, 0xefe3af, 0xf9e1bb, 0xffcc64, 0xd29030, 0x140000, 0x949073, 0xffdbab, 0x362700, 0x0a0c21, 0x121f25, 0x2a2732, 0x0a0607, 0x192211, 0x090400, 0x735a1a, 0xffab42, 0xa96b1e, 0x422803, 0x030000, 0x2e2d32, 0xfaf8fd, 0xfdfbfe, 0xf8f9fb, 0xffffff, 0xf5f5f5, 0xffffff, 0xf6f6f6, 0xffffff, 0xfbfbfb, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xf7f7f7, 0xf7fff8, 0xfcfef9, 0xfffdff, 0xfffeff, 0xeff5f3, 0x252722, 0x0d0000, 0x55322e, 0xcd6315, 0xb38436, 0x251f05, 0x151027, 0x231a2b, 0x191d1e, 0x000606, 0x111810, 0x000a1c, 0x622d01, 0xeeb77f, 0x55554d, 0x1c1000, 0xe89829, 0xffbd4c, 0xf7f6d8, 0xdfd3a9, 0x462200, 0x883b0f, 0xbe5d28, 0x7b4018, 0x12110c, 0x0b1f28, 0x03080c, 0x47361c, 0xfaaf30, 0xff9d1d, 0xffc694, 0xffe8c0, 0xffd186, 0xffb454, 0xe79321, 0x9e581c, 0x452413, 0x010000, 0x55330e, 0xf2af54, 0xffe888, 0xe7bc6e, 0xff8e14, 0xf7cf9e, 0xffe5ab, 0xfbe6a5, 0xffe7b4, 0xf1bd8d, 0xe2ab59, 0xfece7c, 0xffdab9, 0xfeddb2, 0xf8d8a9, 0xfdddaa, 0xffe5b5, 0xfff5ce, 0x7f735b, 0x060300, 0x080b10, 0x101010, 0x000000, 0xa3a3a3, 0xfdfdfd, 0xfefefe, 0xfafafa, 0xfdfdfd, 0xf9f9f9, 0x322d34, 0x000b0b, 0x001b0b, 0x221a03, 0x813525, 0x7a3726, 0x1d0f04, 0x01080e, 0xbebeb6, 0xfffff8, 0xe5e6e0, 0x51524d, 0x000000, 0x171717, 0x1e1e20, 0x1b1b1d, 0x261c1a, 0x0a0b03, 0x2e231d, 0x553633, 0x301c13, 0x1a1704, 0x6a4a3f, 0xd67d83, 0xe58d8b, 0xe98f8e, 0xe98e8d, 0xe68687, 0xe48082, 0xe67f82, 0xea8084, 0xe97f83, 0xfa8f97, 0xf29e9e, 0xbf867f, 0x64352f, 0x320200, 0x4d2120, 0x543834, 0x261911, 0x1d1918, 0x1d1918, 0x1f1e1c, 0x201f1d, 0x10110c, 0x070803, 0x60625d, 0xf6f8f3, 0xfffcff, 0xb6b8ab, 0x000700, 0x2b1b0e, 0x83351f, 0x76291f, 0x28191e, 0x001b19, 0x010101, 0x3c3c3c, 0xfcfcfc, 0xfcfcfc, 0xf9f9f9, 0xfefefe, 0xfcfcfc, 0x929292, 0x000300, 0x0b0e13, 0x1c1924, 0x070000, 0x97896c, 0xfffcca, 0xf1daa4, 0xf3d9a8, 0xffe5a4, 0xfad2b8, 0xffddbc, 0xffd986, 0xdbaf4e, 0xf7c789, 0xffe7b9, 0xf7de9b, 0xffdeb4, 0xffca98, 0xe8950b, 0xffbd5f, 0xffe297, 0xe4b95a, 0x4b2d25, 0x0b0000, 0x562e14, 0xa05325, 0xe78814, 0xfdb235, 0xfcd0a3, 0xfde3c2, 0xffd074, 0xfba62f, 0xf5a630, 0x37290e, 0x060f14, 0x15181d, 0x141720, 0x7c4821, 0xbe5c13, 0x833312, 0x462f1f, 0xebdea9, 0xffecc5, 0xfdc358, 0xe39324, 0x220100, 0x636758, 0xf7d2a6, 0x3c2b00, 0x0c0c14, 0x050c1c, 0x0e0910, 0x282723, 0x0b1919, 0x0d1218, 0x35270a, 0xe38933, 0xb47734, 0x492f0a, 0x060000, 0x373239, 0xfffaff, 0xfffeff, 0xfbffff, 0xfafafa, 0xf8f8f8, 0xffffff, 0xededed, 0xfdfdfd, 0xffffff, 0xf8f8f8, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xfbfbfb, 0xffffff, 0xffffff, 0xf7fff8, 0xfcfff8, 0xfffafa, 0xfdfbfe, 0xf4f8f7, 0x2c2d27, 0x0e0000, 0x5c3530, 0xd26b1c, 0x714e24, 0x081907, 0x121d1f, 0x161324, 0x020b08, 0x101f0c, 0x181617, 0x000618, 0x743b04, 0xcf945c, 0x2b2c30, 0x382a0f, 0xf29a1f, 0xffb946, 0xf6fae1, 0xcdc7a7, 0x331400, 0x8f411a, 0xc15d29, 0x7f4017, 0x12120a, 0x0b1f28, 0x020a0d, 0x49351c, 0xfaab35, 0xff9d27, 0xffc890, 0xf9e29e, 0xf5c05a, 0xf79935, 0xcd6a0d, 0x592d20, 0x0e0f14, 0x270d00, 0xa45e08, 0xffd175, 0xffdc8f, 0xe8a135, 0xffa02d, 0xf5d7b5, 0xfde4ac, 0xfddfa3, 0xffd18d, 0xe8ad53, 0xfbc070, 0xffe5b8, 0xf0d6bb, 0xffe1b1, 0xffddab, 0xf9d9a6, 0xffe8b9, 0xf7e5bf, 0x49412c, 0x010000, 0x13161b, 0x1b1b1b, 0x000000, 0x515151, 0xf2f2f2, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0x706e73, 0x060007, 0x051a15, 0x101d03, 0x662d12, 0x843d27, 0x261408, 0x00060c, 0xb0b0a6, 0xfdfdf3, 0xfffff8, 0xf4f5f0, 0x6b6d6a, 0x000002, 0x101417, 0x111518, 0x21161c, 0x1a2423, 0x0b140f, 0x2a1719, 0x473533, 0x1e2015, 0x130a01, 0x5b3132, 0xae716e, 0xbf827f, 0xd2918f, 0xdb9595, 0xe09496, 0xe59598, 0xe89398, 0xe59095, 0xb97b7c, 0x8d6460, 0x322117, 0x140a01, 0x402e2a, 0x3a2426, 0x150707, 0x1a1917, 0x19191b, 0x1b1c1e, 0x212322, 0x010300, 0x060805, 0x767873, 0xe6e9e2, 0xfefffa, 0xfefdff, 0xb0a798, 0x000300, 0x2e1c0e, 0x8c4322, 0x602311, 0x130f1d, 0x10222c, 0x000000, 0x7c7c7c, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf0f0f0, 0x434343, 0x000400, 0x1b1e23, 0x1d1927, 0x060000, 0x5c4d36, 0xfff0bf, 0xffedb6, 0xfbe1ae, 0xffdbb8, 0xfeddba, 0xffe6bf, 0xffe6b0, 0xeeb96b, 0xe5ae54, 0xffda92, 0xffddad, 0xfcdeba, 0xffdcb2, 0xf5a532, 0xf9a022, 0xfcdc9f, 0xffd183, 0xb05c02, 0x140606, 0x131919, 0x6a3525, 0xc66111, 0xee9213, 0xf6c465, 0xfdddae, 0xffca82, 0xfba723, 0xf1a22b, 0x382a0d, 0x071113, 0x171b1e, 0x131521, 0x794520, 0xc05e17, 0x89381b, 0x2d1f1e, 0xe1d19d, 0xfff3cc, 0xf9bf54, 0xf0961b, 0x3c1705, 0x323c34, 0xd8b28b, 0x554218, 0x020200, 0x161630, 0x1a110c, 0x1b1809, 0x091724, 0x132229, 0x0e080a, 0xad5110, 0xb67742, 0x533618, 0x080000, 0x403845, 0xfffaff, 0xfeffff, 0xf8fffb, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xf8f8f8, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xf5fff6, 0xfefffa, 0xfffcfc, 0xfffeff, 0xfcffff, 0x373631, 0x0f0000, 0x5f3632, 0xc96517, 0x3f2210, 0x001708, 0x132817, 0x070616, 0x000b03, 0x9fae8d, 0x817780, 0x000116, 0x7e4206, 0xb37840, 0x0b0e15, 0x4b3d20, 0xfda01f, 0xffbe4a, 0xf6fbe4, 0xc3bfa4, 0x2b0d00, 0x924720, 0xc25e2a, 0x7f4017, 0x15120b, 0x081f27, 0x020c0e, 0x463116, 0xf7a738, 0xff9e30, 0xffcd8e, 0xf1db85, 0xe4ae34, 0xe17e18, 0xad3f00, 0x291725, 0x000b1f, 0x5f2b16, 0xd98106, 0xffe082, 0xffd195, 0xf19210, 0xffb848, 0xffeacb, 0xfee6b6, 0xffe0ac, 0xebb55f, 0xe9ab30, 0xffdf97, 0xffdbcf, 0xe8dfbe, 0xfdd5a4, 0xffe1ad, 0xffe0ad, 0xffe9bb, 0xd1c19d, 0x0f0700, 0x040300, 0x42454a, 0x373737, 0x080808, 0x000000, 0xdcdcdc, 0xffffff, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xa9a9ab, 0x12000a, 0x0d181a, 0x051f02, 0x502302, 0x813b21, 0x281507, 0x000a10, 0xaba99d, 0xfdfdf3, 0xeeeee6, 0xfafbf6, 0xfeffff, 0x787c7d, 0x000104, 0x11161a, 0x171a21, 0x19111c, 0x202427, 0x000702, 0x000000, 0x422128, 0x2a1617, 0x001101, 0x0d0000, 0x1f0d01, 0x452f24, 0x5b4037, 0x64433c, 0x65403a, 0x603733, 0x5a2e2b, 0x0c0800, 0x0a0000, 0x160d06, 0x23291f, 0x11291c, 0x000d04, 0x010707, 0x271a21, 0x181c1f, 0x1f2324, 0x040809, 0x070908, 0x7e807d, 0xfbfdf8, 0xfefffa, 0xe2e5de, 0xf7fcff, 0xa49383, 0x0c0600, 0x2f1c0d, 0x814018, 0x521f0a, 0x0c0d1f, 0x060f20, 0x010101, 0xb8b8b8, 0xffffff, 0xffffff, 0xfbfbfb, 0xfafafa, 0xd1d1d1, 0x000000, 0x061007, 0x3b4044, 0x3f3d4b, 0x11080d, 0x180c00, 0xd9c89a, 0xfff0b9, 0xf9e0aa, 0xfdd4ce, 0xfde2b3, 0xf6dca9, 0xffdbc0, 0xffdaa3, 0xe9ad3d, 0xe8b758, 0xffe8ce, 0xffe1c4, 0xffe9b7, 0xffb45c, 0xf68e00, 0xf1daa4, 0xffd49f, 0xfd8700, 0x382731, 0x000b1f, 0x48231d, 0xae4613, 0xe07c04, 0xf0bc34, 0xfbd79d, 0xffc392, 0xfca716, 0xee9f26, 0x382b0b, 0x091315, 0x191d20, 0x131521, 0x78441f, 0xc26019, 0x8d3c1f, 0x20161e, 0xd5c48e, 0xfff3cc, 0xfac055, 0xff9f1d, 0x572e1a, 0x111d1b, 0xb69069, 0x4b350e, 0x0f0c00, 0x8e89a9, 0xa89c8e, 0x0a0600, 0x010d23, 0x0f2228, 0x060419, 0x822600, 0xb17247, 0x55371f, 0x0a0000, 0x4e4353, 0xfffbff, 0xfeffff, 0xf1fef4, 0xfefefe, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdf4, 0xfbf7f4, 0xf9ffff, 0xf5ffff, 0xf9ffff, 0x514a44, 0x180100, 0x5b391e, 0x8f6a4d, 0x2e1300, 0x251c15, 0x000107, 0x00060f, 0xb5bec5, 0xfbfbfb, 0x958e88, 0x0c0007, 0x6e4414, 0x734c2b, 0x110014, 0x63341a, 0xffae1f, 0xfab62f, 0xfffbe4, 0xb8ab88, 0x070700, 0x7f4a28, 0xc15d22, 0x81452b, 0x0f0a11, 0x131e22, 0x011516, 0x3f2419, 0xfeb041, 0xfda216, 0xf7b952, 0xffbd4e, 0xff9229, 0xb95a24, 0x433220, 0x000922, 0x2f221a, 0x984600, 0xe4a345, 0xf6e698, 0xffad3b, 0xff8f12, 0xe2da99, 0xebe6d3, 0xfff7cd, 0xf8b04e, 0xf09c2c, 0xfcd99f, 0xf9e2c3, 0xfcd5ae, 0xfbe0c2, 0xe6e6b4, 0xffdbbd, 0xffdcc2, 0xfffab1, 0x876c1d, 0x0d0005, 0x06001e, 0xae995a, 0xa57e47, 0x080016, 0x000020, 0x686868, 0xfffbff, 0xf4f1f8, 0xf9f8f6, 0xfff8ff, 0xffeaf4, 0x252120, 0x000800, 0x18160a, 0x3f1916, 0x75403c, 0x472519, 0x080100, 0x9c9c84, 0xffffe6, 0xf3ecd2, 0xe8dec5, 0xfffde8, 0xfffdee, 0x888983, 0x000100, 0x0a0615, 0x130e15, 0x1e1915, 0x4e4a3e, 0x201e11, 0x0c0d07, 0x0b0e13, 0x090f1b, 0x302728, 0x292826, 0x000200, 0x000c0a, 0x00130f, 0x000c0a, 0x021212, 0x000405, 0x1e2b00, 0x28301b, 0x1d1e23, 0x0e0c17, 0x010101, 0x2e3126, 0x464d45, 0x0d1615, 0x1f201b, 0x010000, 0x14100d, 0x948d87, 0xfffdf1, 0xfef3df, 0xfbedd0, 0xfbeecb, 0xfefff8, 0x8e857c, 0x150000, 0x52281c, 0x63382f, 0x391c16, 0x261c1a, 0x020305, 0x343434, 0xfdfdfd, 0xf0f0f0, 0xffffff, 0xfcfcfc, 0xffffff, 0x545454, 0x000000, 0x000505, 0xbd9861, 0xa7865d, 0x03020a, 0x0e0000, 0x907442, 0xffefc3, 0xffe4d0, 0xffdb9a, 0xffd9b4, 0xf4dab9, 0xecd7bc, 0xffeccb, 0xffd575, 0xe39d24, 0xffb574, 0xfcf1dd, 0xf1e0e6, 0xf8c880, 0xff9f16, 0xffa64b, 0xffd18d, 0xe7a849, 0xb44c00, 0x151924, 0x040f09, 0x51391f, 0xb15e28, 0xeb882a, 0xffbf3f, 0xffbd41, 0xffa43f, 0xf0a331, 0x242515, 0x030e2c, 0x0e0f24, 0x0c191f, 0x7a4c18, 0xcb6115, 0x8b3b22, 0x0f110c, 0xb6bfac, 0xfff2cd, 0xffab37, 0xf6b012, 0x563a0a, 0x16001b, 0x8a593b, 0x5b422e, 0x0f0000, 0xc8beb5, 0xfffffd, 0x999a9c, 0x090d10, 0x000002, 0x222222, 0x302207, 0x775343, 0x693e35, 0x110000, 0x67675d, 0xfefffa, 0xfffeff, 0xfffcff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdf6, 0xfdfcfa, 0xf9ffff, 0xf7ffff, 0xf9ffff, 0x645f5b, 0x120000, 0x64462e, 0x745237, 0x250e00, 0x060000, 0x1b2024, 0xb3c0c9, 0xebf4fb, 0xfbfbfb, 0x837e7a, 0x080005, 0x663f14, 0x6d482d, 0x100018, 0x5f3119, 0xffa51c, 0xf9b32f, 0xfffada, 0xaba080, 0x040600, 0x814b25, 0xc8611f, 0x834222, 0x130a0d, 0x131c21, 0x001114, 0x3f261f, 0xf7ab3d, 0xffa315, 0xf9b548, 0xf6ae42, 0xe6791c, 0x94421a, 0x2a231b, 0x000a13, 0x492b20, 0xaf5b13, 0xf5b352, 0xf8d67c, 0xff9c27, 0xff9d29, 0xede7b7, 0xffedd2, 0xf7d190, 0xeca740, 0xfcb259, 0xffdfab, 0xfbe5be, 0xfcdcb3, 0xffe1c3, 0xfae8b8, 0xf8dbbd, 0xfff7c0, 0xe6c775, 0x3f3208, 0x070009, 0x1b0b0c, 0xdace9a, 0xb08541, 0x080007, 0x020925, 0x22231e, 0xe9e0e3, 0xfeffff, 0xfcfffd, 0xfff7ff, 0xfff6ff, 0x868686, 0x000500, 0x1f201a, 0x311311, 0x683a3a, 0x391d12, 0x0b0600, 0x7b7663, 0xeee6d1, 0xf9edd5, 0xfceed4, 0xf1e2cb, 0xfffae5, 0xefecdd, 0x9b9d90, 0x2e2930, 0x040000, 0x141007, 0xefecdb, 0xe6e5d3, 0x4d4d43, 0x0d0d0b, 0x06070c, 0xc9c3b7, 0xcac6ba, 0x242418, 0x000200, 0x292c23, 0x0a0d04, 0x000200, 0x20231c, 0xe2e5c8, 0xa9a79b, 0x060002, 0x090004, 0x736a63, 0xeee6d9, 0xe1dad4, 0x0e050a, 0x080300, 0x38312b, 0x999186, 0xfffeed, 0xf9edd7, 0xf8ead0, 0xf0e1c4, 0xfff7db, 0xd7ddd3, 0x766f65, 0x110000, 0x533328, 0x66453c, 0x240d07, 0x150d0a, 0x000100, 0x939393, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xd1d1d1, 0x222222, 0x090909, 0x030a12, 0xb48a50, 0xdbbb8a, 0x000309, 0x070200, 0x543d11, 0xe9d399, 0xffe3aa, 0xffd7bf, 0xffe1b6, 0xffeac3, 0xf1ddc2, 0xfde5b9, 0xffe099, 0xf7b658, 0xf4a337, 0xffd8a4, 0xf6e2db, 0xfedba1, 0xfca728, 0xff9934, 0xffcc7e, 0xf5b657, 0xbd5b02, 0x332429, 0x080f08, 0x332812, 0x8e4b20, 0xdb7827, 0xffae3a, 0xffb535, 0xfda72e, 0xe69a2a, 0x252314, 0x080f29, 0x141122, 0x121a1d, 0x774814, 0xc55b11, 0x873b21, 0x060805, 0xadb4a2, 0xfff0c3, 0xffae39, 0xf8ae19, 0x55380c, 0x100017, 0x764a2f, 0x4d3827, 0x0e0000, 0x928982, 0xf7f6f4, 0xfeffff, 0x969a9d, 0x1c1c1c, 0x010000, 0x211500, 0x7e5d4e, 0x5e362e, 0x100000, 0x797b70, 0xfbfcf7, 0xfffbff, 0xfffcff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffef8, 0xfffffd, 0xfbffff, 0xf8ffff, 0xf8fdff, 0x87827e, 0x0d0000, 0x634a36, 0x5a3e28, 0x0f0000, 0x1f1812, 0xb2b7bb, 0xf8ffff, 0xf9ffff, 0xfbfbfb, 0x777370, 0x060005, 0x583611, 0x5e3f2a, 0x0d001a, 0x592f19, 0xf5991a, 0xfab02d, 0xfff7c6, 0x9c967c, 0x020300, 0x7f481f, 0xce621a, 0x823d16, 0x160807, 0x141c1f, 0x001319, 0x352120, 0xe59e32, 0xffa718, 0xfdab3b, 0xe59733, 0xb65c10, 0x612814, 0x0b1517, 0x101403, 0x703724, 0xcd7130, 0xffc25a, 0xfdc055, 0xec9015, 0xffb751, 0xf9f2d6, 0xffe9be, 0xe9a746, 0xe6a73e, 0xffd197, 0xffe2b8, 0xfae4b2, 0xf6e1b4, 0xffdcbf, 0xffdbb4, 0xfee8bf, 0xffe08b, 0xc7a053, 0x050306, 0x0d091a, 0x452e0e, 0xeeeabd, 0xb78530, 0x0e0000, 0x101528, 0x010000, 0x8d8487, 0xf9ffff, 0xf7fffb, 0xfaf9fe, 0xfff9ff, 0xdee1e6, 0x0b1e1c, 0x080e0c, 0x281416, 0x422225, 0x291612, 0x070900, 0x696057, 0x968a7c, 0xd3c2ae, 0xfff3da, 0xeddabc, 0xfffee1, 0xeee7cb, 0x9d997e, 0x7e776f, 0x6f685e, 0x040100, 0xc9c6b3, 0xffffed, 0xf8f5e4, 0x837f74, 0x0e0a01, 0xf4f6de, 0xffffec, 0xc5c0ac, 0x49402f, 0x080000, 0x0d0100, 0x564c40, 0xd3c9bd, 0xfffaf1, 0xf0e7e2, 0x090000, 0x9e9189, 0xfff3e2, 0xfffcec, 0xb29d98, 0x1b0208, 0x7a6c6b, 0x7e7168, 0xb6aa92, 0xfff3d1, 0xfaecc7, 0xf2e2c1, 0xfffbe2, 0xc8b3a0, 0x92988e, 0x4c4a3e, 0x0d0300, 0x2d1d10, 0x3a291f, 0x1d120c, 0x0b0704, 0x1d2120, 0xebebeb, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0x737373, 0x000000, 0x161616, 0x0c010f, 0xca9551, 0xffeeab, 0x212f30, 0x020814, 0x2a1b00, 0xb9a25c, 0xfff091, 0xffd9d8, 0xfee1b7, 0xfceac4, 0xf4e5c4, 0xf2e1ad, 0xffe6bd, 0xffd296, 0xdfa41a, 0xffb550, 0xf9dbbf, 0xfff3ca, 0xf8b84c, 0xee8d1c, 0xffc263, 0xffc566, 0xc77215, 0x62322e, 0x161408, 0x0c1504, 0x5a3017, 0xbd5e26, 0xf7912f, 0xfcab28, 0xf0b221, 0xd78c26, 0x201e11, 0x0f1126, 0x1d131e, 0x161817, 0x784613, 0xc15b11, 0x7d3a1f, 0x010300, 0xa3a894, 0xffeab2, 0xffac34, 0xf1a420, 0x4f3510, 0x0b0012, 0x5d3825, 0x433021, 0x0b0000, 0x8e8781, 0xffffff, 0xfcffff, 0xfcffff, 0xadadad, 0x080705, 0x080000, 0x6e5045, 0x58332d, 0x0e0000, 0x95988f, 0xfafcf9, 0xfef9fd, 0xfffbff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcf8, 0xfffffd, 0xfcffff, 0xfaffff, 0xfafeff, 0xafaba8, 0x080000, 0x463629, 0x3e2b1c, 0x0b0000, 0xb5b0ac, 0xfcffff, 0xf9ffff, 0xf0f5f9, 0xfeffff, 0x737270, 0x010004, 0x45270d, 0x452d21, 0x07031c, 0x532e1b, 0xed8e20, 0xfcad2e, 0xfff0ab, 0x938e7a, 0x000200, 0x764119, 0xcd6319, 0x7e390f, 0x160805, 0x161b1f, 0x0b1a21, 0x231419, 0xcc8e27, 0xffaf20, 0xfe9f31, 0xce8127, 0x894612, 0x371816, 0x000e19, 0x312a00, 0x944325, 0xdb7d3d, 0xffc455, 0xffae32, 0xe9941d, 0xfdd484, 0xfff2e2, 0xffcd89, 0xec961d, 0xf2bc5c, 0xffe8c7, 0xffdfbd, 0xf6e0a7, 0xede0b3, 0xffd8bb, 0xffe0c7, 0xffefae, 0xdebc5a, 0x5f410b, 0x010014, 0x00000b, 0xa3946b, 0xfff8c2, 0xbb8521, 0x240e00, 0x131521, 0x0a0700, 0x282224, 0xdfeaec, 0xebfff4, 0xfbffff, 0xfff7ff, 0xf9ffff, 0x677979, 0x000304, 0x251a20, 0x210e14, 0x261d1e, 0x040a06, 0x423735, 0x897a73, 0x6b5849, 0xfffbe1, 0xfde6c6, 0xe2d0ac, 0xf5e7c2, 0xdfd5b1, 0x746953, 0x948c77, 0x7d7864, 0x676550, 0xf1efda, 0xfffdea, 0xf3e6d3, 0x655641, 0x788269, 0xfeffec, 0xfefbe8, 0x918577, 0x1a0900, 0x110000, 0x9e9087, 0xfffcf3, 0xfffbfd, 0x776e69, 0x686254, 0xf1edd4, 0xffffe2, 0xfff4de, 0x6a584e, 0x8c7376, 0x9a8580, 0x887566, 0xe0d0ae, 0xfdecbe, 0xe9d9a8, 0xfae8c2, 0xfff3de, 0x6c544a, 0x808378, 0x1f2116, 0x1f1f15, 0x0b0800, 0x16130c, 0x22211c, 0x0a0a08, 0x828483, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xcecece, 0x1a1a1a, 0x090909, 0x1a1a1a, 0x1d0a0c, 0xdca147, 0xffef91, 0x7a8a7f, 0x000117, 0x070000, 0x675314, 0xefc45e, 0xffe6c6, 0xfbe1c0, 0xeddcc0, 0xf3e7bd, 0xf3e6b2, 0xffe3c6, 0xffe2b8, 0xefc056, 0xff9913, 0xf2c993, 0xfffcdc, 0xfed17e, 0xe7901c, 0xffb044, 0xffc663, 0xd48826, 0x8d422d, 0x2e1d0d, 0x000b00, 0x2c1e15, 0x974426, 0xe27226, 0xf6a122, 0xf2c220, 0xc98228, 0x14140a, 0x111322, 0x241518, 0x14100f, 0x7b4819, 0xc3651f, 0x6b331a, 0x020202, 0x9a9d88, 0xffe59b, 0xffa82b, 0xe59325, 0x483112, 0x090513, 0x472c21, 0x2c1e13, 0x0a0000, 0x8e8a87, 0xfeffff, 0xf6fafd, 0xfeffff, 0xf8f7f5, 0xa19d9a, 0x070400, 0x3c231c, 0x4b2c2a, 0x0d0000, 0xb7bcb5, 0xfefffd, 0xfffdff, 0xfffbff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffbf8, 0xfffffd, 0xfcfdff, 0xfcffff, 0xfeffff, 0xd1d0ce, 0x0e0905, 0x1c130c, 0x0e0100, 0x6d645d, 0xfcf8f5, 0xfeffff, 0xfcffff, 0xfbffff, 0xf9fafc, 0x777777, 0x000104, 0x311a0a, 0x2b1b1b, 0x00051d, 0x4d2d1e, 0xe08222, 0xfda72e, 0xfee789, 0x888274, 0x000204, 0x633714, 0xc1641f, 0x753e17, 0x160e0c, 0x14171c, 0x121b20, 0x170b17, 0xb48324, 0xffba31, 0xf5942b, 0xb56b24, 0x61351c, 0x1b101e, 0x000d16, 0x593c02, 0xad4e1e, 0xe38842, 0xffbe49, 0xffa01a, 0xefa53c, 0xffeab0, 0xffe7cc, 0xfea142, 0xf79e28, 0xffd68b, 0xffeed8, 0xffdbb9, 0xf9dea7, 0xefe0b5, 0xffdebb, 0xffe6cd, 0xffe18c, 0x947a26, 0x080000, 0x0a0008, 0x373737, 0xe7e4c3, 0xfff1a1, 0xca952f, 0x2c1608, 0x10131c, 0x211f13, 0x040000, 0x8c9898, 0xf0fff8, 0xfbffff, 0xfefbff, 0xfbffff, 0xcfddde, 0x070f12, 0x100e13, 0x1e141c, 0x252527, 0x0d1615, 0x060000, 0x8b807c, 0x675547, 0x6b553e, 0xfffcdc, 0xffefcc, 0xebdcb5, 0xfdefca, 0xfaecc9, 0x635a3b, 0x736d57, 0x53503f, 0xebe5d5, 0xfcefdc, 0xfffce1, 0xd2b799, 0x050c00, 0x717463, 0x8c867a, 0x43352c, 0x43302a, 0x4d3a36, 0x463430, 0x90817e, 0x786868, 0x100800, 0xdbdbbf, 0xfaffdb, 0xfeffe3, 0xbec0a8, 0x554d40, 0x80736b, 0x765e52, 0xf7e3cb, 0xfffad2, 0xe0d09f, 0xfff1c0, 0xfffcda, 0x715e4d, 0x644f4a, 0x7e8176, 0x090c03, 0x141912, 0x181d19, 0x1c201f, 0x0e1211, 0x222421, 0xe0e2df, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0xffffff, 0x7c7c7c, 0x000000, 0x1d1d1d, 0x121212, 0x37271a, 0xdb9b2d, 0xffe06b, 0xe1eacd, 0x253044, 0x030000, 0x221000, 0x9c7228, 0xffeb91, 0xffeed2, 0xf3ddc8, 0xf1e5b3, 0xf7e9bc, 0xf8e0be, 0xffe5bd, 0xffdab5, 0xff940e, 0xeab25f, 0xffedc7, 0xffe8af, 0xeaa63b, 0xf7a12a, 0xffb74e, 0xdf9a32, 0xac4f26, 0x512b14, 0x01100b, 0x101518, 0x6c3224, 0xc3591f, 0xed9420, 0xfccf2e, 0xb4762d, 0x040a06, 0x121420, 0x281616, 0x0d0908, 0x794921, 0xbc6b2a, 0x4f2a17, 0x010002, 0x90927a, 0xffe186, 0xffa624, 0xd9842a, 0x412c17, 0x060e11, 0x2e201d, 0x1b1108, 0x0d0804, 0x828282, 0xf2f6f9, 0xfbffff, 0xfeffff, 0xfffefc, 0xfffaf6, 0x54574c, 0x0e0000, 0x2c0f11, 0x190f0d, 0xdde3df, 0xfcffff, 0xfffdff, 0xfffbff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefdfb, 0xfffffd, 0xfbfbfb, 0xffffff, 0xffffff, 0xebebeb, 0x343434, 0x000000, 0x050100, 0xe1ddda, 0xfbfaf8, 0xf9f9f9, 0xffffff, 0xfeffff, 0xfafbfd, 0x7b7c7e, 0x000605, 0x24130c, 0x1c121b, 0x000c23, 0x42271c, 0xce6d1e, 0xf99e29, 0xfadf6c, 0x7d7568, 0x000309, 0x482c14, 0xa45d25, 0x603c22, 0x12151c, 0x111419, 0x171719, 0x11081b, 0x9b7721, 0xffbf40, 0xe28327, 0x93541f, 0x3c2422, 0x0a0a22, 0x0a1310, 0x7f4408, 0xb75a15, 0xe89644, 0xffb43d, 0xff9913, 0xfcb769, 0xffefc9, 0xfbd396, 0xe88911, 0xffb459, 0xffe6b9, 0xf9ebd0, 0xf7dbb3, 0xffdfb4, 0xfde5c1, 0xffe8c0, 0xffe6b6, 0xd7a357, 0x2f1800, 0x000300, 0x363020, 0xcecbc2, 0xfef8d8, 0xfac962, 0xcd9c40, 0x1f0c05, 0x0e1420, 0x18180c, 0x060000, 0x384140, 0xf7fff8, 0xfefefc, 0xfffeff, 0xfbfcfe, 0xfbffff, 0x5c6061, 0x000002, 0x1d1b20, 0x18191d, 0x151a1d, 0x08080a, 0x433e3b, 0xb4a89c, 0x33210d, 0x937d65, 0xfff3d5, 0xf6e5c9, 0xf4e5c8, 0xfffbd0, 0x8e815f, 0x837c69, 0x332f26, 0x3b322b, 0xd7c6b6, 0xfff5d9, 0xffdeba, 0x251201, 0x140000, 0x2c1507, 0x41251a, 0x200200, 0x2e0f0a, 0x5a3b36, 0x220500, 0x1b0000, 0x442c12, 0xefe7c0, 0xf0f5cd, 0xbdc6a9, 0x333726, 0x444233, 0x827b6b, 0x98846b, 0xfffadc, 0xf4e5be, 0xfcefc5, 0xffffda, 0x796e52, 0x302414, 0xb9aca6, 0x343629, 0x0e110a, 0x111312, 0x272b2e, 0x14171c, 0x000004, 0x707271, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0x343434, 0x080808, 0x1e1e1e, 0x0c0c0c, 0x292317, 0xd89628, 0xffd359, 0xffffd8, 0xbcbdc1, 0x2b2a26, 0x080000, 0x4c2b0c, 0xd4ba4b, 0xffebc2, 0xffeed0, 0xf5e3b1, 0xf8e4bf, 0xf9e2b8, 0xffe3b9, 0xffe0e4, 0xffaa45, 0xe9a132, 0xfdcf91, 0xfff1ce, 0xefbf6b, 0xf69920, 0xffa637, 0xe9a536, 0xb95a1a, 0x743919, 0x1e1a19, 0x01121a, 0x432821, 0x9d491b, 0xda801f, 0xffc73b, 0x95642c, 0x00080f, 0x0f1722, 0x261714, 0x0b090e, 0x674021, 0x9e5b26, 0x332316, 0x010004, 0x88886e, 0xffde73, 0xffa41c, 0xcc702d, 0x362418, 0x02150f, 0x18161b, 0x221d19, 0x010000, 0x878b8e, 0xf6fbff, 0xf7fcff, 0xfcfdff, 0xfffefb, 0xfff8f2, 0xbfc9c1, 0x100202, 0x0f0000, 0x3e3838, 0xf8fffe, 0xfcffff, 0xfffcff, 0xfffafe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfffffd, 0xfefdfb, 0xfffffd, 0xffffff, 0xfafbfd, 0x6a6e71, 0x000105, 0x58595b, 0xfcfdff, 0xffffff, 0xf9f8f6, 0xfffffd, 0xededed, 0xfeffff, 0x8f9396, 0x000906, 0x201114, 0x191526, 0x00142c, 0x361f17, 0xb65510, 0xf09220, 0xf7d955, 0x7e7063, 0x000610, 0x2a1c0f, 0x74451b, 0x3a2c21, 0x081a28, 0x13161d, 0x211716, 0x0a051b, 0x7e6417, 0xf9b643, 0xc66f1f, 0x743f1d, 0x1d1626, 0x060a25, 0x2c2312, 0x9e4912, 0xb8640c, 0xeca344, 0xffac34, 0xf89917, 0xffcb95, 0xffe8d2, 0xedb755, 0xf19a0c, 0xffce99, 0xffe9db, 0xf5e8bc, 0xf4e2b0, 0xffdfc4, 0xffe7cc, 0xf5edbe, 0xe4c66e, 0x643e1a, 0x110000, 0x191d0c, 0xa0ad91, 0xfffff1, 0xfff4c6, 0xefb643, 0xa47a30, 0x0f0307, 0x0f172a, 0x121409, 0x18100d, 0x151716, 0xedf3e9, 0xfffbff, 0xfffefa, 0xfffcf7, 0xfefdf9, 0xc2c1bf, 0x0e0e0c, 0x0b0b0b, 0x161817, 0x161719, 0x101918, 0x020400, 0x6c655b, 0xafa292, 0x100000, 0x534230, 0xd0c0b0, 0xf6e9d9, 0xf9e4b7, 0xd6c7a6, 0xbdb5a8, 0x2c2626, 0x0a0001, 0x281109, 0x684329, 0x8a5c38, 0x773922, 0x72361e, 0x6f351f, 0x531c07, 0x531f09, 0x4b1702, 0x4e1605, 0x713928, 0x8c442e, 0x6a3211, 0x8d6b45, 0x695a3b, 0x170f04, 0x060000, 0x3c2f27, 0xd5c6b3, 0xdccca8, 0xf9ebc8, 0xfff8d6, 0xb4a98b, 0x2d250e, 0x160f00, 0xaca69a, 0x656158, 0x010100, 0x1c1b16, 0x1b191e, 0x1f1c27, 0x02000c, 0x1b1821, 0xd1cfd2, 0xfffffb, 0xffffff, 0xffffff, 0xffffff, 0xd8d8d8, 0x111111, 0x151515, 0x191919, 0x151515, 0x040b11, 0xb7741b, 0xffba4e, 0xffe4b5, 0xffffea, 0x989880, 0x121409, 0x0e0000, 0x755105, 0xd8b571, 0xfff1b5, 0xffe7bc, 0xf8debd, 0xfbe2ba, 0xfde3be, 0xffe3d6, 0xffce96, 0xf39f1b, 0xffb154, 0xffead9, 0xeed199, 0xfa9924, 0xff9d26, 0xf4ad39, 0xbf6411, 0x8d421a, 0x3b2122, 0x000f18, 0x1f241d, 0x7b411b, 0xc4691a, 0xffae3e, 0x714b24, 0x000c1c, 0x0f1d2a, 0x231717, 0x0e111a, 0x4c2c17, 0x6d380c, 0x1e1f19, 0x060107, 0x848367, 0xfed55f, 0xfa960c, 0xb55724, 0x291811, 0x031d10, 0x101622, 0x201f1d, 0x000000, 0xa1a6aa, 0xf6fdff, 0xfbffff, 0xf4f5f7, 0xfaf5f1, 0xfffdf6, 0xf5ffff, 0x54494f, 0x0d0002, 0x787679, 0xf8ffff, 0xfbffff, 0xfffafe, 0xfffbff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfffffd, 0xfffefb, 0xfffefb, 0xfffffd, 0xfeffff, 0x90979d, 0x00070e, 0xaeb3b7, 0xfbffff, 0xfafafa, 0xfffffd, 0xfaf9f7, 0xffffff, 0xfafbfd, 0xbbbfc2, 0x000903, 0x1f141a, 0x1c1a30, 0x031b33, 0x2d1912, 0xa54304, 0xe88817, 0xf6d749, 0x857568, 0x000d1b, 0x14110a, 0x4c2b0c, 0x181816, 0x00182e, 0x181b24, 0x2c1d1a, 0x030018, 0x65530b, 0xe4aa3c, 0xb06017, 0x60321a, 0x0d0d27, 0x090d28, 0x493419, 0xb14b1a, 0xb56907, 0xeaa941, 0xfba62f, 0xf59d21, 0xffd9b4, 0xffdfd1, 0xe0a024, 0xffb71f, 0xffdfc3, 0xf7e4e8, 0xf8e9b2, 0xf4e9b1, 0xffdccc, 0xffe5ce, 0xe5e9b6, 0x876900, 0x120000, 0x0e0010, 0x969372, 0xeeffed, 0xf3f1e2, 0xffd090, 0xf2b945, 0x6f490a, 0x0a020f, 0x0e1a32, 0x1e2015, 0x1a110c, 0x161513, 0xd2d2c8, 0xfff9ff, 0xfffef6, 0xfffef6, 0xfef7f1, 0xfffefa, 0x464541, 0x000000, 0x292927, 0x181818, 0x13221f, 0x0d1611, 0x060600, 0x857b6f, 0xb2a595, 0x1e0e01, 0x24160d, 0x635650, 0xc0aa7b, 0xfff2d4, 0x7d7369, 0x040004, 0x281b24, 0x3a211c, 0x380f00, 0x632f0a, 0x9d3c1c, 0x933615, 0x893513, 0x853917, 0x8e4524, 0x853c1b, 0x883d1e, 0x803315, 0x9b351c, 0x94401c, 0x5e2400, 0x320e00, 0x3b2225, 0x2b141e, 0x150000, 0x917665, 0xfff8cb, 0xb3a781, 0x595031, 0x1e1601, 0x2f291b, 0xa2a094, 0x77776b, 0x000200, 0x1e1e12, 0x211e19, 0x1d181e, 0x191120, 0x0d0415, 0x58525e, 0xfffdff, 0xfffefa, 0xf7f7f7, 0xffffff, 0xf9f9f9, 0xc3c3c3, 0x0b0b0b, 0x111111, 0x1b1b1b, 0x242424, 0x000b26, 0x874000, 0xffa84b, 0xffd7a5, 0xfbe9c1, 0xffffda, 0x80887b, 0x06000c, 0x240000, 0x977418, 0xffe48e, 0xffecc9, 0xf9dcbc, 0xfbe1be, 0xfde2c4, 0xffeab8, 0xffe9d2, 0xffa314, 0xff9f2d, 0xfde0d8, 0xebd9b1, 0xff9e2e, 0xff9a1f, 0xfbb039, 0xbe6b0b, 0x9b4719, 0x4d2324, 0x000c15, 0x0b2218, 0x663e1a, 0xb35714, 0xfb983b, 0x58391a, 0x001327, 0x0e1f2f, 0x22191a, 0x141824, 0x371c0b, 0x471a00, 0x131f1d, 0x0f0a11, 0x858166, 0xf6cf50, 0xeb8600, 0xa04016, 0x1b0c09, 0x042313, 0x141d2e, 0x0a0a0a, 0x0f1012, 0xced5db, 0xf7ffff, 0xf8ffff, 0xfeffff, 0xfffefa, 0xfffdf6, 0xf4ffff, 0x989198, 0x1b0a14, 0xaaa8ab, 0xf3fffd, 0xfbffff, 0xfffdff, 0xfffbff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfcfcfc, 0xfafafa, 0xffffff, 0xc8c8c8, 0x3d3d3d, 0xf5f5f5, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xf5f5f5, 0x262719, 0x060300, 0x1a1720, 0x191a2c, 0x16101a, 0x503115, 0xba7220, 0xffb83f, 0xad7031, 0x0a0000, 0x0e2336, 0x111926, 0x1b1310, 0x23241c, 0x0d190d, 0x16220e, 0x0b140f, 0x462e12, 0xa36228, 0xa8632a, 0x3a2416, 0x011329, 0x160a0c, 0x853e12, 0xac442b, 0xb66e00, 0xffa645, 0xff911c, 0xe8b866, 0xffefde, 0xffc468, 0xfa8b08, 0xf9c48e, 0xfff4c6, 0xdfd8bb, 0xf5f5d3, 0xf0e3b6, 0xfff1be, 0xfff4bd, 0x9b7b4c, 0x000100, 0x000113, 0xa2acab, 0xffffc8, 0xffd99e, 0xefefcd, 0xe3d499, 0xff7f08, 0x1b1b1b, 0x0f0f0f, 0x1d1d1d, 0x1b1b1b, 0x0c0c0c, 0x131313, 0xd8d8d8, 0xffffff, 0xfafafa, 0xffffff, 0xfafafa, 0xffffff, 0xb6b6b6, 0x0c0c0c, 0x0c0c0c, 0x171717, 0x181816, 0x23241f, 0x0a0b06, 0x080903, 0x5c5d55, 0x929489, 0x73756a, 0x606255, 0x959782, 0x554939, 0x260b00, 0x2e0901, 0x3f1a12, 0x361b10, 0x2b1f0f, 0x2d2f1a, 0x312322, 0x312322, 0x312322, 0x312322, 0x312322, 0x312322, 0x312322, 0x312322, 0x302728, 0x2e2423, 0x392b2b, 0x372525, 0x2b1313, 0x321615, 0x321213, 0x190000, 0x767266, 0x7f7b6f, 0x6a665a, 0x726e62, 0x8b877b, 0x555145, 0x100c00, 0x141004, 0x282828, 0x0d0d0d, 0x232323, 0x000000, 0x1b1b1b, 0xb9b9b9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xc8c8c8, 0x060606, 0x191919, 0x171717, 0x1a1a1a, 0x000d44, 0x562100, 0xdb7c12, 0xffda9d, 0xf1e7cc, 0xfff2c6, 0xfff2c0, 0xaba491, 0x000e00, 0x0e0019, 0xb3872e, 0xfffdc2, 0xfeefc8, 0xf7f1b3, 0xffdcc5, 0xf2e0c8, 0xffeddd, 0xf5d372, 0xf08b00, 0xffb871, 0xfff2e4, 0xe5b56b, 0xff9806, 0xfcb42c, 0xcb6f1a, 0x9f5321, 0x773d17, 0x150b00, 0x00151a, 0x3c231e, 0xb96634, 0xa5520e, 0x18191b, 0x18191b, 0x191a1c, 0x1b1c1e, 0x191a1c, 0x151618, 0x131416, 0x141517, 0x001316, 0xbe9042, 0xffac2b, 0xd3812b, 0x502d17, 0x110809, 0x201d18, 0x201d18, 0x070707, 0x2f2f2f, 0xf4f4f4, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xfefefe, 0xc9c9c9, 0x4d4d4d, 0xe2e2e2, 0xfbfbfb, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xd7d7d7, 0xfafafa, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xfafafa, 0x545649, 0x030000, 0x1c1920, 0x151628, 0x140e18, 0x51331b, 0xad681d, 0xfe9a2a, 0xcb8b44, 0x201100, 0x081b29, 0x101823, 0x201816, 0x21221d, 0x0f1a14, 0x192114, 0x0a1517, 0x2d1b07, 0x874f20, 0x995d2b, 0x322117, 0x001427, 0x261b17, 0x924c19, 0xa6451b, 0xbe750c, 0xffa940, 0xff9a25, 0xf8c782, 0xffe9cd, 0xf8b54a, 0xf89212, 0xffd2a8, 0xfff0c2, 0xefe7d4, 0xeae6c1, 0xf2e4b5, 0xfff9cf, 0xc1a46c, 0x250900, 0x0f0c00, 0xa6a5c4, 0xfcefdf, 0xf3d68a, 0xe6cda5, 0xfdeac2, 0xfcca73, 0xc06107, 0x151515, 0x111111, 0x1b1b1b, 0x191919, 0x111111, 0x0f0f0f, 0xc4c4c4, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xf0f0f0, 0x5c5c5c, 0x000000, 0x242424, 0x171715, 0x181816, 0x242520, 0x13140e, 0x050600, 0x171810, 0x2c2e23, 0x3d3f34, 0x131605, 0x171103, 0x311d14, 0x50312c, 0x52332e, 0x342017, 0x1c1608, 0x191c0b, 0x1a100e, 0x1a100e, 0x1a100e, 0x1a100e, 0x1a100e, 0x1a100e, 0x1a100e, 0x1a100e, 0x191514, 0x100a0a, 0x160e0c, 0x221413, 0x2e1c1a, 0x4a3534, 0x553b3a, 0x402423, 0x040000, 0x2c281f, 0x39352c, 0x28241b, 0x1a160d, 0x0c0800, 0x110d04, 0x2d2920, 0x121212, 0x1f1f1f, 0x262626, 0x000000, 0x666666, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xb1b1b1, 0x060606, 0x171717, 0x181818, 0x1a1a1a, 0x00102a, 0x241103, 0xae5d04, 0xffbf64, 0xf5e7cc, 0xeadcb9, 0xffd99a, 0xfff7da, 0x88979e, 0x0e0000, 0x2e1a13, 0xd9bd74, 0xf4f6b5, 0xffdfbc, 0xffeec9, 0xffe2c7, 0xffeccf, 0xf9d990, 0xf49517, 0xffad53, 0xffe8d3, 0xf1c07e, 0xff9b0f, 0xfbb228, 0xd0721a, 0x9b4b16, 0x83451c, 0x291b00, 0x00181d, 0x382423, 0xad623a, 0x894409, 0x141517, 0x17181a, 0x191a1c, 0x191a1c, 0x1a1b1d, 0x191a1c, 0x151618, 0x101113, 0x09190e, 0xd5a14e, 0xff9c24, 0xac5e13, 0x432616, 0x130e12, 0x1c1c1a, 0x181a17, 0x000000, 0x656565, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xcccccc, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xffffff, 0xf7f7f7, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfdfdfd, 0xfdfdfd, 0xfefefe, 0xfefefe, 0xffffff, 0x9ea095, 0x010000, 0x1a181d, 0x161523, 0x100d16, 0x442b17, 0x955819, 0xcd7312, 0xe9a252, 0x3d2a0a, 0x001319, 0x101920, 0x231e1b, 0x1c1c1e, 0x131a20, 0x1a1e1f, 0x101c2a, 0x160b07, 0x613616, 0x7b4d29, 0x241d17, 0x001222, 0x352b1f, 0x9f591d, 0xa14d0f, 0xcb8321, 0xffa634, 0xffa12c, 0xffd7a4, 0xffd9ab, 0xe8a522, 0xfda730, 0xffe6c3, 0xf9e3cc, 0xf9f0d3, 0xefe4c4, 0xfff4c8, 0xfcdda7, 0x593b17, 0x120000, 0x8d8557, 0xfff8ff, 0xffdbb4, 0xe1c06f, 0xf2ecd4, 0xffdfa4, 0xfba534, 0x6a3406, 0x101010, 0x151515, 0x1a1a1a, 0x171717, 0x181818, 0x060606, 0xa3a3a3, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xededed, 0xffffff, 0xc9c9c9, 0x1c1c1c, 0x000000, 0x202020, 0x1a1a18, 0x1b1b19, 0x151611, 0x1a1b15, 0x1d1e16, 0x0f1008, 0x111308, 0x060e03, 0x1f1f17, 0x3e332f, 0x493534, 0x392524, 0x201511, 0x14140c, 0x141c11, 0x1b1a15, 0x1b1a15, 0x1b1a15, 0x1b1a15, 0x1b1a15, 0x1b1a15, 0x1b1a15, 0x1b1a15, 0x1a1c1b, 0x161614, 0x1c1b19, 0x1f1a17, 0x201614, 0x342925, 0x453633, 0x3b2c27, 0x1a1414, 0x161010, 0x1a1414, 0x1b1515, 0x181212, 0x1d1717, 0x201a1a, 0x191313, 0x121212, 0x292929, 0x000000, 0x2a2a2a, 0xd6d6d6, 0xffffff, 0xececec, 0xffffff, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0x8c8c8c, 0x050505, 0x151515, 0x191919, 0x1a1a1a, 0x27201a, 0x000b25, 0x763f06, 0xff9f2e, 0xffebbe, 0xf1e0c2, 0xecbc74, 0xffe6b5, 0xfffdff, 0x7e7f3b, 0x040017, 0x734c13, 0xf4e98d, 0xffead7, 0xf8e5c4, 0xffe0c2, 0xfdebbd, 0xffe2ba, 0xfda83e, 0xf89d2a, 0xffd9b4, 0xffd09d, 0xfba01e, 0xfbae22, 0xe08125, 0x9d4b11, 0x975022, 0x3d280b, 0x001219, 0x2b1f23, 0x8d5437, 0x5c3106, 0x101113, 0x17181a, 0x191a1c, 0x18191b, 0x1a1b1d, 0x1e1f21, 0x17181a, 0x0a0b0d, 0x332c0f, 0xe8aa53, 0xe48318, 0x894409, 0x3a2520, 0x131419, 0x151b19, 0x0b1717, 0x000000, 0xafafaf, 0xffffff, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xf8f8f8, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xdee1da, 0x161510, 0x110d0e, 0x191923, 0x111018, 0x2a1709, 0x7f4b1b, 0xa95a0d, 0xec9c43, 0x543b13, 0x000e0e, 0x101b1d, 0x231f1c, 0x18171d, 0x171b27, 0x1b1924, 0x172236, 0x110e15, 0x3f2315, 0x563722, 0x181a19, 0x00101c, 0x3e321c, 0xa75f17, 0x9a5508, 0xd58e34, 0xffa526, 0xf9a739, 0xffddb8, 0xf9c37b, 0xe09808, 0xffc35d, 0xfff3d7, 0xedd9db, 0xf6ecbb, 0xffedce, 0xffefc4, 0xa68035, 0x1b0000, 0x716241, 0xffffdd, 0xffe6bc, 0xe1a664, 0xefd7a9, 0xfffddf, 0xffc765, 0xd27a10, 0x2e150e, 0x0e0e0e, 0x1a1a1a, 0x1b1b1b, 0x171717, 0x1e1e1e, 0x000000, 0x7f7f7f, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0x9c9c9c, 0x0a0a0a, 0x0b0b0b, 0x151515, 0x1f1f1d, 0x161614, 0x1a1b16, 0x21221c, 0x181911, 0x1c1d15, 0x1a2320, 0x1c201f, 0x1c1819, 0x180d11, 0x150a0e, 0x171314, 0x191d1c, 0x1a2320, 0x1a1f19, 0x1a1f19, 0x1a1f19, 0x1a1f19, 0x1a1f19, 0x1a1f19, 0x1a1f19, 0x1a1f19, 0x161c1a, 0x191d1c, 0x202521, 0x1e1e1c, 0x12110d, 0x191611, 0x211c16, 0x1a150f, 0x272228, 0x19141a, 0x171218, 0x19141a, 0x151016, 0x1e191f, 0x241f25, 0x1b161c, 0x2b2b2b, 0x000000, 0x0f0f0f, 0xafafaf, 0xffffff, 0xfafafa, 0xffffff, 0xfdfdfd, 0xfbfbfb, 0xffffff, 0xfbfbfb, 0x676767, 0x040404, 0x141414, 0x1b1b1b, 0x1a1a1a, 0x251a08, 0x000b2a, 0x402a15, 0xd57912, 0xffd281, 0xfff6d0, 0xfbd49d, 0xddaa5b, 0xfff0cd, 0xfcfce4, 0x5f4a37, 0x160000, 0xc69036, 0xfffacf, 0xffe8d7, 0xffe4c8, 0xf9eaaf, 0xffebe1, 0xffbc6a, 0xeb9107, 0xfcc688, 0xffdeb5, 0xf6a937, 0xfcab1b, 0xeb9033, 0xa55113, 0xa65827, 0x48290a, 0x000d15, 0x1a121d, 0x603928, 0x332208, 0x101113, 0x191a1c, 0x1b1c1e, 0x17181a, 0x1a1b1d, 0x202123, 0x161719, 0x040507, 0x6b4d1b, 0xe69f45, 0xc56a11, 0x713914, 0x2c1f26, 0x0f141a, 0x16201f, 0x021116, 0x1d1d1d, 0xe9e9e9, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xf8f8f8, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafffb, 0x43423e, 0x040000, 0x1b1a20, 0x17171f, 0x120500, 0x6d4222, 0x995822, 0xd87d24, 0x624118, 0x020e0c, 0x101c1c, 0x211d1a, 0x16151b, 0x191b2a, 0x1c1624, 0x181f31, 0x181824, 0x271813, 0x311f13, 0x141c1f, 0x00111a, 0x4b3619, 0xb36213, 0x895009, 0xd48d3b, 0xfaa71d, 0xf9b552, 0xffe0bc, 0xf5b04b, 0xe59407, 0xffd88a, 0xfff6e7, 0xedddcd, 0xfee8c3, 0xffedb7, 0xf2bb78, 0x632e00, 0x401f00, 0xe4d6bc, 0xfffbe6, 0xf2ae3f, 0xf4be74, 0xfff2f2, 0xffe0a1, 0xffaa29, 0x915614, 0x170a1b, 0x121212, 0x1e1e1e, 0x1d1d1d, 0x181818, 0x1f1f1f, 0x000000, 0x646464, 0xfafafa, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfafafa, 0xfcfcfc, 0xfdfdfd, 0x959595, 0x111113, 0x000002, 0x151515, 0x262624, 0x0f0f0d, 0x141510, 0x20211b, 0x1a1b15, 0x151d1f, 0x15191c, 0x141519, 0x19171c, 0x1f1d22, 0x1f2024, 0x181c1f, 0x0d1517, 0x161b17, 0x161b17, 0x161b17, 0x161b17, 0x161b17, 0x161b17, 0x161b17, 0x161b17, 0x151b1b, 0x131718, 0x141817, 0x161b17, 0x191b18, 0x1e201b, 0x1c1f18, 0x11120c, 0x0a080d, 0x1e1c21, 0x242227, 0x18161b, 0x151318, 0x1e1c21, 0x1d1b20, 0x110f14, 0x000000, 0x101010, 0xa2a2a2, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfcfcfc, 0xfbfbfb, 0xffffff, 0xfafafa, 0x4d4d4d, 0x020202, 0x141414, 0x1c1c1c, 0x1a1a1a, 0x111308, 0x0e151b, 0x191a1f, 0x8c5115, 0xff9f30, 0xffe7ad, 0xfffcde, 0xf4b75a, 0xf6b95c, 0xfff6fb, 0xe4cc90, 0x401d00, 0x722b00, 0xe5d07d, 0xfff1d3, 0xf8e7d7, 0xf9eaaf, 0xfff2f2, 0xffd193, 0xe78e00, 0xf9b35b, 0xffe2ba, 0xf4b556, 0xfeaa16, 0xdb8a2f, 0x9d4d10, 0xad5b29, 0x542c09, 0x050f18, 0x120e1d, 0x372018, 0x151b0f, 0x141517, 0x1c1d1f, 0x1d1e20, 0x17181a, 0x191a1c, 0x1e1f21, 0x141517, 0x020305, 0x8c5a1b, 0xd38530, 0xa95912, 0x592f1f, 0x110f1d, 0x0e1619, 0x1c2520, 0x00040b, 0x5e5e5e, 0xffffff, 0xfbfbfb, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xfafafa, 0xffffff, 0xfafafa, 0xffffff, 0xfcfcfc, 0xffffff, 0xf8f8f8, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xf9f9f9, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfbffff, 0x868581, 0x050200, 0x151517, 0x1a1d24, 0x0d0405, 0x563524, 0x8c5634, 0xc7610c, 0x6c451e, 0x091312, 0x101c1c, 0x1c1b16, 0x17181c, 0x191925, 0x1f151e, 0x17181d, 0x1b1e25, 0x191411, 0x1c130c, 0x161d23, 0x06131b, 0x5f3e1f, 0xc26313, 0x6d3d0c, 0xc68231, 0xf9ad1c, 0xffc876, 0xffe0af, 0xf4a121, 0xf49720, 0xfde1b1, 0xfbf0ec, 0xf6ecb1, 0xffe9d6, 0xffdc82, 0xd48b24, 0x853e0a, 0xb99642, 0xfffcea, 0xf4c99f, 0xe9a828, 0xffe9af, 0xfff0f4, 0xffc25b, 0xdd8b0e, 0x462b18, 0x0e0c24, 0x171717, 0x1d1d1d, 0x1f1f1f, 0x1a1a1a, 0x1c1c1c, 0x000000, 0x595959, 0xfafafa, 0xfefefe, 0xffffff, 0xfafafa, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xffffff, 0xfbfbfb, 0x99989d, 0x313035, 0x000002, 0x0d0d0d, 0x222220, 0x272725, 0x181914, 0x12130e, 0x090a0c, 0x0b0c0e, 0x0b0c0e, 0x07080a, 0x000103, 0x000002, 0x000002, 0x000002, 0x000201, 0x000201, 0x000201, 0x000201, 0x000201, 0x000201, 0x000201, 0x000201, 0x000105, 0x020307, 0x050608, 0x050706, 0x040603, 0x080a07, 0x0d0f0a, 0x0b100a, 0x121214, 0x161618, 0x111113, 0x141416, 0x222224, 0x1c1c1e, 0x0b0b0d, 0x070709, 0x292929, 0xa7a7a7, 0xffffff, 0xfdfdfd, 0xfafafa, 0xfdfdfd, 0xefefef, 0xffffff, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0x434343, 0x010101, 0x171717, 0x1d1d1d, 0x191919, 0x0e1d20, 0x2c210d, 0x010b17, 0x4c3525, 0xe98013, 0xffc370, 0xfff7dc, 0xffe69a, 0xeeaa3b, 0xffd0ae, 0xffffd1, 0xc1893e, 0x783b05, 0xdf9927, 0xf2d78a, 0xfff1e3, 0xf9ebbc, 0xf6f5f1, 0xffe0af, 0xf29611, 0xf8a432, 0xffdead, 0xf3c178, 0xffaa16, 0xb77521, 0x833c04, 0xaf5d2b, 0x653511, 0x13161d, 0x161223, 0x241414, 0x061d17, 0x191a1c, 0x1d1e20, 0x1c1d1f, 0x18191b, 0x191a1c, 0x1c1d1f, 0x151618, 0x090a0c, 0x894a07, 0xba6b20, 0x944e1b, 0x3c2223, 0x050b1b, 0x171d19, 0x1a1b13, 0x00000c, 0xa9a9a9, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xf9f9f9, 0xf9f9f9, 0xfbfbfb, 0xffffff, 0xfefefe, 0xfefefe, 0xf4f4f4, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xf7ffff, 0xd3d3d1, 0x1b1610, 0x0a0a0a, 0x191e24, 0x151318, 0x331a13, 0x704330, 0xc9590d, 0x774928, 0x0f1719, 0x0f1b1b, 0x1a1b13, 0x1d1f1c, 0x18171c, 0x22171b, 0x1c180d, 0x1b1d1a, 0x161511, 0x1a1511, 0x151c22, 0x0b1016, 0x724526, 0xca5f0f, 0x592f19, 0xb87526, 0xf8b01e, 0xffd392, 0xf8d595, 0xf19600, 0xffa246, 0xf8e9d2, 0xf7f0de, 0xffefb9, 0xffdeac, 0xffb750, 0xe48914, 0xdc8a36, 0xffe894, 0xfff4d2, 0xf7ac47, 0xe8c977, 0xfeecd6, 0xffd6a8, 0xffb02e, 0xa2610d, 0x180717, 0x07162d, 0x1a1a1a, 0x171717, 0x202020, 0x1b1b1b, 0x181818, 0x000000, 0x5a5a5a, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xf1f1f1, 0xffffff, 0xffffff, 0xf5f5f5, 0xffffff, 0xfffeff, 0xb9b8bd, 0x4c4b50, 0x08080a, 0x000000, 0x000000, 0x000000, 0x10110c, 0x201c1b, 0x252422, 0x292927, 0x282a27, 0x2a2c29, 0x3c3c3a, 0x575654, 0x6e6a69, 0x6d6b6c, 0x6d6b6c, 0x6d6b6c, 0x6d6b6c, 0x6d6b6c, 0x6d6b6c, 0x6d6b6c, 0x6d6b6c, 0x6a656b, 0x6d686e, 0x69646a, 0x535154, 0x383838, 0x262624, 0x232522, 0x282a25, 0x232321, 0x151513, 0x080806, 0x070705, 0x000000, 0x000000, 0x121210, 0x4a4a48, 0xdddddd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfdfdfd, 0x444444, 0x000000, 0x1a1a1a, 0x1d1d1d, 0x181818, 0x0c2126, 0x2a2007, 0x03080c, 0x201920, 0xb5671c, 0xffaa42, 0xf7d79e, 0xfefeda, 0xf7bb5b, 0xe0ad54, 0xfffad5, 0xffd494, 0xd28f34, 0xfe9305, 0xeeaf3b, 0xffe9c5, 0xfdecd0, 0xebf4e1, 0xffebbf, 0xffa130, 0xf79913, 0xfcd496, 0xf5cc96, 0xffab18, 0x9e6d21, 0x682a00, 0xb16031, 0x74401b, 0x17151a, 0x1a1323, 0x211716, 0x03211f, 0x1a1b1d, 0x1b1c1e, 0x1a1b1d, 0x18191b, 0x18191b, 0x191a1c, 0x18191b, 0x151618, 0x884302, 0xad5f1f, 0x753d1a, 0x1f121c, 0x0c1826, 0x1e2013, 0x0e0800, 0x1d1b28, 0xe2e2e2, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xf3f3f3, 0xfefefe, 0xfdfdfd, 0xf6f6f6, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xf9ffff, 0xfffffd, 0x322d27, 0x020200, 0x161b21, 0x201f27, 0x170201, 0x522a20, 0xd35e18, 0x814e33, 0x14191d, 0x0e1a1a, 0x1b1d12, 0x21241d, 0x161616, 0x251a18, 0x251d08, 0x1a1c11, 0x191a14, 0x201d18, 0x151a20, 0x0b0a10, 0x7d4829, 0xca5609, 0x522b26, 0xb06f1f, 0xf7b11e, 0xfcd59e, 0xe8c87d, 0xef8d00, 0xffac64, 0xfaf1e8, 0xfaf5cf, 0xffe9d8, 0xf7ca63, 0xe79331, 0xff9a29, 0xffba30, 0xffe6b4, 0xebdba0, 0xff9c01, 0xefefd7, 0xf5ebf3, 0xffbc56, 0xe99406, 0x6b3809, 0x11001c, 0x072237, 0x1b1b1b, 0x121212, 0x1f1f1f, 0x1c1c1c, 0x151515, 0x040404, 0x5f5f5f, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfbfbfb, 0xfefdff, 0xfffeff, 0xfefdff, 0xbcbcbe, 0x878787, 0x949494, 0xb1b1af, 0xc4c4c2, 0xd9d1cf, 0xe2ddda, 0xe7e6e2, 0xe8e9e4, 0xecede8, 0xf5f4f0, 0xfffbf8, 0xfffdfb, 0xfffdff, 0xfffdff, 0xfffdff, 0xfffdff, 0xfffdff, 0xfffdff, 0xfffdff, 0xfffdff, 0xfffaff, 0xfffbff, 0xfffcff, 0xfef8fc, 0xf7f3f4, 0xedebec, 0xe6e6e4, 0xe6e6e4, 0xdde0d9, 0xd1d4cd, 0xc2c5be, 0xabaea7, 0x8c8f88, 0x8a8d86, 0xc0c3bc, 0xfefffa, 0xffffff, 0xfafafa, 0xfafafa, 0xfafafa, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0x474747, 0x000000, 0x1c1c1c, 0x1d1d1d, 0x171717, 0x0b1d21, 0x232412, 0x1f1c17, 0x04010c, 0x6e3d14, 0xf39221, 0xf3ba61, 0xe0ffff, 0xffde8b, 0xc5a739, 0xffd8a4, 0xffead2, 0xffae26, 0xff9c00, 0xff9714, 0xecbf7e, 0xffedde, 0xe4f3d2, 0xfff0c8, 0xffaa45, 0xf79301, 0xf2cd86, 0xf5d3a6, 0xffac1a, 0x9b732d, 0x592300, 0xb26436, 0x7c4622, 0x120c10, 0x191021, 0x271d1c, 0x032524, 0x1a1b1d, 0x18191b, 0x18191b, 0x191a1c, 0x191a1c, 0x18191b, 0x1b1c1e, 0x1e1f21, 0x995214, 0xac6127, 0x5b2910, 0x050110, 0x162431, 0x1a1b09, 0x0a0000, 0x5c515f, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xfbfbfb, 0xfefefe, 0xfcfcfc, 0xffffff, 0xfafafa, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xa2a2a2, 0x060606, 0x0b0b0b, 0x2b2b2b, 0x111111, 0x1b1b1b, 0x9a4e12, 0xa26433, 0x431c00, 0x170700, 0x201f1d, 0x121619, 0x1c1c1c, 0x1a1613, 0x151e25, 0x171b1e, 0x1c1815, 0x231e1b, 0x15181d, 0x1c1211, 0x814721, 0xc85a0b, 0x3f1f12, 0xaa7735, 0xffa729, 0xffd998, 0xf7be71, 0xfd9400, 0xf9c56f, 0xfbf3de, 0xfaf4f6, 0xffd690, 0xff980b, 0xff9d1e, 0xf59f28, 0xfbce8b, 0xffffe8, 0xf7a207, 0xdabe7f, 0xfffef1, 0xffc061, 0xffae11, 0xaa7738, 0x000d07, 0x111709, 0x2e0c25, 0x191917, 0x141412, 0x151515, 0x1d1d1d, 0x141416, 0x08070c, 0x66656a, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xf1f1f1, 0xffffff, 0xf9f9f9, 0xf4f4f4, 0xffffff, 0xf2f2f2, 0xffffff, 0xfafafa, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xf6f6f6, 0x5e5e5e, 0x030303, 0x171717, 0x222222, 0x141414, 0x11141b, 0x1b221a, 0x181f25, 0x06001c, 0x2c130e, 0x9a6e17, 0xf6b132, 0xffc04c, 0xfffbff, 0xffa45f, 0xffa314, 0xffffdf, 0xf0ceab, 0xfba00b, 0xe9a224, 0xff9720, 0xfcd99f, 0xfcf3ec, 0xfcf9f0, 0xffc361, 0xff8800, 0xffae52, 0xffdd99, 0xfab432, 0x8b6e46, 0x461900, 0xcb6123, 0x7e4122, 0x02121f, 0x191e17, 0x191607, 0x1c1b17, 0x1d171b, 0x151314, 0x1f2120, 0x121713, 0x191e18, 0x1c1b16, 0x0d0301, 0x362827, 0xbd6621, 0x7f4f29, 0x1a110a, 0x121619, 0x1f160f, 0x231306, 0x010000, 0xbccedc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xf6f6f6, 0x434343, 0x000000, 0x1f1f1f, 0x181818, 0x0e0e0e, 0x6a2c00, 0x93623a, 0x52341c, 0x1c1209, 0x1b1b1b, 0x121619, 0x1d1d1d, 0x1f1a16, 0x141d22, 0x171b1e, 0x1d1916, 0x221e1d, 0x15181f, 0x1a1210, 0x7e4621, 0xca5f11, 0x361c0f, 0x946b2d, 0xffb134, 0xffce82, 0xf3b55e, 0xfb9300, 0xf9cb80, 0xfff8ed, 0xfff4d8, 0xf6b767, 0xff9c12, 0xff9c1a, 0xeca13c, 0xffe9ae, 0xf6d7a1, 0xe08e06, 0xffe1ae, 0xf1daae, 0xf8b449, 0xf08e0f, 0x683f13, 0x000705, 0x191c13, 0x241325, 0x1b1c17, 0x151513, 0x141412, 0x252525, 0x19191b, 0x000004, 0x88878c, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfefefe, 0xf5f5f5, 0xffffff, 0xaeaeae, 0x8a8a8a, 0xffffff, 0xf3f3f3, 0xebebeb, 0xfafafa, 0xfcfcfc, 0xffffff, 0xf7f7f7, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xe5e5e5, 0xffffff, 0xffffff, 0xfcfcfc, 0xd6d6d6, 0xfdfdfd, 0xf5f5f5, 0x828282, 0xc5c5c5, 0xffffff, 0xfefefe, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0x747474, 0x000000, 0x151515, 0x151515, 0x1d1d1d, 0x191a1c, 0x131512, 0x17181d, 0x1b182b, 0x160b07, 0x664407, 0xe3a035, 0xffa729, 0xf2e0c8, 0xffcb93, 0xec940f, 0xf1d79a, 0xffeaca, 0xf1a124, 0xf0a621, 0xff971c, 0xedc274, 0xffebd8, 0xfffdf7, 0xfec470, 0xfe8d00, 0xffae4a, 0xffd386, 0xffb738, 0x80643d, 0x471900, 0xc55d1e, 0x793d21, 0x04121d, 0x1b2019, 0x19190d, 0x1b1a16, 0x1e181c, 0x151314, 0x1f2120, 0x151a16, 0x181d17, 0x181712, 0x150b09, 0x473938, 0xb06931, 0x502b0e, 0x181715, 0x0b1218, 0x2d2824, 0x0b0000, 0x555452, 0xeefcff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf4f4f4, 0xffffff, 0xb2b2b2, 0x040404, 0x101010, 0x232323, 0x191919, 0x310a00, 0x6e5038, 0x514134, 0x1c1815, 0x13171a, 0x14181b, 0x1d1c1a, 0x201913, 0x131a20, 0x161a1b, 0x1d1916, 0x211d1c, 0x131720, 0x171113, 0x7c4622, 0xcc651a, 0x2e1b0c, 0x735523, 0xffbe45, 0xfac265, 0xeea942, 0xf8940a, 0xfcd4a0, 0xfffcf9, 0xffd88c, 0xe19832, 0xfd9b1c, 0xfe9915, 0xf5ba74, 0xfff7c7, 0xf0aa4a, 0xeea43b, 0xfff8cd, 0xebbe61, 0xfdb338, 0xb97220, 0x2a1301, 0x0a0b0d, 0x1f1d1e, 0x111820, 0x10110c, 0x2f302b, 0x1a1a18, 0x11110f, 0x191919, 0x000002, 0xa09fa4, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0x868686, 0x101010, 0x626262, 0xd0d0d0, 0x4b4b4b, 0xd3d3d3, 0xf7f7f7, 0xffffff, 0xe5e5e5, 0x4e4e4e, 0xcacaca, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xadadad, 0x626262, 0xf0f0f0, 0xffffff, 0xececec, 0xd0d0d0, 0x474747, 0xe0e0e0, 0x575757, 0x0a0a0a, 0x9e9e9e, 0xfefefe, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0x919191, 0x000000, 0x202020, 0x191919, 0x242424, 0x1d2017, 0x1e191d, 0x1a151c, 0x222629, 0x060c0a, 0x281600, 0xb5772a, 0xfea018, 0xf0c368, 0xfff2c8, 0xf3ac3a, 0xe7ad49, 0xfff6d2, 0xf9be64, 0xf1a019, 0xff9a1b, 0xe1a73b, 0xfed7ae, 0xfffaf6, 0xfdcb8c, 0xf89513, 0xfcac3d, 0xfdc76f, 0xffbb40, 0x6a522e, 0x4a1a00, 0xc05a1c, 0x713b21, 0x05121b, 0x1b2019, 0x171c15, 0x1c1914, 0x211b1f, 0x151314, 0x1c1e1d, 0x161b17, 0x191e18, 0x191813, 0x1d1311, 0x504241, 0x754926, 0x1d0b00, 0x0d161d, 0x101d26, 0x12110f, 0x170a01, 0xc5c1be, 0xf8ffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xfafafa, 0x686868, 0x000000, 0x1c1c1c, 0x212121, 0x160600, 0x3d332a, 0x34302d, 0x13171a, 0x101519, 0x1a1b1d, 0x1e1a17, 0x1d1610, 0x14191d, 0x17181a, 0x1f1a17, 0x201c1b, 0x111822, 0x121013, 0x754223, 0xcd6822, 0x341f0a, 0x4d3a19, 0xffc355, 0xfdbd4f, 0xefa029, 0xf6981a, 0xffdfb9, 0xfff4ec, 0xfdb23b, 0xed971c, 0xf69d25, 0xfd9f25, 0xffe3b3, 0xffdbaa, 0xfb9614, 0xfebf78, 0xf7c89c, 0xf7b431, 0xf0a42a, 0x7a4e2b, 0x120c10, 0x1d161d, 0x1f1a21, 0x061f1c, 0x20211b, 0x151610, 0x11120d, 0x0c0c0a, 0x141412, 0x050505, 0xc0c0c2, 0xfcfcfe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xfefefe, 0xfdfdfd, 0xffffff, 0x101010, 0x585858, 0xf8f8f8, 0x525252, 0x2f2f2f, 0xf2f2f2, 0xfafafa, 0xffffff, 0xececec, 0x000000, 0x7c7c7c, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0x5a5a5a, 0x090909, 0xf6f6f6, 0xffffff, 0xfefefe, 0xf8f8f8, 0x121212, 0x797979, 0xeaeaea, 0x393939, 0x1f1f1f, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xf7f7f7, 0xb0b0b0, 0x000000, 0x121212, 0x131313, 0x000000, 0x121406, 0x2d222a, 0x24191f, 0x131d12, 0x04191c, 0x080613, 0x734013, 0xfda424, 0xfab220, 0xebd7b2, 0xf8c166, 0xf39f1b, 0xffd6a6, 0xffe8af, 0xea9818, 0xffa11f, 0xe59b16, 0xf6b976, 0xfff1e6, 0xffdaad, 0xf39d26, 0xf4a429, 0xfcc15d, 0xffbb4b, 0x4c3718, 0x551f00, 0xc05c21, 0x6a3b27, 0x081118, 0x171e16, 0x131d1c, 0x1e1913, 0x241e22, 0x171516, 0x191b1a, 0x161b17, 0x1b201a, 0x1d1c17, 0x201614, 0x423433, 0x2e1b0c, 0x131210, 0x061623, 0x14222d, 0x000000, 0x7d746d, 0xfffefa, 0xf6fafd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfafafa, 0xe6e6e6, 0x202020, 0x000000, 0x1c1c1c, 0x1c1b19, 0x1b1b1b, 0x161a1d, 0x12171b, 0x151a1e, 0x1c1d1f, 0x1e1d1b, 0x1f1a16, 0x161a1d, 0x181818, 0x1f1a16, 0x1d1b1c, 0x111924, 0x0e0f14, 0x6a3d20, 0xc66723, 0x4e2d0c, 0x302310, 0xf1b658, 0xffbe45, 0xf39c17, 0xf9a028, 0xffe3c0, 0xffe1c0, 0xfea317, 0xffa319, 0xf39f2d, 0xfbb14e, 0xfff8cf, 0xe4b370, 0xff9f15, 0xc28f64, 0xb8823c, 0xffb328, 0xbe7a19, 0x301c1b, 0x0e101d, 0x21171f, 0x191724, 0x0e2a1e, 0x24251d, 0x000100, 0x373832, 0x3f403b, 0x070705, 0x1d1d1b, 0xededed, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xfefefe, 0xc3c3c3, 0x242424, 0xf6f6f6, 0xf9f9f9, 0x040404, 0xb9b9b9, 0xffffff, 0xffffff, 0xffffff, 0xf1f1f1, 0x121212, 0x5f5f5f, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0x505050, 0x151515, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0x9d9d9d, 0x000000, 0xffffff, 0xe7e7e7, 0x232323, 0xdfdfdf, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xfefefe, 0xdfdfdf, 0x0e0e0e, 0x080808, 0x383838, 0x2d2d2d, 0x000200, 0x160b11, 0x271b1d, 0x0d180a, 0x092227, 0x080e28, 0x381400, 0xd08826, 0xffab09, 0xa2915b, 0xbb9453, 0xffa51d, 0xe6b165, 0xfffcd3, 0xeca237, 0xffa01d, 0xf7a110, 0xf29f41, 0xffdcbb, 0xffe5bb, 0xf0a031, 0xf09c18, 0xffbe53, 0xfaaf49, 0x302006, 0x672e03, 0xc16127, 0x643a2a, 0x0b1013, 0x131a12, 0x0a1d21, 0x221b13, 0x211b1f, 0x1a1819, 0x1a1c1b, 0x171c18, 0x1b201a, 0x1d1c17, 0x1c1210, 0x2b1d1c, 0x130f0c, 0x1e252b, 0x0b1b28, 0x00050e, 0x3b3c3e, 0xeae3dd, 0xfffefa, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xa7a7a7, 0x000000, 0x131313, 0x23272a, 0x121619, 0x111518, 0x1a1b1d, 0x1c1d1f, 0x1e1e1e, 0x1e1e1e, 0x201f1d, 0x1a1b1d, 0x181816, 0x1e1915, 0x1c1a1b, 0x111b27, 0x0a0d16, 0x5e341b, 0xbd6122, 0x75400e, 0x261710, 0xc99549, 0xffbd40, 0xf99e11, 0xfca733, 0xffddb3, 0xfec67c, 0xff9f17, 0xffa10d, 0xee9a2a, 0xf9c989, 0xffeebb, 0xeaa73f, 0xffa931, 0x603c22, 0xbf8114, 0xffb73f, 0x824f1a, 0x02000d, 0x12151c, 0x191219, 0x141726, 0x1b2719, 0x000200, 0x36372f, 0xbabbb3, 0x5e5f59, 0x000100, 0x494947, 0xfafaf8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0x828282, 0x757575, 0xffffff, 0x666666, 0x090909, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xdddddd, 0x040404, 0x797979, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xf8f8f8, 0x5d5d5d, 0x111111, 0xf5f5f5, 0xf2f2f2, 0xfbfbfb, 0xfbfbfb, 0xe9e9e9, 0x000000, 0x8b8b8b, 0xffffff, 0x6c6c6c, 0x9b9b9b, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xf6f6f6, 0x3c3c3c, 0x080808, 0x6f6f6f, 0xbfbfbf, 0x23261f, 0x040000, 0x1e1613, 0x181f18, 0x0c1f26, 0x12192b, 0x1c0500, 0x794a1c, 0xffad23, 0x9e7c25, 0x694c22, 0xffa93a, 0xefac39, 0xfff0c8, 0xfcc077, 0xf99816, 0xffa71b, 0xf6931c, 0xffc384, 0xffe1ae, 0xf3a237, 0xf79913, 0xffbe4f, 0xd19139, 0x231900, 0x7f4014, 0xc0612b, 0x553329, 0x0f1012, 0x121911, 0x011c25, 0x231a11, 0x1c161a, 0x1b191a, 0x1a1c1b, 0x181d19, 0x181d17, 0x191813, 0x1b110f, 0x201211, 0x181c1f, 0x161d23, 0x0e171e, 0x000105, 0xb5b5b5, 0xfffefa, 0xfffcf9, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xf5f5f5, 0xffffff, 0x525252, 0x080808, 0x191919, 0x1a1a1a, 0x1c1b19, 0x1e1a17, 0x1e1d1b, 0x1d1d1d, 0x161719, 0x101417, 0x1d1f1e, 0x1a1917, 0x1e1915, 0x1a1a1c, 0x101c2a, 0x060d17, 0x522c15, 0xb1591a, 0x9d5211, 0x2a1618, 0x9c6a2f, 0xffb73d, 0xfca00f, 0xfda939, 0xf8ce94, 0xfdae38, 0xfba02b, 0xff9d07, 0xee9726, 0xf4dfc2, 0xffda94, 0xffaa1c, 0xc28930, 0x3a200f, 0xf2af16, 0xe59945, 0x4b2a25, 0x000815, 0x1e1b14, 0x131217, 0x141e2a, 0x171000, 0x0c0e03, 0xc1c3b8, 0xfefff7, 0x303129, 0x000100, 0x91928d, 0xf7f7f5, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xaeaeae, 0xd4d4d4, 0xffffff, 0x424242, 0x333333, 0xf9f9f9, 0xffffff, 0xfafafa, 0xfafafa, 0xc0c0c0, 0x000000, 0xa9a9a9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0x8d8d8d, 0x000000, 0xc3c3c3, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0x353535, 0x515151, 0xffffff, 0xbdbdbd, 0xb1b1b1, 0xffffff, 0xf4f4f4, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xf4f4f4, 0x7d7d7d, 0x000000, 0x474747, 0xfcfcfc, 0x96979b, 0x1b1b11, 0x0f0f05, 0x1e1e26, 0x151924, 0x171b1a, 0x140d07, 0x372229, 0xf59338, 0xdb9f25, 0x41290f, 0xd6893b, 0xffb319, 0xefdba8, 0xffdcb3, 0xf89619, 0xffa626, 0xff9812, 0xf7ae4f, 0xfecf8b, 0xf9a238, 0xff9e18, 0xffba4e, 0x9c6b1c, 0x251f09, 0x955323, 0xb95b27, 0x442520, 0x131210, 0x161d15, 0x001d2a, 0x23190f, 0x1f191d, 0x171516, 0x0f1110, 0x131814, 0x171c16, 0x191813, 0x201614, 0x211312, 0x1d2124, 0x07080a, 0x101010, 0x646361, 0xfffefb, 0xfffefb, 0xf8f7f5, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xe2e2e2, 0x0a0a0a, 0x090502, 0x221d19, 0x261f19, 0x1b140e, 0x1e1915, 0x1d1c1a, 0x0c1013, 0x000206, 0x1f1f1f, 0x1a1917, 0x1e1915, 0x1a1a1c, 0x101e2b, 0x050b17, 0x4b2711, 0xaa5419, 0xb75b12, 0x30171d, 0x7d4d1c, 0xfcaf39, 0xfea211, 0xfba939, 0xf1c27e, 0xfe9f0f, 0xfea740, 0xffaa13, 0xfa9f2d, 0xf3eee8, 0xf7ce7c, 0xffa500, 0x755210, 0x453223, 0xffc511, 0xa96126, 0x1c0823, 0x0a1720, 0x241d0b, 0x12171a, 0x13242e, 0x120000, 0x828477, 0xfafcf1, 0xc9cbc0, 0x000100, 0x0f100a, 0xd4d5d0, 0xfffffb, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0xfefefe, 0xf9f9f9, 0xf4f4f4, 0xffffff, 0xffffff, 0x232323, 0x656565, 0xffffff, 0xf2f2f2, 0xffffff, 0xfafafa, 0x7a7a7a, 0x080808, 0xe0e0e0, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfdfdfd, 0xcccccc, 0x070707, 0x8a8a8a, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0x494949, 0x383838, 0xf0f0f0, 0xffffff, 0xf3f3f3, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xcdcdcd, 0x000000, 0x000000, 0xdedede, 0xfcffff, 0x5a5e4d, 0x070b00, 0x181423, 0x1e1b26, 0x171806, 0x151611, 0x211c45, 0xbf6028, 0xffba2a, 0x3b2615, 0x975620, 0xffad00, 0xe3cd91, 0xffe8d5, 0xff9c22, 0xffa12d, 0xffa213, 0xf2a22f, 0xf1be6f, 0xfea338, 0xffa41e, 0xfdb64c, 0x785008, 0x2c2713, 0xa25e2d, 0xaf541f, 0x361a16, 0x14130f, 0x1b221a, 0x001d2e, 0x23160d, 0x262024, 0x121011, 0x020403, 0x0d120e, 0x191e18, 0x1e1d18, 0x271d1b, 0x261817, 0x1e1e1e, 0x070300, 0x1d1610, 0xfaf1ea, 0xfffefa, 0xfffefb, 0xfffffd, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xeeeeee, 0xb9b9b9, 0x000000, 0x1f1f1f, 0x151515, 0x252525, 0x151515, 0x0e0e0e, 0x606060, 0x747474, 0x080000, 0x2a2623, 0x060d13, 0x111e27, 0x181f25, 0x221b15, 0x2b1402, 0x7c5a3f, 0xbe652b, 0x69271b, 0x5e3602, 0xddac33, 0xffab33, 0xff941b, 0xffa51a, 0xfbb738, 0xc19864, 0xd48914, 0xffc258, 0xffecd1, 0xf8a930, 0xf2af44, 0x0b1433, 0x8b5d00, 0xfeac46, 0x613f12, 0x0e1317, 0x121d23, 0x1e1818, 0x21161c, 0x09080d, 0x2a312a, 0xf0f1eb, 0xfdfef8, 0xa3a49e, 0x010200, 0x4d4d4b, 0xffffff, 0xffffff, 0xf8f8fa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0x242424, 0x6c6c6c, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0x373737, 0x343434, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xfcfcfc, 0x1a1a1a, 0x454545, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0x565656, 0x3e3e3e, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xfafafa, 0x454545, 0x000000, 0xb0b0b0, 0xfbf8f3, 0xedeae5, 0x25241f, 0x040500, 0x282826, 0x0a0c0b, 0x1d2120, 0x121617, 0x6f3a28, 0xffa834, 0x8a490f, 0x221d0a, 0xffb33a, 0xffb140, 0xeef9ce, 0xf7ba4f, 0xe08713, 0xd18b57, 0xffc73c, 0xfb9c0a, 0xff902d, 0xffb42b, 0xe4b34d, 0x593012, 0x863200, 0xc26031, 0x843d27, 0x211612, 0x101d13, 0x1e1903, 0x1f170a, 0x16232c, 0x202020, 0x000000, 0x868686, 0x5b5b5b, 0x030303, 0x1b1b1b, 0x141414, 0x181818, 0x050505, 0x090909, 0xbababa, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xffffff, 0xeeeeee, 0x616161, 0x000000, 0x1c1c1c, 0x1c1c1c, 0x191919, 0x050505, 0x919191, 0xf7f7f7, 0x524942, 0x010000, 0x282f35, 0x17212a, 0x141b21, 0x1c1713, 0x2a1708, 0x64462e, 0xb55b1c, 0x88412b, 0x522400, 0xc68f28, 0xffac37, 0xffa21d, 0xffbd39, 0xd4993d, 0x4e2b03, 0xc17900, 0xffc265, 0xffe8c4, 0xffb63f, 0xc48329, 0x070a19, 0xb77f20, 0xde923a, 0x462502, 0x070b14, 0x121b22, 0x1e1a17, 0x1a1114, 0x090909, 0x5d6359, 0xf8f9f3, 0xfffffa, 0x595a54, 0x000100, 0xadadab, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0x363636, 0x757575, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0x2e2e2e, 0x535353, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0x3b3b3b, 0x3c3c3c, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0x646464, 0x494949, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xfbfbfb, 0xfefefe, 0x999999, 0x000000, 0x757575, 0xfffffa, 0xfffcf7, 0x55544f, 0x060702, 0x1a1a18, 0x171918, 0x1c201f, 0x0c1011, 0x532b21, 0xe28420, 0xa6601a, 0x1b1a15, 0xd18f2e, 0xffb039, 0xf2efc4, 0xffc965, 0xb86900, 0x682b0f, 0xcb9f36, 0xffb82e, 0xff931f, 0xffb62a, 0xba842c, 0x5a2b0f, 0x9e4b09, 0xb75d2b, 0x7f412a, 0x090000, 0x1d2822, 0x1b1807, 0x231c14, 0x151f29, 0x000000, 0x6b6b6b, 0xe9e9e9, 0x797979, 0x090909, 0x171717, 0x1e1e1e, 0x1b1b1b, 0x000000, 0x7d7d7d, 0xededed, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xfdfdfd, 0xffffff, 0xffffff, 0xe5e5e5, 0x1d1d1d, 0x0b0b0b, 0x131313, 0x1c1c1c, 0x000000, 0x808080, 0xffffff, 0xd8d1cb, 0x383735, 0x000105, 0x151e25, 0x1a1f23, 0x1c1713, 0x1e0e01, 0x4b321e, 0xb45c15, 0xab613c, 0x5b2000, 0xb47123, 0xfca635, 0xffae1c, 0xf5b845, 0x754922, 0x1a0100, 0xd28c0a, 0xffd082, 0xfae3af, 0xfdb23b, 0x804205, 0x171308, 0xe79b43, 0xaa6627, 0x2c0f00, 0x0c101c, 0x12191f, 0x1f1c17, 0x16110e, 0x080904, 0x909483, 0xfffffa, 0xe9eae4, 0x050600, 0x2f302b, 0xfdfdfb, 0xf9f9f9, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0x535353, 0x8c8c8c, 0xfbfbfb, 0xffffff, 0xffffff, 0xf5f5f5, 0x212121, 0x838383, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0x6e6e6e, 0x2d2d2d, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0x7f7f7f, 0x5e5e5e, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfcfcfc, 0xfefefe, 0xe9e9e9, 0x202020, 0x191919, 0xf1eee9, 0xfffffa, 0x807f7a, 0x040500, 0x131311, 0x212322, 0x151918, 0x0b0f10, 0x301c1d, 0xb9590f, 0xcf7d27, 0x151924, 0x87591d, 0xffac2b, 0xf6dfb5, 0xffd57a, 0xc68505, 0x220000, 0x6c501e, 0xf9bd43, 0xffa920, 0xffb72a, 0xa5651e, 0x5f250f, 0xab5c11, 0xa75a24, 0x663620, 0x0a0104, 0x12171b, 0x17120e, 0x262020, 0x00010c, 0x3e3e3e, 0xe8e8e8, 0xffffff, 0x707070, 0x000000, 0x151515, 0x212121, 0x030303, 0x313131, 0xececec, 0xffffff, 0xf1f1f1, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfafafa, 0xfcfcfc, 0xffffff, 0xffffff, 0x959595, 0x090909, 0x151515, 0x212121, 0x000000, 0x8d8d8d, 0xffffff, 0xfffefa, 0xcdccca, 0x0a0e11, 0x01060a, 0x1d2124, 0x14100d, 0x100600, 0x423225, 0xab5814, 0xb26634, 0x792f0a, 0xaa5b23, 0xf2a438, 0xf3b524, 0xac842c, 0x150004, 0x34271f, 0xeda41a, 0xffd690, 0xf6df99, 0xe19b2c, 0x451000, 0x3c320f, 0xef9242, 0x76401a, 0x1f0a07, 0x1a2030, 0x13181b, 0x1e1b12, 0x191512, 0x060701, 0xa9ab95, 0xfcfdf7, 0x9b9c96, 0x000100, 0xa1a29d, 0xfffffd, 0xfbfbfb, 0xf5f5f5, 0xfefeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0x727272, 0xb0b0b0, 0xfdfdfd, 0xffffff, 0xffffff, 0xeaeaea, 0x1b1b1b, 0xb0b0b0, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0x9c9c9c, 0x242424, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xa3a3a3, 0x7b7b7b, 0xfbfbfb, 0xfefefe, 0xfefefe, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfdfdfd, 0xffffff, 0xfefefe, 0xffffff, 0x8f8f8f, 0x000000, 0xb3b0ab, 0xfffffa, 0x95948f, 0x000100, 0x171715, 0x1f2120, 0x0e1211, 0x131718, 0x191820, 0x953a0d, 0xe78d2d, 0x1b1d32, 0x442812, 0xf59d1f, 0xffd5a3, 0xfad47f, 0xe2a725, 0x250423, 0x140c0a, 0xb38f2f, 0xffc130, 0xf9a91e, 0xa85f2a, 0x76321b, 0xab5c0f, 0x935723, 0x442513, 0x151016, 0x191923, 0x1e191d, 0x010004, 0x232732, 0xd2d2d2, 0xffffff, 0xfbfbfb, 0x6f6f6f, 0x000000, 0x1c1c1c, 0x171717, 0x000000, 0xa8a8a8, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xfdfdfd, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfbfbfb, 0xfbfbfb, 0xf8f8f8, 0x3b3b3b, 0x070707, 0x202020, 0x030303, 0xafafaf, 0xfafafa, 0xfffefb, 0xfffffd, 0xa3a4a6, 0x05090c, 0x141517, 0x1d1c1a, 0x1d1814, 0x211811, 0x8e450e, 0xa75c23, 0x97451d, 0x9c4615, 0xf0a741, 0xe1b339, 0x55400b, 0x01001c, 0x3c3636, 0xef9c12, 0xffc982, 0xf5db84, 0xc58523, 0x230000, 0x594a1f, 0xe07831, 0x573220, 0x170a13, 0x1c2232, 0x131716, 0x1f1d11, 0x141412, 0x0a0b06, 0xc7c4b1, 0xfafbf5, 0x3a3b35, 0x262721, 0xf2f3ee, 0xfffffd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xf8f8f8, 0x949494, 0xd7d7d7, 0xffffff, 0xffffff, 0xfdfdfd, 0xe3e3e3, 0x272727, 0xcfcfcf, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xbcbcbc, 0x2b2b2b, 0xf7f7f7, 0xfbfbfb, 0xffffff, 0xffffff, 0xc8c8c8, 0x9e9e9e, 0xf9f9f9, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xffffff, 0xececec, 0x141414, 0x595651, 0xfffffa, 0xb2b1ac, 0x000100, 0x1a1a18, 0x181a19, 0x111514, 0x1a1e1f, 0x0b151f, 0x722a12, 0xdf8223, 0x2a2836, 0x1b0c0f, 0xd98c1a, 0xffd997, 0xf7cf78, 0xd69716, 0x2e1437, 0x00001b, 0x574409, 0xfbbf3b, 0xeda11a, 0xa15023, 0x954a2d, 0xae5f1a, 0x764b20, 0x23190f, 0x141319, 0x2e2834, 0x150f19, 0x020107, 0xb8bbc0, 0xffffff, 0xf9f9f9, 0xfdfdfd, 0x9a9a9a, 0x080808, 0x181818, 0x060606, 0x404040, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0x919191, 0x000000, 0x0c0c0c, 0x080808, 0xcecece, 0xf4f4f4, 0xfffffd, 0xfaf9f7, 0xffffff, 0x797979, 0x040404, 0x161616, 0x262626, 0x050505, 0x6e3311, 0xa25d26, 0xad5726, 0x953a01, 0xe39d3e, 0xb58e3f, 0x160800, 0x010626, 0x332d2d, 0xf8930f, 0xffc46e, 0xf9dd79, 0xae7323, 0x100008, 0x5f4d27, 0xd56728, 0x443029, 0x0d0917, 0x101622, 0x181913, 0x1e1e12, 0x0a0b0f, 0x1a191f, 0xefe6dd, 0xf6f7f1, 0x060701, 0x8e8f89, 0xfefffa, 0xfffffd, 0xf8f8f8, 0xffffff, 0xfefeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0xbbbbbb, 0xf3f3f3, 0xffffff, 0xffffff, 0xfcfcfc, 0xe5e5e5, 0x464646, 0xdfdfdf, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xcccccc, 0x474747, 0xf7f7f7, 0xfbfbfb, 0xffffff, 0xffffff, 0xeaeaea, 0xc3c3c3, 0xf9f9f9, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xf8f8f8, 0xfefefe, 0xfdfdfd, 0xffffff, 0x6d6d6d, 0x13100b, 0xfffcf7, 0xdeddd8, 0x0d0e09, 0x121210, 0x161817, 0x1b1f1e, 0x191d1e, 0x041318, 0x512316, 0xc26b1b, 0x42302c, 0x09010c, 0xb6791e, 0xffdc87, 0xfdca6e, 0xdf9319, 0x331a2d, 0x00102e, 0x100900, 0xd39b3c, 0xf3a82b, 0x8f3b0c, 0xa4552e, 0xb2622f, 0x56381c, 0x0a100e, 0x1a1b20, 0x11070f, 0x010005, 0x868a8d, 0xfffffb, 0xffffff, 0xf6f6f6, 0xffffff, 0xb8b8b8, 0x080808, 0x030303, 0x080808, 0xa7a7a7, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xededed, 0x222222, 0x000000, 0x292929, 0xf0f0f0, 0xffffff, 0xffffff, 0xfffffd, 0xfffffd, 0xfcfbf9, 0x464646, 0x000002, 0x13171a, 0x13181c, 0x4a1e13, 0x945728, 0xb25c21, 0x9f4500, 0xc17e25, 0x714b27, 0x040012, 0x051222, 0x3a312c, 0xff9417, 0xffc55d, 0xfbda6f, 0x8f5a18, 0x010014, 0x54442a, 0xc75a22, 0x2c2422, 0x0b0d1a, 0x0e151d, 0x1c1e11, 0x1c1c10, 0x040710, 0x333041, 0xfffafd, 0xc5c6c0, 0x010200, 0xdbdcd6, 0xf8f9f4, 0xfffffd, 0xf8f8f8, 0xffffff, 0xfcfcfe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xfafafa, 0xe3e3e3, 0xfefefe, 0xffffff, 0xffffff, 0xfdfdfd, 0xeeeeee, 0x6e6e6e, 0xe5e5e5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xd4d4d4, 0x6d6d6d, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xfefefe, 0xffffff, 0xe2e2e2, 0xfefefe, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xf9f9f9, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xc4c4c4, 0x030000, 0xd9d6d1, 0xfbfaf5, 0x23241f, 0x090907, 0x181a19, 0x1e2221, 0x15191a, 0x091513, 0x36231d, 0xa75919, 0x57381c, 0x040005, 0x916423, 0xfcd66b, 0xffc35d, 0xfa9a29, 0x3f2318, 0x001829, 0x00000c, 0x905921, 0xdd8f20, 0x954009, 0xa85722, 0x9f4e30, 0x331f16, 0x001117, 0x181d21, 0x080000, 0x4e4c4f, 0xfbffff, 0xfafaee, 0xfcfcfc, 0xffffff, 0xffffff, 0xd9d9d9, 0x171717, 0x000000, 0x323232, 0xebebeb, 0xfafafa, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xfcfcfc, 0xfafafa, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xf3f3f3, 0xffffff, 0x595959, 0x050505, 0x6d6d6d, 0xffffff, 0xfefefe, 0xffffff, 0xfffefc, 0xf7f3f0, 0xfffefb, 0xd1d0ce, 0x0c0d0f, 0x030a10, 0x141d24, 0x280509, 0x7b4519, 0xaa5514, 0xb15700, 0xa25e09, 0x3e1712, 0x130735, 0x001111, 0x41342b, 0xff8a12, 0xffbe48, 0xf6d466, 0x723f08, 0x000019, 0x493c2b, 0xb24713, 0x131311, 0x101721, 0x171f22, 0x202111, 0x18180c, 0x070918, 0x454158, 0xfff8ff, 0x7f807a, 0x030400, 0xf1f2ec, 0xfefffa, 0xfafaf8, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xfefefe, 0xf7f7f7, 0x8a8a8a, 0xe6e6e6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xd6d6d6, 0x888888, 0xffffff, 0xfefefe, 0xffffff, 0xfafafa, 0xffffff, 0xf5f5f5, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfcfcfc, 0xfbfbfb, 0xf8f8f8, 0xe7e7e7, 0x030000, 0xadaaa5, 0xfffef9, 0x343530, 0x050503, 0x1b1d1c, 0x1a1e1d, 0x121617, 0x121911, 0x2a2722, 0x9a531f, 0x663d11, 0x060000, 0x775525, 0xeaca51, 0xffbc4f, 0xf4881b, 0x46270a, 0x001014, 0x130f34, 0x551c01, 0xa95a00, 0xa75212, 0xae5c20, 0x853220, 0x190b0b, 0x021d26, 0x060b0e, 0x291b18, 0xe1e1e1, 0xf9fffd, 0xfffff1, 0xfafafa, 0xffffff, 0xfdfdfd, 0xffffff, 0x424242, 0x111111, 0x666666, 0xffffff, 0xffffff, 0xfefefe, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0x949494, 0x010101, 0xcfcfcf, 0xfdfdfd, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xf5f5f5, 0xfdfdfd, 0x969696, 0x000000, 0x1d1d1d, 0x000a29, 0x482819, 0xb96424, 0xb15107, 0x935522, 0x2b1903, 0x0b1411, 0x031519, 0x281b25, 0xce9637, 0xffb91d, 0xfdb851, 0x463926, 0x00030b, 0x5e4737, 0x8a3e0d, 0x121116, 0x111015, 0x1e1e20, 0x202020, 0x191919, 0x000000, 0x747570, 0xfffffb, 0x6c5857, 0x110e09, 0xeffaf4, 0xf5fefd, 0xfffdff, 0xfffbff, 0xf9f7fa, 0xf8ffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffffd, 0xffffff, 0xfffeff, 0xfffeff, 0xfffeff, 0xfffeff, 0xffffff, 0xfffffd, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xf0f0f0, 0xbfbfbf, 0xe5e5e5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xdddddd, 0xc4c4c4, 0xf2f2f2, 0xffffff, 0xffffff, 0xfffffb, 0xf8f8f6, 0xfefefc, 0xffffff, 0xfcfcfe, 0xfaf9fe, 0xfffeff, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcf8, 0xf9fcf5, 0xf5fffd, 0xf8ffff, 0xfffaff, 0xfff9ff, 0xfff8fd, 0xe9e9e9, 0x000000, 0x7e7e7e, 0xfcfcfc, 0x5c5c5c, 0x000000, 0x1b1b1b, 0x1d1d1d, 0x1e1e1e, 0x171a2b, 0x220e05, 0x79451e, 0x52302f, 0x000329, 0x55431b, 0xfeba35, 0xffb935, 0xd78f2d, 0x0a1a0d, 0x002326, 0x181601, 0x2f1d13, 0x805135, 0xb25617, 0xc2581e, 0x2a2a2a, 0x121212, 0x1f1f1f, 0x000000, 0xaeaeae, 0xffffff, 0xfafafa, 0xffffff, 0xfefefe, 0xffffff, 0xf6f6f6, 0xfdfdfd, 0xc2c2c2, 0x000000, 0xa6a6a6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xbbbbbb, 0x656565, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xe4e4e4, 0x595959, 0x000000, 0x16253a, 0x1f0800, 0x8e4713, 0xc3651d, 0x8b4a14, 0x332313, 0x081315, 0x0c1818, 0x0e090f, 0xa87631, 0xffc133, 0xefac37, 0x3e2d13, 0x040c17, 0x473425, 0x82421e, 0x100f14, 0x111015, 0x1a1a1c, 0x1c1c1c, 0x1c1c1c, 0x020200, 0x8e8f8a, 0xfffffb, 0x4a3836, 0x24211c, 0xf7fffb, 0xfafffe, 0xfffdff, 0xfff9ff, 0xfefcfd, 0xf6fffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffffd, 0xffffff, 0xffffff, 0xfffeff, 0xfffeff, 0xffffff, 0xffffff, 0xfffffd, 0xfdfdfd, 0xffffff, 0xfafafa, 0xffffff, 0xfdfdfd, 0xdcdcdc, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xf6f6f6, 0xe1e1e1, 0xfcfcfc, 0xffffff, 0xfefefe, 0xfffffd, 0xf9f9f7, 0xfefefc, 0xffffff, 0xfdfdff, 0xfdfdff, 0xfffeff, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffdf8, 0xfefffa, 0xf5fffd, 0xf6fffc, 0xfff8fd, 0xfff9ff, 0xfffcff, 0xf5f7f6, 0x0c0c0c, 0x545454, 0xfcfcfc, 0x808080, 0x040404, 0x1b1b1b, 0x1c1c1c, 0x181818, 0x111b1d, 0x18090e, 0x71432b, 0x4e3121, 0x000619, 0x513a1a, 0xefa72f, 0xffc638, 0x9f6923, 0x08120a, 0x031b1f, 0x171508, 0x311d12, 0x8c5431, 0xb85e1f, 0x924011, 0x101010, 0x1d1d1d, 0x000000, 0x5e5e5e, 0xeaeaea, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xe9e9e9, 0x5c5c5c, 0xc7c7c7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfafafa, 0xe5e5e5, 0xd2d2d2, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xbcbcbc, 0x050505, 0x12161f, 0x0c0606, 0x592905, 0xc56a24, 0x954e16, 0x31271b, 0x08171e, 0x161711, 0x010707, 0x663a1f, 0xffba43, 0xf0b22d, 0x3b2002, 0x0d0c1c, 0x332719, 0x613623, 0x121116, 0x16151a, 0x18181a, 0x181818, 0x1c1c1c, 0x000000, 0xaeafaa, 0xfefffa, 0x291b18, 0x2e2d29, 0xf7fffd, 0xfefffd, 0xfff9f7, 0xfff4f1, 0xfffefb, 0xf3fcfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffffd, 0xfffffd, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfbfbfb, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefc, 0xfcfcfa, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffef8, 0xfcfffb, 0xf7fffe, 0xf6fbf7, 0xfff7f5, 0xfffaf8, 0xfffdfb, 0xf6fafb, 0x181818, 0x2e2e2e, 0xfefefe, 0x9a9a9a, 0x010101, 0x1e1e1e, 0x1c1c1c, 0x161616, 0x0a1e13, 0x160f1f, 0x583227, 0x422d10, 0x000504, 0x4e3316, 0xf0a73e, 0xfcbd32, 0x4e3318, 0x0b090a, 0x12171b, 0x141311, 0x392115, 0x9e5a2b, 0xb36326, 0x512309, 0x0f0f0f, 0x090909, 0x141414, 0xcecece, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xd3d3d3, 0xececec, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xf9f9f9, 0xffffff, 0xffffff, 0xf9f9f9, 0xfefefe, 0xffffff, 0xfefefe, 0xf9f9f9, 0xffffff, 0xf7f7f7, 0xffffff, 0xf5f5f5, 0x7a7a7a, 0x040000, 0x0f181f, 0x301907, 0xa15315, 0xaf672d, 0x30261d, 0x051620, 0x1f1810, 0x0b1c16, 0x24040f, 0xc88c34, 0xfbc73f, 0x4d2c0b, 0x07000e, 0x2e281a, 0x341c1c, 0x19181d, 0x1d1c21, 0x1c1c1e, 0x191919, 0x161616, 0x000000, 0xc6c7c2, 0xf9faf5, 0x18110b, 0x252726, 0xf1f7f7, 0xfffef9, 0xf9ebe0, 0xfff1e3, 0xfffcf6, 0xf9ffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefeff, 0xffffff, 0xfffffb, 0xfffffa, 0xfffffa, 0xfffffb, 0xffffff, 0xfefeff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfcfcfc, 0xfefefe, 0xffffff, 0xfefefe, 0xfdfdfd, 0xfefefe, 0xfefefe, 0xfdfdfb, 0xfefefc, 0xfffffb, 0xfffffb, 0xfdfef9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfef9f3, 0xfcffff, 0xf6fffe, 0xfffef9, 0xfff4e9, 0xffeddf, 0xfffaf4, 0xeaeff2, 0x111111, 0x242424, 0xffffff, 0xa3a3a3, 0x000000, 0x1e1e1e, 0x1c1c1c, 0x1b1b1b, 0x0a1f16, 0x1c202b, 0x381e11, 0x312108, 0x000202, 0x5d3f19, 0xfeba55, 0xba8619, 0x0e0c17, 0x160b13, 0x231d21, 0x0e0b12, 0x4a2b19, 0xae612b, 0x965422, 0x20130d, 0x191919, 0x000000, 0x929292, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xf9f9f9, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfcfcfc, 0xffffff, 0xf6f6f6, 0xfefefe, 0xffffff, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xffffff, 0xfdfdfd, 0xf8f8f8, 0xffffff, 0xf4f4f4, 0x33291f, 0x000512, 0x0f0e0a, 0x6d3001, 0xb77541, 0x433228, 0x010a13, 0x261d18, 0x162925, 0x0a0012, 0x6c450c, 0xe3bd4e, 0x715235, 0x080004, 0x262417, 0x19111c, 0x19181d, 0x1d1c21, 0x1e1e20, 0x1b1b1b, 0x0d0d0d, 0x090907, 0xd9dad5, 0xfbfcf7, 0x0e0e06, 0x111516, 0xe6ebee, 0xfffdf5, 0xedd8c3, 0xfff2da, 0xfffcf1, 0xfbffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefdff, 0xffffff, 0xfffff8, 0xfbfdf0, 0xfbfdf0, 0xfffff8, 0xffffff, 0xfefdff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xfefefe, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xfefefe, 0xfdfdff, 0xffffff, 0xfefefe, 0xfdfdfb, 0xfefffa, 0xfefff9, 0xfdfef6, 0xfefff5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcf5, 0xfcffff, 0xf8fcff, 0xfffef6, 0xfeecd6, 0xf5e1c8, 0xfff9ed, 0xd8e0e3, 0x030303, 0x252525, 0xffffff, 0xbcbcbc, 0x010101, 0x131313, 0x1d1d1d, 0x1e1e1e, 0x0b1d1f, 0x1a2322, 0x2b1b04, 0x24170f, 0x00000c, 0x7a602f, 0xeeb858, 0x5a3700, 0x000622, 0x1f141a, 0x291f27, 0x0b060d, 0x633b21, 0xb06730, 0x643917, 0x030c11, 0x000000, 0x414141, 0xf9f9f9, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xfefefe, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfefefe, 0xffffff, 0xafa79a, 0x00040e, 0x00050b, 0x3f1a00, 0x976135, 0x664b38, 0x030104, 0x262022, 0x162222, 0x0d081e, 0x200f00, 0x998445, 0x7d6656, 0x0f0100, 0x1a1b0d, 0x191b2a, 0x16151a, 0x18171c, 0x1d1d1f, 0x1a1a1a, 0x060606, 0x30302e, 0xecede8, 0xfffffb, 0x161c12, 0x01090b, 0xc6c9ce, 0xfffdf3, 0xe9d0b2, 0xffebc7, 0xfffeed, 0xf7fcff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefdff, 0xffffff, 0xfffff6, 0xf7fae7, 0xf7fae7, 0xfffff6, 0xffffff, 0xfefdff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefdff, 0xffffff, 0xfdfdfd, 0xfefffa, 0xfefff9, 0xf7f9ee, 0xf5f7e9, 0xfffff3, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffff8, 0xfcffff, 0xfbfaff, 0xfffcf3, 0xf5debf, 0xf8e2bd, 0xffffed, 0xb2bbc0, 0x000000, 0x353535, 0xffffff, 0xe9e9e9, 0x252525, 0x040404, 0x1c1c1c, 0x1b1b1b, 0x11191c, 0x0f1813, 0x2c210d, 0x20151b, 0x05071c, 0x836c40, 0xa98237, 0x120600, 0x091428, 0x1f1b1c, 0x1c1c24, 0x130a0d, 0x79481f, 0x955b2d, 0x2f1d11, 0x000a10, 0x000000, 0xc0c0c0, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfefefe, 0xfafafa, 0xffffff, 0xfcfcfc, 0xf5f5f5, 0xf9f9f9, 0xfdfbef, 0x4c5d64, 0x00050d, 0x1b0d00, 0x613616, 0x7d553b, 0x1c0a06, 0x181b24, 0x16191e, 0x16191e, 0x080a00, 0x423c30, 0x534441, 0x201406, 0x191708, 0x1a1d2c, 0x17161b, 0x16151a, 0x1c1c1e, 0x171717, 0x020202, 0x646462, 0xfcfdf8, 0xfffffb, 0x424c41, 0x000305, 0x83838b, 0xfffcf1, 0xf7dbb6, 0xedd2a7, 0xfffeea, 0xf8fdff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefcff, 0xffffff, 0xfdfff2, 0xf2f6df, 0xf2f6df, 0xfdfff2, 0xffffff, 0xfefcff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfdfdfd, 0xfffeff, 0xfefdff, 0xfdfdfd, 0xfffffb, 0xfefff7, 0xeff1e4, 0xedf0df, 0xffffef, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefff8, 0xfcffff, 0xfffdff, 0xfffaf0, 0xe7cda8, 0xffe9bd, 0xffffea, 0x6a7579, 0x000000, 0x616161, 0xfefefe, 0xffffff, 0x535353, 0x010101, 0x1b1b1b, 0x181818, 0x18180e, 0x15151d, 0x271916, 0x211819, 0x0f1525, 0x5b4631, 0x51330d, 0x00091a, 0x1c2021, 0x161b14, 0x071822, 0x281e15, 0x844812, 0x5f3714, 0x060d15, 0x040c0e, 0x666666, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfcfcfc, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfffff8, 0xccdadd, 0x000c16, 0x070602, 0x3a1600, 0x7f4e2e, 0x341c10, 0x091020, 0x1c1922, 0x131d12, 0x121e1e, 0x0c0e25, 0x1a1018, 0x2b200a, 0x201d0e, 0x131723, 0x1d1c21, 0x19181d, 0x1d1d1f, 0x141414, 0x010101, 0x888886, 0xfffffb, 0xfbfcf7, 0x738076, 0x000307, 0x414149, 0xfffcef, 0xffebc1, 0xd4b889, 0xfffde7, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefcff, 0xffffff, 0xfcfef0, 0xeff3da, 0xeff3da, 0xfcfef0, 0xffffff, 0xfefcff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xf9f9f9, 0xffffff, 0xf9f9f9, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfdfdfd, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xf4f4f4, 0xfefefe, 0xffffff, 0xfffeff, 0xfefdff, 0xfcfcfc, 0xfffffb, 0xfefff5, 0xe9ebdd, 0xe8ebd8, 0xffffed, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9fcf5, 0xfcffff, 0xfffdff, 0xfff5e9, 0xdfc499, 0xffedbd, 0xfcf8df, 0x243137, 0x000000, 0x929292, 0xfefefe, 0xffffff, 0x727272, 0x080808, 0x1a1a1a, 0x191919, 0x201a00, 0x221d34, 0x1a0919, 0x221b13, 0x171e26, 0x281415, 0x180000, 0x0b233b, 0x242112, 0x0e1a0e, 0x001722, 0x3e3023, 0x834305, 0x2f1400, 0x00061b, 0x10110c, 0xeeeeee, 0xffffff, 0xffffff, 0xffffff, 0xf5f5f5, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfef9f5, 0xfffefa, 0x928d89, 0x040000, 0x140f0b, 0x433e3a, 0x36312d, 0x16110d, 0x19150a, 0x1a1915, 0x16161e, 0x171926, 0x13161d, 0x1c1c14, 0x1b1500, 0x231b00, 0x161223, 0x2c1c0f, 0x161831, 0x101334, 0x1a0000, 0x9f9154, 0xf5fffd, 0xf7feff, 0xd9c5d0, 0x000a00, 0x000c00, 0xb0baef, 0xfffce8, 0xd8be47, 0xfadaa9, 0xfff7ff, 0xffffee, 0xfffdff, 0xfff9ff, 0xfbfdff, 0xf7ffff, 0xf1feff, 0xf4f8ff, 0xfefaff, 0xfffff3, 0xecf0ff, 0xffffe6, 0xf7db92, 0xffe2cd, 0xfffeff, 0xf2fff8, 0xf9ffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcff, 0xfbf8f3, 0xf4ffff, 0xedfff3, 0xfffbff, 0xffdfcf, 0xf6e18e, 0xf9feff, 0xfff9fb, 0xfaf8f9, 0xf4ffff, 0xf5ffff, 0xfdfbfc, 0xfffcfa, 0xfffdf7, 0xf8fbf0, 0xfcfdff, 0xeafef3, 0xf0ffff, 0xf3d1a4, 0xfba955, 0xfff3ed, 0x97a2b4, 0x0a0007, 0x181310, 0xe5e1d6, 0xfaf2ff, 0xfffef8, 0x848655, 0x040000, 0x221739, 0x1b1a00, 0x1a1a18, 0x1f1c0d, 0x271f08, 0x160a00, 0x261a26, 0x18142b, 0x091223, 0x0d2026, 0x1f1a16, 0x1a1511, 0x100b07, 0x413c38, 0x423d39, 0x18130f, 0x040000, 0xa39e9a, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffefa, 0xfaf5f1, 0xf4efeb, 0x322d29, 0x0d0804, 0x2b2622, 0x3b3632, 0x18130f, 0x201c13, 0x201f1d, 0x1f1f27, 0x1b1d29, 0x191c23, 0x1a1914, 0x201906, 0x5b5233, 0x1e1b12, 0x1e1916, 0x1a1c33, 0x1c1c24, 0x140300, 0x968655, 0xfffff3, 0xf8f8f8, 0xfffeef, 0x303129, 0x00040b, 0x363249, 0xfff2f8, 0xfad891, 0xcea843, 0xfff3d8, 0xfbffff, 0xeaf0fc, 0xfbffff, 0xfffff3, 0xfbf7ec, 0xfff7ff, 0xfffcff, 0xfdfeff, 0xfffff3, 0xf9fdff, 0xffffea, 0xdfc47f, 0xf8d6bb, 0xfaf6f7, 0xf5fffb, 0xfaffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffaff, 0xfffffa, 0xf0fefe, 0xf1fff6, 0xfffaff, 0xf8cbb6, 0xe1cc7d, 0xf9ffff, 0xfff8ff, 0xfffeff, 0xf7ffff, 0xf7ffff, 0xfffefc, 0xfffdfb, 0xfffff8, 0xf7fff6, 0xf9f9ff, 0xfdfdff, 0xfff1c1, 0xdead5e, 0xfad39a, 0xfbeedd, 0x2e2b32, 0x030000, 0x3f443d, 0xfffdff, 0xfff7ff, 0xfffee8, 0x847d47, 0x080000, 0x231c2c, 0x141416, 0x141613, 0x212214, 0x5a5541, 0x261c13, 0x261a24, 0x1a1627, 0x1b1f2b, 0x131f1f, 0x1c1713, 0x27221e, 0x1b1612, 0x3c3733, 0x2a2521, 0x040000, 0x504b47, 0xf6f1ed, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffcf8, 0xfffefa, 0xfffefa, 0xafaaa6, 0x060100, 0x130e0a, 0x27221e, 0x1b1612, 0x221d17, 0x1b1a18, 0x16171c, 0x12151e, 0x23262b, 0x15140f, 0x160f00, 0x8d836a, 0x5e5946, 0x06110d, 0x151b1b, 0x1f191b, 0x070100, 0x7e713a, 0xfff3bb, 0xfffbfb, 0xfcffed, 0x89857a, 0x0a0015, 0x0a0000, 0x9d8992, 0xfff7e6, 0xd7a739, 0xffb863, 0xfffff8, 0xf9ffff, 0xe8f6f7, 0xfeffe6, 0xfff5dc, 0xfff5ff, 0xfdeffe, 0xfbfff8, 0xfffff3, 0xf8ffff, 0xfffff1, 0xd6b97d, 0xc9a581, 0xfff6ef, 0xf8fffd, 0xfbffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffbff, 0xfffffa, 0xeefaf8, 0xf4fffb, 0xfff4f1, 0xc69978, 0xdfc885, 0xf8ffff, 0xfdf6ff, 0xfefeff, 0xf0f6f4, 0xfcfffd, 0xfffeff, 0xf4f4f4, 0xf6fffb, 0xeefff9, 0xfff8ff, 0xfff0f6, 0xffc34a, 0xdba43f, 0xfcffed, 0x78866c, 0x0b0000, 0x030c0b, 0x98a999, 0xfefbff, 0xfffafb, 0xfff4af, 0x796526, 0x0f0000, 0x1a141e, 0x161c2c, 0x000300, 0x5e6053, 0x7c7a6d, 0x0a0300, 0x1f141a, 0x221a25, 0x222025, 0x12140f, 0x1d1814, 0x1e1915, 0x1e1915, 0x201b17, 0x0f0a06, 0x100b07, 0xbeb9b5, 0xfffefa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfaf6f3, 0xfffefb, 0xf3efec, 0xfffefb, 0x575350, 0x030000, 0x15110e, 0x1d1916, 0x211c18, 0x1a1917, 0x191a1e, 0x0c0f14, 0x1e2225, 0x0f0e0a, 0x100700, 0x94887a, 0xc7bab1, 0x000c08, 0x0a0e00, 0x2e2128, 0x000011, 0x564f07, 0xf1d069, 0xfff8ec, 0xf4ffff, 0xdad5cf, 0x0f0016, 0x140710, 0x060a00, 0xe4d8dc, 0xffe9ba, 0xdc8913, 0xf8d28b, 0xfffaed, 0xf7ffff, 0xe6f6eb, 0xffffea, 0xffedec, 0xfff9ff, 0xfbfef5, 0xfefcf0, 0xf1fbff, 0xfefffa, 0xedd19f, 0x8a6433, 0xf9e8d6, 0xf8fcfb, 0xf8fefc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffeff, 0xfcfcf4, 0xf1faf7, 0xf8ffff, 0xe5d4c4, 0x906433, 0xfbe2ac, 0xf7ffff, 0xfcffff, 0xecf1eb, 0xfefff4, 0xfffff7, 0xf9f7fc, 0xfafcff, 0xe8f6f9, 0xf0ffff, 0xfffaf3, 0xffc187, 0xf1991b, 0xffe6a0, 0xc8dcdb, 0x000600, 0x0f0800, 0x081d20, 0xe0efe8, 0xfbf3ff, 0xfff9d5, 0xe9d363, 0x5a3b05, 0x1b010e, 0x25242c, 0x07161b, 0x000300, 0xc9cbbe, 0x817e75, 0x040000, 0x1f1619, 0x1f1619, 0x1c1412, 0x1e1a11, 0x1a1613, 0x171310, 0x1e1a17, 0x16120f, 0x030000, 0x787471, 0xfffcf9, 0xfefaf7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffffd, 0xfffffd, 0xfdfcfa, 0xfffffd, 0xdddcda, 0x151412, 0x0f0e0c, 0x1e1d1b, 0x1d1815, 0x11100e, 0x202123, 0x121619, 0x1b1f20, 0x232220, 0x150b09, 0x392c26, 0xffeed2, 0x464c62, 0x010007, 0x2a2319, 0x071518, 0x201c00, 0xc8a142, 0xffdf9b, 0xf7ffff, 0xfaf2ff, 0x4f424c, 0x000200, 0x000b00, 0x545f61, 0xfff4ff, 0xeeb05b, 0xdc8f01, 0xf8c78f, 0xe9e0f1, 0xf1ffff, 0xf3fffc, 0xf1f3e6, 0xfffefa, 0xfdf9f8, 0xfffef4, 0xf5ffff, 0xf9ffff, 0xffeec7, 0x795012, 0xc2aa8e, 0xfffeff, 0xf3f9f5, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfffeff, 0xfffff6, 0xf7fef7, 0xfbffff, 0xa69174, 0x8b5e1b, 0xfff7d2, 0xf3ffff, 0xf9fff6, 0xfcffed, 0xffffea, 0xfffff8, 0xfcfaff, 0xfbfcff, 0xfcffff, 0xe8ebe0, 0xf5cf7e, 0xde8d0a, 0xf6b66f, 0xfffff6, 0x494e51, 0x070000, 0x091201, 0x3a555c, 0xfdf5ff, 0xfffdec, 0xf8ea7f, 0xa68f27, 0x310e0c, 0x1c061b, 0x23291d, 0x000509, 0x6f6b50, 0xeeebd8, 0x2d2822, 0x080405, 0x2c2829, 0x231e1b, 0x211a14, 0x201712, 0x151412, 0x1e1d1b, 0x22211f, 0x11100e, 0x1e1d1b, 0xe5e4e2, 0xfffffd, 0xfcfbf9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xf6f6f6, 0xffffff, 0x808080, 0x000000, 0x181818, 0x231d1d, 0x1b1a18, 0x2a2c2b, 0x131716, 0x030706, 0x1a1819, 0x23181c, 0x0a0000, 0xd6c37e, 0xe2cef1, 0x21103c, 0x000500, 0x1b2f13, 0x040004, 0x7a532c, 0xefc652, 0xf7e8af, 0xfff2ff, 0xb6b4a7, 0x000900, 0x072525, 0x000a07, 0xaba0ae, 0xfff8e3, 0xf8a612, 0xd39234, 0x8b6852, 0xdad7ea, 0xf1ffff, 0xf2fffa, 0xf8fff1, 0xfffdff, 0xfffdf4, 0xf4ffff, 0xf5ffff, 0xfff7da, 0xa87c31, 0x7a5d35, 0xfffcff, 0xfcfffa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfcff, 0xfffff4, 0xfdfff9, 0xfffcff, 0x6a5129, 0xba8b3b, 0xfff7e2, 0xeffffc, 0xf5ffed, 0xfeffea, 0xf4f8e1, 0xfdfffc, 0xfcfdff, 0xfffbff, 0xdecec1, 0x8c7048, 0xd09611, 0xeeac22, 0xfff9f1, 0x8d9dbe, 0x060000, 0x1a090f, 0x000600, 0xb3c4cb, 0xffefff, 0xffe98b, 0xe0d23e, 0x5a4212, 0x170024, 0x171111, 0x000800, 0x10202f, 0xfff8cc, 0xcabca1, 0x070000, 0x252122, 0x161616, 0x070802, 0x1e1d18, 0x252120, 0x1d1d1d, 0x121212, 0x1f1f1f, 0x000000, 0x929292, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfefefe, 0xf8f8f8, 0xffffff, 0xf5f5f5, 0xe6e6e6, 0x222222, 0x0c0c0c, 0x161012, 0x1c1b19, 0x151714, 0x121713, 0x111514, 0x010002, 0x11060e, 0x190914, 0x7a6317, 0xfff5e2, 0x938096, 0x0a1517, 0x111f12, 0x09061b, 0x2e120f, 0xb78023, 0xfabf41, 0xffdfb5, 0xf7f4e5, 0x2f4338, 0x000509, 0x000400, 0x363833, 0xdad8e6, 0xffe99a, 0xce9925, 0xa06905, 0x79503a, 0xf1e9fe, 0xeeffff, 0xf5fff6, 0xfdfef9, 0xfffaf1, 0xf0fffd, 0xf2ffff, 0xfff6e1, 0xe7b964, 0x583608, 0xbcb0bc, 0xfcfff8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9fdff, 0xfffff4, 0xfffff8, 0xa8a0b8, 0x593d0d, 0xefc064, 0xfff5ea, 0xeffffd, 0xfcfffb, 0xf0f2e5, 0xfffff6, 0xf2f9ff, 0xf6fdff, 0xd9d0d1, 0x835f2d, 0x986003, 0xf4a81f, 0xffeca9, 0xc8d1e2, 0x131f39, 0x050402, 0x090b08, 0x38433f, 0xfffffb, 0xffdfb4, 0xe1b83c, 0x9a811a, 0x281413, 0x110c23, 0x081207, 0x091708, 0x8d9aa2, 0xffe7ab, 0x6b532f, 0x0b0000, 0x1a1519, 0x020605, 0x0c130c, 0x0c100f, 0x16161e, 0x1f1f1f, 0x0b0b0b, 0x0d0d0d, 0x202020, 0xf0f0f0, 0xfafafa, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfeffff, 0xfeffff, 0xfcfdff, 0xfeffff, 0xfeffff, 0xfeffff, 0x727375, 0x000103, 0x201a1c, 0x21201e, 0x030500, 0x565b55, 0xb5bab6, 0x5c5a5d, 0x0f030f, 0x0c000b, 0x381900, 0xd9af4d, 0xfffedf, 0x616ca4, 0x00001c, 0x262a29, 0x110200, 0x621c00, 0xffa602, 0xe4b22d, 0xfffcfa, 0xb6c0d9, 0x000300, 0x221d17, 0x000200, 0x1e2e3d, 0xfaefeb, 0xffe86d, 0xf4af0a, 0x8a4100, 0x724f67, 0xf3fbff, 0xf0fff6, 0xfafff3, 0xfffdf4, 0xebfff7, 0xf1ffff, 0xfff9e8, 0xffd87e, 0x573200, 0x514350, 0xf7fdf1, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbffff, 0xf2f2e6, 0xfffff8, 0x3d304e, 0x674913, 0xffdb77, 0xfff6f1, 0xf0fffe, 0xf6f6ff, 0xfffeff, 0xf6f7fb, 0xf7ffff, 0xdfe7fa, 0x65594b, 0x7c4d00, 0xffb730, 0xffd35a, 0xf0edf6, 0x06202d, 0x010000, 0x071216, 0x000900, 0xd4d2d5, 0xfff2e5, 0xfcaf2f, 0xdda12f, 0x441d00, 0x13060f, 0x18260f, 0x000703, 0x737f97, 0xf8fff4, 0xd1ac66, 0x1e0000, 0x120000, 0x030002, 0x666c6a, 0xb5c0ba, 0x454f50, 0x010713, 0x101113, 0x212224, 0x000002, 0x919294, 0xfafbfd, 0xfeffff, 0xfeffff, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xe4e4e4, 0x080808, 0x0f0f0f, 0x181818, 0x020202, 0x727272, 0xffffff, 0xf9f9f9, 0x9f9f9f, 0x181818, 0x080009, 0x8e611e, 0xedbc45, 0xffffc8, 0x485065, 0x000500, 0x191b03, 0x080030, 0x2f3b31, 0xf0aa17, 0xffb428, 0xfff4e8, 0x727086, 0x000700, 0x102310, 0x0d0906, 0x3a4f7a, 0xfffbfb, 0xefaf4d, 0xffa701, 0x7f4800, 0x3f3a51, 0xf4fbff, 0xfff7f6, 0xfbfef5, 0xfffdff, 0xfcfbff, 0xfffcf3, 0xffdd97, 0xce8a35, 0x180000, 0x77a4b7, 0xfffeff, 0xeeedf3, 0xfeffff, 0xf3f7f8, 0xfbffff, 0xfbfffd, 0xf9fffd, 0xf8fffa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xfef9ff, 0xeeffef, 0x737a84, 0x290000, 0xce9c1f, 0xffed97, 0xf4f2ff, 0xfcffff, 0xf1f9ff, 0xffffe1, 0xf6ffea, 0xf1ffff, 0x442a35, 0x8e4500, 0xfdad20, 0xf0bb5b, 0xf6f6ff, 0x303642, 0x030000, 0x21101a, 0x000800, 0x829895, 0xfff3ff, 0xffb100, 0xe6a128, 0x423400, 0x00040b, 0x162123, 0x000400, 0x5a567b, 0xfff7f3, 0xf9c734, 0x4a4a4a, 0x000000, 0x212121, 0xa8a8a8, 0xffffff, 0xffffff, 0x6b6b6b, 0x040404, 0x1c1c1c, 0x0a0a0a, 0x1e1e1e, 0xeeeeee, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xf7f7f7, 0xfbfbfb, 0xfcfcfc, 0xffffff, 0xffffff, 0xf8f8f8, 0x434343, 0x000000, 0x1c1c1c, 0x0a0a0a, 0x8e8e8e, 0xfefefe, 0xffffff, 0xffffff, 0xcbcbcb, 0x130b1a, 0x180300, 0xbd994b, 0xf6cf58, 0xf2d884, 0x3a2f35, 0x0d0d2f, 0x0b110d, 0x0f0400, 0x614b1a, 0xe7a83f, 0xffbd5d, 0xfffbf4, 0x35445b, 0x030801, 0x101308, 0x000109, 0x756d7c, 0xfff5cb, 0xecb32e, 0xe3a629, 0x5d3114, 0x403249, 0xf9ffff, 0xfbffff, 0xe9e7ea, 0xf6f8ff, 0xfffffd, 0xffe1aa, 0xf5ae52, 0x452000, 0x0b2933, 0xe2e1e6, 0xfffeff, 0xfeffff, 0xf9fafc, 0xfcffff, 0xfbfffd, 0xf8fffc, 0xf2fbf6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfffdff, 0xb9cfc3, 0x1c1b20, 0x66350c, 0xf0bc44, 0xfae7a2, 0xfefdff, 0xfeffff, 0xfffeff, 0xf6fff6, 0xedffff, 0x2c2836, 0x744318, 0xf6aa30, 0xe2a731, 0xfffcc4, 0x5d686c, 0x0c0910, 0x1b1523, 0x000400, 0x515669, 0xfff1e1, 0xf7d35b, 0xe8a652, 0x593910, 0x110000, 0x26292e, 0x000110, 0x473e3f, 0xfde38e, 0xf9d656, 0xa2782e, 0x080808, 0x171717, 0xc4c4c4, 0xffffff, 0xf6f6f6, 0xffffff, 0x767676, 0x040404, 0x191919, 0x050505, 0x515151, 0xf7f7f7, 0xfbfbfb, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0x878787, 0x000000, 0x191919, 0x010101, 0xababab, 0xf4f4f4, 0xfdfdfd, 0xffffff, 0xfdfdfd, 0x86808c, 0x00000f, 0x33210b, 0xd9a223, 0xffd730, 0xc29e6e, 0x020020, 0x0f1b0d, 0x231200, 0x000019, 0x765b2c, 0xf7ac1f, 0xffe79b, 0xe1dbf7, 0x000620, 0x0c1100, 0x1a1200, 0x030119, 0xafb1be, 0xffefa1, 0xf1b428, 0xe99630, 0x2a0100, 0x546c6e, 0xf7ffff, 0xfeffff, 0xf9ffff, 0xfbffff, 0xffe4c2, 0xffc15b, 0xab7922, 0x000100, 0x6f6d6e, 0xfffeff, 0xf7f7f7, 0xfeffff, 0xfbfffe, 0xfcffff, 0xfbfffd, 0xfbfffd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xf4f4f4, 0xffffff, 0xfffff6, 0x515b64, 0x0b0000, 0xb57e2c, 0xfcc757, 0xfffbcf, 0xf8fcff, 0xffffff, 0xfffdf0, 0xecfcff, 0x484f69, 0x350e00, 0xeea031, 0xeaa722, 0xffefa2, 0xadb2ab, 0x000700, 0x161115, 0x0a0e1a, 0x10292d, 0xeee6fe, 0xffe091, 0xdeb209, 0x6b493f, 0x00050f, 0x24152c, 0x1a0919, 0x1d1918, 0xbea467, 0xffdf3a, 0xc89504, 0x301913, 0x000000, 0x939393, 0xffffff, 0xffffff, 0xf5f5f5, 0xf8f8f8, 0x979797, 0x080808, 0x141414, 0x020202, 0x9b9b9b, 0xffffff, 0xfbfbfb, 0xfefefe, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xf6f6f6, 0xffffff, 0xc1c1c1, 0x080808, 0x0c0c0c, 0x030303, 0xd2d2d2, 0xffffff, 0xfbfbfb, 0xfcfcfc, 0xf5f5f5, 0xfcf4f1, 0x283136, 0x030009, 0x643605, 0xe7a513, 0xfecb3a, 0x725d28, 0x0f0b1c, 0x1c232b, 0x0d0b21, 0x0b0006, 0x966a13, 0xfdb32c, 0xffefc9, 0x9da2ca, 0x000301, 0x2c2411, 0x00000c, 0x213651, 0xeff9e1, 0xefbb4d, 0xffb621, 0xbc8123, 0x000500, 0x81899c, 0xfefffd, 0xf5fff9, 0xf0fcff, 0xfff6eb, 0xffb74e, 0xecab33, 0x2f1500, 0x100c09, 0xc4c3bf, 0xfffffb, 0xfffffd, 0xfafcf9, 0xfcffff, 0xf8fcfb, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xf4f4f4, 0xffffff, 0xc8ccb3, 0x0a061d, 0x402102, 0xefaf34, 0xf4ba56, 0xfffdea, 0xf1fcff, 0xfcfbf9, 0xfdfff4, 0x7984a2, 0x0d0002, 0xcf832b, 0xffb41e, 0xecc657, 0xe4ebcc, 0x122232, 0x060900, 0x212832, 0x000709, 0xa8b8c8, 0xfffdbe, 0xeab625, 0x885715, 0x0b0000, 0x0a201e, 0x14111c, 0x1c0112, 0x896b2b, 0xffd736, 0xde9c22, 0x572411, 0x010007, 0x3b3b3b, 0xfdfdfd, 0xf9f9f9, 0xf8f8f8, 0xffffff, 0xf7f7f7, 0xbfbfbf, 0x000000, 0x0d0d0d, 0x0a0a0a, 0xdadada, 0xffffff, 0xfcfcfc, 0xfefefe, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xeeeeee, 0x252525, 0x020202, 0x272727, 0xf1f1f1, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xfffee8, 0x9b9390, 0x040311, 0x08000b, 0x774f1b, 0xf5bc24, 0xebbf3c, 0x391e13, 0x000b22, 0x312229, 0x12041b, 0x150700, 0xbf8b1b, 0xfec049, 0xfffbe4, 0x37466d, 0x000009, 0x060e01, 0x001316, 0x6f7a8c, 0xfffbc6, 0xe39902, 0xf9bc30, 0x492f00, 0x0a0e1a, 0xc5c4c2, 0xf8fff6, 0xeafcff, 0xfff6ff, 0xffb956, 0xfdb221, 0x84510f, 0x030000, 0x6c6962, 0xfffffa, 0xfcfbf7, 0xfbfbf9, 0xfeffff, 0xf6f7f9, 0xfcffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0x525739, 0x07000b, 0x936527, 0xffb821, 0xf8bb62, 0xfaf2ef, 0xf4ffff, 0xfffbf8, 0xbbccd3, 0x01000c, 0x763f18, 0xffaa26, 0xe7a012, 0xffffc8, 0x5c7077, 0x00010e, 0x2d1c14, 0x000513, 0x4a6872, 0xffffdc, 0xf2cd37, 0xa47f0a, 0x21031b, 0x140d07, 0x1f1e1a, 0x07060e, 0x482f19, 0xf6bf3e, 0xf0b60d, 0x734720, 0x070027, 0x010504, 0xbababa, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xe4e4e4, 0x111111, 0x070707, 0x272727, 0xfbfbfb, 0xffffff, 0xfefefe, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xfefefe, 0xfcfcfc, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0x545454, 0x000000, 0x5a5a5a, 0xf8f8f8, 0xfbfbfb, 0xf4f4f4, 0xfafafa, 0xffffff, 0xfffbe1, 0xfff9fd, 0x544f53, 0x00030c, 0x060009, 0x9d6b30, 0xffc54a, 0xa47a16, 0x000200, 0x201c2a, 0x2c1b2b, 0x04000a, 0x312606, 0xd79e1d, 0xffde71, 0xb9c8e5, 0x0a0a24, 0x091300, 0x081704, 0x050c29, 0xd0c1bc, 0xffe374, 0xefb726, 0xb97917, 0x040000, 0x63575b, 0xfbfff4, 0xedffff, 0xffeeff, 0xffc46f, 0xfdaa0e, 0xe19d3a, 0x110d01, 0x211d11, 0xdfdcd3, 0xfffef9, 0xfffffb, 0xffffff, 0xfbfcfe, 0xfeffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xcfcfcf, 0x060b00, 0x220d08, 0xe3a649, 0xfba102, 0xffc676, 0xfffdff, 0xf0ffff, 0xfffefb, 0x364c5a, 0x120000, 0xcb8223, 0xffb523, 0xffde78, 0xafb4ad, 0x000923, 0x191512, 0x1c0d10, 0x000e15, 0xe2e7ed, 0xffe374, 0xc3950c, 0x311b04, 0x050713, 0x1e1a28, 0x200724, 0x1a0e1a, 0x9a842f, 0xffd449, 0x8b550f, 0x040000, 0x000602, 0x666668, 0xffffff, 0xf8f8f8, 0xfdfdfd, 0xffffff, 0xf4f4f4, 0xffffff, 0xf7f7f7, 0x424242, 0x030303, 0x5c5c5c, 0xffffff, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xf9f9f9, 0xffffff, 0x898989, 0x000000, 0x959595, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xfffffd, 0xfffcff, 0xd7cfcc, 0x181a17, 0x070419, 0x170006, 0xbb8c48, 0xf7bf2e, 0x3e240d, 0x121318, 0x0c1117, 0x1b1a28, 0x04010a, 0x5d4000, 0xdfb644, 0xfff7ac, 0x5f555d, 0x020d00, 0x0a1b11, 0x060b21, 0x2d2532, 0xe3ce97, 0xefbb43, 0xffab1d, 0x33230a, 0x1a000b, 0xbfc1b6, 0xebffff, 0xfbf2ff, 0xffc07f, 0xf09c00, 0xfcb132, 0x403a2a, 0x070100, 0x918d82, 0xfffff8, 0xfffffb, 0xfffeff, 0xfbfaff, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0x767676, 0x000100, 0x563e1c, 0xffc148, 0xfc9500, 0xffc77e, 0xfcffff, 0xeaffff, 0xc0b8b6, 0x000209, 0x5e3800, 0xeba625, 0xf1c03f, 0xcfbe88, 0x322b3d, 0x030013, 0x2c251d, 0x000519, 0x8c866c, 0xffe1a5, 0xdeaf45, 0x532e04, 0x0b001a, 0x0c1c11, 0x0d1a23, 0x160730, 0x3e2700, 0xf3d058, 0x9f7b27, 0x17040a, 0x000402, 0x2d3c1f, 0xf4e8f6, 0xfefefe, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xfefefe, 0xf9f9f9, 0x727272, 0x020202, 0x989898, 0xffffff, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xb7b7b7, 0x020202, 0xc9c9c9, 0xffffff, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xf4fbff, 0xf8fff9, 0xfffcfa, 0xb79ba7, 0x080003, 0x000009, 0x361c00, 0xffbe3d, 0x996b53, 0x070100, 0x092731, 0x111c2e, 0x281214, 0x130d0f, 0x716b2d, 0xffd919, 0xc0ae9a, 0x000a06, 0x092028, 0x151b27, 0x030007, 0x30210e, 0xdfae51, 0xffc41c, 0x87714a, 0x160004, 0x5b584f, 0xe0fff0, 0xfffbff, 0xffc18b, 0xfaa308, 0xffb428, 0x6a6552, 0x060000, 0x3f3b2f, 0xf8f4eb, 0xfffdfa, 0xfdfbfc, 0xfdfcff, 0xfffeff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xfefefe, 0xffffff, 0xf9f9f9, 0xffffff, 0xf2f2f2, 0x2c2c2c, 0x000009, 0x866d37, 0xfcaf23, 0xff9f07, 0xffc67f, 0xedf6f3, 0xebffff, 0x483e3f, 0x0c0500, 0xa87a25, 0xffce40, 0xc0ab3e, 0x231f04, 0x0e0010, 0x32172a, 0x14110a, 0x002246, 0xd1b37d, 0xffd041, 0x8d532b, 0x0e0020, 0x1e1a28, 0x1e2730, 0x002212, 0x000115, 0xaa8f1c, 0xeaba3e, 0x33230c, 0x000413, 0x00060e, 0xbdb0c1, 0xfff7ff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfafafa, 0xfcfcfc, 0xfbfbfb, 0xffffff, 0xaeaeae, 0x020202, 0xc0c0c0, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xb1b1b1, 0x3a3a3a, 0xf3f3f3, 0xffffff, 0xfcfcfc, 0xffffff, 0xf8f8f8, 0xffffff, 0xfdfdfd, 0xfefefe, 0xffffff, 0xf6f6f6, 0x6e6e6e, 0x000000, 0x070707, 0x646464, 0xeda64a, 0x430d00, 0x200d07, 0x1b271d, 0x051814, 0x14121d, 0x190000, 0xbe9555, 0xffd653, 0x553810, 0x000009, 0x112f27, 0x06211c, 0x0d051a, 0x431b02, 0xf7bf4e, 0xf1b403, 0x371104, 0x000009, 0xa0afaa, 0xfffff3, 0xf3d895, 0xd6922d, 0xffb81a, 0x8b6c33, 0x080009, 0x0b0600, 0xbda75c, 0xfffaed, 0xf1ffff, 0xeefffb, 0xfffcff, 0xfffdf3, 0xfff9f3, 0xfffbfc, 0xfffcff, 0xfffaff, 0xfeffff, 0xf9fffa, 0xf0feed, 0xffefed, 0xf8fffa, 0xecffff, 0xfcfcff, 0xfff7fe, 0xfffff1, 0x9a9172, 0x190000, 0x040c0e, 0xa07a33, 0xffaf25, 0xf19f1f, 0xf2ca8f, 0xffffff, 0x808f94, 0x000500, 0x440e00, 0xffcd5d, 0xd2b243, 0x191603, 0x00041d, 0x2c2419, 0x1d1606, 0x000427, 0x7f4200, 0xffd76e, 0x947f2c, 0x1a1301, 0x02021a, 0x222536, 0x191a1e, 0x08020c, 0x4e1900, 0xdfb875, 0x705e30, 0x030300, 0x000400, 0x767f7a, 0xfefffb, 0xfbf8f1, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0x2d2d2d, 0xc0c0c0, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xdedede, 0x9c9c9c, 0xffffff, 0xfefefe, 0xfefefe, 0xfafafa, 0xfbfbfb, 0xfefefe, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xeeeeee, 0x3d3d3d, 0x000000, 0x222222, 0xe6ad54, 0x673c12, 0x110300, 0x182416, 0x0f1f1c, 0x100f21, 0x160003, 0x401e00, 0xf1bd50, 0x9a7733, 0x0f0700, 0x031219, 0x112435, 0x13161f, 0x1b0900, 0x63420f, 0xf8bf30, 0x764d2f, 0x040002, 0x243233, 0xeeeee4, 0xffe5a0, 0xeaa229, 0xffac17, 0x926d29, 0x180a17, 0x030106, 0x6f5a19, 0xffe9ad, 0xfffcf3, 0xf9ffff, 0xf8faf9, 0xfffffd, 0xfffdfe, 0xfffeff, 0xfffeff, 0xfbfbfb, 0xfcfffd, 0xfbfffb, 0xf8fff9, 0xfffff8, 0xf8fcfb, 0xf3fbff, 0xfefeff, 0xfffde3, 0xf4da9d, 0x624d22, 0x0b0207, 0x04070c, 0xa17931, 0xffba2d, 0xeb9a17, 0xfff0b3, 0xd6d5d1, 0x232c31, 0x000200, 0x9d652a, 0xe3b557, 0x674e00, 0x0c0800, 0x181e2e, 0x181911, 0x201c11, 0x010012, 0xb9832b, 0xd9b265, 0x442d01, 0x070000, 0x191c25, 0x171c20, 0x121317, 0x14101f, 0x774603, 0xcfaa73, 0x281600, 0x030200, 0x495049, 0xf6fffe, 0xedefee, 0xfffefb, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0x9a9a9a, 0xe5e5e5, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xfcfcfc, 0xffffff, 0xfafafa, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xfefefe, 0xffffff, 0xd0d0d0, 0x181818, 0x000000, 0x9e7831, 0x8b6f48, 0x130c00, 0x071202, 0x13221f, 0x16172b, 0x2d2031, 0x0f0000, 0x985f1c, 0xc6a24c, 0x403000, 0x0c091c, 0x1b2145, 0x15211d, 0x0d1005, 0x050010, 0xb78931, 0xc4955f, 0x140000, 0x00030c, 0x7f8480, 0xffdb96, 0xefa512, 0xffb129, 0x996f1d, 0x110511, 0x03072d, 0x2e1d00, 0xe4b54d, 0xffe0b2, 0xfffafd, 0xf5fff3, 0xfafeff, 0xf8fcff, 0xfbffff, 0xfbffff, 0xf8fff7, 0xf9fff5, 0xfcfffd, 0xfeffff, 0xf4fffb, 0xf3f1fe, 0xfff9ff, 0xfffcf5, 0xffeda4, 0xd49f39, 0x2e1200, 0x001031, 0x0a0412, 0xa0742d, 0xffbb2c, 0xeea11f, 0xffdea0, 0x6f6c63, 0x000002, 0x1d130a, 0xda9e46, 0x957232, 0x160900, 0x0c0904, 0x20282a, 0x05110d, 0x1b1b19, 0x342022, 0xd8ad5e, 0x6e4824, 0x120000, 0x1c1316, 0x282d26, 0x101614, 0x0f0f17, 0x090611, 0xa67e4d, 0x83633c, 0x0e0000, 0x201d14, 0xe1e5e6, 0xfbffff, 0xfeffff, 0xf8f3f7, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xfafafa, 0xffffff, 0xfafafa, 0xfafafa, 0xffffff, 0xffffff, 0xfefefe, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xffffff, 0xf2f2f2, 0xffffff, 0xffffff, 0xaaaaaa, 0x040404, 0x412d0c, 0x5a4b34, 0x0f0d00, 0x0e160b, 0x212c28, 0x050914, 0x141220, 0x1d1520, 0x2b0100, 0x9a7e3d, 0x544413, 0x1c0f20, 0x1b1837, 0x162017, 0x15201a, 0x080c39, 0x4d2f0b, 0xd09f5c, 0x482215, 0x000815, 0x0e1619, 0xc3975a, 0xf5ac11, 0xffb639, 0x93650f, 0x07000b, 0x0b1644, 0x170a00, 0xb57a12, 0xffbc64, 0xffe5ba, 0xfcfff6, 0xf5faff, 0xf1f7ff, 0xf5feff, 0xf7ffff, 0xf8fff6, 0xf9fff2, 0xfcfcfa, 0xfff9ff, 0xe9faf0, 0xfdfbff, 0xfff8ff, 0xffe7b1, 0xf9c24e, 0xa76807, 0x1d0500, 0x001a36, 0x100317, 0x9a6b23, 0xffb325, 0xfab43b, 0xa5844f, 0x100d04, 0x030000, 0x4b342e, 0xd29834, 0x3d2503, 0x100d18, 0x151314, 0x171f14, 0x081d20, 0x090c11, 0x694b40, 0x987847, 0x230401, 0x210c1d, 0x221c1c, 0x11140d, 0x20232c, 0x21212b, 0x090b00, 0x725438, 0x311802, 0x100200, 0xd1cdcc, 0xf8f9fe, 0xfefeff, 0xfcfbff, 0xfbf8ff, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf4f4f4, 0xffffff, 0xf9f9f9, 0xffffff, 0xfefefe, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0x8a8a8a, 0x0a0008, 0x0d0805, 0x23221d, 0x141817, 0x0c1210, 0x192019, 0x191f1b, 0x181b20, 0x090000, 0x3f3625, 0x322918, 0x180d11, 0x1a131a, 0x1f1e19, 0x131716, 0x13152a, 0x110303, 0x946d2c, 0x7e5340, 0x040612, 0x00090d, 0x59360c, 0xf8b735, 0xffb93f, 0x885f0f, 0x0c0012, 0x0f1e3f, 0x0b0a00, 0x8a4d14, 0xffac39, 0xedb848, 0xfff3e3, 0xfffff6, 0xfefeff, 0xf8fcff, 0xf6ffff, 0xf7fff4, 0xfbfff1, 0xfefdfb, 0xfff7ff, 0xfbfcf6, 0xfffdff, 0xfce2c7, 0xffc653, 0xf0a526, 0x723e0e, 0x12090e, 0x0b211f, 0x100219, 0x986e26, 0xffba34, 0xecae4b, 0x452d0b, 0x000100, 0x1c150d, 0x715349, 0x9b711d, 0x130200, 0x171837, 0x1a1a1c, 0x131b0c, 0x182b32, 0x03060f, 0x503520, 0x3b251a, 0x0f0004, 0x2a1d26, 0x24211a, 0x131419, 0x0f0f2b, 0x0e111a, 0x242b0a, 0x180600, 0x110200, 0xa19795, 0xfffdff, 0xfffeff, 0xfefdff, 0xfefbff, 0xfffdff, 0xffffff, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xfefefe, 0xffffff, 0xfdfdfd, 0xf8f8f8, 0xffffff, 0xffffff, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf3f3f3, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xf2f2f2, 0xffffff, 0xf7f7f7, 0xffffff, 0x615d76, 0x000004, 0x1b1b19, 0x1f1e26, 0x05060a, 0x101707, 0x151c0a, 0x181e1e, 0x1a2129, 0x0d1021, 0x191722, 0x18150e, 0x1d190e, 0x241e20, 0x161115, 0x1c1910, 0x020413, 0x594017, 0x86624a, 0x090305, 0x101a1b, 0x100000, 0xc59145, 0xffc64b, 0x836726, 0x120010, 0x121a2d, 0x0b1413, 0x4d2317, 0xef9e32, 0xefac15, 0xe6b980, 0xfff9d1, 0xfffcef, 0xfffcff, 0xf8fdff, 0xf7fff7, 0xfbfff1, 0xfffffd, 0xfff9ff, 0xfffcf6, 0xfff7db, 0xe3b458, 0xfdab1b, 0xe0952f, 0x3b1e16, 0x02071b, 0x1b2113, 0x0d0115, 0x9d792f, 0xffcd52, 0xaa7831, 0x0f0000, 0x0c151a, 0x221c10, 0x8b6757, 0x48320b, 0x140911, 0x14122a, 0x1c1e1b, 0x161c10, 0x161f28, 0x15151d, 0x1f1400, 0x190f1a, 0x181118, 0x17140f, 0x13120e, 0x0d0b18, 0x0b0921, 0x0b0f10, 0x182200, 0x040000, 0x928c8e, 0xfffeff, 0xfffdff, 0xfcfafd, 0xfffeff, 0xfffdff, 0xfffdff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0xffffff, 0xf0f0f0, 0xffffff, 0xfefefe, 0xfafafa, 0xffffff, 0xe9e9e9, 0xffffff, 0xffffff, 0xf8f7ff, 0x4f5048, 0x010100, 0x2f2b3a, 0x767280, 0x323323, 0x000300, 0x17181d, 0x161f1c, 0x101624, 0x1b1f2b, 0x1a1f18, 0x1a1d12, 0x1a171e, 0x211c22, 0x222011, 0x071321, 0x2c2419, 0x60482e, 0x2a1d14, 0x0c1510, 0x04040e, 0x633e2c, 0xffc13e, 0x736733, 0x120002, 0x161527, 0x0d2031, 0x110509, 0xb67426, 0xffb826, 0xe29c1a, 0xf5cf88, 0xffeecc, 0xfff9ff, 0xfefcff, 0xf7fffb, 0xfbfff3, 0xfffffb, 0xfffaff, 0xfff1ea, 0xefc169, 0xf4a107, 0xfda51f, 0xa57135, 0x120806, 0x0d111d, 0x1f1a20, 0x090311, 0x8d7127, 0xf1c155, 0x5b3109, 0x010013, 0x0f1f2f, 0x232112, 0x745239, 0x0b0d19, 0x201825, 0x1a1416, 0x1a2014, 0x151a16, 0x16101a, 0x252026, 0x0e1607, 0x191c25, 0x212320, 0x121210, 0x06050d, 0x3f3d48, 0x7a7c79, 0x282e22, 0x000600, 0x676a73, 0xfdfeff, 0xfffeff, 0xfdfbfc, 0xfdf9f6, 0xfffefb, 0xfffffb, 0xfdfcf8, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xfdfdfd, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xf2f2f2, 0xffffff, 0xfefefe, 0xfbfbfb, 0xfffeff, 0xe8ead4, 0x131200, 0x1b1426, 0xfffaff, 0xebe8df, 0x57574b, 0x01000e, 0x040700, 0x222421, 0x1c2125, 0x121b18, 0x111a19, 0x0a0e17, 0x24252a, 0x161711, 0x14272e, 0x04070e, 0x3a2c11, 0x413020, 0x0d140c, 0x0e1c36, 0x1f0218, 0xdfa11a, 0x57562a, 0x180400, 0x180e29, 0x071f3b, 0x000304, 0x7d4718, 0xffb93e, 0xfea900, 0xce9d40, 0xfed3a6, 0xfff6fb, 0xfffaff, 0xfaffff, 0xfafff3, 0xfefdf8, 0xfffbff, 0xddd4cb, 0xd58f0b, 0xffaa00, 0xffab3a, 0x644729, 0x010200, 0x252523, 0x191233, 0x06040f, 0x725a10, 0xcca03d, 0x2a0600, 0x0b0a34, 0x071b34, 0x313220, 0x422102, 0x051644, 0x271f2e, 0x281c0c, 0x151c0c, 0x15191a, 0x24141f, 0x231a1d, 0x0b2115, 0x131e1a, 0x000400, 0x04070c, 0x514d64, 0xf4f3f8, 0xfeffe4, 0x0c1400, 0x0f1221, 0xf8ffff, 0xf2f6ff, 0xfeffff, 0xfffefa, 0xfffef8, 0xfffff8, 0xfffff8, 0xfffff8, 0xffffff, 0xffffff, 0xfefefe, 0xfcfcfc, 0xfcfcfc, 0xfefefe, 0xffffff, 0xffffff, 0xfbfbfb, 0xfefefe, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf4f4f4, 0xa6a6a6, 0x212121, 0xe9e9e9, 0xffffff, 0xf8f8f8, 0x9c9c9c, 0x171717, 0x000000, 0x232323, 0x181818, 0x0a0a0a, 0x141414, 0x141414, 0x1d1d1d, 0x141414, 0x1d1d1d, 0x0c0c0c, 0x202020, 0x202020, 0x181818, 0x121212, 0x313131, 0x262628, 0x13190b, 0x111c0c, 0x171a21, 0x21132d, 0x220000, 0xc29246, 0xf7c332, 0xeb971b, 0xc08f55, 0xfffbff, 0xf7fdff, 0xfffdff, 0xfffdec, 0xfffffa, 0xeffcff, 0xca894f, 0xd39907, 0xfac320, 0xb48340, 0x2c121f, 0x0e1118, 0x0f1b17, 0x181e2c, 0x181818, 0x272727, 0x202020, 0x1b1b1b, 0x1b1b1b, 0x141414, 0x141414, 0x161616, 0x1c1c1c, 0x161616, 0x171717, 0x202020, 0x000000, 0x080808, 0x1d1d1d, 0x151515, 0x000000, 0x2f2f2f, 0xa4a4a4, 0xf4f4f4, 0xffffff, 0xdbdbdb, 0x1c1c1c, 0xc1c1c1, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfefefe, 0xb3b3b3, 0xfefefe, 0xf9f9f9, 0xffffff, 0xfbfbfb, 0xd6d6d6, 0x434343, 0x000000, 0x0a0a0a, 0xa4a4a4, 0x6a6a6a, 0x060606, 0x161616, 0x232323, 0x151515, 0x191919, 0x1d1d1d, 0x161616, 0x232323, 0x191919, 0x121212, 0x1a151c, 0x181b12, 0x162110, 0x0f1417, 0x1a1229, 0x180002, 0x644004, 0xeac14b, 0xf4a62a, 0x916528, 0xf0e9f0, 0xf5fbff, 0xfefcff, 0xfffeed, 0xf1f0ec, 0xd2dff2, 0x955611, 0xf7be39, 0xefbd3a, 0x5d3408, 0x0b0009, 0x161b1e, 0x18221a, 0x171628, 0x151515, 0x131313, 0x151515, 0x1c1c1c, 0x1b1b1b, 0x1b1b1b, 0x202020, 0x191919, 0x191919, 0x2e2e2e, 0x121212, 0x000000, 0x878787, 0x7f7f7f, 0x070707, 0x050505, 0x505050, 0xeaeaea, 0xffffff, 0xffffff, 0xefefef, 0xefefef, 0xcdcdcd, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfcfcfc, 0xffffff, 0xfefefe, 0xfbfbfb, 0xffffff, 0xffffff, 0xe6e6e6, 0x373737, 0x000000, 0xd7d7d7, 0xffffff, 0x3f3f3f, 0x000000, 0x191919, 0x181818, 0x1e1e1e, 0x191919, 0x181818, 0x181818, 0x1b1b1b, 0x0d0d0d, 0x1d1524, 0x11120d, 0x0a1302, 0x161f1a, 0x232230, 0x1d1218, 0x1d0b00, 0x9f893d, 0xfdbc44, 0x5d3a00, 0x97928c, 0xf9ffff, 0xfcfcfa, 0xffffef, 0xfffffd, 0x798196, 0x763900, 0xffcd63, 0x9d7424, 0x1a0000, 0x181025, 0x1b241f, 0x0f120b, 0x1d132b, 0x1d1d1d, 0x171717, 0x171717, 0x1a1a1a, 0x1a1a1a, 0x1c1c1c, 0x1b1b1b, 0x161616, 0x252525, 0x0d0d0d, 0x0d0d0d, 0x444444, 0xffffff, 0xbababa, 0x000000, 0x494949, 0xf1f1f1, 0xffffff, 0xf3f3f3, 0xfefefe, 0xffffff, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xf4f4f4, 0xffffff, 0xf9f9f9, 0xffffff, 0xfdfdfd, 0xf9f9f9, 0xf5f5f5, 0xffffff, 0xd5d5d5, 0x1e1e1e, 0xa2a2a2, 0xffffff, 0xe4e4e4, 0x3a3a3a, 0x000000, 0x1a1a1a, 0x232323, 0x151515, 0x202020, 0x101010, 0x1c1c1c, 0x1a1a1a, 0x1e1324, 0x221e1f, 0x1f2517, 0x1d271e, 0x0d141a, 0x17171f, 0x141205, 0x242000, 0xeaba4e, 0x6a4e0f, 0x3f3c2d, 0xfbffff, 0xfffffa, 0xfffcf0, 0xfffeff, 0x24293d, 0x8a5400, 0xd3a95d, 0x3f2407, 0x090012, 0x22243b, 0x091308, 0x202016, 0x2f1f39, 0x1a1a1a, 0x242424, 0x212121, 0x141414, 0x1a1a1a, 0x1c1c1c, 0x111111, 0x191919, 0x202020, 0x000000, 0x424242, 0xfdfdfd, 0xffffff, 0x989898, 0x181818, 0xe8e8e8, 0xffffff, 0xf3f3f3, 0xfbfbfb, 0xfefefe, 0xffffff, 0xffffff, 0xf7f7f7, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xd5d5d5, 0xbbbbbb, 0xffffff, 0xffffff, 0xdddddd, 0x1f1f1f, 0x050505, 0x242424, 0x181818, 0x1b1b1b, 0x1e1e1e, 0x1d1d1d, 0x1a1a1a, 0x271c2c, 0x030002, 0x000300, 0x0a110a, 0x1b2325, 0x161d23, 0x151a1d, 0x010602, 0x91701f, 0x7e6c3a, 0x131001, 0xc5cac6, 0xfffff8, 0xfffef2, 0xb8b6b9, 0x030416, 0xa88134, 0x795d2e, 0x0d0105, 0x0e0d2f, 0x151a2d, 0x12180a, 0x232017, 0x07000e, 0x0e0e0e, 0x121212, 0x1f1f1f, 0x161616, 0x181818, 0x222222, 0x1a1a1a, 0x1f1f1f, 0x000000, 0x393939, 0xe7e7e7, 0xfafafa, 0xffffff, 0xb7b7b7, 0xcacaca, 0xffffff, 0xf1f1f1, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xf7f7f7, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfefefe, 0xfdfdfd, 0xffffff, 0xf5f5f5, 0xffffff, 0xfcfcfc, 0xffffff, 0xfcfcfc, 0xffffff, 0xededed, 0xffffff, 0xf5f5f5, 0xffffff, 0xededed, 0xf4f4f4, 0xffffff, 0xa1a1a1, 0x020202, 0x111111, 0x1f1f1f, 0x131313, 0x232323, 0x151515, 0x1a1a1a, 0x0a030a, 0x373236, 0x3c3a3b, 0x010302, 0x101415, 0x1d2225, 0x161d23, 0x151c24, 0x352000, 0x66583d, 0x030000, 0x525451, 0xfefffa, 0xfffff8, 0x343233, 0x090714, 0x77602c, 0x291c09, 0x0f0e1e, 0x1e243e, 0x191c23, 0x0c0c00, 0x070400, 0x393742, 0x3b3b3b, 0x040404, 0x161616, 0x212121, 0x121212, 0x212121, 0x202020, 0x131313, 0x101010, 0xb3b3b3, 0xfcfcfc, 0xfefefe, 0xfafafa, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xf8f8f8, 0xffffff, 0xf7f7f7, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xfdfdfd, 0xf0f0f0, 0xffffff, 0xfefefe, 0xf8f8f8, 0xffffff, 0x5c5c5c, 0x050505, 0x171717, 0x181818, 0x181818, 0x141414, 0x121212, 0x070602, 0xd9d7da, 0xede7f1, 0x615c63, 0x040001, 0x0d0d0b, 0x1f2024, 0x11141d, 0x1d1105, 0x382f2a, 0x120d11, 0x0c0c0e, 0xc4c6c1, 0xcecfc9, 0x050304, 0x1b181f, 0x201900, 0x10120f, 0x1c2632, 0x192227, 0x090601, 0x191208, 0x5a5b56, 0xe4eeef, 0xaeaeae, 0x212121, 0x0d0d0d, 0x232323, 0x141414, 0x1b1b1b, 0x161616, 0x080808, 0x6a6a6a, 0xfcfcfc, 0xffffff, 0xf9f9f9, 0xf8f8f8, 0xffffff, 0xfdfdfd, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xf8f8f8, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xffffff, 0xfbfbfb, 0xffffff, 0xf7f7f7, 0xffffff, 0xffffff, 0xfafafa, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xd6d6d6, 0x111111, 0x040404, 0x222222, 0x131313, 0x202020, 0x000000, 0x76786d, 0xfffeff, 0xfef6ff, 0xfff4ff, 0x6f6669, 0x040000, 0x130f0e, 0x211f24, 0x1d161e, 0x140c17, 0x211b25, 0x010004, 0x4a4c49, 0x30322d, 0x050402, 0x1c171b, 0x161711, 0x141f23, 0x05171b, 0x020c03, 0x0a0400, 0x80756f, 0xf9fbf8, 0xf2ffff, 0xffffff, 0x4a4a4a, 0x050505, 0x1b1b1b, 0x1c1c1c, 0x191919, 0x0b0b0b, 0x0e0e0e, 0xeeeeee, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xf5f5f5, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0x5e5e5e, 0x000000, 0x1c1c1c, 0x141414, 0x040404, 0x2f2f2f, 0xfbfbfb, 0xffffff, 0xf9f9f9, 0xffffff, 0xfdfdfd, 0x909090, 0x161616, 0x000000, 0x1e1e1e, 0x1c1c1c, 0x1d1d1d, 0x1d1d1d, 0x080808, 0x080808, 0x202020, 0x1b1b1b, 0x181818, 0x212121, 0x010101, 0x121212, 0xa4a4a4, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xededed, 0x252525, 0x000000, 0x1a1a1a, 0x191919, 0x010101, 0x6a6a6a, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfdfdfd, 0xb9b9b9, 0x070707, 0x111111, 0x080808, 0x232323, 0xeaeaea, 0xffffff, 0xfafafa, 0xf8f8f8, 0xf9f9f9, 0xffffff, 0xfefefe, 0xa0a0a0, 0x202020, 0x000000, 0x212121, 0x191919, 0x141414, 0x1d1d1d, 0x1a1a1a, 0x1d1d1d, 0x121212, 0x212121, 0x000000, 0x212121, 0xc2c2c2, 0xffffff, 0xfafafa, 0xffffff, 0xf6f6f6, 0xfbfbfb, 0xfdfdfd, 0xd9d9d9, 0x131313, 0x000000, 0x0d0d0d, 0x0f0f0f, 0xc7c7c7, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xdddddd, 0x1f1f1f, 0x000000, 0x323232, 0xdadada, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfefefe, 0xf0f0f0, 0xffffff, 0xffffff, 0xbfbfbf, 0x1a1a1a, 0x0b0b0b, 0x151515, 0x1f1f1f, 0x1c1c1c, 0x151515, 0x141414, 0x2a2a2a, 0x000000, 0x292929, 0xcccccc, 0xffffff, 0xfcfcfc, 0xffffff, 0xf2f2f2, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xc7c7c7, 0x202020, 0x070707, 0x171717, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf0f0f0, 0xffffff, 0x343434, 0x434343, 0xd9d9d9, 0xffffff, 0xfafafa, 0xfbfbfb, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xd5d5d5, 0x1d1d1d, 0x030303, 0x1e1e1e, 0x141414, 0x262626, 0x151515, 0x000000, 0x343434, 0xe0e0e0, 0xffffff, 0xf9f9f9, 0xfcfcfc, 0xf9f9f9, 0xffffff, 0xfbfbfb, 0xfefefe, 0xffffff, 0xfafafa, 0xfbfbfb, 0xd7d7d7, 0x2e2e2e, 0x4b4b4b, 0xf3f3f3, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xffffff, 0xffffff, 0xdcdcdc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf7f7f7, 0xffffff, 0xfdfdfd, 0xf6f6f6, 0xffffff, 0xffffff, 0xf9f9f9, 0xfbfbfb, 0xffffff, 0xd8d8d8, 0x2f2f2f, 0x000000, 0x262626, 0x0d0d0d, 0x090909, 0x2f2f2f, 0xe4e4e4, 0xfcfcfc, 0xffffff, 0xf3f3f3, 0xffffff, 0xffffff, 0xf5f5f5, 0xffffff, 0xfefefe, 0xfbfbfb, 0xfefefe, 0xffffff, 0xf9f9f9, 0xf4f4f4, 0xe2e2e2, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf4f4f4, 0xfefefe, 0xffffff, 0xffffff, 0xfcfcfc, 0xf3f3f3, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfafafa, 0xf7f7f7, 0xffffff, 0xffffff, 0xfbfbfb, 0xf2f2f2, 0xffffff, 0xe3e3e3, 0x333333, 0x000000, 0x0f0f0f, 0x343434, 0xe9e9e9, 0xffffff, 0xf6f6f6, 0xf6f6f6, 0xffffff, 0xfcfcfc, 0xf8f8f8, 0xf9f9f9, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xf0f0f0, 0xfefefe, 0xffffff, 0xfafafa, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xfdfdfd, 0xfafafa, 0xffffff, 0xfefefe, 0xffffff, 0xffffff, 0xf7f7f7, 0xfdfdfd, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xfbfbfb, 0xffffff, 0xf8f8f8, 0xffffff, 0xe2e2e2, 0x383838, 0x434343, 0xffffff, 0xfefefe, 0xf4f4f4, 0xffffff, 0xffffff, 0xf9f9f9, 0xffffff, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xf0f0f0, 0xfdfdfd, 0xffffff, 0xffffff, 0xeeeeee, 0xffffff, 0xfcfcfc, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xf6f6f6, 0xfdfdfd, 0xffffff, 0xffffff, 0xfbfbfb, 0xfbfbfb, 0xffffff, 0xfdfdfd, 0xffffff, 0xffffff, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xf9f9f9, 0xffffff, 0xfdfdfd, 0xfdfdfd, 0xffffff, 0xffffff, 0xf4f4f4, 0xfcfcfc, 0xffffff, 0xfbfbfb, 0xffffff, 0xffffff, 0xfefefe, 0xfafafa, 0xffffff, 0xffffff, 0xfafafa, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xf4f4f4, 0xffffff, 0xffffff, 0xf8f8f8, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 
0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff, 0xffffff
};

const unsigned short  tttt [] PROGMEM = {};

void drawRabbit()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, Rabbit[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 
void drawDog()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, Dog[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 
void drawCat()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, Cat[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 

void drawFantastic()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, Fantastic[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 

void drawTears()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, Tears[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 

void drawPoop()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, Poop[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 
void drawParty()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, Party[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 

void drawQuestions()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, Questions[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 

void drawClown()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, clown[tc]); 
   if(tc < (sx*sy)) tc++;  }
}} 

void drawSMF()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, SMF[tc]); 
   if(tc < (sx*sy)) tc++;  }
}}  
 void drawLion2()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, lion2[tc]); 
   if(tc < (sx*sy)) tc++;  }
}}  
 

void drawHeart1()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, heart1[tc]);//pgm_read_word(myBitmap[tc])
   if(tc < (sx*sy)) tc++;  }
}} 
 
void drawLion()
{
int tc = 0;int x =0; int y=0; int sx =125; int sy = 127;
for(int Y = 0; Y < sy; Y++)
{
  for(int X = 0; X < sx; X++)
  {   tft.drawPixel(X+x, Y+y, lion[tc]);//pgm_read_word(myBitmap[tc])
   if(tc < (sx*sy)) tc++;  }
}}


void testdrawtext(char *text, uint16_t color) {
  tft.setCursor(0, 0);
  tft.setTextColor(color);
  tft.setTextWrap(true);
  tft.print(text);
}

void lionStart()
{
 tft.initR(INITR_GREENTAB);
 tft.setRotation(ST7735_MADCTL_BGR);
 tft.fillScreen(ST77XX_BLACK); 
tft.setRotation(2);
}
void ClsDis() {
tft.fillScreen(ST77XX_BLACK);
  tft.setCursor(0, 0);
   
}
void TextSize(int a) {
tft.setTextSize(a);
   
}
void TextDisplay(String a) {
 
 tft.print(a);  
}
void DisCursor(int x,int y) {
 
 tft.setCursor(x,y);  
}
void TextColor(int x) {
 tft.setTextColor(x);
}
void DisRotation(int x) {
 tft.setRotation(x);
}
